<?php
/**
 * @copyright (C) 2000 - 2010 Weaver Co.Ltd
 * @package   eoffice8.0
 * @name      webroot/E-mobile/App/Addr/AddrProxy.php
 * @function  通讯录代理类      
 * @version   1.0 
 * @author    lizj
 */
include_once ("api/address.class.php");
include_once ("wap/function.php");
include_once ("inc/function_picture.php");
class AddrProxy{
    private static $AddrApi ;
    private $_userId ;
    private $_cursession;
    private $_sessionstr;
    public function __construct() {
        $this->_sessionstr = request_var("sessionkey");
		$strexplode = explode("_",$this->_sessionstr);
	    $this->_cursession = $strexplode[0];
	    $this->_userId    = $strexplode[1];
        if(!self::$AddrApi){
            self::$AddrApi = new address(array("user_id" => $this->_userId));
        }
    }
    /**
    * -1代表没有菜单权限
    * 0代表session过期，或未登录
    * 获取自定义分组
    * 获取每个分组的联系人个数
    */
    public function lists(){
        global $_lang;
	    $userid     = $this->_userId;
            $sessionkey = $sessionstr = $this->_sessionstr;
	    //验证sessionkey
	    $check      = CheckSessionKeys($this->_cursession);
	    if($check){
			//验证菜单权限
			if(CheckMenuPriv($userid,"commaddr")){
                $searchInfo = array(
                    'userid'    => $userid,
                    'diff'      => '',
                    'groupid'   => ''
                );
                
                $_groupInfo     = self::$AddrApi-> GetAddressStruct($searchInfo);
                $groupInfo      = array();
                foreach($_groupInfo as $key => $value){
                    $value['count'] = self::$AddrApi->GetMyAddressAmount("","",$value['GROUP_ID']);
                    $groupInfo[]    = $value;
                }
                $searchInfoP = array(
                    'userid'    => $userid,
                    'diff'      => 'personal',
                    'groupid'   => ''
                );
                $_personGroupInfo = self::$AddrApi-> GetAddressStruct($searchInfoP);
                $personGroupInfo      = array();
                foreach($_personGroupInfo as $key => $value){
                    $value['count'] = self::$AddrApi->GetMyAddressAmount("","",$value['GROUP_ID']);
                    $personGroupInfo[]    = $value;
                }
                include_once(INCLUDE_APP_PATH . 'Addr/View/AddrListsView.php');
            }else{
                echo '<div>'.$_lang["e_addr_no_menu_auth"].'</div>';
            }
        }else{
            echo '<div>'.$_lang["e_addr_login_again"].'</div>';
        }
    }
    /**
     * 按自定义分组id获取通讯录列表
     * out：json字符串
     */
    public function getAddrByDept(){
        $groupId    = request_var('groupid','');
        $addrLists  = self::$AddrApi -> GetAddressInfor(0, 100, '', '','',$groupId);
        $_addrLists = array();
        foreach($addrLists as $val){
            $val['isnew']   = "0";
            $IMAGE_NAME     = substr($val["FRIST_IMAGE"],21,strlen($val["FRIST_IMAGE"]));
            $PHOTO          = $IMAGE_NAME;
            if($val["FRIST_IMAGE"]){
                $img_src = ROOT_PATH.$val["FRIST_IMAGE"];
                if(!file_exists($img_src)){
                    $CACHE_PHOTO = IMG_PATH . "user_info.png";
                }else{
                    $ImgSrc      = createJpeg($img_src,$PHOTO,"60","60");	
                    $Imageurl    = parse_url($ImgSrc);
                    $ShowImgSrc  = $Imageurl["path"];
                    $CACHE_PHOTO = $ShowImgSrc;	
                }
            } else{
                $CACHE_PHOTO =  IMG_PATH . "user_info.png";	
            }
            $picurl         = GetNewUrlPath($CACHE_PHOTO);	
            $val['image']   = $picurl;
            $_addrLists[]   = $val;
        }
        if(empty($_addrLists)){
            echo 0;
        }else{
            echo json_encode($_addrLists);
        }
    }
    /**
     * 拼音分组处理函数
     * 按照每个字母获取联系人个数
     * @global type $connection
     * out:json字符串
     */
    public function groupDealByPinyin(){
        global $connection;
        $words = array('#','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z');
        $UserId = $this->_userId;
        if($UserId) {
            $sql    = "SELECT DEPT_ID,USER_PRIV FROM user WHERE USER_ID='".SecurityFilter($UserId)."'";
            $rs     = exequery($connection,$sql);
            $row    = mysql_fetch_array($rs);
            $DeptId = $row["DEPT_ID"];
            $PrivId = $row["USER_PRIV"];
        }
        $resultArray    = array();
        $query_select   = "SELECT count(*) as count FROM address as a JOIN address_group  as b on a.A10=b.GROUP_ID WHERE 1 ";
        $query_check    = " AND (a.A11='".SecurityFilter($UserId)."' OR (
                b.GROUP_DEPT = 'ALL_DEPT'
                OR((INStr(b.GROUP_DEPT,',$DeptId,')>0 OR INStr(b.GROUP_DEPT,'$DeptId,')=1) 
                   OR
                   (INStr(b.GROUP_PRIV,',$PrivId,')>0 OR INStr(b.GROUP_PRIV,'$PrivId,')=1)
                   OR 
                   (InStr(b.GROUP_USER,'$UserId,')>0 OR INStr(b.GROUP_USER,'$UserId,')=1))))";
        foreach($words as $v){
            if($v == '#'){
                $query_group    = " AND a.NAME_INDEX IN('0','1','2','3','4','5','6','7','8','9')";
            }else{
                $query_group    = " AND a.NAME_INDEX='".$v."'";	
            }
            $query          = $query_select.$query_check.$query_group;
            $result         = exequery ( $connection, $query );
            if( $row = mysql_fetch_array ( $result ) ) {
                $count = $row['count'];
            }else{
                $count = 0;
            }
            $resultArray[$v] = $count;
        }
        echo json_encode($resultArray);
    }
    /**
     * 按照字母获取通讯录列表
     * @global type $connection
     * out:json字符串
     */
    public function getAddrByWord(){
        global $connection;
        $groupId    = request_var('groupid','');
        $UserId     = $this->_userId;
        if($UserId) {
            $sql    = "SELECT DEPT_ID,USER_PRIV FROM user WHERE USER_ID='".$UserId."'";
            $rs     = exequery($connection,$sql);
            $row    = mysql_fetch_array($rs);
            $DeptId = $row["DEPT_ID"];
            $PrivId = $row["USER_PRIV"];
        }
        $query_select   = "SELECT * FROM address as a JOIN address_group  as b on a.A10=b.GROUP_ID WHERE 1 ";
        $query_check    = " AND (a.A11='".$UserId."' OR (
                b.GROUP_DEPT = 'ALL_DEPT'
                OR((INStr(b.GROUP_DEPT,',$DeptId,')>0 OR INStr(b.GROUP_DEPT,'$DeptId,')=1) 
                   OR
                   (INStr(b.GROUP_PRIV,',$PrivId,')>0 OR INStr(b.GROUP_PRIV,'$PrivId,')=1)
                   OR 
                   (InStr(b.GROUP_USER,'$UserId,')>0 OR INStr(b.GROUP_USER,'$UserId,')=1))))";
			
		if($groupId!=""){
            if($groupId == '#'){
                $query_group = " AND a.NAME_INDEX IN ('0','1','2','3','4','5','6','7','8','9')";
            }else{
                $query_group = " AND a.NAME_INDEX='".$groupId."'";	
            }
		}
		$query  = $query_select.$query_check.$query_group;
		$query .= " ORDER BY NAME_PINYIN ASC" ;
		$result         = exequery ( $connection, $query );
		$resultArray    = array();
        if($result){
            while ( $row = mysql_fetch_array ( $result ) ) {
                $userInfor ["ID"]              = $row ["ADD_ID"];
                $userInfor ["Name"]            = $row ["A1"];
                $userInfor ["OtherName"]       = $row ["A14"];
                $userInfor ["Sex"]             = $row ["A2"];
                $userInfor ["City"]            = $row ["A3"];
                $userInfor ["Birthday"]        = $row ["A4"];
                $userInfor ["Mobile"]          = $row ["A5"];
                $userInfor ["Email"]           = $row ["A6"];
                $userInfor ["Company"]         = $row ["A7"];
                $userInfor ["Company_address"] = $row ["A22"];
                $userInfor ["Company_post"]    = $row ["A21"];
                $userInfor ["Company_fax"]     = $row ["A26"];
                $userInfor ["Department"]      = $row ["A8"];
                $userInfor ["job"]             = $row ["A25"];
                $userInfor ["Comment"]         = $row ["A9"];
                $userInfor ["Work_Tel"]        = $row ["A23"];
                $userInfor ["Home_address"]    = $row ["A24"];
                $userInfor ["Home_Tel"]        = $row ["A27"];
                $userInfor ["GroupID"]         = $row ["A10"];
                $userInfor ["GroupName"]       = $row ["GROUP_NAME"];
                $userInfor ["Groupparent"]     = $row ["GROUP_PARENT"];
                $userInfor ["Grouptype"]       = $row ["GROUP_TYPE"];
                $userInfor ["THUMB_IMAGE"]     = $row ["THUMB_IMAGE"];
                $userInfor ["FRIST_IMAGE"]     = $row ["FRIST_IMAGE"];
                $userInfor ["CREAT_USER"]      = $row ["A11"];
                $userInfor ["CREAT_TIME"]      = $row ["A12"];
                $userInfor ["QQ"]              = $row ["A16"];
                $userInfor ["wife"]            = $row ["A18"];
                $userInfor ["son"]             = $row ["A19"];
                $userInfor['isnew']       = "0";
                $IMAGE_NAME  = substr($row["FRIST_IMAGE"],21,strlen($row["FRIST_IMAGE"]));
                $PHOTO		 = $IMAGE_NAME;
                if($row["FRIST_IMAGE"]){
                    $img_src = ROOT_PATH.$row["FRIST_IMAGE"];
                    if(!file_exists($img_src)){
                        $CACHE_PHOTO = IMG_PATH . "user_info.png";
                    }else{
                        $ImgSrc      = createJpeg($img_src,$PHOTO,"60","60");	
                        $Imageurl    = parse_url($ImgSrc);
                        $ShowImgSrc  = $Imageurl["path"];
                        $CACHE_PHOTO = $ShowImgSrc;	
                    }
                } else{
                    $CACHE_PHOTO =  IMG_PATH . "user_info.png";	
                }
                $picurl             = GetNewUrlPath($CACHE_PHOTO);	
                $userInfor['image'] = $picurl;
                array_push ( $resultArray, $userInfor );
            }
        }
        if(empty($resultArray)){
            echo 0;
        }else{
            echo json_encode($resultArray);
        }
    }
    /**
     * 按联系人姓名进行模糊搜索
     */
    public function searchAddrList(){
        global $connection;
        $keyword = request_var('keyword','');
        if($keyword == ''){
            echo 0;exit;
        }
        $UserId     = $this->_userId;
        if($UserId) {
            $sql    = "SELECT DEPT_ID,USER_PRIV FROM user WHERE USER_ID='".".SecurityFilter($UserId)."."'";
            $rs     = exequery($connection,$sql);
            $row    = mysql_fetch_array($rs);
            $DeptId = $row["DEPT_ID"];
            $PrivId = $row["USER_PRIV"];
        }
        $query_select   = "SELECT * FROM address as a JOIN address_group  as b on a.A10=b.GROUP_ID WHERE 1 ";
        $query_check    = " AND (a.A11='".".SecurityFilter($UserId)."."' OR (
                b.GROUP_DEPT = 'ALL_DEPT'
                OR((INStr(b.GROUP_DEPT,',$DeptId,')>0 OR INStr(b.GROUP_DEPT,'$DeptId,')=1) 
                   OR
                   (INStr(b.GROUP_PRIV,',$PrivId,')>0 OR INStr(b.GROUP_PRIV,'$PrivId,')=1)
                   OR 
                   (InStr(b.GROUP_USER,'$UserId,')>0 OR INStr(b.GROUP_USER,'$UserId,')=1))))";
			
		if($keyword!=""){
			$query_group = " AND a.A1 LIKE '%".$keyword."%'";	
		}
		$query  = $query_select.$query_check.$query_group;
		$query .= " ORDER BY NAME_PINYIN ASC" ;

		$result         = exequery ( $connection, $query );
		$resultArray    = array();
        if($result){
            while ( $row = mysql_fetch_array ( $result ) ) {
                $userInfor ["ID"]              = $row ["ADD_ID"];
                $userInfor ["Name"]            = $row ["A1"];
                $userInfor ["OtherName"]       = $row ["A14"];
                $userInfor ["Sex"]             = $row ["A2"];
                $userInfor ["City"]            = $row ["A3"];
                $userInfor ["Birthday"]        = $row ["A4"];
                $userInfor ["Mobile"]          = $row ["A5"];
                $userInfor ["Email"]           = $row ["A6"];
                $userInfor ["Company"]         = $row ["A7"];
                $userInfor ["Company_address"] = $row ["A22"];
                $userInfor ["Company_post"]    = $row ["A21"];
                $userInfor ["Company_fax"]     = $row ["A26"];
                $userInfor ["Department"]      = $row ["A8"];
                $userInfor ["job"]             = $row ["A25"];
                $userInfor ["Comment"]         = $row ["A9"];
                $userInfor ["Work_Tel"]        = $row ["A23"];
                $userInfor ["Home_address"]    = $row ["A24"];
                $userInfor ["Home_Tel"]        = $row ["A27"];
                $userInfor ["GroupID"]         = $row ["A10"];
                $userInfor ["GroupName"]       = $row ["GROUP_NAME"];
                $userInfor ["Groupparent"]     = $row ["GROUP_PARENT"];
                $userInfor ["Grouptype"]       = $row ["GROUP_TYPE"];
                $userInfor ["THUMB_IMAGE"]     = $row ["THUMB_IMAGE"];
                $userInfor ["FRIST_IMAGE"]     = $row ["FRIST_IMAGE"];
                $userInfor ["CREAT_USER"]      = $row ["A11"];
                $userInfor ["CREAT_TIME"]      = $row ["A12"];
                $userInfor ["QQ"]              = $row ["A16"];
                $userInfor ["wife"]            = $row ["A18"];
                $userInfor ["son"]             = $row ["A19"];
                $userInfor['isnew']       = "0";
                $IMAGE_NAME  = substr($row["FRIST_IMAGE"],21,strlen($row["FRIST_IMAGE"]));
                $PHOTO		 = $IMAGE_NAME;
                if($row["FRIST_IMAGE"]){
                    $img_src = ROOT_PATH.$row["FRIST_IMAGE"];
                    if(!file_exists($img_src)){
                        $CACHE_PHOTO = IMG_PATH . "user_info.png";
                    }else{
                        $ImgSrc      = createJpeg($img_src,$PHOTO,"60","60");	
                        $Imageurl    = parse_url($ImgSrc);
                        $ShowImgSrc  = $Imageurl["path"];
                        $CACHE_PHOTO = $ShowImgSrc;	
                    }
                } else{
                    $CACHE_PHOTO =  IMG_PATH . "user_info.png";	
                }
                $picurl             = GetNewUrlPath($CACHE_PHOTO);	
                $userInfor['image'] = $picurl;
                array_push ( $resultArray, $userInfor );
            }
        }
        if(empty($resultArray)){
            echo 0;
        }else{
            echo json_encode($resultArray);
        }
    }
    /**
     * 联系人详情
     * @global type $connection
     * $detailid 联系人详情id
     */
    public function view(){
        global $connection, $_lang;
        /*获取参数----BEGIN*/
        $addressid   = intval(request_var("detailid"));
        $flag       = request_var('flag');
        $userid     = $this->_userId;
        $UserInfor = array();
        $UserInfor["user_id"] = $userid;
        $addrApi = new address($UserInfor);
        $addrs = $addrApi->GetAddressInfor('','',$addressid,'','','');
        $addrsInfor = $addrs[0];
        if($addrsInfor["FRIST_IMAGE"]==""){
            $picurl     = IMG_PATH . "user_info.png";		
        } else{
            if(CheckFileExist($addrsInfor["FRIST_IMAGE"])){
                $attachment = pathinfo($addrsInfor["FRIST_IMAGE"]);	
                $name       = $attachment["basename"];
                $name       = strtolower($name);
                $img_src    = ROOT_PATH.$addrsInfor["FRIST_IMAGE"];
                $urlpic     = createJpeg($img_src,$name,"80","80");
                $pic        = parse_url($urlpic);
                $picurl     = GetNewUrlPath($pic["path"]);		
            }else{
                $picurl     = IMG_PATH . "user_info.png";			
            }
        }
        //自定义字段
        $word_infor = array();
        $query_item = "
                    SELECT ITEM_ID,ITEM_NAME,ITEM_SYS FROM add_item 
                        WHERE ITEM_NAME!=''
                            ORDER BY ITEM_ORDER ASC
                    ";
        $res_i = exequery($connection,$query_item);
        $m = 0;
        while ($ROW_I = mysql_fetch_array($res_i)){
            if($ROW_I['ITEM_SYS']!=1){
                $ITEM_NAME = $ROW_I['ITEM_NAME'];
                $sql_value = "SELECT A".$ROW_I['ITEM_ID']."
                                FROM address
                                WHERE ADD_ID = '".".SecurityFilter($addressid)."."'";
                $course = exequery($connection,$sql_value);
                if($ROW_VALUE = mysql_fetch_array($course)){
                    $addr_value = $ROW_VALUE[0];
                }
                $word_infor[$m]["word"]  = $ITEM_NAME;
                $word_infor[$m]["value"] = $addr_value;
                $m++;	
            }
        }
        $wordnum = count($word_infor);
        include_once(INCLUDE_APP_PATH . 'Addr/View/AddrView.php');
    }
    /**
     * 创建联系人页面
     * @global type $connection
     */
    public function create(){
        global $connection, $_lang;
        /*获取参数----BEGIN*/
        $mobilekey  = $_REQUEST["mobilesessionkey"];
        $page       = $_REQUEST["page"];
        $module     = $_REQUEST["module"];
        $scope      = $_REQUEST["scope"];
        $detailid   = $_REQUEST["detailid"];
        $fromid     = $_REQUEST["fromid"];
        $sessionstr = $_REQUEST["sessionkey"];
        $strexplode = explode("_",$sessionstr);
        $userid     = $strexplode[1];
        $userinfor  = GetCurrUserInfor($userid);
        //自定义字段
        $word_infor = array();
        $query_item = "
                    SELECT * FROM add_item 
                        WHERE ITEM_NAME!=''
                            ORDER BY ITEM_ORDER ASC
                    ";
        $res_i = exequery($connection,$query_item);
        $m = 0;
        while ($ROW_I = mysql_fetch_assoc($res_i)){
            if($ROW_I['ITEM_SYS']!=1)
            {
                $word_infor[] = $ROW_I;
                $m++;	
            }
        }
        $wordnum = count($word_infor);
        include_once(INCLUDE_APP_PATH . 'Addr/View/CreateAddrView.php');
    }
    /**
     * 创建联系人操作
     * @global type $connection
     */
    public function createDo(){
        global $connection,$_lang;
        include_once ("general/address/pubcenter/py.php");
        /*获取参数----BEGIN*/
        $mobilekey  = $_REQUEST["mobilesessionkey"];
        $page       = $_REQUEST["page"];
        $module     = $_REQUEST["module"];
        $scope      = $_REQUEST["scope"];
        $detailid   = $_REQUEST["detailid"];
        $fromid     = $_REQUEST["fromid"];
        $sessionstr = $_REQUEST["sessionkey"];
        $strexplode = explode("_",$sessionstr);
        $userid     = $strexplode[1];
        $userarray        = GetCurrUserPriv($userid);
        $GLOBALS['USER_FUNC_ID_STR'] = $userarray["FUNC_ID_STR"];
        
        $name    = $_REQUEST["name"];
		$groupid = $_REQUEST["groupid"];
		$groupid = substr($groupid,0,-1);
		$city    = $_REQUEST["city"];
		$number  = $_REQUEST["number"];
		$Sex     = $_REQUEST["Sex"];
		$com     = $_REQUEST["com"];
		$dept    = $_REQUEST["dept"];
		$email   = $_REQUEST["email"];
        $mobileNo= $_REQUEST['mobil_no'];
		$bir     = $_REQUEST["bir"];
		$remark  = $_REQUEST["remark"];
		$param   = $_REQUEST["param"];
		$paramarray = explode("*|*",$param);
		$paramcount = count($paramarray);
		$sqlid    = "";
		$sqlvalue = "";
		if($Sex=="1"){
			$sexvalue = $_lang["e_addr_man"];	
		}else{
			$sexvalue = $_lang["e_addr_woman"];		
		}
		for($i=0;$i<$paramcount-1;$i++)
		{
			$splitvalue = explode("|,|",$paramarray[$i]);
			$sqlid .= "A".$splitvalue[0].",";
			$sqlvalue .= "'".$splitvalue[1]."',";	
		}
        $pinName = convertPy($name,'utf-8');
		$sqlid .= "A1,A5,A10,A3,A13,A2,A7,A8,A6,A4,A9,NAME_PINYIN,NAME_INDEX,ADD_TYPE,A11,A12";
		$sqlvalue .= "'".$name."','".$mobileNo."','".$groupid."',"."'".$city."',"."'".$number."',"."'".$sexvalue."',"."'".$com."',"."'".$dept."',"."'".$email."',"."'".$bir."',"."'".$remark."',"."'".$pinName[0]."'".",'".substr($pinName[0],0,1)."'".",'1','".$userid."','".date("Y-m-d H:i:s",time())."'";	
		$query = "INSERT INTO address (".SecurityFilter($sqlid).") VALUES (".SecurityFilter($sqlvalue).")";
		exequery($connection,$query);
        
        include_once(INCLUDE_APP_PATH . 'Create/View/CreateSuccessView.php');
    }
    public function ajaxAddr(){
        global $connection;
        $sortid   = SecurityFilter($_REQUEST["sortid"]);
		$userid   = SecurityFilter($_REQUEST["sortid"]);
		$userdept = SecurityFilter($_REQUEST["userdept"]);
		$userpriv = SecurityFilter($_REQUEST["userpriv"]);
		$str      = "";
		$query = "
			SELECT GROUP_NAME,GROUP_PARENT,GROUP_ID
			FROM address_group
			WHERE GROUP_TYPE  = 1
			AND GROUP_PARENT = $sortid
			AND (
				GROUP_DEPT = 'ALL_DEPT'
				OR(
					(INStr(GROUP_DEPT,',$userdept,')>0 OR INStr(GROUP_DEPT,'$userdept,')=1) 
					OR
					(INStr(GROUP_PRIV,',$userpriv,')>0 OR INStr(GROUP_PRIV,'$userpriv,')=1)
					OR 
					(InStr(GROUP_USER,'$userid,')>0 OR INStr(GROUP_USER,'$userid,')=1)
				  )
				)
			";
		$res = exequery($connection,$query);
		while($row = mysql_fetch_array($res))
		{
			$sqlc = "
				SELECT COUNT(*) AS cnt FROM address_group 
					WHERE GROUP_PARENT ='".SecurityFilter($row["GROUP_ID"])."'
				";
			$rsc  = exequery($connection,$sqlc);
			$rowc = mysql_fetch_array($rsc);
			$cntc = $rowc['cnt'];	
			if($cntc > 0)
			{
				$str .= '<table id="'.$row["GROUP_ID"].'" height="30px;" border="0" cellpadding="0" cellspacing="0" width="100%" style="border-top:1px solid #ccc;">
                    <tr>
                        <td class="backchange" align="left" width="85%" id="show_'.$row["GROUP_ID"].'" onclick="ChooseSure(this,\''.$row["GROUP_ID"].'\',\''.$row["GROUP_NAME"].'\')">
                            <div style=" margin-left:10px;">
                                '.$row["GROUP_NAME"].'
                            </div>
                        </td>
                        <td width="*">
                            <table border="0" cellpadding="0" cellspacing="0" width="100%">
                                <tr>
                                    <td width="1px" align="right">
                                        <div class="line" style="background: #CCCCCC;height: 25px;overflow: hidden; width:1px"></div>
                                    </td>
                                    <td align="center" onclick="Doexpandaddr(\''.$row["GROUP_ID"].'\')">
                                        <span id="expand" class="showexpand"></span>
                                    </td>
                                </tr>
                            </table>
                        </td>
                    </tr>
                </table>
                <div id="expand_'.$row["GROUP_ID"].'" style="width:100%; display:none"></div>';
			}
			else
			{
				$str .= '<table class="backchange" id="other_'.$row["GROUP_ID"].'" height="30px;" border="0" cellpadding="0" cellspacing="0" width="100%" style="border-top:1px solid #ccc;" onclick="ChooseSure(this,\''.$row["GROUP_ID"].'\',\''.$row["GROUP_NAME"].'\')">
                    <tr>
                        <td align="left" width="90%">
                            <div style=" margin-left:10px;">
                                '.$row["GROUP_NAME"].'
                            </div>
                        </td>
                    </tr>
                </table>';
			}
		}	
		if($str==""){
			echo ReturnNoingRemaid();	
		}	
		else{
			echo $str;	
		}	
    }
    public function ajaxSearch(){
        global $connection;
		$search = SecurityFilter($_REQUEST["serchword"]);
		$userid = SecurityFilter($_REQUEST["userid"]);
		$privid = SecurityFilter($_REQUEST["userpriv"]);
		$deptid = SecurityFilter($_REQUEST["userdept"]);
		$strid  = "";
		$query = "
				SELECT GROUP_NAME,GROUP_PARENT,GROUP_ID
				FROM address_group
				WHERE GROUP_TYPE  = 1
				AND (
					GROUP_DEPT = 'ALL_DEPT'
					OR(
						(INStr(GROUP_DEPT,',".$deptid.",')>0 OR INStr(GROUP_DEPT,'".$deptid.",')=1) 
						OR
						(INStr(GROUP_PRIV,',".$privid.",')>0 OR INStr(GROUP_PRIV,'".$privid.",')=1)
						OR 
						(InStr(GROUP_USER,'$userid,')>0 OR INStr(GROUP_USER,'$userid,')=1)
					  )
					)
				";
		if($search=="" || $search=="请输入名称...")
		{
			$query .= " AND GROUP_PARENT = 0 ";
			$res = exequery($connection,$query);
			$i=0;
			while($row = mysql_fetch_array($res))
			{
				if($i==0)
				{
					$str .= '<li class="licentershow" style="border-top:1px solid #ccc;">';	
				}
				else
				{
					$str .= '<li class="licentershow">';		
				}
				$str .= '<table id="'.$row['GROUP_ID'].'" height="30px;" border="0" cellpadding="0" cellspacing="0" width="100%">
							<tr>
								<td align="left" width="85%" id="show_'.$row['GROUP_ID'].'" onclick="ChooseSure(this,\''.$row['GROUP_ID'].'\',\''.$row['GROUP_NAME'].'\')">
									<div style=" margin-left:10px;">
										'.$row['GROUP_NAME'].'
									</div>
								</td>
								<td width="*">
									<table border="0" cellpadding="0" cellspacing="0" width="100%">
										<tr>
											<td width="1px" align="right">
												<div class="line" style="background: #CCCCCC;height: 25px;overflow: hidden; width:1px"></div>
											</td>
											<td align="center" onclick="Doexpandaddr(\''.$row['GROUP_ID'].'\')">
												<span id="expand" class="showexpand"></span>
											</td>
										</tr>
									</table>
								</td>
							</tr>
						</table>
						<div id="expand_'.$row['GROUP_ID'].'" style="width:100%; display:none"></div>';
				$str .= '</li>';
				$i++;	
			}		
		}
		else
		{
			$query .= " AND GROUP_NAME LIKE '%".SecurityFilter($search)."%' ";
			$res = exequery($connection,$query);
			$i=0;
			while($row = mysql_fetch_array($res))
			{
				if($i==0)
				{
					$str .= '<li class="licentershow" style="border-top:1px solid #ccc;">';	
				}
				else
				{
					$str .= '<li class="licentershow">';		
				}
				$str .= '<table id="other_'.$row["GROUP_ID"].'" height="30px;" border="0" cellpadding="0" cellspacing="0" width="100%" onclick="ChooseSure(this,\''.$row["GROUP_ID"].'\',\''.$row["GROUP_NAME"].'\')">
							<tr>
								<td align="left" width="90%">
									<div style=" margin-left:10px;">
										'.$row["GROUP_NAME"].'
									</div>
								</td>
							</tr>
						</table>';
				$str .= '</li>';
				$i++;	
			}	
		}
		if($str==""){
			echo ReturnNoingRemaid();	
		}	
		else{
			echo $str;	
		}	
    }
}
