<?php
/**
 * @copyright (C) 2000 - 2014 Weaver Co.Ltd
 * @package   eoffice9.0
 * @name      webroot/E-mobile/App/Common/Image/ImageProxy.php
 * @function  图片处理代理类      
 * @version   1.0 
 * @author    lizj
 */
class ImageProxy{
    public function __construct() {
        ;
    }
    public function show(){
        global $_lang;
        $picPath        = request_var('picPath','');
        if($picPath == ''){
            $attachId   = request_var('attachId','');
            $attachName = request_var('attachName','');
            if($attachId && $attachName){
                $picPath = GetATTACHMENTURL($attachId, $attachName);
            }else{
                errorPage('error', $_lang['emobile_common_Image_imgID']);
                exit;
            }
        }else{
            $picPath = ROOT_PATH.$picPath;
        }
        $goback         = request_var('goback','');
        $sonFile        = request_var('sonFile','');
        $picPathArray   = explode('attachment/', $picPath);
        $picPathArray2  = explode('/', $picPathArray[1]);
        $picName        = substr($picPathArray2[1],0,strrpos($picPathArray2[1], '.'));
        $picPrix        = substr($picPathArray2[1],strrpos($picPathArray2[1], '.')+1);
        if($sonFile != ''){
            $newPicPath     = ROOT_PATH.'attachment/'.$sonFile.'/'. $picPathArray2[0].'/'.iconv('UTF-8','GBK',$picName).'.'.$picPrix;
        }else{
            $newPicPath     = ROOT_PATH.'attachment/'. $picPathArray2[0].'/'.iconv('UTF-8','GBK',$picName).'.'.$picPrix;
        }
        
        $fileSize       = abs(filesize($newPicPath));
        $fileMB         = floatval($this->HumanReadableFilesize($fileSize.'B'));
        //判断是否需要创建缩略图
        if($fileMB >= 2){
            $targetPath     = ROOT_PATH . 'E-mobile/Public/upload/attachment/';
            if (!file_exists($targetPath)) {
                mkdir($targetPath, 0777, true);
            }
            $size           = getimagesize($newPicPath);
            $imgWidth       = $size[0];
            $imgHeight      = $size[1];
            $targetFile     = $targetPath . md5($picPathArray2[0].'_'.$picName).'.'.$picPrix;
            $showPic        = '/E-mobile/Public/upload/attachment/'. md5($picPathArray2[0].'_'.$picName).'.'.$picPrix;
            if(!file_exists($targetFile)){
                if(!$this->_createThumb($newPicPath, $targetFile, $picPrix, $imgWidth, $imgHeight)){
                    if($sonFile != ''){
                        $showPic = '/attachment/'.$sonFile.'/'.$picPathArray[1];
                    }else{
                        $showPic = '/attachment/'.$picPathArray[1];
                    }
                }
            }
        }else{
            if($sonFile != ''){
                $showPic = '/attachment/'.$sonFile.'/'.$picPathArray[1];
            }else{
                $showPic = '/attachment/'.$picPathArray[1];
            }
        }
        include(INCLUDE_APP_PATH . 'Common/Image/View/ImageView.php');
    }
    /**
     * 将byte转为MB
     * @param type $size
     * @return type
     */
    private function HumanReadableFilesize($size) {
        $mod = 1024; 
        $units = explode(' ','B KB MB GB TB PB');
        for ($i = 0; $size > $mod; $i++) {
            $size /= $mod;
        }
        return round($size, 2) . ' ' . $units[$i];
    }
    /*
    * 创建缩略图
    */  
    private function _createThumb($targetFile,$thumbFile,$ext,$oldWidth,$oldHeight){
        $dstW=1024;//缩略图宽
        $dstH=($dstW * $oldHeight) /$oldWidth;//缩略图高
        if(@imagecreatefromgif($targetFile)){
            $src_image=imagecreatefromgif($targetFile);
        }else if(@imagecreatefrompng($targetFile)){
             $src_image=imagecreatefrompng($targetFile);
        }else if(@imagecreatefromjpeg($targetFile)){
            $src_image=imagecreatefromjpeg($targetFile);
        }
        switch (strtolower($ext)) {
            case 'jpeg':
                $srcW=imagesx($src_image); //获得图片宽
                $srcH=imagesy($src_image); //获得图片高
                $dst_image=imagecreatetruecolor($dstW,$dstH);
                imagecopyresized($dst_image,$src_image,0,0,0,0,$dstW,$dstH,$srcW,$srcH);
                return imagejpeg($dst_image,$thumbFile);
                break;
            case 'png':
                $srcW=imagesx($src_image); //获得图片宽
                $srcH=imagesy($src_image); //获得图片高
                $dst_image=imagecreatetruecolor($dstW,$dstH);
                imagecopyresized($dst_image,$src_image,0,0,0,0,$dstW,$dstH,$srcW,$srcH);
                return imagepng($dst_image,$thumbFile);
                break;
            case 'jpg':;
                $srcW=imagesx($src_image); //获得图片宽
                $srcH=imagesy($src_image); //获得图片高
                $dst_image=imagecreatetruecolor($dstW,$dstH);
                imagecopyresized($dst_image,$src_image,0,0,0,0,$dstW,$dstH,$srcW,$srcH);
                return imagejpeg($dst_image,$thumbFile);
                break;
            case 'gif':
                $srcW=imagesx($src_image); //获得图片宽
                $srcH=imagesy($src_image); //获得图片高
                $dst_image=imagecreatetruecolor($dstW,$dstH);
                imagecopyresized($dst_image,$src_image,0,0,0,0,$dstW,$dstH,$srcW,$srcH);
                return imagegif($dst_image,$thumbFile);
                break;
            default:
                return false;
                break;
        }
    }
}
