<?php
include_once('E-mobile/constant.php'); 
include_once("lang/".LOGIN_LANG."/emobile.lang.php");
/**
 * @copyright (C) 2014 - 2015 Weaver Co.Ltd
 * @package   eoffice9.0
 * @name      webroot/E-mobile/App/Common/Notify/Tool.php
 * @function  系统工具类      
 * @version   1.0 
 * @author    lizhijun
 */
class Tool {
    /**
     * 获取用户头像图片
     * @param type $userId
     * @param type $avatarType
     * @return string
     */
    public static function getUserImage($userId,$avatarType){
        if($avatarType == ""){
            $userImage  = IMG_PATH . "defaultimg.png";	
        }else{
            $img = "/attachment/personal/" . $userId . "/avatar_80" . $avatarType;
            if(CheckFileExist($img)){
                $userImage = $img;	
            }else{
                $userImage = IMG_PATH . "defaultimg.png";		
            }
        }
        return $userImage;
    }
    
    /**
     * 检查用户是否登录
     * 检查用户菜单权限
     * @param type $sessionstr
     * @param type $menu
     * @param type $isReturn 是否返回错误信息
     * @return string error1(用户登录过期)，error2(用户没有该菜单权限)
     */
    public static function checkUserAuth($sessionstr,$menu,$isReturn=false){
        global $_lang;
        if($sessionstr){
            $strexplode = explode("_",$sessionstr);
            $cursession = $strexplode[0];
            $userId     = $strexplode[1];
            $check      = CheckSessionKeys($cursession);
            if($check){
                if(CheckMenuPriv($userId,$menu)){
                    return $userId;
                }else{
                    if($isReturn){
                        return 'error2';
                    }
                    errorPage('error', $_lang['emobile_common_Tool_auth_1']);
                    exit;
                }
            }else{
                if($isReturn){
                    return 'error1';
                }
                errorPage('error', $_lang['emobile_common_Tool_auth_2']);
                exit;
            }
        }else{
            if($isReturn){
                return 'error1';
            }
            errorPage('error', $_lang['emobile_common_Tool_auth_2']);
            exit;
        }
    }
}
