var UserSelect = {
    version:1.0,
    author:'lizhijun',
    date:'2014-11-20',
    pluginName:'用户选择器',
    selectObj:'',//选择框对象
    callback:'',//调用端回调函数
    showId:'',//调用端显示用户div的id
    hiddenId:'',//调用端存放用户ID的隐藏域的id
    deptReload:false,//部门是否已加载标志
    personReload:false,//用户是否已加载标志
    privReload:false,//角色是否已加载标志
    userIds:[],//已选的用户id
    isFlow:false,
    //用户选择器全局参数
    param: {
        height: '100%',
        width: '100%',
        top: '0px',
        right: '0px',
        selectType:'mulit',//选择类型，单选single，多选mulit
        reload:true,//打开选择框是否重新加载，默认true
        url:'/E-mobile/App/Common/UserSelectNew/do.php',
    },
    //用户选择器容器模板
    template: {
        theme:'<div class="select_box">\
                    <div class="select_box_header">\
                        <div class="select_menu active" id="person">'+Emobile.TXT0000029+'</div>\
                        <div class="select_menu" id="dept">'+Emobile.TXT0000030+'</div>\
                        <div class="select_menu" id="priv">'+Emobile.TXT0000031+'</div>\
                        <div class="close" id="close"></div>\
                    </div>\
                    <div class="select_box_body">\
                        <div class="data_list person">\
                            <div class="search_name">\
                                <div class="search_input" style="margin-left:3%;width:70%;float:left;">\
                                    <div class="search_text"><input type="text" id="user_keyword" value="" placeholder="'+Emobile.TXT0000032+'"></div>\
                                    <div class="search_button" id="user_button"></div>\
                                </div>\
                                <div class="pinyin" id="pinyin">'+Emobile.TXT0000033+'</div>\
                            </div>\
                            <div class="search_pinyin"></div>\
                            <div class="list person_list"></div>\
                            <div class="load_more" page="0">'+Emobile.TXT0000034+'</div>\
                        </div>\
                        <div class="data_list dept">\
                            <div class="search_name">\
                                <div class="search_input">\
                                    <div class="search_text"><input type="text" id="dept_keyword" value="" placeholder="'+Emobile.TXT0000046+'"></div>\
                                    <div class="search_button" id="dept_button"></div>\
                                </div>\
                            </div>\
                            <div class="list dept_list"></div>\
                            <div class="load_more" page="0">'+Emobile.TXT0000034+'</div>\
                        </div>\
                        <div class="data_list priv">\
                            <div class="priv_list"></div>\
                        </div>\
                    </div>\
                    <div class="select_box_footer">\
                        <div class="footer_button" id="select_all">'+Emobile.TXT0000036+'</div>\
                        <div class="footer_button" id="cancel_all">'+Emobile.TXT0000037+'</div>\
                        <div class="footer_button" id="submit">'+Emobile.TXT0000038+'</div>\
                        <div class="footer_button2" id="submit_all">'+Emobile.TXT0000039+'</div>\
                    </div>\
                </div>', 
        theme1:''
    },
    //初始设置用户选择器容器
    setSelectBox:function($selectObj){
        var paramObj = UserSelect.param;
        $selectObj.css({'width':paramObj.width,'height':paramObj.height,
                'position':'fixed', 'z-index':'999999','top':paramObj.top,'right':paramObj.right})
            .html(UserSelect.template.theme).hide();
    },
    //用户选择方式切换操作
    operationSwitch:function(){
        var $selectObj = UserSelect.selectObj;
        $selectObj.find('.select_menu').click(function(){
            var id = $(this).attr('id');
            $selectObj.find('.select_menu').removeClass('active');
            $(this).addClass('active');
            switch(id){
                case 'dept':
                    $selectObj.find('.select_box_body .person').hide();
                    $selectObj.find('.select_box_body .priv').hide();
                    var $deptObj = $selectObj.find('.select_box_body .dept');
                    if(UserSelect.deptReload == false){
                        var $listObj = $deptObj.find('.dept_list');
                        UserSelect.getDeptList('',$listObj,'');
                        UserSelect.deptReload = true;
                    }
                    $deptObj.show();
                    break;
                case 'priv':
                    $selectObj.find('.select_box_body .dept').hide();
                    $selectObj.find('.select_box_body .person').hide();
                    var $privObj = $selectObj.find('.select_box_body .priv');
                     if(UserSelect.privReload == false){
                        var $listObj = $privObj.find('.priv_list');
                        UserSelect.getPrivList($listObj);
                        UserSelect.privReload = true;
                    }
                    $selectObj.find('.select_box_body .priv').show();
                    break;
                case 'person':
                    $selectObj.find('.select_box_body .dept').hide();
                    $selectObj.find('.select_box_body .priv').hide();
                    var $personObj = $selectObj.find('.select_box_body .person');
                    if(UserSelect.personReload == false){
                        var $listObj = $personObj.find('.person_list');
                        UserSelect.getUserList(0,'',0,0,'',$listObj,'');
                        UserSelect.personReload = true;
                    }
                    $personObj.show();
                    break;
                default:
                    alert('error');
            }
        });
    },
    //初始化按人员选择的列表页面
    initPerson:function($selectObj,$personObj){
        var pinyin = ['ALL','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','#'];
        var pinyinHtml = '';
        $.each(pinyin,function(i,e){
            pinyinHtml += '<div class="button_pinyin" word_id="'+e+'">'+e+'</div>';
        });
        $selectObj.find('.search_pinyin').html(pinyinHtml);
        var $personObj = $selectObj.find('.select_box_body .person');
        $personObj.find('.pinyin').click(function(){
            if($selectObj.find('.search_pinyin').css('display') == 'none'){
                $selectObj.find('.search_pinyin').show();
            }else{
                $selectObj.find('.search_pinyin').hide();
            }
        }).mouseenter(function(){
            $(this).css({'background':'#2E9DBF'});
        }).mouseleave(function(){
            $(this).css({'background':'#5BC0DE'});
        });
        UserSelect.pinyinSearch($selectObj,$personObj);
        UserSelect.userKeywordSearch($selectObj,$personObj);
        var $listObj = $personObj.find('.person_list');
        UserSelect.selectUser($listObj);
        $personObj.find('.load_more').click(function(){
            if($(this).text() ==  Emobile.TXT0000040 || $(this).text() == Emobile.TXT0000041){
                return;
            }
            var page = parseInt($(this).attr('page')) + 1;
            UserSelect.getMoreUserList(page,'',0,0,'',$listObj);
            $(this).attr('page',page);
        });
    },
     //初始化按部门选择的列表页面
    initDept:function($selectObj,$deptObj){
        var $listObj = $deptObj.find('.dept_list');
        $deptObj.find('.load_more').click(function(){
            if($(this).text() == Emobile.TXT0000042 || $(this).text() == Emobile.TXT0000043){
                return;
            }
            var page = parseInt($(this).attr('page')) + 1;
            UserSelect.getMoreDeptList('',page,$listObj);
            $(this).attr('page',page);
        });
        $deptObj.find('#dept_button').click(function(){
            var keyword = $deptObj.find('#dept_keyword').val();
            UserSelect.getDeptList(keyword,$listObj,'keyword');
        });
        $deptObj.find('#dept_keyword').keydown(function(event) {
            if (event.keyCode == "13") {
                $deptObj.find('#dept_button').click();
            }
        });
        $listObj.on({
            click:function(){
                var dept_id = $(this).parent().attr('dept_id');
                var $contentObj = $(this).parent().parent().find('.dept_item_content');
                if($(this).parent().attr('load') != 1){
                    UserSelect.getUserList(0,'',dept_id,0,'',$contentObj,'dept');
                    $(this).parent().attr('load',1);
                }
                if($contentObj.css('display') == 'none'){
                    $(this).find('span').addClass('open');
                    $contentObj.slideDown('show');
                }else{
                     $(this).find('span').removeClass('open');
                     $contentObj.slideUp('hide');
                }
            }
        },'.dept_item_title .title_left');
        UserSelect.selectUser($listObj);
        $listObj.on({
            click:function(){
                var $dept_content = $(this).parent().parent().find('.dept_item_content');
                if($(this).attr('select') == 1){
                    $(this).attr('select',0).removeClass('selected');
                    $(this).parent().css({'background':''});
                    $dept_content.find('.user_item').attr('select',0).removeClass('active');
                    $dept_content.find('.user_select_box').removeClass('selected');
                }else{
                    if(UserSelect.param.selectType == 'single') {
                        alert( Emobile.TXT0000045);return;
                    }
                    if($(this).parent().attr('load') == 1){
                        $(this).parent().css({'background':'#eaeaea'});
                        $(this).attr('select',1).addClass('selected');
                        $dept_content.find('.user_item').attr('select',1).addClass('active');
                        $dept_content.find('.user_select_box').addClass('selected');
                    }
                    return;
                }
            }
        },'.dept_select_box');
    },
     //初始化按角色选择的列表页面
    initPriv:function($selectObj,$privObj){
        var $listObj = $privObj.find('.priv_list');
         $listObj.on({
            click:function(){
                var user_priv = $(this).parent().attr('user_priv');
                var $contentObj = $(this).parent().parent().find('.dept_item_content');
                if($(this).parent().attr('load') != 1){
                    UserSelect.getUserList(0,'',0,user_priv,'',$contentObj,'priv');
                    $(this).parent().attr('load',1);
                }
                if($contentObj.css('display') == 'none'){
                    $(this).find('span').addClass('open');
                    $contentObj.slideDown('show');
                }else{
                     $(this).find('span').removeClass('open');
                     $contentObj.slideUp('hide');
                }
            }
        },'.dept_item_title .title_left');
        UserSelect.selectUser($listObj);
        $listObj.on({
            click:function(){
                var $priv_content = $(this).parent().parent().find('.dept_item_content');
                if($(this).attr('select') == 1){
                    $(this).attr('select',0).removeClass('selected');
                    $(this).parent().css({'background':''});
                    $priv_content.find('.user_item').attr('select',0).removeClass('active');
                    $priv_content.find('.user_select_box').removeClass('selected');
                }else{
                    if(UserSelect.param.selectType == 'single') {
                        alert( Emobile.TXT0000045);return;
                    }
                    if($(this).parent().attr('load') == 1){
                        $(this).parent().css({'background':'#eaeaea'});
                        $(this).attr('select',1).addClass('selected');
                        $priv_content.find('.user_item').attr('select',1).addClass('active');
                        $priv_content.find('.user_select_box').addClass('selected');
                    }
                    return;
                }
            }
        },'.dept_select_box');
    },
    //获取角色列表
    getPrivList:function($listObj){
         $.ajax({
            url:UserSelect.param.url,
            type:'post',
            data:{
                method:'getPrivList',
            }
        }).done(function(result){
            if(result == 0){
                $listObj.html('<div style="width;100%;height:40px;line-height:40px;text-align:center;">'+Emobile.TXT0000044+'</div>');
                return;
            }
            var parseResult = $.parseJSON(result);
            var html = '';
            $.each(parseResult,function(k,v){
                 html += '<div class="dept_item">\
                            <div class="dept_item_title" user_priv="'+v.USER_PRIV+'">\
                                <div class="title_left"><span class="dept_open_icon"></span>&nbsp;'+v.PRIV_NAME+'</div><div class="dept_select_box"></div>\
                            </div>\
                            <div class="dept_item_content" style="display:none;"></div>\
                        </div>';
            });
            $listObj.html(html);
        });
    },
    //获取部门列表
    getDeptList:function(keyword,$listObj,type){
        if($listObj.parent().find('.load_more').text() != ''+Emobile.TXT0000034+''){
            $listObj.parent().find('.load_more').text(''+Emobile.TXT0000034+'');
        }
        if(type == 'keyword'){
             $listObj.parent().find('.load_more').hide();
        }else{
            $listObj.parent().find('.load_more').show();
        }
        $.ajax({
            url:UserSelect.param.url,
            type:'post',
            data:{
                method:'getDeptList',
                keyword:keyword,
            }
        }).done(function(result){
            if( result== 0){
                $listObj.html('');
                $listObj.parent().find('.load_more').text(Emobile.TXT0000043);
                if(type == 'keyword'){
                    $listObj.parent().find('.load_more').attr('page',0);
                    UserSelect.deptReload = false;
                }
                return ;
            }
            var parseResult = $.parseJSON(result);
            var html = '';
            $.each(parseResult,function(k,v){
                html += '<div class="dept_item">\
                            <div class="dept_item_title" dept_id="'+v.DEPT_ID+'">\
                                <div class="title_left"><span class="dept_open_icon"></span>&nbsp;'+v.DEPT_NAME+'</div><div class="dept_select_box"></div>\
                            </div>\
                            <div class="dept_item_content" style="display:none;"></div>\
                        </div>';
            });
            $listObj.html(html);
            if(type == 'keyword'){
                $listObj.parent().find('.load_more').attr('page',0);
                UserSelect.deptReload = false;
            }
        });
    },
    //获取更多部门列表
    getMoreDeptList:function(keyword,page,$listObj){
         $.ajax({
            url:UserSelect.param.url,
            type:'post',
            data:{
                method:'getDeptList',
                keyword:keyword,
                page:page,
            }
        }).done(function(result){
            if( result== 0){
                $listObj.parent().find('.load_more').text(Emobile.TXT0000042);
                return ;
            }
            var parseResult = $.parseJSON(result);
            var html = '';
            $.each(parseResult,function(k,v){
                html += '<div class="dept_item">\
                            <div class="dept_item_title" dept_id="'+v.DEPT_ID+'">\
                                <div class="title_left"><span class="dept_open_icon"></span>&nbsp;'+v.DEPT_NAME+'</div><div class="dept_select_box"></div>\
                            </div>\
                            <div class="dept_item_content"></div>\
                        </div>';
            })
            $listObj.append(html);
        });
    },
        //获取用户列表
    getUserList:function(page,keyword,deptId,privId,pinyin,$listObj,type){
        if(type == 'pinyin' || type == 'keyword'){
            $listObj.parent().find('.load_more').attr('page',0).text(''+Emobile.TXT0000034+'').hide();
        }
        if(pinyin == ''&&type != 'keyword'){
            $listObj.parent().find('.load_more').text(''+Emobile.TXT0000034+'').show();
        }
        $.ajax({
            url: UserSelect.param.url,
            async:true,
            data:{
                method:'getUserList',
                page:page,
                keyword:keyword,
                deptId:deptId,
                privId:privId,
                pinyin:pinyin
            }
        }).done(function(result){
            if(result == 0){
                $listObj.html('');
                $listObj.parent().find('.load_more').text(Emobile.TXT0000041).show();
                if(type == 'pinyin'){
                    UserSelect.selectObj.find('.search_pinyin').hide();
                }
                if(type == 'keyword'){
                    UserSelect.personReload = false;
                    $listObj.parent().find('.load_more').attr('page',0);
                }
                if(type == 'dept'){
                    $listObj.html('<div style="width:100%;height:40px;line-height:40px;border-bottom:1px solid #eaeaea;text-align:center;float:left;">'+Emobile.TXT0000041+'</div>')
                }
                return;
            }
            var parseResult = $.parseJSON(result);
            var html = '';
            $.each(parseResult,function(k,v){
                var selectAttr = '';
                var active = '';
                var selected = '';
                if($.inArray(v.USER_ID, UserSelect.userIds) >=0){
                    selectAttr = 'select="1"';
                    active = 'active';
                    selected = 'selected';
                }
                html += '<div class="user_item '+active+'" '+selectAttr+' user_id="'+v.USER_ID+'" user_name="'+v.USER_NAME+'"><div class="user_select_box '+selected+'"></div><div class="user_name">'+v.USER_NAME+'['+v.USER_ACCOUNTS+']</div></div>'
            });
            $listObj.html(html);
            if(type == 'pinyin'){
                UserSelect.selectObj.find('.search_pinyin').hide();
            }
            if(type == 'keyword'){
                UserSelect.personReload = false;
                $listObj.parent().find('.load_more').attr('page',0);
            }
        });
    },
    //获取更多用户列表
    getMoreUserList:function(page,keyword,deptId,privId,pinyin,$listObj){
        $.ajax({
            url: UserSelect.param.url,
            async:true,
            data:{
                method:'getUserList',
                page:page,
                keyword:keyword,
                deptId:deptId,
                privId:privId,
                pinyin:pinyin
            }
        }).done(function(result){
            if(result == 0){
                $listObj.parent().find('.load_more').text(Emobile.TXT0000040);
                return;
            }
            var parseResult = $.parseJSON(result);
            var html = '';
            $.each(parseResult,function(k,v){
                var selectAttr = '';
                var active = '';
                var selected = '';
                if($.inArray(v.USER_ID, UserSelect.userIds) >= 0){
                    selectAttr = 'select="1"';
                    active = 'active';
                    selected = 'selected';
                }
                html += '<div class="user_item '+active+'" '+selectAttr+' user_id="'+v.USER_ID+'" user_name="'+v.USER_NAME+'"><div class="user_select_box '+selected+'"></div><div class="user_name">'+v.USER_NAME+'['+v.USER_ACCOUNTS+']</div></div>'
            });
            $listObj.append(html);
        });
    },
    //根据用户首字母拼音进行查询用户
    pinyinSearch:function($selectObj,$personObj){
        $personObj.find('.search_pinyin .button_pinyin').mouseenter(function(){
            $(this).css({'background':'rgba(231,76,60,0.2)'})
        }).mouseleave(function(){
            $(this).css({'background':''})
        }).click(function(){
            var wordId = $(this).attr('word_id');
            if(wordId == '#'){
                wordId = '';
            }
            var $listObj = $personObj.find('.person_list');
            UserSelect.getUserList(0,'',0,0,wordId,$listObj,'pinyin');
        });
    },
    //更加用户名，用户账号，中文或拼音关键字查询用户
    userKeywordSearch:function($selectObj,$personObj){
        var $listObj = $personObj.find('.person_list');
        $personObj.find('#user_button').click(function(){
            var keyword = $personObj.find('#user_keyword').val();
            UserSelect.getUserList(0,keyword,0,0,'',$listObj,'keyword');
        });
        $personObj.find('#user_keyword').keydown(function(event) {
            if (event.keyCode == "13") {
                $personObj.find('#user_button').click();
            }
        });
    },
    //获取显示的列表对象
    getListObj:function($selectObj){
        var $listObj = $selectObj.find('.select_box_body .person');
        if($selectObj.find('.select_box_body .person').css('display') == 'block'){
            $listObj = $selectObj.find('.select_box_body .person');
        }else if($selectObj.find('.select_box_body .dept').css('display') == 'block'){
            $listObj = $selectObj.find('.select_box_body .dept');
        }else if($selectObj.find('.select_box_body .priv').css('display') == 'block'){
            $listObj = $selectObj.find('.select_box_body .priv');
        }
        return $listObj;
    },
    //选择用户，单选或多选
    selectUser: function($listObj){
        if(UserSelect.param.selectType == 'mulit'){
            $listObj.on({
                click:function(){
                    if($(this).attr('select') == 1){
                        $(this).removeClass('active').attr('select',0);
                        $(this).find('.user_select_box').removeClass('selected');
                    }else{
                        $(this).addClass('active').attr('select',1);
                        $(this).find('.user_select_box').addClass('selected');
                    }
                },
                mouseenter:function(){
                    if($(this).attr('select') == 1){
                        return;
                    }
                    $(this).css('background','#f4f4f4');
                },
                mouseleave:function(){
                    if($(this).attr('select') == 1){
                        return;
                    }
                    $(this).css('background','');
                }
            },".user_item");
        }else{
             $listObj.on({
                click:function(){
                    if($(this).attr('select') == 1){
                        $(this).removeClass('active').attr('select',0);
                        $(this).find('.user_select_box').removeClass('selected');
                    }else{
                        $('.user_item').removeClass('active').attr('select',0);
                        $('.user_item .user_select_box').removeClass('selected');
                        $(this).addClass('active').attr('select',1);
                        $(this).find('.user_select_box').addClass('selected');
                    }
                },
                mouseenter:function(){
                    if($(this).attr('select') == 1){
                        return;
                    }
                    $(this).css('background','#f4f4f4');
                },
                mouseleave:function(){
                    if($(this).attr('select') == 1){
                        return;
                    }
                    $(this).css('background','');
                }
            },".user_item");
        }
    },
    //将显示的用户列表全部选中
    selectAll:function($selectObj){
        $selectObj.find('#select_all').click(function(){
            var $listObj = UserSelect.getListObj($selectObj);
            if(UserSelect.param.selectType == 'mulit'){
                $listObj.find('.user_item').attr('select',1).addClass('active');
                $listObj.find('.user_select_box').addClass('selected');
            }else{
                alert( Emobile.TXT0000045);return;
            }
        })
    },
    //将选中的用户进行撤消
    cancelAll:function($selectObj){
        $selectObj.find('#cancel_all').click(function(){
            var $listObj = UserSelect.getListObj($selectObj);
            $listObj.find('.user_item').attr('select',0).removeClass('active').css('background','');
            $listObj.find('.user_select_box').removeClass('selected');
        })
    },
    //提交选中结果
    submitAll:function($selectObj){
       $selectObj.find('#submit').click(function(){
            var $listObj = UserSelect.getListObj($selectObj);
            if($.isFunction(UserSelect.callback)){
                var userItems = $listObj.find('.user_item.active');
                var userArray = new Array();
                $.each(userItems,function(k,v){
                    var userName = $(v).attr('user_name');
                    var userId   = $(v).attr('user_id');
                    userArray.push({userName:userName,userId:userId});
                })
                UserSelect.callback(userArray,0);
            }else{
                UserSelect.success($listObj);
            }
            $selectObj.slideUp('hide');
        });
    },
    submitAllUser:function($selectObj){
        $selectObj.find('#submit_all').click(function(){
            if(UserSelect.param.selectType == 'single'){
                alert( Emobile.TXT0000045);return;
            }
            $.ajax({
                url: UserSelect.param.url,
                async:true,
                data:{
                    method:'getAllUser',
                }
            }).done(function(result){
                if($.isFunction(UserSelect.callback)){
                    var parseResult = $.parseJSON(result);
                    var userArray = new Array();
                    $.each(parseResult,function(k,v){
                        var userName = v.USER_NAME;
                        var userId   = v.USER_ID;
                        userArray.push({userName:userName,userId:userId});
                    });
                    UserSelect.callback(userArray,1);
                }else{
                    var hideUser='',showUserName='';
                    var showDiv = '<div class="user_select show_user_item" user_id="all_user" onclick="removeALLUser(this)">'+Emobile.TXT0000039+'<div class="show_user_close"></div></div>';
                    var parseResult = $.parseJSON(result);
                    $.each(parseResult,function(k,v){
                        var userId   = v.USER_ID;
                        var userName  = v.USER_NAME;
                        hideUser += userId + ',';
                        showUserName +=userName +',';
                    });
                    if(UserSelect.isFlow == true){
                        hideUser = showUserName + '|' + hideUser;
                        var ids =  UserSelect.showId.split('_');
                        var id = ids[1];
                        if(parseResult.length >0){
                            $('#required_'+id+'_span').html('');
                        }else if(parseResult.length == 0){
                            $('#required_'+id+'_span').html('<img src=\"/E-mobile/Public/images/required.gif\" align=\"absmiddle\"/>');
                        }
                        if(hideUser == '|'){
                            hideUser = '';
                        }
                    }
                    $('#'+UserSelect.hiddenId).val(hideUser);
                    $('#'+UserSelect.showId).children('.user_list').html(showDiv).show();
                }
                $selectObj.slideUp('hide');
            });
        });
    },
    //打开用户选择框
    open:function(showId,hiddenId,callback){
        UserSelect.callback = callback;
        UserSelect.showId = showId;
        UserSelect.hiddenId = hiddenId;
        var userIdStr = $('#'+hiddenId).val();
        if(userIdStr != ''){
            if(UserSelect.isFlow == true){
                userIdStr = userIdStr.split('|');
                userIdStr = userIdStr[1];
            }
            var userIdArray = userIdStr.split(',');
            userIdArray.pop();
            UserSelect.userIds = userIdArray;
        }else{
            UserSelect.userIds = [];
        }
        var $listObj = UserSelect.selectObj.find('.select_box_body .person .person_list');
        UserSelect.getUserList(0,'',0,0,'',$listObj,'');
        UserSelect.personReload = true;
        UserSelect.selectObj.slideDown('show');
    },
    //关闭用户选择框
    close:function($selectObj){
        //关闭选择框
        $selectObj.find('#close').click(function(){
            //数据还原
            if(UserSelect.param.reload == true){
                $selectObj.find('.select_box_body .dept .dept_list').html('');
                $selectObj.find('.select_box_body .dept .load_more').text(''+Emobile.TXT0000034+'').attr('page',0);
                $selectObj.find('.select_box_body .priv .priv_list').html('');
                $selectObj.find('.select_box_body .person .load_more').text(''+Emobile.TXT0000034+'').attr('page',0);
                UserSelect.deptReload   = false;
                UserSelect.privReload   = false;
                UserSelect.personReload = false;
            }
            $selectObj.find('.select_box_body .dept').hide();
            $selectObj.find('.select_box_body .priv').hide();
            $selectObj.find('.select_box_body .person').show();
            $selectObj.slideUp('hide');
            $selectObj.find('.select_menu').removeClass('active');
            $selectObj.find('#person').addClass('active');
        }).mouseenter(function(){
            $(this).css('background-color','#D9534F');
        }).mouseleave(function(){
            $(this).css('background-color','#2E9DBF');
        });
    },
    //用户选取成功后默认执行的函数
    success:function($listObj){
        var userItems = $listObj.find('.user_item.active');
        var showDiv = '';
        var hideUser = '';
        var hideUserName = '';
        $.each(userItems,function(k,v){
            var userName = $(v).attr('user_name');
            var userId   = $(v).attr('user_id');
            hideUserName += userName +',';
            hideUser += userId + ',';
            showDiv += '<div class="user_select show_user_item" user_id="'+userId+'" onclick="removeSelectedUser(this)">'+userName+'<div class="show_user_close"></div></div>';
        });
        if(UserSelect.isFlow == true){
            hideUser = hideUserName + '|' + hideUser;
            var ids =  UserSelect.showId.split('_');
            var id = ids[1];
            if(userItems.length >0){
                $('#required_'+id+'_span').html('');
            }else if(userItems.length == 0){
                $('#required_'+id+'_span').html('<img src=\"/E-mobile/Public/images/required.gif\" align=\"absmiddle\"/>');
            }
            if(hideUser == '|'){
                hideUser = '';
            }
        }
        $('#'+UserSelect.hiddenId).val(hideUser);
        $('#'+UserSelect.showId).children('.user_list').html(showDiv).show();
    },
    //删除已选元素
    removeSelectedUser:function(){
        
        $('body').on({
            click:function(){
                var $hideUserInput = $(this).parent().parent().children(':hidden');
                var idsStr =  $(this).parent().parent().attr('id');
                $(this).remove();
                var hideUser = '';
                var hideUserName = '';
                $hideUserInput.parent().find('.user_select.show_user_item').each(function(k,v){
                    var userId   = $(v).attr('user_id');
                    var userName = $(v).text();
                    hideUser += userId + ',';
                    hideUserName += userName + ',';
                });
                if(UserSelect.isFlow == true){
                    hideUser = hideUserName + '|' + hideUser;
                    var ids = idsStr.split('_');
                    var id = ids[1];
                    if($hideUserInput.parent().find('.user_select.show_user_item').length ==0){
                        $('#required_'+id+'_span').html('<img src=\"/E-mobile/Public/images/required.gif\" align=\"absmiddle\"/>');
                    }
                }
                if(hideUser == '|'){
                    hideUser = '';
                }
                $hideUserInput.val(hideUser);
            }
        },'.user_select.show_user_item');
    },
    //用户选择器初始化操作
    init:function(id){
        //获取选择框对象，并赋予全局变量
        var $selectObj = $(id);
        UserSelect.selectObj = $selectObj;
        //初始化用户选择框
        UserSelect.setSelectBox($selectObj);
        //初始化用户，部门，角色选择页面
        var $personObj = $selectObj.find('.select_box_body .person');
        var $deptObj   = $selectObj.find('.select_box_body .dept');
        var $privObj   = $selectObj.find('.select_box_body .priv');
        UserSelect.initPerson($selectObj,$personObj);
        UserSelect.initDept($selectObj,$deptObj);
        UserSelect.initPriv($selectObj,$privObj);
        //选项卡开关操作
        UserSelect.operationSwitch();
        //全选
        UserSelect.selectAll($selectObj);
        //撤消
        UserSelect.cancelAll($selectObj);
        //关闭选择框
        UserSelect.close($selectObj);  
        //提交
        UserSelect.submitAll($selectObj);
        //删除选中的用户
        UserSelect.removeSelectedUser();
        UserSelect.submitAllUser($selectObj);
        $(id+' .footer_button,'+id+ ' .footer_button2').mouseenter(function(){
            $(this).css({'background':'#eaeaea'});
        }).mouseleave(function(){
            $(this).css({'background':'#fafafa'});
        });
    }
}
function removeSelectedUser(obj){
    var $hideUserInput = $(obj).parent().parent().children(':hidden');
    var idsStr =  $(obj).parent().parent().attr('id');
    $(obj).remove();
    var hideUser = '';
    var hideUserName = '';
    $hideUserInput.parent().find('.user_select.show_user_item').each(function(k,v){
        var userId   = $(v).attr('user_id');
        var userName = $(v).text();
        hideUser += userId + ',';
        hideUserName += userName + ',';
    });
    if(UserSelect.isFlow == true){
        hideUser = hideUserName + '|' + hideUser;
        var ids = idsStr.split('_');
        var id = ids[1];
        if($hideUserInput.parent().find('.user_select.show_user_item').length ==0){
            $('#required_'+id+'_span').html('<img src=\"/E-mobile/Public/images/required.gif\" align=\"absmiddle\"/>');
        }
    }
    if(hideUser == '|'){
        hideUser = '';
    }
    $hideUserInput.val(hideUser);
}

function removeALLUser(obj){
    $(obj).remove();
    var $hideUserInput = $(obj).parent().parent().children(':hidden');
    $hideUserInput.val('');
}