<?php

/**
 * @copyright (C) 2000 - 2014 Weaver Co.Ltd
 * @package   eoffice9.0
 * @name      webroot/E-mobile/App/Crm/CrmProxy.php
 * @function  客户管理代理类       
 * @version   1.0 
 * @author    lizhijun
 */
include_once ("api/customer.class.php");

class CrmProxy {

    private $_userId; //用户id
    private $_sessionstr; //sessionkey
    private $_cursession; //当前session
    private $_pageSize = 10; //每也大小
    private static $customer; //客户api对象
    private $_userImagePath = 'personal/'; //用户头像路径

    public function __construct() {
        $this->_sessionstr = request_var("sessionkey");
        $strexplode = explode("_", $this->_sessionstr);
        $this->_cursession = $strexplode[0];
        $this->_userId = $strexplode[1];
        if (!self::$customer) {
            self::$customer = new customer();
        }
    }

    /**
     * 客户管理中心
     */
    public function crmCenter() {
        global $_lang;
        $check = CheckSessionKeys($this->_cursession); //验证sessionkey
        if ($check) {
            if (CheckMenuPriv($this->_userId, "customer")) {//验证菜单权限
                $sessionstr = $this->_sessionstr;
                $crmType = $this->_getCrmType(4);
                include_once(INCLUDE_APP_PATH . 'Crm/View/CrmCenterView.php');
            } else {
                echo $_lang["e_crm_no_power"];
            }
        } else {
            echo $_lang["e_crm_session_expire"];
        }
    }
    
    /**
     * 
     * @global type $connection
     * @param type $id
     * @return type
     */
    public function crmTransferDetail(){
        global $_lang;
        $detailid = $_REQUEST["detailid"];
        $detailCrmName =  self::$customer->getCustomerName($detailid);
        //111
        $check = CheckSessionKeys($this->_cursession); //验证sessionkey
        if ($check) {
            if (CheckMenuPriv($this->_userId, "customer")) {//验证菜单权限
                $sessionstr = $this->_sessionstr;
                $crmType = $this->_getCrmType(4);
                include_once(INCLUDE_APP_PATH . 'Crm/View/crmTransferDetailView.php');
            } else {
                echo $_lang["e_crm_no_power"];
            }
        } else {
            echo $_lang["e_crm_session_expire"];
        }
    }
    
    private function _getCrmType($id){
        global $connection;
        $query      = "SELECT CC_NAME,CC_VALUE FROM combocox_child WHERE CC_PARENT_ID=".SecurityFilter($id). " ORDER BY CC_OEDER ASC";
        $cousor     = exequery($connection, $query); 
        $crmType    = array();
        if($cousor){
            while ($row = mysql_fetch_array($cousor)) {
                $crmType[] = $row;
            }
        }
        return $crmType;
    }
    private function _getAttibute($id,$select=0){
        global $connection;
        $query      = "SELECT CC_NAME,CC_VALUE FROM combocox_child WHERE CC_PARENT_ID=".SecurityFilter($id). " ORDER BY CC_OEDER ASC";
        $cousor     = exequery($connection, $query);

        while ($row = mysql_fetch_array($cousor)) {
            if($row['CC_VALUE'] == intval($select)){
                return $row['CC_NAME'];
            }
        }
        return '';
    }
    /**
     * 获取客户信息列表
     */
    public function getCrmList() {
        $PAGE           = intval(request_var('PAGE',0));
        $CUSTOMER_TYPE  = request_var('CUSTOMER_TYPE');
        $QUICK_SORT     = request_var('QUICK_SORT');
        $ROLE_TYPE      = request_var('ROLE_TYPE');
        $SORT           = request_var('SORT');
        if($SORT){
            $sortArray  = explode('|', $SORT);
            $sortField  = $sortArray[0];
            $sortType   = $sortArray[1];
        }else{
            $sortField = 'CUSTOMER_ID';
            $sortType   = 'DESC';
        }
        $keyword        = request_var('KEYWORD');
        if($keyword){
            $query .= ' AND c.CUSTOMER_NAME LIKE \'%'.$keyword.'%\' ';
        }
        if($ROLE_TYPE){
            switch($ROLE_TYPE) {
				case"MANAGE_USER":
					$query .= " AND c.MANAGE_USER='".$this->_userId."'";
					break;
				case"SERVICE_USER":
					$query .= " AND c.SERVICE_USER='".$this->_userId."'";
					break;					
				case"CREATEOR":
					$query .= " AND c.CREATEOR='".$this->_userId."'";
					break;
			}
        }
        $param          = array(
            'itemsPerPage'          => $this->_pageSize,
            'currentPage'           => $PAGE,
            'customer_type_sort'    => $CUSTOMER_TYPE,
            'quick_sort'            => $QUICK_SORT,
            'sortField'             => $sortField,
            'sortType'              => $sortType,
            'where_query'           => $query
        );
        
        $sql = self::$customer->getCustomerIndexSql($param, 1, $this->_userId);
        $list = self::$customer->getList($sql);
        $_crmList = array();
        if($list){
            $crmType = $this->_getCrmType(4);
            $_crmType = array();
            foreach($crmType as $k => $v){
                $_crmType[$v['CC_VALUE']] = $v['CC_NAME'];
            }
            foreach ($list as $value) {
                $info               = array();
                $info['crmId']      = $value['CUSTOMER_ID'];
                $info['createTime'] = $value['CREATE_TIME'];
                $info['userImage']  = $this->_dealAtavar($value['AVATAR_TYPE'], $value['USER_ID']);
                $info['createTime'] = $value['CREATE_TIME'] == null ? '' : $value['CREATE_TIME'];
                $info['crmName']    = substrGB($value['CUSTOMER_NAME'],10,'...');
                $info['userName']   = $value['MANAGE_USER_NAME'];
                $info['userId']     = $value['USER_ID'];
                $info['telephone']  = $value['TEL_NO'];
                if($value['CUSTOMER_TYPE'] != 0){
                    $info['crmType']    = $_crmType[$value['CUSTOMER_TYPE']];
                }else{
                    $info['crmType']    = '';
                }
                array_push($_crmList, $info);
            }
        }
        echo json_encode($_crmList);
    }

    /**
     *  获取联系记录 
     * @global type $connection
     * @global type $ATTACH_PATH
     */
    public function getLinkRecord() {
        global $connection, $ATTACH_PATH;
        $crmId = intval(request_var('crmId', 0));
        $customer = new customer();
        $recordinfor = $customer->GetEmobileRecordInfor($crmId, "");
        if (empty($recordinfor)) {
            echo 0;
            exit;
        }
        $recordList = array();
        foreach ($recordinfor as $value) {
            $info['recordType'] = $value['RE_TYPE'];
            $startTime  = $value['RE_DATE1'] . ' ' . $value['RE_TIME1'];
            $endTime    = $value['RE_DATE2'] . ' ' . $value['RE_TIME2'];
            if($endTime != ' ' && $endTime != '0000-00-00 '){
                $info['LINK_DATE']  = $startTime .'&nbsp;—&nbsp;'.$endTime;
            }else{
                $info['LINK_DATE']  = $startTime;
            }
            $info['CREAT_DATE'] = $value['CREAT_DATE'] == null ? '' : $value['CREAT_DATE'];
            $info['RE_ID'] = $value['RE_ID'];
            $info['RE_RECORD'] = $value['RE_RECORD'];
            $info['createName'] = getUserNameNew($value['CREATEOR']);
            $attachmentname = explode("*", $value["ATTACHMENT_NAME"]);
            $attachmentid = explode(",", $value["ATTACHMENT_ID"]);
            $attachment = array();
            if (sizeof($attachmentid) > 1) {
                foreach ($attachmentid as $k => $v) {
                    $attachurl = $ATTACH_PATH . $v . "/" . $attachmentname[$k];
                    $attachtype = GetAttachmentPrefix($attachurl);
                    $attachImg = GetAttachType($attachurl);
                    $checkattchtype = EmobileCheckAttachType($attachurl);
                    $url = '/attachment/' . $v . "/" . $attachmentname[$k];
                    $url = GetNewUrlPath($url);
                    $checkfile = EmobileCheckFileExist($attachmentid[$k], $attachmentname[$k]);
                    if ($checkfile && $checkattchtype) {
                        $attachment[] = array(
                            'url' => $url,
                            'type' => $attachtype,
                            'attachId' => $attachmentid[$k],
                            'attachName' => $attachmentname[$k],
                            'imgType' => $attachImg,
                            'name' => $attachmentname[$k],
                        );
                    }
                }
            }
            $info['attachment'] = $attachment;
            $query = 'SELECT * FROM ' . LINKMAN . ' WHERE LINKMAN_ID=' . SecurityFilter($value['LINKMAN_ID']);
            $cousor = exequery($connection, $query);
            $row = mysql_fetch_array($cousor);
            $info['linkMan'] = $row['LINKMAN_NAME'];
            $info['linkId'] = $value['LINKMAN_ID'];
            $info['Tel'] = $row['TEL_NO_WORK'] . '&nbsp;&nbsp;' . $row['MOBILE'];
            $info['Email'] = $row['EMAIL'];
            array_push($recordList, $info);
        }
        echo json_encode($recordList);
    }

    /**
     * 获取联系人
     */
    public function ajaxGetLinkMan() {
        $crmId = intval(request_var('crmId', 0));
        $linkMan = $this->_getLinkMan($crmId);
        if (empty($linkMan)) {
            echo 0;
            exit;
        }
        $newLinkMan = array();
        foreach ($linkMan as $value) {
            $temp['linkmanId'] = $value['LINKMAN_ID'];
            $temp['linkmanName'] = $value['LINKMAN_NAME'];
            $temp['telephone'] = isset($value['MOBILE']) ? $value['MOBILE'] : (isset($value['TEL_NO_WORK']) ? $value['TEL_NO_WORK'] : '');
            $temp['email'] = $value['EMAIL'];
            array_push($newLinkMan, $temp);
        }
        echo json_encode($newLinkMan);
    }

    /**
     * 获取用户对于的头像
     * @global type $ATTACH_PATH
     * @param type $avatarType
     * @param type $userId
     * @return string
     */
    private function _getLinkMan($crmId) {
        global $connection;
        $query = 'SELECT * FROM ' . LINKMAN . ' WHERE CUSTOMER_ID=' . SecurityFilter($crmId).' ORDER BY LINKMAN_ID DESC';
        $cousor = exequery($connection, $query);
        $linkMan = array();
        while ($row = mysql_fetch_array($cousor)) {
            $linkMan[] = $row;
        }
        return $linkMan;
    }

    private function _dealAtavar($avatarType, $userId) {
        global $ATTACH_PATH;
        if (!$avatarType) {
            $avatar_type = '.png';
        } else {
            $avatar_type = $avatarType;
        }
        $personImage = $ATTACH_PATH . $this->_userImagePath . $userId . '/avatar_40' . $avatar_type;
        if (!file_exists($personImage)) {
            $imagePath = IMG_PATH . "default_user.png";
        } else {
            $imagePath = '/attachment/' . $this->_userImagePath . $userId . '/avatar_40' . $avatar_type;
        }
        return $imagePath;
    }

    /**
     * 日期时间处理方法
     * @param type $inDate
     * @return string
     */
    private function _dealDateTime($inDate) {
        global $_lang;

        $time = substr($inDate, strpos($inDate, ' '));
        $date = date('Y-m-d', strtotime($inDate));
        if ($date == date('Y-m-d')) {
            $date = '<span style="color:#75BF26;">' . $_lang["e_crm_today"] . $time . '</span>';
        } else if ($date == date('Y-m-d', strtotime("-1 day"))) {
            $date = '<span style="color:#FFA20E;">' . $_lang["e_crm_yesterday"] . $time . '</span>';
        } else if ($date == date('Y-m-d', strtotime("-2 day"))) {
            $date = '<span style="color:#FFA20E;">' . $_lang["e_crm_before_yesterday"] . $time . '</span>';
        } else if ($date == date('Y-m-d', strtotime("-3 day"))) {
            $date = '<span style="color:#FFA20E;">' . $_lang["e_crm_more_yesterday"] . $time . '</span>';
        }
        return $date;
    }

    /**
     * 获取客户详细信息
     */
    public function getCrmInfo() {
        global $_lang;
        $crmId                          = intval(request_var("crmId"));
        $customer                       = new customer();
        $infor                          = $customer->GetEmobileCustomerInfor($crmId);
        $logArr = array(
            "FIELD_CONTENT"=>$_lang["customer_emboile_check_customer"],
            "TABLE"=>'customer',
            "TABLE_ID"=>$crmId,
            "MODIFY_USER"=>$this->_userId
        );
        $customer->addSaveCustomerLog($logArr);
        $infor['CREATEOR']              = getUserNameNew($infor["CREATEOR"]);
        $infor["CUSTOMER_ATTRIBUTE"]    = $this->_getAttibute(17, $infor["CUSTOMER_ATTRIBUTE"]);
        $infor["CUSTOMER_STATUS"]       = $this->_getAttibute(6, $infor["CUSTOMER_STATUS"]);
        $infor['SERVICE_USER']          = $infor['SERVICE_USER'] == null ? '' :getUserNameNew($infor['SERVICE_USER']);
        $infor["MANAGE_USER"]           = getUserNameNew($infor["MANAGE_USER"]);
        $infor['AREA']                  = $customer->get_proName($infor["PROVINCE"]) . ($infor["CITY"] != null ? "---" . $customer->get_cityName('', $infor["CITY"]) : '');
        $infor["CUSTOMER_TYPE"]         = mobile_combox_info(4, $infor["CUSTOMER_TYPE"], 0);
        $infor["SCALE"]                 = mobile_combox_info(5, $infor["SCALE"], 0);
        $infor["CUSTOMER_INDUSTRY"]     = mobile_combox_info(27, $infor["CUSTOMER_INDUSTRY"], 0);
        $infor["CUSTOMER_TYPE"]         = $infor["CUSTOMER_TYPE"] == null ? '' : $infor["CUSTOMER_TYPE"];
        $infor["SCALE"]                 = $infor["SCALE"] == null ? '' : $infor["SCALE"];
        $infor["CUSTOMER_INDUSTRY"]     = $infor["CUSTOMER_INDUSTRY"] == null ? '' : $infor["CUSTOMER_INDUSTRY"];
        $infor['CUSTOMER_PROFIT']       = $infor['CUSTOMER_PROFIT'] == NULL ? "" : $infor['CUSTOMER_PROFIT'];
        $infor['LE_PERSON']             = $infor['LE_PERSON'] == NULL ? '' : $infor['LE_PERSON'];
        $infor['PERSON_INFO']           = $infor['PERSON_INFO'] == NULL ? '' : $infor['PERSON_INFO'];
        echo json_encode($infor);
    }

    /**
     * 创建联系人页面
     */
    public function createLink() {
        global $_lang;
        include_once ("inc/function_picture.php");
        /* 获取参数----BEGIN */
        $detailid = intval(request_var("detailid"));
        $sessionstr = request_var("sessionkey");
        $strexplode = explode("_", $sessionstr);
        $userid = $strexplode[1];

        $customer = new customer();
        $customers = $customer->GetEmobileCustomerInfor($detailid);
        include_once(INCLUDE_APP_PATH . 'Crm/View/CreatCusLinkView.php');
    }

    /**
     * 创建联系记录页面
     */
    public function createRecord() {
        global $_lang;
        /* 获取参数----BEGIN */
        $detailid	= intval(request_var("detailid"));
        $sessionstr = $this->_sessionstr;
		$check		= CheckSessionKeys($this->_cursession); //验证sessionkey
        if ($check) {
            if (CheckMenuPriv($this->_userId, "customer")) {//验证菜单权限
                $userid		= $this->_userId;
				$linkid		= $_REQUEST["linkid"];
				$linkman	= $_REQUEST["linkname"];
				if ($linkid == "" && $linkman == "") {
					$customer = new customer();
					$linkinfo = $customer->GetEmobileLinkmanInfor($detailid, "", "");
				}
				include_once(INCLUDE_APP_PATH . 'Crm/View/CreatCusRecordView.php');
            } else {
                echo $_lang["e_crm_no_power"];
            }
        } else {
            echo $_lang["e_crm_session_expire"];
        }
    }

    public function success() {
        global $_lang;
		if (!CheckSessionKeys($this->_cursession)) {
			echo $_lang["e_crm_session_expire"];exit;
		}
		if (!CheckMenuPriv($this->_userId, "customer")) {//验证菜单权限
			echo $_lang["e_crm_no_power"];exit;
		}
        include_once("inc/check_type.php");
        /* 获取参数----BEGIN */
        $detailid = intval($_REQUEST["detailid"]);
        $emailsent = $_REQUEST["emailsent"];
        $sessionstr = $this->_sessionstr;
        $userid = $this->_userId;
        $diff = request_var('diff');
        $customer = new customer();
        if ($diff == "link") {
            //新建联系人
			if(trim($_REQUEST["linkname"]) == '') {
				if(trim($content) == '' || trim($_REQUEST["chooselinkuser"]) == ''){
					header('Location:/E-mobile/App/Init.php?m=createLink_Crm&detailid='.$detailid.'&sessionkey='.$sessionstr);
					exit;
				}
			}
            $BIRTHDAY = $_REQUEST["linkbir"];
            if ($BIRTHDAY != "" && $BIRTHDAY != "0000-00-00") {
                $TIME_OK = is_date($BIRTHDAY);
                if (!$TIME_OK) {
                    $BIRTHDAY = "";
                }
            }
            $pyLinkman = convertPy($_REQUEST["linkname"]);
            $inarr = array($detailid, dhtmlspecialchars($_REQUEST["linkname"]), $userid, $_REQUEST["sex"], $BIRTHDAY, dhtmlspecialchars($_REQUEST["linkpriv"]), dhtmlspecialchars($_REQUEST["linkdept"]), dhtmlspecialchars($_REQUEST["linklike"]), dhtmlspecialchars($_REQUEST["linkhome"]), dhtmlspecialchars($_REQUEST["homepost"]), dhtmlspecialchars($_REQUEST["worktel"]), dhtmlspecialchars($_REQUEST["hometel"]), dhtmlspecialchars($_REQUEST["linkfax"]), htmlspecialchars(preg_replace('/\s/', '', $_REQUEST["telephone"])), dhtmlspecialchars($_REQUEST["linkemail"]), dhtmlspecialchars($_REQUEST["likQQ"]), dhtmlspecialchars($_REQUEST["linkmsn"]),
                $_REQUEST["contents"], "", "", $pyLinkman[0], $pyLinkman[1]);
            $customer->saveData('LINKMAN', $inarr);
        } else if ($diff == "record") {
            //新建联系记录
			$content = $_REQUEST["contents"];
			if(trim($content) == '' || trim($_REQUEST["chooselinkuser"]) == ''){
				header('Location:/E-mobile/App/Init.php?m=createRecord_Crm&detailid='.$detailid.'&sessionkey='.$sessionstr);
				exit;
			}
            $subject = substr(dhtmlspecialchars(trim($content)), 0, 10);
            $pyRetitle = convertPy($subject);
            $file = request_var('upload_file', '');
            $fileName = request_var('file_name', 'default.tmp');
            $_fileName = fileNameToGBK($fileName);
            if (strtolower(substr($fileName, strrpos($fileName, '.'))) == '.jpeg') {
                        $fileName = strtolower(substr($fileName, 0, strrpos($fileName, '.'))) . '.jpg';
            }
            if ($file) {
                 /*----- 微信上传start -----*/
                    $attachmentId = request_var('attachmentId','') ;
				/*----- 微信上传end -----*/
                    if($attachmentId){
                      $attachid =  $attachmentId;
                    }else{
                
                    $attachid = time();
                    $targetPath = ROOT_PATH . 'attachment/' . $attachid . '/';
                    if (!file_exists($targetPath)) {
                        mkdir($targetPath, 0777, true);
                    }
                                
                    $temp = base64_decode($file);
                    $FP = fopen($targetPath . $_fileName, "w");
                    fwrite($FP, $temp);
                    fclose($FP);
                }
            }
            $attachid = $attachid . ',';
            $fileName = $fileName . '*';
            $inarr = array($subject, $_REQUEST["begindate"], $_REQUEST["enddate"], $_REQUEST["begintime"], $_REQUEST["endtime"], $_REQUEST["chooselinkuser"], $_REQUEST["RE_TYPE"], $userid, $content, $detailid, $attachid, $fileName, trim($pyRetitle[0]), trim($pyRetitle[1]));
            $customer->AddEmobileLinkRecord($inarr, $userid);
        }
        include_once(INCLUDE_APP_PATH . 'Crm/View/CrmSuccessView.php');
    }

    //联系人详情
    public function cusLink() {
        global $_lang;
        global $connection;
        include_once ("inc/function_picture.php");
        /* 获取参数----BEGIN */
        $mobilekey = $_REQUEST["mobilesessionkey"];
        $page = $_REQUEST["page"];
        $module = $_REQUEST["module"];
        $scope = $_REQUEST["scope"];
        $detailid = $_REQUEST["detailid"];
        $fromid = $_REQUEST["fromid"];
        $sessionstr = $_REQUEST["sessionkey"];
        $strexplode = explode("_", $sessionstr);
        $userid = $strexplode[1];

        $linkid = $_REQUEST["linkid"];
        $customer = new customer();
        $linkinfor = $customer->GetEmobileLinkmanInfor("", $linkid);
        include_once(INCLUDE_APP_PATH . 'Crm/View/CusLinkView.php');
    }

    public function ajaxCustomerLink() {
        global $_lang;

        $haveid = $_REQUEST["haveid"];
        $customerid = $_REQUEST["customerid"];
        $searchword = $_REQUEST["serchword"];
        $customer = new customer();
        $linkinfo = $customer->GetEmobileLinkmanInfor($customerid, "", $searchword);
        $linkcount = count($linkinfo);
        $linkstr = "";
        if ($linkcount > 0) {
            for ($m = 0; $m < $linkcount; $m++) {
                $lishow = "";
                if ($m == 0) {
                    $lishow = "litopshow";
                } else if ($m == $linkcount - 1) {
                    $lishow = "libottomshow";
                } else {
                    $lishow = "licentershow";
                }
                if ($haveid != "" && $haveid == $linkinfo[$m]["LINKMAN_ID"]) {
                    $linkstr .= '<li class="' . $lishow . '" id="' . $linkinfo[$m]["LINKMAN_ID"] . '" onClick="ChooseEmobileSure(this,\'' . $linkinfo[$m]["LINKMAN_ID"] . '\',\'' . $linkinfo[$m]["LINKMAN_NAME"] . '\',\'chooselinkuser\',\'usertd\',\'single\')" cc="1" style="background:#189AE0">
								<table height="30px;" border="0" cellpadding="0" cellspacing="0" width="100%">
									<tr>
										<td>
											<div style=" margin-left:10px;">
											' . $linkinfo[$m]["LINKMAN_NAME"] . '
											</div>
										</td>
									</tr>
								</table>
							</li>';
                } else {
                    $linkstr .= '<li class="' . $lishow . '" id="' . $linkinfo[$m]["LINKMAN_ID"] . '" onClick="ChooseEmobileSure(this,\'' . $linkinfo[$m]["LINKMAN_ID"] . '\',\'' . $linkinfo[$m]["LINKMAN_NAME"] . '\',\'chooselinkuser\',\'usertd\',\'single\')" cc="0">
								<table height="30px;" border="0" cellpadding="0" cellspacing="0" width="100%">
									<tr>
										<td>
											<div style=" margin-left:10px;">
											' . $linkinfo[$m]["LINKMAN_NAME"] . '
											</div>
										</td>
									</tr>
								</table>
							</li>';
                }
            }
        } else {
            $linkstr .= '<li class="' . $libottomshow . '">
							<table height="30px;" border="0" cellpadding="0" cellspacing="0" width="100%">
								<tr>
									<td>
										<div style=" margin-left:10px;">
											'.$_lang["e_crm_no_relation_user"].'
										</div>
									</td>
								</tr>
							</table>
						</li>';
        }
        echo $linkstr;
    }
	
	public function create() {
		global $_lang;
        if (CheckSessionKeys($this->_cursession)) {
            if (CheckMenuPriv($this->_userId, "createcrm")) {//验证菜单权限
                $sessionstr = $this->_sessionstr;

				$province = self::$customer->getData('province','*'," 1=1 ORDER BY proID");
				
				$customerNumber = $this->getCustomerNumber();
				$required = array();
				$_required = self::$customer->getData('customer_validate_field','*'," TABLE_NAME='customer'");
				if($_required) {
					foreach ($_required as $v) {
						$required[] = $v['FIELD_NAME'];
					}
				}
				
				$userarray        = GetCurrUserPriv($this->_userId);
				$GLOBALS['USER_FUNC_ID_STR'] = $userarray["FUNC_ID_STR"];
                include_once(INCLUDE_APP_PATH . 'Crm/View/CreateCrmView.php');
            } else {
				$noPower = true;
				include_once(INCLUDE_APP_PATH . 'Crm/View/CreateCrmView.php');
            }
        } else {
			$sessionExpire = true;
			include_once(INCLUDE_APP_PATH . 'Crm/View/CreateCrmView.php');
        }
	}
	//
	public function createDo() {
        if (CheckSessionKeys($this->_cursession)) {
            if (CheckMenuPriv($this->_userId, "customer")) {//验证菜单权限
				$customerName	= request_var('CUSTOMER_NAME');
				$customerNamePy = convertPy($customerName);
				$data = array(
					'CUSTOMER_NAME'			=>	$customerName,
					'TEL_NO'				=>	request_var('TEL_NO'),
					'FAX_NO'				=>	request_var('FAX_NO'),
					'CUSTOMER_WWW'			=>	request_var('CUSTOMER_WWW'),
					'EMAIL'					=>	request_var('EMAIL'),
					'CUSTOMER_ADD'			=>	request_var('CUSTOMER_ADD'),
					'POSTALCODE'			=>	request_var('POSTALCODE'),
					'MEMO'					=>	request_var('MEMO'),
					'MANAGE_USER'			=>	rtrim(request_var('MANAGE_NAME'),","),
					'CREATE_TIME'			=>	date("Y-m-d H:i:s"),
					'CUSTOMER_NUMBER'		=>	request_var('CUSTOMER_NUMBER'),
					'CUSTOMER_TYPE'			=>	request_var('CUSTOMER_TYPE'),
					'SCALE'					=>	request_var('SCALE'),
					'CUSTOMER_INDUSTRY'		=>	request_var('CUSTOMER_INDUSTRY'),
					'CUSTOMER_PROFIT'		=>	request_var('CUSTOMER_PROFIT'),
					'PROVINCE'				=>	request_var('PROVINCE'),
					'CITY'					=>	request_var('CITY'),
					'PURVIEW'				=>	request_var('PURVIEW',3),
					'PURVIEW_DEPT'			=>	request_var('PURVIEW_DEPT'),
					'PURVIEW_ROLE'			=>	request_var('PURVIEW_ROLE'),
					'PURVIEW_USER'			=>	request_var('PURVIEW_USER'),
					'CREATEOR'				=>	$this->_userId,
					'BIRTHDAY_REMIND_SMS'	=>	request_var('BIRTHDAY_REMIND_SMS', 0) ,
					'BIRTHDAY_REMIND'		=>	request_var('BIRTHDAY_REMIND', 0),
					'LE_PERSON'				=>	request_var('LE_PERSON'),
					'PERSON_INFO'			=>	request_var('PERSON_INFO'),
					'CUSTOMER_NAME_PY'		=>	$customerNamePy[0],
					'CUSTOMER_NAME_ZM'		=>	$customerNamePy[1],
					'CUSTOMER_STATUS'		=>	request_var('CUSTOMER_STATUS',0),
					'CUSTOMER_STATE'		=>	request_var('CUSTOMER_STATE',0),
					'SERVICE_USER'			=>	rtrim(request_var('SERVICE_USER'),","),
					'CUSTOMER_ATTRIBUTE'	=>	request_var('CUSTOMER_ATTRIBUTE',0)
				);
				$customerId = self::$customer->addData('customer',$data);
				if($customerId) {
					echo 1;exit;
				} 
			}
		}
		
		echo 0;
	}
	public function checkCustomerName() {
		$customerName	= request_var('CUSTOMER_NAME');
		$customerInfo   = self::$customer->getData('customer','CUSTOMER_NAME'," CUSTOMER_NAME='".$customerName."'");
		if($customerInfo) {
			echo 0;exit;
		}
		
		echo 1;
	}
	public function checkCustomerNumber() {
		$customerNumber = request_var('CUSTOMER_NUMBER');
		$customerInfo   = self::$customer->getData('customer','CUSTOMER_NUMBER'," CUSTOMER_NUMBER='".$customerNumber."'");
		
		if($customerInfo) {
			echo 0;exit;
		}
		
		echo 1;
	}
	private function getCustomerNumber() {
		$customerId = self::$customer->getDataOne('customer', 'CUSTOMER_ID', "1=1 ORDER BY CUSTOMER_ID DESC LIMIT 1");
		$customerId = $customerId['CUSTOMER_ID'] + 1;
		$bit		= 10;
		$numLen		= strlen($customerId);

		$zero = 'C-NO-';
		for ($i = $numLen; $i < $bit; $i++) {
			$zero .= "0";
		}

		$customerNumber = $zero . $customerId;
		return $customerNumber;
	}
	public function getCity() {
		$province	= request_var('province');
		
		$city		= self::$customer->getData('city','*',"proID='".$province."'");
		
		echo json_encode($city);
	}
	
	public function getSelectList() {
		global $connection;
		
		$ccParentId	= request_var('cc_parent_id');
		
		$query		= 'SELECT CC_NAME,CC_VALUE FROM `combocox_child` WHERE `CC_PARENT_ID` = '.SecurityFilter($ccParentId) . ' ORDER BY CC_OEDER ASC';
		
		$cousor		= exequery($connection, $query);
		
        $selectList = array();
		if ($cousor) {
			while ($row = mysql_fetch_array($cousor, MYSQL_ASSOC)) {
				$selectList[] = $row;
			}
		}
		
		echo json_encode($selectList);
	}
}
