<?php

/**
 * @copyright (C) 2000 - 2014 Weaver Co.Ltd
 * @package   eoffice9.0
 * @name      webroot/E-mobile/App/Email/EmailClass.php
 * @function  内部邮件数据返回       
 * @version   1.0 
 * @author    lizhijun
 */
include_once("api/email.class.php");
include_once("api/user.class.php");
include_once("inc/oa_config.php");
include_once ("inc/mobile_sms.inc.php");

class EmailProxy {

    private $_limitRow = 20;
     private $_sessionstr; //sessionkey
    public function __construct() {
         $this->_sessionstr =  request_var("sessionkey");
    }

    /**
     * 邮箱分类
     * 草稿箱，收件箱，发件箱
     */
    public function emailBox() {
        global $_lang;

        $sessionstr =  $this->_sessionstr;
        $strexplode = explode("_", $sessionstr);
        $cursession = $strexplode[0];
        $userid = $strexplode[1];
        //验证sessionkey
        $check = CheckSessionKeys($cursession);
        if ($check) {
            //验证菜单权限
            if (CheckMenuPriv($userid, "email")) {
                $receBoxCount = $this->getInboxMailCout($userid);
                $unReadCount = $this->getUnreadMailCout($userid);
                $draftCount = $this->getOutboxMailCout($userid);
                $sendBoxCount = $this->getSentMailCout($userid);
                include_once(INCLUDE_APP_PATH . 'Email/View/EmailTypeView.php');
            } else {
                echo "<div>{$_lang["e_email_no_power"]}</div>";
            }
        } else {
            echo "<div>{$_lang["e_email_login_again"]}</div>";
        }
    }

    public function getNewEmail() {
        $sortField = "SEND_TIME";
        $sortType = "DESC";
        $userid = request_var('userid');
        $condition = array(
            'READ_FLAG' => '',
            'FROM_ID' => '',
            'TO_ID' => $userid,
            'SUBJECT' => '',
            'CONTENT' => '',
            'ATTACHMENT_NAME' => '',
        );
        $email = new Email;
        $emailLists = $email->getEmailList(0, -1, $userid, 7, 0, $sortField, $sortType, '', '', $condition, '', '');
        $lists = $this->dealList($emailLists);
        echo json_encode($lists['list']);
    }

    /**
     * 收件箱初始页类表，默认获取获取全部的邮件（包括已读和未读）
     */
    public function inboxMailList() {
        global $_lang;
        $sessionstr =  $this->_sessionstr;
        $limitRows = $this->_limitRow;
        $currentPage = intval(request_var("currentPage", 0));
        $limitOffset = $currentPage * $limitRows;
        $sortField = "SEND_TIME";
        $sortType = "DESC";
        $userid = request_var('userid');
        $email = new Email;
        $emailLists = $email->getEmailList(0, -1, $userid, $limitRows, $limitOffset, $sortField, $sortType, '', '', array(), '', '');
        $lists = $this->dealList($emailLists);
        $paginator = $this->paginator($lists['totalCount'], $limitRows, $currentPage);
        include_once(INCLUDE_APP_PATH . 'Email/View/InboxMailListView.php');
    }

    /**
     * ajax收件箱列表，筛选列表
     */
    public function ajaxInboxMailList() {
        $limitRows = $this->_limitRow;
        $currentPage = intval(request_var("currentPage", 0));
        $limitOffset = $currentPage * $limitRows;
        $sortField = "SEND_TIME";
        $sortType = "DESC";
        $readflag = request_var('readflag', '');
        if ($readflag == 2) {
            $readflag = '';
        }
        $subject = request_var('subject', '');
        $userid = request_var('userid');
        $condition = array(
            'READ_FLAG' => $readflag,
            'FROM_ID' => '',
            'TO_ID' => $userid,
            'SUBJECT' => trim($subject),
            'CONTENT' => '',
            'ATTACHMENT_NAME' => '',
        );
        $email = new Email;
        $emailLists = $email->getEmailList(0, -1, $userid, $limitRows, $limitOffset, $sortField, $sortType, '', '', $condition, '', '');
        $lists = $this->dealList($emailLists);
        $paginator = $this->paginator($lists['totalCount'], $limitRows, $currentPage);
        echo json_encode(array('lists' => $lists['list'], 'paginator' => $paginator));
    }

    /**
     * 分页函数
     * @param type $total
     * @param type $limitRows
     * @param type $currentPage
     * @return type
     */
    public function paginator($total, $limitRows, $currentPage) {
        $pages = ceil($total / $limitRows);
        if ($pages == 0) {
            $nextPage = 0;
        } else {
            $nextPage = $pages - 1;
        }
        $prvPage = ($currentPage - 1) < 0 ? 0 : ($currentPage - 1);
        $nextPage = ($currentPage + 1) > $nextPage ? $nextPage : ($currentPage + 1);
        return array('pages' => $pages, 'prvPage' => $prvPage, 'nextPage' => $nextPage, 'currentPage' => $currentPage);
    }

    /**
     * 对获取的列表进行处理
     * @param type $emailLists
     * @return string
     */
    public function dealList($emailLists) {
        global $_lang;
        $list = array();
        foreach ($emailLists['list'] as $key => $value) {
            $value['SUBJECT'] = substrGB($value['SUBJECT'], 18, '...');
            $time = substr($value['SEND_TIME'], strpos($value['SEND_TIME'], ' '));
            $date = date('Y-m-d', strtotime($value['SEND_TIME']));
            if ($date == date('Y-m-d')) {
                $date = '<span style="color:#75BF26;">' . $_lang['e_sms_today'] . $time . '</span>';
            } else if ($date == date('Y-m-d', strtotime("-1 day"))) {
                $date = '<span style="color:#FFA20E;">' . $_lang['e_sms_yesterday'] . $time . '</span>';
            } else if ($date == date('Y-m-d', strtotime("-2 day"))) {
                $date = '<span style="color:#FFA20E;">' . $_lang['e_sms_before_yesterday'] . $time . '</span>';
            } else if ($date == date('Y-m-d', strtotime("-3 day"))) {
                $date = '<span style="color:#FFA20E;">' . $_lang['e_sms_three_days_ago'] . $time . '</span>';
            } else {
                $date = $value['SEND_TIME'];
            }
            $value['dateTime'] = $date;
            if ($value['READ_FLAG'] == 1) {
                $value['color'] = '#75BF26';
            } else {
                $value['color'] = '#FFA20E';
            }
            $list[] = $value;
        }
        $lists['totalCount'] = $emailLists['totalCount'];
        $lists['list'] = $list;
        return $lists;
    }

    public function outboxMailList() {
        global $_lang;
        $sessionstr =  $this->_sessionstr;
        $limitRows = $this->_limitRow;
        $currentPage = request_var("currentPage", 0);
        $limitOffset = $currentPage * $limitRows;
        $sortField = "SEND_TIME";
        $sortType = "DESC";
        $userid = request_var('userid');
        $email = new Email;
        $emailLists = $email->getEmailList(0, -2, $userid, $limitRows, $limitOffset, $sortField, $sortType, '', '', array(), '', '');
        $lists = $this->dealList($emailLists);
        $paginator = $this->paginator($lists['totalCount'], $limitRows, $currentPage);
        include_once(INCLUDE_APP_PATH . 'Email/View/OutboxMailListView.php');
    }

    public function ajaxOutboxMailList() {
        $limitRows = $this->_limitRow;
        $currentPage = request_var("currentPage", 0);
        $limitOffset = $currentPage * $limitRows;
        $sortField = "SEND_TIME";
        $sortType = "DESC";
        $readflag = request_var('readflag', '');
        if ($readflag == 2) {
            $readflag = '';
        }
        $subject = request_var('subject', '');
        $userid = request_var('userid');
        $condition = array(
            'READ_FLAG' => $readflag,
            'FROM_ID' => '',
            'TO_ID' => '',
            'SUBJECT' => trim($subject),
            'CONTENT' => '',
            'ATTACHMENT_NAME' => '',
        );
        $email = new Email;
        $emailLists = $email->getEmailList(0, -2, $userid, $limitRows, $limitOffset, $sortField, $sortType, '', '', $condition, '', '');
        $lists = $this->dealList($emailLists);
        $paginator = $this->paginator($lists['totalCount'], $limitRows, $currentPage);
        echo json_encode(array('lists' => $lists['list'], 'paginator' => $paginator));
    }

    public function sendMailList() {
        global $_lang;
        $sessionstr =  $this->_sessionstr;
        $limitRows = $this->_limitRow;
        $currentPage = request_var("currentPage", 0);
        $limitOffset = $currentPage * $limitRows;
        $sortField = "SEND_TIME";
        $sortType = "DESC";
        $userid = request_var('userid');
        $email = new Email;
        $emailLists = $email->getEmailList(0, -3, $userid, $limitRows, $limitOffset, $sortField, $sortType, '', '', array(), '', '');
        $lists = $this->dealList($emailLists);
        $paginator = $this->paginator($lists['totalCount'], $limitRows, $currentPage);
        include_once(INCLUDE_APP_PATH . 'Email/View/SendMailListView.php');
    }

    public function ajaxSendMailList() {
        $limitRows = $this->_limitRow;
        $currentPage = request_var("currentPage", 0);
        $limitOffset = $currentPage * $limitRows;
        $sortField = "SEND_TIME";
        $sortType = "DESC";
        $readflag = request_var('readflag', '');
        if ($readflag == 2) {
            $readflag = '';
        }
        $subject = request_var('subject', '');
        $userid = request_var('userid');
        $condition = array(
            'READ_FLAG' => $readflag,
            'FROM_ID' => $userid,
            'TO_ID' => '',
            'SUBJECT' => trim($subject),
            'CONTENT' => '',
            'ATTACHMENT_NAME' => '',
        );
        $email = new Email;
        $emailLists = $email->getEmailList(0, -3, $userid, $limitRows, $limitOffset, $sortField, $sortType, '', '', $condition, '', '');
        $lists = $this->dealList($emailLists);
        $paginator = $this->paginator($lists['totalCount'], $limitRows, $currentPage);
        echo json_encode(array('lists' => $lists['list'], 'paginator' => $paginator));
    }

    public function getInboxMailCout($userid) {
        global $connection;
        $query = "SELECT COUNT(EMAIL_ID) AS count FROM email WHERE BOX_ID=0 AND TO_ID='" . SecurityFilter($userid) . "' AND SEND_FLAG='1' AND DELETE_FLAG !='1' ";
        $rs = exequery($connection, $query);
        if ($rows = mysql_fetch_array($rs)) {
            $inboxmailcount = $rows["count"];
        }
        return $inboxmailcount;
    }

    public function getUnreadMailCout($userid) {
        global $connection;
        $query = "SELECT COUNT(EMAIL_ID) AS count FROM email WHERE BOX_ID=0 and TO_ID='" . SecurityFilter($userid) . "' AND SEND_FLAG='1' AND READ_FLAG='0' AND DELETE_FLAG!='1' ";
        $rs = exequery($connection, $query);
        if ($rows = mysql_fetch_array($rs)) {
            $unreadmailcount = $rows["count"];
        }
        return $unreadmailcount;
    }

    public function getSentMailCout($userid) {
        global $connection;
        $query = "SELECT COUNT(EMAIL_ID) AS count FROM email WHERE FROM_ID='" . SecurityFilter($userid) . "' AND SEND_FLAG='1' AND DELETE_BY_SENT <> 1 ";
        $rs = exequery($connection, $query);
        if ($rows = mysql_fetch_array($rs)) {
            $sentmailcount = $rows["count"];
        }
        return $sentmailcount;
    }

    public function getOutboxMailCout($userid) {
        global $connection;
        $query = "SELECT COUNT(EMAIL_ID) AS count FROM email WHERE SEND_FLAG='0' and FROM_ID='" . SecurityFilter($userid) . "' ";
        $rs = exequery($connection, $query);
        if ($rows = mysql_fetch_array($rs)) {
            $oubboxmailcount = $rows["count"];
        }
        return $oubboxmailcount;
    }

    /**
     * 删除邮件
     */
    public function deleteEmail() {
        $emailId = intval($_REQUEST["emailId"]);
        $boxid = $_REQUEST['boxid'];
        $boxtype = $_REQUEST['boxtype'];
        $email = new Email;
        $result = $email->deleteEmailById(array('EMAIL_ID' => $emailId), $boxid, $boxtype);
        echo $result;
    }

    /**
     * 邮件转发
     */
    public function sendOther() {
        global $connection;
        $emailId = intval(request_var("emailId"));
        $toId = request_var('toId');
        $userId = request_var('userId');
        $email = new email(array('user_id' => $userId));
        $emailInfor = $email->getEmailById($emailId, "");
        $subject = $emailInfor['SUBJECT'];
        $contents = $emailInfor['CONTENT'];
        $curdate = date('Y-m-d H:i:s');
        $toIdArray = explode(',', $toId);
        array_pop($toIdArray);
        $attachId = $emailInfor['ATTACHMENT_ID'];
        $attachName = $emailInfor['ATTACHMENT_NAME'];
        foreach ($toIdArray as $key => $value) {
            $query = "INSERT INTO  EMAIL(FROM_ID,TO_ID,TO_ID2,COPY_TO_ID,SUBJECT,CONTENT,SEND_TIME,ATTACHMENT_ID,ATTACHMENT_NAME,READ_FLAG,SEND_FLAG,DELETE_FLAG) values ('" . $userId . "','" . $value . "','','','" . $subject . "','" . $contents . "','" . $curdate . "','$attachId','$attachName','0','1','0')";
            exequery($connection, $query);
        }
        echo 1;
    }

    public function detail() {
 
        global $_lang;
        $sessionstr =  $this->_sessionstr;
        $UserInfor = array();
        $type = request_var('type');
        $userId = request_var('userid');
        $weiApi = request_var('weiApi');
        $UserInfor["user_id"] = $userId;
        $emailId = intval(request_var('emailId'));
        if ($type == 'send') {
            $linkList = APP_PATH . 'Init.php?m=sendMailList_Email&userid=' . $userId . '&sessionkey=' . $sessionstr;
        } elseif ($type == 'inbox') {
            $goto = request_var('goto');
            if ($goto == 'new') {
                $linkList = APP_PATH . "Init.php?m=emailBox_Email&sessionkey=$sessionstr";
            } else {
                $linkList = APP_PATH . 'Init.php?m=inboxMailList_Email&userid=' . $userId . '&sessionkey=' . $sessionstr;
            }
        } elseif ($type == 'outbox') {
            $linkList = APP_PATH . 'Init.php?m=outboxMailList_Email&userid=' . $userId . '&sessionkey=' . $sessionstr;
        }
        /* 获取参数---END */
        $email = new email($UserInfor);
        if($type == 'send'){
            $emailInfor = $email->getEmailById($emailId, "1");
        }else{
            $emailInfor = $email->getEmailById($emailId, "");
        }
        
        
        //获取全部收件人
        foreach ($emailInfor as $key => $value) {
            $$key = $value;
        }
        $tempTOIDs =  $email->getIdenticalEmail($SEND_TIME,$FROM_ID); 
        $toids = implode(",",array_unique($tempTOIDs));
        $emailInfor["TO_ID2"] = $toids;
        
        
        
        include_once(INCLUDE_APP_PATH . 'Email/View/EmailView.php');
    }
    
    public function sourcePage(){
 
        global $_lang;
        $diff     = $_REQUEST["pagediff"];
        
        $sessionkey = $_GET["sessionkey"];
        $strexplode = explode("_", $sessionkey);
        $weiApi = request_var('weiApi');
        $userid = $strexplode[1];
         
        $title    = "";
        $contents = "";
        $goto     = request_var('goto');
        $emailid  = $_REQUEST["emailid"];
 
        $UserInfor["user_id"] = $userid;
        $email      = new email($UserInfor);
        $emailInfor = $email->getEmailById($emailid,"");
        $contents   = $emailInfor["CONTENT"];
        $title      = $_lang['emobile_common_root_yjyw'];
        
         include_once(INCLUDE_APP_PATH . 'Email/View/sourcePage.php');
                
    }

    public function reply() {
        global $_lang;
        $type = request_var('type');
        $goto = request_var('goto');
        $detailid = intval($_REQUEST["detailid"]);
        $fromid = $_REQUEST["fromid"];
        $emailform = $_REQUEST["emailform"];
        $sessionstr = $_REQUEST["sessionkey"];
        $strexplode = explode("_", $sessionstr);
        $userid = $strexplode[1];
        $UserInfor = array();
        $UserInfor["user_id"] = $userid;
        $emailId = $detailid;
        $email = new email($UserInfor);
        $emailInfor = $email->getEmailById($emailId, "");
        $Oldsubject = $emailInfor["SUBJECT"];
        $Newsubject = "Re:" . $emailInfor["SUBJECT"];
        include_once(INCLUDE_APP_PATH . 'Email/View/EmailReplyView.php');
    }

    //回复全部
    public function replyAll() {
        global $_lang;
        $type = request_var('type');
        $goto = request_var('goto');
        $detailid = intval($_REQUEST["detailid"]);
        $fromid = $_REQUEST["fromid"];
        $emailform = $_REQUEST["emailform"];
        $sessionstr = $_REQUEST["sessionkey"];
        $strexplode = explode("_", $sessionstr);
        $userid = $strexplode[1];
        $UserInfor = array();
        $UserInfor["user_id"] = $userid;
        $emailId = $detailid;
        $email = new email($UserInfor);
        $emailInfor = $email->getEmailById($emailId, "");

        foreach ($emailInfor as $key => $value) {
            $$key = $value;
        }

        $SECRET_TO_ID = "";
        
        //获取同一封的邮件信息
        $tempTOIDs =  $email->getIdenticalEmail($SEND_TIME,$FROM_ID); 
        $toids = implode(",",array_unique($tempTOIDs));
        
       // $TO_ID = $FROM_ID . "," . $toids;
        
        if(strstr($toids,$FROM_ID)){
                    $TO_ID =   $toids;
                }else{
                    $TO_ID = $FROM_ID . "," . $toids;
                }

        $TO_ID = trim(str_replace( $userid.",", "", $TO_ID), ",");
        $COPY_TO_ID = trim(str_replace($userid.",", "", $COPY_TO_ID), ",");
        //主题
        $SUBJECT = "Re:" . $SUBJECT;

        $toData = explode(",", $TO_ID);
        $copyData = explode(",", $COPY_TO_ID);

        $toList = "";
        foreach ($toData as $v) {
           
            if($v){
                 $userData = GetCurrUserInfor($v);
                  $user_name = $userData["USER_NAME"];
                  $toList.= '<div class="user_select show_user_item" user_id="' . $v . '" onclick="removeSelectedUser(this)">' . $user_name . '<div class="show_user_close"></div></div>';
            }
        }

        $copyList = "";
        foreach ($copyData as $v) {
            if($v){
                $userData = GetCurrUserInfor($v);
                $user_name = $userData["USER_NAME"];
                $copyList.= '<div class="user_select show_user_item" user_id="' . $v . '" onclick="removeSelectedUser(this)">' . $user_name . '<div class="show_user_close"></div></div>';
            }

        }

        include_once(INCLUDE_APP_PATH . 'Email/View/EmailReplyAllView.php');
    }

    //回复操作函数
    public function replyAllReponse() {
      
        global $connection, $_lang;
        /* 获取参数----BEGIN */
        $goto = request_var('goto');
        $detailid = $_REQUEST["detailid"];
        $fromid = $_REQUEST["fromid"];
        $sessionstr = $_REQUEST["sessionkey"];
        $strexplode = explode("_", $sessionstr);
        $userid = $strexplode[1];
        $userarray = GetCurrUserPriv($userid);
        $GLOBALS['USER_FUNC_ID_STR'] = $userarray["FUNC_ID_STR"];
        $subject = $_REQUEST["subject"];
        $contents = $_REQUEST["contents"];
        $toid = $_REQUEST["SelectUserID"];
        $copyid = $_REQUEST["SelectReciverID"];
        $hideid = $_REQUEST["SelectHiderID"];
        $sms = request_var("emobile_sms", 0);
        $tel = request_var("emobile_tel", 0);
        $contel = request_var("mobilect", $_lang['email_smstel_remind']);
        $curdate = date("Y-m-d H:i:s", time());
        $TO_ID2 = $toid;
        $TO_ID_STR = trim($toid, ",") . "," . trim($copyid, ",") . "," . $hideid;


        $TOK = strtok($TO_ID_STR, ",");
        $SMS_CONTENT = $_lang["e_email_check_email"] . csubstr($subject, 0, 100);
        $TABLE_NAME = "email";
        $file = request_var('upload_file', '');
        $fileName = request_var('file_name', '');
        $_fileName = fileNameToGBK($fileName);
        if (strtolower(substr($fileName, strrpos($fileName, '.'))) == '.jpeg') {
            $fileName = strtolower(substr($fileName, 0, strrpos($fileName, '.'))) . '.jpg';
        }

        if ($file) {
            /* ----- 微信上传start ----- */
            $attachmentId = request_var('attachmentId', '');
            /* ----- 微信上传end ----- */
            if ($attachmentId) {
                $attachid = $attachmentId;
            } else {

                $attachid = time();
                $targetPath = ROOT_PATH . 'attachment/' . $attachid . '/';
                if (!file_exists($targetPath)) {
                    mkdir($targetPath, 0777, true);
                }


                $temp = base64_decode($file);
                $FP = fopen($targetPath . $_fileName, "w");
                fwrite($FP, $temp);
                fclose($FP);
            }
        }
        if ($attachid) {
            $attachid = $attachid . ',';
            $fileName = $fileName . '*';
        } else {
            $attachid = '';
            $fileName = '';
        }
        while ($TOK != "") {
            $query = "INSERT INTO  EMAIL(FROM_ID,TO_ID,TO_ID2,COPY_TO_ID,SUBJECT,CONTENT,SEND_TIME,ATTACHMENT_ID,ATTACHMENT_NAME,READ_FLAG,SEND_FLAG,DELETE_FLAG) values ('" . $userid . "','" . $TOK . "','" . $TO_ID2 . "','" . $copyid . "','" . $subject . "','" . $contents . "','" . $curdate . "','$attachid','$fileName','0','1','0')";
            exequery($connection, $query);
            $TABLE_ID = mysql_insert_id();
            $TOK = strtok(",");
        }
        if ($sms == "1") {
            sendSms($userid, $TO_ID_STR, $SMS_CONTENT, 1, 2, $TABLE_NAME, $TABLE_ID);
        }
        if ($tel == "1") {
            $newSms = new MobileSms();
            $newSms->SelfSendMore($TO_ID_STR, $contel, '', $userid);
        }
        include_once(INCLUDE_APP_PATH . 'Create/View/replyAllSuccessView.php');
    }

  

    public function success() {
    
        global $_lang;
        /* 获取参数----BEGIN */
        $type = request_var('type');
        $goto = request_var('goto');
        $sms =   request_var('sms',0);
        $detailid = intval($_REQUEST["detailid"]);
        $fromid = $_REQUEST["fromid"];
        $emailsent = $_REQUEST["emailsent"];
        $sessionstr = $_REQUEST["sessionkey"];
        $strexplode = explode("_", $sessionstr);
        $userid = $strexplode[1];
        $subject = $_REQUEST["subject"];
        $contents = $_REQUEST["contents"];
        $Infor = array();
        $Infor["SendFlag"] = "1";
        $Infor["FromId"] = $userid;
        $Infor["ToId"] = $emailsent;
        $Infor["ToId2"] = $emailsent . ",";
        $Infor["Subject"] = $subject;
        $Infor["Content"] = $contents;
        $Infor["Sendtime"] = date("Y-m-d H:i:s");
        $email = new email(array());
        $emailInfor = $email->NewSendEmail($Infor);
        
        if ($sms == "1") {
            $SMS_CONTENT = $_lang["e_email_check_email"] . csubstr($subject, 0, 100);
            sendSms($fromid, $emailsent, $SMS_CONTENT, 1, 2, "email", $emailInfor);
        }
        
        include_once(INCLUDE_APP_PATH . 'Email/View/EmailSuccessView.php');
    }

    public function create() {
        global $_lang;
        /* 获取参数----BEGIN */
        $detailid = $_REQUEST["detailid"];
        $fromid = $_REQUEST["fromid"];
        $sessionstr = $_REQUEST["sessionkey"];
        $goto = request_var('goto');
        $strexplode = explode("_", $sessionstr);
        $userid = $strexplode[1];

        $UserInfor = array();
        $UserInfor["user_id"] = $userid;

        $userarray = GetCurrUserPriv($userid);
        $GLOBALS['USER_FUNC_ID_STR'] = $userarray["FUNC_ID_STR"];
        $array = checkReminds("2", $userarray["USER_PRIV"]);
        $sms_select = $array[0];
        $smstel_select = $array[1];
        $email_select = $array[2];
        $sms_modify = $array[3];
        $smstel_modify = $array[4];
        $email_modify = $array[5];
        include_once(INCLUDE_APP_PATH . 'Email/View/CreateEmailView.php');
    }

    public function createDo() {
        global $connection, $_lang;
        /* 获取参数----BEGIN */
        $goto = request_var('goto');
        $detailid = $_REQUEST["detailid"];
        $fromid = $_REQUEST["fromid"];
        $sessionstr = $_REQUEST["sessionkey"];
        $strexplode = explode("_", $sessionstr);
        $userid = $strexplode[1];
        $userarray = GetCurrUserPriv($userid);
        $GLOBALS['USER_FUNC_ID_STR'] = $userarray["FUNC_ID_STR"];
        $subject = $_REQUEST["subject"];
        $contents = $_REQUEST["contents"];
        $toid = $_REQUEST["SelectUserID"];
        $copyid = $_REQUEST["SelectReciverID"];
        $hideid = $_REQUEST["SelectHiderID"];
        $sms = request_var("emobile_sms", 0);
        $tel = request_var("emobile_tel", 0);
        $contel = request_var("mobilect", $_lang['email_smstel_remind']);
        $curdate = date("Y-m-d H:i:s", time());
        $TO_ID2 = $toid;
        $TO_ID_STR = $toid . $copyid . $hideid;
        $TOK = strtok($TO_ID_STR, ",");

        $SMS_CONTENT = $_lang["e_email_check_email"] . csubstr($subject, 0, 100);
        $TABLE_NAME = "email";
        $file = request_var('upload_file', '');
        $fileName = request_var('file_name', '');
        $_fileName = fileNameToGBK($fileName);
        if (strtolower(substr($fileName, strrpos($fileName, '.'))) == '.jpeg') {
            $fileName = strtolower(substr($fileName, 0, strrpos($fileName, '.'))) . '.jpg';
        }

        if ($file) {
            /* ----- 微信上传start ----- */
            $attachmentId = request_var('attachmentId', '');
            /* ----- 微信上传end ----- */
            if ($attachmentId) {
                $attachid = $attachmentId;
            } else {

                $attachid = time();
                $targetPath = ROOT_PATH . 'attachment/' . $attachid . '/';
                if (!file_exists($targetPath)) {
                    mkdir($targetPath, 0777, true);
                }


                $temp = base64_decode($file);
                $FP = fopen($targetPath . $_fileName, "w");
                fwrite($FP, $temp);
                fclose($FP);
            }
        }
        if ($attachid) {
            $attachid = $attachid . ',';
            $fileName = $fileName . '*';
        } else {
            $attachid = '';
            $fileName = '';
        }
        while ($TOK != "") {
            $query = "INSERT INTO  EMAIL(FROM_ID,TO_ID,TO_ID2,COPY_TO_ID,SUBJECT,CONTENT,SEND_TIME,ATTACHMENT_ID,ATTACHMENT_NAME,READ_FLAG,SEND_FLAG,DELETE_FLAG) values ('" . $userid . "','" . $TOK . "','" . $TO_ID2 . "','" . $copyid . "','" . $subject . "','" . $contents . "','" . $curdate . "','$attachid','$fileName','0','1','0')";
            exequery($connection, $query);
            $TABLE_ID = mysql_insert_id();
            $TOK = strtok(",");
        }
        if ($sms == "1") {
            sendSms($userid, $TO_ID_STR, $SMS_CONTENT, 1, 2, $TABLE_NAME, $TABLE_ID);
        }
        if ($tel == "1") {
            $newSms = new MobileSms();
            $newSms->SelfSendMore($TO_ID_STR, $contel, '', $userid);
        }
        include_once(INCLUDE_APP_PATH . 'Create/View/CreateSuccessView.php');
    }

}
