<?php

/**
 * @copyright (C) 2000 - 2010 Weaver Co.Ltd
 * @package   eoffice8.0
 * @name      webroot/E-mobile/Data/flow_data.php
 * @function  抄送流程数据返回
 * @version   1.0
 * @author    lizhijun
 */
include_once("api/flow.class.php");
include_once("api/user.class.php");
include_once("inc/function_page_01.php");
include_once ("api/FlowEmobileList.class.php");
include_once(COMMON_PATH . 'Tool/Tool.php'); //系统公共工具类

class CopyProxy {

    private $_currentSession;
    private $_userId;
    private $_sessionStr;
    private $_pageSize = 10;

    public function __construct() {
        $this->_sessionStr = request_var("sessionkey");
        $strExplode = explode("_", $this->_sessionStr);
        $this->_currentSession = $strExplode[0];
        $this->_userId = $strExplode[1];
    }

    public function weiLists() {
        global $_lang;
        $sessionstr = $this->_sessionStr;
        $userId = Tool::checkUserAuth($sessionstr, 'flow_copy'); //用户权限检查
        $copyLists = $this->_getCopyLists($userId);

        include_once(INCLUDE_APP_PATH . 'Flow/Copy/View/CopyListsView.php');
    }

    public function ajaxGetCopyLists() {
        global $_lang;

        $sessionstr = $this->_sessionStr;
        $userId = Tool::checkUserAuth($sessionstr, 'flow_copy', true); //用户权限检查
        if ($userId == 'error1') {
            echo 'error1';
            exit;
        }
        if ($userId == 'error2') {
            echo 'error2';
            exit;
        }
        $pageSize = intval(request_var('pageSize', 0));
        $pageIndex = intval(request_var('pageIndex', 1));
        $keyword = request_var('keyword', '');
        $filter = request_var('filter', '');
        if ($pageSize == 0)
            $pageSize = $this->_pageSize;
        $copyLists = $this->_getCopyLists($userId, $keyword, $filter, $pageSize, $pageIndex);
        if ($copyLists) {
            echo json_encode($copyLists);
        } else {
            echo 0;
        }
    }

    private function _getCopyLists($userId, $keyword = '', $filter = '', $pageSize = 10, $pageIndex = 1) {
        global $_lang;
        include_once("api/workflow.list.class.php");
        $copyList = array();
        $getListParam["TABLE_COMMON"] = array(
            "LOGIN_USER_ID" => $userId,
            "PAGINATIONOFFSET" => $pageIndex - 1,
            "PAGINATIONROWS" => $pageSize,
            "SORTFIELD" => 'fc.COPY_TIME',
            "SORTTYPE" => 'DESC'
        );
        $getListParam["FORMAT_SEARCH"] = array(
            array("TABLE" => "flow_run", "TABLE_ABBR" => "fr", "FIELD" => "IS_EFFECT", "RELATION" => "=", "VALUE" => "1")
        );
        if ($keyword) {
            $getListParam["FORMAT_SEARCH"][] = array("TABLE" => "flow_run", "TABLE_ABBR" => "fr", "FIELD" => "RUN_NAME", "RELATION" => "like", "VALUE" => $keyword);
        }
        $flowList = new listItem();
        $workflowList = $flowList->getFlowCopyList($getListParam);
        if ($workflowList['list']) {
            $userapi = new user();
            foreach ($workflowList['list'] as $val) {
                $copyFlow = array();
                $copyFlow['id'] = $val["RUN_ID"] . "," . $val["FLOW_ID"] . "," . $val["FLOW_PRCS"] . "," . $val["PRCS_ID"];
                $copyFlow['title'] = $val["RUN_NAME"];
                $copyFlow['time'] = $val["CREATE_TIME"];
                $copyFlow['description'] = $_lang["flow_filenumber"] . ":" . htmlspecialchars(strip_tags(html_entity_decode($val["RUN_SEQ"], ENT_QUOTES, 'UTF-8')));
                if ($val["RECEIVE_TIME"] == NULL) {
                    $copyFlow['isnew'] = "1"; //未读
                } else {
                    $copyFlow['isnew'] = "0"; //已读
                }
                $userInfo = $userapi->GetUserOtherInfor($val["CREATOR"]);
                if ($userInfo["AVATAR_TYPE"] == "") {
                    $copyFlow['image'] = IMG_PATH . "defaultimg.png";
                } else {
                    $img = "/attachment/personal/" . $val["CREATOR"] . "/avatar_80" . $userInfo["AVATAR_TYPE"];
                    if (CheckFileExist($img)) {
                        $copyFlow['image'] = $img;
                    } else {
                        $copyFlow['image'] = IMG_PATH . "defaultimg.png";
                    }
                }
                $copyList[] = $copyFlow;
            }
            return $copyList;
        }

        return false;
    }

    public function lists() {
        include_once("api/workflow.list.class.php");
        global $_lang;
        $sessionstr = $this->_sessionStr;
        $pageIndex = intval(request_var("pageindex", 1));
        $pageSize = intval(request_var("pagesize", 10));
        $keyword = urldecode(request_var("keyword"));

        $userId = Tool::checkUserAuth($this->_sessionStr, 'flow_copy'); //用户权限检查

        $copyList = array();
        $getListParam["TABLE_COMMON"] = array(
            "LOGIN_USER_ID" => $this->_userId,
            "PAGINATIONOFFSET" => $pageIndex - 1,
            "PAGINATIONROWS" => $pageSize,
            "SORTFIELD" => 'fc.COPY_TIME',
            "SORTTYPE" => 'DESC'
        );
        $getListParam["FORMAT_SEARCH"] = array(
            array("TABLE" => "flow_run", "TABLE_ABBR" => "fr", "FIELD" => "IS_EFFECT", "RELATION" => "=", "VALUE" => "1")
        );
        if ($keyword) {
            $getListParam["FORMAT_SEARCH"][] = array("TABLE" => "flow_run", "TABLE_ABBR" => "fr", "FIELD" => "RUN_NAME", "RELATION" => "like", "VALUE" => $keyword);
        }

        $flowList = new listItem();
        $workflowList = $flowList->getFlowCopyList($getListParam);
        if ($workflowList['totalCount'] > 0) {
            $userapi = new user();
            foreach ($workflowList['list'] as $val) {
                $copyFlow = array();
                $copyFlow['id'] = $val["RUN_ID"] . "," . $val["FLOW_ID"] . "," . $val["FLOW_PRCS"] . "," . $val["PRCS_ID"];
                if ($val["INSTANCY_TYPE"] == "1" || $val["INSTANCY_TYPE"] == "2") {
                    $identifying = "【" . getInstancyName($val["INSTANCY_TYPE"]) . "】";
                    $copyFlow['subject'] = $identifying . $val["RUN_NAME"];
                } else {
                    $copyFlow['subject'] = $val["RUN_NAME"];
                }
                $copyFlow['time'] = $val["CREATE_TIME"];
                $copyFlow['description'] = $_lang["flow_filenumber"] . ":" . htmlspecialchars(strip_tags(html_entity_decode($val["RUN_SEQ"], ENT_QUOTES, 'UTF-8')));
                if ($val["RECEIVE_TIME"] == NULL) {
                    $copyFlow['isnew'] = "1"; //未读
                } else {
                    $copyFlow['isnew'] = "0"; //已读
                }
                $userInfo = $userapi->GetUserOtherInfor($val["CREATOR"]);
                if ($userInfo["AVATAR_TYPE"] == "") {
                    $copyFlow['image'] = IMG_PATH . "defaultimg.png";
                } else {
                    $img = "/attachment/personal/" . $val["CREATOR"] . "/avatar_80" . $userInfo["AVATAR_TYPE"];
                    if (CheckFileExist($img)) {
                        $copyFlow['image'] = $img;
                    } else {
                        $copyFlow['image'] = IMG_PATH . "defaultimg.png";
                    }
                }
                $copyList[] = $copyFlow;
            }
        }
        $currindex = GetCurrPageIndex($pageIndex, $pageSize);
        $page_count = GetSumPageCount($workflowList['totalCount'], $pageSize);
        $curr_page = floor($currindex / $pageSize) + 1;
        $result["ishavepre"] = $currindex < $pageSize ? "0" : "1";
        $result["ishavenext"] = $curr_page < $page_count ? "1" : "0";
        $result["pageindex"] = $pageIndex;
        $result["pagesize"] = $pageSize;
        $result["count"] = $workflowList['totalCount'];
        $result["pagecount"] = $page_count;
        $result['list'] = $copyList;

        echo json_encode($result);
    }

    public function count() {
        $sessionstr = $this->_sessionStr;
        include_once("api/workflow.list.class.php");
        //验证sessionkey
        if (!CheckSessionKeys($this->_currentSession)) {
            echo "{}";
            exit;
        }
        //验证菜单权限
        if (!CheckMenuPriv($this->_userId, "flow_copy")) {
            echo "{}";
            exit;
        }
        $getListParam["TABLE_COMMON"] = array(
            "LOGIN_USER_ID" => $this->_userId,
            "SORTFIELD" => 'fc.COPY_TIME',
            "SORTTYPE" => 'DESC',
            "GETLISTTYPE" => "count"
        );
        $flowList = new listItem();
        $getListParam["FORMAT_SEARCH"] = array(
            array("TABLE" => "flow_run", "TABLE_ABBR" => "fr", "FIELD" => "IS_EFFECT", "RELATION" => "=", "VALUE" => "1"),
            array("TABLE" => "flow_copy", "TABLE_ABBR" => "fc", "FIELD" => "RECEIVE_TIME", "RELATION" => "is", "VALUE" => 'NULL')
        );
        $workflowList = $flowList->getFlowCopyList($getListParam);
        echo json_encode(array('unread' => $workflowList['totalCount']));
    }

    public function view() {
        $sessionstr = $this->_sessionStr;
        include(INCLUDE_APP_PATH . "Flow/Common/common/FlowCommon.class.php");
        $FlowCommon = new FlowCommon();
        $FlowCommon->flowChange('flowCopy');
    }

}
