<?php
/**
 * @copyright (C) 2000 - 2010 Weaver Co.Ltd
 * @package   eoffice8.0
 * @name      webroot/E-mobile/Data/flow_data.php
 * @function  待办流程数据返回
 * @version   1.0
 * @author    liuqingyu
 */
include_once("api/list.class.php");
include_once("api/flow.class.php");
include_once("api/user.class.php");
include_once("inc/function_page_01.php");
include_once ("api/FlowEmobileList.class.php");
include_once(COMMON_PATH . 'Tool/Tool.php');//系统公共工具类
class ToDoProxy{
    private $_pageSize = 10;
     private $_sessionStr;
    public function __construct() {
         $this->_sessionStr = request_var("sessionkey");
    }
    public function weiLists(){
        global $_lang;
        $sessionstr = $this->_sessionStr;
        $userId     = Tool::checkUserAuth($sessionstr, 'todoflow');//用户权限检查
        $toDoLists  = $this->_getToDoLists($userId);
        include_once(INCLUDE_APP_PATH . 'Flow/ToDo/View/ToDoListsView.php');
    }
    public function ajaxGetToDoLists(){
        global $_lang;
        $sessionstr = $this->_sessionStr;
        $userId     = Tool::checkUserAuth($sessionstr, 'todoflow',true);//用户权限检查
        if($userId == 'error1'){
            echo 'error1';
            exit;
        }
        if($userId == 'error2'){
            echo 'error2';
            exit;
        }
        $pageSize   = intval(request_var('pageSize',0));
        $pageIndex  = intval(request_var('pageIndex',1));
        $keyword    = request_var('keyword','');
        $filter     = request_var('filter','');
        if($pageSize == 0) $pageSize = $this->_pageSize;
        $toDoLists  = $this->_getToDoLists($userId, $keyword, $filter, $pageSize, $pageIndex);
        if($toDoLists){
            echo json_encode($toDoLists);
        }else{
            echo 0;
        }
    }
    private function _getToDoLists($userId,$keyword='',$filter='',$pageSize=10,$pageIndex=1){
		global $_lang;
        $currentIndex   = GetCurrPageIndex($pageIndex,$pageSize);
        $type           = array("TYPE"=>"to_do_list","CONSTAINLIST"=>"1");
        $search         = array("USER_ID"=>$userId,"FLOW_NAME"=>$keyword,'filter' => $filter);
        $page           = array("PAGINATIONOFFSET"=>$currentIndex,"PAGINATIONROWS"=>$pageSize,"SORTFIELD"=>"TRANSACT_TIME","SORTTYPE"=>"DESC");
        $other          = array("");
        $list           = new mobilelistItem($type,$search,$page,$other);
        $listData       = $list->EmobileGetList();
        if($listData['list']){
            $userapi    = new user();
            $_listData       = array();
            foreach($listData["list"] as $value){
                $runId                  = $value["RUN_ID"];
                $flowId                 = $value["FLOW_ID"];
                $flowPrcs               = $value["FLOW_PRCS"];
                $prcsId                 = $value["PRCS_ID"];
                $todoId                 = $runId.",".$flowId.",".$flowPrcs.",".$prcsId;
                $temp['id']             = $todoId;
                $temp['title']          = $value["RUN_NAME"];
                $temp['time']           = $value["CREATE_TIME"];
                $temp['description']    = $_lang["flow_filenumber"].":".htmlspecialchars(strip_tags(html_entity_decode($value["RUN_SEQ"],ENT_QUOTES,'UTF-8')));
                $userInfo               = $userapi->GetUserOtherInfor($value["CREATOR"]);
                $temp['image']          = Tool::getUserImage($value['CREATOR'], $userInfo["AVATAR_TYPE"]);
                if($value["PRCS_TIME"] != ""){
                    $temp['isnew']      = "0";	//已读
                }else{
                    $temp['isnew']      = "1";	//未读
                }
                array_push($_listData, $temp);
            }
            return $_listData;
        }
        return false;
    }
    public function lists(){
		global $_lang;
		$pageindex  = intval(request_var("pageindex",1));
		$pagesize   = intval(request_var("pagesize",10));
		$keyword    = $_REQUEST["keyword"];
		$keyword    = urldecode($keyword);
		$sessionstr = $this->_sessionStr;
		$strexplode = explode("_",$sessionstr);
		$cursession = $strexplode[0];
		$userid     = $strexplode[1];
		//验证sessionkey
	    $check      = CheckSessionKeys($cursession);
	    if($check){
	    	$result     = array();
			//验证菜单权限
			if(CheckMenuPriv($userid,"todoflow")){
				$currindex  = GetCurrPageIndex($pageindex,$pagesize);
				$SearchFlowName = "";
				$type   = array("TYPE"=>"to_do_list","CONSTAINLIST"=>"1");
				$search = array("USER_ID"=>$userid,"FLOW_NAME"=>$keyword);
				$page   = array("PAGINATIONOFFSET"=>$currindex,"PAGINATIONROWS"=>$pagesize,"SORTFIELD"=>"TRANSACT_TIME","SORTTYPE"=>"DESC");
				$other  = array("");
				$list   = new mobilelistItem($type,$search,$page,$other);
				$listData = $list->EmobileGetList();
				$flowcount  = $listData["totalCount"];
				$page_count = GetSumPageCount($flowcount,$pagesize);
				$curr_page  = floor($currindex/$pagesize)+1;
				$result["ishavepre"]  = $currindex<$pagesize ? "0" : "1";
				$result["ishavenext"] = $curr_page<$page_count ? "1" : "0";
				$result["pageindex"]  = $pageindex;
				$result["pagesize"]   = $pagesize;
				$result["count"]      = $flowcount;
				$result["pagecount"]  = $page_count;
				$i=0;
				$flowsum = count($listData["list"]);
				if($flowsum==0){
					$result["list"] = array();
				}else{
                    $userapi    = new user();
					foreach($listData["list"] as $index => $val){
						$RUN_ID    = $listData["list"][$index]["RUN_ID"];
						$FLOW_ID   = $listData["list"][$index]["FLOW_ID"];
						$FLOW_PRCS = $listData["list"][$index]["FLOW_PRCS"];
						$PRCS_ID   = $listData["list"][$index]["PRCS_ID"];
						$totalid   = $RUN_ID.",".$FLOW_ID.",".$FLOW_PRCS.",".$PRCS_ID;
						$result["list"][$i]['id']          = $totalid;
                        if($listData["list"][$index]["INSTANCY_TYPE"] == "1" || $listData["list"][$index]["INSTANCY_TYPE"] == "2") {
                            $identifying = "【".getInstancyName($listData["list"][$index]["INSTANCY_TYPE"])."】";
                            $result["list"][$i]['subject'] = $identifying.$listData["list"][$index]["RUN_NAME"];
                        }else{
                            $result["list"][$i]['subject'] = $listData["list"][$index]["RUN_NAME"];
                        }
						$result["list"][$i]['time']        = $listData["list"][$index]["CREATE_TIME"];
						$result["list"][$i]['image']       = "";
						//判断是否已读
						if($listData["list"][$index]["PRCS_TIME"]!=""){
							//已读
							$result["list"][$i]['isnew'] = "0";
						}else{
							//未读
							$result["list"][$i]['isnew'] = "1";
						}
						$user_pic  = $userapi->GetUserOtherInfor($listData["list"][$index]["CREATOR"]);
						if($user_pic["AVATAR_TYPE"]==""){
							$result["list"][$i]['image'] = IMG_PATH . "defaultimg.png";
						}else{
							$img = "/attachment/personal/".$listData["list"][$index]["CREATOR"]."/avatar_80".$user_pic["AVATAR_TYPE"];
							if(CheckFileExist($img)){
								$result["list"][$i]['image'] = $img;
							}else{
								$result["list"][$i]['image'] = IMG_PATH . "defaultimg.png";
							}
						}
						$result["list"][$i]['description'] =  $user_pic['USER_NAME'] . "\t" . $listData["list"][$index]['CREATE_TIME'] . "\t\t\t" .'[' . $listData["list"][$index]['FLOW_NAME'] .']' ;//$_lang["flow_filenumber"].":".htmlspecialchars(strip_tags(html_entity_decode($listData["list"][$index]["RUN_SEQ"],ENT_QUOTES,'UTF-8')));
						$i++;
					}
					if(count($result["list"])==0){
						$result["list"] = array();
					}
				}
			}else{
				$result["list"] = array();
			}
			echo json_encode($result);
	    }else{
	    	echo "{}";
	    }
    }
    public function count(){
        global $_lang;
        $result     = array();
		$sessionstr = $this->_sessionStr;
		$strexplode = explode("_",$sessionstr);
		$cursession = $strexplode[0];
		$userid     = $strexplode[1];
		//验证sessionkey
	    $check      = CheckSessionKeys($cursession);
	    if($check)
	    {
	    	//验证菜单权限
			if(CheckMenuPriv($userid,"todoflow"))
			{
				$type   = array("TYPE"=>"to_do_list","CONSTAINLIST"=>"0");
				$search = array("USER_ID"=>$userid);
				$page   = array();
				$other  = array("");
				$list   = new mobilelistItem($type,$search,$page,$other);
				$listData 	= $list->EmobileGetList();
				$sumcounts  = $listData["totalCount"];
				$p1 = array("WHERE"=>"frp.USER_ID='$userid' AND frp.PRCS_FLAG='1' AND frp.RUN_ID = fr.RUN_ID AND fr.FLOW_ID = ft.FLOW_ID GROUP BY frp.RUN_ID","LIMIT"=>"all");
				$p2 = array("type"=>"unread_to_do_count");
				$listwApi = new listItem($p1,$p2);
				$uncounts = $listwApi->getList();
			}
			else
			{
				$sumcounts  = "0";
				$uncounts   = "0";
			}
			$result["count"]  = $sumcounts;
			$result["unread"] = $uncounts;
			echo json_encode($result);
	    }
	    else
	    {
	    	echo "{}";
	    }
    }
    public function view($weiApi = ''){
        global $_lang;
        global $connection;
        include_once(COMMON_PATH ."function_all.php");
        include_once("api/fixedworkflow.class.php");
        include_once("general/workflow/flow_expr_run.php");
        include_once("general/workflow/function_textarea.php");
        include_once("general/workflow/prcs_role.php");
        include_once("inc/utility_html.php");
        include_once("api/AnalyticFormEmobile.class.php");
        include_once("inc/set_signaturephone.php");
        //验证是否有手机签章
        $isphonesignature = isPhoneSignature();
        $version          = getVersion();
        /*获取参数----BEGIN*/
        $target      = request_var('target');
        $mobilekey   = request_var("mobilesessionkey");
        $page        = request_var("page");
        $module      = request_var("module");
        $scope       = request_var("scope");
        $detailid    = request_var("detailid");
        $fromid      = request_var("fromid");
        $weiApi      = request_var('weiApi',0);
        $sessionstr  = $this->_sessionStr;
        $strexplode  = explode("_",$sessionstr);
        $userid      = SecurityFilter($strexplode[1]);
        $allid       = explode(",",$detailid);
        $runid       = SecurityFilter($allid[0]);
        $flowid      = $allid[1];
        $flow_prcsid = $allid[2];
        $prcsid      = $allid[3];
        $diff        = $allid[4];
        //获取流程步骤
        if($diff=="candeal"){
            $sql = "SELECT PRCS_ID,FLOW_PRCS FROM flow_run_prcs WHERE RUN_ID = '".$runid."'
                    ORDER BY PRCS_ID DESC LIMIT 0,1";
            $result = exequery($connection,$sql);
            if($ROW = mysql_fetch_array($result)){
                $prcsid = $ROW["PRCS_ID"];//节点ID
                $flow_prcsid = $ROW["FLOW_PRCS"];	//节点ID,流程处于哪个节点
            }
        }
        //取用户信息
        if($userid!=""){
            $sql = "SELECT * FROM USER WHERE USER_ID = '".$userid."'";
            $result = exequery($connection,$sql);
            if($ROW = mysql_fetch_array($result)){
                $GLOBALS['LOGIN_USER_ID']   = $userid;
                $GLOBALS['LOGIN_USER_PRIV'] = $ROW["USER_PRIV"];
                $GLOBALS['LOGIN_DEPT_ID']   = $ROW["DEPT_ID"];
            }
        }
        $workFlowRunning = new fixedWorkflow($flowid);// 固定流程类,创建对象
        //设置流程的run_id
        $workFlowRunning->runId = $runid;
        $flowInfo        = $workFlowRunning->getFlowInfo();//获取流程所有节点的信息
        $nodeInfo        = $workFlowRunning->getNodeInfo();//获取流程节点信息
        //此流程的一些属性
        $FORM_ID   = $workFlowRunning->formId;
        $FLOW_TYPE = $workFlowRunning->flowType;
        $FLOW_DOC  = $workFlowRunning->flowDoc;//结束归档
        //获取最大的步骤
        $PRCS_MAX           = 0;
        foreach($nodeInfo as $key=>$val){
            if($PRCS_MAX < $val["PRCS_ID"]){
                $PRCS_MAX = $val["PRCS_ID"];
            }
        }
        $FLOW_NAME          = $workFlowRunning->flowName;
        //获取办理方式0、只有主办人1、第一个2、最后一个
        if($FLOW_TYPE=="1"){
            $PRCS_OPTYPE        = $nodeInfo[$flow_prcsid]["PRCS_OPTYPE"];
            $endFlow            = $nodeInfo[$flow_prcsid]["END_WORKFLOW"];
        }else if($FLOW_TYPE=="2"){
            $PRCS_OPTYPE        = $workFlowRunning->handWay;
        }
        //设置主办人
        if($PRCS_OPTYPE != 3){
            $workFlowRunning->setOpFlag($PRCS_OPTYPE,$prcsid,$flow_prcsid,$userid);
        }
        //进入办理页面，取消短信提醒
        $workFlowRunning->cancelSmsRemind($userid);
        //设置查看
        $workFlowRunning->markHaveReceive($userid,$prcsid);
        //存在节点说明或者，有子流程且需办理完毕，第一步没有子流程须办理
        $PRCS_DESCRIPT      = $nodeInfo[$flow_prcsid]["PRCS_DESCRIPT"];
        //流程配置中的其它设置的配置信息
        $FLOW_SHOW_TEXT     = $flowInfo["FLOW_SHOW_TEXT"];
        $LABLE_SHOW_DEFAULT = $flowInfo["LABLE_SHOW_DEFAULT"];
        $FLOW_AUTOSAVE      = $flowInfo["FLOW_AUTOSAVE"];
        $FLOW_AUTOSAVE_TIME = $flowInfo["FLOW_AUTOSAVE_TIME"];
        if(!$FLOW_SHOW_TEXT)
            $FLOW_SHOW_TEXT = "";
        if(!$LABLE_SHOW_DEFAULT)
            $LABLE_SHOW_DEFAULT = 1;
        if(!$FLOW_AUTOSAVE)
            $FLOW_AUTOSAVE = "";
        if(!$FLOW_AUTOSAVE_TIME)
            $FLOW_AUTOSAVE_TIME = 0;
        $flowPrcsInfo       = $workFlowRunning->getPrcsInfo();
        //记录最后查看时间,增加原因,可能打开查看,但没有办理,下次再打开办理
        $workFlowRunning->recordLastVisitdTime($prcsid,$userid);
        //获取前一个步骤的节点号
        $flowPrcsCount = count($flowPrcsInfo);
        for($flowPrcsCount ;$flowPrcsCount >1 ;$flowPrcsCount--){
            if($flowPrcsInfo[$flowPrcsCount-1]["PRCS_ID"] != $flowPrcsInfo[$flowPrcsCount-2]["PRCS_ID"] ){
                $pre_flow_prcs = $flowPrcsInfo[$flowPrcsCount-2]["FLOW_PRCS"];
                break;
            }
        }
        //流程表单中字段的控制
        $PRCS_ITEM          = $nodeInfo[$flow_prcsid]["PRCS_ITEM"];
        $PRCS_ITEM_CAPACITY = $nodeInfo[$flow_prcsid]["PRCS_ITEM_CAPACITY"];
        $PRCS_ITEM_AUTO     = $nodeInfo[$flow_prcsid]["PRCS_ITEM_AUTO"];
        $PRCS_ITEM_REQUIRED = $nodeInfo[$flow_prcsid]["PRCS_ITEM_REQUIRED"];
        //流程本节点是否可以转发
        $flowForward        = $nodeInfo[$flow_prcsid]["PRCS_FORWARD"];

        //取表单
        $FORM_NAME   = $flowInfo["FORM_NAME"];
        $PRINT_MODEL = $flowInfo["PRINT_MODEL"];
        $FIELD_COUNTER = $flowInfo["FIELD_COUNTER"];
        //取表单数据新
        $form_data = $workFlowRunning->getFormDataNew();
        //取签办反馈数据
        $feedinfor = NewDoFlowFeedBack($runid,$flowid,$FLOW_TYPE);
        //当前流程步骤名称
        $nodeName = $nodeInfo[$flow_prcsid]["PRCS_NAME"];
        //获取流程附件
        $attach = $workFlowRunning->GetFlowOtherInformation();
        //判断是否是主办人
        $OP_FLAG            = 0;
        $mainOpTodo         = 0;
        $opTodo             = 0;
        /**
         * 第四种办理情况处理
         */
        if($PRCS_OPTYPE == 3){
            $maxOpFlag = $workFlowRunning->opFlagIsExist($prcsid);
            if($maxOpFlag == 0){
                $mainOpTodo = 1;
            }else{
                /**
                 * 回收特殊处理
                 */
               $selfOpFlag = $workFlowRunning->opFlagIsSelf($prcsid,$userid);
               if($selfOpFlag){
                   $mainOpTodo = 1;
               }
            }
        }else{
            foreach($flowPrcsInfo as $key=>$val){
                if($val["PRCS_ID"] == $prcsid && $val["USER_ID"] == $userid ){
                    if($val["OP_FLAG"]==1){
                        if(!$val["DELIVER_TIME"]){
                            $mainOpTodo = 1;
                            break;
                        }else{
                            $mainOpTodo = 2;
                        }
                    }else if($val["OP_FLAG"]==0){
                        if(!$val["SAVEFORM_TIME"]){
                            $opTodo = 1;
                            //break;
                        }else{
                            $opTodo = 2;
                        }
                    }
                }
            }
        }
        //删除权限
        $deleteFlag = false;
        $maxPrcs = $this->getCurrentMaxPrcs($userid, $runid);
        foreach($flowPrcsInfo as $key=>$val){
            if($val["USER_ID"] == $userid && $maxPrcs == 1 && $mainOpTodo == 1){
                $deleteFlag = true;
            }
        }

        if($mainOpTodo == 1){
            $OP_FLAG = 1;
        }else if($opTodo == 1){
            $OP_FLAG = 0;
        }
        //获取附件编辑权限
        $attachPriv = false;
        if(strstr($PRCS_ITEM,'[A@]') && $OP_FLAG == 1){
            $attachPriv = true;
        }
        if($FLOW_TYPE == 2){
            $attachPriv = true;
        }
        //判断是否是第一个节点，再去获取流程的流水号是否可以编辑
        if($flow_prcsid == 1){
            $canEditFlowno = $flowInfo["CAN_EDIT_FLOWNO"];
        }else{
            $canEditFlowno =  "";
        }
        //获取主子流程运行模式，子流程的id
        if($pre_flow_prcs){
            $SUB_WORKFLOW_IDS = $nodeInfo[$pre_flow_prcs]["SUB_WORKFLOW_IDS"];
            $RUN_WAYS         = $nodeInfo[$pre_flow_prcs]["RUN_WAYS"];
        }
        //获取子流程的run_id，并验证子流程是否走完
        $is_finished = "true";
        if($SUB_WORKFLOW_IDS&&$RUN_WAYS){
            $is_finished = $workFlowRunning->haveSubFlowFinished($prcsid,$userid);
        }
        //自由流程会签时结束按钮
        if($FLOW_TYPE=="2"){
            $counterSign            = $workFlowRunning->counterSign;
            if($counterSign){
                foreach($flowPrcsInfo as $flowPrcsKey=>$flowPrcsVal){
                    if($flowPrcsVal["USER_ID"] != $userid &&$flowPrcsVal["PRCS_ID"] == $prcsid&&!$flowPrcsVal["SAVEFORM_TIME"]){
                        $neverCounterSign .= $flowPrcsVal["USER_ID"].",";
                    }
                }
                $neverCounterSign = trim($neverCounterSign,",");
            }
        }
        // 判断签办反馈必填
        $feedBackRequiredFlag = "";
        if($FLOW_TYPE == "1") {
            // 需要必填
            if(find_id($PRCS_ITEM_REQUIRED,"[F@]")) {
                $feedBackRequiredFlag = "1";
            }
        }
        // 判断公共附件必填
        $ATTACH_EDIT            = 0;
        $attachmentRequiredFlag = 0;
        if((find_id($PRCS_ITEM,"[A@]")&&$OP_FLAG)||$FLOW_TYPE=="2"){
            $ATTACH_EDIT = 1;
        }
        if($ATTACH_EDIT == 1 && $FLOW_TYPE == 1) {
            // 需要必填
            if(find_id($PRCS_ITEM_REQUIRED,"[A@]")) {
                $attachmentRequiredFlag = "1";
            }
        }
        include_once(INCLUDE_APP_PATH . 'Flow/ToDo/View/FlowNextView.php');
    }
    public function endFixedFlow()
    {
        global $connection;
        include_once("general/workflow/function_textarea.php");
        include_once("inc/function_flow.php");
        include_once("api/fixedworkflow.class.php");
        include_once("api/AnalyticFormView.class.php");
        $userId   = request_var('userId');
        $runId    = request_var('runId');
        $prcsId   = request_var('prcsId');
        $flowPrcs = request_var('flowPrcs');
        $flowId   = request_var('flowId');
        $workFlowRunning        = new fixedWorkflow($flowId);
        $workFlowRunning->runId = $runId;
        $nodeInfo               = $workFlowRunning->getNodeInfo();
        $PRCS_OPTYPE            = $nodeInfo[$flowPrcs]["PRCS_OPTYPE"];
        $sessionstr             = $this->_sessionStr;
        $workFlowRunning->isHaveSubmit($prcsId);
        //判断某个步骤是否存在主办人,由于可能设置为第一个和最后一个办理人为主办人所以主办人还没有确定
        $maxOpFlag = $workFlowRunning->opFlagIsExist($prcsId);
        if($maxOpFlag != 1)
        {
            //尚没有确定主办人
            if($PRCS_OPTYPE == 3)
                $workFlowRunning->setOpFlag($PRCS_OPTYPE,$prcsId,$flowPrcs,$userId);
            else
            {
                echo "notHaveOp";
                exit;
            }
        }
        $workFlowRunning->fakeMarkReceive();
        $sql = "SELECT * FROM flow_run WHERE RUN_ID = '".$runId."'";
        $rs  = exequery($connection,$sql);
        if($rows = mysql_fetch_array($rs))
        {
            $docId  = $rows["LINK_DOC"];
        }
        $workFlowRunning->turnNext('',$prcsId,'',$userId,$docId,'','','',"",0,0,0,$userId,"webservice");
		getSendNeedDataBeforeSend($flowId,$runId,'',$prcsId,'',$userId,'');
        echo 1;
    }
    public function getCurrentMaxPrcs($userId,$runId){
        global $_lang;
        global $connection;
        $sessionstr  = $this->_sessionStr;
        $query = 'SELECT count(*) as maxPrcs FROM flow_run_prcs WHERE USER_ID = \''.$userId.'\' AND RUN_ID='.$runId;
        $result = exequery($connection,$query);
        if($ROW = mysql_fetch_array($result)){
            return intval($ROW['maxPrcs']);
        }
        return 1;
    }
}

