<?php
/**
 * @copyright (C) 2014 - 2016 Weaver Co.Ltd
 * @package   eoffice9.0
 * @name      webroot/E-mobile/App/Meeting/MeetingProxy.php
 * @function  会议模块代理类       
 * @version   1.0 
 * @author    lizhijun
 */
include_once("api/meeting.class.php");
class MeetingProxy
{
    private $_userId; //用户id
    private $_sessionstr; //sessionkey
    private $_cursession; //当前session
    private $_pageSize = 10; //每页大小
    private static $_meeting; //客户api对象
	/**
	 * 构造函数
	 * 注册全局变量
	 * 注册api对象
	 */
    public function __construct() 
	{
        $this->_sessionstr	= request_var("sessionkey");
        $strexplode			= explode("_", $this->_sessionstr);
        $this->_cursession	= $strexplode[0];
        $this->_userId		= $strexplode[1];
        if (!self::$_meeting) {
            self::$_meeting = new meeting();
        }
    }
	/**
	 * 会议列表页面初始化函数
	 * 
	 * @global array $_lang
	 */
	public function lists()
	{
		global $_lang;
		
        if (!CheckSessionKeys($this->_cursession)) {
			echo $_lang['e_meeting_no_auth'];exit;
		}
		
		if (!CheckMenuPriv($this->_userId, "mymeeting")){
			echo $_lang['e_meeting_no_menu_auth'];exit;
		}
		
		$users			= $this->_getUsers();
		$rooms			= $this->_getRooms();
		$meetingType	= $this->_getMeetingType(11);
		
		include_once(INCLUDE_APP_PATH . 'Meeting/View/ListsView.php');
	}
	/**
	 * 会议开始
	 */
	public function ajaxBegin() 
	{
		$this->_authCheck('mymeeting');
		
		$_REQUEST['re_time'] = date('Y-m-d H:i:s');
		
		self::$_meeting->edit_info('remind_begin',$_REQUEST);
		
		echo json_encode(array('status' => 1,'msg' => 'start_success'));exit;
	}
	/**
	 * 会议结束
	 */
	public function ajaxEnd()
	{
		$this->_authCheck('mymeeting');
		
		$_REQUEST['re_time']	= date('Y-m-d H:i:s');
		$_REQUEST['person_id']	= $this->_userId;
		
		self::$_meeting->edit_info('remind_end',$_REQUEST);
		self::$_meeting->creat_info('meeting_recorde',$_REQUEST);
		
		echo json_encode(array('status' => 1,'msg' => 'end_success'));exit;
	}
	/**
	 * 获取会议列表数据
	 */
	public function ajaxLists() 
	{
		$this->_authCheck('mymeeting');
		
		$page		= request_var('page',0);
		$offset		= $page * $this->_pageSize;
		$filter		= request_var('filter','all');
		$keyword	= request_var('keyword','');
		
		$where		= array();
		if($keyword != '') {
			$where['m_subject'] = $keyword;
		}
		
		$infor		= self::$_meeting->myapply_show('A_BEGIN_TIME','DESC',$offset,$this->_pageSize,$filter,$this->_userId,$where);
		array_shift($infor);
		
		echo json_encode(array('status' => 1,'data' => $infor));
	}
	/**
	 * 获取会议先去数据
	 */
	public function ajaxDetail()
	{
        $this->_authCheck('mymeeting');
		
		$applyId	= request_var('applyId',0);
		if(!$applyId) {
			echo json_encode(array('status' => 0,'msg' => 'apply_id_empty'));exit;
		}
		
		$detailInfo		= self::$_meeting->myapply_detail($applyId);
		
		echo json_encode(array('status' => 1,'data' => $detailInfo));
	}
	/**
	 * 会议删除
	 */
	public function ajaxDelete()
	{
		$this->_authCheck('mymeeting');
		
		$applyId	= request_var('applyId',0);
		if(!$applyId) {
			echo json_encode(array('status' => 0,'msg' => 'apply_id_empty'));exit;
		}
		
		$check = self::$_meeting->myapply_detail($applyId);
		if($check['check_time']!="" && $check['state']==1){
			echo json_encode(array('status' => 0,'msg' => 'has_no_del_condition'));exit;
		}
		
		if($check['false_delete']=='2' || $check['check_time']==''){
			self::$_meeting->delete_meeting('meeting_apply',$applyId);
			
			self::$_meeting->delete_meeting('meeting_recorde',$applyId);
		}else{
			self::$_meeting->edit_info("my_false_delete",$applyId);	
		}	
		
		echo json_encode(array('status' => 1,'msg' => 'delete_success'));exit;
	}
	/**
	 * 会议模块权限验证
	 * 
	 * @param string $menu
	 */
	private function _authCheck($menu)
	{
		if (!CheckSessionKeys($this->_cursession)) {
			echo json_encode(array('status' => 0,'msg' => 'no_auth'));exit;
		}
		
		if (!CheckMenuPriv($this->_userId, $menu)){
			echo json_encode(array('status' => 0,'msg' => 'no_menu_auth'));exit;
		}
	}
	/**
	 * 获取会议类别
	 * 
	 * @global obj $connection
	 * @param int $id
	 * @return json
	 */
	private function _getMeetingType($id)
		{
        global $connection;
        $query      = "SELECT CC_NAME,CC_VALUE FROM combocox_child WHERE CC_PARENT_ID=$id ORDER BY CC_OEDER ASC";
        $cousor     = exequery($connection, $query); 
		
        $crmType    = array();
        if($cousor){
            while ($row = mysql_fetch_array($cousor)) {
                $crmType[$row['CC_VALUE']] = $row['CC_NAME'];
            }
        }
		
        return json_encode($crmType);
    }
	/**
	 * 获取会议室
	 * 
	 * @return json
	 */
	private function _getRooms() 
	{
		$sortname		= "R_ID";
		$sorttype		= "DESC";
		$quickSortParam = array();
		$where_str		= array();		
		
		$infor			= self::$_meeting->m_room($sortname,$sorttype,"","",$quickSortParam,$where_str);
		unset($infor["resultCount"]);
		
		$rooms			= array();
		foreach($infor as $v) {
			$rooms[$v['r_id']] = $v['r_name'];
		}
		
		return json_encode($rooms);
	}
	/**
	 * 获取所有用户
	 * 
	 * @global obj $connection
	 * 
	 * @return $userList
	 */
	private function _getUsers()
	{
		global $connection;
		
		$query		= 'SELECT USER_ID,USER_NAME FROM user';
        $rs			= exequery($connection,$query);
		
        $userList	= array();
        if($rs){
            while($row = mysql_fetch_assoc($rs)){
                $userList[$row['USER_ID']] = $row['USER_NAME'];
            }
        }
		
		return json_encode($userList);
	}
}