<?php
/**
 * @copyright (C) 2000 - 2014 Weaver Co.Ltd
 * @package   eoffice9.0
 * @name      webroot/E-mobile/App/New/NewsClass.php
 * @function  新闻数据返回       
 * @version   1.0 
 * @author    lizhijun
 */
include_once("api/news.class.php");
include_once("api/user.class.php");
include_once ("inc/conn.php");
include_once ("inc/function_picture.php");
include_once ("api/email.class.php");
include_once(COMMON_PATH . 'Tool/Tool.php');//系统公共工具类
class NewProxy{
    private $_pageSize = 10;
      private $_sessionStr;
    public function __construct() {
         $this->_sessionStr = request_var("sessionkey");
    }
    public function weiLists(){
        global $_lang;
        $sessionstr =  $this->_sessionStr;
        $userId     = Tool::checkUserAuth($sessionstr, 'news');//用户权限检查
        $newLists   = $this->_getNewLists($userId);
        include_once(INCLUDE_APP_PATH . 'New/View/NewListsView.php');

    }
    public function ajaxGetNewLists(){
        $sessionstr =  $this->_sessionStr;
        $userId     = Tool::checkUserAuth($sessionstr, 'news',true);//用户权限检查
        if($userId == 'error1'){
            echo 'error1';
            exit;
        }
        if($userId == 'error2'){
            echo 'error2';
            exit;
        }
        $pageSize   = intval(request_var('pageSize',0));
        $pageIndex  = intval(request_var('pageIndex',1));
        $keyword    = request_var('keyword','');
        $filter     = request_var('filter','');
        if($pageSize == 0) $pageSize = $this->_pageSize;
        $newLists   = $this->_getNewLists($userId, $keyword, $filter, $pageSize, $pageIndex);
        if($newLists){
            echo json_encode($newLists);
        }else{
            echo 0;
        }
    }
    private function _getNewLists($userId,$keyword='',$filter='',$pageSize=10,$pageIndex=1){
        $currentIndex   = GetCurrPageIndex($pageIndex,$pageSize);
        $search         = array('key_nname'   => $keyword,'FILTER' => $filter,'provider' => 'admin','inspect' => 1,'USERID' => $userId);
        $other          = array('orderby' => 'NEWS_TIME','ordertype' => 'DESC','start' => $currentIndex,'limit' => $pageSize);
        $newsApi        = new news ();
        $news           = $newsApi->getNewsList($search,$other);
        if($news){
            $_news      = array();
            foreach($news as $value){
                $temp['id']         = $value['NEWS_ID'];
                $temp['title']      = substrGB($value['SUBJECT'],14,'...');
                $temp['time']       = $value['NEWS_TIME'];
                $temp['userName']   = $value['PROVIDER_NAME'];
                $temp['typeName']   = $this->_getNewType($value['NEWS_TYPE_ID']);
                $temp['clickCount'] = $value['CLICK_COUNT'];
                if(strstr($value['news_reader'],$userId.",")){
                    $temp['isnew']      = 0;
                }else{
                    $temp['isnew']      = 1;
                }
                $temp['image']      = GetNewUrlPath(EmobilePicShow($value['ATTACHMENT_ID'],$value['ATTACHMENT_NAME'],96,"news"));
                array_push($_news, $temp);
            }
            return $_news;
        }
        return false;
    }
    private function _getNewType($typeId){
        global $_lang;
        global $connection;
        
        if($typeId == '000000'){
            return $_lang["news_no_category_news"];
        }
        $query  = 'SELECT NEWS_TYPE_NAME from news_types WHERE NEWS_TYPE_ID=\''.SecurityFilter($typeId).'\'';
        $result = exequery($connection,$query);
		$row    =mysql_fetch_array($result);
        return $row['NEWS_TYPE_NAME'];
    }
    public function lists(){
        global $_lang;
		$pageindex  = request_var("pageindex");
		$pagesize   = request_var("pagesize");
		$keyword    = request_var("keyword");
		$keyword    = urldecode($keyword);
		 $sessionstr =  $this->_sessionStr;
		$strexplode = explode("_",$sessionstr);
		$cursession = $strexplode[0];
		$userid     = $strexplode[1];
        $check      = CheckSessionKeys($cursession);
        if($check){
	    	$result     = array();
			//验证菜单权限
			if(CheckMenuPriv($userid,"news")){
				$currindex  = GetCurrPageIndex($pageindex,$pagesize);
				
				$search     = array();
				$search["NewsSubject"] = $keyword;
				$newsApi    = new news ();
				$news       = $newsApi->getNewsInfo($pagesize,$currindex,"",$search);
				$newscount  = $newsApi->GetNewsCount($search);
				$page_count = GetSumPageCount($newscount,$pagesize);
				$curr_page  = floor($currindex/$pagesize)+1;		
				$result["ishavepre"]  = $currindex<$pagesize ? "0" : "1";
				$result["ishavenext"] = $curr_page<$page_count ? "1" : "0";
				$result["pageindex"]  = $pageindex;	
				$result["pagesize"]   = $pagesize;
				$result["count"]      = $newscount;
				$result["pagecount"]  = $page_count;
				$i=0;
				$newssum = count($news);
				if($newssum==0){
					$result["list"] = array();	
				}else{
					foreach($news as $index => $val){
						$result["list"][$i]['id']          = $news[$index]['NEWS_ID'];
						$result["list"][$i]['subject']     = $news[$index]['SUBJECT'];
						$result["list"][$i]['time']        = $news[$index]['NEWS_TIME'];
						$result["list"][$i]['description'] = $_lang["e_new_views"].":".$news[$index]['CLICK_COUNT'];
						//判断新闻已读、未读
						if(strstr($news[$index]['news_reader'],$userid.",")){
							//已读
							$result["list"][$i]['isnew'] = "0";	
						}else{
							//未读
							$result["list"][$i]['isnew'] = "1";	
						}
						$result["list"][$i]['image'] = GetNewUrlPath(EmobilePicShow($news[$index]['ATTACHMENT_ID'],$news[$index]['ATTACHMENT_NAME'],96,"news"));
						$i++;
					}
					if(count($result["list"])==0){
						$result["list"] = array();
					}	
				}	
			}else{
				$result["list"] = array();	
			}
			echo json_encode($result);
	    }else {
	    	echo "{}";
	    }
    }
    public function count(){
        $result     = array();
		 $sessionstr =  $this->_sessionStr;
		$strexplode = explode("_",$sessionstr);
		$cursession = $strexplode[0];
		$userid     = $strexplode[1];
		//验证sessionkey
	    $check      = CheckSessionKeys($cursession);
	    if($check){
	    	//验证菜单权限
			if(CheckMenuPriv($userid,"news")){
				$newsapi    = new news();
				$sumcounts  = $newsapi->GetNewsCount(array());
				$uncounts   = $newsapi->NewUnreadSum($userid);	
			}else{
				$sumcounts  = "0";
				$uncounts   = "0";		
			}
			$result["count"]  = $sumcounts;
			$result["unread"] = $uncounts;
			echo json_encode($result);	
	    }else {
	    	echo "{}";
	    }
    }
    public function view(){
        global $connection,$_lang;
        $mobilekey  = request_var("mobilesessionkey");
        $page       = request_var("page");
        $module     = request_var("module");
        $scope      = request_var("scope");
        $detailid   = intval(request_var("detailid"));
        $fromid     = request_var("fromid");
         $sessionstr =  $this->_sessionStr;
        $weiApi      = request_var('weiApi',0);
        $strexplode = explode("_",$sessionstr);
		$cursession = $strexplode[0];
		//验证sessionkey
	    if(!CheckSessionKeys($cursession)) {
			echo 'illegal access';exit;
		}
        $userid     = $strexplode[1];
        $NewsId     = $detailid;
        $UserId     = $userid;
        
        $newsApi   = new news ();
        $newsApi->AddNewsReader($NewsId,$UserId);
        $news      = $newsApi->getNewsInfo("","",$NewsId,array());
        $newsInfor = $news[0];
        $ReplyData = $newsApi->getNewsCommentAndReply($NewsId);
        if($newsInfor["NEWS_TYPE_ID"]=="000000"){
            $new_type_name = $_lang["news_no_category_news"];	
        }else{
            $sql = "SELECT * FROM news_types WHERE NEWS_TYPE_ID='".SecurityFilter($newsInfor["NEWS_TYPE_ID"])."'";
            $rs   = exequery($connection,$sql);
            if($row = mysql_fetch_assoc($rs)){
                $new_type_name = $row["NEWS_TYPE_NAME"];	
            }	
        }
        include_once(INCLUDE_APP_PATH . 'New/View/NewView.php');
    }
    
    public function reply(){
        global $connection;
         $sessionstr =  $this->_sessionStr;
        $CONTENT = str_replace("\n", "<br />",$_REQUEST["news_reply"]);
        $CONTENT = str_replace("\r", "<br />",$CONTENT);
        //$CONTENT = htmlentities($CONTENT, ENT_COMPAT);
        $sql = "INSERT INTO news_comment 
				(NEWS_ID,PARENT_ID,USER_ID,CONTENT,RE_TIME) 
				VALUES 
				('".intval($_REQUEST["news_id"])."','0','".SecurityFilter($_REQUEST["user_id"])."','".SecurityFilter($CONTENT)."','".date('Y-m-d H:i:s',time())."')";
		$rs  = exequery($connection,$sql);
		if($rs)
		{
			echo "success";	
		}
		else
		{
			echo "faild";	
		}
    }
    public function create(){
        global $_lang;
        /*获取参数----BEGIN*/
        $mobilekey  = $_REQUEST["mobilesessionkey"];
        $page       = $_REQUEST["page"];
        $module     = $_REQUEST["module"];
        $scope      = $_REQUEST["scope"];
        $detailid   = $_REQUEST["detailid"];
        $fromid     = $_REQUEST["fromid"];
         $sessionstr =  $this->_sessionStr;
        $strexplode = explode("_",$sessionstr);
		$cursession = $strexplode[0];
		//验证sessionkey
	    if(!CheckSessionKeys($cursession)) {
			echo 'illegal access';exit;
		}
        $userid     = $strexplode[1];
		
        $UserInfor  = array();
        $UserInfor["user_id"] = $userid;

        $userarray        = GetCurrUserPriv($userid);
        $GLOBALS['USER_FUNC_ID_STR'] = $userarray["FUNC_ID_STR"];
        $state = false;
        if(checkFuncPriv('321',$userarray["FUNC_ID_STR"])){
            $state = true;
        }
        $array            = checkReminds("9",$userarray["USER_PRIV"]);
        $sms_select       = $array[0];
        $smstel_select    = $array[1];
        $email_select     = $array[2];
        $sms_modify       = $array[3];
        $smstel_modify    = $array[4];
        $email_modify     = $array[5];
        include_once(INCLUDE_APP_PATH . 'New/View/CreateNewView.php');
    }
    public function createDo(){
        global $connection,$_lang;
        /*获取参数----BEGIN*/
        include_once ("inc/mobile_sms.inc.php");
        $mobilekey  = $_REQUEST["mobilesessionkey"];
        $page       = $_REQUEST["page"];
        $module     = $_REQUEST["module"];
        $scope      = $_REQUEST["scope"];
        $detailid   = $_REQUEST["detailid"];
        $fromid     = $_REQUEST["fromid"];
        $sessionstr =  $this->_sessionStr;
        $strexplode = explode("_",$sessionstr);
		$cursession = $strexplode[0];
		//验证sessionkey
	    if(!CheckSessionKeys($cursession)) {
			echo 'illegal access';exit;
		}
        $userid     = $strexplode[1];
        $diff = $_REQUEST["diff"];
        $userarray        = GetCurrUserPriv($userid);
        $GLOBALS['USER_FUNC_ID_STR'] = $userarray["FUNC_ID_STR"];
        $subject  = $_REQUEST["subject"];
		$contents = $_REQUEST["contents"];
		$typeid   = $_REQUEST["typeid"];
		$top      = $_REQUEST["top"];
		$reply    = $_REQUEST["reply"];
		$sms      = $_REQUEST["Esms"];
		$email    = $_REQUEST["Eemail"];
		$tel      = $_REQUEST["Etel"];
        $public    = request_var('public',0);
		$cur_time = date("Y-m-d H:i:s",time());
		$query = "INSERT INTO NEWS(SUBJECT,CONTENT,PROVIDER,NEWS_TIME,PUTIP,PUBLIC,ATTACHMENT_ID,ATTACHMENT_NAME,NEWS_TYPE_ID,ALLOW_REPLY,SMS_REMIND,SMSTEL_REMIND,EMAIL_REMIND) values ('".SecurityFilter($subject)."', '".SecurityFilter($contents)."', '".SecurityFilter($userid)."', '".SecurityFilter($cur_time)."', '".SecurityFilter($top)."', '".SecurityFilter($public)."','','','".SecurityFilter($typeid)."',".SecurityFilter($reply).",'".SecurityFilter($sms)."','".SecurityFilter($tel)."','".SecurityFilter($email)."')";
		exequery($connection,$query);
		$TABLE_ID   = mysql_insert_id();
		$TABLE_NAME = "news";
		//播报
		AddBroacastLog($userid,"news","NEWS_ID",$TABLE_ID,"SUBJECT","new");
		//发送消息
		$SMS_CONTENT = $_lang["e_new_please_view_news"]."！".$_lang["news_new_title"]."：".csubstr($subject,0,100);
		if($sms=="1" && $public != 0)
		{
			$querysms = "SELECT USER_ID FROM user 
						WHERE DEPT_ID > 0";
			$cursorsms = exequery($connection,$querysms);
            $userIds = '';
			while($ROW=mysql_fetch_array($cursorsms))
			{
				$userIds .= $ROW["USER_ID"] . ',';
			}
            if($userIds){
                sendSms($userid,$userIds,$SMS_CONTENT,1,27,$TABLE_NAME,$TABLE_ID);
            }
		}
		if($email=="1" && $public != 0)
		{
			$email = new email();
			$queryemail = "SELECT USER_ID FROM user 
					WHERE DEPT_ID>0";
			$cursoremail = exequery($connection,$queryemail);
			while($ROWs=mysql_fetch_array($cursoremail)) {
				$USER_ID = $ROWs["USER_ID"];
				$email->sendEmail($userid,$USER_ID,$USER_ID,$_lang["e_new_please_view_news"],$SMS_CONTENT,date("Y-m-d H:i:s",time()),'','');
			}
		}
		if($tel=="1" && $public != 0)
		{
			$USER_ID_STRING = "";
			$querytel = "SELECT USER_ID FROM user WHERE DEPT_ID>0";
			$cursortel = exequery($connection,$querytel);
			while($ROWt=mysql_fetch_array($cursortel))
			{
				$count++;
				$USER_ID_STRING .= $count==1?$ROWt["USER_ID"]:",".$ROWt["USER_ID"];
			}
			$newSms = new MobileSms();
			$newSms->SelfSendMore($USER_ID_STRING,$SMS_CONTENT,'',$userid);
		}
        include_once(INCLUDE_APP_PATH . 'Create/View/CreateSuccessView.php');
    }
    
    
     public function sourcePage(){
 
        global $_lang;
        $diff     = $_REQUEST["pagediff"];
        $sessionstr = request_var('sessionkey');
        $title    = "";
        $contents = "";
       $newsid   = $_REQUEST["newsid"];
        $userid   = $_REQUEST["userid"];
        $newsApi  = new news ();
        $news     = $newsApi->GetSingalNewsDetail($newsid);
        $contents = $news[0]["CONTENT"];
        $title    = $_lang['emobile_common_root_xwyw'];
 
        include_once(INCLUDE_APP_PATH . 'New/View/sourcePage.php');
                
    }
}

