<?php

/**
 * @copyright (C) 2000 - 2014 Weaver Co.Ltd
 * @package   eoffice9.0
 * @name      webroot/E-mobile/App/New/NewsClass.php
 * @function  公告数据返回       
 * @version   1.0 
 * @author    lizhijun
 */
include_once("api/notify.class.php");
include_once("api/user.class.php");
include_once("inc/conn.php");
include_once("wap/function.php");
include_once(COMMON_PATH . 'Tool/Tool.php'); //系统公共工具类

class NotifyProxy {

    private $_pageSize = 10;

    public function __construct() {
        ;
    }

    public function weiLists() {
        global $_lang;
        $sessionstr = request_var("sessionkey");
        $userId = Tool::checkUserAuth($sessionstr, 'notify'); //用户权限检查
        $notifyLists = $this->_getNotifyLists($userId);
        include(INCLUDE_APP_PATH . 'Notify/View/NotifyListsView.php');
    }

    public function ajaxGetNotifyLists() {
        $sessionstr = request_var("sessionkey");
        $userId = Tool::checkUserAuth($sessionstr, 'notify', true); //用户权限检查
        if ($userId == 'error1') {
            echo 'error1';
            exit;
        }
        if ($userId == 'error2') {
            echo 'error2';
            exit;
        }
        $pageSize   = intval(request_var('pageSize',0));
        $pageIndex  = intval(request_var('pageIndex',1));
        $keyword    = request_var('keyword','');
        $filter     = request_var('filter','');
        if($pageSize == 0) $pageSize = $this->_pageSize;
        $notifyLists   = $this->_getNotifyLists($userId, $keyword, $filter, $pageSize, $pageIndex);
        if($notifyLists){
            echo json_encode($notifyLists);
        } else {
            echo 0;
        }
    }

    private function _getNotifyLists($userId, $keyword = '', $filter = '', $pageSize = 10, $pageIndex = 1) {
        $currindex = GetCurrPageIndex($pageIndex, $pageSize);
        $notifyApi = new notify(array('user_id' => $userId));
        $search = array('NotifySubject' => $keyword, 'FILTER' => $filter, 'USER_ID' => $userId);
        $_list = $notifyApi->getNotifyLists($pageSize, $currindex, $search);
        if ($_list) {
            $list = array();
            $userapi = new user();
            foreach ($_list as $value) {
                $temp['id'] = $value['NOTIFY_ID'];
                $temp['title'] = substrGB($value['SUBJECT'], 14, '...');
                $temp['time'] = $value['SEND_TIME'];
                $temp['userId'] = $value['FROM_ID'];
                $temp['userName'] = $value['USER_NAME'];
                $temp['typeName'] = $this->_getNotifyType($value['NOTIFY_TYPE_ID']);
                if (strstr($value['READERS'], $userId . ",")) {
                    $temp['isnew'] = 0;
                } else {
                    $temp['isnew'] = 1;
                }
                $userInfo = $userapi->GetUserOtherInfor($value['FROM_ID']);
                $temp['image'] = Tool::getUserImage($value['FROM_ID'], $userInfo["AVATAR_TYPE"]);
                array_push($list, $temp);
            }
            return $list;
        }
        return false;
    }

    private function _getNotifyType($notifyType) {
        global $connection;
        global $_lang;
        if ($notifyType == '000000') {
            return $_lang["e_notify_no_class"];
        }
        $query = 'SELECT NOTIFY_TYPE_NAME from notify_type WHERE NOTIFY_TYPE_ID=\'' . SecurityFilter($notifyType) . '\'';
        $result = exequery($connection, $query);
        $row = mysql_fetch_array($result);
        return $row['NOTIFY_TYPE_NAME'];
    }

    public function lists() {
        global $_lang;

        $pageindex = request_var("pageindex");
        $pagesize = request_var("pagesize");
        $keyword = request_var("keyword");
        $keyword = urldecode($keyword);
        $sessionstr = request_var("sessionkey");
        $strexplode = explode("_", $sessionstr);
        $cursession = $strexplode[0];
        $userid = $strexplode[1];
        //验证sessionkey
        $check = CheckSessionKeys($cursession);
        if ($check) {
            $result = array();
            //验证菜单权限
            if (CheckMenuPriv($userid, "notify")) {
                $currindex = GetCurrPageIndex($pageindex, $pagesize);
                $UserInfor = array();
                $search = array();
                $search["NotifySubject"] = $keyword;
                $UserInfor["user_id"] = $userid;
                $notifyApi = new notify($UserInfor);
                //$notify_message = $notifyApi->getNotifyInfo($pagesize,$currindex,"",$search);
                $notify_message = $notifyApi->getNotifyLists($pagesize, $currindex, $search, array());
                $notify_counts = $notifyApi->getNotifyAmount($search);
                $page_count = GetSumPageCount($notify_counts, $pagesize);
                $curr_page = floor($currindex / $pagesize) + 1;
                $result["ishavepre"] = $currindex < $pagesize ? "0" : "1";
                $result["ishavenext"] = $curr_page < $page_count ? "1" : "0";
                $result["pageindex"] = $pageindex;
                $result["pagesize"] = $pagesize;
                $result["count"] = $notify_counts;
                $result["pagecount"] = $page_count;
                $i = 0;
                $notifysum = count($notify_message);
                if ($notifysum == 0) {
                    $result["list"] = array();
                } else {
                    foreach ($notify_message as $index => $val) {
                        $result["list"][$i]['id'] = $notify_message[$index]['NOTIFY_ID'];
                        $result["list"][$i]['subject'] = $notify_message[$index]['SUBJECT'];
                        $result["list"][$i]['time'] = $notify_message[$index]['SEND_TIME'];
                        $result["list"][$i]['description'] = $_lang["e_notify_take_effect_date"] . $notify_message[$index]['BEGIN_DATE'];
                        //判断已读、未读
                        if (strstr($notify_message[$index]['READERS'], $userid . ",")) {
                            //已读
                            $result["list"][$i]['isnew'] = "0";
                        } else {
                            //未读
                            $result["list"][$i]['isnew'] = "1";
                        }
                        $result["list"][$i]['image'] = IMG_PATH . "defautimg.png";
                        $i++;
                    }
                    if (count($result["list"]) == 0) {
                        $result["list"] = array();
                    }
                }
            } else {
                $result["list"] = array();
            }
            echo json_encode($result);
        } else {
            echo "{}";
        }
    }

    public function count() {
        $result = array();
        $sessionstr = request_var("sessionkey");
        $strexplode = explode("_", $sessionstr);
        $cursession = $strexplode[0];
        $userid = $strexplode[1];
        //验证sessionkey
        $check = CheckSessionKeys($cursession);
        if ($check) {
            //验证菜单权限
            if (CheckMenuPriv($userid, "notify")) {
                $UserInfor = array();
                $UserInfor["user_id"] = $userid;
                $notifyApi = new notify($UserInfor);
                $sumcounts = $notifyApi->getNotifyAmount(array());
                $uncounts = $notifyApi->getNewNotifyAmount();
            } else {
                $sumcounts = "0";
                $uncounts = "0";
            }
            $result["count"] = $sumcounts;
            $result["unread"] = $uncounts;
            echo json_encode($result);
        } else {
            echo "{}";
        }
    }

    public function view() {
        global $connection;
        global $_lang;
        $mobilekey = request_var("mobilesessionkey");
        $page = request_var("page");
        $module = request_var("module");
        $scope = request_var("scope");
        $detailid = intval(request_var("detailid"));
        $fromid = request_var("fromid");
        $sessionstr = request_var("sessionkey");
        $weiApi = request_var('weiApi');
        $strexplode = explode("_", $sessionstr);
        $userid = $strexplode[1];
        $NotifyId = $detailid;
        $UserInfor["user_id"] = $userid;
        /* 获取参数---END */

        $notifyApi = new notify($UserInfor);
        //更新公告阅读人员
        $notify_update_status = $notifyApi->updateReadStatus($NotifyId);

        // 钉钉和微信  公告详细
        if (strpos($_SERVER['HTTP_USER_AGENT'], 'DingTalk') !== false || strpos($_SERVER['HTTP_USER_AGENT'], 'MicroMessenger') !== false) {
            $notify_message = $notifyApi->getNotifyDataView("", "", $NotifyId, array());
        } else {
            $notify_message = $notifyApi->getNotifyInfo("", "", $NotifyId, array());
        }

        $notifyInfor = $notify_message[0];
        $sql = "SELECT
                  department.DEPT_NAME
                FROM USER
                  LEFT JOIN department
                    ON user.DEPT_ID = department.DEPT_ID
                WHERE user.USER_ID = '" . SecurityFilter($notifyInfor["FROM_ID"]) . "'";
        $rs = exequery($connection, $sql);
        if ($row = mysql_fetch_assoc($rs)) {
            $user_dept_name = $row["DEPT_NAME"];
        }
        if ($notifyInfor["NOTIFY_TYPE"] && $notifyInfor["NOTIFY_TYPE"] != 0) {
            $sql_type = "SELECT
                      NOTIFY_TYPE_NAME
                    FROM notify_type
                    WHERE NOTIFY_TYPE_ID = '" . SecurityFilter($notifyInfor["NOTIFY_TYPE"]) . "'";
            $type_rs = exequery($connection, $sql_type);
            $type_rows = mysql_fetch_array($type_rs);
            $type_name = $type_rows["NOTIFY_TYPE_NAME"];
        } else {
            $type_name = $_lang["e_notify_no_class"];
        }
        if ($notifyInfor["END_DATE"] == "0000-00-00") {
            $notify_endtime = "";
        } else {
            $notify_endtime = $notifyInfor["END_DATE"];
        }

        switch ($notifyInfor["PUBLIC"]) {
            case "1":
                $PUBLIC_STATE = "生效";
                break;
            case "2":
                $PUBLIC_STATE = "审核";
                break;
            case "0":
                $PUBLIC_STATE = "草稿";
                break;
            default:
                $PUBLIC_STATE = "";
                break;
        }

        $attachmentname = explode("*", $notifyInfor["ATTACHMENT_NAME"]);
        $attachmentid = explode(",", $notifyInfor["ATTACHMENT_ID"]);
        $attachurl = explode("*", $notifyInfor["ATTACHMENT_DIR"]);
        include_once(INCLUDE_APP_PATH . 'Notify/View/NotifyView.php');
    }

    public function create() {
        global $_lang;
        /* 获取参数----BEGIN */
        $mobilekey = $_REQUEST["mobilesessionkey"];
        $page = $_REQUEST["page"];
        $module = $_REQUEST["module"];
        $scope = $_REQUEST["scope"];
        $detailid = $_REQUEST["detailid"];
        $fromid = $_REQUEST["fromid"];
        $sessionstr = $_REQUEST["sessionkey"];
        $strexplode = explode("_", $sessionstr);
        $userid = $strexplode[1];

        $UserInfor = array();
        $UserInfor["user_id"] = $userid;

        $userarray = GetCurrUserPriv($userid);
        $GLOBALS['USER_FUNC_ID_STR'] = $userarray["FUNC_ID_STR"];
        $state = false;
        if (checkFuncPriv('321', $userarray["FUNC_ID_STR"])) {
            $state = true;
        }
        $array = checkReminds("1", $userarray["USER_PRIV"]);
        $sms_select = $array[0];
        $smstel_select = $array[1];
        $email_select = $array[2];
        $sms_modify = $array[3];
        $smstel_modify = $array[4];
        $email_modify = $array[5];
        include_once(INCLUDE_APP_PATH . 'Notify/View/CreateNotifyView.php');
    }

    public function createDo() {
        global $connection, $_lang;
        include_once ("api/email.class.php");
        include_once ("inc/mobile_sms.inc.php");
        /* 获取参数----BEGIN */
        $sessionstr = $_REQUEST["sessionkey"];
        $strexplode = explode("_", $sessionstr);
        $userid = $strexplode[1];
        $userarray = GetCurrUserPriv($userid);
        $GLOBALS['USER_FUNC_ID_STR'] = $userarray["FUNC_ID_STR"];
        $subject = SecurityFilter($_REQUEST["subject"]);
        $contents = SecurityFilter($_REQUEST["contents"]);
        $typeid = SecurityFilter($_REQUEST["typeid"]);
        $begindate = $_REQUEST["begindate"];
        $enddate = $_REQUEST["enddate"];
        $toid = SecurityFilter($_REQUEST["toid"]);
        $touser = SecurityFilter($_REQUEST["SelectUserID"]);
        $todept = SecurityFilter($_REQUEST["SelectDeptID"]);
        $topriv = SecurityFilter($_REQUEST["SelectPrivID"]);
        $public = SecurityFilter(request_var('public', 0));
        $sms = request_var("emobile_sms", 0);
        $email = request_var("emobile_email", 0);
        $tel = request_var("emobile_tel", 0);
        $curdate = date("Y-m-d", time());
        if ($begindate == "" || $begindate == 0) {
            $begindate = $curdate;
        }
        if ($enddate == "" || $enddate == 0) {
            $enddate = "0000-00-00";
        }
        if ($begindate > $curdate)
            $OPTIONSTATE = 0;
        if ($begindate <= $curdate)
            $OPTIONSTATE = 1;
        if ($enddate != "0000-00-00" && $enddate < $curdate)
            $OPTIONSTATE = 2;
        $file = request_var('upload_file', '');
        $fileName = request_var('file_name', 'default.tmp');
        $_fileName = fileNameToGBK($fileName);
        if (strtolower(substr($fileName, strrpos($fileName, '.'))) == '.jpeg') {
            $fileName = strtolower(substr($fileName, 0, strrpos($fileName, '.'))) . '.jpg';
        }

        if ($file) {
            /* ----- 微信上传start ----- */
            $attachmentId = request_var('attachmentId', '');
            /* ----- 微信上传end ----- */
            if ($attachmentId) {
                $attachid = $attachmentId;
            } else {

                $attachid = time();
                $targetPath = ROOT_PATH . 'attachment/' . $attachid . '/';
                if (!file_exists($targetPath)) {
                    mkdir($targetPath, 0777, true);
                }


                $temp = base64_decode($file);
                $FP = fopen($targetPath . $_fileName, "w");
                fwrite($FP, $temp);
                fclose($FP);
            }
        }
        if ($attachid) {
            $attachid = $attachid . ',';
            $fileName = $fileName . '*';
        } else {
            $attachid = '';
            $fileName = '';
        }
        //直接发布
        if ($toid == "0") {
            $query = "INSERT INTO notify (FROM_ID,DEPT_ID ,SUBJECT,CONTENT,SEND_TIME,BEGIN_DATE,END_DATE,ATTACHMENT_ID,ATTACHMENT_NAME,PUBLIC,SMS_REMIND,SMSTEL_REMIND,EMAIL_REMIND,OPTIONSTATE,NOTIFY_TYPE_ID) 
			values ('" . $userid . "','ALL_DEPT','" . $subject . "','" . $contents . "','" . date("Y-m-d H:i:s", time()) . "','" . $begindate . "','" . $enddate . "','" . $attachid . "','" . $fileName . "','$public','" . $sms . "','" . $tel . "','" . $email . "','" . $OPTIONSTATE . "','" . $typeid . "')";
        } else {
            $query = "INSERT INTO NOTIFY(FROM_ID,SUBJECT,DEPT_ID,PRIV_ID,USER_ID,CONTENT,SEND_TIME,BEGIN_DATE,END_DATE,ATTACHMENT_ID,ATTACHMENT_NAME,PUBLIC,SMS_REMIND,SMSTEL_REMIND,EMAIL_REMIND,OPTIONSTATE,NOTIFY_TYPE_ID) 
			values ('" . $userid . "','" . $subject . "','" . $todept . "','" . $topriv . "','" . $touser . "','" . $contents . "','" . date("Y-m-d H:i:s", time()) . "','" . $begindate . "','" . $enddate . "','" . $attachid . "','" . $fileName . "','$public','" . $sms . "','" . $tel . "','" . $email . "','" . $OPTIONSTATE . "','" . $typeid . "')";
        }
        exequery($connection, $query);
        $TABLE_ID = mysql_insert_id();
        //播报日志
        AddBroacastLog($userid, "notify", "NOTIFY_ID", $TABLE_ID, "SUBJECT", "new");
        $TABLE_NAME = "notify";
        //发送消息
        $SMS_CONTENT = $_lang["e_notify_see_notify"] . "->" . $_lang["e_notify_title"] . csubstr($subject, 0, 100);
        //生成查询语句
        if ($toid == "0") {
            $querysms = "SELECT USER_ID FROM user 
					WHERE DEPT_ID > 0";
        } else {
            $NOTIFY_USER_SMS = str_replace(",", "','", trim($touser, ","));
            $NOTIFY_DEPT_SMS = str_replace(",", "','", trim($todept, ","));
            $NOTIFY_PRIV_SMS = str_replace(",", "','", trim($topriv, ","));
            $querysms = "SELECT USER_ID FROM user 
						WHERE(USER_ID IN('" . SecurityFilter($NOTIFY_USER_SMS) . "') OR DEPT_ID IN ('" . SecurityFilter($NOTIFY_DEPT_SMS) . "') OR USER_PRIV IN ('" . SecurityFilter($NOTIFY_PRIV_SMS) . "')) 
						AND DEPT_ID > 0";
        }
        if ($sms == "1" && $OPTIONSTATE != "2" && $public != 0) {
            $cursorsms = exequery($connection, $querysms);
            $userIds = '';
            while ($ROW = mysql_fetch_array($cursorsms)) {
                $userIds .= $ROW["USER_ID"] . ',';
            }
            if ($userIds) {
                if (strtotime($begindate) > time()) {
                    sendSms($userid, $userIds, $SMS_CONTENT, 1, 1, $TABLE_NAME, $TABLE_ID, '', '', '', $begindate);
                } else {
                    sendSms($userid, $userIds, $SMS_CONTENT, 1, 1, $TABLE_NAME, $TABLE_ID);
                }
            }
        }
        if ($email == "1" && $OPTIONSTATE != "2" && $public != 0) {
            $email = new email();
            $cursoremail = exequery($connection, $querysms);
            while ($ROWs = mysql_fetch_array($cursoremail)) {
                $USER_ID = $ROWs["USER_ID"];
                $email->sendEmail($userid, $USER_ID, $USER_ID, $_lang["e_notify_see_notify"], $SMS_CONTENT, date("Y-m-d H:i:s", time()), '', '');
            }
        }
        if ($tel == "1" && $OPTIONSTATE != "2" && $public != 0) {
            $USER_ID_STRING = "";
            $cursortel = exequery($connection, $querysms);
            while ($ROWt = mysql_fetch_array($cursortel)) {
                $count++;
                $USER_ID_STRING .= $count == 1 ? $ROWt["USER_ID"] : "," . $ROWt["USER_ID"];
            }
            $newSms = new MobileSms();
            $newSms->SelfSendMore($USER_ID_STRING, $SMS_CONTENT, '', $userid);
        }
        include_once(INCLUDE_APP_PATH . 'Create/View/CreateSuccessView.php');
    }

    public function sourcePage() {

        global $_lang;
        $diff = $_REQUEST["pagediff"];
        $sessionstr = request_var('sessionkey');
        $title = "";
        $contents = "";
        $notifyid = request_var('notifyid');
        $userid = $_REQUEST["userid"];
        $UserInfor["user_id"] = $userid;
        $notifyApi = new notify($UserInfor);
        $notify_message = $notifyApi->getNotifyDataView("", "", $notifyid, array());
        $contents = $notify_message[0]["CONTENT"];
        $title = $_lang['emobile_common_root_ggyw'];



        include_once(INCLUDE_APP_PATH . 'Notify/View/sourcePage.php');
    }

}
