<?php
/**
 * @copyright (C) 2000 - 2014 Weaver Co.Ltd
 * @package   eoffice9.0
 * @name      webroot/E-mobile/App/Sms/SmsClass.php
 * @function  内部消息数据返回
 * @version   1.0
 * @author    lizhijun
 */
include_once ("inc/conn.php");
include_once ("api/sms.class.php");
include_once ("api/user.class.php");
include_once ("api/email.class.php");
include_once ("inc/oa_config.php");
include_once ("inc/mobile_sms.inc.php");
class SmsProxy{
    private $_pageSize = 15;
    private $_sessionkey;
    private $_userId;
    private $_cursession;
    private $_userImagePath = 'personal/';

    public function __construct() {
        $this->_sessionkey = request_var("sessionkey");
		$strexplode = explode("_",$this->_sessionkey);
		$this->_cursession = $strexplode[0];
		$this->_userId     = $strexplode[1];
    }
    /**
     * 内部消息处理中心
     */
    public function smsCenter(){
        global $connection;
        global $_lang;
        //验证sessionkey
	    $check      = CheckSessionKeys($this->_cursession);
        $userid     = $this->_userId;
        $sessionkey = $this->_sessionkey;

	    if($check){
                 $sessionstr =  $this->_sessionkey;
			//验证菜单权限
		if(CheckMenuPriv($userid,"sms")){
                $sessionUsers = $this->_getSessionUsers(0,$this->_pageSize);
                if($sessionUsers){
                    $sessionLists = $this->_getSessionLists($sessionUsers, $userid);
                }
                if($userid){
                    $sql         = "SELECT USER_NAME,AVATAR_TYPE FROM user WHERE USER_ID='".SecurityFilter($userid)."'";
                    $rs          = exequery($connection,$sql);
                    $row         = mysql_fetch_array($rs);
                    $userName    = $row['USER_NAME'];
                    $personImage = $this->_dealAtavar($row['AVATAR_TYPE'],$userid);
                }
                include_once(INCLUDE_APP_PATH . 'Sms/View/SmsCenterPanelView.php');
            }else{
                echo $_lang['e_sms_no_power'];
            }
        }else{
            echo 'session'.$_lang['e_sms_time_out'];
        }
    }
    /**
     * 获取更多会话列表
     */
    public function getMoreSessionList(){
        $userid = $this->_userId;
        $sessionstr =  $this->_sessionkey;
        $page = request_var('page',0);
        $sessionUsers = $this->_getSessionUsers($page*$this->_pageSize,$this->_pageSize);
        if(!$sessionUsers){
            echo 0;exit;
        }
        $sessionLists = $this->_getSessionLists($sessionUsers, $userid);
        echo json_encode($sessionLists);
    }
    /**
     * 根据用户名,姓名搜索
     */
    public function getSessionByUserName(){
        global $connection;
         $sessionstr =  $this->_sessionkey;
        $keyword = request_var('keyword');
        $toId     = $this->_userId;
        $keyword = SecurityFilter($keyword);
        $query = 'SELECT USER_ID,USER_NAME,AVATAR_TYPE FROM user WHERE DEPT_ID > 0 AND (USER_NAME LIKE \'%'.$keyword
                .'%\' OR USER_ACCOUNTS LIKE \'%'.$keyword.'%\' OR USER_NAME_PY LIKE \'%'.$keyword.'%\' OR USER_NAME_ZM =\''.$keyword.'\')';
        $result = exequery($connection,$query);
        $userLists = array();
        while($row = mysql_fetch_array($result,MYSQL_ASSOC)){
            $row['user_image']  = $this->_dealAtavar($row['AVATAR_TYPE'],$row['USER_ID']);
            $sessionInfo        = $this->_getLastSession($row['USER_ID'],$toId);
            $row['content']     = $sessionInfo['content'];
            $row['send_time']   = $sessionInfo['send_time'];
            $row['new_count'] = $this->_getUnreadCount($row['USER_ID'],$toId);
            $userLists[] = $row;
        }
        if(empty($userLists)){
            echo 0;exit;
        }
        echo json_encode($userLists);
    }
    /**
     * 获取会话列表
     */
    private function _getSessionLists($sessionUsers,$userid){
        $sessionLists = array();
        foreach($sessionUsers as $value){
            $sessionInfo = $this->_getLastSession($value['FROM_ID'],$userid);
            $value['content'] = $sessionInfo['content'];
            $value['send_time'] = $sessionInfo['send_time'];
            $value['new_count'] = $this->_getUnreadCount($value['FROM_ID'],$userid);
            $sessionLists[] = $value;
        }
        return $sessionLists;
    }
    /**
     * 获取会话的用户
     */
    private function _getSessionUsers($start,$pageSize){
        global $connection;
        $userid = $this->_userId;
        $query = 'SELECT u.USER_NAME,u.AVATAR_TYPE,s.FROM_ID ,MAX(s.SEND_TIME) as SEND_TIME FROM sms as s '
                . 'LEFT JOIN user as u ON s.FROM_ID = u.USER_ID '
                . 'WHERE s.TO_ID=\''.$userid.'\'  AND s.receive_del = 0 AND u.DEPT_ID > 0 GROUP BY s.FROM_ID ORDER BY SEND_TIME DESC LIMIT '.SecurityFilter($start).','.SecurityFilter($pageSize);
        $result = exequery($connection,$query);
        $users = array();
        while($row = mysql_fetch_array($result,MYSQL_ASSOC)){
            if($row['USER_NAME'] == NULL){
                continue;
            }
            $row['user_image'] = $this->_dealAtavar($row['AVATAR_TYPE'],$row['FROM_ID']);
            $users[] = $row;
        }
        return $users;
    }
    /**
     * 获取相应的会话详情列表
     * @global type $connection
     * @global type $ATTACH_PATH
     */
    public function getSessionDetails(){
        global $connection,$ATTACH_PATH;
        $page = request_var('page',0);
        $pageSize = $this->_pageSize;
        $start = $page*$pageSize;
        $toId = request_var('toId','');
        $fromId = request_var('fromId','');
        $toId = SecurityFilter($toId);
        $fromId = SecurityFilter($fromId);

         $sessionstr =  $this->_sessionkey;
        if($toId == '' || $fromId ==''){
            echo 0;exit;
        }
        $query = 'SELECT SMS_ID,CONTENT,SEND_TIME,TO_ID,FROM_ID,ATTACHMENT_ID,ATTACHMENT_NAME  FROM sms '
                    . 'WHERE ((FROM_ID =\''.$fromId.'\' AND TO_ID =\''.$toId.'\') OR'
                    . ' (FROM_ID =\''.$toId.'\' AND TO_ID =\''.$fromId.'\')) '
                    . ' AND SEND_TIME <= \''.date('Y-m-d H:i:s').'\'AND receive_del = 0 ORDER BY SEND_TIME DESC LIMIT '.$start.','.$pageSize;
        $result = exequery($connection,$query);
        $sessionDetailLists = array();
        while($row = mysql_fetch_array($result,MYSQL_ASSOC)){
            $query = 'UPDATE sms SET REMIND_FLAG = 0 WHERE SMS_ID='.$row['SMS_ID'];
            exequery($connection,$query);
            $row['SEND_TIME'] = $this->_dealDateTime($row['SEND_TIME']);
            $attachmentname = explode("*",$row["ATTACHMENT_NAME"]);
            $attachmentid   = explode(",",$row["ATTACHMENT_ID"]);
            $attachment = array();
            if(!empty($attachmentid)){
                foreach($attachmentid as $key => $value)
                {
                    $attachurl = $ATTACH_PATH.$value."/".$attachmentname[$key];
                    $attachtype = GetAttachType($attachurl);
                    $showtype   = GetAttachmentPrefix($attachurl);
                    $checkattchtype = EmobileCheckAttachType($attachurl);
                    $url        = '/attachment/'.$value."/".$attachmentname[$key];
                    $url        = GetNewUrlPath($url);
                    $checkfile = EmobileCheckFileExist($attachmentid[$key],$attachmentname[$key]);
                    if($checkfile && $checkattchtype){
                        $attachment[] = array(
                            'url' => $url,
                            'type'=> $attachtype,
                            'showtype' => $showtype,
                            'attachId'  => $attachmentid[$key],
                            'attachName'=> $attachmentname[$key],
                            'name'=>$attachmentname[$key],
                        );
                    }
                }
            }
            $row['attachment'] = $attachment;
            $sessionDetailLists[] = $row;
        }
        if(!empty($sessionDetailLists)){
            echo json_encode(array_reverse($sessionDetailLists));
        }else{
           echo 0;
        }
    }
    public function batchDelSms(){
        $toId = $this->_userId;
         $sessionstr =  $this->_sessionkey;
        $fromId = request_var('fromId');
        if(!$toId || !$fromId){
            echo 0;exit;
        }
        global $connection;
        $toId = SecurityFilter($toId);
        $fromId = SecurityFilter($fromId);
        $query = "DELETE FROM sms WHERE TO_ID = '$toId' AND FROM_ID = '$fromId'";
        if(exequery($connection,$query)){
            echo 1;exit;
        }
        echo 0;
    }

    public function delSms(){
         $sessionstr =  $this->_sessionkey;
        $smsId = intval(request_var('smsId'));
        if(!$smsId){
            echo 0;exit;
        }
        global $connection;
        $query = 'DELETE FROM sms WHERE SMS_ID='.SecurityFilter($smsId);
        if(exequery($connection,$query)){
            echo 1;exit;
        }
        echo 0;
    }
    public function sendToOther(){

        global $connection;
         $sessionstr =  $this->_sessionkey;
        $smsId  = intval(request_var('smsId'));
        $query  = "SELECT CONTENT,ATTACHMENT_ID,ATTACHMENT_NAME FROM sms WHERE SMS_ID=".SecurityFilter($smsId);
        $rs     =  exequery($connection,$query);
        $smsInfo= mysql_fetch_array($rs,MYSQL_ASSOC);
        $userId = request_var('userId');
        $userIdArray = explode(',', $userId);
        $Infor = array();
        $Infor["smstype"]    = "0";
        $Infor["content"]    = $smsInfo['CONTENT'];
        $Infor["sendtime"]   = date("Y-m-d H:i:s");
        $Infor["remindflag"] = "1";
        $Infor['attachid']   = $smsInfo['ATTACHMENT_ID'];
        $Infor['attachname'] = $smsInfo['ATTACHMENT_NAME'];
        $UserInfor = array();
        $UserInfor["user_id"] = $this->_userId;
        $smsApi = new sms($UserInfor);
        $errorUserId = '';
        $qyWechat = checkQyWeixinModule(true);
        $opt = array(
                'sourceType'=>0,
                'tableName'=>'',
                'sourceID'=>'',
                'fromID'=>$this->_userId,
                'copy'=>false
            );
        foreach($userIdArray as $key => $value){
            $Infor["toid"] = $value;
            $data =  $smsApi->sendSms($Infor);
            if(!$data){
                $errorUserId .= $value . ',';
            }
        }
		sendMobileSms($userId,$Infor["content"]);
        if($qyWechat){


            $uids = str_replace(',', '|', trim($userId, ','));
            //sendQYMp($qyWechat,$userId, $Infor["content"],$opt);
            sendQYMpNews($qyWechat,$uids,$Infor["content"]);
        }

        $wechat = checkWeixinModule();
        $dingtalk = checkDingTalkModule(true);
$toar =explode(",",$userId);
while(list($key,$var) = each($toar)){

	if($var != ""){
		$sql = "
			INSERT INTO sms
			(FROM_ID,TO_ID,SMS_TYPE,CONTENT,SEND_TIME,REMIND_FLAG,ATTACHMENT_ID,ATTACHMENT_NAME)
			VALUES
			('".SecurityFilter($UserInfor["user_id"])."','".SecurityFilter($var)."',0,'".SecurityFilter($Infor["content"])."','".SecurityFilter($Infor["sendtime"])."',1,'".SecurityFilter($Infor['attachid'])."','".SecurityFilter($Infor['attachname'])."')";
		exequery($connection,$sql);

		if($wechat){
			sendMp($wechat, $var, $Infor["content"], array('fromID'=>$UserInfor["user_id"]));
		}

	}
}


        if($errorUserId == ''){
            echo 1;exit;
        }
        echo $errorUserId;
    }
    /**
     * 发送消息
     */
    public function sendSms(){
        $toId = request_var('toId', '');
        $fromId = request_var('fromId', '');
        $content = request_var('send_content');
        $fileSize = request_var('file_size', 0);
        $attachmentId = '';
        $attachmentName = '';
        $sessionstr = $this->_sessionkey;

        if ($fileSize) {
            for ($i = 1; $i <= $fileSize; $i++) {
                $attachid = time();
                $targetPath = ROOT_PATH . 'attachment/' . $attachid . '/';
                if (!file_exists($targetPath)) {
                    mkdir($targetPath, 0777, true);
                }
                $file = request_var('upload_file_' . $i, '');
                $fileName = request_var('file_name_' . $i, 'default.tmp');
                $_fileName = fileNameToGBK($fileName);
                $temp = base64_decode($file);
                $FP = fopen($targetPath . $_fileName, "w");
                fwrite($FP, $temp);
                fclose($FP);
                $attachmentId .= $attachid . ',';
                $attachmentName .= $fileName . '*';
            }
        }
        $Infor = array();
        $Infor["toid"] = $toId;
        $Infor["smstype"] = "0";
        $Infor["content"] = $content;
        $Infor["sendtime"] = date("Y-m-d H:i:s");
        $Infor["remindflag"] = "1";
        $Infor['attachid'] = $attachmentId;
        $Infor['attachname'] = $attachmentName;
        $UserInfor = array();
        $UserInfor["user_id"] = $fromId;
        $smsApi = new sms($UserInfor);
        $data = $smsApi->sendSms($Infor);
        if ($data) {
            sendMobileSms($toId, $content);
            $qyWechat = checkQyWeixinModule(true);
            $opt = array(
                'sourceType' => 0,
                'tableName' => '',
                'sourceID' => '',
                'fromID' => $fromId,
                'copy' => false
            );
            $uids = str_replace(',', '|', trim($toId, ','));
            if($qyWechat) {
                sendQYMpNews($qyWechat, $uids, $content);
            }
            $wechat = checkWeixinModule();
            $dingtalk = checkDingTalkModule(true);
            $toar = explode(",", $toId);
            while (list($key, $var) = each($toar)) {

                if ($var != "") {
                    $sql = "
			INSERT INTO sms
			(FROM_ID,TO_ID,SMS_TYPE,CONTENT,SEND_TIME,REMIND_FLAG,ATTACHMENT_ID,ATTACHMENT_NAME)
			VALUES
			('" . SecurityFilter($fromId) . "','" . SecurityFilter($var) . "',0,'" . SecurityFilter($content) . "','" . SecurityFilter($Infor["sendtime"]) . "',1,'" . SecurityFilter($Infor['attachid']) . "','" . SecurityFilter($Infor['attachname']) . "')";
                    exequery($connection, $sql);

                    if ($wechat) {
                        sendMp($wechat, $var, $content, array('fromID' => $fromId));
                    }

                    if ($dingtalk) {
                        sendDingTalk($dingtalk, $var, $content, array('fromID' => $fromId));
                    }
                }
            }

            // sendQYMp($qyWechat,$toId, $content,$opt);
            echo 1;
        } else {
            echo 0;
        }
    }
    /**
     * 获取部门列表
     */
    public function getDeptLists(){
        global $connection;
         $sessionstr =  $this->_sessionkey;
        $query = 'SELECT DEPT_ID,DEPT_NAME,DEPT_NO FROM department ORDER BY DEPT_NO';
        $result = exequery($connection,$query);
        $deptLists = array();
        while($row = mysql_fetch_array($result,MYSQL_ASSOC)){
            $queryUser = 'SELECT count(USER_ID) as count FROM user WHERE DEPT_ID = '.SecurityFilter($row['DEPT_ID']);
            $resultuser = exequery($connection,$queryUser);
            $rowuser = mysql_fetch_array($resultuser,MYSQL_ASSOC);
            if($rowuser){
                $count = $rowuser['count'];
            }else{
                $count = 0;
            }
            $row['userCount'] = $count;
            $deptLists[] = $row;
        }
        if(empty($deptLists)){
            echo 0;exit;
        }
        echo json_encode($deptLists);
    }
    /**
     * 按用户获取会话
     */
    public function getUserListByDept(){
        global $connection;
        $deptId = request_var('deptId');
        $toId     = $this->_userId;
         $sessionstr =  $this->_sessionkey;
        $query = 'SELECT USER_ID,USER_NAME,AVATAR_TYPE FROM user WHERE DEPT_ID='.SecurityFilter($deptId);
        $result = exequery($connection,$query);
        $userLists = array();
        while($row = mysql_fetch_array($result,MYSQL_ASSOC)){
            $row['user_image']  = $this->_dealAtavar($row['AVATAR_TYPE'],$row['USER_ID']);
            $sessionInfo        = $this->_getLastSession($row['USER_ID'],$toId);
            $row['content']     = $sessionInfo['content'];
            $row['send_time']   = $sessionInfo['send_time'];
            $row['new_count'] = $this->_getUnreadCount($row['USER_ID'],$toId);
            $userLists[] = $row;
        }
        if(empty($userLists)){
            echo 0;exit;
        }
        echo json_encode($userLists);
    }
    /**
     * 获取用户对于的头像
     * @global type $ATTACH_PATH
     * @param type $avatarType
     * @param type $userId
     * @return string
     */
    private function _dealAtavar($avatarType,$userId){
        global $ATTACH_PATH;
        if(!$avatarType){
            $avatar_type = '.png';
        }else{
            $avatar_type = $avatarType;
        }
        $personImage = $ATTACH_PATH.$this->_userImagePath .$userId. '/avatar_40' . $avatar_type;
        if(!file_exists($personImage)){
            $imagePath = IMG_PATH . "default_user.png";
        }else{
            $imagePath = '/attachment/'.$this->_userImagePath .$userId. '/avatar_40' . $avatar_type;
        }
        return $imagePath;
    }
    /**
     * 获取与该用户的最后一条会话
     * @global type $connection
     * @param type $fromId
     * @param type $toId
     * @return string
     */
    private function _getLastSession($fromId,$toId){
        global $connection;
        global $_lang;
        $querySession = 'SELECT CONTENT,SEND_TIME  FROM sms '
                . 'WHERE FROM_ID =\''.$fromId.'\' AND SEND_TIME <= \''.date('Y-m-d H:i:s').'\'AND receive_del = 0 AND TO_ID =\''.SecurityFilter($toId).'\' '
                . 'ORDER BY SEND_TIME DESC LIMIT 0,1';
        $resultSession = exequery($connection,$querySession);
        if($resultSession){
            $rowSession = mysql_fetch_array($resultSession,MYSQL_ASSOC);
            if($rowSession['CONTENT'] == null){
                $row['content'] = $_lang['e_sms_no_message'];
            }else{
                $row['content'] =  substrGB($rowSession['CONTENT'],14,'...');
            }
            if($rowSession['SEND_TIME'] == ''){
                $row['send_time'] = '';
            }else{
                $sendTime = $this->_dealDateTime($rowSession['SEND_TIME']);
                $row['send_time'] = $sendTime;
            }
        }else{
            $row['content'] = '';
            $row['send_time'] = '';
        }
        return $row;
    }
    /**
     * 获取未读消息条数
     * @global type $connection
     * @param type $fromId
     * @param type $toId
     * @return int
     */
    private function _getUnreadCount($fromId,$toId){
        global $connection;
        $query = 'SELECT count(SMS_ID) as new_count FROM sms '
                . 'WHERE FROM_ID =\''.SecurityFilter($fromId).'\' AND SEND_TIME <= \''.date('Y-m-d H:i:s').'\'AND receive_del = 0 AND TO_ID =\''.SecurityFilter($toId).'\' AND REMIND_FLAG = 1';
        $result = exequery($connection,$query);
        if($result){
            $row = mysql_fetch_array($result,MYSQL_ASSOC);
            $new_count = $row['new_count'];
        }else{
            $new_count = 0;
        }
        return $new_count;
    }
    public  function upateUnreadSms(){
        global $connection;
         $sessionstr =  $this->_sessionkey;
        $fromId = request_var('fromId');
        $toId   = request_var('toId');
        $query = 'UPDATE sms SET REMIND_FLAG = 0 '
                . 'WHERE FROM_ID =\''.SecurityFilter($fromId).'\' AND receive_del = 0 AND TO_ID =\''.SecurityFilter($toId).'\' AND REMIND_FLAG = 1';
        $result = exequery($connection,$query);
        if($result){
            echo 1;exit;
        }
        echo 0;
    }
    /**
     * 日期时间处理方法
     * @param type $inDate
     * @return string
     */
    private function _dealDateTime($inDate){
        global $_lang;
        $time = substr($inDate,  strpos($inDate, ' '));
        $date = date('Y-m-d',strtotime($inDate));
        if($date == date('Y-m-d')){
            $date = '<span style="color:#75BF26;">'.$_lang['e_sms_today'].$time.'</span>';
        }else if($date == date('Y-m-d',strtotime("-1 day"))){
            $date = '<span style="color:#FFA20E;">'.$_lang['e_sms_yesterday'].$time.'</span>';
        }else if($date == date('Y-m-d',strtotime("-2 day"))){
            $date = '<span style="color:#FFA20E;">'.$_lang['e_sms_before_yesterday'].$time.'</span>';
        }else if($date == date('Y-m-d',strtotime("-3 day"))){
            $date = '<span style="color:#FFA20E;">'.$_lang['e_sms_three_days_ago'].$time.'</span>';
        }
        return $date;
    }
    public function create(){
        global $_lang;
        /*获取参数----BEGIN*/

         $sessionstr =  $this->_sessionkey;
        $strexplode = explode("_",$sessionstr);
        $userid     = $strexplode[1];
        $UserInfor  = array();
        $UserInfor["user_id"] = $userid;

        $userarray        = GetCurrUserPriv($userid);
        $array            = checkReminds("4",$userarray["USER_PRIV"]);
        $GLOBALS['USER_FUNC_ID_STR'] = $userarray["FUNC_ID_STR"];
        $sms_select       = $array[0];
        $smstel_select    = $array[1];
        $email_select     = $array[2];
        $sms_modify       = $array[3];
        $smstel_modify    = $array[4];
        $email_modify     = $array[5];
        include_once(INCLUDE_APP_PATH . 'Sms/View/CreateSmsView.php');
    }

    public function createDo(){
        global $connection;
        global $_lang;
        /* 获取参数----BEGIN */
        $sessionstr = request_var("sessionkey", '');
        $strexplode = explode("_", $sessionstr);
        $userid = $strexplode[1];
        $userarray = GetCurrUserPriv($userid);
        $GLOBALS['USER_FUNC_ID_STR'] = $userarray["FUNC_ID_STR"];
        $contents = request_var("contents", '');
        $toid = request_var("SelectUserID", '');
        $begindate = request_var("begindate", '');
        $begintime = request_var("begintime", '');
        $curname = request_var("curname", '');
        $email = request_var("emobile_email", 0);
        $tel = request_var("emobile_tel", 0);
        $weiApi = request_var('weiApi', 0);
        $curdate = date("Y-m-d", time());
        $senddate = "";
        if (($begindate == "" && $begintime == "") || ($begindate == 0 && $begintime == 0)) {
            $senddate = date("Y-m-d H:i:s", time());
        } else {
            $senddate = $begindate . " " . $begintime;
        }
        $file = request_var('upload_file', '');
        $fileName = request_var('file_name', 'default.tmp');
        $_fileName = fileNameToGBK($fileName);
        if (strtolower(substr($fileName, strrpos($fileName, '.'))) == '.jpeg') {
            $fileName = strtolower(substr($fileName, 0, strrpos($fileName, '.'))) . '.jpg';
        }
        if ($file) {
            $attachmentId = request_var('attachmentId', '');
            /* ----- 微信上传end ----- */
            if ($attachmentId) {
                $attachid = $attachmentId;
            } else {

                $attachid = time();
                $targetPath = ROOT_PATH . 'attachment/' . $attachid . '/';
                if (!file_exists($targetPath)) {
                    mkdir($targetPath, 0777, true);
                }


                $temp = base64_decode($file);
                $FP = fopen($targetPath . $_fileName, "w");
                fwrite($FP, $temp);
                fclose($FP);
            }
        }
        if ($attachid) {
            $attachid = $attachid . ',';
            $fileName = $fileName . '*';
        } else {
            $attachid = '';
            $fileName = '';
        }
        $toar = explode(",", $toid);
        $wechat = checkWeixinModule();
        $dingtalk = checkDingTalkModule(true);
        while (list($key, $var) = each($toar)) {
            if ($var != "") {
                $sql = "INSERT INTO sms
					(FROM_ID,TO_ID,SMS_TYPE,CONTENT,SEND_TIME,REMIND_FLAG,ATTACHMENT_ID,ATTACHMENT_NAME)
					VALUES
					('" . SecurityFilter($userid) . "','" . SecurityFilter($var) . "',0,'" . SecurityFilter($contents) . "','" . SecurityFilter($senddate) . "',1,'" . SecurityFilter($attachid) . "','" . SecurityFilter($fileName) . "')";
                exequery($connection, $sql);
                if ($wechat) {
                    sendMp($wechat, $var, $contents, array('fromID' => $userid));
                }

                if ($dingtalk) {
                    sendDingTalk($dingtalk, $var, $contents, array('fromID' => $userid));
                }
            }
        }
        $content = $_lang['e_sms_new_message'];
        sendMobileSms($toid, $content);
        $qyWechat = checkQyWeixinModule(true);
        $opt = array(
            'sourceType' => 0,
            'tableName' => '',
            'sourceID' => '',
            'fromID' => $userid,
            'copy' => false
        );
        if ($qyWechat) {

            $uids = str_replace(',', '|', trim($toid, ','));
            sendQYMpNews($qyWechat, $uids, $contents);
//            sendQYMp($qyWechat,$toid, $contents,$opt);
        }
        if ($begindate == "" && $begintime == "" || (!$begindate && !$begintime)) {
            if ($tel == 1) {
                $newSms = new MobileSms();
                $newSms->SelfSendMore($toid, $contents . "--" . $curname, '', $userid);
            }
            if ($email == 1) {
                $email = new email();
                $USER_ID = explode(',', $toid);
                for ($i = 0; $i < count($USER_ID); $i++) {
                    if ($USER_ID[$i] != "") {
                        $email->sendEmail($userid, $USER_ID[$i], $USER_ID[$i], $_lang['e_sms_email_remind'], $contents, date("Y-m-d H:i:s", time()), '', '');
                    }
                }
            }
        }
        include_once(INCLUDE_APP_PATH . 'Create/View/CreateSuccessView.php');
    }
}
