<?php

/**
 * @copyright (C) 2014 - 2015 Weaver Co.Ltd
 * @package   eoffice9.0
 * @name      webroot/E-mobile/App/weixin/WeiServiceApi.php
 * @function  微信服务开放接口      
 * @version   1.0 
 * @author    lizj
 */
include_once('E-mobile/constant.php'); //引入定义全局常量文件。
include_once("inc/conn.php"); //引入数据库连接文件
include_once("inc/utility_all.php"); //引入公共函数文件。
include_once 'inc/AppGlobal.php';
//include_once('inc/CheckAppVerfy.php'); //引入授权
include_once 'general/weixin/wechat.php';
include_once 'general/qyweixin/qywechat.php';
include_once("lang/" . LOGIN_LANG . "/emobile.lang.php");
$WeiServiceApi = WeiServiceApi::getInstance();
$method = request_var('a', 'start');
$WeiServiceApi->$method();

class WeiServiceApi {

    private static $_instance; //保存类实例的静态对象变量
    private static $_config; //接口配置数组

    /**
     * 构造方法私有化
     */

    private function __construct() {
        @session_start();

        if (!isset(self::$_config)) {
            self::$_config = include(INCLUDE_APP_PATH . 'Weixin/Config/config.php'); //加载配置文件
        }
    }

    /**
     * 创建__clone方法防止对象被复制克隆
     */
    private function __clone() {
        trigger_error('Clone is not allow!', E_USER_ERROR);
    }

    public function other() {
        global $_lang, $connection;
        $userAccounts = request_var('user', '');
        $stauts = request_var('status', 0);
        if ($stauts == '') {
            $this->errorPage('401', '不允许访问');
        }
        if ($userAccounts == '') {
            $this->errorPage('403', '用户账号为空');
        }

        if (!$userInfo = $this->checkUserByAccounts($userAccounts)) {
            $this->errorPage('403', '用户账号错误');
        }
        $_SESSION['USER_NAME'] = $userInfo['USER_NAME'];
        $_SESSION['AVATAR_TYPE'] = $userInfo['AVATAR_TYPE'];
        $sessionkey = session_id();
        $sessionkey = $sessionkey . '_' . $userInfo['USER_ID'];
        //获取权限 --- start
        $user_priv = $userInfo['USER_PRIV'];
        $user_priv_str = $this->systemAuth($user_priv);


        if (!file_exists(UTH_TMP_PATH . "auth/verify_pc.inc")) {
            include_once("inc/module_verify_file.php");
        }

        $arr = json_decode(file_get_contents(UTH_TMP_PATH . "auth/verify_pc.inc"), true);

        $time = time();
        if (abs($time - $arr[1]['time']) > 86399) {
            include_once("inc/module_verify_file.php");
            $arr = json_decode(file_get_contents(UTH_TMP_PATH . "auth/verify_pc.inc"), true);
        }

        $arr2 = explode(",", $user_priv_str);
        $funcIDStr = array_diff($arr2, $arr[0]); //数组
        $this->autoLogin($sessionkey, $funcIDStr);
    }

    private function checkUserByAccounts($userAccounts) {
        global $connection;
        $query = 'SELECT * FROM user WHERE user_accounts=\'' . $userAccounts . '\'';
        $cursor = exequery($connection, $query);
        $row = mysql_fetch_array($cursor);
        if ($row) {
            return $row;
        }
        return false;
    }

    /**
     * 单例方法,用于访问实例的公共的静态方法
     */
    public static function getInstance() {
        if (!(self::$_instance instanceof self)) {
            self::$_instance = new self;
        }
        return self::$_instance;
    }

    /**
     * 微信端调用emobile开始方法。
     */
    public function start() {

        global $_lang;
        $_userId = request_var('uid', '');

        if ($_userId == '') {
            $this->errorPage('Error', $_lang['emobile_weixin_weixin_sp_error_emptyId']);
        }


        $type = request_var('type', 0); //获取初始化类型
        
        //钉钉访问时 传递过来的参数为uid 不加密 -- android报错修改 ------- start -------
        if (in_array($type, array(4, 5, 6))) {
            $userId = $_userId;
        } else { // ------ end -----------
            if ($type == 3) {

                if (strpos($_SERVER['HTTP_USER_AGENT'], 'MicroMessenger') !== false) {

                    if (isset($_SESSION["wexin_openid"]) && isset($_SESSION["wexin_uid"]) && $_SESSION["wexin_openid"] && $_SESSION["wexin_uid"]) {
                        $_GET["uid"] = $_SESSION["wexin_uid"];
                        $_GET["openid"] = $_SESSION["wexin_openid"];
                    } else {
                        //重新获取code->用户
                        require_once("E-mobile/App/Weixin/WeixinAuth.php");
                        $userID = encrypt2($userInfo['uid'], 'E', 'eoffice');
                        $_SESSION["wexin_uid"] = $userID;
                        $_SESSION["wexin_openid"] = $openid;
                        $_GET["uid"] = $userID;
                        $_GET["openid"] = $openid;
                    }
                } else {
                    $this->errorPage('Error', "请在微信端打开");
                    return false;
                }
            }

            $_userId = str_replace(' ', '+', $_userId);
            $key = self::$_config['encryptKey']; //加密key
            $userId = encrypt2($_userId, 'D', $key); //用户ID解密
        }

        $sessionkey = "";

        if ($userInfo = $this->userCheck($userId)) {
            $_SESSION['USER_NAME'] = $userInfo['USER_NAME'];
            $_SESSION['AVATAR_TYPE'] = $userInfo['AVATAR_TYPE'];

            //获取权限 --- start
            $user_priv = $userInfo['USER_PRIV'];
            $user_priv_str = $this->systemAuth($user_priv);


            if (!file_exists(UTH_TMP_PATH . "auth/verify_pc.inc")) {
                include_once("inc/module_verify_file.php");
            }

            $arr = json_decode(file_get_contents(UTH_TMP_PATH . "auth/verify_pc.inc"), true);

            $time = time();
            if (abs($time - $arr[1]['time']) > 86399) {
                include_once("inc/module_verify_file.php");
                $arr = json_decode(file_get_contents(UTH_TMP_PATH . "auth/verify_pc.inc"), true);
            }

            $arr2 = explode(",", $user_priv_str);
            $funcIDStr = array_diff($arr2, $arr[0]); //数组
            //注册
            $sessionkey = session_id();
            $sessionkey = $sessionkey . '_' . $userId;
            $_SESSION["sessionkey_auth"] = $sessionkey;

            $m = request_var('m', 0); //获取模块

            switch ($type) {
                case 1:
                    $this->enterpriseInit($sessionkey, $m);
                    break;
                case 2:
                    $this->hnysjyInit($sessionkey, $m);
                    break;
                case 3:
                    $this->autoLogin($sessionkey, $funcIDStr);
                    break;
                case 4:
                    $this->dingTalk($sessionkey, $funcIDStr);
                    break;
                case 5:
                    $this->workWechat($sessionkey, $m);
                    break;
                case 6:
                    $this->dingTalkHome($sessionkey, $funcIDStr, $type);
                    break;
                case 0:
                    $this->errorPage('500', $_lang['emobile_weixin_weixin_sp_undefind_init']);
                    break;
            }
        } else {
            $this->errorPage('Error', $_lang['emobile_weixin_weixin_sp_error_id']);
        }
    }

    /**
     * 微信企业号初始化
     * @param type $sessionkey
     * @param type $m
     */
    private function enterpriseInit($sessionkey, $m) {
        //增加授权
        global $_lang;
        $nn = $m; // 我的邮件 $nn -- 邮件中心

        $qyWechat = new qyWechat();
        $wxCode1 = CheckAPP(107); // 企业号权限

        if ($wxCode1 != 1) {
            switch ($wxCode1) {
                case -1:
                    $msg1 = $_lang['emobile_weixin_weixin_sp_auth_1'];
                    break;
                case -2:
                    $msg1 = $_lang['emobile_weixin_weixin_sp_auth_2'];
                    break;
                case -3:
                    $msg1 = $_lang['emobile_weixin_weixin_sp_auth_3'];
                    break;
                case -4:
                    $msg1 = $_lang['emobile_weixin_weixin_sp_auth_4'];
                    break;
                default:
                    $msg1 = $_lang['emobile_weixin_weixin_sp_auth_5'] . $wxCode1;
                    break;
            }

            $this->errorPage('Error', $msg1);
            exit;
        }




        $funcid = self::$_config['VerfyMenuArray'][$nn];



        $wxCode = CheckAPP($funcid);

        if ($wxCode == 1) {
            $m = self::$_config['lists'][$m];

            if ($m == '') {
                $this->errorPage('Error', $_lang['emobile_weixin_weixin_sp_nolist']);
            }
            header('Location:/E-mobile/App/Init.php?weiApi=1&sessionkey=' . $sessionkey . '&m=' . $m);
        } else {
            switch ($wxCode) {
                case -1:
                    $msg = $_lang['emobile_weixin_weixin_sp_auth_1'];
                    break;
                case -2:
                    $msg = $_lang['emobile_weixin_weixin_sp_auth_2'];
                    break;
                case -3:
                    $msg = $_lang['emobile_weixin_weixin_sp_auth_3'];
                    break;
                case -4:
                    $msg = $_lang['emobile_weixin_weixin_sp_auth_4'];
                    break;
                default:
                    $msg = $_lang['emobile_weixin_weixin_sp_auth_5'] . $wxCode;
                    break;
            }

            $this->errorPage('Error', $msg);
        }
    }

     /**
     * 企业微信初始化
     * @param type $sessionkey
     * @param type $m
     */
    private function workWechat($sessionkey, $m) {
        //增加授权
        global $_lang;
        $nn = $m; // 我的邮件 $nn -- 邮件中心
        $funcid = self::$_config['VerfyMenuArray'][$nn];
        $wxCode = CheckAPP($funcid);

        if ($wxCode == 1) {
            $m = self::$_config['lists'][$m];

            if ($m == '') {
                $this->errorPage('Error', $_lang['emobile_weixin_weixin_sp_nolist']);
            }
            header('Location:/E-mobile/App/Init.php?weiApi=1&sessionkey=' . $sessionkey . '&m=' . $m);
        } else {
            switch ($wxCode) {
                case -1:
                    $msg = $_lang['emobile_weixin_weixin_sp_auth_1'];
                    break;
                case -2:
                    $msg = $_lang['emobile_weixin_weixin_sp_auth_2'];
                    break;
                case -3:
                    $msg = $_lang['emobile_weixin_weixin_sp_auth_3'];
                    break;
                case -4:
                    $msg = $_lang['emobile_weixin_weixin_sp_auth_4'];
                    break;
                default:
                    $msg = $_lang['emobile_weixin_weixin_sp_auth_5'] . $wxCode;
                    break;
            }

            $this->errorPage('Error', $msg);
        }
    }

    /**
     * 微信公众号初始化
     * @param type $sessionkey
     * @param type $m
     */
    private function hnysjyInit($sessionkey, $m) {
        global $_lang;
        $wechat = new wechat();
        $id = request_var('id');
        if ($id == 0) {
            $this->errorPage('500', $_lang['emobile_weixin_weixin_sp_error_argu']);
        }

        //邮件推送 走inbox
        $str = "";
        if ($m == 4) {
            $str = "&type=inbox";
        }

        $idKey = self::$_config['idKey'][$m];
        $m = self::$_config['view'][$m];
        if ($m == '') {
            $this->errorPage('500', $_lang['emobile_weixin_weixin_sp_error_infolose']);
        }
        header('Location:/E-mobile/App/Init.php?weiApi=1&sessionkey=' . $sessionkey . '&m=' . $m . '&' . $idKey . '=' . $id . $str);
    }

    /**
     * 
     */
    public function autoLogin($sessionkey = '', $funcIDStr) {
        global $_lang;
        global $ATTACH_PATH;
        if ($sessionkey == '') {
            $sessionkey = request_var('sessionkey');
        }
        $func_id_str = $funcIDStr;
        $strexplode = explode("_", $sessionkey);
        $cursession = $strexplode[0];
        $userId = $strexplode[1];
        if (!CheckSessionKeys($cursession)) {
            $this->errorPage('err', $_lang['emobile_weixin_weixin_sp_error_login']);
        }
        $openId = request_var('openid', '');
        if ($openId != '') {
            if (!$this->checkOpenId($openId, $userId)) {
                $this->errorPage('err', $_lang['emobile_weixin_weixin_sp_no_userOA']);
            }
        }
        $USER_NAME = $_SESSION['USER_NAME'];
        $avatar_type = $_SESSION['AVATAR_TYPE'];
        if (!$avatar_type) {
            $avatar_type = '.png';
        }
        if (file_exists($ATTACH_PATH . "/personal/" . $userId . "/avatar_80" . $avatar_type)) {
            $userPic = "/attachment/personal/" . $userId . "/avatar_80" . $avatar_type;
        } else {
            $userPic = '/E-mobile/Public/images/user_info.png';
        }
        $flowMenus = array(
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_dblc'],
                'img' => 'daichuli.png',
                'url' => 'weiLists_ToDo_Flow',
                'funcid' => '3',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_yblc'],
                'img' => 'yichuliliucheng.png',
                'url' => 'weiLists_HaveDone_Flow',
                'funcid' => '252',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_bjlc'],
                'img' => 'jieshuliucheng.png',
                'url' => 'weiLists_Done_Flow',
                'funcid' => '323',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_wdqq'],
                'img' => 'wodeqingqiu.png',
                'url' => 'weiLists_Request_Flow',
                'funcid' => '420',
            )
        );
        $otherMenus = array(
            array(
                'title' => $_lang['e_flow_copy_flow'],
                'img' => 'copy_flow.png',
                'url' => 'weiLists_Copy_Flow',
                'funcid' => '377',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_xwzz'],
                'img' => 'xinwenzhongxin.png',
                'url' => 'weiLists_New',
                'funcid' => '130',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_ggzz'],
                'img' => 'gonggaozhongxin.png',
                'url' => 'weiLists_Notify',
                'funcid' => '131',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_wdzz'],
                'img' => 'mydocument.png',
                'url' => 'docCenter_Doc',
                'funcid' => '8',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_khzz'],
                'img' => 'kehuzhognxin.png',
                'url' => 'crmCenter_Crm',
                'funcid' => '44',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_wdrc'],
                'img' => 'calendar.png',
                'url' => 'viewUpdate_Calendar',
                'funcid' => '141',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_wdxz'],
                'img' => 'xiezuozhongxin.png',
                'url' => 'lists_Coop',
                'funcid' => '363',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_wdwb'],
                'img' => 'weibo.png',
                'url' => 'view_Diary',
                'funcid' => '184',
            ),
            array(
                'title' => '我的会议',
                'img' => 'meeting.png',
                'url' => 'lists_Meeting',
                'funcid' => '702',
            ),
            array(
                'title' => '我的工资单',
                'img' => 'gongzi.png',
                'url' => 'salaryList_Salary',
                'funcid' => '319',
            ),
            array(
                'title' => '签到签退',
                'img' => 'signInOut.png',
                'url' => 'weixinSign_Sign',
                'funcid' => '32',
            ),
            array(
                'title' => '外勤签到',
                'img' => 'outSign.png',
                'url' => 'weixinOutSign_Sign',
                'funcid' => '32',
            ),
            array(
                'title' => '考勤记录',
                'img' => 'signlist.png',
                'url' => 'attendanceList_Sign',
                'funcid' => '17',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_nbxx'],
                'img' => 'neibuxiaoxi.png',
                'url' => 'smsCenter_Sms',
                'funcid' => '13',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_nbyj'],
                'img' => 'email.png',
                'url' => 'emailBox_Email',
                'funcid' => '12',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_txl'],
                'img' => 'maillist.png',
                'url' => 'lists_Addr',
                'funcid' => '216',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_xjzz'],
                'img' => 'buildingcenter.png',
                'url' => 'all_Create',
                'funcid' => '',
            ),
        );
        $PAGE_TITLE = $_lang['emobile_weixin_weixin_sp_mobile_page'];
        include(INCLUDE_APP_PATH . 'Weixin/View/WeiControlPanelView.php');
    }

    /**
     * 钉钉接入 走微信一样配置信息
     */
    public function dingTalk($sessionkey = '', $funcIDStr) {
        global $_lang;
        global $ATTACH_PATH;

        $strexplode = explode("_", $sessionkey);
        $cursession = $strexplode[0];
        $userId = $strexplode[1];
        $func_id_str = $funcIDStr;
        if (!CheckSessionKeys($cursession)) {
            $this->errorPage('err', $_lang['emobile_weixin_weixin_sp_error_login']);
        }

        $USER_NAME = $_SESSION['USER_NAME'];
        $avatar_type = $_SESSION['AVATAR_TYPE'];
        if (!$avatar_type) {
            $avatar_type = '.png';
        }
        if (file_exists($ATTACH_PATH . "/personal/" . $userId . "/avatar_80" . $avatar_type)) {
            $userPic = "/attachment/personal/" . $userId . "/avatar_80" . $avatar_type;
        } else {
            $userPic = '/E-mobile/Public/images/user_info.png';
        }

        $flowMenus = array(
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_dblc'],
                'img' => 'daichuli.png',
                'url' => 'weiLists_ToDo_Flow',
                'funcid' => '3',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_yblc'],
                'img' => 'yichuliliucheng.png',
                'url' => 'weiLists_HaveDone_Flow',
                'funcid' => '252',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_bjlc'],
                'img' => 'jieshuliucheng.png',
                'url' => 'weiLists_Done_Flow',
                'funcid' => '323',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_wdqq'],
                'img' => 'wodeqingqiu.png',
                'url' => 'weiLists_Request_Flow',
                'funcid' => '420',
            )
        );
        $otherMenus = array(
            array(
                'title' => $_lang['e_flow_copy_flow'],
                'img' => 'copy_flow.png',
                'url' => 'weiLists_Copy_Flow',
                'funcid' => '377',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_xwzz'],
                'img' => 'xinwenzhongxin.png',
                'url' => 'weiLists_New',
                'funcid' => '130',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_ggzz'],
                'img' => 'gonggaozhongxin.png',
                'url' => 'weiLists_Notify',
                'funcid' => '131',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_wdzz'],
                'img' => 'mydocument.png',
                'url' => 'docCenter_Doc',
                'funcid' => '8',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_khzz'],
                'img' => 'kehuzhognxin.png',
                'url' => 'crmCenter_Crm',
                'funcid' => '44',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_wdrc'],
                'img' => 'calendar.png',
                'url' => 'viewUpdate_Calendar',
                'funcid' => '141',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_wdxz'],
                'img' => 'xiezuozhongxin.png',
                'url' => 'lists_Coop',
                'funcid' => '363',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_wdwb'],
                'img' => 'weibo.png',
                'url' => 'view_Diary',
                'funcid' => '184',
            ),
            array(
                'title' => '我的会议',
                'img' => 'meeting.png',
                'url' => 'lists_Meeting',
                'funcid' => '702',
            ),
            array(
                'title' => '我的工资单',
                'img' => 'gongzi.png',
                'url' => 'salaryList_Salary',
                'funcid' => '319',
            ),
            array(
                'title' => '签到签退',
                'img' => 'signInOut.png',
                'url' => 'dtSign_Sign',
                'funcid' => '32',
            ),
            array(
                'title' => '外勤签到',
                'img' => 'outSign.png',
                'url' => 'outSign_Sign',
                'funcid' => '32',
            ),
            array(
                'title' => '考勤记录',
                'img' => 'signlist.png',
                'url' => 'attendanceList_Sign',
                'funcid' => '17',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_nbxx'],
                'img' => 'neibuxiaoxi.png',
                'url' => 'smsCenter_Sms',
                'funcid' => '13',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_nbyj'],
                'img' => 'email.png',
                'url' => 'emailBox_Email',
                'funcid' => '12',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_txl'],
                'img' => 'maillist.png',
                'url' => 'lists_Addr',
                'funcid' => '216',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_xjzz'],
                'img' => 'buildingcenter.png',
                'url' => 'all_Create',
                'funcid' => '',
            ),
        );


        $PAGE_TITLE = $_lang['emobile_weixin_weixin_sp_mobile_page'];
        include(INCLUDE_APP_PATH . 'DingTalk/View/DingTalkControlHomePanelView.php');
    }

    /**
     * 钉钉接入 从管理应用中出发
     */
    public function dingTalkHome($sessionkey = '', $funcIDStr, $type = 5) {
        global $_lang;
        global $ATTACH_PATH;

        if ($sessionkey == '') {
            $sessionkey = request_var('sessionkey');
        }
        $strexplode = explode("_", $sessionkey);
        $cursession = $strexplode[0];
        $userId = $strexplode[1];
        if (!CheckSessionKeys($cursession)) {
            $this->errorPage('err', $_lang['emobile_weixin_weixin_sp_error_login']);
        }

        $func_id_str = $funcIDStr;

        $USER_NAME = $_SESSION['USER_NAME'];
        $avatar_type = $_SESSION['AVATAR_TYPE'];
        if (!$avatar_type) {
            $avatar_type = '.png';
        }
        if (file_exists($ATTACH_PATH . "/personal/" . $userId . "/avatar_80" . $avatar_type)) {
            $userPic = "/attachment/personal/" . $userId . "/avatar_80" . $avatar_type;
        } else {
            $userPic = '/E-mobile/Public/images/user_info.png';
        }

        $flowMenus = array(
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_dblc'],
                'img' => 'daichuli.png',
                'url' => 'weiLists_ToDo_Flow',
                'funcid' => '3',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_yblc'],
                'img' => 'yichuliliucheng.png',
                'url' => 'weiLists_HaveDone_Flow',
                'funcid' => '252',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_bjlc'],
                'img' => 'jieshuliucheng.png',
                'url' => 'weiLists_Done_Flow',
                'funcid' => '323',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_wdqq'],
                'img' => 'wodeqingqiu.png',
                'url' => 'weiLists_Request_Flow',
                'funcid' => '420',
            )
        );
        $otherMenus = array(
            array(
                'title' => $_lang['e_flow_copy_flow'],
                'img' => 'copy_flow.png',
                'url' => 'weiLists_Copy_Flow',
                'funcid' => '377',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_xwzz'],
                'img' => 'xinwenzhongxin.png',
                'url' => 'weiLists_New',
                'funcid' => '130',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_ggzz'],
                'img' => 'gonggaozhongxin.png',
                'url' => 'weiLists_Notify',
                'funcid' => '131',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_wdzz'],
                'img' => 'mydocument.png',
                'url' => 'docCenter_Doc',
                'funcid' => '8',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_khzz'],
                'img' => 'kehuzhognxin.png',
                'url' => 'crmCenter_Crm',
                'funcid' => '44',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_wdrc'],
                'img' => 'calendar.png',
                'url' => 'viewUpdate_Calendar',
                'funcid' => '141',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_wdxz'],
                'img' => 'xiezuozhongxin.png',
                'url' => 'lists_Coop',
                'funcid' => '363',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_wdwb'],
                'img' => 'weibo.png',
                'url' => 'view_Diary',
                'funcid' => '184',
            ),
            array(
                'title' => '我的会议',
                'img' => 'meeting.png',
                'url' => 'lists_Meeting',
                'funcid' => '702',
            ),
            array(
                'title' => '我的工资单',
                'img' => 'gongzi.png',
                'url' => 'salaryList_Salary',
                'funcid' => '319',
            ),
            array(
                'title' => '签到签退',
                'img' => 'signInOut.png',
                'url' => 'dtSign_Sign',
                'funcid' => '32',
            ),
            array(
                'title' => '外勤签到',
                'img' => 'outSign.png',
                'url' => 'outSign_Sign',
                'funcid' => '32',
            ),
            array(
                'title' => '考勤记录',
                'img' => 'signlist.png',
                'url' => 'attendanceList_Sign',
                'funcid' => '17',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_nbxx'],
                'img' => 'neibuxiaoxi.png',
                'url' => 'smsCenter_Sms',
                'funcid' => '13',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_nbyj'],
                'img' => 'email.png',
                'url' => 'emailBox_Email',
                'funcid' => '12',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_txl'],
                'img' => 'maillist.png',
                'url' => 'lists_Addr',
                'funcid' => '216',
            ),
            array(
                'title' => $_lang['emobile_weixin_pannel_view_menu_xjzz'],
                'img' => 'buildingcenter.png',
                'url' => 'all_Create',
                'funcid' => '',
            ),
        );


        $PAGE_TITLE = "钉钉办公";

        if ($type == 6) {

            foreach ($otherMenus as $key => $value) {
                if ($value["funcid"] == 32)
                    unset($otherMenus[$key]);
            }
            include(INCLUDE_APP_PATH . 'DingTalk/View/pc/DingTalkControlHomePanelView.php');
        } else {
            include(INCLUDE_APP_PATH . 'DingTalk/View/DingTalkControlHomePanelView.php');
        }
    }

    /**
     * 检测微信端传过来的用户id是否合法
     * @global type $connection
     * @staticvar type $USER_ID
     * @param type $userId
     * @return boolean
     */
    private function userCheck($userId) {
        global $connection;
        $query = 'SELECT USER_ID,USER_NAME,AVATAR_TYPE,USER_PRIV FROM user WHERE USER_ID=\'' . SecurityFilter($userId) . '\'  AND USER_ACCOUNTS !=\'\'';
        $cursor = exequery($connection, $query);
        $row = mysql_fetch_array($cursor);
        if ($row) {
            return $row;
        }
        return false;
    }

    //获取当前用户权限
    private function systemAuth($LOGIN_USER_PRIV) {
        global $connection;
        $query = "SELECT * from USER_PRIV where USER_PRIV=$LOGIN_USER_PRIV";
        $cursor = exequery($connection, $query);
        if ($ROW = mysql_fetch_array($cursor)) {
            $LOGIN_FUNC_STR = $ROW["FUNC_ID_STR"];
        }

        return $LOGIN_FUNC_STR;
    }

    /**
     * 错误页
     * @param type $code
     * @param type $message
     */
    private function errorPage($code = '', $message = '') {
        global $_lang;
        $PAGE_TITLE = $_lang['e_weixin_error_page'];
        include(INCLUDE_APP_PATH . 'Weixin/View/ErrorView.php');
        exit;
    }

    private function checkOpenId($openId, $userId) {
        global $connection;
        $query = 'SELECT * FROM weixin_user WHERE uid=\'' . SecurityFilter($userId) . '\' AND openid=\'' . SecurityFilter($openId) . '\'';
        $cursor = exequery($connection, $query);
        $row = mysql_fetch_array($cursor);
        if ($row) {
            return true;
        }
        return false;
    }

    public function getEnterID($m) {
        global $connection;
        $f = self::$_config['autoMenuArray'][$m];
        $query = " SELECT * FROM qyweixin_menu WHERE name = '" . SecurityFilter($f) . "'";
        $cursor = exequery($connection, $query);
        $row = mysql_fetch_array($cursor);
        if ($row) {
            return true;
        }
        return false;
    }

    public function getToken() {
        global $connection;
        $sql = "select * from  qyweixin_token limit 1";
        $cursor = exequery($connection, $sql);
        $row = mysql_fetch_assoc($cursor);
        if ($row) {

            if (abs(time() - $row['access_token']) > 7200) {
                //GET请求的地址
                $corpid = SecurityFilter(trim($row['corpid']));
                $secret = SecurityFilter(trim($row['secret']));
                $url = "https://qyapi.weixin.qq.com/cgi-bin/gettoken?corpid={$corpid}&corpsecret={$secret}";
                $json = AppGlobal::getToken($url);
                $result = json_decode($json, true);
                $time = time();
                if (!isset($result['errcode']) && $result['access_token'] != $row['access_token']) { // 不存在错误编码
                    $sql2 = "update qyweixin_token set access_token = '{$result['access_token']}', token_time = '{$time}' where corpid = '{$corpid}' and secret = '{$secret}'";
                    exequery($connection, $sql2);
                }
            }
        } else {
            return false;
        }
        return true;
    }

}
