<?
/**
* @copyright (C) 2010 - 2011 Weaver Co.Ltd
* @package       eoffice8.0
* @function      解析表单基类
* @encoding      $_lang['encoding']
* @name          api/AnalyticFormBase.class.php
* @version       1
* @author        sun|www.weaver.com.cn
* @modify        sunx
* @date          2012-11-02
*/

/**
* 解析流程表单的基类
* @access public
* @auth  sunxiang
*/
class AnalyticFormBase
{
    public    $flowForm           ;     //对应流程表单的字符串
    public    $formData           ;     //对应流程表单的数据
    public    $formElement        ;     //表单所有元素
    public    $elementName        ;     //表单所有元素名称
    public    $elementId          ;     //表单所有元素的id
    public    $elementValue       ;     //表单所有元素的值
    public    $elementTitle       ;     //表单所有元素的标题
    public    $fieldArray         ;     //表单有值的字段（不包括date,time）的标题
    public    $elementRequire     ;     //表单所有元素必填信息
    public    $elementClass       ;     //表单所有元素的class
    public    $elementThousand    ;     //表单所有元素是否千位分隔
    public    $prcsItem           ;     //流程当前可以编辑的字段
    public    $prcsItemCapacity   ;     //流程当前只能获值的字段
    public    $prcsItemAuto       ;     //流程当前自动获值的字段
    public    $prcsItemRequired   ;     //流程当前必填的字段
    public    $getValueControl    ;     //获值字段的控制变量
    public    $relationField      ;     //动态字段的关联属性
    public    $dateComputeControl ;     //日期时间计算控件的相关属性
    public    $itemId             ;     //表单字段序号
    public    $flowType           ;     //当前流程的类别
    public    $flowId             ;     //流程类别id
    public    $formName           ;     //流程表单名称
    public    $runId              ;     //运行中的流程id
    public    $runSeq             ;     //流程的流水号
    public    $prcsId             ;     //流程当前序号id
    public    $flowPrcs           ;     //流程当前步骤id
    public    $prcsDate           ;     //流程创建日期
    public    $prcsDateTime       ;     //流程创建日期时间
    public    $opFlag             ;     //当前办理人是否是主办人

    /**
    *构造函数
    *@param  int  $flow_id 流程类别id
    *@return void
    */
    function __construct($flowForm)
    {
        //获取表单元素
        $this->flowForm    = $flowForm;
        $this->formElement = $this->html_element($this->flowForm);
        $this->itemId      = 0;
        for($i=0;$i < count($this->formElement); $i++)
        {
            $ELEMENT                   = $this->formElement[$i];
            $this->elementName[$i]     = $this->get_attr($ELEMENT,"NAME");
            $this->elementId[$i]       = $this->get_attr($ELEMENT,"ID");
            $this->elementValue[$i]    = $this->get_attr($ELEMENT,"VALUE");
            $EITLE                     = $this->get_attr($ELEMENT,"TITLE");
            $EITLE                     = str_replace("+","＋",$EITLE);
            $EITLE                     = str_replace("#","＃",$EITLE);
            $this->elementTitle[$i]    = $EITLE;
            //$this->elementRequire[$i]  = find_id($this->prcsItemRequired,$EITLE) ;
            $this->elementClass[$i]    = $this->get_attr($ELEMENT,"CLASS");
            $this->elementThousand[$i] = $this->get_attr($ELEMENT,"THOUSANDFORMAT");
            //获取格式化属性format
            $this->elementFormat[$i]   = $this->get_attr($ELEMENT,"FORMAT");
			
			$this->elementHidden[$i]   = $this->get_attr($ELEMENT, 'HIDDEN_ATTR');
        }
    }
    /**
    *表单数据值的转换
    *@return array   $formFieldValue     数据库查询结果转换成对应的数组
    */
    function formDataTrans(){
        foreach($this->formData as $key=>$val)
        {
            $formFieldValue[$val["ITEM_ID"]]  = $this->fieldValueFilter($val["ITEM_DATA"]);
        }
        return $formFieldValue;
    }
    /**
    *表单数据值的过滤
    *@param  str  $value 字段原值
    *@return str  $value 过滤后的值
    */
    function fieldValueFilter($value){
        switch ($value){
            case "{宏控件}";
                return $value = "";
                break;
            case "{会签字段}";
                return $value = "";
                break;
            case "{编辑器}";
                return $value = "";
                break;
            case "{人员选择}";
                return $value = "";
                break;
            case "{部门选择}";
                return $value = "";
                break;
            case "{角色选择}";
                return $value = "";
                break;
            default:
                return $value;
        }
    }
    /**
    *字段是否可以编辑
    *@return bool   true/false     字段是否可以编辑
    */
    function fieldCanEdit($elementTitle,$elementClass="") {
        if($this->flowType==1) {
            if($elementClass == "HTML_SIGNATURE" || $elementClass == "SIGNATURE_PICTURE") {
                if(find_id($this->prcsItem,$elementTitle))
                    return true;
                else
                    return false;
            } else {
                if($this->opFlag==1&&find_id($this->prcsItem,$elementTitle))
                    return true;
                else
                    return false;
            }
        } else {
            if($elementClass == "HTML_SIGNATURE" || $elementClass == "SIGNATURE_PICTURE") {
                return true;
            } else {
                if($this->opFlag==1)
                    return true;
                else
                    return false;
            }
        }
    }
    /**
    *表单数据值的过滤
    *@param  str  $value 字段原值
    *@return str  $value 过滤后的值
    */
    /**
    *为表单控件元素增加id,name,必填事件
    *@param  str   $elementName    表单字段类别名称
    *@param  int   $elementId      表单字段序号
    *@param  str   $elementStr     表单字段字符串
    *@param  str   $reqiured       是否必填控制字段
    *@param  str   $opFlag         是否是流程主办人
    *@return str   $elementStr     添加完成后的字符串
    */
    function addIdNameRequiredEvent ($elementName,$elementId,$reqiured,$opFlag,$elementStr){
        return str_replace("<$elementName","<$elementName field_required='$reqiured' onchange=\"checkRequired(this,'$elementId','$opFlag');\" onkeyup=\"checkRequired(this,'$elementId','$opFlag');\" onblur=\"checkRequired(this,'$elementId','$opFlag');\"",$elementStr);
        //return str_replace("<$elementName","<$elementName name='DATA_$elementId' id='DATA_$elementId' required='$reqiured' onchange=\"checkRequired(this,'$elementId','$opFlag');\" onkeyup=\"checkRequired(this,'$elementId','$opFlag');\" onblur=\"checkRequired(this,'$elementId','$opFlag');\"",$elementStr);
    }
    /**
    *为表单元素增加id,name，
    *@param  str   $elementName    表单字段名
    *@param  int   $elementId      表单字段序号
    *@param  str   $elementStr     表单字段字符串
    *@return str   $elementStr     添加id，name后的字符串
    */
    function addIdName($elementName,$elementId,$elementStr)
    {
        return str_replace("<$elementName","<$elementName name='DATA_$elementId' id='DATA_$elementId'",$elementStr);
    }

    /**
    *匹配表单中的控件
    *@param  str   $PRINT_MODEL    表单内容字符串
    *@return array $ELEMENT_ARRAY  表单控件数组
    */
    function html_element($PRINT_MODEL)
    {
        $POS = 0;
        $LEN = strlen ( $PRINT_MODEL );
        $I   = 0;
        $J   = 0;
        while ( $POS < $LEN )
        {
            $POS = strpos ( $PRINT_MODEL, "<", $POS );
            if ($POS === FALSE)
                break;
            if (substr ( $PRINT_MODEL, $POS + 1, 1 ) == "/")
            {
                $POS += 2;
                continue;
            }
            $POS1 = strpos ( $PRINT_MODEL, " ", $POS );
            $POS2 = strpos ( $PRINT_MODEL, ">", $POS );
            if ($POS1 > $POS2)
                $POS1 = $POS2;

            $ELEMENT_NAME = substr ( $PRINT_MODEL, $POS + 1, $POS1 - $POS - 1 );
            switch ($ELEMENT_NAME)
            {
                //控件为单行输入框
                case "INPUT" :
                    $ELEMENT = substr ( $PRINT_MODEL, $POS, $POS2 - $POS + 1 );
                    $ELEMENT_ARRAY [$I ++] = $ELEMENT;
                    $POS = $POS2 + 1;
                break;
                //控件为下拉框
                case "SELECT" :
                    $POS2 = strpos ( $PRINT_MODEL, "</SELECT>", $POS2 + 1 );
                    $ELEMENT = substr ( $PRINT_MODEL, $POS, $POS2 - $POS + 9 );
                    $ELEMENT_ARRAY [$I ++] = $ELEMENT;
                    $POS = $POS2 + 9;
                break;
                //控件为多行文本框
                case "TEXTAREA" :
                    $POS2 = strpos ( $PRINT_MODEL, "</TEXTAREA>", $POS2 + 1 );
                    $ELEMENT = substr ( $PRINT_MODEL, $POS, $POS2 - $POS + 11 );
                    $ELEMENT_ARRAY [$I ++] = $ELEMENT;
                    $POS = $POS2 + 11;
                break;
                //控件为图片类型
                case "IMG" :
                    $ELEMENT = substr ( $PRINT_MODEL, $POS, $POS2 - $POS + 1 );
                    if ($this->get_attr ( $ELEMENT, "CLASS" ))
                        $ELEMENT_ARRAY [$I ++] = $ELEMENT;
                    $POS = $POS2 + 1;
                break;
                default :
                    $POS = $POS2 + 1;
                break;
            }
        }
        return $ELEMENT_ARRAY;
    }
    /**
    *获取表单中控件的属性值
    *@param  str $ELEMENT    控件字符串
    *@param  str $ATTR       要取的属性名称
    *@return str $ATTR_DATA  控件属性值
    */
    function get_attr($ELEMENT,$ATTR)
    {
        //-- 先取元素名 --
        $POS    = strpos ( $ELEMENT, " " );
        $E_NAME = substr ( $ELEMENT, 1, $POS - 1 );
        //-- 分类别取值 --
        $ATTR_DATA == "";
        if ($ATTR == "NAME")
            $ATTR_DATA = $E_NAME;
        else if ($ATTR == "TITLE" || $ATTR == "CLASS" || $ATTR == "DATAFLD" || $ATTR == "DATASRC" || $ATTR == "THOUSANDFORMAT" || $ATTR == "ID" || $ATTR == "FORMAT")
        {
            if ($ATTR == "TITLE" || $ATTR == "CLASS" || $ATTR == "THOUSANDFORMAT" || $ATTR == "ID") {
                $ATTR = strtolower ( $ATTR );
            } else if ($ATTR == "FORMAT") {
                $ATTR = strtolower ( " ".$ATTR );
            } else if ($ATTR == "DATAFLD"){
                $ATTR = "dataFld";
            } else if ($ATTR == "DATASRC") {
                $ATTR = "dataSrc";
            }
            $bool = strstr ( $ELEMENT, $ATTR ) || strstr ( $ELEMENT, strtolower($ATTR) );
            if ($bool)
            {
                $p = strpos ( $ELEMENT, "$ATTR=" );//$p 43
                if($p === false)
                {
                    $att = strtolower($ATTR);
                    $p   = strpos ( $ELEMENT, "$att=" );
                }
                //$POS = strpos ( $ELEMENT, "$ATTR=" ) + strlen ( $ATTR ) + 1;
                $POS  = $p + strlen ( $ATTR ) + 1; //$POS 58
                $POS1 = strpos ( $ELEMENT, ">", $POS ); //$POS1 61
                if ($ATTR == "dataSrc" || $ATTR == "title")
                {
                    $POS ++;
                    $POS2 = strpos ( $ELEMENT, "\"", $POS );
                }
                else
                {
                    $POS2 = strpos ( $ELEMENT, " ", $POS );
                }
                if ($POS2 < $POS1 && $POS2 != 0)
                    $POS1 = $POS2;
                $ATTR_DATA = substr ( $ELEMENT, $POS, $POS1 - $POS );
                $ATTR_DATA = str_replace ( "\"", "", $ATTR_DATA );
            }
        }else if ($ATTR == "VALUE"){
            if ($E_NAME == "INPUT" || $E_NAME == "IMG")
            {
                if (! strstr ( $ELEMENT, "type=\"checkbox\"" )) //textfield
                {
                    $POS = strpos ( $ELEMENT, "value=" );
                    if ($POS > 0)
                    {
                        if ($E_NAME == "INPUT")
                        {
                            $POS = strpos ( $ELEMENT, "value=" ) + 6;
                            $POS1 = strpos ( $ELEMENT, ">", $POS );
                            $ATTR_DATA = substr ( $ELEMENT, $POS, $POS1 - $POS );
                        }
                        else if ($E_NAME == "IMG")
                        {
                            $value_pattern = "/value=\"[^\"]*\"/";
                            preg_match_all ( $value_pattern, $ELEMENT, $value_pattern_array );
                            $value = $value_pattern_array [0] [0];
                            $ATTR_DATA = substr ( $value, 7, strlen ( $value ) - 8 );
                        }
                    }
                    else
                        $ATTR_DATA = "";
                }
                else if (strstr ( $ELEMENT, " checked=\"checked\"" ))
                    $ATTR_DATA = "on";
                $ATTR_DATA = str_replace ( "\"", "", $ATTR_DATA );
            }
            else if ($E_NAME == "TEXTAREA")
            {
                $POS       = strpos ( $ELEMENT, ">" ) + 1;
                $POS1      = strpos ( $ELEMENT, "<", $POS );
                $ATTR_DATA = substr ( $ELEMENT, $POS, $POS1 - $POS );
            }
            else if ($E_NAME == "SELECT")
            {
                $POS       = strpos ( $ELEMENT, ">" ) + 1;
                $POS1      = strpos ( $ELEMENT, "</SELECT>", $POS );
                $ATTR_DATA = substr ( $ELEMENT, $POS, $POS1 - $POS );
            }
        }else if($ATTR == 'HIDDEN_ATTR'){		
			$ATTR_DATA = false;
			if(strstr ( $ELEMENT, 'hidden=' ) || strstr ( $ELEMENT,'HIDDEN=' )){
				$start = strpos ( $ELEMENT, "HIDDEN=" );
				
				if(!$start){
					$start = strpos ( $ELEMENT, "hidden=" );
				}
				
				$start = $start + 7;
				
				$end = strpos ( $ELEMENT, ">", $start );
				
				$subElement = substr($ELEMENT, $start, $end - $start);
				
				if(strpos ( $subElement, "\"" ) == 0){
					$pattern = '#"(.*?)"#i'; 
					preg_match_all($pattern, $subElement, $matches); 
					if($matches[1][0] == 0){
						$ATTR_DATA = true;
					}
				}
			} else if(strstr ( $ELEMENT, 'style=' ) || strstr ( $ELEMENT,'STYLE=' )) {
				$start = strpos ( $ELEMENT, "STYLE=" );
				
				if(!$start){
					$start = strpos ( $ELEMENT, "style=" );
				}
				
				$start = $start + 6;
				
				$end = strpos ( $ELEMENT, ">", $start );
				
				$subElement = substr($ELEMENT, $start, $end - $start);
				
				if(strpos ( $subElement, "\"" ) == 0){
					$pattern = '#"(.*?)"#i'; 
					preg_match_all($pattern, $subElement, $matches); 
					
					$styleStr  = $matches[1][0];
					if(strstr ( $styleStr, 'display:none' ) || strstr ( $styleStr,'visibility:hidden' ) || strstr ( $styleStr,'VISIBILITY:HIDDEN' ) || strstr ( $styleStr,'DISPLAY:NONE' )){
						$ATTR_DATA = true;
					}
				}
			}
		}
        return $ATTR_DATA;
    }
}
?>
