<?php

class MobielAttend {

    public function __construct() {
        ;
    }

    public function getUserList($condition = '') {
        $query = 'SELECT USER_ID,USER_NAME,DEPT_ID FROM user WHERE DEPT_ID>0';
        if ($condition) {
            $query = $query . $condition;
        }


        $userList = $this->_sqlGetRows($query);
        return $userList;
    }

    public function getDeptName($deptId) {
        $query = 'SELECT DEPT_NAME FROM department WHERE DEPT_ID=' . SecurityFilter($deptId);
        $dept = $this->_sqlGetRow($query);
        return $dept['DEPT_NAME'];
    }

    public function getDeptList() {
        $query = 'SELECT DEPT_ID,DEPT_NAME,DEPT_NO,DEPT_PARENT,DEPT_NAME_PY,DEPT_NAME_ZM FROM department';
        $dept = $this->_sqlGetRows($query);
        return $dept;
    }

    public function getRecords($userId, $deptId, $_startTime, $_endTime, $start = 0, $pageSize = 10) {
        $query = 'SELECT mp.ID, mp.USER_ID,mp.LATLNG,mp.ADDRESS,mp.STATUS,mp.CREATE_TIME,mp.mobile_category,mp.out_info,mp.out_img,u.USER_NAME,d.DEPT_NAME FROM mobile_position AS mp '
                . 'LEFT JOIN user AS u ON mp.USER_ID = u.USER_ID LEFT JOIN department AS d ON d.DEPT_ID = u.DEPT_ID WHERE 1=1 ';

        if ($userId) {
            $query .= ' AND mp.USER_ID = \'' . SecurityFilter($userId) . '\'';
        }
        if ($deptId) {
            $query1 = "SELECT USER_ID FROM user WHERE DEPT_ID=" . SecurityFilter($deptId);
            $users = $this->_sqlGetRows($query1);
            if ($users) {
                $userId = '(';

                foreach ($users as $user) {
                    $userId .= "'" . $user['USER_ID'] . "',";
                }

                $userId = rtrim($userId, ',') . ')';
                $query .= ' AND mp.USER_ID IN ' . SecurityFilter($userId);
            }
            
        }
        if ($_startTime) {
            $query .= ' AND mp.CREATE_TIME >= ' . SecurityFilter($_startTime);
        }
        if ($_endTime) {
            $query .= ' AND mp.CREATE_TIME < ' . SecurityFilter($_endTime);
        }
        $query .= ' ORDER BY `CREATE_TIME` DESC LIMIT ' . SecurityFilter($start) . ',' . SecurityFilter($pageSize);
        $records = $this->_sqlGetRows($query);
        return $records;
    }

    //增加考勤相关 -- 涉及到类型 将条件作为唯一条件传入
    public function getDutyRecords($where, $start = 0, $pageSize = 10, $flag = 0) {
        $query = 'SELECT mp.ID, mp.USER_ID,mp.LATLNG,mp.ADDRESS,mp.STATUS,mp.CREATE_TIME,mp.mobile_category,mp.out_info,mp.out_img,u.USER_NAME,d.DEPT_NAME FROM mobile_position AS mp '
                . 'LEFT JOIN user AS u ON mp.USER_ID = u.USER_ID LEFT JOIN department AS d ON d.DEPT_ID = u.DEPT_ID WHERE 1=1 ';

        if (isset($where["USER_ID"]) && $where["USER_ID"]) {
            $query .= ' AND mp.USER_ID = \'' . SecurityFilter($where["USER_ID"]) . '\'';
        }

        if (isset($where["begin"]) && $where["begin"]) {
            $query .= ' AND mp.CREATE_TIME >= ' . SecurityFilter(strtotime($where["begin"]));
        }

        if (isset($where["end"]) && $where["end"]) {

            $end = strtotime($where["end"]) + 86399;
            $query .= ' AND mp.CREATE_TIME <= ' . SecurityFilter($end);
        }

        if (isset($where["mobile_category"])) {
            $where["mobile_category"] == 1 ? 1 : 0;
            $query .= ' AND mp.mobile_category = ' . SecurityFilter($where["mobile_category"]);
        }


        $query .= ' ORDER BY `CREATE_TIME` DESC  ';

        if ($flag != -1) {
            $query .= '  LIMIT ' . SecurityFilter($start) . ',' . SecurityFilter($pageSize);
        }


        $records = $this->_sqlGetRows($query);
        return $records;
    }

    public function getRecordsCount($userId, $deptId, $_startTime, $_endTime) {
        $query = 'SELECT count(*) as COUNT FROM mobile_position AS mp '
                . 'LEFT JOIN user AS u ON mp.USER_ID = u.USER_ID WHERE 1=1 ';
        if ($userId) {
            $query .= ' AND mp.USER_ID = \'' . SecurityFilter($userId) . '\'';
        }
        if ($deptId) {
            $query1 = "SELECT USER_ID FROM user WHERE DEPT_ID=" . SecurityFilter($deptId);
            $users = $this->_sqlGetRows($query1);
            if ($users) {
                $userId = '(';

                foreach ($users as $user) {
                    $userId .= "'" . $user['USER_ID'] . "',";
                }

                $userId = rtrim($userId, ',') . ')';
            }
            $query .= ' AND mp.USER_ID IN ' . SecurityFilter($userId);
        }
        if ($_startTime) {
            $query .= ' AND mp.CREATE_TIME >= ' . SecurityFilter($_startTime);
        }
        if ($_endTime) {
            $query .= ' AND mp.CREATE_TIME < ' . SecurityFilter($_endTime);
        }
        $records = $this->_sqlGetRow($query);
        return $records['COUNT'];
    }

    private function _sqlGetRows($query) {
        global $connection;
        $result = exequery($connection, $query);
        $data = array();
        if ($result) {
            while ($row = @mysql_fetch_array($result, MYSQL_ASSOC)) {
                array_push($data, $row);
            }
            @mysql_free_result($result);
            return $data;
        }
        return false;
    }

    private function _sqlGetRow($query) {
        global $connection;
        $result = exequery($connection, $query);
        if ($result) {
            $row = @mysql_fetch_array($result, MYSQL_ASSOC);
            @mysql_free_result($result);
            return $row;
        }
        return false;
    }

}
