<?php
/**
 *@Copyright (C) 2010 - 2011 Weaver Co.Ltd
 *@systemname:       E-Office
 *@filename:         api/address.class.php
 *@function:         通讯录的类
 *@encoding:         $_lang['encoding']
 *@author:           www.weaver.com.cn
 *@modify:			 dingp
 *@date:             2012-01-16
 *@file Version:     6.0
 *@eoffice Version:  8.0
*/
include_once ("inc/conn.php");
class address{
	var $default_limit = 20;
	var $default_start = 0;
	private $deptid;
	private $uesrpriv;
	private $userid;
	private $curdate;
	private $curdatetime;

	//构造函数
	function __construct($userinfo=array()){
		global $connection;
		if($userinfo["user_id"]=="")
		{
			$this->userid = $_SESSION["LOGIN_USER_ID"];
		}
		else
		{
			$this->userid = $userinfo["user_id"];
		}
		if($this->userid) {
			$sql = "SELECT DEPT_ID,USER_PRIV FROM user WHERE USER_ID='".SecurityFilter($this->userid)."'";
			$rs  = exequery($connection,$sql);
			$row = mysql_fetch_array($rs);
			$this->deptid = $row["DEPT_ID"];
			$this->uesrpriv = $row["USER_PRIV"];
		}
		$this->curdate     = date("Y-m-d",time());
		$this->curdatetime = date("Y-m-d H:i:s",time());
	}

	/**
	 * 获取通讯录信息(For Webservice)
	 * @param string $offset 返回记录的偏移量
	 * @param string $rows 返回记录行的最大数目
	 * @param string $addressID 通讯录ID
	 * @param sting  $searchCondition 查询条件(用户名)
	 * @return array $resultArray 通讯录详细信息
	 */
	public function GetAddressInfor($offset, $rows, $addressID, $searchCondition,$checkdiff='',$groupdiff='')
	{
		global $connection;
		$offset = $offset != "" ? $offset : $this->default_start;
		$rows   = $rows != "" ? $rows : $this->default_limit;
		$UserId = $this->userid;
		$DeptId = $this->deptid;
		$PrivId = $this->uesrpriv;
		$query_select = "SELECT * FROM address as a JOIN address_group  as b on a.A10=b.GROUP_ID WHERE 1 ";
		switch($checkdiff)
		{
			case "":
				$query_check = " AND (a.A11='".SecurityFilter($UserId)."' OR (
						b.GROUP_DEPT = 'ALL_DEPT'
						OR((INStr(b.GROUP_DEPT,',".SecurityFilter($DeptId).",')>0 OR INStr(b.GROUP_DEPT,'".SecurityFilter($DeptId).",')=1)
						   OR
						   (INStr(b.GROUP_PRIV,',".SecurityFilter($PrivId).",')>0 OR INStr(b.GROUP_PRIV,'".SecurityFilter($PrivId).",')=1)
						   OR
						   (InStr(b.GROUP_USER,'".SecurityFilter($UserId).",')>0 OR INStr(b.GROUP_USER,'".SecurityFilter($UserId).",')=1))))";
				break;
			case "common":
				$query_check = " AND a.ADD_TYPE='1' AND (
						b.GROUP_DEPT = 'ALL_DEPT'
						OR((INStr(b.GROUP_DEPT,',".SecurityFilter($DeptId).",')>0 OR INStr(b.GROUP_DEPT,'".SecurityFilter($DeptId).",')=1)
						   OR
						   (INStr(b.GROUP_PRIV,',".SecurityFilter($PrivId).",')>0 OR INStr(b.GROUP_PRIV,'".SecurityFilter($PrivId).",')=1)
						   OR
						   (InStr(b.GROUP_USER,'".SecurityFilter($UserId).",')>0 OR INStr(b.GROUP_USER,'".SecurityFilter($UserId).",')=1)))";
				break;
			case "personal":
				$query_check = " AND a.ADD_TYPE='2' AND a.A11='".SecurityFilter($UserId)."'";
				break;
		}
		if($groupdiff!="")
		{
			$query_group = " AND b.GROUP_ID='".SecurityFilter($groupdiff)."'";
		}
		$query = $query_select.$query_check.$query_group;
		if ($addressID != "") {
			$query .= " AND a.ADD_ID='" . SecurityFilter($addressID) . "'";
		}
		if ($searchCondition != "") {
			$query .= " AND a.A1 like '%" . SecurityFilter($searchCondition) . "%'";
		}
		$query .= " ORDER BY A13 ASC LIMIT " . SecurityFilter($offset) . "," . SecurityFilter($rows);

		$result = exequery ( $connection, $query );
		$resultArray=array();
		while ( $row = mysql_fetch_array ( $result ) ) {
			$userInfor ["ID"]              = $row ["ADD_ID"];
			$userInfor ["Name"]            = $row ["A1"];
			$userInfor ["OtherName"]       = $row ["A14"];
			$userInfor ["Sex"]             = $row ["A2"];
			$userInfor ["City"]            = $row ["A3"];
			$userInfor ["Birthday"]        = $row ["A4"];
			$userInfor ["Mobile"]          = $row ["A5"];
			$userInfor ["Email"]           = $row ["A6"];
			$userInfor ["Company"]         = $row ["A7"];
			$userInfor ["Company_address"] = $row ["A22"];
			$userInfor ["Company_post"]    = $row ["A21"];
			$userInfor ["Company_fax"]     = $row ["A26"];
			$userInfor ["Department"]      = $row ["A8"];
			$userInfor ["job"]             = $row ["A25"];
			$userInfor ["Comment"]         = $row ["A9"];
			$userInfor ["Work_Tel"]        = $row ["A23"];
			$userInfor ["Home_address"]    = $row ["A24"];
			$userInfor ["Home_Tel"]        = $row ["A27"];
			$userInfor ["GroupID"]         = $row ["A10"];
			$userInfor ["GroupName"]       = $row ["GROUP_NAME"];
			$userInfor ["Groupparent"]     = $row ["GROUP_PARENT"];
			$userInfor ["Grouptype"]       = $row ["GROUP_TYPE"];
			$userInfor ["THUMB_IMAGE"]     = $row ["THUMB_IMAGE"];
			$userInfor ["FRIST_IMAGE"]     = $row ["FRIST_IMAGE"];
			$userInfor ["CREAT_USER"]      = $row ["A11"];
			$userInfor ["CREAT_TIME"]      = $row ["A12"];
			$userInfor ["QQ"]              = $row ["A16"];
			$userInfor ["wife"]            = $row ["A18"];
			$userInfor ["son"]             = $row ["A19"];
			array_push ( $resultArray, $userInfor );
		}
		return $resultArray;
	}

	public function GetAddrInfor($offset, $rows, $addressID, $searchCondition,$checkdiff='',$groupdiff='')
	{
		global $connection;
		$offset = $offset != "" ? $offset : $this->default_start;
		$rows   = $rows != "" ? $rows : $this->default_limit;
		$UserId = $this->userid;
		$DeptId = $this->deptid;
		$PrivId = $this->uesrpriv;
		$query_select = "SELECT * FROM address as a JOIN address_group  as b on a.A10=b.GROUP_ID WHERE 1 ";
		switch($checkdiff)
		{
			case "":
				$query_check = " AND (a.A11='".SecurityFilter($UserId)."' OR (
						b.GROUP_DEPT = 'ALL_DEPT'
						OR((INStr(b.GROUP_DEPT,',".SecurityFilter($DeptId).",')>0 OR INStr(b.GROUP_DEPT,'".SecurityFilter($DeptId).",')=1)
						   OR
						   (INStr(b.GROUP_PRIV,',".SecurityFilter($PrivId).",')>0 OR INStr(b.GROUP_PRIV,'".SecurityFilter($PrivId).",')=1)
						   OR
						   (InStr(b.GROUP_USER,'".SecurityFilter($UserId).",')>0 OR INStr(b.GROUP_USER,'".SecurityFilter($UserId).",')=1))))";
				break;
			case "public":
				$query_check = " AND a.ADD_TYPE='1' AND (
						b.GROUP_DEPT = 'ALL_DEPT'
						OR((INStr(b.GROUP_DEPT,',".SecurityFilter($DeptId).",')>0 OR INStr(b.GROUP_DEPT,'".SecurityFilter($DeptId).",')=1)
						   OR
						   (INStr(b.GROUP_PRIV,',".SecurityFilter($PrivId).",')>0 OR INStr(b.GROUP_PRIV,'".SecurityFilter($PrivId).",')=1)
						   OR
						   (InStr(b.GROUP_USER,'".SecurityFilter($UserId).",')>0 OR INStr(b.GROUP_USER,'".SecurityFilter($UserId).",')=1)))";
				break;
			case "personal":
				$query_check = " AND a.ADD_TYPE='2' AND a.A11='".SecurityFilter($UserId)."'";
				break;
		}
		if($groupdiff!="")
		{
			$query_group = " AND b.GROUP_ID='".SecurityFilter($groupdiff)."'";
		}
		$query = $query_select.$query_check.$query_group;
		if ($addressID != "") {
			$query .= " AND a.ADD_ID='" . SecurityFilter($addressID) . "'";
		}
		if ($searchCondition != "") {
			$query .= " AND a.A1 like '%" . SecurityFilter($searchCondition) . "%'";
		}
		$query .= " ORDER BY A13 ASC LIMIT " . SecurityFilter($offset) . "," . SecurityFilter($rows);

		$result = exequery ( $connection, $query );
		$resultArray=array();
		while ( $row = mysql_fetch_array ( $result ,MYSQL_ASSOC) ) {
			array_push ( $resultArray, $row);
		}
		return $resultArray;
	}


	/**
	 * 获取通讯录数量(For Webservice)
	 * @return string 当前用户通讯录数量
	 */
	function GetMyAddressAmount($searchCondition="",$checkdiff="",$groupid="")
	{
		global $connection;
		$UserId = $this->userid;
		$DeptId = $this->deptid;
		$PrivId = $this->uesrpriv;
		$query_select = "SELECT COUNT(*) as amount FROM address as a JOIN address_group  as b on a.A10=b.GROUP_ID WHERE 1 ";
		switch($checkdiff)
		{
			case "":
				$query_check = " AND (a.A11='".SecurityFilter($UserId)."' OR (
						b.GROUP_DEPT = 'ALL_DEPT'
						OR((INStr(b.GROUP_DEPT,',".SecurityFilter($DeptId).",')>0 OR INStr(b.GROUP_DEPT,'".SecurityFilter($DeptId).",')=1)
						   OR
						   (INStr(b.GROUP_PRIV,',".SecurityFilter($PrivId).",')>0 OR INStr(b.GROUP_PRIV,'".SecurityFilter($PrivId).",')=1)
						   OR
						   (InStr(b.GROUP_USER,'".SecurityFilter($UserId).",')>0 OR INStr(b.GROUP_USER,'".SecurityFilter($UserId).",')=1))))";
				break;
			case "common":
				$query_check = " AND a.ADD_TYPE='1'
				  		AND (
						b.GROUP_DEPT = 'ALL_DEPT'
						OR((INStr(b.GROUP_DEPT,',".SecurityFilter($DeptId).",')>0 OR INStr(b.GROUP_DEPT,'".SecurityFilter($DeptId).",')=1)
						   OR
						   (INStr(b.GROUP_PRIV,',".SecurityFilter($PrivId).",')>0 OR INStr(b.GROUP_PRIV,'".SecurityFilter($PrivId).",')=1)
						   OR
						   (InStr(b.GROUP_USER,'".SecurityFilter($UserId).",')>0 OR INStr(b.GROUP_USER,'".SecurityFilter($UserId).",')=1)))";
				break;
			case "personal":
				$query_check = " AND a.ADD_TYPE='2' AND a.A11='".SecurityFilter($UserId)."'";
				break;
		}
		if($groupid!="")
		{
			$query_check .= " AND b.GROUP_ID='".SecurityFilter($groupid)."'";
		}
		if($searchCondition!="")
		{
			$query_search = " AND a.A1 like '%".SecurityFilter($searchCondition)."%'";
		}
		$query = $query_select.$query_check.$query_search;
		$result = exequery ( $connection, $query );

		if ($row = mysql_fetch_array ( $result )) {
			return $row ["amount"];
		} else {
			return 0;
		}
	}

	/**
	 * 获取通讯录组织架构信息(For Webservice)
	 * @param $diff
	 * @return string 组织架构信息
	 */
	 public function GetAddressStruct($Info)
	 {
		global $connection;
		$resultArray = array();
		if($Info["diff"]=="common" || $Info["diff"]=="")
		{
			$sql    = "SELECT DEPT_ID,USER_PRIV FROM user WHERE USER_ID='".SecurityFilter($Info["userid"])."'";
			$rs     = exequery($connection,$sql);
			$row    = mysql_fetch_array($rs);
			$UserId = $Info["userid"];
			$DeptId = $row["DEPT_ID"];
			$PrivId = $row["USER_PRIV"];
			$sql_priv = "
					 SELECT GROUP_ID FROM address_group
						 WHERE  GROUP_TYPE = '1'
						 AND (
							GROUP_DEPT = 'ALL_DEPT'
							OR((INStr(GROUP_DEPT,',".SecurityFilter($DeptId).",')>0 OR INStr(GROUP_DEPT,'".SecurityFilter($DeptId).",')=1)
							   OR
							   (INStr(GROUP_PRIV,',".SecurityFilter($PrivId).",')>0 OR INStr(GROUP_PRIV,'".SecurityFilter($PrivId).",')=1)
							   OR
							   (InStr(GROUP_USER,'".SecurityFilter($UserId).",')>0 OR INStr(GROUP_USER,'".SecurityFilter($UserId).",')=1)))
					 ";
			$res = exequery($connection,$sql_priv);
			$i=0;
			while ($ROW = mysql_fetch_array($res))
			{
				if($i==0)
				{
					$SearchId .= " GROUP_ID='".SecurityFilter($ROW['GROUP_ID'])."'";
				}
				else
				{
					$SearchId .= " OR GROUP_ID='".SecurityFilter($ROW['GROUP_ID'])."'";
				}
				$i++;
			}
		}
		switch($Info["diff"])
		{
			case "common":
                $condition = " AND GROUP_TYPE='1'";
				break;
			case "personal":
				$condition = " AND GROUP_TYPE='2'";
				if($Info["userid"]!="")
				{
					$condition .= " AND USER_ID='".SecurityFilter($Info["userid"])."'";
				}
				break;
			default:
                if($SearchId)
                    $condition = " AND (".$SearchId.")";
		}
		$query  = "SELECT * FROM address_group WHERE 1".$condition;
		if($Info["groupid"]!="")
		{
			$query .= " AND GROUP_PARENT='".SecurityFilter($Info["groupid"])."'";
		}
        $query .= " ORDER BY GROUP_PARENT,GROUP_ORDER,GROUP_ID";
		$result	= exequery($connection,$query);
		while($row = mysql_fetch_array($result))
		{
			$Infor["GROUP_ID"]     = $row["GROUP_ID"];
			$Infor["GROUP_NAME"]   = $row["GROUP_NAME"];
			$Infor["GROUP_PARENT"] = $row["GROUP_PARENT"];
			$Infor["GROUP_USER"]   = $row["GROUP_USER"];
			$Infor["GROUP_PRIV"]   = $row["GROUP_PRIV"];
			$Infor["GROUP_DEPT"]   = $row["GROUP_DEPT"];
			$Infor["GROUP_ORDER"]  = $row["GROUP_ORDER"];
			$Infor["GROUP_GET"]    = $row["GROUP_GET"];
			$Infor["GROUP_DATE"]   = $row["GROUP_DATE"];
			$Infor["USER_ID"]      = $row["USER_ID"];
			array_push($resultArray,$Infor);
		}
		return $resultArray;
	 }

	/**
	*获取通讯录的条数
	*@param  $keyword 通讯录查询的关键字(默认为空)
	*@return $amount  返回的通讯录的条数
	*/
	public function getAddressAmount($keyword=""){
		global $connection;
		$PUR_STR = $this->getPermissionID(1);
		$sql = "
				SELECT COUNT(ADD_ID) AS CNT FROM address
				    WHERE 1
					AND (A10 IN (".SecurityFilter($PUR_STR)."))
				";
		if($keyword) {
			$field[0] = "A1";
			$field[1] = "A4";
			$field[2] = "A5";
			$field[3] = "A6";
			$field[4] = "A7";
			$sql .= getSqlKeyword($keyword,$field);
		}
		$rs	    = exequery($connection,$sql);
		$row    = mysql_fetch_array($rs);
		$amount = $row["CNT"];
		return $amount;
	}

	/**
	*获取通讯录中的信息
	*@param $limit
	*@param $start
	*@param $addid   通讯录的唯一ID号
	*@param $keyword
	*@return $addData
	*/
	public function getAddressInfo($limit=0,$start=0,$addid="",$keyword=""){
		global $connection;
		$limit = $limit>0?$limit:$this->default_limit;
		$start = $start>0?$start:$this->default_start;
		$PUR_STR = $this->getPermissionID(1);
		$sql = "
				SELECT * FROM address
				    WHERE 1
				    AND (A10 IN (".SecurityFilter($PUR_STR)."))
				";
		if($addid != ""){
			$sql .= " AND ADD_ID=".SecurityFilter($addid)." ";
		}
		if($keyword){
			$field[0] = "A1";
			$field[1] = "A4";
			$field[2] = "A5";
			$field[3] = "A6";
			$field[4] = "A7";
			$sql .= getSqlKeyword($keyword,$field);
		}
		$sql .= " ORDER BY A13 ASC LIMIT ".SecurityFilter($start).",".SecurityFilter($limit)."";
		$rs   = exequery($connection,$sql);
		$i    = $start;
		while($row = mysql_fetch_array($rs)) {
			$addData[$i]['ADD_ID']      = $row['ADD_ID'];
			$addData[$i]['ADD_TYPE']    = $row['ADD_TYPE'];
			$addData[$i]['THUMB_IMAGE'] = $row['THUMB_IMAGE'];
			$addData[$i]['FRIST_IMAGE'] = $row['FRIST_IMAGE'];
			for($j=1;$j<=40;$j++){
				$subfix = "A".$j;
				$addData[$i][$subfix] = $row[$subfix];
			}
			$i++;
		}
		return $addData;
	}

	/**
	*获取字段名
	*@return $itemData 返回字段的数据
	*/
	public function getAddItemName(){
		global $connection;
		$sql ="
			   SELECT * FROM add_item
			       WHERE 1 AND ITEM_NAME<>'' ORDER BY ITEM_ID ASC";
		$rs = exequery($connection,$sql);
		$i  = 1;
		while($row = mysql_fetch_array($rs)){
			$subfix = "A".$i;
			$itemData[$i]["ITEM_NAME"]      = $row['ITEM_NAME'];
			$itemData[$i]["ITEM_SYS"]       = $row['ITEM_SYS'];
			$itemData[$i]["ITEM_IMPORTENT"] = $row['ITEM_IMPORTENT'];
			$itemData[$i]["ITEM_TYPE"]      = $row['ITEM_TYPE'];
			$itemData[$i]["ITEM_ORDER"]     = $row['ITEM_ORDER'];
			$itemData[$i]["SUBFIX"]         = $subfix;
			$i++;
		}
		return $itemData;
	}

	/**
	*
	*@param  $addid   通讯录中唯一的ID
	*@param  $flag    初始为next
	*@return $smsData 返回的为内部消息的信息
	*/
	public function getPreNextAddress($addid,$flag="next"){
		global $connection;
		if($smsid){
			$sql = "
					SELECT * FROM sms
					    WHERE 1
					    AND TO_ID='".SecurityFilter($this->userid)."'
					    AND SEND_TIME<'".SecurityFilter($this->curdatetime)."'
				   ";
			switch ($flag) {
				case "next":
					$sql .= " AND SMS_ID>'".SecurityFilter($smsid)."' ORDER BY SMS_ID ASC LIMIT 0,1";
					break;
				case "pre":
					$sql .= " AND SMS_ID<'".SecurityFilter($smsid)."' ORDER BY SMS_ID DESC LIMIT 0,1";
					break;
			}
			$rs        = exequery($connection,$sql);
			$row       = mysql_fetch_array($rs);
			$resmsid   = $row["SMS_ID"];
			$resubject = $row["CONTENT"];
		}
		$smsData["smsid"] = $resmsid;
		$smsData["subject"] = $resubject;
		return $smsData;
	}

	/**
	*根据通讯录分组获取通讯录的信息
	*@param  $GROUP_TYPE    通讯录组的类别
	*@return $RETURN_STR/0  返回对应组的通讯录的信息(为空则为0)
	*/
	public function getPermissionID($GROUP_TYPE){
		global $connection;
		$query = "
				 SELECT GROUP_ID FROM address_group
					 WHERE  GROUP_TYPE = $GROUP_TYPE
				 ";
		if($GROUP_TYPE==1){
			$query.="
					AND (
						GROUP_DEPT = 'ALL_DEPT'
						OR((INStr(GROUP_DEPT,',".SecurityFilter($this->deptid).",')>0 OR INStr(GROUP_DEPT,'".SecurityFilter($this->deptid).",')=1)
						   OR
						   (INStr(GROUP_PRIV,',".SecurityFilter($this->uesrpriv).",')>0 OR INStr(GROUP_PRIV,'".SecurityFilter($this->uesrpriv).",')=1)
						   OR
						   (InStr(GROUP_USER,'".SecurityFilter($this->userid).",')>0 OR INStr(GROUP_USER,'".SecurityFilter($this->userid).",')=1)))
					";
		} else {
			$query.="
					AND USER_ID = '".SecurityFilter($this->userid)."'
				";
		}
		$res = exequery($connection,$query);
		while ($ROW = mysql_fetch_array($res)){
			$PURVIEW_STR = $ROW['GROUP_ID'];
			$RETURN_STR.= $PURVIEW_STR.",";
		}
		if($RETURN_STR!="") {
			return substr($RETURN_STR,0,-1);
		} else {
			return 0;
		}
	}

	/**
	*SQL语句参数的字符替换处理
	*@param  $pars    传入的SQL参数
	*@return $sqlPar
	*/
	private function returnSqlPar($pars){
		$sqlPar = is_array($pars)?implode(",",$pars):$pars;
		if (substr($sqlPar,-1,1) == ",") {
			$sqlPar = substr($sqlPar,0,strlen($sqlPar)-1);
		}

		$sqlPar = "'".str_replace(",","','",$sqlPar)."'";
		return $sqlPar;
	}
	/**
	*通过以下3个函数的配合递归的取出当前GROUP_ID下共有多少子菜单
	*@param   $GROUP_ID 当前的 GROUP_ID
	*@return   $all_group  一个字符串，包含所有子菜单ID，用“,”分割
	*调用时调用get_all_group()函数，传入当前GROUP_ID
	*/
	//取当前GROUP_ID下有多少子菜单
	function get_son_group($GROUP_ID)
	{
		global $connection;
		$sql = "SELECT GROUP_ID FROM address_group WHERE GROUP_PARENT = '".SecurityFilter($GROUP_ID)."' ORDER BY GROUP_ID ASC";
		$cur = exequery($connection,$sql);
		while($row = mysql_fetch_array($cur))
		{
			$value .= $row['GROUP_ID'].",";
		}
		return $value;
	}
	function get_sonall_group($GROUP_ID)
	{
		global $grou_array;
		$value_2 = $this->get_son_group($GROUP_ID);
		if($value_2 != "")
		{
			$value_1 = substr($value_2,0,-1);
			$arr = explode(",",$value_1);
			foreach($arr as $val)
			{
				$group_all = $this->get_son_group($val);
				if($group_all != "")
				{
					array_push($grou_array,$group_all);
					$group_all = $this->get_sonall_group($val);
				}
			}
		}
	}
	function get_all_group($GROUP_ID)
	{
		global $grou_array;
		$first_son = $this->get_son_group($GROUP_ID);
		array_push($grou_array,$first_son);
		$this->get_sonall_group($GROUP_ID);
		foreach ($grou_array as $allarr)
		{
			$all_group .= $allarr;
		}
		$all_group = substr($all_group,0,-1);
		return $all_group;
	}
	/**
	*取当前GROUP_ID下有多少条记录
	*@param    $ADDRESS_TYPE 通讯录类别，公共或个人
	*@param    $GROUP_ID 当前点击的目录
	*@return   $ADDRESS_COUNT  当前类别下的联系人条数
	*/
	function get_address_count($ADDRESS_TYPE,$GROUP_ID,$f)
	{
		global $connection;
		$LOGIN_USER_ID = $this->userid;
		$LOGIN_DEPT_ID = $this->deptid;
		$LOGIN_PRIV_ID = $this->uesrpriv;
		$all_group_id  = $this->get_all_group($GROUP_ID);
		if($ADDRESS_TYPE == "2")
		{
			if($GROUP_ID == "")
				$query = "SELECT count(*) FROM address
							WHERE A11 = '".SecurityFilter($LOGIN_USER_ID)."'
							AND add_type = '".SecurityFilter($ADDRESS_TYPE)."'";
			else if($GROUP_ID != "" && $all_group_id != "")
			{
				$all_group_id = $all_group_id.",".$GROUP_ID;
				$query = "SELECT count(*) FROM address_group adg, address addd
							WHERE adg.`GROUP_ID` = addd.`A10`
							AND A11 = '".SecurityFilter($LOGIN_USER_ID)."'
							AND add_type = '".SecurityFilter($ADDRESS_TYPE)."'
							AND adg.GROUP_ID IN (".SecurityFilter($all_group_id).")";
			}
			else
			{
				$query = "SELECT count(*) FROM address_group adg, address addd
							WHERE adg.`GROUP_ID` = addd.`A10`
							AND A11 = '".SecurityFilter($LOGIN_USER_ID)."'
							AND add_type = '".SecurityFilter($ADDRESS_TYPE)."'
							AND adg.GROUP_ID ='".SecurityFilter($GROUP_ID)."'";
			}
		}
		else
		{
			//如果是admin,显示所有.
			if($LOGIN_USER_ID == "admin" && $f=="")
			{
				if($GROUP_ID == "")
					$query = "SELECT count(*) FROM address_group adg, address addd
							 WHERE  adg.`GROUP_ID` = addd.`A10`
							 AND add_type = '".SecurityFilter($ADDRESS_TYPE)."'";
				else if($GROUP_ID != "" && $all_group_id != "")
				{
					$all_group_id = $all_group_id.",".$GROUP_ID;
					$query = "SELECT count(*) FROM address_group adg, address addd
							 WHERE adg.`GROUP_ID` = addd.`A10`
							 AND add_type = '".SecurityFilter($ADDRESS_TYPE)."'
							 AND adg.GROUP_ID IN (".SecurityFilter($all_group_id).")";
				}
				else
				{
					$query = "SELECT count(*) FROM address_group adg, address addd
							 WHERE adg.`GROUP_ID` = addd.`A10`
							 AND add_type = '".SecurityFilter($ADDRESS_TYPE)."'
							 AND adg.GROUP_ID = '".SecurityFilter($GROUP_ID)."'";
				}
			}
			else
			{
				if($GROUP_ID == "")
					$query = "SELECT count(*) FROM address_group adg, address addd
							 WHERE  adg.`GROUP_ID` = addd.`A10`
							 AND ( adg.`group_user` LIKE '%".SecurityFilter($LOGIN_USER_ID)."%' OR adg.group_dept = 'ALL_DEPT'
							 OR((INStr(adg.GROUP_DEPT,',".SecurityFilter($LOGIN_DEPT_ID).",')>0 OR INStr(adg.GROUP_DEPT,'".SecurityFilter($LOGIN_DEPT_ID).",')=1)
							 OR
							 (INStr(adg.GROUP_PRIV,',".SecurityFilter($LOGIN_PRIV_ID).",')>0 OR INStr(adg.GROUP_PRIV,'".SecurityFilter($LOGIN_PRIV_ID).",')=1)
							 OR
							 (InStr(adg.GROUP_USER,'".SecurityFilter($LOGIN_USER_ID).",')>0 OR INStr(adg.GROUP_USER,'".SecurityFilter($LOGIN_USER_ID).",')=1)))";
				else if($GROUP_ID != "" && $all_group_id != "")
				{
					$all_group_id = $all_group_id.",".$GROUP_ID;
					$query = "SELECT count(*) AS CNT FROM address_group adg, address addd
							 WHERE adg.`GROUP_ID` = addd.`A10`
							 AND ( adg.`group_user` LIKE '%".SecurityFilter($LOGIN_USER_ID)."%' OR adg.group_dept = 'ALL_DEPT'
							 OR((INStr(adg.GROUP_DEPT,',".SecurityFilter($LOGIN_DEPT_ID).",')>0 OR INStr(adg.GROUP_DEPT,'".SecurityFilter($LOGIN_DEPT_ID).",')=1)
							 OR
							 (INStr(adg.GROUP_PRIV,',".SecurityFilter($LOGIN_PRIV_ID).",')>0 OR INStr(adg.GROUP_PRIV,'".SecurityFilter($LOGIN_PRIV_ID).",')=1)
							 OR
							 (InStr(adg.GROUP_USER,'".SecurityFilter($LOGIN_USER_ID).",')>0 OR INStr(adg.GROUP_USER,'".SecurityFilter($LOGIN_USER_ID).",')=1)))
							 AND adg.GROUP_ID IN (".SecurityFilter($all_group_id).")";
				}
				else
				{
					$query = "SELECT count(*) FROM address_group adg, address addd
							 WHERE adg.`GROUP_ID` = addd.`A10`
							 AND ( adg.`group_user` LIKE '%".SecurityFilter($LOGIN_USER_ID)."%' OR adg.group_dept = 'ALL_DEPT'
							 OR((INStr(adg.GROUP_DEPT,',".SecurityFilter($LOGIN_DEPT_ID).",')>0 OR INStr(adg.GROUP_DEPT,'".SecurityFilter($LOGIN_DEPT_ID).",')=1)
							 OR
							 (INStr(adg.GROUP_PRIV,',".SecurityFilter($LOGIN_PRIV_ID).",')>0 OR INStr(adg.GROUP_PRIV,'".SecurityFilter($LOGIN_PRIV_ID).",')=1)
							 OR
							 (InStr(adg.GROUP_USER,'".SecurityFilter($LOGIN_USER_ID).",')>0 OR INStr(adg.GROUP_USER,'".SecurityFilter($LOGIN_USER_ID).",')=1)))
							 AND adg.GROUP_ID = '".SecurityFilter($GROUP_ID)."'";
				}
			}
		}
		$cursor = exequery($connection,$query);
		if ($ROW=mysql_fetch_array($cursor))
			$ADDRESS_COUNT=$ROW[0];
		return $ADDRESS_COUNT;
	}
	/**
	*取当前group_id的目录名称
	*@param    $group_id 目录ID
	*@return   $group_name  当前目录ID对应的目录名称
	*/
	function get_group_name($group_id)
	{
		global $connection;
		$query = "SELECT group_name FROM address_group WHERE group_id = '".SecurityFilter($group_id)."'";
		$cursor = exequery($connection,$query);
		if ($ROW=mysql_fetch_array($cursor))
			$group_name = $ROW["group_name"];
		return $group_name;
	}
	/**
	*判断当前ADD_ID是否有权限
	*@param    $add_id 联系人ID
	*@return   1 有权限 0 没有权限
	*/
	function get_limit_of_id($add_id,$f)
	{
		global $connection;
		$LOGIN_USER_ID = $this->userid;
		$LOGIN_DEPT_ID = $this->deptid;
		$LOGIN_PRIV_ID = $this->uesrpriv;
		$query = "SELECT * FROM address WHERE add_id = '".SecurityFilter($add_id)."'";
		$cursor = exequery($connection,$query);
		if ($ROW=mysql_fetch_array($cursor))
		{
			$add_type = $ROW["ADD_TYPE"];
			$A11      = $ROW["A11"];
			$A10      = $ROW["A10"];
		}
		if($add_type == 2)
		{
			if($LOGIN_USER_ID == $A11)
				return 1;
			else
				return 0;
		}
		else
		{
			$query1 = "SELECT * FROM address_group adg, address addd
							 WHERE adg.`GROUP_ID` = addd.`A10`
							 AND ( adg.`group_user` LIKE '%".SecurityFilter($LOGIN_USER_ID)."%' OR adg.group_dept = 'ALL_DEPT'
							 OR((INStr(adg.GROUP_DEPT,',".SecurityFilter($LOGIN_DEPT_ID).",')>0 OR INStr(adg.GROUP_DEPT,'".SecurityFilter($LOGIN_DEPT_ID).",')=1)
							 OR
							 (INStr(adg.GROUP_PRIV,',".SecurityFilter($LOGIN_PRIV_ID).",')>0 OR INStr(adg.GROUP_PRIV,'".SecurityFilter($LOGIN_PRIV_ID).",')=1)
							 OR
							 (InStr(adg.GROUP_USER,'".SecurityFilter($LOGIN_USER_ID).",')>0 OR INStr(adg.GROUP_USER,'".SecurityFilter($LOGIN_USER_ID).",')=1)))
							 AND addd.ADD_ID = '".SecurityFilter($add_id)."'
							 ";
			$cursor1 = exequery($connection,$query1);
			if($f == "" && $LOGIN_USER_ID == "admin")
			{
				return 1;
			}
			else
			{
				if($ROW1= mysql_fetch_array($cursor1))
				{
					return 1;
				}
				else
				{
					return 0;
				}
			}
		}
	}
	/**
	*取编号最小的2个自定义字段的名称和值
	*@param    $add_id 通讯录联系人ID
	*@param    $item_id 自定义字段ID
	*@return   $head_arr 字段名称/$val_arr 字段的值
	*/
	function get_add_item($item_id='',$add_id='')
	{
		global $connection;
		if($add_id=="")
		{
			$query = "SELECT ITEM_ID,ITEM_NAME FROM add_item WHERE ITEM_SYS  = '2' ORDER BY ITEM_ID ASC LIMIT 0 , 2";
			$cursor = exequery($connection,$query);
			while ($ROW=mysql_fetch_array($cursor))
			{
				$head_arr[name][] = $ROW["ITEM_NAME"];
				$head_arr[id][] = $ROW["ITEM_ID"];
			}
			return $head_arr;
		}
		else
		{
			$query = "SELECT `A".SecurityFilter($item_id)."` FROM address WHERE ADD_ID = '".SecurityFilter($add_id)."'";
			$cursor = exequery($connection,$query);
			if ($ROW=mysql_fetch_array($cursor))
			{
				$val_arr = $ROW["A".$item_id];
			}
			return $val_arr;
		}
	}

	/**
	*检测当前组是否有下级组
	*@param  $groupId   通讯录组ID
	*@return $returnFlag
	*/
	function checkIsParentGroup($groupId,$opt,$addresstype)
	{
		global $connection;
		$query  = "SELECT * FROM address_group WHERE 1 ";
		$query .= $opt == 'view' && $addresstype=='1'?" AND (
										GROUP_DEPT = 'ALL_DEPT'
										OR(
										   (INStr(GROUP_DEPT,',".SecurityFilter($LOGIN_DEPT_ID).",')>0
											OR INStr(GROUP_DEPT,'".SecurityFilter($LOGIN_DEPT_ID).",')=1)
										   OR
										   (INStr(GROUP_PRIV,',".SecurityFilter($LOGIN_PRIV_ID).",')>0
											OR INStr(GROUP_PRIV,'".SecurityFilter($LOGIN_PRIV_ID).",')=1)
										   OR
										   (InStr(GROUP_USER,'".SecurityFilter($LOGIN_USER_ID).",')>0
											OR INStr(GROUP_USER,'".SecurityFilter($LOGIN_USER_ID).",')=1)
											))":"";
		$query .= " AND GROUP_PARENT='".SecurityFilter($groupId)."'";

		$res   = exequery($connection,$query);
		$groupNums  = mysql_num_rows($res);
		$returnFlag = $groupNums != 0 ?1:0;
		return $returnFlag;
	}

	/**
	*@function 返回通讯录下级组的信息
	*@param  $groupId 通讯录ID
	*@return $groupInfo
	*/
	function getChildGroup($groupId)
	{
		global $connection;
		$sql = "SELECT * FROM address_group WHERE 1 AND GROUP_PARENT='".SecurityFilter($groupId)."'";
		$res = exequery($connection,$sql);
		$groupNum  = mysql_num_rows($res);
		$groupInfo = array();
		while($row = mysql_fetch_array($res))
		{
			array_push($groupInfo,$row);
		}
		return array("count"=>$groupNum,"list"=>$groupInfo);
	}
        /**
	*获取字段所有信息
	*@return $itemData 返回字段的数据
	*/
	public function getAddItemNameAllInfo(){
		global $connection;
		$sql ="
			   SELECT * FROM add_item
			       WHERE 1 AND ITEM_NAME<>'' ORDER BY ITEM_ID ASC";
		$rs = exequery($connection,$sql);
		$i  = 1;
		while($row = mysql_fetch_array($rs)){
			$subfix = "A".$i;
			$itemData[$i]["ITEM_NAME"]      = $row['ITEM_NAME'];
			$itemData[$i]["ITEM_SYS"]       = $row['ITEM_SYS'];
			$itemData[$i]["ITEM_IMPORTENT"] = $row['ITEM_IMPORTENT'];
			$itemData[$i]["ITEM_TYPE"]      = $row['ITEM_TYPE'];
			$itemData[$i]["ITEM_ORDER"]     = $row['ITEM_ORDER'];
                        $itemData[$i]["ITEM_PROPERTY"]  = $row['ITEM_PROPERTY'];
			$itemData[$i]["ITEM_DEFAULT"]   = $row['ITEM_DEFAULT'];
                        $itemData[$i]["ITEM_SEARCH"]    = $row['ITEM_SEARCH'];
			$itemData[$i]["ITEM_EXPLAIN"]   = $row['ITEM_EXPLAIN'];
			$itemData[$i]["SUBFIX"]         = $subfix;
			$i++;
		}
		return $itemData;
	}
}
?>