<?php

/**
 * @Copyright (C) 2010 - 2011 Weaver Co.Ltd
 * @systemname:       E-Office
 * @filename:         api/attend.class.php
 * @function:         我的人事
 * @encoding:         $_lang['encoding']
 * @author:           www.weaver.com.cn
 * @modify:			dingp
 * @date:             2013-03-27
 * @file Version:     41.0
 * @eoffice Version:  8.3
 */
include_once("inc/utility.php");
include_once("inc/utility_all.php");
include_once("inc/function_usergeneral.php");
includelangpak("hr");

/**
 * @access public
 * @auth sm
 */
class attend {

    /**
     * 解析出首页页面的信息
     * @param 
     */
    function analysisIndexPage($params) {
        global $_lang;
        $dayMassage = $this->getDutyDayMessage($params);
        $signInTime = $dayMassage['SIGN_IN_TIME'];
        $signOutTime = $dayMassage['SIGN_OUT_TIME'];
        $signType = $dayMassage['DUTY_TYPE'];
        $isDutyVacation = $this->isAttendData('');

        //获取用户假期	
        $dataTypeStr = $isDutyVacation ? '<span >' . $_lang["hr_check_in_workday"] . '</span>' : $_lang["hr_check_in_weekday"]; //根据假期判断是工作日还是休息
        $CUR_DATE = date("Y-m-d", time());
        $signInState = $signInTime ? 'none' : '';
        $signOutState = $signInState ? '' : 'none';
        //签到和签退的方法,signAction('in')和signAction('out')!
        $signInputIn = "<input type='button' class='button' value=" . $_lang["hr_attendtype_sign_in"] . " onclick=\"signAction('in')\" id='sign_in' style='display:" . $signInState . "'>";
        $signInputOut = "<input type='button' class='button' value=" . $_lang["hr_attendtype_sign_out"] . " onclick=\"signAction('out')\" id='sign_out' style='display:" . $signOutState . "'>";
        $signInput = $signInTime ? $signInputOut : $signInputIn . $signInputOut;
        $signDiffTime = round($dayMassage['IN_TIME_DIFF'] / 60, 2);

        if ($signType == 2 && abs($signDiffTime) > 0) {//判断迟到还是正常签到!根据$signType是否为2来判断
            $signDiffTimeStr = "<span style='color:red'>" . $_lang["hr_duty_late"];
            $signDiffTimeStr.= abs($signDiffTime) . $_lang["hr_duty_time_minute"] . "</span>";
        } else {
            $signDiffTimeStr = "<span>" . $_lang["hr_attend_sign_in_normal"] . "</sapn>";
        }

        //早退还是正常签退!		
        $outTimeDiffValue = $dayMassage['OUT_TIME_DIFF'];
        if ($outTimeDiffValue < 0) {
            $outTimeDiffValue = round($outTimeDiffValue / 60, 2);
            $outDiffTimeStr = "<span style='color:red'>" . $_lang["hr_duty_leave_early"];
            $outDiffTimeStr.= abs($outTimeDiffValue) . $_lang["hr_duty_time_minute"] . "</span>";
        } else {
            $outDiffTimeStr = "<span>" . $_lang["hr_attend_sign_out_normal"] . "</sapn>";
        }

        //未签到和签退		
        $daySignIn = $signInTime ? date('H:i', $signInTime) . " (" . $signDiffTimeStr . ")" : "<span style='color:red'>" . $_lang["hr_attend_not_sign_in"] . "</span>";
        $daySignOut = $signOutTime ? date('H:i', $signOutTime) . " (" . $outDiffTimeStr . ")" : "<span style='color:red'>" . $_lang["hr_attend_not_sign_out"] . "</span>";

        $presentMouthLate = $this->getPresentMouthLate($params, $params["userId"]) != "" ? $this->getPresentMouthLate($params, $params["userId"]) : 0;

        $presentMouthNotOut = $this->getPresentMouthNotSign($params, $params["userId"]) != "" ? $this->getPresentMouthNotSign($params, $params["userId"]) : 0;
        ;
        //请假
        $presentMouthLeave = $this->getPresentMouthLeave($params, $params["userId"]) != "" ? $this->getPresentMouthLeave($params, $params["userId"]) : 0;

        //出差
        $presentMouthOut = $this->getPresentMouthLeaveOut($params, $params["userId"]) != "" ? $this->getPresentMouthLeaveOut($params, $params["userId"]) : 0;

        $presentMouthLeaveEarly = $this->presentMouthLeaveEarly($params, $params["userId"]) != "" ? $this->presentMouthLeaveEarly($params, $params["userId"]) : 0;

        //外出
        $presentMouthOutInfo = $this->getPresentMouthAttendOut($params, $params["userId"]) != "" ? $this->getPresentMouthAttendOut($params, $params["userId"]) : 0;

        //加班
        $presentMouthOverTimeInfo = $this->presentMouthOverTimeInfo($params, $params["userId"]) != "" ? $this->presentMouthOverTimeInfo($params, $params["userId"]) : 0;

        $page.= "<tr><td class='linkDiv'  id='sign_td_in' colspan='2'>" . $_lang["hr_attendtype_sign_in"] . ":" . $daySignIn . "</td></tr>";
        $page.= "<tr><td class='linkDiv' id='sign_td_out' colspan='2'>" . $_lang["hr_attendtype_sign_out"] . ":" . $daySignOut . "</td></tr>";
        $page.= "<tr width='50%'><td class='linkDiv'>" . $_lang["hr_duty_late"] . ":" . $presentMouthLate . $_lang["hr_attendance_times"];
        $page.= "&nbsp;&nbsp;" . $_lang["hr_duty_leave_early"] . ":" . $presentMouthLeaveEarly . $_lang["hr_attendance_times"];
        $page.= "&nbsp;&nbsp;" . $_lang["hr_attend_leak_sign"] . ":" . $presentMouthNotOut . $_lang["hr_attendance_times"] . "</td></tr>";
        $page.= "<tr><td class='linkDiv'>" . $_lang["hr_duty_ask_leave"] . ":" . $presentMouthLeave . $_lang["hr_attendance_times"];
        $page.= "&nbsp;&nbsp;" . $_lang["hr_duty_ask_trip"] . ":" . $presentMouthOut . $_lang["hr_attendance_times"] . "&nbsp;&nbsp;" . $_lang["hr_duty_ask_out"] . ":" . $presentMouthOutInfo . $_lang["hr_attendance_times"] . "&nbsp;&nbsp;" . $_lang["hr_attend_overtimework"] . ":" . $presentMouthOverTimeInfo . $_lang["hr_attendance_times"];
        return "<table width='100%'>" . $page . "</table>";
    }

    /**
     * 获取某一天考勤,=例如早退,迟到,正常签退,签到的值取得后的判断的数据
     * @param array $params
     */
    function getDutyDayMessage($params) {
        global $connection;
        extract($params);
        $startDay = strtotime($thisDay);
        $endDay = strtotime(date("Y-m-d", $startDay + 86400));
        $query = "SELECT * FROM attend_duty 
					    WHERE USER_ID = '" . SecurityFilter($userId) . "'
					    AND (SIGN_IN_TIME >=" . SecurityFilter($startDay) . "
						AND SIGN_IN_TIME <= " . SecurityFilter($endDay) . ")";
        $res = exequery($connection, $query);
        $Row = mysql_fetch_assoc($res);
        return is_array($Row) ? $Row : array();
    }

    /**
     * 获取假期页面的方法
     * @return $page 假期页面信息
     */
    function getVacationPage() {
        global $connection, $_lang;
        $query = "SELECT * FROM attend_vacation ORDER BY ID
				 ";
        $res = exequery($connection, $query);
        while ($Row = mysql_fetch_array($res)) {
            $i++;
            $Id = $Row['ID'];
            $Name = $Row['VACATION_NAME'];
            if ($i == 1) {
                $page = '<table border="0" width="100%" cellspacing="0" cellpadding="0" class="pubtable">';
            }

            $vacationContent = $this->getVacationContent($Id);

            $page.= "<tr><td>" . $Id . "</td>";
            $page.= "<td><a href='javaScript:newVacation(" . $Id . "," . $vacationContent . ")'>" . $Name . "</a></td>";
            $page.= "<td><a href='javaScript:newVacation(" . $Id . "," . $vacationContent . ")'>" . $_lang['hr_modify'] . "</a>&nbsp;&nbsp;<a href='javascript:delVacation(" . $Id . ")'>" . $_lang['hr_delete'] . "</a></td></tr>";
        }

        if ($i != '') {
            $topNameArray[0]['name'] = $_lang["hr_attend_vacation_num"];
            $topNameArray[0]['width'] = '130';
            $topNameArray[1]['name'] = $_lang["hr_attend_vacation_name"];
            $topNameArray[1]['width'] = '';
            $topNameArray[2]['name'] = $_lang["hr_attend_operate"];
            $topNameArray[2]['width'] = '';
            $page.= $this->addTableTop($topNameArray, 3);
        } else {
            Message("", $_lang["hr_attend_leave_not_define"]);
        }
        $page.='</table>';
        return $page;
    }

    function getVacationInfo($limitRows, $limitOffset) {
        global $connection, $_lang;
        $query = "SELECT * FROM attend_vacation ORDER BY ID ";
        $queryCount = "SELECT COUNT(*) AS CNT FROM attend_vacation ORDER BY ID";
        $resCount = exequery($connection, $queryCount);
        $row = mysql_fetch_array($resCount);
        $totalcnt = $row['CNT'];

        if ($limitOffset >= $totalcnt) {
            $limitOffset = max(0, $limitOffset - $limitRows);
        }
        $query .= " LIMIT $limitOffset,$limitRows";
        $res = exequery($connection, $query);
        $result = array();
        while ($Row = mysql_fetch_array($res)) {
            $vacationContent = $this->getVacationContent($Row['ID']);
            $Row['vacationContent'] = $vacationContent;
            array_push($result, $Row);
        }

        return array(
            'totalCount' => $totalcnt,
            'list' => $result
        );
    }

    function getVacationContent($vacation_id) {
        global $connection, $_lang;
        $query = "SELECT * FROM attend_vacation_content WHERE VACATION_ID='" . SecurityFilter($vacation_id) . "' ORDER BY ID DESC";
        $res = exequery($connection, $query);
        if ($row = mysql_fetch_array($res)) {
            $vacation_year = $row["VACATION_YEAR"];
        }
        return $vacation_year;
    }

    /**
     * 获取请假的page	
     */
    function getLeavePage() {
        global $connection, $_lang;
        $query = "SELECT * FROM attend_leavetype ORDER BY TYPE_ID
		 		 ";
        $res = exequery($connection, $query);
        while ($Row = mysql_fetch_array($res)) {
            $i++;
            $leaveId = $Row['TYPE_ID'];
            $leaveName = $Row['TYPE_NAME'];
            $leaveNote = $Row['TYPE_Note'];

            if ($i == 1) {
                $page = '<table border="0" width="100%" cellspacing="1" cellpadding="3" class="pubtable">';
            }

            if ($i % 2 == 1) {
                $TableLine = "TableLine1";
            } else {
                $TableLine = "TableLine2";
            }

            $page.= "<tr class='" . $TableLine . "'><td>" . $leaveId . "</td>";
            $page.= "<td>" . $leaveName . "</td>";
            $page.= "<td>" . $leaveNote . "</td>";
//            $page.= "<td><a href='javaScript:newLeave(" . $Id . ")'>" . $_lang['hr_modify'] . "</a>  <a href='javascript:delLeave(" . $Id . ")'>" . $_lang['hr_delete'] . "</a></td></tr>";
        }

        if ($i != '') {
            $topNameArray[0]['name'] = $_lang["hr_attend_sort_num"];
            $topNameArray[0]['width'] = '130';
            $topNameArray[1]['name'] = $_lang["hr_attend_sort_name"];
            $topNameArray[1]['width'] = '';
            $topNameArray[2]['name'] = $_lang["hr_attend_paid_leave"];
            $topNameArray[2]['width'] = '';
            $topNameArray[3]['name'] = $_lang["hr_attend_operate"];
            $topNameArray[3]['width'] = '';
            $page.= $this->addTableTop($topNameArray, 4);
        } else {
            Message("", $_lang["hr_attend_leave_not_define"]);
        }
        $page.='</table>';
        return $page;
    }

    /*     * 增加表格头
     * $topName
     * $number   增加的行数
     */

    function addTableTop($topName, $number) {
        $topStr = '<thead>';
        for ($i = 0; $i < $number; $i++) {
            $topStr.='<td nowrap width="' . $topName[$i]['width'] . '" >' . $topName[$i]['name'] . '</td>';
        }
        $topStr .= '</thead>';
        return $topStr;
    }

    /**
     * 保存请假类型
     * @param $leaveArray 保存请假的数据
     */
    function saveLeaveType($leaveArray) {
        global $connection;
        extract($leaveArray);

        if ($leaveArray['page_id']) {
            $query = "UPDATE attend_leavetype SET 
					     TYPE_NAME='" . SecurityFilter(trim($leaveArray['leaveName'])) . "',
						 TYPE_NOTE='" . SecurityFilter($leaveArray['leaveNote']) . "'
						 WHERE TYPE_ID='". SecurityFilter($leaveId) ."'
					 ";
        } else {
            $query = "INSERT INTO attend_leavetype
						 (TYPE_NAME,TYPE_NOTE)
						 VALUES
						 ('" . SecurityFilter(trim($leaveArray['leaveName'])) . "','" . SecurityFilter($leaveArray['leaveNote']) . "')
					 ";
        }
        exequery($connection, $query);
    }

    /**
     * 删除请假类型	
     * @param $pageId 请假类型的ID
     */
    function deleteLeaveType($pageId) {
        global $connection;
        $query = "DELETE FROM attend_leave_type
				      WHERE TYPE_ID = ". SecurityFilter($pageId) ."
				 ";
        exequery($connection, $query);
    }

    /**
     * 创建新建假期显示的页面
     * @param $year
     * @param $selectDate
     * @param $colWidth
     */
    function createYearPage($year, $selectDate = array(), $colWidth = '200', $login_lang) {
        global $_lang;
        $daysOfMonth = array(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
        $daysOfMonthLY = array(31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);

        $DofW = array($_lang["hr_attend_week_sun"], $_lang["hr_attend_week_mon"], $_lang["hr_attend_week_tue"], $_lang["hr_attend_week_wen"], $_lang["hr_attend_week_thu"], $_lang["hr_attend_week_fri"], $_lang["hr_attend_week_sat"]);

        $Year = (int) isset($year) ? $year : date('Y');
        $cYear = $Year;

        while ($cYear < 1971) {
            $cYear+=28;
        }

        while ($cYear > 2037) {
            $cYear-=28;
        }

        for ($i = 1; $i <= 12; $i++) {
            $Month = $i;
            if ((($Year % 4 == 0) && ($Year % 100 != 0)) || ($Year % 400 == 0)) {
                $DayOfMonth = $daysOfMonthLY[$Month - 1];
            } else {
                $DayOfMonth = $daysOfMonth[$Month - 1];
            }

            if ($login_lang == 'cn') {
                $mouthValue = $i < 10 ? "0" . $i : $i;
            } else if ($login_lang == 'en') {
                $mouthValue = $i - 1;
            }

            $Week = (int) date('w', strtotime($cYear * 100 + $Month . '01'));
            $pageStr .= '<div style="height:202px;float:left;display:inline"><table class="tableClass" height="200px" width="' . $colWidth . '">';

            if ($login_lang == 'cn') {
                $pageStr .= '<tr><td style="text-align:center;background-color:#CCEEFF;color:#003399;" colspan="7"><b>' . $Year . $_lang["hr_year"] . $mouthValue . $_lang['hr_month'] . '</b></td></tr><tr align="center">';
            } else if ($login_lang == "en") {
                $mouthEn = array("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");
                $mouthValue = $mouthEn[$mouthValue];

                $pageStr .= '<tr><td style="text-align:center;background:#CCEEFF;color:#003399;" colspan="7"><b>' . $mouthValue . " " . $Year . '</b></td></tr><tr align="center">';
            }

            for ($j = 0; $j < 7; $j++) {
                $pageStr .= '<th bgcolor="#EBEBEB">' . $DofW[$j] . '</th>';
            }

            $pageStr .= '</tr><tr align="center">';
            for ($p = 0; $p < $Week; $p++) {
                $pageStr.= '<td bgcolor="#F6F6F6">&nbsp;</td>';
            }

            for ($day = 1; $day <= $DayOfMonth; $day++) {
                $dayValue = $day < 10 ? "0" . $day : $day;
                $MonthValue = $Month < 10 ? "0" . $Month : $Month;
                $dateValue = $Year . "-" . $MonthValue . "-" . $dayValue;
                $parDay = ($day + $Week) % 7 - 1;

                if (in_array($dateValue, $selectDate)) {
                    $colorValue = '#CCCCFF';
                    $title = $_lang["hr_attend_restday"];
                } else {
                    $title = $_lang["hr_attend_clickto_restday"];
                    $colorValue = "#f2f2f2";
                }

                $styleValue = "style='cursor:hand;background-color:" . $colorValue . "'";
                $pageStr .= '<td class="td_date" id="' . $dateValue . '" onclick="CalDay(this)" ' . $styleValue . ' title="' . $title . '" tagweek = "week_' . $parDay . '">';
                $pageStr .= $day . $nongLi['month'] . $nongLi['day'] . "</td>";

                if (($day + $Week) % 7 == 0 && $day != $DayOfMonth) {
                    $pageStr .= '</tr><tr align="center">';
                }
            }

            for ($day--; ($day + $Week) % 7 != 0; $day++) {
                $pageStr .= '<td bgcolor="#F6F6F6">&nbsp;</td>';
            }
            $pageStr .= "</tr></table></div>";
        }
        return $pageStr;
    }

    /**
     * 新建或者编辑的时候,获取星期是哪一天
     * @param $selectWeek
     * @return $weekStr 
     */
    function getWeekSelect($selectWeek) {
        global $_lang;
        $basical = array(0 => $_lang["hr_attend_week_sun"], $_lang["hr_attend_week_mon"], $_lang["hr_attend_week_tue"], $_lang["hr_attend_week_wen"], $_lang["hr_attend_week_thu"], $_lang["hr_attend_week_fri"], $_lang["hr_attend_week_sat"], $_lang["hr_attend_week_sev"], $_lang["hr_attend_week_eig"], $_lang["hr_attend_week_nin"]);

        for ($i = 0; $i < 7; $i++) {
            if ($i == 6) {
                $weekValue = '-1';
            } else {
                $weekValue = $i;
            }
            if (in_array($weekValue, $selectWeek)) {
                $checked = 'checked';
            } else {
                $checked = '';
            }
            $weekStr.= "<input type='checkbox' class='checkbox' id='checkbox" . $weekValue . "' " . $checked . ">";
            $weekStr.= $_lang["hr_attend_week"] . $basical[$i] . '&nbsp;&nbsp;&nbsp;&nbsp;';
        }
        return $weekStr;
    }

    /**
     * 保存假期与日期,星期相关
     * @param 
     */
    function saveVacation($vacationArray) {
        global $connection, $_lang;

        $vacationName = $vacationArray['name'];
        $vacationDate = $vacationArray['date'];
        $vacationYear = $vacationArray['year'];
        $vacationWeek = $vacationArray['week']; //序列化数组
        $vacationId = $vacationArray['id'];
        $query = "SELECT MAX(ID) AS MID FROM attend_vacation_content WHERE VACATION_ID='" . SecurityFilter($vacationId) . "'";
        $res = exequery($connection, $query);
        if ($row = mysql_fetch_array($res)) {
            $vcontentId = $row["MID"];
        }

        if ($vacationId) {
            $query = "UPDATE attend_vacation SET 
					      VACATION_NAME = '". SecurityFilter($vacationName) ."'
						  WHERE ID = '". SecurityFilter($vacationId) ."'
					 ";
            $res = exequery($connection, $query);
            //第一次并未显示插入新数据的sql语句,而是在第二次的时候才显示,
            //因而造成了编辑第一次没有数据因为第一次数据库中没有插入数据!

            $vacationId = SecurityFilter($vacationId);
            $vacationDate = SecurityFilter($vacationDate);
            $vacationWeek = SecurityFilter($vacationWeek);
            $vacationYear = SecurityFilter($vacationYear);

            if (!$this->isVacationYear($vacationId, $vacationYear)) {
                $query_d = "INSERT INTO attend_vacation_content 
						       (VACATION_ID,VACATION_DATE,VACATION_WEEK,VACATION_YEAR)
							    VALUE
							   ('$vacationId','$vacationDate','$vacationWeek','$vacationYear')
						   ";
            } else {
                $query_d = "UPDATE attend_vacation_content SET
							VACATION_DATE = '$vacationDate',
							VACATION_WEEK = '$vacationWeek',
							VACATION_YEAR = '$vacationYear'
							WHERE VACATION_ID = '$vacationId' and ID='$vcontentId'";
            }

            exequery($connection, $query_d);
        } else {
            $vacationName = SecurityFilter($vacationName);
            $query = "INSERT INTO attend_vacation 
					    (VACATION_NAME)VALUE('$vacationName') 
					 ";
            exequery($connection, $query);
            $id = mysql_insert_id();
            $id = SecurityFilter($id);
            $vacationDate = SecurityFilter($vacationDate);
            $vacationWeek = SecurityFilter($vacationWeek);
            $vacationYear = SecurityFilter($vacationYear);
            $query_d = "INSERT INTO attend_vacation_content 
						    (VACATION_ID,VACATION_DATE,VACATION_WEEK,VACATION_YEAR)
							 VALUE
							('$id','$vacationDate','$vacationWeek','$vacationYear')";
            exequery($connection, $query_d);
        }
    }

    /**
     * 取得假期的日期
     */
    function getVacationDate($vacationArray) {
        global $connection;
        $vacationId = $vacationArray['id'];
        $vacationYear = $vacationArray['year'];
        $query = "SELECT VACATION_DATE,VACATION_WEEK FROM attend_vacation_content
					  WHERE VACATION_ID = '". SecurityFilter($vacationId) ."'
					  AND VACATION_YEAR = '". SecurityFilter($vacationYear) ."' ORDER BY ID DESC LIMIT 0,1
				 ";
        $res = exequery($connection, $query);
        if ($Row = mysql_fetch_array($res)) {
            $reArray['vcid'] = $Row['ID'];
            $reArray['date'] = $Row['VACATION_DATE'];
            $reArray['week'] = unserialize($Row['VACATION_WEEK']);
            return $reArray;
        } else {
            return false;
        }
    }

    /**
     * 有假期的年份
     *
     */
    function isVacationYear($vacationId, $vacationYear) {
        global $connection;
        $query = "SELECT VACATION_YEAR FROM attend_vacation_content
				      WHERE VACATION_YEAR = '". SecurityFilter($vacationYear) ."'
					  AND VACATION_ID = '". SecurityFilter($vacationId) ."'
				 ";
        $res = exequery($connection, $query);
        return mysql_fetch_array($res) ? true : false;
    }

    /**
     * 获取假期
     *
     */
    function getVacation($vacationId) {
        global $connection;
        $query = "
				 SELECT VACATION_NAME,VACATION_WEEK FROM attend_vacation
					 WHERE ID = '". SecurityFilter($vacationId) ."'
				 ";
        $res = exequery($connection, $query);
        if ($Row = mysql_fetch_array($res)) {
            $reArray['id'] = $Row['ID'];
            $reArray['name'] = $Row['VACATION_NAME'];
            $reArray['week'] = unserialize($Row['VACATION_WEEK']);
            return $reArray;
        } else {
            return false;
        }
    }

    /**
     * 获取假期类型
     * @param $leaveId 假期类型ID
     */
    function getLeave($leaveId) {
        global $connection;
        $query = "SELECT * FROM attend_leavetype 
				      WHERE TYPE_ID = '". SecurityFilter($leaveId) ."'
				 ";
        $res = exequery($connection, $query);
        if ($Row = mysql_fetch_array($res)) {
            $reArray['leaveId'] = $Row['TYPE_ID'];
            $reArray['leaveName'] = $Row['TYPE_NAME'];
            $reArray['leaveNote'] = $Row['TYPE_NOTE'];
            return $reArray;
        } else {
            return false;
        }
    }

    /**
     * 获取校验类型,考勤批示,选择查询!
     *
     */
    function dutyOptionTypeSelect($select, $fieldName, $valueArray) {
        $selectStr = "<select name='" . $fieldName . "' class='select' width='126'>";
        foreach ($valueArray as $key => $value) {
            if ($key == $select) {
                $selectStr .= "<option value='" . $key . "' selected>" . $value . "</option>";
            } else {
                $selectStr .= "<option value='" . $key . "'>" . $value . "</option>";
            }
        }
        return $selectStr . "</select>";
    }

    /**
     * 获取假期选择---考勤批示下，审批类型选择
     */
    function getLeaveSelectType($selectName, $leaveId = '') {
        global $connection, $_lang;
        $query = "
					SELECT TYPE_ID,TYPE_NAME FROM attend_leave_type
				";
        $res = exequery($connection, $query);
        $selectStr = "<select name = '" . $selectName . "' class='select' >";
        if ($leaveId == all) {
            $selectStr.="<option value='all' selected>" . $_lang["hr_attend_no_condition"] . "</option>";
        }

        while ($Row = mysql_fetch_assoc($res)) {
            $leaveName = $Row['TYPE_NAME'];
            $leaveId = $Row['TYPE_ID'];
            $selectStr.="<option value='" . $leaveId . "' " . $vacationCheck . ">" . $leaveName . "</option>";
        }
        return $selectStr . "</select>";
    }

    /**
     * 获取假期名称
     * @param $id 假期ID
     */
    function getLeaveTypeNameById($id) {
        global $connection, $_lang;
        if ($id > 2) {
            $query = "
					SELECT TYPE_NAME FROM attend_leave_type 
						WHERE TYPE_ID = '". SecurityFilter($id) ."'
					";
            $res = exequery($connection, $query);
            $Row = mysql_fetch_array($res);
            return $Row['TYPE_NAME'];
        } else {
            switch ($id) {
                case "1":
                    return $_lang["hr_attend_overtimework"];
                    break;
                case "2":
                    return $_lang["hr_duty_ask_trip"];
                    break;
            }
        }
    }

    function getleavetypeInfo($limitRows, $limitOffset) {
        global $connection;
        $query = "SELECT * FROM attend_leavetype ";
        $queryCount = "SELECT COUNT(*) AS CNT FROM attend_leavetype";
        $resCount = exequery($connection, $queryCount);
        $Row = mysql_fetch_array($resCount);
        $totalcnt = $Row['CNT'];

        if ($limitOffset >= $totalcnt) {
            $limitOffset = max(0, $limitOffset - $limitRows);
        }
        $query .= " LIMIT $limitOffset,$limitRows";
        $res = exequery($connection, $query);
        $result = array();
        while ($row = mysql_fetch_array($res)) {
            array_push($result, $row);
        }
        return array(
            'totalCount' => $totalcnt,
            'list' => $result
        );
    }

    /**
     * 假期的日期
     */
    function isVacationDate($vacationId) {
        global $connection;
        $nowDate = date('Y-m-d');
        $nowYear = date('Y');
        $query = "SELECT VACATION_ID FROM attend_vacation_content 
					    WHERE (INSTR(VACATION_DATE,',". SecurityFilter($nowDate) ."')=1
						OR 
						INSTR(VACATION_DATE,', ". SecurityFilter($nowDate) .",')>1)
						AND VACATION_ID = '". SecurityFilter($vacationId) ."'
						AND VACATION_YEAR = '". SecurityFilter($nowYear) ."'
				   ";
        $res = exequery($connection, $query);
        return $Row = mysql_fetch_array($res) ? true : false;
    }

    /**
     * 删除假期
     * @param 假期ID
     */
    function deleteVacation($vacationId) {
        global $connection;
        $sql = "SELECT count(*) as CNT FROM ATTEND_CONFIG WHERE DUTY_VACATION='" . SecurityFilter($vacationId) . "'";
        $res = exequery($connection, $sql);
        if ($row = mysql_fetch_array($res)) {
            $vCount = $row["CNT"];
            if ($vCount == 0) {
                $query = "DELETE FROM attend_vacation 
						      WHERE ID = ". SecurityFilter($vacationId) ."
						 ";
                $res = exequery($connection, $query);
                $query_v = "DELETE FROM attend_vacation_content  
								WHERE VACATION_ID = ". SecurityFilter($vacationId) ."
						   ";
                $res_v = exequery($connection, $query_v);
                return $res_v && $res ? true : false;
            } else {
                return false;
            }
        }
    }

    /**
     * 选择年份
     */
    function selectYears($selectName, $selectYear = "") {
        $selectYear = $selectYear ? $selectYear : date('Y');
        $nowYear = date('Y');
        $maxYear = $nowYear + 20;
        $selectStr = "<select name = '" . $selectName . "' class='select' onchange='changeDate(this)'>";
        for ($i = $selectYear; $i < $maxYear; $i++) {
            $selectValue = $selectYear == $i ? 'selected' : '';
            $selectStr .= "<option value='" . $i . "' " . $selectValue . ">" . $i . $_lang["hr_year"] . "</option>";
        }
        $selectStr .= "</select>";
        return $selectStr;
    }

    /**
     * 保存排班,判断新建或者编辑两次$dutyUser的不同!
     */
    function saveDuty($dutyArray) {
        global $connection;
        extract($dutyArray);
        $sqlAction = $dutyId ? "UPDATE" : "INSERT INTO";
        $sqlWhere = $dutyId ? "WHERE DUTY_ID = ". SecurityFilter($dutyId) ." " : "";
        $query = " 
				 $sqlAction attend_config SET 
					  DUTY_NAME = '". SecurityFilter($dutyName) ."',
					  DUTY_SIGN_IN = '". SecurityFilter($dutySignIn) ."',
					  DUTY_SIGN_OUT = '". SecurityFilter($dutySignOut) ."',
					  DUTY_LOGIN = '". SecurityFilter($dutyLogin) ."',
					  DUTY_USE='". SecurityFilter($dutyIsUse) ."',
					  DUTY_VACATION = '". SecurityFilter($dutyVacation) ."'
					  $sqlWhere
				 ";
        exequery($connection, $query);
        if ($dutyUser) {
            $thisId = $dutyId ? $dutyId : mysql_insert_id();
            if (substr($dutyUser, -1, 1) == ",") {
                $dutyUser = substr($dutyUser, 0, strlen($dutyUser) - 1);
            }
            $dutyUser = "'" . str_replace(",", "','", $dutyUser) . "'";
            $query_d = "
                        UPDATE USER SET DUTY_TYPE =''
                            WHERE USER_ID NOT IN(". SecurityFilter($dutyUser) .") AND DUTY_TYPE=". SecurityFilter($thisId) ."
                       ";
            exequery($connection, $query_d);
            $query_u = "
						UPDATE USER SET DUTY_TYPE = ". SecurityFilter($thisId) ."
						    WHERE USER_ID IN(". SecurityFilter($dutyUser) .")
					   ";
        } else {
            $query_u = "
						UPDATE USER SET DUTY_TYPE = ''
							WHERE USER_ID IN(". SecurityFilter($dutyUser) .")
					   ";
        }
        exequery($connection, $query_u);
    }

    /**
     * 删除排班
     * @param $dutyId 排班ID
     */
    function deleteDuty($dutyId) {
        global $connection;
        $query = "
				 DELETE FROM attend_config 
					WHERE DUTY_ID = '". SecurityFilter($dutyId) ."'
				 ";
        exequery($connection, $query);
    }

    /**
     * 假期选择
     */
    function selectVacation($VacationSendId = null) {
        global $connection;
        $query = "
				 SELECT VACATION_NAME,ID FROM attend_vacation
				 ";
        $res = exequery($connection, $query);
        $selectStr = "<select name='dutyVacation' class='select'>";
        while ($Row = mysql_fetch_array($res)) {
            $vacationId = $Row['ID'];
            $vacationName = $Row['VACATION_NAME'];
            $vacationCheck = $vacationId == $VacationSendId ? 'selected' : '';
            $selectStr .= "<option value='" . $vacationId . "' " . $vacationCheck . ">" . $vacationName . "</option>";
        }
        return $selectStr . "</select>";
    }

    /**
     * 获取假期名称
     */
    function getVacationName($vacationId) {
        global $connection;
        $query = "
				 SELECT VACATION_NAME FROM attend_vacation
				     WHERE ID = '". SecurityFilter($vacationId) ."'
				 ";
        $res = exequery($connection, $query);
        $Row = mysql_fetch_array($res);
        return $Row['VACATION_NAME'];
    }

    /**
     * 获取使用该排班人员
     * @param $dutyId 排班ID
     */
    function getDutyUserFromUser($dutyId) {
        global $connection;
        $query = "
				 SELECT USER_ID,USER_NAME FROM USER 
					WHERE DEPT_ID >0 and DUTY_TYPE = '". SecurityFilter($dutyId) ."'
				 ";
        $res = exequery($connection, $query);
        $count = 0;
        while ($Row = mysql_fetch_array($res)) {
            $count++;
            $userId = $Row['USER_ID'];
            $userName = $Row['USER_NAME'];
            $returnId .= $userId . ",";
            $returnName .= $userName . ",";
        }
        $returnArray['userId'] = $returnId;
        $returnArray['userName'] = $returnName;
        return $returnArray;
    }

    /**
     * 获取排班列表
     */
    function getDutyPage() {
        global $connection, $_lang;
        $query = "
				 SELECT * FROM attend_config ORDER BY DUTY_ID
				 ";
        $res = exequery($connection, $query);
        while ($Row = mysql_fetch_array($res)) {
            $i++;
            $Id = $Row['DUTY_ID'];
            $Name = $Row['DUTY_NAME'];
            $signIn = $Row['DUTY_SIGN_IN'];
            $signOut = $Row['DUTY_SIGN_OUT'];
            $dutyLogin = $Row['DUTY_LOGIN'];
            $dutyUserArray = $this->getDutyUserFromUser($Id);
            $dutyLoginValue = $dutyLogin == 1 ? $_lang['hr_field_yes'] : $_lang['hr_field_no'];
            $dutyUser = $dutyUserArray['userId'];
            $dutyVacation = $Row['DUTY_VACATION'];
            //获取最新假期的年份
            $dutyVacationYear = $this->getVacationYear($dutyVacation);
            $dutyVacationStr = $this->getVacationName($dutyVacation);
            $dutyUserName = $dutyUserArray['userName'];
            $dutyUserStr = $this->substrUtf8($dutyUserName, '31', '...');
            $vacationContent = $this->getVacationContent($dutyVacation);

            if ($i == 1) {
                $page = '<table border="0" width="100%" cellspacing="0" cellpadding="0" class="pubtable" style="margin-top:5px;">';
            }
            $page .= "<tr><td>" . $Id . "</td>";
            $page .= "<td><a href='javaScript:editDuty(" . $Id . ")' title='$Name'>" . substrGB($Name, "3", "...") . "</a></td>";
            $page .= "<td>" . $signIn . "</td>";
            $page .= "<td>" . $signOut . "</td>";
            $page .= "<td><a href='javascript:newVacation(" . $dutyVacation . "," . $dutyVacationYear["VACATION_YEAR"] . ")'>" . substrGB($dutyVacationStr, "5", "...") . "</a></td>";
            $page .= "<td>" . $dutyLoginValue . "</td>";
            $page .= "<td title='" . $dutyUserName . "'><a onclick=\"return hs.htmlExpand( this, { objectType: 'iframe',width:'665',height:'500',align:'center',captionText:'<span id=\'smsdiaglog\' style=\'color:#1d93d3;font-weight:bold;\' >&nbsp;" . $_lang['hr_people_search_result'] . "</span>',captionOverlay: { position: 'toppanel'}} )\" href='/general/info/user/search_schedule.php?duty_type=" . $Id . "'>" . $dutyUserStr . "</a></td>";

            if ($dutyUserName == '') {
                $page .= "<td><a href='javaScript:editDuty(" . $Id . ")'>" . $_lang['hr_modify'] . "</a> <a href='javascript:delDuty(" . $Id . ")'>" . $_lang['hr_delete'] . "</a></td></tr>";
            } else {
                $page .= "<td><a href='javaScript:editDuty(" . $Id . ")'>" . $_lang['hr_modify'] . "</a></td></tr>";
            }
        }
        if ($i != '') {
            $topNameArray[0]['name'] = $_lang["hr_number"];
            $topNameArray[0]['width'] = '5%';
            $topNameArray[1]['name'] = $_lang["hr_user_dutytype"];
            $topNameArray[1]['width'] = '8%';
            $topNameArray[2]['name'] = $_lang["hr_attend_sign_in"];
            $topNameArray[2]['width'] = '8%';
            $topNameArray[3]['name'] = $_lang["hr_attend_sign_out"];
            $topNameArray[3]['width'] = '8%';
            $topNameArray[4]['name'] = $_lang["hr_attend_vacation"];
            $topNameArray[4]['width'] = '9%';
            $topNameArray[5]['name'] = $_lang["hr_sign_in_auto_default"];
            $topNameArray[5]['width'] = '11%';
            $topNameArray[6]['name'] = $_lang["hr_duty_turns_users"];
            $topNameArray[6]['width'] = '';
            $topNameArray[7]['name'] = $_lang["hr_attend_operate"];
            $topNameArray[7]['width'] = '10%';
            $page.= $this->addTableTop($topNameArray, 8);
        } else {
            Message("", $_lang["hr_duty_not_have_definition"]);
        }
        $page.='</table>';
        return $page;
    }

    function getDutyScheduleInfo($limitRows, $limitOffset) {
        global $connection, $_lang;
        $query = "
                 SELECT * FROM attend_config ORDER BY DUTY_ID";

        $queryCount = "
                 SELECT COUNT(*) AS CNT FROM attend_config ORDER BY DUTY_ID
                 ";
        $resCount = exequery($connection, $queryCount);
        $row = mysql_fetch_array($resCount);
        $totalcnt = $row['CNT'];

        if ($limitOffset >= $totalcnt) {
            $limitOffset = max(0, $limitOffset - $limitRows);
        }
        $query .= "  LIMIT $limitOffset,$limitRows";
        $res = exequery($connection, $query);
        $result = array();
        while ($Row = mysql_fetch_array($res)) {
            $dutyUserArray = $this->getDutyUserFromUser($Row['DUTY_ID']);
            $dutyLoginValue = $Row['DUTY_LOGIN'] == 1 ? $_lang['hr_field_yes'] : $_lang['hr_field_no'];
            $dutyUser = $dutyUserArray['userId'];
            //获取最新假期的年份
            $dutyVacationYear = $this->getVacationYear($Row['DUTY_VACATION']);
            $dutyVacationStr = $this->getVacationName($Row['DUTY_VACATION']);
            $dutyUserName = $dutyUserArray['userName'];
            $Row['dutyLoginValue'] = $dutyLoginValue;
            $Row['dutyUserName'] = $dutyUserName;
            $Row['dutyVacationStr'] = $dutyVacationStr;
            $Row['VACATION_YEAR'] = $dutyVacationYear["VACATION_YEAR"];
            array_push($result, $Row);
        }

        return array(
            'totalCount' => $totalcnt,
            'list' => $result
        );
    }

    function getVacationYear($vacation_id) {
        global $connection;
        $query = "SELECT * FROM attend_vacation_content 
					  WHERE VACATION_ID='" . SecurityFilter($vacation_id) . "' ORDER BY ID DESC LIMIT 0,1";
        $res = exequery($connection, $query);
        if ($row = mysql_fetch_array($res)) {
            return $row;
        }
    }

    /**
     * 获取相关排班
     * @param $dutyId 排班ID
     */
    function getDutyById($dutyId) {
        global $connection;
        $query = "
				 SELECT * FROM attend_config 
					 WHERE DUTY_ID = '". SecurityFilter($dutyId) ."'
				 ";
        $res = exequery($connection, $query);
        if ($Row = mysql_fetch_array($res)) {
            $returnArray['dutyName'] = $Row['DUTY_NAME'];
            $returnArray['dutySignIn'] = $Row['DUTY_SIGN_IN'];
            $returnArray['dutySignOut'] = $Row['DUTY_SIGN_OUT'];
            $returnArray['dutyVacation'] = $Row['DUTY_VACATION'];
            $dutyUserArray = $this->getDutyUserFromUser($dutyId);
            $returnArray['dutyLogin'] = $Row['DUTY_LOGIN'];
            $returnArray['dutyLoginCheck'] = $returnArray['dutyLogin'] == 1 ? 'checked' : '';
            $returnArray['dutyUser'] = $dutyUserArray['userId'];
            $returnArray['dutyUserName'] = $dutyUserArray['userName'];
            $returnArray['dutyUsedCheck'] = $Row['DUTY_USE'] == 1 ? 'checked' : '';
            return $returnArray;
        } else {
            return false;
        }
    }

    /**
     * 截取字符串，编码utf8
     */
    function substrUtf8($in, $num, $suffix = '') {
        if (mb_strlen($in, 'UTF-8') > $num) {
            $restr = mb_substr($in, 0, $num, 'UTF-8') . $suffix;
        } else {
            $restr = $in;
        }
        return $restr;
    }

    /**
     * 获取USER考勤信息
     */
    function getUserDutyPage($params) {
        global $connection;
        extract($params);
        $query = "
				 SELECT SIGN_IN_TIME,SIGN_OUT_TIME,DUTY_TYPE FROM attend_duty 
					 WHERE USER_ID = '". SecurityFilter($userId) ."'
					 ORDER BY SIGN_IN_TIME DESC LIMIT 0,". SecurityFilter($limit) ."
				 ";
        $res = exequery($connection, $query);
        while ($Row = mysql_fetch_row($res)) {
            $page .= $this->createIndexAttend($Row);
        }
        echo "<table>" . $page . "</table>";
    }

    /**
     * 获取首页table
     */
    function createIndexAttend($arrayDuty) {
        extract($arrayDuty);
        $count = 0;
        $i = 0;
        $dutyId = $this->getUserDutyType($userId);
        $dutyArray = $this->getDutyData($dutyId);

        while ($count <= $showNum) {
            $dateNext = date("Y-m-d", time() - 86400 * $i);
            $i++;
            if ($this->isAttendData($dutyArray, $dateNext) == 1) {
                $params['userId'] = $userId;
                $params['thisDay'] = $dateNext;
                $returnArray = $this->getDutyDayMessage($params);
                $thisDayName = array('analysisDay' => $dateNext);
                $returnArray = array_merge($returnArray, $thisDayName);
                $returnPage .= $this->analysisArray($returnArray);
                $count++;
            }
        }
        return $returnPage;
    }

    /**
     * 当前月请假次数attend_leave是请假相关的表
     */
    function getPresentMouthLeave($params = array(), $user_id) {
        global $connection, $_lang;
        extract($params);

        $startDate = $patamStart ? $patamStart : date('Y-m') . "-01 00:00:00";
        $endDate = $patamEnd ? $patamEnd : date('Y-m-d H:i:s');
        $userId = $patamUserId ? $patamUserId : $user_id;
        $query = "SELECT COUNT(*) AS CNT FROM attend_leave 
						  WHERE LEAVE_DATE1>='". SecurityFilter($startDate) ."' 
						  AND LEAVE_DATE2<='". SecurityFilter($endDate) ."' 
						  AND USER_ID ='". SecurityFilter($userId) ."'
					 ";
        $res = exequery($connection, $query);
        $Row = mysql_Fetch_array($res);
        if ($Row['CNT']) {
            //将链接的首页修改成和个人考勤的首页类似,此处为链接错误,history.php中传入参数也无法显示	
            return "<a href='/general/attendance/personal/duty/showcontent.php?userId=" . $userId . "&type=leave&start=$startDate&end=$endDate' onclick=\"return hs.htmlExpand( this, { objectType: 'iframe',width:'700',height:'500',align:'center',captionText:'<span id=\'smsdiaglog\' style=\'color:#1d93d3;font-weight:bold;\'>&nbsp;" . $_lang['hr_duty_ask_off_check'] . "</span>',captionOverlay: { position: 'toppanel'}} )\" id='ContentShow'>" . $Row['CNT'] . "</a>";
        }
    }

    /**
     * 当前月外出次数attend_out是外出相关的表
     */
    function getPresentMouthAttendOut($params = array(), $user_id) {
        global $connection, $_lang;
        extract($params);

        $startDate = $patamStart ? $patamStart : date('Y-m') . "-01 00:00:00";
        $endDate = $patamEnd ? $patamEnd : date('Y-m-d H:i:s');
        $userId = $patamUserId ? $patamUserId : $user_id;
        $query = "SELECT COUNT(*) AS CNT FROM attend_out 
						  WHERE OUT_DATE1>='". SecurityFilter($startDate) ."' 
						  AND OUT_DATE2<='". SecurityFilter($endDate) ."' 
						  AND USER_ID ='". SecurityFilter($userId) ."'
				     ";
        $res = exequery($connection, $query);
        $Row = mysql_Fetch_array($res);
        if ($Row['CNT']) {
            //将链接的首页修改成和个人考勤的首页类似,此处为链接错误,history.php中传入参数也无法显示	
            return "<a href='/general/attendance/personal/duty/showcontent.php?userId=" . $userId . "&type=out&start=$startDate&end=$endDate' onclick=\"return hs.htmlExpand( this, { objectType: 'iframe',width:'700',height:'500',align:'center',captionText:'<span id=\'smsdiaglog\' style=\'color:#1d93d3;font-weight:bold;\'>&nbsp;" . $_lang['hr_duty_check_out'] . "</span>',captionOverlay: { position: 'toppanel'}} )\" id='ContentShow'>" . $Row['CNT'] . "</a>";
        }
    }

    /**
     * 当月出差统计的方法
     */
    function getPresentMouthLeaveOut($params = array(), $user_id) {
        global $connection, $_lang;
        extract($params);

        $start = $patamStart ? $patamStart : date('Y-m') . "-01";
        $startDate = strtotime($start);
        $end = $patamEnd ? $patamEnd : date('Y-m-d');
        $endDate = strtotime($end);
        $userId = $patamUserId ? $patamUserId : $user_id;
        $query = "SELECT COUNT(*) AS CNT FROM attend_evection
						 WHERE EVECTION_DATE1>='". SecurityFilter($start) ."'
						 AND EVECTION_DATE2<='". SecurityFilter($end) ."' 
						 AND USER_ID ='". SecurityFilter($userId) ."'
					 ";
        $res = exequery($connection, $query);
        $Row = mysql_Fetch_array($res);
        if ($Row['CNT']) {
            return "<a href='/general/attendance/personal/duty/showcontent.php?userId=" . $userId . "&type=leaveout&start=$start&end=$end' onclick=\"return hs.htmlExpand( this, { objectType: 'iframe',width:'700',height:'500',align:'center',captionText:'<span id=\'smsdiaglog\' style=\'color:#1d93d3;font-weight:bold;\'>&nbsp;" . $_lang['hr_duty_trip_check'] . "</span>',captionOverlay: { position: 'toppanel'}} )\" id='ContentShow'>" . $Row['CNT'] . "</a>";
        }
    }

    /**
     * 获取当前月迟到次数(首页显示,以及考勤统计中显示的数据)Table表attend_duty中算出迟到次数
     */
    function getPresentMouthLate($params = array(), $user_id) {
        global $connection, $_lang;
        extract($params);

        $start = $patamStart ? $patamStart : date('Y-m') . "-01";
        $startDate = strtotime($start);
        $end = $patamEnd ? $patamEnd : date('Y-m-d H:i:s');
        $endDate = strtotime($end);
        $userId = $patamUserId ? $patamUserId : $user_id;
        $query = "SELECT COUNT(*) AS CNT FROM attend_duty 
					      WHERE SIGN_IN_TIME >= ". SecurityFilter($startDate) ."
					      AND SIGN_IN_TIME <= ". SecurityFilter($endDate) ."
					      AND USER_ID = '". SecurityFilter($userId) ."'
					      AND DUTY_TYPE<>1 
   					  ";
        $res = exequery($connection, $query);
        $Row = mysql_fetch_array($res);
        if ($Row['CNT']) {
            return "<a href='/general/attendance/personal/duty/showcontent.php?userId=" . $userId . "&type=late&start=$startDate&end=$endDate' onclick=\"return hs.htmlExpand( this, { objectType: 'iframe',width:'700',height:'500',align:'center',captionText:'<span id=\'smsdiaglog\' style=\'color:#1d93d3;font-weight:bold;\'>&nbsp;" . $_lang['hr_personal_check_data'] . "</span>',captionOverlay: { position: 'toppanel'}} )\" id='ContentShow'>" . $Row['CNT'] . "</a>";
        }
    }

    /**
     * 获取当前月漏签次数 attend_duty表中可以算出漏签
     */
    function getPresentMouthNotSign($params = array(), $user_id) {
        global $connection, $_lang;
        extract($params);

        $start = $patamStart ? $patamStart : date('Y-m') . "-01";
        $startDate = strtotime($start);
        $end = $patamEnd ? $patamEnd : date('Y-m-d H:i:s');
        $endDate = strtotime($end);
        $userId = $patamUserId ? $patamUserId : $user_id;
        $query = "SELECT COUNT(*) AS CNT FROM attend_duty 
					      WHERE SIGN_IN_TIME >= ". SecurityFilter($startDate) ."
						  AND SIGN_IN_TIME <= ". SecurityFilter($endDate) ."
						  AND USER_ID = '". SecurityFilter($userId) ."'
						  AND SIGN_OUT_TIME = '' 
					 ";
        $res = exequery($connection, $query);
        $Row = mysql_fetch_array($res);
        if ($Row['CNT']) {
            return "<a href='/general/attendance/personal/duty/showcontent.php?userId=" . $userId . "&type=leak&start=$startDate&end=$endDate' onclick=\"return hs.htmlExpand( this, { objectType: 'iframe',width:'700',height:'500',align:'center',captionText:'<span id=\'smsdiaglog\' style=\'color:#1d93d3;font-weight:bold;\'>&nbsp;" . $_lang['hr_personal_check_data'] . "</span>',captionOverlay: { position: 'toppanel'}} )\" id='ContentShow'>" . $Row['CNT'] . "</a>";
        }
    }

    /**
     * 当前月早退次数  Table表attend_duty表中可以算出用户早退
     */
    function presentMouthLeaveEarly($params = array(), $user_id) {
        global $connection, $_lang;
        extract($params);
        $start = $patamStart ? $patamStart : date('Y-m') . "-01";
        $startDate = strtotime($start);
        $end = $patamEnd ? $patamEnd : date('Y-m-d H:i:s');
        $endDate = strtotime($end);
        $userId = $patamUserId ? $patamUserId : $user_id;
        $query = "
				 SELECT COUNT(*) AS CNT FROM attend_duty 
					  WHERE SIGN_IN_TIME >= ". SecurityFilter($startDate) ."
					  AND SIGN_IN_TIME <= ". SecurityFilter($endDate) ."
					  AND USER_ID = '". SecurityFilter($userId) ."'
					  AND OUT_TIME_DIFF < '0'
				 ";
        $res = exequery($connection, $query);
        $Row = mysql_fetch_array($res);
        if ($Row['CNT']) {
            return "<a href='/general/attendance/personal/duty/showcontent.php?userId=" . $userId . "&type=earlyLeave&start=$startDate&end=$endDate' onclick=\"return hs.htmlExpand( this, { objectType: 'iframe',width:'700',height:'500',align:'center',captionText:'<span id=\'smsdiaglog\' style=\'color:#1d93d3;font-weight:bold;\'>&nbsp;" . $_lang['hr_personal_check_data'] . "</span>',captionOverlay: { position: 'toppanel'}} )\" id='ContentShow'>" . $Row['CNT'] . "</a>";
        }
    }

    /**
     * 当前月加班次数  Table表attend_overtime表中可以算出用户加班
     * $params 保存查询需要的数据
     */
    function presentMouthOverTimeInfo($params = array(), $user_id) {
        global $connection, $_lang;
        extract($params);
        $start = $patamStart ? $patamStart : date('Y-m') . "-01";
        $startDate = strtotime($start);
        $end = $patamEnd ? $patamEnd : date('Y-m-d');
        $endDate = strtotime($end);
        $userId = $patamUserId ? $patamUserId : $user_id;
        $query = "SELECT COUNT(*) AS CNT FROM attend_overtime 
					  WHERE OVERTIME_DATE1 >= '". SecurityFilter($start) ."'
					  AND OVERTIME_DATE2 <= '". SecurityFilter($end) ."'
					  AND USER_ID = '". SecurityFilter($userId) ."'					 
				 ";
        $res = exequery($connection, $query);
        $Row = mysql_fetch_array($res);
        if ($Row['CNT']) {
            return "<a href='/general/attendance/personal/duty/showcontent.php?userId=" . $userId . "&type=overtime&start=$start&end=$end' onclick=\"return hs.htmlExpand( this, { objectType: 'iframe',width:'700',height:'500',align:'center',captionText:'<span id=\'smsdiaglog\' style=\'color:#1d93d3;font-weight:bold;\'>&nbsp;" . $_lang["hr_attend_overtime_show"] . "</span>',captionOverlay: { position: 'toppanel'}} )\" id='ContentShow'>" . $Row['CNT'] . "</a>";
        }
    }

    /**
     * 获取用户排班
     * @param $dutyId 排班ID
     */
    function getDutyData($dutyId, $user_id = '') {
        global $connection, $LOGIN_USER_ID;
        if ($user_id != "") {
            $user = $user_id;
        } else {
            $user = $LOGIN_USER_ID;
        }
        $dutyId = $dutyId ? $dutyId : $this->getUserDutyType($user);
        $query = "SELECT * FROM attend_config WHERE 
				       DUTY_ID = '". SecurityFilter($dutyId) ."'
				  ";
        $res = exequery($connection, $query);
        return $Row = mysql_fetch_array($res); //程序本来的语句
    }

    /**
     * 获取用户的排班类型	
     * @param $userId 用户ID
     */
    function getUserDutyType($userId) {
        global $connection;
        $query = "
				 SELECT DUTY_TYPE FROM USER
					 WHERE USER_ID = '". SecurityFilter($userId) ."'
				 ";
        $res = exequery($connection, $query);
        $Row = mysql_fetch_array($res);
        return $Row['DUTY_TYPE'];
    }

    /**
     * 获取SQL的数据
     * @param $data 传过来的数据
     */
    function getSqlByArray($data) {
        foreach ($data as $key => $value) {
            $count++;
            $fields .= $count == 1 ? $key : "," . $key;
            $values .= $count == 1 ? "'" . $value . "'" : ",'" . $value . "'";
        }

        $returnArray['fields'] = $fields;
        $returnArray['values'] = $values;
        return $returnArray;
    }

    /**
     * 获取签到类型(是正常签到还是异常签到)
     */
    function getSignMassage($dutyArray, $USER_ID = '') {
        global $connection, $LOGIN_USER_ID;

        if ($USER_ID == '') {
            $USER_ID = $LOGIN_USER_ID;
        }

        $nowTime = strtotime(date("H:i:s"));
        $signTime = strtotime($dutyArray['DUTY_SIGN_IN']);

        $signTimeInBase = $this->isSignIn($dutyArray, $dutyArray["DUTY_ID"], $USER_ID);

        //检测是否有请假、外出和出差等数据
        if ($dutyArray["SIGN_IN_TIME"] != "") {
            $diff = $signTime - strtotime($dutyArray["SIGN_IN_TIME"]);
        } else {
            $diff = $signTime - $nowTime;
        }

        $returnArray['signType'] = $diff >= 0 ? '1' : '2';
        $returnArray['signDiff'] = $diff;
        return $returnArray;
    }

    /**
     * 判断是否为节假日
     */
    function isAttendData($dutyArray, $thisDay = '', $userId = '') {
        global $connection;

        $dutyArray = $dutyArray ? $dutyArray : $this->getDutyData($dutyId, $userId);
        $vacationId = $dutyArray['DUTY_VACATION'];
        $nowDay = $thisDay ? date("Y-m-d", strtotime($thisDay)) : date("Y-m-d");
        $nowYear = date("Y", strtotime($nowDay));

        $query = "SELECT VACATION_ID FROM attend_vacation_content 
				      WHERE VACATION_YEAR = '". SecurityFilter($nowYear) ."'
					  AND(INSTR(VACATION_DATE,',". SecurityFilter($nowDay) .",')>1
					  OR
					  INSTR(VACATION_DATE,'$nowDay,')=1)
					  AND VACATION_ID = '$vacationId'
				 ";
        $res = exequery($connection, $query);
        return mysql_fetch_array($res) ? '' : '1';
    }

    /**
     * 签到和签退
     */
    function loginSignIn($handSign = '', $userId = '') {
        global $connection, $LOGIN_USER_ID, $LOGIN_DEPT_ID, $LOGIN_USER_PRIV, $LOGIN_THEME, $_lang;
        $dutyUser = $userId != "" ? $userId : $LOGIN_USER_ID;
        $dutyId = $this->getUserDutyType($dutyUser);

        $dutyArray = $this->getDutyData($dutyId);
        $signdate = date("Y-m-d"); //签到日期的变量		
        $autoSignIn = $handSign == '' ? $dutyArray['DUTY_LOGIN'] : false; //自动登录签到	

        $queryData['SIGN_IN_NORMAL'] = strtotime($signdate . " " . $dutyArray['DUTY_SIGN_IN']);
        $SIGN_OUT_NORMAL = strtotime($signdate . " " . $dutyArray['DUTY_SIGN_OUT']);

        if ($autoSignIn || $handSign != "") {
            $signTimeInBase = $this->isSignIn($dutyArray, $dutyId, $LOGIN_USER_ID);

            if ($autoSignIn || $handSign == 'in') {
                if ($signTimeInBase == "") {
                    //判断是否是正常签到return returnArray['signType']为1还是2					
                    $dutyMassage = $this->getSignMassage($dutyArray, $LOGIN_USER_ID);

                    //判断是否是节假日 					
                    $dataType = $this->isAttendData($dutyArray);
                    $timeNow = date("Y-m-d H:i:s");
                    $queryData['USER_ID'] = $dutyUser;
                    $queryData['SIGN_IN_TIME'] = strtotime($timeNow);

                    //取得用户的IP					
                    $queryData['IP'] = getenv("REMOTE_ADDR");
                    $queryData['DUTY_TYPE'] = $dutyMassage['signType'];
                    $queryData['DATA_TYPE'] = $dataType;

                    //签到日期的数据
                    $queryData['sign_date'] = $signdate;
                    $queryData['IN_TIME_DIFF'] = $dutyMassage['signDiff'];
                    $queryData['OUT_TIME_DIFF'] = "";
                    $queryData['SIGN_OUT_NORMAL'] = $SIGN_OUT_NORMAL;
                    $queryData['USER_DEPT'] = $LOGIN_DEPT_ID;
                    $queryData['USER_PRIV'] = $LOGIN_USER_PRIV;

                    //检查考勤数据
                    //$this->checkAttendData();
                    $sql = "SELECT * FROM attend_duty WHERE 1 AND USER_ID='" . SecurityFilter($dutyUser) . "' AND sign_date='" . SecurityFilter($signdate) . "'";
                    $res = exequery($connection, $sql);
                    //调用签到插入到数据库中的方法--传入的数据就是刚刚所取得的数据$queryData数组	
                    if (!$row = mysql_fetch_array($res)) {
                        $this->dutySignInDatabase($queryData, "INSERT INTO");
                        if ($handSign) {
                            $signDiffTime = round($dutyMassage['signDiff'] / 60, 0);
                            $signDate = date('H:i:s', $queryData['SIGN_IN_TIME']);
                            if ($dutyMassage['signType'] == 2 && abs($signDiffTime) > 0) {
                                if (strstr($LOGIN_THEME, "7series")) {
                                    $signDiffTimeStr = $_lang["hr_attend_sign_in"] . ":" . "<span style='color:#f00'>" . $signDate . "</span>";
                                } else {
                                    $signDiffTimeStr = "<span style='color:#f00'>" . $signDate . "</span>";
                                }
                            } else {
                                if (strstr($LOGIN_THEME, "7series")) {
                                    $signDiffTimeStr = $_lang["hr_attend_sign_in"] . ":" . $signDate;
                                } else {
                                    $signDiffTimeStr = $signDate;
                                }
                            }
                            return $signDiffTimeStr;
                        }
                    }
                }
            } else if ($handSign == 'out') {
                //签退
                $dutySignOutDB = $dutyArray['DUTY_SIGN_OUT'];
                $nowTime = strtotime(date("H:i:s"));
                $signTime = strtotime($dutySignOutDB);
                $diff = $nowTime - $signTime;


                $aqlDate = strtotime(date("Y-m-d H:i:s"));
                $signDate = date("H:i:s");

                if ($diff < 0) {
                    $out_type = 2;
                } else {
                    $out_type = 1;
                }

                $query = "UPDATE attend_duty SET
						      SIGN_OUT_TIME   = ". SecurityFilter($aqlDate) .",
						      SIGN_OUT_NORMAL = ". SecurityFilter($SIGN_OUT_NORMAL) .",
							  OUT_TIME_DIFF   = ". SecurityFilter($diff) .",
                              OUT_TYPE        = ". SecurityFilter($out_type) ."
							  WHERE USER_ID   = '". SecurityFilter($LOGIN_USER_ID) ."'							
							  AND sign_date=CURDATE()
						 ";
                exequery($connection, $query);
                if ($diff >= 0) {
                    if (strstr($LOGIN_THEME, "7series")) {
                        $signDiffTimeStr = $_lang["hr_attend_sign_out"] . ":" . $signDate;
                    } else {
                        $signDiffTimeStr = $signDate;
                    }
                    $query = "
							 UPDATE attend_duty SET
							    OUT_TYPE=1 
								WHERE SIGN_IN_TIME=". SecurityFilter($signTimeInBase) ."
							 ";
                    exequery($connection, $query);
                } else {
                    if (strstr($LOGIN_THEME, "7series")) {
                        $signDiffTimeStr = $_lang["hr_attend_sign_out"] . ":" . "<span style='color:#f00'>" . $signDate . "</span>";
                    } else {
                        $signDiffTimeStr = "<span style='color:#f00'>" . $signDate . "</span>";
                    }
                }

                return $signDiffTimeStr;
            }
        }
    }

    /**
     * 签到/签退插入(或者修改)到数据库中对应表中的字段和值···注意传入的参数!	
     */
    function dutySignInDatabase($data, $sqlAction, $table = "attend_duty") {
        global $connection;
        $sqlArray = $this->getSqlByArray($data);
        $fields = $sqlArray['fields'];
        $values = $sqlArray['values'];
        $query = "$sqlAction  $table(". SecurityFilter($fields) .") VALUES(". SecurityFilter($values) .");
				 ";
        exequery($connection, $query);
    }

    /**
     * 处理签到和签退的信息
     */
    function isSignIn($dutyArray, $dutyId, $userId) {
        global $connection;
        $signInTime = strtotime($dutyArray['DUTY_SIGN_IN']);
        $signOutTime = strtotime($dutyArray['DUTY_SIGN_OUT']);
        /*  处理跨天签到的问题
          if($signInTime>$signOutTime){
          $nextDay = strtotime(date("Y-m-d",time()-3600*24));
          //$nextDay = strtotime(date("Y-m-d",time()+3600*24));
          $parDate = $nextDay+$signOutTime;
          }else{} */
        $parDate = strtotime(date("Y-m-d"));
        $query = "
				 SELECT SIGN_IN_TIME FROM attend_duty 
					WHERE SIGN_IN_TIME >= '". SecurityFilter($parDate) ."'
					AND sign_date = DATE_FORMAT(NOW(),'%Y-%m-%d')
					AND USER_ID = '". SecurityFilter($userId) ."'";
        $res = exequery($connection, $query);
        $Row = mysql_fetch_array($res);
        $signInTime = $Row['SIGN_IN_TIME'];
        return $signInTime;
    }

    /**
     * 解析数据
     */
    function analysisArrayData($fieldName, $fieldValue) {
        global $_lang;
        switch ($fieldName) {
            case "USER_ID":
                break;
            case "SIGN_OUT_TIME":
            case "SIGN_IN_TIME":
                if ($fieldValue == "0") {
                    return $_lang["hr_attend_nothing_all"];
                } else {
                    return date('m/d H:i', $fieldValue);
                    ;
                }
                break;
            case "DATA_TYPE":
                switch ($fieldValue) {
                    case "1":
                        return $_lang["hr_attend_workday"];
                        break;
                    case "0":
                        return $_lang["hr_attend_not_workday"];
                        break;
                    case "2":
                        return '<span style="color:#339900">' . $_lang["hr_attend_verify_waiting"] . '</span>';
                        break;
                    case "3":
                        return '<span style="color:red">' . $_lang["hr_duty_apply_not"] . '</span>';
                        break;
                }
            case "IN_TIME_DIFF":
                $fieldValue = round($fieldValue / 60, 2);
                return $fieldValue < 0 ? $_lang["hr_duty_late"] . "(" . abs($fieldValue) . $_lang["hr_duty_time_minute"] . ")" : $_lang["hr_attend_sign_in_normal"];
                break;
            case "OUT_TIME_DIFF":
                $fieldValue = round($fieldValue / 60, 2);
                return $fieldValue < 0 ? $_lang["hr_duty_leave_early"] . "(" . abs($fieldValue) . $_lang["hr_duty_time_minute"] . ")" : $_lang["hr_attend_sign_out_normal"];
                break;
            case "option":
                return "<a href='javascript:" . $fieldValue . "'>" . $_lang["hr_attend_request_verify"] . "</a>";
            default:
                return $fieldValue;
                break;
        }
    }

    /**
     * 获取考勤类型
     */
    function getDataTypeByValue($value, $type = '') {
        global $_lang;
        if ($type == '') {
            switch ($value) {
                case "1":
                    return $_lang["hr_attend_verify_pass"];
                    break;
                case "0":
                    return $_lang["hr_attend_no_operate"];
                    break;
                case "2":
                    return '<span style="color:#339900">' . $_lang["hr_attend_verify_waiting"] . '</span>';
                    break;
                case "3":
                    return '<span style="color:red">' . $_lang["hr_attend_verify_notpass"] . '</span>';
                    break;
//          case "5":
//              return '<span style="color:blue"'.$_lang["hr_attend_sign_leave"].'</span>';
//              break;
            }
        } else {
            switch ($value) {
                case "2":
                    return $_lang["hr_attend_verify_waiting"];
                    break;
                case "3":
                    return $_lang["hr_attend_verify_notpass"];
                    break;
            }
        }
    }

    function getDutyTypeValue($type, $value, $timeValue) {
        global $_lang;
        if ($type == 'in') {
            switch ($value) {
                case"1":
                    $reStr = $_lang["hr_attend_sign_in_normal"];
                    break;
                case"2":
                    $reStr = $_lang["hr_duty_late"] . "(" . abs($timeValue) . $_lang["hr_duty_time_minute"] . ")";
                    break;
                case"5":
                    $reStr = $_lang["hr_attend_sign_leave"];
                    break;
                default:
                    $reStr = $_lang["hr_attend_sign_in_normal"];
            }
        } else if ($type == 'out') {
            switch ($value) {
                case"1":
                    $reStr = $_lang["hr_attend_sign_out_normal"];
                    break;
                case"2":
                    $reStr = $_lang["hr_duty_leave_early"] . "(" . abs($timeValue) . $_lang["hr_duty_time_minute"] . ")";
                    break;
                case"5":
                    break;
                default:
                    $reStr = $_lang["hr_attend_sign_out_normal"];
            }
        }
        return $reStr;
    }

    /**
     * 解析数组生成页面
     */
    function analysisArrayPage($arrayData, $trCss = '') {
        $page = "<tr class='" . $trCss . "'>";
        foreach ($arrayData as $key => $value) {
            if ($arrayData['SIGN_OUT_TIME'] == "0" && $key == "OUT_TIME_DIFF") {
                $value = $_lang["hr_attend_leak_sign"];
            } else {
                $value = $this->analysisArrayData($key, $value);
            }
            $page.= "<td id='" . $key . "' nowrap>" . $value . "</td>";
        }
        return $page . "</tr>";
    }

    /**
     * 获取首页关于个人考勤的信息以及统计中的个人考勤的信息
     */
    function getDutyMassageArray($params, $array = '') {
        global $connection, $LOGIN_USER_ID, $_lang;

        $startDate = $params['startDate'] ? $params['startDate'] : strtotime(date('Y-m') . "-01");
        $endDate = $params['endDate'] ? $params['endDate'] : strtotime(date('Y-m-d H:i:s'));

        //传入的用户
        $userId = $params['userId'] ? $params['userId'] : "";
        $where = $params['where'] ? $params['where'] : " ORDER BY sign_date DESC";
        $fields = $params['fields'] ? $params['fields'] : "*";

        $query = "SELECT $fields FROM attend_duty ad,user u
				      WHERE 1 AND ad.USER_ID=u.USER_ID AND sign_date>='" . SecurityFilter(date("Y-m-d", $startDate)) . "'
				      AND sign_date<='" . SecurityFilter(date("Y-m-d", $endDate)) . "'";
        if (trim($params["searchvalue"]) != "") {
            $query .= $params["searchkey"] == "DEPT_NAME" ? " AND DEPT_ID IN('" . SecurityFilter(str_replace(",", "','", $params["searchvalue"])) . "')" : " AND USER_NAME LIKE '%" . SecurityFilter(trim($params["searchvalue"])) . "%'";
        } else {
            if ($params["searchkey"] == "DEPT_NAME") {
                $query .= " AND 1=2";
            }
        }
        $query .= $userId != "" ? " AND USER_ID IN('". SecurityFilter($userId) ."')" . $where : "";
        $rs = exequery($connection, $query);
        $totalCount = mysql_num_rows($rs);
        $res = exequery($connection, $query);
        $params['userId'] = $LOGIN_USER_ID;
        while ($Row = mysql_fetch_assoc($res)) {
            $count++;
            //考勤日期显示根据校验的SIGN_IN_TIME				
            $reStr[$count]['signDay'] = $Row['sign_date'];
            $reStr[$count]['dataType'] = $Row['DATA_TYPE'];
            $reStr[$count]['dutyOption'] = $Row['DUTY_OPTION'];
            $reStr[$count]['signInTime'] = date('H:i', $Row['SIGN_IN_TIME']);

            //签退时间
            if ($Row['SIGN_OUT_TIME'] == 0) {
                $reStr[$count]['signOutTime'] = '';
            } else {
                $reStr[$count]['signOutTime'] = date('H:i', $Row['SIGN_OUT_TIME']);
            }

            $reStr[$count]['dutyType'] = $Row['DUTY_TYPE'];
            $reStr[$count]['outType'] = $Row['OUT_TYPE'];
            $reStr[$count]['dutyId'] = $Row['DUTY_ID'];
            $reStr[$count]['SIGN_IN_NORMAL'] = $Row['SIGN_IN_NORMAL'];
            $reStr[$count]['SIGN_OUT_NORMAL'] = $Row['SIGN_OUT_NORMAL'];
            $reStr[$count]['DUTY_DATE'] = date("H:i:s", $Row['SIGN_IN_NORMAL']) . "--" . date("H:i:s", $Row['SIGN_OUT_NORMAL']);

            //判断是否为工作日或者休息日
            $reStr[$count]['dataTypeStr'] = $reStr[$count]['dataType'] == '0' ? $_lang["hr_attend_not_workday"] : $_lang["hr_attend_workday"];

            $reStr[$count]['dataTypeValue'] = $this->getDataTypeByValue($Row['DUTY_OPTION']);

            //签到异常值
            $reStr[$count]['inTimeDiff'] = round($Row['IN_TIME_DIFF'] / 60, 2);

            //签到状态
            $reStr[$count]['dutyTypeValue'] = $this->getDutyTypeValue('in', $Row['DUTY_TYPE'], $reStr[$count]['inTimeDiff']);

            //签退异常值
            if ($Row['OUT_TIME_DIFF'] == 0 && $Row['DUTY_OPTION'] != '1') {
                $reStr[$count]['outTypeValue'] = $_lang["hr_attend_leak_sign"];
            } else {
                $reStr[$count]['outTimeDiff'] = round($Row['OUT_TIME_DIFF'] / 60, 2);
                $reStr[$count]['outTypeValue'] = $this->getDutyTypeValue('out', $Row['OUT_TYPE'], $reStr[$count]['outTimeDiff']);
            }
        }
        return array("totalCount" => $totalCount, "list" => $reStr);
    }

    function getDutyInfo($params, $limitRows, $limitOffset) {
        global $connection, $LOGIN_USER_ID, $_lang;
        $startDate = $params['startDate'] ? $params['startDate'] : strtotime(date('Y-m') . "-01");
        $endDate = $params['endDate'] ? $params['endDate'] : strtotime(date('Y-m-d H:i:s'));
        //传入的用户
        $userId = $params['userId'] ? $params['userId'] : $LOGIN_USER_ID;
        $where = $params['where'] ? $params['where'] : " ORDER BY sign_date DESC";
        $fields = $params['fields'] ? $params['fields'] : "*";
        $query = "SELECT ". SecurityFilter($fields) ." FROM attend_duty
                      WHERE sign_date>='" . SecurityFilter(date("Y-m-d", $startDate)) . "'
                      AND sign_date<='" . SecurityFilter(date("Y-m-d", $endDate)) . "'
                      AND USER_ID IN('". SecurityFilter($userId) ."') ". $where ."";
        $queryCount = "SELECT Count(". SecurityFilter($fields) .") AS CNT FROM attend_duty
                      WHERE sign_date>='" . SecurityFilter(date("Y-m-d", $startDate)) . "'
                      AND sign_date<='" . SecurityFilter(date("Y-m-d", $endDate)) . "'
                      AND USER_ID IN('". SecurityFilter($userId) ."') ". $where ."";
        $resCount = exequery($connection, $queryCount);
        $row = mysql_fetch_assoc($resCount);
        $totalcnt = $row['CNT'];
        $query.=" LIMIT ". SecurityFilter($limitOffset) .",". SecurityFilter($limitRows) ."";
        $res = exequery($connection, $query);
        $reStr = array();
        while ($Row = mysql_fetch_assoc($res)) {
            $Row['SIGN_IN_TIME'] = date('H:i', $Row['SIGN_IN_TIME']);
            //签退时间
            if ($Row['SIGN_OUT_TIME'] == 0) {
                $Row['SIGN_OUT_TIME'] = '';
            } else {
                $Row['SIGN_OUT_TIME'] = date('H:i', $Row['SIGN_OUT_TIME']);
            }
            $Row['ATTEND_IP'] = $Row['IP'];
            $Row['DATA_TYPE'] = ($Row['DATA_TYPE'] == '0' ? $_lang["hr_attend_not_workday"] : $_lang["hr_attend_workday"]);
            $Row['USER_DUTY'] = date('H:i', $Row['SIGN_IN_NORMAL']) . '--' . date('H:i', $Row['SIGN_OUT_NORMAL']);
            $Row['dataTypeValue'] = $this->getDataTypeByValue($Row['DUTY_OPTION'], 1);
            array_push($reStr, $Row);
        }
        return array(
            'totalCount' => $totalcnt,
            'list' => $reStr
        );
    }

    function getDutyCount($params) {
        global $connection, $LOGIN_USER_ID, $_lang;
        $startDate = $params['startDate'] ? $params['startDate'] : strtotime(date('Y-m') . "-01");
        $endDate = $params['endDate'] ? $params['endDate'] : strtotime(date('Y-m-d H:i:s'));
        $userId = $params['userId'] ? $params['userId'] : $LOGIN_USER_ID;

        $searchDates = getDates(date('Y-m-d', $startDate), date('Y-m-d', $endDate));
        $query = "SELECT sign_date FROM attend_duty
            WHERE sign_date>='" . SecurityFilter(date("Y-m-d", $startDate)) . "'
            AND sign_date<='" . SecurityFilter(date("Y-m-d", $endDate)) . "'
            AND USER_ID='". SecurityFilter($userId) ."' AND SIGN_IN_TIME !='' AND SIGN_OUT_TIME != ''";
        $resCount = exequery($connection, $query);
        $datearr = array();
        while ($row = mysql_fetch_assoc($resCount)) {
            $datearr[] = $row['sign_date'];
        }
        $result = true;
        foreach ($searchDates as $value) {
            if ($this->isAttendData('', $value, $userId) == 1 && !in_array($value, $datearr)) {
                $result = false;
                break;
            }
        }
        //全勤
        if ($result) {
            return -1;
        } else {
            $queryLate = "SELECT COUNT(*) AS CNT FROM attend_duty
            WHERE sign_date>='" . SecurityFilter(date("Y-m-d", $startDate)) . "'
            AND sign_date<='" . SecurityFilter(date("Y-m-d", $endDate)) . "'
            AND USER_ID='". SecurityFilter($userId) ."' AND SIGN_IN_TIME !='' AND IN_TIME_DIFF<0";
            $resCount = exequery($connection, $queryLate);
            $row = mysql_fetch_assoc($resCount);
            $totallatecnt = $row['CNT'];

            $queryEarly = "SELECT COUNT(*) AS CNT FROM attend_duty
            WHERE sign_date>='" . SecurityFilter(date("Y-m-d", $startDate)) . "'
            AND sign_date<='" . SecurityFilter(date("Y-m-d", $endDate)) . "'
            AND USER_ID='". SecurityFilter($userId) ."' AND SIGN_OUT_TIME !='' AND OUT_TIME_DIFF<0";
            $resCount = exequery($connection, $queryEarly);
            $row = mysql_fetch_assoc($resCount);
            $totalearlycnt = $row['CNT'];
            $total = $totallatecnt + $totalearlycnt;
            return $total;
        }
    }

    function getLastDay($year, $month) {
        if ($month == 4 || $month == 6 || $month == 9 || $month == 11) {
            return 30;
        }
        if ($month == 2) {
            if (($year % 4 == 0) && ($year % 100 != 0) || ($year % 400 == 0)) {
                return 29;
            } else {
                return 28;
            }
        }
        return 31;
    }

    /**
     * 获取考勤校验数据(从用户排班中提取数据)
     */
    function getDutyCheckMassge($dutyId) {
        global $connection, $LOGIN_USER_ID;
        $query = "SELECT DATA_TYPE,DUTY_TYPE,OUT_TYPE,DUTY_WHY FROM attend_duty
				      WHERE DUTY_ID = '". SecurityFilter($dutyId) ."'
				 ";
        $res = exequery($connection, $query);
        return $Row = mysql_fetch_array($res);
    }

    /**
     * 获取请假信息(与请假相关显示)包括首页显示和考勤统计中的显示
     */
    function getLeaveMassageArrays($params, $quicksort = '', $offset = '', $rows = '') {
        global $connection, $LOGIN_USER_ID, $_lang;
        $startDate = $params['startDate'] ? $params['startDate'] : date('Y-m') . "-01";
        $endDate = $params['endDate'] ? $params['endDate'] : date('Y-m-t', time());
        $userId = $params['userId'] ? $params['userId'] : $LOGIN_USER_ID;
        $where = $params['where'] ? $params['where'] : "";

        $leave_select = "SELECT * FROM";
        $query = " attend_leave
					 WHERE USER_ID IN('". SecurityFilter($userId) ."')		
				 ";
        if ($quicksort) {
            switch ($quicksort) {
                case"thismonth":
                    $query .= " AND DATE_FORMAT(LEAVE_DATE2,'%Y-%m')=DATE_FORMAT(NOW(),'%Y-%m')";
                    break;
                case"lastmonth":
                    $query .= " AND ((MONTH(LEAVE_DATE2)=(MONTH(CURDATE())-1) AND YEAR(LEAVE_DATE2)=YEAR(CURDATE()))
									OR (MONTH(CURDATE())=1 AND MONTH(LEAVE_DATE2)=12 AND (YEAR(LEAVE_DATE2)=YEAR(CURDATE())-1)))";
                    break;
                case"all":
                    $query .= " AND LEAVE_DATE1>='" . SecurityFilter($startDate) . "'
					   AND LEAVE_DATE2<='" . SecurityFilter($endDate) . " 23:59'";
                    break;
            }
        } else {
            $query .= " AND LEAVE_DATE1>='" . SecurityFilter($startDate) . "'
					   AND LEAVE_DATE2<='" . SecurityFilter($endDate) . ' 23:59' . "'";
        }

        $getCountQuery = "SELECT COUNT(*) AS CNT FROM" . $query;
        $getCountResult = exequery($connection, $getCountQuery);
        if ($getCountRow = mysql_fetch_array($getCountResult)) {
            $resultCount = $getCountRow['CNT'];
        }

        $query .= "  ORDER BY LEAVE_ID DESC";
        $offset = $offset * $rows;

        //批量删除最后一页的数据，页面无跳转的问题的问题的修复
        if ($offset >= $resultCount) {
            $offset = max(0, $offset - $rows);
        }
        $query .= " LIMIT " . $offset . "," . $rows;
        $res = exequery($connection, $leave_select . $query);
        $count = 0;
        while ($Row = mysql_fetch_array($res)) {
            $count++;
            $reStr[$count]['LEAVE_ID'] = $Row['LEAVE_ID'];
            $reStr[$count]['LEAVE_TYPE'] = $Row['LEAVE_TYPE'];
            $reStr[$count]['LEAVE_DATE1'] = $Row['LEAVE_DATE1'];
            $reStr[$count]['LEAVE_DATE2'] = $Row['LEAVE_DATE2'];
            $reStr[$count]['LEAVE_COUNTS'] = $Row['LEAVE_COUNTS'];
            $reStr[$count]['TYPE_ID'] = $Row['TYPE_ID'];
        }
        $reStr[1]['COUNT'] = $resultCount;
        return $reStr;
    }

    /**
     * 获取请假信息(在新表中)
     */
    function getLeaveMassageArray($params, $value = '') {
        global $connection, $LOGIN_USER_ID, $_lang;

        $startDate = $params['startDate'] ? $params['startDate'] : date('Y-m') . "-01";
        $endDate = $params['endDate'] ? $params['endDate'] : date('Y-m-d', time());
        $userId = $params['userId'] ? $params['userId'] : $LOGIN_USER_ID;
        $fields = $params['fields'] ? $params['fields'] : "*";

        $query = "SELECT $fields FROM attend_leave
					 WHERE DATE_FORMAT(LEAVE_DATE2,'%Y-%m-%d')>='" . SecurityFilter($startDate) . "'
					 AND DATE_FORMAT(LEAVE_DATE1,'%Y-%m-%d')<='" . SecurityFilter($endDate) . "'";
        if ($value == '') {
            $query .= " AND USER_ID IN('". SecurityFilter($userId) ."')";
        } else {
            if ($params['userId'] != '') {
                $query .= " AND USER_ID IN('" . SecurityFilter(str_replace(",", "','", substr($userId, 0, -1))) . "')";
            }
        }

        $query = page($query, 30);
        $res = exequery($connection, $query);
        $count = 0;

        while ($Row = mysql_fetch_array($res)) {
            $count++;
            $reStr[$count]['LEAVE_ID'] = $Row['LEAVE_ID'];
            $reStr[$count]['USER_ID'] = $Row['USER_ID'];
            $reStr[$count]['LEAVE_TYPE'] = $Row['LEAVE_TYPE'];
            $reStr[$count]['LEAVE_DATE1'] = $Row['LEAVE_DATE1'];
            $reStr[$count]['LEAVE_DATE2'] = $Row['LEAVE_DATE2'];
            $reStr[$count]['TYPE_ID'] = $Row['TYPE_ID'];
            $reStr[$count]['LEAVE_COUNTS'] = $Row['LEAVE_COUNTS'];
        }
        return $reStr;
    }

    function getLeaveInfo($params, $limitRows, $limitOffset, $isAll = 0) {
        global $connection, $LOGIN_USER_ID, $_lang;

        if (isset($params['total'])) {
            $fields = $params['fields'] ? $params['fields'] : "*";
            $where = $params['where'] ? $params['where'] : '';
            $query = "SELECT $fields FROM attend_leave where 1=1 $where";
            $queryCount = "SELECT COUNT($fields) AS CNT FROM attend_leave where 1=1 $where";
        } else {
            $startDate = $params['startDate'] ? $params['startDate'] : date('Y-m') . "-01";
            $endDate = $params['endDate'] ? $params['endDate'] : date('Y-m-d', time());
            $userId = $params['userId'] ? $params['userId'] : $LOGIN_USER_ID;
            $fields = $params['fields'] ? $params['fields'] : "*";
            $where = $params['where'] ? $params['where'] : '';

            $query = "SELECT $fields FROM attend_leave
                         WHERE DATE_FORMAT(LEAVE_DATE2,'%Y-%m-%d')>='" . SecurityFilter($startDate) . "'
                         AND DATE_FORMAT(LEAVE_DATE1,'%Y-%m-%d')<='" . SecurityFilter($endDate) . "' $where";
            $queryCount = "SELECT COUNT($fields) AS CNT FROM attend_leave
                         WHERE DATE_FORMAT(LEAVE_DATE2,'%Y-%m-%d')>='" . SecurityFilter($startDate) . "'
                         AND DATE_FORMAT(LEAVE_DATE1,'%Y-%m-%d')<='" . SecurityFilter($endDate) . "' $where";

            if ($isAll == 0) {
                $query .= "  AND USER_ID IN('". SecurityFilter($userId) ."')";
                $queryCount .= "  AND USER_ID IN('". SecurityFilter($userId) ."')";
            }
        }
        $query .= " LIMIT $limitOffset,$limitRows";
        $res = exequery($connection, $query);

        $result = array();
        while ($Row = mysql_fetch_array($res)) {
            $Row['TYPE_NAME'] = $this->getTypeName($Row['TYPE_ID']);
            $Row['LEAVE_DATE'] = $Row['LEAVE_DATE1'] . '--' . $Row['LEAVE_DATE2'];
            $Row['USER_NAME'] = showUserGeneral($Row['USER_ID']);
            array_push($result, $Row);
        }
        $resCount = exequery($connection, $queryCount);
        $row = mysql_fetch_array($resCount);
        $totalcnt = $row['CNT'];
        return array(
            'totalCount' => $totalcnt,
            'list' => $result
        );
    }

    function getLeaveCount($params) {
        global $connection, $LOGIN_USER_ID, $_lang;
        $startDate = $params['startDate'] ? $params['startDate'] : date('Y-m') . "-01";
        $endDate = $params['endDate'] ? $params['endDate'] : date('Y-m-d', time());
        $userId = $params['userId'] ? $params['userId'] : $LOGIN_USER_ID;
        $fields = $params['fields'] ? $params['fields'] : "*";

        $query = "SELECT $fields FROM attend_leave
                WHERE DATE_FORMAT(LEAVE_DATE1,'%Y-%m-%d')>='" . SecurityFilter($startDate) . "'
                AND DATE_FORMAT(LEAVE_DATE2,'%Y-%m-%d')<='" . SecurityFilter($endDate) . "' AND USER_ID IN('". SecurityFilter($userId) ."')";
        $res = exequery($connection, $query);
        $total = 0;
        while ($Row = mysql_fetch_array($res)) {
            $total+=$Row['LEAVE_COUNTS'];
        }
        return $total;
    }

    /**
     * 获取旷工的其他信息
     */
    function getOutWorkArray($params) {
        global $connection, $LOGIN_USER_ID, $_lang;
        $startDate = $params['startDate'] ? $params['startDate'] : date('Y-m-d H:i:s') . "-01";
        $endDate = $params['endDate'] ? $params['endDate'] : date('Y-m-d H:i:s');
        $userId = $params['userId'] ? $params['userId'] : $LOGIN_USER_ID;
        $query = "SELECT * FROM attend_record WHERE SIGN_DATE>='".SecurityFilter($startDate)."'
					  AND SIGN_DATE<='". SecurityFilter($endDate) ."'
					  AND USER_ID IN('". SecurityFilter($userId) ."')
				 ";
        $res = exequery($connection, $query);
        $count = 0;
        while ($row = mysql_fetch_array($res)) {
            $count++;
            $reStr[$count]['SIGN_DATE'] = $row["SIGN_DATE"];
            $reStr[$count]['ATTEND_LEAVE'] = $row["ATTEND_LEAVE"];
            $reStr[$count]['ATTEND_OUT'] = $row["ATTEND_OUT"];
            $reStr[$count]['ATTEND_EVECTION'] = $row["ATTEND_EVECTION"];
        }
        return $reStr;
    }

    /**
     * 外出登记记录	 
     */
    function getAttendOutMassageArrays($params, $quicksort = '', $offset = '', $rows = '') {
        global $connection, $LOGIN_USER_ID, $_lang;
        $reStr = "";

        $startDate = $params['startDate'] ? $params['startDate'] : date('Y-m') . "-01";
        $endDate = $params['endDate'] ? $params['endDate'] : date('Y-m-t', time());
        $userId = $params['userId'] ? $params['userId'] : $LOGIN_USER_ID;
        $where = $params['where'] ? $params['where'] : "";

        $out_select = "SELECT * FROM";
        $query = " attend_out
				          WHERE USER_ID IN('". SecurityFilter($userId) ."') 
				      ";
        if ($quicksort) {
            switch ($quicksort) {
                case"thismonth":
                    $query .= " AND DATE_FORMAT(OUT_DATE2,'%Y-%m')=DATE_FORMAT(NOW(),'%Y-%m')";
                    break;
                case"lastmonth":
                    $query .= " AND ((MONTH(OUT_DATE2)=(MONTH(CURDATE())-1) AND YEAR(OUT_DATE2)=YEAR(CURDATE()))
									OR (MONTH(CURDATE())=1 AND MONTH(OUT_DATE2)=12 AND (YEAR(OUT_DATE2)=YEAR(CURDATE())-1)))";
                    break;
                case"all":
                    $query .= " AND OUT_DATE1>='" . SecurityFilter($startDate) . "'
					   AND OUT_DATE2<='" . SecurityFilter($endDate) . ' 23:59' . "'";
                    break;
            }
        } else {
            $query .= " AND OUT_DATE1>='" . SecurityFilter($startDate) . "'
					   AND OUT_DATE2<='" . SecurityFilter($endDate) . ' 23:59' . "'";
        }

        $getCountQuery = "SELECT COUNT(*) AS CNT FROM" . $query;
        $getCountResult = exequery($connection, $getCountQuery);
        if ($getCountRow = mysql_fetch_array($getCountResult)) {
            $resultCount = $getCountRow['CNT'];
        }

        $query .= "  ORDER BY OUT_ID DESC";

        $offset = $offset * $rows;
        //批量删除最后一页的数据，页面无跳转的问题的问题的修复
        if ($offset >= $resultCount) {
            $offset = max(0, $offset - $rows);
        }
        $query .= " LIMIT " . $offset . "," . $rows;

        $res = exequery($connection, $out_select . $query);
        $count = 0;
        while ($Row = mysql_fetch_array($res)) {
            $count++;
            $reStr[$count]['OUT_ID'] = $Row['OUT_ID'];
            $reStr[$count]['OUT_TYPE'] = $Row['OUT_TYPE'];
            $reStr[$count]['OUT_DATE1'] = $Row['OUT_DATE1'];
            $reStr[$count]['OUT_TIME1'] = $Row['OUT_TIME1'];
            $reStr[$count]['OUT_DATE2'] = $Row['OUT_DATE2'];
            $reStr[$count]['OUT_TIME2'] = $Row['OUT_TIME2'];
        }
        $reStr[1]['COUNT'] = $resultCount;
        return $reStr;
    }

    function getOutInfo($params, $limitRows, $limitOffset, $isAll = 0) {
        global $connection, $LOGIN_USER_ID, $_lang;
        if (isset($params['total'])) {
            $where = $params['where'] ? $params['where'] : "";
            $out_select = "SELECT * FROM";
            $query = " attend_out
                              WHERE 1=1 $where
                          ";
            $getCountQuery = "SELECT COUNT(*) AS CNT FROM" . $query;
        } else {
            $startDate = $params['startDate'] ? $params['startDate'] : date('Y-m') . "-01";
            $endDate = $params['endDate'] ? $params['endDate'] : date('Y-m-d', time());
            $userId = $params['userId'] ? $params['userId'] : $LOGIN_USER_ID;
            $where = $params['where'] ? $params['where'] : "";

            $out_select = "SELECT * FROM";
            $query = " attend_out
                              WHERE 
                          ";

            $query .= " OUT_DATE2>='" . SecurityFilter($startDate) . "'
                    AND OUT_DATE1<='" . SecurityFilter($endDate) . ' 23:59' . "'";

            if ($isAll == 0) {
                $query .= " AND USER_ID IN('". SecurityFilter($userId) ."')";
            }

            $getCountQuery = "SELECT COUNT(*) AS CNT FROM" . $query;
        }
        $getCountResult = exequery($connection, $getCountQuery);
        if ($getCountRow = mysql_fetch_array($getCountResult)) {
            $resultCount = $getCountRow['CNT'];
        }

        $query .= " LIMIT " . $limitOffset . "," . $limitRows;

        $res = exequery($connection, $out_select . $query);
                
        $result = array();
        while ($Row = mysql_fetch_array($res)) {
            $Row['OUT_DATE'] = $Row['OUT_DATE1'] . ' ' . $Row['OUT_TIME1'] . '--' . $Row['OUT_DATE2'] . ' ' . $Row['OUT_TIME2'];
            $Row['USER_NAME'] = showUserGeneral($Row['USER_ID']);
            array_push($result, $Row);
        }
        return array(
            'totalCount' => $resultCount,
            'list' => $result
        );
    }

    function getOutCount($params) {
        global $connection, $LOGIN_USER_ID, $_lang;
        $startDate = $params['startDate'] ? $params['startDate'] : date('Y-m') . "-01";
        $endDate = $params['endDate'] ? $params['endDate'] : date('Y-m-d', time());
        $userId = $params['userId'] ? $params['userId'] : $LOGIN_USER_ID;
        $where = $params['where'] ? $params['where'] : "";

        $out_select = "SELECT * FROM";
        $query = " attend_out
                        WHERE USER_ID IN('". SecurityFilter($userId) ."') 
                    ";

        $query .= " AND OUT_DATE1>='" . SecurityFilter($startDate) . "'
                    AND OUT_DATE2<='" . SecurityFilter($endDate) . ' 23:59' . "'";

        $getCountQuery = "SELECT COUNT(*) AS CNT FROM" . $query;
        $getCountResult = exequery($connection, $getCountQuery);
        if ($getCountRow = mysql_fetch_array($getCountResult)) {
            $resultCount = $getCountRow['CNT'];
        }
        return $resultCount;
    }

    /**
     * 外出详情显示	 
     */
    function getAttendOutMassageArray($params, $value = '') {
        global $connection, $LOGIN_USER_ID, $_lang;
        $startDate = $params['startDate'] ? $params['startDate'] : date('Y-m') . "-01";
        $endDate = $params['endDate'] ? $params['endDate'] : date('Y-m-t', time());
        $userId = $params['userId'] ? $params['userId'] : $LOGIN_USER_ID;
        $fields = $params['fields'] ? $params['fields'] : "*";
        $query = "SELECT $fields FROM attend_out
				          WHERE OUT_DATE2>='" . SecurityFilter($startDate) . "'
					      AND OUT_DATE1<='" . SecurityFilter($endDate) . "'";

        if ($value == '') {
            $query .= " AND USER_ID IN('". SecurityFilter($userId) ."')";
        } else {
            if ($params['userId'] != '') {
                $query .= " AND USER_ID IN('" . SecurityFilter(str_replace(",", "','", substr($userId, 0, -1))) . "')";
            }
        }

        $query = page($query, 30);
        $res = exequery($connection, $query);
        while ($Row = mysql_fetch_array($res)) {
            $count++;
            $reStr[$count]['OUT_ID'] = $Row['OUT_ID'];
            $reStr[$count]['USER_ID'] = $Row['USER_ID'];
            $reStr[$count]['OUT_TYPE'] = $Row['OUT_TYPE'];
            $reStr[$count]['OUT_DATE1'] = $Row['OUT_DATE1'];
            $reStr[$count]['OUT_TIME1'] = $Row['OUT_TIME1'];
            $reStr[$count]['OUT_DATE2'] = $Row['OUT_DATE2'];
            $reStr[$count]['OUT_TIME2'] = $Row['OUT_TIME2'];
        }
        return $reStr;
    }

    /**
     * 出差登记记录	 
     */
    function getOutMassageArrays($params, $quicksort = '', $offset = '', $rows = '') {
        global $connection, $LOGIN_USER_ID, $_lang;
        $reStr = "";
        $startDate = $params['startDate'] ? $params['startDate'] : date('Y-m') . "-01";
        $endDate = $params['endDate'] ? $params['endDate'] : date('Y-m-t', time());
        $userId = $params['userId'] ? $params['userId'] : $LOGIN_USER_ID;
        $where = $params['where'] ? $params['where'] : "";

        $evection_select = "SELECT * FROM";
        $query = " attend_evection
				      WHERE USER_ID IN('". SecurityFilter($userId) ."')
				 ";
        if ($quicksort) {
            switch ($quicksort) {
                case"thismonth":
                    $query .= " AND DATE_FORMAT(EVECTION_DATE2,'%Y-%m')=DATE_FORMAT(NOW(),'%Y-%m')";
                    break;
                case"lastmonth":
                    $query .= " AND ((MONTH(EVECTION_DATE2)=(MONTH(CURDATE())-1) AND YEAR(EVECTION_DATE2)=YEAR(CURDATE()))
									OR (MONTH(CURDATE())=1 AND MONTH(EVECTION_DATE2)=12 AND (YEAR(EVECTION_DATE2)=YEAR(CURDATE())-1)))";
                    break;
                case"all":
                    $query .= " AND EVECTION_DATE1>='" . SecurityFilter($startDate) . "'
					   AND EVECTION_DATE2<='" . SecurityFilter($endDate) . ' 23:59' . "'";
                    break;
            }
        } else {
            $query .= " AND EVECTION_DATE1>='" . SecurityFilter($startDate) . "'
					   AND EVECTION_DATE2<='" . SecurityFilter($endDate) . ' 23:59' . "'";
        }

        $getCountQuery = "SELECT COUNT(*) AS CNT FROM" . $query;
        $getCountResult = exequery($connection, $getCountQuery);
        if ($getCountRow = mysql_fetch_array($getCountResult)) {
            $resultCount = $getCountRow['CNT'];
        }

        $query .= "  ORDER BY EVECTION_ID DESC";

        $offset = $offset * $rows;
        //批量删除最后一页的数据，页面无跳转的问题的问题的修复
        if ($offset >= $resultCount) {
            $offset = max(0, $offset - $rows);
        }
        $query .= " limit " . $offset . "," . $rows;

        $res = exequery($connection, $evection_select . $query);

        while ($Row = mysql_fetch_array($res)) {
            $count++;
            $reStr[$count]['EVECTION_ID'] = $Row['EVECTION_ID'];
            $reStr[$count]['EVECTION_REASON'] = $Row['EVECTION_REASON'];
            $reStr[$count]['EVECTION_DEST'] = $Row['EVECTION_DEST'];
            $reStr[$count]['EVECTION_DATE1'] = $Row['EVECTION_DATE1'];
            $reStr[$count]['EVECTION_DATE2'] = $Row['EVECTION_DATE2'];
        }
        $reStr[1]['COUNT'] = $resultCount;
        return $reStr;
    }

    /**
     * 加班信息
     */
    function getOvertimeMassageArrays($params, $quicksort = '', $offset = '', $rows = '') {
        global $connection, $LOGIN_USER_ID, $_lang;

        $startDate = $params['startDate'] ? $params['startDate'] : date("Y-m") . "-01";
        $endDate = $params['endDate'] ? $params['endDate'] : date("Y-m-t", time());
        $userId = $params['userId'] ? $params['userId'] : $LOGIN_USER_ID;

        $overtime_select = "SELECT * FROM";
        $query = " attend_overtime
				     WHERE USER_ID IN('". SecurityFilter($userId) ."')";
        if ($quicksort) {
            switch ($quicksort) {
                case"thismonth":
                    $query .= " AND DATE_FORMAT(OVERTIME_DATE2,'%Y-%m')=DATE_FORMAT(NOW(),'%Y-%m')";
                    break;
                case"lastmonth":
                    $query .= " AND ((MONTH(OVERTIME_DATE2)=(MONTH(CURDATE())-1) AND YEAR(OVERTIME_DATE2)=YEAR(CURDATE()))
									OR (MONTH(CURDATE())=1 AND MONTH(OVERTIME_DATE2)=12 AND (YEAR(OVERTIME_DATE2)=YEAR(CURDATE())-1)))";
                    break;
                case"all":
                    $query .= " AND OVERTIME_DATE1>='" . SecurityFilter($startDate) . "'
					   AND OVERTIME_DATE2<='" . SecurityFilter($endDate) . "'";
                    break;
            }
        } else {
            $query .= " AND OVERTIME_DATE1>='" . SecurityFilter($startDate) . "'
					   AND OVERTIME_DATE2<='" . SecurityFilter($endDate) . "'";
        }

        $getCountQuery = "SELECT COUNT(*) AS CNT FROM" . $query;
        $getCountResult = exequery($connection, $getCountQuery);
        if ($getCountRow = mysql_fetch_array($getCountResult)) {
            $resultCount = $getCountRow['CNT'];
        }

        $query .= "  ORDER BY OVERTIME_ID DESC";

        $offset = $offset * $rows;
        //批量删除最后一页的数据，页面无跳转的问题的问题的修复
        if ($offset >= $resultCount) {
            $offset = max(0, $offset - $rows);
        }
        $query .= " LIMIT " . $offset . "," . $rows;

        $res = exequery($connection, $overtime_select . $query);
        $count = 0;
        while ($row = mysql_fetch_array($res)) {
            $count++;
            $reStr[$count]['OVERTIME_ID'] = $row['OVERTIME_ID'];
            $reStr[$count]['OVERTIME_DATE1'] = $row['OVERTIME_DATE1'];
            $reStr[$count]['OVERTIME_DATE2'] = $row['OVERTIME_DATE2'];
            $reStr[$count]['OVERTIME_TIME1'] = $row['OVERTIME_TIME1'];
            $reStr[$count]['OVERTIME_TIME2'] = $row['OVERTIME_TIME2'];
            $reStr[$count]['OVERTIME_DESC'] = $row['OVERTIME_DESC'];
        }
        $reStr[1]['COUNT'] = $resultCount;
        return $reStr;
    }

    /**
     * 出差详情显示	 
     */
    function getOutMassageArray($params, $value = '') {
        global $connection, $LOGIN_USER_ID, $_lang;
        $startDate = $params['startDate'] ? $params['startDate'] : date('Y-m') . "-01";
        $endDate = $params['endDate'] ? $params['endDate'] : date('Y-m-t', time());
        $userId = $params['userId'] ? $params['userId'] : $LOGIN_USER_ID;
        $where = $params['where'] ? $params['where'] : "";
        $fields = $params['fields'] ? $params['fields'] : "*";
        $query = "SELECT $fields FROM attend_evection
					 WHERE EVECTION_DATE2>='" . SecurityFilter($startDate) . "'
					 AND EVECTION_DATE1<='" . SecurityFilter($endDate) . "' 
				 ";
        if ($value == '') {
            $query .= " AND USER_ID IN('". SecurityFilter($userId) ."')";
        } else {
            if ($params['userId'] != '') {
                $query .= " AND USER_ID IN('" . SecurityFilter(str_replace(",", "','", substr($userId, 0, -1))) . "')";
            }
        }
        $query = page($query, 30);
        $res = exequery($connection, $query);
        while ($Row = mysql_fetch_array($res)) {
            $count++;
            $reStr[$count]['USER_ID'] = $Row['USER_ID'];
            $reStr[$count]['EVECTION_ID'] = $Row['EVECTION_ID'];
            $reStr[$count]['EVECTION_REASON'] = $Row['EVECTION_REASON'];
            $reStr[$count]['EVECTION_DEST'] = $Row['EVECTION_DEST'];
            $reStr[$count]['EVECTION_DATE1'] = $Row['EVECTION_DATE1'];
            $reStr[$count]['EVECTION_DATE2'] = $Row['EVECTION_DATE2'];
        }
        return $reStr;
    }

    function getEvectionInfo($params, $limitRows, $limitOffset, $isAll = 0) {
        global $connection, $LOGIN_USER_ID, $_lang;
        if (isset($params['total'])) {
            $fields = $params['fields'] ? $params['fields'] : "*";
            $where = $params['where'] ? $params['where'] : "";
            $query = "SELECT $fields FROM attend_evection
                         WHERE 1=1 $where";
            $queryCount = "SELECT COUNT($fields) AS CNT FROM attend_evection
                         WHERE 1=1 $where";
        } else {
            $startDate = $params['startDate'] ? $params['startDate'] : date('Y-m') . "-01";
            $endDate = $params['endDate'] ? $params['endDate'] : date('Y-m-t', time());
            $userId = $params['userId'] ? $params['userId'] : $LOGIN_USER_ID;
            $where = $params['where'] ? $params['where'] : "";
            $fields = $params['fields'] ? $params['fields'] : "*";
            $query = "SELECT $fields FROM attend_evection
                         WHERE EVECTION_DATE2>='" . SecurityFilter($startDate) . "'
                         AND EVECTION_DATE1<='" . SecurityFilter($endDate) . "' $where";
            $queryCount = "SELECT COUNT($fields) AS CNT FROM attend_evection
                         WHERE EVECTION_DATE2>='" . SecurityFilter($startDate) . "'
                         AND EVECTION_DATE1<='" . SecurityFilter($endDate) . "' $where";

            if ($isAll == 0) {
                $query .= "  AND USER_ID IN('". SecurityFilter($userId) ."')";
                $queryCount .= "  AND USER_ID IN('". SecurityFilter($userId) ."')";
            }
        }
        $query .=" LIMIT $limitOffset,$limitRows";

        $res = exequery($connection, $query);
        $result = array();
        while ($Row = mysql_fetch_array($res)) {
            $Row['EVECTION_DATE'] = $Row['EVECTION_DATE1'] . '--' . $Row['EVECTION_DATE2'];
            $Row['USER_NAME'] = showUserGeneral($Row['USER_ID']);
            array_push($result, $Row);
        }
        $resCount = exequery($connection, $queryCount);
        $row = mysql_fetch_array($resCount);
        $totalcnt = $row['CNT'];
        return array(
            'totalCount' => $totalcnt,
            'list' => $result
        );
    }

    function getEvectionCount($params) {
        global $connection, $LOGIN_USER_ID, $_lang;
        $startDate = $params['startDate'] ? $params['startDate'] : date('Y-m') . "-01";
        $endDate = $params['endDate'] ? $params['endDate'] : date('Y-m-t', time());
        $userId = $params['userId'] ? $params['userId'] : $LOGIN_USER_ID;
        $where = $params['where'] ? $params['where'] : "";
        $fields = $params['fields'] ? $params['fields'] : "*";
        $queryCount = "SELECT COUNT($fields) AS CNT FROM attend_evection
                    WHERE EVECTION_DATE1>='" . SecurityFilter($startDate) . "'
                    AND EVECTION_DATE2<='" . SecurityFilter($endDate) . "' 
                    ";
        $queryCount .= " AND USER_ID IN('". SecurityFilter($userId) ."')";
        $resCount = exequery($connection, $queryCount);
        $row = mysql_fetch_array($resCount);
        $totalcnt = $row['CNT'];
        return $totalcnt;
    }

    /**
     * 加班详情显示
     */
    function getOvertimeArray($params, $value = '') {
        global $connection, $LOGIN_USER_ID, $_lang;
        $startDate = $params['startDate'] ? $params['startDate'] : date("Y-m") . "-01";
        $endDate = $params['endDate'] ? $params['endDate'] : date("Y-m-t", time());
        $userId = $params['userId'] ? $params['userId'] : $LOGIN_USER_ID;
        $where = $params['where'] ? $params['where'] : "";

        $query = "SELECT * FROM attend_overtime
					  WHERE OVERTIME_COUNTS >= 0 AND OVERTIME_DATE2>='" . SecurityFilter($startDate) . "'
					  AND OVERTIME_DATE1<='" . SecurityFilter($endDate) . " 23:59" . "'";
        if ($value == "") {
            $query .= " AND USER_ID IN('". SecurityFilter($userId) ."')";
        } else {
            if ($params['userId'] != '') {
                $query .= " AND USER_ID IN ('" . SecurityFilter(str_replace(",", "','", substr($userId, 0, -1))) . "')";
            }
        }

        $query = page($query, 30);
        $res = exequery($connection, $query);
        $count = 0;
        while ($row = mysql_fetch_array($res)) {
            $count++;
            $reStr[$count]['USER_ID'] = $row['USER_ID'];
            $reStr[$count]['OVERTIME_ID'] = $row['OVERTIME_ID'];
            $reStr[$count]['OVERTIME_DATE1'] = $row['OVERTIME_DATE1'];
            $reStr[$count]['OVERTIME_DATE2'] = $row['OVERTIME_DATE2'];
            $reStr[$count]['OVERTIME_TIME1'] = $row['OVERTIME_TIME1'];
            $reStr[$count]['OVERTIME_TIME2'] = $row['OVERTIME_TIME2'];
            $reStr[$count]['OVERTIME_DESC'] = $row['OVERTIME_DESC'];
        }
        return $reStr;
    }

    function getOvertimeInfo($params, $limitRows, $limitOffset, $isAll = 0) {
        global $connection, $LOGIN_USER_ID, $_lang;
        if (isset($params['total'])) {
            $where = $params['where'] ? $params['where'] : "";

            $query = "SELECT * FROM attend_overtime WHERE 1=1 $where AND OVERTIME_COUNTS >= 0";
            $queryCount = "SELECT COUNT(*) AS CNT FROM attend_overtime WHERE 1=1 $where AND OVERTIME_COUNTS >= 0";
        } else {
            $startDate = $params['startDate'] ? $params['startDate'] : date("Y-m") . "-01";
            $endDate = $params['endDate'] ? $params['endDate'] : date("Y-m-t", time());
            $userId = $params['userId'] ? $params['userId'] : $LOGIN_USER_ID;
            $where = $params['where'] ? $params['where'] : "";

            $query = "SELECT * FROM attend_overtime
                          WHERE OVERTIME_DATE2>='" . SecurityFilter($startDate) . "'
                          AND OVERTIME_DATE1<='" . SecurityFilter($endDate) . " 23:59" . "' AND OVERTIME_COUNTS >= 0";

            $queryCount = "SELECT COUNT(*) AS CNT FROM attend_overtime
                          WHERE OVERTIME_DATE2>='" . SecurityFilter($startDate) . "'
                          AND OVERTIME_DATE1<='" . SecurityFilter($endDate) . " 23:59" . "' AND OVERTIME_COUNTS >= 0";

            if ($isAll == 0) {
                $query .= " AND USER_ID IN('". SecurityFilter($userId) ."')";
                $queryCount.=" AND USER_ID IN('". SecurityFilter($userId) ."')";
            }
        }
        $query .=" LIMIT $limitOffset,$limitRows";
        $res = exequery($connection, $query);

        $result = array();
        while ($row = mysql_fetch_array($res)) {
            $row['OVERTIME_DATE'] = $row['OVERTIME_DATE1'] . ' ' . $row['OVERTIME_TIME1'] . '--' . $row['OVERTIME_DATE2'] . ' 
            ' . $row['OVERTIME_TIME2'];
            $row['USER_NAME'] = showUserGeneral($row['USER_ID']);
            array_push($result, $row);
        }
        $resCount = exequery($connection, $queryCount);
        $r = mysql_fetch_array($resCount);
        $totalcnt = $r['CNT'];
        return array(
            'totalCount' => $totalcnt,
            'list' => $result
        );
    }

    function getOvertimeCount($params) {
        global $connection, $LOGIN_USER_ID, $_lang;
        $startDate = $params['startDate'] ? $params['startDate'] : date("Y-m") . "-01";
        $endDate = $params['endDate'] ? $params['endDate'] : date("Y-m-t", time());
        $userId = $params['userId'] ? $params['userId'] : $LOGIN_USER_ID;
        $where = $params['where'] ? $params['where'] : "";

        $queryCount = "SELECT COUNT(*) AS CNT FROM attend_overtime
                    WHERE OVERTIME_DATE1>='" . SecurityFilter($startDate) . "'
                    AND OVERTIME_DATE2<='" . SecurityFilter($endDate) . " 23:59" . "' AND OVERTIME_COUNTS >= 0";
        $queryCount.=" AND USER_ID IN('". SecurityFilter($userId) ."')";
        $res = exequery($connection, $queryCount);
        $r = mysql_fetch_array($res);
        $totalcnt = $r['CNT'];
        return $totalcnt;
    }

    /**
     * 获取请假状态	
     */
    function getLeaveTypeStr($arrayLeave) {
        global $_lang;
        $typeId = $arrayLeave['ALLOW'];
        $leaveId = $arrayLeave['LEAVE_ID'];
        switch ($typeId) {
            case "0":
                $returnArray['state'] = $_lang["hr_attend_not_apply"];
                $returnArray['option'] = "<a href=\"javascript:delLeaveById('" . $leaveId . "')\">" . $_lang['hr_delete'] . "</a>";
                return $returnArray;
                break;
            case "1":
                $returnArray['state'] = "<span style='color:#66CC00'>" . $_lang["hr_duty_apply_alreadly"] . "</span>";
                $returnArray['option'] = $_lang["hr_duty_check_nothing"];
                return $returnArray;
                break;
            case "2":
                $returnArray['state'] = "<span style='color:red'>" . $_lang["hr_duty_apply_alrea_yes"] . "</span>";
                $returnArray['option'] = "<a href=\"javascript:delLeaveById('" . $leaveId . "')\">" . $_lang['hr_delete'] . "</a>";
                return $returnArray;
                break;
            case "3":
                $returnArray['state'] = $_lang["hr_attend_already_over"];
                $returnArray['option'] = $_lang["hr_duty_check_nothing"];
                return $returnArray;
                break;
        }
    }

    /**
     * 获取排班名称
     */
    function getWorkTypeName($id) {
        global $connection;
        $query = "SELECT DUTY_NAME FROM attend_config 
					 WHERE DUTY_ID = '". SecurityFilter($id) ."'
				 ";
        $res = exequery($connection, $query);
        $Row = mysql_fetch_array($res);
        return $Row['DUTY_NAME'];
    }

    /**
     * 获取部门名称URL
     */
    function getDeptNameUrlById($deptId) {
        global $connection;
        $query = "SELECT DEPT_NAME FROM department 
				      WHERE DEPT_ID = '". SecurityFilter($deptId) ."'
				 ";
        $res = exequery($connection, $query);
        $Row = mysql_fetch_array($res);
        return "<a href='" . $_SERVER['PHP_SELF'] . "?deptIds=" . $deptId . ",'>" . $Row['DEPT_NAME'] . "</a>";
    }

    /**
     * 根据部门ID获取用户数目
     */
    function getDeptNumById($deptId) {
        global $connection;
        $query = "
				SELECT count(*) as CNT from user WHERE DEPT_ID = '". SecurityFilter($deptId) ."'
				";
        $res = exequery($connection, $query);
        $Row = mysql_fetch_array($res);
        return $Row['CNT'];
    }

    /**
     * 获取用户名称Url
     */
    function getUsernameStr($struserid) {
        global $connection;
        if ($struserid == "") {
            $usernamestr = "";
        } else {
            if (substr($struserid, -1, 1) == ",") {
                $struserid = substr($struserid, 0, strlen($struserid) - 1);
            }

            $struserid = "'" . str_replace(",", "','", $struserid) . "'";

            $sql = "SELECT USER_NAME FROM user WHERE USER_ID IN (" . SecurityFilter($struserid) . ")";
            $rs = exequery($connection, $sql);
            $uaccount = 0;
            while ($row = mysql_fetch_array($rs)) {
                $uaccount++;
                $user_name = $row['USER_NAME'];
                $strusername .= $user_name . ",";
            }
        }
        return $strusername;
    }

    /**
     * 获取部门名称Url
     */
    function getDeptnameStr($deptIds) {
        global $connection;
        if ($deptIds == "") {
            $deptNames = "";
        } else {
            if (substr($deptIds, -1, 1) == ",") {
                $deptIds = substr($deptIds, 0, strlen($deptIds) - 1);
            }
            $deptIds = "'" . str_replace(",", "','", $deptIds) . "'";
            $sql = "SELECT DEPT_NAME FROM department WHERE DEPT_ID IN (" . SecurityFilter($deptIds) . ")";
            $rs = exequery($connection, $sql);
            $uaccount = 0;
            while ($row = mysql_fetch_array($rs)) {
                $uaccount++;
                $deptName = $row['DEPT_NAME'];
                $deptNames .= $deptName . ",";
            }
        }
        return $deptNames;
    }

    /**
     * 获取角色名称Url
     */
    function getRoleNameStr($roleIds) {
        global $connection;
        if ($roleIds == "") {
            $roleNames = "";
        } else {
            if (substr($roleIds, -1, 1) == ",") {
                $roleIds = substr($roleIds, 0, strlen($roleIds) - 1);
            }
            $roleIds = "'" . str_replace(",", "','", $roleIds) . "'";
            $sql = "SELECT PRIV_NAME FROM user_priv WHERE USER_PRIV IN (" . SecurityFilter($roleIds) . ")";
            $rs = exequery($connection, $sql);
            $uaccount = 0;
            while ($row = mysql_fetch_array($rs)) {
                $uaccount++;
                $privName = $row['PRIV_NAME'];
                $roleNames .= $privName . ",";
            }
        }
        return $roleNames;
    }

    /**
     * 获取排班名称的Url
     */
    function getDutynameStr($dutyIds) {
        global $connection;
        if ($dutyIds == "") {
            $dutyNames = "";
        } else {
            if (substr($dutyIds, -1, 1) == ",") {
                $dutyIds = substr($dutyIds, 0, strlen($dutyIds) - 1);
            }
            $dutyIds = "'" . str_replace(",", "','", $dutyIds) . "'";
            $sql = "
						SELECT DUTY_NAME FROM attend_config 
							 WHERE DUTY_ID IN (" . SecurityFilter($dutyIds) . ")";
            $rs = exequery($connection, $sql);
            $uaccount = 0;
            while ($row = mysql_fetch_array($rs)) {
                $uaccount++;
                $dutyName = $row['DUTY_NAME'];
                $dutyNames .= $dutyName . ",";
            }
        }
        return $dutyNames;
    }

    //检测考勤是否异常
    function checkAttend($USER_ID, $SIGN_IN_TIME = '', $SIGN_OUT_TIME = '') {
        global $connection;
        if ($SIGN_IN_TIME != '') {
            $SIGN_TIME = $SIGN_IN_TIME;
        } else {
            $SIGN_TIME = $SIGN_OUT_TIME;
        }
        $USER_ID = SecurityFilter($USER_ID);
        $SIGN_TIME = SecurityFilter($SIGN_TIME);
        $query = "SELECT LEAVE_ID FROM attend_leave al
					   WHERE al.USER_ID = '$USER_ID'
					   AND '$SIGN_TIME' >= LEAVE_DATE1
					   AND '$SIGN_TIME' <= LEAVE_DATE2
				   UNION 
				   SELECT OUT_ID FROM attend_out ao
						WHERE ao.USER_ID = '$USER_ID'
						AND '$SIGN_TIME' >= CONCAT(OUT_DATE1,' ',OUT_TIME1) 
						AND '$SIGN_TIME' <= CONCAT(OUT_DATE2,' ',OUT_TIME2) 
				   UNION
				   SELECT EVECTION_ID FROM attend_evection ae
						WHERE ae.USER_ID = '$USER_ID'
						AND '$SIGN_TIME' >= EVECTION_DATE1
						AND '$SIGN_TIME' <= EVECTION_DATE2";
        $res = exequery($connection, $query);
        $num = mysql_num_rows($res);
        $LeaveArr = array();

        while ($row = mysql_fetch_array($res)) {
            $LEAVE_ID = $row["LEAVE_ID"];
            array_push($LeaveArr, $LEAVE_ID);

            if ($num > 0) {
                $LeaveArr = implode(",", $LeaveArr);
                $returnStr = $LeaveArr;
            } else {
                if ($SIGN_IN_TIME != '') {
                    $returnStr = $_lang["hr_attend_sign_status_lose"] . "<br>";
                }
                if ($SIGN_OUT_TIME != '') {
                    $returnStr = $_lang["hr_attend_sign_status_early"] . "<br>";
                }
            }
        }
        return $returnStr;
    }

    /**
     * 个人统计的考勤信息的方法
     *
     * */
    function getPersonalDutyMassage($params, $offset = '', $rows = '') {
        global $connection, $LOGIN_USER_ID, $_lang;
        $startDate = $params['startDate'] ? date("Y-m-d", $params['startDate']) : date('Y-m') . "-01";
        $endDate = $params['endDate'] ? date("Y-m-d", $params['endDate']) : date('Y-m-d');
        $userId = $params['userId'] ? $params['userId'] : $LOGIN_USER_ID;
        $where = $params['where'] ? $params['where'] : " ORDER BY DUTY_ID DESC";
        $fields = $params['fields'] ? $params['fields'] : "*";

        $person_sql = " ";
        $startDate = SecurityFilter($startDate);
        $endDate = SecurityFilter($endDate);
        $userId = SecurityFilter($userId);
        $query = "SELECT * FROM attend_duty 
				      WHERE sign_date>='$startDate'
					  AND sign_date<='$endDate'
					  AND USER_ID IN('$userId') ORDER BY sign_date DESC
				 ";

        preg_match('/SELECT ([^\"\']*)[\s]FROM[\s]/i', $query, $reg);
        $getCountQuery = str_replace($reg[1], 'COUNT(*) AS CNT', $query);
        $getCountResult = exequery($connection, $getCountQuery);
        if ($getCountRow = mysql_fetch_array($getCountResult)) {
            $resultCount = $getCountRow['CNT'];
        }

        if ($rows) {
            $offset = $offset * $rows;
            //批量删除最后一页的数据，页面无跳转的问题的问题的修复
            if ($offset >= $resultCount) {
                $offset = max(0, $offset - $rows);
            }
            $query .= " limit " . $offset . "," . $rows;
        }

        $res = exequery($connection, $person_sql . $query);
        $params['userId'] = $LOGIN_USER_ID;

        while ($Row = mysql_fetch_assoc($res)) {
            $count++;

            //考勤日期显示根据校验的SIGN_IN_TIME				
            $reStr[$count]['DUTY_ID'] = $Row['DUTY_ID'];
            $reStr[$count]['SIGN_DATE'] = $Row['sign_date'];
            $reStr[$count]['SIGN_IN_TIME'] = $Row['SIGN_IN_TIME'];
            $reStr[$count]['SIGN_OUT_TIME'] = $Row['SIGN_OUT_TIME'];
            $reStr[$count]['SIGN_IN_NORMAL'] = $Row['SIGN_IN_NORMAL'];
            $reStr[$count]['SIGN_OUT_NORMAL'] = $Row['SIGN_OUT_NORMAL'];
            $reStr[$count]['IN_TIME_DIFF'] = $Row['IN_TIME_DIFF'];
            $reStr[$count]['OUT_TIME_DIFF'] = $Row['OUT_TIME_DIFF'];
            $reStr[$count]['DUTY_TYPE'] = $Row['DUTY_TYPE'];
            $reStr[$count]['OUT_TYPE'] = $Row['OUT_TYPE'];
        }
        $reStr[1]['COUNT'] = $resultCount;
        return $reStr;
    }

    /*     * 校验是否有旷工
     * $params   传入包含开始日期，结束日期和用户ID信息的数组
     */

    function checkAbsent($params) {
        global $connection, $_lang;

        $searchDates = getDates($params["startDate"], $params["endDate"]);
        $params["startDate"] = SecurityFilter($params["startDate"]);
        $params["endDate"] = SecurityFilter($params["endDate"]);
        $params["userId"] = SecurityFilter($params["userId"]);
        $query = "SELECT * FROM attend_duty 
					  WHERE sign_date>='" . $params["startDate"] . "' 
					  AND sign_date<='" . $params["endDate"] . "' 
					  AND USER_ID='" . $params["userId"] . "'";

        $res = exequery($connection, $query);
        $attend_date = array();
        while ($row = mysql_fetch_array($res)) {

            $SIGN_IN_TIME = $row["SIGN_IN_TIME"];
            $SIGN_OUT_TIME = $row["SIGN_OUT_TIME"];
            $SIGN_IN_NORMAL = $row["SIGN_IN_NORMAL"];
            $SIGN_OUT_NORMAL = $row["SIGN_OUT_NORMAL"];
            $SIGN_DATE = $row["sign_date"];
            $DUTY_TYPE = $row["DUTY_TYPE"];

            $user_attend[$SIGN_DATE] = array("SIGN_IN" => $SIGN_IN_TIME,
                "SIGN_OUT" => $SIGN_OUT_TIME,
                "SIGN_IN_NORMAL" => $SIGN_IN_NORMAL,
                "SIGN_OUT_NORMAL" => $SIGN_OUT_NORMAL,
                "DUTY_TYPE" => $DUTY_TYPE);
            array_push($attend_date, $SIGN_DATE);
        }
        //补全查询日期内的缺少日期
        $date_diff = array_diff($searchDates, $attend_date);
        $dutyType = $this->getUserDutyType($params["userId"]);
        $dutyData = $this->getDutyById($dutyType);
        foreach ($date_diff as $key => $value) {
            $user_attend[$value] = array('SIGN_IN' => '',
                'SIGN_OUT' => '',
                'SIGN_IN_NORMAL' => date("H:i", $dutyData['dutySignIn']),
                'SIGN_OUT_NORMAL' => date("H:i", $dutyData['dutySignOut']),
                'DUTY_TYPE' => $dutyType);
        }
        //请假
        $sql = "SELECT * FROM attend_leave 
					WHERE DATE_FORMAT(LEAVE_DATE2,'%Y-%m-%d')>='" . $params['startDate'] . "'
					AND DATE_FORMAT(LEAVE_DATE1,'%Y-%m-%d')<='" . $params['endDate'] . "'
					AND USER_ID='" . $params["userId"] . "'";
        $res = exequery($connection, $sql);
        while ($row = mysql_fetch_array($res)) {
            $LEAVE_DATE1 = $row["LEAVE_DATE1"];
            $LEAVE_DATE2 = $row["LEAVE_DATE2"];

            $leave_dates = getDates($LEAVE_DATE1, $LEAVE_DATE2);

            if (count($leave_dates) == 1) {
                $leave_time[$leave_dates[0]] = array('start_time' => date('H:i', strtotime($LEAVE_DATE1)),
                    'end_time' => date('H:i', strtotime($LEAVE_DATE2)));
            } else {
                foreach ($leave_dates as $k => $v) {
                    if ($k == 0) {
                        $leave_time[$v] = array('start_time' => date("H:i", strtotime($LEAVE_DATE1)),
                            'end_time' => date("H:i", strtotime($dutyData['dutySignOut'])));
                    } else if ($k == count($leave_dates) - 1) {
                        $leave_time[$v] = array('start_time' => date("H:i", strtotime($dutyData['dutySignIn'])),
                            'end_time' => date("H:i", strtotime($LEAVE_DATE2)));
                    } else {
                        $leave_time[$v] = array('start_time' => date("H:i", strtotime($dutyData['dutySignIn'])),
                            'end_time' => date("H:i", strtotime($dutyData['dutySignOut'])));
                    }
                }
            }
        }

        //外出
        $sql1 = "SELECT * FROM attend_out
					WHERE OUT_DATE2>='" . $params['startDate'] . "'
					AND OUT_DATE1<='" . $params['endDate'] . "'
					AND USER_ID='" . $params["userId"] . "'";

        $res1 = exequery($connection, $sql1);
        while ($row = mysql_fetch_array($res1)) {
            $OUT_DATE1 = $row["OUT_DATE1"];
            $OUT_DATE2 = $row["OUT_DATE2"];
            $OUT_TIME1 = $row["OUT_TIME1"];
            $OUT_TIME2 = $row["OUT_TIME2"];

            $out_dates = getDates($OUT_DATE1, $OUT_DATE2);

            if (count($out_dates) == 1) {
                $out_time[$OUT_DATE1] = array('start_time' => $OUT_TIME1,
                    'end_time' => $OUT_TIME2);
            } else {
                foreach ($out_dates as $k => $v) {
                    if ($k == 0) {
                        $out_time[$v] = array('start_time' => $OUT_TIME1,
                            'end_time' => date("H:i", strtotime($dutyData['dutySignOut'])));
                    } else if ($k == count($out_dates) - 1) {
                        $out_time[$v] = array('start_time' => date("H:i", strtotime($dutyData['dutySignIn'])),
                            'end_time' => $OUT_TIME2);
                    } else {
                        $out_time[$v] = array('start_time' => date("H:i", strtotime($dutyData['dutySignIn'])),
                            'end_time' => date("H:i", strtotime($dutyData['dutySignOut'])));
                    }
                }
            }
        }

        //出差
        $sql2 = "SELECT * FROM attend_evection
						    WHERE EVECTION_DATE2>='" . $params['startDate'] . "'
							AND EVECTION_DATE1<='" . $params['endDate'] . "'
							AND USER_ID='" . $params["userId"] . "'";
        $res2 = exequery($connection, $sql2);
        while ($row = mysql_fetch_array($res2)) {
            $EVECTION_DATE1 = $row["EVECTION_DATE1"];
            $EVECTION_DATE2 = $row["EVECTION_DATE2"];

            $evection_dates = getDates($EVECTION_DATE1, $EVECTION_DATE2);
            if (count($evection_dates) == 1) {
                $evection_time[$evection_dates[0]] = array('start_time' => date("H:i", strtotime($dutyData['dutySignIn'])),
                    'end_time' => date("H:i", strtotime($dutyData['dutySignOut'])));
            } else {
                foreach ($evection_dates as $k => $v) {
                    $evection_time[$v] = array('start_time' => date("H:i", strtotime($dutyData['dutySignIn'])),
                        'end_time' => date("H:i", strtotime($dutyData['dutySignOut'])));
                }
            }
        }
        foreach ($user_attend as $key => $value) {
            if (($this->isAttendData('', $key, $params["userId"]) == 1) && $value['SIGN_IN'] == '' && $value['SIGN_OUT'] == '') {
                $attendInfo[$key] = array('attend_leave' => $leave_time[$key],
                    'attend_out' => $out_time[$key],
                    'attend_evection' => $evection_time[$key],
                    'dutysignin' => date("H:i", strtotime($dutyData['dutySignIn'])),
                    'dutysignout' => date("H:i", strtotime($dutyData['dutySignOut'])));
            }
        }
        return $attendInfo;
    }

    function getVerifyInfo($params, $limitRows, $limitOffset) {
        global $connection, $_lang;
        $startDate = $params['startDate'] ? $params['startDate'] : '';
        $endDate = $params['endDate'] ? $params['endDate'] : '';
        $startDate = SecurityFilter($startDate);
        $endDate = SecurityFilter($endDate);
        $where = $params['where'] ? $params['where'] : '';
        if ($startDate != '' && $endDate != '') {
            //考勤校验中的sql语句
            $query = "
                     SELECT * FROM attend_duty 
                         WHERE SIGN_IN_TIME>=$startDate
                         AND SIGN_IN_TIME<=$endDate
                         $where
                     ";
            $queryCount = "
                     SELECT COUNT(*) AS CNT FROM attend_duty 
                         WHERE SIGN_IN_TIME>=$startDate
                         AND SIGN_IN_TIME<=$endDate
                         $where
                     ";
        } else {
            //考勤校验中的sql语句
            $query = "
                    SELECT * FROM attend_duty 
                    WHERE 1=1
                    $where
            ";
            $queryCount = "
                    SELECT COUNT(*) AS CNT FROM attend_duty 
                    WHERE 1=1
                    $where
            ";
        }

        //查询有权限校验的用户
        $checkSetDataSql = "SELECT * FROM attend_check_manage";
        $checkSetDataRes = mysql_fetch_array(exequery($connection, $checkSetDataSql));

        if ($checkSetDataRes) {
            $allCheckUser = $this->getCheckUser($_SESSION['LOGIN_USER_ID']);
            $allCheckUser = '\'' . implode('\',\'', $allCheckUser) . '\'';

            $query .= "AND `USER_ID` IN (" . SecurityFilter($allCheckUser) . ") ";
            $queryCount .= "AND `USER_ID` IN (" . SecurityFilter($allCheckUser) . ") ";
        }

        $query .="ORDER BY sign_date DESC";

        if ($limitRows !== '' && $limitOffset !== '') {
            $query .=" LIMIT $limitOffset,$limitRows";
        }



        $res = exequery($connection, $query);
        $resultarr = array();
        while ($Row = mysql_fetch_array($res)) {
            $Row['USER_NAME'] = showUserGeneral($Row['USER_ID']);
            $Row['SIGN_IN_TIME'] = date('H:i', $Row['SIGN_IN_TIME']);

            if ($Row['SIGN_OUT_TIME'] == 0) {
                $Row['SIGN_OUT_TIME'] = '';
            } else {
                $Row['SIGN_OUT_TIME'] = date('H:i', $Row['SIGN_OUT_TIME']);
            }
            $Row['dataTypeStr'] = $Row['DATA_TYPE'] == '0' ? $_lang["hr_attend_not_workday"] : $_lang["hr_attend_workday"];
            $Row['dataTypeValue'] = $this->getDataTypeByValue($Row['DUTY_OPTION']);

            $inTimeDiff = round($Row['IN_TIME_DIFF'] / 60, 2);
            $Row['dutyTypeValue'] = $Row['DUTY_TYPE'] == 2 ? $_lang["hr_attend_sign_in_late"] . "(" . abs($inTimeDiff) . $_lang["hr_duty_time_minute"] . ")" : $_lang["hr_attend_sign_in_normal"];

            if (($Row['OUT_TIME_DIFF'] == 0 && $Row['DUTY_OPTION'] != 1) || ($Row['OUT_TIME_DIFF'] == 0 && $Row['DUTY_OPTION'] == 1 && $Row['SIGN_OUT_TIME'] == 0)) {
                $Row['outTypeValue'] = $_lang["hr_attend_leak_sign"];
            } else {
                $outTimeDiff = round($Row['OUT_TIME_DIFF'] / 60, 2);
                $Row['outTypeValue'] = $Row['OUT_TYPE'] == 2 ? $_lang["hr_attend_sign_out_early"] . "(" . abs($outTimeDiff) . $_lang["hr_duty_time_minute"] . ")" : $_lang["hr_attend_sign_out_normal"];
            }
            array_push($resultarr, $Row);
        }

        $resCount = exequery($connection, $queryCount);
        $row = mysql_fetch_array($resCount);
        $totalcnt = $row['CNT'];
        return array(
            'list' => $resultarr,
            'totalCount' => $totalcnt
        );
    }

    /**
     * [getCheckUser 获取有校验权限的用户]
     *
     * @method getCheckUser
     *
     * @param  [string]       $userId [用户ID]
     *
     * @return [array]                [获取结果]
     */
    function getCheckUser($userId) {
        global $connection;
        $checkUserSql = "SELECT * FROM attend_check_manage WHERE `MANAGE_USER` = '" . SecurityFilter($userId) . "'";
        $checkUserRes = mysql_fetch_array(exequery($connection, $checkUserSql));

        $deptUser = array();
        $roleUser = array();
        $checkUser = array();

        if ($checkUserRes['CHECK_DEPT']) {
            $checkDept = trim($checkUserRes['CHECK_DEPT'], ',');
            $deptUserSql = "SELECT USER_ID,USER_NAME FROM USER WHERE `DEPT_ID` IN (" . SecurityFilter($checkDept) . ")";
            $deptUserRes = exequery($connection, $deptUserSql);

            while ($row = mysql_fetch_array($deptUserRes)) {
                $deptUser[] = $row['USER_ID'];
            }
        }

        if ($checkUserRes['CHECK_ROLE']) {
            $checkRole = trim($checkUserRes['CHECK_ROLE'], ',');
            $roleUserSql = "SELECT USER_ID,USER_NAME FROM USER WHERE `USER_PRIV` IN (" . SecurityFilter($checkRole) . ")";
            $roleUserRes = exequery($connection, $roleUserSql);

            while ($row = mysql_fetch_array($roleUserRes)) {
                $roleUser[] = $row['USER_ID'];
            }
        }

        if ($checkUserRes['CHECK_USER']) {
            $checkUser = array_filter(explode(',', $checkUserRes['CHECK_USER']));
        }

        return array_unique(array_merge($deptUser, $roleUser, $checkUser));
    }

    /*     * 获取请假类型
     * $type_id 请假类型ID
     */

    function getTypeName($type_id) {
        global $connection;
        $sql = "SELECT * FROM attend_leavetype WHERE TYPE_ID='" . SecurityFilter($type_id) . "'";
        $res = exequery($connection, $sql);
        if ($row = mysql_fetch_array($res)) {
            $typeName = $row['TYPE_NAME'];
            return $typeName;
        }
    }

    function getLeaveType() {
        global $connection;
        $sql = "SELECT * FROM attend_leavetype";
        $res = exequery($connection, $sql);
        $type = array();
        while ($row = mysql_fetch_array($res)) {
            array_push($type, $row);
        }
        return $type;
    }

    /*     * 删除数据
     * $table  删除的数据库表名称
     * $id     数据库表对应的ID
     */

    function delData($table, $id) {
        global $connection, $_lang;
        switch ($table) {
            case"LEAVE":
                $table_name = "attend_leave";
                $table_id = "LEAVE_ID";
                break;
            case"OUT":
                $table_name = "attend_out";
                $table_id = "OUT_ID";
                break;
            case"EVECTION":
                $table_name = "attend_evection";
                $table_id = "EVECTION_ID";
                break;
            case"OVERTIME":
                $table_name = "attend_overtime";
                $table_id = "OVERTIME_ID";
                break;
        }
        $query = "DELETE FROM " . $table_name . " WHERE " . $table_id . "='" . SecurityFilter($id) . "'";
        exequery($connection, $query);
    }

    /**
     * 签到签退(webservice)
     * param $UserInfo Array
     * $UserInfo["UserId"]：用户ID；
     * $UserInfo["DepyId"]：用户部门ID；
     * $UserInfo["PrivId"]：用户角色ID；
     * $UserInfo["LoginCheck"]：in:签到；out:签退；
     */
    function GetLoginInOut($UserInfo) {
        global $connection;
        $LoginArray = array();
        $dutyId = $this->getUserDutyType($UserInfo["UserId"]);
        $dutyArray = $this->getDutyData($dutyId);
        $signdate = date("Y-m-d"); //签到日期的变量		
        $autoSignIn = $UserInfo["LoginCheck"] == '' ? $dutyArray['DUTY_LOGIN'] : false;
        if ($autoSignIn || $UserInfo["LoginCheck"] != "") {
            $signTimeInBase = $this->isSignIn($dutyArray, $dutyId, $UserInfo["UserId"]);
            if ($autoSignIn || $UserInfo["LoginCheck"] == 'in') {
                if ($signTimeInBase == "") {
                    $dutyMassage = $this->getSignMassage($dutyArray);
                    $dataType = $this->isAttendData($dutyArray);
                    $timeNow = date("Y-m-d H:i:s");
                    $queryData['USER_ID'] = $UserInfo["UserId"];
                    $queryData['SIGN_IN_TIME'] = strtotime($timeNow);
                    $queryData['IP'] = getenv("REMOTE_ADDR");
                    $queryData['DUTY_TYPE'] = $dutyMassage['signType'];
                    $queryData['DATA_TYPE'] = $dataType;
                    $queryData['sign_date'] = $signdate;
                    $queryData['IN_TIME_DIFF'] = $dutyMassage['signDiff'];
                    $queryData['OUT_TIME_DIFF'] = "";
                    $queryData['USER_DEPT'] = $UserInfo["DeptId"];
                    $queryData['USER_PRIV'] = $UserInfo["PrivId"];
                    $queryData['SIGN_IN_NORMAL'] = strtotime($signdate . " " . $dutyArray['DUTY_SIGN_IN']);
                    $queryData['SIGN_OUT_NORMAL'] = strtotime($signdate . " " . $dutyArray['DUTY_SIGN_OUT']);

                    $this->dutySignInDatabase($queryData, "INSERT INTO");
                    $this->dutySignInDatabase($queryData, "INSERT INTO", "attend_duty_out");
                    if ($UserInfo["LoginCheck"]) {
                        $signDiffTime = round($dutyMassage['signDiff'] / 60, 0);
                        $signDate = date('H:i:s', $queryData['SIGN_IN_TIME']);
                        $LoginArray["LoginInTime"] = $signDate;
                        if ($dutyMassage['signType'] == 2 && abs($signDiffTime) > 0) {
                            $LoginArray["LoginInLateTime"] = abs($signDiffTime);
                        } else {
                            $LoginArray["LoginInLateTime"] = "";
                        }
                    }
                }
            } else if ($UserInfo["LoginCheck"] == 'out') {
                $dutySignOutDB = $dutyArray['DUTY_SIGN_OUT'];
                $nowTime = strtotime(date("H:i:s"));
                $signTime = strtotime($dutySignOutDB);
                $diff = $nowTime - $signTime;
                $aqlDate = strtotime(date("Y-m-d H:i:s"));
                $signDate = date("H:i:s");
                $LoginArray["LoginOutTime"] = $signDate;
                $aqlDate = SecurityFilter($aqlDate);
                $diff = SecurityFilter($diff);
                $signTimeInBase = SecurityFilter($signTimeInBase);
                $query = "UPDATE attend_duty SET
						      SIGN_OUT_TIME = $aqlDate,
							  OUT_TIME_DIFF = $diff
							  WHERE  SIGN_IN_TIME = $signTimeInBase							
						 ";
                exequery($connection, $query);
                $query2 = "UPDATE attend_duty_out SET
						      SIGN_OUT_TIME = $aqlDate,
							  OUT_TIME_DIFF = $diff
							  WHERE  SIGN_IN_TIME = $signTimeInBase							
						 ";
                exequery($connection, $query2);
                if ($diff >= 0) {
                    $LoginArray["LoginOutEarlyTime"] = "";
                    $query = "UPDATE attend_duty SET
							    OUT_TYPE=1 
								WHERE SIGN_IN_TIME=$signTimeInBase
							 ";
                    exequery($connection, $query);
                    $query = "UPDATE attend_duty SET
							    OUT_TYPE=1 
								WHERE SIGN_IN_TIME=$signTimeInBase							
						 ";
                    exequery($connection, $query2);
                } else {
                    $signDiffTime = round($diff / 60, 0);
                    $LoginArray["LoginOutEarlyTime"] = abs($signDiffTime);
                }
            }
        }
        return $LoginArray;
    }

    //外勤
    function GetSignOut($UserInfo) { //111
        global $connection;
        $LoginArray = array();
        $dutyId = $this->getUserDutyType($UserInfo["UserId"]);
        $dutyArray = $this->getDutyData($dutyId);
        $signdate = date("Y-m-d"); //签到日期的变量		
        $autoSignIn = $UserInfo["LoginCheck"] == '' ? $dutyArray['DUTY_LOGIN'] : false;
        if ($autoSignIn || $UserInfo["LoginCheck"] != "") {
            $signTimeInBase = $this->isSignIn($dutyArray, $dutyId, $UserInfo["UserId"]);
            if ($autoSignIn || $UserInfo["LoginCheck"] == 'in') {
                if ($signTimeInBase == "") {
                    $dutyMassage = $this->getSignMassage($dutyArray);
                    $dataType = $this->isAttendData($dutyArray);
                    $timeNow = date("Y-m-d H:i:s");
                    $queryData['USER_ID'] = $UserInfo["UserId"];
                    $queryData['SIGN_IN_TIME'] = strtotime($timeNow);
                    $queryData['IP'] = getenv("REMOTE_ADDR");
                    $queryData['DUTY_TYPE'] = $dutyMassage['signType'];
                    $queryData['DATA_TYPE'] = $dataType;
                    $queryData['sign_date'] = $signdate;
                    $queryData['IN_TIME_DIFF'] = $dutyMassage['signDiff'];
                    $queryData['OUT_TIME_DIFF'] = "";
                    $queryData['USER_DEPT'] = $UserInfo["DeptId"];
                    $queryData['USER_PRIV'] = $UserInfo["PrivId"];
                    $queryData['SIGN_IN_NORMAL'] = strtotime($signdate . " " . $dutyArray['DUTY_SIGN_IN']);
                    $queryData['SIGN_OUT_NORMAL'] = strtotime($signdate . " " . $dutyArray['DUTY_SIGN_OUT']);

                    $this->dutySignInDatabase($queryData, "INSERT INTO", "attend_duty_out");
                    if ($UserInfo["LoginCheck"]) {
                        $signDiffTime = round($dutyMassage['signDiff'] / 60, 0);
                        $signDate = date('H:i:s', $queryData['SIGN_IN_TIME']);
                        $LoginArray["LoginInTime"] = $signDate;
                        if ($dutyMassage['signType'] == 2 && abs($signDiffTime) > 0) {
                            $LoginArray["LoginInLateTime"] = abs($signDiffTime);
                        } else {
                            $LoginArray["LoginInLateTime"] = "";
                        }
                    }
                }
            } else if ($UserInfo["LoginCheck"] == 'out') {
                $dutySignOutDB = $dutyArray['DUTY_SIGN_OUT'];
                $nowTime = strtotime(date("H:i:s"));
                $signTime = strtotime($dutySignOutDB);
                $diff = $nowTime - $signTime;
                $aqlDate = strtotime(date("Y-m-d H:i:s"));
                $signDate = date("H:i:s");
                $LoginArray["LoginOutTime"] = $signDate;

                $aqlDate = SecurityFilter($aqlDate);
                $diff = SecurityFilter($diff);
                $signTimeInBase = SecurityFilter($signTimeInBase);

                $query = "UPDATE attend_duty_out SET
						      SIGN_OUT_TIME = $aqlDate,
							  OUT_TIME_DIFF = $diff
							  WHERE  SIGN_IN_TIME = $signTimeInBase							
						 ";
                exequery($connection, $query);
                if ($diff >= 0) {
                    $LoginArray["LoginOutEarlyTime"] = "";
                    $query = "UPDATE attend_duty_out SET
							    OUT_TYPE=1 
								WHERE SIGN_IN_TIME=$signTimeInBase
							 ";
                    exequery($connection, $query);
                } else {
                    $signDiffTime = round($diff / 60, 0);
                    $LoginArray["LoginOutEarlyTime"] = abs($signDiffTime);
                }
            }
        }
        return $LoginArray;
    }

    /**
     * 插入签到签退数据(webservice)
     * param $UserInfo Array  包含用户考勤需要信息的数组
     */
    function InsertAttendance($UserInfo) {
        global $connection;
        $LoginArray = array();
        $userId = $UserInfo["UserId"];
        $dutyId = $this->getUserDutyType($UserInfo["UserId"]);
        $dutyArray = $this->getDutyData($dutyId);
        $dutyArray["SIGN_IN_TIME"] = $UserInfo["AttTime"];
        $signdate = date("Y-m-d", strtotime($dutyArray["SIGN_IN_TIME"]));    //签到日期的变量
        $parDate = strtotime($signdate);

        $parDate = SecurityFilter($parDate);
        $signdate = SecurityFilter($signdate);
        $userId = SecurityFilter($userId);

        $query = "
                 SELECT SIGN_IN_TIME,SIGN_OUT_TIME FROM attend_duty 
                    WHERE SIGN_IN_TIME >= '$parDate'
                    AND sign_date = '$signdate'
                    AND USER_ID = '$userId'";
        $res = exequery($connection, $query);
        $Row = mysql_fetch_array($res);
        $signTimeInBase = $Row['SIGN_IN_TIME'];
        $signTimeOutBase = $Row['SIGN_OUT_TIME'];

        if ($signTimeInBase == "" || $signTimeInBase > strtotime($UserInfo["AttTime"])) {
            $signDiff = strtotime($signdate . ' ' . $dutyArray['DUTY_SIGN_IN']) - strtotime($dutyArray['SIGN_IN_TIME']);
            if ($signDiff > 0) {
                $signType = 1;
            } else {
                $signType = 2;
            }

            $dataType = $this->isAttendData($dutyArray, $signdate);
            $timeNow = $UserInfo["AttTime"];
            $queryData['USER_ID'] = $UserInfo["UserId"];
            $queryData['SIGN_IN_TIME'] = strtotime($timeNow);
            $queryData['IP'] = getenv("REMOTE_ADDR");
            $queryData['DUTY_TYPE'] = $signType;
            $queryData['DATA_TYPE'] = $dataType;
            $queryData['sign_date'] = $signdate;
            $queryData['IN_TIME_DIFF'] = $signDiff;
            $queryData['OUT_TIME_DIFF'] = "";
            $queryData['USER_DEPT'] = $UserInfo["DeptId"];
            $queryData['USER_PRIV'] = $UserInfo["PrivId"];
            $queryData['SIGN_IN_NORMAL'] = strtotime($signdate . " " . $dutyArray["DUTY_SIGN_IN"]);
            $queryData['SIGN_OUT_NORMAL'] = strtotime($signdate . " " . $dutyArray["DUTY_SIGN_OUT"]);

            if ($signTimeInBase == "") {
                $this->dutySignInDatabase($queryData, "INSERT INTO");
            } else if ($signTimeInBase > strtotime($UserInfo["AttTime"])) {
                $sql = "UPDATE attend_duty SET SIGN_IN_TIME='" . SecurityFilter(strtotime($timeNow)) . "',IN_TIME_DIFF='". SecurityFilter($signDiff) ."',DUTY_TYPE='". SecurityFilter($signType) ."',SIGN_IN_NORMAL='" . $queryData['SIGN_IN_NORMAL'] . "' WHERE USER_ID='" . SecurityFilter($UserInfo["UserId"]) . "' AND sign_date='" . SecurityFilter($signdate) . "'";
                exequery($connection, $sql);
            }
            $LoginArray["SIGN_IN_TIME"] = $queryData['SIGN_IN_TIME'];
        } elseif ($signTimeOutBase == 0 || $signTimeOutBase < strtotime($UserInfo["AttTime"])) {
            $signOutTime = strtotime($UserInfo["AttTime"]);
            $signOutNormal = strtotime($signdate . ' ' . $dutyArray['DUTY_SIGN_OUT']);
            $outDiff = $signOutTime - $signOutNormal;
            if ($outDiff > 0) {
                $outType = 1;
            } else {
                $outType = 2;
            }

            $query = "UPDATE attend_duty SET
                          SIGN_OUT_TIME = " . SecurityFilter($signOutTime) . ",
                          OUT_TIME_DIFF = " . SecurityFilter($outDiff) . ",
                          SIGN_OUT_NORMAL = " . SecurityFilter($signOutNormal) . ",
                          OUT_TYPE = " . SecurityFilter($outType) . " 
                          WHERE USER_ID='" . SecurityFilter($UserInfo["UserId"]) . "' AND sign_date='" . SecurityFilter($signdate) . "'";

            exequery($connection, $query);
            $LoginArray["SIGN_OUT_TIME"] = $signOutTime;
        }

        return $LoginArray;
    }

    /**
     * 考勤机系统插入考勤签到/签退的方法(同步考勤机系统的数据到oa的考勤)
     * @param 
     * @param 
     * @return
     */
    function InsertzkAttendance($UserInfo) {
        global $connection;

        $attendTime = $UserInfo["AttTime"];
        $SIGN_DATE = date("Y-m-d", strtotime($attendTime));
        $UserId = $UserInfo["UserId"];

        $dutyId = $this->getUserDutyType($UserId);
        $dutyArray = $this->getDutyData($dutyId);
        $signInTime = $this->isSignIns($dutyArray, $dutyId, $UserId, $SIGN_DATE);
        $signAttInfo = $this->getSignByUserId($UserId, $SIGN_DATE);
        //判断该用户当天没有签到时,此时插入签到
        if ($signInTime == "") {
            $dutyMassage = $this->getSignMassages($dutyArray, $attendTime, $UserId);
            $dataType = $this->isAttendData($dutyArray);
            $signInDiff = strtotime($SIGN_DATE . " " . $dutyArray["DUTY_SIGN_IN"]) - strtotime($attendTime);
            $queryData['USER_ID'] = $UserInfo["UserId"];
            $queryData['SIGN_IN_TIME'] = strtotime($UserInfo["AttTime"]);
            $queryData['IP'] = getenv("REMOTE_ADDR");
            $queryData['DUTY_TYPE'] = $signInDiff >= 0 ? 1 : 2;
            $queryData['DATA_TYPE'] = $dataType;
            $queryData['sign_date'] = $SIGN_DATE;
            $queryData['IN_TIME_DIFF'] = $signInDiff;
            $queryData['OUT_TIME_DIFF'] = "";
            $queryData['USER_DEPT'] = $UserInfo["DeptId"];
            $queryData['USER_PRIV'] = $UserInfo["PrivId"];
            $queryData['SIGN_IN_NORMAL'] = strtotime($SIGN_DATE . " " . $dutyArray["DUTY_SIGN_IN"]);
            $queryData['SIGN_OUT_NORMAL'] = strtotime($SIGN_DATE . " " . $dutyArray["DUTY_SIGN_OUT"]);

            $this->dutySignInDatabase($queryData, "INSERT INTO");
        } else {
            //当有签到了时
            //当只有签到数据,传入数据比签到数据还要早时
            if (strtotime($attendTime) <= $signAttInfo["SIGN_IN_TIME"]) {

                $signInDiff = strtotime($attendTime) - strtotime($SIGN_DATE . " " . $dutyArray['DUTY_SIGN_IN']);
                if ($signInDiff < 0) {
                    $query = ",DUTY_TYPE=1,IN_TIME_DIFF='" . SecurityFilter($signInDiff) . "' ";
                } else {
                    $query = ",DUTY_TYPE=2,IN_TIME_DIFF='" . SecurityFilter($signInDiff) . "'";
                }
                //没有签退时间时
                if ($signAttInfo["SIGN_OUT_TIME"] == "" || $signAttInfo["SIGN_OUT_TIME"] == 0) {
                    $signOutDiff = $signAttInfo["SIGN_IN_TIME"] - strtotime($SIGN_DATE . " " . $dutyArray['DUTY_SIGN_OUT']);

                    if ($signOutDiff > 0) {
                        $query .= ",OUT_TYPE=1,OUT_TIME_DIFF='" . SecurityFilter($signOutDiff) . "' ";
                    } else {
                        $query .= ",OUT_TYPE=2,OUT_TIME_DIFF='" . SecurityFilter($signOutDiff) . "' ";
                    }

                    $sql = "UPDATE attend_duty SET SIGN_IN_TIME='" . strtotime(SecurityFilter($attendTime)) . "',SIGN_OUT_TIME='" . SecurityFilter($signAttInfo["SIGN_IN_TIME"]) . "'" . $query . "	             WHERE USER_ID='" . SecurityFilter($UserId) . "' 
								AND sign_date='" . $SIGN_DATE . "'";
                } else {

                    //有签退时间时,只更新签到数据
                    $sql = "UPDATE attend_duty SET SIGN_IN_TIME='" . strtotime(SecurityFilter($attendTime)) . "'" . $query . "
							    WHERE USER_ID='" . SecurityFilter($UserId) . "'
								AND sign_date='" . SecurityFilter($SIGN_DATE) . "'";
                }

                exequery($connection, $sql);
            } else if (strtotime($attendTime) > $signAttInfo["SIGN_IN_TIME"]) {
                $signOutDiff = strtotime($attendTime) - strtotime($SIGN_DATE . " " . $dutyArray['DUTY_SIGN_OUT']);

                if ($signOutDiff > 0) {
                    $query .= ",OUT_TYPE=1,OUT_TIME_DIFF='" . SecurityFilter($signOutDiff) . "' ";
                } else {
                    $query .= ",OUT_TYPE=2,OUT_TIME_DIFF='" . SecurityFilter($signOutDiff) . "' ";
                }
                //签退时间为空或者传入签退时间大于现在的签退时间
                if ($signAttInfo["SIGN_OUT_TIME"] == "" || strtotime($attendTime) > $signAttInfo["SIGN_OUT_TIME"] || $signAttInfo["SIGN_OUT_TIME"] == 0) {
                    $sql = "UPDATE attend_duty SET SIGN_OUT_TIME='" . strtotime(SecurityFilter($attendTime)) . "'" . $query . "
							    WHERE USER_ID='" . SecurityFilter($UserId) . "'
								AND sign_date='" . SecurityFilter($SIGN_DATE) . "'";
                    exequery($connection, $sql);
                }
            }
        }
    }

    /**
     * 特定考勤日期获取是否有签到
     * @param  $dutyArray
     * @param  $dutyId
     * @param  $userId
     * @param  $signDate
     */
    function isSignIns($dutyArray, $dutyId, $userId, $signDate) {
        global $connection;
        $signInTime = strtotime($dutyArray['DUTY_SIGN_IN']);
        $signOutTime = strtotime($dutyArray['DUTY_SIGN_OUT']);

        $parDate = strtotime($signDate);
        $query = "SELECT SIGN_IN_TIME FROM attend_duty 
					  WHERE SIGN_IN_TIME >= '". SecurityFilter($parDate) ."'
					  AND sign_date = '". SecurityFilter($signDate) ."'
					  AND USER_ID = '". SecurityFilter($userId) ."'";
        $res = exequery($connection, $query);
        $Row = mysql_fetch_array($res);
        $signInTime = $Row['SIGN_IN_TIME'];
        return $signInTime;
    }

    /**
     * 获取用户某一天的考勤信息
     * @param   $userId
     * @param   $signDate
     * @return
     */
    function getSignByUserId($userId, $signDate) {
        global $connection;
        $query = "SELECT * FROM attend_duty WHERE USER_ID='" . SecurityFilter($userId) . "' AND sign_date='" . SecurityFilter($signDate) . "'";
        $res = exequery($connection, $query);
        if ($row = mysql_fetch_array($res)) {
            return $row;
        }
    }

    /**
     * 获取签到状态(是正常签到还是异常签到)
     * @param  $dutyArray 
     * @param  $attendTime
     * @param  $USER_ID
     * @return $returnArray
     */
    function getSignMassages($dutyArray, $attendTime, $USER_ID = '') {
        global $connection, $LOGIN_USER_ID;

        if ($USER_ID == '') {
            $USER_ID = $LOGIN_USER_ID;
        }
        $signDate = date("Y-m-d", strtotime($attendTime));
        $nowTime = $attendTime;
        $signTime = strtotime($signDate . " " . $dutyArray['DUTY_SIGN_IN']);

        //检测是否有请假、外出和出差等数据
        $diff = $signTime - $nowTime;

        $returnArray['signType'] = $diff >= 0 ? '1' : '2';
        $returnArray['signDiff'] = $diff;
        return $returnArray;
    }

    /**
     * 获取同步用户列表
     * @param  $limit 
     * @return $returnArray
     */
    function getUserList($limit) {
        global $connection;
        $sql_select = "SELECT u.USER_ID,u.USER_ACCOUNTS,u.USER_NAME,uc.SYNC_ID FROM user_sync as uc
                         LEFT JOIN user as u ON u.USER_ID=uc.USER_ID
                         LIMIT " . $limit;
        $sql_count = "SELECT COUNT(*) AS CNT FROM user_sync";
        $result = exequery($connection, $sql_select);
        $userList = array();
        while ($row = mysql_fetch_assoc($result)) {
            $userList[] = $row;
        }

        $getCount = exequery($connection, $sql_count);
        if ($row = mysql_fetch_assoc($getCount)) {
            $totalCount = $row['CNT'];
        }
        return array(
            "list" => $userList,
            "totalCount" => $totalCount
        );
    }

    /**
     * 删除同步用户
     * @param  $param 
     * @return 1||0
     */
    function userDel($param) {
        global $connection;
        $sql = "DELETE FROM user_sync WHERE USER_ID='" . SecurityFilter($param['user_id']) . "' AND SYNC_ID='" . SecurityFilter($param['sync_id']) . "'";
        $ok = exequery($connection, $sql);
        return $ok ? 1 : 0;
    }

    /**
     * 更新同步用户
     * @param  $param 
     * @return 1||0
     */
    function userEdit($param) {
        global $connection;
        $has_sync = $this->syncCheck($param);
        if ($has_sync > 0)
            return $has_sync;
        $sql = "UPDATE user_sync SET SYNC_ID='" . SecurityFilter($param['sync_id']) . "' WHERE USER_ID='" . SecurityFilter( $param['user_id']) . "'";
        $ok = exequery($connection, $sql);
        return $ok ? 1 : 0;
    }

    /**
     * 检查同步用户
     * @param  $param 
     * @return 1||0
     */
    function userCheck($param) {
        global $connection;
        $sql = "SELECT count(*) AS num FROM user_sync WHERE USER_ID='" . SecurityFilter($param['user_id'] ) . "'";
        $query = exequery($connection, $sql);
        $num = 0;
        if ($row = mysql_fetch_array($query)) {
            $num = $row['num'];
        }
        if ($num > 0)
            return 2;
        return $this->syncCheck($param);
    }

    /**
     * 检查同步用户
     * @param  $param 
     * @return 1||0
     */
    function syncCheck($param) {
        global $connection;
        $sql = "SELECT count(*) AS num FROM user_sync WHERE SYNC_ID='" . SecurityFilter($param['sync_id']) . "'";
        $query = exequery($connection, $sql);
        $num = 0;
        if ($row = mysql_fetch_array($query)) {
            $num = $row['num'];
        }
        if ($num > 0)
            return 3;
        return 0;
    }

    /**
     * 更新同步用户
     * @param  $param 
     * @return 1||0
     */
    function userAdd($param, $check = 1) {
        global $connection;
        if ($check == 1) {
            return $this->userCheck($param);
        }
        $sql = "INSERT INTO user_sync SET SYNC_ID='" . SecurityFilter($param['sync_id']) . "',USER_ID='" . SecurityFilter($param['user_id']) . "'";
        $ok = exequery($connection, $sql);
        return $ok ? 1 : 0;
    }

    /**
     * 更新同步用户
     * @param  $param 
     * @return 1||0
     */
    function userAddAll($value) {
        global $connection;
        $sql = "INSERT INTO user_sync (USER_ID,SYNC_ID) VALUES ";
        $sql = $sql . $value;
        $ok = exequery($connection, $sql);
        return $ok ? 1 : 0;
    }

    /**
     * 获取同步用户
     * @param  $param 
     * @return 1||0
     */
    function userList($field = '', $join = 0) {
        global $connection;
        $data = array();
        $field = $field ? $field : '*';
        $sql = "SELECT $field FROM user_sync";
        if ($join == 1) {
            $sql .= " AS us LEFT JOIN user as u ON us.USER_ID = u.USER_ID";
        }
        $query = exequery($connection, $sql);
        while ($row = mysql_fetch_array($query)) {
            $data[] = $row;
        }
        return $data;
    }

    /**
     * 获取系统用户
     * @param  $param 
     * @return 1||0
     */
    function sysUserList($field = '') {
        global $connection;
        $data = array();
        $field = $field ? $field : '*';
        $sql = "SELECT $field FROM user WHERE DEPT_ID>0";
        $query = exequery($connection, $sql);
        while ($row = mysql_fetch_array($query)) {
            $data[] = $row;
        }
        return $data;
    }

    /**
     * 获取用户列表
     * @param  $param 
     * @return $returnArray
     */
    function getSysUserList($param) {
        global $connection;
        $limitRows = $param["itemsPerPage"];
        $limitOffset = $param["currentPage"] * $limitRows;
        $limit = $limitOffset . "," . $limitRows;
        $sql = "SELECT u.USER_ID,u.USER_ACCOUNTS,u.USER_NAME,uc.SYNC_ID FROM user as u
                LEFT JOIN user_sync as uc ON u.USER_ID=uc.USER_ID
                WHERE DEPT_ID>0
                ORDER BY uc.SYNC_ID
                LIMIT " . $limit;

        $result = exequery($connection, $sql);
        $userList = array();
        while ($row = mysql_fetch_assoc($result)) {
            $row['status'] = empty($row['SYNC_ID']) ? '0' : 1;
            $userList[] = $row;
        }
        return $userList;
    }

    /**
     * 获取用户列表
     * @param  $param 
     * @return $returnArray
     */
    function getSysUserNum($param) {
        global $connection;
        $sql = "SELECT COUNT(*) AS CNT FROM user WHERE DEPT_ID>0";
        $getCount = exequery($connection, $sql);
        if ($row = mysql_fetch_assoc($getCount)) {
            $totalCount = $row['CNT'];
        }
        return $totalCount;
    }

    /**
     * 获取用户列表
     * @param  $param 
     * @return $returnArray
     */
    function attendCount($where = 1) {
        global $connection;
        $sql = "SELECT count(*) as num FROM attend_duty WHERE " . $where;
        $count = exequery($connection, $sql);
        $num = 0;
        if ($row = mysql_fetch_array($count)) {
            $num = $row['num'];
        }
        return $num;
    }

    /**
     * 获取用户列表
     * @param  $param 
     * @return $returnArray
     */
    function attednDutyAdd($data = array()) {
        global $connection;
        $sql = "INSERT INTO attend_duty (USER_ID,SIGN_IN_TIME,SIGN_IN_NORMAL,SIGN_OUT_TIME,SIGN_OUT_NORMAL,DUTY_TYPE,OUT_TIME_DIFF,sign_date,IN_TIME_DIFF,USER_DEPT,USER_PRIV,DATA_TYPE,DUTY_OPTION,OUT_TYPE) VALUES ('" . SecurityFilter($data['USER_ID']) . "','" . SecurityFilter($data['SIGN_IN_TIME']) . "','" . SecurityFilter($data['SIGN_IN_NORMAL']) . "','" . SecurityFilter($data['SIGN_OUT_TIME']) . "','" . SecurityFilter($data['SIGN_OUT_NORMAL']) . "','" . SecurityFilter($data['DUTY_TYPE']) . "','" . SecurityFilter($data['OUT_TIME_DIFF']) . "','" .
            SecurityFilter($data['sign_date']) . "','" . SecurityFilter($data['IN_TIME_DIFF']) . "','" . SecurityFilter($data['USER_DEPT']) . "','" . SecurityFilter($data['USER_PRIV']) . "','" . SecurityFilter($data['DATA_TYPE']) . "','" . SecurityFilter($data['DUTY_OPTION']) . "','" . SecurityFilter($data['OUT_TYPE']) . "')";
        exequery($connection, $sql);
    }

    /**
     * 获取用户列表
     * @param  $param 
     * @return $returnArray
     */
    function attednDutySave($data = array(), $where) {
        global $connection;
        if (empty($where))
            return '';
        $sql = "UPDATE attend_duty
                SET SIGN_IN_TIME='" .
            SecurityFilter($data['SIGN_IN_TIME']) . "',SIGN_OUT_TIME='" .
            SecurityFilter($data['SIGN_OUT_TIME']) . "',DUTY_TYPE='" .
            SecurityFilter($data['DUTY_TYPE']) . "',OUT_TIME_DIFF='" .
            SecurityFilter($data['OUT_TIME_DIFF']) . "',IN_TIME_DIFF='" .
            SecurityFilter($data['IN_TIME_DIFF']) . "',OUT_TYPE='" .
            SecurityFilter($data['OUT_TYPE']) . "'
                WHERE " . $where;
        exequery($connection, $sql);
    }

    /**
     * 获取用户列表
     * @param  $param 
     * @return $returnArray
     */
    function attednDutyAddSave($data = array()) {
        global $connection;
        $sql = "INSERT INTO attend_duty (USER_ID,SIGN_IN_TIME,SIGN_IN_NORMAL,SIGN_OUT_TIME,SIGN_OUT_NORMAL,DUTY_TYPE,OUT_TIME_DIFF,sign_date,IN_TIME_DIFF,USER_DEPT,USER_PRIV,DATA_TYPE) VALUES ('" .
            SecurityFilter($data['USER_ID']) . "','" .
            SecurityFilter($data['SIGN_IN_TIME']) . "','" .
            SecurityFilter($data['SIGN_IN_NORMAL']) . "','" .
            SecurityFilter($data['SIGN_OUT_TIME']) . "','" .
            SecurityFilter($data['SIGN_OUT_NORMAL']) . "','" .
            SecurityFilter($data['DUTY_TYPE']) . "','" .
            SecurityFilter($data['OUT_TIME_DIFF']) . "','" .
            SecurityFilter($data['sign_date']) . "','" .
            SecurityFilter($data['IN_TIME_DIFF']) . "','" .
            SecurityFilter($data['USER_DEPT']) . "','" .
            SecurityFilter($data['USER_PRIV']) . "','" .
            SecurityFilter($data['DATA_TYPE']) . "')  ON DUPLICATE KEY UPDATE USER_ID='" .
            SecurityFilter($data['USER_ID']) . "' AND sign_date='" .
            SecurityFilter($data['sign_date']) . "'";
        return exequery($connection, $sql);
    }

    /**
     * [getUserId 获取用户ID]
     *
     * @method 朱从玺
     *
     * @param  [type]    $userName [用户名]
     *
     * @return [type]              [description]
     */
    function getUserId($userName) {
        global $connection;

        $query = "SELECT USER_ID FROM `user`  WHERE USER_NAME LIKE '%" . SecurityFilter($userName) . "%' AND DEPT_ID > 0";

        $rc = exequery($connection, $query);

        $userId = array();
        while ($row = mysql_fetch_array($rc)) {
            $userId[] = $row['USER_ID'];
        }

        return $userId;
    }

            

}
