<?php

/**
 * 费用管理
 * 许杨
 * 2014-10-8 v1
 */
include_once 'api/dept.class.php';
include_once 'api/user.class.php';
include_once 'inc/utility_all.php';

class Charge {
    /**
     * 费用类型相关
     */

    /**
     * 获取费用类型列表
     * @param  array  $whereInfor [description]
     * @return [type]             [description]
     */
    function getChargeTypeList($whereInfor = array(), $includeDetail = false) {
        global $connection;

        $query = "SELECT * FROM charge_type 
                  WHERE 1=1 ";
        if ($whereInfor['search']) {
            foreach ($whereInfor['search'] as $key => $value) {
                $query.= " AND " . SecurityFilter($value[0]) . SecurityFilter($value[1]) . "'" . SecurityFilter($value[2]) . "'";
            }
        }

        if ($whereInfor["limit"]) {
            $query.= " LIMIT " . $whereInfor["limit"] . "," . $whereInfor["rows"];
        }

        $query.= " ORDER BY CHARGE_TYPE_ID";

        // echo $query;
        $result = exequery($connection, $query);

        $chargeTypeList = array();
        while ($row = mysql_fetch_assoc($result)) {
            $chargeTypeParent = $row['CHARGE_TYPE_PARENT'];
            $chargeTypeID = $row['CHARGE_TYPE_ID'];

            if ($chargeTypeParent == 0) {
                $chargeTypeList[$chargeTypeID] = $row;
                $chargeTypeList[$chargeTypeID]["lazySubItems"] = array();
            } else {

                if ($includeDetail) {
                    $row["CHARGE_DETAIL"] = $this->getChargeDetail(array(
                        "userID" => $whereInfor["userID"],
                        "deptID" => $whereInfor["deptID"],
                        "year" => $whereInfor["year"],
                        "month" => $whereInfor["month"],
                        "type" => $whereInfor["type"],
                        "chargeDept" => $whereInfor["chargeDept"],
                        "chargeUser" => $whereInfor["chargeUser"],
                        "chargeTypeID" => $chargeTypeID
                    ));
                }

                array_push($chargeTypeList[$chargeTypeParent]["lazySubItems"], $row);
            }
        }


        return $chargeTypeList;
    }

    /**
     * 添加费用类型
     * @param array $chargeTypeInfor [description]
     */
    function addChargeType($chargeTypeInfor = array()) {
        global $connection;

        $query = "INSERT INTO charge_type(CHARGE_TYPE_NAME,CHARGE_TYPE_PARENT) 
                  VALUES ('" . SecurityFilter($chargeTypeInfor['CHARGE_TYPE_NAME']) . "','" . SecurityFilter($chargeTypeInfor['CHARGE_TYPE_PARENT']) . "')";
        if (exequery($connection, $query)) {
            return mysql_insert_id();
        } else {
            return false;
        }
    }

    /**
     * 删除费用类型
     * @param  array  $whereInfor [description]
     * @return [type]             [description]
     */
    function deleteChargeType($whereInfor = array()) {
        global $connection;

        //获取当前ID下面的类别组合
        $types = "(";
        if (isset($whereInfor["deleteSub"]) && $whereInfor["deleteSub"]) {
            $allType = "select*  FROM charge_type 
                  WHERE CHARGE_TYPE_PARENT = '" . SecurityFilter($whereInfor['chargeTypeID']) . "'";
            $rc = exequery($connection, $allType);

            while ($row = mysql_fetch_assoc($rc)) {
                $types.= $row['CHARGE_TYPE_ID'] . ",";
            }
            $types = trim($types, ",");
        } else {
            $types.= $whereInfor['chargeTypeID'];
        }

        $types.= ")";

        $checkSql = "select count(*) as count from charge_list where CHARGE_TYPE_ID in $types";
        $rcount = exequery($connection, $checkSql);
        $row = @mysql_fetch_assoc($rcount);
        if (isset($row["count"]) && $row["count"]) {
            return false;
        }
        $deleteQuery = "DELETE FROM charge_type 
                  WHERE CHARGE_TYPE_ID = '" . SecurityFilter($whereInfor['chargeTypeID']) . "'";

        if ($whereInfor["deleteSub"]) {
            $deleteSubquery = "DELETE FROM charge_type 
                  WHERE CHARGE_TYPE_PARENT = '" . SecurityFilter($whereInfor['chargeTypeID']) . "'";
        }

        return exequery($connection, $deleteQuery) && ($whereInfor["deleteSub"] ? exequery($connection, $deleteSubquery) : true);
    }

    /**
     * 更新费用类型
     * @param  array  $chargeTypeInfor [description]
     * @return [type]                  [description]
     */
    function updateChargeType($chargeTypeInfor = array()) {
        global $connection;

        $query = "UPDATE charge_type 
                    SET CHARGE_TYPE_NAME = '" . SecurityFilter($chargeTypeInfor['CHARGE_TYPE_NAME']) . "' 
                    WHERE CHARGE_TYPE_ID = '" . SecurityFilter($chargeTypeInfor['CHARGE_TYPE_ID']) . "'";

        return exequery($connection, $query);
    }

    /**
     * 添加费用设置
     */
    function addChargeSetting($chargeSettingInfor) {
        global $connection;

        $query = 'INSERT INTO charge_setting(USER_ID,ALERT_METHOD,ALERT_VALUE,SUBJECT_CHECK,ALERT_DATE_START,ALERT_DATE_END) 
                        VALUES("' . SecurityFilter($chargeSettingInfor['USER_ID']) . '",
                            "' . SecurityFilter($chargeSettingInfor['ALERT_METHOD']) . '",
                            "' . SecurityFilter($chargeSettingInfor['ALERT_VALUE']). '",
                                 "' . SecurityFilter($chargeSettingInfor['SUBJECT_CHECK']) . '",
                            "' . SecurityFilter($chargeSettingInfor['ALERT_DATE_START']) . '",
                            "' . SecurityFilter($chargeSettingInfor['ALERT_DATE_END']) . '")';

        return exequery($connection, $query);
    }

    /**
     * 添加费用设置（部门）
     */
    function addChargeSettingDept($chargeSettingInfor) {
        global $connection;

        $query = 'INSERT INTO charge_setting(DEPT_ID,ALERT_METHOD,ALERT_VALUE,SUBJECT_CHECK,ALERT_DATE_START,ALERT_DATE_END) 
                        VALUES("' . SecurityFilter($chargeSettingInfor['DEPT_ID']) . '",
                            "' . SecurityFilter($chargeSettingInfor['ALERT_METHOD']) . '",
                            "' . SecurityFilter($chargeSettingInfor['ALERT_VALUE']) . '",
                                 "' . SecurityFilter($chargeSettingInfor['SUBJECT_CHECK']) . '",
                            "' . SecurityFilter($chargeSettingInfor['ALERT_DATE_START']) . '",
                            "' . SecurityFilter($chargeSettingInfor['ALERT_DATE_END']) . '")';

        return exequery($connection, $query);
    }

    /**
     * 更新费用设置
     * @param  [type] $chargeSettingInfor [description]
     * @return [type]                     [description]
     */
    function updateChargeSetting($chargeSettingInfor) {
        global $connection;

        $query = "UPDATE charge_setting 
                    SET ALERT_METHOD = '" . SecurityFilter($chargeSettingInfor['ALERT_METHOD']) . "',
                    ALERT_VALUE = '" . SecurityFilter($chargeSettingInfor['ALERT_VALUE']) . "',
                    ALERT_DATE_START =  '" . SecurityFilter($chargeSettingInfor['ALERT_DATE_START']) . "',
                    ALERT_DATE_END = '" . SecurityFilter($chargeSettingInfor['ALERT_DATE_END']) . "' ,
                        SUBJECT_CHECK = '" . SecurityFilter($chargeSettingInfor['SUBJECT_CHECK']) . "' 
                    WHERE USER_ID = '" . SecurityFilter($chargeSettingInfor['USER_ID']) . "'";

        return exequery($connection, $query);
    }

    /*
     * 
     * 更新费用设置（部门）
     */

    function updateChargeSettingDept($chargeSettingInfor) {
        global $connection;

        $query = "UPDATE charge_setting 
                    SET ALERT_METHOD = '" . SecurityFilter($chargeSettingInfor['ALERT_METHOD']) . "',
                    ALERT_VALUE = '" . SecurityFilter($chargeSettingInfor['ALERT_VALUE']) . "',
                    ALERT_DATE_START =  '" . SecurityFilter($chargeSettingInfor['ALERT_DATE_START']) . "',
                    ALERT_DATE_END = '" . SecurityFilter($chargeSettingInfor['ALERT_DATE_END']) . "' ,
                    SUBJECT_CHECK = '" . SecurityFilter($chargeSettingInfor['SUBJECT_CHECK']) . "' 
                    WHERE DEPT_ID = '" . SecurityFilter($chargeSettingInfor['DEPT_ID']) . "'";

        return exequery($connection, $query);
    }

    //部门科目设置
    function chargerSubjectSetting($whereValue, $chargeValue, $type, $subjectCheck) {
        //验证是否已经设置过
        global $connection;

        if (!$whereValue) {
            return false;
        }

        if ($type == "dept") {
            $whereKey = "dept_id";
        } else if ($type == "user") {
            $whereKey = "user_id";
        }



        $query1 = "delete from charge_subjects_setting where $whereKey = '$whereValue' ";
        exequery($connection, $query1);
        if ($subjectCheck == 0) {
            return true;
        }
        //增加
        foreach ($chargeValue as $charges) {
            foreach ($charges as $k => $v) {
                $query = 'INSERT INTO charge_subjects_setting(' . $whereKey . ',type_id,type_value) 
                                VALUES("' . SecurityFilter($whereValue) . '",
                                    "' . SecurityFilter($k) . '",
                                    "' . SecurityFilter(intval($v, 10)) . '")';
                exequery($connection, $query);
            }
        }

        return true;
    }

    //用户设置
    function userSubjectSetting() {
        
    }

    /**
     * 检查某用户是否已设置
     * @param  [type] $userID [description]
     * @return [type]         [description]
     */
    function checkIsSetting($userID) {
        global $connection;
        $query = 'SELECT COUNT(*) AS CNT 
                    FROM charge_setting 
                    WHERE USER_ID = "' . SecurityFilter($userID) . '"';
        $result = exequery($connection, $query);
        if ($row = mysql_fetch_assoc($result)) {
            $count = $row['CNT'];
        }
        return $count > 0;
    }

    /*
     * 检查某部门是否已设置
     * 
     */

    function checkDeptSetting($deptID) {
        global $connection;
        $query = 'SELECT COUNT(*) AS CNT 
                    FROM charge_setting 
                    WHERE DEPT_ID = "' . SecurityFilter($deptID) . '"';
        $result = exequery($connection, $query);
        if ($row = mysql_fetch_assoc($result)) {
            $count = $row['CNT'];
        }
        return $count > 0;
    }

    /**
     * 添加费用信息
     * @param array $chargeInfor [description]
     */
    function addCharge($chargeInfor = array()) {
        global $connection;

        $query = 'INSERT INTO charge_list (' . SecurityFilter(implode(',', array_keys($chargeInfor))) . ')
                                VALUES("' . SecurityFilter(implode('","', array_values($chargeInfor))) . '")';
        if (exequery($connection, $query)) {
            return mysql_insert_id();
        } else {
            return false;
        }
    }

    /**
     * 删除费用
     * @param  [type] $chargeListID [费用ID]
     * @return [type]               [description]
     */
    function deleteCharge($chargeListID) {
        global $connection;

        $query = 'DELETE FROM charge_list 
                    WHERE CHARGE_LIST_ID = "' . SecurityFilter($chargeListID) . '"';
        return exequery($connection, $query);
    }

    /**
     * [getChargeDetail description]
     * @param  [type] $searchInfor [description]
     * 时间
     * @return [type]              [description]
     */
    function getChargeDetail($searchInfor) {
        //1121
        global $connection;

        $userID = $searchInfor["userID"];
        $deptID = $searchInfor["deptID"];
        $year = $searchInfor["year"];
        $month = $searchInfor["month"];
        $type = $searchInfor["type"];
        $chargeTypeID = $searchInfor["chargeTypeID"];
        $chargeDept = $searchInfor["chargeDept"] == 'true' ? true : false;
        $chargeUser = $searchInfor["chargeUser"] == 'true' ? true : false;

        switch ($type) {
            case 'year':
                for ($i = 1; $i <= 12; $i++) {
                    $chargeDetailArr[$i] = 0;
                }
                break;
            case 'quarter':
                for ($i = 1; $i <= 4; $i++) {
                    $chargeDetailArr[$i] = 0;
                }
                break;
            case 'month':
                for ($i = 1; $i <= 31; $i++) {
                    $chargeDetailArr[$i] = 0;
                }
                break;
        }

        $query = "SELECT cl.CHARGE_TYPE_ID,cl.PAYMENT_DATE,cl.CHARGE_COST,ct.CHARGE_TYPE_PARENT 
                    FROM charge_list AS cl 
                    LEFT JOIN charge_type AS ct ON cl.CHARGE_TYPE_ID = ct.CHARGE_TYPE_ID
                    WHERE ct.CHARGE_TYPE_ID = '" . SecurityFilter($chargeTypeID) . "'";

        if ($userID) {
            $query.= " AND cl.USER_ID = '" . SecurityFilter($userID) . "'";

            if ($chargeUser && $chargeDept) {
                
            } else if ($chargeUser && !$chargeDept) {
                $query.= "  AND CHARGE_UNDERTAKER ='个人' ";
            } else if ($chargeDept && !$chargeUser) {
                $query.= " AND  CHARGE_UNDERTAKER ='部门' ";
            } else {
                $query.= " AND cl.USER_ID = ''"; //强制设置为0  
            }
        } else if ($deptID > 0) {

            $deptStr = "SELECT * FROM  `department` where SORT_LEVEL_ID like '%|" . SecurityFilter($deptID) . "|%'";
            $deptRes = exequery($connection, $deptStr);
            $deptIds = "";
            while ($row = mysql_fetch_assoc($deptRes)) {
                $deptIds .= $row["DEPT_ID"] . ",";
            }

            $deptIds = $deptIds . $deptID;

            $user = new user;
            $userIDList = $user->getDeptUser($deptID);

            if (count($userIDList) > 0) {
                $userIDStr = "'" . implode("','", array_keys($userIDList)) . "'";
            } else {
                $userIDStr = "''";
            }




            if ($chargeUser && $chargeDept) {
                $query.= " AND ( (cl.USER_ID in ( $userIDStr ) AND CHARGE_UNDERTAKER ='个人') or (cl.USER_DEPT_ID in ( $deptIds ) AND CHARGE_UNDERTAKER ='部门')	)";
            } else if ($chargeUser && !$chargeDept) {
                $query.= " AND  cl.USER_ID in ( $userIDStr ) AND CHARGE_UNDERTAKER ='个人' ";
            } else if ($chargeDept && !$chargeUser) {
                $query.= " AND  cl.USER_DEPT_ID in ( $deptIds ) AND CHARGE_UNDERTAKER ='部门' ";
            } else {
                $query.= " AND cl.USER_ID = ''"; //强制设置为0
            }

            //获取此部门下的所有用户
            //  $query.= " AND cl.USER_ID IN (" . $userIDStr . ")";
        } else {
            if ($chargeUser && $chargeDept) {
                
            } else if ($chargeUser && !$chargeDept) {
                $query.= " AND   CHARGE_UNDERTAKER ='个人' ";
            } else if ($chargeDept && !$chargeUser) {
                $query.= " AND   CHARGE_UNDERTAKER ='部门' ";
            } else {
                $query.= " AND cl.USER_ID = ''"; //强制设置为0
            }
        }


        switch ($type) {
            case 'year':
            case 'quarter':
                $query.= " AND DATE_FORMAT(cl.PAYMENT_DATE, '%Y') = '" . SecurityFilter($year) . "'";
                break;
            case 'month':
                $query.= " AND DATE_FORMAT(cl.PAYMENT_DATE, '%Y-%c') = '" . SecurityFilter($year) . "-" . SecurityFilter($month) . "'";
                break;
        }




        $result = exequery($connection, $query);

        while ($row = mysql_fetch_assoc($result)) {
            switch ($type) {
                case 'year':
                    $index = date('n', strtotime($row["PAYMENT_DATE"]));
                    break;
                case 'quarter':
                    $index = ceil(date('n', strtotime($row["PAYMENT_DATE"])) / 3);
                    break;
                case 'month':
                    $index = date('j', strtotime($row["PAYMENT_DATE"]));
                    break;
            }

            $chargeDetailArr[$index]+= $row["CHARGE_COST"];
        }
        return $chargeDetailArr;
    }

    function getUserChargeList($deptID) {
        global $connection;

        $dataInfor = array();
        if ($deptID == "") {
            $query = "SELECT DEPT_ID,DEPT_NAME FROM department 
                        WHERE DEPT_PARENT = 0 
                        ORDER BY DEPT_NO";
        } else {
            $query = "SELECT DEPT_ID,DEPT_NAME 
                        FROM department 
                        WHERE DEPT_PARENT = '" . SecurityFilter($deptID) . "' 
                        ORDER BY DEPT_NO";
        }
        $result = exequery($connection, $query);
        while ($row = mysql_fetch_array($result)) {

            $myDeptID = $row['DEPT_ID'];
            $myDeptName = $row['DEPT_NAME'];

            //下级部门数量
            $getSubDeptCountQuery = "SELECT COUNT(*) AS CNT 
                                    FROM department 
                                    WHERE DEPT_PARENT='" . SecurityFilter($myDeptID) . "'";
            $getSubDeptCountResult = exequery($connection, $getSubDeptCountQuery);
            if ($getSubDeptCountRow = mysql_fetch_assoc($getSubDeptCountResult)) {
                $subDeptCount = $getSubDeptCountRow['CNT'];
            }

            //部门人员数量
            $getSubUserCountQuery = "SELECT COUNT(*) AS CNT 
                                    FROM user 
                                    WHERE DEPT_ID = '" . SecurityFilter($myDeptID) . "'";
            $getSubUserCountResult = exequery($connection, $getSubUserCountQuery);
            if ($getSubUserCountRow = mysql_fetch_assoc($getSubUserCountResult)) {
                $subUserCount = $getSubUserCountRow['CNT'];
            }

            if ($subDeptCount > 0 || $subUserCount > 0) {
                $isParent = true;
            } else {
                $isParent = false;
            }

            $userList[] = array(
                "id" => $myDeptID,
                "isDept" => true,
                "name" => $myDeptName,
                "isParent" => $isParent,
                "chargeCost" => $this->getDeptCharge($myDeptID)
            );
        }
        if ($deptID) {
            $getDeptUserListQuery = "SELECT USER_ID,USER_NAME 
                                        FROM user 
                                        WHERE DEPT_ID >= 0 
                                        AND DEPT_ID = '" . SecurityFilter($deptID) . "'";
            $getDeptUserListResult = exequery($connection, $getDeptUserListQuery);
            while ($getDeptUserListRow = mysql_fetch_assoc($getDeptUserListResult)) {
                $userList[] = array(
                    "id" => $getDeptUserListRow['USER_ID'],
                    "name" => $getDeptUserListRow['USER_NAME'],
                    "isParent" => false,
                    "chargeCost" => $this->getUserCharge($getDeptUserListRow['USER_ID']),
                    "chargeSetting" => $this->getUserSetting($getDeptUserListRow['USER_ID'])
                );
            }
        }
        return $userList;
    }

    /**
     * 获取某用户的费用
     * @param  [type] $userID [description]
     * @return [type]         [description]
     */
    function getUserCharge($userID = "") {
        global $connection;

        $query = "SELECT SUM(CHARGE_COST) AS CHARGE_COST 
                        FROM charge_list as c
                        INNER JOIN charge_type as ct ON ct.CHARGE_TYPE_ID = c.CHARGE_TYPE_ID ";
        if ($userID) {
            $query.= " WHERE USER_ID = '" . SecurityFilter($userID) . "'";
        }

        $result = exequery($connection, $query);
        if ($row = mysql_fetch_assoc($result)) {
            return $row['CHARGE_COST'];
        }

        return 0;
    }

    /**
     * 获取某部门的费用
     * @param  [type] $userID [description]
     * @return [type]         [description]
     */
    function getDeptCharge($deptID) {
        global $connection;



        //拿到当前的类别
        //获取此部门的所有子部门
        $dept = new department;
        $downDeptStr = $dept->getDownPath($deptID);
        $downDeptStr.= $deptID;

        //获取此部门下的所有用户
        //1121


        $user = new user;
        $userIDList = $user->getDeptUser($deptID);
        if (count($userIDList) > 0) {
            $userIDStr = "'" . implode("','", array_keys($userIDList)) . "'";
        } else {
            $userIDStr = "''";
        }

        $query = "SELECT SUM(CHARGE_COST) AS CHARGE_COST 
                        FROM charge_list AS c 
                        LEFT JOIN USER AS u ON c.USER_ID = u.USER_ID
                        INNER JOIN charge_type as ct ON ct.CHARGE_TYPE_ID = c.CHARGE_TYPE_ID
                        WHERE   ( (c.USER_ID in ( ". SecurityFilter($userIDStr) ." ) AND c.CHARGE_UNDERTAKER ='个人') or 
(c.USER_DEPT_ID in ( ". SecurityFilter($downDeptStr) ." ) AND c.CHARGE_UNDERTAKER ='部门')) ";

        $result = exequery($connection, $query);
        if ($row = mysql_fetch_assoc($result)) {

            //有可能是NULL
            return $row['CHARGE_COST'] ? $row['CHARGE_COST'] : 0;
        }

        return 0;
    }

    function getUserSettingList($deptID) {
        global $connection;

        $dataInfor = array();
        if ($deptID == "") {
            $query = "SELECT DEPT_ID,DEPT_NAME FROM department 
                        WHERE DEPT_PARENT = 0 
                        ORDER BY DEPT_NO";
        } else {
            $query = "SELECT DEPT_ID,DEPT_NAME 
                        FROM department 
                        WHERE DEPT_PARENT = '" . SecurityFilter($deptID) . "' 
                        ORDER BY DEPT_NO";
        }
        $result = exequery($connection, $query);
        while ($row = mysql_fetch_array($result)) {

            $myDeptID = $row['DEPT_ID'];
            $myDeptName = $row['DEPT_NAME'];

            //下级部门数量
            $getSubDeptCountQuery = "SELECT COUNT(*) AS CNT 
                                    FROM department 
                                    WHERE DEPT_PARENT='" . SecurityFilter($myDeptID) . "'";
            $getSubDeptCountResult = exequery($connection, $getSubDeptCountQuery);
            if ($getSubDeptCountRow = mysql_fetch_assoc($getSubDeptCountResult)) {
                $subDeptCount = $getSubDeptCountRow['CNT'];
            }

            //部门人员数量
            $getSubUserCountQuery = "SELECT COUNT(*) AS CNT 
                                    FROM user 
                                    WHERE DEPT_ID = '" . SecurityFilter($myDeptID) . "'";
            $getSubUserCountResult = exequery($connection, $getSubUserCountQuery);
            if ($getSubUserCountRow = mysql_fetch_assoc($getSubUserCountResult)) {
                $subUserCount = $getSubUserCountRow['CNT'];
            }

            if ($subDeptCount > 0 || $subUserCount > 0) {
                $isParent = true;
            } else {
                $isParent = false;
            }

            $userList[] = array(
                "id" => $myDeptID,
                "name" => $myDeptName,
                "isParent" => $isParent,
                "isUser" => false
            );
        }
        if ($deptID) {
            $getDeptUserListQuery = "SELECT USER_ID,USER_NAME 
                                        FROM user 
                                        WHERE DEPT_ID >= 0 
                                        AND DEPT_ID = '" . SecurityFilter($deptID) . "'";
            $getDeptUserListResult = exequery($connection, $getDeptUserListQuery);
            while ($getDeptUserListRow = mysql_fetch_assoc($getDeptUserListResult)) {

                $userList[] = array(
                    "id" => $getDeptUserListRow['USER_ID'],
                    "name" => $getDeptUserListRow['USER_NAME'],
                    "isParent" => false,
                    "isUser" => true
                );
            }
        }
        return $userList;
    }

    /**
     * 获取用户的设置信息
     * @param  [type] $userID [description]
     * @return [type]         [description]
     */
    function getUserSetting($userID) {
        global $connection;

        $query = "SELECT * 
                        FROM charge_setting 
                        WHERE USER_ID = '" . SecurityFilter($userID) . "'";
        $result = exequery($connection, $query);
        if ($row = mysql_fetch_assoc($result)) {
            return $row;
        } else {
            return false;
        }
    }

    function getDeptID($userID) {
        global $connection;
        $query = "SELECT b.ALERT_METHOD as DEPT_ALERT_METHOD,b.ALERT_VALUE as DEPT_ALERT_VALUE,b.ALERT_DATE_START as DEPT_ALERT_DATE_START ,b.ALERT_DATE_END as DEPT_ALERT_DATE_END FROM charge_setting b where b.DEPT_ID in (SELECT a.DEPT_ID FROM user a where a.USER_ID = '" . SecurityFilter($userID) . "') ";

        $result = exequery($connection, $query);
        if ($row = mysql_fetch_assoc($result)) {
            return $row;
        } else {
            return false;
        }
    }

    /**
     * 获取部门的设置信息
     * @param  [type] $userID [description]
     * @return [type]         [description]
     */
    function getDeptetting($deptID) {
        global $connection;

        $query = "SELECT * 
                        FROM charge_setting 
                        WHERE DEPT_ID = '" . SecurityFilter($deptID) . "'";
        $result = exequery($connection, $query);
        if ($row = mysql_fetch_assoc($result)) {
            return $row;
        } else {
            return false;
        }
    }

    /*
     * 移除处理函数
     * 
     * 
     */

    function deleteSubChargeType($ids = "", $pid = "") {
        global $connection;

        if (!$ids || !$pid) {
            return false;
        }

        $query = 'DELETE FROM  charge_type  WHERE CHARGE_TYPE_ID  not in (' . SecurityFilter($ids) . ') and CHARGE_TYPE_PARENT = ' . SecurityFilter($pid);

        return exequery($connection, $query);
    }

    function getUserChargeTable($whereInfor = array()) {
        //1122
        global $connection;

        $deptID = isset($whereInfor["deptID"]) ? $whereInfor["deptID"] : "0";
        $uid = isset($whereInfor["uid"]) ? $whereInfor["uid"] : "";
        $filterType = isset($whereInfor["filter_type"]) ? $whereInfor["filter_type"] : "year";
        $year = isset($whereInfor["yearInfor"]) ? $whereInfor["yearInfor"] : date("Y");
        $month = isset($whereInfor["monthInfor"]) ? $whereInfor["monthInfor"] : "1";
        $chargeType = isset($whereInfor["chargeType"]) ? $whereInfor["chargeType"] : "";
        $chargeMonth = isset($whereInfor["chargeMonth"]) ? $whereInfor["chargeMonth"] : "";
        $chargeUser = isset($whereInfor["chargeUser"]) ? $whereInfor["chargeUser"] : "";
        $chargeDept = isset($whereInfor["chargeDept"]) ? $whereInfor["chargeDept"] : "";
        //再次转换
        $chargeDept = $chargeDept == 'true' ? true : false;
        $chargeUser = $chargeUser == 'true' ? true : false;

        $getListQuery = "SELECT cl.*,ct.CHARGE_TYPE_NAME,ct.CHARGE_TYPE_PARENT";
        $getCountQuery = "SELECT COUNT(*) AS CNT";
        $query = " FROM charge_list AS cl 
                    INNER  JOIN charge_type AS ct ON cl.CHARGE_TYPE_ID = ct.CHARGE_TYPE_ID WHERE 1=1";


        switch ($filterType) {
            case 'year':
            case 'quarter':
                $query.= " AND DATE_FORMAT(cl.PAYMENT_DATE, '%Y') = '" . SecurityFilter($year) . "'";
                break;
            case 'month':
                $query.= " AND DATE_FORMAT(cl.PAYMENT_DATE, '%Y-%c') = '" . SecurityFilter($year) . "-" . SecurityFilter($month) . "'";
                break;
        }




        if ($chargeMonth) {//年-》月份  月份-》天数 季度-》月份
            switch ($filterType) {

                case 'year':
                    $query.= " AND DATE_FORMAT(cl.PAYMENT_DATE, '%Y-%c') = '" . SecurityFilter($year) . "-" . SecurityFilter($chargeMonth) . "' ";
                    break;
                case 'quarter':
                    // 第一季度 1-2-3 二季度 4 5 6 
                    $minM = $chargeMonth * 3 - 2;
                    $maxM = $chargeMonth * 3;
                    $query.= " AND DATE_FORMAT(cl.PAYMENT_DATE, '%Y-%c') >= '" . SecurityFilter($year) . "-" . SecurityFilter($minM) . "'   AND DATE_FORMAT(cl.PAYMENT_DATE, '%Y-%c') <= '" . SecurityFilter($year) . "-" . SecurityFilter($maxM) . "' ";
                    break;
                case 'month':
                    $query.= " AND DATE_FORMAT(cl.PAYMENT_DATE, '%Y-%c-%e') = '" . SecurityFilter($year) . "-" . SecurityFilter($month) . "-" . "".SecurityFilter($chargeMonth)."" . "'";
                    break;
            }
        }


        if ($chargeType) {
            $query.= " AND cl.CHARGE_TYPE_ID = '" . SecurityFilter($chargeType) . "' ";
        }



        $userIds = "";
        if ($uid) {
            //当前某个用户
            $query.= " AND cl.USER_ID = '" . SecurityFilter($uid) . "'";

            if ($chargeUser && $chargeDept) {
                
            } else if ($chargeUser && !$chargeDept) {
                $query.= "  AND CHARGE_UNDERTAKER ='个人' ";
            } else if ($chargeDept && !$chargeUser) {
                $query.= " AND  CHARGE_UNDERTAKER ='部门' ";
            } else {
                $query.= " AND cl.USER_ID = ''"; //强制设置为0  
            }
        } else if ($deptID > 0) {
            $deptStr = "SELECT * FROM  `department` where SORT_LEVEL_ID like '%|" . SecurityFilter($deptID) . "|%'";
            $deptRes = exequery($connection, $deptStr);
            $deptIds = "";
            while ($row = mysql_fetch_assoc($deptRes)) {
                $deptIds .= $row["DEPT_ID"] . ",";
            }

            $deptIds = $deptIds . $deptID;

            $user = new user;
            $userIDList = $user->getDeptUser($deptID);

            if (count($userIDList) > 0) {
                $userIDStr = "'" . implode("','", array_keys($userIDList)) . "'";
            } else {
                $userIDStr = "''";
            }


            if ($chargeUser && $chargeDept) {
                $query.= " AND ( (cl.USER_ID in ( $userIDStr ) AND CHARGE_UNDERTAKER ='个人') or (cl.USER_DEPT_ID in ( ". SecurityFilter($deptIds) ." ) AND CHARGE_UNDERTAKER ='部门')	)";
            } else if ($chargeUser && !$chargeDept) {
                $query.= " AND  cl.USER_ID in ( $userIDStr ) AND CHARGE_UNDERTAKER ='个人' ";
            } else if ($chargeDept && !$chargeUser) {
                $query.= " AND  cl.USER_DEPT_ID in ( $deptIds ) AND CHARGE_UNDERTAKER ='部门' ";
            } else {
                $query.= " AND cl.USER_ID = ''"; //强制设置为0
            }
        } else {
            //所有人

            if ($chargeUser && $chargeDept) {
                
            } else if ($chargeUser && !$chargeDept) {
                $query.= " AND   CHARGE_UNDERTAKER ='个人' ";
            } else if ($chargeDept && !$chargeUser) {
                $query.= " AND   CHARGE_UNDERTAKER ='部门' ";
            } else {
                $query.= " AND cl.USER_ID = ''"; //强制设置为0
            }
        }





        if ($whereInfor['search']) {
            foreach ($whereInfor['search'] as $key => $value) {
                $query.= " AND " . SecurityFilter($value[0]) . " " . SecurityFilter($value[1]) . " " . SecurityFilter($value[2]);
            }
        }

        if ($whereInfor['KEYWORDS']) {
            $query.= " AND  cl.REASON like '%" . SecurityFilter($whereInfor['KEYWORDS']) . "%' ";
        }

        //获取数量

        $getCountResult = exequery($connection, $getCountQuery . $query);
        if ($getCountRow = mysql_fetch_assoc($getCountResult)) {
            $totalCount = $getCountRow["CNT"];
        }

        if ($whereInfor['sortField'] && $whereInfor['sortType']) {
            $query.= " ORDER BY " . SecurityFilter($whereInfor['sortField']) . " " . SecurityFilter($whereInfor['sortType']);
        } else {
            $query.= " ORDER BY PAYMENT_DATE DESC";
        }



        if (isset($whereInfor["offset"])) {
            $query.= " LIMIT " . $whereInfor["offset"] . "," . $whereInfor["rows"];
        }


        $getListResult = exequery($connection, $getListQuery . $query);


        $chargeList = array();

        while ($getListRow = mysql_fetch_assoc($getListResult)) {

            //报销人
            $userName = trim(getUsernameStr($getListRow['USER_ID']), ",");

            //创建人
            $creator = trim(getUsernameStr($getListRow['CREATOR']), ",");

            $getListRow['USER_NAME'] = $userName;
            $getListRow['CREATOR_NAME'] = $creator;

            $underType = $getListRow["CHARGE_UNDERTAKER"];
            if ($underType == "个人") {
                $getListRow['CHARGE_UNDERTAKER_ENTITY'] = "个人：" . $userName;
            } else {

                $sql2 = " SELECT * FROM department WHERE  DEPT_ID=" . SecurityFilter($getListRow["USER_DEPT_ID"]);
                $rs = exequery($connection, $sql2);
                $row = mysql_fetch_array($rs);
                if ($row) {
                    $getListRow['CHARGE_UNDERTAKER_ENTITY'] = "部门：" . $row["DEPT_NAME"];
                } else {
                    $getListRow['CHARGE_UNDERTAKER_ENTITY'] = "部门（已删除）";
                }
            }

            //
            if ($getListRow['CHARGE_FROM'] == 1) {
                $getListRow['DELETED_CHARGE'] = "<a href=\"javascript:void(0)\" class='ignore-link' onclick=\"deletedFromCharge('" . $getListRow['CHARGE_LIST_ID'] . "','" . $getListRow['USER_ID'] . "');return false;\">删除</a>    
                    | <a href=\"javascript:void(0)\" class='ignore-link' onclick=\"editFromCharge('" . $getListRow['CHARGE_LIST_ID'] . "','" . $getListRow['USER_ID'] . "','" . $getListRow['CHARGE_TYPE_PARENT'] . "','" . $getListRow['CHARGE_TYPE_ID'] . "');return false;\">编辑</a> 
              ";
            } else {
                $getListRow['DELETED_CHARGE'] = "数据来自外发流程";
            }

            array_push($chargeList, $getListRow);
        }

        return array(
            "totalCount" => $totalCount,
            "list" => $chargeList
        );
    }

    function deleteFromChargtable($id) {
        global $connection;

        $query = 'DELETE FROM  charge_list  WHERE CHARGE_LIST_ID  = ' . SecurityFilter($id);

        return exequery($connection, $query);
    }

    function getFromChargtable($id) {
        global $connection;

        $query = 'SELECT a.*,b.USER_NAME  FROM  charge_list a inner join USER b on a.USER_ID = b.USER_ID WHERE a.CHARGE_LIST_ID  = ' . SecurityFilter($id);
        $getListResult = exequery($connection, $query);
        $chargeList = array();
        $getListRow = mysql_fetch_assoc($getListResult);

        return $getListRow;
    }

    function getUserPrivStr($userID) {
        global $connection;
        $SQL = "select b.FUNC_ID_STR from user a inner join user_priv b on (a.USER_PRIV = b.USER_PRIV or a.USER_SUB_PRIV = b.USER_PRIV) and a.USER_ID = '" . SecurityFilter($userID) . "'"; //获取当前的菜单权限
        $rc = exequery($connection, $SQL);
        $priv_str = "";
        while ($row = mysql_fetch_assoc($rc)) {
            $priv_str.= $row['FUNC_ID_STR'];
        }
        $arr_func = explode(",", $priv_str);
        if (!in_array('38', $arr_func)) { //不存在清单的用户
            if ($_REQUEST["userID"] != $_SESSION['LOGIN_USER_ID']) { //
                $flage = false;
            } else {
                $flage = true;
            }
        } else {

            $flage = true;
        }

        return $flage;
    }

    function updateFromChargtable($data) {
        global $connection;
        $query = "UPDATE charge_list 
                    SET REASON  = '" . SecurityFilter($data['reason']) . "',
                    PAYMENT_DATE  = '" . SecurityFilter($data['charge_date']) . "',
                    CHARGE_COST  =  '" . SecurityFilter($data['amount']) . "',
                    CHARGE_TYPE_ID  = '" . SecurityFilter($data['sub_type']) . "' 
                    WHERE CHARGE_LIST_ID = '" . SecurityFilter($data['charge_list_id']) . "'";
        return exequery($connection, $query);
    }

    function getSubjectSetting($whereValue, $type) {
        global $connection;

        if (!$whereValue || !$type) {
            return false;
        }

        if ($type == "dept") {
            $whereKey = "dept_id";
        } else {
            $whereKey = "user_id";
        }

        $query = "SELECT * 
                        FROM charge_subjects_setting 
                        WHERE $whereKey = '" . SecurityFilter($whereValue) . "'";
        $result = exequery($connection, $query);
        $data = array();
        while ($row = mysql_fetch_assoc($result)) {
            $data[$row["type_id"]] = $row["type_value"];
        }

        return $data;
    }

    function removeSetting($whereValue, $type) {
        global $connection;

        if (!$whereValue || !$type) {
            return false;
        }

        if ($type == "dept") {
            $whereKey = "DEPT_ID";
        } else {
            $whereKey = "USER_ID";
        }

        $query = "DELETE 
                        FROM charge_setting 
                        WHERE $whereKey = '" . SecurityFilter($whereValue) . "'";
        return exequery($connection, $query);
    }

}
