<?
/**
 * Systemname:       E-Office
 * Filename:
 * Function:
 * Encoding:         utf8
 * Author:           www.weaver.com.cn
 * Date:
 * File Version:     1.0
 * Eoffice Version:  7.0
*/
class database{
	public $connection;
	public $affectedRows;
	public $lastInsID;
    protected $comparison = array('eq'=>'=','neq'=>'<>','gt'=>'>','egt'=>'>=','lt'=>'<','elt'=>'<=','notlike'=>'NOT LIKE','like'=>'LIKE','in'=>'IN','notin'=>'NOT IN');

	public function __construct(){
		global $connection;
		$this->connection = $connection;
	}

 	/**
     * 添加数据
     * @access public
     * @param $table 表名,array $data 添加数据
     * @return int 添加主键id
     */
	public function add($table,$data){
		foreach($data as $k=>$v){
            $v = SecurityFilter($v);
			$fields[] = $this->parseKey($k);
			$values[] = $this->parseValue($v);
		}
		$sql = 'INSERT INTO '.$table.' ('.implode(',', $fields).') VALUES ('.implode(',', $values).')';
        $result = $this->query($sql);
		if(false === $result){
			return 0;
		}else{
            $this->lastInsID = mysql_insert_id();
            return $this->lastInsID;
        }
	}

    /**
     * 批量插入数据
     * @access public
     * @param  array $data;
     * @return int
     */
    public function addAll($table,$datas) {
        if(!is_array($datas[0])) return false;
        $fields = array_keys($datas[0]);
        array_walk($fields, array($this, 'parseKey'));
        $values  =  array();
        foreach ($datas as $data){
            $value   =  array();
            foreach ($data as $key=>$val){
                $val = SecurityFilter($val);
                $val   =  $this->parseValue($val);
                if(is_scalar($val)) { // 过滤非标量数据
                    $value[]   =  $val;
                }
            }
            $values[]    = '('.implode(',', $value).')';
        }
        $sql   =  'INSERT INTO '.$table.' ('.implode(',', $fields).') VALUES '.implode(',',$values);
        $result = $this->query($sql);
		if(false === $result){
			return 0;
		}else{
            $this->affectedRows = mysql_affected_rows();
            return $this->affectedRows;
        }
    }

    /**
     * 更新记录
     * @access public
     * @param mixed $where,array $data 数据
     * @param array $options 表达式
     * @return false | integer
     */
    public function update($table,$data,$where) {
        $sql = 'UPDATE '.$table
            .$this->parseSet($data)
            .$this->parseWhere($where);
        return $this->query($sql);
    }

    /**
     * 删除记录
     * @access public
     * @param mixed $where
     * @return bool
     */
    public function delete($table,$where) {
		$sql = "DELETE FROM $table".$this->parseWhere($where);
		return $this->query($sql);
    }

 	/**
     * query执行sql
     * @access protected
     * @param array $data
     * @return string
     */
	protected function query($sql){
		return exequery($this->connection,$sql);
	}

    /**
     * 返回最后插入的ID
     * @access public
     * @return int
     */
    public function getLastInsID() {
        return $this->lastInsID;
    }

    /**
     * 影响记录数
     * @access public
     * @return string
     */
    public function affectedRows() {
        return $this->affectedRows;
    }

	/**
     * where分析
     * @access protected
     * @param mixed $where
     * @return string
     */
    protected function parseWhere($where) {
        $whereStr = '';
        if(is_string($where)) {
            // 直接使用字符串条件
            $whereStr = $where;
        }else{ // 使用数组表达式
            $operate  = isset($where['_relation'])?strtoupper($where['_relation']):'';
            if(in_array($operate,array('AND','OR','XOR'))){
                $operate    =   ' '.$operate.' '; // 定义逻辑运算规则 例如 OR XOR AND NOT
                unset($where['_relation']);
            }else{
                $operate    =   ' AND '; // 默认进行 AND 运算
            }
            foreach ($where as $key=>$val){
                $whereStr .= '( ';
                $whereStr .= $this->parseWhereItem($this->parseKey($key),$val);
                $whereStr .= ' )'.$operate;
            }
            $whereStr = substr($whereStr,0,-strlen($operate));
        }
        return empty($whereStr)?'':' WHERE '.$whereStr;
    }

    // where子单元分析
    protected function parseWhereItem($key,$val) {
        $whereStr = '';
        if(is_array($val)) {
            if(preg_match('/^(EQ|NEQ|GT|EGT|LT|ELT)$/i',$val[0])) { // 比较运算
                $whereStr .= $key.' '.$this->comparison[strtolower($val[0])].' '.$this->parseValue($val[1]);
            }elseif(preg_match('/^(NOTLIKE|LIKE)$/i',$val[0])){// 模糊查找
                $whereStr .= $key.' '.$this->comparison[strtolower($val[0])].' '.$this->parseValue($val[1]);
            }elseif('exp'==strtolower($val[0])){ // 使用表达式
                $whereStr .= ' ('.$key.' '.$val[1].') ';
            }elseif(preg_match('/IN/i',$val[0])){ // IN 运算
                if(is_string($val[1])) {
                     $val[1] =  explode(',',$val[1]);
                }
                $zone      =   implode(',',$this->parseValue($val[1]));
                $whereStr .= $key.' '.strtoupper($val[0]).' ('.$zone.')';
            }elseif(preg_match('/BETWEEN/i',$val[0])){ // BETWEEN运算
                $data = is_string($val[1])? explode(',',$val[1]):$val[1];
                $whereStr .=  ' ('.$key.' '.strtoupper($val[0]).' '.$this->parseValue($data[0]).' AND '.$this->parseValue($data[1]).' )';
            }else{
                $whereStr .= '';
            }
        }else {
            $whereStr .= $key.' = '.$this->parseValue($val);
        }
        return $whereStr;
    }

 	/**
     * set分析
     * @access protected
     * @param array $data
     * @return string
     */
    protected function parseSet($data) {
        foreach ($data as $key=>$val){
            $set[]  =   $this->parseKey($key).'='.$this->parseValue($val);
        }
        if(count($set)>1){
            return ' SET '.implode(',',$set);
        }else{
            return ' SET '.$set[0];
        }
    }

    /**
     * 字段和表名处理添加
     * @access protected
     * @param string $key
     * @return string
     */
    private function parseKey(&$key) {
        $key   =  trim($key);
        if(!preg_match('/[,\'\"\*\(\)`.\s]/',$key)) {
           $key = '`'.$key.'`';
        }
        return $key;
    }

    /**
     * value分析
     * @access protected
     * @param mixed $value
     * @return string
     */
    private function parseValue($value) {
        if(is_string($value)) {
            $value =  '\''.$this->escapeString($value).'\'';
        }elseif(is_bool($value)){
            $value =  $value ? '1' : '0';
        }elseif(empty($value)){
            $value =  '\'\'';
        }
        return $value;
    }

    /**
     * SQL指令安全过滤
     * @access public
     * @param string $str  SQL字符串
     * @return string
     */
    private function escapeString($str) {
    	global $connection;
    	return $str;
        if($connection) {
            return mysql_real_escape_string($str,$connection);
        }else{
            return mysql_escape_string($str);
        }
    }

	function getDatabaseSize(){
		global $connection;
		$cacount = $_SESSION["SESSION_LOGIN_CACCOUNT"];

		$sql = "SHOW TABLE STATUS FROM eoffice_".SecurityFilter($cacount);
		$rs  = exequery($connection,$sql);
		while($row = mysql_fetch_array($rs)){
			$dbsize += $row['Data_length'];
		}
		return $dbsize;
	}
}