<?php
/**
* @copyright (C) 2010 - 2011 Weaver Co.Ltd
* @package       eoffice8.0
* @function      文件类
* @encoding      $_lang['encoding']
* @name          api/folder.class.php
* @version       1
* @author        sun|www.weaver.com.cn
* @date          2013-05-09
*/

class document
{
	private static $CONTENT_ID      = "";    //文档id
	private static $CONTENT_TYPE    = "";    //文档类别:word,excel,html
	private static $SORT_ID         = "";    //所属文件夹id
	private static $FROM_ID         = "";    //来源对应id，如流程的run_id
	private static $FROM_SEQ        = "";    //来源标题，如流水号
	private static $SUBJECT         = "";    //文档标题
	private static $CONTENT         = "";    //文档内容
	private static $REPORT_TYPE     = "";    //报表类型
	private static $SEND_TIME       = "";    //创建时间
	private static $USER_ID         = "";    //创建人id
	private static $ATTACHMENT_ID   = "";    //所有附件id字符串
	private static $ATTACHMENT_NAME = "";    //所有附件名称字符串
	private static $ATTACHMENT_DESC = "";    //附件备注说明字符串
	private static $FILE_TYPE       = "";    //文档类型:个人,公共
	private static $SHARE_USER      = "";    //共享用户
	private static $SHARE_PRIV      = "";    //共享角色
	private static $SHARE_DEPT      = "";    //共享部门
	private static $SHARE_TIME      = "";    //共享的时间
	private static $LINK_DOC        = "";    //流程管理文档的文档id字符串

	private static $CURRENT_USER_ID = "";    //当前用户id
	private static $CURRENT_DEPT_ID = "";    //当前用户部门id
	private static $CURRENT_PRIV_ID = "";    //当前用户角色id

	/**
	*构造函数
	*@access public
	*/
	function __construct($userId,$doc_id = ""){
		global $connection;
		$sql = "SELECT USER_PRIV ,DEPT_ID  FROM user WHERE USER_ID ='".SecurityFilter($userId)."'";
		$rs  = exequery($connection,$sql);
		if($row = mysql_fetch_array($rs))
		{
			$this->CURRENT_USER_ID = $userId;
			$this->CURRENT_DEPT_ID = $row["DEPT_ID"];
			$this->CURRENT_PRIV_ID = $row["USER_PRIV"];
		}
		if($doc_id)
		{
			$docInfo = $this->getDocInfo($doc_id);
			if($docInfo)
			{
				$this->CONTENT_ID      = $docInfo["CONTENT_ID"];
				$this->CONTENT_TYPE    = $docInfo["CONTENT_TYPE"];
				$this->SORT_ID         = $docInfo["SORT_ID"];
				$this->FROM_ID         = $docInfo["FROM_ID"];
				$this->FROM_SEQ        = $docInfo["FROM_SEQ"];
				$this->SUBJECT         = $docInfo["SUBJECT"];
				$this->CONTENT         = $docInfo["CONTENT"];
				$this->REPORT_TYPE     = $docInfo["REPORT_TYPE"];
				$this->SEND_TIME       = $docInfo["SEND_TIME"];
				$this->USER_ID         = $docInfo["USER_ID"];
				$this->ATTACHMENT_ID   = $docInfo["ATTACHMENT_ID"];
				$this->ATTACHMENT_NAME = $docInfo["ATTACHMENT_NAME"];
				$this->ATTACHMENT_DESC = $docInfo["ATTACHMENT_DESC"];
				$this->FILE_TYPE       = $docInfo["FILE_TYPE"];
				$this->SHARE_USER      = $docInfo["SHARE_USER"];
				$this->SHARE_PRIV      = $docInfo["SHARE_PRIV"];
				$this->SHARE_DEPT      = $docInfo["SHARE_DEPT"];
				$this->SHARE_TIME      = $docInfo["SHARE_TIME"];
				$this->LINK_DOC        = $docInfo["LINK_DOC"];
			}
		}
	}
	/**
	 * 检查文档权限
	 * @param  array $docInfo 文档信息数组
	 * @return bool  false_没有权限 true_有权限
	 */
	function getReadPurview($docInfo)
	{
		global $connection;
		$sortId     = $docInfo ['SORT_ID'];
		$contentId  = $docInfo ['CONTENT_ID'];
		$userId     = $docInfo ['USER_ID'];
		$querySort = "
					SELECT COUNT(*) as CNT1 FROM file_purview
					WHERE SORT_ID = '".SecurityFilter($sortId)."'
					AND (
							(INStr(DEPT_VIEW,',".$this->CURRENT_DEPT_ID.",')>0 or INStr(DEPT_VIEW,'".$this->CURRENT_DEPT_ID.",')=1)
							or
							(INStr(PRIV_VIEW,',".$this->CURRENT_PRIV_ID.",')>0 or INStr(PRIV_VIEW,'".$this->CURRENT_PRIV_ID.",')=1)
							or
							(INStr(USER_VIEW,',".$this->CURRENT_USER_ID.",')>0 or INStr(USER_VIEW,'".$this->CURRENT_USER_ID.",')=1)
							or
							(INStr(DEPT_MANAGE,',".$this->CURRENT_DEPT_ID.",')>0 or INStr(DEPT_MANAGE,'".$this->CURRENT_DEPT_ID.",')=1)
							or
							(INStr(PRIV_MANAGE,',".$this->CURRENT_PRIV_ID.",')>0 or INStr(PRIV_MANAGE,'".$this->CURRENT_PRIV_ID.",')=1)
							or
							(INStr(USER_MANAGE,',".$this->CURRENT_USER_ID.",')>0 or INStr(USER_MANAGE,'".$this->CURRENT_USER_ID.",')=1)
						)
					";
		$rsSort = exequery ( $connection, $querySort );
		$rowSort = mysql_fetch_array ( $rsSort );
		$CNT1 = $rowSort ["CNT1"];
		if($CNT1)
			return true;
		$queryDoc = "
			SELECT COUNT(*) AS CNT2 FROM file_content
				WHERE CONTENT_ID = '".SecurityFilter($contentId)."'
					AND (SHARE_DEPT = 'dept_all'
							OR(
								(INStr(SHARE_DEPT,',".$this->CURRENT_DEPT_ID.",')>0 OR INStr(SHARE_DEPT,'".$this->CURRENT_DEPT_ID.",')=1)
								 OR
								(INStr(SHARE_PRIV,',".$this->CURRENT_PRIV_ID.",')>0 OR INStr(SHARE_PRIV,'".$this->CURRENT_PRIV_ID.",')=1)
								 OR
								 (INStr(SHARE_USER,',".$this->CURRENT_USER_ID.",')>0 OR INStr(SHARE_USER,'".$this->CURRENT_USER_ID.",')=1)
							) OR USER_ID = '".$this->CURRENT_USER_ID."'
						)

				";
		$cursorDoc = exequery($connection,$queryDoc);
		$row_d     = mysql_fetch_array ($cursorDoc);
		$CNT2 = $row_d["CNT2"];
		if ($CNT2)
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	/**
	*获取某篇文档属性
	*@param  int $doc_id 文档id
	*@return $row
	*/
	function getDocInfo($doc_id){
		global $connection,$_lang;
		$sql = "SELECT * FROM file_content WHERE CONTENT_ID = '".SecurityFilter($doc_id)."' ";
		$rs  = exequery($connection,$sql);
		$row = mysql_fetch_array($rs,MYSQL_ASSOC);
		if($row)
		{
			if($row["USER_ID"])
			{
				$row["USER_NAME"] = getUserNameNew($row["USER_ID"]);
			}
			else
			{
				$row["USER_NAME"] = $_lang["file_from_get_to_id"];
			}
		}
		//暂时这样用，稍后修改
		if ($row["ATTACHMENT_ID"] != "")
		{
			$row["ATTACHMENT_VALUE"] = getAttachment($row["ATTACHMENT_ID"],$row["ATTACHMENT_NAME"], $doc_id, $row["SORT_ID"],$row["USER_ID"]);
		}
		return $row;
	}

	/**
	 * 获取模版内容
	 * @param string $ModeId 模版ID
	 * @param string 模版内容 false_获取失败
	*/
	function getModeContentById($ModeId)
	{
		global $connection;
		$sql = "SELECT MODE_CONTENT FROM show_mode WHERE MODE_ID = '".SecurityFilter($ModeId)."' ";
		$rs  = exequery ($connection,$sql);
		if ($row = mysql_fetch_array ($rs))
		{
			$modeContent = $row['MODE_CONTENT'];
			return $modeContent;
		}
		else
		{
			$folder   = new folder($this->SORT_ID);
			$sortType = $folder->SORT_TYPE;
			if($sortType == 1)
			{
				$sql = "SELECT MODE_CONTENT FROM show_mode WHERE MODE_ID = '1' ";
				$rs  = exequery ($connection,$sql);
				if ($row = mysql_fetch_array ($rs))
				{
					$modeContent = $row['MODE_CONTENT'];
					return $modeContent;
				}
				else
				{
					return false;
				}
			}
			else
			{
				$sql = "SELECT MODE_CONTENT FROM show_mode WHERE MODE_ID = '2' ";
				$rs  = exequery ($connection,$sql);
				if ($row = mysql_fetch_array ($rs))
				{
					$modeContent = $row['MODE_CONTENT'];
					return $modeContent;
				}
				else
				{
					return false;
				}
			}
		}
	}
	/**
	 * 文档模板替换
	 * @param array  $docInfo     文档内容数组
	 * @param string $tempContent 要替换的内容
	 * @param string $tempContent 替换后的内容
	*/
	function templateReplace($docInfo, $tempContent)
	{
		$tempContent = str_replace("[***内容***]", "{$docInfo['CONTENT']}", $tempContent );
		$tempContent = str_replace("[***标题***]", "{$docInfo['SUBJECT']}", $tempContent );
		$tempContent = str_replace("[***附件***]", "{$docInfo['ATTACHMENT_VALUE']}", $tempContent );
		$tempContent = str_replace("[***附件说明***]","{$docInfo['ATTACHMENT_DESC']}", $tempContent );
		$tempContent = str_replace("[***创建人***]", "{$docInfo['USER_NAME']}", $tempContent );
		$tempContent = str_replace("[***创建时间***]", "{$docInfo['SEND_TIME']}", $tempContent );
		return $tempContent;
	}
	/**
	 * 获取文档回复信息
	 * @param  string $docId  文档ID
	 * @return array  $row
	*/
	function getReplyByDocId($docId)
	{
		global $connection;
		$replySql = "SELECT * FROM file_revert
						WHERE CONTENT_ID = '".SecurityFilter($docId)."'
						ORDER BY RE_TIME DESC ";
		$replyRs  = exequery ( $connection, $replySql );
		while ($row = mysql_fetch_array ($replyRs))
		{
			$replyInfo[] = $row;
		}
		return $replyInfo;
	}
	/**
	 * 获取文档查看日志信息
	 * @param  string $docId  文档ID
	 * @return array  $logInfo
	*/
	function getLogsById($docId, $TableName)
	{
		global $connection;
		//浏览量包含自己的阅读
		$readSql = "SELECT * FROM sys_op_log
						WHERE SEQ_ID   = '" . SecurityFilter($docId). "'
						AND TABLE_NAME = '" . SecurityFilter($TableName) . "'
						AND OPERATION_TYPE <> 4 ";
		$readRs  = exequery ( $connection, $readSql );
		while($readRow = mysql_fetch_array ( $readRs ))
		{
			$logInfo[] = $readRow;
		}
		return $logInfo;
	}
	/**
	 * 新建文档
	 * @param  string $docInfo  文档相关信息
	 * @return array  $logInfo
	*/
	function newDoc($docInfo,$other)
	{
		global $connection,$_lang;
		$SMS_CONTENT = $_lang ["file_report_sms_doc_new"] . "：" . $SUBJECT;
		$query = "INSERT INTO  file_content (CONTENT_ID) VALUES ('')";
		exequery($connection,$query);
		$docId = mysql_insert_id ();
		if(!$this->CONTENT_ID)
			$this->CONTENT_ID = $docId;
		$this->editDoc($docInfo,$other);
		//添加播报日志
		AddBroacastLog($other["USER_ID"],"file_content","CONTENT_ID",$this->CONTENT_ID,"SUBJECT","new");
		if ($docInfo["FILE_TYPE"] == 1) {
			//1，新建事件日志
			saveSysOpLog ($this->CONTENT_ID, '1', 'file_content', '' );
		}
	}
	/**
	 * 编辑文档
	 * @param  string $docInfo  文档相关信息
	 * @return array  $logInfo
	*/
	function editDoc($docInfo,$other)
	{
		global $connection,$_lang;
		$SMS_CONTENT    = $_lang ["file_report_sms_doc_new"] . "：" . $SUBJECT;
		$updateFieldStr = $this->prop_serial($docInfo);
		$conditions     = "CONTENT_ID = '".$this->CONTENT_ID."'";
		$this->update("file_content",$updateFieldStr,$conditions);
		if($other["op"] == "edit"&&$docInfo["FILE_TYPE"] == 1)
			//4 表示保存事件日志
			saveSysOpLog ( $this->CONTENT_ID, '4', 'file_content', '' );
	}
	/**
	 * 文档是否锁定和锁定信息
	 * @return array  $row
	*/
	function lockInfo($limitInfo='')
	{
		global $connection,$_lang;
		if($limitInfo) {
			$limitFirst = $limitInfo[0];
			$limitSecond = $limitInfo[1];
		} else {
			$limitFirst = "0";
			$limitSecond = "1";
		}
		$sql = "SELECT * FROM sys_op_log WHERE SEQ_ID = '".$this->CONTENT_ID."' AND TABLE_NAME ='file_content' ORDER BY OPERATION_DATE DESC LIMIT ".SecurityFilter($limitFirst).",".SecurityFilter($limitSecond)."";
		$rs  = exequery($connection,$sql);
		$row = mysql_fetch_array($rs);
		if(!$row)
			$row = array();
		return $row;
	}
	/**
	*给某个属性赋值
	*@access public
	*/
	function __set($property,$value){
		$this->$property = $value;
	}
	/**
	*获取某属性的值
	*@access public
	*@return int $this->property
	*/
	function __get($property){
		return $this->$property;
	}
	/**
	*搜索文件夹
	*@access public
	*@para   array $conditions
	*@return array $rs
	*/
	function seach($conditions)
	{

	}
	/**
	*遍历文件夹
	*@access public
	*@para   array $conditions
	*@return array $rs
	*/
	function traversal($conditions)
	{

	}
	/**
	*将要数据库字段名和值数组转换成字符串
	*@access public
	*@para   array $properties
	*@return str   $str
	*/
	function prop_serial($properties)
	{
		while(list($key,$val) = each($properties)){
			if($key != 'WHERE'){
				$str .= ",".$key."='".$val."'";
			}
		}
		if($str)
			$str = ltrim($str,",");
		return $str;
	}
	/**
	*封装执行sql语句
	*@access public
	*@para   str  $tables     要更新的表名
	*@para   str  $properties 要更新的字段和值
	*@para   str  $conditions 更新语句的条件
	*@para   str  $others     其他sql语句信息字符串
	*@return bool $rs
	*/
	function update($tables,$properties,$conditions,$others='')
	{
		global $connection;
		$sql = "UPDATE ".SecurityFilter($tables)." SET ".$properties. " WHERE ".$conditions;
		if($others)
			$sql .= " ".$others;
		$rs  = exequery($connection,$sql);
		return $rs;
	}
}
?>