<?php

/**
 * Systemname:       E-Office
 * Filename:
 * Function:
 * Encoding:         utf8
 * Author:           www.weaver.com.cn
 * Date:
 * File Version:     1.0
 * Eoffice Version:  6.0
 */
include_once("inc/function_usergeneral.php");

//include_once("general/email/email_function.php");
class Email {

    var $default_limit = 20;
    var $default_start = 0;
    private $deptid;
    private $uesrpriv;
    private $userid;
    private $curdate;

    /**
     * 初始化userid
     */
    function __construct($userinfo = array()) {
        global $connection;
        if ($userinfo["user_id"] == "") {
            $this->userid = $_SESSION["LOGIN_USER_ID"];
        } else {
            $this->userid = $userinfo["user_id"];
        }
        if ($this->userid) {
            $sql = "SELECT DEPT_ID,USER_PRIV FROM user WHERE USER_ID='" . SecurityFilter($this->userid) . "'";
            $rs = exequery($connection, $sql);
            $row = mysql_fetch_array($rs);
            $this->deptid = $row["DEPT_ID"];
            $this->uesrpriv = $row["USER_PRIV"];
        }
        $this->curdate = date("Y-m-d", time());
    }

    /**
     * 获取邮件列表
     * @param string $boxtype 邮箱文件夹类型
     * @param array $search 没用到
     * @param array $others 搜索关键字等限制
     * @return array 邮件列表内容数组
     */
    public function getEmails($boxtype = -1, $search = array(), $others = array()) {
        global $connection;
        $sql = array();
//		$sql[] = "SELECT * FROM email WHERE from_id = '$user_id'";
        $words = $others['words'] ? $others['words'] : null;
        if ($boxtype == "") {
            $searchtype = -1;
        } else {
            $searchtype = $boxtype;
        }
        $sql[] = $this->getQueryForEmail($searchtype, $words);
        $orderby = $others['orderby'] ? $others['orderby'] : 'DESC';
        $page = $others['page'] ? $others['page'] : 1;
        $limit = $others['limit'] ? $others['limit'] : 10;
        $start = ($page - 1) * $limit;
        $sql[] = "ORDER BY email_id ".SecurityFilter($orderby);
        $sql[] = "limit ".SecurityFilter($start).",".SecurityFilter($limit);
        $query = implode(' ', $sql);
        $result = exequery($connection, $query);
        $emails = array();
        while ($row = mysql_fetch_assoc($result)) {
            $emails[] = $row;
        }
        $emails = $this->replaceUserStr('FROM_ID', 'FROM_NAME', $emails);
        return $emails;
    }

    /**
     * replace user_id or user_account with user_name _by danal
     * @param string $key_in key to compare
     * @param strin $key_out key to be appended
     * @param array $inArray array(0=>array($row),1=>...)
     */
    public function replaceUserStr($key_in, $key_out, $inArray) {
        global $connection;
        $users = array();
        $sql = "SELECT USER_ID,USER_ACCOUNTS,USER_NAME FROM user";
        $rs = exequery($connection, $sql);
        while ($row = mysql_fetch_assoc($rs)) {
            $users[] = $row;
        }
        $inSize = count($inArray);
        $uSize = count($users);
        for ($i = 0; $i != $inSize; $i++) {
            $newkey = array();
            $in_i = $inArray[$i];
            $field = $in_i[$key_in];
            $field_pieces = explode(',', $field);
            for ($j = 0; $j != count($field_pieces); $j++) {
                $field_piece = $field_pieces[$j];
                for ($k = 0; $k != $uSize; $k++) {
                    if ($users[$k]['USER_ID'] == $field_piece) {
                        $newkey[] = $users[$k]['USER_NAME'];
                    }
                }
            }
            $inArray[$i][$key_out] = implode(',', $newkey);
        }
        return $inArray;
    }

    /**
     * 获取邮件。返回一个结果集

     * @param string $type
     * @param string $words
     *
     * @return array $result
     */
    public function getQueryForEmail($type, $words) {
        switch ($type) {
//			case "all":
//				$query = " SELECT e.*, u.USER_NAME FROM email e LEFT JOIN user u ON e.FROM_ID = u.USER_ID ";
//				break;
            case -1:
                $query = " SELECT e.* FROM email e WHERE e.TO_ID = '" . SecurityFilter($this->userid) . "' AND SEND_FLAG='1' AND DELETE_FLAG!='1'";
                break;
            case -2:
                $query = " SELECT e.* FROM email e WHERE e.FROM_ID = '" . SecurityFilter($this->userid) . "' AND e.SEND_FLAG = 1 AND DELETE_BY_SENT!='1' ";
                break;
            case -3:
                $query = " SELECT e.* FROM email e WHERE e.FROM_ID = '" . SecurityFilter($this->userid) . "' AND e.SEND_FLAG = 0 ";
                break;
            default:
                return $this->getQueryForEmail(-1, null);
        }
        if (isset($words))
            $query.=" AND e.SUBJECT LIKE '%" . SecurityFilter($words) . "%'";
        return $query;
    }

    /**
     * get email by email id
     *
     * @param int $id email id
     * @return array email info array
     */
    function getEmailById($id, $box = "") {

        global $connection;

        $sql = " select * from email where email_id = '".SecurityFilter($id)."' ";

        $cursor = exequery($connection, $sql);

        $row = mysql_fetch_array($cursor, MYSQL_ASSOC);
        $inArray = array($row);
        $inArray = $this->replaceUserStr('TO_ID', 'TO_NAME', $inArray);
        $inArray = $this->replaceUserStr('TO_ID2', 'TO_NAME2', $inArray);
        $inArray = $this->replaceUserStr('FROM_ID', 'FROM_NAME', $inArray);
        if ($box == "") {
            //被读过与否
            $this->updateReadflag($id);
        }
        return $inArray[0];
    }

    /**
     * update read_flag
     * @param int $email_id
     */
    public function updateReadflag($email_id) {
        global $connection;
        $q = "UPDATE email SET READ_FLAG = '1' WHERE EMAIL_ID = ".SecurityFilter($email_id);
        $rs = exequery($connection, $q);
        return $rs;
    }

    /**
     * get Unread Mail Count
     * @param int $userid user id
     * @return mail count
     */
    public function getUnreadMailCount($userid) {
        global $connection;
        $query = "SELECT COUNT(EMAIL_ID) AS count FROM email WHERE BOX_ID=0 and TO_ID='" . SecurityFilter($userid) . "' AND SEND_FLAG='1' AND READ_FLAG='0' AND DELETE_FLAG!='1' ";
        $rs = exequery($connection, $query);
        if ($rows = mysql_fetch_array($rs)) {
            $unreadmailcount = $rows["count"];
        }
        return $unreadmailcount;
    }

    /**
     * 取得收件箱邮件数量
     * @param int $userid 用户ID
     * @return 邮件数量
     */
    public function getInboxMailCount($userid) {
        global $connection;
        $query = "SELECT COUNT(EMAIL_ID) AS count FROM email WHERE BOX_ID=0 AND TO_ID='" . SecurityFilter($userid) . "' AND SEND_FLAG='1' AND DELETE_FLAG !='1' ";
        $rs = exequery($connection, $query);
        if ($rows = mysql_fetch_array($rs)) {
            $inboxmailcount = $rows["count"];
        }
        return $inboxmailcount;
    }

    /**
     * get the amount of different emailbox
     * @param int $boxtype
     * @return int $num_total
     */
    public function getEmailAmount($type = -1, $words = null) {
        global $connection;
        //$sql = $this->getQueryForEmail($type,$words);
        switch ($type) {
            case "":
                $sql = " SELECT e.* FROM email e WHERE e.TO_ID = '" . SecurityFilter($this->userid) . "' AND SEND_FLAG='1' AND DELETE_FLAG!='1'";
            case -1:
                $sql = " SELECT e.* FROM email e WHERE e.TO_ID = '" . SecurityFilter($this->userid) . "' AND SEND_FLAG='1' AND DELETE_FLAG!='1'";
                break;
            case -2:
                $sql = " SELECT e.* FROM email e WHERE e.FROM_ID = '" . SecurityFilter($this->userid) . "' AND e.SEND_FLAG = 1 AND DELETE_BY_SENT!='1' ";
                break;
            case -3:
                $sql = " SELECT e.* FROM email e WHERE e.FROM_ID = '" . SecurityFilter($this->userid) . "' AND e.SEND_FLAG = 0 ";
                break;
        }
        if (isset($words)) {
            $sql.=" AND e.SUBJECT LIKE '%" . SecurityFilter($words) . "%'";
        }
        $result = exequery($connection, $sql);
        if (!$result) {
            return 0;
        }
        $num_total = mysql_numrows($result);
        return $num_total;
    }

    /**
     * 根据id删除一条邮件
     *
     * @param int $id 邮件id
     * @return true
     */
    public function delEmailById($id) {

        global $connection;

        $sql = " DELETE FROM email WHERE email_id = '".SecurityFilter($id)."' ";

        $cursor = exequery($connection, $sql);

        return true;
    }

    //撤销全部需要 拿到同一邮件的收件用户
    public function getIdenticalEmail($SEND_TIME,$FROM_ID){


         global $connection;
          $checkSql = "select * from email where SEND_TIME ='" . SecurityFilter($SEND_TIME) . "' and FROM_ID = '" . SecurityFilter($FROM_ID) . "'";
            $cursor = exequery($connection, $checkSql);
            $tempTOIDs = array();
            while ($rows = mysql_fetch_assoc($cursor)) {
                $tempTOIDs[]= $rows["TO_ID2"];
            }

           return $tempTOIDs;

    }

    /**
     * 根据id串删除多条邮件
     * @param mixed $ids id字符串或者id数组
     * @return bool
     */
    public function delEmailByIds($ids) {

        global $connection;

        if (is_array($ids)) {

            foreach ($ids as $id) {
                $id_str .= "'" . SecurityFilter($id) . "',";
            }

            $id_str = substr($id_str, 0, -1);
        }

        $sql = " DELETE FROM email WHERE email_id IN($id_str) ";

        exequery($connection, $sql);
        return true;
    }

    /**
     * 增加保存邮件(webservice)
     * @param array $data
     * @return string 新增邮件的ID串
     */
    public function addEmail($data) {

        global $connection;
        $time = date("Y-m-d H:i:s", time());
//		$receiver_id = substr( $data['receiver_id'], 0, -1 );
//		$receiver_id = $data['receiver_id'];
//		$receiver_id_arr = explode( ',' , $receiver_id );
//		if(!array_key_exists("CopyToId",$data))
//		{
//			$data["CopyToId"] = "";
//		}

        if ((int) $data['send_flag'] == 1) {
            $TO_ID_STR = $data['receiver_id'] . $data['CopyToId'];
            $TOK = strtok($TO_ID_STR, ",");
            while ($TOK != "") {
                $sql = "INSERT INTO email (
							FROM_ID,
							TO_ID,
							TO_ID2,
							COPY_TO_ID,
							SUBJECT,
							CONTENT,
							SEND_TIME,
							ATTACHMENT_ID,
							ATTACHMENT_NAME,
							READ_FLAG,
							SEND_FLAG,
							DELETE_FLAG,
							BOX_ID,
							DELETE_BY_SENT
						)
						VALUES(
							'" . SecurityFilter($this->userid) . "',
							'" . SecurityFilter($TOK) . "',
							'" . SecurityFilter($data['receiver_id']) . "',
							'" . SecurityFilter($data['CopyToId']) . "',
							'" . SecurityFilter($data['subject']) . "',
							'" . SecurityFilter($data['content']) . "',
							'" . SecurityFilter($time) . " ',
							'" . SecurityFilter($data['attachment_id']) . "',
							'" . SecurityFilter($data['attachment_name']) . "',
							'0',
							'1',
							'0',
							'0',
							'0'
						)";
                exequery($connection, $sql);
                $insertIds .= mysql_insert_id() . ",";
                $TOK = strtok(",");
            }
        } else {

            $sql = "INSERT INTO email (
						FROM_ID,
						TO_ID,
						TO_ID2,
						COPY_TO_ID,
						SUBJECT,
						CONTENT,
						SEND_TIME,
						ATTACHMENT_ID,
						ATTACHMENT_NAME,
						READ_FLAG,
						SEND_FLAG,
						DELETE_FLAG,
						BOX_ID,
						DELETE_BY_SENT
					)
					VALUES(
						  '" . SecurityFilter($this->userid) . "',
							'" . SecurityFilter($data['receiver_id']) . "',
							'" . SecurityFilter($data['receiver_id']) . "',
							'" . SecurityFilter($data['CopyToId']) . "',
							'" . SecurityFilter($data['subject']) . "',
							'" . SecurityFilter($data['content']) . "',
							'" . SecurityFilter($time) . " ',
							'" . SecurityFilter($data['attachment_id']) . "',
							'" . SecurityFilter($data['attachment_name']) . "',
							'0',
							'0',
							'0',
							'0',
							'0'
					)";

            exequery($connection, $sql);
            $insertIds .= mysql_insert_id() . ",";
        }

        return $insertIds;
    }

    /**
     * 获取邮件附件名
     *
     * @param file $file 文件名
     * @return array  文件信息
     */
    public function getAttachment($file) {

        for ($i = 0; $i <= (count($file['tmp_name']) * 2); $i++) {
            if (!empty($file['tmp_name'][$i])) {
                $attachment = $file['tmp_name'][$i];
                $attachment_name_once = $file['name'][$i];

                $attachment_id_noce = upload($attachment, $attachment_name_once); //upload方法,inc/upload.php中加载execute_upload.php
                //附件名和ID
                //$attachment_name = $attachment_name_once.'*'.$attachment_name;
                //$attachment_id   = $attachment_id_noce.','.$attachment_id;
                $attachment_name .= $attachment_name_once . '*';
                $attachment_id .= $attachment_id_noce . ',';
            }
        }

        $attachment_arr['name'] = $attachment_name;
        $attachment_arr['id'] = $attachment_id;

        return $attachment_arr;
    }

    /**
     * 更新邮件为已读状态
     * @param int $emailid 邮件ID
     */
    function updateEmailStatus($emailid) {
        global $connection;
        $sql = "UPDATE email SET READ_FLAG='1' WHERE EMAIL_ID=" . SecurityFilter($emailid);
        exequery($connection, $sql);
    }

    /* function getEmailAmount($keyword=""){
      global $connection;
      $sql = "
      SELECT COUNT(EMAIL_ID) AS CNT FROM email WHERE 1
      AND TO_ID='".$this->userid."'
      AND SEND_FLAG='1'
      AND DELETE_FLAG!='1'
      "
      ;
      if($keyword){
      $sql .= getSqlKeyword($keyword,"SUBJECT");
      }
      $rs	 = exequery($connection,$sql);
      $row   = mysql_fetch_array($rs);
      $amount = $row["CNT"];

      return $amount;
      } */

    /**
     * 获取新邮件的数量
     * @param string $keyword 搜索关键字
     * @return 邮件数量
     */
    function getNewEmailAmount($keyword = "") {
        global $connection;
        $sql = "
				SELECT COUNT(EMAIL_ID) AS CNT FROM email WHERE 1
				AND TO_ID='" . SecurityFilter($this->userid) . "'
				AND SEND_FLAG='1'
				AND DELETE_FLAG!='1'
				AND READ_FLAG !='1'
				"
        ;
        if ($keyword) {
            $sql .= getSqlKeyword($keyword, "SUBJECT");
        }
        $rs = exequery($connection, $sql);
        $row = mysql_fetch_array($rs);
        $amount = $row["CNT"];

        return $amount;
    }

    /**
     * 获取邮件内容信息，如果指定了emailid，则只获取该邮件内容
     * @param int $limit 每页限制
     * @param int $start 开始ID
     * @param int $emailid 邮件ID
     * @param string $keyword 搜索关键字
     * @return array 邮件信息
     */
    function getEmailInfo($limit = 0, $start = 0, $emailid = "", $keyword = "") {
        global $connection;
        $limit = $limit > 0 ? $limit : $this->default_limit;
        $start = $start > 0 ? $start : $this->default_start;

        $sql = "
				SELECT * FROM email WHERE 1
				AND TO_ID='" . SecurityFilter($this->userid) . "'
				AND SEND_FLAG='1'
				AND DELETE_FLAG!='1'
				"
        ;
        if ($emailid != "") {
            $sql .= " AND EMAIL_ID=" . $emailid . " ";
        }
        if ($keyword) {
            $sql .= getSqlKeyword($keyword, "SUBJECT");
        }
        $sql .= " ORDER BY EMAIL_ID DESC LIMIT " . SecurityFilter($start) . "," . SecurityFilter($limit) . "";
        $rs = exequery($connection, $sql);
        $i = $start;
        while ($row = mysql_fetch_array($rs)) {
            $emailData[$i]['EMAIL_ID'] = $row['EMAIL_ID'];
            $emailData[$i]['FROM_ID'] = $row['FROM_ID'];
            $emailData[$i]['TO_ID'] = $row['TO_ID'];
            $emailData[$i]['SUBJECT'] = $row['SUBJECT'];
            $emailData[$i]['CONTENT'] = $row['CONTENT'];
            $emailData[$i]['SEND_TIME'] = $row['SEND_TIME'];
            $emailData[$i]['ATTACHMENT_ID'] = $row['ATTACHMENT_ID'];
            $emailData[$i]['ATTACHMENT_NAME'] = $row['ATTACHMENT_NAME'];
            $emailData[$i]['READ_FLAG'] = $row['READ_FLAG'];

            $i++;
        }

        return $emailData;
    }

    /**
     * 取得上/下一封邮件
     * @param int $emailid 邮件id
     * @param string $flag 上(pre)/下(next)标志
     * @return array 邮件内容
     */
    function getPreNextEmail($emailid, $flag = "next") {
        global $connection;
        if ($emailid) {
            $sql = "
				SELECT * FROM email WHERE 1
				AND TO_ID='" . SecurityFilter($this->userid) . "'
				AND SEND_FLAG='1'
				AND DELETE_FLAG!='1'
								"
            ;
            switch ($flag) {
                case "":
                    $sql .= " AND EMAIL_ID>'" . SecurityFilter($emailid) . "' ORDER BY EMAIL_ID ASC LIMIT 0,1";
                    break;
                case "next":
                    $sql .= " AND EMAIL_ID>'" . SecurityFilter($emailid) . "' ORDER BY EMAIL_ID ASC LIMIT 0,1";
                    break;
                case "pre":
                    $sql .= " AND EMAIL_ID<'" . SecurityFilter($emailid) . "' ORDER BY EMAIL_ID DESC LIMIT 0,1";
                    break;
            }
            $rs = exequery($connection, $sql);
            $row = mysql_fetch_array($rs);
            $reemailid = $row["EMAIL_ID"];
            $resubject = $row["SUBJECT"];
        }
        $emailData["emailid"] = $reemailid;
        $emailData["subject"] = $resubject;
        return $emailData;
    }

    /*
      function sendEmail($data){
      global $connection;
      $sql = "INSERT INTO  email(FROM_ID,TO_ID,TO_ID2,COPY_TO_ID,SUBJECT,CONTENT,SEND_TIME,ATTACHMENT_ID,ATTACHMENT_NAME,READ_FLAG,SEND_FLAG,DELETE_FLAG) VALUES ('".$data["fromid"]."','".$data["toid"]."','','','".$data["subject"]."','".$data["content"]."','".$data["sendtime"]."','".$data["attachid"]."','".$data["attachname"]."','0','1','0')";

      exequery($connection,$sql);
      } */

    /**
     * 邮件发送
     * @param string $fromid 发件人ID
     * @param string $toid 收件人ID
     * @param string $toid2 收件人ID串
     * @param string $subject 主题
     * @param string $content 内容
     * @param string $sendtime 发送时间
     * @param string $attachid 附件ID，以逗号隔开
     * @param string $attachname 附件名，以逗号隔开
     */
    function sendEmail($fromid, $toid, $toid2, $subject, $content, $sendtime, $attachid, $attachname) {
        global $connection;
        $sql = "INSERT INTO  email(FROM_ID,TO_ID,TO_ID2,SUBJECT,CONTENT,SEND_TIME,ATTACHMENT_ID,ATTACHMENT_NAME,READ_FLAG,SEND_FLAG,DELETE_FLAG) VALUES ('".SecurityFilter($fromid)."','".SecurityFilter($toid)."','".SecurityFilter($toid2)."','" . SecurityFilter($subject) . "','" . SecurityFilter($content) . "','" . SecurityFilter($sendtime) . "','" . SecurityFilter($attachid) . "','" . SecurityFilter($attachname) . "','0','1','0')";
        exequery($connection, $sql);
    }

    /**
     * 邮件发送(webservice)
     * @param array $Info 发送详情
     */
    public function NewSendEmail($Info) {
        global $connection;
        if ((int) $Info["SendFlag"] == 0) {
            $query = "INSERT INTO  email
				(FROM_ID,TO_ID,TO_ID2,COPY_TO_ID,SECRET_TO_ID,SUBJECT,CONTENT,SEND_TIME,ATTACHMENT_ID,ATTACHMENT_NAME,READ_FLAG,SEND_FLAG,DELETE_FLAG,BOX_ID,DELETE_BY_SENT)
			VALUES
				('" . SecurityFilter($Info["FromId"]) . "','" . SecurityFilter($Info["ToId"]) . "','" . SecurityFilter($Info["ToId2"]) . "','" . SecurityFilter($Info["CopyToId"]) . "','" . SecurityFilter($Info["SecretToId"]) . "','" . SecurityFilter($Info["Subject"]) . "','" . SecurityFilter($Info["Content"]) . "','" . SecurityFilter($Info["Sendtime"]) . "','" . SecurityFilter($Info["AttachmentId"]) . "','" . SecurityFilter($Info["AttachmentName"]) . "','0','0','0','0','0')";
            exequery($connection, $query);
        } else if ((int) $Info["SendFlag"] == 1) {
            $TO_ID_STR = $Info["ToId2"] . $Info["CopyToId"] . $Info["SecretToId"];
            $TOK = strtok($TO_ID_STR, ",");
            while ($TOK != "") {
                $query = "INSERT INTO  email
					(FROM_ID,TO_ID,TO_ID2,COPY_TO_ID,SECRET_TO_ID,SUBJECT,CONTENT,SEND_TIME,ATTACHMENT_ID,ATTACHMENT_NAME,READ_FLAG,SEND_FLAG,DELETE_FLAG,BOX_ID,DELETE_BY_SENT)
				VALUES
					('" . SecurityFilter($Info["FromId"]) . "','" . SecurityFilter($TOK) . "','" . SecurityFilter($Info["ToId2"]) . "','" . SecurityFilter($Info["CopyToId"]) . "','" . SecurityFilter($Info["SecretToId"]) . "','" . SecurityFilter($Info["Subject"]) . "','" . SecurityFilter($Info["Content"]) . "','" . SecurityFilter($Info["Sendtime"]) . "','" . SecurityFilter($Info["AttachmentId"]) . "','" . SecurityFilter($Info["AttachmentName"]) . "','0','1','0','0','0')";
                exequery($connection, $query);
                $TOK = strtok(",");
            }
        }

        return  mysql_insert_id();
    }

    private function returnSqlPar($pars) {
        $sqlPar = is_array($pars) ? implode(",", $pars) : $pars;
        if (substr($sqlPar, -1, 1) == ",") {
            $sqlPar = substr($sqlPar, 0, strlen($sqlPar) - 1);
        }

        $sqlPar = "'" . str_replace(",", "','", $sqlPar) . "'";
        return $sqlPar;
    }

    public function getEmailList($BOX_ID, $boxtype, $LOGIN_USER_ID, $limitRows, $limitOffset, $sortField, $sortType, $searchField, $searchValue, $condition, $send_start_date, $send_end_date) {
        global $connection;
        if ($BOX_ID == 0 && $boxtype == -1) {
            $query = "SELECT a.*,b.USER_NAME FROM email as a join user as b on a.FROM_ID=b.USER_ID WHERE BOX_ID='" . SecurityFilter($BOX_ID) . "' AND TO_ID='" . SecurityFilter($LOGIN_USER_ID) . "'  AND SEND_FLAG='1' AND DELETE_FLAG!='1'";
            $querycount = "SELECT COUNT(*) AS CNT FROM email as a join user as b on a.FROM_ID=b.USER_ID WHERE BOX_ID='" . SecurityFilter($BOX_ID) . "' AND TO_ID='" . SecurityFilter($LOGIN_USER_ID) . "'  AND SEND_FLAG='1' AND DELETE_FLAG!='1'";
        } else if ($BOX_ID == 0 && $boxtype == -2) {
            $query = "SELECT a.*,b.USER_NAME FROM email as a join user as b on a.FROM_ID=b.USER_ID WHERE FROM_ID='" . SecurityFilter($LOGIN_USER_ID) . "' AND SEND_FLAG='0' AND BOX_ID='" . SecurityFilter($BOX_ID) . "' AND DELETE_FLAG!='1' AND DELETE_BY_SENT != '1' ";
            $querycount = "SELECT COUNT(*) AS CNT FROM email as a join user as b on a.FROM_ID=b.USER_ID WHERE FROM_ID='" . SecurityFilter($LOGIN_USER_ID) . "' AND SEND_FLAG='0' AND BOX_ID='" . SecurityFilter($BOX_ID) . "' AND DELETE_FLAG!='1' AND DELETE_BY_SENT != '1' ";
        } else if ($BOX_ID == 0 && $boxtype == -3) {
            $query = "SELECT a.*,b.USER_NAME FROM email as a join user as b on a.TO_ID=b.USER_ID WHERE FROM_ID='" . SecurityFilter($LOGIN_USER_ID) . "' AND SEND_FLAG='1' AND DELETE_BY_SENT <> 1  "; //group by FROM_ID,SEND_TIME
            $querycount = "SELECT COUNT(*) AS CNT FROM email as a join user as b on a.TO_ID=b.USER_ID WHERE FROM_ID='" . SecurityFilter($LOGIN_USER_ID) . "' AND SEND_FLAG='1' AND DELETE_BY_SENT <> 1  ";//group by FROM_ID,SEND_TIME
        } else {
            $query = "SELECT a.*,b.USER_NAME FROM email as a join user as b on a.FROM_ID=b.USER_ID WHERE BOX_ID='" . SecurityFilter($boxtype) . "' AND TO_ID='" . SecurityFilter($LOGIN_USER_ID) . "'  AND SEND_FLAG='1' AND DELETE_FLAG!='1'";
            $querycount = "SELECT COUNT(*) AS CNT FROM email as a join user as b on a.FROM_ID=b.USER_ID WHERE BOX_ID='" . SecurityFilter($boxtype) . "' AND TO_ID='" . SecurityFilter($LOGIN_USER_ID) . "'  AND SEND_FLAG='1' AND DELETE_FLAG!='1'";
        }
        if ($searchField != '' && $searchValue != '') {
            $query.=" AND $searchField LIKE '%" . SecurityFilter($searchValue) . "%'";
            $querycount.=" AND $searchField LIKE '%" . SecurityFilter($searchValue) . "%'";
        }
        foreach ($condition as $key => $value) {
            if ($value != '') {
                $query.=" AND $key LIKE '%" . SecurityFilter($value) . "%'";
                $querycount.=" AND $key LIKE '%" . SecurityFilter($value) . "%'";
            }
        }
        if ($send_end_date != '') {
            $query.=" AND TO_DAYS('" . SecurityFilter($send_start_date) . "') <= TO_DAYS(SEND_TIME)";
            $querycount.=" AND TO_DAYS('" . SecurityFilter($send_start_date) . "') <= TO_DAYS(SEND_TIME)";
            $query.= " AND TO_DAYS('" . SecurityFilter($send_end_date) . "') >= TO_DAYS(SEND_TIME)";
            $querycount.=" AND TO_DAYS('" . SecurityFilter($send_end_date) . "') >= TO_DAYS(SEND_TIME)";
        } else if ($send_start_date != '') {
            $query.=" AND TO_DAYS('" . SecurityFilter($send_start_date) . "') = TO_DAYS(SEND_TIME)";
            $querycount.=" AND TO_DAYS('" . SecurityFilter($send_start_date) . "') = TO_DAYS(SEND_TIME)";
        }

       if ($BOX_ID == 0 && $boxtype == -3) { //FAJIANXIANG
           $query.=" group by FROM_ID,SEND_TIME DESC";
           $querycount.=" group by FROM_ID,SEND_TIME DESC";
       }

       if ($sortField != "") {
            $query.=" ORDER BY ".SecurityFilter($sortField)." ".SecurityFilter($sortType);
        }

        $getCountResult = exequery($connection, $querycount);

        //发件箱 邮件总数 需要
        if ($BOX_ID == 0 && $boxtype == -3) {
            $arrCount = array();
            while ($getCountRow = mysql_fetch_array($getCountResult)) {
                $arrCount[] = $getCountRow["CNT"];
            }

            $totalCount = Count($arrCount);
            // 总数
            $realPage = $totalCount / $limitRows;
            $curentPage = $limitOffset / $limitRows;

            if ($curentPage >= $realPage) {

                if ($totalCount % $limitRows == 0) {
                    $limitOffset = $totalCount - $limitRows;
                } else {
                    $limitOffset = $totalCount - $totalCount % $limitRows;
                }
                // $limitOffset =  $totalCount - $totalCount%$limitRows;
            }
        } else {
            if ($getCountRow = mysql_fetch_array($getCountResult)) {
                $totalCount = $getCountRow["CNT"];
            }
        }


        if($limitOffset < 0){
            $limitOffset = 0;
        }

        $query.=" LIMIT ".SecurityFilter($limitOffset).",".SecurityFilter($limitRows);

        $result = array();
        $cursor = exequery($connection, $query);

        while ($getListRow = mysql_fetch_assoc($cursor)) {

            $news_ex_sql = "select TO_ID2 , EMAIL_ID from email where send_time ='" . SecurityFilter($getListRow['SEND_TIME']) . "' and FROM_ID = '" . SecurityFilter($getListRow['FROM_ID']) . "'";
             $getListRow['FROM_ID'] = showUserGeneral($getListRow['FROM_ID']);
            $str = "";
            $news_ex = exequery($connection, $news_ex_sql);
            $news_res = array();
            while ($ro = mysql_fetch_assoc($news_ex)) {
                $news_res[] = $ro['TO_ID2'];
            }
            if ($news_res[0] == $news_res[1]) {
                $str = $news_res[0];
            } else {
                $count = count($news_res);
                foreach ($news_res as $key => $val) {
                    if ($count == 1) {
                        $str .= $val;
                    } else {
                        $str .= $val . ",";
                    }
                }
            }




            $getListRow['TO_ID'] = showUserMoreGeneral($str);

            array_push($result, $getListRow);
        }


        return array(
            "totalCount" => $totalCount,
            'list' => $result
        );
    }

    public function getInboxMailCout($userid) {
        global $connection;
        $query = "SELECT COUNT(EMAIL_ID) AS count FROM email WHERE BOX_ID=0 AND TO_ID='" . SecurityFilter($userid) . "' AND SEND_FLAG='1' AND DELETE_FLAG !='1' ";
        $rs = exequery($connection, $query);
        if ($rows = mysql_fetch_array($rs)) {
            $inboxmailcount = $rows["count"];
        }
        return $inboxmailcount;
    }

    public function getUnreadMailCout($userid) {
        global $connection;
        $query = "SELECT COUNT(EMAIL_ID) AS count FROM email WHERE BOX_ID=0 and TO_ID='" . SecurityFilter($userid) . "' AND SEND_FLAG='1' AND READ_FLAG='0' AND DELETE_FLAG!='1' ";
        $rs = exequery($connection, $query);
        if ($rows = mysql_fetch_array($rs)) {
            $unreadmailcount = $rows["count"];
        }
        return $unreadmailcount;
    }

    public function getSentMailCout($userid) {
        global $connection;
        //
        //$query = "SELECT COUNT(EMAIL_ID) AS count FROM email WHERE FROM_ID='".$userid."' AND SEND_FLAG='1' AND DELETE_BY_SENT <> 1 group by TO_ID2,SEND_TIME";
        $query = "SELECT COUNT(*) AS count FROM email as a join user as b on a.TO_ID=b.USER_ID WHERE FROM_ID='" . SecurityFilter($userid) . "' AND SEND_FLAG='1' AND DELETE_BY_SENT <> 1 group by FROM_ID,SEND_TIME";
        $rs = exequery($connection, $query);
        $arr = array();
        while ($rows = mysql_fetch_array($rs)) {
            $arr[] = $rows["count"];
        }
        $sentmailcount = count($arr);
        return $sentmailcount;
    }

    public function getOutboxMailCout($userid) {
        global $connection;
        $query = "SELECT COUNT(EMAIL_ID) AS count FROM email WHERE SEND_FLAG='0' and FROM_ID='" . SecurityFilter($userid) . "' ";
        $rs = exequery($connection, $query);
        if ($rows = mysql_fetch_array($rs)) {
            $oubboxmailcount = $rows["count"];
        }
        return $oubboxmailcount;
    }

    public function getDelMailCout($userid) {
        global $connection;
        $query = "SELECT COUNT(EMAIL_ID) AS count FROM email WHERE SEND_FLAG='1' AND FROM_ID='" . SecurityFilter($userid) . "'  AND DELETE_FLAG='1' ";
        $rs = exequery($connection, $query);
        if ($rows = mysql_fetch_array($rs)) {
            $oubboxmailcount = $rows["count"];
        }
        return $oubboxmailcount;
    }

    public function getOherFilefolderMailCout($userid, $boxid) {
        global $connection;
        $query = "SELECT COUNT(EMAIL_ID) AS count FROM email WHERE TO_ID='" . SecurityFilter($userid) . "'  AND BOX_ID ='" . SecurityFilter($boxid) . "' AND DELETE_FLAG != 1 ";
        $rs = exequery($connection, $query);
        if ($rows = mysql_fetch_array($rs)) {
            $otherfilefoldermailcount = $rows["count"];
        }
        return $otherfilefoldermailcount;
    }

    public function getUnreadOherFilefolderMailCout($userid, $boxid) {
        global $connection;
        $query = "SELECT COUNT(EMAIL_ID) AS count FROM email WHERE TO_ID='" . SecurityFilter($userid) . "' AND READ_FLAG='0' AND BOX_ID ='" . SecurityFilter($boxid) . "' AND DELETE_FLAG != 1 ";
        $rs = exequery($connection, $query);
        if ($rows = mysql_fetch_array($rs)) {
            $otherfilefoldermailcount = $rows["count"];
        }
        return $otherfilefoldermailcount;
    }

    public function getEmailBoxList($loginUserID, $limitRows, $limitOffset) {
        global $connection;
        $query = "SELECT * FROM email_box WHERE USER_ID = '" . SecurityFilter($loginUserID) . "' ";
        $querycount = "SELECT COUNT(*) AS CNT  FROM email_box WHERE USER_ID = '" . SecurityFilter($loginUserID) . "' ";
        $query.=" LIMIT ".SecurityFilter($limitOffset).",".SecurityFilter($limitRows);
        $result = array();
        $cursor = exequery($connection, $query);
        while ($getListRow = mysql_fetch_assoc($cursor)) {
            $getListRow['UNREADCOUNT'] = $this->getUnreadOherFilefolderMailCout($loginUserID, $getListRow["BOX_ID"]);
            $getListRow['TOTALCOUNT'] = $this->getOherFilefolderMailCout($loginUserID, $getListRow["BOX_ID"]);
            array_push($result, $getListRow);
        }
        $getCountResult = exequery($connection, $querycount);
        if ($getCountRow = mysql_fetch_array($getCountResult)) {
            $totalCount = $getCountRow["CNT"];
        }
        return array(
            "totalCount" => $totalCount,
            'list' => $result
        );
    }

    public function getEmailBoxFolder($loginUserID) {
        global $connection;
        $query = "SELECT * FROM email_box WHERE USER_ID = '" . SecurityFilter($loginUserID) . "' ";
        $result = array();
        $cursor = exequery($connection, $query);
        while ($getListRow = mysql_fetch_assoc($cursor)) {
            $getListRow['BOX_INFO'] = $getListRow['BOX_NAME'] . '(' .
                    $this->getUnreadOherFilefolderMailCout($loginUserID, $getListRow["BOX_ID"]) . '/' .
                    $this->getOherFilefolderMailCout($loginUserID, $getListRow["BOX_ID"]) . ')';
            array_push($result, $getListRow);
        }
        return $result;
    }

    public function batchUpdateEmailStatus($data) {
        global $connection;
        foreach ($data as $d) {
            $sql = "UPDATE email SET READ_FLAG='1' WHERE EMAIL_ID=" . SecurityFilter($d['EMAIL_ID']);
            exequery($connection, $sql);
        }
        return true;
    }

    public function batchDeleteEmail($data, $boxid, $boxtype) {
        global $connection;
        $emailIdStr = '';
        foreach ($data as $d) {
            $emailIdStr .= "'" . SecurityFilter($d['EMAIL_ID']) . "',";
            $sendemailStr .= "'" . SecurityFilter($d['SEND_TIME']) . "',";
        }
        $emailIdStr = substr($emailIdStr, 0, -1);
        $sendemailStr = substr($sendemailStr, 0, -1);

        if ($boxid == 0 && $boxtype == -1) {
            $query = "UPDATE email SET DELETE_FLAG  = '1' WHERE EMAIL_ID IN (" . SecurityFilter($emailIdStr) . ")";
            $rs = exequery($connection, $query);
        } else if ($boxid == 0 && $boxtype == -2) {
            //删除发件箱中的邮件
            //根据条件删除可以删除的附件

            $query = "SELECT ATTACHMENT_ID,ATTACHMENT_NAME FROM email WHERE EMAIL_ID IN (" . SecurityFilter($emailIdStr) . ")";
            $rs = exequery($connection, $query);
            while ($rows = mysql_fetch_array($rs)) {
                $ATTACHMENT_ID = $rows["ATTACHMENT_ID"];
                $ATTACHMENT_NAME = $rows["ATTACHMENT_NAME"];
                $ATTACHMENT_ID_ARRAY = explode(",", $ATTACHMENT_ID);
                $ATTACHMENT_NAME_ARRAY = explode("*", $ATTACHMENT_NAME);
                $ARRAY_COUNT = sizeof($ATTACHMENT_ID_ARRAY);
                for ($I = 0; $I < $ARRAY_COUNT - 1; $I++) {
                    $re_query = "SELECT COUNT(EMAIL_ID) AS CT FROM email WHERE ATTACHMENT_ID LIKE '%" . $ATTACHMENT_ID_ARRAY[$I] . "%' AND ATTACHMENT_NAME LIKE '%" . $ATTACHMENT_NAME_ARRAY[$I] . "%' AND EMAIL_ID NOT IN (" . SecurityFilter($emailIdStr) . ")";
                    $re_rs = exequery($connection, $re_query);
                    if ($re_rows = mysql_fetch_array($re_rs)) {
                        $count = $re_rows["CT"];
                    }
                    if ($count <= 0) {
                        delete_attach($ATTACHMENT_ID_ARRAY[$I], $ATTACHMENT_NAME_ARRAY[$I]);
                    }
                }
            }
            $query = "DELETE FROM email WHERE EMAIL_ID IN (" . SecurityFilter($emailIdStr) . ")";
            $rs = exequery($connection, $query);
        } else if ($boxid == 0 && $boxtype == -3) {
            //删除已发送邮箱中的邮件
            $query = "UPDATE email SET DELETE_BY_SENT = '1' WHERE SEND_TIME IN (" . SecurityFilter($sendemailStr) . ")";
            $rs = exequery($connection, $query);
        } else {
            //删除自定义邮箱中的邮件（和收件箱中的一样处理）
            $query = "UPDATE email SET DELETE_FLAG  = '1' WHERE EMAIL_ID IN (" . SecurityFilter($emailIdStr) . ")";
            $rs = exequery($connection, $query);
        }
        if ($rs) {
            return 1;
        } else {
            return 0;
        }
    }

    public function deleteEmailById($data, $boxid, $boxtype) {
        global $connection;
        if ($boxid == 0 && $boxtype == -1) {
            $query = "UPDATE email SET DELETE_FLAG  = '1' WHERE EMAIL_ID = '" . SecurityFilter($data['EMAIL_ID']) . "' ";
            $rs = exequery($connection, $query);
        } else if ($boxid == 0 && $boxtype == -2) {
            //删除发件箱中的邮件
            //根据条件删除可以删除的附件

            $query = "SELECT ATTACHMENT_ID,ATTACHMENT_NAME FROM email WHERE EMAIL_ID = '" . SecurityFilter($data['EMAIL_ID']) . "' ";
            $rs = exequery($connection, $query);
            while ($rows = mysql_fetch_array($rs)) {
                $ATTACHMENT_ID = $rows["ATTACHMENT_ID"];
                $ATTACHMENT_NAME = $rows["ATTACHMENT_NAME"];
                $ATTACHMENT_ID_ARRAY = explode(",", $ATTACHMENT_ID);
                $ATTACHMENT_NAME_ARRAY = explode("*", $ATTACHMENT_NAME);
                $ARRAY_COUNT = sizeof($ATTACHMENT_ID_ARRAY);
                for ($I = 0; $I < $ARRAY_COUNT - 1; $I++) {
                    $re_query = "SELECT COUNT(EMAIL_ID) AS CT FROM email WHERE ATTACHMENT_ID LIKE '%" . $ATTACHMENT_ID_ARRAY[$I] . "%' AND ATTACHMENT_NAME LIKE '%" . $ATTACHMENT_NAME_ARRAY[$I] . "%' AND WHERE EMAIL_ID != '" . SecurityFilter($data['EMAIL_ID']) . "' ";
                    $re_rs = exequery($connection, $re_query);
                    if ($re_rows = mysql_fetch_array($re_rs)) {
                        $count = $re_rows["CT"];
                    }
                    if ($count <= 0) {
                        delete_attach($ATTACHMENT_ID_ARRAY[$I], $ATTACHMENT_NAME_ARRAY[$I]);
                    }
                }
            }
            $query = "DELETE FROM email WHERE EMAIL_ID = '" . SecurityFilter($data['EMAIL_ID']) . "' ";
            $rs = exequery($connection, $query);
        } else if ($boxid == 0 && $boxtype == -3) {
            //删除已发送邮箱中的邮件
            $query = "UPDATE email SET DELETE_BY_SENT = '1' WHERE SEND_TIME = '" . SecurityFilter($data['SEND_TIME']) . "' ";
            $rs = exequery($connection, $query);
        } else {
            //删除自定义邮箱中的邮件（和收件箱中的一样处理）
            $query = "UPDATE email SET DELETE_FLAG  = '1' WHERE EMAIL_ID = '" . SecurityFilter($data['EMAIL_ID']) . "' ";
            $rs = exequery($connection, $query);
        }
        if ($rs) {
            return 1;
        } else {
            return 0;
        }
    }

}

?>
