<?php
/**
* @copyright (C) 2010 - 2011 Weaver Co.Ltd
* @package       eoffice8.0
* @function      固定流程类
* @encoding      $_lang['encoding']
* @name          api/fixedworkflow.class.php
* @version       11
* @author        sun|www.weaver.com.cn
* @modify        sunx
* @date          2012-09-17
*/
include_once("inc/flow_doc_class.php");
include_once("api/workflow.class.php");
include_once("api/email.class.php");
include_once("inc/mobile_sms.inc.php");

/**
* 这是固定流程的类，继承流程基类
* @access public
* @auth  sunxiang
*/
class fixedWorkflow extends workflow
{
	/**
	*创建流程函数
	*@access public
	*@param  str  $creator    子流程创建人id
	*@param  str  $parentName 父流程类名称
	*@return int  $this->runId
	*/
	function create($creator='',$parentName='',$formData='',$runSeq='',$runName='')
	{
		global $connection,$_lang;
		$createTime = date("Y-m-d H:i:s");
		if(!$creator)
		{
			$creator = $_SESSION["LOGIN_USER_ID"];
		}
		$sql = "SELECT USER_NAME FROM user WHERE USER_ID='".SecurityFilter($creator)."'";
		$rs  = exequery($connection,$sql);
		$user_name = mysql_fetch_array($rs);
		$this->runName = $runName != ''?$runName:$this->flowName."(".$createTime.":".$user_name['USER_NAME'].")";
		if($parentName)
		{
			$this->runName = $parentName." ".$_lang["flow_trigger"]." ".$this->runName;
			$this->runSeq  = $runSeq != ''?$runSeq:$this->getSeqAuto($creator);
		}
		// $this->runSeq  = $runSeq != ''?$runSeq:$this->getSeqAuto($creator);
		//-------取当前run_id最大值+1作为新流程的run_id--
		//原有的算出RUN_ID，这样会导致流程错乱，故将其改成自增长，qc-5289
		/*$query   = "SELECT MAX(RUN_ID) FROM flow_run ";
		$cursor  = exequery($connection,$query);
		if($rows = mysql_fetch_array($cursor))
		{
			$this->runId = $rows[0]+1;
		}*/
		//-----生成流程flow_run--增加了CURRENT_STEP表示流程的状态------------------------------
		$query = "INSERT INTO flow_run(RUN_NAME,FLOW_ID,RUN_SEQ,CREATE_TIME,CREATOR,CURRENT_STEP,TRANSACT_TIME,MAX_PRCS_ID) VALUES ('".SecurityFilter($this->runName)."','".SecurityFilter($this->flowId)."','".SecurityFilter($this->runSeq)."','$createTime','".SecurityFilter($creator)."','1','".SecurityFilter($createTime)."','1')";
		exequery($connection,$query);
		$this->runId = mysql_insert_id();
		//-----生成流程步骤，第一步flow_run_prcs-----------------------------------------------------
		$query = "INSERT INTO flow_run_prcs (RUN_ID,PRCS_ID,USER_ID,PRCS_FLAG,FLOW_PRCS) VALUES ('".SecurityFilter($this->runId)."',1,'".SecurityFilter($creator)."','1','1')";
		exequery($connection,$query);
		//更新flow_run_step
		$query = "INSERT INTO flow_run_step (RUN_ID,PRCS_ID,USER_ID,FLOW_PRCS,USER_RUN_TYPE,TRANSACT_TIME) VALUES ('".SecurityFilter($this->runId)."',1,'".SecurityFilter($creator)."','1','1',UNIX_TIMESTAMP(NOW()))";
		exequery($connection,$query);
		//-------取表单内容------------------------------------------------------
		$query   = "SELECT * FROM flow_form_type WHERE FORM_ID = '".SecurityFilter($this->formId)."'";
		$cursor1 = exequery($connection,$query);
		if($rows = mysql_fetch_array($cursor1))
		{
			$printModel = $rows["PRINT_MODEL"];
		}
		//-------------Html 智能分析,生成初始数据 ------
		$elementArray = html_element($printModel);
		$arrayCount   = sizeof($elementArray);
		$itemId       = 0;
		for($I=0; $I < $arrayCount; $I++)
		{
			//------默认值 -------------------------------
			$eName  = get_attr($elementArray[$I],"NAME");
			$eClass = get_attr($elementArray[$I],"CLASS");
			$eId    = get_attr($elementArray[$I],"ID");
			$eTitle = get_attr($elementArray[$I],"TITLE");
			if($eClass != "DATE"&&$eClass !="time")
			{
				$itemId++;
			}
			else
				continue;
			if($formData)
			{
				$itemData = $formData->$eTitle;
			}
			else
			{
				if($eName != "SELECT")
				{
					$itemData = get_attr($elementArray[$I],"VALUE");
					$itemData = str_replace("\"","",$itemData);
				}
				else
					$itemData = "";
			}

			$query = "INSERT INTO flow_run_data (RUN_ID,ITEM_ID,ITEM_DATA ) VALUES ('".SecurityFilter($this->runId)."',".SecurityFilter($itemId).",'".SecurityFilter($itemData)."')";
			exequery($connection,$query);
			//用于流程新的保存数据模式
			if($eClass !="DATE"&&$eClass !="time"&&substr($eId,0,5)=="DATA_")
			{
				$fieldStr .= "$eId,";
				$valueStr .= "'".$itemData."'," ;
			}
		}
		//流程新的保存数据模式
		$fieldStr = trim($fieldStr,",");
		$valueStr = trim($valueStr,",");

		$newQuery = "INSERT INTO zzzz_flow_data_".SecurityFilter($this->formId)." ( FORM_ID,FLOW_ID,RUN_ID,FLOW_NAME,RUN_NAME,RUN_SEQ,CREATE_TIME,CURRENT_STEP,TRANSACT_TIME,".SecurityFilter($fieldStr)." ) VALUES('".SecurityFilter($this->formId)."','".SecurityFilter($this->flowId)."','".SecurityFilter($this->runId)."','".SecurityFilter($this->flowName)."','".SecurityFilter($this->runName)."','".SecurityFilter($this->runSeq)."','".SecurityFilter($createTime)."','1','".SecurityFilter($createTime)."',$valueStr)";
		//echo "newQuery=$newQuery";
		exequery($connection,$newQuery);
		//增加创建日志
		AddBroacastLog($creator,"flow_run","RUN_ID",$this->runId,"RUN_NAME","new","1");
		return $this->runId;
	}
	/**
	*流程办理的转交下一步
	*@access public
	*@param  int  $flowPrcs      流程节点
	*@param  str  $prcsId        流程走的的步骤
	*@param  str  $prcsUser      经办人
	*@param  str  $prcsOpUser    主办人
	*@param  str  $oP            操作类型
	*@param  str  $subFlowRunIds 子流程id字符串
	*@param  str  $monitor       监控转交人id
	*@param  str  $mbSmsContent  手机短信提醒内容
	*@param  str  $smsContent    内部消息提醒内容
	*@param  str  $emailContent  邮件提醒内容
	*@param  str  $FLOW_PRCS_UP  流程当前所处节点
	*@param  str  $byCopyUserId  提交页面抄送时的被抄送人员
	*@param  str  $params        其他参数，不再用一个个加参数的方式了
	*@return void
	*/
	function turnNext($flowPrcs,$prcsId,$prcsUser,$prcsOpUser,$docId,$oP,$subFlowRunIds,$limitDate,$monitor='',$mbSmsContent='',$smsContent='',$emailContent='',$userid='',$type='',$canEndFlow='',$FLOW_PRCS_UP='',$byCopyUserId='',$params="")
	{
		global $connection,$_lang;
		if($userid=="")
		{
			$USER_ID = $_SESSION['LOGIN_USER_ID'];
		}
		else
		{
			$USER_ID = $userid;
		}
		$isDeleted = $this->haveDelected();
		if($isDeleted)
		{
			header("location:error.php?errorType=1");
			exit;
		}
		$curTime = date("Y-m-d H:i:s",time());

		//对webservice接口调用做特殊处理
		if($type != 'webservice') {
			//监控人提交，验证的应该是这个步骤实际办理人是否提交
			if($monitor)
			{
				//查询这个步骤地主办人
				$sql = "SELECT * FROM flow_run_prcs WHERE RUN_ID = '".SecurityFilter($this->runId)."' AND PRCS_ID = '".SecurityFilter($prcsId)."' AND OP_FLAG = '1' ";
				$rs  = exequery($connection,$sql);
				if($row = mysql_fetch_array($rs))
					$opFlagUser = $row["USER_ID"];
				$isTurned = $this->haveTurned($prcsId,$opFlagUser);
				if($isTurned)
				{
					Message("",$_lang["flow_turned_tips"]);
					exit;
				}
			} else {
				//非监控提交，检测是否提交了
				$isTurned = $this->haveTurned($prcsId,$USER_ID);
				if($isTurned)
				{
					header("location:error.php?errorType=2");
					exit;
				}
			}
		}
		//抄送参数配置
		$transactUserArr = $this->getFlowTransactUser($this->runId,$prcsId);
		if(count($transactUserArr["OP_FLAG_USER"]) > 0) {
			$COPY_USER_ARR = array_keys($transactUserArr["OP_FLAG_USER"]);
			$COPY_USER     = $COPY_USER_ARR[0];
		}
		if(!$COPY_USER)
			$COPY_USER = $USER_ID;
		$copyFlowParam = array("RUN_ID"=>$this->runId,"COPY_USER"=>$COPY_USER,"FLOW_ID"=>$this->flowId,"PRCS_ID"=>$prcsId,"FLOW_PRCS"=>$FLOW_PRCS_UP,"smsContent"=>$smsContent,"mbSmsContent"=>$mbSmsContent,"emailContent"=>$emailContent,"docId"=>$docId,"byCopyUserId"=>$byCopyUserId,"copyFrom"=>"hostSubmit");
		//获取流程名称，短信提醒中用到
		$this->flowRunningInfo();
		//最后一步，结束流程
		if($flowPrcs == "" || $flowPrcs == "0")
		{
			//更新流程的状态
			$query = "UPDATE flow_run SET CURRENT_STEP = '0',TRANSACT_TIME = '".SecurityFilter($curTime)."' WHERE RUN_ID = '".SecurityFilter($this->runId)."'";
			exequery($connection,$query);
			//更新流程的状态--新的结构
			$query = "UPDATE zzzz_flow_data_".SecurityFilter($this->formId)." SET CURRENT_STEP = '0',TRANSACT_TIME = '".SecurityFilter($curTime)."' WHERE RUN_ID = '".".SecurityFilter($this->runId)."."'";
			exequery($connection,$query);
			$query = "UPDATE flow_run_prcs SET DELIVER_TIME = '".SecurityFilter($curTime)."',PRCS_FLAG = '4',MONITOR_SUBMIT='".SecurityFilter($monitor)."' WHERE RUN_ID = '".SecurityFilter($this->runId)."' AND PRCS_ID = '".SecurityFilter($prcsId)."'";
			exequery($connection,$query);
			$query = "UPDATE flow_run_prcs SET SAVEFORM_TIME ='".SecurityFilter($curTime)."',PRCS_FLAG='4' WHERE RUN_ID = '".SecurityFilter($this->runId)."' AND USER_ID='".SecurityFilter($USER_ID)."' AND OP_FLAG = '0' AND ((SAVEFORM_TIME = '0000-00-00 00:00:00') OR (SAVEFORM_TIME is NULL))";
			exequery($connection,$query);
			//更新flow_run_step
			//1、TRANSACT_TIME
			$query = "UPDATE flow_run fr,flow_run_step frs SET frs.TRANSACT_TIME = UNIX_TIMESTAMP(fr.TRANSACT_TIME) WHERE fr.run_id = frs.run_id AND fr.run_id = '".SecurityFilter($this->runId)."'";
			exequery($connection,$query);
			//2、更新流程对应步骤下，主办人或当前人员的状态
			$query = "UPDATE flow_run fr,flow_run_step frs SET frs.USER_RUN_TYPE = '3' WHERE fr.run_id = frs.run_id AND fr.run_id = '".SecurityFilter($this->runId)."' AND frs.PRCS_ID = '".SecurityFilter($prcsId)."' AND (frs.OP_FLAG = '1' OR frs.USER_ID = '".SecurityFilter($USER_ID)."')";
			exequery($connection,$query);
			//3、将所有已经提交流程的主办/经办人的状态改成结束
			$query = "UPDATE flow_run fr,flow_run_step frs SET frs.USER_RUN_TYPE = '3' WHERE fr.run_id = frs.run_id AND fr.run_id = '".SecurityFilter($this->runId)."' AND frs.USER_RUN_TYPE = '2'";
			exequery($connection,$query);
			//关联文档保存到数据库 结束节点也可以加一些文档的
			if($docId != ''){
				$query_doc = "UPDATE flow_run SET LINK_DOC='".SecurityFilter($docId)."' WHERE RUN_ID = '".SecurityFilter($this->runId)."'";
				exequery($connection, $query_doc);
				//添加共享
				addDocViewPur($docId,$prcsUser,$this->runId);
			}
			//根据短信提醒规则，生成短信提醒--这里是给流程的所有办理人
			$SMS_CONTENT = $_lang["flow_flowsmscontent"].$this->runName." ".$_lang["flow_have_finished"];
			$smstype     = 7;
			$tablename   = "flow_run";
			$TABLE_ID    = $this->runId;
			$SMS_REMIND  = 1;

			//根据流程设置 获取提醒对象
			$flow_end_remind_sql = "SELECT * FROM flow_others WHERE FLOW_ID = '".SecurityFilter($this->flowId)."' ";
			$sms_to_rs   = exequery($connection,$flow_end_remind_sql);
			$flow_end_remind = array();
			while($sms_to_rows = mysql_fetch_array($sms_to_rs)){
				$flow_end_remind['FLOW_END_REMIND'] = $sms_to_rows['FLOW_END_REMIND'];
				$flow_end_remind['REMIND_TARGET'] = $sms_to_rows['REMIND_TARGET'];
				$flow_end_remind['APPOINT_PROCESS'] = $sms_to_rows['APPOINT_PROCESS'];
			}
			$to_str = "";
			$count = "SELECT PRCS_ID,count(1) AS cnt FROM flow_run_prcs WHERE RUN_ID = '".SecurityFilter($this->runId)."' GROUP BY  PRCS_ID";
			$procount   = exequery($connection,$count);
			while($procounts = mysql_fetch_array($procount))
			{   if($procounts['cnt']==1) {
					$prolist_one[] = $procounts['PRCS_ID'];
				}else{
					$prolist_notone[] = $procounts['PRCS_ID'];
				}	
			}
			if($flow_end_remind['FLOW_END_REMIND']==1){
				
			}elseif($flow_end_remind['FLOW_END_REMIND']==2){
				//通知创建人
				$sms_to_sql  = "SELECT CREATOR FROM flow_run WHERE RUN_ID = '".SecurityFilter($this->runId)."'";
				$sms_to_rs   = exequery($connection,$sms_to_sql);
				while($sms_to_rows = mysql_fetch_array($sms_to_rs))
				{
					$to_str = $sms_to_rows["CREATOR"];
				}
			}elseif($flow_end_remind['FLOW_END_REMIND']==3){
				//通知主办人经办人
				if($flow_end_remind['REMIND_TARGET']==3){
					$sms_to_sql  = "SELECT DISTINCT (USER_ID) FROM flow_run_prcs WHERE RUN_ID = '".SecurityFilter($this->runId)."'";
				//通知主办人
				}elseif($flow_end_remind['REMIND_TARGET']==1){
					$sms_to_sql  = "SELECT DISTINCT (USER_ID) FROM flow_run_prcs WHERE RUN_ID = '".SecurityFilter($this->runId)."'  AND OP_FLAG=1";
				//通知经办人 当办理人只有一个时，不判断经办人
				}elseif($flow_end_remind['REMIND_TARGET']==2){
					if(!empty($prolist_one)) {
						$sms_to_sql  = "SELECT DISTINCT (USER_ID) FROM flow_run_prcs WHERE RUN_ID = '".SecurityFilter($this->runId)."' AND (PRCS_ID IN (".SecurityFilter(implode(',',$prolist_one)).") or OP_FLAG=0)";
					}else{
						$sms_to_sql  = "SELECT DISTINCT (USER_ID) FROM flow_run_prcs WHERE RUN_ID = '".SecurityFilter($this->runId)."' AND OP_FLAG=0";
					}	
				}
				$sms_to_rs   = exequery($connection,$sms_to_sql);
				while($sms_to_rows = mysql_fetch_array($sms_to_rs))
				{
					$to_str .= $sms_to_rows["USER_ID"].",";
				}
			}elseif($flow_end_remind['FLOW_END_REMIND']==4){
				if(!empty($flow_end_remind['APPOINT_PROCESS'])){
					//通知主办人经办人
					if($flow_end_remind['REMIND_TARGET']==3){
						$sms_to_sql  = "SELECT DISTINCT (USER_ID) FROM flow_run_prcs WHERE RUN_ID = '".$this->runId."' AND PRCS_ID IN (".SecurityFilter($flow_end_remind['APPOINT_PROCESS']).")";
					//通知主办人
					}elseif($flow_end_remind['REMIND_TARGET']==1){
						$sms_to_sql  = "SELECT DISTINCT (USER_ID) FROM flow_run_prcs WHERE RUN_ID = '".SecurityFilter($this->runId)."' AND PRCS_ID IN (".SecurityFilter($flow_end_remind['APPOINT_PROCESS']).")  AND OP_FLAG=1";
					//通知经办人 当办理人只有一个时，不判断经办人
					}elseif($flow_end_remind['REMIND_TARGET']==2){
						if(!empty($prolist_one)) {
							$pronewslist = explode(',',$flow_end_remind['APPOINT_PROCESS']);
							$prolist = array_intersect($prolist_one,$pronewslist);
							if(!empty($prolist)){
								$sms_to_sql  = "SELECT DISTINCT (USER_ID) FROM flow_run_prcs WHERE RUN_ID = '".$this->runId."' AND ((PRCS_ID IN (".SecurityFilter($flow_end_remind['APPOINT_PROCESS']).") AND OP_FLAG=0) or PRCS_ID IN (".SecurityFilter(implode(',',$prolist))."))";
							}else{
								$sms_to_sql  = "SELECT DISTINCT (USER_ID) FROM flow_run_prcs WHERE RUN_ID = '".SecurityFilter($this->runId)."' AND PRCS_ID IN (".SecurityFilter($flow_end_remind['APPOINT_PROCESS']).") AND OP_FLAG=0";
							}
							
						}else{
							$sms_to_sql  = "SELECT DISTINCT (USER_ID) FROM flow_run_prcs WHERE RUN_ID = '".SecurityFilter($this->runId)."' AND PRCS_ID IN (".SecurityFilter($flow_end_remind['APPOINT_PROCESS']).") AND OP_FLAG=0";
						}
					}
					$sms_to_rs   = exequery($connection,$sms_to_sql);
					while($sms_to_rows = mysql_fetch_array($sms_to_rs))
					{
						$to_str .= $sms_to_rows["USER_ID"].",";
					}
				}
			}
			//手机短信
			if($mbSmsContent && $to_str)
			{
				if(ifSendMbSms())
				{
					$newSms = new MobileSms();
					$newSms->SelfSendMore($to_str,$SMS_CONTENT);
				}
			}
			//内部邮件
			if($emailContent && $to_str)
			{
				$email = new email();
				$currentTime = date("Y-m-d H:i:s",time());
				foreach (explode(',', trim($to_str, ',')) as $toKey => $toValue) {
					if (!empty($toValue)) {
						$email->sendEmail($USER_ID,$toValue,$to_str,$_lang["flow_deal_email_remind"],$SMS_CONTENT,$currentTime,'','');
					}
				}
			}
			$TABLE_VAR   = "FLOW_ID,RUN_ID,PRCS_ID,FLOW_PRCS,|".$this->flowId.",".$this->runId.",$prcsId,$flowPrcs,";
			if($smsContent && $to_str)
				sendSms($USER_ID,$to_str,$SMS_CONTENT,$SMS_REMIND,$smstype,$tablename,$TABLE_ID,$TABLE_VAR);

			//调用独立函数，进行固定抄送
			$this->copyFlowByProcessSet($copyFlowParam);
			//流程归档
			$queryRel = "SELECT FLOW_TO_DOC FROM `flow_others`  WHERE FLOW_ID = '".SecurityFilter($this->flowId)."' ";
			$res      = exequery($connection,$queryRel);
			$rowRel   = mysql_fetch_array($res);
			$FLOW_TO_DOC = $rowRel['FLOW_TO_DOC'];
			if($FLOW_TO_DOC==1){
				$flowToDoc = new flowToDoc($this->flowId,$this->runId,"",$params["folder_id"]);
			}
			//增加判断子流程是否已经归档，如果归档则更新归档文件的权限
			$subRunIdArray = $this->getSubWorkflow();
			for($i=0;$i<count($subRunIdArray);$i++)
			{
				$flowToFile = $this->haveArchive($subRunIdArray[$i]);
				if($flowToFile)
				{
					$flowIdSql = "SELECT * FROM flow_run WHERE RUN_ID = '".SecurityFilter($subRunIdArray[$i])."'";
					$flowIdRs  = exequery($connection,$flowIdSql);
					if($flowIdRow = mysql_fetch_array($flowIdRs))
					{
						$flowid = $flowIdRow["FLOW_ID"];
						$flowToDoc = new flowToDoc($flowid,$subRunIdArray[$i],"update");
					}
				}
			}
		} else {
			//更新流程的状态
			$query = "UPDATE flow_run SET CURRENT_STEP = '$flowPrcs',TRANSACT_TIME = '".SecurityFilter($curTime)."' WHERE RUN_ID = '".SecurityFilter($this->runId)."'";
			exequery($connection,$query);
			//更新流程的状态--新的结构
			$query = "UPDATE zzzz_flow_data_$this->formId SET CURRENT_STEP = '$flowPrcs',TRANSACT_TIME = '".SecurityFilter($curTime)."' WHERE RUN_ID = '".SecurityFilter($this->runId)."'";
			exequery($connection,$query);
			//提交流程结束上一步，保存提交时间(DELIVER_TIME)
			$query = "UPDATE flow_run_prcs SET DELIVER_TIME = '".SecurityFilter($curTime)."',PRCS_FLAG = '3',MONITOR_SUBMIT='".SecurityFilter($monitor)."' WHERE RUN_ID='".SecurityFilter($this->runId)."' AND PRCS_ID = '".SecurityFilter($prcsId)."'";

			exequery($connection,$query);
			//增加保存表单的时间改成所有步骤的经办人
			$query = "UPDATE flow_run_prcs SET SAVEFORM_TIME = '".SecurityFilter($curTime)."' WHERE RUN_ID = '".SecurityFilter($this->runId)."' AND USER_ID = '".SecurityFilter($USER_ID)."' AND OP_FLAG = '0' AND ((SAVEFORM_TIME = '0000-00-00 00:00:00') OR (SAVEFORM_TIME is NULL)) ";
			exequery($connection,$query);
			//更新flow_run_step
			//更新流程，主办人或当前人员的状态
			$query = "UPDATE flow_run fr,flow_run_step frs SET frs.USER_RUN_TYPE = '2' WHERE fr.run_id = frs.run_id AND fr.run_id = '".SecurityFilter($this->runId)."' AND frs.PRCS_ID = '".SecurityFilter($prcsId)."' AND (frs.OP_FLAG = '1' OR frs.USER_ID = '".SecurityFilter($USER_ID)."')";
			exequery($connection,$query);
			$prcsIdNext = $prcsId + 1 ;
			$TOK = strtok($prcsUser,",");
			while($TOK != "")
			{
				if($TOK == $prcsOpUser)
					$OP_FLAG = 1;
				else
					$OP_FLAG = 0;
				//办理方式PRCS_OPTYPE>0无主办人
				$sql = "SELECT PRCS_OPTYPE FROM flow_process WHERE FLOW_ID=".SecurityFilter($this->flowId)." AND PRCS_ID=".SecurityFilter($flowPrcs);
				$rs  = exequery($connection,$sql);
				$row = mysql_fetch_array($rs);
				$PRCS_OPTYPE = $row['PRCS_OPTYPE'];
				if($PRCS_OPTYPE > 0 ){
					$OP_FLAG = 0;
				}
				//判断每个办理人是否有委托流程
				$haveAgent = flowHaveAgent($this->flowId,$TOK);
				if($haveAgent)
				{
					$haveAgentArray = explode("|",$haveAgent);
					$agentFlowId    = $haveAgentArray[0];
					$agentUserId    = $haveAgentArray[1];
					$query = "INSERT INTO flow_run_prcs (RUN_ID,PRCS_ID,USER_ID,PRCS_FLAG,FLOW_PRCS,OP_FLAG,LIMIT_DATE,BY_AGENT_ID,SUB_FLOW_RUN_IDS,FLOW_AGENCY_ID) VALUES ('".SecurityFilter($this->runId)."',".SecurityFilter($prcsIdNext).",'".SecurityFilter($agentUserId)."','1',".SecurityFilter($flowPrcs).",'".SecurityFilter($OP_FLAG)."','".SecurityFilter($limitDate)."','".SecurityFilter($TOK)."','".SecurityFilter($subFlowRunIds)."','".SecurityFilter($agentFlowId)."')";
					//给haveAgent增加流程文档权限
					if(!find_id($prcsUser,$agentUserId))
					{
						$prcsUser = $prcsUser.$agentUserId.",";
					}
					//流程的短信提醒也转发到代理人那里
					$TOK = $agentUserId;
				} else {
					$query = "INSERT INTO flow_run_prcs(RUN_ID,PRCS_ID,USER_ID,PRCS_FLAG,FLOW_PRCS,OP_FLAG,LIMIT_DATE,SUB_FLOW_RUN_IDS) values ('".SecurityFilter($this->runId)."',".SecurityFilter($prcsIdNext).",'".SecurityFilter($TOK)."','1',".SecurityFilter($flowPrcs).",'".SecurityFilter($OP_FLAG)."','".SecurityFilter($limitDate)."','".SecurityFilter($subFlowRunIds)."')";
				}
				exequery($connection,$query);
				//更新flow_run_step
				//判断有没有数据
				$query = "SELECT FLOW_STEP_ID,OP_FLAG FROM flow_run_step WHERE run_id = '".SecurityFilter($this->runId)."' AND user_id = '".SecurityFilter($TOK)."'";
				$cursor = exequery($connection,$query);
				if($ROW=@mysql_fetch_array($cursor)) {
					$FLOW_STEP_ID = $ROW["FLOW_STEP_ID"];
					$sqlStepOpFlag = "select max(OP_FLAG) step_op_flag from flow_run_prcs where run_id = '".SecurityFilter($this->runId)."' AND prcs_id = '".SecurityFilter($prcsIdNext)."' AND user_id = '".SecurityFilter($TOK)."'";
					$cursorStepOpFlag = exequery($connection,$sqlStepOpFlag);
					if($rowStepOpFlag = mysql_fetch_array($cursorStepOpFlag)) {
						$flowRunStepOpFlag = $rowStepOpFlag["step_op_flag"];
					} else {
						$flowRunStepOpFlag = $OP_FLAG;
					}
					$query = "UPDATE flow_run_step SET PRCS_ID = '".SecurityFilter($prcsIdNext)."',FLOW_PRCS = '".SecurityFilter($flowPrcs)."',USER_RUN_TYPE = '1',OP_FLAG = '".SecurityFilter($flowRunStepOpFlag)."',PRCS_TIME = NULL,LIMIT_DATE = '".SecurityFilter($limitDate)."' WHERE FLOW_STEP_ID = '".SecurityFilter($FLOW_STEP_ID)."'";
					exequery($connection,$query);
				} else {
					//插入数据
					$query = "INSERT INTO flow_run_step (RUN_ID,USER_ID,PRCS_ID,FLOW_PRCS,USER_RUN_TYPE,OP_FLAG,LIMIT_DATE) VALUES ('".SecurityFilter($this->runId)."','".SecurityFilter($TOK)."','".SecurityFilter($prcsIdNext)."','".SecurityFilter($flowPrcs)."','1','".SecurityFilter($OP_FLAG)."','".SecurityFilter($limitDate)."')";
					exequery($connection,$query);
				}
				//内部消息
				//$SMS_CONTENT = $_lang["flow_flowsmscontent"].$this->runName;
				$smstype     = 7;
				$tablename   = "flow_run";
				$TABLE_ID    = $this->runId;
				$SMS_REMIND  = 1;
				$TABLE_VAR   = "FLOW_ID,RUN_ID,PRCS_ID,FLOW_PRCS,|$this->flowId,$this->runId,$prcsId,$flowPrcs,";
				if($smsContent) {

					sendSms($USER_ID,$TOK,$smsContent,$SMS_REMIND,$smstype,$tablename,$TABLE_ID,$TABLE_VAR,$attid,$attname);
				}
				//手机短信
				if (ifSendMbSms()) {
					if ($mbSmsContent) {
						$newSms = new MobileSms();
						$newSms->SelfSendMore($TOK,$mbSmsContent);
					}
				}
				//内部邮件
				if($emailContent) {
					$email = new email();
					$email->sendEmail($USER_ID,$TOK,$TOK,$_lang['flow_deal_email_remind'],$emailContent,date("Y-m-d H:i:s",time()),'','');
				}
				//有催办时间的，生成催办短信
				if($limitDate)
				{
					$SMS_CONTENT = $_lang["flow_flowsmscontent"].$this->runName.$_lang["flow_urgency_manage"];
					$smstype     = 7;
					$tablename   = "flow_run";
					$TABLE_ID    = $this->runId;
					$SMS_REMIND  = 1;
					$TABLE_VAR   = "FLOW_ID,RUN_ID,PRCS_ID,FLOW_PRCS,|$this->flowId,$this->runId,$prcsId,$flowPrcs,";

					sendSms($USER_ID,$TOK,$SMS_CONTENT,$SMS_REMIND,$smstype,$tablename,$TABLE_ID,$TABLE_VAR,$attid,$attname,$limitDate);
				}
				$TOK = strtok(",");
			}
			//更新flow_run_step
			//TRANSACT_TIME
			$query = "UPDATE flow_run fr,flow_run_step frs SET frs.TRANSACT_TIME = UNIX_TIMESTAMP(fr.TRANSACT_TIME),fr.MAX_PRCS_ID = '".SecurityFilter($prcsIdNext)."' WHERE fr.run_id = frs.run_id AND fr.run_id = '".SecurityFilter($this->runId)."'";
			exequery($connection,$query);
			//关联文档保存到数据库 sm
			if($docId != ''){
				$query_doc = "UPDATE flow_run SET LINK_DOC='".SecurityFilter($docId)."' WHERE RUN_ID = '".SecurityFilter($this->runId)."'";
				exequery($connection, $query_doc);
				//添加共享
				addDocViewPur($docId,$prcsUser,$this->runId);
			}
			//调用独立函数，进行固定抄送
			$this->copyFlowByProcessSet($copyFlowParam);
		}

		if($canEndFlow != '') {
			$canEnd = $this->getCanEndWorkflow($prcsId);
			if($canEnd == '1') {
				$this->turnNext('',$prcsId,$prcsUser,$prcsOpUser,$docId,$oP,$subFlowRunIds,$limitDate,'','','','','','webservice');
			}
		}
	}
	/**
	*流程办是否有出口条件
	*@access public
	*@param  int  $flowPrcs      流程节点
	*@return int  $haveTerm
	*/
	function haveTerm($flowPrcs)
	{
		global $connection;
		$sql = "SELECT COUNT(*) AS cnt FROM flow_term WHERE LEFT(PRC_PRC,INSTR(PRC_PRC,'-'))=".SecurityFilter($flowPrcs)." AND FLOW_ID=".SecurityFilter($this->flowId);
		$rs  = exequery($connection,$sql);
		$row = mysql_fetch_array($rs);
		if($row['cnt'] > 0){
			$haveTerm = 1;
		}
		else
		{
			$haveTerm = 0;
		}
		return $haveTerm;
	}
	/**
	*获取节点说明
	*@access public
	*@param  int  $flowPrcs      流程节点
	*@return str  $nodeDesc
	*/
	function getNodeDesc($flowPrcs)
	{
		global $connection;
		$nodeDescQuery = "SELECT PRCS_DESCRIPT FROM flow_process WHERE FLOW_ID = '".SecurityFilter($this->flowId)."' AND PRCS_ID = '".SecurityFilter($flowPrcs)."' ";
		$nodeDescRs    = exequery($connection,$nodeDescQuery);
		if($nodeDescrows  = mysql_fetch_array($nodeDescRs))
		{
			$nodeDesc = $nodeDescrows["PRCS_DESCRIPT"];
		}
		return $nodeDesc;
	}
	/**
	*获取节点是否可以转发流程
	*@access public
	*@param  int  $flowPrcs      流程节点
	*@return str  $nodeForward
	*/
	function getNodeForward($flowPrcs)
	{
		global $connection;
		$nodeDescQuery = "SELECT PRCS_FORWARD FROM flow_process WHERE FLOW_ID = '".SecurityFilter($this->flowId)."' AND PRCS_ID = '".SecurityFilter($flowPrcs)."' ";
		$nodeDescRs    = exequery($connection,$nodeDescQuery);
		if($nodeDescrows  = mysql_fetch_array($nodeDescRs))
		{
			$nodeForward = $nodeDescrows["PRCS_FORWARD"];
		}
		return $nodeForward;
	}

	/**
	*获取流程流转的节点信息
	*@return
	*
	*/
	function getNodeRunInfo() {
		global $connection;
		$query = "SELECT * FROM flow_run_prcs WHERE RUN_ID='".SecurityFilter($this->runId)."' AND OP_FLAG=1 ORDER BY PRCS_ID DESC";
		$rs   = exequery($connection,$query);
		$prcsIds = array();
		while($row = mysql_fetch_array($rs)) {
			array_push($prcsIds,$row["FLOW_PRCS"]);
		}

		$returnArr = array();
		foreach($prcsIds as $key=>$value) {
			$sql = "SELECT * FROM flow_process WHERE FLOW_ID='".SecurityFilter($this->flowId)."' AND PRCS_ID='".SecurityFilter($value)."' ORDER BY PRCS_ID";
			$res = exequery($connection,$sql);
			if($ROW = mysql_fetch_array($res)) {
				array_push($returnArr,$ROW);
			}
		}
		return $returnArr;
	}

	/**
	*获取节点是否需要会签
	*@access public
	*@param  int  $flowPrcs      流程节点
	*@return str  $nodeForward
	*/
	function isNeedConcourse($flowPrcs)
	{
		global $connection;
		$sql_concourse = "SELECT PRCS_CONCOURSE FROM flow_process WHERE FLOW_ID= '".SecurityFilter($this->flowId)."' AND PRCS_ID = '".SecurityFilter($flowPrcs)."' ";
		$res_concourse = exequery($connection,$sql_concourse);
		$row_concourse = mysql_fetch_array($res_concourse);
		$is_concourse  = $row_concourse['PRCS_CONCOURSE'];
		return $is_concourse;
	}
	/**
	*获取设置动态办理人的方式
	*@access public
	*@param  int  $flowPrcs      流程节点
	*@return str  $PrcsOptype
	*/
	function getPrcsOptype($flowPrcs)
	{
		global $connection;
		$sql        = "SELECT PRCS_OPTYPE FROM flow_process WHERE FLOW_ID = '".SecurityFilter($this->flowId)."' AND PRCS_ID = '".SecurityFilter($flowPrcs)."'";
		$rs         = exequery($connection,$sql);
		$row        = mysql_fetch_array($rs);
		$PrcsOptype = $row['PRCS_OPTYPE'];
		return $PrcsOptype;
	}
	/**
	*子流程是否完成
	*@access public
	*@param  int  $prcsId      流程步骤
	*@param  str  $userId      用户id
	*@return str  $is_finished
	*/
	function haveSubFlowFinished($prcsId,$userId)
	{
		global $connection;
		$sub_run_id_sql  = "SELECT SUB_FLOW_RUN_IDS FROM flow_run_prcs WHERE RUN_ID = '".SecurityFilter($this->runId)."' AND PRCS_ID = '".SecurityFilter($prcsId)."' AND USER_ID ='".SecurityFilter($userId)."' ";
		$sub_run_id_rs   = exequery($connection,$sub_run_id_sql);
		if($sub_run_id_rows = mysql_fetch_array($sub_run_id_rs))
		{
			$sub_run_ids    = $sub_run_id_rows["SUB_FLOW_RUN_IDS"];
		}
		if($sub_run_ids)
		{
			$is_sub_finished = is_workflow_finished($sub_run_ids);
			if($is_sub_finished == "false")
			{
				$is_finished = "false";
			}
			else if($is_sub_finished == "true")
			{
				$is_finished = "true";
			}else if($is_sub_finished == "del")
			{
				//如果子流程被删除返回del
				$is_finished = "del";
			}
		}
		else
		{
			$is_finished = "true";
		}
		return $is_finished;
	}
	/**
	*获取流程的办理人
	*@access public
	*@param  str   $prcsUser        流程定义的办理人范围
	*@param  str   $prcsDept        流程定义的办理人部门范围
	*@param  str   $prcsPriv        流程定义的办理人角色范围
	*@param  str   $prcsAutoGetUser 自动获取办理人的规则
	*@return array $returnArray
	*/
	function autoGetProcessor($prcsUser,$prcsDept,$prcsPriv,$prcsAutoGetUser)
	{
		global $connection;
		//分2个部分:1、设定范围内的人员 2、自动获取规则的人员
		//根据指定范围,生成sql语句的条件
		if($prcsUser||$prcsDept||$prcsPriv)
		{
			$queryStr = " OR (";
			if($prcsUser)
			{
				$prcsUser = "'".str_replace(",","','",$prcsUser)."'";
				$queryStr .= "USER_ID IN(".$prcsUser.")";
			}
			if($prcsDept)
			{
				if(strstr($queryStr,"USER_ID"))
				{
					$queryStr .= " OR DEPT_ID IN(".$prcsDept.")";
				}
				else
				{
					$queryStr .= " DEPT_ID IN(".$prcsDept.")";
				}
			}
			if($prcsPriv)
			{
				if(strstr($queryStr,"USER_ID")||strstr($queryStr,"DEPT_ID"))
				{
					$queryStr .= " OR USER_PRIV IN(".$prcsPriv.")";
				}
				else
				{
					$queryStr .= " USER_PRIV IN(".$prcsPriv.")";
				}
			}
			$queryStr     .= ")";
		}
		//解析自动办理人的规则
		if($prcsAutoGetUser)
		{
			$proRuleArray = explode("|",$prcsAutoGetUser);
			$returnArray  = "";
			$sqlNeedAddDept = true;
			//创建人
			if($proRuleArray[0] == 1)
			{
				//创人人本人
				if($proRuleArray[1] == 1)
				{
					//获取流程创建人本人
					$sql = "SELECT USER_ID,USER_NAME,DEPT_ID FROM user WHERE USER_ID = (SELECT u.USER_ID FROM user as u,flow_run as fr WHERE  RUN_ID = '".SecurityFilter($this->runId)."' AND u.USER_ID = fr.CREATOR)";
				}
				//创建人同一部门的所有人
				else if($proRuleArray[1] == 2)
				{
					//和创建人同一部门的所有人
					$sql = "SELECT USER_ID,USER_NAME,DEPT_ID FROM user WHERE DEPT_ID = (SELECT u.DEPT_ID FROM user AS u,flow_run AS fr WHERE RUN_ID = '".SecurityFilter($this->runId)."' AND u.USER_ID = fr.CREATOR) AND DEPT_ID > 0";
				}
				//创建人同一角色的所有人
				else if($proRuleArray[1] == 3)
				{
					//和创建人同一角色的所有人
					$sql = "SELECT USER_ID,USER_NAME,DEPT_ID FROM user WHERE USER_PRIV = (SELECT u.USER_PRIV FROM user AS u,flow_run AS fr WHERE RUN_ID = '".SecurityFilter($this->runId)."' AND u.USER_ID = fr.CREATOR) AND DEPT_ID > 0";
				}
				//创建人同一部门的某个角色
				else if($proRuleArray[1] == 4)
				{
					//和创建人同一部门的某个角色
					$sql = "SELECT USER_ID,USER_NAME,DEPT_ID FROM user WHERE DEPT_ID = (SELECT u.DEPT_ID FROM user AS u,flow_run AS fr WHERE RUN_ID = '".SecurityFilter($this->runId)."' AND u.USER_ID = fr.CREATOR) AND USER_PRIV = '".SecurityFilter($proRuleArray[2])."' AND DEPT_ID > 0 ";
				}
				//创建人同一角色的某个部门
				else if($proRuleArray[1] == 5)
				{
					//和创建人同一角色的某个部门
					$sql = "SELECT USER_ID,USER_NAME,DEPT_ID FROM user WHERE USER_PRIV = (SELECT u.USER_PRIV FROM user AS u,flow_run AS fr WHERE RUN_ID = '".SecurityFilter($this->runId)."' AND u.USER_ID = fr.CREATOR) AND DEPT_ID = '".SecurityFilter($proRuleArray[2])."' ";
				}
				//上级部门的所有人
				else if($proRuleArray[1] == 11)
				{
					//上级部门的所有人
					$sql = "SELECT USER_ID,USER_NAME,DEPT_ID FROM user WHERE DEPT_ID = (SELECT DEPT_PARENT FROM department WHERE DEPT_ID = (SELECT u.DEPT_ID FROM user AS u,flow_run AS fr WHERE RUN_ID = '".SecurityFilter($this->runId)."' AND u.USER_ID = fr.CREATOR))";
				}
				//上级部门的某个角色
				else if($proRuleArray[1] == 12)
				{
					//上级部门的某个角色
					$sql = "SELECT USER_ID,USER_NAME,DEPT_ID FROM user WHERE DEPT_ID = (SELECT DEPT_PARENT FROM department WHERE DEPT_ID = (SELECT u.DEPT_ID FROM user AS u,flow_run AS fr WHERE RUN_ID = '".SecurityFilter($this->runId)."' AND u.USER_ID = fr.CREATOR)) AND USER_PRIV = '".SecurityFilter($proRuleArray[2])."'";
				}
				//所在部门的根部门的所有人
				else if($proRuleArray[1] == 13)
				{
					$query1 = "SELECT u.DEPT_ID FROM user AS u,flow_run AS fr WHERE RUN_ID = '".SecurityFilter($this->runId)."' AND u.USER_ID = fr.CREATOR";
					$res1   = exequery($connection,$query1);
					$row1   = mysql_fetch_array($res1);
					$first_dept_id = $row1["DEPT_ID"];
					$i=$first_dept_id;
					$end_dept = "";
					do
					{
						$que = "SELECT DEPT_PARENT FROM department WHERE DEPT_ID ='".SecurityFilter($i)."'";
						$ree = exequery($connection,$que);
						$roe = mysql_fetch_array($ree);
						$end_dept = $i;
						$i   = $roe["DEPT_PARENT"];
						if($i=="")
							$i="0";
					}
					while ($i!="0");
					//所在部门的根部门的所有人
					$sql = "SELECT USER_ID,USER_NAME,DEPT_ID FROM user WHERE DEPT_ID = '".SecurityFilter($end_dept)."'";
				}
				//所在部门的根部门的某个角色
				else if($proRuleArray[1] == 14)
				{
					$query1 = "SELECT u.DEPT_ID FROM user AS u,flow_run AS fr WHERE RUN_ID = '".SecurityFilter($this->runId)."' AND u.USER_ID = fr.CREATOR";
					$res1   = exequery($connection,$query1);
					$row1   = mysql_fetch_array($res1);
					$first_dept_id = $row1["DEPT_ID"];
					$i=$first_dept_id;
					$end_dept = "";
					do
					{
						$que = "SELECT DEPT_PARENT FROM department WHERE DEPT_ID ='".SecurityFilter($i)."'";
						$ree = exequery($connection,$que);
						$roe = mysql_fetch_array($ree);
						$end_dept = $i;
						$i   = $roe["DEPT_PARENT"];
						if($i=="")
							$i="0";
					}
					while ($i!="0");
					//所在部门的根部门的某个角色
					$sql = "SELECT USER_ID,USER_NAME,DEPT_ID FROM user WHERE DEPT_ID = '".SecurityFilter($end_dept)."'
							AND USER_PRIV = '".SecurityFilter($proRuleArray[2])."'
							";
				}
				//创建人同一部门的某个权限级别
				else if($proRuleArray[1] == 20)
				{
					$all_prive_arr = explode("@_@",$proRuleArray[2]);
					//选择的权限级别
					$priv_no  = $all_prive_arr["0"];
					//当前权限级别对应的角色号的字符串
					$priv_str = $all_prive_arr["1"];
					$sql = "SELECT USER_ID,USER_NAME,DEPT_ID
								FROM user u,user_priv up
								WHERE u.USER_PRIV = up.USER_PRIV AND up.PRIV_NO = '".SecurityFilter($priv_no)."'
								AND DEPT_ID = (SELECT u.DEPT_ID FROM user AS u,flow_run AS fr WHERE RUN_ID = '".$this->runId."' AND u.USER_ID = fr.CREATOR) AND u.DEPT_ID > 0";
					$sqlNeedAddDept = false;
				}
				//创建人上级部门的某个权限级别
				else if($proRuleArray[1] == 21)
				{
					$all_prive_arr = explode("@_@",$proRuleArray[2]);
					//选择的权限级别
					$priv_no  = $all_prive_arr["0"];
					//当前权限级别对应的角色号的字符串
					$priv_str = $all_prive_arr["1"];
					$sql = "SELECT USER_ID,USER_NAME,DEPT_ID
								FROM user u,user_priv up
								WHERE u.USER_PRIV = up.USER_PRIV AND up.PRIV_NO = '".SecurityFilter($priv_no)."'
								AND DEPT_ID = (SELECT DEPT_PARENT FROM department WHERE DEPT_ID = (SELECT u.DEPT_ID FROM user AS u,flow_run AS fr WHERE RUN_ID = '".SecurityFilter($this->runId)."' AND u.USER_ID = fr.CREATOR)) AND u.DEPT_ID > 0";
					$sqlNeedAddDept = false;
				}
				//创建人所在部门的负责人
				else if($proRuleArray[1] == 24) {
					$sql = "SELECT dd.DIRECTOR_USER_ID USER_ID,u.USER_NAME,dd.DEPT_ID
							FROM department_director dd
							LEFT JOIN USER u ON u.USER_ID = dd.DIRECTOR_USER_ID
							WHERE dd.DEPT_ID = ( SELECT u.DEPT_ID FROM USER AS u,flow_run AS fr WHERE RUN_ID = '".SecurityFilter($this->runId)."' AND u.USER_ID = fr.CREATOR ) AND u.DEPT_ID > 0";
					$sqlNeedAddDept = false;
				}
				//创建人的上级
				else if($proRuleArray[1] == 22) {
					$sql = "SELECT us.SUPERIOR_USER_ID USER_ID,u_s.USER_NAME USER_NAME,u.DEPT_ID
							FROM  user_superior us
							LEFT JOIN USER u ON u.USER_ID = us.USER_ID
							LEFT JOIN USER u_s ON u_s.USER_ID = us.SUPERIOR_USER_ID
							WHERE us.user_id = (SELECT CREATOR FROM flow_run WHERE RUN_ID = '".SecurityFilter($this->runId)."') AND u_s.DEPT_ID > 0";
					$sqlNeedAddDept = false;
				}
			}
			//某个节点主办人
			else if($proRuleArray[0] == 2)
			{
				//某个节点的主办人本人
				if($proRuleArray[2] == 6)
				{
					$sql = "SELECT USER_ID,USER_NAME,DEPT_ID FROM user WHERE USER_ID = (SELECT USER_ID FROM flow_run_prcs WHERE FLOW_PRCS = '".$proRuleArray[1]."' AND RUN_ID = '".SecurityFilter($this->runId)."' AND OP_FLAG ='1' ORDER BY PRCS_ID DESC LIMIT 0,1) AND DEPT_ID >0 ";
				}
				//某个节点的主办人同一部门所有人
				else if($proRuleArray[2] == 7)
				{
					$sql = "SELECT USER_ID,USER_NAME,DEPT_ID FROM user WHERE DEPT_ID = (SELECT u.DEPT_ID FROM user AS u,flow_run_prcs AS frp WHERE u.USER_ID = frp.USER_ID AND FLOW_PRCS = '".$proRuleArray[1]."' AND RUN_ID = '".SecurityFilter($this->runId)."' AND OP_FLAG ='1' ORDER BY PRCS_ID DESC LIMIT 0,1) AND DEPT_ID >0 ";
				}
				//某个节点的主办人同一角色所有人
				else if($proRuleArray[2] == 8)
				{
					$sql = "SELECT USER_ID,USER_NAME,DEPT_ID FROM user WHERE USER_PRIV = (SELECT u.USER_PRIV FROM user AS u,flow_run_prcs AS frp WHERE u.USER_ID = frp.USER_ID AND FLOW_PRCS = '".$proRuleArray[1]."' AND RUN_ID = '".SecurityFilter($this->runId)."' AND OP_FLAG ='1' ORDER BY PRCS_ID DESC LIMIT 0,1) AND DEPT_ID >0 ";
				}
				//某个节点的主办人同一部门的某个角色
				else if($proRuleArray[2] == 9)
				{
					$sql = "SELECT USER_ID,USER_NAME,DEPT_ID FROM user WHERE DEPT_ID = (SELECT u.DEPT_ID FROM user AS u,flow_run_prcs AS frp WHERE u.USER_ID = frp.USER_ID AND FLOW_PRCS = '".$proRuleArray[1]."' AND RUN_ID = '".SecurityFilter($this->runId)."' AND OP_FLAG ='1' ORDER BY PRCS_ID DESC LIMIT 0,1) AND DEPT_ID > 0 AND USER_PRIV = '".SecurityFilter($proRuleArray[3])."'";
				}
				//某个节点的主办人同一角色的某个部门
				else if($proRuleArray[2] == 10)
				{
					$sql = "SELECT USER_ID,USER_NAME,DEPT_ID FROM user WHERE USER_PRIV = (SELECT u.USER_PRIV FROM user AS u,flow_run_prcs AS frp WHERE u.USER_ID = frp.USER_ID AND FLOW_PRCS = '".$proRuleArray[1]."' AND RUN_ID = '".SecurityFilter($this->runId)."' AND OP_FLAG ='1' ORDER BY PRCS_ID DESC LIMIT 0,1) AND DEPT_ID = '".SecurityFilter($proRuleArray[3])."'";
				}
				//上级部门的所有人
				else if($proRuleArray[2] == 15)
				{
					//上级部门的所有人
					$sql = "SELECT USER_ID,USER_NAME,DEPT_ID FROM user WHERE DEPT_ID = (SELECT DEPT_PARENT FROM department WHERE DEPT_ID = (SELECT u.DEPT_ID FROM user AS u,flow_run_prcs AS frp WHERE u.USER_ID = frp.USER_ID AND FLOW_PRCS = '".SecurityFilter($proRuleArray[1])."' AND RUN_ID = '".SecurityFilter($this->runId)."' AND OP_FLAG ='1' ORDER BY PRCS_ID DESC LIMIT 0,1))";
				}
				//上级部门的某个角色
				else if($proRuleArray[2] == 16)
				{
					//上级部门的某个角色
					$sql = "SELECT USER_ID,USER_NAME,DEPT_ID FROM user WHERE DEPT_ID = (SELECT DEPT_PARENT FROM department WHERE DEPT_ID = (SELECT u.DEPT_ID FROM user AS u,flow_run_prcs AS frp WHERE u.USER_ID = frp.USER_ID AND FLOW_PRCS = '".SecurityFilter($proRuleArray[1])."' AND RUN_ID = '".SecurityFilter($this->runId)."' AND OP_FLAG ='1' ORDER BY PRCS_ID DESC LIMIT 0,1)) AND USER_PRIV = '".SecurityFilter($proRuleArray[3])."'";
				}
				//所在部门的根部门的所有人
				else if($proRuleArray[2] == 17)
				{
					$query1 = "SELECT u.DEPT_ID FROM user AS u,flow_run_prcs AS frp WHERE u.USER_ID = frp.USER_ID AND FLOW_PRCS = '".SecurityFilter($proRuleArray[1])."' AND RUN_ID = '".SecurityFilter($this->runId)."' AND OP_FLAG ='1' ORDER BY PRCS_ID DESC LIMIT 0,1";
					$res1   = exequery($connection,$query1);
					$row1   = mysql_fetch_array($res1);
					$first_dept_id = $row1["DEPT_ID"];
					$i=$first_dept_id;
					$end_dept = "";
					do
					{
						$que = "SELECT DEPT_PARENT FROM department WHERE DEPT_ID ='".SecurityFilter($i)."'";
						$ree = exequery($connection,$que);
						$roe = mysql_fetch_array($ree);
						$end_dept = $i;
						$i   = $roe["DEPT_PARENT"];
						if($i=="")
							$i="0";
					}
					while ($i!="0");
					//所在部门的根部门的所有人
					$sql = "SELECT USER_ID,USER_NAME,DEPT_ID FROM user WHERE DEPT_ID = '".SecurityFilter($end_dept)."'";
				}
				//所在部门的根部门的某个角色
				else if($proRuleArray[2] == 18)
				{
					$query1 = "SELECT u.DEPT_ID FROM user AS u,flow_run_prcs AS frp WHERE u.USER_ID = frp.USER_ID AND FLOW_PRCS = '".SecurityFilter($proRuleArray[1])."' AND RUN_ID = '".SecurityFilter($this->runId)."' AND OP_FLAG ='1' ORDER BY PRCS_ID DESC LIMIT 0,1";
					$res1   = exequery($connection,$query1);
					$row1   = mysql_fetch_array($res1);
					$first_dept_id = $row1["DEPT_ID"];
					$i=$first_dept_id;
					$end_dept = "";
					do
					{
						$que = "SELECT DEPT_PARENT FROM department WHERE DEPT_ID ='".SecurityFilter($i)."'";
						$ree = exequery($connection,$que);
						$roe = mysql_fetch_array($ree);
						$end_dept = $i;
						$i   = $roe["DEPT_PARENT"];
						if($i=="")
							$i="0";
					}
					while ($i!="0");
					//所在部门的根部门的某个角色
					$sql = "SELECT USER_ID,USER_NAME,DEPT_ID FROM user WHERE DEPT_ID = '".SecurityFilter($end_dept)."'
							AND USER_PRIV = '".SecurityFilter($proRuleArray[3])."'
							";
				}
				//某个节点的主办人同一部门的某个权限级别
				else if($proRuleArray[2] == 19)
				{
					$all_prive_arr = explode("@_@",$proRuleArray[3]);
					//选择的权限级别
					$priv_no  = $all_prive_arr["0"];
					//当前权限级别对应的角色号的字符串
					$priv_str = $all_prive_arr["1"];
					$sql = "SELECT USER_ID,USER_NAME,DEPT_ID
								FROM user u,user_priv up
								WHERE u.USER_PRIV = up.USER_PRIV AND up.PRIV_NO = '".SecurityFilter($priv_no)."'
								AND DEPT_ID = (SELECT u.DEPT_ID FROM user AS u,flow_run_prcs AS frp WHERE u.USER_ID = frp.USER_ID AND FLOW_PRCS = '".SecurityFilter($proRuleArray[1])."' AND RUN_ID = '".SecurityFilter($this->runId)."' AND OP_FLAG ='1' ORDER BY PRCS_ID DESC LIMIT 0,1) AND DEPT_ID >0";
				}
				//某个节点的主办人上级部门的某个权限级别
				else if($proRuleArray[2] == 23)
				{
					$all_prive_arr = explode("@_@",$proRuleArray[3]);
					//选择的权限级别
					$priv_no  = $all_prive_arr["0"];
					//当前权限级别对应的角色号的字符串
					$priv_str = $all_prive_arr["1"];
					$sql = "SELECT USER_ID,USER_NAME,DEPT_ID
								FROM user u,user_priv up
								WHERE u.USER_PRIV = up.USER_PRIV AND up.PRIV_NO = '".SecurityFilter($priv_no)."'
								AND DEPT_ID = (SELECT DEPT_PARENT FROM department WHERE DEPT_ID = (SELECT u.DEPT_ID FROM user AS u,flow_run_prcs AS frp WHERE u.USER_ID = frp.USER_ID AND FLOW_PRCS = '".SecurityFilter($proRuleArray[1])."' AND RUN_ID = '".SecurityFilter($this->runId)."' AND OP_FLAG ='1' ORDER BY PRCS_ID DESC LIMIT 0,1)) AND DEPT_ID >0";
				}
				//某个节点的主办人所在部门的负责人
				else if($proRuleArray[2] == 26) {
					$sql = "SELECT dd.DIRECTOR_USER_ID USER_ID,u.USER_NAME,dd.DEPT_ID
							FROM department_director dd
							LEFT JOIN USER u ON u.USER_ID = dd.DIRECTOR_USER_ID
							WHERE dd.DEPT_ID = ( SELECT u.DEPT_ID FROM user AS u,flow_run_prcs AS frp WHERE u.USER_ID = frp.USER_ID AND FLOW_PRCS = '".SecurityFilter($proRuleArray[1])."' AND RUN_ID = '".SecurityFilter($this->runId)."' AND OP_FLAG ='1' ORDER BY PRCS_ID DESC LIMIT 0,1 ) AND u.DEPT_ID > 0";
					$sqlNeedAddDept = false;
				}
				//某个节点的主办人的上级
				else if($proRuleArray[2] == 25) {
					$sql = "SELECT us.SUPERIOR_USER_ID USER_ID,u_s.USER_NAME USER_NAME,u.DEPT_ID
							FROM  user_superior us
							LEFT JOIN USER u ON u.USER_ID = us.USER_ID
							LEFT JOIN USER u_s ON u_s.USER_ID = us.SUPERIOR_USER_ID
							WHERE us.user_id = ( SELECT USER_ID FROM flow_run_prcs WHERE FLOW_PRCS = '".SecurityFilter($proRuleArray[1])."' AND RUN_ID = '".SecurityFilter($this->runId)."' AND OP_FLAG ='1' ORDER BY PRCS_ID DESC LIMIT 0,1 ) AND u_s.DEPT_ID > 0";
					$sqlNeedAddDept = false;
				}
			}
			//人力资源
			else if($proRuleArray[0] == 3)
			{
				$sql = "SELECT USER_ID,USER_NAME,DEPT_ID FROM user WHERE DEPT_ID = '".SecurityFilter($proRuleArray[1])."' AND USER_PRIV = '".SecurityFilter($proRuleArray[2])."' ";
			}
			//流程表单里的某个字段的值
			else if($proRuleArray[0] == 4)
			{
				$getUserSql = "SELECT * FROM zzzz_flow_data_".SecurityFilter($this->formId)." WHERE RUN_ID = '".SecurityFilter($this->runId)."'";
				$resGetUser   = exequery($connection,$getUserSql);
				if($rowGetUser   = mysql_fetch_array($resGetUser)) {
					$autoUserStr = $rowGetUser[$proRuleArray[1]];
					//判断为人员选择框
					if(strpos($autoUserStr,",|WV") || strpos($autoUserStr,",|admin")) {
						$autoUserStr = trim(substr($autoUserStr,strpos($autoUserStr,"|")+1),",");
						$autoUserStr = str_replace(",","','",$autoUserStr);
					} else {
						//其余的内容，需要查询数据库
						$userConvert = str_replace(",","','",trim(str_replace("，",",",$autoUserStr)));
						$sqlConvert  = "SELECT USER_ID FROM user WHERE USER_NAME IN ('".SecurityFilter($userConvert)."') AND DEPT_ID>0";
						$resConvert  = exequery($connection,$sqlConvert);
						$autoUserStr = "";
						while($rowConvert   = @mysql_fetch_array($resConvert)) {
							$autoUserStr .= $rowConvert["USER_ID"].",";
						}
						$autoUserStr = str_replace(",","','",trim($autoUserStr,","));
					}
				} else {
					$autoUserStr = "";
				}
				$sql = "SELECT USER_ID,USER_NAME,DEPT_ID FROM user WHERE USER_ID IN ('".SecurityFilter($autoUserStr)."')";
			}
			if($queryStr)
			{
				$sql .= $queryStr;
			}
			if($sqlNeedAddDept)
				$sql.= " AND DEPT_ID > 0 ";
		}
		else
		{
			if($queryStr)
			{
				$sql = "SELECT USER_ID,USER_NAME,DEPT_ID FROM user WHERE 0 ".$queryStr;
				$sql.= " AND DEPT_ID > 0 ";
			}
		}
		// if($sql!="")
		// 	$sql.= " AND DEPT_ID > 0 ";
		$rs  = exequery($connection,$sql);
		$i   = 0 ;
		while($rows = @mysql_fetch_array($rs))
		{
			$returnArray[$i]["userid"]   = $rows["USER_ID"];
			$returnArray[$i]["username"] = $rows["USER_NAME"];
			$returnArray[$i]["deptid"]   = $rows["DEPT_ID"];
			$returnArray[$i]["opflag"]   = 0;
			$i++;
		}
		if($returnArray)
			return $returnArray;
		else
			return array();
	}
	/**
	*判断签办反馈是否被查看过
	*@access public
	*@param  str   $prcsId        流程的当前步骤
	*@param  str   $editTime      签办反馈编辑时间
	*@return bool  $haveReaded
	*/
	function isHaveCheck($prcsId,$editTime)
	{
		global $connection;
		$haveReadSql = "SELECT PRCS_TIME FROM flow_run_prcs WHERE RUN_ID = '".SecurityFilter($this->runId)."' AND PRCS_ID = '".SecurityFilter($prcsId)."' AND USER_ID != '".$_SESSION['LOGIN_USER_ID']."' AND LAST_VISITED_TIME > '".SecurityFilter($editTime)."'";
		$haveReadRs  = exequery($connection,$haveReadSql);
		if($haveReadRows = mysql_fetch_array($haveReadRs))
		{
			$haveReaded = true;
		}
		else
		{
			$haveReaded = false;
		}
		return $haveReaded;
	}
	/**
	*获取此节点是否可以结束流程
	*@access public
	*@param  str $prcsId        流程的当前步骤
	*@return int $canEndWorkflow
	*/
	function getCanEndWorkflow($prcsId)
	{
		global $connection;
		$canEndSql = "SELECT END_WORKFLOW FROM flow_process  WHERE FLOW_ID = '".SecurityFilter($this->flowId)."' AND PRCS_ID = '".SecurityFilter($prcsId)."' ";
		$canEndRs  = exequery($connection,$canEndSql);
		if($canEndRows = mysql_fetch_array($canEndRs))
		{
			$canEndWorkflow = $canEndRows["END_WORKFLOW"];
		}

		return $canEndWorkflow;
	}
	/**
	*监控转交
	*@access public
	*@param  str $flowPrcs        流程节点
	*@param  str $prcsId          流程的当前步骤
	*@param  str $prcsUser        流程节点的经办人
	*@param  str $prcsOpUser      流程节点的主办人
	*@param  str $flowPrcs        流程流转到那个节点
	*@return void
	*@-----------2014-11-24检查，此函数已废弃
	*/
//	function monitorTurnNext($flowPrcs,$prcsId,$prcsUser,$prcsOpUser,$flowPrcs)
//	{
//		global $connection,$_lang;
//		$curTime = date("Y-m-d H:i:s",time());
//		$this->flowRunningInfo();
//		//最后一步,结束流程;或手动接受流程
//		if($flowPrcs == "")
//		{
//			//更新当前步骤的状态,结束流程
//			$sql = "UPDATE flow_run_prcs SET PRCS_FLAG = '4',DELIVER_TIME = '".$curTime."' WHERE RUN_ID = '".$this->runId."' AND PRCS_ID = '".$prcs_id."' ";
//			exequery($connection,$sql);
//			$query = "UPDATE flow_run SET CURRENT_STEP = '0' WHERE RUN_ID = '".$this->runId."'";
//			exequery($connection,$query);
//			//短信通知所有办理人
//			//根据短信提醒规则，生成短信提醒--这里是给流程的所有办理人
//			$SMS_CONTENT = $_lang["flow_flowsmscontent"].$this->runName." ".$_lang["flow_have_finished"];
//			$smstype     = 7;
//			$tablename   = "flow_run";
//			$TABLE_ID    = $this->runId;
//			$SMS_REMIND  = 1;
//			$sms_to_sql  = "SELECT DISTINCT (USER_ID) FROM flow_run_prcs WHERE RUN_ID = '".$this->runId."' ";
//			$sms_to_rs   = exequery($connection,$sms_to_sql);
//			$to_str      = "";
//			while($sms_to_rows = mysql_fetch_array($sms_to_rs))
//			{
//				$to_str .= $sms_to_rows["USER_ID"].",";
//			}
//			$TABLE_VAR   = "FLOW_ID,RUN_ID,PRCS_ID,FLOW_PRCS,|".$this->flowId.",".$this->runId.",$prcsId,$flowPrcs,";
//			sendSms($_SESSION['LOGIN_USER_ID'],$to_str,$SMS_CONTENT,$SMS_REMIND,$smstype,$tablename,$TABLE_ID,$TABLE_VAR);
//			//流程归档
//			$queryRel = "SELECT FLOW_TO_DOC FROM `flow_others`  WHERE FLOW_ID = '".$this->flowId."' ";
//			$res      = exequery($connection,$queryRel);
//			$rowRel   = mysql_fetch_array($res);
//			$FLOW_TO_DOC = $rowRel['FLOW_TO_DOC'];
//			if($FLOW_TO_DOC==1){
//				$flowToDoc = new flowToDoc($this->flowId,$this->runId);
//			}
//		}
//		else
//		{
//			//转交下一步
//			$query = "UPDATE flow_run SET CURRENT_STEP = '".$flowPrcs."' WHERE RUN_ID = '".$this->runId."'";
//   			exequery($connection,$query);
//			$prcsIdNext = $prcsId + 1;
//			$TOK        = strtok($prcsUser,",");
//			while($TOK != "")
//			{
//				if($TOK == $prcsOpUser)
//					$OP_FLAG = 1;
//				else
//					$OP_FLAG = 0;
//				//判断每个办理人是否有委托流程
//				$haveAgent = flowHaveAgent($this->flowId,$TOK);
//				if($haveAgent)
//				{
//					$haveAgentArray = explode("|",$haveAgent);
//					$agentFlowId    = $haveAgentArray[0];
//					$agentUserId    = $haveAgentArray[1];
//					$query = "INSERT INTO flow_run_prcs (RUN_ID,PRCS_ID,USER_ID,PRCS_FLAG,FLOW_PRCS,OP_FLAG,BY_AGENT_ID,FLOW_AGENCY_ID) VALUES ('".$this->runId."','".$prcsIdNext."','".$agentUserId."','1','".$flowPrcs."','".$OP_FLAG."','".$TOK."','".$agentFlowId."')";
//					//给haveAgent增加流程文档权限
//					if(!find_id($prcsUser,$agentUserId))
//					{
//						$prcsUser = $prcsUser.$agentUserId.",";
//					}
//					//流程的短信提醒也转发到代理人那里
//					$TOK = $agentUserId;
//				}
//				else
//				{
//					$query = "INSERT INTO
//							flow_run_prcs(RUN_ID,PRCS_ID,USER_ID,PRCS_FLAG,FLOW_PRCS,OP_FLAG)
//							VALUES ('".$this->runId."','".$prcsIdNext."','".$TOK."','1','".$flowPrcs."','".$OP_FLAG."')";
//					exequery($connection, $query);
//				}
//				//增加文档权限
//				//$DOC_ID要处理一下的，现在没有值
//
//				addDocViewPur($DOC_ID,$prcsUser,$this->runId);
//				//---------- 短信提醒 ----------
//				$SMS_CONTENT = $_lang["flow_flowsmscontent"].$this->runName;;
//				$smstype     = 7;
//				$tablename   = "flow_run";
//				$TABLE_ID    = $this->runId;
//				$SMS_REMIND  = 1;
//				$TABLE_VAR   = "FLOW_ID,RUN_ID,PRCS_ID,FLOW_PRCS,|$this->flowId,$this->runId,$prcsId,$flowPrcs,";
//				sendSms($_SESSION['LOGIN_USER_ID'],$TOK,$SMS_CONTENT,$SMS_REMIND,$smstype,$tablename,$TABLE_ID,$TABLE_VAR);
//				//手机短信 2006-7-6 lxl
//				$mobilect_now = $SMS_CONTENT."--".$_SESSION['LOGIN_USER_NAME'];
//				if (ifSendMbSms()){
//					if ($MOBILE_SMS_REMIND=="1"){
//						$newSms = new MobileSms();
//						$newSms->SelfSendMore($TOK,$mobilect_now);
//					}
//				}
//				$TOK = strtok(",");
//			}
//			exit;
//			//更新此步骤的状态
//			$query   = "UPDATE flow_run_prcs SET DELIVER_TIME='".$curTime."',PRCS_FLAG='3' WHERE RUN_ID = '".$this->runId."' AND PRCS_ID='".$this->prcsId."'";
//			exequery($connection,$query);
//		}
//
//	}
	 /**
	*获取流程节点信息
	*@access public
	*@param  int $flowPrcs    流程节点
	*@return array $rows|array()
	*/
	function getNodeInfo($flow_prcs='')
	{
		global $connection;
		if($flow_prcs)
		{
			$sql = "SELECT * FROM flow_process
					WHERE FLOW_ID = '".SecurityFilter($this->flowId)."'
					AND PRCS_ID = '".SecurityFilter($flow_prcs)."'
					";
		}
		else
		{
			$sql = "SELECT * FROM flow_process
					WHERE FLOW_ID = '".SecurityFilter($this->flowId)."'
					ORDER BY PRCS_ID
					";
		}
		$rs  = exequery($connection,$sql);
		while($row = mysql_fetch_array($rs,MYSQL_ASSOC))
		{
			$row["haveTerm"]       = $this->haveTerm($row["PRCS_ID"]);
			$rows[$row["PRCS_ID"]] = $row ;
		}
		if($rows)
			return $rows;
		else
			return array();
	}

	 /**
	*获取流程某个节点的流向节点
	*@access public
	*@return array $toArray
	*/
	function getPrcsToId(){

	}
	 /**
	*获取流程某个节点的流向节点
	*@access public
	*@return array $toArray
	*/
	function getCurrentNextPrcstoid(){
		global $_lang;
		$node_info  = $this->getNodeInfo();
		$prcs_info  = $this->getPrcsInfo();
		$prcs_count = count($prcs_info);
		if($prcs_count)
		{
			$flow_prcs = $prcs_info[$prcs_count-1]["FLOW_PRCS"];
		}
		else
		{
			die($_lang["flow_has_been_deleted"]);
		}
		$prcsto    = $node_info[$flow_prcs]["PRCS_TO"];
		$prcs_max  = $this->getMaxPrcsId();
		//最后一步
		if($flow_prcs == $prcs_max){
			$toArray[0]["FLOW_PRCS"] = -1;
			$toArray[0]["PRCS_NAME"] = $_lang["wap_flow_finished"];
			$toArray[0]["CHECKED"]   = 1;
			//return $toArray;
		}
		if($prcsto == ""&& $flow_prcs != $prcs_max){
			$prcsto = $flow_prcs+1;
		}

		if($prcsto !="")
		{
			$MY_ARRAY    = explode(",",$prcsto);
			$ARRAY_COUNT = sizeof($MY_ARRAY);
			if($MY_ARRAY[$ARRAY_COUNT-1] == "")
				$ARRAY_COUNT--;
			if($PRCS_TO_CHOOSE == "")
				$PRCS_TO_CHOOSE = 0;
			$isHavePass = 0;
			$n = count($toArray);
			for($I=0;$I<$ARRAY_COUNT;$I++)
			{
				$PRCS_ID_TO  = $MY_ARRAY[$I];
				$exprRunPass = 0;
				$PRC_PRC = $flow_prcs."-".$PRCS_ID_TO;
				if(exprRun($this->flowId,$this->runId,$PRC_PRC)){
					$exprRunPass = 1;
					$isHavePass++;
				}
				$PRCS_NAME = $node_info[$PRCS_ID_TO]["PRCS_NAME"];

				if($exprRunPass == 1){
					$toArray[$n]["FLOW_PRCS"] = $PRCS_ID_TO;
					$toArray[$n]["PRCS_NAME"] = $PRCS_NAME;
					$toArray[$n]["CHECKED"]   = $PRCS_TO_CHOOSE == $I?1:0;
					$n++;
				}
			}
		}
		return $toArray;
	}
	 /**
	*获取流程某个节点最后一次运行的数据
	*@access public
	×@para   int flowPrcs
	*@return array $row
	*/
	function nodeHaveRun($flowPrcs)
	{
		global $connection;
		$sql = "SELECT * FROM flow_run_prcs WHERE RUN_ID= '".SecurityFilter($this->runId)."' AND FLOW_PRCS = '".SecurityFilter($flowPrcs)."' AND OP_FLAG = 1 ORDER BY PRCS_ID DESC LIMIT 0,1";
		$rs  = exequery($connection,$sql);
		$row = mysql_fetch_array($rs);
		if($row)
		{
			return $row;
		}
		else
			return array();
	}
	 /**
	*获取流程的子流程id
	*@access public
	*@return array $totalArray/array()
	*/
	function getSubWorkflow()
	{
		global $connection;
		$sub_workflow_sql = "SELECT SUB_FLOW_RUN_IDS FROM  flow_run_prcs  WHERE RUN_ID = '".SecurityFilter($this->runId)."' ";
		$sub_workflow_rs  = exequery($connection,$sub_workflow_sql);
		$totalArray      = array();
		while($sub_workflow_rows = mysql_fetch_array($sub_workflow_rs))
		{
			if(trim($sub_workflow_rows["SUB_FLOW_RUN_IDS"],","))
			{
				$sub_workflow_rows_array = explode(",",trim($sub_workflow_rows["SUB_FLOW_RUN_IDS"],","));
				$totalArray = array_merge($totalArray,$sub_workflow_rows_array);
			}
		}
		$totalArray = array_unique($totalArray);
		if($totalArray)
			return $totalArray;
		else
			return array();
	}
	/**
	*获取流程是否归档
	*@access public
	×@para   int id 流程的id
	*@return array $CONTENT_ID/FALSE
	*/
	function haveArchive($id)
	{
		global $connection;
		$sql = "SELECT CONTENT_ID FROM file_content WHERE FROM_ID ='".SecurityFilter($id)."' ";
		$rs  = exequery($connection,$sql);
		if($row = mysql_fetch_array($rs))
		{
			return $row["CONTENT_ID"];
		}
		else
			return false;
	}
	/**
	*获取外发页面地址
	*@access public
	*@param  int  $flowPrcs      流程节点
	*@return str  $outsend_url
	*/
	function getOutSend($flowPrcs)
	{
		global $connection;
		$sql        = "SELECT FLOW_OUTSEND FROM flow_process WHERE FLOW_ID = '".SecurityFilter($this->flowId)."' AND PRCS_ID = '".$flowPrcs."'";
		$rs         = exequery($connection,$sql);
		$row        = mysql_fetch_array($rs);
		$outsend_url = $row['FLOW_OUTSEND'];
		return $outsend_url;
	}

	/**
	*@function 根据flowId和runId来修改流水号
	*@param $flowId   流程号
	*@param $runId    流程运行编号
	*@param $runSeq   流水号
	*/
	function updateRunseq($flowId,$runId,$runSeq) {
		global $connection;
		$query = "UPDATE flow_run SET RUN_SEQ='".$runSeq."' WHERE FLOW_ID='".SecurityFilter($flowId)."' AND RUN_ID='".SecurityFilter($runId)."'";
		$rs    = exequery($connection,$query);
		if($rs) {
			return 1;
		}
	}

	/**
	*@function 根据flowId和runId来修改流程标题
	*@param $flowId   流程号
	*@param $runId    流程运行编号
	*@param $runSeq   流程标题
	*/
	function updateRunname($flowId,$runId,$runName) {
		global $connection;
		if(trim($runName) != '') {
			$query = "UPDATE flow_run SET RUN_NAME='".SecurityFilter($runName)."' WHERE FLOW_ID='".SecurityFilter($flowId)."' AND RUN_ID='".SecurityFilter($runId)."'";
			$rs    = exequery($connection,$query);
			if($rs) {
				return 1;
			}
		} else {
			return 2;
		}
	}

	//函数，获取流程所有节点，增加详细的判断，将各个节点的所有办理信息都拼上
	function getDetailFLowProcessForDeal($getParam){
		global $connection;
		$FLOW_ID        = $getParam["FLOW_ID"];
		$RUN_ID         = $getParam["RUN_ID"];
		$PRCS_ID        = $getParam["PRCS_ID"];
		$FLOW_PRCS      = $getParam["FLOW_PRCS"];
		$OP_FLAG        = $getParam["OP_FLAG"];
		$PRCS_TO_CHOOSE = $getParam["PRCS_TO_CHOOSE"];
		$PRCS_MAX       = $getParam["PRCS_MAX"];
		$ASK_FROM       = $getParam["ASK_FROM"];
		//获取所有节点信息
		$nodeInfo = $this->getNodeInfo();
		//获取所有运行步骤
		$flowPrcsInfo = $this->getPrcsInfo();
		// 是否会签
		$is_concourse = $nodeInfo[$FLOW_PRCS]["PRCS_CONCOURSE"];
		// 未办理人员
		$lesser_manage_name = $this->getNeverSignPerson($PRCS_ID);
		$muc                = count($lesser_manage_name);
		//最大节点数
		$maxPrcsNumber = count($nodeInfo);
		//流出节点
		$PRCS_TO = $nodeInfo[$FLOW_PRCS]["PRCS_TO"];
		if($PRCS_TO == "" && $FLOW_PRCS!=$PRCS_MAX)
			$PRCS_TO = $FLOW_PRCS+1;
		$PRCS_TO_ARRAY = explode(",", $PRCS_TO);
		// 计数器
		$counter  = 0;
		//流程所有节点id的数组
		$PRCS_ID_ARRAY = array();
		//流程前进节点id的数组
		$ADVANCE_PRCS_ID_ARRAY = array();
		//流程后退节点id的数组
		$BACK_PRCS_ID_ARRAY = array();
		if($PRCS_TO) {
			// 重组 $nodeInfo ，按照 $PRCS_TO_ARRAY 的顺序排，修复bug
			$nodeInfoSort = "";
			foreach ($PRCS_TO_ARRAY as $key_sort => $value_sort) {
				$nodeInfoSort[$value_sort] = $nodeInfo[$value_sort];
				unset($nodeInfo[$value_sort]);
			}
			$nodeInfo = $nodeInfoSort + $nodeInfo;
		}
		foreach ($nodeInfo as $key => $value) {
			$PRCS_ID_ARRAY[] = $key;
			//自己节点
			if($key == $FLOW_PRCS) {
				$nodeInfo[$key]["MAP_SELF_PRCS"] = 1;
			}
			//首节点
			if($counter == 0)
				$nodeInfo[$key]["MAP_FIRST_PRCS"] = 1;
			//最后节点
			if($counter == $maxPrcsNumber - 1)
				$nodeInfo[$key]["MAP_LAST_PRCS"] = 1;
			//是可以流出的节点
			if(in_array($key, $PRCS_TO_ARRAY)) {
				// 满足出口条件
				if(exprRun($FLOW_ID,$RUN_ID,$FLOW_PRCS."-".$key)) {
					//可以流出标识
					// 如果会签且有未办理人员，不能流出
					if($is_concourse == 1 && $muc > 0)
						$nodeInfo[$key]["MAP_CAN_OUTFLOW"] = 0;
					else
						$nodeInfo[$key]["MAP_CAN_OUTFLOW"] = 1;
					//前进的节点
					if ($key > $FLOW_PRCS) {
						//流出类型为前进
						$nodeInfo[$key]["MAP_OUTFLOW_TYPE"] = "advance";
						//记录id
						$ADVANCE_PRCS_ID_ARRAY[] = $key;
					} else {
						//后退的节点
						//流出类型为后退
						$nodeInfo[$key]["MAP_OUTFLOW_TYPE"] = "back";
						//记录id
						$BACK_PRCS_ID_ARRAY[] = $key;
					}
				}
				//获取出口节点的数组下标
				$PRCS_TO_ARRAY_CHOOSE_KEY = array_search($key,$PRCS_TO_ARRAY);
				$nodeInfo[$key]["PRCS_TO_ARRAY_CHOOSE_KEY"] = $PRCS_TO_ARRAY_CHOOSE_KEY;
			} else {
				//不能流出的节点
				$nodeInfo[$key]["MAP_CAN_OUTFLOW"] = 0;
			}
			$counter ++;
		}
		// 选中的节点的节点id
		$PRCS_TO_CHOOSE_PRCS_ID = "";
		// 如果 $PRCS_TO_CHOOSE 为空的处理
		if($PRCS_TO_CHOOSE == "") {
			// 如果结束
			if($FLOW_PRCS == $PRCS_MAX) {
				$PRCS_TO_CHOOSE_PRCS_ID = $FLOW_PRCS;
			} else {
				// 如果有前进的节点
				if(count($ADVANCE_PRCS_ID_ARRAY)) {
					$PRCS_TO_CHOOSE_PRCS_ID = $ADVANCE_PRCS_ID_ARRAY[0];
				} else if(count($BACK_PRCS_ID_ARRAY)) {
					//如果有后退的节点
					$PRCS_TO_CHOOSE_PRCS_ID = $BACK_PRCS_ID_ARRAY[0];
				} else {
					//都没有
					$PRCS_TO_CHOOSE_PRCS_ID = $PRCS_TO_ARRAY[0];
				}
			}
		} else {
			if($PRCS_TO_CHOOSE == "-1")
				$PRCS_TO_CHOOSE_PRCS_ID = $FLOW_PRCS;
			else
				$PRCS_TO_CHOOSE_PRCS_ID = $PRCS_TO_ARRAY[$PRCS_TO_CHOOSE];
		}
		// 清空选中节点
		if(((count($ADVANCE_PRCS_ID_ARRAY) == 0 && count($BACK_PRCS_ID_ARRAY) == 0) || ($is_concourse == 1 && $muc > 0) ) && $FLOW_PRCS != $PRCS_MAX)
			$PRCS_TO_CHOOSE_PRCS_ID = "";
		if($PRCS_TO_CHOOSE_PRCS_ID) {
			// 选中
			$nodeInfo[$PRCS_TO_CHOOSE_PRCS_ID]["MAP_PRCS_SELECT"] = 1;
			//循环所有节点，遇到自己节点或选中节点，都开始划线，再遇到自己节点或选中节点，划线结束
			//不存储划线节点的首尾节点，只存储中间需要划完整线的节点。
			$runningLineStart      = "";
			foreach ($PRCS_ID_ARRAY as $prcs_key => $prcs_value) {
				if($runningLineStart == "1") {
					// 展示运行流程的线
					$nodeInfo[$prcs_key]["MAP_PRCS_HAVE_RUNNING_LINE"] = 1;
				}
				//选中节点id>当前节点id，前进
				if($PRCS_TO_CHOOSE_PRCS_ID > $FLOW_PRCS) {
					// 划线开始
					if($prcs_key == $FLOW_PRCS) {
						$runningLineStart = "1";
					}
					// 前一个节点，划线结束
					if($prcs_key == $PRCS_TO_CHOOSE_PRCS_ID-1) {
						$runningLineStart = "";
					}
					//当前节点的流出类型，前进
					// $nodeInfo[$FLOW_PRCS]["MAP_OUTFLOW_TYPE"] = "advance";
				} else if($PRCS_TO_CHOOSE_PRCS_ID < $FLOW_PRCS) {
					//选中节点id<当前节点id，退回
					// 划线开始
					if($prcs_key == $PRCS_TO_CHOOSE_PRCS_ID) {
						$runningLineStart = "1";
					}
					// 前一个节点，划线结束
					if($prcs_key == $FLOW_PRCS-1) {
						$runningLineStart = "";
					}
					//当前节点的流出类型，退回
					// $nodeInfo[$FLOW_PRCS]["MAP_OUTFLOW_TYPE"] = "back";
				}
			}
			// 用原来的方式，获取选中节点的办理人信息
			// 前进
			if($PRCS_TO_CHOOSE_PRCS_ID > $FLOW_PRCS) {
				$PRCS_ID_TO          = $PRCS_TO_CHOOSE_PRCS_ID;
				$PRCS_DEFAULT_USER   = "";
				$PRCS_DEFAULT_TYPE   = "";
				$PRCS_DEFAULT_MANAGE = "";
				$tmppid              = "";
				$PRCS_USER           = $nodeInfo[$PRCS_ID_TO]["PRCS_USER"];
				$PRCS_DEPT           = $nodeInfo[$PRCS_ID_TO]["PRCS_DEPT"];
				$PRCS_PRIV           = $nodeInfo[$PRCS_ID_TO]["PRCS_PRIV"];
				$PRCS_OPTYPE         = $nodeInfo[$PRCS_ID_TO]["PRCS_OPTYPE"];
				$PRCS_DEFAULT_USER   = $nodeInfo[$PRCS_ID_TO]["PRCS_DEFAULT_USER"];
				$PRCS_DEFAULT_TYPE   = $nodeInfo[$PRCS_ID_TO]["PRCS_DEFAULT_TYPE"];
				$PRCS_DEFAULT_MANAGE = $nodeInfo[$PRCS_ID_TO]["PRCS_DEFAULT_MANAGE"];
				//判断默认主办人是否离职，离职的话，把默认主办人清空
				if($PRCS_DEFAULT_MANAGE) {
					if(isLeaver($PRCS_DEFAULT_MANAGE))
						$PRCS_DEFAULT_MANAGE = "";
				}
				//增加自动获取办理人
				$PRCS_AUTO_GET_USER  = $nodeInfo[$PRCS_ID_TO]["PRCS_AUTO_GET_USER"];
				//获取指定范围办理人
				$PRCS_USER = trim($PRCS_USER,",");
				$PRCS_DEPT = trim($PRCS_DEPT,",");
				$PRCS_PRIV = trim($PRCS_PRIV,",");
				//前进的流程也可能是操作过的，判断是否被操作过
				//  节点$PRCS_ID_TO的最大已运行步骤
				foreach($flowPrcsInfo as $key=>$val) {
					if($val["FLOW_PRCS"] == $PRCS_ID_TO) {
						if($tmppid < $val["PRCS_ID"])
							$tmppid = $val["PRCS_ID"];
					}
				}
				//节点已经被操作过,取出办理人和主办人
				if($tmppid != "") {
					//已经被操作过的流程，但当当前节点设置默认办理人且不可以修改时，以设置为准
					if($PRCS_DEFAULT_USER != ""&&$PRCS_DEFAULT_TYPE != 1) {
						$defaultUsersInfo = getUserInfo($PRCS_DEFAULT_USER,2);
						$ci   = count($userInThisFlownode);
						//增加了判断，默认办理人是否在自动获取到的办理人员当中，避免人员重复|这次不改动这里
						//1、二选一的方式也不会产生问题，因为使用自动获取时，默认办理人一定为空,这里就不会执行
						//2、使用指定范围和默认办理人时，自动获取为空，userInThisFlownode为空也不影响
						$ctAr = $ci;
						foreach($defaultUsersInfo as $defaultKey=>$defaultVal) {
							$exist = "";
							for($i = 0;$i < $ctAr; $i++) {
								if($userInThisFlownode[$i]["userid"] == $defaultVal['USER_ID']) {
									$exist = 1;
									break;
								}
							}
							if(!$exist) {
								$userInThisFlownode[$ci]['username'] = $defaultVal['USER_NAME'];
								$userInThisFlownode[$ci]['userid']   = $defaultVal['USER_ID'];
								$op_flag_int = ($defaultVal['USER_ID']== $PRCS_DEFAULT_MANAGE)?1:0;
								$userInThisFlownode[$ci]['opflag']   = $op_flag_int;  //是否主办人
								$ci++;
							}
						}
					} else if($PRCS_AUTO_GET_USER) {
						$userInThisFlownode = $this->autoGetProcessor($PRCS_USER,$PRCS_DEPT,$PRCS_PRIV,$PRCS_AUTO_GET_USER);
					} else {
						foreach($flowPrcsInfo as $flowPrcsKey=>$flowPrcsVal) {
							if($flowPrcsVal["PRCS_ID"] == $tmppid) {
								$doneFlowPrcs[] = $flowPrcsVal;
							}
						}
						foreach($doneFlowPrcs as $doneFlowKey=>$doneFlowVal) {
							if($doneFlowVal["OP_FLAG"] == 1) {
								$opFlagUser = $doneFlowVal["USER_ID"];
							}
							$doneUserStr .= $doneFlowVal["USER_ID"].",";
						}
						//2012-02-15 TD 7457,退回流程再次提交，如果当前节点有默认办理人且可以更改，那么此处的主办人依然是设置的那个主办人，而不是上个节点的主办人。dingp
						if($nodeInfo[$PRCS_ID_TO]["PRCS_DEFAULT_MANAGE"]) {
							$opFlagUser = $nodeInfo[$PRCS_ID_TO]["PRCS_DEFAULT_MANAGE"];
						}
						unset($ci);
						$ci = 0;
						$doneUserInfo = getUserInfo($doneUserStr,2);
						foreach($doneUserInfo as $doneUserKey=>$doneUserVal) {
							if($ci == 0) {
								//远古时期留下的，不清楚$rowu是什么。
								$userStr .= $rowu['USER_ID'].",";
								$userInThisFlownode[$ci]['username'] = $doneUserVal['USER_NAME'];
								$userInThisFlownode[$ci]['userid']   = $doneUserVal['USER_ID'];
								//是否主办人
								$op_flag_int = ($doneUserVal['USER_ID']== $opFlagUser)?1:0;
								$userInThisFlownode[$ci]['opflag']   = $op_flag_int;
							}
							for($i = 0;$i < count($userInThisFlownode);$i++) {
								if($userInThisFlownode[$i]["userid"] == $doneUserVal['USER_ID']) {
									if($doneUserVal['USER_ID'] == $opFlagUser)
										$userInThisFlownode[$i]["opflag"] = 1;
									break;
								} else {
									$userStr .= $doneUserVal['USER_ID'].",";
									$userInThisFlownode[$ci]['username'] = $doneUserVal['USER_NAME'];
									$userInThisFlownode[$ci]['userid']   = $doneUserVal['USER_ID'];
									//是否主办人
									$op_flag_int = ($doneUserVal['USER_ID']== $opFlagUser)?1:0;
									$userInThisFlownode[$ci]['opflag']   = $op_flag_int;
								}
							}
							$ci++;
						}
					}
				} else {
					//获取自动选择办理人+设定范围内的办理人
					if($PRCS_AUTO_GET_USER) {
						$userInThisFlownode = $this->autoGetProcessor($PRCS_USER,$PRCS_DEPT,$PRCS_PRIV,$PRCS_AUTO_GET_USER);
					}
					//获取默认办理人
					if($PRCS_DEFAULT_USER != "") {
						$defaultUsersInfo = getUserInfo($PRCS_DEFAULT_USER,2);
						$ci   = count($userInThisFlownode);
						//增加了判断，默认办理人是否在自动获取到的办理人员当中，避免人员重复|这次不改动这里
						//1、二选一的方式也不会产生问题，因为使用自动获取时，默认办理人一定为空,这里就不会执行
						//2、使用指定范围和默认办理人时，自动获取为空，userInThisFlownode为空也不影响
						$ctAr = $ci;
						foreach($defaultUsersInfo as $defaultUserKey=>$defaultUserVal) {
							$exist = "";
							for($i = 0;$i < $ctAr; $i++) {
								if($userInThisFlownode[$i]["userid"] == $defaultUserVal['USER_ID']) {
									$exist = 1;
									break;
								}
							}
							if(!$exist) {
								$userInThisFlownode[$ci]['username'] = $defaultUserVal['USER_NAME'];
								$userInThisFlownode[$ci]['userid']   = $defaultUserVal['USER_ID'];
								$op_flag_int = ($defaultUserVal['USER_ID'] == $PRCS_DEFAULT_MANAGE)?1:0;
								$userInThisFlownode[$ci]['opflag']   = $op_flag_int;//是否主办人
								$ci++;
							}
						}
					}
				}
			} else {
				// 后退
				$PRCS_ID_TO          = $PRCS_TO_CHOOSE_PRCS_ID;
				$PRCS_DEFAULT_USER   = "";
				$PRCS_DEFAULT_TYPE   = "";
				$PRCS_DEFAULT_MANAGE = "";
				$tmppid              = "";
				$PRCS_USER           = $nodeInfo[$PRCS_ID_TO]["PRCS_USER"];
				$PRCS_DEPT           = $nodeInfo[$PRCS_ID_TO]["PRCS_DEPT"];
				$PRCS_PRIV           = $nodeInfo[$PRCS_ID_TO]["PRCS_PRIV"];
				$PRCS_OPTYPE         = $nodeInfo[$PRCS_ID_TO]["PRCS_OPTYPE"];
				$PRCS_DEFAULT_USER   = $nodeInfo[$PRCS_ID_TO]["PRCS_DEFAULT_USER"];
				$PRCS_DEFAULT_TYPE   = $nodeInfo[$PRCS_ID_TO]["PRCS_DEFAULT_TYPE"];
				$PRCS_DEFAULT_MANAGE = $nodeInfo[$PRCS_ID_TO]["PRCS_DEFAULT_MANAGE"];
				//判断默认主办人是否离职，离职的话，把默认主办人清空
				if($PRCS_DEFAULT_MANAGE) {
					if(isLeaver($PRCS_DEFAULT_MANAGE))
						$PRCS_DEFAULT_MANAGE = "";
				}
				//增加自动获取办理人
				$PRCS_AUTO_GET_USER  = $nodeInfo[$PRCS_ID_TO]["PRCS_AUTO_GET_USER"];
				//获取指定范围办理人
				$PRCS_USER = trim($PRCS_USER,",");
				$PRCS_DEPT = trim($PRCS_DEPT,",");
				$PRCS_PRIV = trim($PRCS_PRIV,",");
				//取出当前节点，最后操作的经办人
				//  节点$PRCS_ID_TO的最大已运行步骤
				foreach($flowPrcsInfo as $key=>$val) {
					if($val["FLOW_PRCS"] == $PRCS_ID_TO) {
						if($tmppid < $val["PRCS_ID"])
							$tmppid = $val["PRCS_ID"];
					}
				}
				//退回的节点已经被操作过
				if($tmppid != "") {
					foreach($flowPrcsInfo as $flowPrcsKey=>$flowPrcsVal) {
						if($flowPrcsVal["PRCS_ID"] == $tmppid) {
							$doneFlowPrcs[] = $flowPrcsVal;
						}
					}
					foreach($doneFlowPrcs as $doneFlowKey=>$doneFlowVal) {
						if($doneFlowVal["OP_FLAG"] == 1) {
							$opFlagUser = $doneFlowVal["USER_ID"];
						}
						$doneUserStr .= $doneFlowVal["USER_ID"].",";
					}
					unset($ci);
					$ci = 0;
					$doneUserInfo = getUserInfo($doneUserStr,2);
					foreach($doneUserInfo as $doneUserKey=>$doneUserVal) {
						if($ci == 0) {
							$userStr .= $doneUserVal['USER_ID'].",";
							$userInThisFlownode[$ci]['username'] = $doneUserVal['USER_NAME'];
							$userInThisFlownode[$ci]['userid']   = $doneUserVal['USER_ID'];
							//是否主办人
							$op_flag_int = ($doneUserVal['USER_ID']== $opFlagUser)?1:0;
							$userInThisFlownode[$ci]['opflag']   = $op_flag_int;
						}
						for($i = 0;$i < count($userInThisFlownode);$i++) {
							if($userInThisFlownode[$i]["userid"] == $doneUserVal['USER_ID']) {
								if($doneUserVal['USER_ID'] == $opFlagUser)
									$userInThisFlownode[$i]["opflag"] = 1;
								break;
							} else {
								$userStr .= $doneUserVal['USER_ID'].",";
								$userInThisFlownode[$ci]['username'] = $doneUserVal['USER_NAME'];
								$userInThisFlownode[$ci]['userid']   = $doneUserVal['USER_ID'];
								//是否主办人
								$op_flag_int = ($doneUserVal['USER_ID']== $opFlagUser)?1:0;
								$userInThisFlownode[$ci]['opflag']   = $op_flag_int;
							}
						}
						$ci++;
					}
				} else {
					//退回的节点未操作过
					//获取自动选择办理人
					if($PRCS_AUTO_GET_USER) {
						$userInThisFlownode = $this->autoGetProcessor($PRCS_USER,$PRCS_DEPT,$PRCS_PRIV,$PRCS_AUTO_GET_USER);
					}
					//获取默认办理人
					if($PRCS_DEFAULT_USER != "") {
						$defaultUsersInfo = getUserInfo($PRCS_DEFAULT_USER,2);
						$ci   = count($userInThisFlownode);
						//增加了判断，默认办理人是否在自动获取到的办理人员当中，避免人员重复|这次不改动这里
						//1、二选一的方式也不会产生问题，因为使用自动获取时，默认办理人一定为空,这里就不会执行
						//2、使用指定范围和默认办理人时，自动获取为空，userInThisFlownode为空也不影响
						$ctAr = $ci;
						foreach($defaultUsersInfo as $defaultUserKey=>$defaultUserVal) {
							$exist = "";
							for($i = 0;$i < $ctAr; $i++) {
								if($userInThisFlownode[$i]["userid"] == $defaultUserVal['USER_ID']) {
									$exist = 1;
									break;
								}
							}
							if(!$exist) {
								$userInThisFlownode[$ci]['username'] = $defaultUserVal['USER_NAME'];
								$userInThisFlownode[$ci]['userid']   = $defaultUserVal['USER_ID'];
								$op_flag_int = ($defaultUserVal['USER_ID'] == $PRCS_DEFAULT_MANAGE)?1:0;
								$userInThisFlownode[$ci]['opflag']   = $op_flag_int;//是否主办人
								$ci++;
							}
						}
					}
				}
			}
			// 办理页面的正常数据获取
			if(!$ASK_FROM) {
				// 如果没有设置默认办理人
				if(count($userInThisFlownode) < 1) {
					// 获取当前节点的符合条件的办理人员
					$userInThisFlownode = $this->autoGetProcessor($PRCS_USER,$PRCS_DEPT,$PRCS_PRIV,$PRCS_AUTO_GET_USER);
					// 如果只有一个
					if(count($userInThisFlownode) == 1) {} else {
						$userInThisFlownode = array();
					}
				}
			} else {
				// 来自不选人提交的特殊处理
				$thisNodeAllUser = $this->autoGetProcessor($PRCS_USER,$PRCS_DEPT,$PRCS_PRIV,$PRCS_AUTO_GET_USER);
				$userInThisFlownode = array("userInThisFlownode" => $userInThisFlownode,"thisNodeAllUser" => $thisNodeAllUser);
			}
			// 选中节点的办理人相关信息
			$nodeInfo[$PRCS_TO_CHOOSE_PRCS_ID]["userInThisFlownode"] = $userInThisFlownode;
			// 节点设置的默认办理人
			$nodeInfo[$PRCS_TO_CHOOSE_PRCS_ID]["PRCS_DEFAULT_USER"]  = $PRCS_DEFAULT_USER;
			// 节点设置的默认办理人可否修改；1、可修改，0、不可以修改
			$nodeInfo[$PRCS_TO_CHOOSE_PRCS_ID]["PRCS_DEFAULT_TYPE"]  = $PRCS_DEFAULT_TYPE;
			$nodeInfo[$PRCS_TO_CHOOSE_PRCS_ID]["PRCS_OPTYPE"]        = $PRCS_OPTYPE;
			$nodeInfo[$PRCS_TO_CHOOSE_PRCS_ID]["PRCS_USER"]          = $PRCS_USER;
			$nodeInfo[$PRCS_TO_CHOOSE_PRCS_ID]["PRCS_DEPT"]          = $PRCS_DEPT;
			$nodeInfo[$PRCS_TO_CHOOSE_PRCS_ID]["PRCS_PRIV"]          = $PRCS_PRIV;
			$nodeInfo[$PRCS_TO_CHOOSE_PRCS_ID]["PRCS_AUTO_GET_USER"] = $PRCS_AUTO_GET_USER;
		}
		// file_put_contents("D:1.txt", json_encode($nodeInfo));
		// echo "<pre>";
		// print_r($userInThisFlownode);
		// print_r($BACK_PRCS_ID_ARRAY);
		return $nodeInfo;
	}
	// 不选人提交主函数
	function submitWithoutDialog($param) {
		global $connection,$_lang;
		$queryRel = "SELECT SUBMIT_WITHOUT_DIALOG FROM `flow_others`  WHERE FLOW_ID = '".SecurityFilter($this->flowId)."'";
		$res      = exequery($connection,$queryRel);
		$rowRel   = mysql_fetch_array($res);
		$SUBMIT_WITHOUT_DIALOG = $rowRel['SUBMIT_WITHOUT_DIALOG'];
		if($SUBMIT_WITHOUT_DIALOG != "1") {
			return false;
		}
		$PRCS_ID            = $param["PRCS_ID"];
		$FLOW_PRCS          = $param["FLOW_PRCS"];
		$OP_FLAG            = $param["OP_FLAG"];
		$DOC_ID             = $param["DOC_ID"];
		$USER_PRIV          = $param['USER_PRIV'];
		$nodeInfo           = $this->getNodeInfo();
		$PRCS_MAX           = $this->getMaxPrcsId();
		$pressAddHour       = $nodeInfo[$FLOW_PRCS]["PRESS_ADD_HOUR"];
		$sub_flow_ids       = $nodeInfo[$FLOW_PRCS]["SUB_WORKFLOW_IDS"];
		$flowPrcsInfo       = $this->getPrcsInfo();
		$lesser_manage_name = $this->getNeverSignPerson($PRCS_ID);
		$is_concourse       = $nodeInfo[$FLOW_PRCS]["PRCS_CONCOURSE"];
		$muc                = count($lesser_manage_name);
		// 提交类型判断
		if ($OP_FLAG == 1 && (($is_concourse == 1 && $muc == 0) || $is_concourse != 1)){
			$fvalue = 'turnnext';
		} else{
			$fvalue = 'saveform';
		}
		//获取流程图的数据
		$param["PRCS_TO_CHOOSE"] = "";
		$param["PRCS_MAX"]       = $PRCS_MAX;
		$param["ASK_FROM"]       = "ASK_FROM";
		$detailFLowProcess       = $this->getDetailFLowProcessForDeal($param);
		// 所需变量等获取完成，判断几种必须弹框的情况
		if($OP_FLAG == 1) {
			// 1、如果非结束，且有催促时间默认增加值或子流程，要弹出弹出框
			if($FLOW_PRCS != $PRCS_MAX && $pressAddHour) {
				return false;
			}
			// 2、如果非结束，且有有新建权限的子流程，要弹出弹出框
			if($FLOW_PRCS != $PRCS_MAX && trim($sub_flow_ids)) {
				$haveSubFlow    = "";
				$sub_flow_array = explode(",",trim($sub_flow_ids,","));
				for($i = 0;$i < count($sub_flow_array);$i++) {
					if(prcs_role($sub_flow_array[$i],1)) {
						$haveSubFlow = 1;
						break;
					}
				}
				if($haveSubFlow) {
					return false;
				}
			}
			///3、需要会签，要弹框
			if(/*$OP_FLAG == 1 && */$is_concourse == 1 && $muc > 0) {
				return false;
			}
		}
		// 可流出节点计数器
		$canOutFlowCounter = 0;
		foreach ($detailFLowProcess as $key => $value) {
			//如果有可以流出的节点， $isHavePass = 1
			if($value["MAP_CAN_OUTFLOW"] == 1) {
				$isHavePass = 1;
				$canOutFlowCounter++;
			}
			if($canOutFlowCounter > 1) {
				return false;
			}
			//选中的节点，相关信息处理
			if($value["MAP_PRCS_SELECT"] == 1) {
				$MAP_PRCS_SELECT    = $key;
				$userInThisFlownode = $value["userInThisFlownode"];
				$PRCS_TO_CHOOSE     = $value["PRCS_TO_ARRAY_CHOOSE_KEY"];
				$PRCS_DEFAULT_USER  = $value["PRCS_DEFAULT_USER"];
				$PRCS_DEFAULT_TYPE  = $value["PRCS_DEFAULT_TYPE"];
				$PRCS_OPTYPE        = $value["PRCS_OPTYPE"];
				$PRCS_USER          = $value["PRCS_USER"];
				$PRCS_DEPT          = $value["PRCS_DEPT"];
				$PRCS_PRIV          = $value["PRCS_PRIV"];
				$PRCS_AUTO_GET_USER = $value["PRCS_AUTO_GET_USER"];
				$MAP_OUTFLOW_TYPE   = $value["MAP_OUTFLOW_TYPE"];
			}
			if($canOutFlowCounter != 1) {
				return false;
			}
			$PRCS_TO_ARRAY_CHOOSE_KEY = $value["PRCS_TO_ARRAY_CHOOSE_KEY"];
			//自己
			if($value["MAP_SELF_PRCS"]==1) {
				if($FLOW_PRCS == $PRCS_MAX)
					$PRCS_TO_ARRAY_CHOOSE_KEY = -1;
			}
			// 如果不能出口，且不是自己节点，不展示
			if($value["MAP_CAN_OUTFLOW"] == 1 || ($value["MAP_SELF_PRCS"] == 1 && $FLOW_PRCS == $PRCS_MAX) ) {
				if($value["MAP_SELF_PRCS"] == 1 && $FLOW_PRCS == $PRCS_MAX) {
					// 自己节点，且可以结束,输出"结束流程"
				} else {
					if($value["MAP_OUTFLOW_TYPE"] == "advance") {
					} else if($value["MAP_OUTFLOW_TYPE"] == "back") {
					}
				}
			}
		}
		$flowWillStopFlag = "";
		if($OP_FLAG == "1") {
			// 如果不是结束流程，且有超过一个办理人，要弹出弹框
			if($FLOW_PRCS != $PRCS_MAX) {
				// 全部办理人员
				$thisNodeAllUser    = $userInThisFlownode["thisNodeAllUser"];
				// 默认办理人
				$userInThisFlownode = $userInThisFlownode["userInThisFlownode"];
				// 判断前进/退回
				if($MAP_OUTFLOW_TYPE == "advance") {
					// 智能获取办理人
					if($PRCS_AUTO_GET_USER) {
						if(count($thisNodeAllUser) != 1) {
							return false;
						}
						// 有智能获取办理人的时候，把默认办理人清空，防止下面合并的时候主办人没有
						$userInThisFlownode = array();
					} else {
						// 范围内的办理人
						if(count($thisNodeAllUser) != 1) {
							// 1、如果【定义流程--设置好的--默认办理人】有值，要判断是否弹框
							if($PRCS_DEFAULT_USER) {
								// 如果：默认办理人不可以修改，那么，默认办理人有值，才可以不选人提交
								if($PRCS_DEFAULT_TYPE != 1) {
									if(count($userInThisFlownode) < 1) {
										return false;
									}
								} else {
									// 如果：默认办理人可以修改，那么，要求全部办理人员只有一个，才可以不选人提交
									if(count($thisNodeAllUser) != 1) {
										return false;
									}
								}
							} else {
								// 2、如果【定义流程--设置好的--默认办理人】没值，要弹框
								return false;
							}
						}
					}
				} else if($MAP_OUTFLOW_TYPE == "back") {
					// 退回的情况下，只需要关注 userInThisFlownode
				}
			} else {
				// 结束流程，FLOW_PRCS 传空
				$MAP_PRCS_SELECT = "";
				$flowWillStopFlag = "stop";
				// 如果流程结束的时候，还有可出口节点，说明，最后一个节点，设置了可退回某个节点，要弹出框
				if($isHavePass == 1) {
					return false;
				}
				// 判断是否可以归档，如果可以归档，提交页面要展示归档目录选择框
				$flowNodeInfo = $this->getFlowInfo();
				if($flowNodeInfo["FLOW_TO_DOC"] == 1) {
					return false;
				}
			}
			// 取内部消息配置
			$remindSetArray    = checkReminds("0",$USER_PRIV);
			$sms_select        = $remindSetArray[0];
			$smstel_select     = $remindSetArray[1];
			$email_select      = $remindSetArray[2];
			$sms_modify        = $remindSetArray[3];
			$smstel_modify     = $remindSetArray[4];
			$email_modify      = $remindSetArray[5];
			$SMS_REMIND        = $sms_select == "1" ? 1 : 0;
			$EMAIL_REMIND      = $email_select == "1" ? 1 : 0;
			$MOBILE_SMS_REMIND = $smstel_select == "1" ? 1 : 0;
			$returnSubmitNeedArray = array(
				"f"                 => $fvalue,
				"FLOW_ID"           => $this->flowId,
				"RUN_ID"            => $this->runId,
				"PRCS_ID"           => $PRCS_ID,
				"FLOW_PRCS"         => $MAP_PRCS_SELECT,
				"FLOW_PRCS_UP"      => $FLOW_PRCS,
				"OP_FLAG"           => $OP_FLAG,
				"DOC_ID"            => $DOC_ID,
				"is_concourse"      => $is_concourse,
				"muc"               => $muc,
				"SMS_REMIND"        => $SMS_REMIND,
				"EMAIL_REMIND"      => $EMAIL_REMIND,
				"MOBILE_SMS_REMIND" => $MOBILE_SMS_REMIND
			);
			$remindFlowRunName = $_lang["flow_todoprocess"]."-".$this->runName;
			if($sms_select == "1") {
				$returnSubmitNeedArray["smsct"] = $remindFlowRunName;
			}
			if($email_select == "1") {
				$returnSubmitNeedArray["emailct"] = $remindFlowRunName;
			}
			if($smstel_select == "1") {
				$returnSubmitNeedArray["mobilect"] = $remindFlowRunName;
			}
			if(!$flowWillStopFlag) {
				// 办理人员
				$opUserString = "";
				$userString   = "";
				if(count($userInThisFlownode)) {
					foreach ($userInThisFlownode as $default_key => $default_value) {
						if($default_value["opflag"] == "1") {
							$opUserString .= $default_value["userid"];
						}
						$userString .= $default_value["userid"].",";
					}
				} else {
					foreach ($thisNodeAllUser as $all_user_key => $all_user_value) {
						$opUserString .= $all_user_value["userid"];
						$userString .= $all_user_value["userid"].",";
					}
				}
				if($PRCS_OPTYPE < 1) {
					// 第一种办理方式
					$returnSubmitNeedArray["PRCS_OP_USER"] = $opUserString;
					$returnSubmitNeedArray["PRCS_USER"] = $userString;
				} else {
					// 其他办理方式，放所有办理人，没有主办人
					$returnSubmitNeedArray["PRCS_USER"] = $userString;
				}
			}
			return $returnSubmitNeedArray;
		} else {
			// 把提交要的参数都传出去
			return array(
				"f" => $fvalue,
				"FLOW_ID" => $this->flowId,
				"RUN_ID" => $this->runId,
				"PRCS_ID" => $PRCS_ID,
				"FLOW_PRCS" => $MAP_PRCS_SELECT,
				"FLOW_PRCS_UP" => $FLOW_PRCS,
				"OP_FLAG" => $OP_FLAG,
				"is_concourse" => $is_concourse,
				"muc" => $muc
			);
		}
	}
}
?>
