<?php
/**
* @copyright (C) 2000 - 2011 Weaver Co.Ltd
* @package eoffice6.0
* @name api/list.class.php
* @version 2 
* @author sunxiang
*/

/**
* 这是列表类
* @access public
* @auth  sunxiang
*/
class listItem {
	private $others;
	private $condition;
	private $connection;
	private $type;
	private $limit;
	private $perPage;
	private $start;
	/**
	*构造函数
	*@param  array  $fieldArray 条件字段数组
	*@param  array  $otherArray 其它信息数字
	*@return void
	*/
	function __construct ($fieldArray=array(),$otherArray=array()){
		global $connection;
		$this->connection = $connection;
		$this->fields     = $fieldArray;
		$this->others     = $otherArray;
	}
	/**
	*获取列表
	*@return array $rows|array()
	*/
	function getList()
	{
		switch ($this->others["type"])
		{
			case "recent_create" : 
				$sql = "SELECT fr.*,ft.FLOW_NAME   
						FROM flow_run AS fr 
						LEFT JOIN flow_type AS ft ON(fr.FLOW_ID = ft.FLOW_ID) 
						";
				$condition = $this->serializationCondition($this->fields);
				$sql .= $condition;
				$sql = page($sql,$this->perPage);
				break;
			case "to_do" :
				$sql = "SELECT frp.RUN_ID,frp.PRCS_TIME,MAX(frp.PRCS_ID) AS MAX_PRCS_ID,frp.FLOW_PRCS,frp.PRCS_ID,fr.*,ft.*   
						FROM flow_run_prcs AS frp 
						LEFT JOIN flow_run AS fr ON (frp.RUN_ID = fr.RUN_ID)    
						LEFT JOIN flow_type AS ft ON(fr.FLOW_ID = ft.FLOW_ID)  
						";
				$condition = $this->serializationCondition($this->fields);
				$sql .= $condition;
				//$pageSql = $this->subLimit($sql);
				if($this->perPage&&$this->perPage!="all")
				{
					if($this->start)
						$sql = $sql." LIMIT ".$this->start." , ".$this->perPage;						
					else
						$sql = page($sql,$this->perPage);
				}
				break;
			case "passed" :
				$sql = "SELECT frp.RUN_ID,MAX(frp.PRCS_ID) AS MAX_PRCS_ID,fr.*,ft.*   
						FROM flow_run_prcs AS frp 
						LEFT JOIN flow_run AS fr ON (frp.RUN_ID = fr.RUN_ID)    
						LEFT JOIN flow_type AS ft ON(fr.FLOW_ID = ft.FLOW_ID)  
						";
				$condition = $this->serializationCondition($this->fields);
				$sql .= $condition;
				if($this->start)
				{
					$sql = $sql." LIMIT ".$this->start.",".$this->perPage;				
				}
				else
				{
					$sql = page($sql,$this->perPage);	
				}
				break;
			case "finished" :
				$sql = "SELECT frp.RUN_ID,MAX(frp.PRCS_ID) AS MAX_PRCS_ID,fr.*,ft.*   
						FROM flow_run_prcs AS frp 
						LEFT JOIN flow_run AS fr ON (frp.RUN_ID = fr.RUN_ID)    
						LEFT JOIN flow_type AS ft ON(fr.FLOW_ID = ft.FLOW_ID)  
						";
				$condition = $this->serializationCondition($this->fields);
				$sql .= $condition;
				if($this->start)
				{
					$sql = $sql." LIMIT ".$this->start.",".$this->perPage;		
				}
				else
				{
					$sql = page($sql,$this->perPage);	
				}
				break;
			case "search" :
				$sql = "SELECT frp.RUN_ID,MAX(frp.PRCS_ID) AS MAX_PRCS_ID,fr.*,ft.*   
						FROM flow_run_prcs AS frp 
						LEFT JOIN flow_run AS fr ON (frp.RUN_ID = fr.RUN_ID)    
						LEFT JOIN flow_type AS ft ON(fr.FLOW_ID = ft.FLOW_ID)  
						";
				$condition = $this->serializationCondition($this->fields);
				$sql .= $condition;
				//$pageSql = $this->subLimit($sql);
				$sql = page($sql,$this->perPage);
				break;
			case "my_create" :
				$sql = "SELECT frp.RUN_ID,MAX(frp.PRCS_ID) AS MAX_PRCS_ID,fr.*,ft.*   
						FROM flow_run_prcs AS frp 
						LEFT JOIN flow_run AS fr ON (frp.RUN_ID = fr.RUN_ID)    
						LEFT JOIN flow_type AS ft ON(fr.FLOW_ID = ft.FLOW_ID)  
						";
				$condition = $this->serializationCondition($this->fields);
				$sql .= $condition;
				//$pageSql = $this->subLimit($sql);
				$sql = page($sql,$this->perPage);
				break;
			case "flow_type" :
				$sql = "SELECT ft.FLOW_ID,ft.FLOW_NAME,ft.FLOW_SORT,fs.TITLE 
						FROM flow_type AS ft 
						LEFT JOIN flow_sort AS fs ON(fs.ID = ft.FLOW_SORT)
						";
				$condition = $this->serializationCondition($this->fields);
				$sql .= $condition;
				$sql = page($sql,$this->perPage);
				break;
			case "flow_sort" :
				$sql = "SELECT * FROM flow_sort ";
				$condition = $this->serializationCondition($this->fields);
				$sql .= $condition;
				$sql = page($sql,$this->perPage);
				break;
			case "file_in_sort" :
				$sql = "SELECT fc.*,u.USER_NAME FROM file_content AS fc 
						LEFT JOIN user AS u ON(u.USER_ID = fc.USER_ID) ";
				$condition = $this->serializationCondition($this->fields);
				$sql .= $condition;
				$sql = page($sql,$this->perPage);
				break;
			case "sub_folders" :
				$sql = "SELECT fs.*,fp.* FROM file_sort AS fs LEFT 
						JOIN file_purview AS fp ON (fs.SORT_ID = fp.SORT_ID) ";
				$condition = $this->serializationCondition($this->fields);
				$sql .= $condition;
				$sql = page($sql,$this->perPage);
				break;
			case "to_do_count" : 
				$sql = "SELECT frp.RUN_ID 
						FROM flow_run_prcs frp,flow_run fr,flow_type ft
						";	
				$condition = $this->serializationCondition($this->fields);
				$sql .= $condition;	
				$rs = exequery($this->connection,$sql);
				$amount = mysql_num_rows($rs);			
				return $amount;
				break;
			case "unread_to_do_count" : 
				$sql = "SELECT frp.RUN_ID  
						FROM flow_run_prcs AS frp,flow_run AS fr,flow_type AS ft ";
				$condition = $this->serializationCondition($this->fields);
				$sql .= $condition;
				$rs   = exequery($this->connection,$sql);
				$amount = mysql_num_rows($rs);
				return $amount;
				break;
			default :
				exit("Never assign category type !");
		}
		if($sql)
		{
			$rs = exequery($this->connection,$sql);
			while($row = mysql_fetch_array($rs,MYSQL_ASSOC))
			{
				//获取附件地址
				$row["ATTACHMENT_DIR"] = GetATTACHMENTURL($row["ATTACHMENT_ID"],$row["ATTACHMENT_NAME"]);
				$row["LINK_DOC_NAME"] = $this->GetFlowRelationFile($row["LINK_DOC"]);
				$rows[] = $row;
			}
			if($rows)
				return $rows;
			else
				return array();
		}
	}
	/**
	*获取关联文档名称
	*@param  string  $FileId 文档ID字符串
	*@return string  $FileName 文档名称字符串 
	*/
	public function GetFlowRelationFile($FileId)
	{
		global $connection;
		if ($FileId == "")
		{
			$FileName = "";
		} 
		else
		{
			if(substr($FileId,-1,1)== ",")
			{
				$FileId = substr($FileId, 0, strlen($FileId) - 1);
			}
			$FileId = "'" . str_replace(",", "','", $FileId) . "'";
	
			$sql = "SELECT SUBJECT FROM file_content WHERE CONTENT_ID IN (" . SecurityFilter($FileId) . ")";
			$rs = exequery($connection, $sql);
			$uaccount = 0;
			while ($row = mysql_fetch_array($rs)) {
				$uaccount++;
				$file_name = $row['SUBJECT'];
				$FileName .= $file_name . ",";
			}
		}
		return $FileName;
	}
	
	
	/**
	*序列化条件字段
	*@param  array  $field 条件字段数组
	*@return str    $str 条件字符串 
	*/
	function serializationFields($field = array())
	{
		foreach($field as $key=>$val)
		{
			if($key != "WHERE")
			{
				$str .= ",".$key."='".$val."'";
			}
		}
		if($str)
			$str = trim($str,",");
		return $str;
	}
	/**
	*序列化条件字段
	*@param  array  $field 关键字数组
	*@return str    $str 条件字符串 
	*/
	function serializationCondition($field = array())
	{
		$conditionStr = "";
		if($field["WHERE"])
		{
			$conditionStr = " WHERE ".$this->fields["WHERE"];
		}
		else
		{
			$conditionStr = " WHERE 1 ";
		}
		if($this->fields["GROUPBY"])
		{
			$conditionStr .= " GROUP BY ".$this->fields["GROUPBY"];
		}
		if($this->fields["SORTBY"])
		{
			$conditionStr .= " ORDER BY ".$this->fields["SORTBY"];
		}
		if($this->fields["START"])
		{
			$this->start = $this->fields["START"];
		}
		if($this->fields["LIMIT"])
		{
			$this->perPage = $this->fields["LIMIT"];
			//$conditionStr .= " LIMIT $start , ".$this->fields["LIMIT"];
		}
		else
		{
			$this->perPage = 15;
		}
		
		return $conditionStr;
	}
	//这个函数好像没有意义了
	function subLimit($sql){
		return substr($sql,0,strrpos($sql,"LIMIT"));
	}
	//获取流程数量
	function GetFlowCount($SearchCondition)
	{
		$sql = "SELECT *   
						FROM flow_run_prcs AS frp 
						LEFT JOIN flow_run AS fr ON (frp.RUN_ID = fr.RUN_ID)    
						LEFT JOIN flow_type AS ft ON(fr.FLOW_ID = ft.FLOW_ID) 
						WHERE 1
						";
		$SearchFlowTime = "";
		if($SearchCondition["FlowName"]!="")
		{
			$SearchFlowName = " AND fr.RUN_NAME LIKE '%".SecurityFilter($SearchCondition["FlowName"])."%' ";	
		}
		if($SearchCondition["SearchBeginTime"]!="")
		{
			$SearchFlowTime .= " AND UNIX_TIMESTAMP(fr.CREATE_TIME)>=UNIX_TIMESTAMP('".SecurityFilter($SearchCondition["SearchBeginTime"])."') ";	
		}
		if($SearchCondition["SearchEndTime"]!="")
		{
			$SearchFlowTime .= " AND UNIX_TIMESTAMP(fr.CREATE_TIME)<=UNIX_TIMESTAMP('".SecurityFilter($SearchCondition["SearchEndTime"])."') ";	
		}
		if($SearchCondition["FlowId"]!="")
		{
			$FlowIdCondition = " AND fr.FLOW_ID = '".SecurityFilter($SearchCondition["FlowId"])."' ";	
		}
		else
		{
			$FlowIdCondition = " AND ft.FLOW_TYPE = 1 ";
		}
		switch($SearchCondition["FlowType"])
		{
			case "":
				$sql .= " AND frp.USER_ID='".SecurityFilter($SearchCondition["UserId"])."' AND (((frp.SAVEFORM_TIME IS NULL AND frp.OP_FLAG=0) OR (frp.PRCS_FLAG='2' AND frp.OP_FLAG=1)) OR( frp.PRCS_FLAG = 1)) ".$FlowIdCondition.$SearchFlowName.$SearchFlowTime." GROUP BY frp.RUN_ID";
				break;
			case "to_do":
				$sql .= " AND frp.USER_ID='".SecurityFilter($SearchCondition["UserId"])."' AND (((frp.SAVEFORM_TIME IS NULL AND frp.OP_FLAG=0) OR (frp.PRCS_FLAG='2' AND frp.OP_FLAG=1)) OR( frp.PRCS_FLAG = 1)) ".$FlowIdCondition.$SearchFlowName.$SearchFlowTime." GROUP BY frp.RUN_ID";
				break;
			case "passed":
				$sql .= " AND frp.RUN_ID=fr.RUN_ID AND frp.USER_ID='".SecurityFilter($SearchCondition["UserId"])."' AND fr.CURRENT_STEP<>0
			AND ((frp.OP_FLAG=1 AND frp.DELIVER_TIME<>'NULL') 
				  OR 
				 (frp.OP_FLAG=0 AND frp.SAVEFORM_TIME<>'NULL')) ".$FlowIdCondition.$SearchFlowName.$SearchFlowTime." GROUP BY frp.RUN_ID";
				break;
			case "finished":
				$sql .= " AND fr.CURRENT_STEP = '0' 
			AND frp.USER_ID ='".SecurityFilter($SearchCondition["UserId"])."' AND ((SAVEFORM_TIME IS NOT NULL AND SAVEFORM_TIME <> '0000-00-00 00:00:00' AND OP_FLAG ='0') OR( DELIVER_TIME IS NOT NULL AND DELIVER_TIME <> '0000-00-00 00:00:00' AND OP_FLAG ='1') ) ".$FlowIdCondition.$SearchFlowName.$SearchFlowTime." GROUP BY frp.RUN_ID";
				break;	
		}
		$rs = exequery($this->connection,$sql);
		$FlowCount = mysql_num_rows($rs);
		return $FlowCount;
		
	}
	
	//获取可新建的流程
	function GetMyCreatFlow($UserInfo,$diff="")
	{
		$AllFlow = array();
		$MyFlow  = array();
		$query = "SELECT ft.FLOW_SORT,ft.FLOW_NAME,ft.FLOW_ID,ft.FLOW_TYPE,ft.FORM_ID,ft.FLOW_NOORDER,ft.FLOW_SEQUENCE,ft.CREATE_USER,ft.CREATE_DEPT,ft.CREATE_PRIV,
					ft.FLOW_NAME_PY,ft.FLOW_NAME_ZM,fs.NOORDER,fs.TITLE,fp.PRCS_USER,fp.PRCS_DEPT,fp.PRCS_PRIV 
					FROM
					flow_type ft 
					LEFT JOIN flow_sort fs ON(fs.ID = ft.FLOW_SORT) 
					LEFT JOIN FLOW_PROCESS fp ON(fp.FLOW_ID = ft.FLOW_ID and fp.PRCS_ID=1) WHERE ft.IS_USING=1 ORDER BY fs.NOORDER,ft.FLOW_NOORDER ASC, ft.FLOW_ID ASC";					
		$rs    = exequery($this->connection,$query);
		while($row = mysql_fetch_array($rs))
		{
			$info["FLOW_SORT_ID"]      = $row["FLOW_SORT"];
			$info["FLOW_NAME"]         = $row["FLOW_NAME"];
			$info["FLOW_ID"]           = $row["FLOW_ID"];
			$info["FLOW_TYPE"]         = $row["FLOW_TYPE"];
			$info["FORM_ID"]           = $row["FORM_ID"];
			$info["FLOW_SORT_NOORDER"] = $row["NOORDER"];
			$info["FLOW_SMALL_NOORDER"]= $row["FLOW_NOORDER"];
			$info["FLOW_SORT_TITLE"]   = $row["TITLE"];
			$info["PRCS_USER"]         = $row["PRCS_USER"];
			$info["PRCS_DEPT"]         = $row["PRCS_DEPT"];
			$info["PRCS_PRIV"]         = $row["PRCS_PRIV"];
			$info["CREATE_USER"]       = $row["CREATE_USER"];
			$info["CREATE_DEPT"]       = $row["CREATE_DEPT"];
			$info["CREATE_PRIV"]       = $row["CREATE_PRIV"];
            $info["FLOW_SEQUENCE"]     = $row["FLOW_SEQUENCE"];
			$info["FLOW_NAME_PY"]      = $row["FLOW_NAME_PY"];
			$info["FLOW_NAME_ZM"]      = $row["FLOW_NAME_ZM"];
			array_push($AllFlow,$info);
		}
		if(count($AllFlow) > 0)
		{
			$u_id   = ','.$UserInfo["UserId"].',';
			$d_id   = ','.$UserInfo["DepyId"].',';
			$u_priv = ','.$UserInfo["PrivId"].',';
			foreach($AllFlow as $key=>$val)
			{
				if($val['FLOW_TYPE'] == 1)
				{
					$s_prcs_user = ','.$val['PRCS_USER'];
					$s_prcs_dept = ','.$val['PRCS_DEPT'];
					$s_prcs_priv = ','.$val['PRCS_PRIV'];
					if(strpos($s_prcs_user,$u_id) === false && strpos($s_prcs_dept,$d_id) === false && strpos($s_prcs_priv,$u_priv) === false){
						continue;
					}
				}
				else if($val['FLOW_TYPE'] == 2)
				{
					//自由流程
					if($diff!=""){
						$s_prcs_user = ','.$val['CREATE_USER'];
						$s_prcs_dept = ','.$val['CREATE_DEPT'];
						$s_prcs_priv = ','.$val['CREATE_PRIV'];
						if(strpos($s_prcs_user,$u_id) === false && strpos($s_prcs_dept,$d_id) === false && strpos($s_prcs_priv,$u_priv) === false){
							continue;
						}	
					}else{
						continue;	
					}
				}
				$MyFlow[$key] = $val;
			}
	
		}
		return $MyFlow;
	}
	
}
?>