<?php
/**
 *@Copyright (C) 2010 - 2011 Weaver Co.Ltd
 *@systemname:       E-Office
 *@filename:         api/notify.class.php
 *@function:         公告
 *@encoding:         $_lang['encoding']
 *@author:           www.weaver.com.cn
 *@modify:			 dingp
 *@date:             2011-12-07
 *@file Version:     4.0
 *@eoffice Version:  8.0
*/
class notify{
	var $default_limit = 20;
	var $default_start = 0;
	private $deptid;
	private $uesrpriv;
	private $userid;
	private $curdate;
	
	/*
	@function:  构造函数，通过session判断用户权限
	@parameter: 无
	@return:    无
	*/	
	function __construct($userinfo=array()){
		global $connection;
		if($userinfo["user_id"]=="")
		{
			$this->userid = $_SESSION["LOGIN_USER_ID"];	
		}
		else
		{
			$this->userid = $userinfo["user_id"];		
		}
		if($this->userid){
			$sql = "SELECT DEPT_ID,USER_PRIV FROM user WHERE USER_ID='".SecurityFilter($this->userid)."'";
			$rs  = exequery($connection,$sql);
			$row = mysql_fetch_array($rs);
			$this->deptid = $row["DEPT_ID"];
			$this->uesrpriv = $row["USER_PRIV"];
		}
		$this->curdate = date("Y-m-d",time());
	}
	
	/*
	@function:  更新阅读公告的人员
	@parameter: $notifyid->    int :当前浏览公告的ID号
	@return:    无
	*/
	function updateReadStatus($notifyid){
		global $connection;
		$sql = "SELECT READERS FROM notify WHERE NOTIFY_ID=".SecurityFilter($notifyid);
		$rs = exequery($connection,$sql);
		$row = mysql_fetch_array($rs);
		$READERS = $row["READERS"];
		if(!includeStr($READERS,$this->userid))
		{
			$READERS .= $this->userid.",";
			$sql = "update NOTIFY set READERS='$READERS' where NOTIFY_ID=".SecurityFilter($notifyid);
			exequery($connection,$sql);
		}
	}
	
	/*
	@function:  获取公告总数
	@parameter: 无
	@return:    $amount->  string  :公告总数
	*/	
	function getNotifyAmount($search=array()){
		global $connection;
		$sql = "SELECT COUNT(NOTIFY_ID) AS CNT FROM notify WHERE PUBLIC = '1' AND OPTIONSTATE='1' AND BEGIN_DATE<='".SecurityFilter($this->curdate)."' AND ( END_DATE>='".SecurityFilter($this->curdate)."' OR END_DATE = '0000-00-00') AND( (DEPT_ID = 'ALL_DEPT') OR (INStr(DEPT_ID,',".SecurityFilter($this->deptid).",')>0 OR INStr(DEPT_ID,'".SecurityFilter($this->deptid).",')=1) OR (INStr(PRIV_ID,',".SecurityFilter($this->uesrpriv).",')>0 OR  INStr(PRIV_ID,'".SecurityFilter($this->uesrpriv).",')=1) OR (INStr(USER_ID,',".SecurityFilter($this->userid).",')>0 OR  INStr(USER_ID,'".SecurityFilter($this->userid).",')=1) )";		
		if($search["NotifySubject"]!="")
		{
			$sql .= " AND SUBJECT like '%".SecurityFilter($search["NotifySubject"])."%'";	
		}
		if($search["NotifySort"]!="")
		{
			$sql .= " AND NOTIFY_TYPE_ID='".SecurityFilter($search["NotifySort"])."'";	
		}
		$rs = exequery($connection,$sql);
		$row = mysql_fetch_array($rs);
		$amount = $row["CNT"];
		return $amount;
	}
	
	/*
	@function:  获取最新未读公告数
	@parameter: 无
	@return:    $notify_new_counts->  string  :公告数
	*/
	function getNewNotifyAmount(){
		global $connection;
		$sql = "SELECT COUNT(NOTIFY_ID) AS CNT FROM notify WHERE PUBLIC = '1' AND OPTIONSTATE='1' AND BEGIN_DATE<='".SecurityFilter($this->curdate)."' AND ( END_DATE>='".SecurityFilter($this->curdate)."' OR END_DATE = '0000-00-00') AND( (DEPT_ID = 'ALL_DEPT') OR FROM_ID = '".SecurityFilter($this->userid)."' OR (INStr(DEPT_ID,',".SecurityFilter($this->deptid).",')>0 OR INStr(DEPT_ID,'".SecurityFilter($this->deptid).",')=1) OR (INStr(PRIV_ID,',".SecurityFilter($this->uesrpriv).",')>0 OR  INStr(PRIV_ID,'".SecurityFilter($this->uesrpriv).",')=1) OR (INStr(USER_ID,',".SecurityFilter($this->userid).",')>0 OR  INStr(USER_ID,'".SecurityFilter($this->userid).",')=1)) AND ((INStr(READERS,',".SecurityFilter($this->userid).",')=0 AND  INStr(READERS,'".SecurityFilter($this->userid).",')=0))";
		$rs = exequery($connection,$sql);
		$row = mysql_fetch_array($rs);
		$amount = $row["CNT"];

		return $amount;
	}
	
	/*
	@function:  获取公告信息(webservice)
	@parameter: $limit->               string  :每页显示的条数
				$start->               string  :当前页从第几条开始显示
				$notifyid->            string  :查看或者当前的公告ID
	@return:    $notifyData->          Array  :公告的详细信息
	*/
	function getNotifyInfo($limit=0,$start=0,$notifyid="",$search=array(),$mgrPur=""){
		global $connection;
		$limit = $limit>0?$limit:$this->default_limit;
		$start = $start>0?$start:$this->default_start;
		/*if($notifyid == ""){
			$sql = "SELECT * FROM notify WHERE OPTIONSTATE='1' AND BEGIN_DATE<='".$this->curdate."' AND ( END_DATE>='".$this->curdate."' OR END_DATE = '0000-00-00') AND( (DEPT_ID = 'ALL_DEPT') OR (INStr(DEPT_ID,',".$this->deptid.",')>0 OR INStr(DEPT_ID,'".$this->deptid.",')=1) OR (INStr(PRIV_ID,',".$this->uesrpriv.",')>0 OR  INStr(PRIV_ID,'".$this->uesrpriv.",')=1) OR (INStr(USER_ID,',".$this->userid.",')>0 OR  INStr(USER_ID,'".$this->userid.",')=1) ) ";
		} else {*/
		$sqlPar = $this->returnSqlPar($notifyid);
		$sql = "SELECT DISTINCT(NOTIFY_ID),n.*,u.USER_NAME AS USER_NAME FROM NOTIFY n,USER u WHERE 1 AND n.FROM_ID=u.USER_ID  AND BEGIN_DATE<='".$this->curdate."' AND ( END_DATE>='".SecurityFilter($this->curdate)."' OR END_DATE = '0000-00-00') AND( (n.DEPT_ID = 'ALL_DEPT') OR (INStr(n.DEPT_ID,',".$this->deptid.",')>0 OR INStr(n.DEPT_ID,'".SecurityFilter($this->deptid).",')=1) OR (INStr(PRIV_ID,',".SecurityFilter($this->uesrpriv).",')>0 OR  INStr(PRIV_ID,'".SecurityFilter($this->uesrpriv).",')=1) OR (INStr(n.USER_ID,',".SecurityFilter($this->userid).",')>0 OR  INStr(n.USER_ID,'".SecurityFilter($this->userid).",')=1)  OR n.FROM_ID='".SecurityFilter($this->userid)."')";		
		if($notifyid != '') {
			$sql .= " AND NOTIFY_ID IN(".SecurityFilter($sqlPar).")";
		}
		if($mgrPur == "")
		{
			$sql .= " AND OPTIONSTATE='1' ";
		}

		
		$PUBLIC = $search["NotifyPublic"] != ""?$search["NotifyPublic"]:"1";
		$sql .= " AND PUBLIC='".SecurityFilter($PUBLIC)."'";
		if($search["NotifySubject"]!="")
		{
			$sql .= " AND SUBJECT like '%".SecurityFilter($search["NotifySubject"])."%'";	
		}
		
		if($search["NotifySort"]!="")
		{
			$sql .= " AND n.NOTIFY_TYPE_ID='".SecurityFilter($search["NotifySort"])."'";	
		}	
		
		switch($search["FILTER"]) 
		{
			case "unread":
				$sql .= " AND NOT FIND_IN_SET('".SecurityFilter($search["USER_ID"])."',READERS)";
				break;
            case "read":
				$sql .= " AND FIND_IN_SET('".SecurityFilter($search["USER_ID"])."',READERS)";
				break;
			case "days":
				$sql .= " AND DATE_FORMAT(SEND_TIME,'%Y-%m-%d')>=DATE_SUB(CURDATE(),INTERVAL 3
DAY) AND DATE_FORMAT(SEND_TIME,'%Y-%m-%d')<=CURDATE() ";
				break;
			case "week":
				$sql .= " AND DATE_FORMAT(SEND_TIME,'%Y-%m-%d')>=DATE_SUB(CURDATE(),INTERVAL 6
DAY) AND DATE_FORMAT(SEND_TIME,'%Y-%m-%d')<=CURDATE() ";
				break;
			case "month":
				$sql .= " AND DATE_FORMAT(SEND_TIME,'%Y-%m-%d')>=DATE_SUB(CURDATE(),INTERVAL 30
DAY) AND DATE_FORMAT(SEND_TIME,'%Y-%m-%d')<=CURDATE() ";
				break;
		}
		$res = exequery($connection,$sql);
		$count = mysql_num_rows($res);
		$sql .= " ORDER BY BEGIN_DATE DESC,NOTIFY_ID DESC LIMIT ".SecurityFilter($start).",".SecurityFilter($limit)."";
		$rs = exequery($connection,$sql);
		$i  = $start;
		$read_flag = 0;
		while($row = mysql_fetch_array($rs)){
			$notifyData[$i]['NOTIFY_ID'] = $row['NOTIFY_ID'];
			$notifyData[$i]['FROM_ID']   = $row['FROM_ID'];
			$notifyData[$i]['FROM_NAME'] = $row['USER_NAME'];

			if($notifyData[$i]['FROM_ID']!="")
			{
				$sql_name = "SELECT USER_NAME FROM user 
								WHERE USER_ID='".$notifyData[$i]['FROM_ID']."'";
				$rs_name  = exequery($connection,$sql_name);
				$row_name = mysql_fetch_array($rs_name);
				$notifyData[$i]['FROM_NAME'] = $row_name['USER_NAME'];
			}
			$notifyData[$i]['SUBJECT']    = $row['SUBJECT'];
			$notifyData[$i]['CONTENT']    = $row['CONTENT'];
			$notifyData[$i]['SEND_TIME']  = $row['SEND_TIME'];
			$notifyData[$i]['BEGIN_DATE'] = $row['BEGIN_DATE'];
			$notifyData[$i]['END_DATE']   = $row['END_DATE'];
			$notifyData[$i]['READERS']    = $row['READERS'];

			if(strpos($row['READERS'],$this->userid) == false){
				$read_flag=0;
			} else {
				$read_flag=1;
			}
			$notifyData[$i]['PUBLIC']          = $row['PUBLIC'];
			$notifyData[$i]['READ_FLAG']       = $read_flag;
			$notifyData[$i]['OPTIONSTATE']     = $row['OPTIONSTATE'];
			$notifyData[$i]['ATTACHMENT_ID']   = $row['ATTACHMENT_ID'];
			$notifyData[$i]['ATTACHMENT_NAME'] = $row['ATTACHMENT_NAME'];			
			$notifyData[$i]['NOTIFY_TYPE']     = $row['NOTIFY_TYPE_ID'];
			$notifyData[$i]['PUBLISH_DEPT']    = $row['DEPT_ID'];
			$notifyData[$i]['PUBLISH_PRIV']    = $row['PRIV_ID'];
			$notifyData[$i]['PUBLISH_USER']    = $row['USER_ID'];			
			$notifyData[$i]['ATTACHMENT_DIR']  = "";
			$notifyData[$i]['COUNT']           = $count;
			if($notifyData[$i]['ATTACHMENT_ID']!="")
			{
				$ATTACHMENT_ID_ARRAY   = explode(",",$notifyData[$i]['ATTACHMENT_ID']);
				$ATTACHMENT_NAME_ARRAY = explode("*",$notifyData[$i]['ATTACHMENT_NAME']);
				$ARRAY_COUNT           = sizeof($ATTACHMENT_ID_ARRAY);
				for($j=0; $j<=$ARRAY_COUNT; $j++)
				{
					if($ATTACHMENT_ID_ARRAY[$j]=="")
					break;
					global $ATTACH_PATH,$ROOT_PATH,$rooturl;				
					$PATH     = str_replace($ROOT_PATH,$rooturl,$ATTACH_PATH).$ATTACHMENT_ID_ARRAY[$j];
					$FILENAME = $PATH."/".$ATTACHMENT_NAME_ARRAY[$j];
					$notifyData[$i]['ATTACHMENT_DIR'] .= $FILENAME."*";
				}					
				$notifyData[$i]['ATTACHMENT_DIR'] = substr($notifyData[$i]['ATTACHMENT_DIR'],0,-1);
			}
			$i++;
		}		
		return $notifyData;
	}
	
	/*
	@function:  获取公告类别(webservice)
	@parameter: $TypeId->              int     :类别ID
	@return:    $NotifyType->          Array   :返回公告类别信息
	*/
   public function GetNotifyType($TypeId = "", $columns = array()) {
        global $connection;
        if (empty($columns)) {
            $columnQuery = "*";
        } else {
            foreach ($columns as $k => $v) {
                $columnQuery .= "`$v`,";
            }
            $columnQuery = substr($columnQuery, 0, strrpos($columnQuery, ','));
        }
        if ($TypeId == "") {
            $query = "SELECT $columnQuery FROM notify_type ORDER BY NOTIFY_TYPE_PRO ASC";
        } else {
            $query = "SELECT $columnQuery FROM notify_type WHERE NOTIFY_TYPE_ID='" . SecurityFilter($TypeId) . "'";
        }
        $NotifyType = array();
        $result = exequery($connection, $query);
        if ($result) {
            while ($row = mysql_fetch_assoc($result)) {
                $NotifyType[] = $row;
            }
        }
        return $NotifyType;
    }

    /**
	*@function   根据公告类别获取数量
	*@param     $notifyId
	*/
	public function getCountByType($notifyId) {
		global $connection;
		$query = "SELECT * FROM notify WHERE 1 ";
		if($notifyId != "") {
			$query .= " AND NOTIFY_TYPE_ID='".SecurityFilter($notifyId)."'";
		}
		$res   = exequery($connection,$query);
		$countNums = mysql_num_rows($res);
		
		return $countNums;
	}

	/*
	@function:  公告内容页显示上篇下篇
	@parameter: $notifyid->              int     :当前浏览公告的ID号
				$flag->                  string  :上篇‘pre’或者下篇‘next’
	@return:    $newsData->              Array   :返回公告的ID号和名称
	*/
	function getPreNextNotify($notifyid,$flag="next"){
		global $connection;
		if($notifyid){
			switch ($flag) {
				case "next":
					$sql = "SELECT NOTIFY_ID,SUBJECT FROM notify WHERE PUBLIC = '1' AND BEGIN_DATE<='".SecurityFilter($this->curdate)."' AND ( END_DATE>='".SecurityFilter($this->curdate)."' OR END_DATE = '0000-00-00') AND( (DEPT_ID = 'ALL_DEPT') OR (INStr(DEPT_ID,',".SecurityFilter($this->deptid).",')>0 OR INStr(DEPT_ID,'".SecurityFilter($this->deptid).",')=1) OR (INStr(PRIV_ID,',".SecurityFilter($this->uesrpriv).",')>0 OR  INStr(PRIV_ID,'".SecurityFilter($this->uesrpriv).",')=1) OR (INStr(USER_ID,',".SecurityFilter($this->userid).",')>0 OR  INStr(USER_ID,'".SecurityFilter($this->userid).",')=1) ) AND NOTIFY_ID>".SecurityFilter($notifyid)." ORDER BY BEGIN_DATE DESC,NOTIFY_ID ASC ";
					break;
				case "pre":
					$sql = "SELECT NOTIFY_ID,SUBJECT FROM notify WHERE PUBLIC = '1' AND BEGIN_DATE<='".SecurityFilter($this->curdate)."' AND ( END_DATE>='".SecurityFilter($this->curdate)."' OR END_DATE = '0000-00-00') AND( (DEPT_ID = 'ALL_DEPT') OR (INStr(DEPT_ID,',".SecurityFilter($this->deptid).",')>0 OR INStr(DEPT_ID,'".SecurityFilter($this->deptid).",')=1) OR (INStr(PRIV_ID,',".SecurityFilter($this->uesrpriv).",')>0 OR  INStr(PRIV_ID,'".SecurityFilter($this->uesrpriv).",')=1) OR (INStr(USER_ID,',".$this->userid.",')>0 OR  INStr(USER_ID,'".SecurityFilter($this->userid).",')=1) ) AND NOTIFY_ID<".SecurityFilter($notifyid)." ORDER BY BEGIN_DATE ASC,NOTIFY_ID DESC ";
					break;
			}
			$rs = exequery($connection,$sql);
			$row = mysql_fetch_array($rs);
			$renotifyid = $row["NOTIFY_ID"];
			$resubject = $row["SUBJECT"];
		}
		$newsData["notifyid"] = $renotifyid;
		$newsData["subject"] = $resubject;
		return $newsData;
	}
	
	/*
	@function:  格式化公告ID号
	@parameter: $pars->              string   :需要重新调整的ID号
	@return:    $sqlPar->            string   :返回能够被查询的ID号
	*/
	private function returnSqlPar($pars) {
		$sqlPar = is_array($pars)?implode(",",$pars):$pars;
		if (substr($sqlPar,-1,1) == ","){
			$sqlPar = substr($sqlPar,0,strlen($sqlPar)-1);
		}
		
		$sqlPar = "'".str_replace(",","','",$sqlPar)."'";
		return $sqlPar;
	}
	
	/*
	@function:  公告权限判断
	@parameter: $pars->   string OR arary :需要判断的公告ID号
	@return:    $sqlPar-> string OR array :返回有权限OR有权限的公告ID号
	*/
	function notifyAccessControl($pars)
	{
		global $connection;
		$LOGIN_USER_ID   = $this->userid;
		$LOGIN_DEPT_ID   = $this->deptid;
		$LOGIN_USER_PRIV = $this->uesrpriv;
		$notify_str = array();
		if(!is_array($pars))
			$not_id_str = $pars;
		else
			$not_id_str = join(",",$pars);
		$query = "
		SELECT NOTIFY_ID FROM notify 
			WHERE  NOTIFY_ID in ($not_id_str) 
			AND ( 
				(DEPT_ID = 'ALL_DEPT') 
				OR 
				(INStr(DEPT_ID,',$LOGIN_DEPT_ID,')>0 OR INStr(DEPT_ID,'$LOGIN_DEPT_ID,')=1) 
				OR (INStr(PRIV_ID,',$LOGIN_USER_PRIV,')>0 OR  INStr(PRIV_ID,'$LOGIN_USER_PRIV,')=1) 
				OR (INStr(USER_ID,',$LOGIN_USER_ID,')>0 OR  INStr(USER_ID,'$LOGIN_USER_ID,')=1 OR FIND_IN_SET('$LOGIN_USER_ID',FROM_ID)>0 OR $LOGIN_USER_PRIV = 1) 
				)";
		$result = exequery ( $connection, $query );
		while($row = mysql_fetch_array($result))
		{
			$notify_str[] = $row["NOTIFY_ID"];
		}
		return $notify_str;
	}

	/*
	*@function   获取需要审核的公告
	*@param     notifyId   公告ID
	*@return    notifyInfo 公告信息
	*/
	function getApproveNotify($notifyArr) {
		global $connection;
		$query = "SELECT * FROM notify n,user u WHERE 1 AND n.FROM_ID=u.USER_ID AND PUBLIC='2'";
		if($notifyArr["NOTIFY_ID"] != "") {
			$query .= " AND NOTIFY_ID='".SecurityFilter($notifyArr["NOTIFY_ID"])."'";
		}

		$start = $notifyArr['start']?$notifyArr['start']:0;
		$limit = $notifyArr['limit']?$notifyArr['limit']:20;
		$query .= " ORDER BY NOTIFY_ID DESC";
		$rs    = exequery($connection,$query);
		$nums  = mysql_num_rows($rs);
		if($start>=$nums)
		{
			$start = max(0,$start-$limit);
		}
		$query .= " LIMIT ".SecurityFilter($start).",".SecurityFilter($limit);
		$res   = exequery($connection,$query);
		$notifyInfo = array();
		while($row = mysql_fetch_array($res)) {
			array_push($notifyInfo,$row);
		}
		return array("totalCount"=>$nums,"list"=>$notifyInfo);
	}

	/**
	*@function 公告的审核方法
	*
	*/
	function inspectionNotify($inspectOp,$notifyId) {
		global $connection;
		if($inspectOp == "approve") 
		{
			$query = "UPDATE notify SET PUBLIC='1' WHERE 1 AND NOTIFY_ID='".SecurityFilter($notifyId)."'";
		}
		else 
		{
			$query = "UPDATE notify SET PUBLIC='0' WHERE 1 AND NOTIFY_ID='".SecurityFilter($notifyId)."'";
		}
		exequery($connection,$query);
		return true;
	}

	/**
	*@function 公告删除
	*
	*/
	function notifyDel($notifyId,$batchFlag) {
		global $connection;
		$query = "DELETE FROM notify WHERE 1";
		$query .= $batchFlag==""?" AND NOTIFY_ID='".SecurityFilter($notifyId)."'":" AND NOTIFY_ID IN('".str_replace(",","','",$notifyId)."')";
		exequery($connection,$query);
		return true;
	}

	/**
	*@function 公告状态操作
	*
	*/
	function notifyFlagOpt($notifyId,$notifyFlag) {
		global $connection;
		$flagValue  = $notifyFlag == "setbegin"?"1":"2";
		//获取该公告信息
		$notifyInfo = $this-> getSingleNotify($notifyId);
		$datesql    = $notifyFlag == "setbegin"?",BEGIN_DATE=CURDATE()":",END_DATE=CURDATE()";
		if($notifyFlag == "setbegin" && ($notifyInfo[0]["END_DATE"]!= "") && $notifyInfo[0]["OPTIONSTATE"] != 0)
		{
			//生效后，清除公告结束时间
			$datesql .= ",END_DATE=''";
		}
		$query = "UPDATE notify SET OPTIONSTATE='".SecurityFilter($flagValue)."'".SecurityFilter($datesql)." 
				      WHERE NOTIFY_ID='".SecurityFilter($notifyId)."'";
		exequery($connection,$query);
		return true;
	}

	/**
	*@function 获取公告类别的数组
	*
	*/
	function getNotifyTypeArr() {
		global $connection;
		$query = "SELECT NOTIFY_TYPE_ID,NOTIFY_TYPE_NAME FROM notify_type WHERE 1";
		$res   = exequery($connection,$query);
		while($row = mysql_fetch_array($res)) {
			$notifyTypeArr[$row["NOTIFY_TYPE_ID"]] = $row["NOTIFY_TYPE_NAME"];
		}
		return $notifyTypeArr;
	}

	/**
	*@function 获取单条公告
	*
	*/
	function getSingleNotify($notifyId) {
		global $connection;
		$query = "SELECT * FROM notify WHERE 1 AND NOTIFY_ID='".SecurityFilter($notifyId)."'";
		$res   = exequery($connection,$query);
		$notifyInfo = array();
		if($row = mysql_fetch_array($res)) 
		{
			array_push($notifyInfo,$row);
		}
		return $notifyInfo;
	}

	/*
	@function:  获取公告信息(webservice)
	@parameter: $limit->               string  :每页显示的条数
				$start->               string  :当前页从第几条开始显示
				$notifyid->            string  :查看或者当前的公告ID
	@return:    $notifyData->          Array  :公告的详细信息
	*/
    public function getAllCount($search=array()){
        global $connection;

        $sql = "SELECT count(*) as CNT FROM NOTIFY n WHERE 1 ";

        if($search["USER_ID"] == "admin"){
			if($search["FILTER"] != 'hasExpired') {
				$sql .= "AND ((FROM_ID = 'admin' AND (OPTIONSTATE != 2 OR PUBLIC != 1)) OR (FROM_ID !='admin' AND PUBLIC = 1 AND OPTIONSTATE = 1)) ";
			}else {
				$sql .= "AND ((FROM_ID = 'admin' AND PUBLIC = 1) OR (FROM_ID !='admin' AND PUBLIC = 1)) ";
			}
        }else {
        	$sql .= "AND (
				PUBLIC = 1 
				AND BEGIN_DATE<='" .SecurityFilter($this->curdate) . "' 
				AND (n.DEPT_ID = 'ALL_DEPT' 
		    	    OR (INStr(n.DEPT_ID,'," . SecurityFilter($this->deptid) . ",')>0 
		    	   		OR INStr(n.DEPT_ID,'" . SecurityFilter($this->deptid) . ",')=1) 
				    OR (INStr(PRIV_ID,'," . SecurityFilter($this->uesrpriv) . ",')>0 
				   		OR  INStr(PRIV_ID,'" . SecurityFilter($this->uesrpriv) . ",')=1) 
			        OR (INStr(n.USER_ID,'," . SecurityFilter($this->userid) . ",')>0 
			      		OR  INStr(n.USER_ID,'" . SecurityFilter($this->userid) . ",')=1)
        	) ";

			if($search["FILTER"] != 'hasExpired') {
				$sql .= "AND OPTIONSTATE = 1 ";
				$sql .= $search["USER_ID"] != "" ? "OR (FROM_ID='" . SecurityFilter($search["USER_ID"]) . "' AND (OPTIONSTATE != 2 OR PUBLIC != 1))) " : ") ";
			}else {
				$sql .= $search["USER_ID"] != "" ? "OR (FROM_ID='" . SecurityFilter($search["USER_ID"]) . "' AND OPTIONSTATE = 2 AND PUBLIC = 1)) " : ") ";
			}
        }

        if($search["FILTER"] == 'hasExpired') {
        	$sql .= "AND OPTIONSTATE = 2 ";
        }

        $sql .= $search["NotifyPublic"] != "" ? " AND PUBLIC='" . SecurityFilter($search["NotifyPublic"]) . "'" : "";
        if ($search["NotifySubject"] != "") {
            $sql .= " AND SUBJECT LIKE '%" . SecurityFilter($search["NotifySubject"]) . "%'";
        }

        if ($search["NotifySort"] != "") {
            $sql .= " AND n.NOTIFY_TYPE_ID='" . SecurityFilter($search["NotifySort"]) . "'";
        }

        if ($search["SEARCHDATA"]["SUJECT"] != "") {
            $sql .= " AND SUBJECT LIKE '%" . SecurityFilter($search["SEARCHDATA"]["SUJECT"]) . "%'";
        }
        if ($search["SEARCHDATA"]["FROM_ID"] != "") {
            $query = "SELECT USER_ID FROM user WHERE USER_NAME LIKE '%" . SecurityFilter($search["SEARCHDATA"]["FROM_ID"]) . "%'";
            $res1 = exequery($connection, $query);
            $userIds = '';
            while($row1 = mysql_fetch_array($res1)){
                $userIds .= '\''.$row1['USER_ID'].'\',';
            }
            $userIds  = substr($userIds,0,strrpos($userIds, ','));
            if($userIds){
                $sql .= " AND n.FROM_ID IN(".$userIds.") ";
            }else{
                $sql .= " AND n.FROM_ID IN('')";
            }
        }
        if ($search["SEARCHDATA"]["SEND_TIME"] != "") {
            if (strstr($search["SEARCHDATA"]["SEND_TIME"], "~")) {
                $sendTimeArr = explode("~", $search["SEARCHDATA"]["SEND_TIME"]);
                $sql .= " AND DATE_FORMAT(n.SEND_TIME,'%Y-%c-%e')>='" . SecurityFilter(trim($sendTimeArr[0])) . "' AND DATE_FORMAT(n.SEND_TIME,'%Y-%c-%e')<='" . SecurityFilter(trim($sendTimeArr[1])) . "'";
            } else {
                $sql .= " AND DATE_FORMAT(n.SEND_TIME,'%Y-%c-%e')='" . SecurityFilter($search["SEARCHDATA"]["SEND_TIME"]) . "'";
            }
        }
        if ($search["SEARCHDATA"]["NOTIFY_TYPE_ID"] != "") {
            $sql .= " AND NOTIFY_TYPE_ID='" . SecurityFilter($search["SEARCHDATA"]["NOTIFY_TYPE_ID"]) . "'";
        }
        if ($search["SEARCHDATA"]["NOTIFY_FLAG"] != "") {
            switch ($search["SEARCHDATA"]["NOTIFY_FLAG"]) {
                case "approve":
                    $sql .= " AND PUBLIC='2'";
                    break;
                case "public":
                    $sql .= " AND PUBLIC='1'";
                    break;
                case "draft":
                    $sql .= " AND PUBLIC='0'";
                    break;
            }
        }
        if ($search["SEARCHDATA"]["PUBLIC_TIME"] != "") {
            if (strstr($search["SEARCHDATA"]["PUBLIC_TIME"], "~")) {
                $publicTimeArr = explode("~", $search["SEARCHDATA"]["PUBLIC_TIME"]);
                $sql .= " AND (DATE_FORMAT(n.BEGIN_DATE,'%Y-%c-%e')>='" . SecurityFilter(trim($publicTimeArr[0])) . "' AND (DATE_FORMAT(n.END_DATE,'%Y-%c-%e')<='" . SecurityFilter(trim($publicTimeArr[1])) . "' OR n.END_DATE='0000-00-00'))";
            } else {
                $sql .= " AND DATE_FORMAT(n.BEGIN_DATE,'%Y-%c-%e')='" . SecurityFilter($search["SEARCHDATA"]["PUBLIC_TIME"]) . "'";
            }
        }
        switch ($search["FILTER"]) {
            case "unread":
                $sql .= " AND NOT FIND_IN_SET('" . SecurityFilter($search["USER_ID"]) . "',READERS)";
                break;
            case "read":
                $sql .= " AND FIND_IN_SET('" . SecurityFilter($search["USER_ID"]) . "',READERS)";
                break;
            case "day":
                $sql .= " AND DATE_FORMAT(SEND_TIME,'%Y-%m-%d')>=DATE_SUB(CURDATE(),INTERVAL 3
DAY) AND DATE_FORMAT(SEND_TIME,'%Y-%m-%d')<=CURDATE() ";
                break;
            case "week":
                $sql .= " AND DATE_FORMAT(SEND_TIME,'%Y-%m-%d')>=DATE_SUB(CURDATE(),INTERVAL 6
DAY) AND DATE_FORMAT(SEND_TIME,'%Y-%m-%d')<=CURDATE() ";
                break;
            case "month":
                $sql .= " AND DATE_FORMAT(SEND_TIME,'%Y-%m-%d')>=DATE_SUB(CURDATE(),INTERVAL 30
DAY) AND DATE_FORMAT(SEND_TIME,'%Y-%m-%d')<=CURDATE() ";
                break;
        }
            
        $res = exequery($connection, $sql);
        if ($res) {
            $row = mysql_fetch_array($res);
            return $row['CNT'];
        }
    }
    public function getNotifyLists($limit=0,$start=0,$search=array(),$fieldArray = array()){
        global $connection;
        $limit = $limit > 0 ? $limit : $this->default_limit;
        $start = $start > 0 ? $start : $this->default_start;
        if (empty($fieldArray)) {
            $fieldStr = 'n.*';
        } else {
            $fieldStr = '';
            foreach ($fieldArray as $k => $v) {
                $fieldStr .= 'n.' . strtoupper($v) . ',';
            }
            $fieldStr = substr($fieldStr, 0, strrpos($fieldStr, ','));
        }

        $sql = "SELECT NOTIFY_ID FROM NOTIFY n WHERE 1 ";

        if($search["USER_ID"] == "admin"){
			if($search["FILTER"] != 'hasExpired') {
				$sql .= "AND ((FROM_ID = 'admin' AND (OPTIONSTATE != 2 OR PUBLIC != 1)) OR (FROM_ID !='admin' AND PUBLIC = 1 AND OPTIONSTATE = 1)) ";
			}else {
				$sql .= "AND ((FROM_ID = 'admin' AND PUBLIC = 1) OR (FROM_ID !='admin' AND PUBLIC = 1)) ";
			}
        }else {
        	$sql .= "AND (
				PUBLIC = 1 
				AND BEGIN_DATE<='" . SecurityFilter($this->curdate) . "' 
				AND (n.DEPT_ID = 'ALL_DEPT' 
		    	    OR (INStr(n.DEPT_ID,'," . SecurityFilter($this->deptid) . ",')>0 
		    	   		OR INStr(n.DEPT_ID,'" . SecurityFilter($this->deptid) . ",')=1) 
				    OR (INStr(PRIV_ID,'," . SecurityFilter($this->uesrpriv) . ",')>0 
				   		OR  INStr(PRIV_ID,'" . SecurityFilter($this->uesrpriv) . ",')=1) 
			        OR (INStr(n.USER_ID,'," . SecurityFilter($this->userid) . ",')>0 
			      		OR  INStr(n.USER_ID,'" . SecurityFilter($this->userid) . ",')=1)
        	) ";

			if($search["FILTER"] != 'hasExpired') {
				$sql .= "AND OPTIONSTATE = 1 ";
				$sql .= $search["USER_ID"] != "" ? "OR (FROM_ID='" . SecurityFilter($search["USER_ID"]) . "' AND (OPTIONSTATE != 2 OR PUBLIC != 1))) " : ") ";
			}else {
				$sql .= $search["USER_ID"] != "" ? "OR (FROM_ID='" . SecurityFilter($search["USER_ID"]) . "' AND OPTIONSTATE = 2 AND PUBLIC = 1)) " : ") ";
			}
        }

        if($search["FILTER"] == 'hasExpired') {
        	$sql .= "AND OPTIONSTATE = 2 ";
        }

        $sql .= $search["NotifyPublic"] != "" ? " AND PUBLIC='" . SecurityFilter($search["NotifyPublic"]) . "'" : "";
        if ($search["NotifySubject"] != "") {
            $sql .= " AND SUBJECT LIKE '%" . SecurityFilter($search["NotifySubject"]) . "%'";
        }

        if ($search["NotifySort"] != "") {
            $sql .= " AND n.NOTIFY_TYPE_ID='" . SecurityFilter($search["NotifySort"]) . "'";
        }

        if ($search["SEARCHDATA"]["SUJECT"] != "") {
            $sql .= " AND SUBJECT LIKE '%" . SecurityFilter($search["SEARCHDATA"]["SUJECT"]) . "%'";
        }
        if ($search["SEARCHDATA"]["FROM_ID"] != "") {
            $query = "SELECT USER_ID FROM user WHERE USER_NAME LIKE '%" . SecurityFilter($search["SEARCHDATA"]["FROM_ID"]) . "%'";
            $res1 = exequery($connection, $query);
            $userIds = '';
            while($row1 = mysql_fetch_array($res1)){
                $userIds .= '\''.$row1['USER_ID'].'\',';
            }
            $userIds  = substr($userIds,0,strrpos($userIds, ','));
            $sql .= " AND n.FROM_ID IN(".$userIds.") ";
        }
        if ($search["SEARCHDATA"]["SEND_TIME"] != "") {
            if (strstr($search["SEARCHDATA"]["SEND_TIME"], "~")) {
                $sendTimeArr = explode("~", $search["SEARCHDATA"]["SEND_TIME"]);
                $sql .= " AND DATE_FORMAT(n.SEND_TIME,'%Y-%c-%e')>='" . trim($sendTimeArr[0]) . "' AND DATE_FORMAT(n.SEND_TIME,'%Y-%c-%e')<='" . trim($sendTimeArr[1]) . "'";
            } else {
                $sql .= " AND DATE_FORMAT(n.SEND_TIME,'%Y-%c-%e')='" . SecurityFilter($search["SEARCHDATA"]["SEND_TIME"]) . "'";
            }
        }
        if ($search["SEARCHDATA"]["NOTIFY_TYPE_ID"] != "") {
            $sql .= " AND NOTIFY_TYPE_ID='" . SecurityFilter($search["SEARCHDATA"]["NOTIFY_TYPE_ID"]) . "'";
        }
        if ($search["SEARCHDATA"]["NOTIFY_FLAG"] != "") {
            switch ($search["SEARCHDATA"]["NOTIFY_FLAG"]) {
                case "approve":
                    $sql .= " AND PUBLIC='2'";
                    break;
                case "public":
                    $sql .= " AND PUBLIC='1'";
                    break;
                case "draft":
                    $sql .= " AND PUBLIC='0'";
                    break;
            }
        }
        if ($search["SEARCHDATA"]["PUBLIC_TIME"] != "") {
            if (strstr($search["SEARCHDATA"]["PUBLIC_TIME"], "~")) {
                $publicTimeArr = explode("~", $search["SEARCHDATA"]["PUBLIC_TIME"]);
                $sql .= " AND (DATE_FORMAT(n.BEGIN_DATE,'%Y-%c-%e')>='" . trim($publicTimeArr[0]) . "' AND (DATE_FORMAT(n.END_DATE,'%Y-%c-%e')<='" . trim($publicTimeArr[1]) . "' OR n.END_DATE='0000-00-00'))";
            } else {
                $sql .= " AND DATE_FORMAT(n.BEGIN_DATE,'%Y-%c-%e')='" . SecurityFilter($search["SEARCHDATA"]["PUBLIC_TIME"]) . "'";
            }
        }
        switch ($search["FILTER"]) {
            case "unread":
                $sql .= " AND NOT FIND_IN_SET('" . SecurityFilter($search["USER_ID"]) . "',READERS)";
                break;
            case "read":
                $sql .= " AND FIND_IN_SET('" . SecurityFilter($search["USER_ID"]) . "',READERS)";
                break;
            case "day":
                $sql .= " AND DATE_FORMAT(SEND_TIME,'%Y-%m-%d')>=DATE_SUB(CURDATE(),INTERVAL 3
DAY) AND DATE_FORMAT(SEND_TIME,'%Y-%m-%d')<=CURDATE() ";
                break;
            case "week":
                $sql .= " AND DATE_FORMAT(SEND_TIME,'%Y-%m-%d')>=DATE_SUB(CURDATE(),INTERVAL 6
DAY) AND DATE_FORMAT(SEND_TIME,'%Y-%m-%d')<=CURDATE() ";
                break;
            case "month":
                $sql .= " AND DATE_FORMAT(SEND_TIME,'%Y-%m-%d')>=DATE_SUB(CURDATE(),INTERVAL 30
DAY) AND DATE_FORMAT(SEND_TIME,'%Y-%m-%d')<=CURDATE() ";
                break;
        }

        $orderby = $search["orderby"] != "" ? $search["orderby"] : " SEND_TIME";
        $ordertype = $search["ordertype"] != "" ? $search["ordertype"] : " DESC";
        $sql .= " ORDER BY " . $orderby . " " . $ordertype;
        $sql .= " LIMIT " . $start . "," . $limit . "";
        $rs = exequery($connection, $sql);
            
        if($rs){
            $notifyIds = '';
            while($row = mysql_fetch_array($rs)){
                $notifyIds .= $row['NOTIFY_ID'] . ',';
            }
            $notifyIds  = substr($notifyIds,0,strrpos($notifyIds, ','));
        }
        $notifyData = array();
        if($notifyIds){
            $sql = "SELECT $fieldStr,u.USER_NAME AS USER_NAME FROM NOTIFY n,USER u WHERE 1 
					AND n.FROM_ID=u.USER_ID AND NOTIFY_ID IN(".$notifyIds.") ORDER BY " . SecurityFilter($orderby) . " " . SecurityFilter($ordertype);
            $i = $start;
            $rs = exequery($connection, $sql);
            
            while ($row = mysql_fetch_array($rs)) {
                array_push($notifyData, $row);
                if ($notifyData[$i]['ATTACHMENT_ID'] != "") {
                    $ATTACHMENT_ID_ARRAY = explode(",", $notifyData[$i]['ATTACHMENT_ID']);
                    $ATTACHMENT_NAME_ARRAY = explode("*", $notifyData[$i]['ATTACHMENT_NAME']);
                    $ARRAY_COUNT = sizeof($ATTACHMENT_ID_ARRAY);
                    for ($j = 0; $j <= $ARRAY_COUNT; $j++) {
                        if ($ATTACHMENT_ID_ARRAY[$j] == "")
                            break;
                        global $ATTACH_PATH, $ROOT_PATH, $rooturl;
                        $PATH = str_replace($ROOT_PATH, $rooturl, $ATTACH_PATH) . $ATTACHMENT_ID_ARRAY[$j];
                        $FILENAME = $PATH . "/" . $ATTACHMENT_NAME_ARRAY[$j];
                        $notifyData[$i]['ATTACHMENT_DIR'] .= $FILENAME . "*";
                    }
                    $notifyData[$i]['ATTACHMENT_DIR'] = substr($notifyData[$i]['ATTACHMENT_DIR'], 0, -1);
                }
                $i++;
            }
        }
        return $notifyData;
    }
	function getNotifyInfos($limit=0,$start=0,$notifyid="",$search=array(),$fieldArray = array()){
		global $connection;
		$limit = $limit>0?$limit:$this->default_limit;
		$start = $start>0?$start:$this->default_start;

		$sqlPar = $this->returnSqlPar($notifyid);
        if(empty($fieldArray)){
            $fieldStr = 'n.*';
        }else{
            $fieldStr = '';
            foreach($fieldArray as $k => $v){
                $fieldStr .= 'n.'.strtoupper($v).',';
            }
            $fieldStr  = substr($fieldStr,0,strrpos($fieldStr,','));
        }
		$sql = "SELECT $fieldStr,u.USER_NAME AS USER_NAME FROM NOTIFY n,USER u WHERE 1 
					AND n.FROM_ID=u.USER_ID  
					AND (PUBLIC=1 
							AND BEGIN_DATE<='".SecurityFilter($this->curdate)."' 
							AND ( END_DATE>='".SecurityFilter($this->curdate)."' 
									OR END_DATE = '0000-00-00') 
						    AND OPTIONSTATE=1 
						    AND ( (n.DEPT_ID = 'ALL_DEPT') 
						    		  OR (INStr(n.DEPT_ID,',".SecurityFilter($this->deptid).",')>0 
						    		  OR INStr(n.DEPT_ID,'".SecurityFilter($this->deptid).",')=1) 
								  OR (INStr(PRIV_ID,',".SecurityFilter($this->uesrpriv).",')>0 
								  		  OR  INStr(PRIV_ID,'".SecurityFilter($this->uesrpriv).",')=1) 
							      OR (INStr(n.USER_ID,',".SecurityFilter($this->userid).",')>0 
							      		OR  INStr(n.USER_ID,'".SecurityFilter($this->userid).",')=1))";		

		$sql .= $search["USER_ID"] != ""?" OR (FROM_ID='".SecurityFilter($search["USER_ID"])."'))":")";// AND (PUBLIC=0 OR OPTIONSTATE=2 OR PUBLIC=2 OR BEGIN_DATE>CURDATE())
		if($notifyid != '') {
			$sql .= " AND NOTIFY_ID IN(".$sqlPar.")";
		}
		
		$sql .= $search["NotifyPublic"] != ""?" AND PUBLIC='".SecurityFilter($search["NotifyPublic"])."'":"";
		if($search["NotifySubject"]!="")
		{
			$sql .= " AND SUBJECT LIKE '%".SecurityFilter($search["NotifySubject"])."%'";	
		}
		
		if($search["NotifySort"]!="")
		{
			$sql .= " AND n.NOTIFY_TYPE_ID='".SecurityFilter($search["NotifySort"])."'";	
		}	
		
		if($search["SEARCHDATA"]["SUJECT"] != "")
		{
			$sql .= " AND SUBJECT LIKE '%".SecurityFilter($search["SEARCHDATA"]["SUJECT"])."%'";
		}
		if($search["SEARCHDATA"]["FROM_ID"] != "")
		{
			$sql .= " AND u.USER_NAME LIKE '%".SecurityFilter($search["SEARCHDATA"]["FROM_ID"])."%'";
		}
		if($search["SEARCHDATA"]["SEND_TIME"] != "")
		{
			if(strstr($search["SEARCHDATA"]["SEND_TIME"],"~"))
			{
				$sendTimeArr = explode("~",$search["SEARCHDATA"]["SEND_TIME"]);
				$sql .= " AND DATE_FORMAT(n.SEND_TIME,'%Y-%c-%e')>='".SecurityFilter(trim($sendTimeArr[0]))."' AND DATE_FORMAT(n.SEND_TIME,'%Y-%c-%e')<='".SecurityFilter(trim($sendTimeArr[1]))."'";
			}
			else
			{
				$sql .= " AND DATE_FORMAT(n.SEND_TIME,'%Y-%c-%e')='".SecurityFilter($search["SEARCHDATA"]["SEND_TIME"])."'";
			}
		}
		if($search["SEARCHDATA"]["NOTIFY_TYPE_ID"] != "")
		{
			$sql .= " AND NOTIFY_TYPE_ID='".SecurityFilter($search["SEARCHDATA"]["NOTIFY_TYPE_ID"])."'";
		}
		if($search["SEARCHDATA"]["NOTIFY_FLAG"] != "")
		{
			switch($search["SEARCHDATA"]["NOTIFY_FLAG"])
			{
				case "approve":
					$sql .= " AND PUBLIC='2'";
					break;
				case "public":
					$sql .= " AND PUBLIC='1'";
					break;
				case "draft":
					$sql .= " AND PUBLIC='0'";
					break;
			}
		}
		if($search["SEARCHDATA"]["PUBLIC_TIME"] != "")
		{
			if(strstr($search["SEARCHDATA"]["PUBLIC_TIME"],"~"))
			{
				$publicTimeArr = explode("~",$search["SEARCHDATA"]["PUBLIC_TIME"]);
				$sql .= " AND (DATE_FORMAT(n.BEGIN_DATE,'%Y-%c-%e')>='".SecurityFilter(trim($publicTimeArr[0]))."' AND (DATE_FORMAT(n.END_DATE,'%Y-%c-%e')<='".SecurityFilter(trim($publicTimeArr[1]))."' OR n.END_DATE='0000-00-00'))";
			}
			else
			{
				$sql .= " AND DATE_FORMAT(n.BEGIN_DATE,'%Y-%c-%e')='".SecurityFilter($search["SEARCHDATA"]["PUBLIC_TIME"])."'";
			}
		}
		switch($search["FILTER"]) 
		{
			case "unread":
				$sql .= " AND NOT FIND_IN_SET('".SecurityFilter($search["USER_ID"])."',READERS)";
				break;
            case "read":
				$sql .= " AND FIND_IN_SET('".SecurityFilter($search["USER_ID"])."',READERS)";
				break;
			case "day":
				$sql .= " AND DATE_FORMAT(SEND_TIME,'%Y-%m-%d')>=DATE_SUB(CURDATE(),INTERVAL 3
DAY) AND DATE_FORMAT(SEND_TIME,'%Y-%m-%d')<=CURDATE() ";
				break;
			case "week":
				$sql .= " AND DATE_FORMAT(SEND_TIME,'%Y-%m-%d')>=DATE_SUB(CURDATE(),INTERVAL 6
DAY) AND DATE_FORMAT(SEND_TIME,'%Y-%m-%d')<=CURDATE() ";
				break;
			case "month":
				$sql .= " AND DATE_FORMAT(SEND_TIME,'%Y-%m-%d')>=DATE_SUB(CURDATE(),INTERVAL 30
DAY) AND DATE_FORMAT(SEND_TIME,'%Y-%m-%d')<=CURDATE() ";
				break;
		}
		$res = exequery($connection,$sql);
		$count = mysql_num_rows($res);
		if($start>=$count)
		{
			$start = max(0,$start-$limit);
		}
		$orderby   = $search["orderby"] != ""?$search["orderby"]:" SEND_TIME";
		$ordertype = $search["ordertype"] != ""?$search["ordertype"]:" DESC";
		$sql .= " ORDER BY ".$orderby." ".$ordertype;
		$sql .= " LIMIT ".$start.",".$limit."";	
		$rs = exequery($connection,$sql);
		$i  = $start;
		$read_flag = 0;
		$notifyData = array();
		while($row = mysql_fetch_array($rs)){
			array_push($notifyData,$row);			
			if($notifyData[$i]['ATTACHMENT_ID']!="")
			{
				$ATTACHMENT_ID_ARRAY   = explode(",",$notifyData[$i]['ATTACHMENT_ID']);
				$ATTACHMENT_NAME_ARRAY = explode("*",$notifyData[$i]['ATTACHMENT_NAME']);
				$ARRAY_COUNT           = sizeof($ATTACHMENT_ID_ARRAY);
				for($j=0; $j<=$ARRAY_COUNT; $j++)
				{
					if($ATTACHMENT_ID_ARRAY[$j]=="")
					break;
					global $ATTACH_PATH,$ROOT_PATH,$rooturl;				
					$PATH     = str_replace($ROOT_PATH,$rooturl,$ATTACH_PATH).$ATTACHMENT_ID_ARRAY[$j];
					$FILENAME = $PATH."/".$ATTACHMENT_NAME_ARRAY[$j];
					$notifyData[$i]['ATTACHMENT_DIR'] .= $FILENAME."*";
				}					
				$notifyData[$i]['ATTACHMENT_DIR'] = substr($notifyData[$i]['ATTACHMENT_DIR'],0,-1);
			}
			$i++;
		}		
		return array("totalCount"=>$count,"list"=>$notifyData);
	}


	/**
	*@function 根据类别获取公告数
	*@param    notifyId
	*
	*/
	function getNotifyCount($searchArray)
	{
		global $connection;
		$query = "SELECT COUNT(*) AS CNT FROM NOTIFY WHERE 1 
					  AND ((PUBLIC=1 
						     AND BEGIN_DATE<='".SecurityFilter($this->curdate)."' 
						     AND (END_DATE>='".SecurityFilter($this->curdate)."' 
						           OR END_DATE = '0000-00-00') 
						     AND((DEPT_ID = 'ALL_DEPT') 
						          OR (INStr(DEPT_ID,',".SecurityFilter($this->deptid).",')>0 
						          OR INStr(DEPT_ID,'".SecurityFilter($this->deptid).",')=1) 
						          OR (INStr(PRIV_ID,',".SecurityFilter($this->uesrpriv).",')>0 
						          OR  INStr(PRIV_ID,'".SecurityFilter($this->uesrpriv).",')=1) 
						          OR (INStr(USER_ID,',".SecurityFilter($this->userid).",')>0 
						          OR  INStr(USER_ID,'".SecurityFilter($this->userid).",')=1))) 
						          OR (FROM_ID='".SecurityFilter($searchArray["USER_ID"])."' 
						   ))";//  AND (PUBLIC=0 OR PUBLIC=2 OR BEGIN_DATE>CURDATE())
        
		$query .= $searchArray["NOTIFY_TYPE_ID"] != ""?" AND NOTIFY_TYPE_ID='".SecurityFilter($searchArray["NOTIFY_TYPE_ID"])."'":"";
		$res   = exequery($connection,$query);
		if($row = mysql_fetch_array($res))
		{
			$CNT = $row["CNT"];
			return $CNT;
		}
	}
    public function getAllCountGroupTypeId($userId){
        global $connection;
        
        if($userId == "admin"){
            $query = "SELECT NOTIFY_TYPE_ID,COUNT(*) AS CNT FROM NOTIFY WHERE 1 

					AND (   PUBLIC=1 
							AND BEGIN_DATE<='" . SecurityFilter($this->curdate) . "' 
							AND ( END_DATE>='" . SecurityFilter($this->curdate) . "' 
									OR END_DATE = '0000-00-00') 
						    AND OPTIONSTATE=1 
                            OR ((FROM_ID = 'admin' AND (OPTIONSTATE!=2 OR PUBLIC = 0)) OR (FROM_ID !='admin' and PUBLIC = 1 AND OPTIONSTATE = 1) )
                         ) GROUP BY NOTIFY_TYPE_ID";               
                        
                        
        }else{
            $query = "SELECT NOTIFY_TYPE_ID,COUNT(*) AS CNT FROM NOTIFY WHERE 1 
					  AND ((PUBLIC=1 
                            AND OPTIONSTATE = 1 
                            AND OPTIONSTATE=1
                            AND((DEPT_ID = 'ALL_DEPT') 
                                 OR (INStr(DEPT_ID,',".SecurityFilter($this->deptid).",')>0 
                                 OR INStr(DEPT_ID,'".SecurityFilter($this->deptid).",')=1) 
                                 OR (INStr(PRIV_ID,',".SecurityFilter($this->uesrpriv).",')>0 
                                 OR  INStr(PRIV_ID,'".SecurityFilter($this->uesrpriv).",')=1) 
                                 OR (INStr(USER_ID,',".SecurityFilter($this->userid).",')>0 
                                 OR  INStr(USER_ID,'".SecurityFilter($this->userid).",')=1))) 
                            OR (FROM_ID='".SecurityFilter($userId)."' AND (OPTIONSTATE!=2 OR PUBLIC = 0))
						) GROUP BY NOTIFY_TYPE_ID";
        }
        
		
		$res   = exequery($connection,$query);
        $count = array();
		while($row = @mysql_fetch_array($res,MYSQL_ASSOC))
		{
			$count[$row['NOTIFY_TYPE_ID']] = $row;
		}
        return $count;
    }
	/**
	*@function 自动检查公告并更新公告最新状态
	*
	*/
	function checkNotify()
	{
		global $connection;
        $CUR_DATE = date("Y-m-d",time());
        $query  = 'SELECT USER_ID,DATE FROM notify_check WHERE USER_ID =\''.SecurityFilter($this->userid).'\'';
        $result = exequery($connection,$query);
        $row    = @mysql_fetch_array($result,MYSQL_ASSOC);
        if($row){
            if($row['DATE'] == $CUR_DATE){
                return true;
            }else{
                $query = "UPDATE notify_check SET DATE='$CUR_DATE' WHERE USER_ID='".SecurityFilter($this->userid)."'";
                exequery($connection,$query);
            }
        }else{
            $query = "INSERT INTO notify_check(`USER_ID`,`DATE`) VALUE('".SecurityFilter($this->userid)."','$CUR_DATE')";
            exequery($connection,$query);
        }
        $query1 = 'UPDATE notify SET OPTIONSTATE = 0 WHERE BEGIN_DATE > \''.SecurityFilter($CUR_DATE).'\' AND OPTIONSTATE != 0';//更新开始时间小于当前时间的
        $query2 = "UPDATE notify SET OPTIONSTATE = 1 WHERE BEGIN_DATE <= '$CUR_DATE' AND ((END_DATE='0000-00-00' AND OPTIONSTATE !=1) OR (END_DATE >= '$CUR_DATE' AND OPTIONSTATE = 0))";
        $query4 = "UPDATE notify SET OPTIONSTATE = 2 WHERE BEGIN_DATE <= '$CUR_DATE' AND END_DATE != '0000-00-00' AND END_DATE < '$CUR_DATE' AND OPTIONSTATE != 2";
        exequery($connection,$query1);
        exequery($connection,$query2);
        exequery($connection,$query4);
                        
	}
        //钉钉微信 详细页
        public function   getNotifyDataView($limit=0,$start=0,$notifyid="" ){
		global $connection;
		$limit = $limit>0?$limit:$this->default_limit;
		$start = $start>0?$start:$this->default_start;
                        
		$sqlPar = $this->returnSqlPar($notifyid);
		$sql = "SELECT DISTINCT(NOTIFY_ID),n.*,u.USER_NAME AS USER_NAME FROM NOTIFY n,USER u WHERE 1 AND n.FROM_ID=u.USER_ID  AND BEGIN_DATE<='".SecurityFilter($this->curdate)."' AND ( END_DATE>='".SecurityFilter($this->curdate)."' OR END_DATE = '0000-00-00') AND( (n.DEPT_ID = 'ALL_DEPT') OR (INStr(n.DEPT_ID,',".SecurityFilter($this->deptid).",')>0 OR INStr(n.DEPT_ID,'".$this->deptid.",')=1) OR (INStr(PRIV_ID,',".SecurityFilter($this->uesrpriv).",')>0 OR  INStr(PRIV_ID,'".SecurityFilter($this->uesrpriv).",')=1) OR (INStr(n.USER_ID,',".SecurityFilter($this->userid).",')>0 OR  INStr(n.USER_ID,'".SecurityFilter($this->userid).",')=1)  OR n.FROM_ID='".SecurityFilter($this->userid)."')";		
		if($notifyid != '') {
			$sql .= " AND NOTIFY_ID IN(".SecurityFilter($sqlPar).")";
		}
                        
		if($search["NotifySubject"]!="")
		{
			$sql .= " AND SUBJECT like '%".SecurityFilter($search["NotifySubject"])."%'";	
		}
		
		if($search["NotifySort"]!="")
		{
			$sql .= " AND n.NOTIFY_TYPE_ID='".SecurityFilter($search["NotifySort"])."'";	
		}	
		
		switch($search["FILTER"]) 
		{
			case "unread":
				$sql .= " AND NOT FIND_IN_SET('".SecurityFilter($search["USER_ID"])."',READERS)";
				break;
            case "read":
				$sql .= " AND FIND_IN_SET('".SecurityFilter($search["USER_ID"])."',READERS)";
				break;
			case "days":
				$sql .= " AND DATE_FORMAT(SEND_TIME,'%Y-%m-%d')>=DATE_SUB(CURDATE(),INTERVAL 3
DAY) AND DATE_FORMAT(SEND_TIME,'%Y-%m-%d')<=CURDATE() ";
				break;
			case "week":
				$sql .= " AND DATE_FORMAT(SEND_TIME,'%Y-%m-%d')>=DATE_SUB(CURDATE(),INTERVAL 6
DAY) AND DATE_FORMAT(SEND_TIME,'%Y-%m-%d')<=CURDATE() ";
				break;
			case "month":
				$sql .= " AND DATE_FORMAT(SEND_TIME,'%Y-%m-%d')>=DATE_SUB(CURDATE(),INTERVAL 30
DAY) AND DATE_FORMAT(SEND_TIME,'%Y-%m-%d')<=CURDATE() ";
				break;
		}
		$res = exequery($connection,$sql);
		$count = mysql_num_rows($res);
		$sql .= " ORDER BY BEGIN_DATE DESC,NOTIFY_ID DESC LIMIT ".SecurityFilter($start).",".SecurityFilter($limit)."";
		$rs = exequery($connection,$sql);
		$i  = $start;
		$read_flag = 0;
		while($row = mysql_fetch_array($rs)){
			$notifyData[$i]['NOTIFY_ID'] = $row['NOTIFY_ID'];
			$notifyData[$i]['FROM_ID']   = $row['FROM_ID'];
			$notifyData[$i]['FROM_NAME'] = $row['USER_NAME'];

			if($notifyData[$i]['FROM_ID']!="")
			{
				$sql_name = "SELECT USER_NAME FROM user 
								WHERE USER_ID='".SecurityFilter($notifyData[$i]['FROM_ID'])."'";
				$rs_name  = exequery($connection,$sql_name);
				$row_name = mysql_fetch_array($rs_name);
				$notifyData[$i]['FROM_NAME'] = $row_name['USER_NAME'];
			}
			$notifyData[$i]['SUBJECT']    = $row['SUBJECT'];
			$notifyData[$i]['CONTENT']    = $row['CONTENT'];
			$notifyData[$i]['SEND_TIME']  = $row['SEND_TIME'];
			$notifyData[$i]['BEGIN_DATE'] = $row['BEGIN_DATE'];
			$notifyData[$i]['END_DATE']   = $row['END_DATE'];
			$notifyData[$i]['READERS']    = $row['READERS'];

			if(strpos($row['READERS'],$this->userid) == false){
				$read_flag=0;
			} else {
				$read_flag=1;
			}
			$notifyData[$i]['PUBLIC']          = $row['PUBLIC'];
			$notifyData[$i]['READ_FLAG']       = $read_flag;
			$notifyData[$i]['OPTIONSTATE']     = $row['OPTIONSTATE'];
			$notifyData[$i]['ATTACHMENT_ID']   = $row['ATTACHMENT_ID'];
			$notifyData[$i]['ATTACHMENT_NAME'] = $row['ATTACHMENT_NAME'];			
			$notifyData[$i]['NOTIFY_TYPE']     = $row['NOTIFY_TYPE_ID'];
			$notifyData[$i]['PUBLISH_DEPT']    = $row['DEPT_ID'];
			$notifyData[$i]['PUBLISH_PRIV']    = $row['PRIV_ID'];
			$notifyData[$i]['PUBLISH_USER']    = $row['USER_ID'];			
			$notifyData[$i]['ATTACHMENT_DIR']  = "";
			$notifyData[$i]['COUNT']           = $count;
			if($notifyData[$i]['ATTACHMENT_ID']!="")
			{
				$ATTACHMENT_ID_ARRAY   = explode(",",$notifyData[$i]['ATTACHMENT_ID']);
				$ATTACHMENT_NAME_ARRAY = explode("*",$notifyData[$i]['ATTACHMENT_NAME']);
				$ARRAY_COUNT           = sizeof($ATTACHMENT_ID_ARRAY);
				for($j=0; $j<=$ARRAY_COUNT; $j++)
				{
					if($ATTACHMENT_ID_ARRAY[$j]=="")
					break;
					global $ATTACH_PATH,$ROOT_PATH,$rooturl;				
					$PATH     = str_replace($ROOT_PATH,$rooturl,$ATTACH_PATH).$ATTACHMENT_ID_ARRAY[$j];
					$FILENAME = $PATH."/".$ATTACHMENT_NAME_ARRAY[$j];
					$notifyData[$i]['ATTACHMENT_DIR'] .= $FILENAME."*";
				}					
				$notifyData[$i]['ATTACHMENT_DIR'] = substr($notifyData[$i]['ATTACHMENT_DIR'],0,-1);
			}
			$i++;
		}		
		return $notifyData;
	}
}
?>