<?php
/*
 * @package       eoffice9.0
 * @function      角色通信控制类
 * @encoding      $_lang['encoding']
 * @name          api/rolerule.class.php
 * @version       1.0
 * @author        mbr
 * @date          2014-01-16
 */

include_once('inc/auth.php');

class rolerule{
	public function __construct(){
		//设置时区
		date_default_timezone_set('Asia/Shanghai'); 
		
		if(method_exists($this, '_init')){
			$this->_init();
		}
	}
	
	/**
	 *	@param $opt array
	 *	$param $opt 下标id 主key currentPage当前页 itemsPerPage页长
	 *
	 */
	public function getRule($opt){
		$id = $opt['id'];
		$currentPage = $opt['currentPage'] ? $opt['currentPage'] : 0;
		$itemsPerPage = $opt['itemsPerPage'] ? $opt['itemsPerPage'] : 10;
		
		$sql = 'select * from role_to_role';
		if($id){
			$sql .= " where id in ('{$id}')";
		}
		$sql .= ' order by id desc';
		$limit = SecurityFilter($currentPage) * SecurityFilter($itemsPerPage);
		
		$sql .= " limit {$limit}, {$itemsPerPage}";
		return $this->query($sql);
	}
	
	public function getdata($opt){
		
		$result = $this->getRule($opt);
		foreach($result as &$value){
			$value['role_1'] = $this->getRoleName($value['role_1']);
			$value['role_2'] = $this->getRoleName($value['role_2']);
			$value['type'] = $this->dealRuleType($value['type']);
		}
		
		return $result;
	}
	
	protected function dealRuleType($types){
		$typeArray = array(
			'1'=>'内部消息',
			'2'=>'内部邮件',
			'3'=>'手机短信',
		);
		$types = explode(',', trim($types, ','));
		
		$ruleType = '';
		if(is_array($types) && $types){
			foreach($types as $type){
				$ruleType .= $typeArray[$type] .',';
			}
		}
		
		return trim($ruleType, ',');
	}
	
	public function getRoleName($roleID){
		if(!$roleID) return false;
		
		$roleIDArr = explode(',', $roleID);
		
		$names = '';
		foreach($roleIDArr as $value){
			$sql = "select PRIV_NAME from user_priv where USER_PRIV in ('{$value}')";
			$result = $this->query($sql);
			$names .= $result[0]['PRIV_NAME'].',';
		}
		
		return trim($names,',');
	}
	
	//获取总数
	public function getCount($id = null){
		$sql = 'select count(*) as count from role_to_role';
		if($id){
			$sql .= " where id in ('{$id}')";
		}

		$result =  $this->query($sql);
		return $result[0]['count'];
	}
	
	/*
	 * $role1, 受限角色的角色ID, 非用户ID
	 * $role2, 目标角色的角色ID, 非用户ID
	 */
	public function createRule($role1, $role2, $type = array()){
		$time = time();
		$type = implode(',', $type);
		$sql = "insert into role_to_role(role_1,role_2,type,create_time) values('{$role1}', '{$role2}', '{$type}', {$time})";

		$this->query($sql);
		return mysql_affected_rows();
	}
	
	//删除规则
	public function deleteRule($id){
		if(!$id) return false;
		$id = trim($id, ',');
		$sql = "delete from role_to_role where id in ({$id})";
		
		$this->query($sql);
		return mysql_affected_rows();
	}
	
	//更新规则
	public function updateRule($id, $opt){
		if(!is_array($opt) || empty($opt) || !$id) return false;
		
		$role1 = $opt['role_1'];
		$role2 = $opt['role_2'];
		$type = implode(',', $opt['type']);
		
		$sql = "update role_to_role set role_1='{$role1}', role_2='{$role2}', type = '{$type}' where id = {$id}";
		
		$this->query($sql);
		return mysql_affected_rows();
	}
	
	//清空规则
	public function cleanRule(){
		$sql = 'delete from role_to_role';
		
		$this->query($sql);
		return mysql_affected_rows();
	}
	
	protected function query($sql){
		if(!$sql) return false;
		
		global $connection;
		$result = exequery($connection, $sql);
		
		//返回数据的容器
		$data = array();
		
		if(is_resource($result)){
			while($row = mysql_fetch_assoc($result)){
				$data[] = $row;
			}
		}
		return $data;
	}
	
	/* 获取通信规则过滤
	 * @param $opt array('privID'=>'角色ID', 'type'=>'类型')
	 * @return array 不包含$privID的角色ID
	 */
	public function getRoleFilterArr($opt = array()){
		
		$privID = $opt['privID'];
		$type = $opt['type'];
		//角色ID
		if(empty($privID)){
			$uid = $_SESSION['LOGIN_USER_ID'];
			$result = $this->getUserInfo($uid);
			$privID = $result['USER_PRIV'];
		}
		
		$sql = 'select * from role_to_role';
		$roleResult = $this->query($sql);
		
		$roleFilterArray = array();
		foreach($roleResult as $roleRow){
			if(!$roleRow['role_1']) continue;
			
			$role_1 = explode(',', trim($roleRow['role_1'], ','));
			if(in_array($privID, $role_1) && false !== strpos($roleRow['type'], $type)){
				$roleFilterArray = array_merge($roleFilterArray, explode(',', trim($roleRow['role_2'], ',')));
			}
		}
		// $roleFilter = implode(',', $roleFilterArray);
		return $roleFilterArray;
	}
	
	public function getUserInfo($uid){
		if(!$uid) $uid = $_SESSION['LOGIN_USER_ID'];
		
		$sql = "select * from user where USER_ID = '{$uid}'";
		$result = $this->query($sql);
		return $result[0];
	}
	
	/* 获取通信规则过滤
	 * @param $opt array('role_1'=>'角色1的ID', 'role_2'=>'角色2的ID', 'type'=>'类型')
	 * @return boolean
	 */
	public function checkRoleWithRole($opt = array()){
		foreach((array)$opt as $key=>$value){
			$$key = $value;
		}
		
		$sql = "select count(*) as count from role_to_role where 
		(role_1 like '%,{$role_1},%' or role_1 like '{$role_1},%') and 
		(role_2 like '%,{$role_2},%' or role_2 like '{$role_2},%') and type like '%{$type}%'";
		$result = $this->query($sql);
		
		return $result[0]['count'];
	}
	
}