<?php
/**
 * Systemname:       E-Office
 * Filename:         
 * Function:         
 * Encoding:         utf8
 * Author:           www.weaver.com.cn
 * Date:             
 * File Version:     1.0
 * Eoffice Version:  6.0
*/
include_once("general/workflow/prcs_role.php");
class sms{
	var $default_limit = 20;
	var $default_start = 0;
	private $deptid;
	private $uesrpriv;
	private $userid;
	private $curdate;
	private $curdatetime;
	
	function __construct($userInfo=array()){
		global $connection;
		
		if($userInfo["user_id"] == "") {
			$this->userid = $_SESSION["LOGIN_USER_ID"];
		} else {
			$this->userid = $userInfo["user_id"];
		}
		
		if($this->userid){
			$sql = "SELECT DEPT_ID,USER_PRIV FROM user WHERE USER_ID='".SecurityFilter($this->userid)."'";
			$rs  = exequery($connection,$sql);
			$row = mysql_fetch_array($rs);
			$this->deptid = $row["DEPT_ID"];
			$this->uesrpriv = $row["USER_PRIV"];
		}

		$this->curdate = date("Y-m-d",time());
		$this->curdatetime = date("Y-m-d H:i:s",time());
	}

	/**
	 * 修改提醒状态
	 * @param int $smsid	sms id
	 */
	function updateRemind($smsid){
		global $connection;
		$sql = "UPDATE sms SET REMIND_FLAG=0 WHERE SMS_ID=".SecurityFilter($smsid);
		return exequery($connection,$sql);	
	}

	/**
	 * 取消某人的所有短信提醒
	 * @param int $userid	用户id
	 */
	function updateRemindAll($userId){
		global $connection;
		$sql = "UPDATE sms SET REMIND_FLAG=0 WHERE TO_ID ='".SecurityFilter($userId)."' AND REMIND_FLAG != '0' ";
		return exequery($connection,$sql);
	}
	/**
	 * 取得用户消息总数量
	 * @return 消息数量
	 */	
	function getSmsAmount($keyWord = ''){
		global $connection;
				
		$sql =	"SELECT count(*) CNT FROM sms WHERE 1 
				AND TO_ID='".SecurityFilter($this->userid)."' 
				AND SEND_TIME<'".SecurityFilter($this->curdatetime)."' 
				AND receive_del != '1'
		";
		if($keyWord != ''){
			$sql .= " AND CONTENT LIKE '%".SecurityFilter($keyWord)."%' ";
		}
		$rs	 = exequery($connection,$sql);
		$row   = mysql_fetch_array($rs);
		$amount = $row["CNT"];

		return $amount;
	}
	/**
	 * 取得新消息数量
	 * @return 消息数量
	 */	
	function getNewSmsAmount(){
		global $connection;
		$sql = "
				SELECT COUNT(SMS_ID) AS CNT FROM sms WHERE 1 
				AND TO_ID='".SecurityFilter($this->userid)."' 
				AND SEND_TIME<'".SecurityFilter($this->curdatetime)."' 
				AND REMIND_FLAG=1 
				"
				;

		$rs	 = exequery($connection,$sql);
		$row   = mysql_fetch_array($rs);
		$amount = $row["CNT"];
		return $amount;
	}
	/**
	 * 取得消息内容
	 * @param int $limit 每页数量
	 * @param int $start 开始ID
	 * @param int $smsid 消息ID,如果设置了这项只会返回该ID的消息
	 * @param string $keyWord 搜索关键字
	 * @return 消息内容数组
	 */
	function getSmsInfo($limit=0,$start=0,$smsid="",$keyWord=""){

		global $connection;
		$limit = $limit>0?$limit:$this->default_limit;
		$start = $start>0?$start:$this->default_start;
		$sql = "SELECT * FROM sms 
					WHERE 1 
					AND TO_ID='".SecurityFilter($this->userid)."' 
					AND SEND_TIME<'".SecurityFilter($this->curdatetime)."' 
					AND receive_del != '1'"
				;
		if($smsid != ""){
			$sql .= " AND SMS_ID=".SecurityFilter($smsid)." ";
		}
		if($keyWord)
		{
			$sql .= " AND CONTENT LIKE '%".SecurityFilter($keyWord)."%' ";
		}
		$sql .= " ORDER BY SMS_ID DESC LIMIT ".SecurityFilter($start).",".SecurityFilter($limit)."";

		$rs = exequery($connection,$sql);
		$i = $start;
		$smsData = array();
		while($row = mysql_fetch_array($rs)) {
			$smsData[$i]['SMS_ID']  = $row['SMS_ID'];
			$smsData[$i]['FROM_ID'] = $row['FROM_ID'];
			$smsData[$i]['TO_ID']   = $row['TO_ID'];
			$smsData[$i]['SMS_TYPE']		= $row['SMS_TYPE'];
			$smsData[$i]['CONTENT']			= $row['CONTENT'];
			$smsData[$i]['SEND_TIME']		= $row['SEND_TIME'];
			$smsData[$i]['REMIND_FLAG']		= $row['REMIND_FLAG'];
			$smsData[$i]['ATTACHMENT_ID']	= $row['ATTACHMENT_ID'];
			$smsData[$i]['ATTACHMENT_NAME'] = $row['ATTACHMENT_NAME'];
			//获取短信链接地址的必要参数
			$smsData[$i]['TABLE_ID']        = $row['TABLE_ID'];
			$smsData[$i]['TABLE_NAME']      = $row['TABLE_NAME'];
			$smsData[$i]['TABLE_VAR']       = $row['TABLE_VAR'];
			$i++;
		}
		return $smsData;
	}

	/**
	 * 取得上/下一条消息
	 * @param int $smsid 消息id
	 * @param string $flag next or pre
	 * @return 消息内容数组
	 */
	function getPreNextSms($smsid,$flag="next") {
		global $connection;
		if($smsid) {
			$sql = "SELECT * FROM sms WHERE 1	
						AND TO_ID='".SecurityFilter($this->userid)."' 
						AND SEND_TIME<'".SecurityFilter($this->curdatetime)."' 
				   ";
			switch ($flag){
				case "next":
					$sql .= " AND SMS_ID>'".SecurityFilter($smsid)."' ORDER BY SMS_ID ASC LIMIT 0,1";
					break;
				case "pre":
					$sql .= " AND SMS_ID<'".SecurityFilter($smsid)."' ORDER BY SMS_ID DESC LIMIT 0,1";
					break;
			}
			$rs = exequery($connection,$sql);
			$row = mysql_fetch_array($rs);
			$resmsid = $row["SMS_ID"];
			$resubject = $row["CONTENT"];
		}
		$smsData["smsid"] = $resmsid;
		$smsData["subject"] = $resubject;
		return $smsData;
	}

	/**
	 * 发送消息
	 * @param array $data 消息字段数组array(fromid,toid,smstype,content,sendtime,remindflag,attachid,attachname)
	 * @return 返回当前一条数据的ID
	 */
	function sendSms($data){
		global $connection;
		$sql = "
			INSERT INTO sms  
			(FROM_ID,TO_ID,SMS_TYPE,CONTENT,SEND_TIME,REMIND_FLAG,ATTACHMENT_ID,ATTACHMENT_NAME)
			VALUES 
			('".SecurityFilter($this->userid)."','".SecurityFilter($data['toid'])."',".SecurityFilter($data['smstype']).",'".SecurityFilter($data['content'])."','".SecurityFilter($data['sendtime'])."',".SecurityFilter($data['remindflag']).",'".SecurityFilter($data['attachid'])."','".SecurityFilter($data['attachname'])."')
			"
			;	//$data['fromid']
		exequery($connection,$sql);
		return mysql_insert_id();
	}

	/**
	 * 这个方法没使用到
	 */
	private function returnSqlPar($pars){
		$sqlPar = is_array($pars)?implode(",",$pars):$pars;
		if (substr($sqlPar,-1,1) == ","){
			$sqlPar = substr($sqlPar,0,strlen($sqlPar)-1);
		}
		
		$sqlPar = "'".str_replace(",","','",$sqlPar)."'";
		return $sqlPar;
	}
	/**
	 * 获取消息信息 新的方法,分页条件在field数组里
	 * @param array $field 包含条件的键值关联数组
	 * @param array $other 没有用到
	 * @return 消息数组
	 */
	function getSmsInfoNew($field,$other){
		global $connection;
		$sql  = " SELECT * FROM sms ";
		$sql .= $this->serializationCondition($field);
		$rs = exequery($connection,$sql);
		$i = 0;
		while($row = mysql_fetch_array($rs)){
			$smsData[$i]['SMS_ID'] = $row['SMS_ID'];
			$smsData[$i]['FROM_ID'] = $row['FROM_ID'];
			$smsData[$i]['TO_ID'] = $row['TO_ID'];
			$smsData[$i]['SMS_TYPE'] = $row['SMS_TYPE'];
			$smsData[$i]['CONTENT'] = $row['CONTENT'];
			$smsData[$i]['SEND_TIME'] = $row['SEND_TIME'];
			$smsData[$i]['REMIND_FLAG'] = $row['REMIND_FLAG'];
			$smsData[$i]['ATTACHMENT_ID'] = $row['ATTACHMENT_ID'];
			$smsData[$i]['ATTACHMENT_NAME'] = $row['ATTACHMENT_NAME'];

			$i++;
		}
		$smsData = $this->replaceUserStr('FROM_ID','FROM_NAME', $smsData);
		$smsData = $this->replaceUserStr('TO_ID','TO_NAME', $smsData);
		return $smsData;
	}
	/**
	 * 取得消息总数量
	 * @param array $field 查询条件字段
	 * @param array $other 其他条件
	 * @return 消息数量
	 */	
	function getSmsNum($field,$other)
	{
		global $connection;
		$sql = "
				SELECT COUNT(SMS_ID) AS CNT FROM sms "
				;
		if($field)
		{
			$conStr = $this->serializationCondition($field);	
		}
		$sql .=  $conStr;
		$rs	 = exequery($connection,$sql);
		$row   = mysql_fetch_array($rs);
		$amount = $row["CNT"];

		return $amount;
	}
	/**
	 * 格式化查询条件
	 * Enter description here ...
	 * @param array $field sql查询有关的键值关联数组
	 * @return 格式化后的SQL语句
	 */
	function serializationFields($field = array())
	{
		foreach($field as $key=>$val)
		{
			if($key != "WHERE")
			{
				$str .= ",".$key."='".$val."'";
			}
		}
		if($str)
			$str = trim($str,",");
		return $str;
	}
	/**
	 * 格式化查询条件
	 * @param array $field sql查询有关的键值关联数组
	 * @return 格式化后的SQL语句
	 */
	function serializationCondition($field = array())
	{
		$conditionStr = "";
		if($field["WHERE"])
		{
			$conditionStr = " WHERE ".$field["WHERE"];
		}
		else
		{
			$conditionStr = " WHERE 1 ";
		}
		if($field["GROUPBY"])
		{
			$conditionStr .= " GROUP BY ".SecurityFilter($field["GROUPBY"]);
		}
		if($field["SORTBY"])
		{
			$conditionStr .= " ORDER BY ".SecurityFilter($field["SORTBY"]);
		}
		if($field["LIMIT"])
		{
			$conditionStr .= "LIMIT ".SecurityFilter($field["LIMIT"]) ;
			//$conditionStr .= " LIMIT $start , ".$this->fields["LIMIT"];
		}
		return $conditionStr;
	}
	/**
	 * 删除消息???貌似没有用到
	 * @param array $info 查询需要的字段条件
	 * @param array $other 其他条件
	 */
	function deleteSms($info,$other=array())
	{
		global $connection;
		$sql      = "UPDATE sms SET ";
		$fieldStr = $this->serializationFields($info);
		$conStr   = $this->serializationCondition($info);
		$sql     .= $fieldStr.$conStr; 
		$rs       = exequery($connection,$sql);
	}
	/**
	 * replace user_id or user_account with user_name _by danal
	 * @param string $key_in key to compare
	 * @param strin $key_out key to be appended
	 * @param array $inArray array(0=>array($row),1=>...)
	 */
	public function replaceUserStr($key_in,$key_out,$inArray){
		global $connection;
		$users = array();
		$sql = "SELECT USER_ID,USER_ACCOUNTS,USER_NAME FROM user";
		$rs = exequery($connection,$sql);
		while($row = mysql_fetch_assoc($rs)){
			$users[] = $row;
		}	
		$inSize = count($inArray);
		$uSize = count($users);
		for($i = 0; $i != $inSize; $i++){
			$newkey = array();
			$in_i = $inArray[$i];		
			$field = $in_i[$key_in];
			if(trim($field) != ''){	
				$field_pieces = explode(',', $field);		
				for ($j=0; $j != count($field_pieces); $j++){
					$field_piece = $field_pieces[$j];		
					for($k = 0; $k != $uSize; $k++){		
						if($users[$k]['USER_ID'] == $field_piece){	
							$newkey[] = $users[$k]['USER_NAME'];
						}
					}
				}
				$inArray[$i][$key_out] = implode(',',$newkey);
			} 
		}
		return $inArray;
	}
	/**
	 * 取消公告消息提醒
	 * @param int $notifyId id
	 * @return 成功 1,失败 0
	 */
	function cancelNotifySmsRemind($notifyId) {
		global $connection;
		$sql = "UPDATE sms SET REMIND_FLAG = '0'
				WHERE FROM_ID ='".SecurityFilter($_SESSION['LOGIN_USER_ID'])."' 
				AND SMS_TYPE = '1' 
				AND REMIND_FLAG = '1' 
				AND TABLE_NAME = 'notify'				
				AND TABLE_ID = '".SecurityFilter($notifyId)."' 
				";	
		$rs  = exequery($connection,$sql); 
	}
	/**
	 * 设置消息提醒
	 * @param int $notifyId 消息ID
	 */
	function notifySmsRemind($notifyId) {
		global $connection;
		$sql = "UPDATE sms SET REMIND_FLAG = '1'
				WHERE FROM_ID ='".SecurityFilter($_SESSION['LOGIN_USER_ID'])."' 
				AND SMS_TYPE = '1' 
				AND REMIND_FLAG = '0' 
				AND TABLE_NAME = 'notify'				
				AND TABLE_ID = '".SecurityFilter($notifyId)."' 
				";	
		$rs  = exequery($connection,$sql); 
	}

	/**
	 *获取内部消息的url
	 *@param  string $SMS_TYPE   内部消息类型
	 *@param  string $CONTENT    内部消息内容
	 *@param  string $TABLE_ID   表的ID
	 *@param  string $TABLE_VAR  表的值
	 *@return array $ARY          返回包括url的数组
	 */
	function getSmstypeUrls($SMS_TYPE, $CONTENT, $TABLE_ID = "", $TABLE_VAR = "",$TABLE_NAME = "",$USER_ID = "") {
		global $connection, $LOGIN_USER_ID;
		switch ($SMS_TYPE) {
			case "0":
				$URL = '/general/sms/receive/';
				break;
			case "1":
				$URL = '/general/notify/show/';
				if ($TABLE_ID != "") {
					$URL = '/general/notify/show/read_notify.php?NOTIFY_ID=' . $TABLE_ID.'&limit=0';
				}
				break;
			case "2":
				$URL = '/general/email/';
				if ($TABLE_ID != "") {
					$URL = '/general/email/email_detail.php?EMAIL_ID=' . $TABLE_ID . '&boxid=-1';
				}
				break;
			case "3":
				$URL = '/general/netmeeting/';
				break;
			case "4":
				$URL = '/general/salary/submit/';
				break;
			case "5":
				$URL = '/general/calendar/affair/';
				break;
			case "6":
				if (strstr($CONTENT, "提交") && strstr($CONTENT, "申请") && strstr($CONTENT, "请批示")) {
					$URL = '/general/attendance/manage/att_pass_appov.php?TABLE_NAME='.$TABLE_NAME.'&TABLE_ID='.$TABLE_ID;
				} else {
					$URL = '/general/attendance/personal/';
				}
				break;
			case "7":
				//流程是否已结束
				if($TABLE_ID > 0) {
					$arryflow = explode("|", $TABLE_VAR);
					$arkey	  = explode(",", $arryflow[0]);
					$arval	  = explode(",", $arryflow[1]);
					$FLOW_ID  = $arval[0];
					$RUN_ID	  = $arval[1];
					$PRCS_ID  = $arval[2];
					$FLOW_PRCS = $arval[3];

					$sqlft = "SELECT FLOW_TYPE FROM flow_type WHERE FLOW_ID=" . SecurityFilter($FLOW_ID);
					$rsft  = exequery($connection, $sqlft);
					$rowft = mysql_fetch_array($rsft);
					$htmsuffix == "";
					if($rowft['FLOW_TYPE'] == 2) {
						$htmsuffix = "free_";
					}

					$tmpurlview = "/general/workflow/print/index.php?FLOW_ID=" . $FLOW_ID .
						"&RUN_ID=" . $RUN_ID;
					$tmpurldo = "/general/workflow/input_form/" . $htmsuffix .
						"input_form.php?RUN_ID=" . $RUN_ID . "&FLOW_ID=" . $FLOW_ID . "&PRCS_ID=" . $PRCS_ID .
						"&FLOW_PRCS=" . $FLOW_PRCS;

					$sql = "SELECT RUN_ID FROM flow_run_prcs WHERE RUN_ID=".SecurityFilter($RUN_ID) .
						" AND PRCS_FLAG<>'4'";
					$rs = exequery($connection, $sql);
					if ($row = mysql_fetch_array($rs)) {
						$sqlfl = "SELECT * FROM flow_run_prcs WHERE RUN_ID=".SecurityFilter($RUN_ID) .
							"  AND USER_ID='" . SecurityFilter($USER_ID) .
							"' ORDER BY PRCS_ID DESC LIMIT 1";
						$rsfl = exequery($connection, $sqlfl);
						if ($rowfl = mysql_fetch_array($rsfl)) {
							//主办人是否办理结束
							if ($rowfl['OP_FLAG'] == 1) {
								if ($rowfl['PRCS_FLAG'] == 4 || $rowfl['PRCS_FLAG'] == 3) {
									$URL = $tmpurlview;
								} else {
									$URL = "/general/workflow/input_form/" . $htmsuffix . "input_form.php?RUN_ID=" .
										$RUN_ID . "&FLOW_ID=" . $FLOW_ID . "&PRCS_ID=" . $rowfl['PRCS_ID'] .
										"&FLOW_PRCS=" . $rowfl['FLOW_PRCS'] . "&OP_FLAG=" . $rowfl['OP_FLAG'];
								}
							}
							//经办人是否办理结束
							else 
							{
								if ($rowfl['SAVEFORM_TIME'] == null) {
									$URL = "/general/workflow/input_form/" . $htmsuffix . "input_form.php?RUN_ID=" .
										$RUN_ID . "&FLOW_ID=" . $FLOW_ID . "&PRCS_ID=" . $rowfl['PRCS_ID'] .
										"&FLOW_PRCS=" . $rowfl['FLOW_PRCS'] . "&OP_FLAG=" . $rowfl['OP_FLAG'];
								} else {
									$URL = $tmpurlview;
								}
							}
						} else {
							$URL = "";
						}
					}
					//流程已结束
					else 
					{
						$URL = $tmpurlview;
						//有短信提醒,且流程办理完了,但是没有查看权限,判断为被转移了
						if(!run_role($RUN_ID,0))
						{
							$URL  = "/general/workflow/print/index.php?FLOW_ID=".$FLOW_ID."&RUN_ID=".$RUN_ID;
						} else {
							$sqlf = "SELECT * FROM flow_run_prcs 
									     WHERE RUN_ID=".SecurityFilter($RUN_ID).
									     "  AND USER_ID='".SecurityFilter($USER_ID).
										 "' ORDER BY PRCS_ID DESC LIMIT 1";
							$rsf	 = exequery($connection, $sqlf);
							if($rowf = mysql_fetch_array($rsf)) {
								if($rowf['OP_FLAG'] != 1 && $rowf['SAVEFORM_TIME'] == null && $rowf['FLOW_PRCS'] != '') {
									$URL  = "/general/workflow/input_form/".$htmsuffix. "input_form.php?RUN_ID=".
										$RUN_ID."&FLOW_ID=".$FLOW_ID."&PRCS_ID=".$rowf['PRCS_ID'].
										"&FLOW_PRCS=".$rowf['FLOW_PRCS']."&OP_FLAG=".$rowf['OP_FLAG'];
								}
							}
						}
					}
				} else {
					$URL = '/general/workflow/';
				}
				break;
			case "8":
				$URL  = '/general/meetings/myapply/index.php?apply_id='.$TABLE_ID;
				break;
			case "9":
				$URL  = '/general/vehicles/examine.php?apply_id='.$TABLE_ID;
				break;
			case "10":
				$URL  = '/general/vehicles/show.php?apply_id='.$TABLE_ID;
				break;
			case "11":
				$URL  = '/general/vehicle/maintenance/';
				break;
			case "12":
				$URL = '/general/vehicles/manage/show_read.php?car_id='.$TABLE_ID.'&diff=homepage';
				break;
			case "13":
				$URL = '/general/meetings/examine/index.php?apply_id='.$TABLE_ID;
				break;
			case "15":
				$URL = '/general/workflow/manage.php';
				break;
			case "16":
				$URL = '/general/officeitem/takemanage/';
				break;
			case "17":
				$URL = '/general/officeitem/take/';
				break;
			case "18":
				$URL = '/general/inspection/approval.php?NEWS_ID=' . $TABLE_ID;
				break;
			case "19":
				$URL = '/general/crm/linkman';
				break;
			case "20":
				$URL = '/general/file_folder/file_new/read.php?CONTENT_ID=' . $TABLE_ID;
				break;
			case "21":
				$URL = '/general/inspection/approval_notify.php?notify_id=' . $TABLE_ID;
				break;
			case "22":
				$URL = '/general/news/show/read_news.php?NEWS_ID=' . $TABLE_ID;
				break;
			case "23":
				$URL = '/general/sms/receive/';
				break;
			case "24":
				$URL = '/general/diary/index.php?diaryid='.$TABLE_ID;
				break;
			case "25":
				$URL = '/general/diary/info/index.php?diaryid='.$TABLE_ID;
				break;
			case "26":
				$URL = '/general/cooperation/coop_view/index.php?theme_id='.$TABLE_ID;
				break;
			case "27":
				$URL = '/general/news/show/';
				if ($TABLE_ID != "") {
					$URL = '/general/news/show/read_news.php?NEWS_ID=' . $TABLE_ID.'&limit=0';
				}
				break;
			case "28":
				$URL  = '/general/calendar/cal_detail.php?CAL_ID='.$TABLE_ID;
				break;
			case "29":
				$URL = '/general/crm/customer/contract_detail.php?CON_ID='.$TABLE_ID;
				break;
		}
		$ARY['URL'] = $URL;
		return $ARY;
	}
}
?>