<?php
/**
 *@Copyright (C) 2010 - 2015 Weaver Co.Ltd
 *@systemname:       E-Office
 *@filename:         api/task.class.php
 *@function:         任务管理的类
 *@encoding:         $_lang['encoding']
 *@author:           www.weaver.com.cn
 *@modify:			 qsb
 *@date:             2015-01-15
 *@file Version:     1.0
 *@eoffice Version:  9.0
*/
include_once ("inc/conn.php");
include_once("inc/auth.php");
include_once("inc/utility_all.php");
class task{

    /**
     * 添加任务
     * @access public
     * @param array $data
     * @return int
     */
	function addTask($data){
		if(!empty($data['TASK_NAME'])){
			$task_id = $this->taskInsert('task_manage',$data);
			$dataUser[] = array(
							'TASK_ID' 	=> $task_id,
							'USER_ID' 	=> $_SESSION['LOGIN_USER_ID'],
							'USER_TYPE' => '0',
						  );
			$this->addUsers($dataUser);
			return $task_id;
		}
	}

    /**
     * 编辑任务
     * @access public
     * @param array $data
     * @return int
     */
	function editTask($data){
		global $connection;
		$task_id = $data['TASK_ID'];
		unset($data['TASK_ID']);
		$sql = "UPDATE task_manage set ";
		foreach($data as $k=>$v){
			$sql .= SecurityFilter($k)."='".SecurityFilter($v)."',";
		}
		$sql = rtrim($sql,",");
		$sql .= " WHERE TASK_ID=".SecurityFilter($task_id);
		exequery($connection,$sql);
	}

    /**
     * 标记任务
     * @access public
     * @param $tid:任务id;$status:1进行中,2已完成,0删除;
     * @return int
     */
	function taskUpdateStatus($task_id,$status=2){
		global $connection;
		$sql = "UPDATE task_manage ";
		if($status==2||$status==0){
			$sql .= "SET  TASK_STATUS=".SecurityFilter($status).",COMPLATE_DATE = ".time();
			if($status==0){
				$sql_del_tag = "DELETE FROM task_tag_relation WHERE TASK_ID=".SecurityFilter($task_id);
				exequery($connection,$sql_del_tag);
			}
		}else{
			$sql .= "SET  TASK_STATUS=".SecurityFilter($status)."";
		}
		if(!strpos($task_id,",")){
			$sql .= " WHERE TASK_ID=".SecurityFilter($task_id)." OR PID=".SecurityFilter($task_id);
		}else{
			$sql .= " WHERE TASK_ID IN(".SecurityFilter(trim($task_id,",")).") OR PID IN(".SecurityFilter(trim($task_id,",")).")";
		}
		exequery($connection,$sql);
	}

    /**
     * 是否关注
     * @access public
     * @param $tid:任务id;
     * @return int
     */
	function taskIsAttention($tid){
		global $connection;
		$sql = "SELECT TASK_ID FROM task_user
				WHERE TASK_ID=".SecurityFilter($tid)." AND USER_ID='".$_SESSION['LOGIN_USER_ID']."' AND USER_TYPE=2";
		$query = exequery($connection,$sql);
		return mysql_num_rows($query);
	}

    /**
     * 添加关注
     * @access public
     * @param $tid:任务id;
     * @return int
     */
	function taskAttention($tid){
		global $connection;
		$sql = "INSERT INTO task_user
				SET TASK_ID=".SecurityFilter($tid).",USER_ID='".$_SESSION['LOGIN_USER_ID']."',USER_TYPE=2";
		exequery($connection,$sql);
		return 1;
	}

    /**
     * 批量添加关注
     * @access public
     * @param $tid:任务id;
     * @return int
     */
	function taskAttentionBatch($tid){
		global $connection;
		$sql = "INSERT INTO task_user
				(`TASK_ID`,`USER_ID`,`USER_TYPE`)VALUES";
		$tidArr = explode(',',trim($tid,','));
		foreach($tidArr as $v){
			$sql .="(".SecurityFilter($v).",'".$_SESSION['LOGIN_USER_ID']."',2),";
		}
		$sql = trim($sql,',');
		exequery($connection,$sql);
		return 1;
	}

    /**
     * 批量取消关注
     * @access public
     * @param $tid:任务id;
     * @return int
     */
	function taskDelAttentionBatch($tid){
		global $connection;
		$sql = "DELETE FROM task_user
				WHERE TASK_ID IN(".SecurityFilter(trim($tid,",")).") AND USER_ID='".$_SESSION['LOGIN_USER_ID']."' AND USER_TYPE=2";
		 exequery($connection,$sql);
	}

  	/**
     * 取消关注
     * @access public
     * @param $tid:任务id;
     * @return int
     */
	function taskDelAttention($tid){
		global $connection;
		$sql = "DELETE FROM task_user
				WHERE TASK_ID=".SecurityFilter($tid)." AND USER_ID='".$_SESSION['LOGIN_USER_ID']."' AND USER_TYPE=2";
		 exequery($connection,$sql);
	}

    /**
     *获取已完成任务
     * @access public
     * @param array $data
     * @return int
     */
	function getTasksDone($data=array()){
		$result = array();
		$data['perPage']   = 15;
		$tasks             =  $this->getTasks($data);
		$result[0]['num']  =  $tasks['num'];
		unset($tasks['num']);
		$result[0]['list'] =  $tasks;
		return $result;
	}


    /**
     *获取任务附件
     * @access public
     * @param array $data
     * @return int
     */
	function getAttachments($tid){
		global $connection;
		$sql  = "SELECT * FROM  task_attachments WHERE TASK_ID = ".SecurityFilter($tid)."";
		$query = exequery($connection,$sql);
		while($row = mysql_fetch_assoc($query)){
			$res[] = $row;
		}
		return $res;
	}

    /**
     *获取子任务
     * @access public
     * @param int $tid任务id
     * @return int
     */
	function getTaskSons($tid){
		global $connection;
		$result = array();
		if($tid>0){
			$sql       = "SELECT DISTINCT tm.*,u.USER_NAME FROM task_manage as tm
						  LEFT JOIN user as u on tm.USER_ID = u.USER_ID
						  WHERE PID=".SecurityFilter($tid);
			$query = exequery($connection,$sql);
			while($row = mysql_fetch_assoc($query)){
				$row['ATTENTION'] = $this->taskIsAttention($row['TASK_ID']);
				$row['USER_TYPE'] = $this->taskIsController($row['USER_ID'],$row['TASK_ID']);
				$result[] = $row;
			}
		}
		return $result;
	}
    /**
     *获取父任务
     * @access public
     * @param int $tid任务id
     * @return int
     */
	function getTaskParent($tid){
		global $connection;
		$result = array();
		if($tid>0){
			$sql       = "SELECT DISTINCT tm.*,u.USER_NAME FROM task_manage as tm
						  LEFT JOIN user as u on tm.USER_ID = u.USER_ID
						  WHERE TASK_ID=".SecurityFilter($tid);
			$query = exequery($connection,$sql);
			while($row = mysql_fetch_assoc($query)){
				$result[] = $row;
			}
		}
		return $result[0];
	}

    /**
     *获取任务
     * @access public
     * @param array $data
     * @return int
     */
	function getTasksImportant($data=array()){
		$result = array();
		$status =  array('important_urgent'=>1,'important_unurgent'=>2,'unimportant_urgent'=>3,'unimportant_unurgent'=>4,'no_tag'=>0);
		foreach($status as $k=>$v){
			$data['important'] 		=  $v;
			$result[$k]['id']		=  $v;
			$tasks              	=  $this->getTasks($data);
			$result[$k]['num']  	=  $tasks['num'];
			unset($tasks['num']);
			$result[$k]['list'] 	=  $tasks;
		}
		return $result;

	}

    /**
     *获取更多任务
     * @access public
     * @param array $data
     * @return int
     */
	function getTasksMore($data=array()){
		$perPage = 5;
		$result    = array();
		$arr = $this->getTasks($data);
		$result['num'] = $arr['num'] - $perPage*($data['page']+1);
		unset($arr['num']);
		$result['con'] = $arr;
		return $result;
	}

    /**
     *获取任务
     * @access public
     * @param array $data
     * @return int
     */
	function getTasksIndex($data=array()){
		$result = array();
		$status =  array('delay'=>-1,'today'=>1,'tomorrow'=>2,'will'=>3,'no_tag'=>4);
		foreach($status as $k=>$v){
			$data['date'] 		=  $v;
			$data['fields'] 		=  "tm.TASK_ID,tm.TASK_NAME,tm.TASK_STATUS,tm.IMPORTANT_LEVEL";
			$result[$k]['id']	=  $v;
			$tasks              =  $this->getTasks($data);
			$result[$k]['num']  =  $tasks['num'];
			unset($tasks['num']);
			$result[$k]['list'] =  $tasks;
		}
		return $result;
	}

 	/**
     *获取任务
     * @access public
     * @param array $data
     * @return int
     */
	function getTasks($param=array()){
		global $connection;
		$perPage   =  isset($param['perPage'])?$param['perPage']:5;
		if(!isset($param['page'])) $param['page']=0;
		$status     =  isset($param['status'])?$param['status']:1;
		if($status > 0){
			$where  =  " WHERE tm.TASK_STATUS = ".SecurityFilter($status);
		}else{
			$where  =  " WHERE tm.TASK_STATUS > 0 ";
		}

		if(isset($param['date'])){
			$stoday   = strtotime(date("Y-m-d"));
			$today    = $stoday+86400-1;
			$tomorrow = $stoday+86400*2-1;
			$will     = $stoday+86400*3-1;
			switch($param['date']){
				case -1:
					$where .= " AND tm.END_DATE < ".$stoday." AND tm.END_DATE != 0";
					break;
				case 1:
					$where .= " AND tm.END_DATE <= ".$today." AND tm.END_DATE > ".$stoday;
					break;
				case 2:
					$where .= " AND tm.END_DATE <= ".$tomorrow." AND tm.END_DATE > ".$today;
					break;
				case 3:
					$where .= " AND tm.END_DATE > ".$tomorrow;
					break;
				case 4:
					$where .= " AND tm.END_DATE = 0";
					break;
			}
		}
		$type = isset($param['type'])?(int)$param['type']:0;
		if($type>1){
			$where    .= " AND tu.USER_ID = '".$_SESSION['LOGIN_USER_ID']."' AND tu.USER_TYPE = ".SecurityFilter($param['type']);
		}else if($type==1){
			$where    .= " AND tu.USER_ID = '".$_SESSION['LOGIN_USER_ID']."' AND (tu.USER_TYPE = 0 OR tu.USER_TYPE = 1)";
		}else if($type==0){
			$where    .= " AND tu.USER_ID = '".$_SESSION['LOGIN_USER_ID']."' AND (tu.USER_TYPE = 0 OR tu.USER_TYPE = 1 OR tu.USER_TYPE = 3)";
		}

		if(isset($param['tags'])){
			$tags = trim($param['tags'],',');
			if(!empty($tags)){
				$where    .= " AND ttr.TAG_ID IN(".SecurityFilter($tags).")";
			}
		}

		$order = ' ORDER BY RELEASE_DATE DESC';

		if(isset($param['fields'])){
			$fields = $param['fields'];
		}else{
			$fields = 'tm.*';
		}
		$sql_count = "SELECT COUNT(DISTINCT tm.TASK_ID) as num ";
		$sql_select = "SELECT DISTINCT ".SecurityFilter($fields).",u.USER_ID,u.USER_NAME ";
		$sql_from = "FROM task_manage as tm
					  LEFT JOIN task_user as tu on tm.TASK_ID = tu.TASK_ID
					  LEFT JOIN user as u on tm.USER_ID = u.USER_ID
					  LEFT JOIN task_tag_relation as ttr on tm.TASK_ID = ttr.TASK_ID ";

		$sql = 	$sql_count.$sql_from.$where;

		$query_count = exequery($connection,$sql);
		if($row = mysql_fetch_array($query_count)){
			$result    =  array('num'=>$row['num']);
		}

		$page      =   $perPage*$param['page'];
		$limit     = " LIMIT ".SecurityFilter($page).",".SecurityFilter($perPage)."";
		$sql 	   =  $sql_select.$sql_from.$where.$order.$limit;

		$resultObj = exequery($connection,$sql);
		while($row = mysql_fetch_assoc($resultObj)){
			$row['ATTENTION'] = $this->taskIsAttention($row['TASK_ID']);
			$row['USER_TYPE'] = $this->taskIsController($row['USER_ID'],$row['TASK_ID']);
			$result[] = $row;
		}


		return $result;
	}
   /**
     * 是否可以控制任务
     * @access public
     * @param int $id
     * @return array
     */
	function taskIsController($uid,$tid){
		global $connection;
		if($uid == $_SESSION['LOGIN_USER_ID']){
			return 1;
		}else{
			$sql = "SELECT USER_TYPE FROM task_user
					WHERE USER_ID = '".$_SESSION['LOGIN_USER_ID']."' AND TASK_ID = ".SecurityFilter($tid);
			$resultObj = exequery($connection,$sql);
			while($row = mysql_fetch_array($resultObj)){
				$result[] = $row;
			}
			return $result[0]['USER_TYPE'];
		}
	}
    /**
     * 获取数据
     * @access public
     * @param int $id
     * @return array
     */
	function getTask($id){
		global $connection;
		$sql = 'SELECT * FROM task_manage where TASK_ID = '.SecurityFilter($id);
		$resultObj = exequery($connection,$sql);
		while($row = mysql_fetch_assoc($resultObj)){
			$result[] = $row;
		}
		return $result[0];
	}

    /**
     * 获取任务所有标签
     * @access public
     * @param
     * @return array
     */
	function getTags($getNum=0){
		global $connection;
		$result = '';
		if($getNum==0){
			$sql = 'SELECT * FROM task_tag';
		}else{
			$sql = 'SELECT tt.*,COUNT(ttr.TAG_ID) AS TAG_USECOUNT FROM task_tag as tt
					LEFT JOIN task_tag_relation as ttr on tt.TAG_ID=ttr.TAG_ID
					GROUP BY tt.TAG_ID';
		}
		$resultObj = exequery($connection,$sql);
		while($row = mysql_fetch_assoc($resultObj)){
			$result[] = $row;
		}
		return $result;
	}

    /**
     * 获取任务标签
     * @access public
     * @param  int $task_id
     * @return array
     */
	function getTaskTags($task_id){
		global $connection;
		$result = '';
		$sql    = 'SELECT * FROM task_tag_relation AS ttr
					LEFT JOIN task_tag as tt ON ttr.TAG_ID=tt.TAG_ID';
		$sql   .=  ' WHERE ttr.TASK_ID = '.$task_id;
		$resultObj = exequery($connection,$sql);
		while($row = mysql_fetch_assoc($resultObj)){
			$result[] = $row;
		}
		return $result;
	}

    /**
     * 删除标签
     * @access public
     * @param  int $task_id
     * @return array
     */
	function tagDel($tag_id){
		global $connection;
		$sql = "DELETE FROM task_tag WHERE TAG_ID=".SecurityFilter($tag_id);
		$ok = exequery($connection,$sql);
		return $ok?1:0;
	}

    /**
     * 编辑标签
     * @access public
     * @param  int $task_id
     * @return array
     */
	function tagEdit($tag_id,$data){
		global $connection;
		$sql = "UPDATE task_tag set ";
		foreach($data as $k=>$v){
			$sql .= SecurityFilter($k)."='".SecurityFilter($v)."',";
		}
		$sql = rtrim($sql,",");
		$sql .= " WHERE TAG_ID=".SecurityFilter($tag_id);
		exequery($connection,$sql);
		$ok = exequery($connection,$sql);
		return $ok?1:0;
	}

    /**
     * 获取标签信息
     * @access public
     * @param  int $task_id
     * @return array
     */
	function getTagInfo($tag_id){
		global $connection;
		$info = '';
		$sql = 'SELECT tt.*,COUNT(ttr.TAG_ID) AS TAG_USECOUNT FROM task_tag as tt
					LEFT JOIN task_tag_relation as ttr on tt.TAG_ID=ttr.TAG_ID
					WHERE tt.TAG_ID='.SecurityFilter($tag_id).'
					GROUP BY tt.TAG_ID';
		$resultObj = exequery($connection,$sql);
		while($row = mysql_fetch_assoc($resultObj)){
			$info = $row;
		}
		return $info;
	}

    /**
     * 插入任务标签
     * @access public
     * @param  array $data
     * @return int
     */
	function addTaskTag($data){
		global $connection;
		$dataTag = array(
			'TAG_NAME' => $data['TAG_NAME'],
			'STATUS'   => 1
		);
		if(isset($data['TAG_REMARK'])) $dataTag['TAG_REMARK'] = $data['TAG_REMARK'];
		echo $this->taskInsert('task_tag',$dataTag);
	}


    /**
     * 获取任务文档
     * @access public
     * @param  array $data
     * @return int
     */
	function getTaskDoc($tid){
		global $connection;
		$tid = rtrim($tid,",");
		if(!empty($tid)){
			$sql  = "SELECT CONTENT_ID,SUBJECT FROM  file_content WHERE CONTENT_ID IN (".SecurityFilter($tid).")";
			$query = exequery($connection,$sql);
			while($row = mysql_fetch_assoc($query)){
				$res[] = $row;
			}
		}
		return isset($res)?$res:'';
	}
    /**
     * 删除文档
     * @access public
     * @param  array $data
     * @return int
     */
	function delDoc($data){
		global $connection;
		if(!empty($data['TASK_ID'])){
			$sql  = "SELECT CONTRAT_DOC FROM  task_manage WHERE TASK_ID=".SecurityFilter($data['TASK_ID']);
			$query = exequery($connection,$sql);
			while($row = mysql_fetch_array($query)){
				$res[] = $row;
			}
			$doc = str_replace($data['CONTRAT_DOC'].',','',$res[0]['CONTRAT_DOC'].',');
			$doc = rtrim($doc,',');
			if(!empty($data['CONTRAT_DOC'])){
				$sql  = "UPDATE task_manage
						SET CONTRAT_DOC='".SecurityFilter($doc)."'
						WHERE TASK_ID=".SecurityFilter($data['TASK_ID']);
				$query = exequery($connection,$sql);
			}
		}

		return isset($res)?$res:'';
	}

    /**
     * 更新附件
     * @access public
     * @param  array $data
     * @return int
     */
	function attachUpdate($tid,$attIds,$attNames){
		global $connection;
		$TASK_ID = (int)$tid;
		$ATTACHMENT_ID   = $attIds;
		$ATTACHMENT_NAME = $attNames;
		$ATTACHMENT_NAME = urldecode($ATTACHMENT_NAME);
		$sql   = "SELECT * FROM task_manage WHERE TASK_ID = ".SecurityFilter($TASK_ID)."";
		$query =  exequery($connection,$sql);
		if($row=mysql_fetch_assoc($query))
		{
			$ATTACHMENT_ID_OLD   =  ','.$row["ATTACHMENT_ID"];
			$ATTACHMENT_NAME_OLD =  '*'.$row["ATTACHMENT_NAME"];
		}

		if($ATTACHMENT_ID!="")
		{
			delete_attach($ATTACHMENT_ID,$ATTACHMENT_NAME);
			$ATTACHMENT_ID = ','.$ATTACHMENT_ID.',';
			$ATTACHMENT_ID = str_replace($ATTACHMENT_ID,',',$ATTACHMENT_ID_OLD);
			$ATTACHMENT_ID = substr($ATTACHMENT_ID,1);
			$a_name = $ATTACHMENT_NAME;
			$ATTACHMENT_NAME = '*'.$ATTACHMENT_NAME.'*';
			$ATTACHMENT_NAME = str_replace($ATTACHMENT_NAME,'*',$ATTACHMENT_NAME_OLD);
			$ATTACHMENT_NAME = substr($ATTACHMENT_NAME,1);
			$query = "UPDATE task_manage
						SET ATTACHMENT_ID='".SecurityFilter($ATTACHMENT_ID)."',ATTACHMENT_NAME='".SecurityFilter($ATTACHMENT_NAME)."'
						WHERE TASK_ID = ".SecurityFilter($TASK_ID)."";
			exequery($connection,$query);
		}
	}

    /**
     * 添加附件
     * @access public
     * @param  array $data
     * @return int
     */
	function attAdd($data){
		global $connection;
		$this->insertAll('task_attachments',$data);

	}

    /**
     * 添加附件
     * @access public
     * @param  array $data
     * @return int
     */
	function attDel($task_att_id){
		global $connection;
		$sql = "DELETE FROM task_attachments WHERE TASK_ATT_ID = ".SecurityFilter($task_att_id);
		exequery($connection,$sql);
	}

	/*
	@function:  项目类型列表数据
	@return:    $dataInfor->    array : 字段数组
	*/
	public function tagListData($where){
		global $connection;
		$infor = array();
		$search_all    = "SELECT * FROM  task_tag WHERE 1 ";
		$query .= " AND TAG_NAME LIKE'%".SecurityFilter($where)."%'";
		$query .= " ORDER BY TAG_ID ASC";
		$search = $search_all.$query;
		$cursor = exequery($connection,$search);
		while($row = mysql_fetch_assoc($cursor)){
			$infor[] = $row;
		}
		return 	$infor;
	}

    /**
     * 删除关于任务的标签
     * @access public
     * @param  int $task_id;
     * @return int
     */
	function deleteTaskTags($task_id){
		global $connection;
		$sql = "DELETE FROM task_tag_relation WHERE TASK_ID=".SecurityFilter($task_id);
		$ok = exequery($connection,$sql);
		return $ok?1:0;
	}

    /**
     * 删除关于任务的标签
     * @access public
     * @param  int $task_id;
     * @return int
     */
	function deleteTaskTag($task_id,$tag_id){
		global $connection;
		$sql = "DELETE FROM task_tag_relation WHERE TASK_ID=".SecurityFilter($task_id)." AND TAG_ID=".SecurityFilter($tag_id);
		$ok = exequery($connection,$sql);
		return $ok?1:0;
	}

    /**
     * 添加任务的标签
     * @access public
     * @param  array $data;
     * @return int
     */
	function addTaskTags($data){
		return $this->insertAll('task_tag_relation',$data);
	}

    /**
     * 参与类型
     * @access public
     * @param  array $data;
     * @return int
     */
	function getJoinType($tid){
		global $connection;
		$sql    = "SELECT USER_TYPE FROM task_user WHERE TASK_ID=".SecurityFilter($tid)." AND USER_ID = '".$_SESSION['LOGIN_USER_ID']."' ORDER BY USER_TYPE ASC LIMIT 1";
		$resultObj = exequery($connection,$sql);
		if($row = mysql_fetch_assoc($resultObj)){
			return $row['USER_TYPE'];
		}else{
			return -1;
		}
	}

    /**
     * 获取关于任务的人员
     * @access public
     * @param  int $task_id;$type:1返回array,2返回字符串
     * @return array
     */
	function getUsers($task_id,$type=1){
		global $connection;
		$result = array();
		$sql    = 'SELECT tu.*,u.USER_NAME FROM task_user AS tu LEFT JOIN user as u ON tu.USER_ID = u.USER_ID WHERE tu.TASK_ID = '.SecurityFilter($task_id);
		$resultObj = exequery($connection,$sql);
		while($row = mysql_fetch_assoc($resultObj)){
			if($type == 1){
				if($row['USER_TYPE']==1){
					$result['join'][] = $row;
				}else if($row['USER_TYPE']==2){
					$result['attention'] = $row;
				}else if($row['USER_TYPE']==3){
					$result['share'][] = $row;
				}
			}else if($type == 2){
				if($row['USER_TYPE']==1){
					$result['join']['user_id'] .= $row['USER_ID'].',';
					$result['join']['user_name'] .= $row['USER_NAME'].',';
				}else if($row['USER_TYPE']==2){
					$result['attention']['user_id'] .= $row['USER_ID'].',';
					$result['attention']['user_name'] .= $row['USER_NAME'].',';
				}else if($row['USER_TYPE']==3){
					$result['share']['user_id'] .= $row['USER_ID'].',';
					$result['share']['user_name'] .= $row['USER_NAME'].',';
				}
			}
		}
		return $result;
	}
    /**
     * 添加关于任务的人员
     * @access public
     * @param  array $data;
     * @return int
     */
	function addUsers($data){
		return $this->insertAll('task_user',$data);
	}

    /**
     * 删除关于任务的人员
     * @access public
     * @param  int $task_id;
     * @return int
     */
	function deleteUsers($task_id,$participate=''){
		global $connection;
		$sql = "DELETE FROM task_user
				WHERE (USER_TYPE=1 OR USER_TYPE=3) AND TASK_ID=".SecurityFilter($task_id);
		$ok = exequery($connection,$sql);
		$sql = "DELETE FROM task_user
				WHERE TASK_ID='".SecurityFilter($task_id)."' AND USER_TYPE=2";
		if(!empty($participate)){
			$participate = str_replace(",","','",trim($participate,','));
			$sql .= " AND USER_ID NOT IN('".SecurityFilter($participate)."')";
		}
		exequery($connection,$sql);
		return $ok?1:0;
	}


    /**
     * 删除关于任务的人员
     * @access public
     * @param  arr $data;
     * @return int
     */
	function deleteSingeUsers($data){
		global $connection;
		$sql = "DELETE FROM task_user
				WHERE TASK_ID='".SecurityFilter($data['TASK_ID'])."' AND USER_ID='".SecurityFilter($data['USER_ID'])."' ";
		if($data['USER_TYPE']==1){
			$sql .= "AND (USER_TYPE=1 OR USER_TYPE=2)";
		}else{
			$sql .= "AND USER_TYPE='".SecurityFilter($data['USER_TYPE'])."' LIMIT 1";
		}
		$ok = exequery($connection,$sql);
		return $ok?1:0;
	}

    /**
     * 批量插入数据
     * @access public
     * @param  array $data;
     * @return int
     */
    public function insertAll($table,$datas) {
    	global $connection;
        if(!is_array($datas[0])) return false;
        $fields = array_keys($datas[0]);
        array_walk($fields, array($this, 'parseKey'));
        $values  =  array();
        foreach ($datas as $data){
            $value   =  array();
            foreach ($data as $key=>$val){
                $val   =  SecurityFilter($this->parseValue($val));
                if(is_scalar($val)) { // 过滤非标量数据
                    $value[]   =  $val;
                }
            }
            $values[]    = '('.implode(',', $value).')';
        }
        $sql   =  'INSERT INTO '.SecurityFilter($table).' ('.implode(',', $fields).') VALUES '.implode(',',$values);
        $ok = exequery($connection,$sql);
		return $ok?1:0;
    }


   /**
     * 插入任务反馈
     * @access public
     * @param  array $data
     * @return array
     */
	function addTaskFeedback($param){
		global $connection;
		$data = array(
			'FB_CONTENT' => $param['FB_CONTENT'],
			'FB_DATE'    => date("Y-m-d H:i:s"),
			'FB_USER_ID' => $_SESSION['LOGIN_USER_ID'],
			'TASK_ID'    => $param['TASK_ID'],
		);
		$data['FB_ID'] = $this->taskInsert('task_feedback',$data);
		return $data;
	}

   /**
     * 查询任务反馈
     * @access public
     * @param  array $data
     * @return array
     */
	function feedbackSelect($param){
		global $connection;
		$perPage   = 5;
		$page      = isset($param['page'])?($param['page']-1)*$perPage:0;
		$pageNext  = isset($param['page'])?$param['page']*$perPage:5;
		$result    = array();
		$sql       = 'SELECT tf.*,u.USER_NAME,u.USER_ID FROM task_feedback AS tf
						LEFT JOIN user AS u ON u.USER_ID=tf.FB_USER_ID
 						WHERE TASK_ID = '.SecurityFilter($param['TASK_ID']).'
		 				 ORDER BY FB_ID DESC';
		$sqlPage   	   =  $sql.' LIMIT '.SecurityFilter($page).','.SecurityFilter($perPage);
		$sqlNextPage   =  $sql.' LIMIT '.SecurityFilter($pageNext).','.SecurityFilter($perPage);

		$resultObj = exequery($connection,$sqlPage);
		while($row = mysql_fetch_assoc($resultObj)){
			$result['con'][] = $row;
		}
		$resultObj = exequery($connection,$sqlNextPage);
		$result['num'] = mysql_num_rows($resultObj);
		return $result;
	}

    /**
     * 记录日志
     * @access public
     * @param array $data
     * @return int
     */
	function taskLogRecord($task_id,$con){
		$data = array(
				'LOG_TIME' => date("Y-m-d H:i:s"),
				'USER_ID'  =>  $_SESSION['LOGIN_USER_ID'],
				'TASK_ID'  =>  $task_id,
				'LOG_CON'  =>  $con
			);
		return $this->taskInsert('task_log',$data);
	}

    /**
     * 记录日志
     * @access public
     * @param array $param
     * @return int
     */
	function taskLogFind($param){
		global $connection;
		$perPage = 5;
		$result = array();
		$page      = isset($param['page'])?($param['page']-1)*$perPage:0;
		$pageNext  = isset($param['page'])?$param['page']*$perPage:5;
		$sql    = 'SELECT tl.*,u.USER_NAME FROM task_log AS tl
					LEFT JOIN user as u ON tl.USER_ID = u.USER_ID
					WHERE tl.TASK_ID = '.SecurityFilter($param['TASK_ID']).'
					 ORDER BY tl.LOG_ID DESC';
		$sqlPage   	   =  $sql.' LIMIT '.SecurityFilter($page).','.SecurityFilter($perPage);
		$sqlNextPage   =  $sql.' LIMIT '.SecurityFilter($pageNext).','.SecurityFilter($perPage);

		$resultObj = exequery($connection,$sqlPage);
		while($row = mysql_fetch_assoc($resultObj)){
			$result['con'][] = $row;
		}
		$resultObj = exequery($connection,$sqlNextPage);
		$result['num'] = mysql_num_rows($resultObj);
		return $result;
	}

    /**
     * 获取任务统计总数
     * @access public
     * @param array $param
     * @return int
     */
	function getTaskTotalNum($sql){
		global $connection;
		$res  = exequery($connection,$sql);
		return @mysql_num_rows($res);
	}
    /**
     * 获取任务统计页数
     * @access public
     * @param array $param
     * @return int
     */
	function getPageNum($sql){
		global $connection;
		$rs = exequery($connection,$sql);
		return @mysql_num_rows($rs);
	}
   /**
     * 获取任务信息
     * @access public
     * @param array $param
     * @return int
     */
	function getTaskInfo($sql,$list=''){
		global $connection;
		$taskInfo = array();
		$rs = exequery($connection,$sql);
		while($row = @mysql_fetch_array($rs)) {
			if($list='list'){
				if($row['TASK_TALL']>0){
					$row['TASK_COMPLATE'] = round($row['TASK_OVER']/$row['TASK_TALL'],2)*100;
					$row['TASK_COMPLATE'] = $row['TASK_COMPLATE'].'%';
				}else{
					$row['TASK_COMPLATE'] = '-';
				}
			}
			array_push($taskInfo,$row);
		}
		return $taskInfo;
	}


    /**
     * 任务统计sql
     * @access public
     * @param array $param
     * @return int
     */
	function getTaskStatistic($data){
		global $connection;
		$list = isset($_REQUEST["list"])&&$_REQUEST["list"]=='list'?'list':'';
		$userType  = array(0,0);
		$startDate = '';
		$endDate   = '';
		$dept      = '';

		$itemsPerPage = $data["itemsPerPage"];
		$startRow     = $data["currentPage"]*$itemsPerPage;


		if(isset($data['searchData'])){
			parse_str($data['searchData'],$searchArr);
			$userType  = !empty($searchArr["USER_TYPE"])?$searchArr["USER_TYPE"]:array(0,0);
			$startDate = !empty($searchArr["START_DATE"])?strtotime($searchArr["START_DATE"]):'';
			$endDate   = !empty($searchArr["END_DATE"])?strtotime($searchArr["END_DATE"])+86400:'';
			$dept      = !empty($searchArr["DEPT"])?trim($searchArr["DEPT"],','):'';
		}

		$sql_count = 'SELECT COUNT(DISTINCT u.USER_ID) as num ';
		$sql_select = 'SELECT u.USER_NAME,d.DEPT_NAME,
					COUNT(tm.TASK_STATUS>0 OR NULL) TASK_TALL,
					COUNT(tm.TASK_STATUS=2 OR NULL) TASK_OVER,
					COUNT((tm.END_DATE < '.time().' AND tm.END_DATE>0 AND tm.TASK_STATUS=1) OR NULL) TASK_DELAY,
					COUNT(((tm.END_DATE > '.time().' OR tm.END_DATE=0) AND tm.TASK_STATUS=1) OR NULL) TASK_DOING';

		$sql_from 	= 	' FROM user AS u ';

		$sql_join 	= 	' LEFT JOIN department AS d ON u.DEPT_ID=d.DEPT_ID ';

		if(($userType[0]==0&&$userType[1]==0)||($userType[0]==1&&$userType[1]==3)){
			$sql_join .= 'LEFT JOIN task_user AS tu ON u.USER_ID=tu.USER_ID AND (tu.USER_TYPE=0 OR tu.USER_TYPE=1 OR tu.USER_TYPE=3)
					   LEFT JOIN task_manage AS tm ON tu.task_id=tm.task_id AND tm.TASK_STATUS > 0 ';
		}else if($userType[0]==1&&$userType[1]==0){
			$sql_join .= 'LEFT JOIN task_user AS tu ON u.USER_ID=tu.USER_ID AND (tu.USER_TYPE=0 OR tu.USER_TYPE=1)
					   LEFT JOIN task_manage AS tm ON tu.task_id=tm.task_id AND tm.TASK_STATUS > 0 ';
		}else{
			$sql_join .= 'LEFT JOIN task_user AS tu ON u.USER_ID=tu.USER_ID AND tu.USER_TYPE=3
					   LEFT JOIN task_manage AS tm ON tu.task_id=tm.task_id AND tm.TASK_STATUS > 0 ';
		}

		$sql_where = 'WHERE u.USER_ACCOUNTS!="" AND USER_STATUS=1 ';
		if(!empty($startDate)){
			$sql_where .= ' AND tm.END_DATE > '.SecurityFilter($startDate);
		}
		if(!empty($endDate)){
			$sql_where .= ' AND tm.END_DATE < '.SecurityFilter($endDate);
		}
		if(!empty($dept)){
			$sql_where .= ' AND d.DEPT_ID IN('.SecurityFilter($dept).')';
		}
		$sql_where .= $data["USER_NAME"] != ""?" AND u.USER_NAME LIKE '%".SecurityFilter($data["USER_NAME"])."%' ":"";

		if(empty($dept)&&empty($startDate)&&empty($dept)&&empty($data["USER_NAME"])){
			$sql_count = "SELECT COUNT(*) as num from user WHERE USER_ACCOUNTS!='' AND USER_STATUS=1";
		}else{
			$sql_count = $sql_count.$sql_from.$sql_join.$sql_where;
		}

		$query_nums  = exequery($connection,$sql_count);
		if($row = mysql_fetch_array($query_nums)){
			$totalCount = $row['num'] ;
		}


		$sql_group = ' GROUP BY u.USER_ID';

		if(!empty($data['sortField'])){
			$sortType  = $data['sortType'] != ""?$data['sortType']:"DESC";
			$sql_order = ' ORDER BY '.SecurityFilter($data['sortField']).' '.SecurityFilter($sortType);
		}else{
			$sql_order = ' ';
		}

		$sql_limit = " LIMIT ".SecurityFilter($startRow).",".SecurityFilter($itemsPerPage);

		if($data['sortField']=='USER_NAME'||$data['sortField']=='DEPT_ID'){

			$sql_order = ' ORDER BY '.SecurityFilter($data['sortField']).' '.SecurityFilter($sortType);

			$sql_from = " FROM (SELECT * FROM USER WHERE DEPT_ID>0 ".$sql_order." ".$sql_limit.") AS u ";

			$sql = $sql_select.$sql_from.$sql_join.$sql_where.$sql_group;
		}else{
			$sql = $sql_select.$sql_from.$sql_join.$sql_where.$sql_group.$sql_order.$sql_limit;
		}

		$taskList = $this->getTaskInfo($sql,$list);

		return array("totalCount"=>$totalCount,"list"=>$taskList);
	}

    /**
     * 插入数据
     * @access private
     * @param array $value
     * @return int
     */
	private function taskInsert($table,$data){
		global $connection;
		$fields = $values = array();
		foreach($data as $k=>$v){
			$k = SecurityFilter($k);
			$fields[] = $this->parseKey($k);
			$v = SecurityFilter($v);
			$values[] = $this->parseValue($v);
		}

		$sql = 'INSERT INTO '.$table.' ('.implode(',', $fields).') VALUES ('.implode(',', $values).')';
		mysql_query("SET NAMES 'utf8'");
		mysql_query($sql,$connection);
		$insertId = mysql_insert_id();
		return $insertId?$insertId:0;
	}

    /**
     * 字段和表名处理添加`
     * @access protected
     * @param string $key
     * @return string
     */
    protected function parseKey(&$key) {
        $key   =  trim($key);
        if(!preg_match('/[,\'\"\*\(\)`.\s]/',$key)) {
           $key = '`'.$key.'`';
        }
        return $key;
    }

    /**
     * value分析
     * @access protected
     * @param mixed $value
     * @return string
     */
    private function parseValue($value) {
        if(is_string($value)) {
            $value =  '\''.$this->escapeString($value).'\'';
        }elseif(is_bool($value)){
            $value =  $value ? '1' : '0';
        }elseif(is_null($value)){
            $value =  'null';
        }
        return $value;
    }

    /**
     * SQL指令安全过滤
     * @access public
     * @param string $str  SQL字符串
     * @return string
    */
    private function escapeString($str) {
    	global $connection;
        if($connection) {
            return mysql_real_escape_string($str,$connection);
        }else{
            return mysql_escape_string($str);
        }
    }

    /**
     * 删除提醒
     * @param string $where 删除条件
     * @return bool
    */
    public function deleteOldMessage($where) {
    	global $connection;
		$sql = "DELETE FROM sms WHERE ".$where;
		mysql_query($sql, $connection);
    }


}