<?php
/**
* @copyright (C) 2010 - 2011 Weaver Co.Ltd
* @package       eoffice8.0
* @function      流程类的基类
* @encoding      $_lang['encoding']
* @name          api/workflow.class.php
* @version       8
* @author        sun|www.weaver.com.cn
* @modify        sunx
* @date          2012-01-12
*/
include_once("inc/flow_doc_class.php");
/**
* 这是流程的基类
* @access public
* @auth  sunxiang
*/
class workflow
{
	protected $flowId        ;
	protected $flowName      ;
	protected $formId        ;
	protected $flowDoc       ;
	protected $flowLink      ;
	protected $flowType      ;
	protected $manageUser    ;
	protected $flowSort      ;
	protected $flowSequence  ;
	protected $flowNooder    ;
	protected $handWay       ;
	protected $counterSign   ;
	protected $canEditFlowNo ;

	public    $runId         ;
	public    $runName       ;
	public    $runSeq        ;

	/**
	*构造函数
	*@param  int  $flow_id 流程类别id
	*@return void
	*/
	function __construct($flow_id)
	{
		global $connection,$_lang;
		$this->flowId  = SecurityFilter($flow_id)  ;
		$this->runId = SecurityFilter($this->runId);
		$sql = "SELECT * FROM flow_type WHERE FLOW_ID = '".$this->flowId."'";
		$rs  = exequery($connection,$sql);
		if($rows = mysql_fetch_array($rs))
		{
			$this->flowName      = $rows["FLOW_NAME"]       ;
			$this->formId        = $rows["FORM_ID"]         ;
			$this->flowDoc       = $rows["FLOW_DOC"]        ;
			$this->flowLink      = $rows["FLOW_LINK"]       ;
			$this->flowType      = $rows["FLOW_TYPE"]       ;
			$this->manageUser    = $rows["MANAGE_USER"]     ;
			$this->flowSort      = $rows["FLOW_SORT"]       ;
			$this->flowSequence  = $rows["FLOW_SEQUENCE"]   ;
			$this->flowNooder    = $rows["FLOW_NOORDER"]    ;
			$this->handWay       = $rows["HANDLE_WAY"]      ;
			$this->counterSign   = $rows["COUNTERSIGN"]     ;
			$this->canEditFlowNo = $rows["CAN_EDIT_FLOWNO"];
			$this->isUsing       = $rows["IS_USING"];
		}
		else
		{
			Message("",$_lang["flow_may_be_deleted"]);
			exit;
		}
	}
	/**
	*赋值函数
	*@access public
	*@param  str  $property 变量名
	*@param  str  $value    变量值
	*@return void
	*/
	function __set($property,$value)
	{
		$this->$property = $value;
	}
	/**
	*获值函数
	*@access public
	*@param  str  $property   变量名
	*@return $this->$property 对应属性的值
	*/
	function __get($property)
	{
		return $this->$property;
	}
	/**
	*判断流程是否结束
	*@access public
	*@return blooen true/false
	*/
	function isEnd()
	{
		global $connection;
		$isEndSql = "SELECT CURRENT_STEP FROM flow_run WHERE RUN_ID = '".$this->runId."'";
		$rs       = exequery($connection,$isEndSql);
		$row      = mysql_fetch_array($rs);
		if($row["CURRENT_STEP"] ==0)
			return true;
		else
			return false;
	}
	/**
	*保存表单函数（把保存表单字段SAVEFORM_TIME，赋值）
	*@access public
	*@param  int  $prcsId   步骤id
	*@return void
	*/
	function saveForm($prcsId,$userId="",$updateUserRunType="")
	{
		global $connection;
		if($userId=="")
		{
			$currentID = $_SESSION['LOGIN_USER_ID'];
		}
		else
		{
			$currentID = SecurityFilter($userId);
		}
		$saveFormTime = date("Y-m-d H:i:s",time());
		//增加判断流程是否结束,如果结束了,经办人提交流程应该将 PRCS_FLAG 改为4,未结束的保持原来的不变
		if($this->isEnd()) {
			$query = "UPDATE flow_run_prcs SET  SAVEFORM_TIME='".$saveFormTime."',PRCS_FLAG ='4' WHERE RUN_ID='".$this->runId."' AND USER_ID='".$currentID."' AND ((SAVEFORM_TIME = '0000-00-00 00:00:00') OR (SAVEFORM_TIME is NULL))" ;
			//更新flow_run_step
			$query2 = "UPDATE flow_run fr,flow_run_step frs SET frs.USER_RUN_TYPE = '3' WHERE fr.run_id = frs.run_id AND fr.run_id = '".$this->runId."' AND frs.USER_ID = '".$currentID."'";
		} else {
			$query = "UPDATE flow_run_prcs SET  SAVEFORM_TIME='".$saveFormTime."' WHERE RUN_ID='".$this->runId."' AND USER_ID='".$currentID."' AND ((SAVEFORM_TIME = '0000-00-00 00:00:00') OR (SAVEFORM_TIME is NULL)) AND PRCS_TIME !='0000-00-00 00:00:00' AND PRCS_TIME IS NOT NULL" ;
			if($updateUserRunType == "")
				$query2 = "UPDATE flow_run fr,flow_run_step frs SET frs.USER_RUN_TYPE = '2' WHERE fr.run_id = frs.run_id AND fr.run_id = '".$this->runId."' AND frs.USER_ID = '".$currentID."'";
		}
		exequery($connection,$query);
		if($query2)
			exequery($connection,$query2);
	}
	/**
	*保存表单内容函数
	*@access public
	*@param  array $formItemValue   表单数据
	*@param  str   $docId   关联文档id组合
	*@return void
	*/
	function autoSave($formItemValue,$docId,$formItemValueNew='',$runId='')
	{
		global $connection;
		if($runId != "") {
			$this->runId = SecurityFilter($runId);
		}
		//新的流程结构，保存数据到新的表中
		$updateField  = "";
		if(count($formItemValue)) {
			foreach ($formItemValue as $key => $value) {
				$key = SecurityFilter($key);
				$value = SecurityFilter($value);
				// 新数据update字符串拼接
				$updateField .= "DATA_".$key." = '".$value."'," ;

				// 旧数据处理
				$query  = "SELECT * FROM flow_run_data WHERE RUN_ID='".$this->runId."' AND ITEM_ID='".$key."'";
				$cursor = exequery($connection,$query);
				if(mysql_fetch_array($cursor)) {
					$query = "UPDATE flow_run_data SET ITEM_DATA='".$value."' WHERE RUN_ID='".$this->runId."' AND ITEM_ID='".$key."'";
				} else {
					$query="INSERT INTO flow_run_data (RUN_ID,ITEM_ID,ITEM_DATA) VALUES ($this->runId,$key,'".$value."')";
				}
				exequery($connection, $query);
			}
		}
		$updateField = SecurityFilter(trim($updateField,","));
		//新版流程数据保存到对应的物理表中
		$saveSql = "UPDATE zzzz_flow_data_$this->formId SET ".$updateField." WHERE RUN_ID = '".$this->runId."' ";
		exequery($connection,$saveSql);
		if(!empty($this->runSeq)){
			$sql = "UPDATE flow_run SET RUN_NAME='".SecurityFilter($this->runName)."',LINK_DOC = '".$docId."' ,RUN_SEQ = '".$this->runSeq."' WHERE RUN_ID=".$this->runId;
			//新结构需要处理的数据
			$sqlNew = "UPDATE zzzz_flow_data_$this->formId SET RUN_NAME='".SecurityFilter($this->runName)."' , RUN_SEQ = '".$this->runSeq."' WHERE RUN_ID=".$this->runId;
		}else{
			//$this->runSeq为空时，为新建流程，如果新建时流水号被修改修改时已经保存无需再次保存，如果未修改，也无需再次保存
			$sql = "UPDATE flow_run SET RUN_NAME='".SecurityFilter($this->runName)."',LINK_DOC = '".SecurityFilter($docId)."'  WHERE RUN_ID=".$this->runId;
			//新结构需要处理的数据
			$sqlNew = "UPDATE zzzz_flow_data_$this->formId SET RUN_NAME='".($this->runName)."' WHERE RUN_ID=".$this->runId;
		}
		$rs = exequery($connection,$sqlNew);
		$rs = exequery($connection,$sql);
		return $rs;
	}


	/**
	*经办人保存表单会签内容函数
	*@access public
	*@param  array $formItemValue   表单数据
	*@return void
	*/
	function savejointlysign($formItemValue,$formItemValueNew='',$formCLassArrayNew="")
	{
		global $connection;
		//新的流程结构，保存数据到新的表中
		$updateField  = "";
		foreach ($formItemValue as $key => $value) {
			$key = SecurityFilter($key);
			$value = SecurityFilter($value);
			// 新数据update字符串拼接
			if($formCLassArrayNew[$key] == "SIGNATURE_PICTURE") {
				$updateField .= "DATA_".$key." = '".SecurityFilter($formItemValueNew[$key])."'," ;
			} else {
				if($value)
					$updateField .= "DATA_".$key." = '".$value."'," ;
			}
			// 旧数据处理
			$query  = "SELECT * FROM flow_run_data WHERE RUN_ID='".$this->runId."' AND ITEM_ID='".$key."'";
			$cursor = exequery($connection,$query);
			if(mysql_fetch_array($cursor)) {
				$query = "UPDATE flow_run_data SET ITEM_DATA='".$value."' WHERE RUN_ID='".$this->runId."' AND ITEM_ID='".$key."'";
			} else {
				$query="INSERT INTO flow_run_data (RUN_ID,ITEM_ID,ITEM_DATA) VALUES ($this->runId,$key,'".$value."')";
			}
			exequery($connection, $query);
		}
		$updateField = trim($updateField,",");

		if($updateField) {
			//新版流程数据保存到对应的物理表中
			$saveSql = "UPDATE zzzz_flow_data_".SecurityFilter($this->formId)." SET ".$updateField." WHERE RUN_ID = '".$this->runId."' ";
			exequery($connection,$saveSql);
		}
	}
	/**
	*获取流程配置中的其它信
	*@access public
	*@return str $returnStr(其它配置信息组成的字符串)
	*/
	function getOtherSetInfo()
	{
		global $connection;
		$sql = "SELECT * FROM flow_others WHERE FLOW_ID = '".$this->flowId."'";
		$rs  = exequery($connection,$sql);
		if($row = mysql_fetch_array($rs)){
			$FLOW_SHOW_TEXT		= $row['FLOW_SHOW_TEXT'];
			$FLOW_AUTOSAVE		= $row['FLOW_AUTOSAVE'];
			$LABLE_SHOW_DEFAULT	= $row['LABLE_SHOW_DEFAULT'];
			$FLOW_AUTOSAVE_TIME = getFieldPara('FLOW_FREQUENCY');
		}
		else
		{
			$FLOW_SHOW_TEXT		= 1;
			$LABLE_SHOW_DEFAULT = 1;
			$FLOW_AUTOSAVE		= 0;
			$FLOW_AUTOSAVE_TIME = 0;
		}
		$returnStr = "$FLOW_SHOW_TEXT|$LABLE_SHOW_DEFAULT|$FLOW_AUTOSAVE|$FLOW_AUTOSAVE_TIME";
		return $returnStr;
	}
	/**
	*获取流程定义好的最大步骤
	*@access public
	*@return int $prcsMax
	*/
	function getMaxPrcsId()
	{
		global $connection;
		$query    = "SELECT MAX(PRCS_ID) FROM flow_process WHERE FLOW_ID = '".$this->flowId."'";
		$prcsMax  = 0;
		$cursor   = exequery($connection,$query);
		if($rows  = mysql_fetch_array($cursor))
		{
			$prcsMax = $rows[0];
		}
		return $prcsMax;
	}
	/**
	*获取用户是否是主办人
	*@access public
	*@param  str $userId   用户id
	*@param  int $prcsId   流程当前步骤
	*@return int $OP_FLAG  0，非主办人，1是主办人
	*/
	function isOpFlag($userId,$prcsId)
	{
		global $connection;
		$query   = "SELECT OP_FLAG FROM flow_run_prcs WHERE RUN_ID = '".$this->runId."' AND USER_ID='".SecurityFilter($userId)."' AND PRCS_ID = '".SecurityFilter($prcsId)."'";

		$cursor  = exequery($connection,$query);
		while($rows = mysql_fetch_array($cursor))
		{
			$OP_FLAG = $rows['OP_FLAG'];
			if($OP_FLAG == 1)
				break;
		}
		return $OP_FLAG;
	}
	/**
	*获取运行中某个流程的信息
	*@access public
	*@return array $rows|array()
	*/
	function flowRunningInfo()
	{
		global $connection;
		$sql = "SELECT * FROM flow_run WHERE RUN_ID = '".$this->runId."'";
		$rs  = exequery($connection,$sql);
		if($rows = mysql_fetch_array($rs,MYSQL_ASSOC))
		{
			$this->runName = $rows["RUN_NAME"];
			$this->runSeq  = $rows["RUN_SEQ"];
			return $rows;
			//$this->runName = $rows["RUN_NAME"];
		}
		else
			return array();
	}
	/**
	*将流程标志为用户已接收状态
	*@access public
	*@param  str $userId   用户id
	*@param  int $prcsId   流程当前步骤
	*@return void
	*/
	function markHaveReceive($userId,$prcsId)
	{
		global $connection;
		$userId = SecurityFilter($userId);
		$prcsId = SecurityFilter($prcsId);
		$curTime = date("Y-m-d H:i:s",time());
		$maxSql  = "SELECT MAX(PRCS_FLAG) AS MAX_PRCS_FLAG FROM flow_run_prcs WHERE USER_ID='".$userId."' AND RUN_ID = '".$this->runId."' AND PRCS_ID = '".$prcsId."'";
		$maxRs   = exequery($connection,$maxSql);
		if($maxRow= mysql_fetch_array($maxRs))
			$MAX_PRCS_FLAG = SecurityFilter($maxRow["MAX_PRCS_FLAG"]);
		//主办人尚未提交到下一步

		if($MAX_PRCS_FLAG==1||$MAX_PRCS_FLAG==2)
		{
			$query = "UPDATE flow_run_prcs SET PRCS_FLAG='2',PRCS_TIME='".$curTime."' WHERE USER_ID='".$userId."' AND RUN_ID='".$this->runId."' AND PRCS_ID='".$prcsId."' AND PRCS_TIME IS NULL ";
		}
		else//主办人已经提交到下一步
		{
			$query = "UPDATE flow_run_prcs SET PRCS_FLAG = '".$MAX_PRCS_FLAG."',PRCS_TIME = '".$curTime."' WHERE USER_ID='".$userId."' AND RUN_ID = '".$this->runId."' AND PRCS_ID = '".$prcsId."' AND PRCS_TIME IS NULL";
		}
		exequery($connection,$query);
		//更新flow_run_step
		$query = "UPDATE flow_run fr,flow_run_step frs SET frs.PRCS_TIME='".$curTime."' WHERE fr.run_id = frs.run_id AND fr.run_id = '".$this->runId."' AND frs.USER_ID = '".$userId."' AND frs.PRCS_TIME IS NULL";
		exequery($connection,$query);
		//一旦执行此函数，则将自己的所有步骤的为空的PRCS_TIME赋值
		$sql = "UPDATE flow_run_prcs SET PRCS_TIME = '".$curTime."' WHERE USER_ID='".$userId."' AND RUN_ID='".$this->runId."' AND ((PRCS_TIME = '0000-00-00 00:00:00') OR (PRCS_TIME is NULL)) AND PRCS_ID <= $prcsId";
		exequery($connection,$sql);
		//一旦有人查看了，则上一步的PRCS_FLAG将变成4
		$prcsIdPre = $prcsId - 1;
		$query     = "UPDATE flow_run_prcs SET PRCS_FLAG = '4' WHERE RUN_ID='".$this->runId."' AND PRCS_ID = '".SecurityFilter($prcsIdPre)."'";
		exequery($connection,$query);
		//标记为已查看抄送
		$this->markFlowCopyHaveReceive($userId);
	}
	/**
	*获取当前节点尚未办理的人
	*@access public
	*@param  int $prcsId   流程当前步骤
	*@return array $neverSignName
	*/
	function getNeverSignPerson($prcsId,$userid="")
	{
		global $connection;
		if($userid!=""){
			$UserID = $userid;
		}else{
			$UserID = $_SESSION['LOGIN_USER_ID'];
		}
		$sqlmu = "SELECT u.USER_NAME,u.USER_ID FROM user u,flow_run_prcs frp WHERE RUN_ID = '".$this->runId."' AND PRCS_ID=".SecurityFilter($prcsId)." AND u.USER_ID=frp.USER_ID AND frp.USER_ID != '".SecurityFilter($UserID)."' AND frp.OP_FLAG<>1 AND (frp.PRCS_FLAG=1 OR (frp.PRCS_FLAG=2 AND frp.SAVEFORM_TIME IS NULL))";
		$rsmu  = exequery($connection,$sqlmu);
		$key = 0;
		while($rowsmu = mysql_fetch_array($rsmu))
		{
			$neverSignName[$key]['user_name'] = $rowsmu["USER_NAME"];
			$neverSignName[$key]['user_id'] = $rowsmu["USER_ID"];
			$key++;
		}
		return $neverSignName;
	}
	/**
	*动态设置主办人
	*@access public
	*@param  int $prcsOptype 流程定义的动态主办人信息
	*@param  int $prcsId     流程当前步骤
	*@param  int $flowPrcs   当前步骤对于流程设计的哪个节点
	*@param  str $userId     当前用户id
	*@return void
	*/
	function setOpFlag($prcsOptype,$prcsId,$flowPrcs,$userId,$fromType="")
	{
		global $connection;
		switch($prcsOptype){
			//第一个接收设置为主办人
			case 1:
				//判断是否已经确定主办人了,如果是则不去修改主办人,原因是监控提交须确定主办人,可能出现监控设置了主办人,等经办人回来查看时再被设为主办人
				$maxOpFlag = $this->opFlagIsExist($prcsId);
				if($maxOpFlag > 0)
				{
					return ;
				}
				$sql = "SELECT COUNT(*) AS cnt FROM flow_run_prcs WHERE RUN_ID = '".$this->runId."' AND PRCS_ID = '".SecurityFilter($prcsId)."' AND FLOW_PRCS = '".SecurityFilter($flowPrcs)."' AND PRCS_TIME IS NOT NULL";
				$rs  = exequery($connection,$sql);
				$row = mysql_fetch_array($rs);
				$haveOpTag = $row['cnt'];
				if($haveOpTag == 0){
					$sql = "UPDATE flow_run_prcs SET OP_FLAG=1 WHERE RUN_ID = '".$this->runId."' AND PRCS_ID = '".SecurityFilter($prcsId)."' AND FLOW_PRCS = '".SecurityFilter($flowPrcs)."' AND USER_ID='".SecurityFilter($userId)."'";
					exequery($connection,$sql);
					//更新flow_run_step
					$query = "UPDATE flow_run fr,flow_run_step frs SET frs.OP_FLAG=1 WHERE fr.run_id = frs.run_id AND fr.run_id = '".$this->runId."' AND frs.USER_ID = '".SecurityFilter($userId)."'";
					exequery($connection,$query);
				}
			break;
			//最后一个接收设置为主办人
			case 2:
				//判断是否已经将某个人设为主办人了,用于修改bug3504,最后办理人为主办人时又转发出现的问题
				$maxOpFlag = $this->opFlagIsExist($prcsId);
				if($maxOpFlag > 0)
				{
					return ;
				}
				$sql = "SELECT COUNT(DISTINCT(USER_ID)) AS cnt FROM flow_run_prcs WHERE RUN_ID = '".$this->runId."' AND PRCS_ID = '".SecurityFilter($prcsId)."' AND FLOW_PRCS = '".SecurityFilter($flowPrcs)."' AND PRCS_TIME IS  NULL AND FORWARD_USER_ID =''";
				$rs  = exequery($connection,$sql);
				$row = mysql_fetch_array($rs);
				$haveOpTag = $row['cnt'];
				$sql = "SELECT COUNT(*) AS cnt FROM flow_run_prcs WHERE RUN_ID = '".$this->runId."' AND PRCS_ID = '".SecurityFilter($prcsId)."' AND FLOW_PRCS = '".SecurityFilter($flowPrcs)."' AND PRCS_TIME IS  NULL AND USER_ID = '".SecurityFilter($userId)."' AND FORWARD_USER_ID  ='' ";
				$rs  = exequery($connection,$sql);
				$row = mysql_fetch_array($rs);
				$haveOpTagSelf = $row['cnt'];
				if($haveOpTag == 1 && $haveOpTagSelf > 0){
					$sql = "UPDATE flow_run_prcs SET OP_FLAG=1 WHERE RUN_ID = '".$this->runId."' AND PRCS_ID = '".SecurityFilter($prcsId)."' AND FLOW_PRCS = '".SecurityFilter($flowPrcs)."' AND USER_ID='".SecurityFilter($userId)."'";
					exequery($connection,$sql);
					//更新flow_run_step
					$query = "UPDATE flow_run fr,flow_run_step frs SET frs.OP_FLAG=1 WHERE fr.run_id = frs.run_id AND fr.run_id = '".$this->runId."' AND frs.USER_ID = '".SecurityFilter($userId)."'";
					exequery($connection,$query);
				}
			break;
			//所有办理人员都可以转到下一步
			case 3:
				//没有主办人，当前人员就是主办人
				$maxOpFlag = $this->opFlagIsExist($prcsId);
				if($maxOpFlag == 0 && $fromType != "print")
				{
					$sql = "UPDATE flow_run_prcs SET OP_FLAG=1 WHERE RUN_ID = '".$this->runId."' AND PRCS_ID = '".SecurityFilter($prcsId)."' AND FLOW_PRCS = '".SecurityFilter($flowPrcs)."' AND USER_ID='".SecurityFilter($userId)."'";
					exequery($connection,$sql);
					//更新flow_run_step
					$query = "UPDATE flow_run fr,flow_run_step frs SET frs.OP_FLAG=1 WHERE fr.run_id = frs.run_id AND fr.run_id = '".$this->runId."' AND frs.USER_ID = '".SecurityFilter($userId)."'";
					exequery($connection,$query);
				}
			break;
		}
	}
	/**
	*解析文号规则，生成对应的文号
	*@access public
	*@return str $RUN_SEQ_AUTO
	*/
	function getSeqAuto($userId = null){
		global $connection,$_SESSION,$_lang;
		if(is_null($userId)){
			$userId = $_SESSION['LOGIN_USER_ID'];
		}
		$sql = "SELECT ft.FLOW_NAME,ft.FLOW_SORT,ft.FLOW_TYPE,ft.FLOW_SEQUENCE,fs.TITLE FROM flow_type ft , flow_sort fs WHERE ft.FLOW_ID=".$this->flowId." AND ft.FLOW_SORT=fs.ID";
		$rs  = exequery($connection,$sql);
		$row = mysql_fetch_array($rs);
		$CREATE_TIME = date("Y-m-d H:i:s");
		if($row['FLOW_TYPE'] == 1){
			$row['FLOW_TYPE'] = $_lang["flow_fixflow"];
		}else{
			$row['FLOW_TYPE'] = $_lang["flow_freeflow"];
		}
		//$sql = "SELECT flow_run.RUN_ID,flow_run.RUN_SEQ,flow_run.CREATE_TIME,department.DEPT_NAME,user.USER_NAME FROM flow_run LEFT JOIN flow_run_prcs ON(flow_run_prcs.RUN_ID = flow_run.RUN_ID and flow_run_prcs.PRCS_ID='1') LEFT JOIN user ON(user.USER_ID = flow_run_prcs.USER_ID) LEFT JOIN department ON(department.DEPT_ID = user.DEPT_ID) WHERE flow_run.FLOW_ID= ORDER BY flow_run.RUN_ID DESC";
		$sql = "SELECT flow_run.RUN_ID,flow_run.RUN_SEQ,flow_run.CREATE_TIME,department.DEPT_NAME,user.USER_NAME
				FROM flow_run
				LEFT JOIN USER ON(user.USER_ID = flow_run.CREATOR)
				LEFT JOIN department ON(department.DEPT_ID = user.DEPT_ID)
				WHERE flow_run.FLOW_ID='".$this->flowId."'
				AND IS_EFFECT = 1 AND flow_run.RUN_SEQ != ''
				ORDER BY flow_run.CREATE_TIME DESC";
		$rs  = exequery($connection,$sql);

		if($creator_rows = mysql_fetch_array($rs))
		{
			$creator_rows["RUN_SEQ"] = strip_tags(html_entity_decode($creator_rows["RUN_SEQ"]));

			preg_match_all("/(.*?)\[流水号(\d+)\|(\d+)\]/",$row["FLOW_SEQUENCE"],$flow_num);
			$prv_username  = $creator_rows["USER_NAME"];
			$prv_time      = $creator_rows["CREATE_TIME"];
			$prv_seq       = $creator_rows["RUN_SEQ"];
			$prv_name      = $row["FLOW_NAME"];
			$prv_title     = $row["TITLE"];
			$prv_type      = $row["FLOW_TYPE"];
			$dept_name     = $row["DEPT_NAME"];
			$creat_y       = substr($prv_time,0,4);
			$creat_m       = substr($prv_time,5,2);
			$creat_d       = substr($prv_time,8,2);
			$creat_h       = substr($prv_time,11,2);
			$creat_i       = substr($prv_time,14,2);

			if(count($flow_num[0])){
				$flow_num[1][0] = strip_tags($flow_num[1][0]);
				$seq = '';
				$RUN_SEQ_AUTO = str_replace("[名称]","{$prv_name}",$flow_num[1][0]);

				$RUN_SEQ_AUTO = str_replace("[类别]","{$prv_title}",$RUN_SEQ_AUTO);
				$RUN_SEQ_AUTO = str_replace("[类型]","{$prv_type}",$RUN_SEQ_AUTO);
				$RUN_SEQ_AUTO = str_replace("[创建人]","{$prv_username}",$RUN_SEQ_AUTO);

				$RUN_SEQ_AUTO = str_replace("[创建人部门]","{$dept_name}",$RUN_SEQ_AUTO);
				$RUN_SEQ_AUTO = str_replace("[年份]","{$creat_y}",$RUN_SEQ_AUTO);
				$RUN_SEQ_AUTO = str_replace("[月份]","{$creat_m}",$RUN_SEQ_AUTO);
				$RUN_SEQ_AUTO = str_replace("[日期]","{$creat_d}",$RUN_SEQ_AUTO);
				$RUN_SEQ_AUTO = str_replace("[时]","{$creat_h}",$RUN_SEQ_AUTO);
				$RUN_SEQ_AUTO = str_replace("[分]","{$creat_i}",$RUN_SEQ_AUTO);
				//$RUN_SEQ_AUTO = str_replace("<p>","",$RUN_SEQ_AUTO);
				//$RUN_SEQ_AUTO = str_replace("<p/>","",$RUN_SEQ_AUTO);
				$first_len = strlen(strip_tags(html_entity_decode($RUN_SEQ_AUTO)));
				$seq = substr($creator_rows["RUN_SEQ"],$first_len,$flow_num[2][0]);
				//从起始位置，开始算的话，计数器应该是当前值-起始值+1
				$FLOW_COUNT_SEQ = $seq-$flow_num[3][0]+1;

				if($FLOW_COUNT_SEQ < 0)
					$FLOW_COUNT_SEQ = 0;
			}else{
				$FLOW_COUNT_SEQ = 0;
			}
		}else{
			$FLOW_COUNT_SEQ = 0;
		}
		//--
		$sql = "SELECT user.USER_NAME,department.DEPT_NAME FROM user  LEFT JOIN department ON(department.DEPT_ID = user.DEPT_ID) WHERE USER_ID='".SecurityFilter($userId)."'";
		$rs  = exequery($connection,$sql);
		$ro  = mysql_fetch_array($rs);
		$creat_y = substr($CREATE_TIME,0,4);
		$creat_m = substr($CREATE_TIME,5,2);
		$creat_d = substr($CREATE_TIME,8,2);
		$creat_h = substr($CREATE_TIME,11,2);
		$creat_i = substr($CREATE_TIME,14,2);
		$RUN_SEQ_AUTO = str_replace("[名称]","{$row['FLOW_NAME']}",$row['FLOW_SEQUENCE']);
		$RUN_SEQ_AUTO = str_replace("[类别]","{$row['TITLE']}",$RUN_SEQ_AUTO);
		$RUN_SEQ_AUTO = str_replace("[类型]","{$row['FLOW_TYPE']}",$RUN_SEQ_AUTO);
		$RUN_SEQ_AUTO = str_replace("[创建人]","{$ro['USER_NAME']}",$RUN_SEQ_AUTO);
		$RUN_SEQ_AUTO = str_replace("[创建人部门]","{$ro['DEPT_NAME']}",$RUN_SEQ_AUTO);
		$RUN_SEQ_AUTO = str_replace("[年份]","{$creat_y}",$RUN_SEQ_AUTO);
		$RUN_SEQ_AUTO = str_replace("[月份]","{$creat_m}",$RUN_SEQ_AUTO);
		$RUN_SEQ_AUTO = str_replace("[日期]","{$creat_d}",$RUN_SEQ_AUTO);
		$RUN_SEQ_AUTO = str_replace("[时]","{$creat_h}",$RUN_SEQ_AUTO);
		$RUN_SEQ_AUTO = str_replace("[分]","{$creat_i}",$RUN_SEQ_AUTO);
		preg_match_all("/\[流水号(\d+)\|(\d+)\]/",$RUN_SEQ_AUTO,$flow_num);
		if(count($flow_num[1])){
			foreach($flow_num[1] as $key=>$val){
				if($FLOW_COUNT_SEQ)
					$flow_now_num = $FLOW_COUNT_SEQ+$flow_num[2][$key];
				else
					$flow_now_num = $flow_num[2][$key];
				if(strlen($flow_now_num) <= $val){
					$num = "%0".$val."d";
					$flow_num[1][$key] = sprintf($num, $flow_now_num);
					$RUN_SEQ_AUTO = str_replace($flow_num[0][$key], $flow_num[1][$key], $RUN_SEQ_AUTO);
				}
				else
				{
					return array("error" => $_lang['flow_no_expire_hint']);
					// Message("error",$_lang['flow_no_expire_hint']);
					// die("");
				}
			}
		}
		return $RUN_SEQ_AUTO;
	}
	/**
	*获取流程走过的最大步骤
	*@access public
	*@return int $maxPrcsId
	*/
	function getCurrentMaxPrcsId()
	{
		global $connection;
		$MaxPrcsIdSql = "SELECT MAX(PRCS_ID)AS PRCS_ID FROM flow_run_prcs WHERE RUN_ID = '".$this->runId."'";
		$MaxPrcsIdRs  = exequery($connection,$MaxPrcsIdSql);
		if($MaxPrcsIdRows = mysql_fetch_array($MaxPrcsIdRs))
		{
			$maxPrcsId = $MaxPrcsIdRows["PRCS_ID"];
		}
		return $maxPrcsId;
	}
	/**
	*判断签办反馈是否被查看过
	*@access public
	*@return int $haveReaded
	*/
	function isHaveCheck($prcsId,$editTime)
	{
		global $connection;
		$haveReadSql = "SELECT PRCS_TIME FROM flow_run_prcs WHERE RUN_ID = '".$this->runId."' AND PRCS_ID = '".$prcsId."' AND USER_ID != '".$_SESSION['LOGIN_USER_ID']."' AND LAST_VISITED_TIME > '".SecurityFilter($editTime)."'";
		$haveReadRs  = exequery($connection,$haveReadSql);
		if($haveReadRows = mysql_fetch_array($haveReadRs))
		{
			$haveReaded = true;
		}
		else
		{
			$haveReaded = false;
		}
		return $haveReaded;
	}
	/**
	*记录最后查看时间
	*@access public
	*@param  int $prcsId   当前步骤号
	*@return void
	*/
	function recordLastVisitdTime($prcsId,$user_id="")
	{
		global $connection;
		if($user_id=="")
		{
			$UserId = $_SESSION['LOGIN_USER_ID'];
		}
		else
		{
			$UserId	= $user_id;
		}
		$curDateTime = date("Y-m-d H:i:s",time());
		$sql = "UPDATE flow_run_prcs SET LAST_VISITED_TIME = '".$curDateTime."' WHERE RUN_ID = '".$this->runId."' AND PRCS_ID = '".SecurityFilter($prcsId)."' AND USER_ID = '".SecurityFilter($UserId)."' ";
		$rs  = exequery($connection,$sql);
	}
	/**
	*模拟主办人接受流程，主要用户监控转交
	*@access public
	*@return void
	*/
	function fakeMarkReceive()
	{
		global $connection,$_lang;
		$curTime = date("Y-m-d H:i:s",time());
		//判断流程当前最大步骤主办人是否已经接收
		$sql      = "SELECT * FROM flow_run_prcs WHERE RUN_ID = '".$this->runId."' AND OP_FLAG = '1' ORDER BY PRCS_ID DESC";
		$rs       = exequery($connection,$sql);
		$rows     = mysql_fetch_array($rs);
		$prcsFlag = $rows["PRCS_FLAG"];
		$prcs_id  = SecurityFilter($rows["PRCS_ID"]);

		if($prcsFlag == 1)
		{
			//此步骤主办人尚未接收
			//更新前一步的所有PRCS_FLAG为4
			$prePrcsId = $prcs_id - 1;
			$prePrcsId = SecurityFilter($prePrcsId);
			$sql = "UPDATE flow_run_prcs SET PRCS_FLAG = '4' WHERE RUN_ID = '".$this->runId."' AND PRCS_ID = '".$prePrcsId."'";
			exequery($connection,$sql);
			//更新主办人的PRCS_TIME的值,否则流程图计算耗时出错
			if($prePrcsId > 0)
			{
				$viewTimeSql = "SELECT DELIVER_TIME FROM flow_run_prcs WHERE RUN_ID = '".$this->runId."' AND PRCS_ID = '".$prePrcsId."' AND OP_FLAG = '1' ";
				$viewTimeRs  = exequery($connection,$viewTimeSql);
				if($viewTimeRows = mysql_fetch_array($viewTimeRs))
				{
					$viewTime   = $viewTimeRows["DELIVER_TIME"];
				}
			}
			//如果是第一步DELIVER_TIME为空,则取当前时间-1秒
			if(!$viewTime)
			{
				$viewTime = strtotime($curTime)-1;//时间少一秒做个区别
				$viewTime = date("Y-m-d H:i:s",$viewTime);
			}
			$sql = "UPDATE flow_run_prcs SET PRCS_TIME ='".$viewTime."' WHERE RUN_ID = '".$this->runId."' AND PRCS_ID = '".$prcs_id."' AND OP_FLAG = '1' ";
			exequery($connection,$sql);
			//更新flow_run_step
			$query = "UPDATE flow_run fr,flow_run_step frs SET frs.PRCS_TIME='".$viewTime."' WHERE fr.run_id = frs.run_id AND fr.run_id = '".$this->runId."' AND frs.PRCS_ID = '".$prcs_id."' AND frs.OP_FLAG = '1'";
			exequery($connection,$query);
		}
	}
	function currentUserHaveSubmit($userId){
		global $connection,$_lang;
		$query = "SELECT USER_RUN_TYPE FROM flow_run_step WHERE RUN_ID = '".$this->runId."' AND USER_ID = '".SecurityFilter($userId)."'";

		$rs = exequery($connection,$query);
		if($row = mysql_fetch_array($rs)){
			if($row['USER_RUN_TYPE'] != 1){
				Message("",$_lang["flow_process_over"]);
				exit;
			}
		}
	}
	/**
	*判断该步骤是否已提交
	*@access public
	*@param  int $prcsId   当前步骤号
	*@return void
	*/
	function isHaveSubmit($prcsId)
	{
		global $connection,$_lang;
		$query = "SELECT * FROM flow_run_prcs WHERE PRCS_FLAG in (3,4) AND RUN_ID = '".$this->runId."' AND PRCS_ID = '".SecurityFilter($prcsId)."'";
		$rs = exequery($connection,$query);
		if(mysql_fetch_array($rs)){
			Message("",$_lang["flow_process_over"]);
			exit;
		}
	}
	/**
	*是否已经存在主办人
	*@access public
	*@param  int $prcsId   当前步骤号
	*@return int $maxOpFlag 1、已经存在，0、不存在
	*/
	function opFlagIsExist($prcsId)
	{
		global $connection;
		$sql = "SELECT MAX(OP_FLAG) AS OP_FLAG FROM flow_run_prcs WHERE RUN_ID = '".$this->runId."' AND PRCS_ID = '".SecurityFilter($prcsId)."' ";
		$rs  = exequery($connection,$sql);
		if($rows = mysql_fetch_array($rs))
		{
			return $maxOpFlag = $rows["OP_FLAG"];
		}
	}
    /**
     * 判断主办人是否是当前用户
     * @global type $connection
     * @param type $prcsId
     * @param type $userId
     * @return boolean
     */
    function opFlagIsSelf($prcsId,$userId){
        global $connection;
		$sql = "SELECT MAX(OP_FLAG) AS OP_FLAG FROM flow_run_prcs WHERE USER_ID = '".SecurityFilter($userId)."' AND RUN_ID = '".$this->runId."' AND PRCS_ID = '".SecurityFilter($prcsId)."' ";
		$rs  = exequery($connection,$sql);
		if($rows = mysql_fetch_array($rs))
		{
            if($rows['OP_FLAG'] == 0){
                return false;
            }
            return true;
		}
        return false;
    }
	/**
	*判断流程某个步骤主办人是否已经提交
	*@access public
	*@param  int $prcsId   当前步骤号
	*@return bool true:已提交，false:未提交
	*/
	function haveTurned($prcsId,$userId)
	{
		global $connection;
		$maxOpFlag = $this->opFlagIsExist($prcsId);
		if($maxOpFlag == 0)
		{
			return false;
		}
		else
		{
			$sql = "SELECT COUNT(RUN_ID) AS CT FROM flow_run_prcs WHERE RUN_ID = '".$this->runId."' AND PRCS_ID = '".SecurityFilter($prcsId)."' AND USER_ID = '".SecurityFilter($userId)."' AND OP_FLAG = '1' AND ( DELIVER_TIME IS NULL OR DELIVER_TIME = '0000-00-00 00:00:00')";
			// $sql = "SELECT COUNT(RUN_ID) AS CT FROM flow_run_step WHERE RUN_ID = '".$this->runId."' AND PRCS_ID = '".$prcsId."' AND USER_ID = '".$userId."' AND USER_RUN_TYPE = '1' AND OP_FLAG = '1'";
			$ct = 0;
			$rs = exequery($connection,$sql);
			if($rows = mysql_fetch_array($rs))
			{
				$ct = $rows["CT"];
			}
			if($ct > 0)
				return false;
			else
				return true;
		}
 	}
	/**
	*判断流程是否已经删除
	*@access public
	*@return bool true:已删除，false:未删除
	*/
	function haveDelected()
	{
		global $connection;
		$sql = "SELECT COUNT(RUN_ID) AS CT FROM flow_run WHERE RUN_ID = '".$this->runId."'";
		$rs  = exequery($connection,$sql);
		$ct  = 0;
		if($rows = mysql_fetch_array($rs))
		{
			$ct = $rows["CT"];
		}
		if($ct > 0)
			return false;
		else
			return true;

	}
	/**
	*取消短信提醒
	*@access public
	*@return void
	*/
	function cancelSmsRemind($login_user_id = null)
	{
		global $connection;
        if($login_user_id == null) {
            $login_user_id = $_SESSION['LOGIN_USER_ID'];
        }
		$sql = "UPDATE sms SET REMIND_FLAG = '0'
				WHERE TO_ID ='".SecurityFilter($login_user_id)."'
				AND SMS_TYPE = '7'
				AND REMIND_FLAG = '1'
				AND TABLE_NAME = 'flow_run'
				AND TABLE_ID = '".$this->runId."'
				";
		$rs  = exequery($connection,$sql);
	}
	/**
	 * 获取类流的流水号是否可以修改信息
	 * @access public
	 * @return array
	*/
	function canEditFlowno()
	{
		global $connection;
		$sql = "SELECT CAN_EDIT_FLOWNO FROM flow_type WHERE FLOW_ID ='".$this->flowId."'";
		$rs  = exequery($connection,$sql);
		if($rows = mysql_fetch_array($rs))
		{
			return $rows["CAN_EDIT_FLOWNO"];
		}
	}
	/**
	 * 获取流程所有节点的信息
	 * @access public
	 * @return array
	*/
	function getFlowInfo()
	{
		global $connection;
		$sql = "SELECT ft.*,fo.FLOW_SHOW_GRAPH,fo.FLOW_SHOW_TEXT,fo.FLOW_SHOW_STEP,fo.FLOW_SHOW_ATTACH,fo.FLOW_SHOW_FEEDBACK,fo.FLOW_AUTOSAVE,fo.FLOW_AUTOSAVE_TIME,fo.FLOW_TO_DOC,fo.FLOW_SHOW_DOC,fo.LABLE_SHOW_DEFAULT,fo.FIRST_NODE_DELETE_FLOW,fft.*
				FROM flow_type AS ft
				LEFT JOIN flow_others AS fo ON ft.FLOW_ID = fo.FLOW_ID
				LEFT JOIN flow_form_type AS fft ON ft.FORM_ID = fft.FORM_ID
				WHERE ft.FLOW_ID = '".$this->flowId."' ";
		$rs  = exequery($connection,$sql);
		if($row = mysql_fetch_array($rs,MYSQL_ASSOC))
			return $row;
		else
			return array();
	}
	/**
	 * 获取流程的类型
	 * @access public
	 * @para   int flow_id 流程类别id
	 * @return int $flow_type 流程分类id
	*/
	function getFlowType($flow_id)
	{
		global $connection;
		$sql = "SELECT * FROM flow_type WHERE FLOW_ID = '".$flow_id."'";
		$rs  = exequery($connection,$sql);
		if($row = mysql_fetch_array($rs))
		{
			$flow_type = $row["FLOW_TYPE"];
		}
		return $flow_type;
	}
	/**
	 * 获取流程的表单数据
	 * @access public
	 * @return array
	*/
	function getFormData()
	{
		global $connection;
		$query  = "SELECT * FROM flow_run_data WHERE RUN_ID='".$this->runId."' ORDER BY ITEM_ID";
		$cursor = exequery($connection,$query);
		while($row = mysql_fetch_array($cursor,MYSQL_ASSOC))
		{
			$rows[] = $row;
		}
		if(is_array($rows))
			return $rows;
		else
			return array();
	}
	/**
	 * 获取流程的运行步骤数据
	 * @access public
	 * @return array
	*/
	function getPrcsInfo()
	{
		global $connection;
		$sql = "SELECT * FROM flow_run_prcs WHERE RUN_ID = '".$this->runId."' ORDER BY PRCS_ID";
		$rs  = exequery($connection,$sql);
		while($row = mysql_fetch_array($rs,MYSQL_ASSOC))
		{
			$rows[] = $row;
		}
		if($rows) {
			return $rows;
		} else {
			return array();
		}
	}

	/**
	 * 更改新建流程中流水号样式
	 * @access public
	 * @para   int run_id 流程id
	 * @para   str RUN_SEQ 文号
	 * @return void
	*/
	function savefilenumber($run_id,$RUN_SEQ)
	{
		global $connection;
		$sql = "
		UPDATE FLOW_RUN SET RUN_SEQ='$RUN_SEQ' WHERE RUN_ID=".SecurityFilter($run_id);
		$result = exequery($connection,$sql);
		$sql = "
		UPDATE zzzz_flow_data_$this->formId SET RUN_SEQ='".SecurityFilter($RUN_SEQ)."' WHERE RUN_ID=".SecurityFilter($run_id);
		$result = exequery($connection,$sql);
		return $result;
	}
	/**
	 * 返回表单字段信息
	 * @access public
	 * @return array
	*/
	public function GetListFiledInfo($filed)
	{
		global $connection;
		$FiledArray = array();
		if($filed["PrcsId"]!="")
		{
			$query = "SELECT * FROM flow_process WHERE FLOW_ID='".$this->flowId."' AND PRCS_ID='".SecurityFilter($filed["PrcsId"])."'";
		}
		else
		{
			$query = "SELECT * FROM flow_process WHERE FLOW_ID='".$this->flowId."'";
		}
		$rs  = exequery($connection,$query);
		while($row=mysql_fetch_array($rs))
		{
			$info["FLOW_ID"]            = $row["FLOW_ID"];
			$info["PRCS_ID"]            = $row["PRCS_ID"];
			$info["PRCS_NAME"]          = $row["PRCS_NAME"];
			$info["PRCS_USER"]          = $row["PRCS_USER"];
			$info["PRCS_ITEM"]          = $row["PRCS_ITEM"];
			$info["PRCS_TO"]            = $row["PRCS_TO"];
			$info["PRCS_ITEM_VIEW"]     = $row["PRCS_ITEM_VIEW"];
			$info["PRCS_ITEM_CAPACITY"] = $row["PRCS_ITEM_CAPACITY"];
			$info["PRCS_ITEM_AUTO"]     = $row["PRCS_ITEM_AUTO"];
			array_push($FiledArray,$info);
		}
		return $FiledArray;
	}

	/**
	 * 返回表单字段以及数值
	 * @access public
	 * @return array
	*/
	function getFormRunValue($PRCS_ITEM="",$OP_FLAG=""){
		global $connection;
		$fieldValueArray = $this->getFormData() ;
		$flowInfoArray   = $this->getFlowInfo() ;
		$ELEMENT_ARRAY   = html_element($flowInfoArray["PRINT_MODEL"]);
		$ITEM_ID_MAX = sizeof($ELEMENT_ARRAY);
		$ITEM_ID     = 0;
		$index       = 0;
		$query = "SELECT * FROM FLOW_RUN_DATA WHERE RUN_ID='".$this->runId."'  ORDER BY ITEM_ID";
		$cursor= exequery($connection,$query);
		$FlowData = array();
		while($ROW=mysql_fetch_array($cursor)){
			$ITEM_IDS=$ROW["ITEM_ID"];
			$ITEM_DATAS=$ROW["ITEM_DATA"];
			$STR="DATA_".$ITEM_IDS;
			$$STR=$ITEM_DATAS;
			$FlowData[$ITEM_IDS] = $ITEM_DATAS;
		}
		for($I=0;$I<$ITEM_ID_MAX;$I++)
		{
			$ELEMENT = $ELEMENT_ARRAY[$I];
			$ENAME   = get_attr($ELEMENT,"NAME");
			$EVALUE  = get_attr($ELEMENT,"VALUE");
			$ECLASS  = get_attr($ELEMENT,"CLASS");
			$EITLE   = get_attr($ELEMENT,"TITLE");
			//这个地方不全面，暂时是拷贝手机的api的，日后统一修改
			//签章判断是否能编辑
			if(!find_id($PRCS_ITEM,$EITLE)||$OP_FLAG != 1)
			{
				$ITEM_PRCS = "0";
			}
			else
			{
				$ITEM_PRCS = "1";
			}
			if($ECLASS != "DATE"&&$ECLASS != "time")
				$ITEM_ID++;

			$ITEM_VALUE = $fieldValueArray[$index]["ITEM_DATA"];

			if($ECLASS == "DATE")
			{
				$ITEM_VALUE = "";
				$checktypedate .= $this->GetHtmlValue($ELEMENT,"value").",";
			}
			else if($ECLASS == "HTML_SIGNATURE" || $ECLASS == "PHONE_SIGNATURE")
			{
				$ELEMENT_OUT = str_replace("<$ENAME","<$ENAME name='DATA_$ITEM_ID'  id='DATA_$ITEM_ID' required='$REQUIRE' onchange=\"checkRequired(this,'$ITEM_ID','$OP_FLAG');\" onblur=\"checkRequired(this,'$ITEM_ID','$OP_FLAG');\"",$ELEMENT);
				preg_match("/<[^\>]*/",$ELEMENT_OUT,$rs);
				$htmlEditTemp = $rs[0];
				//width
				$fromWidthStr   = strstr($htmlEditTemp,"style=\"overflow-x: hidden; overflow-y: hidden; width: ");
				$subWidthStr    = substr($fromWidthStr,54,strlen($fromWidthStr));
				$subWidthPxStr  = strstr($subWidthStr,"px");
				$width          = substr($subWidthStr,0,strlen($subWidthStr)-strlen($subWidthPxStr))."px";
				//height
				$fromStyleStr   = strstr($htmlEditTemp,"style=\"overflow-x: hidden; overflow-y: hidden; width: ");
				$subStylestr    = substr($fromStyleStr,63+strlen($width),strlen($fromStyleStr));
				$subHeightPxStr = strstr($subStylestr,"px");
				$height         = substr($subStylestr,0,strlen($subStylestr)-strlen($subHeightPxStr))."px";
				$ITEM_WIDTH = $width;
				$ITEM_HEIGHT = $height;
			}
			else if($ECLASS == "time")
			{
				$ITEM_VALUE = "";
				$checktypetime .= $this->GetHtmlValue($ELEMENT,"value").",";
			}
			else if($ECLASS=="AUTO" && $ENAME=="SELECT" && $ITEM_VALUE!="") //--- 列表型宏控件 ---
			{
				$EDATAFLD = get_attr($ELEMENT,"DATAFLD");
				$auto_id = "";
				switch($EDATAFLD)
				{
					case "SYS_LIST_DEPT":
						$auto_id = $ITEM_VALUE;
						$query_auto  = "SELECT * from DEPARTMENT where DEPT_ID=".SecurityFilter($ITEM_VALUE)."";
						$cursor_auto = exequery($connection,$query_auto);
						if($ROW = mysql_fetch_array($cursor_auto))
							$ITEM_VALUE = $ROW["DEPT_NAME"];
					break;
					case "SYS_LIST_PRIV":
					break;
					case "SYS_LIST_USER":
					case "SYS_LIST_PRCSUSER1":
					case "SYS_LIST_PRCSUSER2":
						$auto_id = $ITEM_VALUE;
						$query_auto  = "SELECT * from USER where USER_ID='".SecurityFilter($ITEM_VALUE)."'";
						$cursor_auto = exequery($connection,$query_auto);
						if($ROW = mysql_fetch_array($cursor_auto))
					 		$ITEM_VALUE = $ROW["USER_NAME"];
					break;
					case "SYS_LIST_SQL":
					break;
				}
			}
			else if($ECLASS=="detailChar")
			{
				/*$valuecount = count($FlowData);
				for($m=1;$m<=$valuecount;$m++)
				{
					if($m-1==$I)
					{
						$detailvalue = 	$FlowData[$m];
					}
				}*/
				$detailvalue = 	$FlowData[$ITEM_ID];
				$detailCharWidth        = $this->GetHtmlValue($ELEMENT,"detailcharwidth");
				$detailCharFormula      = $this->GetHtmlValue($ELEMENT,"detailcharformula");
				$detailCharTotal        = $this->GetHtmlValue($ELEMENT,"detailchartotal");
				$detailCharName         = $this->GetHtmlValue($ELEMENT,"detailcharname");
				$detailCharNameArray    = explode("`",$detailCharName);
				$detailCharWidthArray   = explode("`",$detailCharWidth);
				$detailCharFormulaArray = explode("`",$detailCharFormula);
				$detailCharTotalArray   = explode("`",$detailCharTotal);
				$title                  = $this->GetHtmlValue($ELEMENT,"title");
				$ITEM_VALUE = "<table border=\"0\" cellspace=\"0\" cellpadding=\"2\"><tr>";
				for($i = 0; $i < count($detailCharNameArray);$i++)
				{
					$ITEM_VALUE .= "<td >$detailCharNameArray[$i]</td>";
				}
				$ITEM_VALUE .= "</tr>";
				$itemRowValueArray  = explode("|＃|",trim($detailvalue,"|＃|"));
				$detailCharArray    = "";
				$totalnum = array();
				for($i = 0; $i <count($itemRowValueArray);$i++)
				{
					if($itemRowValueArray[$i])
					{
						$ITEM_VALUE .= "<tr>";
						$itemColValueArray = explode("`*`",$itemRowValueArray[$i]);
						for($j = 0;$j < count($detailCharTotalArray);$j++)
						{
							$ITEM_VALUE .= "<td>".$itemColValueArray[$j]."</td>";
							$totalnum[$i][$j] = $itemColValueArray[$j];
						}
						$ITEM_VALUE .= "</tr>";
					}
				}
				//$formula   = "0";
				$chartotal = "0";
				/*for($for=0;$for<count($detailCharFormulaArray);$for++){
					if($detailCharFormulaArray[$for]!==""){
						$formula = "1";
					}
				}*/
				for($tot=0;$tot<count($detailCharTotalArray);$tot++){
					if($detailCharTotalArray[$tot]!=0){
						$chartotal = "1";
					}
				}
				if($chartotal=="1"){
					$ITEM_VALUE .= "<tr>";
					$counttotal = count($totalnum);
					$newsubnum = array();
					for($num=0;$num<$counttotal;$num++)
					{
						$newsubnum = $this->getArrayMerge($totalnum[$num],$newsubnum);
					}
					for($i = 0; $i < count($detailCharNameArray);$i++)
					{
						if($detailCharTotalArray[$i]==0)
						{
							$ITEM_VALUE .= "<td></td>";
						}
						else
						{
							$ITEM_VALUE .= "<td>".$newsubnum[$i]."</td>";
						}
					}
					$ITEM_VALUE .= "</tr>";
				}
				$ITEM_VALUE .= "</table>";
				//$ITEM_VALUE = trim($detailvalue,"|＃|");
			}
			else //--- 普通控件 ---
			{
				$EDATAFLD = get_attr($ELEMENT,"DATAFLD");
				if($ECLASS=="AUTO" && $ITEM_VALUE=="{宏控件}"||$ITEM_VALUE=="{会签字段}")
					$ITEM_VALUE = "";
				if($EDATAFLD != "SYS_RUNNAME"){
					$ITEM_VALUE = str_replace("<","&lt",$ITEM_VALUE);
					$ITEM_VALUE = str_replace(">","&gt",$ITEM_VALUE);
					$ITEM_VALUE = stripslashes($ITEM_VALUE);
					$ITEM_VALUE = str_replace("\r\n","<br>",$ITEM_VALUE);
					$ITEM_VALUE = str_replace(" ","&nbsp;",$ITEM_VALUE);
				}

				if($ENAME=="INPUT" && strstr($ELEMENT,"type=\"checkbox\""))
				{
					$formrunData[$index]["type"] = "checkbox";
					if($ITEM_VALUE == "on")
					{
						$ITEM_VALUE = '<img src="images/flow/selected.png">';
						$formrunData[$index]["check"] = 1;
					}
					else
					{
						$ITEM_VALUE = '<img src="images/flow/unselected.png">';
						$formrunData[$index]["check"] = 0;
					}
				}
				if($ENAME=="SELECT" || $ENAME=="select")
				{
					//编辑时取所有值
					$reghtml    = "/<[^>]+>/";
					$checkhtml  = preg_match_all($reghtml,$ELEMENT,$result);
					$count      = count($result[0]);
					$mtchEndIdx = 0;
					$infor = "";
					for($i=0;$i<$count;$i++)
					{
						$str     = $result[0][$i];
						$begin   = stripos($ELEMENT,$str,$mtchEndIdx);
						$length  = (int)$begin-(int)$mtchEndIdx;
						$content = substr($ELEMENT,$mtchEndIdx,$length);
						if($str{1} != '/' || stripos($str,"SELECT"))
						{}
						else
						{
							$infor  .= $content."*|*";
						}
						$mtchEndIdx = $begin + strlen($str);
					}
				}
			}
			$formrunData[$index]["name"] = $ENAME;
			$formrunData[$index]["title"] = $EITLE;
			$formrunData[$index]["class"] = $ECLASS;
			$formrunData[$index]["value"] = $ITEM_VALUE;
			if($ENAME=="SELECT" || $ENAME=="select")
			{
				//编辑时取所有值
				$formrunData[$index]["allvalue"] = $infor;
				if($ECLASS=="AUTO"){
					$formrunData[$index]["allvalue"] = $auto_id;
				}
			}
			$formrunData[$index]["prcs"]  = $ITEM_PRCS;
			$formrunData[$index]["width"] = $ITEM_WIDTH;
			$formrunData[$index]["height"]= $ITEM_HEIGHT;
			if($ECLASS != "DATE"&&$ECLASS != "time")
				$index++;
		}
		$DataNum = count($formrunData);
		for($num=0;$num<$DataNum;$num++)
		{
			if($formrunData[$num]["name"]=="INPUT")
			{
				if(strstr($checktypedate,$formrunData[$num]["title"].","))
				{
					$formrunData[$num]["type"] = "date";
				}
				else if(strstr($checktypetime,$formrunData[$num]["title"].","))
				{
					$formrunData[$num]["type"] = "time";
				}
				else if($formrunData[$num]["class"]=="AUTO")
				{
					$formrunData[$num]["type"] = "AUTO";
				}
				else if($formrunData[$num]["type"]=="")
				{
					$formrunData[$num]["type"] = "text";
				}
			}
			else if($formrunData[$num]["name"]=="TEXTAREA")
			{
				if($formrunData[$num]["class"]=="EDITOR")
				{
					$formrunData[$num]["type"] = "FckEditer";
				}
				else if($formrunData[$num]["class"]=="countersign")
				{
					$formrunData[$num]["type"] = "countersign";
				}
				else if($formrunData[$num]["class"]=="chooseUser")
				{
					$formrunData[$num]["type"] = "chooseUser";
				}
				else if($formrunData[$num]["class"]=="chooseDept")
				{
					$formrunData[$num]["type"] = "chooseDept";
				}
				else if($formrunData[$num]["class"]=="chooseRole")
				{
					$formrunData[$num]["type"] = "chooseRole";
				}
				else if($formrunData[$num]["class"]=="")
				{
					$formrunData[$num]["type"] = "text";
				}
			}
			else if($formrunData[$num]["name"]=="IMG")
			{
				$formrunData[$num]["type"] = "detailChar";
			}
		}
		return $formrunData;
	}
	//数组键值相同的相加
	private function getArrayMerge($descs,$json_wares)
	{
	   if (is_array($descs) && is_array($json_wares)) {
		$arrayMerge = array();
		foreach ($json_wares as $key=>$value) {
		 if (array_key_exists($key, $descs)) {
		  $arrayMerge[$key] = $value + $descs[$key];
		  unset($descs[$key]);
		 } else {
		  $arrayMerge[$key] = $value;
		 }
		}
		$subarray = $arrayMerge+$descs;
		return $subarray;
	   } else {
		return false;
	   }
	}
	function GetHtmlValue($objStr,$PropName)
	{
		$PropStr     = $PropName."=\"";
		$fromPropStr = strstr($objStr,$PropStr);
		$subPropStr  = substr($fromPropStr,strlen($PropStr),strlen($fromPropStr));
		$subQuotStr  = strstr($subPropStr,"\"");
		$propValue   = substr($subPropStr,0,strlen($subPropStr)-strlen($subQuotStr));
		return $propValue;
	}

	function saveFeedBack($userid,$content,$attachment_id,$attachment_name){
		global $connection;
		$edit_time = date("Y-m-d H:i:s",time());
		$seq_id    = $this->getNextSeqId($userid);
		$prcsSql   = "SELECT * FROM flow_run_prcs WHERE USER_ID = '".SecurityFilter($userid)."' AND RUN_ID = '".$this->runId."' ORDER BY PRCS_ID DESC ";
		$prcsRs    = exequery($connection,$prcsSql);
		if($prcsRow=mysql_fetch_array($prcsRs))
		{
			$flow_prcs = $prcsRow["FLOW_PRCS"];
			$prcs_id   = $prcsRow["PRCS_ID"];
		}
		$sql       = "INSERT INTO flow_run_feedback (RUN_ID,USER_ID,CONTENT,ATTACHMENT_ID,ATTACHMENT_NAME,EDIT_TIME,SEQ_ID,FLOW_PRCS,PRCS_ID) VALUES ('".$this->runId."','".SecurityFilter($userid)."','".SecurityFilter($content)."','".SecurityFilter($attachment_id)."','".SecurityFilter($attachment_name)."','".SecurityFilter($edit_time)."','".SecurityFilter($seq_id)."','".SecurityFilter($flow_prcs)."','".SecurityFilter($prcs_id)."')";
		$rs = exequery($connection,$sql);
		return $rs;
	}
	function getNextSeqId($userid){
		global $connection;
		$sql = "SELECT MAX(SEQ_ID) AS cnt FROM flow_run_feedback WHERE USER_ID='".SecurityFilter($userid)."' AND RUN_ID=".$this->runId."";
		$rs  = exequery($connection,$sql);
		$row = mysql_fetch_array($rs);
		$nowmaxseqid = $row['cnt'];
		$nextseqid = $nowmaxseqid+1;
		return $nextseqid;
	}
	function getFeedBack(){
		global $connection;
		$feedSql   = "SELECT * FROM flow_run_feedback WHERE RUN_ID = '".$this->runId."' ORDER BY PRCS_ID DESC ";
		$feedRs    = exequery($connection,$feedSql);
		while($feedRow=mysql_fetch_array($feedRs))
		{
			//获取附件地址
			$feedRow["ATTACHMENT_DIR"] = GetATTACHMENTURL($feedRow["ATTACHMENT_ID"],$feedRow["ATTACHMENT_NAME"]);
			$rows[] = $feedRow;
		}
		if($rows)
			return $rows;
		else
			return array();
	}
	function encodeHtmlEntity($inputArray)
	{
		if($inputArray)
		{
			for($i=1; $i<= count($inputArray);$i++)
			{
				$rt[] = htmlentities($inputArray[$i],ENT_QUOTES,"utf-8");
			}
		}
		else
		{
			$rt = array();
		}
		return $rt;
	}
	/**
	*判断流程某个步骤某个经办人是否已经提交
	*@access public
	*@param  int $prcsId   当前步骤号
	*@param  str $userId   经办人id
	*@return bool true:已提交，false:未提交
	*/
	function operatorHaveTurned($prcsId,$userId)
	{
		global $connection;
		$sql = "SELECT COUNT(RUN_ID) AS CT FROM flow_run_prcs WHERE RUN_ID = '".$this->runId."' AND PRCS_ID = '".SecurityFilter($prcsId)."' AND OP_FLAG = '0' AND USER_ID ='".SecurityFilter($userId)."' AND ( SAVEFORM_TIME IS NULL OR SAVEFORM_TIME = '0000-00-00 00:00:00')";
		$ct = 0;
		$rs = exequery($connection,$sql);
		if($rows = mysql_fetch_array($rs))
		{
			$ct = $rows["CT"];
		}
		if($ct > 0)
			return false;
		else
			return true;
 	}
	/**
	*获取表单总信息函数
	*@param  array $Info       参数信息
	*@return array $AllInfo    详细信息
	*/
	public function GetListAllInformation($Info)
	{
		global $connection;
		$AllInfo          = array();
		$ListFiledInfo = array();
		$query = "SELECT PRCS_ID,PRCS_NAME,FLOW_ID,PRCS_ITEM FROM flow_process WHERE FLOW_ID='".$this->flowId."'";
		$rs  = exequery($connection,$query);
		while($row=mysql_fetch_array($rs))
		{
			$infor["FLOW_ID"]   = $row["FLOW_ID"];
			$infor["PRCS_ID"]   = $row["PRCS_ID"];
			$infor["PRCS_NAME"] = $row["PRCS_NAME"];
			$infor["PRCS_ITEM"] = $row["PRCS_ITEM"];
			array_push($ListFiledInfo,$infor);
		}
		$formdata      = $this->getFormData();
		$fieldAndValue = $this->getFormRunValue();
		foreach($fieldAndValue as $item=>$value)
		{
			foreach($formdata as $item2=>$value2)
			{
				if($item==$item2)
				{
					$data = array_merge($fieldAndValue[$item],$formdata[$item2]);
					$edit_prcs="";
					foreach($ListFiledInfo as $item3=>$value3)
					{
						$edit = strstr($value3["PRCS_ITEM"],$value["title"].",");
						if($edit)
						{
							$edit_prcs .= $value3["PRCS_ID"].",";
						}
					}
					if($Info["PrcsId"]!="")
					{
						$readonly = strstr($edit_prcs,$Info["PrcsId"].",");
						if($readonly)
						{
							$data["nature"] = "edit";
						}
						else
						{
							$data["nature"] = "readonly";
						}
					}
					else
					{
						$editarray    = explode(",",$edit_prcs);
						$neweditarray = array_unique($editarray);
						$edit_str     = implode(",",$neweditarray);
						$data["edit_prcs"] = $edit_str;
					}
					unset($data["ITEM_DATA"]);
					array_push($AllInfo,$data);
				}
			}
		}
		return $AllInfo;
	}
	/**
	*获取流程其他信息函数(for webservice)
	*@return array $AllInfo    详细信息
	*/
	public function GetFlowOtherInformation()
	{
		global $connection;
		$AllInfo = array();
		$sql = "SELECT * FROM flow_run WHERE FLOW_ID='".$this->flowId."' AND RUN_ID='".$this->runId."'";
		$rs = exequery($connection,$sql);
		if($rows = mysql_fetch_array($rs))
		{
			$AllInfo["RUN_NAME"]        = $rows["RUN_NAME"];
			$AllInfo["RUN_SEQ"]         = $rows["RUN_SEQ"];
			$AllInfo["LINK_DOC"]        = $rows["LINK_DOC"];
			$AllInfo["VIEW_USER"]       = $rows["VIEW_USER"];
			$AllInfo["CREATOR"]         = $rows["CREATOR"];
			$AllInfo["CURRENT_STEP"]    = $rows["CURRENT_STEP"];
			$AllInfo["ATTACHMENT_ID"]   = $rows["ATTACHMENT_ID"];
			$AllInfo["ATTACHMENT_NAME"] = $rows["ATTACHMENT_NAME"];
			$AllInfo["ATTACHMENT_DIR"]  = GetATTACHMENTURL($AllInfo["ATTACHMENT_ID"],$AllInfo["ATTACHMENT_NAME"]);
			$AllInfo["INSTANCY_TYPE"]   = $rows["INSTANCY_TYPE"];
		}
		return $AllInfo;
	}
	/**
	 * 获取电脑签章当前页面的签章按钮相关的信息
	 * @access public
	 * @return array
	*/
	function getSigButtonId($getbuttonid,$PRCS_ITEM,$OP_FLAG,$sig_type)
	{
		$sigbuttonidarr = array();
		$formValue = $this->getFormRunValue($PRCS_ITEM,$OP_FLAG);
		if(is_array($formValue))
		{
			while(list($key,$var)=each($formValue))
			{
				if($var["class"] != "DATE"&&$var["class"] != "time")
				{
					$var["value"] = $var["value"]==""?"&nbsp;":strip_tags($var["value"]);
					if($var["class"] == $sig_type)
					{
						$sigbuttonidarr[0][] = $key+1;
						$sigbuttonidarr[1][] = $var["value"];
						$sigbuttonidarr[2][] = $var["prcs"];
						$sigbuttonidarr[3][] = $var["title"];
					}
				}
			}
		}
		return $sigbuttonidarr;
	}
	function getFormDataNew()
	{
		global $connection;
		$query  = "SELECT * FROM zzzz_flow_data_".SecurityFilter($this->formId)." WHERE RUN_ID='".$this->runId."'";
		$cursor = exequery($connection,$query);
		if($row = mysql_fetch_array($cursor,MYSQL_ASSOC))
			$rows  = $row ;
		if(is_array($rows))
			return $rows;
		else
			return array();
	}
	/**
	*保存流程紧急程度的函数
	*@param  str $InstancyType   紧急程度的数字 0：正常、1：重要、2：紧急
	*/
	function saveInstancyType($InstancyType)
	{
		global $connection,$LOGIN_USER_ID,$LOGIN_USER_NAME;
		if($InstancyType != "")
		{
			$getInstancySql    = "SELECT INSTANCY_TYPE,RUN_ID,RUN_NAME FROM flow_run WHERE RUN_ID = '".$this->runId."'";
			$getInstancyCursor = exequery($connection,$getInstancySql);
			if($row = mysql_fetch_array($getInstancyCursor,MYSQL_ASSOC)) {
				$oldInstancy = $row["INSTANCY_TYPE"];
				$RUN_NAME    = $row["RUN_NAME"];
				$RUN_ID      = $row["RUN_ID"];
			}
			// 日志
			if($oldInstancy != "" && $oldInstancy != $InstancyType) {
				$logString = "run_name:".$RUN_NAME.";run_id:".$RUN_ID.";time:".date("Y-m-d H:i:s",time()).";user_id:".$LOGIN_USER_ID.";user_name:".$LOGIN_USER_NAME.";old_instancy:".$oldInstancy.";new_instancy:".$InstancyType."."."\r\n";
				file_put_contents(str_replace("/webroot", "", ROOT_PATH) . "logs/instancytypechange.txt",$logString,FILE_APPEND);
			}
			$query  = "UPDATE flow_run SET INSTANCY_TYPE = '".SecurityFilter($InstancyType)."' WHERE RUN_ID = '".$this->runId."'";
			$cursor = exequery($connection,$query);
		}
	}
	/**
	*获取流程相关文档列表
	*@param  array $type           取值参数
	*@param  array $search         查询参数
	*@param  array $page           翻页参数
	*@param  array $other          自定义参数
	*@return array $returnArray    返回结果
	*/
	function getFlowRelatedDoc($type=array(),$search=array(),$page=array(),$other=array())
	{
		global $connection;
		//返回的固定格式的数组
		$returnArray = array("totalCount"=>"","list"=>array());
		//先查所有文档ID的串
		$query = "
					SELECT * from FLOW_RUN WHERE RUN_ID = '".$this->runId."'
				";
		$cursor= exequery($connection,$query);
		$REV_DOC_STR = "";
		while($ROW   = mysql_fetch_array($cursor)){
			$LINK_DOC     = $ROW["LINK_DOC"];
			$REV_DOC_STR .= $LINK_DOC;
		}
		$REV_DOC_STR_ARR   = explode(",",trim($REV_DOC_STR,","));
		$REV_DOC_STR_ARRAY = array_unique($REV_DOC_STR_ARR);
		$REV_DOC_ALL_STR   = "'".implode("','",$REV_DOC_STR_ARRAY)."'";

		$countSqlPre  = "SELECT fc.CONTENT_ID ";
		$sqlPublicPre = "
						FROM file_content fc
						LEFT JOIN user u ON u.USER_ID = fc.USER_ID
						WHERE fc.CONTENT_ID IN ( ".SecurityFilter($REV_DOC_ALL_STR)." )
						";
		//拼接筛选、自定义查询等条件
		$sqlPublicPre .= $search["CUSTOMPARAM"];
		$countSql = $countSqlPre.$sqlPublicPre;
		$cntRs = exequery($connection,$countSql);
		//因为含有group by 获取总数的方法有点不一样
		$totalCount = mysql_affected_rows();
		$returnArray["totalCount"] =  $totalCount;
		while($page["PAGINATIONOFFSET"]*$page["PAGINATIONROWS"] >=$totalCount &&$page["PAGINATIONOFFSET"])
			$page["PAGINATIONOFFSET"] = $page["PAGINATIONOFFSET"]- 1;
		//是否要获取列表，如果不要的话，只返回总数
		if($type["CONSTAINLIST"])
		{
			$idSql    = "SELECT fc.*,u.USER_NAME AS USER_NAME ";
			$idSql   .= $sqlPublicPre;
			$idSql   .= " LIMIT ".SecurityFilter($page["PAGINATIONOFFSET"])*SecurityFilter($page["PAGINATIONROWS"]).",".SecurityFilter($page["PAGINATIONROWS"]);
			$rs     = exequery($connection,$idSql);
			//file_put_contents("D:\\idSql.txt",$idSql);
			while($row = mysql_fetch_array($rs,MYSQL_ASSOC))
			{
				$detailRows[] = $row;
			}
			$returnArray["list"] = $detailRows;
		}
		//返回结果
		return $returnArray;
	}
	/**
	*获取流程相关附件列表
	*@param  array $type           取值参数
	*@param  array $search         查询参数
	*@param  array $page           翻页参数
	*@param  array $other          自定义参数
	*@return array $returnArray    返回结果
	*/
	function getFlowRelatedAtt($type=array(),$search=array(),$page=array(),$other=array())
	{
		global $connection;
		//返回的固定格式的数组
		$returnArray = array("totalCount"=>"","list"=>array());
		//先查所有文档ID的串
		$query = "
					SELECT * from FLOW_RUN WHERE RUN_ID= '".$this->runId."'
				";
		$cursor= exequery($connection,$query);
		while($ROW   = mysql_fetch_array($cursor)){
			$ATTACHMENT_ID        = $ROW['ATTACHMENT_ID'];
			$ATTACHMENT_NAME      = $ROW['ATTACHMENT_NAME'];
			$ATTACHMENT_ID_ALL   .= $ATTACHMENT_ID;
			$ATTACHMENT_NAME_ALL .= $ATTACHMENT_NAME;
		}
		if($ATTACHMENT_ID_ALL != "")
		{
			$ATTACHMENT_ID_ARRAY   = explode(",",trim($ATTACHMENT_ID_ALL,","));
			$ATTACHMENT_NAME_ARRAY = explode("*",trim($ATTACHMENT_NAME_ALL,"*"));
			$ARRAY_COUNT = sizeof($ATTACHMENT_ID_ARRAY);
			$returnArray["totalCount"] = $ARRAY_COUNT;
			while($page["PAGINATIONOFFSET"]*$page["PAGINATIONROWS"] >=$ARRAY_COUNT &&$page["PAGINATIONOFFSET"])
				$page["PAGINATIONOFFSET"] = $page["PAGINATIONOFFSET"]- 1;
			$limit_start = $page["PAGINATIONOFFSET"]*$page["PAGINATIONROWS"];
			$limit_end   = $page["PAGINATIONROWS"];

			for($I=$limit_start;$I<$ARRAY_COUNT;$I++)
			{
				$doc_size_str = "";
				if($ATTACHMENT_ID_ARRAY[$I]=="")
					break;
				$ATTACH_IMAGE = fileTypeToFontIcon($ATTACHMENT_NAME_ARRAY[$I]);
				$doc_size     = attach_size($ATTACHMENT_ID_ARRAY[$I],$ATTACHMENT_NAME_ARRAY[$I]);
				$doc_size_convert = "";
				if ($doc_size > 1024){
					$doc_size_convert = round($doc_size/1024,0);
				}
				if ($doc_size >= 1024*1024){
					$doc_size_convert = round($doc_size/(1024*1024),2);
				}
				//关于操作权限
				$HANDLE_TYPE = "";
				if(isPicOfFile($ATTACHMENT_NAME_ARRAY[$I]))
				{
					$picType = strtolower(getFileSuffix($ATTACHMENT_NAME_ARRAY[$I]));
					if($picType == "jpg"||$picType == "gif"||$picType == "jpeg"||$picType == "png")
					{
						$HANDLE_TYPE .= "1,";
					}
					else
					{
						$HANDLE_TYPE .= "2,";
					}
				}
				if(getFilesuffix($ATTACHMENT_NAME_ARRAY[$I]) == 'pdf')
				{
					$HANDLE_TYPE .= "3,";
				}
				if(isOfficeOfFile($ATTACHMENT_NAME_ARRAY[$I]))
				{
					$HANDLE_TYPE .= "4,";
					if($other["ATTACH_EDIT"]&&$other["from"]!="view"){
						$HANDLE_TYPE .= "5,";
					}
				}
				$HANDLE_TYPE .= "6,";
				if($other["ATTACH_EDIT"]&&$other["from"]!="view"){
					$HANDLE_TYPE .= "7,";
				}
				$Rows["HANDLE_TYPE"]     = $HANDLE_TYPE;
				$Rows["DOC_SIZE"]        = $doc_size;
				$Rows["DOC_SIZE_CONVERT"]= $doc_size_convert;
				$Rows["ATTACHMENT_ID"]   = $ATTACHMENT_ID_ARRAY[$I];
				$Rows["ATTACHMENT_NAME"] = $ATTACHMENT_NAME_ARRAY[$I];
				$Rows["ATTACH_IMAGE"]    = $ATTACH_IMAGE;
				$Rows["ATTACHMENT_ID_CODE"]   = $ATTACHMENT_ID_ARRAY[$I]*3+2;
				$Rows["ATTACHMENT_NAME_CODE"] = urlencode($ATTACHMENT_NAME_ARRAY[$I]);
				$Rows["ATTACHMENT_NAME_CODE_64"] = base64_encode($ATTACHMENT_NAME_ARRAY[$I]);
				$Rows["FLOW_ID"]              = $this->flowId;
				$Rows["RUN_ID"]               = $this->runId;
				$Rows["LOGIN_USER_ID"]        = $search["USER_ID"];
				$Rows["PRCS_ID"]              = $other["PRCS_ID"];
				$Rows["FLOW_PRCS"]            = $other["FLOW_PRCS"];
				$detailRows[] = $Rows;
				$counter++;
				if($counter == $limit_end)
					break;
			}
			$returnArray["list"] = $detailRows;
			return $returnArray;
		}
		else
		{
			//返回结果
			return $returnArray;
		}
	}
	/**
	*@function 获取流程某步骤办理人、未办理人
	*@param $PRCS_ID   流程步骤号
	*@param $RUN_ID    流程运行编号
	*@return $transactUserArr 返回数组，里面有办理过的，未办理的，主办人(如果有)
	*/
	function getFlowTransactUser($RUN_ID,$PRCS_ID) {
		global $connection;
		$transactUserArr["HAVE_DEAL"]    = array();
		$transactUserArr["NOT_DEAL"]     = array();
		$transactUserArr["OP_FLAG_USER"] = array();
		$query  = "
					SELECT frp.RUN_ID,u.USER_NAME,
					CASE
					WHEN
						(frp.OP_FLAG=1 AND frp.DELIVER_TIME<>'NULL')
						OR
						(frp.OP_FLAG=0 AND frp.SAVEFORM_TIME<>'NULL') THEN u.USER_ID
					END HAVE_DEAL,
					CASE
					WHEN
						(frp.OP_FLAG=1 AND frp.DELIVER_TIME IS NULL)
						OR
						(frp.OP_FLAG=0 AND frp.SAVEFORM_TIME IS NULL) THEN u.USER_ID
					END NOT_DEAL,
					CASE
					WHEN
						OP_FLAG THEN u.USER_ID
					END OP_FLAG_USER
					FROM flow_run_prcs frp
					LEFT JOIN USER u ON u.USER_ID = frp.USER_ID
					WHERE frp.RUN_ID= '".SecurityFilter($RUN_ID)."'
					AND frp.PRCS_ID= '".SecurityFilter($PRCS_ID)."'
				";
		$cursor = exequery($connection,$query);
		while($ROW=mysql_fetch_array($cursor))
		{
			if($ROW["HAVE_DEAL"] && !in_array($ROW["HAVE_DEAL"], $transactUserArr["HAVE_DEAL"]))
				$transactUserArr["HAVE_DEAL"][$ROW["HAVE_DEAL"]]   = $ROW["USER_NAME"];

			if($ROW["NOT_DEAL"] && !in_array($ROW["NOT_DEAL"], $transactUserArr["NOT_DEAL"]))
				$transactUserArr["NOT_DEAL"][$ROW["NOT_DEAL"]]  = $ROW["USER_NAME"];
			if($ROW["OP_FLAG_USER"] && !in_array($ROW["OP_FLAG_USER"], $transactUserArr["OP_FLAG_USER"]))
				$transactUserArr["OP_FLAG_USER"][$ROW["OP_FLAG_USER"]]   = $ROW["USER_NAME"];
		}
		return $transactUserArr;
	}

	/**
	*@function 提交流程之后，根据节点设置进行流程抄送
	*@param $copyFlowParam   抄送所需参数
	*"RUN_ID" 流程ID,"COPY_USER" 抄送人ID,"FLOW_ID" 流程ID,"PRCS_ID" 步骤ID,"FLOW_PRCS" 节点ID
	*"smsContent" 短消息,"mbSmsContent" 手机短信,"emailContent" 邮件
	*/
	function copyFlowByProcessSet($copyFlowParam) {
		$byCopyUserId = SecurityFilter($copyFlowParam["byCopyUserId"]);
		// 留个设置，以后固定抄送的提醒需要按照配置的话，从这里走
		// 提交页面抄送的时候，提醒是跟着提交页面的
		if($copyFlowParam["copyFrom"] == "hostSubmit") {

		} else {
			$copyFlowParam['mbSmsContent'] = "1";
			$copyFlowParam['emailContent'] = "1";
			$copyFlowParam['smsContent']   = "1";
		}
		global $connection,$_lang;
		$termStr = "";
		if($this->flowType == "1") {
			// 固定流程
			//查设置的人员、角色、部门
			$query = "SELECT * FROM flow_process WHERE FLOW_ID = '".SecurityFilter($copyFlowParam["FLOW_ID"])."' AND PRCS_ID = '".SecurityFilter($copyFlowParam["FLOW_PRCS"])."'";
			$cursor = exequery($connection,$query);
			if($ROW=mysql_fetch_array($cursor))
			{
				$PRCS_COPY_USER          = SecurityFilter($ROW["PRCS_COPY_USER"]);
				$PRCS_COPY_DEPT          = SecurityFilter($ROW["PRCS_COPY_DEPT"]);
				$PRCS_COPY_PRIV          = SecurityFilter($ROW["PRCS_COPY_PRIV"]);
			}
			// 处理一下提交页面抄送时的被抄送人员
			$PRCS_COPY_USER = SecurityFilter($PRCS_COPY_USER.$byCopyUserId);
			if(str_replace(",","','",trim($PRCS_COPY_USER,",")))
				$termStr .= " USER_ID IN ('".str_replace(",","','",trim($PRCS_COPY_USER,","))."') OR";
			if(str_replace(",","','",trim($PRCS_COPY_PRIV,",")))
				$termStr .= " USER_PRIV IN ('".str_replace(",","','",trim($PRCS_COPY_PRIV,","))."') OR";
			if(str_replace(",","','",trim($PRCS_COPY_DEPT,",")))
				$termStr .= " DEPT_ID IN ('".str_replace(",","','",trim($PRCS_COPY_DEPT,","))."') ";
		} else if($this->flowType == "2") {
			// 自由流程
			$termStr .= " USER_ID IN ('".str_replace(",","','",trim($byCopyUserId,","))."') OR";
		}
		if(trim($termStr,"OR"))
		{
			$termStr = " AND ( ".trim($termStr,"OR")." ) ";
		}
		if($termStr) {
			$SMS_CONTENT = $_lang["flow_copy_sms_content"].$this->runName;
			$tablename   = "flow_run";
			$TABLE_ID    = $this->runId;
			$TABLE_VAR   = "FLOW_ID,RUN_ID,PRCS_ID,FLOW_PRCS,|".$this->flowId.",".$this->runId.",".$copyFlowParam["PRCS_ID"].",".$copyFlowParam["FLOW_PRCS"].",";
			$query1 = "
						SELECT DISTINCT USER_ID FROM user
						WHERE DEPT_ID>0
						".$termStr;
			$cursor1 = exequery($connection,$query1);
			$smsUserIdString = "";
			while($ROWS=mysql_fetch_array($cursor1)) {
				$copyFlowParam["BY_USER_ID"] = $ROWS["USER_ID"];
				$copyFlowParam["COPY_TYPE"]  = "1";
				$flowCopyId = $this->newFlowCopy($copyFlowParam);
				if($flowCopyId) {
					$USER_ID = $ROWS["USER_ID"];
					$smsUserIdString .= $USER_ID.",";
					if($copyFlowParam['mbSmsContent'])
					{
						if(ifSendMbSms())
						{
							$newSms = new MobileSms();
							$newSms->SelfSendMore($USER_ID,$SMS_CONTENT);
						}
					}
					if($copyFlowParam['emailContent'])
					{
						if(ifSendMbSms('email'))
						{
							$email = new email();
							$email->sendEmail($copyFlowParam["COPY_USER"],$USER_ID,$USER_ID,$_lang["flow_copy_deal_email_remind"],$SMS_CONTENT,date("Y-m-d H:i:s",time()),'','');
						}
					}
				}
			}
			if($copyFlowParam['smsContent'])
			{
                $TABLE_VAR .="|copy";
				sendSms($copyFlowParam["COPY_USER"],$smsUserIdString,$SMS_CONTENT,1,7,$tablename,$TABLE_ID,$TABLE_VAR);
			}
			//增加，被抄送人的文档权限
			if(trim($copyFlowParam["docId"],","))
			{
				addDocViewPur($copyFlowParam["docId"],"",$this->runId);
			}
			//增加子流程查看权限
			addViewUser($this->runId);
		}
	}

	/**
	*@function 新建抄送
	*@param $para 参数数组
	*@return 返回抄送ID
	*/
	function newFlowCopy($para){
		global $connection;
		//先查是否存在此人的抄送
		$COPY_ID = $this->getCopyByRunidUser($para["BY_USER_ID"],$para["RUN_ID"]);
		if($COPY_ID) {
			//重新抄送
			$query = "UPDATE flow_copy SET COPY_TIME = UNIX_TIMESTAMP(now()),COPY_TYPE = '".SecurityFilter($para["COPY_TYPE"])."',FLOW_ID = '".SecurityFilter($para["FLOW_ID"])."',PRCS_ID = '".SecurityFilter($para["PRCS_ID"])."',COPY_USER = '".SecurityFilter($para["COPY_USER"])."' WHERE COPY_ID = '".SecurityFilter($COPY_ID)."'";
			exequery($connection,$query);
			return "";
		} else {
			//新建抄送
			$copy_id = $this->insetFlowCopy($para);
			return $copy_id;
		}
	}
	/**
	*@function 流程抄送/密送数据插入
	*@param $para 参数数组
	*@return 返回抄送ID
	*/
	function insetFlowCopy($para){
		global $connection;
		$query = "
					INSERT INTO flow_copy(BY_USER_ID,RUN_ID,COPY_USER,COPY_TIME,COPY_TYPE,FLOW_ID,PRCS_ID)
					VALUES
					('".SecurityFilter($para["BY_USER_ID"])."','".SecurityFilter($para["RUN_ID"])."','".SecurityFilter($para["COPY_USER"])."',UNIX_TIMESTAMP(now()),'".SecurityFilter($para["COPY_TYPE"])."','".SecurityFilter($para["FLOW_ID"])."','".SecurityFilter($para["PRCS_ID"])."')";
		exequery($connection,$query);
		return mysql_insert_id();
	}
	//被抄送人查看流程，标记查看时间
	function markFlowCopyHaveReceive($BY_USER_ID){
		global $connection;
		$sql = "UPDATE flow_copy SET RECEIVE_TIME = NOW() WHERE RUN_ID = '".$this->runId."' AND BY_USER_ID = '".SecurityFilter($BY_USER_ID)."' AND RECEIVE_TIME IS NULL";
		exequery($connection,$sql);
	}
	//被抄送人提交流程，标记提交时间
	function markFlowCopyHaveSubmit($BY_USER_ID){
		global $connection;
		$sql = "UPDATE flow_copy SET SUBMIT_TIME = NOW() WHERE RUN_ID = '".$this->runId."' AND BY_USER_ID = '".SecurityFilter($BY_USER_ID)."' AND SUBMIT_TIME IS NULL";
		exequery($connection,$sql);
	}
	//获取某条抄送的所有信息
	function getFlowCopyInfo($COPY_ID){
		global $connection;
		$query  = "SELECT * FROM flow_copy WHERE COPY_ID = '".SecurityFilter($COPY_ID)."'";
		$cursor = exequery($connection,$query);
		if($ROW=mysql_fetch_array($cursor,MYSQL_ASSOC)) {
			$copyInfo = $ROW;
		}
		return $copyInfo;
	}
	//获取某条流程的所有抄送信息
	function getFlowCopyByRunId(){
		global $connection;
		$query  = "SELECT * FROM flow_copy WHERE RUN_ID = '".$this->runId."' AND FLOW_ID = '".$this->flowId."'";
		$cursor = exequery($connection,$query);
		while($ROW=mysql_fetch_array($cursor,MYSQL_ASSOC)) {
			$copyInfo[$ROW["PRCS_ID"]][] = $ROW;
		}
		return $copyInfo;
	}
	//根据流程id和人员id查询是否有抄送，返回抄送id或者空
	function getCopyByRunidUser($BY_USER_ID,$RUN_ID,$COPY_USER=""){
		global $connection;
		$query  = "SELECT * FROM flow_copy WHERE BY_USER_ID = '".SecurityFilter($BY_USER_ID)."' AND RUN_ID = '".SecurityFilter($RUN_ID)."'";
		if($COPY_USER)
			$query .= " AND COPY_USER = '".SecurityFilter($COPY_USER)."'";
		$cursor = exequery($connection,$query);
		$COPY_ID = "";
		if($ROW=mysql_fetch_array($cursor)) {
			$COPY_ID = $ROW["COPY_ID"];
		}
		return $COPY_ID;
	}
	/**
	*更改流程是否有效字段的值
	*@access public
	*@param  array $flowParamArray   流程相关参数，IS_EFFECT=0：失效，IS_EFFECT=1：生效
	*@param  array $updateWhereArray   需要的update限制条件
	*@param  array $setTableArray    操作哪几个表，默认操作 flow_run/flow_run_prcs/flow_run_step
	*@return str true/false  操作是否成功
	*/
	function updateFlowIsEffect($flowParamArray,$updateWhereArray='',$setTableArray='')
	{
		global $connection;
		if(!$setTableArray) {
			$setTableArray = array("flow_run","flow_run_prcs","flow_run_step");
		}
		if($flowParamArray["IS_EFFECT"])
			$IS_EFFECT = $flowParamArray["IS_EFFECT"];
		else
			$IS_EFFECT = "0";
		foreach ($setTableArray as $key => $value) {
			if ($value == "flow_run") {
				$sql = "UPDATE flow_run SET IS_EFFECT = '".SecurityFilter($IS_EFFECT)."' WHERE RUN_ID = '".SecurityFilter($flowParamArray["RUN_ID"])."'";
				if($updateWhereArray && $updateWhereArray["flow_run"])
					$sql .= $updateWhereArray["flow_run"];
				exequery($connection,$sql);
				unset($sql);
			}
			if ($value == "flow_run_prcs") {
				$sql = "UPDATE flow_run_prcs SET IS_EFFECT = '".SecurityFilter($IS_EFFECT)."' WHERE RUN_ID = '".SecurityFilter($flowParamArray["RUN_ID"])."'";
				if($updateWhereArray && $updateWhereArray["flow_run_prcs"])
					$sql .= $updateWhereArray["flow_run_prcs"];
				exequery($connection,$sql);
				unset($sql);
			}
			if ($value == "flow_run_step") {
				$sql = "UPDATE flow_run fr,flow_run_step frs SET frs.IS_EFFECT = '".SecurityFilter($IS_EFFECT)."' WHERE fr.run_id = frs.run_id AND fr.run_id = '".SecurityFilter($flowParamArray["RUN_ID"])."'";
				if($updateWhereArray && $updateWhereArray["flow_run_step"])
					$sql .= $updateWhereArray["flow_run_step"];
				exequery($connection,$sql);
				unset($sql);
			}
		}
		return true;
	}
	// 流程保存那里(autosave)，将流程设置为生效之后，获取流水号，保存到flow_run表
	function manualCreateFlowRunSeq($creator = "") {
		global $connection;
		if(!$creator) {
			$creator = $_SESSION["LOGIN_USER_ID"];
		}
		// 判断
		$sql = "SELECT ft.FLOW_NAME,ft.FLOW_SORT,ft.FLOW_TYPE,ft.FLOW_SEQUENCE,fs.TITLE FROM flow_type ft , flow_sort fs WHERE ft.FLOW_ID=".$this->flowId." AND ft.FLOW_SORT=fs.ID";
		$rs  = exequery($connection,$sql);
		if($row = mysql_fetch_array($rs)) {
			if($row["FLOW_SEQUENCE"]) {
				$sql1 = "SELECT RUN_SEQ FROM flow_run WHERE RUN_ID = '".$this->runId."'";
				$rs1  = exequery($connection,$sql1);
				if($row1 = mysql_fetch_array($rs1)) {
					if(!$row1["RUN_SEQ"]) {
						$seq = $this->getSeqAuto($creator);
						if(gettype($seq) == "array" && $seq["error"]) {
							return $seq;
						} else {
							$query = "UPDATE flow_run fr SET RUN_SEQ = '".SecurityFilter($seq)."',CREATE_TIME = NOW() WHERE run_id = '".$this->runId."'";
							exequery($connection,$query);
							return $seq;
						}
					}
				}
			}
		}
	}
	// 签办反馈那里，获取流程步骤id和步骤名称
	function getFeedBackListJoinPrcsDetail(){
		global $connection,$_lang;
		$detailRows = array();
		if($this->flowType == "1") {
			$sql = "
					SELECT frf.PRCS_ID,fp.PRCS_NAME FROM flow_run_feedback frf
					LEFT  JOIN flow_process fp ON frf.FLOW_PRCS = fp.PRCS_ID
					WHERE frf.RUN_ID='".$this->runId."' AND fp.FLOW_ID='".$this->flowId."'
					GROUP BY frf.PRCS_ID
					ORDER BY frf.SEQ_ID ASC
					";
		} else {
			$sql = "
					SELECT PRCS_ID,CONCAT('".SecurityFilter($_lang["flow_no."])."',PRCS_ID,'".SecurityFilter($_lang["flow_steps"])."') PRCS_NAME FROM flow_run_feedback
					WHERE RUN_ID = '".$this->runId."'
					GROUP BY PRCS_ID
					ORDER BY SEQ_ID ASC
					";
		}
		$cursor = exequery($connection,$sql);
		while($ROW = mysql_fetch_assoc($cursor)) {
			$detailRows[$ROW["PRCS_ID"]] = $ROW["PRCS_NAME"];
		}
		return $detailRows;
	}
}
?>
