<?php
@session_start();
include_once("inc/conn.php");

class Update
{
	private $serverUrl = 'http://v10.e-office.cn/eoffice9update/';
	private $tmpPath = '';
	private $dataPath = '';
	public function __construct()
	{
		$this->tmpPath = dirname(dirname(__FILE__)).'/updatetmp/';
		$this->dataPath = dirname(dirname(__FILE__)).'/data/';
	}
	
	public function checkVersion()
	{
		$opts = array(   
		  'http'=>array(   
			'method'=>"GET",   
			'timeout'=>3,//单位秒  
		   )   
		);
		$version = $this->_getClientVersion();
		ob_flush();
		
		$content = @file_get_contents($this->serverUrl . 'update.php?version=' . $version, false, stream_context_create($opts));
		
		if(!$content){
			echo json_encode(array('status' => 0, 'errors' => '请检查服务器环境是否有外网！'));exit;
		}
		echo $content;exit;
	}
	public function viewVersion()
	{
		$version = isset($_GET['version']) && $_GET['version'] ? $_GET['version'] : '';
		
		echo '<div style="font-size:24px;text-align:center;margin-top:30px;">检测到当前系统有新的安全补丁，建议立即更新！</div>';
		echo '<div style="font-size:30px;text-align:center;margin-top:15px;">v9.5 '.$version.'</div>';
		exit;
	}
	public function run()
	{
		if(!$_SESSION["LOGIN_USER_ID"] || $_SESSION["LOGIN_USER_ID"] != 'admin'){
			echo '<div style="width:300px;border:1px dashed #ddd;height:80px;text-align:center;line-height:80px;font-size:20px;margin:auto;color:#999">';
			echo '无权限访问!';
			echo '</div>';
			exit;
		}
		ob_implicit_flush(true);
		$begin = microtime(true);
		$version = $this->_getClientVersion();
		//echo "<div style='width:800px'>";
		echo "<b style=\"font-size:3rem;color:green;\">E-OFFICE</b>";
		echo ' (v9.5 ' .$version . ')<br/>';
		if(!$version) {
			echo '系统当前已是最新版本!';exit;
		}
		echo '连接更新服务器...##################################<br/>';
		$updateVersion = $this->_getUpdateVersion($version);
		if(!$updateVersion) {
			echo '系统当前已是最新版本!';
		} else {
			$tmp = $this->_downloadUpdateFile($updateVersion);
			echo '下载完成,准备解压...################################<br/>';
			echo "升级包解压中... ###################################<br/>";
			exec(dirname(__FILE__). '/7z.exe x "' . $tmp . '" -o"'.dirname(dirname(__FILE__)) . '" -aoa');
			echo '解压完成,准备备份数据...#############################<br/>';
			//ob_flush();
			//$this->_copyFile($this->tmpPath . 'webroot', './');
			//echo '复制完成,准备备份数据<br/>';
			$this->_backupData($version);
			$this->_update();
			$this->_removeDir($this->tmpPath);
			echo '系统完成升级... ###################################<br/>';
		}
		//echo "</div>";
	}
	private function _backupData($version)
	{
		global $MYSQL_DB;
		
		echo '数据备份中...#####################################<br/>';
		if(file_exists($this->dataPath . $MYSQL_DB)) {
			exec(dirname(__FILE__). '/7z.exe a "' . $this->dataPath .$version. '.zip" "'.$this->dataPath . $MYSQL_DB . '/*" -aoa');
		}
		echo '数据备份完成，准备升级... ###########################<br/>';
	}
	private function _removeDir($dir) {
	   //先删除目录下的文件：
	   $dh=opendir($dir);
	   while ($file=readdir($dh)) {
		  if($file!="." && $file!="..") {
			 $fullpath=$dir."/".$file;
			 if(!is_dir($fullpath)) {
				unlink($fullpath);
			 } else {
				$this->_removeDir($fullpath);
			 }
		  }
	   }
	 
	   closedir($dh);
	   //删除当前文件夹：
	   if(rmdir($dir)) {
		  return true;
	   } else {
		  return false;
	   }
	}
	private function _update()
	{
		echo '开始升级脚本... ###################################<br/>';
		echo '脚本升级中....... ###################################<br/>';
		echo '<div style="display:none;">';
		if(file_exists(dirname(__FILE__) . '/update/1.php')) {
			try{
			 include('update/1.php');
			} catch(Exception $e) {
				echo $e->getMessage();
			}
			unlink(dirname(__FILE__) . '/update/1.php');
		}
		echo '</div>';
		echo '脚本升级结束... ###################################<br/>';
	}
	private function _copyFile($src = '', $dst = '')
	{
		if (empty($src) || empty($dst)) {
			return false;
		}
	 
		$dir = opendir($src);
		$this->_mkdir($dst);
		while (false !== ($file = readdir($dir))) {
			if (($file != '.') && ($file != '..')) {
				if (is_dir($src . '/' . $file)) {
					$this->_copyFile($src . '/' . $file, $dst . '/' . $file);
				} else {
					copy($src . '/' . $file, $dst . '/' . $file);
				}
			}
		}
		closedir($dir);
	 
		return true;
	}
	private function _mkdir($path = '', $mode = 0777, $recursive = true)
	{
		clearstatcache();
		if (!is_dir($path)) {
			mkdir($path, $mode, $recursive);
			return chmod($path, $mode);
		}
	 
		return true;
	}
	private function _downloadUpdateFile($updateVersion)
	{
		ob_flush();
		if(!is_dir($this->tmpPath)){
			mkdir($this->tmpPath);
		}
		$tmp = $this->tmpPath . $updateVersion . '.zip';
		$localHandler = fopen($tmp, 'wb');
		echo '开始下载更新文件... ################################<br/>';
		ob_flush();
		$remoteHander = fopen($this->serverUrl . $updateVersion . '/webroot.zip', 'rb');
		while (!feof($remoteHander)) {
			fwrite($localHandler, fread($remoteHander, 128));
		}
		fclose($remoteHander);
		fclose($localHandler);
		return $tmp;
	}
	private function _getClientVersion()
	{
		global $connection;
		
		$sql = "SELECT * FROM version";
                        
		$res = exequery($connection,$sql);
		if($row = mysql_fetch_array($res)) {
			$ver = $row["VER"];
			$verExplode = explode(' ', $ver);
			
			return $verExplode[1];
		} 
		mysql_free_result($res);
		mysql_close($connection);
		return false;
	}
	
	private function _getUpdateVersion($version)
	{
		$opts = array(   
		  'http'=>array(   
			'method'=>"GET",   
			'timeout'=>3,//单位秒  
		   )   
		);
		ob_flush();
		
		$content = @file_get_contents($this->serverUrl . 'update.php?version=' . $version, false, stream_context_create($opts));
		
		if(!$content){
			echo '请检查服务器环境是否有外网！';exit;
		}
		$info = json_decode($content, true);
		if($info && $info['status'] == 1) {
			return $info['version'];
		}
		return false;  
		
	}
}
$update = new Update();
$method = isset($_GET['method']) && $_GET['method'] ? $_GET['method'] : 'run';
$update->{$method}();
