<?php
/**
*@page  rtx配置页面
*
*/
include_once("inc/conn.php");
include_once("building/function.php");
include_once("building/backmgr/loginauth.php");

$configdir  = ROOT_PATH.DIRECTORY_SEPARATOR."building".DIRECTORY_SEPARATOR."config";
$configfile = $configdir.DIRECTORY_SEPARATOR."rtx_config.ini";

$ini_array  = @parse_ini_file($configfile);

if($ini_array['state'] == 1) {
	$checked = "checked";
} else {
	$checked = "";
}

if($ini_array['sms'] == 1) {
	$sms_rtx = "checked";
} else {
	$sms_rtx = "";
}

if($ini_array['offline_sms'] == 1) {
	$offline_sms = "checked";
} else {
	$offline_sms = "";
}

if($ini_array['any_sms'] == 1) {
	$any_sms = "checked";
} else {
	$any_sms = "";
}

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>rtx配置页面</title>
<meta http-equiv="Content-Type" content="text/html; charset=<?=$_lang['encoding']?>">
<link rel="stylesheet" type="text/css" href="/newplugins/js/jquery-ui/css/ui-lightness/jquery-ui.css">
<link rel="stylesheet" type="text/css" href="/newplugins/font-awesome/css/font-awesome.min.css">
<link rel="stylesheet" type="text/css" href="/newplugins/bootstrap/css/bootstrap.min.css">
<link rel="stylesheet" type="text/css" href="/newplugins/js/bootstrap-select/bootstrap-select.min.css">
<link rel="stylesheet" type="text/css" href="/newplugins/js/iCheck/skins/all.css">
<link rel="stylesheet" href="/newplugins/js/pnotify/jquery.pnotify.default.css" />
<link rel="stylesheet" type="text/css" href="/newplugins/css/jquery.lazyplugins.css">
<link rel="stylesheet" type="text/css" href="/newplugins/css/style.css" rel="stylesheet" />
</head>
<body>	
<div class="lazy_header">
	<span class="lazy-page-title">
		<i class="fa fa-page-title"></i>
		<span class="tip">RTX配置</span>
	</span>
	<button type="button" class="btn btn-primary" id="sync" onclick="syncAll();">一键同步</button>
	<button type="button" class="btn btn-primary" id="submit" style="margin-rigth:20px;margin-top:5px;">保存配置</button>
</div>
<div style="width:100%;">
	<form name="form1" id="form1" method="post" action="config_do.php?op=rtx">
		<table border="0" cellspacing="0" width="90%" class="form_table" cellpadding="5">
			<tr>
				<td class="title">RTX服务器IP地址</td>
				<td nowrap>
					<input type="text" name="rtx_ip" id="rtx_ip" size="20" maxlength="20" value="<?=$ini_array['ip']?>" />&nbsp;&nbsp;(不在同一台应用服务器上,需添加本机IP到RTX服务器目录下的AppConnConfig.xml、SDKProrpery.xml)
				</td>
			</tr>
			<tr>
				<td class="title">RTX服务器端口</td>
				<td nowrap>
					<input type="text" name="rtx_port" id="rtx_port" size="20" maxlength="20" value="<?=$ini_array['port']?>" />&nbsp;&nbsp;(消息提醒接口端口)
				</td>
			</tr>
			<tr>
				<td class="title">RTXServerSDK端口</td>
				<td nowrap>
					<input type="text" name="rtx_sdk_port" id="rtx_sdk_port" size="20" maxlength="20" value="<?=$ini_array['sdk_port']?>"  />&nbsp;&nbsp;(用户同步数据SDK端口)
				</td>
			</tr>			
			<tr>
				<td class="title">设置提醒消息停留时间</td>
				<td nowrap>
					<input type="text" name="rtx_time" id="rtx_time" size="20" maxlength="20" value="<?=$ini_array['time']?>"/>&nbsp;&nbsp;秒(0秒表示一直停留)
				</td>
			</tr>
			<tr>
				<td class="title">是否启用RTX消息提醒</td>
				<td nowrap>
					<input type="checkbox" name="sms_rtx" id="sms_rtx" size="20" maxlength="20" <?=$sms_rtx?>/>&nbsp;&nbsp;(启用该功能，有内部消息提醒的模块，也会收到RTX消息提醒)
					<input type="hidden" name="rtx_used" id="rtx_used" value="<?=$ini_array['sms']?>">
				</td>
			</tr>
		</table>
	</form>
</div>
</body>
</html>
<script type="text/javascript" src="/inc/jquery/jquery.js"></script>
<script type="text/javascript" src="/newplugins/js/jquery.lazyplugins.js"></script>
<script type="text/javascript" src="/newplugins/js/iCheck/icheck.js"></script>
<script type="text/javascript" src="/newplugins/bootstrap/js/bootstrap.min.js"></script>
<script type="text/javascript" src="/newplugins/js/bootstrap.bootbox.js"></script>
<script type="text/javascript" src="/newplugins/js/pnotify/jquery.pnotify.min.js"></script>
<script type="text/javascript" src="/newplugins/js/jquery.nicescroll.js"></script>
<script type="text/javascript" src="/newplugins/js/jquery.form.js"></script>
<script type="text/javascript">
	$(function() {
		$.pnotify.defaults.styling = "bootstrap3";
		$.pnotify.defaults.sticker = false;
		$.pnotify.defaults.history = false;
		$.pnotify.defaults.delay   = 2000;

		$('#submit').click(function() {
			var servIp   = $.trim($("#rtx_ip").val());
			var servPort = $.trim($("#rtx_port").val())
			var servSdkPort = $.trim($("#rtx_sdk_port").val());
			var rtxTime     = $.trim($("#rtx_time").val());
			var rtxUsed     = $.trim($("#rtx_used").val());

			if(servIp == '')
			{
				$.pnotify({
					text:"服务器IP地址不能为空",
					type:"error"
				});
				return false;
			}

			if(servPort == '')
			{
				$.pnotify({
					text:"服务器端口不能为空",
					type:"error"
				});
				return false;
			}

			if(servSdkPort == '')
			{
				$.pnotify({
					text:"ServerSDK端口不能为空",
					type:"error"
				});
				return false;
			}

			if(rtxTime == '')
			{
				$.pnotify({
					text:"消息停留时间不能为空",
					type:"error"
				});
				return false;
			}

			$('#form1').ajaxSubmit({
				success:function(resp)
				{
					if(resp)
					{
						$.pnotify({
							text:'保存成功',
							type:'success'
						});
					}
				}
			});
			/*$.ajax({
				url:"/building/do.php",
				data:"do=rtxconfig&IP="+servIp+"&PORT="+servPort+"&SDKPORT="+servSdkPort+"&TIME="+rtxTime+"RTXUSED="+rtxUsed,
				type:"POST",
				success:function(resp)
				{
					if(resp)
					{
						$.pnotify({
							text:"保存成功",
							type:"success"
						});
					}
				}
			});*/
		});

		$("#sms_rtx").iCheck({
		    checkboxClass : 'icheckbox_square-blue',
		    radioClass : 'iradio_square-blue'
		});

		$("#sms_rtx").on("ifChanged",function() {
			var smsrtx = $("#sms_rtx").attr("checked");
			smsrtx == "checked"?$("#rtx_used").val("1"):$("#rtx_used").val("0");

		});
	});

	//一键同步
	function syncAll()
	{
		bootbox.confirm("是否确定同步信息",function(result) {
			if(result)
			{

			}
		});	
	}
</script>
