<?
/**
 * Systemname:     building
 * Filename:       $path/$name
 * Function:       $function
 * Encoding:       $_lang['encoding']
 * Author:         www.weaver.com.cn
 * Date:           2011-11-21
 * Version:        1.x
*/

/*
* 复制目录包含目录下文件和目录
*/
function copyDir($source, $destination)
{
    $result = true;

    if(! is_dir($source))
    {
        //trigger_error('Invalid Parameter', E_USER_ERROR);
    }
    if(! is_dir($destination))
    {
        if(! mkdir($destination, 0700))
        {
            //trigger_error('Invalid Parameter', E_USER_ERROR);
        }
    }

    $handle = opendir($source);
    while(($file = readdir($handle)) !== false)
    {
        if($file != '.' && $file != '..')
        {
            $src = $source . DIRECTORY_SEPARATOR . $file;
            $dtn = $destination . DIRECTORY_SEPARATOR . $file;
            if(is_dir($src))
            {
                copyDir($src, $dtn);
            }
            else
            {
                if(! copy($src, $dtn))
                {
                    $result = false;
                    break;
                }
            }
        }
    }
    closedir($handle);

    return $result;
}


/*
* 删除目录包含目录下文件和目录
*/
function removeDir($dirName)
{
    $result = false;

    if(! is_dir($dirName))
    {
        return $result;
    }

    $handle = opendir($dirName);
    while(($file = readdir($handle)) !== false)
    {
        if($file != '.' && $file != '..')
        {
            $dir = $dirName . DIRECTORY_SEPARATOR . $file;
            is_dir($dir) ? removeDir($dir) : unlink($dir);
        }
    }
    closedir($handle);

    $result = rmdir($dirName) ? true : false;

    return $result;
}

/*
* 写入 ini格式的文件
*/
function write_ini_file($path, $assoc_array) {

	foreach($assoc_array as $key => $item) {
		if(is_array($item)) {
			$content .= "\n[{$key}]\n";
			foreach ($item as $key2 => $item2) {
				if(is_numeric($item2) || is_bool($item2)) 
					$content .= "{$key2} = {$item2}\n";
				else
					$content .= "{$key2} = \"{$item2}\"\n";
			}
		}
		else {
			if(is_numeric($item) || is_bool($item)) 
				$content .= "{$key} = {$item}\n";
			else
				$content .= "{$key} = \"{$item}\"\n";
		}
	}    

	if(!$handle = fopen($path, 'w')) {
		return false;
	}

	if(!fwrite($handle, $content)) {
		return false;
	}

	fclose($handle);
	return true;

}

/*
* 读取配置信息
*/
function read_ini_file($type="") {
	$ds = DIRECTORY_SEPARATOR;
	if(empty($type)){
		$configfile = dirname(__file__).$ds."config".$ds."config.ini";
	}else{
		$configdir = ROOT_PATH.$ds."building".$ds."config";
		$configfile = $configdir.$ds.$type."_config.ini";
	}
	$ini_array = @parse_ini_file($configfile);
	return $ini_array;
}

/*
* 3des加密 
* $dat 未加密字符  $key 密钥 $iv 向量
*/
function TripleDESencode($dat,$key,$iv){
	
	$key = pack("H48",$key);
	$iv  = pack("H16",$iv);

	$block_size = mcrypt_get_block_size('tripledes', 'cbc');

	$padding_char = $block_size - (strlen($dat) % $block_size);

	if ($padding_char==$block_size) {
		$padding_char=0;
	}

	$dat .= str_repeat(chr($padding_char),$padding_char);

	$td = mcrypt_module_open(MCRYPT_3DES, '', MCRYPT_MODE_CBC, '');

    mcrypt_generic_init($td, $key, $iv); 

    $encrypted = mcrypt_generic($td, $dat);

	mcrypt_generic_deinit($td);

	mcrypt_module_close($td);

	return $encrypted;
}

/*
* 3des解密 
* $dat 已加密字符  $key 密钥 $iv 向量
*/
function TripleDESdecode($dat,$key,$iv){

	$key = pack("H48",$key);
	$iv  = pack("H16",$iv);

	$td = mcrypt_module_open(MCRYPT_3DES, '', MCRYPT_MODE_CBC, '');

	mcrypt_generic_init($td, $key, $iv);

	$decrypted = mdecrypt_generic ($td, $dat);

	mcrypt_generic_deinit($td);

	mcrypt_module_close($td);

	if ($decrypted=='') {
		$decrypted = '';
	}

	$l=strlen($decrypted);

	$n=ord($decrypted[$l-1]);

	$decrypted=substr($decrypted,0,$l-$n);

	return $decrypted;
}

/*
* 生成key 
*/
function getTripleDESKey($str){

	$key  = chunk_split(md5($str),2,'0');

	return $key;
}



?>