// JavaScript Document
//文字验证
function Arc_WordCheck(obj){
	var pattern = /^([\u4E00-\uFA29]*[a-z]*[A-Z]*[0-9]*)+$/;
	//记录光标位置
	var pos       = getPosition(obj);
	//var fieldvalue = obj.value.replace(/(^\s*)|(\s*$)/g, ""); 
	var fieldvalue = obj.value; 
	if(fieldvalue!=""){
		var rs = "";
		if(!pattern.test(fieldvalue)){
			var notice_toid = $.pnotify({
	        		text: AnalysConfig.AnalysStr,
	        		type : "error",
					animate_speed: 'fast'
	    	}).click(function() {
	    			notice_toid.pnotify_remove();
			});
			var count = 0;
			for(var i = 0; i < fieldvalue.length; i++)
			{
				var dovalue = fieldvalue.substr(i,1);
				if(!pattern.test(dovalue)){
					rs += "";	
					count++;
				}else{
					rs += dovalue;	
				}
			}
			obj.value = rs;
			setCursorPosition(obj,parseInt(pos)-parseInt(count));	
		}	
	}
}
//数字验证
function Arc_NumberCheck(obj,checkid,checkimg){
	var pattern = /^\d+$/;
	var fieldvalue = obj.value;
	if(fieldvalue!=""){
		var pos       = getPosition(obj);
		if(!pattern.test(fieldvalue)){
			var notice_toid = $.pnotify({
	        		text: AnalysConfig.AnalysNum,
	        		type : "error",
					animate_speed: 'fast'
	    	}).click(function() {
	    			notice_toid.pnotify_remove();
			});
			var rs = "";
			var count = 0;
			for(var i = 0; i < fieldvalue.length; i++)
			{
				if(!pattern.test(fieldvalue[i])){
					rs += "";	
					count++;
				}else{
					rs += fieldvalue[i];	
				}
			}
			obj.value = rs.replace(/(^\s*)|(\s*$)/g, "");
			setCursorPosition(obj,parseInt(pos)-parseInt(count));
		}
		if(checkid!="" && checkimg!=""){
			Arc_CheckRequired(checkid,checkimg);	
		}	
	}
	
}
//日期时间验证
function Arc_DateCheck(obj,type,checkid,checkimg){
	var checkvalue = obj.value;
	if(checkvalue!=""){
		if(type=="date"){
			//正确日期格式：YYYY-MM-DD 或者 YYYY/MM/DD
			if(!Arc_RQcheck(checkvalue)){
				var notice_toid = $.pnotify({
		        		text: AnalysConfig.AnalysDate,
		        		type : "error",
						animate_speed: 'fast'
		    	}).click(function() {
		    			notice_toid.pnotify_remove();
				});
				obj.value = "";
			}
		}else if(type=="time"){
			//正确时间格式：HH:MM
			checkvalue += ":00";
			if(!Arc_CheckTime(checkvalue)){
				var notice_toid = $.pnotify({
		        		text: AnalysConfig.AnalysDate,
		        		type : "error",
						animate_speed: 'fast'
		    	}).click(function() {
		    			notice_toid.pnotify_remove();
				});
				obj.value = "";	
			}	
		}else if(type=="all"){
			//正确日期格式：YYYY-MM-DD HH:MM 或者 YYYY/MM/DD HH:MM
			checkvalue += ":00";
			if(!Arc_DTCheck(checkvalue)){
				var notice_toid = $.pnotify({
		        		text: AnalysConfig.AnalysDate,
		        		type : "error",
						animate_speed: 'fast'
		    	}).click(function() {
		    			notice_toid.pnotify_remove();
				});
				obj.value = "";
			}	
		}
		if(checkid!="" && checkimg!=""){
			Arc_CheckRequired(checkid,checkimg);	
		}		
	}
	
}
//验证日期格式
function Arc_RQcheck(RQ) {
	var date = RQ;
	var result = date.match(/^(\d{1,4})(-|\/)(\d{1,2})\2(\d{1,2})$/);
	if (result == null)
		return false;
	var d = new Date(result[1], result[3] - 1, result[4]);
	return (d.getFullYear() == result[1] && (d.getMonth() + 1) == result[3] && d.getDate() == result[4]);
}
//时间格式验证
function Arc_CheckTime(str)     
{     
  var a = str.match(/^(\d{1,2})(:)?(\d{1,2})\2(\d{1,2})$/);     
  if (a==null)
     {
        //alert('时间格式不正确');   
        return false;
      }     
  if (a[1]>24 || a[3]>60 || a[4]>60)     
  {     
      //alert("无效时间");     
      return false     
  }     
  return true;     
}
//日期+时间格式验证
function Arc_DTCheck(str){
	var result=str.match(/^(\d{4})(-|\/)(\d{1,2})\2(\d{1,2}) (\d{1,2}):(\d{1,2}):(\d{1,2})$/); 
	if(result==null) 
		return false; 
	var d= new Date(result[1], result[3]-1, result[4], result[5], result[6], result[7]); 
	return (d.getFullYear()==result[1]&&(d.getMonth()+1)==result[3]&&d.getDate()==result[4]&&d.getHours()==result[5]&&d.getMinutes()==result[6]&&d.getSeconds()==result[7]); 
}
//必填检测

function Arc_CheckRequired(id,imgid){
	var checkvalue = $.trim($("#"+id).val());
	if(checkvalue!=""){
		$("#"+id).attr("class","");	
	}else{
		$("#"+id).attr("class","require");		
	}
}
//日期+时间控件处理
function Arc_DateTimeDo(obj,recordid,diff){
	var data = obj.value;
	var havevalue = $("#"+recordid).val();
	var newvalue = "";
	if(diff=="date"){
		if(havevalue==""){
			newvalue = data+" ";	
		}else{
			var strs = new Array();
			strs = havevalue.split(" ");
			if(strs[0]!=""){
				newvalue = havevalue.replace(strs[0],data);		
			}else{
				newvalue = data+havevalue;	
			}	
		}	
	}else if(diff=="time"){
		if(havevalue==""){
			newvalue = " "+data;	
		}else{
			var strs = new Array();
			strs = havevalue.split(" ");
			if(strs[1]!=""){
				newvalue = havevalue.replace(strs[1],data);		
			}else{
				newvalue = havevalue+data;	
			}		
		}		
	}
	$("#"+recordid).val(newvalue);
}
//必填项检测

function Arc_requirecheck(strid,diff){
	if(strid!=""){
		var formcheck = "";
		var strs = new Array();
		var $element; 
		strs = strid.split(",");	
		if(diff=="check"){
			for(i=0;i<strs.length ;i++){
				if(strs[i]!=""){
					$element = $("#"+strs[i]);
					if($element.val()){
						//$("#"+strs[i]).attr("class","");
						$element.removeClass('require');
					}	
				}	
			}
		}else if(diff=="submit"){
			for(i=0;i<strs.length ;i++){
				if(strs[i]!=""){
					if($("#"+strs[i]).val()==""){
						//alert("请检查必填项！");
						var notice_toid = $.pnotify({
				        		text: AnalysConfig.AnalysNeed,
				        		type : "error",
								animate_speed: 'fast'
				    	}).click(function() {
				    			notice_toid.pnotify_remove();
						});
						formcheck = "no";
						return false;	
					}
				}	
			}	
		}
		if(formcheck==""){
			return true;	
		}else{
			return false;	
		}
	}
}