<?php
include_once("inc/auth.php");
include_once("inc/utility_all.php");//引入公共函数文件。
include_once('api/MobileAttend.class.php');
include_once("inc/function_usergeneral.php");
define('VIEW_PATH', 'general/attendance/mobile/view/');
define('IMG_PATH','/'.VIEW_PATH.'images/');
define('JS_PATH','/'.VIEW_PATH.'js/');
define('CSS_PATH','/'.VIEW_PATH.'css/');
$method = request_var('m','noMethod');
includelangpak("attend");
$MAttend = new MAttend();
$MAttend -> $method();
/**
 * 移动考勤代理类
 */
class MAttend {
    private $_MobileAttend;
	
    private $_pageSize = 10;
	
    public function __construct() {
        $this->_MobileAttend = new MobielAttend();
    }
	/**
	 * 移动考勤初始化
	 * @global array $_lang
	 */
    public function init(){
        global $_lang;
        $deptList   = $this->_MobileAttend->getDeptList();
        $year       = date('Y');
        $month      = intval(date('m'));
        $day        = intval(date('d'));
        $days       = $this->getMonthLastDay($month, $year);
        include(VIEW_PATH.'index.view.php');
    }
	/**
	 * 错误跳转
	 * @global array $_lang
	 */
    public function noMethod(){
		global $_lang;
		echo $_lang["attend_no_method"];
    }
	/**
	 * 获取用户列表
	 */
    public function getUserList(){
        $dataKey    = request_var('dataKey');
        $dataValue  = request_var('dataValue');
        $condition      = '';
        if($dataValue){
            $condition = " AND `$dataKey` LIKE '%$dataValue%'";
        }
        $userList = $this->_MobileAttend->getUserList($condition);
        echo json_encode($userList);
    }
	/**
	 * 获取考勤记录
	 */
    public function getRecords(){
		$type		= request_var('type', '');
		$page		= request_var('page', 1);
		$userId		= request_var('userId');
		$deptId		= request_var('deptId',0);
		$year		= request_var('year');
		$month		= request_var('month');
		$day		= request_var('day');
		$startTime	= request_var('startTime');
		$endTime	= request_var('endTime');
		$pageSize	= $type == 'export' ? 5000 : $this->_pageSize;
		$start		= ($page - 1) * $pageSize;
		$startDate	= $endDate = '';

		if ($year && $month != 'all' && $day != 'all') {
			$startDate	= $year . '-' . $month . '-' . $day . ' 00:00:00';
			
			$endDate	= $year . '-' . $month . '-' . $day . ' 23:59:59';
		} elseif ($year && $month != 'all' && $day == 'all') {
			$startDate = $year . '-' . $month . '-01' . ' 00:00:00';
			
			if ($month != 12) {
				$endDate = $year . '-' . ($month + 1) . '-01' . ' 00:00:00';
			} else {
				$endDate = ($year + 1) . '-01' . '-01' . ' 00:00:00';
			}
		} elseif ($year && $month == 'all' && $day == 'all') {
			$startDate = $year . '-01' . '-01' . ' 00:00:00';
			
			$endDate = ($year + 1) . '-01' . '-01' . ' 00:00:00';
		} else {
			if ($startTime && $endTime) {
				$startDate = $startTime . ' 00:00:00';

				$endDate = $endTime . ' 23:59:59';
			} else if ($startTime && !$endTime) {
				$startDate = $startTime . ' 00:00:00';
			} else if (!$startTime && $endTime) {
				$endDate = $endTime . ' 23:59:59';
			}
		}

		$_startTime = $startDate != '' ? strtotime($startDate) : '';

		$_endTime = $endDate != '' ? strtotime($endDate) : '';
		
		if($type == 'total') {
			echo $this->_MobileAttend->getRecordsCount($userId,$deptId, $_startTime, $_endTime);
			
			exit;
		}
		
		$recordList = $this->_MobileAttend->getRecords($userId,$deptId, $_startTime, $_endTime, $start, $pageSize);

		if ($type == 'export') {
			$this->exportData($recordList,$year, $month, $day, $startTime, $endTime, $userId, $deptId);
		} else {
            $tempdata = array();
            foreach($recordList as $value){
                
               $imgs = trim($value["out_img"],",");
                $imgObjs  = explode(",",$imgs);

                $str = " ";
                if(count($imgObjs)){
                    foreach($imgObjs as $obj){
                          $str  .= "<div class='img-box-layer'><div class='img-content' onclick=previewImg('".$obj."')><img src='".$obj."' style='width:50px;height:50px;'/></div></div>";
                    }
                }
                
                $value["out_img_html"] = $str;
                
                array_push($tempdata, $value);
                
                
            }
            
			echo json_encode($tempdata);
		}
	}
    
    
    /**
     * 微信考勤获取固定时间期间的考勤记录
     */
    public function weixinGetRecords(){
            
		$page		= request_var('page', 1);
		$userId		= request_var('userId');
		$deptId		= request_var('deptId',0);
		$year		= request_var('year');
		$month		= request_var('month');
		$day		= request_var('day');
		$_startTime	= request_var('startTime');
		$_endTime	= request_var('endTime');
		$pageSize	= $type == 'export' ? 5000 : $this->_pageSize;
		$start		= ($page - 1) * $pageSize;
   
		$recordList = $this->_MobileAttend->getRecords($userId,$deptId, $_startTime, $_endTime, 0, 31);
        echo json_encode($recordList);
            
    }
    
	/**
	 * 导出考勤记录数据
	 * 
	 * @global array $_lang
	 * 
	 * @param array $data 导出的数据
	 * @param int $year 年
	 * @param int $month 月	
	 * @param int $day 日
	 * @param string $startTime 开始时间
	 * @param string $endTime 结束时间
	 * @param string $userId 用户id
	 * 
	 * @author 李志军
	 * 
	 * @since 2015-10-23
	 */
	public function exportData($data, $year, $month, $day, $startTime, $endTime, $userId,$deptId)
	{
		global $_lang;
		$total      = sizeof($data);

		if ($year && $month != 'all' && $day != 'all') {
			$title = $year . $_lang["attend_year"] . $month . $_lang["attend_month"] . $day . $_lang["attend_day"] . ' ' . $_lang["attend_attend_record"];
		} elseif ($year && $month != 'all' && $day == 'all') {
			$title = $year . $_lang["attend_year"] . $month . $_lang["attend_month"] . ' ' . $_lang["attend_all"] . $_lang["attend_attend_record"];
		} elseif ($year && $month == 'all' && $day == 'all') {
			$title = $year . $_lang["attend_year"] . ' ' . $_lang["attend_all"] . $_lang["attend_attend_record"];
		} else {
			if ($startTime && $endTime) {
				$title = $startTime . $_lang["attend_to"] . $endTime . ' ' . $_lang["attend_all"] . $_lang["attend_attend_record"];
			} else if ($startTime && !$endTime) {
				$title = $_lang["attend_from"] . $startTime . ' ' . $_lang["attend_title1"] . $_lang["attend_all"] . $_lang["attend_attend_record"];
			} else if (!$startTime && $endTime) {
				$title = $_lang["attend_use"] . $endTime . ' ' . $_lang["attend_title2"] . $_lang["attend_all"] . $_lang["attend_attend_record"];
			}
		}
		
		if ($userId) {
			$title = getUserNameNew($userId) . ' ' . $title;
		}
		
		if($deptId) {
			$title = $this->_MobileAttend->getDeptName($deptId) . ' ' . $title;
		}

		require_once 'newplugins/PHPExcel_1.8.0/Classes/PHPExcel.php';  
        require_once 'newplugins/PHPExcel_1.8.0/Classes/PHPExcel/Writer/Excel5.php';
		
        $objExcel   = new PHPExcel();  // 创建一个处理对象实例 
        $objExcel->getProperties();
        $objExcel->setActiveSheetIndex(0);
        $objActSheet = $objExcel->getActiveSheet();
        $objActSheet->setTitle($title);  
        $objActSheet->getColumnDimension('A')->setWidth(20);
        $objActSheet->getColumnDimension('B')->setWidth(25);
        $objActSheet->getColumnDimension('C')->setWidth(25);
		$objActSheet->getColumnDimension('D')->setWidth(55);
        $objActSheet->getColumnDimension('E')->setWidth(25);
        $objActSheet->getColumnDimension('F')->setWidth(25);
		$objActSheet->getColumnDimension('G')->setWidth(55);
		
        $objActSheet->getDefaultRowDimension('A')->setRowHeight(25);
        $objActSheet->getDefaultRowDimension('B')->setRowHeight(25);
        $objActSheet->getDefaultRowDimension('C')->setRowHeight(25);
		$objActSheet->getDefaultRowDimension('D')->setRowHeight(25);
        $objActSheet->getDefaultRowDimension('E')->setRowHeight(25);
        $objActSheet->getDefaultRowDimension('F')->setRowHeight(25);
		$objActSheet->getDefaultRowDimension('G')->setRowHeight(25);
		
        $objActSheet->setCellValue('A1', $_lang["attend_person"]);
        $objActSheet->setCellValue('B1', $_lang["attend_department"]);
        $objActSheet->setCellValue('C1', $_lang["attend_status"]);
		$objActSheet->setCellValue('D1', $_lang["attend_address"]);
        $objActSheet->setCellValue('E1', $_lang["attend_datetime"]);
        $objActSheet->setCellValue('F1', $_lang["attend_mobile_category"]);
		$objActSheet->setCellValue('G1', $_lang["attend_mobile_info"]);
		
        foreach ($data as $key => $value){
			$k = $key+2;
			$objActSheet->setCellValue('A'.$k, $value['USER_NAME']);
			$objActSheet->setCellValue('B'.$k, $value['DEPT_NAME']);   
			if($value['STATUS'] == 1) {
				$objActSheet->setCellValue('C'.$k, $_lang["attend_sign_in"]);   
			} else if($value['STATUS'] == 2) {
				$objActSheet->setCellValue('C'.$k, $_lang["attend_sign_out"]);   
			} else {
				$objActSheet->setCellValue('C'.$k, $_lang["attend_dingwei"]);   
			}
			$objActSheet->setCellValue('D'.$k, $value['ADDRESS']);
            $objActSheet->setCellValue('E'.$k, date('Y-m-d H:i:s',$value['CREATE_TIME']));
            if($value['mobile_category'] == 1) {
                $objActSheet->setCellValue('F'.$k, $_lang["attend_mobile_out"]);
            }else {
                $objActSheet->setCellValue('F'.$k, '');
            }
			$objActSheet->setCellValue('G'.$k, $value['out_info']);
        }
		
        $objStyleA5 = $objActSheet->getStyle('A5');  
        $objFontA5 = $objStyleA5->getFont();  
        $objFontA5->setName('Courier New');  
        $objFontA5->setSize(10);  
        $objFontA5->getColor()->setRGB('333333'); 

        $objAlignA5 = $objStyleA5->getAlignment();  
        $objAlignA5->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);  
        $objAlignA5->setVertical(PHPExcel_Style_Alignment::VERTICAL_CENTER);

        $objBorderA5 = $objStyleA5->getBorders();  
		
        $objBorderA5->getTop()->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN);
        $objBorderA5->getTop()->getColor()->setRGB('B7E0FE');
        $objBorderA5->getBottom()->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN);
        $objBorderA5->getBottom()->getColor()->setRGB('B7E0FE');
        $objBorderA5->getLeft()->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN);
        $objBorderA5->getLeft()->getColor()->setRGB('B7E0FE');
        $objBorderA5->getRight()->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN);
        $objBorderA5->getRight()->getColor()->setRGB('B7E0FE');
		
        $objActSheet->duplicateStyle($objStyleA5, 'A1:G'.($total+1)); 
		
        $objActSheet->getStyle('A1')->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID);
        $objActSheet->getStyle('A1')->getFill()->getStartColor()->setRGB('DBF0FF');
        $objActSheet->getStyle('B1')->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID);
        $objActSheet->getStyle('B1')->getFill()->getStartColor()->setRGB('DBF0FF');
        $objActSheet->getStyle('C1')->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID);
        $objActSheet->getStyle('C1')->getFill()->getStartColor()->setRGB('DBF0FF');
		$objActSheet->getStyle('D1')->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID);
        $objActSheet->getStyle('D1')->getFill()->getStartColor()->setRGB('DBF0FF');
        $objActSheet->getStyle('E1')->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID);
        $objActSheet->getStyle('E1')->getFill()->getStartColor()->setRGB('DBF0FF');
        $objActSheet->getStyle('F1')->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID);
        $objActSheet->getStyle('F1')->getFill()->getStartColor()->setRGB('DBF0FF');
		$objActSheet->getStyle('G1')->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID);
        $objActSheet->getStyle('G1')->getFill()->getStartColor()->setRGB('DBF0FF');
		
        $objActSheet->getStyle('A1')->getFont()->setName('微软雅黑');
        $objActSheet->getStyle('A1')->getFont()->setBold(true);
        $objActSheet->getStyle('B1')->getFont()->setName('微软雅黑');
        $objActSheet->getStyle('B1')->getFont()->setBold(true);
        $objActSheet->getStyle('C1')->getFont()->setName('微软雅黑');
        $objActSheet->getStyle('C1')->getFont()->setBold(true);
		$objActSheet->getStyle('D1')->getFont()->setName('微软雅黑');
        $objActSheet->getStyle('D1')->getFont()->setBold(true);
        $objActSheet->getStyle('E1')->getFont()->setName('微软雅黑');
        $objActSheet->getStyle('E1')->getFont()->setBold(true);
        $objActSheet->getStyle('F1')->getFont()->setName('微软雅黑');
        $objActSheet->getStyle('F1')->getFont()->setBold(true);
		$objActSheet->getStyle('G1')->getFont()->setName('微软雅黑');
        $objActSheet->getStyle('G1')->getFont()->setBold(true);
		
        $objWriter = new PHPExcel_Writer_Excel5($objExcel);
		if(!strpos($_SERVER["HTTP_USER_AGENT"],'Safari'))
		{
			$title = iconv('utf-8','gbk',$title);
		}
        header("Pragma: public");
        header("Expires: 0");
        header("Cache-Control:must-revalidate, post-check=0, pre-check=0");
        header("Content-Type:application/force-download");
        header("Content-Type:application/vnd.ms-execl");
        header("Content-Type:application/octet-stream");
        header("Content-Type:application/download");
        header('Content-Disposition:attachment;filename="'.$title.'.xls"');
        header("Content-Transfer-Encoding:binary");
        $objWriter->save('php://output');
	}
	/**
	 * 获取一个人一天的考勤记录
	 */
    public function getOneDayOneManRecords(){
        $userId     = request_var('userId');
        $year       = request_var('year');
        $month      = request_var('month');
        $day        = request_var('day');
        $startTime  = request_var('startTime');
        $endTime    = request_var('endTime');
		$deptId		= request_var('deptId',0);
        $pageSize   = 100;
        $start      = 0;
        $startDate  = '';
        $endDate    = '';
        $_startTime = '';
        $_endTime   = '';
        if($year && $month !='all' && $day != 'all'){
            $startDate  = $year .'-' . $month . '-'.$day . ' 00:00:00';
            $endDate    = $year .'-' . $month . '-'.$day . ' 23:59:59';
        }elseif($year && $month != 'all' && $day == 'all'){
            $startDate  = $year .'-' . $month . '-01' . ' 00:00:00';
            if($month != 12){
                $endDate    = $year .'-' . ($month+1) . '-01' . ' 00:00:00';
            }else{
                $endDate    = ($year+1) .'-01' . '-01' . ' 00:00:00';
            }
        }elseif($year && $month == 'all' && $day == 'all'){
            $startDate  = $year .'-01'  . '-01' . ' 00:00:00';
            $endDate    = ($year+1) .'-01' . '-01' . ' 00:00:00';
        }else{
            if($startTime && $endTime){
                $startDate  = $startTime . ' 00:00:00';
                $endDate    = $endTime . ' 23:59:59';
            }elseif($startTime && !$endTime){
                $startDate  = $startTime . ' 00:00:00';
            }elseif(!$startTime && $endTime){
                $endDate    = $endTime . ' 23:59:59';
            }
        }
        if($startDate){
            $_startTime = strtotime($startDate);
        }
        if($endDate){
            $_endTime = strtotime($endDate);
        }
        $recordList   = $this->_MobileAttend->getRecords($userId,$deptId,$_startTime,$_endTime,$start,$pageSize);
        $data = array();
        if($recordList){
            foreach ($recordList as $key=>$value){
                $temp = array();
                $latlngArr = explode(',',$value['LATLNG']);
                $temp['alat'] = floatval($latlngArr[0]);
                $temp['along'] = floatval($latlngArr[1]);
                $temp['createTime'] = date('Y-m-d H:i:s',$value['CREATE_TIME']);
                $temp['addr']   = $value['ADDRESS'];
                $data[] = $temp;
            }
            echo json_encode(array_reverse($data));
        }else{
            echo json_encode(array());
        }
        
    }
    public function getMonthLastDay($month, $year) {
        switch ($month) {
            case 4 :
            case 6 :
            case 9 :
            case 11 :
                $days = 30;
                break;
            case 2 :
                if ($year % 4 == 0) {
                    if ($year % 100 == 0) {
                        $days = $year % 400 == 0 ? 29 : 28;
                    } else {
                        $days = 29;
                    }
                } else {
                    $days = 28;
                }
                break;

            default :
                $days = 31;
                break;
        }
        return $days;
    }
}
