<?php

include 'inc/auth.php';
include 'api/charge.class.php';

$op = $_REQUEST['op'];

$charge = new Charge;

switch ($op) {
    case 'getList':


        $chargeTypeList = $charge->getChargeTypeList(array(
            "userID" => $_REQUEST["userID"],
            "deptID" => $_REQUEST["deptID"],
            "year" => $_REQUEST["year"],
            "month" => $_REQUEST["month"],
            "type" => $_REQUEST["type"],
            "chargeDept" => $_REQUEST["chargeDept"],
            "chargeUser" => $_REQUEST["chargeUser"],
                ), true);
        echo json_encode($chargeTypeList);
        break;

    case 'getUserCharge':
        $parentID = $_REQUEST["id"] != "" ? $_REQUEST["id"] : "";
        echo json_encode($charge->getUserChargeList($parentID));
        break;

    case 'getUserChargeTable':

        //修改---- 按照条件导出 里面涉及到部门 年月等

        $deptID = isset($_REQUEST['deptID']) ? $_REQUEST['deptID'] : "0";
        $filter_type = isset($_REQUEST['filter_type']) ? $_REQUEST['filter_type'] : "year";
        $yearInfor = isset($_REQUEST['yearInfor']) ? $_REQUEST['yearInfor'] : date('Y'); //今年
        $monthInfor = isset($_REQUEST['monthInfor']) ? $_REQUEST['monthInfor'] : "1";
        $uid = isset($_REQUEST['uid']) ? $_REQUEST['uid'] : "";
        $chargeType = isset($_REQUEST['chargeType']) ? $_REQUEST['chargeType'] : "";
        $chargeMonth = isset($_REQUEST['chargeMonth']) ? $_REQUEST['chargeMonth'] : "";
        $chargeUser = isset($_REQUEST['chargeUser']) ? $_REQUEST['chargeUser'] : "";
        $chargeDept = isset($_REQUEST['chargeDept']) ? $_REQUEST['chargeDept'] : "";

        //排序
        $sortField = $_REQUEST["sortField"];
        $sortType = $_REQUEST["sortType"];

        //常规搜索
        $KEYWORDS = $_REQUEST["KEYWORDS"];

        //分页
        $limitRows = $_REQUEST["itemsPerPage"];
        $limitOffset = $_REQUEST["currentPage"] * $limitRows;

        //筛选
        $search = array();

        //报销日期
        $paymentDateFilter = array();

        switch ($_REQUEST["filter"]) {
            case 'thisMonth':
                $from = date("Y-m-d", mktime(0, 0, 0, date("m"), 1, date("Y")));
                $end = date("Y-m-d", mktime(0, 0, 0, date("m"), date("t"), date("Y")));

                array_push($paymentDateFilter, $from, $end);
                break;

            case 'thisWeek':
                $curweekday = date('w');
                $curweekday = $curweekday ? $curweekday : 7;

                $from = date('Y-m-d', time() - ($curweekday - 1) * 86400);
                $end = date('Y-m-d', time() + (7 - $curweekday) * 86400);
                array_push($paymentDateFilter, $from, $end);
                break;

            case 'today':
                array_push($paymentDateFilter, date("Y-m-d"));
                break;
        }

        //报销日期
        if ($_REQUEST['PAYMENT_DATE']) {
            $paymentDateSplit = explode("~", $_REQUEST['PAYMENT_DATE']);
            array_push($paymentDateFilter, $paymentDateSplit);
        }




        if (is_array($paymentDateFilter[0])) {
            $paymentDateFilter_count = count($paymentDateFilter[0]);
            $paymentDateFilter_arr = $paymentDateFilter[0];
        } else {
            $paymentDateFilter_count = count($paymentDateFilter);
            $paymentDateFilter_arr = $paymentDateFilter;
        }

        if ($paymentDateFilter_count == 2) {

            array_push($search, array(
                "PAYMENT_DATE",
                ">=",
                "'" . $paymentDateFilter_arr[0] . " 00:00:00'"
                    ), array(
                "PAYMENT_DATE",
                "<=",
                "'" . $paymentDateFilter_arr[1] . " 23:59:59'"
            ));
        } else if ($paymentDateFilter_count == 1) {
            array_push($search, array(
                "PAYMENT_DATE",
                "=",
                "'" . $paymentDateFilter_arr[0] . "'"
            ));
        }

        /**
         * 查询
         */
        //事由
        if ($_REQUEST['REASON']) {
            array_push($search, array(
                "REASON",
                "LIKE",
                "'%" . $_REQUEST['REASON'] . "%'"
            ));
        }

        //科目
        if ($_REQUEST['CHARGE_TYPE']) {
            array_push($search, array(
                "ct.CHARGE_TYPE_NAME",
                "LIKE",
                "'%" . $_REQUEST['CHARGE_TYPE'] . "%'"
            ));
        }

        //用户
        if ($_REQUEST['USER_ID']) {
            $userIDStr = trim($_REQUEST['USER_ID'], ",");

            array_push($search, array(
                "cl.USER_ID",
                "IN",
                "('" . str_replace(",", "','", $userIDStr) . "')"
            ));
        }


        $whereInfor = array(
            "sortField" => $sortField,
            "sortType" => $sortType,
            "offset" => $limitOffset,
            "rows" => $limitRows,
            "KEYWORDS" => $KEYWORDS,
            "search" => $search,
            "deptID" => $deptID,
            "filter_type" => $filter_type,
            "yearInfor" => $yearInfor,
            "monthInfor" => $monthInfor,
            "uid" => $uid,
            "chargeType" => $chargeType,
            "chargeMonth" => $chargeMonth,
            "chargeDept" => $chargeDept,
            "chargeUser" => $chargeUser,
        );




        echo json_encode($charge->getUserChargeTable($whereInfor));
        break;

    /**
     * 获取用户的设置
     */
    case 'getUserSetting':
        $userID = $_REQUEST["userID"];

        if (preg_match("/^(\d)*$/", $userID)) {
            echo json_encode($charge->getDeptetting($userID));
        } else {
            $arrA = $charge->getUserSetting($userID);
            if (!$arrA) {
                $arrA = array(
                    "ALERT_METHOD" => 0,
                    "ALERT_VALUE" => 0,
                    "ALERT_DATE_START" => 0,
                    "ALERT_DATE_END" => 0
                );
            }
            $arrB = $charge->getDeptID($userID);

            if (!$arrB) {
                $arrB = array(
                    "DEPT_ALERT_METHOD" => 0, //ALERT_DATE_START
                    "DEPT_ALERT_VALUE" => 0,
                    "DEPT_ALERT_DATE_START" => 0,
                    "DEPT_ALERT_DATE_END" => 0
                );
            }
            $arr = array_merge($arrA, $arrB);

            echo json_encode($arr);
        }

        // echo json_encode($charge->getUserSetting($userID));
        break;

    case 'export':
        // $html = $_REQUEST['html'];
        // // Put the html into a temporary file
        // $tmpfile = time() . '.html';
        // file_put_contents($tmpfile, $html);
        // // Read the contents of the file into PHPExcel Reader class
        // $reader = new PHPExcel_Reader_HTML;
        // $content = $reader->load($tmpfile);
        // // Pass to writer and output as needed
        // $objWriter = PHPExcel_IOFactory::createWriter($content, 'Excel2007');
        // $objWriter->save('excelfile.xlsx');
        // // Delete temporary file
        // unlink($tmpfile);
        break;


    case 'deletedFromCharge':

        $id = $_REQUEST['id'];
        $uid = $_REQUEST['uid'];

        // 判断下 是否拥有菜单清单的权限

        if ($uid != $_SESSION['LOGIN_USER_ID']) {
            $status = $charge->getUserPrivStr($_SESSION['LOGIN_USER_ID']);
        } else {
            $status = true;
        }

        if (!$status) {
            //只有当前用户和管理员才能删除
            echo -1;
            exit;
        } else {
            echo $charge->deleteFromChargtable($id);
            exit;
        }


        break;


    case 'editFromCharge':

        $id = $_REQUEST['id'];
        $uid = $_REQUEST['uid'];

        if ($uid != $_SESSION['LOGIN_USER_ID']) {
            $status = $charge->getUserPrivStr($_SESSION['LOGIN_USER_ID']);
        } else {
            $status = true;
        }


        // 判断下 是否拥有菜单清单的权限
        //  $status = $charge->getUserPrivStr($_SESSION['LOGIN_USER_ID']);
        if (!$status) {
            //只有当前用户和管理员才能删除
            echo -1;
            exit;
        } else {
            // 获取菜单所有信息
            echo json_encode($charge->getFromChargtable($id));
            exit;
        }


        break;
    case "updateChargeForm":
        //op:"updateChargeForm",reason:reason,charge_date:charge_date,amount:amount,main_type:main_type,sub_type:sub_type,charge_list_id:charge_list_id
        $data = array(
            'reason' => $_REQUEST['reason'],
            'charge_date' => $_REQUEST['charge_date'],
            'amount' => $_REQUEST['amount'],
            'main_type' => $_REQUEST['main_type'],
            'sub_type' => $_REQUEST['sub_type'],
            'charge_list_id' => $_REQUEST['charge_list_id']
        );
        // 获取菜单所有信息
        echo $charge->updateFromChargtable($data);
        exit;
}
?>