<?php

include_once("inc/auth.php");
include_once("inc/conn.php");
include_once 'api/dept.class.php';
include_once 'api/user.class.php';
include_once 'inc/utility_all.php';

$deptID = isset($_REQUEST["deptID"]) ? $_REQUEST["deptID"] : "0";
$uid = isset($_REQUEST["uid"]) ? $_REQUEST["uid"] : "";
$filterType = isset($_REQUEST["filter_type"]) ? $_REQUEST["filter_type"] : "year";
$year = isset($_REQUEST["yearInfor"]) ? $_REQUEST["yearInfor"] : date("Y");
$month = isset($_REQUEST["monthInfor"]) ? $_REQUEST["monthInfor"] : "1";
$chargeType = isset($_REQUEST['chargeType']) ? $_REQUEST['chargeType'] : "";
$chargeMonth = isset($_REQUEST['chargeMonth']) ? $_REQUEST['chargeMonth'] : "";

$chargeUser = isset($_REQUEST["chargeUser"]) ? $_REQUEST['chargeUser'] : "";
$chargeDept = isset($_REQUEST["chargeDept"]) ? $_REQUEST['chargeDept'] : "";

//强制转换
$chargeDept = $chargeDept == 'true' ? true : false;
$chargeUser = $chargeUser == 'true' ? true : false;

$getListQuery = "SELECT cl.*,ct.CHARGE_TYPE_NAME,ct.CHARGE_TYPE_PARENT";

$query = " FROM charge_list AS cl 
                    INNER  JOIN charge_type AS ct ON cl.CHARGE_TYPE_ID = ct.CHARGE_TYPE_ID WHERE 1=1";


switch ($filterType) {
    case 'year':
    case 'quarter':
        $query.= " AND DATE_FORMAT(cl.PAYMENT_DATE, '%Y') = '" . $year . "'";
        break;
    case 'month':
        $query.= " AND DATE_FORMAT(cl.PAYMENT_DATE, '%Y-%c') = '" . $year . "-" . $month . "'";
        break;
}



if ($chargeMonth) {//年-》月份  月份-》天数 季度-》月份
    switch ($filterType) {

        case 'year':
            $query.= " AND DATE_FORMAT(cl.PAYMENT_DATE, '%Y-%c') = '" . $year . "-" . $chargeMonth . "' ";
            break;
        case 'quarter':
            // 第一季度 1-2-3 二季度 4 5 6 
            $minM = $chargeMonth * 3 - 2;
            $maxM = $chargeMonth * 3;
            $query.= " AND DATE_FORMAT(cl.PAYMENT_DATE, '%Y-%c') >= '" . $year . "-" . $minM . "'   AND DATE_FORMAT(cl.PAYMENT_DATE, '%Y-%c') <= '" . $year . "-" . $maxM . "' ";
            break;
        case 'month':
            $query.= " AND DATE_FORMAT(cl.PAYMENT_DATE, '%Y-%c-%e') = '" . $year . "-" . $month . "-" . "$chargeMonth" . "'";
            break;
    }
}


if ($chargeType) {
    $query.= " AND cl.CHARGE_TYPE_ID = '" . $chargeType . "' ";
}





if ($uid) {
    //当前某个用户    
    $query.= " AND cl.USER_ID = '" . $uid . "'";
    if ($chargeUser && $chargeDept) {
        
    } else if ($chargeUser && !$chargeDept) {
        $query.= "  AND CHARGE_UNDERTAKER ='个人' ";
    } else if ($chargeDept && !$chargeUser) {
        $query.= " AND  CHARGE_UNDERTAKER ='部门' ";
    } else {
        $query.= " AND cl.USER_ID = ''"; //强制设置为0  
    }
} else if ($deptID > 0) {

    $deptStr = "SELECT * FROM  `department` where SORT_LEVEL_ID like '%|" . SecurityFilter($deptID) . "|%'";
    $deptRes = exequery($connection, $deptStr);
    $deptIds = "";
    while ($row = mysql_fetch_assoc($deptRes)) {
        $deptIds .= $row["DEPT_ID"] . ",";
    }

    $deptIds = $deptIds . $deptID;

    $user = new user;
    $userIDList = $user->getDeptUser($deptID);

    if (count($userIDList) > 0) {
        $userIDStr = "'" . implode("','", array_keys($userIDList)) . "'";
    } else {
        $userIDStr = "''";
    }


    if ($chargeUser && $chargeDept) {
        $query.= " AND ( (cl.USER_ID in ( ".SecurityFilter($userIDStr)." ) AND CHARGE_UNDERTAKER ='个人') or (cl.USER_DEPT_ID in ( ".SecurityFilter($deptIds)." ) AND CHARGE_UNDERTAKER ='部门')	)";
    } else if ($chargeUser && !$chargeDept) {
        $query.= " AND  cl.USER_ID in ( ".SecurityFilter($userIDStr)." ) AND CHARGE_UNDERTAKER ='个人' ";
    } else if ($chargeDept && !$chargeUser) {
        $query.= " AND  cl.USER_DEPT_ID in ( ".SecurityFilter($deptIds)." ) AND CHARGE_UNDERTAKER ='部门' ";
    } else {
        $query.= " AND cl.USER_ID = ''"; //强制设置为0
    }
} else {
    //所有人
    if ($chargeUser && $chargeDept) {
        
    } else if ($chargeUser && !$chargeDept) {
        $query.= " AND   CHARGE_UNDERTAKER ='个人' ";
    } else if ($chargeDept && !$chargeUser) {
        $query.= " AND   CHARGE_UNDERTAKER ='部门' ";
    } else {
        $query.= " AND cl.USER_ID = ''"; //强制设置为0
    }
}


$query.= " ORDER BY PAYMENT_DATE DESC";

        

$getListResult = exequery($connection, $getListQuery . $query);


$chargeList = array();

while ($getListRow = mysql_fetch_assoc($getListResult)) {

    //报销人
    $userName = trim(getUsernameStr($getListRow['USER_ID']), ",");

    //创建人
    $creator = trim(getUsernameStr($getListRow['CREATOR']), ",");

    $getListRow['USER_NAME'] = $userName;
    $getListRow['CREATOR_NAME'] = $creator;

    array_push($chargeList, $getListRow);
}

if (count($chargeList) == 0) {
    echo "<script type='text/javascript'>alert('no data');</script>";
    exit;
}



//生产模板的文件名
$file_name = "charge_" . time() . ".csv";
//生产报表的头
$header = "姓名,科目,费用,事由,报销日期,费用承担者,创建者\n\r";
$content = "";

foreach ($chargeList as $v) {

    $content.= $v['USER_NAME'] . "," . $v['CHARGE_TYPE_NAME'] . "," . $v['CHARGE_COST'] . "," . $v['REASON'] . "," . $v['PAYMENT_DATE'] . "," . $v['CHARGE_UNDERTAKER'] . "," . $v['CREATOR_NAME'] . "\n";
}
//生产报表的内容
$header = iconv("utf-8", "gbk", $header);
$content = iconv("utf-8", "gbk", $content);
ob_end_clean();
Header("Cache-control: private");
Header("Content-type: application/vnd.ms-excel");
Header("Accept-Ranges: bytes");
header("Accept-Length: " . strlen($content));
header("Content-Disposition: attachment; filename=" . $file_name);
echo $header . $content;





