<?php

/**
 * 费用设置
 */
include 'inc/auth.php';
include_once 'api/charge.class.php';
include_once 'api/user.class.php';

$op = $_REQUEST['op'];

$charge = new Charge;

switch ($op) {
    case 'add':

        $user = new User;
        $userIDList = array();
        $userID = $_REQUEST['userID'];
        $unify = $_REQUEST['unify'];
        $alertMethod = $_REQUEST['alertMethod'];
        $alertValue = $_REQUEST['alertValue'];
        $dateStart = $_REQUEST['dateStart'];
        $dateEnd = $_REQUEST['dateEnd'];
        $subjectCheck = $_REQUEST['subjectCheck'] == 'true' ? 1 : 0;
        $deptID = $_REQUEST['deptID'];

        $chargeValue = $_REQUEST["chargeValue"];

        $fail = 0;
        //如果是root 将所有人设置
        if ($deptID > 0) {

            //科目设置 --  
            if (!$charge->chargerSubjectSetting($deptID, $chargeValue, "dept", $subjectCheck)) {
                $fail++;
            }

            //科目设置 -- 
            if ($charge->checkDeptSetting($deptID)) {
                if (!$charge->updateChargeSettingDept(array(
                            "DEPT_ID" => $deptID,
                            "ALERT_METHOD" => $alertMethod,
                            "ALERT_VALUE" => $alertValue,
                            "ALERT_DATE_START" => $dateStart,
                            "ALERT_DATE_END" => $dateEnd,
                            "SUBJECT_CHECK" => $subjectCheck
                        ))) {
                    $fail++;
                }
            } else {
                if (!$charge->addChargeSettingDept(array(
                            "DEPT_ID" => $deptID,
                            "ALERT_METHOD" => $alertMethod,
                            "ALERT_VALUE" => $alertValue,
                            "ALERT_DATE_START" => $dateStart,
                            "ALERT_DATE_END" => $dateEnd,
                            "SUBJECT_CHECK" => $subjectCheck
                        ))) {
                    $fail++;
                }
            }
        } else {
            //当前用户
            if ($unify == "user") {
                $userIDList = array(
                    $userID
                );
            }

            //同角色
            else if ($unify == "priv") {
                $userIDList = $user->getSamePrivUser($userID);
            }

            //同部门
            else if ($unify == "dept") {
                $userIDList = $user->getSameDeptUser($userID);
            }

            //所有
            else if ($unify == "all") {
                $userIDList = array_keys($user->getUserArrayInfo());
            }
        }



        $fail = 0;
        for ($i = 0; $i < count($userIDList); $i++) {

            //科目设置 --  
            if (!$charge->chargerSubjectSetting($userIDList[$i], $chargeValue, "user", $subjectCheck)) {
                $fail++;
            }


            //科目设置 --  

            if ($charge->checkIsSetting($userIDList[$i])) {
                if (!$charge->updateChargeSetting(array(
                            "USER_ID" => $userIDList[$i],
                            "ALERT_METHOD" => $alertMethod,
                            "ALERT_VALUE" => $alertValue,
                            "ALERT_DATE_START" => $dateStart,
                            "ALERT_DATE_END" => $dateEnd,
                            "SUBJECT_CHECK" => $subjectCheck
                        ))) {
                    $fail++;
                }
            } else {
                if (!$charge->addChargeSetting(array(
                            "USER_ID" => $userIDList[$i],
                            "ALERT_METHOD" => $alertMethod,
                            "ALERT_VALUE" => $alertValue,
                            "ALERT_DATE_START" => $dateStart,
                            "ALERT_DATE_END" => $dateEnd,
                            "SUBJECT_CHECK" => $subjectCheck
                        ))) {
                    $fail++;
                }
            }
        }
        echo $fail == 0;
        break;

    case 'getSettingList':
        $parentID = $_REQUEST["id"] != "" ? $_REQUEST["id"] : "";
        echo json_encode($charge->getUserSettingList($parentID));
        break;

    case 'getUserSetting':
        $userID = $_REQUEST["userID"];
        if (preg_match("/^(\d)*$/", $userID)) {
            $type = "dept";
            $userSetting = $charge->getDeptetting($userID);
        } else {
            $type = "user";
            $userSetting = $charge->getUserSetting($userID);
        }

        $subjectSetting = $charge->getSubjectSetting($userID, $type);

        $userSetting["subject"] = $subjectSetting;

        if ($userSetting) {
            echo json_encode($userSetting);
        } else {
            echo false;
        }
        break;
    case 'remove':

        $user = new User;

        $userID = $_REQUEST['userID'];
        $deptID = $_REQUEST['deptID'];
        //如果是root 将所有人设置
        if ($deptID > 0) {
            //将当前部门配置清除
            $charge->removeSetting($deptID, "dept");
        } else {
            //当前用户 $userID
            $charge->removeSetting($userID, "user");
        }

        echo $fail == 0;
        break;
}
?>