<?
/**
*@Systemname:       E-Office
*@Filename:         general/crm
*@Function:         客户管理系统
*@Encoding:         utf8
*@Author:           www.weaver.com.cn
*@Date:             2008-5-26
*@File Version:     2.0
*@Eoffice Version:  7.6
*/
include_once("inc/auth.php"); 
include_once ('inc/excel/reader.php');
includelangpak("customer");
include_once("api/customer.class.php");

/**
*从excel文件中读取导入数据

*@param  string $filename
*@return array $data 
*/
function get_data_from_excel( $filename ) {	
	$reader = new Spreadsheet_Excel_Reader();
	$reader->setOutputEncoding('UTF-8');
	$reader->read( getenv("DOCUMENT_ROOT") . "attachment/" . $filename );

	$data = array();
	//array_push($data, array()); 	
	$sheet_num = 0;
	for($s = 0; $s < 3; $s++) {
		if( trim($reader->sheets[$s]['cells'][1][1]) !== '' ) {
			$sheet_num = $s;
			break;
		}
	}

	for ($i = 2; $i <= $reader->sheets[$sheet_num]['numRows']; $i++) {
		for ($j = 1; $j <= $reader->sheets[$sheet_num]['numCols']; $j++) {			
			$cell = trim($reader->sheets[$sheet_num]['cells'][$i][$j]);
			if( !empty($cell) )
				$data[$i-2][] = $cell;
		}
	}	
	return $data;
}

/**
*通过id查找客户信息表中待导入的列名
*@param  string $item_id 
*@return string 
*/
function get_item_name_by_id($item_id){
	$customerObj   = new customer();
	$row    = $customerObj->getDataOne('import_item','ITEM_ID, ITEM_NAME, ITEM_EXPLAIN',"ITEM_TABLE = 'customer' AND ITEM_ID = '$item_id'");
	return $row[1];
}

/**
*将map_array数组元素中冒号右边数字转化为customer表的列名
*@param  array $map_array 
*@param  array $table_fields 
*@return array $data 
*/
function convert_map_array( $map_array ) {	
	foreach( $map_array as $item ) {
		$item_array  = explode( ':', $item );
		$right_index = $item_array[0];
		$left_index  = $item_array[1];		
		$item  = preg_replace("/(.*)(:)/", get_item_name_by_id($right_index).":" , $item);
		$map[] = $item; 
	}
	return $map;
}

/**
*必须包含customer_name 字段
*@param  array $map
*@return bool true|false 
*/
function check_must_include_field( $map ) {
	foreach( $map as $item ) {
		$item_array = explode( ':', $item );
		$field = $item_array[0];
		if( trim($field) == 'CUSTOMER_NAME' )
			return true;
	}
	return false;
}

/**
*检测当前行中的客户名称或者客户号码是否与customer表中重复
*@param array $row
*@param string $field
*@param string $index
*@return bool true|false 
*/
function is_duplicate( $row, $field, $index ) {
	$customerObj   = new customer();
	if( $field == 'CUSTOMER_NAME' || $field == 'CUSTOMER_NUMBER' ) {
		$ext    = $customerObj->getDataOne('customer','count(1) AS ext',"$field = '". $row[$index] ."' AND $field <>'' ");

		if( $ext[0] ) {
			return true;
		}
	}
	return false;
}

/**
*将excel文本中的内容一行一行的插入到customer表，插入数据库之前检索该行的客户名称和客户号码是否重复

*@param  array $excel_data
*@param  array $map
*@return 
*/
function import_customer( $excel_data, $map ){
	$customerObj   = new customer();
	$line = 0;
	$duplicate_index = array(); 

	foreach( $excel_data as $row ){
		$line++;
		$continue = false;
		unset( $key_str );
		unset( $value_str );
		foreach ( $map as $item ) {
			$item_array = explode( ':', $item );
			$key_str   .= $item_array[0];
			//$key_str   .= $item_array[0] . ',';
			$value_str .= $row[$item_array[1]];
			//$value_str .= "'" . $row[$item_array[1]] . "',";
			if(is_duplicate( $row, $item_array[0], $item_array[1]) ){
				//记录客户名重复和客户编号重复的信息。

				$duplicate_index[$item_array[0]][] = array( 'line' => $line, 'detail' => $row[$item_array[1]] );
				$_SESSION['duplicate_index']       = $duplicate_index;
				$continue = true;
			}
		}

		if( $continue )
			continue;
		
		$data = array(
			$key_str				=> $value_str,
			'MANAGE_USER'			=> $_SESSION['LOGIN_USER_ID'],
			'PURVIEW'				=> 3,
			'CREATEOR'				=> $_SESSION['LOGIN_USER_ID'],
			'BIRTHDAY_REMIND_SMS'	=> 1,
			'BIRTHDAY_REMIND'		=> 1
			);
		$customerObj->addData('customer',$data);

	}
	return $duplicate_index;
}

/**
*提示信息，页面跳转

*@param  string $msg 
*@return 
*/
function show_msg( $msg ) {
	Message( "", $msg );
	echo "<SCRIPT LANGUAGE='JavaScript'>
			window.setTimeout('goto()',3000);
			function goto(){ 
				window.location.href='index.php';
			}
	</SCRIPT>";	
	exit();
}
$map_string = $_REQUEST['nlist'];
//excel文件名

$filename   = $_REQUEST['filename'];
//登录用户id号

$login_user = $_SESSION['LOGIN_USER_ID'];
$map_string = substr($map_string,0,-1);
$map_array  = explode(',', $map_string);
//从上传的excel中读取数据,不包含第一行

$excel_data = get_data_from_excel( $filename );
//转化映射数组
$map = convert_map_array( $map_array );
if( '' == $map_string ){
	@unlink( getenv("DOCUMENT_ROOT") . "attachment/" . $filename );
	@unlink( getenv("DOCUMENT_ROOT") . "attachment/" . substr($filename, 0, -4) . "tmp" );
	show_msg( $_lang['customer_no_field'] );
}
//检测是否包含customer_name字段
if( !check_must_include_field( $map ) ){
	@unlink( getenv("DOCUMENT_ROOT") . "attachment/" . $filename );
	@unlink( getenv("DOCUMENT_ROOT") . "attachment/" . substr($filename, 0, -4) . "tmp" );
	show_msg($_lang['customer_name_not_included']);
}
//导入数据
$duplicate_index = import_customer( $excel_data, $map );
@unlink( getenv("DOCUMENT_ROOT") . "attachment/" . $filename );
@unlink( getenv("DOCUMENT_ROOT") . "attachment/" . substr($filename, 0, -4) . "tmp" );
//记录excel中客户名称与数据表中重名的行号

if( count($duplicate_index) ){
	header("location:import_problem.php");
}
show_msg($_lang['customer_import_success']);
?>