<?
/**
 * Systemname:       E-Office
 * Filename:         general/crm
 * Function:         客户管理系统
 * Encoding:         utf8
 * Author:           www.weaver.com.cn
 * Date:             2008-5-26
 * File Version:     1.0
 * Eoffice Version:  6.0
*/
include_once("inc/auth.php"); 
include_once ('inc/excel/reader.php');
includelangpak("customer");
includelangpak("hr");
include_once("api/customer.class.php");
/**
 * 验证是否是合法的excel或者csv文件
 *
 * @param  string $filename
 * @param  string $reg 
 * @return bool 
 */
function is_valid( $filename, $reg ){

	$mark = preg_match( $reg, $filename, $match );

	return (0 == $mark)? false: true;

}

/**
 * excel报表出错，页面跳转

 * @param  string $msg || 出错提示信息
 * @return 
 */

function show_report_error( $msg ){

	Message( "", $msg );
	echo "<SCRIPT LANGUAGE='JavaScript'>
			window.setTimeout('goto()',1500);
			function goto(){ 
				window.location.href='import.php';
			}
	</SCRIPT>";
	
	exit();
}



/**
 * 从excel文件读取导入列

 *
 * @param  file $excel || excel 文件
 * @return array $fields || excel文件第一行的数据
 */

function get_fields_from_excel( $excel ){

	$reader = new Spreadsheet_Excel_Reader();
	$reader->setOutputEncoding('UTF-8');

	$reader->read($excel['tmp_name']);
	
	$sheet_num = 0;
	for($s = 0; $s < 3; $s++){
		if( trim($reader->sheets[$s]['cells'][1][1]) !== '' ){
			$sheet_num = $s;
			break;
		}
	}

	for ($j = 1; $j <= $reader->sheets[$sheet_num]['numCols']; $j++) {
		
		$cell = trim($reader->sheets[$sheet_num]['cells'][1][$j]);
		if( !empty($cell) )
			$fields[] = $cell;
	}
	
	return $fields;
}

/**
 * 复制文件到attachment目录下,如果文件复制成功,返回新的文件名

 *
 * @param string $filename
 * @return string $destname
 */
function save_to_attachment( $filename ){

	mt_srand((double)microtime()*1000000);
	$rand = mt_rand();
	$file_prefix = substr( $filename, 0, -4 );
	
	$destname = str_replace($file_prefix, $rand, $filename);
	$destpath = getenv("DOCUMENT_ROOT")."attachment/".$destname;
	
	$sucess = copy($filename, $destpath);
	
	return ($sucess ? $destname : $sucess);
}

/**
 * 获取customer表中可以用户导入的字段信息

 *
 * @return array $result
 */

function get_fields_from_customer(){
	$customerObj   = new customer();
    $list = $customerObj->getData('import_item','ITEM_ID, ITEM_PROPERTY, ITEM_NAME, ITEM_EXPLAIN',"ITEM_TABLE = 'customer' ");
	return $list;
}


$excel = $_FILES['excel_customer'];
$filename = $excel['name'];


//验证excel类型
if( is_valid( $filename, '/(\.)(xls)$/') ){

	$import_fields = get_fields_from_excel( $excel );
	
	$destname = save_to_attachment( $excel['tmp_name'] );
	
	$table_fields = get_fields_from_customer();

	for($i=0; $i < count($import_fields); $i++){
		
		foreach($table_fields as $field){
			if($import_fields[$i] == $field['ITEM_EXPLAIN']){
				${'selectClass'.$i} = "selectDivCss";
			}			
		}

		if(${'selectClass'.$i}==""){
			${'selectClass'.$i} = "patient-label";
		}
		$impro_str.= "{insuranceCode:".$i.",name:'".$import_fields[$i]."',className:'". ${'selectClass'.$i} ."'},";
	}
	
	
	foreach($table_fields as $field){
		$class_name = 'hospital-label-no';
		$name = '';
		for($i=0; $i < count($import_fields); $i++){
			if($import_fields[$i] == $field['ITEM_EXPLAIN']){
				$initListValue.= $field['ITEM_ID'] .":$i,";
				$class_name = 'hospital-label';
				$name = $field['ITEM_EXPLAIN'];
			}
		}
		if($field['ITEM_PROPERTY'])
			$filled = 'true';
		else
			$filled = 'false';
		
		$table_str .= "{code:'".$field['ITEM_ID']."',
						name:'".$field['ITEM_EXPLAIN']."',
						className:'$class_name',
						nameSelect:'$name',
						explain:'".$field['ITEM_EXPLAIN']."',
						filled:$filled},";
		
	}
	$table_str = "[".substr($table_str, 0, -1)."]";

}
else{
	show_report_error( $_lang["customer_template_error"] );
}

$impro_str = "[".substr( $impro_str,0,-1 )."]";


?>

<html>
<head>
<title><?=$_lang["hr_address_group_up"]?></title>
<meta http-equiv="content-type" content="text/html; charset=<?=$_lang['encoding']?>" />
<link rel="stylesheet" type="text/css" href="/inc/ext/ext-all.css" />
<style>
.submit {
      background-image:url(<?=THEME_FLAG?>/<?=$_SESSION['LOGIN_THEME']?>/images/icon/submit.gif) !important;
}
</style>
<script type="text/javascript" src="/lang/<?=$_SESSION['LOGIN_LANG']?>/javascript.lang.js"></script>
<!-- GC -->
<!-- LIBS -->
<script type="text/javascript" src="/inc/ext/ext-base.js"></script>
<!-- ENDLIBS -->
<script type="text/javascript" src="/inc/ext/ext-all.js"></script>
<script language="javascript" src="/inc/common.js" ></script>
<script>

Ext.onReady(function() {

	
    var patients =eval(<?=$impro_str?>);

    var PatientRecord = Ext.data.Record.create([{
	    	name: 'name'
		}, {
	    	name: 'insuranceCode'
		},{
			name:'className'
		}
    ]);

    var patientStore = new Ext.data.Store({
        data: patients,
        reader: new Ext.data.JsonReader({
            id: 'insuranceCode'
        }, PatientRecord)
    });
    var hospitals = eval(<?=$table_str?>);
    var HospitalRecord = Ext.data.Record.create([{
        name: 'name'
    },{
        name: 'property'
    },{
        name: 'explain'
    },{
        name: 'code'
    },{
        name: 'nameSelect'
    },{
        name: 'className'
    },{
		name: 'filled'
	}
    ]);

	var hospitalStore = new Ext.data.Store({
        data: hospitals,
        reader: new Ext.data.JsonReader({
            id: 'code'
        }, HospitalRecord)
    });

	var patientView = new Ext.DataView({
		cls: 'patient-view',
		tpl: '<tpl for=".">' +
				'<div class="patient-source"><table><tbody>' +
					'<tr><td class="{className}" >{name}</td></tr>' +
				'</tbody></table></div>' +
			 '</tpl>',
		itemSelector: 'div.patient-source',
		store: patientStore,
		listeners: {
			render: initializePatientDragZone
		}
	});
  
    var hospitalView = new Ext.DataView({
    	cls: 'patient-view',
    	tpl: '<tpl for=".">' +
                '<div  class="hospital-target" ><table style="width:100%"><tbody>' +
                    '<tr><td class="{className}" >{name} <tpl if="filled"><b style="color:red">!</b></tpl> → <span style="color:blue">{nameSelect}</span></td></tr>' +
                '</tbody></table></div>' +
             '</tpl>',
        itemSelector: 'div.hospital-target',
        store: hospitalStore,
        listeners: {
            render: initializeHospitalDropZone
        }
    });
	

    new Ext.Viewport({
        layout: 'border',
        items: [{
            title: "<?=$_lang['customer_import_fields'];?>",
            region: 'west',
            width: 310,
            minSize:128,
			maxSize:310,
			split:true,
            margins: '0',
            collapsible:true,
            autoScroll:true,
            items: patientView

        },{
			region:'south',
			split:true,
			contentEl: 'south',
			height: 100,
			minSize: 100,
			maxSize: 200,
			collapsible: true,
			title:'',
			margins:'0 0 0 0'
		},{
            region:'center',
            width:500,
            height: 600,
            title:"<?=$_lang['customer_table_fields'];?>",
            margins:'0 0 0 0',
            autoScroll:true,
            items:hospitalView
        }]
    });
});

function initializePatientDragZone(v) {
    v.dragZone = new Ext.dd.DragZone(v.getEl(), {

//      On receipt of a mousedown event, see if it is within a draggable element.
//      Return a drag data object if so. The data object can contain arbitrary application
//      data, but it should also contain a DOM element in the ddel property to provide
//      a proxy to drag.
        getDragData: function(e) {
            var sourceEl = e.getTarget(v.itemSelector, 10);
            if (sourceEl) {
                d = sourceEl.cloneNode(true);
                d.id = Ext.id();
                return v.dragData = {
                    sourceEl: sourceEl,
                    repairXY: Ext.fly(sourceEl).getXY(),
                    ddel: d,
                    patientData: v.getRecord(sourceEl).data
                }
            }
        },

//      Provide coordinates for the proxy to slide back to on failed drag.
//      This is the original XY coordinates of the draggable element.
        getRepairXY: function() {
            return this.dragData.repairXY;
        }
    });
}


function initializeHospitalDropZone(v) {
    v.dropZone = new Ext.dd.DropZone(v.getEl(), {
        getTargetFromEvent: function(e) {
            return e.getTarget('.hospital-target');
            
        },
        onNodeEnter : function(target, dd, e, data){ 
            Ext.fly(target).addClass('hospital-target-hover');
        },

        onNodeOut : function(target, dd, e, data){ 
            Ext.fly(target).removeClass('hospital-target-hover');
        },

//      While over a target node, return the default drop allowed class which
//      places a "tick" icon into the drag proxy.
        onNodeOver : function(target, dd, e, data){ 
            return Ext.dd.DropZone.prototype.dropAllowed;
        },
        onNodeDrop : function(target, dd, e, data){
        	var srcEl = Ext.get(this.getEl());
        	var sourceEl = e.getTarget(v.itemSelector, 10);
        	dropData = v.getRecord(sourceEl).data;
        	var dataBaseId = dropData.code;
           //保存操作
         	var set_fied_str = document.getElementById('nlist').value;
         	if(dropData.property!=""){
        		var par_have = ","+dataBaseId+':'+dropData.property.patientData.insuranceCode+",";
           		var par_now = ","+dataBaseId+':'+data.patientData.insuranceCode+",";
           		var set_fied_par = ","+set_fied_str;
           		var set_fied_now = set_fied_par.replace(par_have,par_now);
           		set_fied_now = set_fied_now.substring(1);
           		document.getElementById('nlist').value = set_fied_now;
           		dropData.property.sourceEl.innerHTML = "<table><tbody><tr><td class='patient-label'>"+dropData.property.patientData.name+"</td></tr></tbody></table>";
         	}else{
	       		document.getElementById('nlist').value = set_fied_str + dataBaseId+':'+data.patientData.insuranceCode+",";
         	}
         	data.sourceEl.innerHTML = "<table><tbody><tr><td class='selectDivCss'>"+data.patientData.name+"</td></tr></tbody></table>";
         	dropData.property = data;
         	e.getTarget('.hospital-target').innerHTML = "<table style='width:100%'><tbody><tr><td class='hospital-label'><span style='color:#000'>"+dropData.name+" → </span><span style='color:blue'>"+data.patientData.name+"</span></td></tr></tbody></table>";
            return true; 
        }
    });
}

var rlist,pos;
 var mystr = new Array('a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','w');
 
 Array.prototype.indexOf=function(substr,start){
	var ta,rt,d='\0';
	if(start!=null){ta=this.slice(start);rt=start;}else{ta=this;rt=0;}
	var str=d+ta.join(d)+d,t=str.indexOf(d+substr+d);
	if(t==-1)return -1;rt+=str.slice(0,t).replace(/[^\0]/g,'').length;
	return rt;
 }
 Array.prototype.replace=function(reg,rpby){
	var ta=this.slice(0),d='\0';
	var str=ta.join(d);str=str.replace(reg,rpby);
	
	return str.split(d);
 }
 function replacePos(strObj, pos, replacetext) { 
   var str = strObj.substr(0, pos-1) + replacetext + strObj.substring(pos, strObj.length); 
   var str = strObj.substring(pos, strObj.length);
   
   return str; 
 }
 function setRecordList(a) {
   rlist = document.getElementById(a).value;
   mystr.splice(a,1, rlist);
   document.csv.nlist.value = mystr;
 }

function check_form(){
	
	var hospitalTarget = Ext.query(".hospital-target table tr td");
	var i = 0;
	var reg = /<[b|B](.*?)>/;
	for( i = 0;i < hospitalTarget.length; i++ ){
		if(hospitalTarget[i].innerHTML.match(reg)){
			if(hospitalTarget[i].childNodes[3].innerText.trim() == ''){
				alert("<?php echo $_lang['customer_must_import_field'];?>");
				return false;
			}
		}
	}
	form1.submit();
	
}
</script>
<style type="text/css">
.app-header .x-panel-body {
    background-color: #99BBE8;
}

.app-header h1 {
    font-family: verdana,arial,sans-serif;
    font-size: 16px;
}

.hospital-target {
    text-align:left;
    color:red;
}

.hospital-target.hospital-target-hover {
    background-color: #D88;
    cursor: hand;
}

.patient-source {
    cursor: move;
}

.patient-view td {
    font-family: verdana,arial,sans-serif;
    font-size: 12px;
}

td.patient-label {
    background-color: #e1e1e1;
    border: 1px solid #B1C9E5;
    text-align: right;
    width: 300px;
    height:20px;
    padding: 0px 2px 0px 2px;
    text-align:right;
    color:blue;
}

td.hospital-label {
    background-color: #e1e1e1;
    border: 1px solid #B1C9E5;
    text-align: left;
    width: 300px;
    height:20px;
    padding: 0px 2px 0px 2px;
    color:#000;
}
td.hospital-label-no {
    background-color: #e1e1e1;
    border: 1px solid red;
    text-align: left;
    width: 300px;
    height:20px;
    padding: 0px 2px 0px 2px;
    color:#000;
}
.selectDivCss{
	background-color: #ccc;
    border: 1px solid #B1C9E5;
    text-align: right;
    width: 300px;
    height:20px;
    padding: 0px 2px 0px 2px;
    text-align:right;
    color:#999;
}


</style>
<title><?=$_lang["hr_set_field"]?></title>
</head>
<body>
<form name="form1" method="post" action="import_do.php" >
<table border="0" width="100%" cellspacing="0" cellpadding="3">
  <tr>
    <td class="pagehead1"><img src="<?=THEME_FLAG?>/<?=$_SESSION['LOGIN_THEME']?>/images/general/icon_customer.gif" align="absmiddle"> <?=$_lang["customer_query_read_mass"] ?>
    </td>
  </tr>
  <tr>
    <td class="pagehead2">
		<a class="button" href="#" onClick="search_click();">
			<span><img src="<?=THEME_FLAG?>/<?=$_SESSION['LOGIN_THEME']?>/images/icon/search.gif" border="0" align="absmiddle"> <?=$_lang["common_inquire"]?></span>
		</a>
		<a class="button" href="#" onClick="javascript:;">
			<span><img src="<?=THEME_FLAG?>/<?=$_SESSION['LOGIN_THEME']?>/images/icon/export.gif" border="0" align="absmiddle"> <?=$_lang["customer_query_export"]?></span>
		</a>
		
    </td>
  </tr>
</table>

<input type="hidden" name="nlist" id='nlist' value="<?=$initListValue?>">
<input type="hidden" name="filename" id='filename' value="<? echo $destname; ?>">

</form>
<div id="south" style="font-size:12px">
	<div>
		<b><?=$_lang["hr_import_op_explain_content"]?></b>
	</div>
	<div style='border-top:1px solid #ddd;padding:8px'>
		<a href="#" onClick="javascript:check_form();" style='text-decoration:none'>
			<span><img src="<?=THEME_FLAG?>/<?=$_SESSION['LOGIN_THEME']?>/images/icon/export.gif" border="0" align="absmiddle"> <?=$_lang["customer_start_import"]?></span>
		</a>
	</div>
</div>
</body>
</html>

