<?php

class dingtalk {

    public $uid;
    protected $corpid;
    protected $appid;
    protected $appkey;
    protected $appsecret;
    protected $access_token;
    protected $encodingAesKey = '';
    protected $token_time;
    protected $create_time;

    public function __construct() {

        $this->updateAccessToken();
    }

    protected function updateAccessToken() {
        date_default_timezone_set('Asia/Shanghai'); //设置时区
        $this->getAccessToken();
    }

    //获取AccessToken
    protected function getAccessToken() {
        //获取时间
        $sql = 'select * from dingtalk_token limit 1';
        $result = $this->query($sql);
        $row = mysql_fetch_assoc($result);
        if (!$row) {
            return false;
        }
        foreach ($row as $key => $value) {
            $this->$key = $value;
        }
        if (abs(time() - $this->token_time) > 7200) {
            //GET请求的地址
            $url = "https://oapi.dingtalk.com/gettoken?appkey={$this->appkey}&appsecret={$this->appsecret}";
            $access_token_Arr = $this->https_request($url);
            //这里判断是否正常获取到
            if (isset($access_token_Arr["errmsg"]) && $access_token_Arr["errmsg"] == "ok" && $access_token_Arr['access_token']) {
                $this->token_time = time();
                $this->access_token = $access_token_Arr['access_token'];
                $sql = "update dingtalk_token set access_token = '{$this->access_token}', token_time = '{$this->token_time}'";
                $this->query($sql);
            } else {
                return false;
            }
        }

        return $this->access_token ? $this->access_token : false;
    }

    public function getDingTalk() {

        $sql = 'select * from dingtalk_token limit 1';
        $result = $this->query($sql);
        $row = mysql_fetch_assoc($result);
        if (!$row) {
            return false;
        }
        return $row;
    }

    // 获取操作数据 CURL
    public function https_request($url, $data = null) {
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, FALSE);
        if (!empty($data)) {
            curl_setopt($curl, CURLOPT_POST, 1);
            curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
            curl_setopt($curl, CURLOPT_HTTPHEADER, array('Content-Type: application/json;charset=UTF-8'));
        }
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        $output = curl_exec($curl);
        curl_close($curl);
        return json_decode($output, true);
    }

    //获取jsapi_ticket
    public function getConfig($agentId = 0) {

        $accessToken = $this->getAccessToken();
        $corpId = $this->corpid;
        $nonceStr = $this->createNonceStr();
        $timeStamp = (String) time();
        //获取jsapi

        $ticket = $this->getJsApiTicket();

        $row = $this->getDingTalk();
        if (!$row) {
            return false;
        }
        $agentId = $row["appid"];
        $url = $row["domain"] . $_SERVER["REQUEST_URI"];

        //排序签名
        $signature = sha1('jsapi_ticket=' . $ticket . '&noncestr=' . $nonceStr . '&timestamp=' . $timeStamp . '&url=' . $url);

        $config = array(
            'url' => $url,
            'nonceStr' => $nonceStr,
            'agentId' => $agentId,
            'timeStamp' => $timeStamp,
            'corpId' => $corpId,
            'signature' => $signature);
        return $config;
    }

    public function query($sql) {
        global $connection;
        return exequery($connection, $sql);
    }

    public function getJsApiTicket() {
        $accessToken = $this->getAccessToken();
        $sql = 'select * from dingtalk_ticket limit 1';
        $result = $this->query($sql);
        $row = mysql_fetch_assoc($result);
        if (!$row) {
            $expire_time = 0;
        } else {
            $expire_time = $row["expire_time"];
        }

        if ($expire_time < time()) {

            // 如果是企业号用以下 URL 获取 ticket
            $url = "https://oapi.dingtalk.com/get_jsapi_ticket?access_token=$accessToken";

            $dingtalkData = $this->https_request($url);
            if (isset($dingtalkData['errcode']) && $dingtalkData['errcode'] != 0) {
                return false;
            }

            $ticket = $dingtalkData["ticket"];
            if ($ticket) {
                $expire_time = time() + 7000;
                $sql = "truncate dingtalk_ticket";
                $this->query($sql);
                $sql2 = "INSERT INTO `dingtalk_ticket` (`jsapi_ticket`, `expire_time`) VALUES ('".SecurityFilter($ticket)."', '".SecurityFilter($expire_time)."');";
                $this->query($sql2);
            }
        } else {
            $ticket = $row["jsapi_ticket"];
        }

        return $ticket;
    }

    public function createNonceStr($length = 16) {
        $chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
        $str = "";
        for ($i = 0; $i < $length; $i++) {
            $str .= substr($chars, mt_rand(0, strlen($chars) - 1), 1);
        }
        return $str;
    }

    //获取域名
    public function getDomain() {
        $sql = 'select domain from dingtalk_token limit 1';
        $result = $this->query($sql);
        $row = @mysql_fetch_assoc($result);

        return trim($row['domain'], '/');
    }

    public function getUserInfo($uid, $mobile) {

        $sql = "select * from user where (USER_ID ='" . SecurityFilter($uid) . "' or MOBIL_NO ='" . SecurityFilter($mobile) . "') and USER_ACCOUNTS!=''  limit 1";

        $result = $this->query($sql);
        $row = @mysql_fetch_assoc($result);

        if (!$row) {
            return false;
        }
        return $row;
    }

    // 绑定OAID和userID 发送消息用
    public function updateDingTalkUser($oaId, $userId, $mobile) {

        $sql = "select * from  dingtalk_user where   mobile ='" . SecurityFilter($mobile) . "'  limit 1";
        $result = $this->query($sql);
        $row = @mysql_fetch_assoc($result);

        if (!$row) {
            //不存在 插入
            $sql2 = "INSERT INTO  `dingtalk_user` (`oa_id`, `userid`, `mobile`, `actived`) VALUES ('".SecurityFilter($oaId)."', '".SecurityFilter($userId)."', '".SecurityFilter($mobile)."', '1');";
        } else {
            $sql2 = "UPDATE  `dingtalk_user` SET `oa_id` = '".SecurityFilter($oaId)."', `userid` = '".SecurityFilter($userId)."' WHERE `mobile`  = '".SecurityFilter($mobile)."';";
        }

        return $this->query($sql2);
    }

    public function errorPage($code = '', $message = '') {
        include('./error.php');
        exit;
    }

    public function pushTemplate($option) {


        $access_token = $this->getAccessToken();
        if (!$access_token) {
            return false;
        }

        $api = "https://oapi.dingtalk.com/message/send?access_token={$access_token}";

        $data = $this->getTemplateToPush($option);

        $content = $this->https_request($api, $data);

        return $content;
    }

    //带连接的OA消息
    protected function getTemplateToPush($option) {

        $template = array(
            'touser' => $option["uids"], //用户组
            'toparty' => "", //用户组
            'agentid' => $option["agentid"], //用户,
            "msgtype" => "oa",
            "oa" => array(
                "message_url" => $option["url"],
                "pc_message_url" => $option["url"],
                "head" => array(
                    "bgcolor" => "FF4876FF",
                    "text" => "",
                ),
                "body" => array(
                    "title" => "",
                    "content" => $option['content'],
                )
            )
        );

        return urldecode(json_encode($template));
    }

    //不带连接的普通文本消息
    protected function getTemplateTextToPush($option) {
        $template = array(
            'touser' => $option["uids"], //用户组
            'toparty' => "", //用户组
            'agentid' => $option["agentid"], //用户,
            "msgtype" => "text",
            "text" => array(
                "content" => $option['content'],
            )
        );

        return urldecode(json_encode($template));
    }

    public function getMobile($uid, $sourceType = '0', $sourceID) {
        if (!$uid) {
            return false;
        }

        $domain = $this->getDomain();
        $method = $this->dealSource($sourceType);

        if (false !== strpos($sourceID, ',')) {
            $FlowPrcsResult = $this->dealFlowPrcs($uid, $sourceID);
            $sourceID = $FlowPrcsResult['sourceID'];
            $copy = $FlowPrcsResult['copy'];
        }

        if ($copy) {
            $method = 16;
        }

        $userID = encrypt2($uid, 'E', 'eoffice');
        header("Location:/E-mobile/App/weixin/WeiServiceApi.php?type=2&uid={$userID}&m={$method}&id={$sourceID}");
    }

    private function dealSource($type) {
        $source = array(
            '7' => array('id' => 10, 'name' => '待办流程'),
            '27' => array('id' => 14, 'name' => '新闻'),
            '1' => array('id' => 15, 'name' => '公告'),
            // '27'=>array('id'=>1, 'name'=>'通讯录'),
            '28' => array('id' => 2, 'name' => '日程'),
            '20' => array('id' => 3, 'name' => '文档'),
            '2' => array('id' => 4, 'name' => '内部邮件'),
            '26' => array('id' => 8, 'name' => '协作')
        );

        return $source[$type]['id'];
    }

    public function dealFlowPrcs($uid, $sourceID) {
        $_pos = strpos($sourceID, '|');

        if (false !== $_pos) {
            $copy = trim(substr($sourceID, $_pos), '|');
            $sourceID = substr($sourceID, 0, $_pos);
        }

        $sourceID = explode(',', trim($sourceID, ','));
        $runID = $sourceID[0];

        $sql = "select FLOW_PRCS,PRCS_ID from flow_run_prcs where RUN_ID=".SecurityFilter($runID)." and USER_ID='".SecurityFilter($uid)."' order by PRCS_ID desc limit 1";
        $result = $this->query($sql);
        $row = @mysql_fetch_assoc($result);
        $sourceID[2] = $row['FLOW_PRCS'];
        $sourceID[3] = $row['PRCS_ID'];

        $implode = implode(',', $sourceID);
        $return = array('copy' => $copy, 'sourceID' => $implode);

        return $return;
    }

    public function checkDingTalkUser($userId) {
        $sql = 'SELECT USER_ID  FROM user WHERE USER_ID=\'' . SecurityFilter($userId) . '\'  AND USER_ACCOUNTS !=\'\'';

        $result = $this->query($sql);
        $row = @mysql_fetch_assoc($result);
        if ($row) {
            return $row;
        }
        return false;
    }

}
