<?php

include_once 'inc/conn.php';
require_once "../api/dingtalk.class.php";
include_once 'inc/utility_all.php';
include_once 'inc/AppGlobal.php';


$dingtalk = new dingtalk();
$result = $dingtalk->getDingTalk();
if ($result) {
    if (!$result["access_token"]) {
        //token为空 --- 当时间过期，会自动获取 只有当时间没有过期
        if ($result["appkey"] && $result["appsecret"]) {
            //尝试重新连接
            $url = "https://oapi.dingtalk.com/gettoken?appkey={$result["appkey"]}&appsecret={$result["appsecret"]}";
            $obj = $dingtalk->https_request($url);

            if (isset($obj["errmsg"]) && $obj["errmsg"] == "ok" && $obj['access_token']) {
                //更新入库
                $sql = "update dingtalk_token set 	access_token	 = '".SecurityFilter($obj['access_token'])."', token_time = '".SecurityFilter($time)."'";
                exequery($connection, $sql);

                $result["access_token"] = $obj['access_token'];
            } else {
                errorPage('503', '系统异常，错误码:' . $obj["errcode"] . ",错误信息:" . $obj["errmsg"]);
            }
        } else {
            errorPage('err', '请填写appkey和appsecret');
        }
    }

    $corpId = $result["corpid"];
    $domain = $result["domain"];
    $accessToken = $result["access_token"];
} else {
    errorPage('err', '钉钉设置异常，请联系管理员');
}

$code = $_GET['code'];


$url = "https://oapi.dingtalk.com/user/getuserinfo?access_token={$accessToken}&code={$code}";

$postObj = $dingtalk->https_request($url);



$userId = $postObj["userid"];
//通过userId 获取 当前用户的手机号
$url2 = "https://oapi.dingtalk.com/user/get?access_token={$accessToken}&userid={$userId}";
$userObj = $dingtalk->https_request($url2);
$mobile = $userObj["mobile"];

$userInfo = $dingtalk->getUserInfo($userId, $mobile);

if (!$userInfo) {
    errorPage('err', '该用户不是系统用户, 无法使用移动OA办公');
} else {

    $oaId = $userInfo["USER_ID"];

    //简单做一个绑定，发送消息用
    $dingtalk->updateDingTalkUser($oaId, $userId, $mobile);


    $wxCode = AppGlobal::getModApp(120);

    if ($wxCode == 1) {

        // $userID = encrypt2($oaId, 'E', 'eoffice');

        $content = $dingtalk->getDomain() . "/E-mobile/App/weixin/WeiServiceApi.php?type=4&uid={$oaId}";

        header("Location:" . $content);
    } else {
        switch ($wxCode) {
            case -1:
                $content = "授权许可已经过期或者未注册授权";
                break;
            case -2:
                $content = "授权文件不存在,请联系泛微";
                break;
            case -3:
                $content = "未授权";
                break;
            case -4:
                $content = "试用结束";
                break;
            default:
                $content = "请联系泛微，是否被授权可使用";
                break;
        }

        errorPage('err', $content);
    }
}

function errorPage($code = '', $message = '') {
    include('../error.php');
    exit;
}
