<?php

include_once("inc/reg_check.php");
include_once("inc/utility_all.php");

$LoginCheck = new LoginCheck();
$LoginCheck->validateCenter();

class LoginCheck {

    /**
     * 定义类全局变量
     */
    private $_USER_LANG;            //用户选择的登录语言
    private $_CUR_TIME;             //系统当前时间
    private $_LOGIN_FLAG = 1;       //是否正确登录
    private $_SEC_PASS_FLAG;        //密码定时过期标记
    private $_SEC_PASS_TIME;        //密码有效期
    private $_LIMIT_LOGIN_TIMES;    //限制多窗口登录
    private $_SEC_PASS_IMG;         //图形码验证标记
    private $_LOGIN_ERROR = '';     //登录错误信息;
    private $_LANG;                 //语言包
    private $_SEKEY = 'e-office';   //图形验证码的加密key

    public function __construct() {
        $this->setLoginLang(); //设置登录语言

        include_once("inc/utility.php"); //导入工具函数文件

        date_default_timezone_set('Asia/Shanghai'); //设置时区
        $this->_CUR_TIME = date("Y-m-d H:i:s", time());
    }

    /**
     * 登录验证中心
     */
    public function validateCenter() {
        @session_start(); //开启session机制
        @ob_start(); //打开输出控制缓冲


        $uid = isset($_POST['uid']) ? $_POST['uid'] : (isset($_GET['uid']) ? $_GET['uid'] : '');


        if ($this->_LOGIN_FLAG == 1)
            $userInfo = $this->validateAccount($uid); //账户密码验证

        if ($this->_LOGIN_FLAG == 1)
            $this->validateEnd($userInfo); //验证成功后的操作


        $useragent = $_SERVER['HTTP_USER_AGENT'];
        if ($this->_LOGIN_FLAG == 1) {
            header("location: /general/index9.php");
        } else {
            header("location: /login.php");
        }
    }

    /**
     * 检查用户名和密码;
     * @global type $connection
     */
    private function validateAccount($uid) {
        global $connection;
        /*
         * 验证用户名是否存在
         */
        if ($this->_LOGIN_FLAG && $uid != '') {
            $query = "SELECT * from USER where 	USER_ID ='".SecurityFilter($uid)."'";
            $cursor = exequery($connection, $query);
            if (!$ROW = @mysql_fetch_array($cursor)) {
                $this->_LOGIN_FLAG = 0;
            }
            @mysql_free_result($cursor);
        }

        $ROW["LOGIN_THEME"] = $ROW["THEME"] == '' ? 'theme1' : $ROW["THEME"];
        $ROW['MENU_TYPE'] = 2 - $ROW["MENU_TYPE"];

        return $ROW;
    }

    /**
     * 验证正确后做相应处理动作
     */
    private function validateEnd($userInfo = array()) {
        global $connection;
        ////////////////////检查上次访问时间及更新访问时间////////////////////////
        $labor_check = true;
        $query = "SELECT * FROM sys_log WHERE TYPE=1 AND TIME>=CURDATE() ORDER BY LOG_ID DESC";
        $cousor = exequery($connection, $query);
        if ($row = @mysql_fetch_array($cousor)) {
            $labor_check = false;
        }
        @mysql_free_result($cousor);

        $officeitem_need_check = true;
        $timenow = time();
        $query = "select LAST_VISIT_TIME from USER where USER_ID='" . SecurityFilter($userInfo['USER_ID']) . "'";
        $rs = @exequery($connection, $query);
        if ($row = @mysql_fetch_array($rs)) {
            $last_vt_time = strtotime($row[0]);
            $d_last = date("d", $last_vt_time);
            $m_last = date("m", $last_vt_time);
            $Y_last = date("Y", $last_vt_time);
            $d_now = date("d", $timenow);
            $m_now = date("m", $timenow);
            $Y_now = date("Y", $timenow);
            if ((abs($d_now - $d_last) == 0) && (abs($m_now - $m_last) == 0) && (abs($Y_now - $Y_last) == 0)) {
                $officeitem_need_check = false;
            }
        }
        @mysql_free_result($rs);

        $query = "update USER set LAST_VISIT_TIME='".SecurityFilter($this->_CUR_TIME)."' where USER_ID='" . SecurityFilter($userInfo['USER_ID']) . "'";
        @exequery($connection, $query);
        ///////////////////////////////////////////////////////////////////////
        //////////////////////////将登录后需要使用到的参数保存至session//////////
        $query = "SELECT * from USER_PRIV where USER_PRIV=" . SecurityFilter($userInfo['USER_PRIV']);
        $cursor = exequery($connection, $query);
        if ($ROW = @mysql_fetch_array($cursor)) {
            $LOGIN_FUNC_STR = $ROW["FUNC_ID_STR"];
        }
        @mysql_free_result($cousor);

        $sql = "SELECT LANG_ID FROM language WHERE LANG_AB='" . SecurityFilter($this->_USER_LANG) . "'";
        $rs = exequery($connection, $sql);
        $row = @mysql_fetch_array($rs);
        @mysql_free_result($rs);
        $_SESSION["LOGIN_LANG_ID"] = $row['LANG_ID'];
        $_SESSION["LOGIN_LANG"] = $this->_USER_LANG;
        $_SESSION["LOGIN_USER_ID"] = $userInfo['USER_ID'];
        $_SESSION["LOGIN_PASSWORD"] = $userInfo['PASSWORD'];
        $_SESSION["LOGIN_POST_PRIV"] = $userInfo["POST_PRIV"];
        $_SESSION["LOGIN_USER_ACCOUNTS"] = $userInfo['USER_ACCOUNTS'];
        $_SESSION["LOGIN_USER_NAME"] = $userInfo["USER_NAME"];
        $_SESSION["LOGIN_USER_PRIV"] = $userInfo["USER_PRIV"];
        $_SESSION["LOGIN_DEPT_ID"] = $userInfo["DEPT_ID"];
        $_SESSION["LOGIN_AVATAR"] = $userInfo["AVATAR"];
        $_SESSION["LOGIN_THEME"] = $userInfo['LOGIN_THEME'];
        $_SESSION["LOGIN_FUNC_STR"] = $LOGIN_FUNC_STR;
        $_SESSION['SMS_LOGIN'] = $userInfo['SMS_LOGIN'];
        $_SESSION["LOGIN_USBKEY"] = $userInfo['LOGIN_USBKEY'];
        $_SESSION["USBKEY_PIN"] = $userInfo['USBKEY_PIN'];
        setcookie("USER_NAME_COOKIE", $userInfo['USER_ACCOUNTS'], time() + 60 * 60 * 24 * 1000);
        setcookie("LOGIN_LANG", $this->_USER_LANG, time() + 60 * 60 * 24 * 1000);
        ///////////////////////////////////////////////////////////////////////
        /////////////////增加在线状态和同用户同时登录的限制//////////////////////
        $sessid = SESSION_ID();
        $userid = $userInfo['USER_ID'];
        $vtime = $this->_CUR_TIME;
        $sql = " SELECT COUNT(USER_ID) AS cnt FROM USER_ONLINE WHERE USER_ID='" . SecurityFilter($userInfo['USER_ID']) . "'";
        $re = exequery($connection, $sql);
        $row = @mysql_fetch_array($re);
        @mysql_free_result($re);
        if ($row['cnt'] == 0) {
            $sql = "INSERT INTO user_online (USER_ID,SESSION_ID,VISIT_TIME) VALUES ('" . SecurityFilter($userid) . "','" . SecurityFilter($sessid) . "','" . SecurityFilter($vtime) . "')";
        } else {
            $sql = "UPDATE user_online SET SESSION_ID='" . SecurityFilter($sessid) . "',VISIT_TIME='" . SecurityFilter($vtime) . "' WHERE USER_ID='" . SecurityFilter($userid) . "'";
        }
        exequery($connection, $sql);

        if ($this->_SEC_PASS_FLAG == '1')
            $this->passwordPastCheck($userInfo["LAST_PASS_TIME"]);
        add_log(1, "", $userInfo['USER_ID']); //添加日志

        affair_sms(); //根据日程安排生成短信息

        birthday_info(); //检查过生日，发送邮件祝福

        if ($officeitem_need_check == true)
            officeitem_sms(); //检查办公用品,同一天只检查一次

            /*
             * 人事档案检查
             */
        if ($labor_check == "1") {
            send_mes_to_hr("admin");
            $labor_check = false;
        }

        limitdate_flow_sms(); //检查是否有过期的流程需要办理

        if (!$sid = input_survey())
            $sid = 0; //检查是否有首页弹出的调查表
        $_SESSION['sid'] = $sid;
        $this->userAttend($userInfo['USER_ACCOUNTS']); //登陆签到

        $this->todayWorkCheck(); // 当天事务检查
        /*
         * 判断是否需要短信动态码登录
         */
        if ($userInfo["SMS_LOGIN"] && $this->_LOGIN_FLAG == 1) {
            $_SESSION["TMP_LOGIN_USER_ID"] = $_SESSION['LOGIN_USER_ID'];
            $_SESSION["LOGIN_USER_ID"] = "";
            $this->_LOGIN_FLAG = 2;
            $this->_LOGIN_ERROR = $this->_LANG['other_must_send_verfiy_code'];
        };

        if ($userInfo["LOGIN_USBKEY"] && $this->_LOGIN_FLAG == 1)
            $this->usbCheckStart($userInfo['USER_ID'], $userInfo["LOGIN_USBKEY"], $userInfo["USBKEY_PIN"]); //判读是否需要usb验证
    }

    /**
     * 导入登录后的语言包;
     */
    private function setLoginLang() {
        $USER_LANG = isset($_POST['USER_LANG']) ? $_POST['USER_LANG'] : (isset($_GET['USER_LANG']) ? $_GET['USER_LANG'] : 'cn');
        include_once("lang/" . $USER_LANG . "/other.lang.php");
        include_once("lang/" . $USER_LANG . "/common.lang.php");
        $this->_USER_LANG = $USER_LANG;
        $this->_LANG = $_lang;
    }

    /**
     * 当天事务检查
     */
    private function todayWorkCheck() {
        global $connection;
        $sql = "SELECT TIME FROM sys_log order by LOG_ID DESC limit 0,1";
        $rs = exequery($connection, $sql);
        $row = mysql_fetch_array($rs);
        @mysql_free_result($rs);
        $date = substr($row['TIME'], 0, 10);
        if ($date != date("Y-m-d")) {
            today_action();
        }
    }

    /**
     * @abstract 登录签到
     * @param type $LOGIN_USER_ACCOUNTS
     */
    private function userAttend($LOGIN_USER_ACCOUNTS) {
        include_once("api/attend.class.php");
        $attendClass = new attend();
        $USER_IP = $_SERVER["REMOTE_ADDR"];
        if (check_ip($USER_IP, "1", $LOGIN_USER_ACCOUNTS) == false) {
            echo $this->_LANG["index_no_iprule"];
        } else {
            $attendClass->loginSignIn();
        }
    }

}
