var lazyFormBuilder = {
    // 配置信息
    config: {
        basicProperties: ["title", "height", "width", "fontFamily", "fontSize", "color", "background"],
        fontFamily: {
            "SimSun": "宋体",
            "方正姚体": "方正姚体",
            "Microsoft YaHei": "微软雅黑",
            "SimKai": "楷体",
            "SimHei": "黑体",
            "SimLi": "隶书",
            "andale mono": "andale mono",
            "arial": "arial",
            "arial black": "arial black",
            "comic sans ms": "comic sans ms",
            "impact": "impact",
            "times new roman": "times new roman"
        },
        //fontSize: [10, 11, 12, 14, 16, 18, 20, 24, 36],
        fontSize: [12, 14, 16, 18, 20, 24, 36],
        editorID: "editor",
        widgetCategory: [{
            title: "基础控件",
            items: ["text", "textarea", "select", "checkbox", "DATE", "time"]
        }, {
            title: "高级控件",
            items: ["AUTO", "CALC", "EDITOR", "countersign", "chooseUser", "chooseDept", "chooseRole", "detailChar", "getvalue", "datecompute", "dynamic", "dynamic_info", "HTML_SIGNATURE", "PHONE_SIGNATURE","SIGNATURE_PICTURE"]
        }],
        colorPickerSetting: {
            history: false,
            displayIndicator: false,
            strings: '主题颜色,标准颜色,其他颜色...,返回,Back to Palette,History,No history yet.'
        },
        templateColudUrl: "http://eoffice9.weaver.cn/platform/list.php?type=template",
        styleColudUrl: "http://eoffice9.weaver.cn/platform/list.php?type=style",
    },
    client: false,
    // 控件
    widget: {
        text: {
            title: "单行文本框",
            view: "<input type='text'/>",
            resize: true,
            properties: ["defaultValue", "valueFormat"]
        },
        textarea: {
            title: "多行文本框",
            view: "<textarea></textarea>",
            resize: true,
            properties: ["defaultValue"]
        },
        select: {
            title: "下拉菜单",
            cancelProperties: ["height"],
            view: "<select></select>",
            properties: ["selectItems","searchAllow"]
        },
        checkbox: {
            title: "复选框",
            view: "<input type='checkbox'/>",
            cancelProperties: ["height", "width", "fontFamily", "fontSize", "color", "background"],
            properties: ["checkboxDefault"]
        },
        DATE: {
            title: "日期控件",
            view: '<img class="DATE" src="/images/form/calendar.png"/>',
            cancelProperties: ["title", "height", "width", "fontFamily", "fontSize", "color", "background"],
            properties: ["chooseTextWidget"]
        },
        time: {
            title: "时间控件",
            view: '<img class="time" src="/images/form/time.png"/>',
            cancelProperties: ["title", "height", "width", "fontFamily", "fontSize", "color", "background"]
        },
        AUTO: {
            title: "宏控件",
            view: '<input class="AUTO" datafld="SYS_TIME" value="{宏控件}" type="text">',
            properties: ["macroType", "SQLEditor"]
        },
        CALC: {
            title: "计算控件",
            view: "<input class='CALC' type='text' />",
            properties: ["formula", "thousandSeparator", "decimalFormat", "roundOff"]
        },
        EDITOR: {
            title: "编辑器",
            view: "<textarea class='EDITOR'>{编辑器}</textarea>",
            cancelProperties: ["fontFamily", "fontSize", "color", "background"]
        },
        countersign: {
            title: "会签字段",
            view: "<textarea class='countersign' auto_datetime='1' auto_user='1'>{会签字段}</textarea>",
            cancelProperties: ["fontFamily", "fontSize", "color", "background"],
            properties: ["autoAddUserName", "autoAddDate"]
        },
        chooseUser: {
            title: "人员选择框",
            view: "<textarea class='chooseUser'>{人员选择}</textarea>",
            cancelProperties: ["background"]
        },
        chooseDept: {
            title: "部门选择框",
            view: "<textarea class='chooseDept'>{部门选择}</textarea>",
            cancelProperties: ["background"]
        },
        chooseRole: {
            title: "角色选择框",
            view: "<textarea class='chooseRole'>{角色选择}</textarea>",
            cancelProperties: ["background"]
        },
        detailChar: {
            title: "明细字段",
            view: "<img class='detailChar' name='DATA_1' src='/images/form/calculator.png' />",
            cancelProperties: ["height", "width", "fontFamily", "fontSize", "color", "background"],
            properties: ["detailCharEditor"]
        },
        getvalue: {
            title: "获值和金额大写",
            view: "<input class='getvalue' type='text' />",
            cancelProperties: ["fontFamily", "fontSize", "color", "background"],
            properties: ["dataSource", "amountInWords"]
        },
        datecompute: {
            title: "日期时间计算",
            view: "<input class='datecompute' type='text' morning_start='00:00' morning_end='04:00' afternoon_start='11:00' afternoon_end='15:00' />",
            properties: ["startDate", "startTime", "endDate", "endTime", "workingHoursAM", "workingHoursPM","dateTimeCalcFormat","excludeVacation","relateUser"]
        },
        dynamic: {
            title: "动态联动",
            view: "<input class='dynamic' fieldtype='1' relparent='' type='text' />",
            cancelProperties: ["height", "width", "fontFamily", "fontSize", "color", "background"],
            properties: ["widgetType", "dataSourcePath", "parentWidget"]
        },
        dynamic_info: {
            title: "动态信息控件",
            view: "<textarea style='background:#EBEBE4;height:160px;width:560px;overflow-x: hidden; overflow-y: hidden;' class='dynamic_info'></textarea>",
            cancelProperties: ["fontFamily", "fontSize", "color", "background"],
            properties: ["dataSourcePath"]
        },
        HTML_SIGNATURE: {
            title: "电脑签章控件",
            view: '<textarea class="HTML_SIGNATURE" style="background:#EBEBE4;height: 165px; width: 165px; overflow-x: hidden; overflow-y: hidden"></textarea>',
            cancelProperties: ["fontFamily", "fontSize", "color", "background"]
        },
        PHONE_SIGNATURE: {
            title: "手机签章控件",
            view: '<textarea class="PHONE_SIGNATURE" style="background:#EBEBE4;height: 165px; width: 165px; overflow-x: hidden; overflow-y: hidden"></textarea>',
            cancelProperties: ["fontFamily", "fontSize", "color", "background"]
        },
        SIGNATURE_PICTURE: {
            title: "签名图片控件",
            view: '<textarea class="SIGNATURE_PICTURE" style="color:#A39B9B;background:#EBEBE4;height: 75px; width: 165px; overflow-x: hidden; overflow-y: hidden"></textarea>',
            cancelProperties: ["fontFamily", "fontSize", "color", "background"],
            properties: ["showBorderFormat"]
        }
    },
    // 属性
    property: {
        title: {
            title: "控件名称",
            view: "<input property-flag type='text'/>",
            getter: function() {
                return $(this).val();
            },
            setter: function($widget) {
                var $this = $(this);
                $this.val($widget.attr("title"));
            },
            create: function($widget) {
                $(this).change(function() {
                    var widgetName = $.trim($(this).val());
                    widgetName = UE.utils.unhtml(widgetName);
                    //$widget.attr("title", widgetName);
                    $(".shortcut-property").data("thisWidget").attr("title", widgetName);
                });
            },
            validate: {
                /**
                 * 必填验证
                 * @type {Object}
                 */
                require: {
                    func: function() {
                        if ($.trim($(this).val()) == "") {
                            return false;
                        } else {
                            return true;
                        }
                    },
                    msg: "控件名称不能为空"
                },
                /**
                 * 重复验证
                 * @type {Object}
                 */
                repeat: {
                    func: function() {
                        return true;
                    },
                    msg: "控件名称已存在"
                },
                /**
                 * 命名规则
                 * @type {Object}
                 */
                namingRule: {
                    func: function() {
                        return /^[a-zA-Z0-9_\u2E80-\uFE4F]+$/.test($.trim($(this).val()));
                    },
                    msg: "控件名称只能包含有汉字、数字、字母、下划线"
                }
            }
        },
        height: {
            title: "高度",
            view: "<input property-flag type='text'/>",
            getter: function() {
                return $(this).val();
            },
            setter: function($widget) {
                var $this = $(this),
                    h = $widget.css("height").replace("px", "");
                $this.val(h);
                //缓存原来的值,如果输入的是非数字的，则恢复成原来的值
                $this.data("height", $this.val());
            },
            create: function($widget) {
                var $this = $(this);
                $this.change(function() {
                    var height = parseInt($this.val(), 10);
                    if (isNaN(height)) {
                        $this.val($this.data("height"));
                    }
                    //$widget.height($this.val());
                    $(".shortcut-property").data("thisWidget").height($this.val());
                });
            }
        },
        width: {
            title: "宽度",
            view: "<input property-flag type='text'/>",
            getter: function() {
                return $(this).val();
            },
            setter: function($widget) {
                var $this = $(this),
                    w = $widget.css("width").replace("px", "");
                $this.val(w);
                //缓存原来的值,如果输入的是非数字的，则恢复成原来的值
                $this.data("width", $this.val());
            },
            create: function($widget) {
                var $this = $(this);
                $this.change(function() {
                    var width = parseInt($this.val(), 10);
                    if (isNaN(width)) {
                        $this.val($this.data("width"));
                    }
                    //$widget.width($this.val());
                    $(".shortcut-property").data("thisWidget").width($this.val());
                });
            }
        },
        fontFamily: {
            title: "字体",
            view: function() {
                var fontFamilyHtml = ['<select data-width="180px" property-flag>'];
                $.each(lazyFormBuilder.config.fontFamily, function(index, value) {
                    fontFamilyHtml.push('<option value="' + index + '">' + value + '</option>');
                });
                fontFamilyHtml.push('</select>');
                return fontFamilyHtml.join('');
            },
            getter: function() {
                return $(this).val();
            },
            setter: function($widget) {
                var $this = $(this);
                var fontFamily = $widget.css("fontFamily");
                //获取的字体 对于有空格的名字 会用逗号隔开
                fontFamily = fontFamily.replace(/'/g, "");
                $this.val($.trim(fontFamily));
            },
            create: function($widget) {
                var $this = $(this);
                $this.change(function() {
                    //$widget.css("fontFamily", $this.val());
                    $(".shortcut-property").data("thisWidget").css("fontFamily", $this.val());
                });
            }
        },
        fontSize: {
            title: "字号",
            view: function() {
                var fontSizeHtml = ['<select data-width="180px" property-flag>'];
                $.each(lazyFormBuilder.config.fontSize, function(index, value) {
                    fontSizeHtml.push('<option value="' + value + 'px">' + value + 'px</option>');
                });
                fontSizeHtml.push('</select>');
                return fontSizeHtml.join('');
            },
            getter: function() {
                return $(this).val();
            },
            setter: function($widget) {
                var $this = $(this);
                $this.val($widget.css("fontSize"));
            },
            create: function($widget) {
                var $this = $(this);
                $this.change(function() {
                    //$widget.css("fontSize", $this.val());
                    $(".shortcut-property").data("thisWidget").css("fontSize", $this.val());
                });
            }
        },
        color: {
            title: "字体颜色",
            view: "<input property-flag type='text'/>",
            getter: function() {
                return $(this).val();
            },
            setter: function($widget) {
                $(this).val(lazyFormBuilder.util.RGBToHex($widget.css("color")));
            },
            create: function($widget) {
                $(this).colorpicker(lazyFormBuilder.config.colorPickerSetting).on("change.color", function(event, color) {
                    //$widget.css("color", color);
                    $(".shortcut-property").data("thisWidget").css("color", color);
                });
            }
        },
        background: {
            title: "背景色",
            view: "<input property-flag type='text'/>",
            getter: function() {
                return $(this).val();
            },
            setter: function($widget) {
                $(this).val(lazyFormBuilder.util.RGBToHex($widget.css("backgroundColor")));
            },
            create: function($widget) {
                $(this).colorpicker(lazyFormBuilder.config.colorPickerSetting).on("change.color", function(event, color) {
                    //$widget.css("background-color", color);
                    $(".shortcut-property").data("thisWidget").css("background-color", color);
                });
            }
        },
        defaultValue: {
            title: "默认值",
            view: "<input property-flag type='text'/>",
            getter: function() {
                return $(this).val();
            },
            setter: function($widget) {
                var $this = $(this);
                $this.val($widget.attr("value"));
            },
            create: function($widget) {
                var $this = $(this);
                $this.change(function() {
                    if ($widget.is("textarea")) {
                        //直接用val赋值时,在切换源代码时会被清除
                        $widget.html($this.val());
                        $widget.val($this.val());
                    } else {
                        $widget.attr("value", $this.val());
                    }
                });
            }
        },
        decimalFormat: {
            title: "保留小数点位数",
            view: "<input property-flag type='text'/>",
            getter: function() {
                return $(this).val();
            },
            setter: function($widget) {
                if ($widget.attr("format")) {
                    $(this).val($widget.attr("format"));
                } else {
                    $(this).val('2');
                    $widget.attr("format", $(this).val());
                }
            },
            create: function($widget) {
                $(this).change(function() {
                    $widget.attr("format", $(this).val());
                });
            },
            validate: {
                /**
                 * 计算控件小数点位数验证
                 * @type {Object}
                 */
                decimalLength: {
                    func: function() {
                        if(/^\d+$/.test($.trim($(this).val())) && $.trim($(this).val()) >= 0 && $.trim($(this).val()) <= 10)
                            return true;
                        else
                            return false;
                    },
                    msg: "计算控件小数点位数，只能是 0 ~ 10 之间的值，包括 0 和 10！"
                }
            }
        },
        roundOff: {
            title: "&nbsp;",
            view: "<label ><input property-flag type='checkbox'/> 四舍五入</label>",
            getter: function() {},
            setter: function($widget) {
                // 默认是四舍五入的
                if (!$widget.attr("round-off")) {
                    $widget.attr("round-off", "1");
                }
                $(this).prop("checked", $widget.attr("round-off") == "1").iCheck("update");
            },
            create: function($widget) {
                $(this).iCheck({
                    checkboxClass: 'icheckbox_square-blue'
                }).on("ifChanged", function() {
                    $widget.attr("round-off", $(this).prop("checked") ? "1" : "0");
                });
            }
        },
        valueFormat: {
            title: "格式化",
            view: '<select data-width="180px" property-flag>\
                        <option value="0">请选择</option>\
                        <option value="thousandformat">千位分隔符</option>\
                        <option value="number">数字</option>\
                        <option value="email">邮箱格式</option>\
                        <option value="mobile">手机格式</option>\
                        <option value="money">金额</option>\
                   </select>',
            getter: function() {
                return $(this).val();
            },
            setter: function($widget) {
                if ($widget.attr("format")) {
                    $(this).val($widget.attr("format"));
                } else {
                    $(this).val(0);
                }
            },
            create: function($widget) {
                $(this).change(function() {
                    if ($(this).val() == 0) {
                        $widget.removeAttr("format");
                    } else {
                        $widget.attr("format", $(this).val());
                    }
                });
            }
        },
        showBorderFormat: {
            title: "展示/隐藏边框线",
            view: '<select data-width="180px" property-flag>\
                        <option value="showborder">展示控件边框线</option>\
                        <option value="hiddenborder">隐藏控件边框线</option>\
                   </select>',
            getter: function() {
                return $(this).val();
            },
            setter: function($widget) {
                if ($widget.attr("format")) {
                    $(this).val($widget.attr("format"));
                } else {
                    $(this).val('showborder');
                    $widget.attr("format", $(this).val());
                }
            },
            create: function($widget) {
                $(this).change(function() {
                    if ($(this).val() == 'showborder') {
                        $widget.removeAttr("format");
                    } else {
                        $widget.attr("format", $(this).val());
                    }
                });
            }
        },
        checkboxDefault: {
            title: "默认选中",
            view: '<input property-flag type="checkbox">',
            getter: function() {
                return $(this).prop("checked");
            },
            setter: function($widget) {
                $(this).prop("checked", $widget.prop("checked")).iCheck("update");
            },
            create: function($widget) {
                $(this).iCheck({
                    checkboxClass: 'icheckbox_square-blue'
                }).on("ifChanged", function() {
                    $widget.attr("checked", $(this).prop("checked") ? "checked" : "");
                });
            }
        },
        selectItems: {
            title: "下拉项",
            view: "<span class='property-sub-title'>(集合)</span><input type='button' property-flag class='btn btn-browse' value='...'/>",
            getter: function() {},
            setter: function($widget) {},
            create: function($widget) {
                itemsEditor.init.call($widget);
                itemsEditor.setData = function(selectItems) {
                    var selectItemHtml = [];
                    $.each(selectItems, function(index, value) {
                        selectItemHtml.push('<option value="' + value + '">' + value + '</option>');
                    });
                    $widget.html(selectItemHtml.join(''));
                }
                itemsEditor.getData = function() {
                    var items = [];
                    $widget.find("option").each(function() {
                        items.push($(this).text());
                    });
                    return items;
                }
                $(this).click(function() {
                    itemsEditor.open();
                });
            }
        },
        searchAllow: {
            title: "允许查询",
            view: "<label ><input property-flag type='checkbox'/></label>",
            getter: function() {},
            setter: function($widget) {
                // 默认不允许
                if (!$widget.attr("search-allow")) {
                    $widget.attr("search-allow", "0");
                }
                $(this).prop("checked", $widget.attr("search-allow") == "1").iCheck("update");
            },
            create: function($widget) {
                $(this).iCheck({
                    checkboxClass: 'icheckbox_square-blue'
                }).on("ifChanged", function() {
                    $widget.attr("search-allow", $(this).prop("checked") ? "1" : "0");
                });
            }
        },
        macroType: {
            title: "宏控件类型",
            view: function() {
                var macroTypeList = {
                    text: {
                        groupName: "单行文本框",
                        groupList: {
                            SYS_DATE: "日期",
                            SYS_TIME: "当前时间",
                            SYS_DATETIME: "当前日期+时间",
                            SYS_USERID: "当前用户ID",
                            SYS_USERNAME: "当前用户姓名",
                            SYS_ACCOUNTS: "当前用户账户名",
                            SYS_USERCURDEAL: "当前主办人姓名",
                            SYS_USERPRIV: "当前用户角色",
                            SYS_DEPTNAME: "当前用户部门完整路径",
                            SYS_DEPTNAME_S: "当前用户部门名称",
                            SYS_USER_SUPERIOR: "当前用户上级",
                            SYS_USER_SUBORDINATE: "当前用户下级",
                            SYS_USER_JOBNUMBER: "当前用户工号",
                            SYS_FORMNAME: "表单名称",
                            SYS_RUNNAME: "流水号",
                            SYS_FLOWRUNNAME: "流程标题",
                            SYS_RUNDATE: "流程开始日期",
                            SYS_RUNDATETIME: "流程开始日期+时间",
                            SYS_SQL: "来自SQL查询语句"
                        }
                    },
                    select: {
                        groupName: "下拉菜单",
                        groupList: {
                            SYS_LIST_DEPT: "部门列表",
                            SYS_LIST_USER: "人员列表",
                            SYS_LIST_PRIV: "角色列表",
                            SYS_LIST_PRCSUSER1: "流程经办人列表",
                            SYS_LIST_PRCSUSER2: "本步骤经办人列表",
                            SYS_LIST_SQL: "来自SQL查询语句"
                        }
                    }
                }
                var macroTypeListHtml = ['<select data-width="180px" property-flag>']
                $.each(macroTypeList, function(index, value) {
                    macroTypeListHtml.push('<optgroup label="' + value.groupName + '">');
                    $.each(value.groupList, function(listIndex, listValue) {
                        macroTypeListHtml.push('<option value="' + listIndex + '">' + listValue + '</option>');
                    });
                    macroTypeListHtml.push('</optgroup>');
                });
                macroTypeListHtml.push('</select>');
                return macroTypeListHtml.join('');
            },
            getter: function() {},
            setter: function($widget) {
                $(this).val($widget.attr("datafld"));
            },
            create: function($widget) {
                //console.log($(this).val());
                var thisValue = $.trim($(this).val());
                if (thisValue == "SYS_SQL" || thisValue == "SYS_LIST_SQL") {
                    $(this).parents(".property-list").next().show();
                } else {
                    $(this).parents(".property-list").next().hide();
                }
                $(this).change(function() {
                    $widget.attr("datafld", $(this).val());
                    if ($(this).val() == "SYS_SQL" || $(this).val() == "SYS_LIST_SQL") {
                        $(this).parents(".property-list").next().show();
                    } else {
                        $(this).parents(".property-list").next().hide();
                    }
                    //更改宏控件类型
                    var $newWidget;
                    if ($(this).val().indexOf("SYS_LIST") != -1) {
                        $newWidget = $("<select/>", {
                            'class': $widget.attr("class"),
                            'id': $widget.attr("id"),
                            'title': $widget.attr("title"),
                            'datafld': $(this).val(),
                            'html': '<option selected="selected">{宏控件}</option>'
                        });
                    } else {
                        $newWidget = $("<input/>", {
                            'class': $widget.attr("class"),
                            'id': $widget.attr("id"),
                            'title': $widget.attr("title"),
                            'datafld': $(this).val(),
                            'type': 'text',
                            'value': "{宏控件}"
                        });
                    }
                    //复制已设定的样式 QC:20116 start
                    $newWidget.css({
                        "height": $widget.css("height"),
                        "width": $widget.css("width"),
                        "fontFamily": $widget.css("fontFamily"),
                        "fontSize": $widget.css("fontSize"),
                        "color": $widget.css("color"),
                        "backgroundColor": $widget.css("backgroundColor")
                    });
                    //复制已设定的样式 QC:20116 end
                    $widget.replaceWith($newWidget);
                    $widget = $newWidget;
                    $(".shortcut-property").data("thisWidget", $widget);
                });
            }
        },
        SQLEditor: {
            title: "SQL查询语句",
            view: "<span class='property-sub-title'>(SQL语句编辑器)</span><input type='button' property-flag class='btn btn-browse' value='...'/>",
            getter: function() {
                //return $(this).val();
            },
            setter: function(value) {
                //$(this).val(value);
            },
            create: function($widget) {
                SQLEditor.init.call($widget);
                $(this).click(function() {
                    SQLEditor.open.call($widget);
                });
            }
        },
        formula: {
            title: "计算公式",
            view: "<span class='property-sub-title'>(计算公式编辑器)</span><input type='button' property-flag class='btn btn-browse' value='...'/>",
            getter: function() {
                //return $(this).val();
            },
            setter: function(value) {
                //$(this).val(value);
            },
            create: function($widget) {
                formulaEditor.init.call($widget);
                formulaEditor.setData = function(data) {
                    $widget.attr("value", data);
                }
                formulaEditor.getData = function() {
                    return $widget.val();
                }
                $(this).click(function() {
                    formulaEditor.open.call($widget);
                });
            }
        },
        autoAddUserName: {
            title: "自动添加用户名",
            view: "<input type='checkbox' property-flag/>",
            getter: function() {
                return $(this).prop("checked");
            },
            setter: function($widget) {
                $(this).prop("checked", $widget.attr("auto_user") == 1).iCheck("update");
            },
            create: function($widget) {
                $(this).iCheck({
                    checkboxClass: 'icheckbox_square-blue'
                }).on("ifChanged", function() {
                    $widget.attr("auto_user", $(this).prop("checked") ? 1 : 0);
                });
            }
        },
        autoAddDate: {
            title: "自动添加日期",
            view: "<input type='checkbox' property-flag/>",
            getter: function() {
                return $(this).prop("checked");
            },
            setter: function($widget) {
                $(this).prop("checked", $widget.attr("auto_datetime") == 1).iCheck("update");
            },
            create: function($widget) {
                $(this).iCheck({
                    checkboxClass: 'icheckbox_square-blue'
                }).on("ifChanged", function() {
                    $widget.attr("auto_datetime", $(this).prop("checked") ? 1 : 0);
                });
            }
        },
        detailCharEditor: {
            title: "明细字段列表",
            view: "<span class='property-sub-title'>(明细字段编辑器)</span><input type='button' property-flag class='btn btn-browse' value='...'/>",
            getter: function() {},
            setter: function($widget) {
                var itemNameSplit = $widget.attr("detailcharname") ? $widget.attr("detailcharname").split('`') : [];
                var itemTypeSplit = $widget.attr("detailchartype") ? $widget.attr("detailchartype").split('`') : [];
                var itemSizeSplit = $widget.attr("detailcharwidth") ? $widget.attr("detailcharwidth").split('`') : [];
                var itemTotalSplit = $widget.attr("detailchartotal") ? $widget.attr("detailchartotal").split('`') : [];
                var dropItemsSplit = $widget.attr("detailchardropvalues") ? $widget.attr("detailchardropvalues").split('~') : [];
                var formulaSplit = $widget.attr("detailcharformula") ? $widget.attr("detailcharformula").split('`') : [];
                // 列合计时，保留小数点位数
                var itemDecimalSplit = $widget.attr("detailchardecimal") ? $widget.attr("detailchardecimal").split('`') : [];
                // 列合计时，四舍五入
                var itemRoundoffSplit = $widget.attr("detailcharroundoff") ? $widget.attr("detailcharroundoff").split('`') : [];
                // 行计算时，保留小数点位数&四舍五入，保存在一个属性里，用*连接，初始值"2*1"，代表，两位小数，四舍五入
                var formulaFormatSplit = $widget.attr("detailcharformulaformat") ? $widget.attr("detailcharformulaformat").split('`') : [];
                var itemStr = [];
                var itemNameLength = itemNameSplit.length;
                for (var i = 0; i < itemNameLength; i++) {
                    var sizeSplit = itemSizeSplit[i].split("*");
                    var decimalSplit = itemDecimalSplit[i] ? itemDecimalSplit[i] : "2";
                    var roundoffSplit = itemRoundoffSplit[i] ? itemRoundoffSplit[i] : "1";
                    itemStr.push("<li formula='" + (formulaSplit[i] ? formulaSplit[i] : '') + "' formulaformat='" + (formulaFormatSplit[i] ? formulaFormatSplit[i] : '2*1') + "' item-order='" + (i + 1) + "' items='" + (dropItemsSplit[i] ? dropItemsSplit[i] : '') + "' type='" + itemTypeSplit[i] + "' total='" + itemTotalSplit[i] + "' decimal='" + decimalSplit + "' roundoff='" + roundoffSplit + "' width='" + sizeSplit[0] + "' height='" + sizeSplit[1] + "' class='item-list'><span class='item-order'>[" + (i + 1) + "]</span><span class='item-title'>" + itemNameSplit[i] + "</span><a href='javascript:void(0)' class='remove'><i class='fa fa-times'/></i></a></li>");
                }
                $(".detail-char-dialog .item-list-wrap .content-wrap").html(itemStr.join(''));
                if ($(".detail-char-dialog .item-list-wrap").find(".item-list").length > 0) {
                    $(".detail-char-dialog .content-wrap").css("visibility", "visible");
                    $(".detail-char-dialog .empty-tip").hide();
                } else {
                    $(".detail-char-dialog .content-wrap").css("visibility", "hidden");
                    $(".detail-char-dialog .empty-tip").show();
                }
            },
            create: function($widget) {
                detailCharEditor.init.call($widget);
                $(this).click(function() {
                    detailCharEditor.open();
                });
            }
        },
        thousandSeparator: {
            title: "&nbsp;",
            view: "<label ><input property-flag type='checkbox'/> 使用千位分隔符格式化</label>",
            getter: function() {},
            setter: function($widget) {
                $(this).prop("checked", $widget.attr("thousandformat") == "1").iCheck("update");
            },
            create: function($widget) {
                $(this).iCheck({
                    checkboxClass: 'icheckbox_square-blue'
                }).on("ifChanged", function() {
                    $widget.attr("thousandformat", $(this).prop("checked") ? 1 : "");
                });
            }
        },
        dataSource: {
            title: "值来源控件名",
            view: function() {
                var dataSourceListHtml = ['<select data-none-results-text="未找到控件包含" data-live-search="true" class="require" data-width="180px" property-flag><option value="0">请选择值来源控件</option>'];
                var widgetList = lazyFormBuilder.ui.widget.getAllWidgets($(this).attr("title"));
                $.each(widgetList, function(index, value) {
                    dataSourceListHtml.push('<option value="' + value + '">' + value + '</option>');
                });
                dataSourceListHtml.push('</select>');
                return dataSourceListHtml.join('');
            },
            getter: function() {},
            setter: function($widget) {
                $(this).val($widget.attr("datasourceid"));
            },
            create: function($widget) {
                $(this).change(function() {
                    if ($(this).val() == 0) {} else {
                        $widget.attr("datasourceid", $(this).val());
                    }
                });
            }
        },
        amountInWords: {
            title: "&nbsp;",
            view: "<label><input property-flag type='checkbox'/> 金额转换为大写</label>",
            getter: function() {},
            setter: function($widget) {
                $(this).prop("checked", $widget.attr("uppercase") == "uppercase");
            },
            create: function($widget) {
                $(this).iCheck({
                    checkboxClass: 'icheckbox_square-blue'
                }).on("ifChanged", function() {
                    $widget.attr("uppercase", $(this).prop("checked") ? "uppercase" : "");
                });
            }
        },
        startDate: {
            title: "开始日期控件",
            view: function() {
                var dateWidgetListHtml = ['<select data-none-results-text="未找到控件包含" data-live-search="true" class="require" data-width="180px" property-flag><option value="0">选择参与计算的日期控件</option>'];
                var widgetList = lazyFormBuilder.ui.widget.getAllDateWidgets();
                $.each(widgetList, function(index, value) {
                    dateWidgetListHtml.push('<option value="' + value + '">' + value + '</option>');
                });
                dateWidgetListHtml.push('</select>');
                return dateWidgetListHtml.join('');
            },
            getter: function() {},
            setter: function($widget) {
                $(this).val($widget.attr("startdate"));
            },
            create: function($widget) {
                $(this).change(function() {
                    $widget.attr("startdate", $(this).val());
                });
            }
        },
        startTime: {
            title: "开始时间控件",
            view: function() {
                var dateWidgetListHtml = ['<select data-none-results-text="未找到控件包含" data-live-search="true" data-width="180px" property-flag><option value="0">选择参与计算的时间控件</option>'];
                var widgetList = lazyFormBuilder.ui.widget.getAllTimeWidgets();
                $.each(widgetList, function(index, value) {
                    dateWidgetListHtml.push('<option value="' + value + '">' + value + '</option>');
                });
                dateWidgetListHtml.push('</select>');
                return dateWidgetListHtml.join('');
            },
            getter: function() {},
            setter: function($widget) {
                $(this).val($widget.attr("starttime"));
            },
            create: function($widget) {
                $(this).change(function() {
                    $widget.attr("starttime", $(this).val());
                });
            }
        },
        endDate: {
            title: "结束日期控件",
            view: function() {
                var dateWidgetListHtml = ['<select data-none-results-text="未找到控件包含" data-live-search="true" class="require" data-width="180px" property-flag><option value="0">选择参与计算的日期控件</option>'];
                var widgetList = lazyFormBuilder.ui.widget.getAllDateWidgets();
                $.each(widgetList, function(index, value) {
                    dateWidgetListHtml.push('<option value="' + value + '">' + value + '</option>');
                });
                dateWidgetListHtml.push('</select>');
                return dateWidgetListHtml.join('');
            },
            getter: function() {},
            setter: function($widget) {
                $(this).val($widget.attr("enddate"));
            },
            create: function($widget) {
                $(this).change(function() {
                    $widget.attr("enddate", $(this).val());
                });
            }
        },
        endTime: {
            title: "结束时间控件",
            view: function() {
                var dateWidgetListHtml = ['<select data-none-results-text="未找到控件包含" data-live-search="true" data-width="180px" property-flag><option value="0">选择参与计算的时间控件</option>'];
                var widgetList = lazyFormBuilder.ui.widget.getAllTimeWidgets();
                $.each(widgetList, function(index, value) {
                    dateWidgetListHtml.push('<option value="' + value + '">' + value + '</option>');
                });
                dateWidgetListHtml.push('</select>');
                return dateWidgetListHtml.join('');
            },
            getter: function() {},
            setter: function($widget) {
                $(this).val($widget.attr("endtime"));
            },
            create: function($widget) {
                $(this).change(function() {
                    $widget.attr("endtime", $(this).val());
                });
            }
        },
        workingHoursAM: {
            title: "工作日时间范围",
            view: function() {
                var timeStr = [];
                for (var i = 0; i < 24; i++) {
                    var hour = (i + "").length == 1 ? "0" + i : i;
                    timeStr.push("<option value='" + hour + ":00'>" + hour + ":00</option>");
                    timeStr.push("<option value='" + hour + ":15'>" + hour + ":15</option>");
                    timeStr.push("<option value='" + hour + ":30'>" + hour + ":30</option>");
                    timeStr.push("<option value='" + hour + ":45'>" + hour + ":45</option>");
                }
                timeStr.push("<option value='24:00'>24:00</option></select>");
                return "<table property-flag cellpadding='0' cellspacing='0'>\
                            <tr>\
                                <td><select data-width='80px' am-start>" + timeStr.join('') + "</td>\
                                <td style='width:20px;text-align:center;'>~</td>\
                                <td><select data-width='80px' am-end>" + timeStr.join('') + "</td>\
                                <td>&nbsp;(上午)</td>\
                            <tr>\
                        </table>";
            },
            getter: function() {},
            setter: function($widget) {
                $(this).find("select[am-start]").val($widget.attr("morning_start"));
                $(this).find("select[am-end]").val($widget.attr("morning_end"));
            },
            create: function($widget) {
                $(this).find("select[am-start]").change(function() {
                    $widget.attr("morning_start", $(this).val());
                });
                $(this).find("select[am-end]").change(function() {
                    $widget.attr("morning_end", $(this).val());
                });
            },
            validate: {
                timeCheck: {
                    func: function() {
                        var startTime = $(this).find("select[am-start]").val();
                        var endTime = $(this).find("select[am-end]").val();
                        if (Date.parse('01/01/2014 ' + startTime) >= Date.parse('01/01/2014 ' + endTime)) {
                            return false;
                        } else {
                            return true;
                        }
                    },
                    msg: "工作日时间上午结束时间必须大于开始时间"
                },
                // rangeCheck1: {
                //     func: function() {
                //         var amStartTime = $(this).find("select[am-start]").val();
                //         var amEndTime = $(this).find("select[am-end]").val();
                //         var $nextObj = $(this).parents(".property-list").next();
                //         var pmStartTime = $nextObj.find("select[pm-start]").val();
                //         var pmEndTime = $nextObj.find("select[pm-end]").val();
                //         if (Date.parse('01/01/2014 ' + amStartTime) >= Date.parse('01/01/2014 ' + pmStartTime)) {
                //             return false;
                //         } else {
                //             return true;
                //         }
                //     },
                //     msg: "工作日时间下午开始时间必须大于上午开始时间"
                // },
                // rangeCheck2: {
                //     func: function() {
                //         var amStartTime = $(this).find("select[am-start]").val();
                //         var amEndTime = $(this).find("select[am-end]").val();
                //         var $nextObj = $(this).parents(".property-list").next();
                //         var pmStartTime = $nextObj.find("select[pm-start]").val();
                //         var pmEndTime = $nextObj.find("select[pm-end]").val();
                //         if (Date.parse('01/01/2014 ' + amEndTime) >= Date.parse('01/01/2014 ' + pmStartTime)) {
                //             return false;
                //         } else {
                //             return true;
                //         }
                //     },
                //     msg: "工作日时间下午开始时间必须大于上午结束时间"
                // }
            }
        },
        workingHoursPM: {
            title: "&nbsp;",
            view: function() {
                var timeStr = [];
                for (var i = 0; i < 24; i++) {
                    var hour = (i + "").length == 1 ? "0" + i : i;
                    timeStr.push("<option value='" + hour + ":00'>" + hour + ":00</option>");
                    timeStr.push("<option value='" + hour + ":15'>" + hour + ":15</option>");
                    timeStr.push("<option value='" + hour + ":30'>" + hour + ":30</option>");
                    timeStr.push("<option value='" + hour + ":45'>" + hour + ":45</option>");
                }
                timeStr.push("<option value='24:00'>24:00</option></select>");
                return "<table property-flag cellpadding='0' cellspacing='0'>\
                            <tr>\
                                <td><select data-width='80px' pm-start>" + timeStr.join('') + "</td>\
                                <td style='width:20px;text-align:center;'>~</td>\
                                <td><select data-width='80px' pm-end>" + timeStr.join('') + "</td>\
                                <td>&nbsp;(下午)</td>\
                            <tr>\
                        </table>";
            },
            getter: function() {},
            setter: function($widget) {
                $(this).find("select[pm-start]").val($widget.attr("afternoon_start"));
                $(this).find("select[pm-end]").val($widget.attr("afternoon_end"));
            },
            create: function($widget) {
                $(this).find("select[pm-start]").change(function() {
                    $widget.attr("afternoon_start", $(this).val());
                });
                $(this).find("select[pm-end]").change(function() {
                    $widget.attr("afternoon_end", $(this).val());
                });
            },
            validate: {
                timeCheck: {
                    func: function() {
                        var startTime = $(this).find("select[pm-start]").val();
                        var endTime = $(this).find("select[pm-end]").val();
                        if (Date.parse('01/01/2014 ' + startTime) >= Date.parse('01/01/2014 ' + endTime)) {
                            return false;
                        } else {
                            return true;
                        }
                    },
                    msg: "工作日时间下午结束时间必须大于开始时间"
                }
            }
        },
        dateTimeCalcFormat: {
            title: "格式化",
            view: '<select data-width="180px" property-flag>\
                        <option value="days">天</option>\
                        <option value="hours">小时</option>\
                   </select>',
            getter: function() {
                return $(this).val();
            },
            setter: function($widget) {
                if ($widget.attr("format")) {
                    $(this).val($widget.attr("format"));
                } else {
                    $(this).val(0);
                }
            },
            create: function($widget) {
                $widget.attr("format", $(this).val());
                $(this).change(function() {
                    if ($(this).val() == 0) {
                        $widget.removeAttr("format");
                    } else {
                        $widget.attr("format", $(this).val());
                    }
                });
            }
        },
        excludeVacation: {
            title: "排除假期",
            view: "<input type='checkbox' property-flag/>",
            getter: function() {
                return $(this).prop("checked");
            },
            setter: function($widget) {
                $(this).prop("checked", $widget.attr("exclude_vacation") == 1).iCheck("update");
            },
            create: function($widget) {
                $(this).iCheck({
                    checkboxClass: 'icheckbox_square-blue'
                }).on("ifChanged", function() {
                    $widget.attr("exclude_vacation", $(this).prop("checked") ? 1 : 0);
                });
            }
        },
        relateUser: {
            title: "关联用户",
            view: function() {
                var relateUserListHtml = ['<select data-none-results-text="未找到控件包含" data-live-search="true" data-width="180px" property-flag><option value="0">选择用户名来源控件</option>'];
                var widgetList = lazyFormBuilder.ui.widget.getAllWidgets($(this).attr("title"));
                $.each(widgetList, function(index, value) {
                    relateUserListHtml.push('<option value="' + value + '">' + value + '</option>');
                });
                relateUserListHtml.push('</select>\
                    <a title="若勾选排除假期，计算结果会排除假期，假期可以在考勤模块里设置，此处默认关联流程创建人的假期，也可在关联用户中关联其他用户的假期。" style="margin-left:10px;color:#428BCA;" class=" date-relate-user-tips" href="javascript:void(0);">\
                    <i class="fa fa-question-circle"></i>\
                    </a>\
                    ');
                return relateUserListHtml.join('');
            },
            getter: function() {
            },
            setter: function($widget) {
                $('.date-relate-user-tips').tooltip({
                    placement : "top"
                });
                $(this).val($widget.attr("relate_user"));
            },
            create: function($widget) {
                $(this).change(function() {
                    $widget.attr("relate_user", $(this).val());
                });
            }
        },
        widgetType: {
            title: "控件类型",
            view: "<select data-width='180px' property-flag>\
                        <option value='1'>单行输入框</option>\
                        <option value='2'>多行输入框</option>\
                        <option value='3'>下拉菜单</option>\
                    </select>",
            getter: function() {},
            setter: function($widget) {
                $(this).val($widget.attr("fieldtype"));
            },
            create: function($widget) {
                $(this).change(function() {
                    var fieldType = $(this).val();
                    var widgetAttr = {
                        'class': 'dynamic',
                        id: $widget.attr("id"),
                        title: $widget.attr("title"),
                        fieldtype: fieldType,
                        datasource: $widget.attr("datasource"),
                        relparent: $widget.attr("relparent"),
                        name: $widget.attr("name")
                    }
                    if (fieldType == 1) {
                        var textAttr = $.extend({}, widgetAttr, {
                            type: "text"
                        });
                        $newWidget = $("<input/>", textAttr);
                    } else if (fieldType == 2) {
                        $newWidget = $("<textarea/>", widgetAttr);
                    } else if (fieldType == 3) {
                        $newWidget = $("<select/>", widgetAttr);
                    }
                    $widget.replaceWith($newWidget);
                    $widget = $newWidget;
                });
            }
        },
        dataSourcePath: {
            title: "选择数据源",
            view: "<span property-flag><input type='text' class='require'/><input type='button' value='...' class='btn btn-browse'/></span>",
            getter: function() {},
            setter: function($widget) {
                $(this).find(":text").val($widget.attr("datasource"));
            },
            create: function($widget) {
                dataSourceSelector.init.call($widget, $(this));
                $(this).find(":text").change(function() {
                    $widget.attr("datasource", $(this).val());
                });
                $(this).find('.btn-browse').click(function() {
                    dataSourceSelector.open.call($widget);
                });
            },
            validate: {
                /**
                 * 必填验证
                 * @type {Object}
                 */
                require: {
                    func: function() {
                        if ($.trim($(this).find(":text").val()) == "") {
                            return false;
                        } else {
                            return true;
                        }
                    },
                    msg: "数据源不能为空"
                }
            }
        },
        parentWidget: {
            title: "关联上级控件",
            view: function() {
                var dateWidgetListHtml = ['<select data-none-results-text="未找到控件包含" data-live-search="true" data-width="180px" property-flag><option value="0">选择上级控件</option>'];
                var widgetList = lazyFormBuilder.ui.widget.getAllWidgets($(this).attr("title"));
                $.each(widgetList, function(index, value) {
                    dateWidgetListHtml.push('<option value="' + value + '">' + value + '</option>');
                });
                dateWidgetListHtml.push('</select>');
                return dateWidgetListHtml.join('');
            },
            getter: function() {},
            setter: function($widget) {
                $(this).val($widget.attr("relparent"));
            },
            create: function($widget) {
                $(this).change(function() {
                    $widget.attr("relparent", $(this).val());
                });
            }
        },
        tipText: {
            title: "提示文字",
            view: "<input property-flag type='text'/>",
            getter: function() {
                return $(this).val();
            },
            setter: function($widget) {
                var $this = $(this);
                $this.val($widget.attr("value"));
            },
            create: function($widget) {
                var $this = $(this);
                $this.change(function() {
                    if ($widget.is("textarea")) {
                        //直接用val赋值时,在切换源代码时会被清除
                        $widget.html($this.val());
                        $widget.val($this.val());
                    } else {
                        $widget.attr("value", $this.val());
                    }
                });
            }
        },
        widgetID: {
            title: "控件ID",
            view: '<span property-flag><input readonly="readonly" type="text"/>\
                        <a title="更改控件ID" class="btn-waring" href="javascript:void(0);">\
                            <i class="fa fa-exclamation-triangle"></i>\
                        </a></span>',
            getter: function() {},
            setter: function($widget) {
                $(this).find(":text").val($widget.attr("id"));
            },
            create: function($widget) {
                var $this = $(this);
                $this.find("a").click(function() {
                    $(".change-id-dialog").dialog("open");
                });
                $(".change-id-dialog").dialog({
                    autoOpen: false,
                    modal: true,
                    width: 400,
                    height: 230,
                    draggable: false,
                    resizable: false,
                    buttons: [{
                        text: "确定修改",
                        'class': "btn btn-primary",
                        click: function() {
                            var idValue = $.trim($(".change-id-dialog").find(".id-value").val());
                            var errorMsg = "";
                            if (idValue == "") {
                                errorMsg = "ID不能为空";
                            } else if (!lazyFormBuilder.ui.widget.isValidateID(idValue)) {
                                errorMsg = "ID不符合规则,必须是DATA_数字的形式";
                            } else if (lazyFormBuilder.ui.widget.IDIsRepeat(idValue) && $widget.attr("id") != idValue) {
                                //计算建议ID 不能直接lazyFormBuilder.ui.widget.widgetCount++ 可能手动更改了ID
                                while ($(lazyFormBuilder.editor.document).find('#DATA_' + lazyFormBuilder.ui.widget.widgetCount).length > 0) {
                                    lazyFormBuilder.ui.widget.widgetCount++;
                                }
                                errorMsg = "ID已存在,建议设为DATA_" + lazyFormBuilder.ui.widget.widgetCount;
                            }
                            if (errorMsg != "") {
                                $.pnotify({
                                    text: errorMsg,
                                    type: "error"
                                });
                                return false;
                            }
                            $widget.attr({
                                "id": idValue,
                                "name": idValue
                            });
                            $(".property-dialog-wrap .property-list[property='widgetID'] :text").val(idValue);
                            $(this).dialog("close");
                        }
                    }, {
                        text: "取消",
                        'class': "btn btn-default",
                        click: function() {
                            $(this).dialog("close");
                        }
                    }],
                    open: function() {
                        $(".change-id-dialog").find(".id-value").val($widget.attr("id"));
                    }
                });
            }
        }
    },
    // 初始化
    init: function() {
        //初始化字段列表
        lazyFormBuilder.ui.widget.init();
        // 初始化头部
        lazyFormBuilder.ui.header.init();
        // 初始化工具栏
        lazyFormBuilder.ui.toolbar.init();
        //初始化属性框
        lazyFormBuilder.ui.property.init();
        //初始化快捷属性框
        lazyFormBuilder.ui.shortcutProperty.init();
        $.pnotify.defaults.styling = "bootstrap3";
        $.pnotify.defaults.closer = false;
        $.pnotify.defaults.sticker = false;
        $.pnotify.defaults.history = false;
        $.pnotify.defaults.delay = 2000;
        $.pnotify.defaults.addclass = "stack-topleft";
        $.pnotify.defaults.animate_speed = 'fast';
        $(window).resize(function() {
            lazyFormBuilder.ui.resize();
        });
        lazyFormBuilder.ui.resize();
        $(document).on("click.lazyFormBuilder", function(event) {
            var $target = $(event.target);
            if (!$target.hasClass("global-close") && !$target.parents().hasClass("global-close") && !$target.hasClass("trigger-global") && !$target.parents().hasClass("trigger-global")) {
                $(".global-close").hide();
                $(".trigger-global,.trigger-global *").removeClass("toolbar-hover");
                $(lazyFormBuilder.editor.document).find(":input,img").removeClass("widget-active");
            }
        });
        $(".tip-control").tooltip({
            container: "body"
        });

        $("#add-template").uploadify({
            swf: '/inc/jquery/uploadify/uploadify.swf',
            uploader: "do.php",
            auto: true,
            multi: true,
            queueID: "upload-queue",
            width: 20,
            height: 24,
            runtimes:"html5,flash,html4",
            itemTemplate: function(file) {
                return '<li file-id="' + file.id + '" class="upload-item"><div style="height:17px;"><span class="file-name">' + file.name + '</span><span class="file-progress">0%</span></div>\
                            <div class="progress">\
                                <div class="progress-bar" role="progressbar" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100" style="width: 0%;"></div>\
                            </div>\
                        </li>';
            },
            fileTypeDesc: 'Html文件|文本文件',
            fileTypeExts: '*.html;*.htm;*.txt',
            buttonText: '<i class="fa fa-plus"></i>',
            formData: {
                op: "uploadTemplate"
            },
            onInit: function() {

            },
            onUploadStart: function(file) {
                $(".upload-queue").show();
                // console.log(file);
            },
            onInit: function(uploader) {
                this.parent().children('div:last').css('z-index', 10000).attr("title", "添加新模板").tooltip({
                    container: "body",
                    placement: "left"
                });
                /*$(".template-list-wrap .uploadify").css({
                    position: "absolute"
                });*/
                //this.parent().children('div:last').css('z-index', 10000);
            },
            onUploadSuccess: function(file, data, response) {
                // console.log(file);
                // console.log(data);
                // console.log(response);
            },
            onQueueComplete: function(queueData) {
                setTimeout(function() {
                    $(".upload-queue").animate({
                        opacity: 0
                    }, 1000, function() {
                        $(".upload-queue").hide();
                    });
                }, 1000);
            },
            onUploadProgress: function(file, filePercent, uploadPercent) {
                var $currentItemObj = $("#upload-queue .upload-item[file-id='" + file.id + "']"),
                    progress = filePercent + "%";
                $currentItemObj.find(".progress-bar").css("width", progress);
                $currentItemObj.find(".file-progress").html(progress);
            }
        });
        $("#add-style").uploadify({
            swf: '/inc/jquery/uploadify/uploadify.swf',
            uploader: "do.php",
            auto: true,
            multi: true,
            queueID: "upload-queue",
            width: 20,
            height: 24,
            runtimes:"html5,flash,html4",
            itemTemplate: function(file) {
                return '<li file-id="' + file.id + '" class="upload-item"><div style="height:17px;"><span class="file-name">' + file.name + '</span><span class="file-progress">0%</span></div>\
                            <div class="progress">\
                                <div class="progress-bar" role="progressbar" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100" style="width: 0%;"></div>\
                            </div>\
                        </li>';
            },
            fileTypeDesc: 'Html文件|文本文件',
            fileTypeExts: '*.html;*.htm;*.txt',
            buttonText: '<i class="fa fa-plus"></i>',
            formData: {
                op: "uploadStyle"
            },
            onUploadStart: function(file) {
                $(".upload-queue").show();
            },
            onInit: function(uploader) {
                this.parent().children('div:last').css('z-index', 10000).attr("title", "添加新样式").tooltip({
                    container: "body",
                    placement: "left"
                });
                /*$(".style-list-wrap .uploadify").css({
                    position: "absolute"
                });*/
                //this.parent().children('div:last').css('z-index', 10000);
            },
            onUploadSuccess: function(file, data, response) {
                // console.log(file);
                // console.log(data);
                // console.log(response);
            },
            onQueueComplete: function(queueData) {
                setTimeout(function() {
                    $(".upload-queue").animate({
                        opacity: 0
                    }, 1000, function() {
                        $(".upload-queue").hide();
                    });
                }, 1000);
                lazyFormBuilder.ui.toolbar.getStyleList();
            },
            onUploadProgress: function(file, filePercent, uploadPercent) {
                var $currentItemObj = $("#upload-queue .upload-item[file-id='" + file.id + "']"),
                    progress = filePercent + "%";
                $currentItemObj.find(".progress-bar").css("width", progress);
                $currentItemObj.find(".file-progress").html(progress);
            }
        });
    },
    editor: false,
    ui: {
        resize: function() {
            var windowHeight = $(window).height();
            $(".list-wrap .content-wrap").height(windowHeight - 180).getNiceScroll().resize();
            $(".widget-list-wrap .content-wrap").height(windowHeight - 180).getNiceScroll().resize();
            $("#editor .edui-editor-iframeholder").height(windowHeight - 150);
        },
        header: {
            init: function() {
                var formID = $.trim($("#form-id").val());
                //获取所有版本
                $.ajax({
                    url: "do.php",
                    data: {
                        op: "getVersionList",
                        formID: formID
                    }
                }).done(function(result) {
                    if (result) {
                        var parsedData = $.parseJSON(result);
                        var versionListHtml = ['<option value="0">当前版本</option>'];
                        for (var i = 0; i < parsedData.length; i++) {
                            versionListHtml.push('<option value="' + parsedData[i].ID + '">V' + (parsedData.length - i) + '&nbsp;&nbsp;' + parsedData[i].DATE + '</option>');
                        }
                        $(".lazy-form-builder .header .version-list").html(versionListHtml.join('')).selectpicker({
                            width: "200px"
                        });
                    }
                });
                //切换版本
                $(".lazy-form-builder .header .version-list").change(function() {
                    var versionID = $(this).val();
                    $.ajax({
                        url: "do.php",
                        data: {
                            op: "getVersionForm",
                            versionID: versionID,
                            formID: formID
                        }
                    }).done(function(result) {
                        if (result || result == "") {
                            lazyFormBuilder.editor.setContent(result);
                        } else {
                            var title = versionID == 0 ? "当前版本" : "历史版本";
                            $.pnotify({
                                type: "error",
                                text: "加载" + title + "失败"
                            });
                        }
                        lazyFormBuilder.editor.focus(true);
                    }).fail(function() {
                        $.pnotify({
                            type: "error",
                            text: "加载历史版本失败"
                        });
                    });
                });
            }
        },
        widget: {
            /**
             * 表单控件数量
             * @type {Number}
             */
            widgetCount: 0,
            /**
             * 控件列表 用于编辑器右击菜单
             * @type {Array}
             */
            contextWidget: [],
            /**
             * 初始化控件
             * @return {[type]} [description]
             */
            init: function() {
                //检查是否有电脑签章和手机签章功能
                $.ajax({
                    url: "do.php",
                    data: {
                        op: "hasSignature"
                    }
                }).done(function(result) {
                    if (result) {
                        var parsedData = $.parseJSON(result);
                        var widgetListHtml = ['<ul>'];
                        $.each(lazyFormBuilder.config.widgetCategory, function(index, value) {
                            widgetListHtml.push('<li class="category">' + value.title + '</li>');
                            if (value.items) {
                                widgetListHtml.push('<ul class="sub-list">');
                                $.each(value.items, function(itemIndex, itemValue) {
                                    //电脑签章权限、手机签章权限
                                    if ((itemValue == "HTML_SIGNATURE" && parsedData.hasHtmlSignature) || (itemValue == "PHONE_SIGNATURE" && parsedData.hasPhoneSignature) || (itemValue != "HTML_SIGNATURE" && itemValue != "PHONE_SIGNATURE")) {
                                        var widgetTitle = lazyFormBuilder.widget[itemValue].title;
                                        widgetListHtml.push('<li class="widget-list" type="' + itemValue + '"><img src="/images/form/widget/' + itemValue + '.png"/>' + widgetTitle + '</li>');
                                        lazyFormBuilder.ui.widget.contextWidget.push({
                                            label: widgetTitle,
                                            cmdName: "insertwidget",
                                            className: itemValue,
                                            value: itemValue,
                                            query: function() {
                                                return 0;
                                            }
                                        });
                                    }
                                });
                                widgetListHtml.push('</ul>');
                            }
                        });
                        widgetListHtml.push('</ul>');
                        $(".widget-list-wrap .content-wrap").html(widgetListHtml.join('')).niceScroll();
                    }
                    //初始化编辑器
                    //控件加载之后再加载编辑器
                    //为了右击菜单 控件列表能展示
                    lazyFormBuilder.ui.editor.init();
                });
                $(".widget-list-wrap").on({
                    click: function() {
                        var type = $(this).attr("type");
                        lazyFormBuilder.ui.widget.insertWidget(type);
                    }
                }, ".widget-list");
                //隐藏控件列表
                $(".widget-list-wrap").on({
                    click: function() {
                        $(".widget-list-wrap").hide(100, function() {
                            $(".show-widget-list").show();
                            $(".widget-list-wrap .content-wrap").getNiceScroll().hide();
                        });
                    }
                }, ".hide-widget-list");
                //显示控件列表
                $(".show-widget-list").on({
                    click: function() {
                        $(".widget-list-wrap").show(100, function() {
                            $(".show-widget-list").hide();
                            $(".widget-list-wrap .content-wrap").getNiceScroll().resize().show();
                        });
                    }
                });
                $(".error-list-wrap").on({
                    click: function() {
                        var validateType = $(this).attr("validate-type");
                        $(lazyFormBuilder.editor.document).find(":input,img").removeClass("widget-error");
                        // console.log(validateType);
                        if (validateType) {
                            //按ID分组
                            var groupInfor = {};
                            $.each(lazyFormBuilder.ui.widget.validate[validateType].result, function(index, value) {
                                $(value).addClass("widget-error");
                                //以下的操作 先简单处理，应该从此处分离的
                                if (validateType == "repeatIDWidget") {
                                    var widgetID = $(value).attr("id");
                                    if (!groupInfor[widgetID]) {
                                        groupInfor[widgetID] = []
                                    }
                                    groupInfor[widgetID].push(value);
                                } else if (validateType == "repeatTitleWidget") {
                                    var widgetTitle = $(value).attr("title");
                                    if (!groupInfor[widgetTitle]) {
                                        groupInfor[widgetTitle] = []
                                    }
                                    groupInfor[widgetTitle].push(value);
                                }
                            });
                            //ID重复的控件
                            if (validateType == "repeatIDWidget") {
                                var html = ['<ul class="sub-ul">'];
                                $.each(groupInfor, function(index, value) {
                                    html.push('<li type="id" type-value="' + index + '">\
                                                    <a href="javascript:void(0)">ID为\
                                                        <span style="color:red;">' + index + '</span>\
                                                    的控件,有' + value.length + '处重复</a>\
                                                </li>');
                                });
                                html.push('</ul>');
                                $(this).find(".sub-ul").remove().end().append(html.join(''));
                            } else if (validateType == "repeatTitleWidget") {
                                var html = ['<ul class="sub-ul">'];
                                $.each(groupInfor, function(index, value) {
                                    html.push('<li  type="title" type-value="' + index + '">\
                                                    <a href="javascript:void(0)">控件名称为\
                                                        <span style="color:red;">' + index + '</span>\
                                                    的控件,有' + value.length + '处重复</a>\
                                                </li>');
                                });
                                html.push('</ul>');
                                $(this).find(".sub-ul").remove().end().append(html.join(''));
                            } else if (validateType == "emptyIDWidget" || validateType == "errorIDWidget") {
                                //  console.log($(this).find(".btn").length );
                                if ($(this).find(".btn").length == 0) {
                                    $(this).append('<input type="button" validate-type="' + validateType + '" value="自动修复" class="btn btn-primary">');
                                }
                            }
                        }
                        return false;
                    }
                }, ".list");
                //重复列表
                $(".error-list-wrap").on({
                    click: function() {
                        $(lazyFormBuilder.editor.document).find(":input,img").removeClass("widget-error");
                        var type = $(this).attr("type"),
                            typeValue = $(this).attr("type-value");
                        $(lazyFormBuilder.editor.document).find("[" + type + "='" + typeValue + "']").addClass("widget-error");
                        return false;
                    }
                }, ".sub-ul li");
                //修复按钮
                $(".error-list-wrap").on({
                    click: function() {
                        var $this = $(this),
                            $parentObj = $this.parents("li.list"),
                            $faObj = $parentObj.find(".fa"),
                            $cloneObj = $faObj.clone(),
                            validateType = $this.attr("validate-type");
                        $parentObj.prepend($cloneObj);
                        //修复问题
                        $.each(lazyFormBuilder.ui.widget.validate[validateType].result, function(index, value) {
                            $(value).removeClass("widget-error");
                            lazyFormBuilder.ui.widget.validate[validateType].repair.call(value);
                        });
                        $cloneObj.css("position", "absolute").animate({
                            top: "-=50",
                            opacity: 0
                        }, function() {
                            $cloneObj.remove();
                            $faObj.replaceWith('<i class="fa fa-check-circle"/>');
                            $.pnotify({
                                text: "修复成功",
                                type: "success"
                            });
                            $this.remove();
                        })
                        return false;
                    }
                }, "li.list .btn");
            },
            /**
             * 判断是否是表单控件
             * @param  {[type]}  html [description]
             * @return {Boolean}      [description]
             */
            isWidget: function(html) {
                var $widgetObj = $.type(html) === "object" ? html : $(html);
                if ($widgetObj.is(":input") || ($widgetObj.is("img") && ($widgetObj.hasClass("detailChar") || $widgetObj.hasClass("DATE") || $widgetObj.hasClass("time")))) {
                    return true;
                } else {
                    return false;
                }
            },
            /**
             * 获取所有的单行文本框控件
             * @return {[type]} [description]
             */
            getAllTextWidgets: function() {
                var widgetList = [];
                $(lazyFormBuilder.editor.document).find(":text").each(function() {
                    if (!$(this).attr("class") || $(this).attr("class") == 'AUTO') {
                        widgetList.push($(this).attr("title"));
                    }
                });
                return widgetList;
            },
            /**
             * 获取所有的控件
             * @param  {[type]} cancelWidget [不获取的控件title]
             * @return {[type]}              [description]
             */
            getAllWidgets: function(cancelWidget) {
                var widgetList = [];
                $(lazyFormBuilder.editor.document).find(":input,img").each(function() {
                    var widgetTitle = $.trim($(this).attr("title"));
                    if (widgetTitle != $.trim(cancelWidget)) {
                        widgetList.push(widgetTitle);
                    }
                });
                return widgetList;
            },
            /**
             * 获取所有的有日期控件关联的文本框
             * @return {[type]} [description]
             */
            getAllDateWidgets: function() {
                var widgetList = [];
                $(lazyFormBuilder.editor.document).find("img").each(function() {
                    if ($(this).hasClass("DATE")) {
                        //日期控件关联的文本框控件
                        var associatedWidgetTitle = $(this).attr("value");
                        var $associatedWidget = $(lazyFormBuilder.editor.document).find(":text[title='" + associatedWidgetTitle + "']");
                        if ($associatedWidget.length > 0) {
                            widgetList.push(associatedWidgetTitle);
                        }
                    }
                });
                return widgetList;
            },
            /**
             * 获取所有的有日期控件关联的文本框
             * @return {[type]} [description]
             */
            getAllTimeWidgets: function() {
                var widgetList = [];
                $(lazyFormBuilder.editor.document).find("img").each(function() {
                    if ($(this).hasClass("time")) {
                        //日期控件关联的文本框控件
                        var associatedWidgetTitle = $(this).attr("value");
                        var $associatedWidget = $(lazyFormBuilder.editor.document).find(":text[title='" + associatedWidgetTitle + "']");
                        if ($associatedWidget.length > 0) {
                            widgetList.push(associatedWidgetTitle);
                        }
                    }
                });
                return widgetList;
            },
            /**
             * 插入控件
             * @param  {[type]} type [description]
             * @return {[type]}      [description]
             */
            insertWidget: function(type) {
                lazyFormBuilder.ui.widget.widgetCount++;
                var widgetCount = lazyFormBuilder.ui.widget.widgetCount;
                var thisWidget = lazyFormBuilder.widget[type];
                var widgetHtml = "";
                if ($.type(thisWidget.view) === "function") {
                    widgetHtml = thisWidget.view.call(this);
                } else {
                    widgetHtml = thisWidget.view;
                }
                var $widgetObj = $(widgetHtml);
                var attrs = [];
                //除了日期和时间控件,其他的控件需要生成ID name title
                if (type != "DATE" && type != "time") {
                    $widgetObj.attr({
                        "id": "DATA_" + widgetCount,
                        "name": "DATA_" + widgetCount,
                        "title": thisWidget.title + "_" + widgetCount
                    });
                }
                var widgetStr = "";
                for (var i = 0; i < $widgetObj.length; i++) {
                    widgetStr += $widgetObj.get(i).outerHTML;
                }
                //如果图片被选中时，直接插入控件会覆盖此图片
                //移动选取到图片后面
                var range = lazyFormBuilder.editor.selection.getRange();
                range.setCursor(true);
                lazyFormBuilder.editor.execCommand("insertHtml", widgetStr);
                //此处有问题 无法选中图片
                $(lazyFormBuilder.editor.document).find("#DATA_" + widgetCount).trigger('click');
            },
            getWidgetType: function() {
                var $this = $(this),
                    //选中的控件 默认加上了widget-active class
                    className = $this.attr("class") ? $this.attr("class").replace("widget-active", "") : "";
                if (className) {
                    //处理多个class的情况，代表控件的类型的class必须放在第一个
                    var classNameSplit = className.split(" ");
                    if (classNameSplit.length > 1) {
                        className = $.trim(classNameSplit[0]);
                    }
                } else {
                    if ($this.is(":text")) {
                        className = "text";
                    } else if ($this.is("textarea")) {
                        className = "textarea";
                    } else if ($this.is("select")) {
                        className = "select";
                    } else if ($this.is(":checkbox")) {
                        className = "checkbox";
                    }
                }
                //兼容旧的文本框的千位分隔符
                if (className == "thousandformat") {
                    className = "text";
                }
                return className;
            },
            /**
             * 验证控件ID是否符合规则  DATA_数字
             * @param  {[type]} widgetID [description]
             * @return {[type]}          [description]
             */
            isValidateID: function(widgetID) {
                return /DATA_\d+$/.test(widgetID);
            },
            /**
             * 验证ID是否重复
             * @param {[type]} widgetID [description]
             */
            IDIsRepeat: function(widgetID) {
                return $(lazyFormBuilder.editor.document).find("#" + widgetID).length > 0;
            },
            validate: {
                //控件名称为空的控件
                emptyTitleWidget: {
                    title: "检测控件名称为空的控件",
                    check: function() {
                        var widgetTitle = $.trim($(this).attr("title"));
                        return widgetTitle != "";
                    },
                    result: []
                },
                //控件名称重复的控件
                repeatTitleWidget: {
                    title: "检测控件名称重复的控件",
                    check: function() {
                        var widgetTitle = $.trim($(this).attr("title"));
                        if (widgetTitle != "") {
                            //如果此ID除了本身之外还有,则说明是重复的.
                            return $(lazyFormBuilder.editor.document).find("[title='" + widgetTitle + "']").length == 1;
                        }
                        return true;
                    },
                    result: []
                },
                //关联的文本框不存在的日期、时间控件
                dateTimeNoTextWidget: {
                    title: "检测日期时间控件关联文本框是否存在",
                    check: function() {
                        if ($(this).hasClass("DATE") || $(this).hasClass("time")) {
                            var relateText = $(this).attr("value");
                            return $(lazyFormBuilder.editor.document).find(":text[title='" + relateText + "']").length != 0;
                        }
                        return true;
                    },
                    result: []
                },
                //获取控件的值来源控件不存在的控件
                getValueNoDataSouceWidget: {
                    title: "检测获值控件的值来源控件是否存在",
                    check: function() {
                        if ($(this).hasClass("getvalue")) {
                            var dataSourceID = $(this).attr("datasourceid");
                            return $(lazyFormBuilder.editor.document).find("[title='" + dataSourceID + "']").length != 0;
                        }
                        return true;
                    },
                    result: []
                },
                //日期时间计算控件不存在的控件
                getCompareNoTextWidget: {
                    title: "检测参与时间计算的控件是否存在",
                    check: function() {
                        if ($(this).hasClass("datecompute")) {
                            var startDate = $(this).attr("startdate"),
                                endDate = $(this).attr("enddate"),
                                starttime = $(this).attr("starttime") ? $(this).attr("starttime") : "",
                                endtime = $(this).attr("endtime") ? $(this).attr("endtime") : "",
                                $documentObj = $(lazyFormBuilder.editor.document);
                            if (startDate == "" || (startDate != "" && $documentObj.find(":text[title='" + startDate + "']").length == 0) || endDate == "" || (endDate != "" && $documentObj.find(":text[title='" + endDate + "']").length == 0) || (starttime != "" && $documentObj.find(":text[title='" + starttime + "']").length == 0) || (endtime != "" && $documentObj.find(":text[title='" + endtime + "']").length == 0)) {
                                return false;
                            } else {
                                return true;
                            }
                        }
                        return true;
                    },
                    result: []
                },
                //明细字段没有设置明细项
                detailCharNameWidget: {
                    title: "明细字段至少需要一个明细项",
                    check: function() {
                        if ($(this).hasClass("detailChar")) {
                            var detailCharName = $(this).attr("detailcharname");
                            return detailCharName && detailCharName != "";
                        }
                        return true;
                    },
                    result: []
                },
                //动态联动控件上级关联控件不存在的控件
                dynamicNoTextWidget: {
                    title: "检测动态联动控件的上级控件是否存在",
                    check: function() {
                        if ($(this).hasClass("dynamic")) {
                            //上级关联控件不存在的控件
                            var parentWidget = $(this).attr("relparent") ? $(this).attr("relparent") : "";
                            //上级控件不是必填项
                            return (parentWidget == "") || (parentWidget != "" && $(lazyFormBuilder.editor.document).find("[title='" + parentWidget + "']").length > 0);
                        }
                        return true;
                    },
                    result: []
                },
                //数据源为空在的控件
                dataSourceEmptyWidget: {
                    title: "检测动态数据源是否为空",
                    check: function() {
                        //动态联动控件和动态信息控件
                        if ($(this).hasClass("dynamic") || $(this).hasClass("dynamic_info")) {
                            //数据源地址
                            var dataSource = $(this).attr("datasource") ? $(this).attr("datasource") : "";
                            return dataSource != "";
                        }
                        return true;
                    },
                    result: []
                },
                //ID为空的控件
                emptyIDWidget: {
                    title: "检测ID为空的控件",
                    check: function() {
                        var widgetID = $.trim($(this).attr("id"));
                        //日期、时间控件 没有ID
                        return widgetID != "" || $(this).hasClass("DATE") || $(this).hasClass("time");
                    },
                    repair: function() {
                        lazyFormBuilder.ui.widget.widgetCount++;
                        $(this).attr({
                            "id": "DATA_" + lazyFormBuilder.ui.widget.widgetCount,
                            "name": "DATA_" + lazyFormBuilder.ui.widget.widgetCount
                        });
                    },
                    result: []
                },
                //ID重复的控件
                repeatIDWidget: {
                    title: "检测ID重复的控件",
                    check: function() {
                        var widgetID = $.trim($(this).attr("id"));
                        if (widgetID != "") {
                            //如果此ID除了本身之外还有,则说明是重复的.
                            //此处检测ID不能写"#" + widgetID jQuery默认ID是唯一的
                            return $(lazyFormBuilder.editor.document).find("[id='" + widgetID + "']").length == 1;
                        }
                        return true;
                    },
                    result: []
                },
                //ID不符合规则的控件
                errorIDWidget: {
                    title: "检测ID不符合规范的控件",
                    check: function() {
                        var widgetID = $.trim($(this).attr("id"));
                        if (widgetID != "") {
                            return lazyFormBuilder.ui.widget.isValidateID(widgetID);
                        }
                        return true;
                    },
                    repair: function() {
                        lazyFormBuilder.ui.widget.widgetCount++;
                        $(this).attr({
                            "id": "DATA_" + lazyFormBuilder.ui.widget.widgetCount,
                            "name": "DATA_" + lazyFormBuilder.ui.widget.widgetCount
                        });
                    },
                    result: []
                }
            },
            validateWidget: function(from) {
                //重置检查结果
                $.each(lazyFormBuilder.ui.widget.validate, function(index, value) {
                    value.result = [];
                });
                $(lazyFormBuilder.editor.document).find(":input,img").each(function() {
                    var $this = $(this);
                    $this.removeClass("widget-active widget-error");
                    if (lazyFormBuilder.ui.widget.isWidget($this)) {
                        $.each(lazyFormBuilder.ui.widget.validate, function(index, value) {
                            if (!value.check.call($this)) {
                                value.result.push($this);
                            }
                        });
                    }
                });
                var $errorListObj = $(".error-list-wrap .content-wrap");
                var hasError = false;
                $errorListObj.html('');
                $.each(lazyFormBuilder.ui.widget.validate, function(index, value) {
                    if (value.result.length > 0) {
                        $errorListObj.append('<li class="list clear has-error" validate-type="' + index + '"><i class="fa fa-info-circle"></i><span title="有' + value.result.length + "处错误" + '">' + value.title + '</span></li>');
                        hasError = true;
                    } else {
                        $errorListObj.append('<li class="list clear"><i class="fa fa-check-circle"></i><span>' + value.title + '</span></li>');
                    }
                });
                //保存的时候，检查表单，如果表单没有错误，则不显示检查列表
                if (hasError || from != "save") {
                    $(".error-list-wrap li.has-error span").tooltip({
                        container: "body"
                    });
                    $(".error-list-wrap").show(150, function() {
                        $(".error-list-wrap .content-wrap").getNiceScroll().show().resize();
                    });
                }
                return hasError;
            }
        },
        toolbar: {
            init: function() {
                $(".lazy-form-builder .toolbar-container .toolbar-name-container,.lazy-form-builder .toolbar-container .toolbar-arrow").on({
                    mouseenter: function(event) {
                        var $toolbarItem = $(this).parents(".toolbar-item");
                        if ($toolbarItem.hasClass("disabled")) {
                            return false;
                        }
                        if ($toolbarItem.attr("toolbar") == "layout") {
                            $toolbarItem.addClass("toolbar-hover");
                        } else {
                            $(this).addClass("toolbar-hover");
                        }
                        var toolbar = $toolbarItem.attr("toolbar");
                    },
                    mouseleave: function(event) {
                        var $toolbarItem = $(this).parents(".toolbar-item");
                        if ($toolbarItem.hasClass("disabled")) {
                            $(this).removeClass("toolbar-hover");
                            return false;
                        }
                        if (!$(this).data("holdHover")) {
                            if ($toolbarItem.attr("toolbar") == "layout") {
                                $toolbarItem.removeClass("toolbar-hover");
                            } else {
                                $(this).removeClass("toolbar-hover");
                            }
                        }
                    },
                    click: function() {
                        var $toolbarItem = $(this).parents(".toolbar-item");
                        if ($toolbarItem.hasClass("disabled")) {
                            return false;
                        }
                        var toolbar = $toolbarItem.attr("toolbar");
                        var command = $toolbarItem.attr("command");
                        var left = $toolbarItem.offset().left,
                            top = $toolbarItem.offset().top + $toolbarItem.height() + 1;
                        if (toolbar) {
                            switch (toolbar) {
                                //表格
                                case 'table':
                                    $(".insert-table-wrap").show().css({
                                        left: left,
                                        top: top
                                    });
                                    $(this).data("holdHover", true);
                                    break;
                                    //图片
                                case 'image':
                                    if (UE.ui['insertimage']) {
                                        new UE.ui['insertimage'](lazyFormBuilder.editor);
                                    }
                                    lazyFormBuilder.editor.getDialog('insertimage').open();
                                    break;
                                    //涂鸦
                                case 'scrawl':
                                    if (UE.ui['scrawl']) {
                                        new UE.ui['scrawl'](lazyFormBuilder.editor);
                                    }
                                    lazyFormBuilder.editor.getDialog('scrawl').open();
                                    break;
                                    //分隔线
                                case 'line':
                                    lazyFormBuilder.editor.execCommand("insertHtml", "<hr style='height:5px;margin:5px 0;border:none;border-top:1px solid #000;'/>");
                                    //
                                    //lazyFormBuilder.editor.execCommand("insertHtml", "<div class='hr' style='border-bottom:1px solid #000;height:10px;'>&nbsp;</div>");
                                    break;
                                    //布局
                                case 'layout':
                                    $(".layout-mode-wrap").show().css({
                                        left: left,
                                        top: top
                                    });
                                    break;
                                    //模板
                                case 'template':
                                    $(".list-wrap").hide();
                                    $(".template-list-wrap").show(150, function() {
                                        $(".template-list-wrap .content-wrap").getNiceScroll().show().resize();
                                        $("#add-template").uploadify("refresh");
                                    });
                                    break;
                                    //样式
                                case 'style':
                                    $(".list-wrap").hide();
                                    $(".style-list-wrap").show(150, function() {
                                        $(".style-list-wrap .content-wrap").getNiceScroll().show().resize();
                                        $("#add-style").uploadify("refresh");
                                    });
                                    break;
                                    //保存
                                case 'save':
                                    if ($(this).hasClass("toolbar-name-container")) {
                                        lazyFormBuilder.data.save();
                                    } else {
                                        $(".save-dialog-wrap").show().css({
                                            left: left,
                                            top: top
                                        });
                                    }
                                    break;
                                    //预览
                                case 'preview':
                                    window.open("/general/system/workflow/flow_form/cool_form/preview.php?FORM_ID=" + $("#form-id").val(), "_blank", "");
                                    break;
                                    //检查
                                case 'validate':
                                    $(".list-wrap").hide();
                                    lazyFormBuilder.ui.widget.validateWidget();
                                    break;
                                    //导出
                                case 'export':
                                    window.location = "/general/system/workflow/flow_form/export.php?FORM_ID=" + $("#form-id").val();
                                    break;
                            }
                        } else if (command) {
                            //切换为源代码模式的时候 自动隐藏控件列表
                            if (command == "source") {
                                var sourceCommandState = lazyFormBuilder.editor.queryCommandState("source");
                                $(".shortcut-property").hide();
                                if (sourceCommandState == 0) {
                                    $(".lazy-form-builder .toolbar-container .toolbar-item[command!='source']").addClass("disabled");
                                    $(".lazy-form-builder .toolbar-container .toolbar-item[command='source'] .toolbar-name-container").data("holdHover", true);
                                    if ($(".widget-list-wrap").css("display") != "none") {
                                        $(".widget-list-wrap .hide-widget-list").trigger('click');
                                        $(".widget-list-wrap").data("autoHide", true);
                                    }
                                } else {
                                    $(".lazy-form-builder .toolbar-container .toolbar-item[command='source'] .toolbar-name-container").removeData("holdHover");
                                    $(".lazy-form-builder .toolbar-container .toolbar-item").removeClass("disabled");
                                    if ($(".widget-list-wrap").data("autoHide")) {
                                        $(".show-widget-list").trigger('click');
                                        $(".widget-list-wrap").removeData("autoHide");
                                    }
                                }
                            }
                            lazyFormBuilder.editor.execCommand(command);
                        }
                    }
                });
                //插入表格
                $(".insert-table-wrap .unhighlight-wrap").mousemove(function(event) {
                    var width = event.pageX - $(this).offset().left;
                    var height = event.pageY - $(this).offset().top;
                    var column = Math.floor(width / 22) + 1;
                    width = Math.min(220, column * 22);
                    var row = Math.floor(height / 22) + 1;
                    height = Math.min(220, row * 22);
                    $(".insert-table-wrap .title").html(row + "行x" + column + "列");
                    $(".insert-table-wrap .highlight-wrap").css("visibility", "").width(width).height(height);
                    $(this).data({
                        row: row,
                        column: column
                    });
                }).mouseleave(function() {
                    $(".insert-table-wrap .highlight-wrap").css("visibility", "hidden");
                    $(".insert-table-wrap .title").html("0行x0列");
                }).click(function() {
                    lazyFormBuilder.editor.execCommand('insertTable', {
                        numRows: $(this).data("row"),
                        numCols: $(this).data("column")
                    });
                    $(".insert-table-wrap").hide();
                });
                //插入分隔线
                $(".line-list-wrap tr").click(function() {
                    lazyFormBuilder.editor.execCommand("insertHtml", $(this).find("td").html());
                });
                $(".line-property-dialog-wrap").dialog({
                    resizable: false,
                    modal: true,
                    autoOpen: false,
                    width: 400,
                    height: 300,
                    buttons: [{
                        text: "确定",
                        'class': "btn btn-primary",
                        click: function() {
                            $(this).dialog("close");
                            var target = $(".line-property-dialog-wrap").data("currentObj");
                            $(target).css("border-top-width", $(".line-property-dialog-wrap .hr-height").val() + "px");
                            $(target).css("border-top-color", $(".line-property-dialog-wrap .hr-color").val());
                            $(target).css("border-top-style", $(".line-property-dialog-wrap .hr-style").val());
                        }
                    }, {
                        text: "取消",
                        'class': "btn btn-default",
                        click: function() {
                            $(this).dialog("close");
                        }
                    }],
                    open: function() {
                        var target = $(".line-property-dialog-wrap").data("currentObj");
                        $(".line-property-dialog-wrap .hr-height").val(parseInt($(target).css("border-top-width")));
                        $(".line-property-dialog-wrap .hr-color").val(lazyFormBuilder.util.RGBToHex($(target).css("border-top-color")));
                        var style = $(target).css("border-top-style"),
                            styleValue = "solid";
                        if (style.indexOf("dashed") != -1) {
                            styleValue = "dashed";
                        } else if (style.indexOf("double") != -1) {
                            styleValue = "double";
                        }
                        $(".line-property-dialog-wrap .hr-style").val(styleValue).selectpicker("refresh");
                    }
                });
                $(".line-property-dialog-wrap .hr-style").selectpicker();
                $(".line-property-dialog-wrap .hr-color").colorpicker(lazyFormBuilder.config.colorPickerSetting);
                //版式
                $(".layout-mode-wrap li").click(function() {
                    $(".layout-mode-wrap li").removeClass("current");
                    $(this).addClass("current");
                    var mode = $(this).attr("mode");
                    if (mode == "full") {
                        $("#" + lazyFormBuilder.config.editorID).removeClass("widget-list-show");
                    } else {
                        $("#" + lazyFormBuilder.config.editorID).addClass("widget-list-show");
                    }
                    $(".layout-mode-wrap").hide();
                });
                //模板
                //初始化模板 后续可以放到第一打开模板的时候初始化
                lazyFormBuilder.ui.toolbar.getTemplateList();
                $(".template-list-wrap .cloud").click(function() {
                    $(".cloud-template-list-wrap").show(100, function() {
                        $(".cloud-template-list-wrap .loading").show();
                        $(".cloud-template-list-wrap iframe").attr("src", lazyFormBuilder.config.templateColudUrl).load(function() {
                            $(".cloud-template-list-wrap .loading").hide();
                        });
                    });
                });
                $(".style-list-wrap .cloud").click(function() {
                    $(".cloud-style-list-wrap").show(100, function() {
                        $(".cloud-style-list-wrap .loading").show();
                        $(".cloud-style-list-wrap iframe").attr("src", lazyFormBuilder.config.styleColudUrl).load(function() {
                            $(".cloud-style-list-wrap .loading").hide();
                        });
                    });
                });
                $(".list-wrap .content-wrap").niceScroll();
                $(".list-wrap .close-list-wrap").click(function() {
                    var $wrapObj = $(this).parents(".list-wrap");
                    $wrapObj.hide(100);
                    $wrapObj.find(".content-wrap").getNiceScroll().hide();
                });
                $(".list-wrap").on({
                    mouseenter: function() {
                        $(this).find(".title").slideDown(200);
                        $(this).find("a.remove").show();
                    },
                    mouseleave: function() {
                        $(this).find(".title").slideUp(200);
                        $(this).find("a.remove").hide();
                    }
                }, ".list");
                $(".template-list-wrap").on({
                    mouseenter: function() {
                        var formID = $(this).attr("form-id");
                        $("body").data("template-content", lazyFormBuilder.editor.getContent());
                        $.ajax({
                            url: "do.php",
                            data: {
                                op: "getTemplateContent",
                                formID: formID
                            }
                        }).done(function(result) {
                            if (result) {
                                lazyFormBuilder.editor.setContent(result);
                                $("body").data("temp-content", result);
                            }
                        });
                    },
                    mouseleave: function() {
                        if (!$(this).data("is-confirm")) {
                            lazyFormBuilder.editor.setContent($("body").data("template-content"));
                        }
                    },
                    click: function(event) {
                        $(this).data("is-confirm", true);
                        bootbox.confirm("确定使用此模板,现有的表单内容将会被覆盖?", function(result) {
                            if (result) {
                                lazyFormBuilder.editor.setContent($("body").data("temp-content"));
                            } else {
                                lazyFormBuilder.editor.setContent($("body").data("template-content"));
                            }
                            $("body").removeData("template-content temp-content is-confirm");
                        });
                    }
                }, ".list");
                //样式
                lazyFormBuilder.ui.toolbar.getStyleList();
                //移除样式
                $(".style-list-wrap").on({
                    click: function() {
                        var $styleObj = $(this).parents(".list");
                        var styleID = $styleObj.attr("data-style-id");
                        bootbox.confirm("确定移除此样式?", function(result) {
                            if (result) {
                                $.ajax({
                                    url: "do.php",
                                    data: {
                                        op: "deleteStyle",
                                        styleID: styleID
                                    }
                                }).done(function(result) {
                                    if (result) {
                                        $styleObj.remove();
                                        $.pnotify({
                                            type: "success",
                                            text: "操作成功"
                                        })
                                    } else {
                                        $.pnotify('操作失败,请重试!');
                                    }
                                })
                            }
                        });
                        return false;
                    }
                }, "a.remove");
                //保存到我的模板
                $(".save-to-template").click(function() {
                    alert(1);
                });
                $(".style-list-wrap").on({
                    mouseenter: function() {
                        var styleID = $(this).attr("data-style-id");
                        $("body").data("form-content", lazyFormBuilder.editor.getContent());
                        $.ajax({
                            url: "do.php",
                            data: {
                                op: "getStyleList",
                                styleID: styleID
                            }
                        }).done(function(result) {
                            if (result) {
                                var parsedData = $.parseJSON(result);
                                if (parsedData.length > 0) {
                                    var oldContent = lazyFormBuilder.editor.getContent();
                                    //去除style标签
                                    oldContent = oldContent.replace(/<style[^>]*?>[\s\S]*?<\/style>/, "");
                                    var newFormContent = oldContent + "<style>" + parsedData[0]["STYLE_CONTENT"] + "</style>";
                                    lazyFormBuilder.editor.setContent(newFormContent);
                                    $("body").data("temp-content", newFormContent);
                                }
                            }
                        });
                    },
                    mouseleave: function() {
                        if (!$(this).data("is-confirm")) {
                            lazyFormBuilder.editor.setContent($("body").data("form-content"));
                        }
                    },
                    click: function(event) {
                        $(this).data("is-confirm", true);
                        bootbox.confirm("确定使用此样式?", function(result) {
                            if (result) {
                                lazyFormBuilder.editor.setContent($("body").data("temp-content"));
                            } else {
                                lazyFormBuilder.editor.setContent($("body").data("form-content"));
                            }
                            $("body").removeData("form-content temp-style is-confirm");
                        });
                    }
                }, ".list");
                // $(".style-list-wrap").on({
                //     click: function(event) {
                //         var $target = $(event.target),
                //             styleName = $(this).find(".title").text();
                //         if ($target.hasClass("preview")) {
                //             $("body").data("template-content", lazyFormBuilder.editor.getContent());
                //             $.ajax({
                //                 url: "do.php",
                //                 data: {
                //                     op: "getStyleContent",
                //                     styleName: styleName
                //                 }
                //             }).done(function(result) {
                //                 if (result) {
                //                     lazyFormBuilder.editor.setContent(lazyFormBuilder.editor.getContent() + "<style>" + result + "</style>");
                //                 }
                //             });
                //         } else if ($target.hasClass("confirm")) {
                //             $.ajax({
                //                 url: "do.php",
                //                 data: {
                //                     op: "getStyleContent",
                //                     styleName: styleName
                //                 }
                //             }).done(function(result) {
                //                 if (result) {
                //                     lazyFormBuilder.editor.setContent(lazyFormBuilder.editor.getContent() + "<style>" + result + "</style>");
                //                     $("body").removeData("template-content");
                //                 }
                //             })
                //         }
                //     }
                // }, ".list");
            },
            getTemplateList: function() {
                $.ajax({
                    url: "do.php",
                    data: {
                        op: "getTemplateList"
                    }
                }).done(function(result) {
                    if (result) {
                        var parsedData = $.parseJSON(result);
                        var templateListHtml = [];
                        $.each(parsedData, function(index, value) {
                            templateListHtml.push('<div class="list" form-id="' + value.FORM_ID + '">\
                                                        <img src="' + value.imgSrc + '">\
                                                        <div class="title">' + value.FORM_NAME + '</div>\
                                                    </div>');
                        });
                        $(".template-list-wrap .content-wrap").html(templateListHtml.join(''));
                    }
                });
            },
            getStyleList: function() {
                $.ajax({
                    url: "do.php",
                    data: {
                        op: "getStyleList"
                    }
                }).done(function(result) {
                    if (result) {
                        var parsedData = $.parseJSON(result);
                        var styleListHtml = [];
                        $.each(parsedData, function(index, value) {
                            styleListHtml.push('<div class="list" data-style-id="' + value.STYLE_ID + '">\
                                                        <a href="#" title="移除样式" class="remove"><i class="fa fa-times"></i></a>\
                                                        <img src="' + value.imgSrc + '">\
                                                        <div class="title">' + value.STYLE_TITLE + '</div>\
                                                    </div>');
                        });
                        $(".style-list-wrap .content-wrap").html(styleListHtml.join(''));
                    }
                });
            }
        },
        editor: {
            init: function() {
                lazyFormBuilder.editor = UE.getEditor(lazyFormBuilder.config.editorID, {
                    toolbars: [
                        []
                    ],
                    theme: "formbuilder",
                    wordCount: false,
                    enableAutoSave: false,
                    imageScaleEnabled: false,
                    disabledTableInTable: false,
                    removeFormatAttributes: '',
                    autoClearEmptyNode: false,
                    allowDivTransToP: false,
                    elementPathEnabled: false,
                    autoHeightEnabled: false,
                    initialFrameWidth: "100%",
                    initialFrameHeight: $(window).height() - 150,
                    shortcutMenu: ["fontfamily", "fontsize", "bold", "italic", "forecolor", "backcolor", "JustifyLeft", "JustifyCenter", "JustifyRight", "JustifyJustify"],
                    contextMenu: [{
                        group: "表格",
                        icon: "table",
                        subMenu: [{
                            label: "插入表格",
                            cmdName: 'inserttable'
                        }, {
                            label: "删除表格",
                            cmdName: 'deletetable'
                        }, '-', {
                            label: "删除当前行",
                            cmdName: 'deleterow'
                        }, {
                            label: "删除当前列",
                            cmdName: 'deletecol'
                        }, {
                            label: "左插入列",
                            cmdName: 'insertcol'
                        }, {
                            label: "右插入列",
                            cmdName: 'insertcolnext'
                        }, {
                            label: "前插入行",
                            cmdName: 'insertrow'
                        }, {
                            label: "后插入行",
                            cmdName: 'insertrownext'
                        }, '-', {
                            label: "插入表格名称",
                            cmdName: 'insertcaption'
                        }, {
                            label: "删除表格名称",
                            cmdName: 'deletecaption'
                        }, {
                            label: "插入表格标题行",
                            cmdName: 'inserttitle'
                        }, {
                            label: "删除表格标题行",
                            cmdName: 'deletetitle'
                        }, '-', {
                            label: "合并单元格",
                            cmdName: 'mergecells'
                        }, {
                            label: "向右合并",
                            cmdName: 'mergeright'
                        }, {
                            label: "向下合并",
                            cmdName: 'mergedown'
                        }, '-', {
                            label: "拆分成行",
                            cmdName: 'splittorows'
                        }, {
                            label: "拆分成列",
                            cmdName: 'splittocols'
                        }, {
                            label: "完全拆分单元格",
                            cmdName: 'splittocells'
                        }, '-', {
                            label: "平均分布各行",
                            cmdName: 'averagedistributerow'
                        }, {
                            label: "平均分布各列",
                            cmdName: 'averagedistributecol'
                        }, '-', {
                            label: "表格属性",
                            cmdName: 'edittable',
                            exec: function() {
                                if (UE.ui['edittable']) {
                                    new UE.ui['edittable'](this);
                                }
                                this.getDialog('edittable').open();
                            }
                        }, {
                            label: "设置表格边线可见",
                            cmdName: 'setbordervisible'
                        }]
                    }, {
                        group: "边框底纹",
                        icon: 'borderBack',
                        subMenu: [{
                            label: "表格隔行变色",
                            cmdName: "interlacetable"
                        }, {
                            label: "取消表格隔行变色",
                            cmdName: "uninterlacetable"
                        }, {
                            label: "选区背景隔行",
                            cmdName: "settablebackground"
                        }, {
                            label: "取消选区背景",
                            cmdName: "cleartablebackground"
                        }, {
                            label: "红蓝相间",
                            cmdName: "settablebackground"
                        }, {
                            label: "三色渐变",
                            cmdName: "settablebackground"
                        }, '-', {
                            label: "单元格背景",
                            cmdName: 'edittd',
                            exec: function() {
                                if (UE.ui['edittd']) {
                                    new UE.ui['edittd'](this);
                                }
                                this.getDialog('edittd').open();
                            }
                        }]
                    }, {
                        group: "单元格对齐方式",
                        icon: 'aligntd',
                        subMenu: [{
                            cmdName: 'cellalignment',
                            value: {
                                align: 'left',
                                vAlign: 'top'
                            }
                        }, {
                            cmdName: 'cellalignment',
                            value: {
                                align: 'center',
                                vAlign: 'top'
                            }
                        }, {
                            cmdName: 'cellalignment',
                            value: {
                                align: 'right',
                                vAlign: 'top'
                            }
                        }, {
                            cmdName: 'cellalignment',
                            value: {
                                align: 'left',
                                vAlign: 'middle'
                            }
                        }, {
                            cmdName: 'cellalignment',
                            value: {
                                align: 'center',
                                vAlign: 'middle'
                            }
                        }, {
                            cmdName: 'cellalignment',
                            value: {
                                align: 'right',
                                vAlign: 'middle'
                            }
                        }, {
                            cmdName: 'cellalignment',
                            value: {
                                align: 'left',
                                vAlign: 'bottom'
                            }
                        }, {
                            cmdName: 'cellalignment',
                            value: {
                                align: 'center',
                                vAlign: 'bottom'
                            }
                        }, {
                            cmdName: 'cellalignment',
                            value: {
                                align: 'right',
                                vAlign: 'bottom'
                            }
                        }]
                    }, {
                        group: "表格对齐方式",
                        icon: 'aligntable',
                        subMenu: [{
                            cmdName: 'tablealignment',
                            className: 'left',
                            label: "左浮动",
                            value: "left"
                        }, {
                            cmdName: 'tablealignment',
                            className: 'center',
                            label: "居中显示",
                            value: "center"
                        }, {
                            cmdName: 'tablealignment',
                            className: 'right',
                            label: "右浮动",
                            value: "right"
                        }]
                    }, {
                        group: "插入控件",
                        icon: "widget",
                        subMenu: lazyFormBuilder.ui.widget.contextWidget
                    }]
                });
                //注册插入控件命令
                UE.commands["insertwidget"] = {
                    execCommand: function(cmd, value) {
                        lazyFormBuilder.ui.widget.insertWidget(value);
                    }
                };
                lazyFormBuilder.editor.ready(function() {
                    var formID = $.trim($("#form-id").val());
                    var type = $.trim($("#type").val());
                    if (formID) {
                        lazyFormBuilder.data.getForm(formID, type);
                    }

                    lazyFormBuilder.client = new ZeroClipboard($(".shortcut-property .copy-widget,.shortcut-property .cut-widget"));

                    lazyFormBuilder.client.on("copy", function(event) {
                        var $thisWidget = $(".shortcut-property").data("thisWidget");
                        $thisWidget.removeClass("widget-active widget-error");
                        $(".shortcut-property").hide();
                        var clipboard = event.clipboardData;
                        clipboard.setData("text/html", $thisWidget.get(0).outerHTML);

                        //剪切控件
                        var $target = $(event.target);
                        if ($target.hasClass("cut-widget") || $target.parents().hasClass("cut-widget")) {
                            $thisWidget.remove();
                        }
                    });


                    // lazyFormBuilder.client.on("ready", function(readyEvent) {
                    //     alert("ZeroClipboard SWF is ready!");
                    //     lazyFormBuilder.client.on("aftercopy", function(event) {
                    //         console.log(event);
                    //         alert("Copied text to clipboard: " + event.data["text/html"]);
                    //     });
                    // });
                    // $(lazyFormBuilder.editor.document).on({
                    //     click: function(event) {
                    //         var $target = $(event.target);
                    //         alert(2);
                    //         if (!$target.hasClass("global-close") && !$target.parents().hasClass("global-close")) {
                    //             alert(3);
                    //             $(".global-close").hide();
                    //         }
                    //     }
                    // });
                    //
                    //
                    //
                    //
                    //
                    // ZeroClipboard.create();
                    // $(lazyFormBuilder.editor.document).on('keydown', function(event) {
                    //     if (event.ctrlKey && event.keyCode == 67) {
                    //         ZeroClipboard.setData({
                    //             "text/plain": "Blah",
                    //             "text/html": "<b>Blah</b>"
                    //         });
                    //     }
                    // });
                    // ZeroClipboard.on("ready", function(e) {
                    //     console.log(e);
                    // });
                    lazyFormBuilder.editor.addListener('beforeselectionchange', function(editor) {
                        var $undoObj = $(".lazy-form-builder .toolbar-container .toolbar-item[command='undo']");
                        var $redoObj = $(".lazy-form-builder .toolbar-container .toolbar-item[command='redo']");
                        if (lazyFormBuilder.editor.queryCommandState("undo") == -1) {
                            $undoObj.addClass("disabled");
                        } else {
                            $undoObj.removeClass("disabled");
                        }
                        if (lazyFormBuilder.editor.queryCommandState("redo") == -1) {
                            $redoObj.addClass("disabled");
                        } else {
                            $redoObj.removeClass("disabled");
                        }
                        //console.log(22211111);
                        //IE 在此处触发显示快捷属性框的操作
                        // var range = lazyFormBuilder.editor.selection.getRange();
                        // console.log(lazyFormBuilder.ui.widget.isWidget($(range.endContainer)));
                        //$(".shortcut-property").hide();
                    });
                    //复制控件
                    lazyFormBuilder.editor.addListener('beforepaste', function(type, html) {
                        //判断是否是复制的控件
                        //console.log(html);
                        if (lazyFormBuilder.ui.widget.isWidget(html.html)) {
                            var range = this.selection.getRange();
                            lazyFormBuilder.ui.widget.widgetCount++;
                            $(html.html).removeClass("widget-active widget-error");
                            if (!$(html.html).hasClass("DATE") && !$(html.html).hasClass("time")) {
                                html.html = $(html.html).attr({
                                    id: "DATA_" + lazyFormBuilder.ui.widget.widgetCount,
                                    name: "DATA_" + lazyFormBuilder.ui.widget.widgetCount,
                                    title: $(html.html).attr("title") + lazyFormBuilder.ui.widget.widgetCount
                                }).get(0).outerHTML;
                            }
                        }
                    });
                    // $(lazyFormBuilder.editor.document).on({
                    //     click: function(event) {
                    //         $(".line-property-dialog-wrap").dialog("open");
                    //         return false;
                    //     }
                    // },"hr");
                    $(lazyFormBuilder.editor.document).on({
                        click: function(event) {
                            var $target = $(event.target);
                            // console.log($target);
                            $(lazyFormBuilder.editor.document).find(":input,img").removeClass("widget-active");
                            if (!$target.hasClass("global-close") && !$target.parents().hasClass("global-close") && !$target.hasClass("trigger-global") && !$target.parents().hasClass("trigger-global")) {
                                $(".global-close").hide();
                                $(".trigger-global,.trigger-global *").removeClass("toolbar-hover");
                            }
                            //分隔线特殊处理
                            if (event.target.nodeName == "HR") {
                                $(".line-property-dialog-wrap").data("currentObj", event.target).dialog("open");
                            } else if (lazyFormBuilder.ui.widget.isWidget($target)) {
                                $target.removeClass("widget-error").addClass("widget-active");
                                lazyFormBuilder.ui.shortcutProperty.open.call($target);
                            }
                            return false;
                        },
                        scroll: function() {
                            $(lazyFormBuilder.editor.document).find(":input,img").removeClass("widget-active");
                            $(".shortcut-property").hide();
                        }
                    });
                    lazyFormBuilder.editor.addInputRule(function(root) {
                        $.each(root.getNodesByTagName('img'), function(i, node) {
                            //更改旧版表单设计器的日期、时间图标
                            var imgClass = node.getAttr("class");
                            if (imgClass == "DATE") {
                                node.setAttr('src', '/images/form/calendar.png');
                            } else if (imgClass == "time") {
                                node.setAttr('src', '/images/form/time.png');
                            } else if (imgClass == "detailChar") {
                                node.setAttr('src', '/images/form/calculator.png');
                            }
                        });
                    });
                    lazyFormBuilder.editor.addOutputRule(function(root) {
                        $.each(root.getNodesByTagName('img'), function(i, node) {
                            //更改旧版表单设计器的日期、时间图标
                            var imgClass = node.getAttr("class");
                            if (imgClass == "DATE") {
                                node.setAttr('src', '/images/form/calendar.png');
                            } else if (imgClass == "time") {
                                node.setAttr('src', '/images/form/time.png');
                            } else if (imgClass == "detailChar") {
                                node.setAttr('src', '/images/form/calculator.png');
                            }
                        });
                    });
                });
            }
        },
        shortcutProperty: {
            /**
             * 属性快捷编辑的宽度
             * @type {Number}
             */
            shortcutPropertyWidth: 300,
            /**
             * 显示控件属性快捷编辑
             * @return {[type]} [description]
             */
            init: function() {
                var $shortcutPropertyObj = $(".shortcut-property");
                //显示属性
                $(".shortcut-property").on({
                    click: function(event) {
                        var $target = $(event.target);
                        //console.log($target);
                        var $thisWidget = $(".shortcut-property").data("thisWidget");
                        if ($target.hasClass("show-property") || $target.parents().hasClass("show-property")) {
                            lazyFormBuilder.ui.property.show.call($thisWidget);
                            $(".shortcut-property").hide();
                        } else if ($target.hasClass("remove-widget") || $target.parents().hasClass("remove-widget")) {
                            $thisWidget.remove();
                            $(".shortcut-property").hide();
                        }
                    }
                });
                //控件名称更改
                $shortcutPropertyObj.on({
                    focus: function() {
                        //记住原始控件名称 如果后面控件名称为空 则恢复为此名称 并提示
                        $(this).data("widgetName", $(this).val());
                    },
                    change: function() {
                        var $thisWidget = $shortcutPropertyObj.data("thisWidget");
                        var widgetName = $.trim($(this).val());
                        widgetName = UE.utils.unhtml(widgetName);
                        if (widgetName == "") {
                            $(this).val($(this).data("widgetName"));
                            $.pnotify({
                                text: "控件名称不能为空",
                                type: "error"
                            });
                        } else {
                            $thisWidget.attr("title", widgetName);
                        }
                    }
                }, ".widget-name");
                //文本框控件列表(用于日期、时间控件选择关联控件)
                $shortcutPropertyObj.find("select.widget-name-list").selectpicker({
                    width: "160px",
                    height: "27px"
                }).change(function() {
                    var $thisWidget = $shortcutPropertyObj.data("thisWidget");
                    var preTitle = $thisWidget.hasClass("DATE") ? "日期控件：" : "时间控件:";
                    if ($(this).val() != 0) {
                        $thisWidget.attr({
                            title: preTitle + $(this).val(),
                            value: $(this).val()
                        });
                    }
                });
                $(".shortcut-property .op-btn").tooltip({
                    container: "body"
                });
            },
            open: function() {
                if (lazyFormBuilder.ui.widget.isWidget($(this))) {
                    var editorScrollTop = lazyFormBuilder.editor.body.scrollTop,
                        editorScrollLeft = lazyFormBuilder.editor.body.scrollLeft,
                        $this = $(this),
                        $shortcutPropertyObj = $(".shortcut-property");
                    $shortcutPropertyObj.data("thisWidget", $this);
                    //日期、时间控件特殊处理
                    if ($this.hasClass("DATE") || $this.hasClass("time")) {
                        $shortcutPropertyObj.find(".set-widget-title").html("关联文本框");
                        $shortcutPropertyObj.find(".title").html("关联文本框");
                        $shortcutPropertyObj.find(".widget-name,.show-property").hide();
                        //加载所有单行文本框
                        var textWidgetList = lazyFormBuilder.ui.widget.getAllTextWidgets();
                        var listStr = ["<option value='0'>选择关联文本框</option>"];
                        for (var i = 0, widgetLength = textWidgetList.length; i < widgetLength; i++) {
                            listStr.push("<option value='" + textWidgetList[i] + "'>" + textWidgetList[i] + "</option>");
                        }
                        $shortcutPropertyObj.find("select.widget-name-list").html(listStr.join(""));
                        var preTitle = $this.hasClass("DATE") ? "日期控件：" : "时间控件:";
                        var selectedTextBox = 0;
                        if ($this.attr("title")) {
                            selectedTextBox = $this.attr("title").replace(preTitle, "");
                        }
                        $shortcutPropertyObj.find(".widget-name-list").val(selectedTextBox).selectpicker("refresh").selectpicker("show");
                    } else {
                        $shortcutPropertyObj.find(".title").html("名称快捷编辑");
                        $shortcutPropertyObj.find(".set-widget-title").html("控件名称");
                        $shortcutPropertyObj.find(".widget-name-list").hide();
                        $shortcutPropertyObj.find(".widget-name,.show-property").show();
                    }
                    var left = $this.offset().left + $("#" + lazyFormBuilder.config.editorID).offset().left - editorScrollLeft;
                    var top = $this.offset().top + $("#" + lazyFormBuilder.config.editorID).offset().top + $this.height() + 20 - editorScrollTop;
                    var windowHeight = $(window).height();
                    var windowWidth = $(window).width();
                    if (top > windowHeight - 100) {
                        top = windowHeight - 100;
                    }
                    if (windowWidth - left < lazyFormBuilder.ui.shortcutProperty.shortcutPropertyWidth) {
                        left = windowWidth - lazyFormBuilder.ui.shortcutProperty.shortcutPropertyWidth - 20
                    }
                    $shortcutPropertyObj.show().offset({
                        left: left,
                        top: top
                    }).find(".widget-name").val($this.attr("title"));
                } else {
                    //alert("不是控件");
                }
            },
            hide: function() {
                var $shortcutPropertyObj = $(".shortcut-property");
                $shortcutPropertyObj.hide();
            }
        },
        property: {
            init: function() {
                $(".property-dialog-wrap").dialog({
                    resizable: false,
                    modal: true,
                    autoOpen: false,
                    width: 400,
                    buttons: [{
                        text: "确定",
                        'class': "btn btn-primary",
                        click: function() {
                            //验证属性设置是否通过验证
                            var hasError = false;
                            $(".property-dialog-wrap").find(".property-list").each(function() {
                                var $this = $(this),
                                    property = $this.attr("property"),
                                    propertyObj = lazyFormBuilder.property[property];
                                if (propertyObj.validate) {
                                    $.each(propertyObj.validate, function(validateIndex, validateValue) {
                                        if (!validateValue.func.call($this.find("[property-flag]"))) {
                                            $.pnotify({
                                                text: validateValue.msg,
                                                type: "error"
                                            });
                                            hasError = true;
                                        }
                                    });
                                }
                            });
                            if (!hasError) {
                                $(this).dialog("close");
                            }
                        }
                    }, {
                        text: "取消",
                        'class': "btn btn-default",
                        click: function() {
                            $(this).dialog("close");
                        }
                    }],
                    open: function() {
                        //美化属性框中的控件
                        //应该每个属性自己增加回调函数来美化
                        //先简化处理下
                        $(".property-dialog-wrap").find("select").selectpicker({
                            height: 27,
                            container: "body"
                        });
                    }
                });
            },
            show: function() {
                //控件类型
                var $this = $(this),
                    widgetType = lazyFormBuilder.ui.widget.getWidgetType.call(this),
                    widgetObj = lazyFormBuilder.widget[widgetType],
                    propertyInfor = widgetObj.properties;
                //合并基础属性
                var propertyList = lazyFormBuilder.config.basicProperties.concat(propertyInfor);
                //去除忽略的属性
                var cancelProperties = widgetObj.cancelProperties;
                if (cancelProperties) {
                    for (var i = 0, length = widgetObj.cancelProperties.length; i < length; i++) {
                        //var propertyIndex = propertyList.indexOf(cancelProperties[i]);
                        var propertyIndex = $.inArray(cancelProperties[i], propertyList);
                        if (propertyIndex != -1) {
                            propertyList.splice(propertyIndex, 1);
                        }
                    }
                }
                //增加控件ID属性
                propertyList.push("widgetID");
                //生成属性列表
                var propertyHtml = ['<ul class="property-list-wrap">'];
                for (var i = 0, length = propertyList.length; i < length; i++) {
                    var propertyObj = lazyFormBuilder.property[propertyList[i]];
                    if (propertyObj) {
                        var propertyView = $.type(propertyObj.view) === "function" ? propertyObj.view.call(this) : propertyObj.view;
                        propertyHtml.push('<li class="property-list" property="' + propertyList[i] + '"><span class="property-title">' + propertyObj.title + '</span>' + propertyView + '</li>');
                    }
                }
                propertyHtml.push('</ul>');
                $(".property-dialog-wrap").html(propertyHtml.join(''));
                $(".property-dialog-wrap").find(".property-list").each(function() {
                    var property = $(this).attr("property");
                    lazyFormBuilder.property[property].setter.call($(this).find("[property-flag]"), $this);
                    if (lazyFormBuilder.property[property].create) {
                        lazyFormBuilder.property[property].create.call($(this).find("[property-flag]"), $this);
                    }
                });
                $(".property-dialog-wrap").dialog("option", "title", widgetObj.title + "属性").dialog("open");
            }
        }
    },
    data: {
        getForm: function(formID, type) {
            $.ajax({
                url: "do.php",
                data: {
                    op: "getForm",
                    formID: formID,
                    type: type
                }
            }).done(function(result) {
                if (result) {
                    var parsedData = $.parseJSON(result);
                    $(".form-name").val(parsedData.FORM_NAME);
                    lazyFormBuilder.editor.setContent(parsedData.PRINT_MODEL);
                    lazyFormBuilder.ui.widget.widgetCount = parsedData.FIELD_COUNTER;
                } else {
                    $.pnotify({
                        text: "获取表单数据失败",
                        type: "error"
                    });
                }
            });
        },
        save: function() {
            var formID = $("#form-id").val();
            var formContent = lazyFormBuilder.editor.getContent();
            if (formContent == "") {
                $.pnotify({
                    text: "表单内容不能为空",
                    type: "error"
                });
                return false;
            }
            var formName = $.trim($(".form-name").val());
            if (formName == "") {
                $.pnotify({
                    text: "表单名称不能为空",
                    type: "error"
                });
                return false;
            }
            //检查表单
            var checkResult = lazyFormBuilder.ui.widget.validateWidget("save");
            if (checkResult) {
                $.pnotify({
                    text: "表单有错误,请查看错误列表",
                    type: "error"
                });
                $(".error-list-wrap").show(150);
                return false;
            }
            $.ajax({
                url: "do.php",
                type: "POST",
                data: {
                    op: "saveForm",
                    type: $("#type").val(),
                    formName: formName,
                    formContent: formContent,
                    formID: formID,
                    formWidgetCount: lazyFormBuilder.ui.widget.widgetCount
                }
            }).done(function(result) {
                if (result) {
                    $.pnotify({
                        text: "保存成功",
                        type: "success"
                    });
                } else {
                    $.pnotify({
                        text: "保存失败",
                        type: "error"
                    });
                }
            }).fail(function() {
                $.pnotify({
                    text: "保存失败,ajax错误",
                    type: "error"
                });
            });
        }
    },
    util: {
        RGBToHex: function(color) {
            if (color.substr(0, 1) === "#" || color == "transparent") {
                return color;
            }
            var nums = /(.*?)rgb\((\d+),\s*(\d+),\s*(\d+)\)/i.exec(color);
            if (!nums) {
                nums = /(.*?)rgba\((\d+),\s*(\d+),\s*(\d+),\s*(\d+)\)/i.exec(color);
            }
            var r = parseInt(nums[2], 10).toString(16);
            var g = parseInt(nums[3], 10).toString(16);
            var b = parseInt(nums[4], 10).toString(16);
            return "#" + ((r.length == 1 ? "0" + r : r) + (g.length == 1 ? "0" + g : g) + (b.length == 1 ? "0" + b : b));
        }
    }
};
/**
 * 集合编辑器
 */
var itemsEditor = {
    itemTemplate: '<li class="item-list">\
                        <a class="move-tip">\
                            <i class="fa fa-bars"></i>\
                        </a>\
                        <input placeholder="请输入下拉项信息" type="text" value="{value}" class="item-title"/>\
                        <a class="remove" title="删除此项">\
                            <i class="fa fa-times-circle"></i>\
                        </a>\
                     </li>',
    itemEditorDialog: false,
    setData: false,
    getData: false,
    init: function() {
        var $widgetObj = $(this);
        if (!itemsEditor.itemEditorDialog) {
            itemsEditor.itemEditorDialog = $(".items-editor-dialog").dialog({
                width: 330,
                autoOpen: false,
                modal: true,
                resizable: false,
                buttons: [{
                    text: "添加新项",
                    'class': "btn btn-primary pull-left",
                    click: function() {
                        $(this).find(".items-list-wrap").append(itemsEditor.itemTemplate.replace("{value}", ""));
                    }
                }, {
                    text: "确定",
                    'class': "btn btn-primary",
                    click: function() {
                        var selectItems = [];
                        $(this).find(".items-list-wrap .item-list").each(function() {
                            var text = $.trim($(this).find(".item-title").val());
                            selectItems.push(text);
                        });
                        if (itemsEditor.setData) {
                            itemsEditor.setData.call(this, selectItems);
                        }
                        $(this).dialog("close");
                    }
                }, {
                    text: "取消",
                    'class': "btn btn-default",
                    click: function() {
                        $(this).dialog("close");
                    }
                }],
                open: function() {
                    if (itemsEditor.getData) {
                        var itemHtml = [];
                        var initItems = itemsEditor.getData.call(this);
                        $.each(initItems, function(index, value) {
                            var trimValue = $.trim(value);
                            itemHtml.push(itemsEditor.itemTemplate.replace("{value}", trimValue));
                        });
                        $(this).find(".items-list-wrap").html(itemHtml.join(''));
                    }
                }
            });
        }
        //排序
        $(".items-editor-dialog .items-list-wrap").sortable({
            placeholder: "sort-place-holder",
            forcePlaceholderSize: true
        });
        //显示、隐藏删除按钮
        $(".items-editor-dialog").on({
            mouseenter: function() {
                $(this).find(".remove").show();
            },
            mouseleave: function() {
                $(this).find(".remove").hide();
            }
        }, ".item-list");
        //删除项
        $(".items-editor-dialog").on({
            click: function() {
                $(this).parents(".item-list").remove();
            }
        }, ".remove");
    },
    open: function() {
        $(".items-editor-dialog").dialog("open");
    }
};
/**
 * SQL语句编辑器
 */
var SQLEditor = {
        SQLEditorDialog: false,
        triggerWidget: false,
        init: function() {
            SQLEditor.triggerWidget = this;
            if (!SQLEditor.SQLEditorDialog) {
                SQLEditor.SQLEditorDialog = $(".sql-editor-dialog").dialog({
                    width: 570,
                    autoOpen: false,
                    modal: true,
                    resizable: false,
                    buttons: [{
                        text: "验证SQL语句",
                        'class': "btn btn-info pull-left",
                        click: function() {
                            var sqlContent = $.trim($(this).find(".sql-content").val());
                            if (sqlContent == "") {
                                $.pnotify({
                                    text: "请输入SQL语句",
                                    type: "error"
                                })
                            } else {
                                try {
                                    SQLParser.parse($(this).find(".sql-content").val());
                                    $.pnotify({
                                        text: "SQL语句正确",
                                        type: "success"
                                    })
                                } catch (err) {
                                    $.pnotify({
                                        text: "SQL语句貌似有问题",
                                        type: "error"
                                    })
                                }
                            }
                        }
                    }, {
                        text: "确定",
                        'class': "btn btn-primary",
                        click: function() {
                            var sqlContent = $.trim($(this).find(".sql-content").val());
                            if (sqlContent == "") {
                                $.pnotify({
                                    text: "请输入SQL语句",
                                    type: "error"
                                })
                            } else {
                                var $widgetObj = $(SQLEditor.triggerWidget);
                                //console.log(SQLEditor.triggerWidget);
                                //console.log($widgetObj);
                                $widgetObj.attr("datasrc", sqlContent);
                                // console.log(sqlContent);
                                // console.log($widgetObj.attr("aaa"));
                                $(this).dialog("close");
                                //console.log($widgetObj.attr("aaa"));
                            }
                        }
                    }, {
                        text: "取消",
                        'class': "btn btn-default",
                        click: function() {
                            $(this).dialog("close");
                        }
                    }],
                    open: function() {
                        var $widgetObj = $(SQLEditor.triggerWidget);
                        $(this).find(".sql-content").val($widgetObj.attr("datasrc"));
                    },
                    close: function() {
                        var $widgetObj = $(SQLEditor.triggerWidget);
                        //console.log($widgetObj.attr("aaa"));
                        //console.log(22222);
                    }
                });
            }
        },
        open: function() {
            SQLEditor.SQLEditorDialog.data("thisWidget", $(this));
            SQLEditor.SQLEditorDialog.dialog("open");
        }
    }
    /**
     * 计算公式编辑器
     */
var formulaEditor = {
        formulaEditorDialog: false,
        formulaEditorContent: false,
        triggerWidget: false,
        getData: false,
        setData: false,
        init: function() {
            formulaEditor.triggerWidget = this;
            if (!formulaEditor.formulaEditorDialog) {
                formulaEditor.formulaEditorDialog = $(".formula-editor-dialog").dialog({
                    width: "auto",
                    autoOpen: false,
                    modal: true,
                    resizable: false,
                    open: function() {
                        if (formulaEditor.getData) {
                            formulaEditor.formulaEditorContent.setContent(formulaEditor.getData.call(this));
                        }
                        //加载控件列表
                        var widgetList = lazyFormBuilder.ui.widget.getAllWidgets($(formulaEditor.triggerWidget).attr("title"));
                        var widgetListHtml = ['<option value="0">请选择要计算的控件</option>'];
                        $.each(widgetList, function(index, value) {
                            widgetListHtml.push('<option>' + value + '</option>');
                        });
                        $(".formula-editor-dialog select.calculate-widget-list").html(widgetListHtml.join('')).selectpicker("refresh");
                    },
                    buttons: [{
                        text: "确定",
                        'class': "btn btn-primary",
                        click: function() {
                            if (formulaEditor.setData) {
                                formulaEditor.setData.call(this, $.trim(formulaEditor.formulaEditorContent.getContentTxt()));
                            }
                            $(this).dialog("close");
                        }
                    }, {
                        text: "取消",
                        'class': "btn btn-default",
                        click: function() {
                            $(this).dialog("close");
                        }
                    }]
                });
                //公式编辑器
                if (!formulaEditor.formulaEditorContent) {
                    formulaEditor.formulaEditorContent = UE.getEditor("formula-editor-content", {
                        toolbars: [
                            []
                        ],
                        theme: "formbuilder",
                        wordCount: false,
                        allowDivTransToP: false,
                        elementPathEnabled: false,
                        autoHeightEnabled: false,
                        initialFrameWidth: 800,
                        initialFrameHeight: 120,
                        enableContextMenu: false,
                        shortcutMenu: false,
                        enableAutoSave: false,
                        initialStyle: "p{line-height:24px;font-size:12px;font-family:微软雅黑;}"
                    });
                }
                //插入控件
                $(".formula-editor-dialog .calculate-widget-list").selectpicker({
                    container: "body"
                }).change(function() {
                    if ($(this).val() != 0) {
                        formulaEditor.formulaEditorContent.execCommand("insertHtml", $(this).val());
                        $(this).val(0).selectpicker("refresh");
                    }
                });
                //插入运算符
                $(".formula-editor-dialog .operator").click(function() {
                    formulaEditor.formulaEditorContent.execCommand("insertHtml", $(this).html());
                });
            }
        },
        open: function() {
            formulaEditor.formulaEditorDialog.dialog("open");
        }
    }
    /**
     * 明细字段编辑器
     * @type {Object}
     */
var detailCharEditor = {
        detailCharEditorDialog: false,
        triggerWidget: false,
        init: function() {
            detailCharEditor.triggerWidget = this;
            if (!detailCharEditor.detailCharEditorDialog) {
                detailCharEditor.detailCharEditorDialog = $(".detail-char-dialog").dialog({
                    width: "auto",
                    autoOpen: false,
                    modal: true,
                    dialogClass: "detail-char-dialog-class",
                    resizable: false,
                    buttons: [{
                        text: "添加新项",
                        'class': "btn btn-info pull-left",
                        click: function() {
                            var newItemNumber = $(".detail-char-dialog .item-list-wrap .item-list").length + 1;
                            var $newItemObj = $("<li type='1' total='0' decimal='2' roundoff='1' items='' formula='' formulaformat='2*1' width='90' item-order='" + newItemNumber + "' height='20' class='item-list'><span class='item-order'>[" + newItemNumber + "]</span><span class='item-title'>明细字段" + newItemNumber + "</span><a href='javascript:void(0)' class='remove'><i class='fa fa-times'/></i></a></li>");
                            $(".detail-char-dialog .item-list-wrap .content-wrap").css("visibility", "visible").append($newItemObj);
                            $(".detail-char-dialog .item-list-wrap .empty-tip").hide();
                            $newItemObj.click();
                        }
                    }, {
                        text: "确定",
                        'class': "btn btn-primary",
                        click: function() {
                            //项目名称
                            var itemName = [];
                            //控件类型
                            var itemType = [];
                            //控件尺寸
                            var itemSize = [];
                            //是否合计
                            var itemTotal = [];
                            //下拉项
                            var dropItems = [];
                            //计算公式
                            var formula = [];
                            //保留小数点位数
                            var decimal = [];
                            //四舍五入
                            var roundoff = [];
                            //行计算时，保留小数点位数&四舍五入
                            var formulaformat = [];
                            $(".detail-char-dialog .item-list-wrap .item-list").each(function() {
                                itemName.push($(this).find(".item-title").text());
                                itemType.push($(this).attr("type"));
                                itemSize.push($(this).attr("width") + "*" + $(this).attr("height"));
                                itemTotal.push($(this).attr("total"));
                                dropItems.push($(this).attr("items"));
                                formula.push($(this).attr("formula"));
                                decimal.push($(this).attr("decimal"));
                                roundoff.push($(this).attr("roundoff"));
                                formulaformat.push($(this).attr("formulaformat"));
                            });
                            $(detailCharEditor.triggerWidget).attr({
                                detailcharname: itemName.join('`'),
                                detailchartype: itemType.join('`'),
                                detailcharwidth: itemSize.join('`'),
                                detailchartotal: itemTotal.join('`'),
                                detailchardropvalues: dropItems.join('~'),
                                detailcharformula: formula.join('`'),
                                detailchardecimal: decimal.join('`'),
                                detailcharroundoff: roundoff.join('`'),
                                detailcharformulaformat: formulaformat.join('`')
                            });
                            $(this).dialog("close");
                        }
                    }, {
                        text: "取消",
                        'class': "btn btn-default",
                        click: function() {
                            $(this).dialog("close");
                        }
                    }],
                    open: function() {
                        $(".detail-char-dialog .item-list-wrap .content-wrap").getNiceScroll().show();
                        $(".detail-char-dialog .item-list-wrap .item-list:first").click();
                    },
                    close: function() {
                        $(".detail-char-dialog .item-list-wrap .content-wrap").getNiceScroll().hide();
                    }
                });
                $(".detail-char-dialog .item-list-wrap").on({
                    mouseenter: function() {
                        if (!$(this).hasClass("current")) {
                            $(this).addClass("hover");
                        }
                        $(this).find(".remove").show();
                    },
                    mouseleave: function() {
                        if (!$(this).hasClass("current")) {
                            $(this).removeClass("hover");
                        }
                        $(this).find(".remove").hide();
                    },
                    click: function() {
                        $(".detail-char-dialog .item-list-wrap .item-list").removeClass("hover current");
                        $(this).addClass("current");
                        var $propertyObj = $(".detail-char-dialog .property-list-wrap");
                        $propertyObj.find(".empty-tip").hide();
                        $propertyObj.find(".content-wrap").css("visibility", "visible");
                        if ($(this).attr("type") == 3) {
                            $propertyObj.find(".select-items-wrap").show();
                        } else {
                            $propertyObj.find(".select-items-wrap").hide();
                        }
                        if ($(this).attr("total") == "1") {
                            $propertyObj.find(".total-result-format-wrap").show();
                        } else {
                            $propertyObj.find(".total-result-format-wrap").hide();
                        }
                        $propertyObj.show();
                        //设置属性
                        $propertyObj.find(".item-name").val($(this).find(".item-title").text());
                        $propertyObj.find(".item-height").val($(this).attr("height"));
                        $propertyObj.find(".item-width").val($(this).attr("width"));
                        $propertyObj.find(".item-type").val($(this).attr("type")).selectpicker("refresh");
                        $propertyObj.find(".item-total").prop("checked", $(this).attr("total") == "1").iCheck("update");
                        $propertyObj.find(".item-decimal").val($(this).attr("decimal"));
                        $propertyObj.find(".item-roundoff").prop("checked", $(this).attr("roundoff") == "1").iCheck("update");
                    }
                }, ".item-list");
                //移除明细项
                $(".detail-char-dialog .item-list-wrap").on({
                    click: function() {
                        $(this).parents(".item-list").remove();
                        var $itemListObj = $(".detail-char-dialog .item-list-wrap .content-wrap li");
                        //重置顺序
                        $itemListObj.each(function() {
                            $(this).find(".item-order").html("[" + ($(this).index() + 1) + "]");
                        });
                        //console.log($itemListObj.first());
                        if ($itemListObj.length > 0) {
                            $itemListObj.first().click();
                        } else {
                            $(".detail-char-dialog .content-wrap").css("visibility", "hidden");
                            $(".detail-char-dialog .empty-tip").show();
                        }
                        $.pnotify({
                            text: "若明细字段计算公式包含此项,请更改计算公式",
                            type: "info"
                        });
                        return false;
                    }
                }, ".item-list .remove");
                $(".detail-char-dialog .item-list-wrap .content-wrap").niceScroll();
                //下拉集合编辑器
                itemsEditor.init();
                itemsEditor.setData = function(selectItems) {
                    var $currentItem = $(".detail-char-dialog .item-list-wrap .item-list").filter(function() {
                        return $(this).hasClass("current");
                    });
                    $currentItem.attr("items", selectItems.join(','));
                }
                itemsEditor.getData = function() {
                    var $currentItem = $(".detail-char-dialog .item-list-wrap .item-list").filter(function() {
                        return $(this).hasClass("current");
                    });
                    //如果最后一个是逗号 需要去掉 否则最后会有一个空的项
                    //旧版编辑器元素升级有此问题
                    var items = $currentItem.attr("items");
                    if (items) {
                        if (items.charAt(items.length - 1) == ",") {
                            items = items.substr(0, items.length - 1);
                        }
                        return items.split(",");
                    } else {
                        return [];
                    }
                }
                $(".detail-char-dialog .property-list-wrap .btn-items-editor").click(function() {
                    itemsEditor.open();
                });
                //明细字段计算公式编辑器
                detailFormulaEditor.init.call(this);
                detailFormulaEditor.setData = function(data) {
                    var $currentItem = $(".detail-char-dialog .item-list-wrap .item-list").filter(function() {
                        return $(this).hasClass("current");
                    });
                    $currentItem.attr("formula", data.formula);
                    $currentItem.attr("formulaformat", data.formulaformat);
                }
                detailFormulaEditor.getData = function() {
                    var $currentItem = $(".detail-char-dialog .item-list-wrap .item-list").filter(function() {
                        return $(this).hasClass("current");
                    });
                    return {
                        "formula" : $currentItem.attr("formula") ? $currentItem.attr("formula") : "",
                        "formulaformat" : $currentItem.attr("formulaformat") ? $currentItem.attr("formulaformat") : "",
                    };
                }
                $(".detail-char-dialog .property-list-wrap .btn-open-formula-editor").click(function() {
                    detailFormulaEditor.open();
                });
                //控件名称
                $(".detail-char-dialog .property-list-wrap .item-name").change(function() {
                    var itemName = $.trim($(this).val());
                    var $currentItemObj = $(".detail-char-dialog .item-list-wrap .item-list").filter(function() {
                        return $(this).hasClass("current");
                    });
                    if (itemName == "") {
                        $.pnotify({
                            text: "明细项目名称不能为空",
                            type: "error"
                        });
                        $(this).val($currentItemObj.html());
                    } else {
                        $currentItemObj.find(".item-title").html(itemName);
                    }
                });
                //宽度
                $(".detail-char-dialog .property-list-wrap .item-width").keyup(function() {
                    $(".detail-char-dialog .item-list-wrap .item-list").filter(function() {
                        return $(this).hasClass("current");
                    }).attr("width", $(this).val());
                });
                //高度
                $(".detail-char-dialog .property-list-wrap .item-height").keyup(function() {
                    $(".detail-char-dialog .item-list-wrap .item-list").filter(function() {
                        return $(this).hasClass("current");
                    }).attr("height", $(this).val());
                });
                //控件类型
                $(".detail-char-dialog .property-list-wrap .item-type").selectpicker({
                    width: "170px",
                    height: "27px"
                }).change(function() {
                    //选下拉类型的时候需要 可以配置下拉项
                    if ($(this).val() == 3) {
                        $(".detail-char-dialog .select-items-wrap").show();
                    } else {
                        $(".detail-char-dialog .select-items-wrap").hide();
                    }
                    $(".detail-char-dialog .item-list-wrap .item-list").filter(function() {
                        return $(this).hasClass("current");
                    }).attr("type", $(this).val());
                });
                //是否合计
                $(".detail-char-dialog .property-list-wrap .item-total").iCheck({
                    checkboxClass: 'icheckbox_square-blue'
                }).on("ifChanged", function() {
                    $(".detail-char-dialog .item-list-wrap .item-list").filter(function() {
                        return $(this).hasClass("current");
                    }).attr("total", $(this).prop("checked") ? "1" : "0");
                    // 如果选中合计，才展示保留小数点位数和四舍五入
                    if($(this).prop("checked")) {
                        $(".detail-char-dialog .total-result-format-wrap").show();
                    } else {
                        $(".detail-char-dialog .total-result-format-wrap").hide();
                    }
                });
                // 合计结果保留小数点位数
                $(".detail-char-dialog .property-list-wrap .item-decimal").keyup(function() {
                    if(/^\d+$/.test($.trim($(this).val())) && $.trim($(this).val()) >= 0 && $.trim($(this).val()) <= 10) {
                    } else {
                        $.pnotify({
                            text: "合计结果保留小数点位数，只能是 0 ~ 10 之间的值，包括 0 和 10！",
                            type: "error"
                        });
                        $(this).val("");
                    }
                    $(".detail-char-dialog .item-list-wrap .item-list").filter(function() {
                        return $(this).hasClass("current");
                    }).attr("decimal", $(this).val());
                });
                // 合计结果四舍五入
                $(".detail-char-dialog .property-list-wrap .item-roundoff").iCheck({
                    checkboxClass: 'icheckbox_square-blue'
                }).on("ifChanged", function() {
                    $(".detail-char-dialog .item-list-wrap .item-list").filter(function() {
                        return $(this).hasClass("current");
                    }).attr("roundoff", $(this).prop("checked") ? "1" : "0");
                });
            }
        },
        open: function() {
            detailCharEditor.detailCharEditorDialog.dialog("open");
        }
    }
    /**
     * 明细字段计算公式编辑器
     */
var detailFormulaEditor = {
        detailFormulaEditorDialog: false,
        detailFormulaEditorContent: false,
        triggerWidget: false,
        getData: false,
        setData: false,
        init: function() {
            detailFormulaEditor.triggerWidget = this;
            //console.log(detailFormulaEditor.triggerWidget);
            if (!detailFormulaEditor.detailFormulaEditorDialog) {
                detailFormulaEditor.detailFormulaEditorDialog = $(".detail-formula-editor-dialog").dialog({
                    width: "auto",
                    autoOpen: false,
                    modal: true,
                    resizable: false,
                    open: function() {
                        if (detailFormulaEditor.getData) {
                            detailFormulaEditor.detailFormulaEditorContent.setContent(detailFormulaEditor.getData.call(this).formula);
                        }
                        //加载明细字段列表
                        var detailListHtml = ['<option value="0">请选择要计算的明细字段</option>'];
                        $(".detail-char-dialog .item-list-wrap .content-wrap li").each(function() {
                            detailListHtml.push('<option value="' + $(this).attr("item-order") + '">' + $(this).text() + '</option>');
                        });
                        $(".detail-formula-editor-dialog select.calculate-widget-list").html(detailListHtml.join('')).selectpicker("refresh");
                        // 保留小数点位数&四舍五入赋值
                        var formulaFormatSplit = detailFormulaEditor.getData.call(this).formulaformat.split('*');
                        $(".detail-formula-editor-dialog .detail-formula-editor-content-result-decimal").val(formulaFormatSplit[0]);
                        $(".detail-formula-editor-dialog .detail-formula-editor-content-result-roundoff").prop("checked", formulaFormatSplit[1] == "1").iCheck("update");
                    },
                    buttons: [{
                        text: "确定",
                        'class': "btn btn-primary",
                        click: function() {
                            if (detailFormulaEditor.setData) {
                                var formulaResultRoundoff = $(".detail-formula-editor-dialog .detail-formula-editor-content-result-roundoff").prop("checked") ? "1" : "0";
                                detailFormulaEditor.setData.call(this, {
                                    "formula" : $.trim(detailFormulaEditor.detailFormulaEditorContent.getContentTxt()),
                                    "formulaformat" : $(".detail-formula-editor-dialog .detail-formula-editor-content-result-decimal").val()+"*"+formulaResultRoundoff,
                                });
                            }
                            $(this).dialog("close");
                        }
                    }, {
                        text: "取消",
                        'class': "btn btn-default",
                        click: function() {
                            $(this).dialog("close");
                        }
                    }]
                });
                //公式编辑器
                if (!detailFormulaEditor.detailFormulaEditorContent) {
                    detailFormulaEditor.detailFormulaEditorContent = UE.getEditor("detail-formula-editor-content", {
                        toolbars: [
                            []
                        ],
                        theme: "formbuilder",
                        wordCount: false,
                        allowDivTransToP: false,
                        elementPathEnabled: false,
                        autoHeightEnabled: false,
                        initialFrameWidth: 800,
                        initialFrameHeight: 120,
                        enableContextMenu: false,
                        shortcutMenu: false,
                        enableAutoSave: false,
                        initialStyle: "p{line-height:24px;font-size:12px;font-family:微软雅黑;}"
                    });
                }
                //插入控件
                $(".detail-formula-editor-dialog .calculate-widget-list").selectpicker({
                    container: "body"
                }).change(function() {
                    if ($(this).val() != 0) {
                        detailFormulaEditor.detailFormulaEditorContent.execCommand("insertHtml", "[" + $(this).val() + "]");
                        $(this).val(0).selectpicker("refresh");
                    }
                });
                //插入运算符
                $(".detail-formula-editor-dialog .operator").click(function() {
                    detailFormulaEditor.detailFormulaEditorContent.execCommand("insertHtml", $(this).html());
                });
                // 计算结果保留小数点位数
                $(".detail-formula-editor-dialog .detail-formula-editor-content-result-decimal").keyup(function() {
                    if(/^\d+$/.test($.trim($(this).val())) && $.trim($(this).val()) >= 0 && $.trim($(this).val()) <= 10) {
                    } else {
                        $.pnotify({
                            text: "计算结果保留小数点位数，只能是 0 ~ 10 之间的值，包括 0 和 10！",
                            type: "error"
                        });
                        $(this).val("");
                    }
                });
                // 计算结果四舍五入
                $(".detail-formula-editor-dialog .detail-formula-editor-content-result-roundoff").iCheck({
                    checkboxClass: 'icheckbox_square-blue'
                }).on("ifChanged", function() {
                });
            }
        },
        open: function() {
            detailFormulaEditor.detailFormulaEditorDialog.dialog("open");
        }
    }
    /**
     * 数据源选择器
     */
var dataSourceSelector = {
    dataSourceSelectorDialog: false,
    triggerWidget: false,
    propertyObj: false,
    selectedFlag: '<a class="selected" href="javascript:void(0);"><i class="fa fa-check-square-o"></i></a>',
    init: function($propertyObj) {
        dataSourceSelector.triggerWidget = this;
        dataSourceSelector.propertyObj = $propertyObj;
        if (!dataSourceSelector.dataSourceSelectorDialog) {
            dataSourceSelector.dataSourceSelectorDialog = $(".dynamic-list-dialog").dialog({
                autoOpen: false,
                modal: true,
                width: 300,
                resizable: false,
                buttons: [{
                    text: "确定",
                    'class': "btn btn-primary",
                    click: function() {
                        var $selectedObj = $(".dynamic-list-dialog li").filter(function() {
                            return $(this).find(".selected").length == 1;
                        });
                        if ($selectedObj) {
                            dataSourceSelector.propertyObj.find(":text").val($selectedObj.attr("url"));
                            dataSourceSelector.triggerWidget.attr("datasource", $selectedObj.attr("url"));
                        }
                        $(this).dialog("close");
                    }
                }, {
                    text: "取消",
                    'class': "btn btn-default",
                    click: function() {
                        $(this).dialog("close");
                    }
                }],
                open: function() {
                    var type;
                    if ($(dataSourceSelector.triggerWidget).hasClass("dynamic")) {
                        type = "dynamic_field";
                    } else if ($(dataSourceSelector.triggerWidget).hasClass("dynamic_info")) {
                        type = "dynamic_info";
                    }
                    if (type) {
                        $.ajax({
                            url: "do.php",
                            data: {
                                op: "getDynamicList",
                                type: type
                            }
                        }).done(function(result) {
                            var parsedData = $.parseJSON(result);
                            var list = [];
                            $.each(parsedData,function(k,v){
                               var moduleTitle = v.title;
                               var fieldList  = v.list;
                               list.push("<li>" + moduleTitle + "</li>");
                               $.each(fieldList,function(_k,_v){
                                   list.push("<li class='list' url='" + _v.url + "' style='text-indent:10px;'>" + _v.title + "</li>");
                               });
                            });
                            $(".dynamic-list-dialog").find(".dynamic-list").html(list.join(''));
                        }).fail(function() {
                            alert("ajax error in getDynamicList");
                        });
                    }
                }
            });
            $(".dynamic-list-dialog").on({
                click: function() {
                    $(".dynamic-list-dialog li .selected").remove();
                    $(this).append(dataSourceSelector.selectedFlag);
                }
            }, "li.list");
        }
    },
    open: function() {
        var title;
        if ($(dataSourceSelector.triggerWidget).hasClass("dynamic")) {
            title = "系统动态字段选择";
        } else if ($(dataSourceSelector.triggerWidget).hasClass("dynamic_info")) {
            title = "动态信息数据源选择";
        }
        dataSourceSelector.dataSourceSelectorDialog.dialog("option", "title", title).dialog("open");
    }
}
