//日期选择插件
;(function($) {
	//默认参数
	var defaluts = {
		lang:"cn",
		defaultView :"month",
		selectable:true,//是否可以拖动选择时间
		selectHelper:true,//显示默认加载的提示信息,该属性只在周/天视图里可用
		editable: true,//是否可编辑
		emouserOver:"",//鼠标滑过事件
		emouserClick:"",//鼠标单击事件
		emouserOut:""//鼠标离开事件
	};
	/*
	selectDate:选择时间触发事件
	*/
	$.fn.extend({
		calendarInit:function(settings){
			var opts = $.extend({}, defaluts, settings); //使用jQuery.extend 覆盖插件默认参数
			var mySetting = {
				header: {
					left: 'prev,next today',
					center: 'title',
					right: 'agendaDay,agendaWeek,month'
				},
				selectable: opts.selectable,
				selectHelper: true,
				firstDay:1,//每周的第一天是哪天,Sunday=0, Monday=1,
				height: 850,//日历高度,包括表头
				contentHeight: 600,//内容高度，不包括表头
				defaultView:opts.defaultView,//默认显示的视图，注意引号
				allDaySlot:true,//在agenda开头的视图里，是否显示最上面all-day那一栏
				axisFormat:'HH(:mm):00',//左边那一列时间的格式
				select: function(start, end, allDay) {			
					if(opts.selectDate){
						opts.selectDate.call(this, start, end, allDay);	
						/*calendar.fullCalendar('renderEvent',
							{
								title: "aaaa",
								start: start,
								end: end,
								allDay: allDay
							},
							true // make the event "stick"
						);*/
					}
					//calendar.fullCalendar('unselect');
					
				},
				eventClick: function(calEvent, jsEvent, view) {
					/*layer.tips($("#aaaaa").html(), this, {
						guide: 1,
						style: ['background-color:#999; color:#fff', '#999'],
						maxWidth:240,
						closeBtn:[0,true]
					});*/
					/*alert('Event: ' + calEvent.title);
					alert('Coordinates: ' + jsEvent.pageX + ',' + jsEvent.pageY);
					alert('View: ' + view.name);
					// change the border color just for fun
					$(this).css('border-color', 'red');*/
					//alert(calEvent.id);
					if(opts.emouserClick){
						opts.emouserClick.call(this, calEvent, jsEvent, view);	
					}
				},
				eventMouseover: function(calEvent, jsEvent, view) {
					//console.log(calEvent);
					//console.log($(this));
					if(opts.emouserOver){
						opts.emouserOver.call(this, calEvent, jsEvent, view);	
					}
				},
				eventMouseout: function(calEvent, jsEvent, view) {
					//console.log(calEvent);
					//console.log($(this));
					if(opts.emouserOut){
						opts.emouserOut.call(this, calEvent, jsEvent, view);	
					}
				},
				editable: opts.editable
			};

			if(opts.lang=="cn"){
				var language_cn = {
					monthNamesShort : ['1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11', '12'],
					monthNames : ['1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11', '12'],
					dayNamesShort : [DateLang['Sun'], DateLang['Mon'], DateLang['Tue'], DateLang['Wed'], DateLang['Thu'], DateLang['Fri'], DateLang['Sat']],
					dayNames : [DateLang['Sunday'], DateLang['Monday'], DateLang['Tuesday'], DateLang['Wednesday'], DateLang['Thursday'], DateLang['Friday'], DateLang['Saturday']],
					allDayText : DateLang['AllDay'],
					buttonText : {
						today : DateLang['Today'],
						week : DateLang['Week'],
						month : DateLang['Month'],
						day : DateLang['CalDay']
					},
					allDayText:DateLang['AllDay'],
					titleFormat: {
						month: 'yyyy'+DateLang['Year']+'MMMM'+DateLang['Month'],
						week: 'yyyy'+DateLang['Year']+'MMMM'+DateLang['Month']+'d'+DateLang['Tdate']+'{&#8212;yyyy'+DateLang['Year']+'MMMM'+DateLang['Month']+'d'+DateLang['Tdate']+'}',
						day: 'yyyy'+DateLang['Year']+'MMMM'+DateLang['Month']+'d'+DateLang['Tdate']+' dddd'
					},
				};	
				$.extend(mySetting, language_cn);	
			}
			var calendarObj = $("#calendar").fullCalendar(mySetting);
			//修改样式
			$("#calendar").find(".fc-content").css("clear","none");
			return calendarObj;
		}	
	});
})(jQuery);
