<?php
/**
 *@Copyright (C) 2015 - 2015 Weaver Co.Ltd
 *@systemname:       E-Office
 *@filename:         general/income_expend/include/tool/Tool.php
 *@function:         收支管理工具类
 *@encoding:         $_lang['encoding']
 *@author:           www.weaver.com.cn
 *@modify:           lizhijun
 *@date:             2015-04-22
 *@file Version:     1.0
 *@eoffice Version:  9.0
*/
class Tool {
    /**
     * 加载配置文件
     * @staticvar type $config
     * @param type $type
     * @param type $configName
     * @return boolean
     */
    public static function loadConfig($type='php' ,$configName='config'){
        if($configName == ''){
            return false;
        }
        static $config;
        if(isset($config)){
            return $config;
        }
        $type = strtolower($type);
        $configPath = ROOT_PATH.CONFIG_PATH.$configName.'.'.$type;
        if(!file_exists($configPath)){
            return false;
        }
        switch ($type){
            case 'xml':
                $xml=join("",file($configPath)); 
                $_array = (array)(simplexml_load_string($xml));     
                foreach ($_array as $key=>$item){  
                    $temp                       = structToArray((array)$item);
                    $array[$key]    =  $temp[0];      
                }    
                break;
            case 'php':
                $array = include(CONFIG_PATH.$configName.'.'.$type);
                break;
            default: 
                $array = include(CONFIG_PATH.$configName.'.'.$type);
        }
        $config = $array;
        return $array;   
    }  
    /**
     * 判断菜单权限
     * @param type $funcId
     * @param type $userId
     * @return boolean
     */
    public static function checkMenuPriv($funcId,$userId){
        $privStr = getLoginUserPriv($userId);
        if(!empty($_SESSION["USER_SUB_PRIV"])){
            $privStr = implode(",",array_filter(array_unique(explode(",",$privStr.",".$_SESSION["USER_SUB_PRIV"]))));
        }
        if (!isThisPri($privStr, isMenuPri($funcId))) {
            return false;
        }
        return true;
    }
    /**
     * 获取某月份的天数
     * @param type $month
     * @param type $year
     * @return int
     */
    public static function getMonthLastDay($month, $year) {
        switch ($month) {
            case 4 :
            case 6 :
            case 9 :
            case 11 :
                $days = 30;
                break;
            case 2 :
                if ($year % 4 == 0) {
                    if ($year % 100 == 0) {
                        $days = $year % 400 == 0 ? 29 : 28;
                    } else {
                        $days = 29;
                    }
                } else {
                    $days = 28;
                }
                break;

            default :
                $days = 31;
                break;
        }
        return $days;
    }
	public static function deldir($dir) {
		//先删除目录下的文件：
		$dh = opendir($dir);
		while ($file = readdir($dh)) {
			if ($file != "." && $file != "..") {
				$fullpath = $dir . "/" . $file;
				if (!is_dir($fullpath)) {
					unlink($fullpath);
				} else {
					deldir($fullpath);
				}
			}
		}
		closedir($dh);
		//删除当前文件夹：
		if (rmdir($dir)) {
			return true;
		} else {
			return false;
		}
	}
    /**
     * 将数目转为千位分隔符形式
     * @param type $money
     * @return string
     */
    public static function money2($money){
        if($money == 0){
            return '0.00';
        }
        if(strrpos($money, '.')){
            $moneyArr1  = explode('.', $money);
            $money1     = $moneyArr1[0];
            $money2     = $moneyArr1[1];
            $size1      = strlen($money1);
            $size2      = strlen($money2);
            if($size2>2){
                $money2 = substr($money2, 0, 2);
            }else if($size2 == 1){
                $money2 = $money2 . '0';
            }
        }else{
            $money1     = $money;
            $size1      = strlen($money1);
            $money2     = '00';
        }
        if($size1>=4 && $size1<7){
            $temp       = $money1/1000;
            $tempArr    = explode('.', $temp);
            if(strlen($tempArr[1]) == 0){
                $tempArr[1] = '000';
            }else if(strlen($tempArr[1]) == 1){
                $tempArr[1] = $tempArr[1].'00';
            }else if(strlen($tempArr[1]) == 2){
                $tempArr[1] = $tempArr[1].'0';
            }
            $temp = $tempArr[0] . ','.$tempArr[1];
        }else if($size1>=7 && $size1<10){
            $temp       = $money1/1000;
            $tempArr    = explode('.', $temp);
            $temp1      = $tempArr[0]/1000;
            $tempArr1   = explode('.', $temp1);
            if(strlen($tempArr[1]) == 0){
                $tempArr[1] = '000';
            }else if(strlen($tempArr[1]) == 1){
                $tempArr[1] = $tempArr[1].'00';
            }else if(strlen($tempArr[1]) == 2){
                $tempArr[1] = $tempArr[1].'0';
            }
             if(strlen($tempArr1[1]) == 0){
                $tempArr1[1] = '000';
            }else if(strlen($tempArr1[1]) == 1){
                $tempArr1[1] = $tempArr1[1].'00';
            }else if(strlen($tempArr1[1]) == 2){
                $tempArr1[1] = $tempArr1[1].'0';
            }
            $temp    = $tempArr1[0].','.$tempArr1[1].','.$tempArr[1];
        }else if($size1>=10 && $size1<13){
            $temp       = $money1/1000;
            $tempArr    = explode('.', $temp);
            $temp1      = $tempArr[0]/1000;
            $tempArr1   = explode('.', $temp1);
            $temp2      = $tempArr1[0]/1000;
            $tempArr2   = explode('.', $temp2);
            if(strlen($tempArr[1]) == 0){
                $tempArr[1] = '000';
            }else if(strlen($tempArr[1]) == 1){
                $tempArr[1] = $tempArr[1].'00';
            }else if(strlen($tempArr[1]) == 2){
                $tempArr[1] = $tempArr[1].'0';
            }
            if(strlen($tempArr1[1]) == 0){
                $tempArr1[1] = '000';
            }else if(strlen($tempArr1[1]) == 1){
                $tempArr1[1] = $tempArr1[1].'00';
            }else if(strlen($tempArr1[1]) == 2){
                $tempArr1[1] = $tempArr1[1].'0';
            }
            if(strlen($tempArr2[1]) == 0){
                $tempArr2[1] = '000';
            }else if(strlen($tempArr2[1]) == 1){
                $tempArr2[1] = $tempArr2[1].'00';
            }else if(strlen($tempArr2[1]) == 2){
                $tempArr2[1] = $tempArr2[1].'0';
            }
            $temp       = $tempArr2[0].','.$tempArr2[1].','.$tempArr1[1].','.$tempArr[1];
        }else{
            $temp = $money1;
        }
             
        $returnMoney = $temp.'.'.$money2;
        $returnMoney = str_replace('-0,', '-', $returnMoney);
        return $returnMoney;
    }
}
function structToArray($item) {                        
    if(!is_string($item)) {                                
        $item = (array)$item;                                
        foreach ($item as $key=>$val){                       
          $item[$key]  =  structToArray($val);             
        }                                                    
    }                                                      
    return $item;                                          
}