<?php
/**
 *@Copyright (C) 2015 - 2015 Weaver Co.Ltd
 *@systemname:       E-Office
 *@filename:         general/income_expend/index.php
 *@function:         收支管理入口文件
 *@encoding:         $_lang['encoding']
 *@author:           www.weaver.com.cn
 *@modify:           lizhijun
 *@date:             2015-04-22
 *@file Version:     1.0
 *@eoffice Version:  9.0
*/
define('MODULE_PATH',       'general/income_expend/');  //模块路径
define('PROXY_PATH',        MODULE_PATH .'proxy/');     //代理类路径
define('VIEW_PATH',         MODULE_PATH .'view/');      //视图文件路径
define('INCLUDE_PATH',      MODULE_PATH .'include/');   //包含文件路径
define('CONFIG_PATH',       INCLUDE_PATH .'config/');   //配置文件路径
define('TOOL_PATH',         INCLUDE_PATH .'tool/');     //工具类路径
define('CSS_PATH',          '/'.VIEW_PATH .'css/');     //css样式路径
define('JS_PATH',           '/'.VIEW_PATH . 'js/');     //js文件路径   
if(!@include_once('inc/auth.php')){
    trigger_error('error', E_USER_ERROR);
}
define('ATTACH_PATH',        $ATTACH_PATH);
if(!@include_once('inc/utility_all.php')){
    trigger_error('error', E_USER_ERROR);
}
if(!@include_once(TOOL_PATH . 'Tool.php')){
    trigger_error('error', E_USER_ERROR);
}
if(!@include_once('api/IncomeExpend.class.php')){
    trigger_error('error', E_USER_ERROR);
}
$config = Tool::loadConfig();   //加载配置文件
includelangpak("incomeexpend"); //导入语言包
Init::getInstance()->start();   //启动项目
class Init{
   
    private static $_instance;//保存类实例的静态对象变量
    /**
     * 构造方法私有化
     */
    private function __construct(){
        
    }
    /**
     * 创建__clone方法防止对象被复制克隆
     */
    private function __clone(){
        trigger_error('Clone is not allow!',E_USER_ERROR);
    }
    /**
     * 单例方法,用于访问实例的公共的静态方法
     */
    public static function getInstance(){
        if(!(self::$_instance instanceof self)){
            self::$_instance = new self;
        }
        return self::$_instance;
    }
    public function start(){
        global $config;
        $c          = intval(request_var('c',1));//将字符串转为数字，避免sql注入
        $m          = intval(request_var('m',1));
        $funcId     = intval(request_var('func_id',0));
        $userId     = $_SESSION["LOGIN_USER_ID"];
        $userPriv   = $_SESSION["LOGIN_USER_PRIV"];
        $deptId     = $_SESSION["LOGIN_DEPT_ID"];
        if($funcId != 0){
            if(!Tool::checkMenuPriv($funcId, $userId)){
                echo '<b style="color:red">您没有该菜单权限</b>';exit;
            }
        }
        $route      = $config['route'];
        $className  = $route['c'][$c];
        $methodName = $route['m'][$m];
        include(PROXY_PATH . $className . '.proxy.php');
        $_className     = $className.'Proxy';
        $classObj       = new $_className($funcId,$userId,$userPriv,$deptId);
        $classObj->$methodName();
    }
}
