<?php
/**
 *@Copyright (C) 2015 - 2015 Weaver Co.Ltd
 *@systemname:       E-Office
 *@filename:         general/income_expend/proxy/IncomeExpendPlan.proxy.php
 *@function:         收支方案管理代理类
 *@encoding:         $_lang['encoding']
 *@author:           www.weaver.com.cn
 *@modify:           lizhijun
 *@date:             2015-04-22
 *@file Version:     1.0
 *@eoffice Version:  9.0
*/
class IncomeExpendPlanProxy {
    private $_funcId;
    private $_userId;
    private $_privId;
    private $_deptId;
    private $_IncomeExpend;
    public function __construct($funcId,$userId,$privId,$deptId) {
        $this->_funcId = $funcId;
        $this->_userId = $userId;
        $this->_privId = $privId;
        $this->_deptId = $deptId;
        $this->_IncomeExpend = new IncomeExpend();
    }
    /**
     * 加载方案类别页面
     */
    public function lists(){
        global $_lang;
        $page           = intval(request_var('page',0));
        $perPage        = intval(request_var('perPage',15));
        $planTypeLists  = $this->_IncomeExpend->planTypeLists();//获取方案类别
        $PAGE_TITLE     = $_lang["incomeexpend_plan_manager"];
        include(VIEW_PATH . '2/lists.view.php');
    }
    /**
     * 获取方案类别数据
     */
    public function ajaxLists(){
        if($this->_userId == 'admin'){
            $defaultSortField = 'PLAN_ID';
        }else{
            $defaultSortField = 'CREATE_TIME';
        }
        $pageSize       = request_var('itemsPerPage',20);
        $currentPage    = request_var('currentPage',0);  
        $sortField      = request_var('sortField',$defaultSortField);
        $sortType       = request_var('sortType','DESC');
        $filter         = request_var('FILTER','all');
        $planType       = request_var('PLAN_TYPE');
        $keyName        = request_var('keyName');
        $keyValue       = request_var('keyValue');
        $status         = request_var('status',0);
        $eq             = array();
        $gt             = array();
        if($planType != ''){
            $eq['p.PLAN_TYPE']    = $planType;
        } 
        if($keyValue != ''){
            $like['p.'.$keyName] = $keyValue;
        }
        switch ($filter) {
            case 'unStart':
                $eq['p.PLAN_STATE'] = 0;
                break;
            case 'starting':
                $eq['p.PLAN_STATE'] = 1;
                break;
            case 'end':
                $eq['p.PLAN_STATE'] = 2;
                break;
            case 'last7d':
                $seconds  = time() - 7*24*3600; 
                $gt['p.CREATE_TIME']  = $seconds;      
                break;
            case 'last1m':
                $seconds  = time() - 30*24*3600;
                $gt['p.CREATE_TIME']  = $seconds; 
                break;
            case 'last3m':
                $seconds  = time() - 3*30*24*3600;
                $gt['p.CREATE_TIME']  = $seconds; 
                break;
            default:
                break;
        }
        $start          = $pageSize * $currentPage;
        $selectName     = array('p.PLAN_ID','p.PLAN_CODE','p.PLAN_NAME','pt.TYPE_NAME','p.PLAN_STATE','p.EXPENSE_BUDGET','p.REVENUE_BUDGET','p.PLAN_CYCLE','p.PLAN_CYCLE_UNIT');
        $condition      = array('count' => 1,'eq' => $eq,'gt' => $gt,'like' => $like,'neq' => array('STATUS' => $status));
        $order          = array($sortField => $sortType);
        
        $this->_IncomeExpend->pageSize  = $pageSize;
        $this->_IncomeExpend->userId    = $this->_userId;
        $this->_IncomeExpend->deptId    = $this->_deptId;
        $this->_IncomeExpend->privId    = $this->_privId;
        $planLists = $this->_IncomeExpend->planLists($selectName, true, $start, $condition,$order,'','AND');
        echo json_encode($planLists);
    }
    /**
     * 方案详情数据
     */
    public function detail(){
        global $_lang;
        $type           = request_var('type');
        $planId         = intval(request_var('planId',0));
        $planInfo       = $this->_IncomeExpend->planInfo($planId);
        if($planInfo['PLAN_STATE'] == 2){
            $day = ($planInfo['END_TIME'] - $planInfo['START_TIME']) / (3600*24);
            if($planInfo['PLAN_CYCLE_UNIT'] == 1){
               $planInfo['REAL_CYCLE'] =   round($day, 2);
            }else if($planInfo['PLAN_CYCLE_UNIT'] == 2){
                $planInfo['REAL_CYCLE'] =  round($day/7, 2);
            }
        }
        if($planInfo['PLAN_STATE'] != 2){
            $planInfo['END_TIME'] = $_lang["incomeexpend_not_end"];
        }else{
            $planInfo['END_TIME'] = date('Y-m-d H:i:s',$planInfo['END_TIME']);
        }
        if($planInfo['PLAN_STATE'] == 0){
            $planInfo['START_TIME'] = $_lang["incomeexpend_unstart"];
        }else{
            $planInfo['START_TIME'] = date('Y-m-d H:i:s',$planInfo['START_TIME']);
        }
        if($planInfo['PLAN_CYCLE'] == 0){
            $planInfo['PLAN_CYCLE'] = $_lang["incomeexpend_not_set_cycle"];
        }
        $planInfo['REAL_PROFIT']    = Tool::money2($planInfo['REAL_REVENUE'] - $planInfo['REAL_EXPENSE']);
        $planInfo['EXPENSE_BUDGET'] = Tool::money2($planInfo['EXPENSE_BUDGET']);
        $planInfo['REVENUE_BUDGET'] = Tool::money2($planInfo['REVENUE_BUDGET']);
        $planInfo['REAL_REVENUE']   = Tool::money2($planInfo['REAL_REVENUE']);
        $planInfo['REAL_EXPENSE']   = Tool::money2($planInfo['REAL_EXPENSE']);

        $PAGE_TITLE                 = $_lang["incomeexpend_plan_detail"];
        include(VIEW_PATH . '2/detail.view.php');
    }
    /**
     * 加载新增方案页面
     */
    public function add(){
        global $_lang;
        $planTypeLists  = $this->_IncomeExpend->planTypeLists();//获取方案类别
        $planCode       = $this->_createPlanCode();//创建方案编码
        $PAGE_TITLE     = $_lang["incomeexpend_add_plan"];
        include(VIEW_PATH . '2/add.view.php');
    }
    /**
     * 新增处理
     */
    public function addDo(){
        $data['PLAN_CODE']              = request_var('PLAN_CODE');
        $data['PLAN_NAME']              = request_var('PLAN_NAME');
        $data['PLAN_TYPE']              = request_var('PLAN_TYPE');
        $data['PLAN_CYCLE']             = request_var('PLAN_CYCLE');
        $data['PLAN_CYCLE_UNIT']        = request_var('PLAN_CYCLE_UNIT');
        $data['EXPENSE_BUDGET']         = request_var('EXPENSE_BUDGET');
        $data['REVENUE_BUDGET']         = request_var('REVENUE_BUDGET');
        $data['IS_START']               = request_var('IS_START');
        $data['EXPENSE_BUDGET_ALERT']   = request_var('EXPENSE_BUDGET_ALERT') == '' ? 0 : request_var('EXPENSE_BUDGET_ALERT');
        $data['ALL_USER']               = request_var('ALL_USER');
        $data['DEPT_ID']                = request_var('DEPT_ID');
        $data['ROAL_ID']                = request_var('USER_PRIV_ID');
        $data['USER_ID']                = request_var('USER_ID');
        $data['CREATOR']                = $this->_userId;
        $data['CREATE_TIME']            = time();
        $data['UPDATE_TIME']            = time();
        $dataSub['ATTACHMENT_ID']          = request_var('ATTACHMENT_ID');
        $dataSub['ATTACHMENT_NAME']        = request_var('ATTACHMENT_NAME');
        $dataSub['PLAN_DESCRIPTION']       = request_var('PLAN_DESCRIPTION');
        if($data['IS_START'] == 1){
            $data['PLAN_STATE'] = 1;
            $data['START_TIME'] = time();
        }
        $id = $this->_IncomeExpend->addPlan($data,$dataSub);
        echo json_encode($id);
    }
    /**
     * 加载编辑方案页面
     */
    public function edit(){
        global $_lang;
        $page           = intval(request_var('page',0));
        $perPage        = intval(request_var('perPage',15));
        $planId         = intval(request_var('planId',0));
        $planInfo       = $this->_IncomeExpend->planInfo($planId);
        if($planInfo){
            if($planInfo['ALL_USER'] == 2){
                $planInfo["deptName"] = '';
                $planInfo["privName"] = '';
                $planInfo["userName"] = '';
            }else{
                $planInfo["deptName"] = $planInfo["DEPT_ID"] !="" ? getDeptStr($planInfo["DEPT_ID"]) : "";
                $planInfo["privName"] = $planInfo["ROAL_ID"] !="" ? getPrivStr($planInfo["ROAL_ID"]) : "";
                $planInfo["userName"] = $planInfo["USER_ID"] !="" ? getUsernameStr($planInfo["USER_ID"]) : "";
            }
        }
        $planTypeLists  = $this->_IncomeExpend->planTypeLists();//获取方案类别
        $PAGE_TITLE     = $_lang["incomeexpend_edit_plan"];
        include(VIEW_PATH . '2/edit.view.php');
    }
    /**
     * 编辑处理
     */
    public function editDo(){
        $planId                         = intval(request_var('PLAN_ID',0));
        $data['PLAN_CODE']              = request_var('PLAN_CODE');
        $data['PLAN_NAME']              = request_var('PLAN_NAME');
        $data['PLAN_TYPE']              = request_var('PLAN_TYPE');
        $data['PLAN_CYCLE']             = request_var('PLAN_CYCLE');
        $data['PLAN_CYCLE_UNIT']        = request_var('PLAN_CYCLE_UNIT');
        $data['EXPENSE_BUDGET']         = request_var('EXPENSE_BUDGET');
        $data['REVENUE_BUDGET']         = request_var('REVENUE_BUDGET');
        $data['PLAN_STATE']             = request_var('PLAN_STATE');
        $data['EXPENSE_BUDGET_ALERT']   = request_var('EXPENSE_BUDGET_ALERT') == '' ? 0 : request_var('EXPENSE_BUDGET_ALERT');
        $data['ALL_USER']               = request_var('ALL_USER');
        $data['DEPT_ID']                = request_var('DEPT_ID');
        $data['ROAL_ID']                = request_var('USER_PRIV_ID');
        $data['USER_ID']                = request_var('USER_ID');
        $data['UPDATE_TIME']            = time();
        $dataSub['ATTACHMENT_ID']          = request_var('ATTACHMENT_ID');
        $dataSub['ATTACHMENT_NAME']        = request_var('ATTACHMENT_NAME');
        $dataSub['PLAN_DESCRIPTION']       = request_var('PLAN_DESCRIPTION');
        if($data['PLAN_STATE'] == 1){
            $data['IS_START'] = 1;
            $data['START_TIME'] = time();
        }else{
            $data['IS_START'] = 0;
        }
        if($data['PLAN_STATE'] == 2){
            $data['END_TIME'] = time();
        }
        if($this->_IncomeExpend->updatePlan($data,$dataSub,$planId)){
            echo 1;exit;
        }
        echo 0;
    }
    public function planRecycle(){
        global $_lang;
        $PAGE_TITLE = $_lang["incomeexpend_del_plan"];
        include(VIEW_PATH . '2/recycle.view.php');
    }
    /**
     * 删除方案
     */
    public function delete(){
        $planId     = request_var('planId');
        $deleteType = request_var('deleteType');
        if($deleteType != 'batch'){
            $planId = intval($planId);
        }
        $checkState = $this->_IncomeExpend->checkPlanState($planId);
        if($checkState){
            echo 2;exit;
        }
        $result     = $this->_IncomeExpend->deletePlan($planId, $deleteType);
        echo $result;
    }
    /**
     * 删除附件
     */
    public function deleteAttachment(){
        $planId         = intval(request_var('planId'));
        $delAttachId    = request_var('delAttachId');
        $delAttachName  = request_var('delAttachName');
        $attachId       = request_var('attachId');
        $attachName     = request_var('attachName');
        $attachmentPath  = ATTACH_PATH . $delAttachId.'/'.iconv('UTF-8', 'GBK', $delAttachName);
        if(file_exists($attachmentPath)){
            if(unlink($attachmentPath)){
                $result     = $this->_IncomeExpend->deleteAttachment($planId, $attachId,$attachName);
            }
        }else{
            $result     = $this->_IncomeExpend->deleteAttachment($planId, $attachId,$attachName);
        }
        if($result){
            echo 1;exit;
        }
        echo 0;
    } 
    /**
     * 启动方案
     */
    public function start(){
        $planId     = request_var('planId');
        $startType  = request_var('startType');
        if($startType != 'batch'){
            $planId = intval($planId);
        }
        $result     = $this->_IncomeExpend->startPlan($planId, $startType);
        echo $result;
    }
    /**
     * 结束方案
     */
    public function end(){
        $planId     = request_var('planId');
        $endType    = request_var('endType');
        if($endType != 'batch'){
            $planId = intval($planId);
        }
        $result     = $this->_IncomeExpend->endPlan($planId, $endType);
        echo $result;
    }
    /**
     * 恢复方案
     */
    public function recover(){
        $planId         = request_var('planId');
        $recoverType    = request_var('recoverType');
        if($recoverType != 'batch'){
            $planId = intval($planId);
        }
        $result         = $this->_IncomeExpend->recoverPlan($planId, $recoverType);
        echo $result;
    }
    /**
     * 销毁方案
     */
    public function destory(){
        $planId         = request_var('planId');
        $destoryType    = request_var('destoryType');
        if($destoryType != 'batch'){
            $planId = intval($planId);
        }
        $result         = $this->_IncomeExpend->destoryPlan($planId, $destoryType);
		
		if($result){
			$this->_IncomeExpend->deleteRecordByPlanId($planId, $destoryType);
		}
		
        echo $result;
    }
    /**
     * 创建方案编码
     * @return type
     */
    private function _createPlanCode(){
        $lastId   = $this->_IncomeExpend->getLastPlanCode();
        $planCode       = 'FA00001';
        if($lastId){
            $planCodeNum        = $lastId + 1;
            $numLen             = strlen($planCodeNum);
            switch ($numLen){
                case 1:
                    $planCode   =  'FA0000' . strval($planCodeNum);
                    break;
                case 2:
                    $planCode   =  'FA000' . strval($planCodeNum);
                    break;
                case 3:
                    $planCode   =  'FA00' . strval($planCodeNum);
                    break;
                case 4:
                    $planCode   =  'FA0' . strval($planCodeNum);
                    break;
                default :
                    $planCode   = 'FA'.$planCodeNum;
            }
        }
        return $planCode;
    }
}
