<?php
/**
 *@Copyright (C) 2015 - 2015 Weaver Co.Ltd
 *@systemname:       E-Office
 *@filename:         general/income_expend/proxy/IncomeExpendPlanType.proxy.php
 *@function:         收支方案管理代理类
 *@encoding:         $_lang['encoding']
 *@author:           www.weaver.com.cn
 *@modify:           lizhijun
 *@date:             2015-04-22
 *@file Version:     1.0
 *@eoffice Version:  9.0
*/
class IncomeExpendPlanTypeProxy {
    private $_funcId;
    private $_userId;
    private $_IncomeExpend;
    public function __construct($funcId,$userId,$privId,$deptId) {
        $this->_funcId = $funcId;
        $this->_userId = $userId;
        $this->_IncomeExpend = new IncomeExpend();
    }
    /**
     * 加载方案类型初始化页面
     */
    public function init(){
        global $_lang;
        $typeLists = $this->lists();
        //包含页面文件
        $PAGE_TITLE = $_lang["incomeexpend_plan_type"];
        include(VIEW_PATH . '3/init.view.php');
    }
    /**
     * 获取方案类型列表
     * @return type
     */
    public function lists(){
        $result = $this->_IncomeExpend->planTypeLists();
        return $result;
    }
    /**
     * 获取方案类型详情
     */
    public function detail(){
        $typeId = intval(request_var('TYPE_ID'));
        $result = $this->_IncomeExpend->planTypeDetail($typeId);
        echo json_encode($result);
    }
    /**
     * 删除方案类型
     */
    public function delete(){
        $typeId = intval(request_var('TYPE_ID'));
        $hasPlan = $this->_IncomeExpend->hasPlanOfType($typeId);
        if($hasPlan){
            echo 2;exit;
        }
        $result = $this->_IncomeExpend->deletePlanType($typeId);
        echo $result;
    }
    /**
     * 编辑方案类型
     */
    public function edit(){
        $condition['TYPE_ID']       = intval(request_var('TYPE_ID'));
        $data['TYPE_NAME']          = request_var('TYPE_NAME');
        $data['TYPE_DESCRIPTION']   = request_var('TYPE_DESCRIPTION');
        $result = $this->_IncomeExpend->updatePlanType($data,$condition);
        echo $result;
    }
    /**
     * 添加方案类型
     */
    public function add(){
        $data['TYPE_NAME']          = request_var('TYPE_NAME');
        $data['TYPE_DESCRIPTION']   = request_var('TYPE_DESCRIPTION');
        $result = $this->_IncomeExpend->addPlanType($data);
        echo $result;
    }
}
