<?php
/**
 *@Copyright (C) 2015 - 2015 Weaver Co.Ltd
 *@systemname:       E-Office
 *@filename:         general/income_expend/proxy/IncomeExpendRecord.proxy.php
 *@function:         收支记录管理和统计代理类
 *@encoding:         $_lang['encoding']
 *@author:           www.weaver.com.cn
 *@modify:           lizhijun
 *@date:             2015-04-22
 *@file Version:     1.0
 *@eoffice Version:  9.0
*/
class IncomeExpendRecordProxy {
    private $_funcId;
    private $_userId;
    private $_privId;
    private $_deptId;
    private $_IncomeExpend;
    public function __construct($funcId,$userId,$privId,$deptId) {
        $this->_funcId = $funcId;
        $this->_userId = $userId;
        $this->_privId = $privId;
        $this->_deptId = $deptId;
        $this->_IncomeExpend = new IncomeExpend();
    }
    /**
     * 加载收支记录初始化页面
     */
    public function initRecord(){
        global $_lang;
        $loginUserId = $this->_userId;
        $planTypeLists  = $this->_IncomeExpend->planTypeLists();//获取方案类别
        $PAGE_TITLE     = $_lang["incomeexpend_record"];
        include(VIEW_PATH . '1/initRecord.view.php');
    }
    /**
     * 获取方案列表数据
     */
    public function planList(){
        $pageSize       = 15;
        $currentPage    = request_var('page',0);  
        $filter         = request_var('FILTER','all');
        $planType       = request_var('PLAN_TYPE','all');
        $keyword        = request_var('keyword');
        $eq             = array();
        $gt             = array();
        $like           = array();
        if($planType != 'all'){
            $eq['PLAN_TYPE']    = $planType;
        } 
        if($keyword != ''){
            $like['PLAN_NAME'] = $keyword;
        }
        switch ($filter) {
            case 'starting':
                $eq['PLAN_STATE'] = 1;
                break;
            case 'end':
                $eq['PLAN_STATE'] = 2;
                break;
            case 'last7d':
                $seconds  = time() - 7*24*3600; 
                $gt['UPDATE_TIME']  = $seconds;      
                break;
            case 'last1m':
                $seconds  = time() - 30*24*3600;
                $gt['UPDATE_TIME']  = $seconds; 
                break;
            case 'last3m':
                $seconds  = time() - 3*30*24*3600;
                $gt['UPDATE_TIME']  = $seconds; 
                break;
            default:
                break;
        }
        $start          = $pageSize * $currentPage;
        $selectName     = array('PLAN_ID','PLAN_CODE','PLAN_NAME','PLAN_STATE','EXPENSE_BUDGET','REVENUE_BUDGET','REAL_EXPENSE','REAL_REVENUE','START_TIME','END_TIME');
        $condition      = array('count' =>1,'eq' => $eq,'gt' => $gt,'like' => $like,'neq' => array('STATUS' => 0,'PLAN_STATE' => 0));
        $order          = array('UPDATE_TIME' => 'DESC');
        
        $this->_IncomeExpend->pageSize  = $pageSize;
        $this->_IncomeExpend->userId    = $this->_userId;
        $this->_IncomeExpend->deptId    = $this->_deptId;
        $this->_IncomeExpend->privId    = $this->_privId;
        $planLists = $this->_IncomeExpend->simplePlanLists($selectName,$start,$pageSize,$condition,$order);
        echo json_encode($planLists);
    }
    /**
     * 获取一个方案的记录列表
     */
    public function oneRecordList(){
        global $_lang;
        $pageSize = 8;
        $planId         = intval(request_var('planId',0));
        $chart          = request_var('chart');
        $currentPage    = request_var('page',0);  
        $start          = $pageSize * $currentPage;
        $this->_IncomeExpend->pageSize  = $pageSize;
        $records = $this->_IncomeExpend->oneRecordList($planId,$start,$pageSize);
        $_records = array();
        foreach($records as $key => $value){
            $createTime = date('Y-m-d H:i',$value['CREATE_TIME']);
            if(!$chart){
                if(date('Y-m-d',$value['CREATE_TIME']) == date('Y-m-d')){
                    $time = substr($createTime, strrpos($createTime,' '));
                    $value['CREATE_TIME'] = $_lang["incomeexpend_today"].$time;
                    $value['TIME_TIP']   = 'success';
                }else if(date('Y-m-d',$value['CREATE_TIME']) == date("Y-m-d",strtotime("-1 day"))){
                    $time = substr($createTime, strrpos($createTime,' '));
                    $value['CREATE_TIME'] = $_lang["incomeexpend_yestoday"].$time;
                    $value['TIME_TIP']   = 'error';
                }else if(date('Y-m-d',$value['CREATE_TIME']) == date("Y-m-d",strtotime("-2 day"))){
                    $time = substr($createTime, strrpos($createTime,' '));
                    $value['CREATE_TIME'] = $_lang["incomeexpend_before_yesterday"].$time;
                    $value['TIME_TIP']   = 'error';
                }else if(date('Y-m-d',$value['CREATE_TIME']) == date("Y-m-d",strtotime("-3 day"))){
                    $time = substr($createTime, strrpos($createTime,' '));
                    $value['CREATE_TIME'] = $_lang["incomeexpend_three_days_ago"].$time;
                    $value['TIME_TIP']   = 'error';
                }else{
                    $value['TIME_TIP']   = 'error';
                    $value['CREATE_TIME'] = $createTime;
                }
                $value['EXPENSE1']  = $value['EXPENSE'];
                $value['REVENUE1']  = $value['REVENUE'];
                $value['EXPENSE']   = Tool::money2($value['EXPENSE']);
                $value['REVENUE']   = Tool::money2($value['REVENUE']);
            }else{
                $value['CREATE_TIME'] = $createTime;
            }
            $_records[] = $value;
        }
        echo json_encode($_records);
    }
    /**
     * 获取一个方案记录个数
     */
    public function oneRecordListSize(){
        $planId         = intval(request_var('planId',0));
        $count          = $this->_IncomeExpend->getOneRecordsSize($planId);
        echo $count;
    }
    /**
     * 获取一个方案的信息
     */
    public function planInfo(){
        global $_lang;
        $type           = request_var('type','');
        if($type == 'flow'){
            $planId         = request_var('planId','');
            $planIdArr      = explode(',', $planId);
            $planId         = intval($planIdArr[0]);
        }else{
            $planId         = intval(request_var('planId',0));
        }
        $planInfo       = $this->_IncomeExpend->planInfo($planId);
        $planInfo['REAL_PROFIT'] = Tool::money2($planInfo['REAL_REVENUE'] - $planInfo['REAL_EXPENSE']);
        $planInfo['PLAN_PROFIT'] = Tool::money2($planInfo['REVENUE_BUDGET'] - $planInfo['EXPENSE_BUDGET']);
        
        if($planInfo['PLAN_STATE'] == 1){
            $day = (time() - $planInfo['START_TIME']) / (3600*24);
            if($planInfo['PLAN_CYCLE_UNIT'] == 1){
                $planDays = $planInfo['PLAN_CYCLE'];
            }else{
                $planDays = $planInfo['PLAN_CYCLE'] * 7;
            }
            if(($day -$planDays) > 0 && $planDays != 0){
                $planInfo['CYCLE_OVER'] = 1;
            }else{
                $planInfo['CYCLE_OVER'] = 0;
            }
        }
        if($planInfo['PLAN_CYCLE'] == 0) {
            $planInfo['PLAN_CYCLE'] = $_lang["incomeexpend_not_set_cycle"];
        } else {
            if($planInfo['PLAN_CYCLE_UNIT'] == 1){
                $planInfo['PLAN_CYCLE'] = $planInfo['PLAN_CYCLE'] . $_lang["incomeexpend_day"];
            }else if($planInfo['PLAN_CYCLE_UNIT'] == 2){
                $planInfo['PLAN_CYCLE'] = $planInfo['PLAN_CYCLE'] . $_lang["incomeexpend_week"];
            }
        }
        if(($planInfo['REAL_EXPENSE']  - $planInfo['EXPENSE_BUDGET']) > 0){
            $planInfo['BUDGET_OVER'] = 1;
        }else{
            $planInfo['BUDGET_OVER'] = 0;
        }
        $planInfo['START_TIME']     = date('Y-m-d H:i:s',$planInfo['START_TIME']);
        if($planInfo['END_TIME'] == 0){
            $planInfo['END_TIME'] = $_lang["incomeexpend_not_end"];
        }else{
            $planInfo['END_TIME'] = date('Y-m-d H:i:s',$planInfo['END_TIME']);
        }
        $planInfo['CREATE_TIME']        = date('Y-m-d H:i:s' , $planInfo['CREATE_TIME']);
        $planInfo['_REAL_EXPENSE']      = $planInfo['REAL_EXPENSE'];
        $planInfo['_EXPENSE_BUDGET']    = $planInfo['EXPENSE_BUDGET'];
        $planInfo['EXPENSE_BUDGET']     = Tool::money2($planInfo['EXPENSE_BUDGET']);
        $planInfo['REVENUE_BUDGET']     = Tool::money2($planInfo['REVENUE_BUDGET']);
        $planInfo['REAL_EXPENSE']     = Tool::money2($planInfo['REAL_EXPENSE']);
        $planInfo['REAL_REVENUE']     = Tool::money2($planInfo['REAL_REVENUE']);
        echo json_encode($planInfo);
    }
    /**
     * 获取所有的记录列表
     */
    public function allRecordList(){
        $pageSize = 8;
        $currentPage    = intval(request_var('page',0));  
        $start          = $pageSize * $currentPage;
        $condition      = array();
        $beginTime      = request_var('beginTime');
        $endTime        = request_var('endTime');    
        if($beginTime){
            $condition['beginTime'] = strtotime($beginTime);
        }
        if($endTime){
            $condition['endTime']   = strtotime($endTime) + 3600*24;
        } 
        $this->_IncomeExpend->pageSize  = $pageSize;
        $this->_IncomeExpend->userId    = $this->_userId;
        $this->_IncomeExpend->deptId    = $this->_deptId;
        $this->_IncomeExpend->privId    = $this->_privId;
        $records = $this->_IncomeExpend->allRecordList($condition,$start,$pageSize);
        echo json_encode($records);
    }
    /**
     * 加载收支统计初始页面
     */
    public function initStat(){
        global $_lang;
        $PAGE_TITLE     = $_lang["incomeexpend_stat"];
        $year           = intval(date('Y'));
        include(VIEW_PATH . '1/initStat.view.php');
    }
    /**
     * 获取统计数据
     */
    public function ajaxStat(){
        $year           = intval(request_var('year'));
        $totalType      = intval(request_var('total_type'));
        $month          = request_var('month','all');
        $planId         = request_var('planId');
        $statData       = array();
        $_stat          = array();
        $inTotal        = 0;
        $outTotal       = 0;
        $inOutTotal     = 0;
        $totalRecords   = 0;
        /**
         * 按季度统计
         */
        if($totalType == 2){
            if($planId == ''){
                $stat   = $this->_IncomeExpend->statAllQuarter($year);
            }else{
                $planId     = substr($planId,0,strrpos($planId, ','));
                $stat       = $this->_IncomeExpend->statQuarterByPlan($year,$planId);
            }
            if($stat){
                foreach($stat as $k => $v){
                    $_stat[$v['QUARTER']]['_IN']       = $v['IN'];
                    $_stat[$v['QUARTER']]['_OUT']      = $v['OUT'];
                    $_stat[$v['QUARTER']]['_IN_OUT']   = $v['IN'] - $v['OUT'];
                    $_stat[$v['QUARTER']]['IN']       = Tool::money2($v['IN']);
                    $_stat[$v['QUARTER']]['OUT']      = Tool::money2($v['OUT']);
                    $_stat[$v['QUARTER']]['TIMES']    = $v['TIMES'];
                    $_stat[$v['QUARTER']]['IN_OUT']   = Tool::money2($v['IN'] - $v['OUT']);
                }    
            }
            for($i = 1;$i<=4;$i++){
                if($_stat[$i]){
                    $statData[$i]    = $_stat[$i];
                    $inTotal         += $_stat[$i]['_IN'];
                    $outTotal        += $_stat[$i]['_OUT'];
                    $inOutTotal      += $_stat[$i]['_IN_OUT'];
                    $totalRecords    += $_stat[$i]['TIMES'];
                }else{
                    $statData[$i]['IN']      = '0.00';
                    $statData[$i]['OUT']     = '0.00';
                    $statData[$i]['IN_OUT']  = '0.00';
                    $statData[$i]['_IN']      = 0;
                    $statData[$i]['_OUT']     = 0;
                    $statData[$i]['_IN_OUT']  = 0;
                    $statData[$i]['TIMES']   = 0;
                }
            }
            $statData[5]['IN']         = Tool::money2($inTotal);
            $statData[5]['OUT']        = Tool::money2($outTotal);
            $statData[5]['IN_OUT']     =Tool::money2( $inOutTotal);
            $statData[5]['TIMES']      = $totalRecords;
            file_put_contents('include/export_tmp/all_quarter_data.txt',json_encode($statData));
            echo json_encode($statData);exit;
        }
        /**
         * 按所有月份统计
         */
        if($month == 'all'){
            if($planId == ''){
                $stat = $this->_IncomeExpend->statAllMonth($year);
            }else{
                $planId     = substr($planId,0,strrpos($planId, ','));
                $stat   = $this->_IncomeExpend->statMonthByPlan($year,$planId);
            }
            if($stat){
                foreach($stat as $k => $v){
                    $_stat[$v['MONTH']]['_IN']      = $v['IN'];
                    $_stat[$v['MONTH']]['_OUT']     = $v['OUT'];
                    $_stat[$v['MONTH']]['_IN_OUT']  = $v['IN'] - $v['OUT'];
                    $_stat[$v['MONTH']]['IN']       = Tool::money2($v['IN']);
                    $_stat[$v['MONTH']]['OUT']      = Tool::money2($v['OUT']);
                    $_stat[$v['MONTH']]['TIMES']    = $v['TIMES'];
                    $_stat[$v['MONTH']]['IN_OUT']   = Tool::money2($v['IN'] - $v['OUT']);
                }
            }
            for($i = 1;$i<=12;$i++){
                if($_stat[$i]){
                    $statData[$i]    = $_stat[$i];
                    $inTotal         += $_stat[$i]['_IN'];
                    $outTotal        += $_stat[$i]['_OUT'];
                    $inOutTotal      += $_stat[$i]['_IN_OUT'];
                    $totalRecords    += $_stat[$i]['TIMES'];
                }else{
                    $statData[$i]['IN']      = '0.00';
                    $statData[$i]['OUT']     = '0.00';
                    $statData[$i]['IN_OUT']  = '0.00';
                    $statData[$i]['_IN']      = 0;
                    $statData[$i]['_OUT']     = 0;
                    $statData[$i]['_IN_OUT']  = 0;
                    $statData[$i]['TIMES']   = 0;
                }
            }
            $statData[13]['IN']         = Tool::money2($inTotal);
            $statData[13]['OUT']        = Tool::money2($outTotal);
            $statData[13]['IN_OUT']     = Tool::money2($inOutTotal);
            $statData[13]['TIMES']      = $totalRecords;
            file_put_contents('include/export_tmp/all_month_data.txt',json_encode($statData));
            echo json_encode($statData);exit;
        }
        /**
         *  按单个月份统计
         */
        $month  = intval($month);
        $planId     = substr($planId,0,strrpos($planId, ','));
        $stat = $this->_IncomeExpend->statOneMonth($year,$month,$planId);
        if($stat){
            foreach($stat as $k => $v){
                $_stat[$v['DAY']]['_IN']      = $v['IN'];
                $_stat[$v['DAY']]['_OUT']     = $v['OUT'];
                $_stat[$v['DAY']]['_IN_OUT']  = $v['IN'] - $v['OUT'];
                $_stat[$v['DAY']]['IN']       = Tool::money2($v['IN']);
                $_stat[$v['DAY']]['OUT']      = Tool::money2($v['OUT']);
                $_stat[$v['DAY']]['TIMES']    = $v['TIMES'];
                $_stat[$v['DAY']]['IN_OUT']   = Tool::money2($v['IN'] - $v['OUT']);
            }
        }
        $days = Tool::getMonthLastDay($month, $year);
        for($i = 1;$i<=$days;$i++){
            if($_stat[$i]){
                $statData[$i]    = $_stat[$i];
                $inTotal         += $_stat[$i]['_IN'];
                $outTotal        += $_stat[$i]['_OUT'];
                $inOutTotal      += $_stat[$i]['_IN_OUT'];
                $totalRecords    += $_stat[$i]['TIMES'];
            }else{
                $statData[$i]['IN']      = '0.00';
                $statData[$i]['OUT']     = '0.00';
                $statData[$i]['IN_OUT']  = '0.00';
                $statData[$i]['_IN']      = 0;
                $statData[$i]['_OUT']     = 0;
                $statData[$i]['_IN_OUT']  = 0;
                $statData[$i]['TIMES']   = 0;
            }
        }
        $statData[$days + 1]['IN']         = Tool::money2($inTotal);
        $statData[$days + 1]['OUT']        = Tool::money2($outTotal);
        $statData[$days + 1]['IN_OUT']     = Tool::money2($inOutTotal);
        $statData[$days + 1]['TIMES']      = $totalRecords;
        file_put_contents('include/export_tmp/one_month_data.txt',json_encode(array('total' => $days + 1,'list' => $statData)));
        echo json_encode(array('total' => $days + 1,'list' => $statData));exit;
    }
    /**
     * 获取分别统计数据
     */
    public function diffStat(){
        $year           = intval(request_var('year'));
        $totalType      = intval(request_var('total_type'));
        $month          = request_var('month','all');
        $planId         = request_var('planId');
        $planId         = substr($planId,0,strrpos($planId, ','));
        $planIdArr      = explode(',', $planId);
        $stats          = array();
        //按月份统计
        if($totalType == 1){
            foreach($planIdArr as $value){
                $stat = $this->_IncomeExpend->statAllMonthByPlanId($year,$value);
                $statData       = array();
                $_stat          = array();
                $inTotal        = 0;
                $outTotal       = 0;
                $inOutTotal     = 0;
                $totalRecords   = 0;
                if($stat){
                    foreach($stat as $k => $v){
                        $_stat[$v['MONTH']]['_IN']      = $v['IN'];
                        $_stat[$v['MONTH']]['_OUT']     = $v['OUT'];
                        $_stat[$v['MONTH']]['_IN_OUT']  = $v['IN'] - $v['OUT'];
                        $_stat[$v['MONTH']]['IN']       = Tool::money2($v['IN']);
                        $_stat[$v['MONTH']]['OUT']      = Tool::money2($v['OUT']);
                        $_stat[$v['MONTH']]['TIMES']    = $v['TIMES'];
                        $_stat[$v['MONTH']]['IN_OUT']   = Tool::money2($v['IN'] - $v['OUT']);
                    }
                }
                for($i = 1;$i<=12;$i++){
                    if($_stat[$i]){
                        $statData[$i]    = $_stat[$i];
                        $inTotal         += $_stat[$i]['_IN'];
                        $outTotal        += $_stat[$i]['_OUT'];
                        $inOutTotal      += $_stat[$i]['_IN_OUT'];
                        $totalRecords    += $_stat[$i]['TIMES'];
                    }else{
                        $statData[$i]['IN']      = '0.00';
                        $statData[$i]['OUT']     = '0.00';
                        $statData[$i]['IN_OUT']  = '0.00';
                        $statData[$i]['_IN']      = 0;
                        $statData[$i]['_OUT']     = 0;
                        $statData[$i]['_IN_OUT']  = 0;
                        $statData[$i]['TIMES']   = 0;
                    }
                }
                $statData[13]['IN']         = Tool::money2($inTotal);
                $statData[13]['OUT']        = Tool::money2($outTotal);
                $statData[13]['IN_OUT']     = Tool::money2($inOutTotal);
                $statData[13]['TIMES']      = $totalRecords;
                $stats[$value]                  = $statData;
            }
        //按季节统计
        }else if($totalType == 2){
            foreach($planIdArr as $value){
                $stat           = $this->_IncomeExpend->statQuarterByPlanId($year,$value);
                $statData       = array();
                $_stat          = array();
                $inTotal        = 0;
                $outTotal       = 0;
                $inOutTotal     = 0;
                $totalRecords   = 0;
                if($stat){
                    foreach($stat as $k => $v){
                        $_stat[$v['QUARTER']]['_IN']       = $v['IN'];
                        $_stat[$v['QUARTER']]['_OUT']      = $v['OUT'];
                        $_stat[$v['QUARTER']]['_IN_OUT']   = $v['IN'] - $v['OUT'];
                        $_stat[$v['QUARTER']]['IN']       = Tool::money2($v['IN']);
                        $_stat[$v['QUARTER']]['OUT']      = Tool::money2($v['OUT']);
                        $_stat[$v['QUARTER']]['TIMES']    = $v['TIMES'];
                        $_stat[$v['QUARTER']]['IN_OUT']   = Tool::money2($v['IN'] - $v['OUT']);
                    }    
                }
                for($i = 1;$i<=4;$i++){
                    if($_stat[$i]){
                        $statData[$i]    = $_stat[$i];
                        $inTotal         += $_stat[$i]['_IN'];
                        $outTotal        += $_stat[$i]['_OUT'];
                        $inOutTotal      += $_stat[$i]['_IN_OUT'];
                        $totalRecords    += $_stat[$i]['TIMES'];
                    }else{
                        $statData[$i]['IN']      = '0.00';
                        $statData[$i]['OUT']     = '0.00';
                        $statData[$i]['IN_OUT']  = '0.00';
                        $statData[$i]['_IN']      = 0;
                        $statData[$i]['_OUT']     = 0;
                        $statData[$i]['_IN_OUT']  = 0;
                        $statData[$i]['TIMES']   = 0;
                    }
                }
                $statData[5]['IN']         = Tool::money2($inTotal);
                $statData[5]['OUT']        = Tool::money2($outTotal);
                $statData[5]['IN_OUT']     =Tool::money2( $inOutTotal);
                $statData[5]['TIMES']      = $totalRecords;
                $stats[$value]                 = $statData;
            }
        //按一个月统计
        }else if($totalType == 3){
             foreach($planIdArr as $value){
                $stat = $this->_IncomeExpend->statOneMonthByPlanId($year,$month,$value);
                if($stat){
                    foreach($stat as $k => $v){
                        $_stat[$v['DAY']]['_IN']      = $v['IN'];
                        $_stat[$v['DAY']]['_OUT']     = $v['OUT'];
                        $_stat[$v['DAY']]['_IN_OUT']  = $v['IN'] - $v['OUT'];
                        $_stat[$v['DAY']]['IN']       = Tool::money2($v['IN']);
                        $_stat[$v['DAY']]['OUT']      = Tool::money2($v['OUT']);
                        $_stat[$v['DAY']]['TIMES']    = $v['TIMES'];
                        $_stat[$v['DAY']]['IN_OUT']   = Tool::money2($v['IN'] - $v['OUT']);
                    }
                }
                $days = Tool::getMonthLastDay($month, $year);
                for($i = 1;$i<=$days;$i++){
                    if($_stat[$i]){
                        $statData[$i]    = $_stat[$i];
                        $inTotal         += $_stat[$i]['_IN'];
                        $outTotal        += $_stat[$i]['_OUT'];
                        $inOutTotal      += $_stat[$i]['_IN_OUT'];
                        $totalRecords    += $_stat[$i]['TIMES'];
                    }else{
                        $statData[$i]['IN']      = '0.00';
                        $statData[$i]['OUT']     = '0.00';
                        $statData[$i]['IN_OUT']  = '0.00';
                        $statData[$i]['_IN']      = 0;
                        $statData[$i]['_OUT']     = 0;
                        $statData[$i]['_IN_OUT']  = 0;
                        $statData[$i]['TIMES']   = 0;
                    }
                }
                $statData[$days + 1]['IN']         = Tool::money2($inTotal);
                $statData[$days + 1]['OUT']        = Tool::money2($outTotal);
                $statData[$days + 1]['IN_OUT']     = Tool::money2($inOutTotal);
                $statData[$days + 1]['TIMES']      = $totalRecords;
                $stats[$value]                     = $statData;
            }
        }
        file_put_contents('include/export_tmp/diff_data.txt',json_encode($stats));
        echo json_encode($stats);
    }
    /**
     * 加载新建记录页面
     */
    public function add(){
        global $_lang;
        $PAGE_TITLE     = $_lang["incomeexpend_new_record"] ;
		$currentDataTime = date('Y-m-d H:i:s');
        include(VIEW_PATH . '1/add.view.php');
    }
    /**
     * 处理流程外发过来的收支记录数据
     * @return type
     */
    public function addOtherRecord(){
        $data['PLAN_ID']            = request_var('PLAN_ID');
        $data['RUN_ID']             = request_var('RUN_ID');
        $data['REVENUE']            = request_var('REVENUE');
        $data['IS_FLOW_RECORD']     = 1;
        if(strstr($data['REVENUE'],'|＃|')){
            $subData['INCOME_DETAIL'] = $data['REVENUE'];
            $revenueRows = explode('|＃|', $data['REVENUE']);
            if(empty($revenueRows[0])){
                array_shift($revenueRows);
            }
            array_pop($revenueRows);
            $total = 0;
            foreach($revenueRows as $row){
                $columns = explode('`*`', $row);
                $total += intval($columns[1]);
            }
            $data['REVENUE'] = $total;
        }else{
            $subData['INCOME_DETAIL'] = '';
        }
        $data['EXPENSE']            = request_var('EXPENSE');
        if(strstr($data['EXPENSE'],'|＃|')){
            $subData['EXPEND_DETAIL'] = $data['EXPENSE'];
            $expenseRows = explode('|＃|', $data['EXPENSE']);
            if(empty($expenseRows[0])){
                array_shift($expenseRows);
            }
            array_pop($expenseRows);
            $total = 0;
            foreach($expenseRows as $row){
                $columns = explode('`*`', $row);
                $total += intval($columns[1]);
            }
            $data['EXPENSE'] = $total;
        }else{
            $subData['EXPEND_DETAIL'] = '';
        }
        $data['CREATOR']            = request_var('CREATOR');
        $data['YEAR']               = intval(date('Y'));
        $data['MONTH']              = intval(date('m'));
        $quarter = 0;
        if($data['MONTH'] == 1 || $data['MONTH'] == 2 || $data['MONTH'] == 3 ){
            $quarter    = 1;
        }else if($data['MONTH'] == 4 || $data['MONTH'] ==5 || $data['MONTH'] ==6){
            $quarter    = 2;
        }else if($data['MONTH'] == 7 || $data['MONTH'] == 8 || $data['MONTH'] == 9){
            $quarter    = 3;
        }else if($data['MONTH'] == 10 || $data['MONTH'] == 11 || $data['MONTH'] == 12){
            $quarter    = 4;
        }
        $data['QUARTER']            = $quarter;
        $data['DAY']                = intval(date('d'));
        $data['CREATE_TIME']        = time();
        $subData['RECORD_DESC']     = request_var('RECORD_DESC');
        $subData['ATTACHMENT_ID']   = request_var('PUBLIC_ATTACHMENT_ID');
        $subData['ATTACHMENT_NAME'] = request_var('PUBLIC_ATTACHMENT_NAME');
        $records    = $this->_IncomeExpend->getRecordsByPlanId($data['PLAN_ID']);
        
        $paymentData['REAL_EXPENSE'] = $data['EXPENSE'];
        $paymentData['REAL_REVENUE'] = $data['REVENUE'];
        if($records){
            foreach($records as $key => $value){
                $paymentData['REAL_EXPENSE'] += $value['EXPENSE'];
                $paymentData['REAL_REVENUE'] += $value['REVENUE'];
            }
        }
        $paymentData['UPDATE_TIME'] = time();
        $result     = $this->_IncomeExpend->addPaymentRecord($data, $subData,$paymentData);
        return $result;
    }
    /**
     * 处理新增记录
     */
    public function addDo(){
        $planId                     = request_var('PLAN_ID');
        $data['PLAN_ID']            = intval(substr($planId,0,strrpos($planId,',')));
        $data['REVENUE']            = request_var('REVENUE');
        $data['EXPENSE']            = request_var('EXPENSE');
        $data['CREATOR']            = $this->_userId;
		$createTime					= strtotime(request_var('CREATE_ITME'));

		$data['CREATE_TIME']		= $createTime;
        $data['YEAR']               = intval(date('Y',  $createTime));
        $data['MONTH']              = intval(date('m',  $createTime));
        $quarter = 0;
        if($data['MONTH'] == 1 || $data['MONTH'] == 2 || $data['MONTH'] == 3 ){
            $quarter    = 1;
        }else if($data['MONTH'] == 4 || $data['MONTH'] ==5 || $data['MONTH'] ==6){
            $quarter    = 2;
        }else if($data['MONTH'] == 7 || $data['MONTH'] == 8 || $data['MONTH'] == 9){
            $quarter    = 3;
        }else if($data['MONTH'] == 10 || $data['MONTH'] == 11 || $data['MONTH'] == 12){
            $quarter    = 4;
        }
        $data['QUARTER']            = $quarter;
        $data['DAY']                = intval(date('d',  $createTime));
        
        $subData['RECORD_DESC']     = request_var('RECORD_DESC');
        $subData['ATTACHMENT_ID']   = request_var('ATTACHMENT_ID');
        $subData['ATTACHMENT_NAME'] = request_var('ATTACHMENT_NAME');
        $records    = $this->_IncomeExpend->getRecordsByPlanId($data['PLAN_ID']);
        
        $paymentData['REAL_EXPENSE'] = $data['EXPENSE'];
        $paymentData['REAL_REVENUE'] = $data['REVENUE'];
        if($records){
            foreach($records as $key => $value){
                $paymentData['REAL_EXPENSE'] += $value['EXPENSE'];
                $paymentData['REAL_REVENUE'] += $value['REVENUE'];
            }
        }
        $paymentData['UPDATE_TIME'] = $createTime;
        $result     = $this->_IncomeExpend->addPaymentRecord($data, $subData,$paymentData);
        echo $result;
    }
    public function editDo()
    {
        $recordId       = request_var('recordId', 0);
        if ($recordId == 0) {
            echo 0;exit;
        }

        $expense        = request_var('expense', 0);
        $revenue        = request_var('revenue', 0);
        if($expense< 0 || $revenue < 0) {
            echo 0;exit;
        }

        $recordDesc     = request_var('recordDesc', '');
        $attachmentId   = request_var('attachment_id');
		$attachmentName = request_var('attachment_name');
        $recordInfo     = $this->_IncomeExpend->getSimpleRecordInfo($recordId);
        $oldExpense     = $recordInfo['EXPENSE'];
        $oldRevenue     = $recordInfo['REVENUE'];
        $planId         = $recordInfo['PLAN_ID'];
        $year           = $recordInfo['YEAR'];
        $month          = $recordInfo['MONTH'];

        $planInfo       = $this->_IncomeExpend->planInfo($planId);
        $realExpense    = $planInfo['REAL_EXPENSE'];
        $realRevenue    = $planInfo['REAL_REVENUE'];
        $newRealExpense = $realExpense + $expense - $oldExpense;
        $newRealRevenue = $realRevenue + $revenue - $oldRevenue;
        
        $data = array(
            'RECORD_ID'     => $recordId,
            'EXPENSE'       => $expense,
            'REVENUE'       => $revenue,
            'RECORD_DESC'   => $recordDesc,
			'ATTACH_ID'		=> $attachmentId,
			'ATTACH_NAME'	=> $attachmentName
        );
        $paymentData = array(
            'PLAN_ID'       => $planId,
            'REAL_EXPENSE'  => $newRealExpense,
            'REAL_REVENUE'  => $newRealRevenue,
            'UPDATE_TIME'   => time()
        );
        if($result = $this->_IncomeExpend->editPaymentRecord($data, $paymentData)) {
            $in     = 0;
            $out    = 0;
            if($records    = $this->_IncomeExpend->getRecords($year,$month)) {
                foreach ($records as $key => $value) {
                    $in     += $value['REVENUE'];
                    $out    += $value['EXPENSE'];
                }
            } 
            $data = array(
                    'IN'    => $in,
                    'OUT'   => $out,
                );
            $where = array(
                    'year'  => $year,
                    'month' => $month
                );
            $this->_IncomeExpend->updateStat($data,$where);
        }
        
        echo $result;
    }
	public function deleteAttachment()
	{
		global $ATTACH_PATH;
		$recordId       = request_var('recordId', 0);
		$attachmentId   = request_var('attachmentId', '');
		$attachmentName = request_var('attachmentName','');
		if($attachmentId == '' || $attachmentName == '') {
			echo 0;exit;
		}
		$recordInfo			= $this->_IncomeExpend->getSimpleRecordInfo($recordId);
		$attachmentIdStr	= $recordInfo['ATTACHMENT_ID'];
		$attachmentNameStr	= $recordInfo['ATTACHMENT_NAME'];
		$attachmentIdStr	= str_replace($attachmentId . ',','',$attachmentIdStr);
		$attachmentNameStr	= str_replace($attachmentName . '*','',$attachmentNameStr);
		if($this->_IncomeExpend->updateRecordAttachment($attachmentIdStr,$attachmentNameStr,$recordId)) {
			Tool::deldir($ATTACH_PATH . $attachmentId);
			echo json_encode(array('attachment_id' => $attachmentIdStr,'attachment_name' => $attachmentNameStr));exit;
		}
		echo 0;
	}
    public function delete()
    {
        $recordId       = request_var('recordId', 0);
        if ($recordId == 0) {
            echo 0;exit;
        }

        $recordInfo     = $this->_IncomeExpend->getSimpleRecordInfo($recordId);
        $oldExpense     = $recordInfo['EXPENSE'];
        $oldRevenue     = $recordInfo['REVENUE'];
        $planId         = $recordInfo['PLAN_ID'];
        $year           = $recordInfo['YEAR'];
        $month          = $recordInfo['MONTH'];

        $planInfo       = $this->_IncomeExpend->planInfo($planId);
        $realExpense    = $planInfo['REAL_EXPENSE'];
        $realRevenue    = $planInfo['REAL_REVENUE'];
        $newRealExpense = $realExpense  - $oldExpense;
        $newRealRevenue = $realRevenue  - $oldRevenue;
        
        $paymentData    = array(
            'PLAN_ID'       => $planId,
            'REAL_EXPENSE'  => $newRealExpense,
            'REAL_REVENUE'  => $newRealRevenue,
            'UPDATE_TIME'   => time()
        );
        if($result = $this->_IncomeExpend->deletePaymentRecord($recordId, $paymentData)) {
            $in     = 0;
            $out    = 0;
            $times   = 0;
            if($records    = $this->_IncomeExpend->getRecords($year,$month)) {
                foreach ($records as $key => $value) {
                    $in     += $value['REVENUE'];
                    $out    += $value['EXPENSE'];
                }
            } 
            $times = sizeof($records);
            $data = array(
                    'IN'    => $in,
                    'OUT'   => $out,
                    'TIMES' => $times
                );
            $where = array(
                    'year'  => $year,
                    'month' => $month
                );
            $this->_IncomeExpend->updateStat($data,$where);
        }
        echo $result;
    }
    /**
     * 按一天统计收支数据
     */
    public function oneDayStat(){
        $year           = intval(request_var('year'));
        $month          = intval(request_var('month'));
        $day            = intval(request_var('day'));
        $stat = $this->_IncomeExpend->oneDayStat($year,$month,$day);
        $_stat = array();
        $expenseTotal = 0;
        $revenueTotal = 0;
        $inOutTotal   = 0;
        $timesTotal    = 0;
        foreach($stat as $key => $value){
            $expenseTotal       += $value['EXPENSE'];
            $revenueTotal       += $value['REVENUE'];
            $timesTotal         += $value['TIMES'];
            $inOutTotal         += ($value['REVENUE']-$value['EXPENSE']);
            $value['_EXPENSE']   = Tool::money2($value['EXPENSE']);
            $value['_REVENUE']   = Tool::money2($value['REVENUE']);
            $value['IN_OUT']     = Tool::money2($value['REVENUE']-$value['EXPENSE']);   
            $_stat[]             = $value;
        }
         $_stat[] = array(
            'expenseTotal'  => Tool::money2($expenseTotal),
            'revenueTotal'  => Tool::money2($revenueTotal),
            'inOutTotal'    => Tool::money2($inOutTotal),
            'timesTotal'    => $timesTotal
        );
        file_put_contents('include/export_tmp/one_day_data.txt',json_encode($_stat));
        echo json_encode($_stat);exit;
    }
    /**
     * 导出收支数据到excel表
     */
    public function export(){
        global $_lang;
        $year       = request_var('year');
        $month      = request_var('month');
        $planName   = request_var('planName','');
        $exportType = request_var('exportType');
        $diffType   = request_var('diffType');
        require_once 'newplugins/PHPExcel_1.8.0/Classes/PHPExcel.php';  
        require_once 'newplugins/PHPExcel_1.8.0/Classes/PHPExcel/Writer/Excel5.php';
        $objExcel   = new PHPExcel();  // 创建一个处理对象实例 
        $objProps   = $objExcel->getProperties();

        $diffData   = array();
        if($diffType == 2){
            $diffData   = file_get_contents('include/export_tmp/diff_data.txt');
            $diffData   = json_decode($diffData,true);
            $planNameArr = explode(',', $planName);
        }
        if($exportType == 'all_month'){
            $title      = $year.$_lang["incomeexpend_year"].$_lang["incomeexpend_all_year_month"].$_lang["incomeexpend_payment_stat_table"];
            if($planName != ''){
                $title   = $planName.' '.$title;
            }
            $title= mb_convert_encoding($title, 'gbk', 'utf-8');

            $data   = file_get_contents('include/export_tmp/all_month_data.txt');
            $data   = json_decode($data,true);
            $this->setSheet($objExcel,0,$data,$_lang["incomeexpend_all"],13,$_lang["incomeexpend_month"]);
            $sheet = 1;
            if($diffData){
                $i = 0;
                foreach($diffData as $key => $value){
                    $objExcel->createSheet();
                    $this->setSheet($objExcel,$sheet++,$value,$planNameArr[$i++],13,$_lang["incomeexpend_month"]);
                }
            }
        }elseif($exportType == 'all_jj'){
            $title      = $year.$_lang["incomeexpend_year"].$_lang["incomeexpend_all_year_quarter"].$_lang["incomeexpend_payment_stat_table"];
            if($planName != ''){
                $title   = $planName.' '.$title;
            }
            $title= mb_convert_encoding($title, 'gbk', 'utf-8');
            $data   = file_get_contents('include/export_tmp/all_quarter_data.txt');
            $data   = json_decode($data,true);
            $this->setSheet($objExcel,0,$data,$_lang["incomeexpend_all"],5,$_lang["incomeexpend_quarter"]);
            $sheet = 1;
            if($diffData){
                $i = 0;
                foreach($diffData as $key => $value){
                    $objExcel->createSheet();
                    $this->setSheet($objExcel,$sheet++,$value,$planNameArr[$i++],5,$_lang["incomeexpend_quarter"]);
                }
            }
        }elseif($exportType == 'one_month'){
            $title      = $year.$_lang["incomeexpend_year"].$month.$_lang["incomeexpend_mon"].$_lang["incomeexpend_payment_stat_table"];
            if($planName != ''){
                $title   = $planName.' '.$title;
            }
            $title= mb_convert_encoding($title, 'gbk', 'utf-8');
            $data   = file_get_contents('include/export_tmp/one_month_data.txt');
            $data   = json_decode($data,true);
            $total  = $data['total'];
            $list   = $data['list'];
            $this->setSheet($objExcel,0,$list,$_lang["incomeexpend_all"],$total,$_lang["incomeexpend_days"]);
            $sheet = 1;
            if($diffData){
                $i = 0;
                foreach($diffData as $key => $value){
                    $objExcel->createSheet();
                    $this->setSheet($objExcel,$sheet++,$value,$planNameArr[$i++],$total,$_lang["incomeexpend_days"]);
                }
            }
        }
        $objWriter = new PHPExcel_Writer_Excel5($objExcel);
        header("Pragma: public");
        header("Expires: 0");
        header("Cache-Control:must-revalidate, post-check=0, pre-check=0");
        header("Content-Type:application/force-download");
        header("Content-Type:application/vnd.ms-execl");
        header("Content-Type:application/octet-stream");
        header("Content-Type:application/download");
        header('Content-Disposition:attachment;filename="'.$title.'.xls"');
        header("Content-Transfer-Encoding:binary");
        $objWriter->save('php://output');
    }
    /**
     * 设置excel的当前sheet属性
     * @param type $objExcel
     * @param type $sheet
     * @param type $data
     * @param type $title
     * @param type $lastNum
     * @param type $firstName
     */
    public function setSheet($objExcel,$sheet,$data,$title,$lastNum,$firstName){
        global $_lang;
        $objExcel->setActiveSheetIndex($sheet);
        $objActSheet = $objExcel->getActiveSheet();
        $objActSheet->setTitle($title);  
        $objActSheet->getColumnDimension('A')->setWidth(10);
        $objActSheet->getColumnDimension('B')->setWidth(25);
        $objActSheet->getColumnDimension('C')->setWidth(25);
        $objActSheet->getColumnDimension('D')->setWidth(25);
        $objActSheet->getColumnDimension('E')->setWidth(15);
        $objActSheet->getDefaultRowDimension('A')->setRowHeight(25);
        $objActSheet->getDefaultRowDimension('B')->setRowHeight(25);
        $objActSheet->getDefaultRowDimension('C')->setRowHeight(25);
        $objActSheet->getDefaultRowDimension('D')->setRowHeight(25);
        $objActSheet->getDefaultRowDimension('E')->setRowHeight(25);
        $objActSheet->setCellValue('A1', $firstName);
        $objActSheet->setCellValue('B1', $_lang["incomeexpend_expense_money"]);
        $objActSheet->setCellValue('C1', $_lang["incomeexpend_revenue_money"]);
        $objActSheet->setCellValue('D1', $_lang["incomeexpend_in_out"]);
        $objActSheet->setCellValue('E1', $_lang["incomeexpend_record_size"]);
        foreach ($data as $key => $value){
            $k = $key+1;
            if($key == $lastNum){
                $objActSheet->setCellValue('A'.$k, $_lang["incomeexpend_stat_total"]);
            }else{
                $objActSheet->setCellValue('A'.$k, $key);
            }
            $objActSheet->setCellValue('B'.$k, $value['OUT']);
            $objActSheet->setCellValue('C'.$k, $value['IN']);
            $objActSheet->setCellValue('D'.$k, $value['IN_OUT']);
            $objActSheet->setCellValue('E'.$k, $value['TIMES']);
        }
        $objStyleA5 = $objActSheet->getStyle('A5');  
        $objFontA5 = $objStyleA5->getFont();  
        $objFontA5->setName('Courier New');  
        $objFontA5->setSize(10);  
        $objFontA5->getColor()->setRGB('333333'); 

        $objAlignA5 = $objStyleA5->getAlignment();  
        $objAlignA5->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);  
        $objAlignA5->setVertical(PHPExcel_Style_Alignment::VERTICAL_CENTER);

        $objBorderA5 = $objStyleA5->getBorders();  
        $objBorderA5->getTop()->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN);  
        $objBorderA5->getTop()->getColor()->setRGB('B7E0FE');
        $objBorderA5->getBottom()->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN);  
        $objBorderA5->getBottom()->getColor()->setRGB('B7E0FE');
        $objBorderA5->getLeft()->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN); 
        $objBorderA5->getLeft()->getColor()->setRGB('B7E0FE');
        $objBorderA5->getRight()->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN); 
        $objBorderA5->getRight()->getColor()->setRGB('B7E0FE');
        $objActSheet->duplicateStyle($objStyleA5, 'A1:E'.($lastNum+1)); 
        $objActSheet->getStyle('A1')->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID);
        $objActSheet->getStyle('A1')->getFill()->getStartColor()->setRGB('DBF0FF');
        $objActSheet->getStyle('B1')->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID);
        $objActSheet->getStyle('B1')->getFill()->getStartColor()->setRGB('DBF0FF');
        $objActSheet->getStyle('C1')->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID);
        $objActSheet->getStyle('C1')->getFill()->getStartColor()->setRGB('DBF0FF');
        $objActSheet->getStyle('D1')->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID);
        $objActSheet->getStyle('D1')->getFill()->getStartColor()->setRGB('DBF0FF');
        $objActSheet->getStyle('E1')->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID);
        $objActSheet->getStyle('E1')->getFill()->getStartColor()->setRGB('DBF0FF');
        $objActSheet->getStyle('A1')->getFont()->setName('微软雅黑');
        $objActSheet->getStyle('A1')->getFont()->setBold(true);
        $objActSheet->getStyle('B1')->getFont()->setName('微软雅黑');
        $objActSheet->getStyle('B1')->getFont()->setBold(true);
        $objActSheet->getStyle('C1')->getFont()->setName('微软雅黑');
        $objActSheet->getStyle('C1')->getFont()->setBold(true);
        $objActSheet->getStyle('D1')->getFont()->setName('微软雅黑');
        $objActSheet->getStyle('D1')->getFont()->setBold(true);
        $objActSheet->getStyle('E1')->getFont()->setName('微软雅黑');
        $objActSheet->getStyle('E1')->getFont()->setBold(true);
    }
    /**
     *  导出一天的收支数据到excel表
     */
    public function exportOneDay(){
        global $_lang;
        $year       = request_var('year');
        $month      = request_var('month');
        $day        = request_var('day');
        $data       = file_get_contents('include/export_tmp/one_day_data.txt');
        $data       = json_decode($data,true);
        $total      = sizeof($data);
        $title      = $year.$_lang["incomeexpend_year"].$month.$_lang["incomeexpend_mon"].$day.$_lang["incomeexpend_ri"].$_lang["incomeexpend_payment_stat_table"];
        require_once 'newplugins/PHPExcel_1.8.0/Classes/PHPExcel.php';  
        require_once 'newplugins/PHPExcel_1.8.0/Classes/PHPExcel/Writer/Excel5.php';
        $objExcel   = new PHPExcel();  // 创建一个处理对象实例 
        $objProps   = $objExcel->getProperties();
        $objExcel->setActiveSheetIndex(0);
        $objActSheet = $objExcel->getActiveSheet();
        $objActSheet->setTitle($title);  
        $objActSheet->getColumnDimension('A')->setWidth(30);
        $objActSheet->getColumnDimension('B')->setWidth(25);
        $objActSheet->getColumnDimension('C')->setWidth(25);
        $objActSheet->getColumnDimension('D')->setWidth(25);
        $objActSheet->getColumnDimension('E')->setWidth(15);
        $objActSheet->getDefaultRowDimension('A')->setRowHeight(25);
        $objActSheet->getDefaultRowDimension('B')->setRowHeight(25);
        $objActSheet->getDefaultRowDimension('C')->setRowHeight(25);
        $objActSheet->getDefaultRowDimension('D')->setRowHeight(25);
        $objActSheet->getDefaultRowDimension('E')->setRowHeight(25);
        $objActSheet->setCellValue('A1', $_lang["incomeexpend_plan_name"]);
        $objActSheet->setCellValue('B1', $_lang["incomeexpend_expense_money"]);
        $objActSheet->setCellValue('C1', $_lang["incomeexpend_revenue_money"]);
        $objActSheet->setCellValue('D1', $_lang["incomeexpend_in_out"]);
        $objActSheet->setCellValue('E1', $_lang["incomeexpend_record_size"]);
        foreach ($data as $key => $value){
            $k = $key+2;
            if($k == $total+1){
                $objActSheet->setCellValue('A'.$k, $_lang["incomeexpend_stat_total"]);
                $objActSheet->setCellValue('B'.$k, $value['expenseTotal']);
                $objActSheet->setCellValue('C'.$k, $value['revenueTotal']);
                $objActSheet->setCellValue('D'.$k, $value['inOutTotal']);
                $objActSheet->setCellValue('E'.$k, $value['timesTotal']);
            }else{
                $objActSheet->setCellValue('A'.$k, $value['PLAN_NAME']);
                $objActSheet->setCellValue('B'.$k, $value['EXPENSE']);
                $objActSheet->setCellValue('C'.$k, $value['REVENUE']);
                $objActSheet->setCellValue('D'.$k, $value['IN_OUT']);
                $objActSheet->setCellValue('E'.$k, $value['TIMES']);
            }
           
        }
        $objStyleA5 = $objActSheet->getStyle('A5');  
        $objFontA5 = $objStyleA5->getFont();  
        $objFontA5->setName('Courier New');  
        $objFontA5->setSize(10);  
        $objFontA5->getColor()->setRGB('333333'); 

        $objAlignA5 = $objStyleA5->getAlignment();  
        $objAlignA5->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);  
        $objAlignA5->setVertical(PHPExcel_Style_Alignment::VERTICAL_CENTER);

        $objBorderA5 = $objStyleA5->getBorders();  
        $objBorderA5->getTop()->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN);  
        $objBorderA5->getTop()->getColor()->setRGB('B7E0FE');
        $objBorderA5->getBottom()->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN);  
        $objBorderA5->getBottom()->getColor()->setRGB('B7E0FE');
        $objBorderA5->getLeft()->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN); 
        $objBorderA5->getLeft()->getColor()->setRGB('B7E0FE');
        $objBorderA5->getRight()->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN); 
        $objBorderA5->getRight()->getColor()->setRGB('B7E0FE');
        $objActSheet->duplicateStyle($objStyleA5, 'A1:E'.($total+2)); 
        $objActSheet->getStyle('A1')->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID);
        $objActSheet->getStyle('A1')->getFill()->getStartColor()->setRGB('DBF0FF');
        $objActSheet->getStyle('B1')->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID);
        $objActSheet->getStyle('B1')->getFill()->getStartColor()->setRGB('DBF0FF');
        $objActSheet->getStyle('C1')->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID);
        $objActSheet->getStyle('C1')->getFill()->getStartColor()->setRGB('DBF0FF');
        $objActSheet->getStyle('D1')->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID);
        $objActSheet->getStyle('D1')->getFill()->getStartColor()->setRGB('DBF0FF');
        $objActSheet->getStyle('E1')->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID);
        $objActSheet->getStyle('E1')->getFill()->getStartColor()->setRGB('DBF0FF');
        $objActSheet->getStyle('A1')->getFont()->setName('微软雅黑');
        $objActSheet->getStyle('A1')->getFont()->setBold(true);
        $objActSheet->getStyle('B1')->getFont()->setName('微软雅黑');
        $objActSheet->getStyle('B1')->getFont()->setBold(true);
        $objActSheet->getStyle('C1')->getFont()->setName('微软雅黑');
        $objActSheet->getStyle('C1')->getFont()->setBold(true);
        $objActSheet->getStyle('D1')->getFont()->setName('微软雅黑');
        $objActSheet->getStyle('D1')->getFont()->setBold(true);
        $objActSheet->getStyle('E1')->getFont()->setName('微软雅黑');
        $objActSheet->getStyle('E1')->getFont()->setBold(true);
        $objWriter = new PHPExcel_Writer_Excel5($objExcel);
        header("Pragma: public");
        header("Expires: 0");
        header("Cache-Control:must-revalidate, post-check=0, pre-check=0");
        header("Content-Type:application/force-download");
        header("Content-Type:application/vnd.ms-execl");
        header("Content-Type:application/octet-stream");
        header("Content-Type:application/download");
        header('Content-Disposition:attachment;filename="'.$title.'.xls"');
        header("Content-Transfer-Encoding:binary");
        $objWriter->save('php://output');
    }
    public function recordDetail(){
        $detailInfo     = request_var('detailInfo');
        $revenueRows = explode('|＃|', $detailInfo);
        if(empty($revenueRows[0])){
            array_shift($revenueRows);
        }
        array_pop($revenueRows);
        $detailArray = array();
        foreach($revenueRows as $row){
            $columns        = explode('`*`', $row);
            $row            = array();
            $row[0]         = $columns[0];
            $row[1]         = Tool::money2($columns[1]);
            $detailArray[]  = $row;
        }
        echo json_encode($detailArray);
    }
}
