<?php
/**
 *@Copyright (C) 2015 - 2015 Weaver Co.Ltd
 *@systemname:       E-Office
 *@filename:         general/income_expend/proxy/SelectPlan.proxy.php
 *@function:         收支方案选择器代理类
 *@encoding:         $_lang['encoding']
 *@author:           www.weaver.com.cn
 *@modify:           lizhijun
 *@date:             2015-04-22
 *@file Version:     1.0
 *@eoffice Version:  9.0
*/
class SelectPlanProxy {
    private $_funcId;
    private $_userId;
    private $_deptId;
    private $_privId;
    private $_IncomeExpend;
    public function __construct($funcId,$userId,$privId,$deptId) {
        $this->_funcId = $funcId;
        $this->_userId = $userId;
        $this->_deptId = $deptId;
        $this->_privId = $privId;
        $this->_IncomeExpend = new IncomeExpend();
    }
    /**
     * 获取方案类别
     */
    public function init(){
        $planTypeLists  = $this->_IncomeExpend->planTypeLists();//获取方案类别
        echo json_encode($planTypeLists);
    }
    /**
     * 获取收支方案列表
     */
    public function lists(){
        $authType       = request_var('authType');//获取权限类型
        if($authType == 'all'){
            $userId     = 'admin';
        }else{
            $userId     = $this->_userId;
        }
        if($userId == 'admin'){
            $defaultSortField = 'PLAN_ID';
        }else{
            $defaultSortField = 'CREATE_TIME';
        }
        $pageSize       = 15;
        $currentPage    = request_var('currentPage',0);  
        $filter         = request_var('FILTER','all');
        $planType       = request_var('PLAN_TYPE','all');
        $keyValue       = request_var('keyword');
        $neq            = array('p.STATUS' => 0);
        if($authType == 'all'){
            $neq['p.PLAN_STATE']  = 0;      
        }else{
            $eq         = array('p.PLAN_STATE' => 1);
        }
        $gt             = array();
        if($planType != 'all'){
            $eq['p.PLAN_TYPE']    = $planType;
            $gt['p.PLAN_TYPE']    = $planType;
        } 
        if($keyValue != ''){
            $like['p.PLAN_NAME']  = $keyValue;
        }
        switch ($filter) {
            case 'last7d':
                $seconds  = time() - 7*24*3600; 
                $gt['p.CREATE_TIME']  = $seconds;      
                break;
            case 'last1m':
                $seconds  = time() - 30*24*3600;
                $gt['p.CREATE_TIME']  = $seconds; 
                break;
            case 'last3m':
                $seconds  = time() - 3*30*24*3600;
                $gt['p.CREATE_TIME']  = $seconds; 
                break;
            default:
                break;
        }
        $start          = $pageSize * $currentPage;
        $selectName     = array('p.PLAN_ID','p.PLAN_CODE','p.PLAN_NAME','pt.TYPE_NAME','p.PLAN_STATE','p.EXPENSE_BUDGET','p.REVENUE_BUDGET','p.PLAN_CYCLE','p.PLAN_CYCLE_UNIT');
        $condition      = array('eq' => $eq,'gt' => $gt,'like' => $like,'neq' => $neq);
        $order          = array($defaultSortField => 'DESC');
        
        $this->_IncomeExpend->pageSize   = $pageSize;
        $this->_IncomeExpend->userId     = $userId;
        $this->_IncomeExpend->deptId     = $this->_deptId;
        $this->_IncomeExpend->privId     = $this->_privId;
        $this->_IncomeExpend->userSelect = true;
        $planLists = $this->_IncomeExpend->planLists($selectName, true, $start, $condition,$order,'','AND');
        echo json_encode($planLists);
    }
}
