<?php
/**
 * 工具类
 */
class Tool {
    /**
    * 生成动态密码
    */
    public function randPassWd($len=6,$format="0"){
        switch($format) { 
            case '0':
                $chars='ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789'; 
                break;
            case '1':
                $chars='ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789'; 
                break;
            case '2':
                $chars='abcdefghijklmnopqrstuvwxyz0123456789'; 
                break;
            case '3':
                $chars='ABCDEFGHIJKLMNOPQRSTUVWXYZ'; 
                break;
            case '4':
                $chars='abcdefghijklmnopqrstuvwxyz'; 
                break;
            case '5':
                $chars='0123456789'; 
                break;
            default :
                $chars='ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789'; 
                break;
        }
        mt_srand((double)microtime()*1000000*getmypid());
        $password='';
        while(strlen($password)<$len){
            $password .=substr($chars,(mt_rand()%strlen($chars)),1);
        }
        return $password;
    }
    /*
    * 获取附件后缀
    */
    public static function getFileExtension($file){
        $pos  = strrpos($file, '.');
        $ext = substr($file,$pos);
        return $ext;
    }
    /*
    * 创建缩略图
    */  
    public static function createThumb($targetFile,$thumbFile,$ext){
        $dstW=90;//缩略图宽
        $dstH=52;//缩略图高
        if(@imagecreatefromgif($targetFile)){
            $src_image=imagecreatefromgif($targetFile);
        }else if(@imagecreatefrompng($targetFile)){
             $src_image=imagecreatefrompng($targetFile);
        }else if(@imagecreatefromjpeg($targetFile)){
            $src_image=imagecreatefromjpeg($targetFile);
        }
        switch (strtolower($ext)) {
            case '.jpeg':
                $srcW=imagesx($src_image); //获得图片宽
                $srcH=imagesy($src_image); //获得图片高
                $dst_image=imagecreatetruecolor($dstW,$dstH);
                imagecopyresized($dst_image,$src_image,0,0,0,0,$dstW,$dstH,$srcW,$srcH);
                return imagejpeg($dst_image,$thumbFile);
                break;
            case '.png':
                $srcW=imagesx($src_image); //获得图片宽
                $srcH=imagesy($src_image); //获得图片高
                $dst_image=imagecreatetruecolor($dstW,$dstH);
                imagecopyresized($dst_image,$src_image,0,0,0,0,$dstW,$dstH,$srcW,$srcH);
                return imagepng($dst_image,$thumbFile);
                break;
            case '.jpg':;
                $srcW=imagesx($src_image); //获得图片宽
                $srcH=imagesy($src_image); //获得图片高
                $dst_image=imagecreatetruecolor($dstW,$dstH);
                imagecopyresized($dst_image,$src_image,0,0,0,0,$dstW,$dstH,$srcW,$srcH);
                return imagejpeg($dst_image,$thumbFile);
                break;
            case '.gif':
                $srcW=imagesx($src_image); //获得图片宽
                $srcH=imagesy($src_image); //获得图片高
                $dst_image=imagecreatetruecolor($dstW,$dstH);
                imagecopyresized($dst_image,$src_image,0,0,0,0,$dstW,$dstH,$srcW,$srcH);
                return imagegif($dst_image,$thumbFile);
                break;
            default:
                break;
        }
    }
    /**
     * 加载配置文件
     * @staticvar type $config
     * @param type $type
     * @param type $configName
     * @return boolean
     */
    public static function loadConfig($type='php' ,$configName='config'){
        if($configName == ''){
            return false;
        }
        static $config;
        if(isset($config)){
            return $config;
        }
        $type = strtolower($type);
        $configPath = ROOT_PATH.LOGIN_PATH.'include/config/'.$configName.'.'.$type;
        if(!file_exists($configPath)){
            return false;
        }
        switch ($type){
            case 'xml':
                $xml=join("",file($configPath)); 
                $_array = (array)(simplexml_load_string($xml));     
                foreach ($_array as $key=>$item){  
                    $temp                       = structToArray((array)$item);
                    $array[strtoupper($key)]    =  $temp[0];      
                }    
                break;
            case 'php':
                $array = include(LOGIN_PATH.'include/config/'.$configName.'.'.$type);
                break;
            default: 
                $array = include(LOGIN_PATH.'include/config/'.$configName.'.'.$type);
        }
        $config = $array;
        return $array;   
    }                                                       
}
function structToArray($item) {                        
    if(!is_string($item)) {                                
        $item = (array)$item;                                
        foreach ($item as $key=>$val){                       
          $item[$key]  =  structToArray($val);             
        }                                                    
    }                                                      
    return $item;                                          
}
