<?php
define("LOGIN_BG_PATH", ROOT_PATH . "attachment/");
define('LOGIN_BG_SHOW_PATH', '/attachment/');
class LoginProxy {
    
     /**
     *定义类全局变量
     */
    private $_loginObj;             //api类对象
    private $_LOGIN_FLAG = 1;       //是否正确登录
    private $_LOGIN_ERROR = '';     //登录错误信息;
    private $_SEKEY = 'e-office';   //图形验证码的加密key
    private $_userLang;
    private $_lang;
    private $_containLang = array('other','common','login','performance');
    public function __construct() {
        $lang       = $_COOKIE['LOGIN_LANG'];
        if(!$lang){
            $lang = request_var('userLang','cn');
        }
        $this->_userLang = $lang;
        $this->_lang = $this->_getLang($this->_userLang);
        if(!@include_once(LOGIN_PATH .'include/tool/Tool.php')){//导入工具类
            trigger_error('error', E_USER_ERROR);
        }
        if(!@include_once('api/login.class.php')){//导入api类
            trigger_error('error', E_USER_ERROR);
        }
        $this->_loginObj = new Login();
    }
    /**
     * 初始化登录页
     */
    public function init(){
		$OA_UPDATE_FILE="update/2.php";
		if(file_exists($OA_UPDATE_FILE))
		{
			include_once($OA_UPDATE_FILE);
				unlink($OA_UPDATE_FILE);
		}
        $id         = request_var('id',2);
        include_once("building/config/remindBrowserUrl.php");//导入文件
        @session_start();//启动session
        $this->_updateFile();//调用文件更新方法
        $loginInfor = $this->_loginObj->getLoginInfor($id);//获取登录页属性。
        $sysParam   = $this->_loginObj->getSystemParam();//获取系统参数
        $loginLang  = $this->_loginObj->getLoginLang();
        //获取logo，form样式
        $showFlag = true;
        if($loginInfor == false){
            $showFlag   = false;
            $loginInfor = Tool::loadConfig();
        }
        $formCss    = $this->_getFormCss($loginInfor['FORM_X'], $loginInfor['FORM_Y'],$loginInfor['FORM_DIR']);
        $logoCss    = $this->_getLogoCss($loginInfor['LOGO_X'], $loginInfor['LOGO_Y'],$loginInfor['LOGO_DIR']);
        //包含页面文件
        $PAGE_TITLE = $sysParam['IE_TITLE_VALUE'];
        include(VIEW_PATH . 'login.view.php');
    }
    
    /**
     * 登录验证
     */
    public function loginCheck(){
        include_once("inc/utility.php");//导入工具函数文件
        include_once("api/regcheck.class.php");
        $regcheck   = new regcheck();
        $checkFlag  = $regcheck->checkSys();
        if(!$checkFlag){
            echo json_encode(array('flag' =>5,'info' => $this->_lang["common_license_has_expired"]));exit;
        }
        @session_start();//开启session机制
        @ob_start();//打开输出控制缓冲
        $sysParam   = $this->_loginObj->getSystemParam();//获取系统参数 
        $username   = request_var('username');
        $password   = $_REQUEST['password'];
        $goto       = request_var('goto');//跳转到非系统的其他页面
        
        if($this->_LOGIN_FLAG == 1) $this->_checkUpdateFile ();//检查是否有升级程序
        if($this->_LOGIN_FLAG == 1) $this->_ipCheck($username); //IP检验
        if($this->_LOGIN_FLAG == 1) $userInfo = $this->_validateAccount($username,$password,$sysParam); //账户密码验证
        if($sysParam['SEC_PASS_IMG'] == "1" && $goto == '' && $this->_LOGIN_FLAG == 1) $this->_verifyCheck ();//图形验证码验证
        //验证是否是离职人员或删除人员
        if($this->_LOGIN_FLAG == 1) {
            if(!$this->_loginObj->dimissionCheck($userInfo['USER_ID'])){
                $this->_LOGIN_FLAG      = 0;
                $this->_LOGIN_ERROR     = $this->_lang["other_login_error_userdeny"];
            }
        } 
        if($this->_LOGIN_FLAG == 1) $this->_validateEnd($userInfo,$sysParam); //验证成功后的操作
		session_write_close();
        echo json_encode(array('flag' => $this->_LOGIN_FLAG,'info' => $this->_LOGIN_ERROR));
    }
    public function selectLang(){
        $lang = request_var('lang');
        setcookie('LOGIN_LANG', '');
        setcookie('LOGIN_LANG', $lang,time() + 60*60*24*1000);
        setcookie('LOGIN_LANG', $lang,time() + 60*60*24*1000,'/');
        setcookie('LOGIN_LANG', $lang,time() + 60*60*24*1000,'/general/');
        echo 1;
    }
    /**
     * 该函数不要有输出
     * 该函数里面的操作最好加上@
     */
    public function afterLoginEnd(){
        //绩效考核模块调用发送考核函数
        if(@include_once("api/performance.class.php")){
            $performance = new performance();
            $performance->sendKpiInfo('APPROVER');
        }
    }
    /**
     * usbkey验证结束
     */
    public function usbCheckEnd(){
        @session_start();
        if($_SESSION['TMP_LOGIN_USER_ID'] == ""){
            header("login.php");
            exit;
        }
        $LOGIN_USER_ID = $_SESSION['TMP_LOGIN_USER_ID'];
        $_SESSION["LOGIN_USER_ID"] = $LOGIN_USER_ID;

        header("location:/general/index9.php");
    }
    /**
     * 短信动态密码验证
     */
    public function checkMsgPassword(){
        $msgPassword = request_var('msgPassword');
        @session_start();
        if($msgPassword == $_SESSION['SMS_PASSWORD']){
            $_SESSION["LOGIN_USER_ID"] = $_SESSION['TMP_LOGIN_USER_ID'];
            if($_SESSION['LOGIN_USBKEY'])$this->_usbCheckStart($_SESSION["LOGIN_USER_ID"],$_SESSION['LOGIN_USBKEY'],$_SESSION["USBKEY_PIN"]);
            echo 1;
        }else{
            echo 0;
        }
    }
    /**
     * 发送短信动态密码
     * global $connection;
     */
    public function sendSmsPassword(){
        @session_start();//开启session机制
        @ob_start();//打开输出控制缓冲
        $sysParam           = $this->_loginObj->getSystemParam();//获取系统参数 
        $TMP_LOGIN_USER_ID  = $_SESSION["TMP_LOGIN_USER_ID"];
        include_once("inc/mobile_sms.inc.php");
        $newSms = new MobileSms();
        $unitInfo       = $this->_loginObj->getUnitInfo('UNIT_NAME');
        $UNIT_NAME      = $unitInfo['UNIT_NAME'];
        $sms_content    = $this->_lang["other_login_pass"];
        $sms_passwd     = Tool::randPassWd(6,$sysParam['DYNAMIC_LOGIN_SMS']);
        $_SESSION["SMS_PASSWORD"] = $sms_passwd;
        $sms_content .= $sms_passwd;
        $sms_content .= " ".$this->_lang["other_login_you"].date("Y-m-d H:i").$this->_lang["other_login"].$UNIT_NAME.$this->_lang["other_login_system"];
        $newSms->SelfSendMore($TMP_LOGIN_USER_ID,$sms_content);
        echo 1;
    }
    /**
     * 系统升级
     */
    public function updateSystem(){
        $oaUpdateFile = "update/1.php";
        if(file_exists(ROOT_PATH . $oaUpdateFile)){
            include_once($oaUpdateFile);
            @unlink(ROOT_PATH.$oaUpdateFile);
        }
        if(file_exists(ROOT_PATH.'update/logs/update_'.date('Y-m-d').'.log')){
            echo 0;
        }else{
            echo 1;
        }
    }
    /**
     * 加载登录设置页
     */
    public function loginSet(){
        @session_start();//启动session
        //非admin非法访问处理
        if($_SESSION["LOGIN_USER_ID"] != 'admin'){
            $open   = request_var('open');
            if($open){
                $this->loginError(4);exit;
            }else{
                $this->loginError(3);exit;
            }
        }
        $id         = request_var('id',2);
        $sysParam   = $this->_loginObj->getSystemParam();//获取系统参数 
        $loginInfor = $this->_loginObj->getLoginInfor($id);//获取登录页属性。
        $logoDir    = explode(',',$loginInfor['LOGO_DIR']);
        $_logoDir    = $logoDir[0] == 'left' ? 'right' : 'left';
        $formDir    = explode(',', $loginInfor['FORM_DIR']);
        $_formDir    = $formDir[0] == 'left' ? 'right' : 'left';
        
        $formCss    = $this->_getFormCss($loginInfor['FORM_X'], $loginInfor['FORM_Y'],$loginInfor['FORM_DIR']);
        $logoCss    = $this->_getLogoCss($loginInfor['LOGO_X'], $loginInfor['LOGO_Y'],$loginInfor['LOGO_DIR']);
        //包含页面文件
        $PAGE_TITLE = $this->_lang["login_set_page"];
        include(VIEW_PATH . 'login_set.view.php');
    }
    /**
     * 上传logo图片
     */
    public function uploadLogo(){
        if (!empty($_FILES)) {
            $id         = request_var('id',2);
            $tempFile   = $_FILES['Filedata']['tmp_name'];
            $targetPath = LOGIN_BG_PATH . 'logo/';
            if (!file_exists($targetPath)) {
                mkdir($targetPath, 0777, true);
            }
            $type = Tool::getFileExtension($_FILES['Filedata']['name']);
            if(!in_array(strtolower($type), array('.jpg','.jpeg','.png','.gif'))){
                echo 3;exit;
            }
            $_targetFile    = 'logo-login'.$type;
            $targetFile     = str_replace('//', '/', $targetPath) . $_targetFile;
            if(move_uploaded_file($tempFile, $targetFile)){
                $result     = $this->_loginObj->setLoginInfor($id, array('LOGO_IMG' =>$_targetFile), 'setLogo');
                if($result){
                    echo $_targetFile;
                }else{
                    echo 0;
                }
            }else{
                echo 0;
            }
        }else{
            echo 0;
        }   
    }
    /**
     * 上传登录主题背景
     */
    public function uploadTheme(){
        if (!empty($_FILES)) {
            $id         = request_var('id',2);
            $tempFile   = $_FILES['Filedata']['tmp_name'];
            $targetPath = LOGIN_BG_PATH . 'login-bg/';
            $thumbPath  = LOGIN_BG_PATH . 'login-bg/thumb/';
            if (!file_exists($targetPath)) {
                mkdir($targetPath, 0777, true);
            }
            if (!file_exists($thumbPath)) {
                mkdir($thumbPath, 0777, true);
            }
            $this->isThumbFull();//判断图片是否已满
            $ext = Tool::getFileExtension($_FILES['Filedata']['name']);
            if(!in_array(strtolower($ext), array('.jpg','.jpeg','.png','.gif'))){
                echo 3;exit;
            }
            $_targetFile    = 'theme-'. time().$ext;
            $targetFile     = str_replace('//', '/', $targetPath) . $_targetFile;
            $thumbFile      = str_replace('//', '/', $thumbPath) . $_targetFile;
            if(move_uploaded_file($tempFile, $targetFile)){
                if(Tool::createThumb($targetFile, $thumbFile,$ext)){
                    $result     = $this->_loginObj->setLoginInfor($id, array('BACKGROUND_IMG' =>$_targetFile), '');
                    echo $_targetFile;
                }else{
                    echo 4;
                }
            }else{
                echo 0;
            }
        }else{
            echo 0;
        }
    }
    /**
     * 获取所有主题背景图片缩略图
     */
    public function getThumb(){
        $thumbPath = LOGIN_BG_PATH.'login-bg/thumb/';
        $thumbs = array();
        $handler = opendir($thumbPath);
        while( ($filename = readdir($handler)) !== false ){
              if($filename != "." && $filename != ".."){
                list($file, $suffix) = explode(".", $filename);
                if (strtolower($suffix) == "png" || strtolower($suffix) == "jpg" || strtolower($suffix) == "jpeg"||strtolower($suffix) == "gif") {
                    $thumbs[] = $filename;
                }
              }
        }
        closedir($handler);
        array_shift($thumbs);
        rsort($thumbs);
        echo json_encode($thumbs);
    }
    /**
     * 判断图片是否已满
     */
    public function isThumbFull(){
        $thumbPath = LOGIN_BG_PATH.'login-bg/thumb/';
        $thumbs = array();
        $handler = opendir($thumbPath);
        while( ($filename = readdir($handler)) !== false ){
              if($filename != "." && $filename != ".."){
                list($file, $suffix) = explode(".", $filename);
                if (strtolower($suffix) == "png" || strtolower($suffix) == "jpg" || strtolower($suffix) == "jpeg"||strtolower($suffix) == "gif") {
                    $thumbs[] = $filename;
                }
              }
        }
        $size = sizeof($thumbs);
        if($size >= 10){
            echo 2;exit;
        }
    }
    /**
     * 删除登录页主题背景图片
     */
    public function delTheme(){
        $theme = request_var('theme');
        $thumbPic = LOGIN_BG_PATH .'login-bg/thumb/'.$theme;
        $themePic = LOGIN_BG_PATH .'login-bg/'.$theme;
        if(unlink($themePic)){
            if(unlink($thumbPic)){
                echo 1;
            }else{
                echo 0;
            }
        }else{
            echo 0;
        }
    }
    /**
     * 设置登录页信息
     */
    public function setLoginInfor(){
        $info       = request_var('loginInfo');
        $id         = request_var('id',2);
        $method     = request_var('updateMethod');
        $result     = $this->_loginObj->setLoginInfor($id, $info, $method);
        if($result){
            echo 1;exit;
        }
        echo 0;exit;
    }
    /**
     * 恢复默认
     */
    public function recoverDefault(){
        $id         = request_var('id',2);
        $result     = $this->_loginObj->recoverDefault($id);
        if($result){
            echo 1;exit;
        }
        echo 0;
    }
    /**
     * 登录跳转错误信息提示页面
     * @param type $tag
     */
    public function loginError($tag =0){
        $tag    = $tag == 0 ? request_var('tag',0) : $tag;
        switch ($tag){
            case 0:
                header('Location:/'.LOGIN_PATH.'index.php');
                break;
            case 1:
                $info = $this->_lang["login_error_info_one"];
                break;
            case 2:
                $info = $this->_lang["login_error_info_two"];
                break;
            case 3:
                $info = $this->_lang["login_error_info_three"];
                break;
            case 4:
                $info = $this->_lang["login_error_info_four"];
                $loginEdit = 'window';
                break;
            default :
                header('Location:/'.LOGIN_PATH.'index.php');
        }
        $PAGE_TITLE = $this->_lang["login_passd_page"];
        include(VIEW_PATH . 'login_error.view.php');
    }
    /**
     * 文件更新方法。
     */
    private function _updateFile(){
        $oaUpdateFile = "update/2.php";
        if(file_exists(ROOT_PATH . $oaUpdateFile)){
            include_once($oaUpdateFile);
            @unlink(ROOT_PATH . $oaUpdateFile);
        }
    }
    /**
     * 检查是否有更新程序
     */
    private function _checkUpdateFile(){
        if(file_exists(ROOT_PATH . "update/1.php")){
            $this->_LOGIN_FLAG  = 6;
            $this->_LOGIN_ERROR = $this->_lang["login_system_update_now"];
        }
    }
    /**
     * 检查用户名和密码;
     * @global type $connection
     */
    private function _validateAccount($username,$password,$sysParam){
        /*
         * 验证用户名是否存在,是否正确
         */
        if($this->_LOGIN_FLAG && $username != ''){
            $userInfo   = $this->_loginObj->userAccountCheck(array('USER_ACCOUNTS' => $username));
            if(!$userInfo){
                $this->_LOGIN_FLAG  = 0;
                $this->_LOGIN_ERROR = $this->_lang["other_login_error_username"];
                add_log(10,"USER_ACCOUNTS=$username",$username);
            }
        }
        /*
         * 验证密码是否正确或是否过期
         */
        if($this->_LOGIN_FLAG){
            $userInfo["LOGIN_THEME"]  = $userInfo["THEME"] == '' ? 'theme1' : $userInfo["THEME"];
            $userInfo['MENU_TYPE']    = 2 - $userInfo["MENU_TYPE"];  
            if(crypt($password,$userInfo["PASSWORD"])!= $userInfo["PASSWORD"]){
                $error_pwd = maskstr($password,2,1);
                $this->_LOGIN_FLAG = 0;
                $this->_LOGIN_ERROR = $this->_lang["other_login_error_password_update"];
                add_log(2,$error_pwd,$username);
            }
        }
        
         //动态密码验证
        if($this->_LOGIN_FLAG)
        {
            if(isDynamiCode() == 1) {
            $userSecext = $this->_loginObj->getUserSecext($userInfo["USER_ID"]);
            if($userSecext)
            {
                $isDynami = $userSecext["IS_DYNAMI_CODE"];
                $snNum    = $userSecext["SN_NUM"];
			
                //动联动态码验证
                if($isDynami == '1') {
                    if($snNum == "") {
                        $this->_LOGIN_FLAG = 0;
                        $this->_LOGIN_ERROR = $this->_lang["other_dynamicode_not_use"];
                    }
                    $host   = $sysParam['DYNAMI_ADDR'];
                    if($host != '') {
                        //校验动态码     
                        $dynamiCode = request_var("dynamiCode");
                        if(trim($dynamiCode) == "") {
                            $this->_LOGIN_FLAG  = 0;
                            $this->_LOGIN_ERROR = $this->_lang["login_dynami_code_null"];
                        } else {
                            $result = @file_get_contents($host."/tokenDL/index.jsp?TYPE=checkKey&SN_NUM=".trim($snNum)."&TOKENCODE=".trim($dynamiCode));
                            if($result == "") {
                                $this->_LOGIN_FLAG  = 0;
                                $this->_LOGIN_ERROR = $this->_lang["login_server_link_error"];
                            } else {
                                $this->_LOGIN_FLAG  = 0;                                       
                                if (strstr($result,"13")){
                                    $this->_LOGIN_ERROR = $this->_lang["login_dynami_code_error"];
                                }else if(strstr($result,"14")){   
                                    //动态令牌默认设置1分钟内只允许校验一次
                                    $this->_LOGIN_ERROR = $this->_lang["login_dynami_certi_failure"];
                                }else if (strstr($result,"15")){
                                    $this->_LOGIN_ERROR = $this->_lang["login_token_error"] . "<a href='#' onclick=\"javascript:location.href='/syncCode.php'\">".$this->_lang["login_synchronous_token"]."</a>";
                                }else if(strstr(trim($result),"208")){
                                    $this->_LOGIN_ERROR = $this->_lang["login_dynami_length_error"];
                                }else if(strstr($result,"7") || strstr($result,"100")){
                                    $this->_LOGIN_ERROR = $this->_lang["login_token_check_error"] . "<a href='#' onclick=\"javascript:location.href='/syncCode.php'\">".$this->_lang["login_synchronous_token"]."</a>".$this->_lang["login_or"]."<a href='#' onClick=\"javascript:location.href='/bindkey.php?USER_ID=".$userInfo["USER_ID"]."'\">".$this->_lang["login_bind_token"]."</a>";   
                                }else if ($result == 1 || $result == 0){
                                    //$result返回值包含0表示此动态码第一次验证,包含1表示绑定后验证的返回值
                                    $this->_LOGIN_FLAG  = 1;
                                }else{
                                    $this->_LOGIN_ERROR = $this->lang["login_dynami_code_error"];   
                                }
                            }
                        }           
                    } else {
                        $this->_LOGIN_FLAG = 0;
                        $this->_LOGIN_ERROR = $this->_lang["other_dynamicode_serveraddr_null"];
                    }
                }
                }
            }
        }
        return $userInfo;
    }
    /**
     * 获取登录语言包 
     * @param type $userLang
     * @return \type
     */
    private function _getLang($userLang){
        global $_lang;
        foreach($this->_containLang as $value){
            include_once("lang/".$userLang."/".$value.".lang.php");
        }      
        return $_lang;
    }
    /**
     * IP检验
     */
    private function _ipCheck($username = ''){
        $USER_IP = $_SERVER["REMOTE_ADDR"];
        if(!check_ip($USER_IP,"0",$username)){
            add_log(9,"USER_ACCOUNT=$username",$username);
            $this->_LOGIN_ERROR = str_replace("USER_IP",$USER_IP,$this->_lang["other_login_error_ip"]);
            $this->_LOGIN_FLAG = 0;
        }
    }
    /**
     * 图形码验证
     */
    private function _verifyCheck(){
        $verify        = request_var('verify');
        $passImgNum  = isset($_SESSION['verify_code']) ? $_SESSION['verify_code'] : '';
        if($verify && session_is_registered("verify_code")){
            if($this->_authCode(strtoupper($verify)) != $passImgNum){
                $this->_LOGIN_ERROR = $this->_lang["other_login_error_graphcode"];
                $this->_LOGIN_FLAG  = 0;
            }
        }else{
            $this->_LOGIN_ERROR = $this->_lang["other_login_error_graphcode"];
            $this->_LOGIN_FLAG  = 0;
        }
    }
    /* *
     * 加密图形验证码 
     */
    private function _authCode($str){
        $key = substr(md5($this->_SEKEY), 5, 8);
        $str = substr(md5($str), 8, 10);
        return md5($key . $str);
    }
    /**
     * 验证正确后做相应处理动作
     */
    private function _validateEnd($userInfo = array(),$sysParam=array()){
        global $IS_REGISTERED_MYOA,$IS_OFFICIAL_CLIENT;
        ////////////////////检查上次访问时间及更新访问时间////////////////////////
        $laborCheck             = $this->_loginObj->laborCheck();//人事档案检查标志 
        $officeitemNeedCheck    = $this->_loginObj->officeitemNeedCheck();//办公用品检查标志
        $this->_loginObj->updateUserInfo(array('LAST_VISIT_TIME'=>date('Y-m-d H:i:s')),$userInfo['USER_ID']);//更新用户访问时间
        $LOGIN_FUNC_STR         = $this->_loginObj->getFuncStr($userInfo['USER_PRIV']);//获取有权限的菜单id
        
        $USER_SUB_PRIV          =  $this->_loginObj->getUserSubPriv($userInfo['USER_SUB_PRIV']);//查询用户辅助权限,并一起赋给主权限
        if(!empty($USER_SUB_PRIV))$LOGIN_FUNC_STR = implode(",",array_filter(array_unique(explode(",",$LOGIN_FUNC_STR.",".$USER_SUB_PRIV))));

        $_SESSION["USER_SUB_PRIV"]          =  $USER_SUB_PRIV;
        $_SESSION["LOGIN_LANG_ID"]          = $this->_loginObj->getLangId($this->_userLang);
        $_SESSION["LOGIN_LANG"]             = $this->_userLang;
        $_SESSION["LOGIN_USER_ID"]          = $userInfo['USER_ID'];
        $_SESSION["LOGIN_PASSWORD"]         = $userInfo['PASSWORD'];
        $_SESSION["LOGIN_POST_PRIV"]        = $userInfo["POST_PRIV"];
        $_SESSION["LOGIN_USER_ACCOUNTS"]    = $userInfo['USER_ACCOUNTS'];
        $_SESSION["LOGIN_USER_NAME"]        = $userInfo["USER_NAME"];
        $_SESSION["LOGIN_USER_PRIV"]        = $userInfo["USER_PRIV"];
        $_SESSION["LOGIN_DEPT_ID"]          = $userInfo["DEPT_ID"];
        $_SESSION["LOGIN_AVATAR"]           = $userInfo["AVATAR"];
        $_SESSION["LOGIN_THEME"]            = $userInfo['LOGIN_THEME'] ? $userInfo['LOGIN_THEME'] : 'theme1';
        $_SESSION["LOGIN_FUNC_STR"]         = $LOGIN_FUNC_STR;
        $_SESSION['SMS_LOGIN']              = $userInfo['SMS_LOGIN'];
        $_SESSION["LOGIN_USBKEY"]           = $userInfo['LOGIN_USBKEY'];
        $_SESSION["USBKEY_PIN"]             = $userInfo['USBKEY_PIN'];
        
        setcookie ("USER_NAME_COOKIE",  $userInfo['USER_ACCOUNTS'],time() + 60*60*24*1000);
        setcookie ("LOGIN_LANG",        $this->_userLang,time() + 60*60*24*1000);
        
        //正式客户 需要读取模块授权信息
        $machineCode = get_machine_code(1);
        if($IS_REGISTERED_MYOA && $IS_OFFICIAL_CLIENT){
            $verifyFile = BIN_PATH."auth/".md5($machineCode."eoffice9731").".evf";
            if(file_exists($verifyFile)){
                $_SESSION['MODULE_VERIFY'] = authcode(file_get_contents($verifyFile),"DECODE");
            }else{
                $_SESSION['MODULE_VERIFY'] = "error";
            }
        }

        //增加在线状态和同用户同时登录的限制
        $sessid    = SESSION_ID();
        $vtime     = date('Y-m-d H:i:s',time());
        $this->_loginObj->updateOnline($userInfo['USER_ID'], $sessid, $vtime);
        if($sysParam['SEC_PASS_FLAG'] == '1') $this->_passwordPastCheck($userInfo["LAST_PASS_TIME"],$sysParam['SEC_PASS_TIME']);//密码过期验证
        add_log(1,"",$userInfo['USER_ID']); //添加日志

        affair_sms(); //根据日程安排生成短信息

        birthday_info(); //检查过生日，发送邮件祝福

        if($officeitemNeedCheck == true) officeitem_sms(); //检查办公用品,同一天只检查一次
        /*
         * 人事档案检查
         */
        if($laborCheck == "1") {
            send_mes_to_hr("admin");
            //performSms();
            $laborCheck = false;
        }

        limitdate_flow_sms(); //检查是否有过期的流程需要办理

        if(!$surveyID = input_survey()) $surveyID = 0;//检查是否有首页弹出的调查表
        $_SESSION['quesId'] = $surveyID;
        $this->_userAttend($userInfo['USER_ACCOUNTS'],$userInfo['USER_ID']);//登陆签到
        
        $this->_loginObj->todayWorkCheck();// 当天事务检查
        $this->afterLoginEnd();
        /*
         * 判断是否需要短信动态码登录
         */
        if($userInfo["SMS_LOGIN"] &&  $this->_LOGIN_FLAG == 1 ) {
            $_SESSION["TMP_LOGIN_USER_ID"]  = $_SESSION['LOGIN_USER_ID'];
            $_SESSION["LOGIN_USER_ID"]      = "";
            $this->_LOGIN_FLAG = 2;
            $this->_LOGIN_ERROR = $this->_lang["login_need_send_msg"];
        };
        
        if($userInfo["LOGIN_USBKEY"] &&  $this->_LOGIN_FLAG == 1 ) 
            $this->_usbCheckStart($userInfo['USER_ID'],$userInfo["LOGIN_USBKEY"],$userInfo["USBKEY_PIN"]);//判读是否需要usb验证
    }
     /**
     * 密码过期验证
     * @param type $LAST_PASS_TIME
     */
    private function _passwordPastCheck($lastPassTime,$secPassTime){
        if((time()-strtotime($lastPassTime) >= $secPassTime*24*3600) || $lastPassTime == "0000-00-00 00:00:00"){
            $this->_LOGIN_FLAG = 4;
            $this->_LOGIN_ERROR = $this->_lang["login_password_has_expired"];
        }
    }
     /**
     * @abstract 登录签到
     * @param type $LOGIN_USER_ACCOUNTS
     */
    private function _userAttend($loginUserAccounts,$userId=''){
        include_once("api/attend.class.php");
        $attendClass = new attend();
        $userIp = $_SERVER["REMOTE_ADDR"];	
        if(check_ip($userIp,"1",$loginUserAccounts)==false){
            echo  $this->_lang["index_no_iprule"];
        } else {
            $attendClass->loginSignIn('',$userId);
        }
    }
     /**
     * usb验证
     */
    private function _usbCheckStart($USER_ID,$LOGIN_USBKEY,$USBKEY_PIN){
        if($_SESSION['LOGIN_USER_ID']){
            $TMP_LOGIN_USER_ID             = $_SESSION['LOGIN_USER_ID'];
            $_SESSION["LOGIN_USER_ID"]     = "";
            $_SESSION["TMP_LOGIN_USER_ID"] = $TMP_LOGIN_USER_ID;
        }else if($_SESSION['TMP_LOGIN_USER_ID'] == ""){
            $TMP_LOGIN_USER_ID 		   = $USER_ID;
            $_SESSION["TMP_LOGIN_USER_ID"] = $TMP_LOGIN_USER_ID;
        }
        $this->_LOGIN_FLAG = 3;
        $this->_LOGIN_ERROR = $this->_lang["login_need_insert_usb"];
        if($USBKEY_PIN){
            $USBKEY_PIN = xxtea_decrypt(base64_decode($USBKEY_PIN),"usbkey");
        }
        else
        {
            $USBKEY_PIN = "123456";
        }
        echo json_encode(array('flag' => $this->_LOGIN_FLAG,'info' => $this->_LOGIN_ERROR,'loginUsbKey' => $LOGIN_USBKEY,'usbKeyPin' => $USBKEY_PIN,'userAccount'=>$_SESSION["LOGIN_USER_ACCOUNTS"]));
        exit;
    }
    
    private function _getLogoCss($logoX='default',$logoY='default',$logoDir=''){
        $logoCss = '';
        if($logoX != 'default' && $logoY != 'default' ){
            $logoDirArray = explode(',', $logoDir);
            $dir1    = $logoDirArray[0];
            $dir2    = $logoDirArray[1];
            if($logoX == 'center'){
                $logoCss    .= 'left:50%;margin-left:-150px;';
            }else{
                if($dir1 == 'left'){
                    $logoCss .= 'left:'.$logoX.';';
                }else{
                    $logoCss .= 'right:'.$logoX.';';
                }
            }
            if($logoY == 'middle'){
                $logoCss .= 'top:50%;margin-top:-75px';
            }else{
                if($dir2 == 'top'){
                    $logoCss .= 'top:'.$logoY.';';
                }else{
                    $logoCss .= 'bottom:'.$logoY.';';
                }
            }
        }else{
            $logoCss .= 'left:50%;margin-left:-150px;top:110px';
        }
        return $logoCss;
    }
    private function _getFormCss($formX='default',$formY='default',$formDir=''){
        $formCss = '';
        if($formX != 'default' && $formY != 'default' ){
            $formDirArray = explode(',', $formDir);
            $dir1    = $formDirArray[0];
            $dir2    = $formDirArray[1];
            if($formX == 'center'){
                $formCss .= 'left:50%;margin-left:-150px;';
            }else{
                if($dir1 == 'left'){
                    $formCss .= 'left:'.$formX.';';
                }else{
                    $formCss .= 'right:'.$formX.';';
                }
            }
            if($formY == 'middle'){
                $formCss .= 'top:50%;margin-top:-150px';
            }else{
                if($dir2 == 'top'){
                    $formCss .= 'top:'.$formY.';';
                }else{
                    $formCss .= 'bottom:'.$formY.';';
                }
            }
        }else{
            $formCss .= 'left:50%;margin-left:-150px;top:270px';
        }
        return $formCss;
    }
}
