<?php
/**
 *@copyright (C) 2001 - 2011 Weaver Co.Ltd
 *@package       eoffice 9.0
 *@function      门户数据处理页
 *@encoding      $_lang['encoding']
 *@name          general/portal/do.php
 *@version       32
 *@date          2014-9-10
 */
include 'inc/auth.php';
include 'api/portal.class.php';
include_once ("inc/function_usergeneral.php");
include_once ("inc/function_picture.php");
include_once ("inc/utility_all.php");
include_once ("general/new_mytable/index_function.php");
include_once ("inc/address/add_function.php");
includelangpak("index", $lang);
includelangpak("hr,info,calendar", $lang);
$loginPrivID = $_SESSION["LOGIN_USER_PRIV"];
$loginDeptID = $_SESSION["LOGIN_DEPT_ID"];
$loginUserID = $_SESSION["LOGIN_USER_ID"];
$userSubPriv = $_SESSION["USER_SUB_PRIV"];

session_write_close();

$documentRoot = $_SERVER['DOCUMENT_ROOT'];//系统根目录
$op     = request_var('op','');
$portal = new Portal;

switch ($op) {
    /**
     *
     */
    case 'checkMenuPriv':
        $funcID = request_var('funcID','');//funcID 如果有funcID则需要判断权限
        if ($funcID) {
			$privStr = getUserPriv($loginUserID);
			if(!empty($userSubPriv)){
                $privStr = implode(",",array_filter(array_unique(explode(",",$privStr.",".$userSubPriv))));
            }
			//内部消息 是一级菜单 单独判断  可以合并 先按照原来的实现
			if ($funcID == 13) {
				if (!find_id($privStr, $funcID)) {
					echo 0;exit;
				}
                echo 1;
			} else {
				if (!isThisPri($privStr, isMenuPri($funcID))) {
					echo 0;exit;
				}
                echo 1;
			}
		}
    break;
    /**
     * 新建门户
     */
	case 'newPortal' :
		$portalName  = SecurityFilter(request_var('portalName',''));
		$portalID    = intval(request_var('portalID',''));
		$portalInfor = SecurityFilter(request_var('portalInfor',''));

		//新建、编辑门户时，确认门户的权限
		if($portalInfor['DEPT_ID'] == 'DEPT_ALL' ||
			strpos(",".trim($portalInfor['DEPT_ID'],",").",", ",".$loginDeptID.",") !== false ||
				strpos(",".trim($portalInfor['PRIV_ID'],",").",", ",".$loginPrivID.",") !== false ||
				strpos(",".trim($portalInfor['USER_ID'],",").",", ",".$loginUserID.",") !== false){
				$hasEditPriv = true;
		}else{
			$hasEditPriv = false;
		}

		if($loginUserID == 'admin'){
			$hasEditPriv = true;
		}

		if($portalID){
			$result =  $portal -> UpdatePortal("index_portal",$portalInfor, array("PORTAL_ID"=>$portalID));
		}else{
			$result = $portal -> NewPortal($portalInfor, $loginUserID);
		}
		echo json_encode(
				array("result"=>$result,"hasEditPriv"=>$hasEditPriv)
			);


		break;
    /**
     * 删除门户
     */
	case 'deletePortal' :
		$portalID = intval(request_var('portalID',''));

		echo $portal -> DeletePortal($portalID);
		break;
    /**
     * 设为默认门户
     */
	case 'setDefault' :
		$portalID = intval(request_var('portalID',''));
		$result1 = $portal -> UpdatePortal("index_portal",array("PORTAL_DEFAULT"=>0),array("PORTAL_DEFAULT"=>1));
		$result2 = $portal -> UpdatePortal("index_portal",array("PORTAL_DEFAULT"=>1),array("PORTAL_ID"=>$portalID));
		echo  $result1 && $result2;
		break;
    /**
     * 统一门户
     */
    case 'unifyPortal':
        $flag = false;
        $userId   = SecurityFilter(request_var('userId',''));
        $portalID = intval(request_var('portalID',''));
        $portalInfor = $portal ->GetPortalLayoutInforByUser($userId,$portalID);
        $PORTAL_LAYOUT_INFOR = $portalInfor[0]['PORTAL_LAYOUT_INFOR'];
        $PORTAL_LAYOUT_INFOR = str_replace("\\", "\\\\", $PORTAL_LAYOUT_INFOR);
        $result = $portal -> UpdatePortal('portal_layout',array('PORTAL_LAYOUT_INFOR' => $PORTAL_LAYOUT_INFOR),array('PORTAL_ID' => 1));
        if($result){
            $flag = true;
        }
        $query = 'SELECT USER_ID FROM user WHERE DEPT_ID != -1';
        $result1 = exequery($connection, $query);
        $userIds = array();
        while($row = mysql_fetch_assoc($result1)) {
			$userIds[] = $row['USER_ID'];
		}
        $query = 'SELECT USER_ID FROM portal_layout WHERE PORTAL_ID=1';
        $result2 = exequery($connection, $query);
        $pUserId = array();
        while($row = mysql_fetch_assoc($result2)) {
			$pUserId[] = $row['USER_ID'];
		}
        $_userIds = array_diff($userIds,$pUserId);
        foreach($_userIds as $_userId){
            $query = 'INSERT INTO portal_layout(`PORTAL_ID`,`PORTAL_LAYOUT_INFOR`,`USER_ID`) VALUES(1,\''.$PORTAL_LAYOUT_INFOR.'\',\''.$_userId.'\')';
            $result = exequery($connection, $query);
            if(!$result){
                $flag = false;
                break;
            }
        }
        echo $flag;
        break;
    /**
     * 恢复默认设置
     */
    case 'resumeDefault':
        $userId= SecurityFilter(request_var('userId',''));
        $portalID = intval(request_var('portalID',''));
        $portalInfor = $portal ->GetPortalLayoutInfor(0);
        $PORTAL_LAYOUT_INFOR = $portalInfor[0]['PORTAL_LAYOUT_INFOR'];
        $PORTAL_LAYOUT_INFOR = str_replace("\\", "\\\\", $PORTAL_LAYOUT_INFOR);
        $result = $portal -> UpdatePortal('portal_layout',array('PORTAL_LAYOUT_INFOR' => $PORTAL_LAYOUT_INFOR),array('PORTAL_ID' => $portalID,'USER_ID' => $userId));
        echo $result;
        break;
    /**
     * 获取某门户的详细信息
     */
	case 'getPortalInfor':
		$portalID = intval(request_var('portalID',''));
		$portalInfor = $portal -> GetPortalInfor($portalID);
		if($portalInfor){
			//转换权限信息
			if($portalInfor["VIEW_DEPT_ID"]!="DEPT_ALL"){
				if($portalInfor["VIEW_DEPT_ID"] != ""){
					$portalInfor["VIEW_DEPT_ID_STR"] = getNameFromId($portalInfor["VIEW_DEPT_ID"], 'DEPT_NAME', 'DEPT_ID', 'department');
				}

				if($portalInfor["VIEW_PRIV_ID"] != ""){
					$portalInfor["VIEW_PRIV_ID_STR"] = getNameFromId($portalInfor["VIEW_PRIV_ID"], 'PRIV_NAME', 'USER_PRIV','user_priv');
				}

				if($portalInfor["VIEW_USER_ID"] != ""){
					$portalInfor["VIEW_USER_ID_STR"] = getNameFromId($portalInfor["VIEW_USER_ID"], 'USER_NAME', 'USER_ID', 'user');
				}
			}

			if($portalInfor["DEPT_ID"]!="DEPT_ALL"){
				if($portalInfor["DEPT_ID"] != ""){
					$portalInfor["DEPT_ID_STR"] = getNameFromId($portalInfor["DEPT_ID"], 'DEPT_NAME', 'DEPT_ID', 'department');
				}

				if($portalInfor["PRIV_ID"] != ""){
					$portalInfor["PRIV_ID_STR"] = getNameFromId($portalInfor["PRIV_ID"], 'PRIV_NAME', 'USER_PRIV','user_priv');
				}

				if($portalInfor["USER_ID"] != ""){
					$portalInfor["USER_ID_STR"] = getNameFromId($portalInfor["USER_ID"], 'USER_NAME', 'USER_ID', 'user');
				}
			}
			echo json_encode($portalInfor);
		}else{
			echo false;
		}
        break;
    /**
     * 获取门户信息
     */
	case 'getLayoutInfor' :
		$portalID = intval(request_var('portalID',''));

		$query = "SELECT * FROM portal_layout
						WHERE PORTAL_ID = " . $portalID;

		//个人门户
		if ($portalID == 1) {
			$query .= " AND USER_ID ='" . $loginUserID . "' ";
		}
		$result = exequery($connection, $query);

		//个人门户没有时，获取默认的个人门户
		//PORTAL_ID为0 的门户信息  为默认的个人门户信息
		if (mysql_num_rows($result) == 0 && $portalID == 1) {
			$query = "SELECT * FROM portal_layout
						WHERE PORTAL_ID = 0";
			$result = exequery($connection, $query);
		}
		if ($row = mysql_fetch_assoc($result)) {
            $res = '';
            // 返回数据中存在null 导致前段解析失败问题
            if (isset($row['PORTAL_LAYOUT_INFOR']) && !empty($row['PORTAL_LAYOUT_INFOR'])) {
                $res = json_encode(array_filter(json_decode($row['PORTAL_LAYOUT_INFOR'])));
            }
            echo $res;
		}

		break;
    /**
     * 获取通讯录字段
     */
	case 'getAddressColumns' :
		$query = "SELECT ITEM_ID,ITEM_SYS,ITEM_NAME FROM add_item
			   WHERE ITEM_NAME!=''
			   AND ITEM_SYS='1'
			   ORDER BY ITEM_ORDER
			   LIMIT 0,5";
		$result = exequery($connection, $query);
		while ($row = mysql_fetch_array($result)) {
			if ($row['ITEM_SYS'] == 1) {
				$itemName = $_lang[$row['ITEM_NAME']];
			} else {
				$itemName = $row['ITEM_NAME'];
			}
			$addressColumns["A" . $row['ITEM_ID']] = $itemName;
		}
		echo json_encode($addressColumns);
		break;
    /**
     * 更新门户布局信息
     */
	case 'updateLayoutInfor' :
		$portalID = intval(request_var('portalID',''));
		$layoutInfor = SecurityFilter(request_var('layoutInfor',''));
		$portalName = SecurityFilter(request_var('portalName',''));
		$portalName = htmlspecialchars(strip_tags($portalName));

		//检查布局表 是否有此门户
		$checkQuery = "SELECT COUNT(*) AS CNT
						FROM portal_layout
						WHERE PORTAL_ID = " . $portalID;

		//个人门户
		if($portalID == 1){
			$checkQuery.=" AND USER_ID = '".$loginUserID."'";
		}

		$checkResult = exequery($connection, $checkQuery);

		if ($checkRow = mysql_fetch_assoc($checkResult)) {
			$layoutCount = $checkRow['CNT'];
		}

		if ($layoutCount == 0) {
			$updateLayoutInforQuery = "INSERT INTO  portal_layout (PORTAL_ID,PORTAL_LAYOUT_INFOR,USER_ID)
										VALUES('" . $portalID . "','" . $layoutInfor . "','" . $loginUserID . "')";
		} else {

			//更新布局信息
			$updateLayoutInforQuery = "UPDATE portal_layout SET PORTAL_LAYOUT_INFOR = '" . $layoutInfor . "'
				WHERE PORTAL_ID = " . $portalID;

			if($portalID == 1){
				$updateLayoutInforQuery.= " AND USER_ID = '" . $loginUserID . "'";
			}
		}

		//更新门户名称
		$updatePortalNameQuery = "UPDATE index_portal SET PORTAL_NAME = '" . $portalName . "'
			WHERE PORTAL_ID = '" . $portalID . "'";

		echo exequery($connection, $updateLayoutInforQuery) && exequery($connection, $updatePortalNameQuery);
		break;
    /**
     * 检测用户头衔是否存在
     */
    case 'checkPersonImage':
        $image = request_var('image','');
        $imageRealPath = $documentRoot.'attachment/personal/'.$image;
        if(!file_exists($imageRealPath)){
            echo 0;
        } else{
            echo 1;
        }
        break;
    /**
     * 获取门户模块的数据
     */
	case 'getPortalData' :

		$module		= request_var('module','');//模块
		$rowCount	= intval(request_var('rows',''));//获取数据行数
		$type		= request_var('type','');//类型
		$dirID		= request_var('dirID','');//目录ID
		$funcID		= request_var('funcID','');//funcID 如果有funcID则需要判断权限
        /**
         * 判断用户是否有权限
         */
		if ($funcID) {
			$privStr = getLoginUserPriv($loginUserID);
			if (!empty($userSubPriv))
				$privStr = implode(",", array_filter(array_unique(explode(",", $privStr . "," . $userSubPriv))));

			//内部消息 是一级菜单 单独判断  可以合并 先按照原来的实现
			if ($funcID == 13) {
				if (!find_id($privStr, $funcID)) {
					echo "-1";
					exit();
				}
			} else {
				if (!isThisPri($privStr, trim(isMenuPri($funcID),','))) {
					echo "-1";
					exit();
				}
			}
		}
		switch ($module) {
			/**
			 * 工作流程
			 */
			case 'workflow' :
                include_once ("api/workflow.list.class.php");

                $_dirID = '';

				if (!strpos($dirID, ',')) {
					$_dirID = $dirID;

					if ($_dirID != '' && $_dirID != 0) {
						$count = 1;
					}
				} else {
					$dirID = explode(',', $dirID);

					$count = sizeof($dirID);

					for ($i = 0; $i < $count - 1; $i++) {
						if ($i == $count - 2) {
							$_dirID .=$dirID[$i];
						} else {
							$_dirID .=$dirID[$i] . ',';
						}
					}
				}

				if ($count >= 1)
					$CUSTOMPARAM = ' AND fr.FLOW_ID IN (' . SecurityFilter($_dirID) . ') AND fr.IS_EFFECT = 1';
				else
					$CUSTOMPARAM = " AND fr.IS_EFFECT = 1";

				switch ($type) {
					/**
					 * 代办
					 */
                    case 'todo' :
						$CUSTOMPARAM .= " AND frs.USER_ID = '" . $loginUserID . "' AND frs.USER_RUN_TYPE = '1'";

						$getListParam = array(
							"CUSTOMPARAM"		=> $CUSTOMPARAM,
							"PAGINATIONOFFSET"	=> 0,
							"PAGINATIONROWS"	=> $rowCount,
							"SORTFIELD"			=> "fr.TRANSACT_TIME",
							"SORTTYPE"			=> "DESC"
						);

						$flowList		= new listItem();

						$workflowList	= $flowList->getToDoList($getListParam);

						$todoList		= array();

						if ($workflowList['list']) {
							//格式化一下
							foreach ($workflowList['list'] as $key => $val) {
								$status = $val["PRCS_TIME"] == NULL ? "new" : '';
								if($val["INSTANCY_TYPE"] == 1 || $val["INSTANCY_TYPE"] == 2) {
                                    $runName = " <span style='color:red;'>[ ".getInstancyName($val["INSTANCY_TYPE"])." ]</span> ".$val["RUN_NAME"];
                                } else {
                                    $runName = $val["RUN_NAME"];
                                }
                                // 未办理人员
                                $NOT_DEAL       = "";
                                $NOT_DEAL_COUNT = 0;
                                foreach($val["ALL_STEP"] as $detail_key=>$detail_value){
                                    //最新步骤未办理人员，为了性能，超过100个，不再拼接
                                    if(((!$detail_value["SAVEFORM_TIME"] && $detail_value["SAVEFORM_TIME"] != "0000-00-00 00:00:00" && $detail_value["OP_FLAG"] == 0) || (!$detail_value["DELIVER_TIME"] && $detail_value["DELIVER_TIME"] != "0000-00-00 00:00:00" && $detail_value["OP_FLAG"] == 1)) && $NOT_DEAL_COUNT <= 100 && $val["PRCS_ID"] == $detail_value["PRCS_ID"]) {
                                        $NOT_DEAL .= $detail_value["USER_ID"].",";
                                        $NOT_DEAL_COUNT++;
                                    }
                                }
								$todoList[] = array(
                                    "run_id"         => $val["RUN_ID"],
                                    "flow_id"        => $val["FLOW_ID"],
                                    "prcs_id"        => $val["PRCS_ID"],
                                    "flow_prcs"      => $val["FLOW_PRCS"],
                                    "flow_type"      => $val["FLOW_TYPE"],
                                    "run_name"       => $runName,
                                    "run_name_title" => $val["RUN_NAME"],
                                    "status"         => $status,
                                    'datetime1'      => $val["CREATE_TIME"],
                                    "datetime"       => date('Y-m-d', strtotime($val["CREATE_TIME"])),
                                    "username"       => getusername($val["CREATOR"]),
                                    "CREATOR_ID"     => $val['CREATOR'],
                                    "type"           => "todo",
                                    "notHandleUser"  => trim(getUsernameStr($NOT_DEAL),","),
								);
							}
						}

						echo !empty($todoList) ? json_encode($todoList) : 0;

						break;
					/**
					 * 已办
					 */
					case 'haveDone' :
						//加上已办的条件
						$CUSTOMPARAM .= " AND frs.USER_ID = '".$loginUserID."' AND frs.USER_RUN_TYPE = '2'";

						$getListParam = array(
							"CUSTOMPARAM"		=> $CUSTOMPARAM,
							"PAGINATIONOFFSET"	=> 0,
							"PAGINATIONROWS"	=> $rowCount,
							"SORTFIELD"			=> "fr.TRANSACT_TIME",
							"SORTTYPE"			=> "DESC"
						);

						$flowList     = new listItem();

						$workflowList = $flowList->getFinishedList($getListParam);

						$haveDoneList = array();

						if($workflowList['list']){
							//格式化一下
							foreach($workflowList['list'] as $key => $val){
								$status = $val["PRCS_TIME"] == NULL ? "new" : '';
								if($val["INSTANCY_TYPE"] == 1 || $val["INSTANCY_TYPE"] == 2) {
                                    $runName = " <span style='color:red;'>[ ".getInstancyName($val["INSTANCY_TYPE"])." ]</span> ".$val["RUN_NAME"];
                                } else {
                                    $runName = $val["RUN_NAME"];
                                }
                                // 未办理人员
                                $NOT_DEAL       = "";
                                $NOT_DEAL_COUNT = 0;
                                foreach($val["ALL_STEP"] as $detail_key=>$detail_value){
                                    //最新步骤未办理人员，为了性能，超过100个，不再拼接
                                    if(((!$detail_value["SAVEFORM_TIME"] && $detail_value["SAVEFORM_TIME"] != "0000-00-00 00:00:00" && $detail_value["OP_FLAG"] == 0) || (!$detail_value["DELIVER_TIME"] && $detail_value["DELIVER_TIME"] != "0000-00-00 00:00:00" && $detail_value["OP_FLAG"] == 1)) && $NOT_DEAL_COUNT <= 100 && $val["MAX_PRCS_ID"] == $detail_value["PRCS_ID"]) {
                                        $NOT_DEAL .= $detail_value["USER_ID"].",";
                                        $NOT_DEAL_COUNT++;
                                    }
                                }
								$haveDoneList[] = array(
									"run_id"		=> $val["RUN_ID"],
									"flow_id"		=> $val["FLOW_ID"],
									"prcs_id"		=> $val["PRCS_ID"],
									"flow_prcs"		=> $val["FLOW_PRCS"],
									"flow_type"		=> $val["FLOW_TYPE"],
                                    "run_name"      => $runName,
									"run_name_title"=> $val["RUN_NAME"],
									"status"		=> $status,
									 'datetime1'	=> $val["CREATE_TIME"],
									"datetime"		=> date('Y-m-d',strtotime($val["CREATE_TIME"])),
									"username"		=> getusername($val["CREATOR"]),
                                    "CREATOR_ID"	=> $val['CREATOR'],
									"type"			=> "haveDone",
                                    "notHandleUser"  => trim(getUsernameStr($NOT_DEAL),","),
								);
							}
						}

						echo !empty($haveDoneList) ? json_encode($haveDoneList) : 0;

						break;
					/**
					 * 办结事宜
					 */
					case 'done' :
						$CUSTOMPARAM .= " AND frs.USER_ID = '" . $loginUserID . "' AND frs.USER_RUN_TYPE = '3'";

						$getListParam = array(
							"CUSTOMPARAM"		=> $CUSTOMPARAM,
							"PAGINATIONOFFSET"	=> 0,
							"PAGINATIONROWS"	=> $rowCount,
							"SORTFIELD"			=> 'fr.TRANSACT_TIME',
							"SORTTYPE"			=> 'DESC'
						);

						$flowList		= new listItem();

						$workflowList	= $flowList->getPassedList($getListParam);

						$doneList		= array();

						if ($workflowList['list']) {
							//格式化一下
							foreach ($workflowList['list'] as $key => $val) {
								$status = $val["PRCS_TIME"] == NULL ? "new" : '';
								if($val["INSTANCY_TYPE"] == 1 || $val["INSTANCY_TYPE"] == 2) {
                                    $runName = " <span style='color:red;'>[ ".getInstancyName($val["INSTANCY_TYPE"])." ]</span> ".$val["RUN_NAME"];
                                } else {
                                    $runName = $val["RUN_NAME"];
                                }
								$doneList[] = array(
									"run_id"		=> $val["RUN_ID"],
									"flow_id"		=> $val["FLOW_ID"],
									"prcs_id"		=> $val["PRCS_ID"],
									"flow_prcs"		=> $val["FLOW_PRCS"],
									"flow_type"		=> $val["FLOW_TYPE"],
                                    "run_name"      => $runName,
									"run_name_title"=> $val["RUN_NAME"],
									"status"		=> $status,
									'datetime1'		=> $val["CREATE_TIME"],
									"datetime"		=> date('Y-m-d', strtotime($val["CREATE_TIME"])),
									"username"		=> getusername($val["CREATOR"]),
									"CREATOR_ID"	=> $val['CREATOR'],
									"type"			=> "done"
								);
							}
						}

						echo !empty($doneList) ? json_encode($doneList) : 0;

						break;
					/**
					 * 我的请求
					 */
					case 'request' :
						//取我的请求列表数据
						$CUSTOMPARAM .= " AND fr.CREATOR = '".$loginUserID."' ";

						$getListParam = array(
							"CUSTOMPARAM"		=> $CUSTOMPARAM,
							"PAGINATIONOFFSET"	=> 0,
							"PAGINATIONROWS"	=> $rowCount,
							"SORTFIELD"			=> 'fr.TRANSACT_TIME',
							"SORTTYPE"			=> 'DESC'
						);

						$flowList     = new listItem();

						$workflowList = $flowList -> getMyRequestList($getListParam);

						$requestList  = array();

						if($workflowList['list']){
							//格式化一下
							foreach($workflowList['list'] as $key => $val){
								$status = $val["PRCS_TIME"] == NULL ? "new" : '';
								if($val["INSTANCY_TYPE"] == 1 || $val["INSTANCY_TYPE"] == 2) {
                                    $runName = " <span style='color:red;'>[ ".getInstancyName($val["INSTANCY_TYPE"])." ]</span> ".$val["RUN_NAME"];
                                } else {
                                    $runName = $val["RUN_NAME"];
                                }
								$requestList[] = array(
									"run_id"		=> $val["RUN_ID"],
									"flow_id"		=> $val["FLOW_ID"],
									"prcs_id"		=> $val["PRCS_ID"],
									"flow_prcs"		=> $val["FLOW_PRCS"],
									"flow_type"		=> $val["FLOW_TYPE"],
                                    "run_name"      => $runName,
									"run_name_title"=> $val["RUN_NAME"],
									"status"		=> $status,
									 'datetime1'	=> $val["CREATE_TIME"],
									"datetime"		=> date('Y-m-d',strtotime($val["CREATE_TIME"])),
									"username"		=> getusername($val["CREATOR"]),
									"CREATOR_ID"	=> $val['CREATOR'],
									"type"			=> "request",
									"dealFlow"		=> $val["canDeal"],
									"dealPrcsId"	=> $val["dealPrcsId"],
									"dealFlowPrcs"	=> $val["dealFlowPrcs"]
								);
							}
						}

						echo !empty($requestList) ? json_encode($requestList) : 0;

						break;
					case 'copy':
							//取流程抄送列表数据
						$getListParam["TABLE_COMMON"] = array(
							"LOGIN_USER_ID"		=> $loginUserID,
							"PAGINATIONOFFSET"	=> 0,
							"PAGINATIONROWS"	=> $rowCount,
							"SORTFIELD"			=> 'fc.COPY_TIME',
							"SORTTYPE"			=> 'DESC'
						);

						$getListParam["FORMAT_SEARCH"] = array(
							array("TABLE" => "flow_run", "TABLE_ABBR" => "fr", "FIELD" => "IS_EFFECT", "RELATION" => "=", "VALUE" => "1")
						);

						if ($count >= 1) {
							$getListParam["FORMAT_SEARCH"][] = array("TABLE" => "flow_run", "TABLE_ABBR" => "fr", "FIELD" => "FLOW_ID", "RELATION" => "in", "VALUE" => '(' . $_dirID . ')');
						}

						$flowList		= new listItem();

						$workflowList	= $flowList->getFlowCopyList($getListParam);

						$copyList		= array();

						if ($workflowList['totalCount'] > 0) {
							foreach ($workflowList['list'] as $val) {
								$status = $val["RECEIVE_TIME"] == NULL ? "new" : '';
								if($val["INSTANCY_TYPE"] == 1 || $val["INSTANCY_TYPE"] == 2) {
                                    $runName = " <span style='color:red;'>[ ".getInstancyName($val["INSTANCY_TYPE"])." ]</span> ".$val["RUN_NAME"];
                                } else {
                                    $runName = $val["RUN_NAME"];
                                }
								$copyList[] = array(
									"run_id"		=> $val["RUN_ID"],
									"flow_id"		=> $val["FLOW_ID"],
									"prcs_id"		=> $val["PRCS_ID"],
									"flow_prcs"		=> $val["FLOW_PRCS"],
									"flow_type"		=> $val["FLOW_TYPE"],
                                    "run_name"      => $runName,
									"run_name_title"=> $val["RUN_NAME"],
									"status"		=> $status,
									'datetime1'		=> $val["CREATE_TIME"],
									"datetime"		=> date('Y-m-d', strtotime($val["CREATE_TIME"])),
									"username"		=> getusername($val["CREATOR"]),
									"CREATOR_ID"	=> $val['CREATOR'],
									"type"			=> "copy",
									'copy_id'		=> $val['COPY_ID'],
									'copy_time'		=> $val['COPY_TIME']
								);
							}
						}

						echo !empty($copyList) ? json_encode($copyList) : 0;

						break;
					default :
						break;
				}
				break;
			/**
			 * 文档
			 */
			case 'publicDocument' :

				//判断SORT_ID
				$dept_id = getUserDept($loginUserID);
				$priv_id = getUserPrivId($loginUserID);

				$FILE_SORT = 1;
				$SORT_ID = $dirID;
				include_once ("inc/config_doc.inc.php");
				global $FILE_PATH_PURVIEW;
				global $DOWN_PATH_PURVIEW;
				global $ALLREADPUR;

				$COUNT = 0;
				//取得数据
				$query = "SELECT fc.USER_ID,fc.SORT_ID,fc.CONTENT_ID,fc.SUBJECT,fc.SEND_TIME FROM file_content fc WHERE 1";
				$share_file_query = "
								SELECT CONTENT_ID FROM file_share
								 WHERE 1
								 AND(
									 SHARE_DEPT = 'dept_all'
									 OR
									 (INStr(SHARE_DEPT,',$loginDeptID,')>0 OR INStr(SHARE_DEPT,'$loginDeptID,')=1)
									 OR
									 (INStr(SHARE_PRIV,',$loginPrivID,')>0 OR INStr(SHARE_PRIV,'$loginPrivID,')=1)
									 OR
									 (INStr(SHARE_USER,',$loginUserID,')>0 OR INStr(SHARE_USER,'$loginUserID,')=1)
									 OR USER_ID = '" . $loginUserID . "'
								 )
								";
				if ($SORT_ID != 0) {
					$share_file_query .= " AND (SORT_ID IN ($DOWN_PATH_PURVIEW))";
				}
				$cursor = exequery($connection,$share_file_query);
				$privContentID = "";
				while ( $ROW = mysql_fetch_array ( $cursor ) ) {
					$contentID = $ROW ['CONTENT_ID'];
					if ($privContentID == "") {
						$privContentID = $contentID;
					} else {
						$privContentID .= "," . $contentID;
					}
				}
				if (trim ( $privContentID ) == "") {
					$privContentID = "'0'";
				}
				if (trim ( $SPECIAL_PURVIEW_CONTENT_ID ) == "") {
					$SPECIAL_PURVIEW_CONTENT_ID = "'0'";
				}
				$query .= "
							AND (
									fc.SORT_ID IN (".manageStringUnique($ALLREADPUR.",".$FILE_PATH_PURVIEW.",".$HAVE_PATH_PURVIEW).")
									OR fc.CONTENT_ID IN (".manageStringUnique($privContentID.",".$SPECIAL_PURVIEW_CONTENT_ID).")
								)
							AND (
									fc.SUBJECT != ''
								)
							";
				$query .= "ORDER BY SEND_TIME DESC LIMIT 0,$rowCount";
				$rc = exequery($connection, $query);
				while ($ROW = mysql_fetch_array($rc)) {
					$USER_ID = $ROW['USER_ID'];
					$COUNT++;
					$SORT_ID	= $ROW['SORT_ID'];
					$CONTENT_ID = $ROW["CONTENT_ID"];
					$SUBJECT    = $ROW["SUBJECT"];
					$SEND_TIME  = $ROW["SEND_TIME"];
					$SUBJECT		 = str_replace("<", "&lt", $SUBJECT);
					$SUBJECT		 = str_replace(">", "&gt", $SUBJECT);
					$SUBJECT		 = stripslashes($SUBJECT);
					$linkStr = "";
					$query_read = "SELECT COUNT(LOG_ID) as CNT2 FROM sys_op_log
								       WHERE SEQ_ID = " . $CONTENT_ID . "
									   and	 USER_ID = '" . $user_id . "'";
					$cursor_read = exequery($connection, $query_read);
					$READ_ROW = mysql_fetch_array($cursor_read);

					//判断日志中有没有数据&判断日志表中有没有新建操作
					$query_log = "
								SELECT COUNT( * ) AS logCon
								FROM  `sys_op_log`
								WHERE (
									SELECT COUNT( LOG_ID ) AS CNT2
									FROM sys_op_log
									WHERE SEQ_ID = '".$CONTENT_ID."'
									AND USER_ID =  '" . $loginUserID . "'
									) =0
								AND (
									SELECT COUNT( LOG_ID ) AS CNT3
									FROM sys_op_log
									WHERE SEQ_ID = '".$CONTENT_ID."'
									AND OPERATION_TYPE =1
									) !=0
								";
					$cursor_log = exequery ( $connection, $query_log );
					$LOG_ROW = mysql_fetch_array ( $cursor_log );
					if ($LOG_ROW["logCon"]) {
						$isNew = true;
					} else {
						$isNew = false;
					}
					$documentList[] = array(
						"CONTENT_ID" => $CONTENT_ID,
						"SORT_ID" => $SORT_ID,
						"USER_NAME" => getusername($USER_ID),
						"SEND_TIME1" => $SEND_TIME,
                        "SEND_TIME" => date('Y-m-d',strtotime($SEND_TIME)),
						"SUBJECT" => $SUBJECT,
						"isNew" => $isNew,
                        "USER_ID" => $USER_ID,
                        "avatar_type" => getAvatarType($USER_ID)
					);
				}
				echo json_encode($documentList);
				break;
			/**
			 * 我的协作
			 */
			case 'cooperation' :
                include_once ("api/cooperation.class.php");
				include_once ("inc/coop_func/fun_coop.php");
				$now_time  = date("Y-m-d H:i:s",time());
				if($dirID)
					$customParam .= " AND cs.COOP_ID = '".SecurityFilter($dirID)."'";
				//排除掉未生效和过期协作
				$customParam .= " AND (ct.THE_START <= '".$now_time."' AND (ct.THE_END>='".$now_time."' OR ct.THE_END='0000-00-00 00:00:00'))";
				$type = array(
					"TYPE" => "",
					"CONSTAINLIST" => "1"
				);
				$search = array(
					"USER_ID" => $loginUserID,
					"PRIV_ID" => $loginUserPriv,
					"DEPT_ID" => $loginDeptID,
					"QUICKSORTPARAM" => "",
					"CUSTOMPARAM" => $customParam
				);
				$page = array(
					"PAGINATIONOFFSET" => 0,
					"PAGINATIONROWS" => $rowCount,
					"SORTFIELD" => "",
					"SORTTYPE" => ""
				);
				$other = array("");
				$cooperationSort = new cooperation;
				$cooperationList = $cooperationSort->getCoopListMain($type,$search,$page,$other);
				if($cooperationList["list"]){
					//格式化一下
					foreach($cooperationList["list"] as $key => $val){
						$user_read_time = getUserReadTime($val["THE_ID"]);
						$last_time_revert = getLastTimeRevert($val["THE_ID"]);
						if ($user_read_time <= $last_time_revert || $user_read_time == "0000-00-00 00:00:00") {
							$isNew = true;
						} else {
							$isNew = false;
						}
						$val['isNew'] = $isNew;
                        $val['USER_ID'] = $val['THE_CREATER'];
                        $val['avatar_type'] = getAvatarType($val['THE_CREATER']);
						$val['THE_CREATER'] = getusername($val['THE_CREATER']);
                        $val['THE_TIME1']   = $val['THE_TIME'];
                        $val['THE_TIME']    = date('Y-m-d',strtotime($val['THE_TIME']));
						$coopList[] = $val;
					}
				}
				echo json_encode($coopList);
				break;
			/**
			 * 最近计划
			 */
			case 'plan' :
                include_once("api/workplan.class.php");
				$planApi  = new workplan();
				$infor = $planApi->planListShowData("PLAN_ID","DESC",0,$rowCount,"",array());
				$newInfor = array();
				for($i=0;$i<count($infor);$i++){
					if($infor[$i]["PLAN_ID"]){
						$newInfor[$i] = $infor[$i];
                        $newInfor[$i]["creator"] = getUserNameNew($newInfor[$i]["CREATOR"]);
                        $newInfor[$i]['avatar_type'] = getAvatarType($newInfor[$i]["CREATOR"]);
						$newInfor[$i]["begDataTime"] = $infor[$i]["BEGIN_DATE"]." ".substr($infor[$i]["BEGIN_TIME"],0,5);
						$newInfor[$i]["endDataTime"] = $infor[$i]["END_DATE"]." ".substr($infor[$i]["END_TIME"],0,5);
						if($newInfor[$i]["begDataTime"] == "0000-00-00 00:00" || $list_infor["list"][$i]["begDataTime"] == "0000-00-00 ")
		                    $newInfor[$i]["begDataTime"] = "";
		                if($newInfor[$i]["endDataTime"] == "0000-00-00 00:00" || $list_infor["list"][$i]["endDataTime"] == "0000-00-00 ")
		                    $newInfor[$i]["endDataTime"] = "";
                                $newInfor[$i]["MANAGER"] = $infor[$i]["MANAGER"];
		                if ($infor[$i]["MANAGER"]) {
		                	$newInfor[$i]["personName"] = getUsernameStr($infor[$i]["MANAGER"],'USER_ID,USER_NAME');
		                } else {
		                	$newInfor[$i]["personName"] = "";
		                }
		                //z状态
						$OPTIONSTATE = $infor[$i]["OPTIONSTATE"];
		                if($OPTIONSTATE=='0') {
		                    //待生效
		                    $STATUS_DESC = $_lang['calendar_plan_vali'];
		                }
		                if($infor[$i]["END_DATE"]!="0000-00-00") {
		                    if($OPTIONSTATE=='1')
		                    {
		                       //已生效
		                       $STATUS_DESC="<font color='#00AA00'>".$_lang["calendar_plan_has_vali"]."</font>";
		                    }
		                   if($OPTIONSTATE=='2')
		                      {
		                         //已终止
		                         $STATUS_DESC="<font color='#FF0000'>".$_lang["calendar_plan_has_over"]."</font>";
		                      }
		                } else {
		                    if($OPTIONSTATE=='1') {
		                        //已生效
		                        $STATUS_DESC="<font color='#00AA00'>".$_lang["calendar_plan_has_vali"]."</font>";
		                    }
		                    if($OPTIONSTATE=='2') {
		                        //已终止
		                        $STATUS_DESC="<font color='#FF0000'>".$_lang["calendar_plan_has_over"]."</font>";
		                    }
		                }
		                $newInfor[$i]["stateText"] = $STATUS_DESC;
					}
				}

				echo json_encode($newInfor);
				break;
			/**
			 * 公告
			 */
			case 'notify' :
				//======= 显示已发布公告 =======
                include_once ("api/notify.class.php");
				$notify = new notify();
                $fieldArray = array(
                    'NOTIFY_ID',
                    'SUBJECT',
                    'BEGIN_DATE',
                    'FROM_ID',
                    'READERS'
                );
                $notifyList = $notify->getNotifyLists($rowCount, 0,array("NotifySort"=>$dirID,"orderby"=>"SEND_TIME","ordertype"=>"DESC"),$fieldArray);
				$_notifyList = array();
				foreach($notifyList as $key => $value){
					$temp = array();
					$temp['NOTIFY_ID']      = $value['NOTIFY_ID'];
					$temp['SUBJECT']        = $value['SUBJECT'];
					$temp['BEGIN_DATE']     = $value['BEGIN_DATE'];
					$temp['BEGIN_DATE1']    = date('Y-m-d H:i:s',strtotime($value['BEGIN_DATE']));
					$temp['USER_NAME']      = $value['USER_NAME'];
					$temp['avatar_type']    = getAvatarType($value['FROM_ID']);
					$isNew = false;
					if(!find_id($value["READERS"],$loginUserID)) {
						$isNew = true;
					}
					$temp['isNew']          = $isNew;
					$temp['USER_ID']        = $value['FROM_ID'];
					$_notifyList[] = $temp;
				}
				echo json_encode($_notifyList);
				break;
			/**
			 * 最新消息
			 */
			case 'sms' :
				include_once ("general/workflow/prcs_role.php");

				$CUR_TIME = date("Y-m-d H:i:s", time());

				$sql = "SELECT * FROM SMS WHERE TO_ID='{$loginUserID}' AND SEND_TIME<='{$CUR_TIME}' AND receive_del = 0 ORDER BY SEND_TIME DESC LIMIT 0,{$rowCount}";
				$rs = exequery($connection, $sql);
				$count = 0;
				while ($ROW = mysql_fetch_array($rs)) {
					$count++;
					$SMS_ID = $ROW["SMS_ID"];
					$SMS_ID_STR .= $SMS_ID . ",";
					$FROM_ID = $ROW["FROM_ID"];
					$SEND_TIME = $ROW["SEND_TIME"];
					$REMIND_FLAG = $ROW["REMIND_FLAG"];
					$SMS_TYPE = $ROW["SMS_TYPE"];
					$TABLE_ID = $ROW["TABLE_ID"];
					$CONTENT = $ROW["CONTENT"];
					//去掉可能有的连接
					$CONTENT = str_replace("<", "&lt", $CONTENT);
					$CONTENT = str_replace(">", "&gt", $CONTENT);

					$TYPE_NAME = getSmstype($SMS_TYPE);
					$TABLE_NAME = $ROW["TABLE_NAME"];
					$TABLE_VAR = $ROW["TABLE_VAR"];
					$TYPE_ARY = getSmstypeUrl($SMS_TYPE, $CONTENT, $TABLE_ID, $TABLE_VAR, $TABLE_NAME, $loginUserID);
					$TYPE_TEXT = $TYPE_ARY['TEXT'];
					$TYPE_URL = $TYPE_ARY['URL'];

					$smsInfor = array(
						"SMS_ID" => $SMS_ID,
						"TYPE_NAME" => $TYPE_NAME,
						"CONTENT" => $CONTENT,
						"TYPE_TEXT" => $TYPE_TEXT,
						"TYPE_URL" => $TYPE_URL,
                        "SEND_TIME1" => $SEND_TIME,
						"SEND_TIME" => date('Y-m-d',strtotime($SEND_TIME)),
						"USER_NAME" => getUserNameNew($FROM_ID),
						"REMIND_FLAG" => $REMIND_FLAG,
						"FROM_ID"=>$FROM_ID
					);

					$SMS_LINK_TYPE = 0;
					if ($TYPE_TEXT != "" && $TYPE_URL) {
						if (strstr($TYPE_URL, "/general/workflow/input_form/input_form.php")) {
							$run_id = substr(strstr($TYPE_URL, "RUN_ID="), 7, strpos(strstr($TYPE_URL, "RUN_ID="), "&") - 7);
							$smsInfor["RUN_ID"] = $run_id;
							$SMS_LINK_TYPE = 1;
						} else {
							if (strstr($TYPE_URL, '?')) {
								$SMS_LINK_TYPE = 2;
							} else {
								$SMS_LINK_TYPE = 3;
							}
						}

					} else if ($TYPE_TEXT) {
						$SMS_LINK_TYPE = 4;
					}

					$smsInfor["SMS_LINK_TYPE"] = $SMS_LINK_TYPE;
                    $smsInfor['avatar_type'] = getAvatarType($FROM_ID);
					$smsList[] = $smsInfor;
				}

				echo json_encode($smsList);
				break;
			/**
			 * 最近邮件
			 */
			case 'email' :
				$CUR_TIME = date("Y-m-d H:i:s", time());

				$sql = "SELECT * FROM email WHERE BOX_ID=0
                    AND TO_ID='$loginUserID'
                    AND SEND_FLAG='1'
                    AND DELETE_FLAG!='1' ORDER BY EMAIL_ID DESC LIMIT 0," . $rowCount . "";
				$rs = exequery($connection, $sql);
				$COUNT = 0;
				while ($ROW = mysql_fetch_array($rs)) {
					$COUNT++;
					$EMAIL_ID = $ROW["EMAIL_ID"];
					$FROM_ID = $ROW["FROM_ID"];
					$SEND_TIME = $ROW["SEND_TIME"];
					$READ_FLAG = $ROW["READ_FLAG"];
					$SUBJECT = $ROW["SUBJECT"];
					$SUBJECT = str_replace("<", "&lt", $SUBJECT);
					$SUBJECT = str_replace(">", "&gt", $SUBJECT);
					$SUBJECT = stripslashes($SUBJECT);

					$emailList[] = array(
						"EMAIL_ID" => $EMAIL_ID,
						"SUBJECT" => $SUBJECT,
                        "SEND_TIME1" => $SEND_TIME,
						"SEND_TIME" => date('Y-m-d',strtotime($SEND_TIME)),
                        "FROM_ID"  => $FROM_ID,
                        'avatar_type' => getAvatarType($FROM_ID),
						"FROM_USER_NAME" => getusername($FROM_ID),
						"isNew" => $READ_FLAG
					);
				}

				echo json_encode($emailList);

				break;
			/**
			 * 通讯录
			 */
			case 'addressBook' :
                include_once ("api/address.class.php");
				$address   = new address();
				$rownum    = $rowCount;
				$common_id = $dirID;

				$sql = "SELECT * FROM address_group";
				$res = exequery($connection,$sql);
				while($row = mysql_fetch_array($res)){
					$addressGroupList[$row["GROUP_ID"]] = $row["GROUP_NAME"];
				}

				$addressBookList = $address->GetAddrInfor('0',$rownum,'','',$type,'');
                $_addressBookList = array();
                foreach($addressBookList as $key => $value){
                    $creator = getUserNameNew($value['A11']);
                    $avatar_type = getAvatarType($value['A11']);
                    $value['userId'] =$value['A11'];
                    $value['A11'] = $creator;
                    $value['creator'] = $creator;
                    $value['avatar_type'] = $avatar_type;
                    $_addressBookList[] = $value;
                    $_addressBookList[$key]["A10"] = $addressGroupList[$value['A10']];
                }
				echo json_encode($_addressBookList);
				break;
			/**
			 * 待批会议
			 */
			case 'meeting' :
                include_once("api/meeting.class.php");
				$meeting  = new meeting();
				$newInfor = array();
				switch ($type) {
					case 'examine':
						$infor = $meeting->meeting_examine("A_ID","DESC",0,$rowCount,"",array("m_state"=>'7'));
						for($i=0;$i<count($infor);$i++){
							if($infor[$i]["apply_id"]){
								$newInfor[$i] = $infor[$i];
								$newInfor[$i]["applyPersonName"] = getUserNameNew($infor[$i]["apply_person"]);
		                        $newInfor[$i]['avatar_type'] = getAvatarType($infor[$i]["apply_person"]);
		                        $newInfor[$i]['create_time'] = $infor[$i]["begin_time"].' ~ '.$infor[$i]["end_time"];
								$newInfor[$i]["type"] = "examine";
							}
						}
						break;
					case 'join':
						$infor = $meeting->myapply_show("A_ID","DESC",0,$rowCount,"my_join",$loginUserID,array());
						for($i=0;$i<count($infor);$i++){
							if($infor[$i]["apply_id"]){
								$newInfor[$i] = $infor[$i];
								$newInfor[$i]["applyPersonName"] = getUserNameNew($infor[$i]["apply_person"]);
		                        $newInfor[$i]['avatar_type'] = getAvatarType($infor[$i]["apply_person"]);
		                        $newInfor[$i]['create_time'] = $infor[$i]["begin_time"].' ~ '.$infor[$i]["end_time"];
								$newInfor[$i]["type"] = "join";
							}
						}
						break;
					default:
						break;
				}
				echo json_encode($newInfor);
                break;
			/**
			 * 新闻
			 */
			case 'news' :
                include_once ("api/news.class.php");
				$news = new news();
                $fieldArray = array(
                    'NEWS_ID',
                    'SUBJECT',
                    'news_reader',
                    'ATTACHMENT_ID',
                    'ATTACHMENT_NAME',
                    'NEWS_DESC',
                    'PROVIDER',
                    'NEWS_TIME'
                );
				$newsList = $news->getNewsList(array("provider"=>"admin","news_type"=>$dirID,"inspect"=>'1'),array("orderby"=>"PUTIP","ordertype"=>"DESC","limit"=>$rowCount),$fieldArray);
                global $ATTACH_PATH;
                $_newList = array();
				foreach($newsList as $key=>$value){
					$isNew = false;
					if (!find_id($value["news_reader"],$loginUserID)) {
						$isNew = true;
					}
                    $imgSrc = $value["ATTACHMENT_ID"] != ""?$value["ATTACHMENT_ID"].'/'.$value["ATTACHMENT_NAME"]:"images/defau.jpg";
                    if(file_exists(iconv("UTF-8","GBK",$ATTACH_PATH.$imgSrc))){
                        $viewSrc = createimage($ATTACH_PATH.$imgSrc,md5($value["ATTACHMENT_NAME"]),0,$value["ATTACHMENT_ID"]);
                        $newpicname  = '0'.md5($value["ATTACHMENT_NAME"]);
                        $cachedir    = mkMd5DirForCache($value["ATTACHMENT_ID"].md5($value["ATTACHMENT_NAME"]));
                        $destination = $cachedir.$newpicname;
                        if(!file_exists($destination)){
                            $viewSrc = "/images/defau.jpg";
                        }
                    }else{
                        $viewSrc = "/images/defau.jpg";
                    }
                    $temp["NEWS_ID"]        = $value["NEWS_ID"];
					$temp["SUBJECT"]        = $value["SUBJECT"];
                    $temp["CONTENT"]        = $value["NEWS_DESC"];
                    $temp["username"]       = getUsernameNew($value["PROVIDER"]);
					$temp["isNew"]          = $isNew;
					$temp["imgSrc"]         = $viewSrc;
                    $temp["imgSrc1"]         = $value["news_reader"];
					$temp["USER_ID"]        = $value["PROVIDER"];//更新—>李志军
					$temp["avatar_type"]    = getAvatarType($value["PROVIDER"]);//更新—>李志军
                    $temp["NEWS_TIME1"]     = $newsList[$key]["NEWS_TIME"];
                    $temp["NEWS_TIME"]      = date('Y-m-d',strtotime($newsList[$key]["NEWS_TIME"]));
                    $_newList[] = $temp;
				}

				echo json_encode($_newList);
				break;
			/**
			 * 日程
			 */
			case 'agenda' :
                includelangpak("calendar");
                include_once("api/calendar.class.php");
				$caleApi  = new calendar();
				$infor = $caleApi->caleListShowData("CAL_ID","DESC","","","receive",array());
				$newInfor = array();
				for($i=0;$i<count($infor);$i++){
					if($infor[$i]["CAL_ID"]){
						$newInfor[$i] = $infor[$i];
					}
				}
				echo json_encode($newInfor);
				break;
			/**
			 * 项目
			 */
			case 'project' :
                include_once("api/project.class.php");
				include_once ("general/project/function/function_all.php");
				$projectapi = new Projects();
				$infor = $projectapi->pro_ListMyProjectData("MANAGER_ID","DESC",0,$rows,"",array());
				$newInfor = array();
				for($i=0;$i<count($infor);$i++){
					if($infor[$i]["MANAGER_ID"]){
						$newInfor[$i] = $infor[$i];
						$newInfor[$i]["plan"] = pro_countSumPersent($infor[$i]["MANAGER_ID"]);
					}
				}
				echo json_encode($newInfor);
				break;
            /**
             * 客户
             */
			case 'customer' :
				include_once("api/customer.class.php");
				$customer    = new customer();
				$purview_where = $customer->get_purview_where();

				$sql = "SELECT c.CREATEOR,c.CUSTOMER_ID, c.CUSTOMER_NAME, c.CREATE_TIME,c.MANAGE_USER ";

				$query = "FROM customer as c
						LEFT JOIN user as u ON(u.USER_ID = c.MANAGE_USER)
						LEFT JOIN user_priv as up ON(up.USER_PRIV = u.USER_PRIV)
							WHERE $purview_where";

				$query.=" ORDER BY c.CUSTOMER_ID desc LIMIT 0,$rowCount";

				$result = exequery($connection, $sql.$query);
				while ($row = mysql_fetch_assoc($result)) {
					$row['MANAGE_USER_NAME'] = getUserNameNew($row['MANAGE_USER']);
                    $row['avatar_type'] = getAvatarType($row['CREATEOR']);
                    $row['CREATE_TIME1'] = $row['CREATE_TIME'];
                    $row['CREATE_TIME']  = date('Y-m-d',strtotime($row['CREATE_TIME']));
					$customerList[] = $row;
				}

				echo json_encode($customerList);
				break;
            /**
             * 投票
             */
			case 'vote':
				$query = "SELECT * FROM phpqsurvey
							  WHERE 1 AND Active='y'
						  	  AND((StartDate<=NOW() and EndDate>=NOW())
							      OR
								 (StartDate<=NOW() and UNIX_TIMESTAMP(EndDate)= 0))
								AND(
									(DEPT_ID='DEPT_ALL')
									OR
									(INStr(DEPT_ID,'".$loginDeptID."')>0 or INStr(DEPT_ID,'".$loginDeptID."')=1)
									OR
									(INStr(PRIV_ID,'".$loginPrivID."')>0 or INStr(PRIV_ID,'".$loginPrivID."')=1)
									OR
									(InStr(USER_ID,'".$loginUserID."')>0 or INStr(PRIV_ID,'".$loginUserID."')=1)
								) ORDER BY SID DESC LIMIT 0,$rowCount";
				$res = exequery($connection,$query);
				$voteList = array();
				while($row = mysql_fetch_array($res))
				{
                    $row['creator'] = getUserNameNew($row['CREATOR']);
                    $row['avatar_type'] = getAvatarType($row['CREATOR']);
                    array_push($voteList,$row);
				}
				foreach($voteList as $key=>$value)
				{
					$voteList[$key]["Opt"] = "<a href='#' onClick=\"javascript:window.open('/general/vote/see_result.php?sid=".$value["SID"]."&op=view&res_type=result');\">".$_lang["info_vote_see_result"]."</a>";
				}
				echo json_encode($voteList);
				break;
            /**
             * 车辆审批
             */
			case "vehicle":
                include_once ("api/vehicles.class.php");
				$vehicles = new vehicles ();
				$infor     = $vehicles->examine_info("VA_ID","DESC",0,$rowCount,"",$loginUserID);
				$newInfor = array();
				for($i=0;$i<count($infor);$i++){
					if($infor[$i]["apply_id"]){
						$newInfor[$i] = $infor[$i];
                        $newInfor[$i]['creator'] = getUserNameNew($infor[$i]["apply_person"]);
                        $newInfor[$i]['avatar_type'] = getAvatarType($infor[$i]["apply_person"]);
						$newInfor[$i]["begin_time"] = date("Y-m-d",strtotime($infor[$i]["begin_time"]));
                        $newInfor[$i]["begin_time1"] = date("Y-m-d H:i:s",strtotime($infor[$i]["begin_time"]));
						$newInfor[$i]["end_time"] = date("Y-m-d",strtotime($infor[$i]["end_time"]));
					}
				}
				echo json_encode($newInfor);
			break;
            /**
             * 快捷运行
             */
            case  "winRun":
                $query = "SELECT * from WINEXE where USER_ID='$loginUserID' order by WIN_NO";
                $cursor= exequery($connection,$query);
                $winInfo = array();
                while($ROW=mysql_fetch_array($cursor))
                {
                    $ROW['creator'] = getUserNameNew($ROW['USER_ID']);
                    $ROW['avatar_type'] = getAvatarType($ROW['USER_ID']);
                    $ROW['WIN_PATH_C'] =base64_encode($ROW['WIN_PATH']);
                    $winInfo[] = $ROW;
                }
                echo json_encode($winInfo);
                break;
			default :
				break;
		}
}
/**
 * 获取用户头像图片后缀。
 * @global type $connection
 * @param type $userId
 * @return type
 */
function getAvatarType($userId){
    global $connection;
    $query = "SELECT AVATAR_TYPE from user where USER_ID='" . SecurityFilter($userId) ."'";
    $cursor= exequery($connection,$query);
    $row = mysql_fetch_array($cursor);
    return $row['AVATAR_TYPE'];
}
?>
