<?php

include 'inc/auth.php';
include_once 'inc/utility_all.php';
include_once 'inc/AppGlobal.php';

$uid = $_SESSION['LOGIN_USER_ID'];
$corpid = trim($_GET['corpid']);
$secret = trim($_GET['secret']);
$domain = trim($_GET["domain"]);
$domain = trim($domain, "/");

//排除内网IP
if (!filter_var($domain, FILTER_VALIDATE_URL)) {
    $result = array(
        "errcode" => "99999",
        "errmsg" => "域名错误：不是合法域名"
    );

    echo json_encode($result);
    exit;
}

$urls = parse_url($domain);
$host = $urls["host"];

if (filter_var($host, FILTER_VALIDATE_IP)) {
    //IP地址
    if ($host == "localhost" || $host == "127.0.0.1") {
        $result = array(
            "errcode" => "99999",
            "errmsg" => "域名错误：内网IP"
        );
        echo json_encode($result);
        exit;
    }

    $ip_range = array(
        array('10.0.0.0', '10.255.255.255'),
        array('172.16.0.0', '172.31.255.255'),
        array('192.168.0.0', '192.168.255.255'),
    );

    $ip = ip2long($host);
    $find = '';
    foreach ($ip_range as $k => $v) {
        if ($ip >= ip2long($v[0]) && $ip <= ip2long($v[1])) {
            $find = $k;
        }
    }

    if ((!empty($find))) {
        $result = array(
            "errcode" => "99999",
            "errmsg" => "域名错误：内网IP"
        );
        echo json_encode($result);
        exit;
    }
}

//访问测试
$url = $domain . "/general/qyweixin/validurl.php";
$status = AppGlobal::getToken($url);
if (!$status || $status != 100) {
    $result = array(
        "errcode" => "99999",
        "errmsg" => "域名错误：访问异常"
    );

    echo json_encode($result);
    exit;
}

$time = time();
$url = "https://qyapi.weixin.qq.com/cgi-bin/gettoken?corpid={$corpid}&corpsecret={$secret}";
$json = AppGlobal::getToken($url);

if (!$json) {
    $result = array(
        "errcode" => "40099",
        "errmsg" => "未知结果，请查看系统日志获取错误信息"
    );
    echo json_encode($result);
    exit;
}

$result = json_decode($json, true);
if (!isset($result['errcode'])) { // 不存在错误编码
    $sql = "update qyweixin_token set access_token = '{$result['access_token']}', token_time = '{$time}',domain =  '{$domain}' ";
    exequery($connection, $sql);
} else {
    $logObj = array(
        "time" => date("Y-m-d H:i:s"),
        "user_name" => $_SESSION['LOGIN_USER_NAME'],
        "errcode" => $result["errcode"],
        "errmsg" => $result["errmsg"],
    );

    custom_checkpath(UTH_TMP_PATH . "auth"); //pc
    $file = fopen(UTH_TMP_PATH . "auth/qyweixin.log", 'a');
    fwrite($file, json_encode($logObj));
    fwrite($file, "\r\n");
    fclose($file);
}

echo $json;
exit;






