<?php

include_once 'general/qyweixin/qy.class.php';
include_once 'inc/utility_all.php';
include_once 'inc/AppGlobal.php';

class qyWechat extends qy {

    public $pid = array();
    protected $autoMenuArray = array(
        '216' => array(1, '通讯录'),
        '26' => array(2, '我的日程'),
        '6' => array(3, '我的文档'),
        '12' => array(4, '我的邮件'),
        '13' => array(5, '我的消息'),
        '44' => array(6, '我的客户'),
        '28' => array(7, '我的微博'),
        '362' => array(8, '我的协作'),
        '新建中心' => array(9, '新建中心'),
        '130' => array(14, '综合新闻'),
        '131' => array(15, '公告通知'),
        '126' => array(19, '我的工资单'),
        '1' => array(
            '待办流程' => array(10, '待办流程'),
            '流程跟踪' => array(
                array(11, '办结流程'),
                array(12, '已办流程'),
                array(13, '我的请求'),
                array(20, '抄送流程')
            )
        ),
        '32' => array(
            '考勤记录' => array(16, '我的考勤'),
            '移动考勤' => array(
                array(17, '签到签退'),
                array(18, '业务出差'),
                array(21, '考勤统计'),
            )
        )
    );

    public function __construct() {

        parent::__construct();
        $this->updateAccessToken();
    }

    /*
     * name: 部门名称
     * parentid: 父部门id, 根部门id为1
     * order: 在父部门中的次序, 从1开始, 数字越大排序越靠后
     */

    public function createDepartment($name, $parentid, $order, $error = false) {

        $access_token = $this->get_access_token();
        $api = 'https://qyapi.weixin.qq.com/cgi-bin/department/create?access_token=' . $access_token;
        $opt = array(
            'name' => urlencode($name),
            'parentid' => $parentid,
            'order' => $order
        );
        $code = urldecode(json_encode($opt));
        $result = json_decode(AppGlobal::getHttps($api, $code, true), true);

        if ($error) {
            return $result;
        }
        return $result['id'];
    }

    //获取部门信息
    public function getDepartment() {
        $access_token = $this->get_access_token();
        $api = 'https://qyapi.weixin.qq.com/cgi-bin/department/list?access_token=' . $access_token;
        $result = json_decode(AppGlobal::getToken($api), true);

        return $result['department'];
    }

    //清空部门
    public function cleanDepartment() {
        $departmentTemp = $this->getDepartment();

        if (1 < count($departmentTemp)) {
            foreach ($departmentTemp as $temp) {
                $this->deleteDepartment($temp['id']);
            }
            $this->cleanDepartment();
        }
    }

    //删除部门
    public function deleteDepartment($id) {

        $access_token = $this->get_access_token();
        $api = "https://qyapi.weixin.qq.com/cgi-bin/department/delete?access_token={$access_token}&id={$id}";
        $result = json_decode(AppGlobal::getToken($api), true);

        if (0 === $result['errcode']) {
            return true;
        } else {
            return false;
        }
    }

    public function inputDepartment() {

        $rootID = $this->getRootID();

        foreach ($rootID as $v) {
            $this->dealDepartment($v);
        }

        //删除掉无用的部门
        //导入通讯录
        return $this->inputUser();
    }

    //递归处理 组织架构
    protected function dealDepartment($dID) {
        $child = $this->getChild($dID);
        if ($child && is_array($child)) {
            foreach ($child as $value) {
                $name = $value['DEPT_NAME'];
                $id = $value['DEPT_ID'];
                $pid = $this->qyweixinDept($value['DEPT_PARENT']);
                $parentID = max(1, $pid);
                $qydept_id = $this->createDepartment($name, $parentID, 1);
                if ($qydept_id != 0) {
                    $this->qyweixinUpdate($id, $qydept_id);
                    $this->dealDepartment($id);
                }
                //获取$id对应的qydept_id
            }
        }
        //$this->dealDepartment($id);
    }

    public function qyweixinDept($id) {
        $sql2 = "select id,qydept_id from qyweixin_department where dept_id =" . $id;
        $result = $this->query($sql2);
        $row = @mysql_fetch_assoc($result);
        if ($row['id']) {
            return $row['qydept_id'];
        } else {
            return FALSE;
        }
    }

    public function get_qyweixin_token() {
        $sql = 'select * from qyweixin_token limit 1';
        $result = $this->query($sql);
        $row = @mysql_fetch_assoc($result);
        return $row;
    }

    public function qyweixinUpdate($id, $qydept_id) {

        $sql2_1 = "select id,dept_id, qydept_id from qyweixin_department where dept_id =" . $id;
        $result = $this->query($sql2_1);
        $row = @mysql_fetch_assoc($result);
        if ($row['id']) {
            $sql = "update  qyweixin_department set qydept_id = '" . $qydept_id . "' where dept_id =" . $id;
        } else {
            $sql = "insert into qyweixin_department(dept_id,qydept_id) values('" . $id . "','" . $qydept_id . "')";
        }
        $this->query($sql);
    }

    //获取顶层部门
    private function getRootID() {
        $sql = 'select DEPT_PARENT from department order by DEPT_NO ASC ,DEPT_PARENT ASC';
        $result = $this->query($sql);

        while ($root = mysql_fetch_assoc($result)) {
            $roots[] = $root['DEPT_PARENT'];
        }

        return $roots;
    }

    //获取子部门
    public function getChild($pid) {
        if (!isset($pid)) {
            return false;
        }
        $pid = intval($pid);
        $sql = "select DEPT_ID, DEPT_NAME, DEPT_PARENT from department where DEPT_PARENT = " . $pid . " order by DEPT_NO DESC,DEPT_PARENT DESC,DEPT_ID DESC";
        $result = $this->query($sql);

        $child = array();
        while ($row = @mysql_fetch_assoc($result)) {
            if (empty($row['DEPT_ID'])) {
                continue;
            }
            $child[] = $row;
        }

        return $child;
    }

    //导入通讯录
    public function inputUser() {

        $sql = "SELECT u.USER_ID,u.USER_NAME,u.MOBIL_NO,u.EMAIL,u.DEPT_ID,p.PRIV_NAME FROM user u LEFT JOIN user_priv p ON u.USER_PRIV = p.USER_PRIV WHERE u.DEPT_ID > 0 AND u.MOBIL_NO != '' AND u.MOBIL_NO != 0 and u.USER_ACCOUNTS !=''"; //and u.user_id = 'WV00000068'

        $result = $this->query($sql);

        while ($row = @mysql_fetch_assoc($result)) {
            if (empty($row['MOBIL_NO']))
                continue;

            $user = array();
            $user['userid'] = $row['USER_ID'];
            $user['name'] = urlencode($row['USER_NAME']);
            //$pid =  $this->qyweixinDept($row['DEPT_ID']);
            $user['department'] = array($this->qyweixinDept($row['DEPT_ID']));
            $user['mobile'] = $row['MOBIL_NO'];
            $user['email'] = $row['EMAIL'];
            $user['position'] = urlencode($row['PRIV_NAME']);

            $arr = $this->getUser($user['userid']);
            $user = urldecode(json_encode($user));


            if ($arr['errcode'] == 0) { // 存在
                //更新
                $mm = $this->updateUser($user);
            } else {
                $mm = $this->createUser($user);
            }
            if ($mm == 45024) {
                break;
            }
        }

        return true;
    }

    //新建用户
    protected function createUser($user) {
        $api = 'https://qyapi.weixin.qq.com/cgi-bin/user/create?access_token=' . $this->access_token;

        $result = json_decode(AppGlobal::getHttps($api, $user, 1), true);
        return $result['errcode'];
    }

    //获取用户信息
    public function getUser($uid) {
        $access_token = $this->get_access_token();
        $api = "https://qyapi.weixin.qq.com/cgi-bin/user/get?userid={$uid}&access_token=" . $access_token;


        return json_decode(AppGlobal::getToken($api), true);
    }

    public function updateUser($user) {
        $access_token = $this->get_access_token();
        $api = "https://qyapi.weixin.qq.com/cgi-bin/user/update?access_token=" . $access_token;
        $result = json_decode(AppGlobal::getHttps($api, $user, 1), true);

        return $result['errcode'];
    }

    //批量删除用户
    public function deleteUser($userList) {
        $access_token = $this->get_access_token();
        $api = "https://qyapi.weixin.qq.com/cgi-bin/user/batchdelete?access_token={$access_token}";
        $post = array('useridlist' => $userList);

        $result = json_decode(AppGlobal::getHttps($api, $post, true), true);

        if (0 === $result['errcode']) {
            return true;
        } else {
            return false;
        }
    }

    public function getAgentAppList() {
        $access_token = $this->get_access_token();
        $url = "https://qyapi.weixin.qq.com/cgi-bin/agent/list?access_token=$access_token";
        $temp = json_decode(AppGlobal::getToken($url), true);

        if (isset($temp["errcode"]) && $temp["errcode"]) {
            return $temp["errcode"];
        }
        return $temp["agentlist"];
    }

    //创建菜单
    public function createMenu($agentid, $menu) {

        $access_token = $this->get_access_token();

        $api = "https://qyapi.weixin.qq.com/cgi-bin/menu/create?agentid={$agentid}&access_token=" . $access_token;
        $code = urldecode(json_encode($menu));

        $res = json_decode(AppGlobal::getHttps($api, $code, true), true);

        return $res;
    }

    //删除菜单
    public function deleteMenuByAgentId($agentid) {
        if (!$agentid) {
            return;
        }
        $access_token = $this->get_access_token();

        $api = "https://qyapi.weixin.qq.com/cgi-bin/menu/delete?access_token=$access_token&agentid=$agentid";
        AppGlobal::getToken($api);
    }

    //更新菜单信息
    public function updateMenu($agentid) {
        $imenu = array();

        $sql = "select * from qyweixin_menu where node = 'p' and agentid = '{$agentid}'";
        $parent = $this->queryWithFilter($sql);

        foreach ($parent as $row) {
            $iSQL = "select * from qyweixin_menu where node = '{$row['id']}'";
            $iResult = $this->queryWithFilter($iSQL, array('name', 'type', 'value'));
            if (!empty($iResult)) {
                $imenu[] = array(
                    'name' => urlencode($row['name']),
                    'sub_button' => $this->dealKey($iResult)
                );
            } else {
                unset($row['id']);
                unset($row['node']);

                $imenu[] = $this->dealKey($row);
            }
        }
        $menu = array('button' => $imenu);

        return $this->createMenu($agentid, $menu);
    }

    //菜单信息全部更新
    public function updateAll() {
        //清空数据 1111  
        $result = $this->createWechatMenu();
        $tempAgentId = array();
        foreach ($result as $val) {
            $tempAgentId[] = $val["agentid"];
        }

        $ageidList = $this->getAgentAppList();
        if (!is_array($ageidList) && $ageidList) {
            return $ageidList;
        }

        $wxAgentIds = array();
        if ($ageidList) {
            foreach ($ageidList as $val2) {
                $wxAgentIds[] = $val2["agentid"];
            }
        }

        $delAgentIds = array_diff($wxAgentIds, $tempAgentId);
        foreach ($delAgentIds as $agentid) {
            $this->deleteMenuByAgentId($agentid);
        }
        $sql = 'select distinct agentid from qyweixin_menu';
        $result = $this->queryWithFilter($sql, array('agentid'));

        foreach ($result as $value) {
            $result = $this->updateMenu($value['agentid']);
            if (isset($result["errcode"]) && $result["errcode"] != 0) {
                return $result['errcode'];
                break;
            }
        }
        return 0; //0 代表没有错误
    }

    public function createWechatMenu() {
        $Tsql = "truncate table qyweixin_menu";
        $this->query($Tsql);
        //生成menuData
        $sql = 'select * from qyweixin_app where agentid is not null';
        $result = $this->queryWithFilter($sql, array('agentid', 'funcid'));

        foreach ($result as $key => $val) {
            $agentId = $val["agentid"];
            $menuId = $val["funcid"];
            if (!$menuId || $menuId == NULL) {
                $menuId = "新建中心";
            }

            $appCheck = array_values($this->autoMenuArray[$menuId]);

            $menuName = $appCheck[1];
            $option = array();
            $option['agentid'] = $agentId;

            //重复创建的菜单 应该删除掉 $agentId
            if (is_array($menuName)) {
                $appArray = $this->autoMenuArray[$menuId];
                foreach ($appArray as $key => $value) {
                    $checkValue = array_values($value);
                    if (!is_array($checkValue[0])) {
                        $option['menu_name'] = $value[1];
                        $option['state'] = $value[0] . "-" . $agentId;
                        $this->createAppData($option);
                    } else {
                        $option['menu_name'] = $key;
                        $option['state'] = $agentId;
                        $juniorId = $this->createAppData($option);
                        foreach ($value as $imenu) {
                            $option['menu_name'] = $imenu[1];
                            $option['state'] = $imenu[0] . "-" . $agentId;
                            $this->createAppData($option, $juniorId);
                        }
                    }
                }
            } else {
                $option['menu_name'] = $menuName;
                $option['state'] = $appCheck[0] . '-' . $agentId;
                $this->createAppData($option);
            }
        }

        return $result;
    }

    //获取菜单信息
    public function getMenu($agentid) {
        $access_token = $this->get_access_token();
        $api = "https://qyapi.weixin.qq.com/cgi-bin/menu/get?agentid={$agentid}&access_token=" . $access_token;
        // return $api;
        $res = json_decode(AppGlobal::getToken($api), true);

        return $res;
    }

    //oauth2验证用code值获取微信通讯录的uid
    public function getCode($agentid, $code) {
        $access_token = $this->get_access_token();
        $api = "https://qyapi.weixin.qq.com/cgi-bin/user/getuserinfo?access_token={$access_token}&code={$code}&agentid={$agentid}";

        return json_decode(AppGlobal::getToken($api), true);
    }

    //获取agentid
    public function getAgentid($appName) {
        $appName = trim($appName);
        if (!$appName)
            return false;

        $sql = "select agentid from qyweixin_app where name = '{$appName}'";
        $result = $this->query($sql);

        $row = @mysql_fetch_assoc($result);
        return $row['agentid'];
    }

    //推送信息
    public function pushMsg($agentid, $uids, $msgType = 'news') {
        switch ($msgType) {
            case 'news':
                $this->pushNews($agentid, $uids);
                break;
            case 'text':
                $this->pushText($agentid, $uids);
                break;
            case 'image':
                $this->pushImage($agentid, $uids);
                break;
            case 'voice':
                $this->pushVoice($agentid, $uids);
                break;
            case 'video':
                $this->pushVideo($agentid, $uids);
                break;
            case 'file':
                $this->pushFile($agentid, $uids);
                break;
            case 'mpnews':
                $this->pushMpNews($agentid, $uids);
                break;
            default:
                break;
        }
    }

    public function pushNews($option) {

        $access_token = $this->get_access_token();
        if (empty($option) || !is_array($option)) {
            return false;
        }


        $sourceType = $option['sourceType'];
        $sourceID = $option['sourceID'];
        $content = $option['content'];
        //$url = $option['url'];
        $uids = $option['uids'];

        $agentid = $this->dealSourceToAgentid($sourceType);

        if (!$agentid) {
            return false;
        }

        $url = $this->dealSourceToURL($agentid);
        if (!$url) {
            return false;
        }
        if ($option['url'] == "x") {
            $url_current = $url;
        } else {
            $che = array('#wechat_redirect' => "-{$sourceID}-{$sourceType}#wechat_redirect");
            $url_current = strtr($url, $che);
        }
        $api = 'https://qyapi.weixin.qq.com/cgi-bin/message/send?access_token=' . $access_token;
        $msgTemp = array(
            'touser' => $uids,
            'toparty' => "",
            'totag' => "",
            'msgtype' => 'news',
            'agentid' => $agentid,
            'news' => array(
                'articles' => array(
                    array(
                        'title' => urlencode($content),
                        'description' => urlencode($content),
                        'url' => $url_current,
                        'picurl' => ""
                    )
                )
            )
        );

        $msg = urldecode(json_encode($msgTemp));

        $result = json_decode(AppGlobal::getHttps($api, $msg, true), true);

        return $result;
    }

    public function pushSmsNews($option) {

        $access_token = $this->get_access_token();
        if (empty($option) || !is_array($option)) {
            return false;
        }

        $content = $option['content'];

        $uids = $option['uids'];
        $agentid = $this->dealSourceToAgentid(false); // 设置为空

        if (!$agentid) {
            return false;
        }

        $url = $this->dealSourceToURL($agentid);
        if (!$url) {
            return false;
        }


        $url_current = $url;

        $api = 'https://qyapi.weixin.qq.com/cgi-bin/message/send?access_token=' . $access_token;



        $msgTemp = array(
            'touser' => $uids,
            'toparty' => "",
            'totag' => "",
            'msgtype' => 'news',
            'agentid' => $agentid,
            'news' => array(
                'articles' => array(
                    array(
                        'title' => urlencode($content),
                        'description' => urlencode($content),
                        'url' => $url_current,
                        'picurl' => ""
                    )
                )
            )
        );

        $msg = urldecode(json_encode($msgTemp));

        $result = json_decode(AppGlobal::getHttps($api, $msg, true), true);

        return $result;
    }

    //推送文本
    public function pushText($agentid, $uids, $content) {
        if (!$agentid || !$uids) {
            return false;
        }

        $access_token = $this->get_access_token();
        $api = 'https://qyapi.weixin.qq.com/cgi-bin/message/send?access_token=' . $access_token;

        $uids = trim(str_replace(',', '|', $uids), '|');
        $msgTemp = array(
            'touser' => $uids,
            'msgtype' => 'text',
            'agentid' => $agentid,
            'text' => array(
                'content' => urlencode($content)
            )
        );

        $msg = urldecode(json_encode($msgTemp));
        $result = json_decode(AppGlobal::getHttps($api, $msg, true), true);

        return $result;
    }

    //获取域名
    public function getDomain() {
        $sql = "select domain from qyweixin_token limit 1";
        $result = $this->query($sql);
        $row = @mysql_fetch_assoc($result);

        return trim($row['domain'], '/');
    }

    //获取app名称对应的func_id
    public function getFuncID($appName) {
        $sql = "select FUNC_ID from sys_function where FUNC_NAME = '{$appName}'";
        $result = $this->query($sql);
        $row = @mysql_fetch_assoc($result);

        return $row['FUNC_ID'];
    }

    //检查是否还有app没有agentid
    public function checkAppWithOutAgentid() {
        $sql = "SELECT count(*) count from qyweixin_app where agentid is null";
        $result = $this->query($sql);
        $row = @mysql_fetch_assoc($result);

        return $row['count'];
    }

    //获取手机版接口
    public function getMobile($uid, $method) {
        // $domain = trim($this->getDomain(), '/');
        // $url = $domain."/E-mobile/App/weixin/WeiServiceApi.php?type=1&uid={$uid}&m={$method}";
        // return httpContents($url);
        header("Location:/E-mobile/App/weixin/WeiServiceApi.php?type=1&uid={$uid}&m={$method}");
    }

    //获取微信推送的连接
    public function getQyUrl($uid, $sourceType, $sourceID) {
        // 解密Uid
        $arr = include('E-mobile/App/Weixin/Config/config.php');

        $_userId = str_replace(' ', '+', $uid);
        $userId = encrypt2($_userId, 'D', $arr['encryptKey']); //用户ID解密

        $method = $this->dealSource($sourceType);

        if (false !== strpos($sourceID, ',')) {
            $FlowPrcsResult = $this->dealFlowPrcs($userId, $sourceID);
            $sourceID = $FlowPrcsResult['sourceID'];
            $copy = $FlowPrcsResult['copy'];
        }

        if ($copy) {
            $method = 16;
        }

        header("Location:/E-mobile/App/weixin/WeiServiceApi.php?type=2&uid={$uid}&m={$method}&id={$sourceID}");
    }

    //点击跳转
    public function getMobileRedirect($uid, $sourceType = '0', $sourceID) {
        $method = $this->dealSource($sourceType);

        if (false !== strpos($sourceID, ',')) {
            $FlowPrcsResult = $this->dealFlowPrcs($uid, $sourceID);
            $sourceID = $FlowPrcsResult['sourceID'];
            $copy = $FlowPrcsResult['copy'];
        }

        if ($copy) {
            $method = 16;
        }

        $userID = encrypt2($uid, 'E', 'eoffice');
        header("Location:/E-mobile/App/weixin/WeiServiceApi.php?type=2&uid={$userID}&m={$method}&id={$sourceID}");
    }

    private function dealSourceToAgentid($sourceType) {

        if (!$sourceType)
            $sourceType = 'x';

        $dealSourceToFuncID = array(
            '1' => 131, //公告
            '2' => 12, //内部邮件
            '7' => 1, //工作流程
            '20' => 6, //文档中心
            '26' => 362, //协作区
            '27' => 130, //新闻
            '28' => 26, //日程计划
            'x' => 13, //内部消息
            '19' => 44,
            '24' => 28
        );

        $funcID = $dealSourceToFuncID[$sourceType];

        if (!$funcID) {
            $funcID = 13;
        }

        $sql = "SELECT agentid FROM qyweixin_app  WHERE funcid ={$funcID}";
        $result = $this->query($sql);
        $row = mysql_fetch_assoc($result);

        return $row['agentid'];
    }

    private function dealSourceToURL($agentid) {

        $sql = "SELECT value FROM  qyweixin_menu WHERE agentid ={$agentid}";
        $result = $this->query($sql);
        $row = @mysql_fetch_assoc($result);
        //替换连接 加入参数
        if ($row) {
            return $row['value'];
        } else {
            return false;
        }
    }

    private function dealSource($type) {
        $source = array(
            '7' => 10, //待办流程,
            '27' => 14, //新闻
            '1' => 15, //公告
            '28' => 2, //日程
            '20' => 3, //文档
            '2' => 4, //内部邮件
            '26' => 8, //协作
            '35' => 21, //客户 
            '24' => 7,
            
        );

        return $source[$type];
    }

    public function dealFlowPrcs($uid, $sourceID) {
        $_pos = strpos($sourceID, '|');

        if (false !== $_pos) {
            $copy = trim(substr($sourceID, $_pos), '|');
            $sourceID = substr($sourceID, 0, $_pos);
        }

        $sourceID = explode(',', trim($sourceID, ','));
        $runID = $sourceID[0];

        $sql = "select FLOW_PRCS,PRCS_ID from flow_run_prcs where RUN_ID={$runID} and USER_ID='{$uid}' order by PRCS_ID desc limit 1";
        $result = $this->query($sql);
        $row = @mysql_fetch_assoc($result);
        $sourceID[2] = $row['FLOW_PRCS'];
        $sourceID[3] = $row['PRCS_ID'];

        $implode = implode(',', $sourceID);
        $return = array('copy' => $copy, 'sourceID' => $implode);

        return $return;
    }

    //更新应用-- 只生成对应的菜单
    //参数 应用ID 名称 菜单ID
    public function updateApp($agentid, $appName, $funcId) {

        if ($funcId == "null" || !$funcId) {
            $where = " and funcid is null and name ='新建中心'";
        } else {
            $where = " and funcid = '" . $funcId . "'";
        }
        if ($agentid == 0 || !$agentid) {
            //获取
            $tep = "select agentid from qyweixin_app where 1 = 1" . $where;
            $result = $this->query($tep);
            $row = @mysql_fetch_assoc($result);
            if (isset($row['agentid']) && $row['agentid']) {
                $delAgentid = $row['agentid'];
                $sql2 = "delete from qyweixin_menu where agentid = $delAgentid";
                $this->query($sql2);
            }
            $sql = "update qyweixin_app set agentid = null  where 1 = 1" . $where;
        } else {
            $sql = "update qyweixin_app set agentid = {$agentid}  where 1 = 1" . $where;
        }

        return $this->query($sql);
    }

    //创建临时应用
    public function createTempApp($func_id, $appName) {
        if (!$func_id || !$appName)
            return false;

        $sql = "insert into qyweixin_app (name, agentid) values('{$appName}', null)";
        $this->query($sql);
    }

    //创建应用
    public function createApp($agentid, $appName, $funcID = '') {
        if (!$agentid || !$appName) {
            return false;
        }
        if ($funcID == "null" || !$funcID) {
            $funcID = $appName; //新建中心
        }

        $appCheck = array_values($this->autoMenuArray[$funcID]);
        $menuName = $appCheck[1];

        $option = array();
        $option['agentid'] = $agentid;


        if (is_array($menuName)) {

            $appArray = $this->autoMenuArray[$funcID];
            foreach ($appArray as $key => $value) {
                $checkValue = array_values($value);

                if (!is_array($checkValue[0])) {
                    $option['menuName'] = $value[1];
                    $option['state'] = $value[0] . "-" . $agentid;
                    $this->createAppData($option);
                } else {
                    $option['menuName'] = $key;



                    $option['state'] = $title . $agentid;
                    $flowID = $this->createAppData($option);

                    foreach ($value as $imenu) {
                        $option['menuName'] = $imenu[1];
                        $option['state'] = $imenu[0] . "-" . $agentid;
                        $this->createAppData($option, $flowID);
                    }
                }
            }
        } else {
            $option['menuName'] = $menuName;
            $option['state'] = $appCheck[0] . '-' . $agentid;

            $this->createAppData($option);
        }
    }

    public function createAppData($opt, $node = 'p') {

        $agentid = $opt['agentid'];
        $menuName = $opt['menu_name'];
        $state = $opt['state'];
        $api = 'https://open.weixin.qq.com/connect/oauth2/authorize?';
        $domain = $this->getDomain();
        $redirect = $domain . '/general/qyweixin/oauth2.php';
        $redirect_uri = urlencode($redirect);

        $build = array(
            'appid' => $this->corpid,
            'redirect_uri' => $redirect_uri,
            'response_type' => 'code',
            'scope' => 'snsapi_base',
            'state' => $state,
        );
        $api .= http_build_query($build) . '#wechat_redirect';



        $sql = "insert into qyweixin_menu (agentid, name, node, value) values ({$agentid}, '{$menuName}', '{$node}', '{$api}')";
        $this->query($sql);

        return mysql_insert_id();
    }

    //删除应用
    public function deleteApp($agentid) {
        $sql = "delete from qyweixin_app where agentid in ({$agentid})";
        $this->query($sql);

        $this->deleteMenu($agentid);
    }

    //删除菜单
    public function deleteMenu($agentid) {
        $sql = "DELETE FROM qyweixin_menu WHERE agentid in ({$agentid})";
        $this->query($sql);
    }

    //检查菜单是否存在
    public function checkMenuExists($name) {
        $sql = "SELECT count(*) count FROM qyweixin_menu WHERE name = '{$name}'";
        $result = $this->query($sql);
        $row = @mysql_fetch_assoc($result);

        return $row['count'];
    }

    public function queryWithFilter($sql, $filter = array()) {
        global $connection;
        if (empty($sql)) {
            return false;
        }

        $res = exequery($connection, $sql);
        $respon = array();
        if (is_resource($res)) {
            while ($row = @mysql_fetch_assoc($res)) {
                if ($filter) {
                    $temp = array();
                    foreach ($filter as $k) {
                        $temp[$k] = $row[$k];
                    }
                } else {
                    $temp = $row;
                }
                $respon[] = $temp;
            }
        } else {
            $respon = $res;
        }

        return $respon;
    }

    public function dealKey($array) {
        $result = array();
        foreach ($array as $key => $value) {
            if (is_array($value)) {
                $temp = array();

                $type = $value['type'];
                switch ($type) {
                    case 'view':
                        $temp['url'] = urlencode($value['value']);
                        break;
                    case 'click':
                        $temp['key'] = urlencode($value['value']);
                        break;
                }
                $temp['type'] = $type;
                $temp['name'] = urlencode($value['name']);

                $result[] = $temp;
            } else {
                if ('type' == $key) {
                    switch ($value) {
                        case 'view':
                            $result['url'] = urlencode($array['value']);
                            break;
                        case 'click':
                            $temp['key'] = urlencode($array['value']);
                            break;
                    }
                }
                $result[$key] = urlencode($value);
                unset($result['value']);
            }
        }

        return $result;
    }

    public function errorView($msg) {
        global $_lang;

        include 'ErrorView.php';
        exit;
    }

    //获取用户OA信息 -- 用户姓名 ID 部门 
    public function getUseInfo($where) {

        $sql = "SELECT USER_ID,USER_NAME,DEPT_ID  FROM user   where  $where limit 1";
        $res = $this->query($sql);
        $row = @mysql_fetch_assoc($res);
        return $row;
    }

    //同步用户信息 先清空表 在插入信息
    public function syncUserInfo($data) {

        $sql = "insert into qyweixin_user (user_id,oa_id,gender,mobile,weixinid,oa_name,nickname,avatar,dept_id)";
        $sql .= " values ('{$data["userId"]}','{$data["oa_Id"]}','{$data["gender"]}','{$data["mobile"]}','{$data["weixinid"]}','{$data["oa_name"]}','{$data["nickname"]}','{$data["avatar"]}','{$data["dept_id"]}')";
        return $this->query($sql);
    }

    public function truncateUserInfo() {
        $sql = "TRUNCATE TABLE  `qyweixin_user`";
        return $this->query($sql);
    }

    public function getFollowList() {

        $access_token = $this->get_access_token();
        if (!$access_token) {
            return false;
        }

        $api = "https://qyapi.weixin.qq.com/cgi-bin/user/simplelist?access_token={$access_token}&department_id=1&fetch_child=1&status=1";

        $result = json_decode(AppGlobal::getToken($api), true);

        if ($result["errcode"] != 0) {
            return false;
        }

        $this->truncateUserInfo();

        foreach ($result["userlist"] as $res) {
            //获取当前用户
            $userInfo = $this->getUser($res["userid"]);

            //微信端信息
            $data["userId"] = $userInfo["userid"];
            $data["nickname"] = $userInfo["name"]; //昵称 -- 微信后台显示
            $data["mobile"] = isset($userInfo["mobile"]) && $userInfo["mobile"] ? $userInfo["mobile"] : "";
            $data["gender"] = isset($userInfo["gender"]) && $userInfo["gender"] ? $userInfo["gender"] : "";
            $data["weixinid"] = isset($userInfo["weixinid"]) && $userInfo["weixinid"] ? $userInfo["weixinid"] : ""; //昵称-- 微信后台显示
            $data["avatar"] = $userInfo["avatar"]; //昵称-- 微信后台显示

            $where = "1";

            if ($data["mobile"]) {
                $where .= "  AND USER_ACCOUNTS !='' AND ( USER_ID= '" . $data["userId"] . "' or MOBIL_NO ='" . $data["mobile"] . "') ";
            } else if ($data["weixinid"]) {
                $where .= "  AND USER_ACCOUNTS !='' AND ( USER_ID= '" . $data["userId"] . "' or BP_NO ='" . $data["weixinid"] . "') ";
            } else {
                continue;
            }
            //插入数据库
            $userOA = $this->getUseInfo($where);

            $data["oa_Id"] = $userOA["USER_ID"];
            $data["oa_name"] = $userOA["USER_NAME"];
            $data["dept_id"] = $userOA["DEPT_ID"];

            $this->syncUserInfo($data);
        }


        return true;
    }

    //获取关注用户
    public function getSubscribe($search = array()) {
        $field = $search['field'];
        $value = $search['value'];
        $currentPage = $search['currentPage'];
        $itemsPerPage = $search['itemsPerPage'];

        $sql = 'select qyweixin_user.*,DEPT_NAME as dept_name from qyweixin_user left join department on  qyweixin_user.dept_id = department.DEPT_ID where subscribe = 1';
        $totalSql = 'select count(*) count from qyweixin_user where subscribe = 1';

        if ($value) {
            $sql .= " and {$field} like '%{$value}%'";
            $totalSql .= " and {$field} like '%{$value}%'";
        }

        $currentPage *= $itemsPerPage;
        $sql .= " limit {$currentPage}, {$itemsPerPage}";

        $totalTemp = $this->query($totalSql);
        $totalResult = @mysql_fetch_assoc($totalTemp);
        $total = $totalResult['count'];

        $result = $this->query($sql);

        $list['list'] = array();
        while ($row = @mysql_fetch_assoc($result)) {
            if ($row['avatar']) {
                $row['avatar'] = "<img src='{$row['avatar']}' width='40px' />";
            } else {
                $row['avatar'] = "<img src='/images/nopicture.png' width='40px' />";
            }
            if ($row['gender'] == 1) {
                $row['gender'] = '男';
            } else {
                $row['gender'] = '女';
            }
            $list['list'][] = $row;
        }

        $list['totalCount'] = $total;

        return json_encode($list);
    }

    public function transferUserID($uids) {
        if (!$uids) {
            return false;
        }

        $temps = "('" . str_replace("|", "','", $uids) . "')";
        $sql = "select * from qyweixin_user where oa_id in $temps";
        $res = $this->query($sql);
        while ($row = @mysql_fetch_assoc($res)) {
            $uids = str_replace($row["oa_id"], $row["user_id"], $uids);
        }

        return $uids;
    }

    //重置应用ID
    public function removeAppId($funcid) {
        //删除qymenuId
        $tep = "select agentid from qyweixin_app  where funcid	 = $funcid";
        $result = $this->query($tep);
        $row = @mysql_fetch_assoc($result);
        if (isset($row['agentid']) && $row['agentid']) {
            $delAgentid = $row['agentid'];
            $sql2 = "delete from qyweixin_menu where agentid = $delAgentid";
            $this->query($sql2);
        }

        $sql = "UPDATE qyweixin_app set  `agentid` = NULL  where funcid	 = $funcid";
        return $this->query($sql);
    }

    //获取所有的应用
    public function getApps() {
        $sql = "SELECT name,agentid,funcid  FROM  `qyweixin_app` order by agentid desc";
        $result = $this->query($sql);
        $list = array();
        while ($row = @mysql_fetch_assoc($result)) {

            $list[] = $row;
        }

        return $list;
    }

    public function updateAppId($arr) {

        foreach ($arr as $apps) {
            foreach ($apps as $k => $v) {
                if (!$v) {
                    if (!$k) {
                        $sql = "UPDATE qyweixin_app set  agentid = null   where  funcid is null";
                    } else {
                        $sql = "UPDATE qyweixin_app set  agentid = null   where  funcid = $k ";
                    }
                } else {

                    if (!$k) {
                        $sql = "UPDATE qyweixin_app set  agentid = $v   where  funcid is null";
                    } else {
                        $sql = "UPDATE qyweixin_app set  agentid = $v   where  funcid = $k ";
                    }
                }

                $this->query($sql);
            }
        }

        return true;
    }

}
