<?php
require_once 'ireport.class.php';
require_once 'report.utility.php';
include_once('inc/utility_all.php');
includelangpak('report');
/*
 * 人事档案报表
 */
class Archive implements IReport {
	
	public function __construct(){
		global $_lang;
		$this->_lang = $_lang;
	}

	public function getGroupByList($filterInfor = array()) {
		return array(
			"archiveEducation" => array(
				"title" => $this->_lang['report_archiveEducation'],
				"type" => "string"
			),
			"archiveStatus" => array(
				"title" => $this->_lang['report_archiveStatus'],
				"type" => "string"
			),
			"archiveDepartment" => array(
				"title" => $this->_lang['report_archiveDepartment'],
				"type" => "string"
			),
			"archiveEntryTime" => array(
				"title" => $this->_lang['report_archiveEntryTime'],
				"type" => "date"
			)
		);
	}

	public function getDataAnalysisList($filterInfor = array()) {
		return array("count" => array("title" => $this->_lang['report_count']));
	}

	public function getSearchList($filterInfor = array()) {
		return array("archiveDepartment" => array(
				"title" => $this->_lang['report_archiveDepartment'],
				"type" => "choose",
				"url" => "dept"
			));
	}

	public function getReportData($groupByField, $dataAnalysisField, $filterInfor = array()) {
		global $connection;

		$groupByList = $this -> getGroupByList();

		$dateType = $filterInfor['dateType'];
		$dateValue = $filterInfor['dateValue'];

		$searchArray = searchStrToArr($filterInfor["searchInfor"]);

		switch ($groupByField) {
			case 'archiveEducation' :
				$query = 'SELECT * FROM `combocox_child` WHERE `CC_PARENT_ID` = 2';
				$result = exequery($connection, $query);
				while ($row = @mysql_fetch_assoc($result)) {
					$reportData[$row['CC_VALUE']] = array(
						"name" => $row['CC_NAME'],
						"y" => 0
					);
				}

				$reportData["else"] = array(
					"name" => "其他",
					"y" => 0
				);

				$query = "SELECT COUNT(*) AS CNT,IF(EDUCATION=''||EDUCATION IS NULL,0,EDUCATION) AS FORMAT_EDUCATION 
						FROM `hrms` WHERE DELETE_FLAG = 0 ";

				if ($searchArray['archiveDepartment']) {
					$query .= " AND DEPT_ID IN (" . SecurityFilter(trim($searchArray['archiveDepartment'],',')) . ")";
				}
				$query .= " GROUP BY FORMAT_EDUCATION";

				$result = exequery($connection, $query);
				while ($row = @mysql_fetch_assoc($result)) {
					if (array_key_exists($row['FORMAT_EDUCATION'], $reportData)) {
						$reportData[$row['FORMAT_EDUCATION']]["y"] = (float)$row['CNT'];
					} else {
						$reportData['else']["y"] = (float)$row['CNT'];
					}
				}

				break;
			case 'archiveStatus' :
				$reportData = array(
					"1" => array(
						"name" => $this->_lang['report_inActiveService'],
						"y" => 0
					),
					"2" => array(
						"name" => $this->_lang['report_dimission'],
						"y" => 0
					),
					"else" => array(
						"name" => $this->_lang['report_others'],
						"y" => 0
					)
				);

				$query = "SELECT COUNT( * ) AS CNT, STATUS FROM  `hrms` WHERE DELETE_FLAG = 0  ";

				if ($searchArray['archiveDepartment']) {
					$query .= " AND DEPT_ID IN (" . SecurityFilter(trim($searchArray['archiveDepartment'],',')) . ")";
				}
				$query .= " GROUP BY STATUS ";
				
				$result = exequery($connection, $query);
				while ($row = @mysql_fetch_assoc($result)) {
				
					if (array_key_exists($row['STATUS'], $reportData)) {
						$reportData[$row['STATUS']]["y"] = (float)$row['CNT'];
						
					} else {
						$reportData['else']["y"] = (float)$row['CNT'];
					}
				}

				break;

			case 'archiveDepartment' :
				$query = 'SELECT DEPT_ID,DEPT_NAME FROM `department` ';

				if ($searchArray['archiveDepartment']) {
					$query .= " WHERE DEPT_ID IN (" . SecurityFilter(trim($searchArray['archiveDepartment'],',')) . ")";
				}

				$result = exequery($connection, $query);
				while ($row = @mysql_fetch_assoc($result)) {
					$reportData[$row['DEPT_ID']] = array(
						"name" => $row['DEPT_NAME'],
						"y" => 0
					);
				}

				$reportData["else"] = array(
					"name" => $this->_lang['report_others'],
					"y" => 0
				);

				$query = "SELECT COUNT(*) AS CNT,DEPT_ID 
							FROM `hrms` WHERE DELETE_FLAG = 0 ";
				if ($searchArray['archiveDepartment']) {
					$query .= " AND DEPT_ID IN (" . SecurityFilter(substr($searchArray['archiveDepartment'], 0, -1)) . ")";
				}

				$query .= "  GROUP BY DEPT_ID";

				$result = exequery($connection, $query);
				while ($row = @mysql_fetch_assoc($result)) {
					if (array_key_exists($row['DEPT_ID'], $reportData)) {
						$reportData[$row['DEPT_ID']]["y"] = (float)$row['CNT'];
					} else {
						$reportData['else']["y"] = (float)$row['CNT'];
					}
				}
				break;

			case 'archiveEntryTime' :
				$reportData = getDatexAxis($dateType, $dateValue);
				$where = array();
                                
                                array_push($where, array(
						"AND",
						"DELETE_FLAG",
						"=",
						"0"
				 ));

				if ($searchArray['archiveDepartment']) {
					array_push($where, array(
						"AND",
						"DEPT_ID",
						"IN",
						"(" . SecurityFilter(substr($searchArray['archiveDepartment'], 0, -1)) . ")"
					));
				}

				$query = getDateQuery($dateType, $dateValue, "hrms", "LABOR_START_TIME", "", $where);

				$result = exequery($connection, $query);
				while ($row = @mysql_fetch_assoc($result)) {
					if (key_exists($row['DATE_FORMAT'], $reportData)) {
						$reportData[$row['DATE_FORMAT']]["y"] = (float)$row['CNT'];
					}
				}
				break;

			default :
				break;
		}

		return array( array(
				"name" => $groupByList[$groupByField]["title"],
				"data" => array_values($reportData)
			));
	}

}
?>