<?php
require_once 'ireport.class.php';
require_once 'report.utility.php';
include_once('inc/utility_all.php');
includelangpak('report');
/*
 * 商机报表
 */
class Business implements IReport {
	
	public function __construct(){
		global $_lang;
		$this->_lang = $_lang;
	}
	
	public function getGroupByList($filterInfor = array()) {
		return array(
			"businessType" => array(
				"title" => $this->_lang['report_businessType'],
				"type" => "string"
			),
			"businessSource" => array(
				"title" => $this->_lang['report_businessSource'],
				"type" => "string"
			),
			"businessStep" => array(
				"title" => $this->_lang['report_businessStep'],
				"type" => "string"
			),
			"businessEndTime" => array(
				"title" => $this->_lang['report_businessEndTime'],
				"type" => "date"
			)
		);
	}

	public function getDataAnalysisList($filterInfor = array()) {
		return array("quote" => array("title" => $this->_lang['report_proposalQuotation']));
	}

	public function getSearchList($filterInfor = array()) {
		return array("customerName" => array(
				"title" => $this->_lang['report_customerName'],
				"type" => "choose",
				"url" => "customer"
			));
	}

	public function getReportData($groupByField, $dataAnalysisField, $filterInfor = array()) {
		global $connection;

		$groupByList = $this -> getGroupByList();

		$dateType = $filterInfor['dateType'];
		$dateValue = $filterInfor['dateValue'];

		$searchArray = searchStrToArr($filterInfor["searchInfor"]);

		switch ($groupByField) {
			case 'businessType' :
				$query = 'SELECT * FROM `combocox_child` WHERE `CC_PARENT_ID` = 29';
				$result = exequery($connection, $query);
				while ($row = @mysql_fetch_assoc($result)) {
					$reportData[$row['CC_VALUE']] = array(
						"name" => $row['CC_NAME'],
						"y" => 0
					);
				}

				$reportData[0] = array(
					"name" => $this->_lang['report_others'],
					"y" => 0
				);

				$query = $this -> getQueryStr("`OPER_TYPE`", $dataAnalysisField, $searchArray);

				$result = exequery($connection, $query);
				while ($row = @mysql_fetch_assoc($result)) {
					if (array_key_exists($row['OPER_TYPE'], $reportData)) {
						$reportData[$row['OPER_TYPE']]["y"] = (float)$row['CNT'];
					} else {
						$reportData['else']["y"] = (float)$row['CNT'];
					}
				}
				break;
			case 'businessSource' :
				$query = 'SELECT * FROM `combocox_child` WHERE `CC_PARENT_ID` = 30';
				$result = exequery($connection, $query);
				while ($row = @mysql_fetch_assoc($result)) {
					$reportData[$row['CC_VALUE']] = array(
						"name" => $row['CC_NAME'],
						"y" => 0
					);
				}

				$reportData[0] = array(
					"name" => $this->_lang['report_others'],
					"y" => 0
				);

				$query = $this -> getQueryStr("`OPER_SOURCE`", $dataAnalysisField, $searchArray);

				$result = exequery($connection, $query);
				while ($row = @mysql_fetch_assoc($result)) {
					if (array_key_exists($row['OPER_SOURCE'], $reportData)) {
						$reportData[$row['OPER_SOURCE']]["y"] = (float)$row['CNT'];
					} else {
						$reportData['else']["y"] = (float)$row['CNT'];
					}
				}
				break;
			case 'businessStep' :
				$query = 'SELECT * FROM `combocox_child` WHERE `CC_PARENT_ID` = 32';
				$result = exequery($connection, $query);
				while ($row = @mysql_fetch_assoc($result)) {
					$reportData[$row['CC_VALUE']] = array(
						"name" => $row['CC_NAME'],
						"y" => 0
					);
				}

				$reportData[0] = array(
					"name" => $this->_lang['report_others'],
					"y" => 0
				);

				$query = $this -> getQueryStr("`OPER_STEP`", $dataAnalysisField, $searchArray);

				$result = exequery($connection, $query);
				while ($row = @mysql_fetch_assoc($result)) {
					if (array_key_exists($row['OPER_STEP'], $reportData)) {
						$reportData[$row['OPER_STEP']]["y"] = (float)$row['CNT'];
					} else {
						$reportData['else']["y"] = (float)$row['CNT'];
					}
				}

				break;
			case 'businessEndTime' :
				$reportData = getDatexAxis($dateType, $dateValue);

				$where = array();

				if ($searchArray['customerName']) {
					array_push($where, array(
						"AND",
						"CUSTOMER_ID",
						"IN",
						"(" . $searchArray['customerName'] . ")"
					));
				}

				if ($dataAnalysisField == "quote") {
					$query = getDateQuery($dateType, $dateValue, "operation", "OPER_DATE", "OPER_MONEY", $where);

				} else {
					$query = getDateQuery($dateType, $dateValue, "operation", "OPER_DATE", "", $where);
				}

				$result = exequery($connection, $query);
				while ($row = @mysql_fetch_assoc($result)) {
					if (array_key_exists($row['DATE_FORMAT'], $reportData)) {
						$reportData[$row['DATE_FORMAT']]["y"] = (float)$row['CNT'];
					}
				}

				break;
			default :
				break;
		}

		return array( array(
				"name" => $groupByList[$groupByField]["title"],
				"data" => array_values($reportData)
			));
	}

	function getQueryStr($queryField, $dataAnalysis, $searchArray) {

		$query = "SELECT";

		if ($dataAnalysis == "quote") {
			$query .= " SUM(`OPER_MONEY`)";
		} else {
			$query .= " COUNT(*)";
		}

		$query .= " AS CNT," . $queryField . " 
					FROM `operation` ";

		if ($searchArray['customerName']) {
			$query .= " WHERE CUSTOMER_ID IN (" . SecurityFilter($searchArray['customerName']) . ")";
		}

		$query .= " GROUP BY " . SecurityFilter($queryField);

		return $query;
	}

}
?>