<?php
require_once 'ireport.class.php';
require_once 'report.utility.php';
include_once('inc/utility_all.php');
includelangpak('report');
/*
 * 合同报表
 */
class Contract implements IReport {
	
	public function __construct(){
		global $_lang;
		$this->_lang = $_lang;
	}
	
	/**
	 * 合同分组依据
	 * @param  array  $filterInfor [description]
	 * @return [type]              [description]
	 */
	public function getGroupByList($filterInfor = array()) {
		return array(
			"contractType" => array(
				"title" => $this->_lang['report_contractType'],
				"type" => "string"
			),
			"contractStartTime" => array(
				"title" => $this->_lang['report_contractStartTime'],
				"type" => "date"
			),
			"contractEndTime" => array(
				"title" => $this->_lang['report_contractEndTime'],
				"type" => "date"
			)
		);
	}

	/**
	 * 合同数据分析字段
	 * @param  array  $filterInfor [description]
	 * @return [type]              [description]
	 */
	public function getDataAnalysisList($filterInfor = array()) {
		return array("contractAmount" => array("title" => $this->_lang['report_contractAmount']));
	}

	/**
	 * 合同数据筛选
	 * @param  array  $filterInfor [description]
	 * @return [type]              [description]
	 */
	public function getSearchList($filterInfor = array()) {
		return array("customerName" => array(
				"title" => $this->_lang['report_customerName'],
				"type" => "choose",
				"url" => "customer"
			));
	}

	public function getReportData($groupByField, $dataAnalysisField, $filterInfor = array()) {
		global $connection;

		$groupByList = $this -> getGroupByList();

		$dateType = $filterInfor['dateType'];
		$dateValue = $filterInfor['dateValue'];

		$searchArray = searchStrToArr($filterInfor["searchInfor"]);



		$where = array();
		if ($searchArray['customerName']) {
			array_push($where, array(
				"AND",
				"CUST_ID",
				"IN",
				"(" . SecurityFilter($searchArray['customerName']) . ")"
			));
		}


		switch ($groupByField) {

			//合同类型
			case 'contractType' :
				$query = 'SELECT * FROM `combocox_child` 
							WHERE `CC_PARENT_ID` = 31';
				$result = exequery($connection, $query);

				while ($row = @mysql_fetch_assoc($result)) {
					$reportData[$row['CC_VALUE']] = array(
						"name" => $row['CC_NAME'],
						"y" => 0
					);
				}

				$reportData["else"] = array(
					"name" => $this->_lang['report_others'],
					"y" => 0
				);

				$query = "SELECT";

				if ($dataAnalysisField == "contractAmount") {
					$query .= " SUM(`CON_COUNT`)";
				} else {
					$query .= " COUNT(*)";
				}

				$query .= " AS CNT,CON_TYPE 
								FROM `contract` ";
				if ($searchArray['customerName']) {
					$query .= " WHERE CUST_ID IN (" . SecurityFilter($searchArray['customerName']) . ")";
				}
				$query .= " GROUP BY `CON_TYPE`";

				$result = exequery($connection, $query);

				while ($row = @mysql_fetch_assoc($result)) {
					if (array_key_exists($row['CON_TYPE'], $reportData)) {
						$reportData[$row['CON_TYPE']]["y"] = (float)$row['CNT'];
					} else {
						$reportData['else']["y"] = (float)$row['CNT'];
					}
				}

				break;

			//合同开始时间
			case 'contractStartTime' :
				$reportData = getDatexAxis($dateType, $dateValue);

			

				if ($dataAnalysisField == "contractAmount") {
					$query = getDateQuery($dateType, $dateValue, "contract", "CON_DATE1", "CON_COUNT", $where);

				} else {
					$query = getDateQuery($dateType, $dateValue, "contract", "CON_DATE1", "", $where);
				}
				
				
				$result = exequery($connection, $query);
				while ($row = @mysql_fetch_assoc($result)) {
					if (array_key_exists($row['DATE_FORMAT'], $reportData)) {
						$reportData[$row['DATE_FORMAT']]["y"] = (float)$row['CNT'];
					}
				}
				break;

			//合同结束时间
			case 'contractEndTime' :
				$reportData = getDatexAxis($dateType, $dateValue);

				if ($dataAnalysisField == "contractAmount") {
					$query = getDateQuery($dateType, $dateValue, "contract", "CON_DATE2", "CON_COUNT", $where);

				} else {
					$query = getDateQuery($dateType, $dateValue, "contract", "CON_DATE2", "", $where);
				}

				$result = exequery($connection, $query);
				while ($row = @mysql_fetch_assoc($result)) {
					if (array_key_exists($row['DATE_FORMAT'], $reportData)) {
						$reportData[$row['DATE_FORMAT']]["y"] = (float)$row['CNT'];
					}

				}
				break;

			default :
				break;
		}

		return array( array(
				"name" => $groupByList[$groupByField]["title"],
				"data" => array_values($reportData)
			));
	}

}
?>