<?php
require_once 'ireport.class.php';
require_once 'report.utility.php';
include_once('inc/utility_all.php');
includelangpak('report');
/*
 * 客户报表
 */
class Customer implements IReport {
	
	public function __construct(){
		global $_lang;
		$this->_lang = $_lang;
	}

	public function getGroupByList($filterInfor = array()) {
		return array(
			"customerType" => array(
				"title" => $this->_lang['report_customerType'],
				"type" => "string"
			),
			"customerIndustry" => array(
				"title" => $this->_lang['report_customerIndustry'],
				"type" => "string"
			),
			"customerManager" => array(
				"title" => $this->_lang['report_customerManager'],
				"type" => "string"
			),
			"customerProvince" => array(
				"title" => $this->_lang['report_customerProvince'],
				"type" => "string"
			),
			"customerCity" => array(
				"title" => $this->_lang['report_customerCity'],
				"type" => "string"
			),
			"customerCreateTime" => array(
				"title" => $this->_lang['report_customerCreateTime'],
				"type" => "date"
			)
		);
	}

	public function getDataAnalysisList($filterInfor = array()) {
		return array("count" => array("title" => $this->_lang['report_count']));
	}

	public function getSearchList($filterInfor = array()) {
		global $connection;

		//行业数据
		$query = 'SELECT * FROM `combocox_child` WHERE `CC_PARENT_ID` = 27';
		$result = exequery($connection, $query);
		while ($row = @mysql_fetch_assoc($result)) {
			$industry[$row['CC_VALUE']] = $row['CC_NAME'];
		}

		//省份
		$query = 'SELECT * FROM `province`';
		$result = exequery($connection, $query);
		while ($row = @mysql_fetch_assoc($result)) {
			$province[$row['proID']] = $row['proName'];
		}

		//城市
		$query = 'SELECT * FROM `city`';
		$result = exequery($connection, $query);
		while ($row = @mysql_fetch_assoc($result)) {
			$city[$row['cityId']] = $row['cityName'];
		}

		//客户类型
		$query = 'SELECT * FROM `combocox_child` WHERE `CC_PARENT_ID` = 4';
		$result = exequery($connection, $query);
		while ($row = @mysql_fetch_assoc($result)) {
			$customerType[$row['CC_VALUE']] = $row['CC_NAME'];
		}

		return array(
			"customerManager" => array(
				"title" => $this->_lang['report_customerManager'],
				"type" => "choose",
				"url" => "user"
			),
			"customerType" => array(
				"title" => $this->_lang['report_customerType'],
				"type" => "multiSelect",
				"dataSource" => $customerType
			),
			"customerProvince" => array(
				"title" => $this->_lang['report_customerProvince'],
				"type" => "multiSelect",
				"dataSource" => $province,
				"defaultSearch" => ""
			),
			"customerCity" => array(
				"title" => $this->_lang['report_customerCity'],
				"type" => "multiSelect",
				"dataSource" => $city,
				"defaultSearch" => ""
			),
			"customerIndustry" => array(
				"title" => $this->_lang['report_customerIndustry'],
				"type" => "multiSelect",
				"dataSource" => $industry
			)
		);
	}

	public function getReportData($groupByField, $dataAnalysisField, $filterInfor = array()) {
		global $connection;

		$groupByList = $this -> getGroupByList();

		//处理查询条件
		$searchArray = searchStrToArr($filterInfor["searchInfor"]);

		switch ($groupByField) {

			//行业
			case 'customerIndustry' :
				$query = 'SELECT * FROM `combocox_child` WHERE `CC_PARENT_ID` = 27';

				if ($searchArray["customerIndustry"]) {
					$query .= ' AND CC_VALUE IN (' . SecurityFilter($searchArray["customerIndustry"]) . ')';
				}

				$result = exequery($connection, $query);
				while ($row = @mysql_fetch_assoc($result)) {
					$reportData[$row['CC_VALUE']] = array(
						"name" => $row['CC_NAME'],
						"y" => 0
					);
				}

				$reportData[0] = array(
					"name" => $this->_lang['report_others'],
					"y" => 0
				);

				$query = "SELECT COUNT(*) AS CNT,IF(CUSTOMER_INDUSTRY IS NULL || 
							CUSTOMER_INDUSTRY = '', 0, CUSTOMER_INDUSTRY) AS FORMAT_CUSTOMER_INDUSTRY
							FROM `customer` WHERE 1=1 ";
				$query .= $this -> getWhereStr($searchArray);
				$query .= " GROUP BY `FORMAT_CUSTOMER_INDUSTRY`";

				$result = exequery($connection, $query);
				while ($row = @mysql_fetch_assoc($result)) {
					if (array_key_exists($row['FORMAT_CUSTOMER_INDUSTRY'], $reportData)) {
						$reportData[$row['FORMAT_CUSTOMER_INDUSTRY']]["y"] = (float)$row['CNT'];
					} else {
						$reportData['else']["y"] = (float)$row['CNT'];
					}
				}
				break;

			//省
			case 'customerProvince' :
				$query = 'SELECT * FROM `province` WHERE 1 = 1 ';

				if ($searchArray["customerProvince"]) {
					$query .= ' AND proID IN (' . SecurityFilter($searchArray["customerProvince"]) . ')';
				}

				$result = exequery($connection, $query);
				while ($row = @mysql_fetch_assoc($result)) {
					$reportData[$row['proID']] = array(
						"name" => $row['proName'],
						"y" => 0
					);
				}

				$reportData[0] = array(
					"name" => $this->_lang['report_others'],
					"y" => 0
				);

				$query = "SELECT COUNT(*) AS CNT, IF(PROVINCE='',0,PROVINCE) AS FORMAT_PROVINCE 
								FROM `customer` WHERE 1=1 ";
				$query .= $this -> getWhereStr($searchArray);
				$query .= " GROUP BY `FORMAT_PROVINCE`";
				$result = exequery($connection, $query);
				while ($row = @mysql_fetch_assoc($result)) {
					if (array_key_exists($row['FORMAT_PROVINCE'], $reportData)) {
						$reportData[$row['FORMAT_PROVINCE']]["y"] = (float)$row['CNT'];
					} else {
						$reportData['else']["y"] = (float)$row['CNT'];
					}
				}
				break;

			//客户类型
			case 'customerType' :
				$query = 'SELECT * FROM `combocox_child` WHERE `CC_PARENT_ID` = 4';

				if ($searchArray["customerType"]) {
					$query .= ' AND CC_VALUE IN (' . SecurityFilter($searchArray["customerType"]) . ')';
				}

				$result = exequery($connection, $query);
				while ($row = @mysql_fetch_assoc($result)) {
					$reportData[$row['CC_VALUE']] = array(
						"name" => $row['CC_NAME'],
						"y" => 0
					);
				}

				$reportData[0] = array(
					"name" => $this->_lang['report_others'],
					"y" => 0
				);

				$query = "SELECT COUNT(*) AS CNT,CUSTOMER_TYPE 
						FROM `customer` WHERE 1=1 ";
				$query .= $this -> getWhereStr($searchArray);
				$query .= " GROUP BY `CUSTOMER_TYPE`";

				$result = exequery($connection, $query);
				while ($row = @mysql_fetch_assoc($result)) {

					if (array_key_exists($row['CUSTOMER_TYPE'], $reportData)) {
						$reportData[$row['CUSTOMER_TYPE']]["y"] = (float)$row['CNT'];
					} else {
						$reportData['else']["y"] = (float)$row['CNT'];
					}
				}

				break;

			//客户经理
			case 'customerManager' :
				$query = 'SELECT distinct c.`MANAGE_USER`,u.USER_NAME 
					FROM customer AS c JOIN user AS u ON c.MANAGE_USER = u.USER_ID';
				$result = exequery($connection, $query);
				while ($row = @mysql_fetch_assoc($result)) {
					$reportData[$row['MANAGE_USER']] = array(
						"name" => $row['USER_NAME'],
						"y" => 0
					);
				}

				$reportData[0] = array(
					"name" => $this->_lang['report_others'],
					"y" => 0
				);

				$query = "SELECT COUNT(*) AS CNT, IF(u.USER_NAME IS NULL,0,c.MANAGE_USER) AS FORMAT_USER 
					FROM customer AS c LEFT JOIN user AS u ON c.MANAGE_USER = u.USER_ID WHERE 1=1 ";
				$query .= $this -> getWhereStr($searchArray);
				$query .= " GROUP BY `FORMAT_USER`";
				//echo $query;

				$result = exequery($connection, $query);
				while ($row = @mysql_fetch_assoc($result)) {
					if (array_key_exists($row['FORMAT_USER'], $reportData)) {
						$reportData[$row['FORMAT_USER']]["y"] = (float)$row['CNT'];
					} else {
						$reportData['else']["y"] = (float)$row['CNT'];
					}
				}
				break;

			//客户城市
			case 'customerCity' :
				$query = 'SELECT * FROM `city` WHERE 1=1 ';

				if ($searchArray["customerCity"]) {
					$query .= ' AND cityId IN (' . SecurityFilter($searchArray["customerCity"]) . ')';
				}

				$result = exequery($connection, $query);
				while ($row = @mysql_fetch_assoc($result)) {
					$reportData[$row['cityId']] = array(
						"name" => $row['cityName'],
						"y" => 0
					);
				}

				$reportData[0] = array(
					"name" => $this->_lang['report_others'],
					"y" => 0
				);

				$query = "SELECT COUNT(*) AS CNT, IF(CITY='',0,CITY) AS FORMAT_CITY
					FROM `customer` WHERE 1=1 ";

				$query .= $this -> getWhereStr($searchArray);

				$query .= " GROUP BY `FORMAT_CITY`";
				$result = exequery($connection, $query);
				while ($row = @mysql_fetch_assoc($result)) {
					if (array_key_exists($row['FORMAT_CITY'], $reportData)) {
						$reportData[$row['FORMAT_CITY']]["y"] = (float)$row['CNT'];
					} else {
						$reportData['else']["y"] = (float)$row['CNT'];
					}
				}
				break;

			//创建时间
			case 'customerCreateTime' :
				$dateType = $filterInfor['dateType'];
				$dateValue = $filterInfor['dateValue'];

				$reportData = getDatexAxis($dateType, $dateValue);

				$where = $this -> getWhereStr($searchArray, "array");

				$query = getDateQuery($dateType, $dateValue, "customer", "CREATE_TIME", "", $where);

				$result = exequery($connection, $query);
				while ($row = @mysql_fetch_assoc($result)) {
					if (key_exists($row['DATE_FORMAT'], $reportData)) {
						$reportData[$row['DATE_FORMAT']]["y"] = (float)$row['CNT'];
					}
				}

				break;
			default :
				break;
		}

		return array( array(
				"name" => $groupByList[$groupByField]["title"],
				"data" => array_values($reportData)
			));

	}

	function getWhereStr($searchArray, $format = "string") {

		$where = array();
		if ($searchArray['customerManager']) {
			$customerManagerStr = substr($searchArray['customerManager'], 0, -1);

			array_push($where, array(
				"AND",
				"MANAGE_USER",
				"IN",
				"('" . implode("','", explode(",", $customerManagerStr)) . "')"
			));
		}

		if ($searchArray['customerType']) {
			array_push($where, array(
				"AND",
				"CUSTOMER_TYPE",
				"IN",
				"(" . $searchArray['customerType'] . ")"
			));
		}

		if ($searchArray['customerProvince']) {
			array_push($where, array(
				"AND",
				"PROVINCE",
				"IN",
				"(" . $searchArray['customerProvince'] . ")"
			));

		}

		if ($searchArray['customerCity']) {
			array_push($where, array(
				"AND",
				"CITY",
				"IN",
				"(" . $searchArray['customerCity'] . ")"
			));
		}

		if ($searchArray['customerIndustry']) {
			array_push($where, array(
				"AND",
				"CUSTOMER_INDUSTRY",
				"IN",
				"(" . $searchArray['customerIndustry'] . ")"
			));
		}

		if ($format == "string") {
			$whereStr = "";
			for ($i = 0; $i < count($where); $i++) {
				$whereStr .= implode(" ", $where[$i]);
			}

			return $whereStr;
		} else {
			return $where;
		}
	}

}
?>