<?php
include_once 'inc/auth.php';
include 'api/report.class.php';

function __autoload($className) {
	if ($className != 'custom') {
		require_once 'general/report/inc/' . $className . '.class.php';
	}
}

function getCurlData($url) {

	$curl = curl_init();
	curl_setopt($curl, CURLOPT_URL, $url);
	curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
	$data = curl_exec($curl);
	curl_close($curl);
	return $data;
}



function reportPermission($reportID = false){
	global $connection;

	$loginUserID = $_SESSION['LOGIN_USER_ID'];
	$loginPrivID = $_SESSION['LOGIN_USER_PRIV'];
	$loginDeptID = $_SESSION['LOGIN_DEPT_ID'];

	$reportPermission = true;
	if(!$reportID) $reportPermission = false;
        $reportID = SecurityFilter($reportID);
	$where = "and ((CHART_PERMISSION_DEPT='DEPT_ALL') ";

	$where .= "OR (INStr(CHART_PERMISSION_DEPT,',{$loginDeptID},')>0 OR INStr(CHART_PERMISSION_DEPT,'{$loginDeptID},')=1) ";
	$where .= "OR (INStr(CHART_PERMISSION_PRIV,',{$loginPrivID},')>0 OR INStr(CHART_PERMISSION_PRIV,'{$loginPrivID},')=1) ";
	$where .= "OR (INStr(CHART_PERMISSION_USER,',{$loginUserID},')>0 OR INStr(CHART_PERMISSION_USER,'{$loginUserID},')=1))";

	$sql = "select count(*) count from `report_chart` where CHART_ID='{$reportID}' {$where}";

	$result = exequery($connection, $sql);
	if($count = @mysql_fetch_assoc($result)){
		$reportPermission = $count['count'];
	}

	return $reportPermission;
}
$reportID = $_REQUEST['reportID'];
$isCheck = $_REQUEST['isCheck'] ? $_REQUEST['isCheck'] : 0;
$reportPermission = reportPermission($reportID);

if($isCheck && !$reportPermission){
	echo json_encode(array());
	exit;
}

$report = new Report;

$op = $_REQUEST['op'];

switch ($op) {
	case 'getUpdateData' :
		$url = $_REQUEST['url'];
		echo getCurlData($url . "?op=update");
		break;
	case 'getReportData' :

		//报表信息
		if (0 < $reportID) {

			$reportInfor = $report -> getReportList("", "", "", "", "", "", "", array( array(
					"AND",
					"CHART_ID",
					"=",
					$reportID
				)), false);

			$reportInfor = $reportInfor[0];
		}

		//数据源信息
		$dataSourceID = $reportInfor["CHART_DATASOURCE_ID"] ? $reportInfor["CHART_DATASOURCE_ID"] : $_REQUEST['dataSourceID'];

		$dataSourceInfor = $report -> getDataSourceList(array( array(
				"AND",
				"DATASOURCE_ID",
				"=",
				$dataSourceID
			)));
		if ($dataSourceInfor) {
			$dataSourceInfor = $dataSourceInfor[0];
		}

		//数据源类型
		$reportDataSourceType = $dataSourceInfor['DATASOURCE_TYPE'];
        if(!$reportDataSourceType){
            echo false;
			exit;
        }

		//数据源参数
		$dataSourceParam = $dataSourceInfor['DATASOURCE_PARAM'];

		if ($dataSourceParam) {
			$dataSourceParam = json_decode($dataSourceParam, true);
		}

		//自定义数据源
		if ($reportDataSourceType == "custom") {
			$data = getCurlData($dataSourceParam["url"] . "?op=init");

			$formatData = json_decode($data, true);
			if($formatData['original']){ //highcharts原始配置数据
				echo json_encode($formatData);
				exit;
			}
			$formatData["dataSourceInfor"] = $dataSourceInfor;
			$formatData["chartType"] = $reportInfor["CHART_TYPE"];
			$formatData["chartTitle"] = $reportInfor["CHART_TITLE"];

			echo json_encode($formatData);
		} else {

			//分组依据
			$reportDataSourceGroupBy = $dataSourceInfor['DATASOURCE_GROUPBY'];

			//数据分析
			$reportDataAnalysis = $dataSourceInfor['DATASOURCE_DATA_ANALYSIS'];

			//查询条件
			$searchInfor = $reportInfor["CHART_SEARCH"] ? $reportInfor["CHART_SEARCH"] : $_REQUEST['searchInfor'];

			//日期类型 年 季 月 日
			$dateType = $_REQUEST['dateType'] ? $_REQUEST['dateType'] : "year";

			//日期值 根据日期类型的不同而不同
			$dateValue = $_REQUEST['dateValue'] ? $_REQUEST['dateValue'] : date("Y", strtotime("-5 year")) . "-" . date("Y");

			//获取报表数据
			$reprotDataSourceTypeInfor = new $reportDataSourceType;

			$reportData = $reprotDataSourceTypeInfor -> getReportData($reportDataSourceGroupBy, $reportDataAnalysis, array(
				"dateType" => $dateType,
				"dateValue" => $dateValue,
				"searchInfor" => $searchInfor,
				"param" => $dataSourceParam
			));

			$res = array(
				"series" => $reportData,
				"dataSourceInfor" => $dataSourceInfor,
				"chartInfor" => $reportInfor
			);

			echo json_encode($res);
		}
		break;
	default :
		break;
}
?>