<?
include_once('inc/utility_all.php');
includelangpak('report');
/**
 * 日期类型分组字段x坐标
 */
function getDatexAxis($dateType, $dateValue) {
	global $_lang;
	
	switch ($dateType) {

		//按年
		case 'year' :
			$split = explode("-", $dateValue);

			if (count($split) == 2) {
				for ($i = $split[0]; $i <= $split[1]; $i++) {
					$reportData[$i] = array(
						"name" => (string)$i,
						"y" => 0
					);
				}
			}

			break;

		//按季度
		case 'quarter' :
			$reportData[1] = array(
				"name" => $_lang['report_firstQuarter'],
				"y" => 0
			);
			$reportData[2] = array(
				"name" => $_lang['report_secondQuarter'],
				"y" => 0
			);
			$reportData[3] = array(
				"name" => $_lang['report_thirdQuarter'],
				"y" => 0
			);
			$reportData[4] = array(
				"name" => $_lang['report_fourthQuarter'],
				"y" => 0
			);
			break;

		//按月
		case 'month' :
			for ($i = 1; $i <= 12; $i++) {
				$reportData[$i] = array(
					"name" => $i,
					"y" => 0
				);
			}
			break;

		//按天
		case 'day' :

			//获取指定月的最后一天
			$lastDay = date('t', strtotime($dateValue));
			for ($i = 1; $i <= $lastDay; $i++) {
				$reportData[$i] = array(
					"name" => $i,
					"y" => 0
				);
			}
			break;

		default :
			break;
	}

	return $reportData;
}

/**
 * 日期类型分组字段获取数据语句
 */
function getDateQuery($dateType, $dateValue, $tableName, $dateFieldName, $sumFieldName = "", $where = array()) {

	$countStr = $sumFieldName == "" ? "COUNT(*)" : "SUM(" . $sumFieldName . ")";

	switch ($dateType) {

		//按年
		case 'year' :
			$selectStr = "DATE_FORMAT(" . $dateFieldName . ", '%Y')";
			$whereStr = "";

			break;

		//按季度
		case 'quarter' :
			$selectStr = "quarter(" . $dateFieldName . ")";
			$whereStr = "AND DATE_FORMAT(" . $dateFieldName . ", '%Y') = '" . $dateValue . "'";

			break;

		//按月
		case 'month' :
			$selectStr = "DATE_FORMAT(" . $dateFieldName . ",'%c')";
			$whereStr = "AND DATE_FORMAT(" . $dateFieldName . ", '%Y') = '" . $dateValue . "' ";
			break;

		//按天
		case 'day' :
			$selectStr = "DATE_FORMAT(" . $dateFieldName . ",'%e')";
			$whereStr = "AND DATE_FORMAT(" . $dateFieldName . ", '%Y-%c') = '" . $dateValue . "' ";
			break;

		default :
			break;
	}

	for ($i = 0; $i < count($where); $i++) {
				$whereInfor .= " " . implode($where[$i], " ");
			}

	return "SELECT " . $selectStr . " DATE_FORMAT," . $countStr . " CNT FROM " . $tableName . "  WHERE 1=1 " . $whereStr . $whereInfor . " GROUP BY DATE_FORMAT";
}

function getFlowDateQuery($dateType, $dateValue, $tableName, $dateFieldName, $sumFieldName = '', $where = array(), $workflowID = false) {

	if($sumFieldName){
		$sumFieldNameArray = explode(',', $sumFieldName);
		
		foreach($sumFieldNameArray as $field){
			$countStr .= " SUM({$field}) as {$field},";
		}
	}else{
		$countStr .= ' COUNT(*) as count,';
	}
	$countStr = rtrim($countStr, ',');
	switch ($dateType) {

		//按年
		case 'year' :
			$selectStr = "DATE_FORMAT(z." . $dateFieldName . ", '%Y')";
			$whereStr = "";

			break;

		//按季度
		case 'quarter' :
			$selectStr = "quarter(z." . $dateFieldName . ")";
			$whereStr = "AND DATE_FORMAT(z." . $dateFieldName . ", '%Y') = '" . $dateValue . "'";

			break;

		//按月
		case 'month' :
			$selectStr = "DATE_FORMAT(z." . $dateFieldName . ",'%c')";
			$whereStr = "AND DATE_FORMAT(z." . $dateFieldName . ", '%Y') = '" . $dateValue . "' ";
			break;

		//按天
		case 'day' :
			$selectStr = "DATE_FORMAT(z." . $dateFieldName . ",'%e')";
			$whereStr = "AND DATE_FORMAT(z." . $dateFieldName . ", '%Y-%c') = '" . $dateValue . "' ";
			break;

		default :
			break;
	}
	if($workflowID){
		$where .= " and z.FLOW_ID = '{$workflowID}' ";
	}

	return "select {$selectStr} DATE_FORMAT, {$countStr} from {$tableName} z join `flow_run` f on f.RUN_ID = z.RUN_ID where 1=1 {$whereStr} {$where} group by DATE_FORMAT";
}

/**
 * 查询字符串转化成数组
 * @param  [type] $searchInfor [description]
 * @return [type]              [description]
 */
function searchStrToArr($searchInfor) {

	$searchInforSplit = explode("&", $searchInfor);
	for ($i = 0, $length = count($searchInforSplit); $i < $length; $i++) {
		$subCondition = explode("=", $searchInforSplit[$i]);

		if (count($subCondition) == 2) {
			$searchArray[$subCondition[0]] = $subCondition[1];
		}
	}
	return $searchArray;
}

//强制合并数组
//自带的array_merge在数字键的, 不是后覆盖
function array_merge_compel(&$arr1, $arr2){
	foreach($arr2 as $key=>$value){
		if(key_exists($key, $arr1)){
			$arr1[$key] = $value;
		}
	}
	return $arr1;
}
?>