<?php
require_once 'ireport.class.php';
require_once 'report.utility.php';
require_once 'inc/utility_html.php';
include_once('inc/utility_all.php');
includelangpak('report');

/*
 * 流程报表
 */
class Workflow implements IReport {
	
	public function __construct(){
		global $_lang;
		$this->_lang = $_lang;
	}
	
	function getWhereStr($searchArray, $workflowID) {
		if ($searchArray) {
			foreach ($searchArray as $key => $value) {
				if ($value) {
					switch ($key) {

						//创建人
						case 'creator' :
							$value = trim($value, ',');
							$value = str_replace(',', "','", $value);
							$where .= " AND f.CREATOR IN ('{$value}')";
							break;
							
						//创建时间
						case 'createTime' :
							$valueSplit = explode("~", $value);
							if (count($valueSplit) == 2) {
								$timeStart = strtotime($valueSplit[0]);
								$timeEnd = strtotime($valueSplit[1]) + 24*3600;
								
								$where .= " AND UNIX_TIMESTAMP(f.CREATE_TIME) >= '{$timeStart}' AND UNIX_TIMESTAMP(f.CREATE_TIME) < '{$timeEnd}' ";
							} else {
								$time = strtotime($value);
								$dayTime = $time + 24*3600;
								$where .= " AND UNIX_TIMESTAMP(f.CREATE_TIME) >= {$time} AND UNIX_TIMESTAMP(f.CREATE_TIME) < {$dayTime} ";
								
							}
							break;
							
						//结束时间
						case 'overTime' :
							$where .= " AND f.CURRENT_STEP = 0";
							$valueSplit = explode("~", $value);

							if (count($valueSplit) == 2) {
								$timeStart = strtotime($valueSplit[0]);
								$timeEnd = strtotime($valueSplit[1]) + 24*3600;
								
								$where .= " AND UNIX_TIMESTAMP(f.TRANSACT_TIME) >= '{$timeStart}' AND UNIX_TIMESTAMP(f.TRANSACT_TIME) < '{$timeEnd}' ";
							} else {
								$time = strtotime($value);
								$dayTime = $time + 24*3600;
								$where .= " AND UNIX_TIMESTAMP(f.TRANSACT_TIME) >= {$time} AND UNIX_TIMESTAMP(f.TRANSACT_TIME) < {$dayTime} ";
							}
							break;
							
						//流程状态
						case 'status' :
							if ($value != 0) {
								if ($value == 1) {
									$where .= " AND f.CURRENT_STEP=0";
								} else {
									$where .= " AND f.CURRENT_STEP!=0";
								}

							}
							break;
						default :
							# code...
							break;
					}
				}
			}
		}

		return $where;
	}

	function getFormID($workflowID) {
		global $connection;

		//获取流程formID
		$query = "SELECT FORM_ID FROM flow_type WHERE FLOW_ID = '" . SecurityFilter($workflowID) . "'";
		$result = exequery($connection, $query);
		if ($row = mysql_fetch_assoc($result)) {
			$formID = $row['FORM_ID'];
		}

		return $formID;
	}

	function getFieldList($workflowID) {
		global $connection;

		$query = "SELECT b.PRINT_MODEL FROM flow_type AS a JOIN flow_form_type AS b 
					ON a.FORM_ID = b.FORM_ID 
					WHERE a.FLOW_ID = '" . SecurityFilter($workflowID) . "'";
		$result = exequery($connection, $query);
		if ($row = mysql_fetch_assoc($result)) {
			$formContent = $row['PRINT_MODEL'];

			$elementArray = html_element($formContent);

			$elementArrayLength = sizeof($elementArray);
			for ($i = 0; $i < $elementArrayLength; $i++) {
				$element = $elementArray[$i];
				$elementID = get_attr($element, "ID");
				$elementTitle = get_attr($element, "TITLE");

				if ($elementID) {
					$fieldList[$elementID] = array(
						"title" => $elementTitle,
						"type" => "string"
					);
				}
			}

		}

		return $fieldList;
	}

	public function getGroupByList($filterInfor = array()) {
		$workflowID = SecurityFilter($filterInfor["workflowID"]);
		$groupByList = $this -> getFieldList($workflowID);

		//添加流程固定字段
		$systemFields = array(
			"creator" => array(
				"title" => $this->_lang['report_creator'],
				"type" => "string"
			),
			"createTime" => array(
				"title" => $this->_lang['report_createTime'],
				"type" => "date"
			),
			"endTime" => array(
				"title" => $this->_lang['report_endTime'],
				"type" => "date"
			)
		);
		foreach ($systemFields as $key => $value) {
			$groupByList[$key] = $value;
		}

		return $groupByList;
	}

	public function getDataAnalysisList($filterInfor = array()) {
		$workflowID =SecurityFilter($filterInfor["workflowID"]);
		$dataAnalysisList = $this -> getFieldList($workflowID);
		// $dataAnalysisList["status"] = array(
			// "title" => "流程状态",
			// "type" => "string"
		// );
		// $dataAnalysisList['flow_over'] = array(
			// 'title'=>'完结流程数量',
			// 'type'=>'string'
		// );
		// $dataAnalysisList['flow_flying'] = array(
			// 'title'=>'进行中流程数量',
			// 'type'=>'string'
		// );
		return $dataAnalysisList;
	}

	public function getSearchList($filterInfor = array()) {

		global $connection;
		$searchList = array();

		$searchList["creator"] = array(
			"title" => $this->_lang['report_creator'],
			"type" => "choose",
			"url" => "user"
		);
		$searchList["createTime"] = array(
			"title" => $this->_lang['report_createTime'],
			"type" => "dateRange"
		);
		$searchList["overTime"] = array(
			"title" => $this->_lang['report_endTime'],
			"type" => "dateRange"
		);
		$searchList["status"] = array(
			"title" => $this->_lang['report_status'],
			"type" => "select",
			"dataSource" => array(
				"0" => $this->_lang['report_all'],
				"1" => $this->_lang['report_done'],
				"2" => $this->_lang['report_running'],
			)
		);
		return $searchList;
	}

	public function getReportData($groupByField, $dataAnalysisField, $filterInfor = array()) {
		global $connection;
		
		$workflowID = SecurityFilter($filterInfor["param"]["workflowID"]);
		$formID = $this -> getFormID($workflowID);
		
		$dateType = $filterInfor['dateType'];
		$dateValue = $filterInfor['dateValue'];

		$dataAnalysisList = $this -> getDataAnalysisList(array("workflowID" => $workflowID));
		
		$searchArray = searchStrToArr($filterInfor["searchInfor"]);
		$where = $this -> getWhereStr($searchArray, $workflowID);
		
		
		$sql = 'select ';
		if($dataAnalysisField){
			$dataAnalysisFieldSplit = explode(',', $dataAnalysisField);
			
			foreach($dataAnalysisFieldSplit as $field){
				// if('status' == strtolower($field)){
					// $specialDealStatus = true;
					// continue;
				// }
				$sql .= " SUM(REPLACE({$field},',','')) as {$field},";
			}
		}else{
			$sql .= 'COUNT(*) AS count,';
		}
		if(empty($dataAnalysisFieldSplit)) $dataAnalysisFieldSplit = array($this->_lang['report_count']);
		
		switch($groupByField){
			case 'creator' :
				
				$tempData = array();
				
				$_sql = "select f.CREATOR, f.RUN_ID, u.USER_NAME from `flow_run` f join `user` u on u.USER_ID = f.CREATOR where f.FLOW_ID = '{$workflowID}'";
				$query = $sql ." USER_NAME FROM `zzzz_flow_data_{$formID}` z,({$_sql}) i where z.RUN_ID = i.RUN_ID and z.FLOW_ID='{$workflowID}'";
				$query .= ' group by i.CREATOR';
				
				$xAreaResult = exequery($connection, $query);
				
				while($r = @mysql_fetch_assoc($xAreaResult)){
				
					if(is_array($r) && !empty($r)){
						foreach($r as $k => $v){
						
							if('user_name' == strtolower($k)) continue;
							$tempData[$k][] = array(
								'name' => $r['USER_NAME'],
								'y' => 0
							);
							
						}
					}
				}
				
				$_sql = "select f.CREATOR, f.RUN_ID, u.USER_NAME from `flow_run` f join `user` u on u.USER_ID = f.CREATOR where f.FLOW_ID = '{$workflowID}' {$where}";
				$sql .= " USER_NAME FROM `zzzz_flow_data_{$formID}` z,({$_sql}) i where z.RUN_ID = i.RUN_ID and z.FLOW_ID='{$workflowID}'";
				$sql .= ' group by i.CREATOR';

				$result = exequery($connection, $sql);
				while($row = @mysql_fetch_assoc($result)){
				
					if(is_array($row) && !empty($row)){
						foreach($row as $key => $value){
						
							if(array_key_exists($key, $tempData)){
								foreach($tempData[$key] as &$temp){
									if($temp['name'] == $row['USER_NAME']){
										$temp['y'] = (float)$value;
									}
								}
							}
						}
					}
				}
				
				if(empty($tempData)){
					foreach($dataAnalysisFieldSplit as $value){
						$tempData[$value][] = array(
							'name'=>$value,
							'y'=>0
						);
					}
				}
				if($tempData){
					foreach($tempData as $key => $value){

						$name = array_key_exists($key, $dataAnalysisList) ? $dataAnalysisList[$key]['title'] : $this->_lang['report_count'];
						$reportData[] = array(
							'name' => $name,
							'data' => $value
						);
					}
				}
				
				break;

			case 'createTime' :
				$dateType = $filterInfor['dateType'];
				$dateValue = $filterInfor['dateValue'];
				
				if('quarter' == $dateType){
					$quarter = array('1'=>$this->_lang['report_firstQuarter'], '2'=>$this->_lang['report_secondQuarter'], '3'=>$this->_lang['report_thirdQuarter'], '4'=>$this->_lang['report_fourthQuarter']);
				}

				$tempData = getDatexAxis($dateType, $dateValue);
				
				$table = "zzzz_flow_data_{$formID}";
				
				$query = getFlowDateQuery($dateType, $dateValue, $table, 'CREATE_TIME', $dataAnalysisField, $where, $workflowID);
				$result = exequery($connection, $query);
				
				$data = array();
				while($row = @mysql_fetch_assoc($result)){
					
					if(is_array($row) && !empty($row)){
						if(!key_exists($row['DATE_FORMAT'], $tempData)) continue;
						foreach($row as $key=>$value){
						
							if('date_format' == strtolower($key)) continue;
							if(isset($quarter)){
								$xName = $quarter[$row['DATE_FORMAT']];
							}else{
								$xName = $row['DATE_FORMAT'];
							}
							$data[$key][$row['DATE_FORMAT']] = array(
								'name' => $xName,
								'y' => (float)$value
							);
						}
					}
				}
				
				if(empty($data)){
					foreach($dataAnalysisFieldSplit as $value){
					
						$data[$value] = array(
							'name'=>$value,
							'data'=>array_values($tempData)
						);
					}
				}

				$template = array();
				foreach($data as $key=>$value){
					$template[$key]['name'] = $key;
					$template[$key]['data'] = array_merge_compel($tempData, $value);
				}
				$template = array_values($template);
				if($template){
					foreach($template as $value){

						$name = key_exists($value['name'], $dataAnalysisList) ? $dataAnalysisList[$value['name']]['title'] : $this->_lang['report_count'];
						$reportData[] = array(
							'name'=>$name,
							'data'=>array_values($value['data'])
						);
					}
				}
				break;

			case 'endTime' :
				$dateType = $filterInfor['dateType'];
				$dateValue = $filterInfor['dateValue'];

				$tempData = getDatexAxis($dateType, $dateValue);
				
				$table = "zzzz_flow_data_{$formID}";
				$where .= ' and f.CURRENT_STEP=0 ';
				$query = getFlowDateQuery($dateType, $dateValue, $table, 'TRANSACT_TIME', $dataAnalysisField, $where, $workflowID);

				$result = exequery($connection, $query);
				
				$data = array();
				while($row = @mysql_fetch_assoc($result)){
					
					if(is_array($row) && !empty($row)){
						if(!key_exists($row['DATE_FORMAT'], $tempData)) continue;
						
						foreach($row as $key=>$value){
							if('date_format' == strtolower($key)) continue;
							$data[$key][$row['DATE_FORMAT']] = array(
								'name' => $row['DATE_FORMAT'],
								'y' => (float)$value
							);
						}
					}
				}
				if(empty($data)){
					foreach($dataAnalysisFieldSplit as $value){
						$data[$value] = array(
							'name'=>$value,
							'data'=>array_values($tempData)
						);
					}
				}

				$template = array();
				foreach($data as $key=>$value){
					$template[$key]['name'] = $key;
					$template[$key]['data'] = array_merge_compel($tempData, $value);
				}
				$template = array_values($template);
				if($template){
					foreach($template as $value){

						$name = key_exists($value['name'], $dataAnalysisList) ? $dataAnalysisList[$value['name']]['title'] : $this->_lang['report_count'];
						$reportData[] = array(
							'name'=>$name,
							'data'=>array_values($value['data'])
						);
					}
				}
				break;
			
			default :
				$tempData = array();
				
				$query = $sql ." {$groupByField} from `zzzz_flow_data_{$formID}` z where z.FLOW_ID = '{$workflowID}' and {$groupByField} != '{宏控件}' AND {$groupByField} != '' group by {$groupByField}";
				
				$xAreaResult = exequery($connection, $query);
				
				while($r = @mysql_fetch_assoc($xAreaResult)){
					if(is_array($r) && !empty($r)){
						foreach($r as $k => $v){
						
							if($k != $groupByField){
								$tempData[$k][] = array(
									'name' => $r[$groupByField],
									'y' => 0
								);
							}
						}
					}
				}
				
				$_sql = "select f.CREATOR, f.RUN_ID, u.USER_NAME from `flow_run` f join `user` u on u.USER_ID = f.CREATOR where f.FLOW_ID = '{$workflowID}' {$where}";
				$sql .= " {$groupByField} FROM `zzzz_flow_data_{$formID}` z,({$_sql}) i where z.RUN_ID = i.RUN_ID and z.FLOW_ID='{$workflowID}'";
				$sql .= " GROUP BY {$groupByField}";
				
				$result = exequery($connection, $sql);
				while($row = @mysql_fetch_assoc($result)){
				
					if(is_array($row) && !empty($row)){
						foreach($row as $key => $value){
						
							if(array_key_exists($key, $tempData)){
								foreach($tempData[$key] as &$temp){
									if($temp['name'] == $row[$groupByField]){
										$temp['y'] = (float)$value;
									}
								}
							}
						}
					}
				}
				
				if(empty($tempData)){
					foreach($dataAnalysisFieldSplit as $value){
						$tempData[$value][] = array(
							'name'=>$value,
							'y'=>0
						);
					}
				}
				
				if($tempData){
					foreach($tempData as $key => $value){

						$name = array_key_exists($key, $dataAnalysisList) ? $dataAnalysisList[$key]["title"] : $this->_lang['report_count'];
						$reportData[] = array(
							'name' => $name,
							'data' => $value
						);
					}
				}
				break;
		}

		return $reportData;

	}

}
?>