<?php
include_once 'inc/auth.php';
include_once('inc/utility_all.php');
includelangpak('report');

$PAGE_TITLE	= $_lang["system_edit_report"];
include_once 'inc/page_header.inc.php';
?>
		<link rel="stylesheet" id="theme-url" href="<?= THEME_FLAG ?>/<?= $_SESSION['LOGIN_THEME'] ?>/style.css">
		<link rel="stylesheet" type="text/css" href="/newplugins/css/jquery.lazyplugins.css">
		<link rel="stylesheet" type="text/css" href="/newplugins/font-awesome/css/font-awesome.min.css">
		<link rel="stylesheet" href="/newplugins/bootstrap/css/bootstrap.min.css" />
		<link rel="stylesheet" href="/newplugins/js/pnotify/jquery.pnotify.default.css" />
		<link rel="stylesheet" type="text/css" href="/newplugins/js/bootstrap-select/bootstrap-select.min.css"/>
		<link rel="stylesheet" href="/newplugins/js/jquery-ui/css/ui-lightness/jquery-ui.css" />
		<link rel="stylesheet" type="text/css" href="/newplugins/js/iCheck/skins/all.css">
		<link rel="stylesheet" type="text/css" href="/newplugins/css/style.css">
		<style>
			.report-search{
				float:right;
				margin:6px 5px 0 0;
			}
		</style>
	</head>
	<body>
		<div class="lazy_header">
			<span class="lazy-page-title">
				<i class="fa fa-page-title"></i>
				<span class="tip"><?=$_lang['report_manage_report']?></span>
			</span>
			
			<div class="report-search"></div>
		</div>
		<div class="report-list"></div>

	</body>
</html>

<script src="/inc/jquery/jquery.js"></script>
<script src="/lang/<?=$_SESSION['LOGIN_LANG'] ?>/javascript.lang.js"></script>
<script src="/newplugins/js/jquery.lazyplugins.js"></script>
<script type="text/javascript" src="/newplugins/js/bootstrap.bootbox.js"></script>
<script type="text/javascript" src="/newplugins/bootstrap/js/bootstrap.min.js"></script>
<script type="text/javascript" src="/newplugins/js/pnotify/jquery.pnotify.min.js"></script>
<script type="text/javascript" src="/newplugins/js/iCheck/icheck.js"></script>
<script type="text/javascript" src="/newplugins/js/bootstrap-select/bootstrap-select.js"></script>
<script type="text/javascript" src="/newplugins/js/jquery-ui/js/jquery-ui.min.js"></script>

<script>

	$(function() {

		$.pnotify.defaults.styling = "bootstrap3";
	    $.pnotify.defaults.closer = false;
	    $.pnotify.defaults.sticker = false;
	    $.pnotify.defaults.history = false;
	    $.pnotify.defaults.delay = 1000;
	    $.pnotify.defaults.addclass = "stack-topleft";
	    $.pnotify.defaults.animate_speed = 'fast';
	    $.pnotify.defaults.type = "error";

	    $(".report-search").LazySearch({
	    	tip:"<?=$_lang['report_query_report']?>",
	    	url:"do.php",
			param:{
				op:"getList"
			},
			 autoSearch : {
              	template : "{CHART_TITLE}",
                onItemClick : function(data) {
                	location.href = "../report_create/index.php?op=edit&chartType="+data.CHART_TYPE+"&chartTag="+data.CHART_TAG+"&chartTitle="+data.CHART_TITLE+"&chartID="+data.CHART_ID+"&dataSourceID="+data.CHART_DATASOURCE_ID;
               }
           }
	    });

	    $(".report-list").LazyTable({
		dataSource : 'do.php',
		param:{
			op:"getList"
		},
		page:{
			itemsPerPage:8
		},
		column:[{
			key:"checkall"
		},
		{
			key:"CHART_TITLE",
			title: '<?=$_lang['report_title']?>'
		},{
			key:'CHART_TYPE',
			title:'<?=$_lang['report_graphical']?>',
			template:function(data){
				return '<div style="height:35px;width:35px;background:url(/images/chart/'+data.CHART_TYPE+'.png) center center"></div>'; 
			}
		},{
			key:'CHART_TAG_TITLE',
			title:'<?=$_lang['report_tag']?>'
		},{
			key:'USER_NAME',
			title:'<?=$_lang['report_creator']?>'
		},{
			key:'CHART_CREATE_TIME',
			title:'<?=$_lang['report_create_time']?>'
		}],
		buttons : {
				buttonInfor : {
					"edit" : {
						title : '<?=$_lang['report_edit']?>',
						func : function(data) {
							location.href = "../report_create/index.php?op=edit&chartID="+data.CHART_ID;
						}
					},
					"copy" : {
						title : '<?=$_lang['report_copy']?>',
						func : function(data) {
							location.href = "../report_create/index.php?op=copy&chartID="+data.CHART_ID;
						}
					},
					"delete" : {
						title : '<?=$_lang['report_delete']?>',
						func : function(data) {
							bootbox.confirm("<?=$_lang['report_delete_report?']?>", function(result) {
						      if(result){
						          $.ajax({
						          	url:"do.php",
						          	data:{
						          		op:"delete",
						          		chartID :data.CHART_ID
						          	}
						          }).done(function(result){
						          	if(result){
						          		$.pnotify({
									        text: '<?=$_lang['report_delete_success']?>',
									        type:"success"
									    });
						          		$(".report-list").LazyTable("reload");

						          	} else {
						          		$.pnotify({
									        text: '<?=$_lang['report_delete_failure']?>',
									        type:"error"
									    });
						          	}
						          });
						      }
						    });
						}
					}
				}
			},
		batchButtons : {
				"delte" : {
					title : '<?=$_lang['report_delete_batch']?>',
					func : function(data) {
						if(data.length == 0){
							$.pnotify({
						        text: '<?=$_lang['report_at_least_one_report']?>',
						        type : "error"
						    });
						} else {
							var contentIDStr = [];
							for(var i = 0,length = data.length ;i < length;i++){
								contentIDStr.push(data[i].CHART_ID);
							}

							bootbox.confirm("<?=$_lang['report_delete_report?']?>", function(result) {
						      if(result){
						           $.ajax({
						          	url:"do.php",
						          	data:{
						          		op:"delete",
						          		chartID :contentIDStr.join(',')
						          	}
						          }).done(function(result){
						          	if(result){
						          		$.pnotify({
									        text: '<?=$_lang['report_delete_success']?>',
									        type:"success"
									    });
						          		$(".report-list").LazyTable("reload");

						          	} else {
						          		$.pnotify({
									        text: '<?=$_lang['report_delete_failure']?>',
									        type:"error"
									    });
						          	}
						          });
						      }
						    });

						}
					}
				}
			},
			onAfterLoad:function(){
				 $(':checkbox').iCheck({
                    checkboxClass : 'icheckbox_square-grey',
                    radioClass : 'iradio_square-grey'
                });

				 $(':checkbox.lazy_table_checkall').iCheck({
                    checkboxClass : 'icheckbox_square-blue',
                    radioClass : 'iradio_square-blue'
                });
			}
	});


		$(".report-list").on('ifChanged', '.lazy_table_checkall', function(event){
			$(".report-list").find(".lazy_table_checkbox,.lazy_table_checkall").prop("checked", $(this).prop("checked")).iCheck('update'); 
		});

		$(".report-list").on('ifChanged','.lazy_table_checkbox', function(event){
			if ($(this).prop("checked")) {
                    if ($(".report-list").find(".lazy_table_checkbox").filter(function() {
                        return jQuery(this).prop("checked") == false;
                    }).length == 0) {
                        $(".report-list").find(".lazy_table_checkall").prop("checked", true);
                    }
                } else {
                    $(".report-list").find(".lazy_table_checkall").prop("checked", false);
                }

                $(":checkbox").iCheck('update'); 
		});


		
	}); 
</script>
