<?php
include_once 'inc/auth.php';
include_once('inc/utility_all.php');
includelangpak('report');

$PAGE_TITLE	= $_lang["system_report"];
include_once 'inc/page_header.inc.php';
?>
		<link rel="stylesheet" id="theme-url" href="<?= THEME_FLAG ?>/<?= $_SESSION['LOGIN_THEME'] ?>/style.css">
		<link rel="stylesheet" type="text/css" href="/newplugins/css/jquery.lazyplugins.css">
		<link rel="stylesheet" type="text/css" href="/newplugins/font-awesome/css/font-awesome.min.css">
		<link rel="stylesheet" href="/newplugins/bootstrap/css/bootstrap.min.css" />
		<link rel="stylesheet" href="/newplugins/js/pnotify/jquery.pnotify.default.css" />
		<link rel="stylesheet" type="text/css" href="/newplugins/css/style.css">
		<style>
			.tag-list-wrap{
				width:300px;
				float:left;
				border-right:1px solid #D9D9D9;
			}
			.tag-list{
				overflow-y: auto;
				overflow-x:hidden;
			}
			.tag-form-wrap{
				margin-left:300px;
			}
			.tag-title{
				width: 300px;
			}

		</style>
	</head>
	<body>
		<div class="tag-list-wrap">
			<div class="lazy_header">
				<span class="lazy-list-title">
					<i class="fa fa-list-title"></i>
					<span class="tip"><?=$_lang['report_tag'];?></span>
				</span>

				<input type="button" value="<?=$_lang['report_new'];?>" class="btn btn-primary new">				
			</div>
			<div class="tag-list"></div>
		</div>
		<div class="tag-form-wrap">
			<div class="lazy_header">
				<div class="toggle-list"></div>
				<span class="lazy-page-title">
					<i class="fa fa-page-title"></i>
					<span class="tip"><?=$_lang['report_new_tag'];?></span>
				</span>
				<input type="button" value="<?=$_lang['report_submit'];?>" class="btn btn-primary save" />
			</div>
			<table class="form_table">
				<tr>
					<td class="title"><?=$_lang['report_tag_name'];?></td>
					<td>
						<input type="text" maxlength="20" class="require tag-title">
					</td>
				</tr>
			</table>
		</div>
	</body>
</html>

<script src="/inc/jquery/jquery.js"></script>
<script src="/lang/<?=$_SESSION['LOGIN_LANG'] ?>/javascript.lang.js"></script>
<script src="/newplugins/js/jquery.lazyplugins.js"></script>
<script type="text/javascript" src="/newplugins/js/bootstrap.bootbox.js"></script>
<script type="text/javascript" src="/newplugins/js/jquery.nicescroll.js"></script>
<script type="text/javascript" src="/newplugins/bootstrap/js/bootstrap.min.js"></script>
<script type="text/javascript" src="/newplugins/js/pnotify/jquery.pnotify.min.js"></script>

<script>

	$(function() {

		$.pnotify.defaults.styling = "bootstrap3";
	    $.pnotify.defaults.closer = false;
	    $.pnotify.defaults.sticker = false;
	    $.pnotify.defaults.history = false;
	    $.pnotify.defaults.delay = 1000;
	    $.pnotify.defaults.addclass = "stack-topleft";
	    $.pnotify.defaults.animate_speed = 'fast';
	    $.pnotify.defaults.type = "error";

		$(".tag-list").height($(window).height() - 40).niceScroll();

		$(".toggle-list").LazyToggle({
			onAfterShow : function() {
				$(".tag-list-wrap").show();
				$(".tag-form-wrap").css("margin-left","300px");
			},
			onAfterHide : function() {
				$(".tag-list-wrap").hide();
				$(".tag-form-wrap").css("margin-left","0");
			}
		});

		$(".new").click(function(){
			$(".tag-form-wrap .tip").html("<?=$_lang['report_new_tag'];?>");
			$(".tag-title").val("");
			$(".tag-title").removeData("tagID");
		});

		$(".tag-list").LazyList({
			dataSource:"do.php",
			param:{
				op:"getList"
			},
			buttons:{
				buttonInfor:{
					"delete":{
						title:"<?=$_lang['report_delete'];?>",
						func:function(data){
							bootbox.confirm("<?=$_lang['report_delete_tag?'];?>", function(result) {
						      if(result){
						          $.ajax({
						          	url:"do.php",
						          	data:{
						          		op:"delete",
						          		tagID:data.TAG_ID
						          	}
						          }).done(function(result){
						          	if(result){
						          		$.pnotify({
											text:"<?=$_lang['report_do_success'];?>",
											type:"success"
										});

										$(".tag-list").LazyList("reload");

										$(".tag-form-wrap .tip").html("<?=$_lang['report_new_tag'];?>");
										$(".tag-title").val("");
										$(".tag-title").removeData("tagID");
						          	}else{
						          		$.pnotify("<?=$_lang['report_do_failure'];?>");
						          	}
						          });
						      }
						    });
						}
					}
				}
			},
			itemListTemplate:"{TAG_TITLE}",
			onItemClick : function(ui, data, event) {
				$(".tag-form-wrap .tip").html("<?=$_lang['report_edit_tag'];?>");
				$(".tag-title").val(data.TAG_TITLE);
				$(".tag-title").data("tagID",data.TAG_ID);
			}
		});

		$(".save").click(function(){
			var tagTitle = $.trim($(".tag-title").val());

			if(tagTitle == ""){
				$.pnotify("<?=$_lang['report_input_tag_name'];?>");
				return false;
			}

			var tagID = $(".tag-title").data("tagID") ? $(".tag-title").data("tagID") : "";

			$.ajax({
				url:"do.php",
				data:{
					op:"new",
					tagTitle:tagTitle,
					tagID : tagID
				}
			}).done(function(result){
				if(result){
					$.pnotify({
						text:"<?=$_lang['report_do_success'];?>",
						type:"success"
					});


					$(".tag-list").LazyList("reload");

					if(!tagID){
						$(".tag-title").val("");
					}

				}else{
					$.pnotify("<?=$_lang['report_do_failure'];?>");
				}
			});

		});
	}); 
</script>
