<?
/**
*@Systemname:       E-Office
*@Filename:         general/crm/customer/query/export.php
*@Function:         客户信息导出
*@Encoding:         $_lang['encoding']
*@Author:           sun|www.weaver.com.cn
*@Date:             2008-08-07
*@File Version:     5.0
*@Eoffice Version:  7.3
*/
include_once("inc/auth.php");
includelangpak("customer");

include_once("inc/utility_all.php");
// 用户id
$customer_id = $_POST['customer_id'];
// 产品名称
$product_id = $_POST['product_id'];
// 时间段

$time_sel = $_POST['time_sel'];
// 开始时间

$time_start = $_POST['start'];
// 结束时间
$time_end = $_POST['end'];
// 按照
$count_field = $_POST['count_field'];

$count_type = $_POST['count_type'];

$sort = $_POST['sort'];


switch( $count_field ){
	case 1:
		$group = 's.SALESMAN';
		$group_name = $_lang['customer_sale_man']; 
		break;
	case 2:
		$group = 's.CUSTOMER_ID';
		$group_name = $_lang['customer_self']; 
		break;
	case 3:
		$group = 's.PRODUCT_ID';
		$group_name = $_lang['customer_pdt']; 
		break;
	case 4:
		$group = 's.DATE';
		$group_name = $_lang['customer_time']; 
		break;

}

$sale_data = get_summary_data( $customer_id, $product_id, $start, $end, $group, $sort, $count_type );

$field_counts = count($sale_data['data']);
$sale_title = get_sale_title( $group, $count_type );


/**
 * 显示在thead标签中的列名
 *
 * @param  string $group
 * @param  string $count_type
 * @return array $result
 */
function get_sale_title( $group, $count_type ){
	$arr = array();
	$group_field = get_group_field( $group );

	if( strstr( $group_field, 'mon' ) )
		$group_field = 'mon';
	
	array_push( $arr, $group_field );
	$summary_field = get_summary_field( $count_type );
	preg_match_all( "/as(\s*)[a-zA-Z0-9_]+/", $summary_field, $match );
	
	foreach($match[0] as $item){
		array_push( $arr, str_replace('as ', '', $item) );
	}
	return $arr;
}


/**
*获取销售记录报表的查询结果
*@param  string $customer_id
*@param  string $product_id
*@param  string $start
*@param  string $end
*@param  string $group
*@param  string $sort
*@param  string $count_type
*@return array $result
*/
function get_summary_data( $customer_id, $product_id, $start, $end, $group, $sort, $count_type){

	$where_str = get_summary_where( $customer_id, $product_id, $start, $end );

	$result['data'] = get_summary_data_list( $group, $where_str, $sort, $count_type );
	
	$result['total'] = get_summary_data_count($where_str, $count_type);
	
	return $result;
}

/**
*获取销售记录统计查询条件

*@param  string $customer_id
*@param  string $product_id
*@param  string $start
*@param  string $end
*@return string $where_str
*/
function get_summary_where( $customer_id, $product_id, $start, $end ){

	$where_str = '';
	if($customer_id){
		$where_str .= " AND s.`CUSTOMER_ID` IN ( $customer_id ) ";
	}
	if($product_id){
		$where_str .= " AND s.`PRODUCT_ID` IN ( $product_id ) ";
	}
	if($start){
		$where_str .= " AND s.`DATE` >= '$start' ";
	}
	if($end){
		$where_str .= " AND s.`DATE` <= '$end' ";
	}
	return $where_str;
}

/**
*获取查询语句的group by 的字段

*@param  string $group
*@return string $field
*/
function get_group_field( $group ){
	// 查询中group by的列
	switch( $group ){
		case "s.SALESMAN":
			$field = 'USER_NAME';
			break;
		case "s.CUSTOMER_ID":
			$field = 'CUSTOMER_NAME';
			break;
		case "s.PRODUCT_ID":
			$field = 'PRODUCT_NAME';
			break;
		case "s.DATE":
			$field = 'LEFT(DATE,7) AS mon';
			break;
	}
	return $field;
}

/**
*获取查询语句的 sum 字段
*@param  string $count_type
*@return string $field
*/
function get_summary_field( $count_type ){

	$count_type = explode( ',', $count_type );
	
	$count_type = array_filter($count_type);
	
	//分组查询列名
	$field = '';
	foreach($count_type as $type){
		if($type == 1)
			$field .= ' SUM(PRICE * AMT) as MONEY_TOTAL ,';
		if($type == 2)
			$field .= ' SUM(PRICE * AMT * (1-DISCOUNT)) as MONEY_DISCOUNT ';
	}
	$field = preg_replace( "/\,$/", '', $field );
	return $field;
}

/**
*获取销售记录统计查询结果

*@param  string $group
*@param  string $where_str
*@param  string $sort
*@param  string $count_type
*@return array $result
*/
function get_summary_data_list( $group, $where_str, $sort, $count_type ){
	global $connection;	
	$group_field_str = SecurityFilter(get_group_field( $group ));

	if(strstr($group,'s.DATE'))
		$group = 'LEFT(DATE,7)';
	
	$summary_field_str = SecurityFilter(get_summary_field($count_type));

	//排序字段
	if( strstr( $summary_field_str, 'MONEY_TOTAL' ) )
		$order = 'MONEY_TOTAL';
	if( strstr( $summary_field_str, 'MONEY_DISCOUNT' ) )
		$order = 'MONEY_DISCOUNT';
	
	//排序
	if($sort)
		$order_str = " ORDER BY $order $sort ";	
	
	//分组查询数据
	$sql = "SELECT $group_field_str, $summary_field_str FROM sale_history s LEFT JOIN USER u ON s.SALESMAN = u.USER_ID 
				LEFT JOIN customer c ON s.CUSTOMER_ID = c.CUSTOMER_ID 
				LEFT JOIN product P ON s.PRODUCT_ID = p.PRODUCT_ID 
				WHERE 1 = 1 ". SecurityFilter($where_str) ." GROUP BY ".SecurityFilter($group)." 
		   ";	
	
	//防止分页函数中加入排序引起错误.
	if($sort) {
		$sql = str_replace("limit", $order_str." limit", $sql);
	}
	
	$cursor	= exequery( $connection, $sql );
	
	while($row = mysql_fetch_array( $cursor , MYSQL_ASSOC )){
		
		$result[] = $row;
	}
	return $result;
}

/**
*获取销售记录汇总

*@param  string $where_str
*@param  string $count_type
*@return array $result
*/
function get_summary_data_count( $where_str, $count_type ){
	global $connection;
	
	$summary_field_str = SecurityFilter(get_summary_field($count_type));
	//总计数据
	$sql = "SELECT $summary_field_str  FROM sale_history s LEFT JOIN USER u ON s.SALESMAN = u.USER_ID 
				LEFT JOIN customer c ON s.CUSTOMER_ID = c.CUSTOMER_ID 
				LEFT JOIN product p ON s.PRODUCT_ID = p.PRODUCT_ID 
				WHERE 1 = 1 ". SecurityFilter($where_str) ;

	$cursor = exequery( $connection, $sql );	
	while($row = mysql_fetch_array( $cursor ,MYSQL_ASSOC )){
		$result[] = $row;
	}
	return $result;	
}

$str = "\r\n<html xmlns:o=\"urn:schemas-microsoft-com:office:office\"\r\nxmlns:x=\"urn:schemas-microsoft-com:office:excel\"\r\nxmlns=\" http://www.w3.org/TR/REC-html40\">\r\n<meta http-equiv=\"Content-Type\" content=\"text ml; charset=gb2312\">\r\n";

$str .= "<table border='1px' width='100%'>";
$str .= "	<tr bgcolor='#99FFFF'>";
foreach($sale_title as $key){
	$str .= "	<td nowarp><b>".$_lang["custommer_sale_summary_".$key]."</b></td>";
}
$str .=	"	</tr>";
if( !empty($sale_data['data']) )
{
	foreach($sale_data['data'] as $value){
		$str .= "<tr>";
		foreach($sale_title as $key){
			$str .= "	<td align='left' nowarp nowarp style=\"vnd.ms-excel.numberformat:@\";>".$value[$key]."</td>";
		}
		$str .=	"</tr>";
	}
}
$str .= "<tr>";
$str .= "	<td nowarp>".$_lang['customer_total']."</td>";
foreach($sale_data['total'][0] as $value){
	$str .= "	<td align='left' nowarp>".$value."</td>";
}
$str .=	"</tr>";
$str .= "</table>";
$excaltitle = $_lang["customer_sale_report"].".xls";
$str_out    = getTypeString($str,'gb2312');
$excaltitle = getTypeString($excaltitle,'gb2312');

ob_end_clean();
Header("Cache-control: private");
Header("Content-type: application/vnd.ms-excel");
Header("Accept-Ranges: bytes");
header("Accept-Length: ".strlen($str_out));
header("Content-Disposition: attachment; filename=".$excaltitle);
echo  $str_out;

?>