<?php
/**
 *@systemname:       E-Office
 *@filename:         general/task/mytask/do.php
 *@function:         任务管理
 *@encoding:         $_lang['encoding']
 *@file Version:     1.0
 *@eoffice Version:  9.0
 *@author:           qishaobo|www.weaver.com.cn
 *@modify            qishaobo
 *@date:             2015-03-05
*/
include_once("inc/auth.php");
include_once("inc/utility_all.php");
include_once("api/task.class.php");
include_once("../public/helper.php");
include_once ("inc/function_usergeneral.php");
includelangpak("task");
$opt = $_POST['opt'];
$taskObj = new task();
switch($opt) {
	case "create":
		$end   = get_task_date($_POST['date']);
		$pid   = isset($_POST['pid'])?(int)$_POST['pid']:0;
		$imp   = isset($_POST['important'])?(int)$_POST['important']:0;
		$desc  = isset($_POST['DESCRIPTION'])?$_POST['DESCRIPTION']:'';
		if(empty($_POST['name'])) exit();
		$data = array(
				'TASK_NAME'         => $_POST['name'],
				'TASK_DESCRIPTION'  => $desc,
				'RELEASE_DATE'      => time(),
				'END_DATE'          => $end,
				'USER_ID'	        => $_SESSION['LOGIN_USER_ID'],
				'TASK_STATUS'       => 1,
				'IMPORTANT_LEVEL'   => $imp,
				'PID'			    => $pid
			);
		$insertId = $taskObj->addTask($data);

		if ($data['END_DATE'] > 0) {
			$dateTime = date("Y-m-d", $data['END_DATE']);
			$message = $_lang['task_create_message'].$data['TASK_NAME'];
			sendMessageToUser($_SESSION['LOGIN_USER_ID'], $dateTime, $message);	
		}

		if($pid>0){
			$taskObj->taskLogRecord($pid,$_lang['task_create_son']);
		}
		if($insertId > 0){
			$taskObj->taskLogRecord($insertId,$_lang['task_create']);
			$data['TASK_ID']  = $insertId;
			$data['USER_NAME'] = $_SESSION['LOGIN_USER_NAME'];
			$data['ATTENTION'] = 0;
			echo json_encode($data);
		}else{
			echo 0;
		}
		break;
	case "getTask":
		$tagsArr = $taskObj->getTags();
		$tags    = json_encode($tagsArr);
		if(!empty($tagsArr)){
			foreach($tagsArr as $k=>$v){
				$tags .=$v['TAG_NAME']."|";
			}
		}
		$tags   = rtrim($tags,'|');
		if($_POST['status']!=2){
			$tasks   = $taskObj->getTasksIndex($_POST);
			include_once("./task_list_date.php"); 
		}else{
			$tasks   = $taskObj->getTasksDone($_POST);
			include_once("./task_list_done.php"); 
		}
		
		foreach($tasks as $k=>$v){
			$arr['name'][] = $_lang['task_'.$k];
			$arr['num'][]  = $v['num'];
		}
		$_SESSION['task'] = $arr;
		break;	
	case "getTaskChart":
		echo json_encode($_SESSION['task']);
		break;		
	case "taskMore":
		$tasks   = $taskObj->getTasksMore($_POST);
		echo json_encode($tasks);
		break;			
	case "edit":
		$tagsArr  	=  $taskObj->getTags();
		$tags     	=  json_encode($tagsArr);
		if(!empty($_POST['task_id'])){
			$tid = (int)$_POST['task_id'];
			$taskTags 	=  $taskObj->getTaskTags($tid);
			$task     	=  $taskObj->getTask($tid);
			$feedbacks  =  $taskObj->feedbackSelect(array('TASK_ID'=>$tid));
			$taskUsers  =  $taskObj->getUsers($tid,2);
			$logs       =  $taskObj->taskLogFind(array('TASK_ID'=>$tid));
			$taskSons 	=  $taskObj->getTaskSons($tid);
			$taskParent =  $taskObj->getTaskParent($task['PID']);
			$taskAtts	=  $taskObj->getAttachments($tid);
			$joinType   =  $taskObj->getJoinType($tid);
		}
		if(isset($_POST['check_son'])&&$_POST['check_son']=='parent'&&strpos($taskUsers['join']['user_id'].$taskUsers['share']['user_id'],$_SESSION['LOGIN_USER_ID'])===false){
			echo 0;
			exit;
		}
		if($_SESSION['LOGIN_USER_ID']==$task['USER_ID']){
			include_once("./task_edit.php"); 
		}else{
			include_once("./task_read.php"); 
		}
		break;	
	case "addTask":
		$tagsArr  	=  $taskObj->getTags();
		$tags     	=  json_encode($tagsArr);
		include_once("./task_add.php"); 
		break;				
	case "taskComplate":
		if(!empty($_POST['task_id'])){
			deleteMessage($_POST['task_id'], $taskObj);
			$taskObj->taskUpdateStatus((int)$_POST['task_id'],$_POST['done']);
			$taskObj->taskLogRecord((int)$_POST['task_id'],$_lang['task_mark_done']);
		}
		break;
	case "taskDel":
		if(!empty($_POST['task_id'])){
			deleteMessage($_POST['task_id'], $taskObj);
			$taskObj->taskUpdateStatus((int)$_POST['task_id'],0);
			$taskObj->taskLogRecord((int)$_POST['task_id'],$_lang['task_mark_del']);
		}
		break;	
	case "batchOperation":
		if(!empty($_POST['type'])){
			$type = (int)$_POST['type'];
			if($type == 1){
				$taskObj->taskUpdateStatus($_POST['task_id']);
			}else if($type == 2){ //批量关注
				$taskObj->taskAttentionBatch($_POST['task_id']);
			}else if($type == 3){
				$taskObj->taskUpdateStatus($_POST['task_id'],0);
			}else if($type == 4){
				$taskObj->taskDelAttentionBatch($_POST['task_id']);
			}
		}
		break;		
	case "taskAttention":
		if(!empty($_POST['task_id'])){
			echo $taskObj->taskAttention((int)$_POST['task_id']);
		}
		break;	
	case "taskDelAttention":
		if(!empty($_POST['task_id'])){
			echo $taskObj->taskDelAttention((int)$_POST['task_id']);
		}
		break;								
	case "addTaskTag":
		unset($_POST['opt']);
		echo $taskObj->addTaskTag($_POST);
		break;		
	case "feedbackAdd":
		unset($_POST['opt']);
		$data = $taskObj->addTaskFeedback($_POST);
		$taskObj->taskLogRecord($_POST['TASK_ID'],$_lang['task_add_feedback']);
		echo json_encode($data);
		break;		
	case "feedbackMore":
		unset($_POST['opt']);
		$data = $taskObj->feedbackSelect($_POST);
		echo json_encode($data);
		break;	
	case "logMore":
		unset($_POST['opt']);
		$data = $taskObj->taskLogFind($_POST);
		echo json_encode($data);
		break;			
	case "editInfo":
		$end   = !empty($_POST['END_DATE'])?strtotime($_POST['END_DATE']):0;
		$dataInfo = array(
				'IMPORTANT_LEVEL'  => $_POST['important'],
				'END_DATE'         => $end,
				'TASK_DESCRIPTION' => $_POST['DESCRIPTION'],
				'ATTACHMENT_ID'    => $_POST['attachmentIDStr'],				
				'ATTACHMENT_NAME'  => $_POST['attachmentNameStr'],
				'TASK_ID' 		   => $_POST['TASK_ID'],
				'CONTRAT_DOC'      => $_POST['CONTRAT_DOC']
			);
		if(!empty($_POST['TASK_NAME'])) $dataInfo['TASK_NAME'] = $_POST['TASK_NAME'];
		$taskObj->editTask($dataInfo);

		//添加参与人和分享人
		$dataUser = array();
		$userArr  = array(
				1 => $_POST['PARTICIPANT_ID'],
				3 => $_POST['SHARE_ID']
			);

		foreach($userArr as $key=>$val){
			if(!empty($val)){
				$users = explode(",",$val);
				foreach($users as $k=>$v){
					if(!empty($v)){
						$dataUser[] = array(
										'TASK_ID' 	=> $_POST['TASK_ID'],
										'USER_ID' 	=> $v,
										'USER_TYPE' => $key,
									  );
					}
				}
			}
		}
		$taskObj->deleteUsers($_POST['TASK_ID']);
		$taskObj->addUsers($dataUser);
		//编辑标签
		$dataLables =  array();
		if(!empty($_POST['lablesId'])){
			$lables = explode(",",$_POST['lablesId']);
			foreach($lables as $v){
				if(!empty($v)){
					$dataLables[] = array(
						'TASK_ID' 	=> $_POST['TASK_ID'],
						'TAG_ID' 	=> $v,
						);
				}
			}
		}	
		$taskObj->deleteTaskTags($_POST['TASK_ID']);
		$taskObj->addTaskTags($dataLables);
		break;	
	case "editAttInfo":
		$data = array();
		$at_id = explode(',',$_POST['attachmentIDStr']);
		$at_name = explode('*',$_POST['attachmentNameStr']);
		$num = count($at_id);
		for($i=0;$i<$num;$i++){
			if(!empty($at_id[$i])){
				$data[] = array(
						'TASK_ID'   => $_POST['TASK_ID'],
						'ATT_ID'    => $at_id[$i],				
						'ATT_NAME'  => $at_name[$i],
						'USER_ID'  	=> $_SESSION['LOGIN_USER_ID']
					);	
			}
		}
		$taskObj->attAdd($data);
		break;	
	case "delParticipant":
		if(!empty($_POST['TASK_ID']) && !empty($_POST['USER_ID'])){
			$taskObj->deleteSingeUsers($_POST);
			$task = $taskObj->getTask($_POST['TASK_ID']);
			$sendDate = date("Y-m-d", $task['END_DATE']);
			$where = "SMS_TYPE=37 AND LEFT(SEND_TIME, 10)='".$sendDate."' AND TO_ID='".$_POST['USER_ID']."' AND CONTENT LIKE '%".$task['TASK_NAME']."'";
			deleteOldMessage($where, $taskObj);
		}
		break;	
	case "delDoc":
		if(!empty($_POST['TASK_ID'])){
			$taskObj->delDoc($_POST);
		}
		break;							
	case "editInfoAjax":
		$dataInfo = array();
		if(!isset($_POST['TASK_ID'])) exit;
		$dataInfo['TASK_ID'] = $_POST['TASK_ID'];
		if(isset($_POST['END_DATE'])) $dataInfo['END_DATE'] = !empty($_POST['END_DATE'])?(strtotime($_POST['END_DATE'])+86399):0;
		if(isset($_POST['important'])) $dataInfo['IMPORTANT_LEVEL'] = $_POST['important'];
		if(isset($_POST['DESCRIPTION'])) $dataInfo['TASK_DESCRIPTION'] = $_POST['DESCRIPTION'];
		if(isset($_POST['attachmentIDStr'])) $dataInfo['ATTACHMENT_ID'] = $_POST['attachmentIDStr'];
		if(isset($_POST['attachmentNameStr'])) $dataInfo['ATTACHMENT_NAME'] = $_POST['attachmentNameStr'];
		if(isset($_POST['CONTRAT_DOC'])) $dataInfo['CONTRAT_DOC'] = $_POST['CONTRAT_DOC'];		
		if(!empty($_POST['TASK_NAME'])) $dataInfo['TASK_NAME'] = $_POST['TASK_NAME'];
		if(isset($_POST['date'])) $dataInfo['END_DATE'] = get_task_date($_POST['date']);

		if (isset($dataInfo['TASK_NAME'])) {
			$task = $taskObj->getTask($_POST['TASK_ID']);
			if ($task['TASK_NAME'] !== $dataInfo['TASK_NAME'] && $task['END_DATE'] > 0) {
				$taskUser = $taskObj->getUsers($_POST['TASK_ID']);
				$taskUserArr = array();

				if (!empty($taskUser) && isset($taskUser['join'])) {
					foreach ($taskUser['join'] as $k => $v) {
						$taskUserArr[] = $v['USER_ID'];
					}			
				}	

				$sendDate = date("Y-m-d", $task['END_DATE']);

				if (!empty($taskUserArr)) {
					$participantStr = implode(',', array_unique($taskUserArr));
					$message = $_lang['task_join_message'].$dataInfo['TASK_NAME'];
					sendMessageToUser($participantStr, $sendDate, $message);				
				}	

				$message = $_lang['task_create_message'].$dataInfo['TASK_NAME'];
				sendMessageToUser($task['USER_ID'], $sendDate, $message);

				$taskUserArr[] = $task['USER_ID'];
				$userStr = "'".implode("','", $taskUserArr)."'";
				$where = "SMS_TYPE=37 AND LEFT(SEND_TIME, 10)='".$sendDate."' AND TO_ID IN(".$userStr.") AND CONTENT LIKE '%".$task['TASK_NAME']."'";
				deleteOldMessage($where, $taskObj);	
			}
		}

		if((isset($_POST['END_DATE']) && !empty($_POST['END_DATE'])) || (isset($_POST['date']) && empty($dataInfo['END_DATE']))) {
			$task = $taskObj->getTask($_POST['TASK_ID']);
			$taskUser = $taskObj->getUsers($_POST['TASK_ID']);
			$taskUserArr = array();

			if (!empty($taskUser) && isset($taskUser['join'])) {
				foreach ($taskUser['join'] as $k => $v) {
					$taskUserArr[] = $v['USER_ID'];
				}			
			}	

			if (isset($_POST['END_DATE']) && !empty($_POST['END_DATE']) && $_POST['END_DATE'] !== date("Y-m-d", $task['END_DATE'])) {

				if (!empty($taskUserArr)) {
					$participantStr = implode(',', array_unique($taskUserArr));
					$message = $_lang['task_join_message'].$task['TASK_NAME'];
					sendMessageToUser($participantStr, $_POST['END_DATE'], $message);				
				}	

				$message = $_lang['task_create_message'].$task['TASK_NAME'];
				sendMessageToUser($task['USER_ID'], $_POST['END_DATE'], $message);
			}
			
			$taskUserArr[] = $task['USER_ID'];
			$userStr = "'".implode("','", $taskUserArr)."'";
			$sendDate = date("Y-m-d", $task['END_DATE']);
			$where = "SMS_TYPE=37 AND LEFT(SEND_TIME, 10)='".$sendDate."' AND TO_ID IN(".$userStr.") AND CONTENT LIKE '%".$task['TASK_NAME']."'";
			deleteOldMessage($where, $taskObj);
		}

		$taskObj->editTask($dataInfo);
		
		$dataUser = array();
		if (isset($_POST['PARTICIPANT_ID']) && !empty($_POST['PARTICIPANT_ID'])) {
			$task = $taskObj->getTask($_POST['TASK_ID']);
			if ($task['END_DATE'] > 0) {
				$participant = array_filter(explode(',', $_POST['PARTICIPANT_ID']));
				if (in_array($task['USER_ID'], $participant)) {
					unset($participant[array_search($task['USER_ID'], $participant)]);
				}
				$taskUser = $taskObj->getUsers($_POST['TASK_ID']);

				$taskUserArr = array();
				$participantNew = array();
				if (!empty($taskUser) && isset($taskUser['join'])) {
					
					foreach ($taskUser['join'] as $k => $v) {
						$taskUserArr[] = $v['USER_ID'];
					}

					if (in_array($task['USER_ID'], $taskUserArr)) {
						unset($taskUserArr[array_search($task['USER_ID'], $taskUserArr)]);
					}
					
					$participantNew = array_diff($participant, $taskUserArr);
					$participantOld = array_diff($taskUserArr, $participant);

					if (!empty($participantOld)) {
						$userStr = "'".implode("','", $participantOld)."'";
						$sendDate = date("Y-m-d", $task['END_DATE']);
						$where = "SMS_TYPE=37 AND LEFT(SEND_TIME, 10)='".$sendDate."' AND TO_ID IN(".$userStr.") AND CONTENT LIKE '%".$task['TASK_NAME']."'";
						deleteOldMessage($where, $taskObj);					
					}					
				} else {
					$participantNew = $participant;
				}

				$participantStr = implode(',', $participantNew);
				$dateTime = date("Y-m-d", $task['END_DATE']);
				$message = $_lang['task_join_message'].$task['TASK_NAME'];
				sendMessageToUser($participantStr, $dateTime, $message);	
			}
		}

		//添加参与人和分享人
		if(isset($_POST['PARTICIPANT_ID'])||isset($_POST['SHARE_ID'])){
			$userArr  = array(
					1 => $_POST['PARTICIPANT_ID'],
					3 => $_POST['SHARE_ID']
				);

			foreach($userArr as $key=>$val){
				if(!empty($val)){
					$users = explode(",",$val);

					foreach($users as $k=>$v){
						if(!empty($v)){
							$dataUser[] = array(
											'TASK_ID' 	=> $_POST['TASK_ID'],
											'USER_ID' 	=> $v,
											'USER_TYPE' => $key,
										  );
						}
					}
				}
			}
			$taskObj->deleteUsers($_POST['TASK_ID'],$_POST['PARTICIPANT_ID']);
			$taskObj->addUsers($dataUser);			
		}
		//编辑标签
		if(isset($_POST['lablesId'])){
			$dataLables =  array();
			if(!empty($_POST['lablesId'])){
				$lables = explode(",",$_POST['lablesId']);
				foreach($lables as $v){
					if(!empty($v)){
						$dataLables[] = array(
							'TASK_ID' 	=> $_POST['TASK_ID'],
							'TAG_ID' 	=> $v,
							);
					}
				}
			}	
			$taskObj->deleteTaskTags($_POST['TASK_ID']);
			$taskObj->addTaskTags($dataLables);			
		}
		break;	
	case "delAttach":
		$taskObj->attDel($_POST['task_att_id']);
		break;		
	case "getUserInfo":
		echo showUserGeneral($_POST['uid']);
		break;					
	default:
		break;
}

function sendMessageToUser($user, $dateTime, $message) {
	if ($dateTime == date("Y-m-d")) {
		sendSms($_SESSION['LOGIN_USER_ID'], $user, $message, 1, 37);
	} else {
		sendSms($_SESSION['LOGIN_USER_ID'], $user, $message, 1, 37, "", "", "", "", "", $dateTime." 09:00:00");
	}
}

function deleteOldMessage($where, $taskObj) {
	return $taskObj->deleteOldMessage($where);
}

function deleteMessage($taskId, $taskObj) {
	$task = $taskObj->getTask($taskId);
	if ($task['END_DATE'] > 0) {
		$taskUser = $taskObj->getUsers($taskId);
		$taskUserArr = array();

		if (!empty($taskUser) && isset($taskUser['join'])) {
			foreach ($taskUser['join'] as $k => $v) {
				$taskUserArr[] = $v['USER_ID'];
			}			
		}	
		$sendDate = date("Y-m-d", $task['END_DATE']);

		$taskUserArr[] = $task['USER_ID'];
		$userStr = "'".implode("','", $taskUserArr)."'";
		$where = "SMS_TYPE=37 AND LEFT(SEND_TIME, 10)='".$sendDate."' AND TO_ID IN(".$userStr.") AND CONTENT LIKE '%".$task['TASK_NAME']."'";
		return deleteOldMessage($where, $taskObj);	
	}
	return false;
}