(function($) {
	var selectID = "";
	var calendar;
	$.fn.extend({
		Choose : function(settings) {

			var cookieSplit = document.cookie.split(";");
			var lang = "cn";
			for (var i = 0; i < cookieSplit.length; i++) {
				var splitStr = cookieSplit[i].split("=");
				var language = splitStr[0];
				if (splitStr[1] == "en") {
					lang = "en";
					break;
				}
			}
			selectID = "";
			var id = $(this).attr("id");
			$("#" + id).html("").addClass(".main").append("<div></div>");
			var parsedData = $.parseJSON(settings.dataInfor);
			if (parsedData) {
				selectID = parsedData.id;
			}

			if (settings.occupationImgSrc) {
				$("#" + id).children("div").append("&nbsp;&nbsp; <img src='" + settings.occupationImgSrc + "'/>&nbsp;&nbsp;"+EOlang.msgApproved);
			}
			if (settings.accraditationImgSrc) {
				$("#" + id).children("div").append("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <img src='" + settings.accraditationImgSrc + "'/>&nbsp;&nbsp;"+EOlang.msgApprovalIn);
			}
			if (settings.maintainImgSrc) {
				$("#" + id).children("div").append("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <img src='" + settings.maintainImgSrc + "'/> &nbsp;&nbsp;"+EOlang.msgMaintain);
			}
			$("#" + id).append("<div id='mainChoose' style='width:" + settings.width + "%'></div>");
			var occupationEventStr = "";
			var accraditationEventStr = "";
			var maintainEventStr = "";

			if (parsedData && parsedData.apply) {
				$.each(parsedData.apply, function(key, value) {
					if (value.state == 2 || value.state == 4) {
						occupationEventStr += "{id:1" + key + ",title:'" + value.apply_person + "',start:'" + value.begin_time + "',end:'" + value.end_time + "',allDay: false},";
					} else if (value.state == 1) {
						accraditationEventStr += "{id:2" + key + ",title:'" + value.apply_person + "',start:'" + value.begin_time + "',end:'" + value.end_time + "',allDay: false},";
					}
				});
			}

			if (parsedData && parsedData.maintain) {
				$.each(parsedData.maintain, function(key, value) {
					maintainEventStr += "{id:3" + key + ",title:' ',start:'" + value.begin_time + "',end:'" + value.end_time + "',allDay: false},";
				});
			}
			var eventSourcesStr = "[{events:[" + accraditationEventStr.substring(0, accraditationEventStr.length - 1) + "],color:'#FFCC00',editable:false},{events:[" + occupationEventStr.substring(0, occupationEventStr.length - 1) + "],color:'#008000',editable:false},{events:[" + maintainEventStr.substring(0, maintainEventStr.length - 1) + "],color:'#FF0000',editable:false},{events:[{title:'"+settings.user+"',start:'"+settings.get_begin_date+"',end:'"+settings.get_end_date+"',allDay: false}]}]";
			var mySetting = {
				header : {
					left : 'prev,next today',
					center : 'title',
					right : settings.view
				},
				defaultView : settings.defaultView,
				selectable : settings.selectable,
				selectHelper : true,
				axisFormat : 'H',
				firstHour : 8,

				weekends : settings.weekends,
				height : settings.height,
				firstDay : 1,
				timeFormat : 'HH:mm{-HH:mm}',
				select : function(start, end, allDay, jsEvent) {
					calendar.fullCalendar('unselect');
					calendar.fullCalendar('removeEvents', function(event) {
						if (event._id.substring(0, 3) == "_fc") {
							return event._id;
						}
					});
					var title = settings.user;
					if (title) {
						calendar.fullCalendar('renderEvent', {
							title : title,
							start : start,
							end : end,
							allDay : allDay
						}, true);
					}
				},
				editable : true,
				eventSources : eval(eventSourcesStr),
				eventClick : function(calEvent, jsEvent, view) {
					if (settings.eventClick) {
						eval(settings.eventClick + "(" + calEvent.id + ")");
					}
				}
			};
			if (lang == "cn") {
				var language_cn = {
					//monthNamesShort : ['一月', '二月', '三月', '四月', '五月', '六月', '七月', '八月', '九月', '十月', '十一月', '十二月'],
					//monthNames : ['一月份', '二月份', '三月份', '四月份', '五月份', '六月份', '七月份', '八月份', '九月份', '十月份', '十一月份', '十二月份'],
					dayNamesShort : [DateLang['Sun'], DateLang['Mon'], DateLang['Tue'], DateLang['Wed'], DateLang['Thu'], DateLang['Fri'], DateLang['Sat']],
					dayNames : [DateLang['Sunday'], DateLang['Monday'], DateLang['Tuesday'], DateLang['Wednesday'], DateLang['Thursday'], DateLang['Friday'], DateLang['Saturday']],
					allDayText : DateLang['AllDay'],
					buttonText : {
						today : DateLang['Today'],
						week : DateLang['Week'],
						month : DateLang['Month'],
						day : DateLang['CalDay']
					}
				}
				$.extend(mySetting, language_cn);

			}

			calendar = $("#mainChoose").fullCalendar(mySetting);
		},
		GetResult : function() {
			var resultArray = new Array();
			if (selectID != "") {
				var todaysEvents = calendar.fullCalendar('clientEvents');
				var selectEnd = "";
				var selectgStart = "";
				$.each(todaysEvents, function(index, value) {
					if (value.start == "NaN") {
						return false;
					}
					if (value.id == undefined) {
						selectgStart = $.fullCalendar.formatDate(value.start, 'yyyy-MM-dd HH:mm:ss');
						if ($.fullCalendar.formatDate(value.end, 'HH:mm:ss') == "00:00:00") {
							selectEnd = $.fullCalendar.formatDate(value.end, 'yyyy-MM-dd') + " 23:30:00";
						} else if (!value.end) {
							selectEnd = $.fullCalendar.formatDate(value.start, 'yyyy-MM-dd') + " 23:30:00";
						} else {
							selectEnd = $.fullCalendar.formatDate(value.end, 'yyyy-MM-dd HH:mm:ss');
						}
						return false;
					}
				});
				resultArray.push(selectgStart);
				resultArray.push(selectEnd);
				resultArray.push(selectID);
			}
			return resultArray;
		}
	});
})(jQuery)
