<?php
/*
 * 外部邮件API
 */

/*
 * 插入邮件信息
 * @param string $sourceFileName 邮件源文件名称
 * @param int $emailboxID 邮箱ID
 * @param string $fromName 发件人姓名
 * @param string $fromEmail 发件人邮箱地址
 * @param string $subject 邮箱主题
 * @param int $date 邮件日期
 * @param int $isRead 是否已读(0-未读 1-已读)
 * @param string $folder 所属文件夹(inbox-收件箱,sent-发件箱,trash-垃圾箱,draft-草稿箱,数字-自定义文件夹ID)
 * @param int $hasAttachment 是否有附件(0-无 1-有)
 * @param string $to 收件人地址(多个用逗号隔开)
 * @param string $cc 抄送人地址(多个用逗号隔开)
 * @param string $bcc 密送人地址(多个用逗号隔开)
 * @param text $body 邮件主体内容
 * @param string $attachmentID 附件ID字符串(多个用逗号隔开)
 * @param string $attachmentName 附件名称字符串(多个用星号隔开)
 * @param string $userID 用户ID
 * @param string $emailID 邮件ID
 * @param string $toExtend 收件人附加信息
 * @param string $runId 流程ID
 */
function SaveBoxInfor($sourceFileName, $emailboxID, $fromName, $fromEmail, $subject, $date, $isRead, $folder, $hasAttachment, $to, $cc, $bcc, $body, $attachmentID, $attachmentName, $userID, $emailID = "", $toExtend = "", $runId = "") {
	global $connection;

	//保存到草稿箱时，需要先检查是否已保存过，如果已保存则更新，否则插入

	$query = "SELECT COUNT(*) AS CNT FROM `webmail_box` WHERE FOLDER ='draft' AND EMAIL_ID='" . SecurityFilter($emailID) . "' ";
	$result = exequery($connection, $query);
	$count = 0;
	if ($row = mysql_fetch_array($result)) {
		$count = $row["CNT"];
	}

	if ($count == 0) {
		$query = "INSERT INTO `webmail_box`
			(`SOURCE_FILE_NAME`,
			`EMAILBOX_ID`,
			`FROM_NAME`,
			`FROM_EMAIL`,
			`SUBJECT`,
			`DATE`,
			`IS_READ`,
			`FOLDER`,
			`HAS_ATTACHMENT`,
			`TO`,
			`CC`,
			`BCC`,
			`BODY`,
			`ATTACHMENT_ID`,
			`ATTACHMENT_NAME`,
			`USER_ID`,
			`TO_MESSAGE`,
			`FLOW_BODY`)
			VALUES
			('" . SecurityFilter($sourceFileName). "',
			'" . SecurityFilter($emailboxID). "',
			'" . SecurityFilter($fromName). "',
			'" . SecurityFilter($fromEmail). "',
			'" . SecurityFilter($subject). "',
			'" . SecurityFilter($date). "',
			'" . SecurityFilter($isRead). "',
			'" . SecurityFilter($folder). "',
			'" . SecurityFilter($hasAttachment). "',
			'" . SecurityFilter($to). "',
			'" . SecurityFilter($cc). "',
			'" . SecurityFilter($bcc). "',
			'" . SecurityFilter($body). "',
			'" . SecurityFilter($attachmentID). "',
			'" . SecurityFilter($attachmentName). "',
			'" . SecurityFilter($userID). "',
			'" . SecurityFilter($toExtend). "',
			'" . SecurityFilter($runId) . "'
			);";
	} else {

		$query = "UPDATE `webmail_box`
				SET
				`SUBJECT` = '" . SecurityFilter($subject). "',
				`DATE` = '" . SecurityFilter($date). "',
				`TO` = '" . SecurityFilter($to). "',
				`CC` = '" . SecurityFilter($cc). "',
				`BCC` = '" . SecurityFilter($bcc). "',
				`BODY` = '" . SecurityFilter($body). "',
				`FOLDER`='" . SecurityFilter($folder). "',
				`ATTACHMENT_ID` = '" . SecurityFilter($attachmentID). "',
				`ATTACHMENT_NAME` = '" . SecurityFilter($attachmentName). "',
				`EMAILBOX_ID` = '" . SecurityFilter($emailboxID) . "'
				WHERE EMAIL_ID =" . SecurityFilter($emailID);
	}
	if (exequery($connection, $query)) {
		if ($count == 0) {
			return mysql_insert_id();
		} else {
			return $emailID;
		}
	} else {
		return -1;
	}

}

/*
 * 保存到发件箱
 * @param int $emailboxID 邮箱ID
 * @param string $subject 邮件主题
 * @param string $to 收件人
 * @param string $cc 抄送人
 * @param string $bcc 密送人
 * @param string $body 邮件主体内容
 * @param int $date 发送时间 (保存的是时间戳，所以为int类型，便于加快检索速度)
 * @param string $attachmentID 附件ID字符串
 * @param string $attachmentName  附件名称字符串
 * @param int $hasAttachment 是否有附件(0-无 1-有)
 * @param int $flag 发送标识 1-已发送 0-未发送(草稿箱)
 * @param string $userID 用户ID
 * @return int 1-成功 0-失败
 */
function SaveSentEmail($emailboxID, $subject, $to, $cc, $bcc, $body, $date, $attachmentID, $attachmentName, $flag, $userID, $emailID,$all_extend) {
	global $connection;

	if (is_array($to)) {
		$to = implode(";", $to);
	}
	if (is_array($cc)) {
		$cc = implode(";", $cc);
	}
	if (is_array($bcc)) {
		$bcc = implode(";", $bcc);
	}

	$hasAttachment = $attachmentName == '' ? 0 : 1;
	return SaveBoxInfor("", $emailboxID, "", "", $subject, $date, 1, $flag, $hasAttachment, $to, $cc, $bcc, $body, $attachmentID, $attachmentName, $userID, $emailID,$all_extend);
}

/*
 *保存收件箱邮件信息
 * @param int $emailBoxID 邮箱ID
 * @param array  $mailInforArray  邮件信息数组
 * @param string $userID 用户ID
 * @return array 保存邮件结果信息数组 success-插入成功数量 ，failed-插入失败数量
 */
function SaveInboxInfor($emailBoxID, $mailInforArray, $userID) {
	global $connection;

	$successFlag = 0;
	for ($i = 0; $i < count($mailInforArray); $i++) {
		$fromName = $mailInforArray[$i]["from"][0]["name"];

		$fromEmail = $mailInforArray[$i]["from"][0]['mail'];

		$folder = GetFolder($userID, $fromEmail);

		$fromName = $fromName != "" ? $fromName : substr($fromEmail, 0, strpos($fromEmail, "@"));
		$to = "";
		$cc = "";
		for ($j = 0; $j < count($mailInforArray[$i]["to"]); $j++) {
			$to .= $mailInforArray[$i]["to"][$j]["mail"] . ";";
		}

		for ($j = 0; $j < count($mailInforArray[$i]["cc"]); $j++) {
			$cc .= $mailInforArray[$i]["cc"][$j]["mail"] . ";";
		}
		$date = strtotime($mailInforArray[$i]['date']);
		$hasAttachment = eregi("(multipart/mixed|multipart/related|application)", $mailInforArray[$i]["content-type"]) ? 1 : 0;

		//保存日志
		$emailInfor = GetAccountInfor($userID, false, $emailBoxID);
		SaveLog($fromEmail, $emailInfor[0]["EMAIL_ADDRESS"], "receive");

		if (SaveBoxInfor($mailInforArray[$i]["sourceFileName"], $emailBoxID, addslashes($fromName), addslashes($fromEmail), addslashes($mailInforArray[$i]['subject']), $date, 0, $folder, $hasAttachment, $to, $cc, "", "", "", "", $userID)) {
			$successFlag++;
		}
	}
	return array(
		"success" => $successFlag,
		"failed" => count($mailInforArray) - $successFlag
	);
}

/*
 * 获取收取邮件保存到哪个文件夹
 * @param string $userID 用户ID
 * @param string $fromMail 发件人
 * @return string 文件夹ID
 */
function GetFolder($userID, $fromMail) {
	global $connection;
	$query = "SELECT * FROM `webmail_folder`
			WHERE USER_ID ='" . SecurityFilter($userID) . "'
			AND FOLDER_FILTER
			LIKE '%" . SecurityFilter($fromMail) . "%'";
	$result = exequery($connection, $query);
	if ($row = mysql_fetch_array($result)) {
		$folder = $row["FOLDER_ID"];
	} else {
		$folder = "inbox";
	}
	return $folder;
}

/*
 * 获取用户帐号信息
 * @param string $userID 用户ID
 * @param bool $checkCount 是否检查帐号数量
 * @param int $emailboxID  邮箱ID
 * @return int/array  $checkCount=true是返回用户帐号数量  /$checkCount=false返回用户帐号信息
 */
function GetAccountInfor($userID,$checkCount = false, $emailboxID = -1,$mailtype = "") {
	global $connection;
	$query = "SELECT * FROM webmail_emailbox
			WHERE 1=1";

	$mailtype = SecurityFilter($mailtype ? $mailtype : '');
	$query .= " AND MAIL_TYPE = '".SecurityFilter($mailtype)."'";

	if ($userID != "") {
		$query .= " AND USER_ID = '" . SecurityFilter($userID) . "'";
	}
	if ($emailboxID != -1) {
		$query .= " AND EMAILBOX_ID=" . SecurityFilter($emailboxID);
	}
	$query .= " ORDER BY IS_DEFAULT DESC";

	$result = exequery($connection, $query);
	$accountInfor = array();
	while ($row = @mysql_fetch_assoc($result)) {
		array_push($accountInfor, $row);
	}
	if ($checkCount) {
		return count($accountInfor);
	} else {
		return $accountInfor;
	}

}

function GetAccountList($userID,$limitRows,$limitOffset,$checkCount = false, $emailboxID = -1,$mailtype = ""){
	global $connection;
	$query = "SELECT * FROM webmail_emailbox
			WHERE 1=1";
	$queryCount = "SELECT COUNT(*) AS CNT FROM webmail_emailbox
			WHERE 1=1";
	if($mailtype!=""){
		$query.= " AND MAIL_TYPE = '".SecurityFilter($mailtype)."'";
		$queryCount.=" AND MAIL_TYPE = '".SecurityFilter($mailtype)."'";
	}
	if(!$mailtype){
		$query.= " AND MAIL_TYPE = ''";
		$queryCount.= " AND MAIL_TYPE = ''";
	}
	if ($userID != "") {
		$query .= " AND USER_ID = '" . SecurityFilter($userID) . "'";
		$queryCount .= " AND USER_ID = '" . SecurityFilter($userID) . "'";
	}
	if ($emailboxID != -1) {
		$query .= " AND EMAILBOX_ID=" . SecurityFilter($emailboxID);
		$queryCount .= " AND EMAILBOX_ID=" . SecurityFilter($emailboxID);
	}
	$query .= " ORDER BY IS_DEFAULT DESC";
	$query.=" LIMIT ".SecurityFilter($limitOffset).",".SecurityFilter($limitRows);
	$result = exequery($connection, $query);
	$accountInfor = array();
	if ($result) {
		while ($row = mysql_fetch_assoc($result)) {
			$row["PASSWORD"] = decrypt($row["PASSWORD"]);
			array_push($accountInfor, $row);
		}
	}

	$resultcnt=exequery($connection, $queryCount);
	$totalcnt='';
	while ($row = mysql_fetch_assoc($resultcnt)) {
		$totalcnt=$row['CNT'];
	}
	$result = array(
		"totalCount" => $totalcnt,
		'list'=>$accountInfor
	);
	return $result;
}
/*
 * 获取文件夹信息
 * @param string $userID 用户ID
 * @return array 文件夹信息
 */
function GetFolderInfor($userID) {
	global $connection;
	$query = "SELECT * FROM `webmail_folder` WHERE USER_ID ='" . SecurityFilter($userID) . "' ORDER BY FOLDER_ID";
	$result = exequery($connection, $query);
	$folderInfor = array();
	while ($row = mysql_fetch_assoc($result)) {
		array_push($folderInfor, $row);
	}
	return $folderInfor;
}
/*
 * 获取文件夹信息以及包含的邮件数量统计
 */
function getFolderInfoAndCount($uid){
	global $connection;
	$sql = "select f.*,count(b.EMAIL_ID) as count from webmail_folder as f left join webmail_box as b on b.FOLDER = f.FOLDER_ID where f.USER_ID ='".SecurityFilter($uid)."' group by f.FOLDER_ID";

	$result = exequery($connection, $sql);

	$getFolderInfoAndCount = array();
	while($row = @mysql_fetch_assoc($result)){
		if($row['FOLDER_ID'] > 0){
			if($row['count'] > 0){
				$row['count'] = '('.$row['count'].')';
			}else{
				$row['count'] = '';
			}
			if(24 < mb_strlen($row['FOLDER_NAME'])){
				$tmpName = mb_substr($row['FOLDER_NAME'], 0, 24);
				$row['tmp_NAME'] = $tmpName.'...';
			}else{
				$row['tmp_NAME'] = $row['FOLDER_NAME'];
			}
			$getFolderInfoAndCount[$row['FOLDER_ID']] = $row;
		}
	}
	// echo'<pre>';print_r($getFolderInfoAndCount);die;
	return $getFolderInfoAndCount;
}

function getFolderList($userID,$limitRows,$limitOffset){
	global $connection;
	$query = "SELECT * FROM `webmail_folder` WHERE USER_ID ='" . SecurityFilter($userID) . "' ORDER BY FOLDER_ID LIMIT ".SecurityFilter($limitOffset).",".SecurityFilter($limitRows);
	$queryCount="SELECT COUNT(*) AS CNT FROM `webmail_folder` WHERE USER_ID ='" . SecurityFilter($userID) . "' ORDER BY FOLDER_ID";
	$result = exequery($connection, $query);
	$folderInfor = array();
	while ($row = mysql_fetch_assoc($result)) {
		array_push($folderInfor, $row);
	}
	$countresult=exequery($connection,$queryCount);
	$totalcnt='';
	$row = mysql_fetch_assoc($countresult);
	$totalcnt=$row['CNT'];
	return array(
		'totalCount'=>$totalcnt,
		'list'=>$folderInfor
	);
}
/*
 * 获取邮件列表
 * @param string $boxType 列表类型 draft-草稿箱 inbox-收件箱 sent-发件箱 trash-垃圾箱
 * @param int $emailboxID 邮箱ID 当为0,且$boxType='inbox'时，表示获取所有收件箱邮件
 * @param string $userID 用户ID
 * @param int $isRead  是否已读 1-未读,0-已读  仅针对 inbox
 * @param bool $checkCount true-获取邮件数量  false-获取邮件信息
 * @param int $emailID 邮件ID
 * @param array $search 查询条件
 */
function GetList($boxType, $emailboxID, $userID, $isRead = -1, $checkCount = false, $emailID = -1, $search = array()) {
	global $connection;
	if ($checkCount) {
		$query = "SELECT COUNT(*) AS CNT FROM webmail_box WHERE 1=1";
	} else {
		$query = "SELECT * FROM webmail_box WHERE 1=1";
	}

	if ($userID != "") {
		$query .= " AND USER_ID = '" . SecurityFilter($userID) . "'";
	}

	if ($boxType != "") {
		$query .= " AND FOLDER='" . SecurityFilter($boxType) . "'";
	}

	if ($emailboxID != 0) {
		$query .= " AND EMAILBOX_ID = '" . SecurityFilter($emailboxID) . "'";
	}

	if ($isRead != -1) {
		$query .= " AND IS_READ = '" . SecurityFilter($isRead) . "'";
	}

	if ($emailID != -1) {
		$query .= " AND EMAIL_ID = '" . SecurityFilter($emailID) . "'";
	}

	for ($i = 0; $i < count($search); $i++) {
		if ($search[$i]["field"] == "subject") {
			$query .= " AND SUBJECT LIKE '%" . SecurityFilter($search[$i]["value"]) . "%'";
		}
	}

	$query .= " ORDER BY DATE DESC";

	if ($checkCount) {
		$result = exequery($connection, $query);
		if ($row = mysql_fetch_assoc($result)) {
			return $row["CNT"];
		}
	} else {
		if ($emailID == -1) {
			$query = page($query, 15);
		}

		$result = exequery($connection, $query);
		$resultArray = array();
		while ($row = mysql_fetch_assoc($result)) {
			array_push($resultArray, $row);
		}
		return $resultArray;
	}

}


//获取某邮箱账号下的 所有FOLDER的统计
function getEmailCountById($uid, $emailboxID, $searchValue=''){
	global $connection;

	$sql = "select FOLDER, count(EMAIL_ID) as count from webmail_box where 1=1";

	if(!empty($uid)){
		$sql .= " and USER_ID='".SecurityFilter($uid)."'";
	}
	if(!empty($emailboxID)){
		$sql .= " and EMAILBOX_ID='".SecurityFilter($emailboxID)."'";
	}
	if(!empty($searchValue)){
		$sql .= " and '".SecurityFilter($searchValue)."'";
	}
	$sql .= ' group by FOLDER';

	$result = exequery($connection, $sql);
	while($row = @mysql_fetch_assoc($result)){
		$emailCount[$row['FOLDER']] = $row['count'];
	}

	return $emailCount;
}

function getEmailList($userID,$boxType,$emailboxID,$limitRows,$limitOffset,$searchValue){
	global $connection;
	$query = "SELECT * FROM webmail_box WHERE 1=1";
	$queryCount = "SELECT COUNT(*) AS CNT FROM webmail_box WHERE 1=1";
	if ($userID != "") {
		$query .= " AND USER_ID = '" . SecurityFilter($userID) . "'";
		$queryCount .= " AND USER_ID = '" . SecurityFilter($userID) . "'";
	}

	if ($boxType != "") {
		$query .= " AND FOLDER='" . SecurityFilter($boxType) . "'";
		$queryCount .= " AND FOLDER='" . SecurityFilter($boxType) . "'";
	}

	if ($emailboxID != 0) {
		$query .= " AND EMAILBOX_ID = '" . SecurityFilter($emailboxID) . "'";
		$queryCount .= " AND EMAILBOX_ID = '" . SecurityFilter($emailboxID) . "'";
	}

	if ($searchValue!=''){
		$query .= " AND SUBJECT LIKE '%" . SecurityFilter($searchValue) . "%'";
		$queryCount .= " AND SUBJECT LIKE '%" . SecurityFilter($searchValue) . "%'";
	}
	$query .= " ORDER BY DATE DESC";
	$query.=" LIMIT ".SecurityFilter($limitOffset).",".SecurityFilter($limitRows);
	$result = exequery($connection, $query);
	$resultArray = array();
	while ($row = mysql_fetch_assoc($result)) {
		$row['DATE']=date('Y-m-d H:i:s',$row['DATE']);
		array_push($resultArray, $row);
	}
	$countresult =exequery($connection,$queryCount);
	$totalcnt='';
	$row = mysql_fetch_assoc($countresult);
	$totalcnt=$row['CNT'];
	return array(
		'totalCount'=>$totalcnt,
		'list'=>$resultArray
	);
}
/*
 * 根据emailID获取邮件信息
 * @param int  $emailID邮件ID
 */
function GetEmailInforByID($emailID) {
	return GetList("", 0, "", -1, false, $emailID);
}

/*
 * 加密
 * @param string $txt 需要加密的字符串
 * @param string $key 加密key
 */
function encrypt($txt, $key = "eoffice") {
	srand((double)microtime() * 1000000);
	$encrypt_key = md5(rand(0, 32000));
	$ctr = 0;
	$tmp = '';
	for ($i = 0; $i < strlen($txt); $i++) {
		$ctr = $ctr == strlen($encrypt_key) ? 0 : $ctr;
		$tmp .= $encrypt_key[$ctr] . ($txt[$i] ^ $encrypt_key[$ctr++]);
	}
	return base64_encode(passport_key($tmp, $key));
}

/*
 * 解密
 * @param string $txt 需要解密的字符串
 * @param string $key 解密key(需要于加密key一致，否则无法解密)
 */
function decrypt($txt, $key = "eoffice") {
	$txt = passport_key(base64_decode($txt), $key);
	$tmp = '';
	for ($i = 0; $i < strlen($txt); $i++) {
		$md5 = $txt[$i];
		$tmp .= $txt[++$i] ^ $md5;
	}
	return $tmp;
}

/*
 * 加密、解密key解析
 * @param string $txt 需加、解密的字符串
 * @param string $encrypt_key 加、解密key
 */
function passport_key($txt, $encrypt_key) {
	$encrypt_key = md5($encrypt_key);
	$ctr = 0;
	$tmp = '';
	for ($i = 0; $i < strlen($txt); $i++) {
		$ctr = $ctr == strlen($encrypt_key) ? 0 : $ctr;
		$tmp .= $txt[$i] ^ $encrypt_key[$ctr++];
	}
	return $tmp;
}

/*
 * 解析邮件
 * @param array $config 配置信息
 * @param int $emailID 邮件ID
 */
function DecodeMail($config, $emailID) {
	global $connection;

	//根据邮件ID获邮箱名称和本地保存的邮件源文件名称
	$query = "SELECT a.SOURCE_FILE_NAME,b.EMAIL_ADDRESS
FROM `webmail_box` AS a
JOIN webmail_emailbox AS b
ON a.EMAILBOX_ID = b.EMAILBOX_ID
WHERE a.EMAIL_ID = " . SecurityFilter($emailID);
	$result = exequery($connection, $query);
	if ($row = mysql_fetch_assoc($result)) {
		$sourceFileName = $row["SOURCE_FILE_NAME"];
		$emailAddress = $row["EMAIL_ADDRESS"];
		$fileName = $config["userFolder"] . "/" . $emailAddress . "/inbox/" . $sourceFileName . ".eml";
		if (file_exists($fileName)) {
			$mailInfor = file_get_contents($fileName);
			$decodeMail = new UebiMiau_core();
			$decodeMail -> use_html = $config["useHtml"];
			$mailInforArray = $decodeMail -> Decode($mailInfor, $emailID);
			$mailInforArray["date"] = $decodeMail -> build_mime_date($mailInforArray["date"]);

			$newMailInfor = $decodeMail -> fetch_structure($mailInfor);

			$header = $newMailInfor["header"];
			$body = $newMailInfor["body"];

			//缓存附件
			if ($mailInforArray["attachments"]) {
				for ($i = 0; $i < count($mailInforArray["attachments"]); $i++) {
					$decodeMail -> save_orig_attach($header, $body, $mailInforArray["attachments"][$i]["boundary"], $mailInforArray["attachments"][$i]["part"], $config["userFolder"] . "/temp/" . $sourceFileName . "/" . $mailInforArray["attachments"][$i]["name"]);
				}
			}

			$mailInforArray["sourceName"] = $sourceFileName;
			return $mailInforArray;

		} else {
			return false;
		}
	} else {
		return false;
	}

}

/*
 * 邮件日志
 * @param string $from 发件人
 * @param string $to 收件人
 * @param string $type send-发送/receive-接收
 */
function SaveLog($from, $to, $type) {
	$fileName = str_replace("/webroot", "", ROOT_PATH) . "logs/webmail.txt";
	$f = fopen($fileName, 'a');
	$content = "[" . date("Y-m-d H:i:s ") . "] [from:" . $from . "] [to:" . $to . "] [type:" . $type . "]\r\n";
	fwrite($f, $content, strlen($content));
	fclose($f);
}

/*
 * 格式化附件大小
 * @param int $size 附件大小
 * @return string 格式化好的附件大小
 */
function FormatSize($size) {
	if ($size > 1024 * 1024) {
		$size = ceil($size / 1024 / 1024);
		$unit = ' MB';
	}
	//KB
	elseif ($size > 1024) {
		$size = ceil($size / 1024);
		$unit = ' KB';
	}
	//B
	else {
		$unit = ' B';
	}
	return $size . $unit;
}

/*
 * 删除目录
 * @param string $dir 目录名称
 */
function DeleteDirAndFile($dirName) {
	if ($handle = @opendir("$dirName")) {
		while (false !== ($item = readdir($handle))) {
			if ($item != "." && $item != "..") {
				if (is_dir("$dirName/$item")) {
					DeleteDirAndFile("$dirName/$item");
				} else {
					unlink("$dirName/$item");

				}
			}
		}
		closedir($handle);
		if (rmdir($dirName)) {
			return true;
		} else {
			return false;
		}
	}
}
//取出现频率最高的
function getAriseNum($str,$line){
	$str_arr = array();
	if(substr($str,-1) == ";")
	{
		$str = substr($str,0,strlen($str)-1);
	}
	$str_arr = explode(";",$str);
	$str_arr = array_count_values($str_arr);
	arsort($str_arr);
	//$str_arr = array_slice($str_arr,0,$line);

	return $str_arr;
}
//获取拼装常用联系人
function getComLinkman($input,$userId,$privId,$deptId,$line,$type)
{
	global $connection;
	$sql = "SELECT `TO`,`CC`,`BCC`,`TO_MESSAGE` FROM WEBMAIL_BOX WHERE USER_ID = '".SecurityFilter($userId)."' AND TO_MESSAGE !=''";
	$res = exequery ( $connection, $sql );
	while ($row = @mysql_fetch_assoc($res)) {
		$to_str_1.=$row["TO"].";".$row["CC"].";".$row["BCC"].";";
		$toMessageArr = explode("@",$row["TO_MESSAGE"]);
		$to_str_2.=$toMessageArr[0].";".$toMessageArr[1].";".$toMessageArr[2].";";
	}
	if($to_str_1 == "")
		return array();
	$to_array_1 = explode(";",substr($to_str_1,0,strlen($to_str_1)-1));
	$to_array_2 = explode(";",substr($to_str_2,0,strlen($to_str_2)-1));
	//循环一遍，进行地址和附加信息的对应，以修复一个错误
	$to_arise_arr = array();
	for($i=0;$i<count($to_array_1);$i++)
	{
		if($to_array_1[$i]!="")
			$to_arise_arr[] = $to_array_1[$i]."|".$to_array_2[$i];
	}
	//直接排序$to_str_1，得到排序后的收件人地址数组
	$to_array_1_new = getAriseNum(implode(";",$to_arise_arr),$line);
	//取排序后的收件人其余信息数组
	$to_other_array = array();
	foreach($to_array_1_new as $key_1 => $value_1)
	{
		//将排序后的数组的其余信息取出来
		array_push($to_other_array,substr(strstr($key_1,"|"),1,strlen(strstr($key_1,"|"))));
	}
	return getDetailByExtend($to_other_array,$userId,$privId,$deptId,$line);
}
//根据排序后的其余信息数组，拼接上查询出来的其余信息，组成完整数据，返回数组
function getDetailByExtend($to_other_array,$userId,$privId,$deptId,$line)
{
	global $connection;
	//循环收件人其余信息数组，将姓名等信息查询出来，得到新的数组
	$neibu_str      = "";
	$tongxunlu_str  = "";
	$kehu_str       = "";
	$lianxiren_str  = "";
	foreach($to_other_array as $key_2 => $value_2)
	{
		$value_1_array = explode(",",$value_2);
		$search_type   = $value_1_array[0];
		$search_value  = $value_1_array[1];
		$search_type_str.= $search_type.",".$key_2.";";
		switch($search_type)
		{
			case neibu:
				$neibu_str.=$search_value.",";
				break;
			case tongxunlu:
				$tongxunlu_str.=$search_value.",";
				break;
			case kehu:
				$kehu_str.=$search_value.",";
				break;
			case lianxiren:
				$lianxiren_str.=$search_value.",";
				break;
			default:
				break;
		}
	}
	//排序后的收件人其余信息数组转换成字符串
	$customer     = new customer();
	$to_other_str = implode(";",$to_other_array);
	if($neibu_str!="")
	{
		$neibu_replace_str = "neibu,".str_replace(",",";neibu,",substr($neibu_str,0,strlen($neibu_str)-1));
		$sql_1 = "SELECT USER_ID,USER_NAME,DEPT_ID,EMAIL,USER_NAME_PY,USER_NAME_ZM FROM USER WHERE DEPT_ID > 0 AND USER_ID in ('".SecurityFilter(str_replace(",","','",substr($neibu_str,0,strlen($neibu_str)-1)))."')";
		$res_1 = exequery($connection,$sql_1);
		while ($row_1  = mysql_fetch_assoc($res_1)) {
			$USER_ID   = $row_1["USER_ID"];
			$USER_NAME = $row_1["USER_NAME"];
			$DEPT_ID   = $row_1["DEPT_ID"];
			$EMAIL     = $row_1["EMAIL"];
			$NAME_PY   = $row_1["USER_NAME_PY"];
			$NAME_ZM   = $row_1["USER_NAME_ZM"];
			$USER_DEPT = dept_small_name($DEPT_ID);
			$neibu_new = $USER_NAME.",".$EMAIL.",".$USER_DEPT;
			$to_other_str = str_replace("neibu,".$USER_ID,$neibu_new.",neibu,".$USER_ID.",".$NAME_PY.",".$NAME_ZM,$to_other_str);
			$neibu_replace_str = str_replace("neibu,".$USER_ID.";","",$neibu_replace_str.";");
		}
		$neibu_replace_str = trim($neibu_replace_str,";");
		if($neibu_replace_str != "")
		{
			foreach(explode(";",$neibu_replace_str) as $neibu_key_re => $neibu_val_re)
			{
				$to_other_str = str_replace($neibu_val_re.";","",$to_other_str.";");
			}
		}
	}
	if($tongxunlu_str!="")
	{
		$tongxunlu_replace_str = "tongxunlu,".str_replace(",",";tongxunlu,",substr($tongxunlu_str,0,strlen($tongxunlu_str)-1));
		$sql_2 = "SELECT * FROM address_group adg, address addd
					 WHERE adg.`GROUP_ID` = addd.`A10`
					 AND (ADD_ID in ('".SecurityFilter(str_replace(",","','",substr($tongxunlu_str,0,strlen($tongxunlu_str)-1)))."'))
					 AND (
							( adg.`group_user` LIKE '%".SecurityFilter($userId)."%' OR adg.group_dept = 'ALL_DEPT'
							 OR((INStr(adg.GROUP_DEPT,',".SecurityFilter($deptId).",')>0 OR INStr(adg.GROUP_DEPT,'".SecurityFilter($deptId).",')=1)
							 OR(INStr(adg.GROUP_PRIV,',".SecurityFilter($privId).",')>0 OR INStr(adg.GROUP_PRIV,'".SecurityFilter($privId).",')=1)
							 OR(InStr(adg.GROUP_USER,'".SecurityFilter($userId).",')>0 OR INStr(adg.GROUP_USER,'".SecurityFilter($userId).",')=1))
							)
							OR (addd.`A11` = '".SecurityFilter($userId)."' AND add_type = '2')
						 )";
		$res_2 = exequery($connection,$sql_2);
		while ($row_2  = mysql_fetch_assoc($res_2)) {
			$ADD_ID    = $row_2["ADD_ID"];
			$NAME      = $row_2["A1"];
			$EMAIL     = $row_2["A6"];
			$A10       = $row_2["A10"];
			$NAME_PY   = $row_2["NAME_PINYIN"];
			$NAME_ZM   = $row_2["NAME_INDEX"];
			$GROUP     = getAddressGroupName($A10);
			$tongxunlu_new = $NAME.",".$EMAIL.",".$GROUP;
			$to_other_str = str_replace("tongxunlu,".$ADD_ID,$tongxunlu_new.",tongxunlu,".$ADD_ID.",".$NAME_PY.",".$NAME_ZM,$to_other_str);
			$tongxunlu_replace_str = str_replace("tongxunlu,".$ADD_ID.";","",$tongxunlu_replace_str.";");
		}
		$tongxunlu_replace_str = trim($tongxunlu_replace_str,";");
		if($tongxunlu_replace_str != "")
		{
			foreach(explode(";",$tongxunlu_replace_str) as $tongxunlu_key_re => $tongxunlu_val_re)
			{
				$to_other_str = str_replace($tongxunlu_val_re.";","",$to_other_str.";");
			}
		}
	}
	if($kehu_str!="")
	{
		$kehu_replace_str = "kehu,".SecurityFilter(str_replace(",",";kehu,",substr($kehu_str,0,strlen($kehu_str)-1)));
		$CrmSearchParam = " AND CUSTOMER_ID in ('".SecurityFilter(str_replace(",","','",substr($kehu_str,0,strlen($kehu_str)-1)))."')";
		$sql_3 = $customer->get_customer_view_str("",$userId,$CrmSearchParam);
		$res_3 = exequery($connection,$sql_3);
		while ($row_3  = mysql_fetch_assoc($res_3)) {
			$CUSTOMER_ID   = $row_3["CUSTOMER_ID"];
			$CUSTOMER_NAME = $row_3["CUSTOMER_NAME"];
			$CUSTOMER_TYPE = $row_3["CUSTOMER_TYPE"];
			$EMAIL         = $row_3["EMAIL"];
			$NAME_PY       = $row_3["CUSTOMER_NAME_PY"];
			$NAME_ZM       = $row_3["CUSTOMER_NAME_ZM"];
			$CUSTOMER_SORT = get_info(4,$CUSTOMER_TYPE,1);
			$kehu_new      = $CUSTOMER_NAME.",".$EMAIL.",".$CUSTOMER_SORT;
			$to_other_str  = str_replace("kehu,".$CUSTOMER_ID,$kehu_new.",kehu,".$CUSTOMER_ID.",".$NAME_PY.",".$NAME_ZM,$to_other_str);
			$kehu_replace_str = str_replace("kehu,".$CUSTOMER_ID.";","",$kehu_replace_str.";");
		}
		$kehu_replace_str = trim($kehu_replace_str,";");
		if($kehu_replace_str != "")
		{
			foreach(explode(";",$kehu_replace_str) as $kehu_key_re => $kehu_val_re)
			{
				$to_other_str = str_replace($kehu_val_re.";","",$to_other_str.";");
			}
		}
	}
	if($lianxiren_str!="")
	{
		$lianxiren_replace_str = "lianxiren,".SecurityFilter(str_replace(",",";lianxiren,",substr($lianxiren_str,0,strlen($lianxiren_str)-1)));
		$LinSearchParam = " AND LINKMAN_ID in ('".SecurityFilter(str_replace(",","','",substr($lianxiren_str,0,strlen($lianxiren_str)-1)))."')";
		$sql_4  = $customer->get_linkman_str_with_preview("",$LinSearchParam);
		$res_4 = exequery($connection,$sql_4);
		while ($row_4  = mysql_fetch_assoc($res_4)) {
			$LINKMAN_ID    = $row_4["LINKMAN_ID"];
			$LINKMAN_NAME  = $row_4["LINKMAN_NAME"];
			$CUSTOMER_ID   = $row_4["CUSTOMER_ID"];
			$EMAIL         = $row_4["EMAIL"];
			$NAME_PY       = $row_4["LINKMAN_NAME_PY"];
			$NAME_ZM       = $row_4["LINKMAN_NAME_ZM"];
			$CUSTOMER_NAME = getLinkmanCustomer($CUSTOMER_ID);
			$lianxiren_new = $LINKMAN_NAME.",".$EMAIL.",".$CUSTOMER_NAME;
			$to_other_str  = str_replace("lianxiren,".$LINKMAN_ID,$lianxiren_new.",lianxiren,".$LINKMAN_ID.",".$NAME_PY.",".$NAME_ZM,$to_other_str);
			$lianxiren_replace_str = str_replace("lianxiren,".$LINKMAN_ID.";","",$lianxiren_replace_str.";");
		}
		$lianxiren_replace_str = trim($lianxiren_replace_str,";");
		if($lianxiren_replace_str != "")
		{
			foreach(explode(";",$lianxiren_replace_str) as $lianxiren_key_re => $lianxiren_val_re)
			{
				$to_other_str = str_replace($lianxiren_val_re.";","",$to_other_str.";");
			}
		}
	}
	if($line != "")
	{
		$re_end_arr = array_slice(explode(";",$to_other_str),0,$line);
		return $re_end_arr;
	}
	else
	{
		return $to_other_str;
	}
}
//获取内部人员
function getInsider($input,$type)
{
	global $connection;
	if($type == "show")
	{
		$sql = "SELECT USER_NAME_PY,USER_ID,USER_NAME,DEPT_ID,EMAIL FROM USER WHERE DEPT_ID > 0 ORDER BY USER_NAME_PY ASC";
	}
	else
	{
		$sql = "SELECT USER_NAME_PY,USER_ID,USER_NAME,DEPT_ID,EMAIL FROM USER WHERE DEPT_ID > 0 AND (USER_NAME LIKE '%".SecurityFilter($input)."%' OR USER_NAME_PY LIKE '%".SecurityFilter($input)."%' OR USER_NAME_ZM LIKE '%".SecurityFilter($input)."%' OR EMAIL LIKE '%".SecurityFilter($input)."%') ORDER BY USER_NAME_PY ASC";
	}
	$res = exequery ( $connection, $sql );
	$py_tips    = "";
	$res_array  = array();
	$res_py_array  = array();
	while ($row = mysql_fetch_assoc($res)) {
		$USER_ID   = $row["USER_ID"];
		$USER_NAME = $row["USER_NAME"];
		$DEPT_ID   = $row["DEPT_ID"];
		$EMAIL     = $row["EMAIL"];
		$USER_DEPT = dept_small_name($DEPT_ID);
		$USER_PY   = $row["USER_NAME_PY"];
		$py_first_word = strtoupper(substr($USER_PY,0,1));
		if($py_tips!=$py_first_word)
		{
			$py_tips = $py_first_word;
			array_push($res_array,$py_tips);
			array_push($res_py_array,$py_tips);
			array_push($res_array,$USER_NAME.",".$EMAIL.",".$USER_DEPT.","."neibu,".$USER_ID);
		}
		else if($py_tips==$py_first_word)
		{
			array_push($res_array,$USER_NAME.",".$EMAIL.",".$USER_DEPT.","."neibu,".$USER_ID);
		}
	}
	$res_all_arr[py] = $res_py_array;
	$res_all_arr[val] = $res_array;
	return $res_all_arr;
}
//获取通讯录人员
function getAddress($input,$USER_ID,$PRIV_ID,$DEPT_ID,$type)
{
	global $connection;
	$res_all_arr[py]  = "";
	$res_all_arr[val] = "";
	$pubAddressFlag = isThisPri($_SESSION['LOGIN_FUNC_STR'],isMenuPri('25,'));
	$perAddressFlag = isThisPri($_SESSION['LOGIN_FUNC_STR'],isMenuPri('23,'));
	$conditionStr   = "";
	if($pubAddressFlag)
	{
		$conditionStr .= " (adg.`group_user` LIKE '%".SecurityFilter($USER_ID)."%' OR adg.group_dept = 'ALL_DEPT'
							 OR((INStr(adg.GROUP_DEPT,',".SecurityFilter($DEPT_ID).",')>0 OR INStr(adg.GROUP_DEPT,'".SecurityFilter($DEPT_ID).",')=1)
							 OR(INStr(adg.GROUP_PRIV,',".SecurityFilter($PRIV_ID).",')>0 OR INStr(adg.GROUP_PRIV,'".SecurityFilter($PRIV_ID).",')=1)
							 OR(InStr(adg.GROUP_USER,'".SecurityFilter($USER_ID).",')>0 OR INStr(adg.GROUP_USER,'".SecurityFilter($USER_ID).",')=1))
							)";
		if($perAddressFlag)
		{
			$conditionStr .= " OR (addd.`A11` = '".SecurityFilter($USER_ID)."' AND add_type = '2')";
		}
	}
	else
	{
		if($perAddressFlag)
		{
			$conditionStr .= " addd.`A11` = '".SecurityFilter($USER_ID)."' AND add_type = '2'";
		}
		else
		{
			return $res_all_arr;
		}
	}
	if($type == "show")
	{
		$query = "SELECT * FROM address_group adg, address addd
					 WHERE adg.`GROUP_ID` = addd.`A10`
					 AND (
							( ".$conditionStr." )
						 )
						 ORDER BY NAME_PINYIN ASC";
	}
	else
	{
		$query = "SELECT * FROM address_group adg, address addd
					 WHERE adg.`GROUP_ID` = addd.`A10`
					 AND (A1 LIKE '%".SecurityFilter($input)."%' OR NAME_PINYIN LIKE '%".SecurityFilter($input)."%' OR NAME_INDEX LIKE '%".SecurityFilter($input)."%' OR A6 LIKE '%".SecurityFilter($input)."%')
					 AND (
							( ".$conditionStr." )
						 )
						 ORDER BY NAME_PINYIN ASC";
	}
	$res = exequery ( $connection, $query );
	$py_tips    = "";
	$res_array  = array();
	$res_py_array  = array();
	while ($row = mysql_fetch_assoc($res)) {
		$ADD_ID    = $row["ADD_ID"];
		$NAME      = $row["A1"];
		$EMAIL     = $row["A6"];
		$A10       = $row["A10"];
		$GROUP     = getAddressGroupName($A10);
		if($row["NAME_INDEX"] == "" && $row["NAME_PINYIN"] != "")
		{
			$py_first_word = strtoupper(substr(trim($row["NAME_PINYIN"]),0,1));
		}
		else
		{
			$py_first_word = strtoupper($row["NAME_INDEX"]);
		}
		if($py_tips!=$py_first_word)
		{
			$py_tips = $py_first_word;
			array_push($res_array,$py_tips);
			array_push($res_py_array,$py_tips);
			array_push($res_array,$NAME.",".$EMAIL.",".$GROUP.","."tongxunlu,".$ADD_ID);
		}
		else if($py_tips==$py_first_word)
		{
			array_push($res_array,$NAME.",".$EMAIL.",".$GROUP.","."tongxunlu,".$ADD_ID);
		}
	}
	$res_all_arr[py] = $res_py_array;
	$res_all_arr[val] = $res_array;
	return $res_all_arr;
}
//获取客户联系人
function getCusLink($input,$USER_ID,$type)
{
	global $connection;
	$res_all_arr[py]  = "";
	$res_all_arr[val] = "";
	$cusFlag = isThisPri($_SESSION['LOGIN_FUNC_STR'],isMenuPri('502,'));
	if(!$cusFlag)
		return $res_all_arr;
	$customer = new customer();
	if($type == "show")
	{
		$customer_sql = $customer->get_customer_view_str("",$USER_ID);
		$linkman_sql  = $customer->get_linkman_str_with_preview();
	}
	else
	{
		$CrmSearchParam = " AND (c.CUSTOMER_NAME LIKE '%".SecurityFilter($input)."%' OR c.CUSTOMER_NAME_PY LIKE '%".SecurityFilter($input)."%' OR c.CUSTOMER_NAME_ZM LIKE '%".SecurityFilter($input)."%' OR c.EMAIL LIKE '%".SecurityFilter($input)."%') ";
		$LinSearchParam = " AND (l.LINKMAN_NAME LIKE '%".SecurityFilter($input)."%' OR l.LINKMAN_NAME_PY LIKE '%".SecurityFilter($input)."%' OR l.LINKMAN_NAME_ZM LIKE '%".SecurityFilter($input)."%' OR l.EMAIL LIKE '%".SecurityFilter($input)."%') ";
		$customer_sql = $customer->get_customer_view_str("",$USER_ID,$CrmSearchParam);
		$linkman_sql  = $customer->get_linkman_str_with_preview("",$LinSearchParam);
	}
	$customer_res = exequery ( $connection, $customer_sql );
	$all_data_arr = array();
	while ($customer_row = mysql_fetch_assoc($customer_res)) {
		$all_data_arr[$customer_row["CUSTOMER_NAME"].",".$customer_row["EMAIL"].",".get_info(4,$customer_row["CUSTOMER_TYPE"],1).","."kehu,".$customer_row["CUSTOMER_ID"]] = $customer_row["CUSTOMER_NAME_PY"]."1,".$customer_row["CUSTOMER_ID"];
	}
	$linkman_res = exequery ( $connection, $linkman_sql );
	while ($linkman_row = mysql_fetch_assoc($linkman_res)) {
		$all_data_arr[$linkman_row["LINKMAN_NAME"].",".$linkman_row["EMAIL"].",".$linkman_row["CUSTOMER_NAME"].","."lianxiren,".$linkman_row["LINKMAN_ID"]] = $linkman_row["LINKMAN_NAME_PY"]."2,".$linkman_row["LINKMAN_ID"];
	}
	asort($all_data_arr);
	$py_tips    = "";
	$res_array  = array();
	$res_py_array  = array();
	foreach(array_flip($all_data_arr) as $key => $value)
	{
		$py_first_word = strtoupper(substr($key,0,1));
		if($py_tips!=$py_first_word)
		{
			$py_tips = $py_first_word;
			array_push($res_array,$py_tips);
			array_push($res_py_array,$py_tips);
			array_push($res_array,$value);
		}
		else if($py_tips==$py_first_word)
		{
			array_push($res_array,$value);
		}
	}
	$res_all_arr[py] = $res_py_array;
	$res_all_arr[val] = $res_array;
	return $res_all_arr;
}
//查询通讯录里有没有一样的数据,如果有:返回id,没有:返回空
function getExtendByAddress($address,$USER_ID,$PRIV_ID,$DEPT_ID)
{
	global $connection;
	$query = "SELECT ADD_ID FROM address_group adg, address addd
					 WHERE adg.`GROUP_ID` = addd.`A10`
					 AND (
							( adg.`group_user` LIKE '%".SecurityFilter($USER_ID)."%' OR adg.group_dept = 'ALL_DEPT'
							 OR((INStr(adg.GROUP_DEPT,',".SecurityFilter($DEPT_ID).",')>0 OR INStr(adg.GROUP_DEPT,'".SecurityFilter($DEPT_ID).",')=1)
							 OR(INStr(adg.GROUP_PRIV,',".SecurityFilter($PRIV_ID).",')>0 OR INStr(adg.GROUP_PRIV,'".SecurityFilter($PRIV_ID).",')=1)
							 OR(InStr(adg.GROUP_USER,'".SecurityFilter($USER_ID).",')>0 OR INStr(adg.GROUP_USER,'".SecurityFilter($USER_ID).",')=1))
							)
							OR (addd.`A11` = '".SecurityFilter($USER_ID)."' AND add_type = '2')
						 )
					 AND A1 = '".SecurityFilter($address)."' AND A6 = '".SecurityFilter($address)."'
					 ORDER BY NAME_PINYIN ASC";
	$res = exequery ( $connection, $query );
	while ($row = mysql_fetch_assoc($res)) {
		$ADD_ID = $row["ADD_ID"];
	}
	return $ADD_ID;
}

function getEmailboxId($userMail, $userId){
	global $connection;

	$sql = "select EMAILBOX_ID from webmail_emailbox where EMAIL_ADDRESS='".SecurityFilter($userMail)."' and USER_ID='".SecurityFilter($userId)."'";
	$result = exequery($connection, $sql);

	if ($row = mysql_fetch_assoc($result)){
		return $row['EMAILBOX_ID'];
	}

	return '';
}

function haveEmailboxMails($emailboxId, $userId){
	global $connection;

	$sql = "select * from webmail_box where EMAILBOX_ID=".SecurityFilter($emailboxId)." and FOLDER='inbox' and USER_ID='".SecurityFilter($userId)."' limit 1";
	$query = exequery($connection, $sql);

	if ($row = mysql_fetch_assoc($query)){
		return true;
	}

	return false;
}

?>