<?php
/*
 * 发送邮件
 * @param Array $sendParam 发送邮件参数
 * @param String $to 收件人
 * @param String $cc 抄送
 * @param String $bcc 密送
 * @param String $subject 邮件主题
 * @param String $body 邮件内容
 * @param Array $attachment 附件
 */
function SendEmail($sendParam, $to, $subject, $body, $cc, $bcc, $attachment) {
	$sendMailer = new PHPMailer(true);
	$sendMailer -> SetLanguage('cn');
	$sendMailer -> IsSMTP();

	$sendMailer -> SMTPAuth = $sendParam['IS_SMTP_AUTH'];
	$sendMailer -> Host = $sendParam['SMTP_SERVER'];
	$sendMailer -> Port = $sendParam['SMTP_PORT'];

	if ($sendParam['IS_SSL_AUTH']) {
		$sendMailer -> SMTPSecure = "ssl";
	}

	$sendMailer -> CharSet = "UTF-8";

	$sendMailer -> Username = $sendParam['USER_NAME'];

	$sendMailer -> Password = decrypt($sendParam['PASSWORD']);
	$sendMailer -> SetFrom($sendParam['EMAIL_ADDRESS'], $sendParam['NICKNAME']);
	$sendMailer -> Subject = $subject;

	$sendMailer -> AltBody = "This is the body when user views in plain text format";

	$sendMailer -> WordWrap = 50;

	$sendMailer -> MsgHTML($body);

	//添加收件人
	if (is_array($to)) {
		for ($i = 0; $i < count($to); $i++) {
			$sendMailer -> AddAddress($to[$i]);
		}
	}

	//添加收件人
	if (is_array($cc)) {
		for ($i = 0; $i < count($cc); $i++) {
			$sendMailer -> AddCC($cc[$i]);
		}
	}

	//添加密送人
	if (is_array($bcc)) {
		for ($i = 0; $i < count($bcc); $i++) {
			$sendMailer -> AddBCC($bcc[$i]);
		}
	}

	//添加附件
	if (is_array($attachment)) {
		for ($i = 0; $i < count($attachment); $i++) {
			$sendMailer -> AddAttachment($attachment[$i]['attachmentFullName'], $attachment[$i]['attachmentName']);
		}
	}

	$sendMailer -> IsHTML(true);

	try {
		return $sendMailer -> Send();
	} catch (Exception $e) {
		return false;
	}
}
?>