<?php

include_once ("api/attend.class.php");

class Attendance {

    private $_userId;
    private $_Attend;
    private $MOBILE_SIGN_START;
    private $MOBILE_SIGN_RADIUS;

    public function __construct($uid) {

        $this->_userId = $uid;
        $this->_Attend = new attend();
        $signStrategy = $this->getStrategy();
        $this->MOBILE_SIGN_START = $signStrategy['MOBILE_SIGN_START'];
        $this->MOBILE_SIGN_RADIUS = $signStrategy['MOBILE_SIGN_RADIUS'];
    }

    /**
     * 签到
     */
    public function signIn() {
        $latlng = request_var('latlng');
        $addr = request_var('addr');

        $userId = $this->_userId;
        $isNoPointer = $this->isNoPointerAttend(); //判断非定点 非定点 1

        if (!$isNoPointer) {
            $latlngCheck = $this->latlngCheck($latlng);
            if ($latlngCheck == 0) {
                $showSignButton = array(
                    'result' => 'Failure',
                    'signName' => "签到",
                    'error' => "您不在考勤点范围内"
                );
                echo json_encode($showSignButton);
                exit;
            }
        }


        $userRow = $this->getUserInfo();
        $userInfo = array(
            'UserId' => $userId,
            'DepyId' => $userRow['DEPT_ID'],
            'PrivId' => $userRow['USER_PRIV'],
            'LoginCheck' => 'in'
        );
        $dutyInfo = $this->_Attend->GetLoginInOut($userInfo);
        if ($dutyInfo) {
            $this->latlngRecord($latlng, $addr); //记录用户移动位置
            $showSignButton = array(
                'result' => 'success',
                'signName' => "签退",
                'msg' => "签到成功" . ',' . "您本次的签到时间为" . date('Y-m-d') . ' ' . $dutyInfo['LoginInTime'],
                'signInTime' => "签到时间：" . date('Y-m-d') . ' ' . $dutyInfo['LoginInTime']
            );
            echo json_encode($showSignButton);
        } else {
            $params = array('thisDay' => date("Y-m-d", time()), 'userId' => $userId);
            $dutyMsg = $this->_Attend->getDutyDayMessage($params);
            if ($dutyMsg) {
                $showSignButton = array(
                    'result' => 'Failure',
                    'signName' => "签退",
                    'error' => "对不起,您已签到"
                );
            } else {
                $showSignButton = array(
                    'result' => 'Failure',
                    'signName' => "签到",
                    'error' => "签到失败"
                );
            }
            echo json_encode($showSignButton);
        }
    }

    /**
     * 签退
     */
    public function signOut() {

        $latlng = request_var('latlng');
        $addr = request_var('addr');
        $userId = $this->_userId;
        $isNoPointer = $this->isNoPointerAttend();
        if (!$isNoPointer) {
            $latlngCheck = $this->latlngCheck($latlng);
            if ($latlngCheck == 0) {
                $showSignButton = array(
                    'result' => 'Failure',
                    'signName' => "签退",
                    'error' => "您不在考勤点范围内"
                );
                echo json_encode($showSignButton);
                exit;
            }
        }

        $userRow = $this->getUserInfo();
        $userInfo = array(
            'UserId' => $userId,
            'DepyId' => $userRow['DEPT_ID'],
            'PrivId' => $userRow['USER_PRIV'],
            'LoginCheck' => 'out'
        );
        $dutyInfo = $this->_Attend->GetLoginInOut($userInfo);
        if ($dutyInfo) {
            $this->latlngRecord($latlng, $addr, 'signOut'); //记录用户移动位置

            $showSignButton = array(
                'result' => 'success',
                'signName' => "签退",
                'msg' => "您本次考勤的时间为:" . date('Y-m-d') . ' ' . $dutyInfo['LoginOutTime'],
                'signOutTime' => "上次签退：" . date('Y-m-d') . ' ' . $dutyInfo['LoginOutTime']
            );
            echo json_encode($showSignButton);
        } else {
            $showSignButton = array(
                'result' => 'Failure',
                'signName' => "签退",
                'error' => "考勤失败"
            );
            echo json_encode($showSignButton);
        }
    }

    /**
     * 外勤签到
     */

    /**
     * 签到
     */
    public function dutyIn() {
        $latlng = request_var('latlng');
        $addr = request_var('addr');
        $userId = $this->_userId;
        $img = request_var('img');
        $info = request_var('info');



        $userRow = $this->getUserInfo();
        $userInfo = array(
            'UserId' => $userId,
            'DepyId' => $userRow['DEPT_ID'],
            'PrivId' => $userRow['USER_PRIV'],
            'LoginCheck' => 'in'
        );
        $dutyInfo = $this->_Attend->GetSignOut($userInfo);
        if ($dutyInfo) {
            $this->latlngRecord($latlng, $addr, 'signIn', $img, $info, 1); //记录用户移动位置

            $showSignButton = array(
                'result' => 'success',
                'signName' => "签退",
                'msg' => "签到成功" . ',' . "您本次的签到时间为" . date('Y-m-d') . ' ' . $dutyInfo['LoginInTime'],
                'signInTime' => "签到时间：" . date('Y-m-d') . ' ' . $dutyInfo['LoginInTime']
            );
            echo json_encode($showSignButton);
        } else {
            $params = array('thisDay' => date("Y-m-d", time()), 'userId' => $userId);
            $dutyMsg = $this->_Attend->getDutyDayMessage($params);
            if ($dutyMsg) {
                $showSignButton = array(
                    'result' => 'Failure',
                    'signName' => "签退",
                    'error' => "对不起,您已签到"
                );
            } else {
                $showSignButton = array(
                    'result' => 'Failure',
                    'signName' => "签到",
                    'error' => "签到失败"
                );
            }
            echo json_encode($showSignButton);
        }
    }

    /**
     * 签退
     */
    public function dutyOut() {

        $latlng = request_var('latlng');
        $addr = request_var('addr');
        $userId = $this->_userId;
        $img = request_var('img');
        $info = request_var('info');
        //1111
        $userRow = $this->getUserInfo();

        $userInfo = array(
            'UserId' => $userId,
            'DepyId' => $userRow['DEPT_ID'],
            'PrivId' => $userRow['USER_PRIV'],
            'LoginCheck' => 'out'
        );
        $dutyInfo = $this->_Attend->GetSignOut($userInfo);
        if ($dutyInfo) {
            $this->latlngRecord($latlng, $addr, 'signOut', $img, $info, 1); //记录用户移动位置

            $showSignButton = array(
                'result' => 'success',
                'signName' => "签退",
                'msg' => "您本次考勤的时间为:" . date('Y-m-d') . ' ' . $dutyInfo['LoginOutTime'],
                'signOutTime' => "上次签退：" . date('Y-m-d') . ' ' . $dutyInfo['LoginOutTime']
            );
            echo json_encode($showSignButton);
        } else {
            $showSignButton = array(
                'result' => 'Failure',
                'signName' => "签退",
                'error' => "考勤失败"
            );
            echo json_encode($showSignButton);
        }
    }

    /**
     * 是否显示考勤按钮
     * 并且判断显示签到，还是签退
     * isEnableCheckin 1为显示，0为隐藏。
     * isCheckin 0为签到，1为签退
     */
    public function showSign() {

        $isShow = $this->MOBILE_SIGN_START;
        $isEnableCheckin = '0';
        if ($isShow == 1) {
            $isEnableCheckin = '1';
        }
        $userId = $this->_userId;
        $params = array('thisDay' => date("Y-m-d", time()), 'userId' => $userId);
        $dutyMsg = $this->_Attend->getDutyDayMessage($params);
        $isCheckin = "0";
        $signName = "签到";
        if ($dutyMsg) {
            $isCheckin = "1";
            $signName = "签退";
        }
        $showSignButton = array('isCheckin' => $isCheckin, 'isEnableCheckin' => $isEnableCheckin, 'signName' => $signName);
        echo json_encode($showSignButton);
    }

    /**
     * 获取考勤策略
     * @global type $connection
     * @return type
     */
    public function getStrategy() {
        global $connection;
        $sql = 'SELECT * FROM sys_para';
        $rs = exequery($connection, $sql);
        $signStrategy = array();
        while ($row = mysql_fetch_array($rs)) {
            if ($row['PARA_NAME'] == 'MOBILE_SIGN_START') {
                $signStrategy['MOBILE_SIGN_START'] = intval($row['PARA_VALUE']);
            } else if ($row['PARA_NAME'] == 'MOBILE_SIGN_RADIUS') {
                $signStrategy['MOBILE_SIGN_RADIUS'] = intval($row['PARA_VALUE']);
            }
        }
        return $signStrategy;
    }

    /**
     * 求两个已知经纬度之间的距离,单位为米
     * @param lng1,lng2 经度
     * @param lat1,lat2 纬度
     * @return float 距离，单位米
     * @author www.Alixixi.com
     * */
    public function getDistance($lng1, $lat1, $lng2, $lat2) {
        //将角度转为狐度
        $radLat1 = deg2rad($lat1); //deg2rad()函数将角度转换为弧度
        $radLat2 = deg2rad($lat2);
        $radLng1 = deg2rad($lng1);
        $radLng2 = deg2rad($lng2);
        $a = $radLat1 - $radLat2;
        $b = $radLng1 - $radLng2;
        $s = 2 * asin(sqrt(pow(sin($a / 2), 2) + cos($radLat1) * cos($radLat2) * pow(sin($b / 2), 2))) * 6378.137 * 1000;
        return $s;
    }

    /**
     * 获取考勤点列表
     * @global type $connection
     * @return array
     */
    public function getAttendPoints() {
        global $connection;
        $userRow = $this->getUserInfo();
        $userId = $this->_userId;
        $privId = $userRow['USER_PRIV'];
        $deptId = $userRow['DEPT_ID'];
        $query = "SELECT * FROM attend_points ";
        $query .= " WHERE all_member=1 ";
        $query .= " OR (all_member=0 "
                . " AND ((INStr(dept_id,',".SecurityFilter($deptId).",')>0 OR INStr(dept_id,'".SecurityFilter($deptId).",')=1))"
                . " OR ((INStr(user_id,',".SecurityFilter($userId).",')>0 OR INStr(user_id,'".SecurityFilter($userId).",')=1))"
                . " OR ((INStr(priv_id,',".SecurityFilter($privId).",')>0 OR INStr(priv_id,'".SecurityFilter($privId).",')=1)))";
        $query .= " ORDER BY create_time DESC";
        $rs = exequery($connection, $query);
        $list = array();
        while ($row = mysql_fetch_array($rs)) {
            array_push($list, $row);
        }
        return $list;
    }

    /**
     * 获取用户信息
     * @global type $connection
     * @return type
     */
    private function getUserInfo() {
        global $connection;
        $userId = $this->_userId;
        $userQuery = 'SELECT USER_ID,USER_ACCOUNTS,USER_NAME,USER_PRIV,DEPT_ID FROM user WHERE USER_ID=\'' . SecurityFilter($userId) . '\'';
        $userRs = exequery($connection, $userQuery);
        $userRow = mysql_fetch_array($userRs);
        return $userRow;
    }

    /**
     * 考勤范围检查
     * @param type $latlng
     * @return int
     */
    private function latlngCheck($latlng) {
        $latlngCheck = 0;
        $attendPoint = $this->getAttendPoints();
        $latlngArray = explode(',', $latlng);
        foreach ($attendPoint as $key => $value) {
            $pointLatlng = $value['point_latlng'];
            $pointLatlngArray = explode(',', $pointLatlng);
            $length = $this->getDistance($latlngArray[1], $latlngArray[0], $pointLatlngArray[0], $pointLatlngArray[1]);
            if ($length <= $this->MOBILE_SIGN_RADIUS) {
                $latlngCheck = 1;
                break;
            }
        }
        return $latlngCheck;
    }

    /**
     * 记录用户移动坐标
     * @param type $latlng
     */
    public function latlngRecord($latlng, $addr, $type = 'signIn', $img = "", $info = "", $flag = 0) {
        global $connection;
        $userId = $this->_userId;

        $createTime = time();

        $statusArr = $this->getStatus($type);

        $status = $statusArr['status'];
        if ($flag == 1) {
            //业务签到
            $status = 0;
            $query = "INSERT INTO mobile_position(`USER_ID`,`LATLNG`,`ADDRESS`,`STATUS`,`CREATE_TIME`,`mobile_category`,`out_info`,`out_img`) VALUES('".SecurityFilter($userId)."','".SecurityFilter($latlng)."','".SecurityFilter($addr)."',".SecurityFilter($status).",$createTime,'1','".SecurityFilter($info)."','".SecurityFilter($img)."')";
        } else {
            $query = "INSERT INTO mobile_position(`USER_ID`,`LATLNG`,`ADDRESS`,`STATUS`,`CREATE_TIME`) VALUES('$userId','".SecurityFilter($latlng)."','".SecurityFilter($addr)."',$status,$createTime)";
        }

        exequery($connection, $query);

        if ($statusArr['id'] && $flag == 0) { //外勤不影响签到签退状态
            $query1 = 'UPDATE mobile_position SET STATUS = 0 WHERE ID = ' . $statusArr['id'];

            exequery($connection, $query1);
        }
    }

   public function getStatus($type) {
        global $connection;

        if ($type == 'signIn') {
            return array('status' => 1);
        } else {
            $startDate = strtotime(date('Y-m-d') . ' 00:00:00');

            $endDate = strtotime(date('Y-m-d') . ' 23:59:59');

            $query = "SELECT * FROM mobile_position WHERE USER_ID='$this->_userId' AND CREATE_TIME >= '$startDate' AND CREATE_TIME <= '$endDate' and mobile_category = 0 ";

            $rs = exequery($connection, $query);

            $row = array();
            while ($rr = mysql_fetch_array($rs)) {
                $row[] = $rr;
            }
            $count = count($row);
            if ($count >= 2 || ($count == 1 && $row[0]["STATUS"] == 2)) {
                $query1 = "SELECT * FROM mobile_position WHERE USER_ID='$this->_userId' AND CREATE_TIME >= '$startDate' AND CREATE_TIME <= '$endDate' and mobile_category = 0 ORDER BY CREATE_TIME DESC LIMIT 0,1";

                $rs1 = exequery($connection, $query1);

                $row1 = mysql_fetch_array($rs1);

                return array('status' => 2, 'id' => $row1['ID']);
            }

            return array('status' => 2, 'id' => false);
        }
    }

    public function isNoPointerAttend() {
        global $connection;
        $userRow = $this->getUserInfo();
        $userId = $this->_userId;
        $privId = $userRow['USER_PRIV'];
        $deptId = $userRow['DEPT_ID'];
        $query = "SELECT * FROM attend_no_pointer ";
        $query .= " WHERE all_member=1 ";
        $query .= " OR (all_member=0 "
                . " AND ((INStr(dept_id,',$deptId,')>0 OR INStr(dept_id,'$deptId,')=1))"
                . " OR ((INStr(user_id,',$userId,')>0 OR INStr(user_id,'$userId,')=1))"
                . " OR ((INStr(priv_id,',$privId,')>0 OR INStr(priv_id,'$privId,')=1)))";
        $rs = exequery($connection, $query);
        $row = mysql_fetch_array($rs);
        if ($row) {
            return true;
        }
        return false;
    }

}
