<?php

include 'inc/CheckAppVerfy.php';

class mp {


    protected $appid;
    protected $appsecret;
    protected $access_token;
    protected $token_time = 0;
    protected $create_time = 0;
    protected $default_text;

    public function __construct() {

    }

    protected function query($sql) {
        global $connection;
        return exequery($connection, $sql);
    }

    //验证签名
    public function valid() {

        $echoStr = $_GET["echostr"];
        $signature = $_GET["signature"];
        $timestamp = $_GET["timestamp"];
        $nonce = $_GET["nonce"];
        $token = TOKEN;

        $tmpArr = array($token, $timestamp, $nonce);
        sort($tmpArr, SORT_STRING);
        $tmpStr = implode($tmpArr);
        $tmpStr = sha1($tmpStr);
        if ($tmpStr == $signature) {
            echo $echoStr;
            exit;
        }
    }

    //响应消息
    public function responseMsg() {

        $postStr = $GLOBALS[HTTP_RAW_POST_DATA];

        if (!$postStr) {
            echo "error";
            exit;
        }
        $this->logger("R " . $postStr);
        $xmlElement = simplexml_load_string($postStr, 'SimpleXMLElement', LIBXML_NOCDATA);
        $type = trim($xmlElement->MsgType);
        switch ($type) {

            case "event":
                $result = $this->receiveEvent($xmlElement); //ddd
                break;
            case "text":
                $result = $this->receiveText($xmlElement);
                break;
            case "image":
                $result = $this->receiveImage($xmlElement);
                break;
            case "location":
                $result = $this->receiveLocation($xmlElement);
                break;
            case "voice":
                $result = $this->receiveVoice($xmlElement);
                break;
            case "video":
                $result = $this->receiveVideo($xmlElement);
                break;
            case "link":
                $result = $this->receiveLink($xmlElement);
                break;
            default:
                $result = "unknown msg type: " . $type;
                break;
        }
        $this->logger("T " . $result);
        echo $result;
    }

    protected function subscribe($openid) {
        if (!$openid) {
            return false;
        }

        $time = time();
        $sql = "insert into weixin_user(openid,create_time) values('".SecurityFilter($openid)."', '{$time}')";
        $this->query($sql);
        $res = $this->saveUserInfo($openid);
        return $res;
    }

    protected function unsubscribe($openid) {
        if (!$openid) {
            return false;
        }

        $sql1 = "delete from weixin_user where openid = '".SecurityFilter($openid)."'";
        $this->query($sql1);

        $sql = "delete from  weixin_user_info where openid = '".SecurityFilter($openid)."'";
        return $this->query($sql);
    }

    public function saveUserInfo($openid) {

        if (!$openid || !$this->access_token) {
            return false;
        }
        $api = "https://api.weixin.qq.com/cgi-bin/user/info?access_token={$this->access_token}&openid={$openid}&lang=zh_CN";

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $api);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
        curl_setopt($ch, CURLOPT_FAILONERROR, FALSE);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
        $result = curl_exec($ch);
        curl_close($ch);
        $info = json_decode($result, true);

        if (40000 < $info['errcode']) {
            return false;
        }
        $openid = $info['openid'];
        $nickname = $info['nickname'];
        $sex = $info['sex'];
        $city = $info['city'];
        $province = $info['province'];
        $country = $info['country'];
        $headimgurl = $info['headimgurl'];

        $sql = "insert into weixin_user_info (openid,nickname,sex,city,province,country,headimgurl,subscribe)";
        $sql .= " values ('{$openid}','{$nickname}','{$sex}','{$city}','{$province}','{$country}','{$headimgurl}',1)";


        return $this->query($sql);
    }

    public function bindingMP($uid, $openid) {
        global $_lang;
        if (!$openid || !$uid) {
            return false;
        }

        $time = time();

        $sql = "select * from weixin_user where openid = '".SecurityFilter($openid)."'";
        $res = $this->query($sql);

        $checkID_sql = "select * from weixin_user where uid = '".SecurityFilter($uid)."'";
        $result = $this->query($checkID_sql);

        $row = @mysql_fetch_assoc($res);
        $checkID_row = @mysql_fetch_assoc($result);

        if ($row['uid']) {
            if ($row['uid'] == $uid) {
                $date = date('Y-m-d H:i', $row['auth_time']);
                return $date . $_lang["other_weixin_bind"]; // 已经绑定
            } else {
                return "您已经绑定过其他eoffice账号。";
            }
        } else if ($checkID_row['openid']) {
            return $_lang["other_weixin_bind_eoff"];
        } else if ($row['openid']) {
            $sql = "update weixin_user set uid = '{$uid}', auth_time = '{$time}' where openid = '".SecurityFilter($openid)."'";
        } else {
            $sql = "insert into weixin_user values ('{$uid}', '".SecurityFilter($openid)."', '{$time}', '{$time}', '', '','{$time}',0)";
        }

        $res = $this->query($sql);

        $content = $res ? $_lang["other_weixin_bindOK"] : $_lang["other_weixin_bindNO"];

        return $content;
    }

    //检验是否具备考勤权限
    public function checkAttendance($openid) {
        if (!$openid)
            return false;

        $sql = "select uid from weixin_user where openid = '".SecurityFilter($openid)."'";
        $temp = $this->query($sql);
        if ($temp) {
            $result = @mysql_fetch_assoc($temp);
            if ($result['uid']) {
                if (!$this->uid) {
                    $this->uid = $result['uid'];
                }
                return true;
            }
        }
        return false;
    }

    protected function signIn($opt = array()) {
        global $_lang;
        foreach ($opt as $key => $value) {
            $$key = $value;
        }
        if (!$openid)
            return false;

        //没绑定e-office9.0 无法签到
        if (!$this->checkAttendance($openid)) {
            $content = $_lang["other_weixin_nouse"];
            return $content;
        }

        $uid = $this->getUidByOpenid($openid);

        //计算距离签到者和公司距离
        $distance = $this->getDistance($lat, $lng, $this->lat, $this->lng);

        if (1200 < $distance) {
            $content = $_lang["other_weixin_nofanwei"];
        } else {
            $userRow = $this->getUserInfo($uid);
            $userInfo = array(
                'UserId' => $userRow['USER_ID'],
                'DepyId' => $userRow['DEPT_ID'],
                'PrivId' => $userRow['USER_PRIV'],
                'LoginCheck' => 'in'
            );

            include_once 'api/attend.class.php';
            $attend = new attend;

            $attendResult = $attend->GetLoginInOut($userInfo);
            if ($attendResult) {
                $content = $_lang["other_weixin_qd_time"] . date('Y-m-d') . ' ' . $attendResult['LoginInTime'];
            } else {
                $params = array('thisDay' => date('Y-m-d'), 'userId' => $uid);
                $dutyMsg = $attend->getDutyDayMessage($params);

                if ($dutyMsg) {
                    $signInTime = $dutyMsg['SIGN_IN_TIME'];
                    if (300 > time() - $signInTime) {
                        $content = $_lang["other_weixin_qd_rule"];
                    } else {
                        $userInfo['LoginCheck'] = 'out';
                        $attendResult = $attend->GetLoginInOut($userInfo);

                        if ($attendResult) {
                            $content = $_lang["other_weixin_qt_time"] . date('Y-m-d') . ' ' . $attendResult['LoginOutTime'];
                        } else {
                            $content = $_lang["other_weixin_qt_error"];
                        }
                    }
                } else {
                    $content = $_lang["other_weixin_qd_othererror"];
                }
            }
        }

        return $content;
    }

    public function autoLogin($openid = null) {
        if (!$openid)
            return false;

        $uid = $this->getUidByOpenid($openid);
        if (false !== $uid) {
            // header("Location:/E-mobile/App/weixin/WeiServiceApi.php?type=2&uid={$userID}&m={$method}&id={$sourceID}");
            $userID = encrypt2($uid, 'E', 'eoffice');
            return $userID;
            header("Location:/E-mobile/App/weixin/WeiServiceApi.php?type=3&uid={$userID}");
        }
    }

    /**
     * 获取用户信息
     *
     */
    protected function getUserInfo($uid) {
     //   $uid = $uid ? $uid : $this->uid;

        $sql = "SELECT USER_ID,USER_ACCOUNTS,USER_NAME,USER_PRIV,DEPT_ID FROM user WHERE USER_ID='".SecurityFilter($uid)."'";

        $temp = $this->query($sql);
        $result = @mysql_fetch_array($temp);

        return $result;
    }

    public function getUserInfoByOpenid($openid) {
        if (!$openid)
            return false;

        $sql = "SELECT u.USER_ID uid,u.USER_NAME name,u.AVATAR_TYPE,w.openid openid FROM USER u LEFT JOIN weixin_user w ON u.USER_ID = w.uid WHERE w.openid = '".SecurityFilter($openid)."'";
        $temp = $this->query($sql);
        $result = @mysql_fetch_assoc($temp);

        $uid = $result['uid'];


        if (!$uid)
            return false;

        return $result;
    }

    /**
     * @desc 根据两点间的经纬度计算距离
     * @param float $lat 纬度值
     * @param float $lng 经度值
     */
    public function getDistance($lat1, $lng1, $lat2, $lng2) {
        $earthRadius = 6367000;

        $lat1 = ($lat1 * pi() ) / 180;
        $lng1 = ($lng1 * pi() ) / 180;

        $lat2 = ($lat2 * pi() ) / 180;
        $lng2 = ($lng2 * pi() ) / 180;

        $calcLongitude = $lng2 - $lng1;
        $calcLatitude = $lat2 - $lat1;
        $stepOne = pow(sin($calcLatitude / 2), 2) + cos($lat1) * cos($lat2) * pow(sin($calcLongitude / 2), 2);
        $stepTwo = 2 * asin(min(1, sqrt($stepOne)));
        $calculatedDistance = $earthRadius * $stepTwo;

        return round($calculatedDistance);
    }

    //缓存用户地理位置
    protected function cacheUserLocation($opt) {
        foreach ($opt as $key => $value) {
            $$key = $value;
        }

        if (!$this->checkAttendance($openid))
            return false;

        $sql = "update weixin_user set lng='".SecurityFilter($lng)."',lat='".SecurityFilter($lat)."' where openid = '".SecurityFilter($openid)."'";

        $this->query($sql);
    }

    protected function getUserCacheLocation($openid) {
        $sql = "select lng,lat from weixin_user where openid = '".SecurityFilter($openid)."'";

        $result = $this->query($sql);
        $opt = @mysql_fetch_assoc($result);

        return $opt;
    }

    //接收事件消息
    protected function receiveEvent($object) {
        global $_lang;

        $content = "";
        switch (strtolower($object->Event)) {

            case "subscribe":
                $openid = $object->FromUserName;
                $this->subscribe($openid); // 关注
                $key = $object->EventKey;
                $arr = explode('_', $key);


                $content = $this->default_text ?   str_replace("<br />", " ", $this->default_text) : 'Welcome！';
                if ($arr[1]) { // 排除WV00000000
                    if ('999999' == $arr[1]) {
                        $uid = 'admin';
                    } else {
                        $uid = 'WV' . str_pad($arr[1], 8, '0', STR_PAD_LEFT);
                    }

                    $sql = "select uid from weixin_user where  uid ='{$uid}' and openid != '{$openid}'"; // 存在非openid的uid绑定
                    $res = $this->query($sql);
                    $row = @mysql_fetch_assoc($res);
                    if ($row['uid'] && $row) {
                        $content .= ', ' . $_lang["other_weixin_bind_eoff"];
                    } else {
                        $this->bindingMP($uid, $openid);
                    }
                }

                // $this->subscribe($openid);

                break;
            case "unsubscribe":
                $openid = $object->FromUserName;
                $this->unsubscribe($openid);

                $content = $_lang["other_weixin_no_gz"];
                break;
            case "scan":

                $key = $object->EventKey;
                $openid = $object->FromUserName;

                if (!$key) {
                    $content = "系统异常,请稍后重试！";
                    break;
                }

                if ('999999' == $key) {
                    $uid = 'admin';
                } else {
                    $uid = 'WV' . str_pad($key, 8, '0', STR_PAD_LEFT);
                }

                $content = $this->bindingMP($uid, $openid);
                break;
            case "click":

                if (!checkWeixinModule()) {
                    $content = $_lang["other_weixin_no_sq"];
                } else {
                    switch ($object->EventKey) {

                        case 'attendance':

                            $wxCode = CheckAPP(499);
                            if ($wxCode == 1) {
                                $openid = $object->FromUserName;
                                $opt = $this->getUserCacheLocation($openid);
                                $opt['openid'] = $openid;

                                sleep(1);
                                $content = $this->signIn($opt);
                            } else {
                                switch ($wxCode) {
                                    case -1:
                                        $content = "授权许可已经过期或者未注册授权";
                                        break;
                                    case -2:
                                        $content = "授权文件不存在,请联系泛微";
                                        break;
                                    case -3:
                                        $content = "未授权";
                                        break;
                                    case -4:
                                        $content = "试用结束";
                                        break;
                                    default:
                                        $content = "请联系泛微，是否被授权可使用";
                                        break;
                                }
                            }

                            break;

                        case 'autoLogin':
                            $openid = $object->FromUserName;
                            $userInfo = $this->getUserInfoByOpenid($openid); //111

                            if (!$userInfo['uid']) {
                                $content = $_lang["other_weixin_no_oabg"];
                            } else {

                                $wxCode = CheckAPP(499);
                                if ($wxCode == 1) {
                                    $option['openid'] = $userInfo['openid'];
                                    $option['userName'] = $userInfo['name'];

                                    $content = $_lang["other_weixin_click_oa"];
                                    $userID = encrypt2($userInfo['uid'], 'E', 'eoffice');
                                    // weixin_user表 中 查询对应的uid,openid 是否都在
                                    $url = $this->getDomain() . "/E-mobile/App/weixin/WeiServiceApi.php?type=3&uid={$userID}&openid={$openid}";

                                    $this->pushTemplate($option, $content, $url);
                                    $content = $_lang["other_weixin_hy_oa"];
                                } else {
                                    switch ($wxCode) {
                                        case -1:
                                            $content = "授权许可已经过期或者未注册授权";
                                            break;
                                        case -2:
                                            $content = "授权文件不存在,请联系泛微";
                                            break;
                                        case -3:
                                            $content = "未授权";
                                            break;
                                        case -4:
                                            $content = "试用结束";
                                            break;
                                        default:
                                            $content = "请联系泛微，是否被授权可使用";
                                            break;
                                    }
                                }



//                                $option['openid'] = $userInfo['openid'];
//                                $option['userName'] = $userInfo['name'];
//
//                                $content = $_lang["other_weixin_click_oa"];
//                                $userID = encrypt2($userInfo['uid'], 'E', 'eoffice');
//                                // weixin_user表 中 查询对应的uid,openid 是否都在
//                                $url = $this->getDomain() . "/E-mobile/App/weixin/WeiServiceApi.php?type=3&uid={$userID}&openid={$openid}";
//
//                                $this->pushTemplate($option, $content, $url);
//                                $content = $_lang["other_weixin_hy_oa"];
                            }

                            break;

                        default:
                            break;
                    }
                }

                break;
            case "location":
                // $content = "上传位置：纬度 ".$object->Latitude.";经度 ".$object->Longitude.';用户:'.$object->FromUserName;

                $opt['openid'] = $object->FromUserName;
                $opt['lng'] = $object->Longitude;
                $opt['lat'] = $object->Latitude;

                $content = $this->cacheUserLocation($opt);
                break;
            case "view":
                $content = $_lang["other_weixin_reurl"] . " " . $object->EventKey;
                break;
            case "masssendjobfinish":
                $content = $_lang["other_weixin_messId"] . $object->MsgID . ", " . $_lang["other_weixin_messres"] . $object->Status . ", " . $_lang["other_weixin_messfans"] . $object->TotalCount . ", " . $_lang["other_weixin_messdelother"] . $object->FilterCount . ", " . $_lang["other_weixin_mess_OK"] . $object->SentCount . ", " . $_lang["other_weixin_mess_NO"] . $object->ErrorCount;
                break;
            default:
                $content = "receive a new event: " . $object->Event;
                break;
        }
        if (is_array($content)) {
            if (isset($content["PicUrl"])) {
                $result = $this->transmitNews($object, $content);
            } else if (isset($content['MusicUrl'])) {
                $result = $this->transmitMusic($object, $content);
            }
        } else {
            $result = $this->transmitText($object, $content);
        }

        return $result;
    }

    //获取域名
    public function getDomain() {
        $sql = 'select domain from weixin_token limit 1';
        $result = $this->query($sql);
        $row = @mysql_fetch_assoc($result);

        return trim($row['domain'], '/');
    }

    public function errorPage($code = '', $message = '') {
        include('messageView.php');
        exit;
    }

    public function getWxAll() {
        $sql = 'select * from weixin_token limit 1';
        $result = $this->query($sql);
        $row = @mysql_fetch_assoc($result);

        return $row;
    }

    //检查当前用户是否 离职
    public function checkUserStatus($userId){
        $sql = 'SELECT USER_ID  FROM user WHERE USER_ID=\'' . SecurityFilter($userId) . '\'  AND USER_ACCOUNTS !=\'\'';

        $result = $this->query($sql);
        $row = @mysql_fetch_assoc($result);
        if ($row) {
                return $row;
        }
        return false;

    }

    //接收文本消息
    protected function receiveText($object) {
        global $_lang;
        $keyword = trim($object->Content);
        $content = $_lang["other_weixin_OAoffice"];

        switch ($keyword) {

            default:
                break;
        }

        return $this->transmitText($object, $content);
    }

    //接收图片消息
    protected function receiveImage($object) {
        $content = array(
            "MediaId" => $object->MediaId,
            "PicUrl" => $object->PicUrl
        );
        $result = $this->transmitImage($object, $content);
        return $result;
    }

    //接收位置消息
    protected function receiveLocation($object) {
        global $_lang;
        $content = $_lang["other_weixin_pos_wd"] . $object->Location_X . " " . $_lang["other_weixin_pos_jd"] . $object->Location_Y . " " . $_lang["other_weixin_pos_sale"] . $object->Scale . " " . $_lang["other_weixin_pos_pos"] . $object->Label;
        $result = $this->transmitText($object, $content);
        return $result;
    }

    //接收语音消息
    protected function receiveVoice($object) {
        global $_lang;
        if (isset($object->Recognition) && !empty($object->Recognition)) {
            $content = $_lang["other_weixin_what_said"] . $object->Recognition;
            $result = $this->transmitText($object, $content);
        } else {
            $content = array("MediaId" => $object->MediaId);
            $result = $this->transmitVoice($object, $content);
        }

        return $result;
    }

    //接收视频消息
    protected function receiveVideo($object) {
        $content = array("MediaId" => $object->MediaId, "ThumbMediaId" => $object->ThumbMediaId, "Title" => "", "Description" => "");
        $result = $this->transmitVideo($object, $content);
        return $result;
    }

    //接收链接消息
    protected function receiveLink($object) {
        global $_lang;
        $content = $_lang["other_weixin_what_title"] . $object->Title . $_lang["other_weixin_what_content"] . $object->Description . $_lang["other_weixin_what_link"] . $object->Url;
        $result = $this->transmitText($object, $content);
        return $result;
    }

    //回复文本消息
    protected function transmitText($object, $content) {
        $xmlTpl = "<xml>
<ToUserName><![CDATA[%s]]></ToUserName>
<FromUserName><![CDATA[%s]]></FromUserName>
<CreateTime>%s</CreateTime>
<MsgType><![CDATA[text]]></MsgType>
<Content><![CDATA[%s]]></Content>
</xml>";
        $result = sprintf($xmlTpl, $object->FromUserName, $object->ToUserName, time(), $content);
        return $result;
    }

    //回复图片消息
    protected function transmitImage($object, $imageArray) {
//        $itemTpl = "<Image>
//    <MediaId><![CDATA[%s]]></MediaId>
//</Image>";
//
//        $item_str = sprintf($itemTpl, $imageArray['MediaId']);

        $xmlTpl = "<xml>
<ToUserName><![CDATA[%s]]></ToUserName>
<FromUserName><![CDATA[%s]]></FromUserName>
<CreateTime>%s</CreateTime>
<MsgType><![CDATA[image]]></MsgType>
<Image><MediaId><![CDATA[%s]]></MediaId></Image>
</xml>";

        $result = sprintf($xmlTpl, $object->FromUserName, $object->ToUserName, time(), $imageArray['MediaId']);
        return $result;
    }

    //回复语音消息
    protected function transmitVoice($object, $voiceArray) {
        $itemTpl = "<Voice>
    <MediaId><![CDATA[%s]]></MediaId>
</Voice>";

        $item_str = sprintf($itemTpl, $voiceArray['MediaId']);

        $xmlTpl = "<xml>
<ToUserName><![CDATA[%s]]></ToUserName>
<FromUserName><![CDATA[%s]]></FromUserName>
<CreateTime>%s</CreateTime>
<MsgType><![CDATA[voice]]></MsgType>
$item_str
</xml>";

        $result = sprintf($xmlTpl, $object->FromUserName, $object->ToUserName, time());
        return $result;
    }

    //回复视频消息
    protected function transmitVideo($object, $videoArray) {
        $itemTpl = "<Video>
    <MediaId><![CDATA[%s]]></MediaId>
    <ThumbMediaId><![CDATA[%s]]></ThumbMediaId>
    <Title><![CDATA[%s]]></Title>
    <Description><![CDATA[%s]]></Description>
</Video>";

        $item_str = sprintf($itemTpl, $videoArray['MediaId'], $videoArray['ThumbMediaId'], $videoArray['Title'], $videoArray['Description']);

        $xmlTpl = "<xml>
<ToUserName><![CDATA[%s]]></ToUserName>
<FromUserName><![CDATA[%s]]></FromUserName>
<CreateTime>%s</CreateTime>
<MsgType><![CDATA[video]]></MsgType>
$item_str
</xml>";

        $result = sprintf($xmlTpl, $object->FromUserName, $object->ToUserName, time());
        return $result;
    }

    //回复图文消息
    protected function transmitNews($object, $newsArray) {
        if (!is_array($newsArray)) {
            return;
        }
        $itemTpl = "    <item>
        <Title><![CDATA[%s]]></Title>
        <Description><![CDATA[%s]]></Description>
        <PicUrl><![CDATA[%s]]></PicUrl>
        <Url><![CDATA[%s]]></Url>
    </item>
";
        $item_str = "";
        foreach ($newsArray as $item) {
            $item_str .= sprintf($itemTpl, $item['Title'], $item['Description'], $item['PicUrl'], $item['Url']);
        }
        $xmlTpl = "<xml>
<ToUserName><![CDATA[%s]]></ToUserName>
<FromUserName><![CDATA[%s]]></FromUserName>
<CreateTime>%s</CreateTime>
<MsgType><![CDATA[news]]></MsgType>
<ArticleCount>%s</ArticleCount>
<Articles>
        {$item_str}
 </Articles>
</xml>";

        $result = sprintf($xmlTpl, $object->FromUserName, $object->ToUserName, time(), count($newsArray));
        return $result;
    }

    //回复音乐消息
    protected function transmitMusic($object, $musicArray) {
        $itemTpl = "<Music>
    <Title><![CDATA[%s]]></Title>
    <Description><![CDATA[%s]]></Description>
    <MusicUrl><![CDATA[%s]]></MusicUrl>
    <HQMusicUrl><![CDATA[%s]]></HQMusicUrl>
</Music>";

        $item_str = sprintf($itemTpl, $musicArray['Title'], $musicArray['Description'], $musicArray['MusicUrl'], $musicArray['HQMusicUrl']);

        $xmlTpl = "<xml>
<ToUserName><![CDATA[%s]]></ToUserName>
<FromUserName><![CDATA[%s]]></FromUserName>
<CreateTime>%s</CreateTime>
<MsgType><![CDATA[music]]></MsgType>
$item_str
</xml>";

        $result = sprintf($xmlTpl, $object->FromUserName, $object->ToUserName, time());
        return $result;
    }

    //回复多客服消息
    protected function transmitService($object) {
        $xmlTpl = "<xml>
<ToUserName><![CDATA[%s]]></ToUserName>
<FromUserName><![CDATA[%s]]></FromUserName>
<CreateTime>%s</CreateTime>
<MsgType><![CDATA[transfer_customer_service]]></MsgType>
</xml>";
        $result = sprintf($xmlTpl, $object->FromUserName, $object->ToUserName, time());
        return $result;
    }

    //日志记录
    protected function logger($log_content) {
        if (isset($_SERVER['HTTP_APPNAME'])) {   //SAE
            sae_set_display_errors(false);
            sae_debug($log_content);
            sae_set_display_errors(true);
        } else if ($_SERVER['REMOTE_ADDR'] != "127.0.0.1") { //LOCAL
            $max_size = 10000;
            $log_filename = "log.xml";
            if (file_exists($log_filename) and ( abs(filesize($log_filename)) > $max_size)) {
                unlink($log_filename);
            }
            file_put_contents($log_filename, date('H:i:s') . " " . $log_content . "\r\n", FILE_APPEND);
        }
    }

}
