<?php

$lang_file = "lang/cn/other.lang.php";
include_once($lang_file);
include_once 'general/weixin/mp.class.php';
include_once 'inc/utility_all.php';
include_once 'inc/function_usergeneral.php';
include_once 'inc/AppGlobal.php';

class wechat extends mp {

    public function __construct() {
        parent::__construct($uid);
        $this->updateAccessToken();
    }

    protected function updateAccessToken() {
        date_default_timezone_set('Asia/Shanghai'); //设置时区
        $this->get_access_token();
    }

    public function get_access_token() {
        //获取时间
        $sql = 'select * from weixin_token limit 1';
        $result = $this->query($sql);
        $row = @mysql_fetch_assoc($result);


        if (!isset($row["appid"])) {
            return false;
        }
        foreach ($row as $key => $value) {
            if ('uid' == $key)
                continue;
            $this->$key = trim($value);
        }

        if (abs(time() - $this->token_time) > 7000) {
            //GET请求的地址
            $url = "https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid={$this->appid}&secret={$this->appsecret}";
            $json = AppGlobal::getToken($url);
            $access_token_Arr = json_decode($json, true);
            $time = time();
            $sql = "update weixin_token set access_token = '{$access_token_Arr['access_token']}', token_time = '{$time}' where appid='{$this->appid}'";
            $this->query($sql);
            $this->access_token = $access_token_Arr['access_token'];
        }
        return $this->access_token;
    }

    public function get_weixin_token() {
        $sql = 'select * from weixin_token limit 1';
        $result = $this->query($sql);
        $row = @mysql_fetch_assoc($result);
        return $row;
    }

    //https请求（支持GET和POST）
    public function https_request($url, $data = "") {

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
        if (!empty($data)) {
            curl_setopt($ch, CURLOPT_POST, 1); //模拟POST
            curl_setopt($ch, CURLOPT_POSTFIELDS, $data); //POST内容
        }
        $outopt = curl_exec($ch);
        $outopt = json_decode($outopt, true);
        curl_close($ch);
        return $outopt;
        exit;
    }

    public function getTicket($scene_id = null) {
        $access_token = $this->get_access_token();

        if (!$access_token) {
            return false;
        }


        $url = "https://api.weixin.qq.com/cgi-bin/qrcode/create?access_token={$access_token}";

        $array = array(
            'expire_seconds' => 1800,
            'action_name' => 'QR_SCENE',
            'action_info' => array(
                'scene' => array(
                    'scene_id' => $scene_id
                )
            )
        );
        $post_json = json_encode($array);

        $json = AppGlobal::getHttps($url, $post_json, 1);
        return json_decode($json, true);
    }

    public function getQRcode($ticket, $uid, $file = null) {

        $url = "https://mp.weixin.qq.com/cgi-bin/showqrcode?ticket={$ticket}";


        $QRcode = AppGlobal::getToken($url);

        $fileName = './QRcode/' . $uid . '.jpg';
        $fp = fopen($fileName, 'w');
        if (false !== $fp) {
            if (false !== fwrite($fp, $QRcode)) {
                fclose($fp);
                return true;
            }
        }
        return false;
    }

    public function getBindingQRcode($uid) {

        $userStr = '';

        if ('WV' == substr($uid, 0, 2)) {
            $userStr = (int) substr($uid, 2);
        }
        if ('admin' == $uid) {
            $userStr = '999999';
        }



        $ticket = $this->getTicket($userStr);



        return $this->getQRcode($ticket['ticket'], $uid);
    }

    public function pushMsg($openid, $content = '', $type = 'text') {
        $access_token = $this->get_access_token();
        if (!$access_token) {
            return false;
        }
        $api = "https://api.weixin.qq.com/cgi-bin/message/custom/send?access_token={$access_token}";

        switch ($type) {
            case 'text':
                $post = $this->getTextToPush($openid, $content);
                break;
        }

        return AppGlobal::getHttps($api, $post, true);
    }

    protected function getTextToPush($openid, $content) {
        $data = array(
            'touser' => $openid,
            'msgtype' => 'text',
            'text' => array(
                'content' => urlencode($content)
            )
        );

        return urldecode(json_encode($data));
    }

    public function pushTemplate($option, $content, $url = '') {
        $access_token = $this->get_access_token();
        if (!$access_token) {
            return false;
        }
        $api = "https://api.weixin.qq.com/cgi-bin/message/template/send?access_token={$access_token}";
        $data = $this->getTemplateToPush($option, $content, $url);

        $content = AppGlobal::getHttps($api, $data, true);

        return $content;
    }

    protected function getTemplateToPush($option, $content, $url = '') {
        $openid = $option['openid'];
        $userName = $option['userName'] ? $option['userName'] : '消息通知';

        $time = date('Y-m-d H:i');
        $template = array(
            'touser' => $openid,
            'template_id' => $this->temp_id,
            'url' => $url,
            'topcolor' => '#7B68EE',
            'data' => array(
                'first' => array(
                    'value' => '',
                    'color' => '#000000'
                ),
                'keyword1' => array(
                    'value' => $content,
                    'color' => '#0000FF'
                ),
                'keyword2' => array(
                    'value' => urlencode($userName),
                    'color' => '#000000'
                ),
                'keyword3' => array(
                    'value' => urlencode($time),
                    'color' => '#000000'
                ),
                'remark' => array(
                    'value' => '',
                    'color' => '#000000'
                )

//                'keyword1' => array(
//                    'value' => urlencode($userName),
//                    'color' => '#000000'
//                ),
//                'keyword2' => array(
//                    'value' => "e-office协同办公",
//                    'color' => '#000000'
//                ),
//
//                'keyword3' => array(
//                    'value' => urlencode($time),
//                    'color' => '#000000'
//                ),
//                'remark' => array(
//                    'value' => '点击立即开始手机办公',
//                    'color' => '#000000'
//                )
            )
        );

        return urldecode(json_encode($template));
    }

    private function dealSource($type) {
        $source = array(
            '7' => array('id' => 10, 'name' => '待办流程'),
            '27' => array('id' => 14, 'name' => '新闻'),
            '1' => array('id' => 15, 'name' => '公告'),
            // '27'=>array('id'=>1, 'name'=>'通讯录'),
            '28' => array('id' => 2, 'name' => '日程'),
            '20' => array('id' => 3, 'name' => '文档'),
            '2' => array('id' => 4, 'name' => '内部邮件'),
            '26' => array('id' => 8, 'name' => '协作'),
            '35' => array('id' => 21, 'name' => '客户'),
            '24' => array('id' => 7, 'name' => '微博')
        );

        return $source[$type]['id'];
    }

    //获取手机版接口 35 /2 
    public function getMobile($uid, $sourceType = '0', $sourceID) {
        if (!$uid) {
            return false;
        } else {
            $this->countApply($uid);
        }

        $domain = $this->getDomain();
        $method = $this->dealSource($sourceType);
        
 

        if (false !== strpos($sourceID, ',')) {
            $FlowPrcsResult = $this->dealFlowPrcs($uid, $sourceID);
            $sourceID = $FlowPrcsResult['sourceID'];
            $copy = $FlowPrcsResult['copy'];
        }

        if ($copy) {
            $method = 16;
        }

        $userID = encrypt2($uid, 'E', 'eoffice');
            
        header("Location:/E-mobile/App/weixin/WeiServiceApi.php?type=2&uid={$userID}&m={$method}&id={$sourceID}");
    }

    //使用统计
    protected function countApply($uid) {
        if (!$uid)
            return false;

        $sql = "UPDATE weixin_user SET jumpNum = jumpNum + 1 WHERE uid = '{$uid}'";
        return $this->query($sql);
    }

    //获取关注用户
    public function getSubscribe($search = array()) {
        $field = $search['field'];
        $value = $search['value'];
        $currentPage = $search['currentPage'];
        $itemsPerPage = $search['itemsPerPage'];

        $sql = 'select * from weixin_user_info where subscribe = 1';
        $totalSql = 'select count(*) count from weixin_user_info where subscribe = 1';

        if ($value) {
            $sql .= " and {$field} like '%{$value}%'";
            $totalSql .= " and {$field} like '%{$value}%'";
        }

        $currentPage *= $itemsPerPage;
        $sql .= " limit {$currentPage}, {$itemsPerPage}";

        $totalTemp = $this->query($totalSql);
        $totalResult = @mysql_fetch_assoc($totalTemp);
        $total = $totalResult['count'];

        $result = $this->query($sql);

        $list['list'] = array();
        while ($row = @mysql_fetch_assoc($result)) {
            if ($row['headimgurl']) {
                $row['headimgurl'] = "<img src='{$row['headimgurl']}' width='40px' />";
            } else {
                $row['headimgurl'] = "<img src='/images/nopicture.png' width='40px' />";
            }
            if ($row['sex'] == 1) {
                $row['sex'] = '男';
            } else {
                $row['sex'] = '女';
            }
            $list['list'][] = $row;
        }

        $list['totalCount'] = $total;

        return json_encode($list);
    }

    //获取绑定用户
    public function getBinding($opt = array()) {
        $param = $opt['param'];
        $value = $opt['value'];
        $field = $opt['field'];
        $currentPage = $opt['currentPage'];
        $itemsPerPage = $opt['itemsPerPage'];
        $sortField = $opt['sortField'];
        $sortType = $opt['sortType'];

        $selectSql = 'SELECT u.USER_ID uid,u.USER_ACCOUNTS account,u.USER_NAME name,d.DEPT_NAME dept,p.PRIV_NAME priv,IFNULL(w.jumpNum,0) jumpNum ,w.uid AS Status ';
        $totalSql = 'SELECT count(*) count';

        $sql = ' FROM user u';
        $sql .= ' LEFT JOIN department d ON u.DEPT_ID = d.DEPT_ID';
        $sql .= ' LEFT JOIN user_priv p ON u.USER_PRIV = p.USER_PRIV';
        $sql .= ' LEFT JOIN weixin_user w ON u.USER_ID = w.uid';
        $sql .= ' WHERE u.DEPT_ID > 0';

        if ('binding' == $param) {
            $sql .= ' AND u.USER_ID IN (SELECT uid FROM weixin_user w)';
        } elseif ('no_binding' == $param) {
            $sql .= ' AND u.USER_ID NOT IN (SELECT uid FROM weixin_user)';
        }

        if ($value) {
            $field = str_replace('|', '.', $field);
            $sql .= " AND {$field} LIKE '%{$value}%'";
        }
        if ($sortField) {
            $sql .= " ORDER BY {$sortField} {$sortType}";
        }

        $totalSql = $totalSql . $sql;
        $totalTemp = $this->query($totalSql);
        $totalResult = @mysql_fetch_assoc($totalTemp);
        $total = $totalResult['count'];

        $currentPage *= $itemsPerPage;

        if (!$sortField) {
            $sql .= " ORDER by w.uid desc ";
        }

        $sql .= " limit {$currentPage}, {$itemsPerPage}";

        $selectSql = $selectSql . $sql;


        $result = $this->query($selectSql);

        $list['list'] = array();
        while ($row = @mysql_fetch_assoc($result)) {
            if (function_exists('showUserGeneral')) {
                $row['name'] = showUserGeneral($row['uid']);
            }
            if (!empty($row['Status'])) {
                $row['Status'] = "已绑定";
                $row["OP"] = "<a href=\"javascript:void(0)\" class='ignore-link' onclick=\"noBindWeixin('" . $row['uid'] . "');return false;\">解绑</a>";
            } else {
                $row['Status'] = "未绑定";
                $row["OP"] = "";
            }

            $list['list'][] = $row;
        }

        $list['totalCount'] = $total;

        return json_encode($list);
    }

    public function dealFlowPrcs($uid, $sourceID) {
        $_pos = strpos($sourceID, '|');

        if (false !== $_pos) {
            $copy = trim(substr($sourceID, $_pos), '|');
            $sourceID = substr($sourceID, 0, $_pos);
        }

        $sourceID = explode(',', trim($sourceID, ','));
        $runID = $sourceID[0];

        $sql = "select FLOW_PRCS,PRCS_ID from flow_run_prcs where RUN_ID={$runID} and USER_ID='{$uid}' order by PRCS_ID desc limit 1";
        $result = $this->query($sql);
        $row = @mysql_fetch_assoc($result);
        $sourceID[2] = $row['FLOW_PRCS'];
        $sourceID[3] = $row['PRCS_ID'];

        $implode = implode(',', $sourceID);
        $return = array('copy' => $copy, 'sourceID' => $implode);

        return $return;
    }

    public function createMenu($menu) {
        $access_token = $this->get_access_token();
        if (!$access_token) {
            return false;
        }
        $api = "https://api.weixin.qq.com/cgi-bin/menu/create?access_token={$access_token}";
        $code = urldecode(json_encode($menu));

        $res = json_decode(AppGlobal::getHttps($api, $code, true), true);

        return $res;
    }

    public function deleteMenu() {
        $access_token = $this->get_access_token();
        if (!$access_token) {
            return false;
        }
        $api = "https://api.weixin.qq.com/cgi-bin/menu/delete?access_token={$access_token}";
        $res = json_decode(AppGlobal::getToken($api), true);

        return $res;
    }

    public function getMenu() {
        $access_token = $this->get_access_token();
        if (!$access_token) {
            return false;
        }
        $api = "https://api.weixin.qq.com/cgi-bin/menu/get?access_token={$access_token}";
        $res = json_decode(AppGlobal::getToken($api), true);

        return $res;
    }

    public function isFieldExists($tableName, $field) {
        $sql = "DESC {$tableName} {$field}";
        $result = $this->query($sql);
        $row = @mysql_fetch_assoc($result);

        if ($field == $row['Field']) {
            return true;
        }

        return false;
    }

    public function decode($param) {
        $temp = explode('\u', $param);

        $result = array();
        array_shift($temp);

        foreach ($temp as $key => $value) {

            //将16进制转换成十进制
            $value = hexdec($value);

            //转换成html实体
            $result[] = "&#{$value};";
        }

        return implode('', $result);
    }

    public function getFollowList($next_openid = null) {

        $access_token = $this->get_access_token();
        if (!$access_token) {
            return false;
        }
        $api = "https://api.weixin.qq.com/cgi-bin/user/get?access_token={$access_token}";
        if ($next_openid) {
            $api .= "&next_openid={$next_openid}";
        }

        $result = json_decode(AppGlobal::getToken($api), true);

        $total = $result['total'];
        $count = $result['count'];
        $data = $result['data']['openid'];
        $next_openid = $result['next_openid'];

        if ($data) {
            foreach ($data as $openid) {
                $this->saveUserInfo($openid);
            }
        }

        if (10000 == $count && 10000 < $total) {
            return $this->getFollowList($next_openid);
        }
    }

}
