<?php
include_once("inc/reg_check.php");
include_once("inc/utility_all.php");
if($OA_REG_ON!=2)
   exit;
$LoginCheck = new LoginCheck();
$LoginCheck->validateCenter();
class LoginCheck{
    /**
     *定义类全局变量
     */
    private $_USER_LANG;            //用户选择的登录语言
    private $_CUR_TIME;             //系统当前时间
    private $_LOGIN_FLAG = 1;       //是否正确登录
    private $_SEC_PASS_FLAG;        //密码定时过期标记
    private $_SEC_PASS_TIME;        //密码有效期
    private $_LIMIT_LOGIN_TIMES;    //限制多窗口登录
    private $_SEC_PASS_IMG;         //图形码验证标记
    private $_LOGIN_ERROR = '';     //登录错误信息;
    private $_LANG;                 //语言包
    private $_SEKEY = 'e-office';   //图形验证码的加密key
    public function __construct() {
        $this->setLoginLang();//设置登录语言

        include_once("inc/utility.php");//导入工具函数文件

        date_default_timezone_set('Asia/Shanghai'); //设置时区
        $this->_CUR_TIME = date("Y-m-d H:i:s",time());

    }
    /**
     * 登录验证中心
     */
    public function validateCenter(){
        @session_start();//开启session机制
        @ob_start();//打开输出控制缓冲
        $this->getSystemParam();//获取系统参数


        $USERNAME = isset($_POST['u']) ? $_POST['u'] : (isset($_GET['u']) ? $_GET['u'] : '');//登录用户名
        $PASSWORD = isset($_POST['p']) ? $_POST['p'] : (isset($_GET['p']) ? $_GET['p'] : '');//登录密码

        if($this->_LOGIN_FLAG == 1) $this->ipCheck ($USERNAME); //IP检验
        if($this->_LOGIN_FLAG == 1) $userInfo = $this->validateAccount($USERNAME,$PASSWORD);//账户密码验证
        $GOTO     = isset($_POST['GOTO']) ? $_POST['GOTO'] : (isset($_GET['GOTO']) ? $_GET['GOTO'] : '');//登录跳转的页面
        if($this->_SEC_PASS_IMG == "1" && $GOTO == '' && $this->_LOGIN_FLAG == 1) $this->verifyCheck ();//图形验证码验证

        if($this->_LOGIN_FLAG == 1) $this->dimissionCheck($userInfo['USER_ID']); //验证是否是离职人员或删除人员

        if($this->_LOGIN_FLAG == 1) $this->validateEnd($userInfo); //验证成功后的操作

        if ($this->_LOGIN_FLAG == 1){
            header("location: /general/index9.php");
        } elseif ($this->_LOGIN_FLAG == 0) {
            $isAjax = $_SERVER['HTTP_X_REQUESTED_WITH'];
            if($isAjax &&($isAjax=='XMLHttpRequest')){
                echo 0;
            }else{
                $url = isset($_POST['source_url']) ? $_POST['source_url'] : (isset($_GET['source_url']) ? $_GET['source_url'] : '/general/login/index.php');
                header('Location:' . $url);
            }
        }
    }
    /**
     * 检查用户名和密码;
     * @global type $connection
     */
    private function validateAccount($USERNAME,$PASSWORD){
        global $connection;
        $USERNAME = SecurityFilter($USERNAME);
        /*
         * 验证用户名是否存在
         */
        if($this->_LOGIN_FLAG && $USERNAME != ''){
            $query  = "SELECT * from USER where USER_ACCOUNTS='$USERNAME'";
            $cursor = exequery($connection,$query);
            if(!$ROW = @mysql_fetch_array($cursor)){
                $this->_LOGIN_FLAG  = 0;
                $this->_LOGIN_ERROR = $this->_LANG["other_login_error_username"];
                add_log(10,"USER_ACCOUNTS=$USERNAME",$USERNAME);
            }
            @mysql_free_result($cursor);
        }
        /*
         * 验证用户名是否正确
         */
        if($this->_LOGIN_FLAG){
            if($USERNAME != $ROW["USER_ACCOUNTS"]){
                $this->_LOGIN_FLAG = 0;
                $this->_LOGIN_ERROR = $this->_LANG["other_login_error_username"];
                add_log(10,"USER_ACCOUNTS=$USERNAME",$USERNAME);
            }
        }
        /*
         * 验证密码是否正确或是否过期
         */
        if($this->_LOGIN_FLAG){
            $ROW["LOGIN_THEME"]  = $ROW["THEME"] == '' ? 'theme1' : $ROW["THEME"];
            $ROW['MENU_TYPE']    = 2 - $ROW["MENU_TYPE"];
            if(crypt($PASSWORD,$ROW["PASSWORD"])!= $ROW["PASSWORD"]){
                $ERROR_PWD = maskstr($PASSWORD,2,1);
                $this->_LOGIN_FLAG = 0;
                $this->_LOGIN_ERROR = $this->_LANG["other_login_error_password_update"];
                add_log(2,$ERROR_PWD,$USERNAME);
            }
        }

        return $ROW;
    }
    /**
     * 验证正确后做相应处理动作
     */
    private  function validateEnd($userInfo = array()){
        global $connection;
        ////////////////////检查上次访问时间及更新访问时间////////////////////////
        $labor_check = true;
        $query       = "SELECT * FROM sys_log WHERE TYPE=1 AND TIME>=CURDATE() ORDER BY LOG_ID DESC";
        $cousor      = exequery($connection,$query);
        if($row = @mysql_fetch_array($cousor)) {
            $labor_check = false;
        }
        @mysql_free_result($cousor);

        $officeitem_need_check = true;
        $timenow = time();
        $query   = "select LAST_VISIT_TIME from USER where USER_ID='".$userInfo['USER_ID']."'";
        $rs      = @exequery($connection,$query);
        if($row = @mysql_fetch_array($rs)){
            $last_vt_time = strtotime($row[0]);
            $d_last = date("d",$last_vt_time);
            $m_last = date("m",$last_vt_time);
            $Y_last = date("Y",$last_vt_time);
            $d_now  = date("d",$timenow);
            $m_now  = date("m",$timenow);
            $Y_now  = date("Y",$timenow);
            if((abs($d_now-$d_last) == 0) && (abs($m_now-$m_last) == 0) && (abs($Y_now-$Y_last) == 0)){
                $officeitem_need_check = false;
            }
        }
        @mysql_free_result($rs);

        $query = "update USER set LAST_VISIT_TIME='$this->_CUR_TIME' where USER_ID='".$userInfo['USER_ID']."'";
        @exequery($connection,$query);
         ///////////////////////////////////////////////////////////////////////

         //////////////////////////将登录后需要使用到的参数保存至session//////////
        $query  = "SELECT * from USER_PRIV where USER_PRIV=".$userInfo['USER_PRIV'];
        $cursor = exequery($connection,$query);
        if($ROW = @mysql_fetch_array($cursor)){
            $LOGIN_FUNC_STR = $ROW["FUNC_ID_STR"];
        }
        @mysql_free_result($cousor);

        $sql = "SELECT LANG_ID FROM language WHERE LANG_AB='".$this->_USER_LANG."'";
        $rs  = exequery($connection,$sql);
        $row = @mysql_fetch_array($rs);
        @mysql_free_result($rs);
        $_SESSION["LOGIN_LANG_ID"]          = $row['LANG_ID'];
        $_SESSION["LOGIN_LANG"]             = $this->_USER_LANG;
        $_SESSION["LOGIN_USER_ID"]          = $userInfo['USER_ID'];
        $_SESSION["LOGIN_PASSWORD"]         = $userInfo['PASSWORD'];
        $_SESSION["LOGIN_POST_PRIV"]        = $userInfo["POST_PRIV"];
        $_SESSION["LOGIN_USER_ACCOUNTS"]    = $userInfo['USER_ACCOUNTS'];
        $_SESSION["LOGIN_USER_NAME"]        = $userInfo["USER_NAME"];
        $_SESSION["LOGIN_USER_PRIV"]        = $userInfo["USER_PRIV"];
        $_SESSION["LOGIN_DEPT_ID"]          = $userInfo["DEPT_ID"];
        $_SESSION["LOGIN_AVATAR"]           = $userInfo["AVATAR"];
        $_SESSION["LOGIN_THEME"]            = $userInfo['LOGIN_THEME'] ;
        $_SESSION["LOGIN_FUNC_STR"]         = $LOGIN_FUNC_STR;
        $_SESSION['SMS_LOGIN']              = $userInfo['SMS_LOGIN'];
        $_SESSION["LOGIN_USBKEY"]           = $userInfo['LOGIN_USBKEY'];
        $_SESSION["USBKEY_PIN"]             = $userInfo['USBKEY_PIN'];
        setcookie ("USER_NAME_COOKIE", $userInfo['USER_ACCOUNTS'],time() + 60*60*24*1000);
        setcookie ("LOGIN_LANG", $this->_USER_LANG,time() + 60*60*24*1000);
        ///////////////////////////////////////////////////////////////////////

        /////////////////增加在线状态和同用户同时登录的限制//////////////////////
        $sessid    = SESSION_ID();
        $userid    = $userInfo['USER_ID'];
        $vtime     = $this->_CUR_TIME;
        $sql       = " SELECT COUNT(USER_ID) AS cnt FROM USER_ONLINE WHERE USER_ID='".$userInfo['USER_ID']."'";
        $re        = exequery($connection,$sql);
        $row       = @mysql_fetch_array($re);
        @mysql_free_result($re);
        if ($row['cnt'] == 0){
            $sql = "INSERT INTO user_online (USER_ID,SESSION_ID,VISIT_TIME) VALUES ('".$userid."','".$sessid."','".$vtime."')";
        }else{
            $sql = "UPDATE user_online SET SESSION_ID='".$sessid."',VISIT_TIME='".$vtime."' WHERE USER_ID='".$userid."'";
        }
        exequery($connection,$sql);
        ///////////////////////////////////////////////////////////////////////
        if($this->_SEC_PASS_FLAG == '1') $this->passwordPastCheck($userInfo["LAST_PASS_TIME"]);
        add_log(1,"",$userInfo['USER_ID']); //添加日志

        affair_sms(); //根据日程安排生成短信息

        birthday_info(); //检查过生日，发送邮件祝福

        if($officeitem_need_check == true) officeitem_sms(); //检查办公用品,同一天只检查一次

        /*
         * 人事档案检查
         */
        if($labor_check == "1") {
            send_mes_to_hr("admin");
            $labor_check = false;
        }

        limitdate_flow_sms(); //检查是否有过期的流程需要办理

        if(!$sid = input_survey()) $sid = 0;//检查是否有首页弹出的调查表
        $_SESSION['sid'] = $sid;
        $this->userAttend($userInfo['USER_ACCOUNTS']);//登陆签到

        $this->todayWorkCheck();// 当天事务检查
        /*
         * 判断是否需要短信动态码登录
         */
        if($userInfo["SMS_LOGIN"] &&  $this->_LOGIN_FLAG == 1 ) {
            $_SESSION["TMP_LOGIN_USER_ID"]  = $_SESSION['LOGIN_USER_ID'];
            $_SESSION["LOGIN_USER_ID"]      = "";
            $this->_LOGIN_FLAG = 2;
            $this->_LOGIN_ERROR = $this->_LANG['other_must_send_verfiy_code'];
        };

        if($userInfo["LOGIN_USBKEY"] &&  $this->_LOGIN_FLAG == 1 ) $this->usbCheckStart($userInfo['USER_ID'],$userInfo["LOGIN_USBKEY"],$userInfo["USBKEY_PIN"]);//判读是否需要usb验证
    }
    /**
     * 密码过期验证
     * @param type $LAST_PASS_TIME
     */
    private function passwordPastCheck($LAST_PASS_TIME){
        if((time()-strtotime($LAST_PASS_TIME) >= $this->_SEC_PASS_TIME*24*3600) || $LAST_PASS_TIME == "0000-00-00 00:00:00"){
            $this->_LOGIN_FLAG = 4;
            $this->_LOGIN_ERROR = $this->_LANG['other_password_past'];
        }
    }
    /**
     *  取系统设置参数
     * @global type $connection
     */
    private function getSystemParam() {
        global $connection;
        $query  = "SELECT * from SYS_PARA where PARA_NAME in('SEC_PASS_FLAG','SEC_PASS_TIME','SEC_PASS_IMG','LIMIT_LOGIN_TIMES')";
        $cursor = exequery($connection,$query);
        while($ROW = @mysql_fetch_array($cursor)){
            $PARA_NAME  = $ROW["PARA_NAME"];
            $PARA_VALUE = $ROW["PARA_VALUE"];
            if($PARA_NAME == "SEC_PASS_FLAG")
                $this->_SEC_PASS_FLAG = $PARA_VALUE;
            else if($PARA_NAME == "SEC_PASS_TIME")
                $this->_SEC_PASS_TIME = $PARA_VALUE;
            else if($PARA_NAME == "SEC_PASS_IMG")
                $this->_SEC_PASS_IMG  = $PARA_VALUE;
            else if($PARA_NAME == "LIMIT_LOGIN_TIMES")
                $this->_LIMIT_LOGIN_TIMES = $PARA_VALUE;
        }
        @mysql_free_result($cursor);
    }
    /**
     * 导入登录后的语言包;
     */
    private function setLoginLang(){
        $USER_LANG = isset($_POST['USER_LANG']) ? $_POST['USER_LANG'] : (isset($_GET['USER_LANG']) ? $_GET['USER_LANG'] : 'cn');
        include_once("lang/".$USER_LANG."/other.lang.php");
        include_once("lang/".$USER_LANG."/common.lang.php");
        $this->_USER_LANG = SecurityFilter($USER_LANG);
        $this->_LANG = $_lang;
    }
     /**
     * 当天事务检查
     */
    private function todayWorkCheck(){
        global $connection;
        $sql  = "SELECT TIME FROM sys_log order by LOG_ID DESC limit 0,1";
        $rs   = exequery($connection,$sql);
        $row  = mysql_fetch_array($rs);
        @mysql_free_result($rs);
        $date = substr($row['TIME'],0,10);
        if($date != date("Y-m-d")){
            today_action();
        }
    }
    /**
     * 验证用户输入图形验证码
     */
    private function verifyCheck(){
        $VERIFY         = isset($_POST['VERIFY']) ? $_POST['VERIFY'] : (isset($_GET['VERIFY']) ? $_GET['VERIFY'] : '');
        $PASS_IMG_NUM   = isset($_SESSION['verify_code']) ? $_SESSION['verify_code'] : '';
        if($VERIFY && session_is_registered("verify_code")){
            if($this->authcode(strtoupper($VERIFY)) != $PASS_IMG_NUM){
                $this->_LOGIN_ERROR = $this->_LANG["other_login_error_graphcode"];
                $this->_LOGIN_FLAG  = 0;
            }
        }else{
            $this->_LOGIN_ERROR = $this->_LANG["other_login_error_graphcode"];
            $this->_LOGIN_FLAG  = 0;
        }
    }
    /**
     * IP检验
     */
    private function ipCheck($USERNAME = ''){
        $USER_IP = $_SERVER["REMOTE_ADDR"];
        if(!check_ip($USER_IP,"0",$USERNAME)){
            add_log(9,"USER_ID=$USERNAME",$USERNAME);
            $this->_LOGIN_ERROR = str_replace("USER_IP",$USER_IP,$this->_LANG["other_login_error_ip"]);
            $this->_LOGIN_FLAG = 0;
        }
    }
    /**
     * 验证是否是离职人员或删除人员
     * @global type $connection
     * @param type $USER_ID
     */
    private function dimissionCheck($USER_ID = ''){
        global $connection;
        $dimission_sql  = "select DEPT_ID from user where USER_ID='".$USER_ID."'";
        $dimission_cs   = exequery($connection, $dimission_sql);
        if ($dimission_r = mysql_fetch_row($dimission_cs)) {
            $dept_id    = $dimission_r[0];
            if ($dept_id < 1) {
                $this->_LOGIN_FLAG      = 0;
                $this->_LOGIN_ERROR = $this->_LANG["other_login_error_userdeny"];
            }
        }
        @mysql_free_result($dimission_cs);
    }
    /**
     * @abstract 登录签到
     * @param type $LOGIN_USER_ACCOUNTS
     */
    private function userAttend($LOGIN_USER_ACCOUNTS){
        include_once("api/attend.class.php");
        $attendClass = new attend();
        $USER_IP = $_SERVER["REMOTE_ADDR"];
        if(check_ip($USER_IP,"1",$LOGIN_USER_ACCOUNTS)==false){
            echo  $this->_LANG["index_no_iprule"];
        } else {
            $attendClass->loginSignIn();
        }
    }
    /**
     * 发送短信动态密码
     * global $connection;
     */
    public function sendSmsPassword(){
        global $connection;
        $sql = "SELECT PARA_VALUE FROM sys_para WHERE PARA_NAME='DYNAMIC_LOGIN_SMS'";
        $rs  = exequery($connection,$sql);
        $row = @mysql_fetch_array($rs);
        @mysql_free_result($rs);
        $dynamicsms_format = $row['PARA_VALUE'];
        @session_start();//开启session机制
        @ob_start();//打开输出控制缓冲

        $TMP_LOGIN_USER_ID = $_SESSION["TMP_LOGIN_USER_ID"];
        include_once("inc/mobile_sms.inc.php");
        $newSms = new MobileSms();

        $sql = "SELECT UNIT_NAME FROM unit";
        $rs  = exequery($connection,$sql);
        $row = @mysql_fetch_array($rs);
        @mysql_free_result($rs);
        $UNIT_NAME    = $row['UNIT_NAME'];
        $sms_content  = $this->_LANG["other_login_pass"];
        $sms_passwd   = $this->randPassWd(6,$dynamicsms_format);
        $SMS_PASSWORD = $sms_passwd ;
        $_SESSION["SMS_PASSWORD"] = $SMS_PASSWORD;
        $sms_content .= $sms_passwd;
        $sms_content .= " ".$this->_LANG["other_login_you"].date("Y-m-d H:i").$this->_LANG["other_login"].$UNIT_NAME.$this->_LANG["other_login_system"];
        $newSms->SelfSendMore($TMP_LOGIN_USER_ID,$sms_content);
        echo 1;
    }
    /**
     * 短信动态密码验证
     */
    public function checkMsgPassword(){
        $msgPassword = isset($_POST['msgPassword']) ? $_POST['msgPassword'] : (isset($_GET['msgPassword']) ? $_GET['msgPassword'] : '');
        @session_start();
        if($msgPassword == $_SESSION['SMS_PASSWORD']){
            $_SESSION["LOGIN_USER_ID"] = $_SESSION['TMP_LOGIN_USER_ID'];
            if($_SESSION['LOGIN_USBKEY'])$this->usbCheckStart($_SESSION["LOGIN_USER_ID"],$_SESSION['LOGIN_USBKEY'],$_SESSION["USBKEY_PIN"]);
//            if(!$sid = input_survey()){
//                $sid = 0;
//            }
            echo 1;
        }else{
            echo 0;
        }
    }
    /**
     * 生成动态密码
     */
    private function randPassWd($len=6,$format="0"){
        switch($format) {
            case '0':
                $chars='ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
                break;
            case '1':
                $chars='ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789';
                break;
            case '2':
                $chars='abcdefghijklmnopqrstuvwxyz0123456789';
                break;
            case '3':
                $chars='ABCDEFGHIJKLMNOPQRSTUVWXYZ';
                break;
            case '4':
                $chars='abcdefghijklmnopqrstuvwxyz';
                break;
            case '5':
                $chars='0123456789';
                break;
            default :
                $chars='ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
                break;
        }
        mt_srand((double)microtime()*1000000*getmypid());
        $password='';
        while(strlen($password)<$len){
            $password .=substr($chars,(mt_rand()%strlen($chars)),1);
        }
        return $password;
    }
    /**
     * usb验证
     */
    private function usbCheckStart($USER_ID,$LOGIN_USBKEY,$USBKEY_PIN){
        if($_SESSION['LOGIN_USER_ID']){
            $TMP_LOGIN_USER_ID             = $_SESSION['LOGIN_USER_ID'];
            $_SESSION["LOGIN_USER_ID"]     = "";
            $_SESSION["TMP_LOGIN_USER_ID"] = $TMP_LOGIN_USER_ID;
        }else if($_SESSION['TMP_LOGIN_USER_ID'] == ""){
            $TMP_LOGIN_USER_ID         = $USER_ID;
            $_SESSION["TMP_LOGIN_USER_ID"] = $TMP_LOGIN_USER_ID;
        }
        $this->_LOGIN_FLAG = 3;
        $this->_LOGIN_ERROR = $this->_LANG['other_must_insert_usb_key'];
        if($USBKEY_PIN){
            $USBKEY_PIN = xxtea_decrypt(base64_decode($USBKEY_PIN),"usbkey");
        }else{
            $USBKEY_PIN = "123456";
        }
        echo json_encode(array('flag' => $this->_LOGIN_FLAG,'info' => $this->_LOGIN_ERROR,'loginUsbKey' => $LOGIN_USBKEY,'usbKeyPin' => $USBKEY_PIN,'userAccount'=>$_SESSION["LOGIN_USER_ACCOUNTS"]));
    }

    public function usbCheckEnd(){
        @session_start();
        if($_SESSION['TMP_LOGIN_USER_ID'] == ""){
            header("location: login.php");
            exit;
        }
        $LOGIN_USER_ID = $_SESSION['TMP_LOGIN_USER_ID'];
        $_SESSION["LOGIN_USER_ID"] = $LOGIN_USER_ID;
//        if(!$sid = input_survey()){
//            $sid = 0;
//        }
        header("location: /general/index9.php");
    }
    /* *
     * 加密图形验证码
     */
    private function authcode($str){
        $key = substr(md5($this->_SEKEY), 5, 8);
        $str = substr(md5($str), 8, 10);
        return md5($key . $str);
    }
}