<?php

/*
 * 解析页面内容
 * 参数 URL
 * 参数 请求数据
 * 参数 POST/GET
 * 
 * 
 */
include_once 'inc/reg_func.php';
include_once("api/regcheck.class.php");

class AppGlobal {

    public static function httpRequest($url, $post = '', $method = 'GET', $limit = 0, $returnHeader = FALSE, $cookie = '', $bysocket = FALSE, $ip = '', $timeout = 15, $block = TRUE) {
        $return = '';
        $matches = parse_url($url);

        !isset($matches['host']) && $matches['host'] = '';
        !isset($matches['path']) && $matches['path'] = '';
        !isset($matches['query']) && $matches['query'] = '';
        !isset($matches['port']) && $matches['port'] = '';

        $host = $matches['host'];
        $path = $matches['path'] ? $matches['path'] . ($matches['query'] ? '?' . $matches['query'] : '') : '/';
        $port = !empty($matches['port']) ? $matches['port'] : 80;

        if (strtolower($method) == 'post') {
            $post = (is_array($post) and ! empty($post)) ? http_build_query($post) : $post;
            $out = "POST $path HTTP/1.0\r\n";
            $out .= "Accept: */*\r\n";
            //$out .= "Referer: $boardurl\r\n";
            $out .= "Accept-Language: zh-cn\r\n";
            $out .= "Content-Type: application/x-www-form-urlencoded\r\n";
            $out .= "User-Agent: $_SERVER[HTTP_USER_AGENT]\r\n";
            $out .= "Host: $host\r\n";
            $out .= 'Content-Length: ' . strlen($post) . "\r\n";
            $out .= "Connection: Close\r\n";
            $out .= "Cache-Control: no-cache\r\n";
            $out .= "Cookie: $cookie\r\n\r\n";

            $out .= $post;
        } else {
            $out = "GET $path HTTP/1.0\r\n";
            $out .= "Accept: */*\r\n";
            //$out .= "Referer: $boardurl\r\n";
            $out .= "Accept-Language: zh-cn\r\n";
            $out .= "User-Agent: $_SERVER[HTTP_USER_AGENT]\r\n";
            $out .= "Host: $host\r\n";
            $out .= "Connection: Close\r\n";
            $out .= "Cookie: $cookie\r\n\r\n";
        }

        $fp = fsockopen(($ip ? $ip : $host), $port, $errno, $errstr, $timeout);

        if (!$fp)
            return '';
        else {
            $header = $content = '';

            stream_set_blocking($fp, $block);
            stream_set_timeout($fp, $timeout);
            fwrite($fp, $out);
            $status = stream_get_meta_data($fp);

            if (!$status['timed_out']) {//未超时
                while (!feof($fp)) {
                    $header .= $h = fgets($fp);
                    if ($h && ($h == "\r\n" || $h == "\n"))
                        break;
                }

                $stop = false;
                while (!feof($fp) && !$stop) {
                    $data = fread($fp, ($limit == 0 || $limit > 8192 ? 8192 : $limit));
                    $content .= $data;
                    if ($limit) {
                        $limit -= strlen($data);
                        $stop = $limit <= 0;
                    }
                }
            }
            fclose($fp);

            return $returnHeader ? array($header, $content) : $content;
        }
    }

    public static function getToken($url) {

        try {
            if (function_exists('curl_init')) {
                $ch = curl_init();
                curl_setopt($ch, CURLOPT_URL, $url);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
                curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
                curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
                curl_setopt($ch, CURLOPT_SSLVERSION, 1);
                $res = curl_exec($ch);
                if($res === false){
                     $res = array(
                        "errcode" => "0x100003",
                        "errmsg" => curl_error($ch)
                     );
                      $res = json_encode($res);
                }
                curl_close($ch);
            } else {

                $res = array(
                    "errcode" => "0x100001",
                    "errmsg" => "CURL扩展没有开启!"
                );
                $res = json_encode($res);
            }
        } catch (Exception $exc) {

            $res = array(
                "errcode" => "0x100002",
                "errmsg" => $exc->getTraceAsString()
            );
            
            $res = json_encode($res);
        }
 
        return $res;
    }

    public static function getHttps($url, $postFields = '', $json = false) {


//        if (!$json) {
//            $heard = array('Content-Type: application/x-www-form-urlencoded; charset=utf-8');
//        } else {
//            $heard = array('Content-Type: application/json; charset=utf-8');
//        }
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); //禁止直接显示获取的内容 重要
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10); //10秒
        curl_setopt($ch, CURLOPT_FAILONERROR, FALSE);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        curl_setopt($ch, CURLOPT_POST, TRUE);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $postFields);
        if (strlen($url) > 5 && strtolower(substr($url, 0, 5)) == 'https') {
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
            curl_setopt($ch, CURLOPT_SSLVERSION, 1);
        }
//        curl_setopt($ch, CURLOPT_HTTPHEADER, $heard);
        $result = curl_exec($ch);
        curl_close($ch);

        return $result;
    }

    //远程获取 微信token

    public static function curl_get_weixin_token($url, $filename) { // /weixin/get_token.txt
        //去微信获取，然后保存
        $TOKEN = AppGlobal::getHttps($url);
        $TOKEN_json = json_decode($TOKEN, true);
        $TOKEN_json['get_token_time'] = time();
        file_put_contents(ROOT_PATH . 'general' . $filename, json_encode($TOKEN_json)); //保存到本地 
        return $TOKEN_json;
    }

    //本地获取 微信token（如果不成功或者超时，就去远程获取）
    public static function file_get_weixin_token($now_time, $url, $filename) {
        //去微信获取，然后保存
        $get_local_token = file_get_contents(ROOT_PATH . 'general' . $filename);
        $token_array = json_decode($get_local_token, true);

        //判断本地的weixin_token是否存在
        if (!is_array($token_array) || !isset($token_array['get_token_time'])) {
            //去微信获取，然后保存
            $token_array = AppGlobal::curl_get_weixin_token($url, $filename);
        } else {
            //判断 当前时间 减去 本地获取微信token的时间 大于7000秒 ,就要重新获取
            if ($now_time - $token_array['get_token_time'] > 7000) {
                $token_array = AppGlobal::curl_get_weixin_token($url, $filename);
            }
        }
        return $token_array;
    }

    public static function getModApp($funcid = "") {

        $regcheck = new regcheck();
        $checkFlag = $regcheck->checkSys();
        if (!$checkFlag) {
            return -1; //Message("", "授权许可已经过期或者未注册授权", "failed");
        }

//正式客户 需要读取模块授权信息
        global $IS_REGISTERED_MYOA;
        global $IS_OFFICIAL_CLIENT;
        global $connection;
        $machineCode = get_machine_code(1);
        if ($IS_REGISTERED_MYOA && $IS_OFFICIAL_CLIENT) { // 正式用户 模块授权
            $verifyFile = BIN_PATH . "auth/" . md5($machineCode . "eoffice9731") . ".evf";
            if (file_exists($verifyFile)) {
                $moduleVerifyInfor = json_decode(authcode(file_get_contents($verifyFile), "DECODE"), true);

                // 传递 模块的NN
                if ($funcid == "新建中心") {
                    return 1; //  通过
                } else if ($funcid) {
                    $where = "  AND s.FUNC_ID = '" . $funcid . "'";
                } else {
                    $where = ""; //
                }
                $query = "SELECT s.FUNC_ID ,m.FUNC_NAME FROM  sys_function  AS s JOIN  menu_lang  AS m ON s.FUNC_ID = m.FUNC_ID  WHERE LENGTH(MENU_ID) = 2 AND s.FUNC_ISEOFFICE  = 1" . $where;

                $result = exequery($connection, $query);
                while ($row = mysql_fetch_array($result)) {
                    $funcID = $row["FUNC_ID"];
                    if (is_array($moduleVerifyInfor) && array_key_exists($funcID, $moduleVerifyInfor)) {
                        if ($moduleVerifyInfor[$funcID] != "") {
                            if (strtotime(date("Y-m-d")) > strtotime($moduleVerifyInfor[$funcID])) {

                                return -4; // Message("", "试用结束(试用结束日期 ' . $moduleVerifyInfor[$funcID] . ')", "failed");
                            }
                        }
                    } else {
                        return -3; // Message("", "未授权", "failed");
                    }
                }
            } else {
                return -2; //Message("", "授权文件不存在,请联系泛微", "failed");
            }
        }

        return 1;
    }

}
