<?php



class EverDatabase {

  var $className = "EverDatabase";

  var $dbHost;
  var $dbUser;
  var $dbPass;
  var $dbName;

  var $conn;
  var $stmt;
  var $record;
  var $rows;
  var $maxRows;
  var $orgMaxRows;

  var $dbError;
  var $debug;
  var $sqlArray;
  var $sqlIdx;
  var $printDebug;


  function EverDatabase($parr) {

    $this->dbHost               = $parr["dbHost"];
    $this->dbUser               = $parr["dbUser"];
    $this->dbPass               = $parr["dbPass"];
    $this->dbName               = $parr["dbName"];

    $this->maxRows              = 200;
    $this->orgMaxRows           = 200;
    $this->debug                = $parr["debug"];
    $this->email                = $parr["email"];
    $this->printDebug           = $parr["printDebug"];

    $this->conn                 = "";
    $this->stmt                 = "";
    $this->record               = "";
    $this->rows                 = 0;
    $this->dbError              = "";
    $this->sqlArray             = array();
    $this->sqlIdx               = 0;
  }

  function haltOnError($resType = "", $dbError = "", $sqltext = "") {
    if ($resType == "init") {
      $this->dbError = $dbError;
    }
    else {
      $this->dbError["code"]      = @mysql_errno();
      $this->dbError["message"]   = @mysql_error();
    }
    if ($this->debug and $this->dbError["code"] != "1062") {
      @$this->rollback();
      @$this->freeStmt();
      @$this->closeConn();
      if ($sqltext != "") {
        $this->dbError["sqltext"] = $sqltext;
      }
      echo "<html><head><style>body {background-color: #FFFFFF; font-family: 宋体; font-size:85%}";
      echo "table {border-collapse: collapse;border-style: solid;border-width: 1px;border-color: #67CEFA;}";
      echo "td {font-family: 宋体; font-size: 85%;border-collapse: collapse;";
      echo "border-style: solid;  border-color: #67CEFA;border-width: 1px;}</style></head><body>";
      echo "<font size=3 color=blue><br><p align=\"center\">SQL Debug Infomation<br></font>";
      echo "<table align=\"center\" width=\"700\">";
      echo "<tr><td>code: </td><td>" . $this->dbError["code"] . "</td></tr>";
      echo "<tr><td>message: </td><td>" . $this->dbError["message"] . "</td></tr>";
      echo "<tr><td>sqltext: </td><td>" . wordwrap($this->dbError["sqltext"], 100, "<br />") . "</td></tr>";
      echo "</table><br><br>";
      echo "<p align=\"center\">sqltext by one line<p align=\"left\">" . $this->dbError["sqltext"] . "";
      echo "<br><br><font size=3 color=blue><br><p align=\"center\">SQL History<br></font>";
      echo "<table align=\"center\" width=\"700\">";
      if ($this->printDebug) {
        $sql_cnt = count($this->sqlArray);
        for ($i = 0; $i < $sql_cnt; $i++) {
          if ($i == $sql_cnt - 2) {
            echo "<tr><td><font color=blue>sql[$i]</font></td><td>" . wordwrap($this->sqlArray[$i], 80, "<br />") . "</td></tr>";
          }
          else {
            echo "<tr><td>sql[$i]</td><td>" . wordwrap($this->sqlArray[$i], 80, "<br />") . "</td></tr>";
          }
        }
      }
      echo "</table><br>";
      echo "</body><html>";
      exit;
    }
    return false;
  }

  function getEmail() {
    return $this->email;
  }

  function getDbError() {
    return $this->dbError;
  }


  function resetMaxRows() {
    $this->maxRows = $this->orgMaxRows;
  }


  function setMaxRows($rowCnt) {
    $this->maxRows = $rowCnt;
  }


  function captureUniqueKey($idx = 2) {
    if ($this->dbError["code"] == "1062" and strrchr($this->dbError["message"], " ") == $idx) {
      return true;
    }
    else {
      return false;
    }
  }


  function getConn() {
    if (!$this->conn) {
		
      if (!$this->conn = @mysql_connect($this->dbHost, $this->dbUser, $this->dbPass)) {
		   return $this->haltOnError();
      }
      if (!@mysql_select_db($this->dbName, $this->conn)) {
        
		return $this->haltOnError();
      }
    }
	
    return true;
  }


  function startTransaction() {
    @mysql_query("START TRANSACTION");
    $this->sqlArray[$this->sqlIdx++] = "START TRANSACTION";
  }


  function nextTransaction($type = "AUTO") {
    if ($type == "AUTO" ) {
      if (!$this->dbError) {
        $nts = "COMMIT";
      }
      else {
        $nts = "ROLLBACK";
      }
    }
    else {
      $nts = ($type == "COMMIT") ? "COMMIT" : "ROLLBACK";
    }
    @mysql_query($nts);
    $this->sqlArray[$this->sqlIdx++] = $nts;
    @mysql_query("START TRANSACTION");
    $this->sqlArray[$this->sqlIdx++] = "START TRANSACTION";
  }


  function executeQuery($sql) {
    $this->rows = 0;
    $this->sqlArray[$this->sqlIdx++] = $sql;
    if (!$this->stmt = @mysql_query($sql, $this->conn)) {
      return $this->haltOnError("", "", $sql);
    }
    return true;
  }


  function getRecordSet() {
    $this->rows = 0;
    $this->record = array();
    while ($this->rows < $this->maxRows) {
      if (!$row = @mysql_fetch_assoc($this->stmt)) {
        break;
      }
      $this->record[$this->rows] = $row;
      $this->rows++;
    }
    @mysql_free_result($this->stmt);
    if ($this->rows <= 0) {
      return 0;
    }
    return $this->record;
  }


  function commit() {
    @mysql_query("COMMIT");
    $this->sqlArray[$this->sqlIdx++] = "COMMIT";
  }


  function rollback() {
    @mysql_query("ROLLBACK");
    $this->sqlArray[$this->sqlIdx++] = "ROLLBACK";
  }


  function getRows() {
    return $this->rows;
  }


  function getNumRows() {
    return @mysql_num_rows($this->stmt);
  }


  function getAffectedRows() {
    return @mysql_affected_rows($this->conn);
  }


  function getNF() {
    return @mysql_num_fields($this->stmt);
  }


  function myInfo() {
    return @mysql_info($this->conn);
  }


  function freeStmt() {
    @mysql_free_result($this->stmt);
  }


  function closeConn() {
    @mysql_close($this->conn);
    /*
    if ($this->printDebug == true) {
      echo "<font size=3 color=blue><br><p align=\"center\">Debug Infomation:<br><table width=\"80%\" align=\"center\" border=\"1\">";
      $sq_cnt = count($this->sqlArray);
      for ($i = 0; $i < $sql_cnt; $i++) {
        echo "<tr><td>sql[$i]</td><td>" . $this->sqlArray[$i] . "</td></tr>";
      }
      echo "</table><br></font>";
    }
    */
  }


  function setDebug($tof = false) {
    $this->debug = $tof;
  }

  function getDebug() {
    return $this->debug;
  }

}


?>