Ext.onReady(function(){ 
    Ext.QuickTips.init();
    // 格式化性别显示,这是个 renderer, 渲染器

    function formatImportent(value) {
        return value==1 ? ExtLang.Attention : ExtLang.NoAttention; 
    };
    function formatType(value) {
        return value==1 ? BatchCreateLang.Required : BatchCreateLang.NoRequired; 
    };
    function formatProperty(value) {
        return value==1 ? ExtLang.Character : ExtLang.TimeCharacter; 
    };
    // 弄个缩写的别名 
    var fm = Ext.form; 
    // 列模型定义了表格所有列的信息, 
    // dataIndex 将特定的列映射到数据源(Data Store)中的数据列(在后面创建) 
    var cm = new Ext.grid.ColumnModel([ 
        { 
           id:'id', 
           header: ExtLang.ShowNumber, 
           dataIndex: 'id', 
           width: 50 
        }, 
        { 
           id:'name', 
           header: ExtLang.StringName, 
           dataIndex: 'name', 
           width: 120, 
           editor: new fm.TextField({ 
               allowBlank: false// 不能为空 
           })
        },
        {
           header: ExtLang.StringNature, 
           dataIndex: 'property', 
           width: 100, 
           renderer: formatProperty,
           editor: new Ext.form.ComboBox({ 
               typeAhead: true, 
               triggerAction: 'all', 
               transform:'select_1',// 对应的选择框的ID 
               lazyRender:true, 
               listClass: 'x-combo-list-small' 
            })
        },
        {
           header: BatchCreateLang.IsRequired, 
           dataIndex: 'type',
           width: 95,
           renderer: formatType, 
           editor: new Ext.form.ComboBox({ 
               typeAhead: true, 
               triggerAction: 'all', 
               transform:'select_3',// 对应的选择框的ID 
               lazyRender:true, 
               listClass: 'x-combo-list-small' 
            })
        },
        {
           header: ExtLang.IsAttention, 
           dataIndex: 'importent',
           width:95,
           renderer: formatImportent, 
           editor: new Ext.form.ComboBox({ 
               typeAhead: true, 
               triggerAction: 'all', 
               transform:'select_2',// 对应的选择框的ID 
               lazyRender:true, 
               listClass: 'x-combo-list-small' 
            }) 
        },
        {
           header: ExtLang.StringShow, 
           dataIndex: 'explain',
           width: 295,
            editor: new fm.TextField({ 
               allowBlank: true// 不能为空 
           })
        }
    ]); 

    // 默认情况下列是可排序的 
    cm.defaultSortable = true; 

    // 定义一个用户对象,这样便于我们动态的添加记录,虽然也可以设置成匿名内置对象 
    var Field = Ext.data.Record.create([ 
           // 下面的 "name" 匹配读到的标签名称

           {name: 'id', type: 'int' }, 
           {name: 'name', type: 'string'}, 
           {name: 'property', type: 'int'}, 
           {name: 'type', type: 'int'}, 
           {name: 'importent', type: 'int'},
           {name: 'explain', type: 'string'} 
      ]); 

    // 创建 Data Store 
    var store = new Ext.data.Store({ 
        // 使用 HTTP 加载 
        url: '/general/address/pubcenter/user.xml', 

        // 因为返回值是 XML, 所以我们创建一个解析器 
        reader: new Ext.data.XmlReader({ 
               // 记录必须包含 "user" 标签 
               record: 'field' 
           }, Field), 

        sortInfo:{field:'name', direction:'ASC'}// 排序信息 
    }); 
    // 创建编辑器表格 
    var grid = new Ext.grid.EditorGridPanel({ 
        store: store, 
        cm: cm, 
        renderTo: 'editor-grid', 
        height:500, 
        width:900,
        autoExpandColumn:'name', 
        title:ExtLang.StringManager,// 标题 
        frame:true, 
        clicksToEdit:1,//设置点击几次才可编辑 
        selModel: new Ext.grid.RowSelectionModel({singleSelect:false}),//设置单行选中模式, 否则将无法删除数据 
        loadMask: true,
	
        // 顶部工具栏按钮 
        tbar:[{
            text:BatchCreateLang.Create,
            tooltip:BatchCreateLang.CreateOne,
            iconCls:'add',
            handler:handleAdd
        }, '-', {
            text:ExtLang.Modification,
            tooltip:ExtLang.Modification,
            iconCls:'option',
            handler:handleEdit
        },'-',{
            text:EOlang.msgdel,
            tooltip:ExtLang.DeleteRecord,
            iconCls:'remove',
            handler:handleDelete
        }]
    }); 

    // 单元格编辑后事件处理 
    grid.render();
    // 触发数据加载 
     store.load();
     //员工信息表单
     var EmpForm = new Ext.FormPanel({
        frame: true,
        labelAlign: 'right',
        labelWidth: 120,
        width: 450,
        height:250,
        items: new Ext.form.FieldSet({
                title: ExtLang.UserInformation,
                autoHeight: true,
                defaults: {width: 200},
                defaultType: 'textfield',
        items: [new Ext.form.Hidden({
                name: 'EmployeeID'
            }),{
                fieldLabel: EOlang.msgFullName,
                name: 'CnName',
                allowBlank:false
            },new Ext.form.ComboBox({
                fieldLabel: EOlang.msgUserSex,
                hiddenName:'Sex',
                store: new Ext.data.SimpleStore({
                    fields: ['value', 'text'],
                    data : [[1,EOlang.msgUserSexMan],[0,EOlang.msgUserSexWoman]]
                }),
                valueField:'value',
                displayField:'text',
                typeAhead: true,
                mode: 'local',
                triggerAction: 'all',
                selectOnFocus:true,
                allowBlank:false
            }),new Ext.form.NumberField({
                fieldLabel: ExtLang.UserAge,
                name: 'Age'
            }), {
                fieldLabel: 'Email',
                name: 'Email',
                vtype:'email'
            }, new Ext.form.DateField({
                            fieldLabel: ExtLang.WorkInDate,
                            name: 'OnWorkDate',
                            allowBlank:false,
                            format : "Y-m-d"
            }), new Ext.form.ComboBox({
                            fieldLabel: ExtLang.WorkInDepart,
                            name: 'DepartmentName',
                            hiddenName: 'DepartmentID',
                            store: deptDs,
                            valueField: 'DeptID',
                            displayField: 'DeptName',
                            typeAhead: true,
                            mode: 'remote',
                            triggerAction: 'all',
                            emptyText: ExtLang.ChooseDeart,
                            selectOnFocus: true,
                            allowBlank: false
                        })
            ]
         })
    });
   
    
     function handleAdd(){
       var AddEmpWin = new Ext.Window({
                title: ExtLang.AddNewUser,
                layout:'fit',
                width:500,
                height:300,
                plain: true,
                items:EmpForm,
                buttons: [{
                    text:EOlang.msgSaveEdit,
                    handler: AddRecord
                },{
                    text: EOlang.msgRemove,
                    handler: function(){
                        AddEmpWin.hide();
                    }
                }]
     });
        AddEmpWin.show(this);
    }  
    function handleEdit(){
     var selectedKeys = grid.selModel.selections.keys; //returns array of selected rows ids only
            if(selectedKeys.length != 1){
                Ext.MessageBox.alert(EOlang.msgGiveWhy,ExtLang.ChooseOneRecord);
            }    
            else {
            var EditEmpWin = new Ext.Window({
                title: ExtLang.ModiUserInformation,
                layout:'fit',
                width:500,
                height:300,
                plain: true,
                items:EmpForm,
                buttons: [{
                    text:EOlang.msgSaveEdit,
                    handler: UpdateRecord
                },{
                    text: EOlang.msgRemove,
                    handler: function(){
                        EditEmpWin.hide();
                    }
                }]
     });
        EditEmpWin.show(this);
        //Ext.MessageBox.alert("提示",selectedKeys);
          deptDs.load(); //取得科室列表
        var request = {empID:selectedKeys[0]};
             Ext.MessageBox.show({
                           msg: ExtLang.ShowMsg,
                           progressText: ExtLang.NowShowMsg,
                           width:300,
                           wait:true,
                           waitConfig: {interval:200}
                     });
            Ext.Ajax.request({
                    url: '/EmployeeService.svc/GetEmployee', //url to server side script
                    method: 'POST', 
                    params:Ext.util.JSON.encode(request),//the unique id(s)
                    callback: function (options, success, response) {
                        if (success) { //success will be true if the request succeeded
                              Ext.MessageBox.hide();
                              var formvalue=ConvertResponseText(response.responseText,"OnWorkDate",true,true);
                              EmpForm.form.setValues(formvalue);
                        } else {
                             Ext.MessageBox.hide();
                             Ext.MessageBox.alert(ExtLang.FailTry,response.responseText);
                        }
                    },
                    //the function to be called upon failure of the request (server script, 404, or 403 errors)
                    failure:function(response,options){
                        Ext.MessageBox.hide();
                        ReturnValue = Ext.MessageBox.alert(EOlang.msgLostWring,EOlang.msgLostWringAlert);
                    },  
                    success:function(response,options){
                        Ext.MessageBox.hide();
                    }                                    
          })// end Ajax request 
        }
    }  
    function UpdateRecord(btn)
    {
        if (EmpForm.form.isValid()) {
                btn.disabled=true;
                Ext.MessageBox.show({
                       msg: ExtLang.ShowMsg,
                       progressText: ExtLang.NowShowMsg,
                       width:300,
                       wait:true,
                       waitConfig: {interval:200}
                 });
                 var formvalue = EmpForm.form.getValues();
                 var request = {emp:ConvertFormValue(formvalue,'OnWorkDate')};
                 //Ext.MessageBox.alert("提示",formvalues); 
                Ext.Ajax.request({
                        url: '/EmployeeService.svc/UpdateEmployee', //url to server side script
                        method: 'POST', 
                        params:Ext.util.JSON.encode(request),//the unique id(s)
                        callback: function (options, success, response) {
                            if (success) { //success will be true if the request succeeded
                                  Ext.MessageBox.hide();
                                  var alertcontent=ConvertResponseText(response.responseText,"",true,false);
                                  Ext.MessageBox.alert(EOlang.msgRequetOK,alertcontent);
                            } else {
                                 Ext.MessageBox.hide();
                                 Ext.MessageBox.alert(ExtLang.FailTry,response.responseText);
                            }
                        },
                        //the function to be called upon failure of the request (server script, 404, or 403 errors)
                        failure:function(response,options){
                            Ext.MessageBox.hide();
                            ReturnValue = Ext.MessageBox.alert(EOlang.msgLostWring,EOlang.msgLostWringAlert);
                        },  
                        success:function(response,options){
                            Ext.MessageBox.hide();
                            store.reload();
                        }                                    
              })// end Ajax request 
         }
    }    
    
    function AddRecord(btn)
    {
        if (EmpForm.form.isValid()) {
          btn.disabled=true;
                   Ext.MessageBox.show({
                       msg: ExtLang.ShowMsg,
                       progressText: ExtLang.NowShowMsg,
                       width:300,
                       wait:true,
                       waitConfig: {interval:200}
                 });
                 var formvalue = EmpForm.form.getValues();
                 var request = {emp:ConvertFormValue(formvalue,'OnWorkDate')};
                 //Ext.MessageBox.alert("提示",formvalues); 
                Ext.Ajax.request({
                        url: '/EmployeeService.svc/AddEmployee', //url to server side script
                        method: 'POST', 
                        params:Ext.util.JSON.encode(request),//the unique id(s)
                        callback: function (options, success, response) {
                            if (success) { //success will be true if the request succeeded
                                  Ext.MessageBox.hide();
                                  var alertcontent=ConvertResponseText(response.responseText,"",true,false);
                                  Ext.MessageBox.alert(EOlang.msgRequetOK,alertcontent);
                            } else {
                                 Ext.MessageBox.hide();
                                 Ext.MessageBox.alert(ExtLang.FailTry,response.responseText);
                            }
                        },
                        //the function to be called upon failure of the request (server script, 404, or 403 errors)
                        failure:function(response,options){
                            Ext.MessageBox.hide();
                            ReturnValue = Ext.MessageBox.alert(EOlang.msgLostWring,EOlang.msgLostWringAlert);
                        },  
                        success:function(response,options){
                            Ext.MessageBox.hide();
                            store.reload();
                        }                                    
              })// end Ajax request 
                
        }
    }
    
    function handleDelete(){
      var selectedKeys = grid.selModel.selections.keys; //returns array of selected rows ids only
            if(selectedKeys.length > 0)
            {
                Ext.MessageBox.confirm(EOlang.msgGiveWhy,EOlang.msgDeleteAlert, deleteRecord);
            }
            else
            {
                Ext.MessageBox.alert(EOlang.msgGiveWhy,EOlang.msgSelectRecode);
            }//end
    }  
   
    function deleteRecord(btn){
         if(btn=='yes'){
              var selectedRows = grid.selModel.selections.items;//returns record objects for selected rows (all info for row)
                var selectedKeys = grid.selModel.selections.keys; 
                //var deleteresult = AjaxRequest('/EmployeeService.svc/DelEmployee',selectedKeys,false,"")
                Ext.MessageBox.show({
                       msg: ExtLang.ShowMsg,
                       progressText: ExtLang.NowShowMsg,
                       width:300,
                       wait:true,
                       waitConfig: {interval:200}
                 });
                Ext.Ajax.request({
                        url: '/EmployeeService.svc/DelEmployee', //url to server side script
                        method: 'POST', 
                        params:Ext.util.JSON.encode(selectedKeys),//the unique id(s)
                        callback: function (options, success, response) {
                            if (success) { //success will be true if the request succeeded
                                  Ext.MessageBox.hide();
                                   var alertcontent=ConvertResponseText(response.responseText,"",false,false);
                                  Ext.MessageBox.alert(EOlang.msgRequetOK,alertcontent);
                            } else {
                                 Ext.MessageBox.hide();
                                 Ext.MessageBox.alert(ExtLang.FailTry,response.responseText);
                            }
                        },
                        //the function to be called upon failure of the request (server script, 404, or 403 errors)
                        failure:function(response,options){
                            Ext.MessageBox.hide();
                            ReturnValue = Ext.MessageBox.alert(EOlang.msgLostWring,EOlang.msgLostWringAlert);
                        },  
                        success:function(response,options){
                            Ext.MessageBox.hide();
                            store.reload();
                        }                                    
              })// end Ajax request 
         }//end if click 'yes' on button
    } // end deleteRecord
});
