/**
 *@Copyright (C) 2010 - 2011 Weaver Co.Ltd
 *@systemname:       E-Office
 *@filename:         common.js
 *@function:         include public js function.
 *@encoding:         $_lang['encoding']
 *@author:           www.weaver.com.cn
 *@modify:			 liuqingyu
 *@date:             2012-12-13
 *@file Version:     23.0
 *@eoffice Version:  8.3
*/

//---获取光标位置函数
function getPosition(obj)
{
	var result = 0;
	if(obj.selectionStart)
	{ //非IE浏览器
	   result = obj.selectionStart;
	}
	else
	{ //IE
	   var rng;
	   if(obj.tagName == "TEXTAREA")
	   { //如果是文本域
			obj.focus();
			var Sel  = document.selection.createRange();
			var Sel2 = Sel.duplicate();
			Sel2.moveToElementText(obj);
			var result = -1;
			while(Sel2.inRange(Sel))
			{
				Sel2.moveStart('character');
				result++;
			}
	   }
	   else
	   { //输入框
			rng = document.selection.createRange();
			rng.moveStart("character",-event.srcElement.value.length);
	   		result = rng.text.length;
	   }
	}
	return result;
}

//---设置光标位置函数
function setCursorPosition(ctrl, pos)
{
	if(ctrl.setSelectionRange)
	{ //非IE浏览器
		ctrl.focus();
		ctrl.setSelectionRange(pos,pos);
	}
	else if (ctrl.createTextRange)
	{ //IE
		var range = ctrl.createTextRange();
		range.collapse(true);
		range.moveEnd('character', pos);
		range.moveStart('character', pos);
		range.select();
	}
}
/*	屏蔽特殊字符函数
	@modify zhucx 19422 2015-05-25
		在处理该缺陷时,将原本表单输入域onkeyup事件改为blur事件,导致页面在谷歌浏览器中无法选中其他输入框,
		故将该函数最后一步'调用setCursorPosition()函数'注释掉,不让它重新设置光标位置
*/
function characters_change(obj,level)
{
	var str       = obj.value;
	if(level=="low")
	{
		var pattern   = new RegExp("['\"|<>]");
		var validChar = /^[^\|"'<>]*$/;
	}
	else if(level=="high")
	{
		var pattern   = new RegExp("[`·~!@#$%^&*()+|<>?/,.;:'=\\-_{}\\[\\]\\\\《》\"~！@#￥&*（）——|{}【】‘；：”“'。，、？]");
		var validChar = /^[\u4e00-\u9fa5\da-zA-Z\s]+$/;
	}
	//var pos       = getPosition(obj);
	//辨别特殊字符
	if(validChar.test(obj.value))
	{
		obj.value = obj.value;
		//setCursorPosition(obj,pos);
	}
	else
	{
		if(pattern.test(obj.value))
		{
			//alert(CommonLang.specialCharTip+"！");
			$.pnotify({
		        text: CommonLang.specialCharTip+"！",
		        type : "error"
		    });
		}
		rs = "";
		for(var i = 0; i < obj.value.length; i++)
		{
			rs += obj.value.substr(i, 1).replace(pattern, '');
		}
		obj.value = rs;
		//setCursorPosition(obj,pos-1);
	}
}
//---屏蔽图片名称特殊字符
function AttachmentNameCheck(name)
{
	var pattern = /^[^\|"'<>#%]*$/;
	if(pattern.test(name))
	{
		return true;
	}
	else
	{
		return false;
	}
}
//引用js/css文件;
function include(path,type,title){
	var s,i,t;
	if(arguments.length < 1){
		return ;
	}
	if(arguments.length == 1){
		type = "js";
	}
	switch(type.toLowerCase()){
		case "css":
				t = document.getElementsByTagName("link");
				for(i=0;i<t.length;i++){
					if(t[i].href && t[i].href.indexOf(path)!=-1){
						return;
					}
				}
				s=document.createElement("link");
				s.rel="alternate stylesheet";
				s.type="text/css";
				s.href=path;
				s.title=title;
				s.disabled=false;
				break;
		case "js":
		case "javascript":
		default:
				t = document.getElementsByTagName("script");
				for(i=0;i<t.length;i++){
					if(t[i].src && t[i].src.indexOf(path)!=-1){
						return;
					}
				}
				s=document.createElement("script");
				s.type="text/javascript";
				s.src=path;
			break;
	}
	var h=document.getElementsByTagName("head")[0];
	h.appendChild(s);
}
//字符处理;
//去左右空格;
function trim(s){
 	return rtrim(ltrim(s));
}
//去左空格;
function ltrim(s){
 	return s.replace( /^\s*/, "");
}
//去右空格;
function rtrim(s){
 	return s.replace( /\s*$/, "");
}
//验证信息;
//空字符值;
function isEmpty(s){
	s = trim(s);
	return s.length == 0;
}
//变量是否定义
function isset(s){
	if(typeof s == 'undefined'){
		return false;
	}else if(s == null){
		return false;
	}
	return true;
}
//Email;
function isEmail(s){
	s = trim(s);
 	var p = /^[_\.0-9a-z-]+@([0-9a-z][0-9a-z-]+\.){1,4}[a-z]{2,3}$/i;
 	return p.test(s);
}
//数字;
function isNumber(s){
	return !isNaN(s);
}
//颜色值;
function isColor(s){
	s = trim(s);
	if (s.length !=7) return false;
	return s.search(/\#[a-fA-F0-9]{6}/) != -1;
}
//手机号码;
function isMobile(s){
	s = trim(s);
	var p = /13\d{9}/;
	return p.test(s);
}
//身份证;
function isCard(s){
	s = trim(s);
	var p = /^\d{15}(\d{2}[xX0-9])?$/;
	return p.test(s);
}
//URL;
function isURL(s){
	s = trim(s).toLowerCase();
	var p = /^http:\/\/[A-Za-z0-9]+\.[A-Za-z0-9]+[\/=\?%\-&_~`@[\]\':+!]*([^<>\"\"])*$/;
	return p.test(s);
}
//Phone;
function isPhone(s){
	s = trim(s);
	var p = /^((\(\d{3}\))|(\d{3}\-))?(\(0\d{2,3}\)|0\d{2,3}-)?[1-9]\d{6,7}$/;
	return p.test(s);
}
//Zip;
function isZip(s){
	s = trim(s);
	var p = /^[1-9]\d{5}$/;
	return p.test(s);
}
//Double;
function isDouble(s){
	s = trim(s);
	var p = /^[-\+]?\d+(\.\d+)?$/;
	return p.test(s);
}
//Integer;
function isInteger(s){
	s = trim(s);
	var p = /^[-\+]?\d+$/;
	return p.test(s);
}
//English;
function isEnglish(s){
	s = trim(s);
	var p = /^[A-Za-z]+$/;
	return p.test(s);
}
//中文;
function isChinese(s){
	s = trim(s);
	var p = /^[\u0391-\uFFE5]+$/;
	return p.test(s);
}
//双字节
function isDoubleChar(s){
	var p = /^[^\x00-\xff]+$/;
	return p.test(s);
}
//含有中文字符
function hasChineseChar(s){
	var p = /[^\x00-\xff]/;
	return p.test(s);
}
//特殊符号(包括中文字符)
function hasAccountChar(s){
	var p = /^[a-zA-Z0-9][a-zA-Z0-9_-]{0,15}$/;
	return p.test(s);
}
function limitLen(s,Min,Max){
	s=trim(s);
	if(s=="") return false;
	if((s.length<Min)||(s.length>Max))
		return false;
	else
		return true;
}
//检查日期是否正确
function checkDate(pFMT,pDate)
{
	var ResultOK = null
	var RegDateDot = /\d{4}\.{1}\d{1,2}\.{1}\d{1,2}/
	var RegDateLine = /\d{4}-{1}\d{1,2}-{1}\d{1,2}/

	switch (pFMT)
	{
		case 1:
			ResultOK = RegDateDot.test(pDate)
			break
		case 2:
			ResultOK = RegDateLine.test(pDate)
			break
		default:
			ResultOK = RegDateDot.test(pDate)
			break
	}

	if(!ResultOK)
	{
	   return false
	}

	var mYear = 0,mMonth = 0,mDay = 0
	var iPos1 = 0,iPos2 = 0
	var sDate = pDate.toString()
	var mSepChar = ((pFMT == 1) ? ".":"-")

	var MonthDays = new Array(null,31,28,31,30,31,30,31,31,30,31,30,31)

	iPos1 = sDate.indexOf(mSepChar)
	iPos2 = sDate.indexOf(mSepChar,iPos1+1)

	mYear = sDate.substring(0,iPos1)
	mMonth = sDate.substring(iPos1+1,iPos2)
	mDay = sDate.substr(iPos2+1)

	if(mYear <= 0 || mYear > 9999)
	{
		return false
	}
	if (mYear.length > 4)
	{
		return false
	}

	mMonth = parseInt(mMonth,10);

	if(mMonth <= 0 || mMonth > 12)
	{
		return false
	}
	if (mMonth.length > 2)
	{
		return false
	}

	var RightDay = 0
	if(mMonth == 2)
		RightDay = (((mYear%4 == 0) && (mYear%100 != 0) || (mYear%400 == 0))? 29: 28)
	else {
		RightDay = MonthDays[mMonth];
	}

	if (mDay.length > 2)
	{
		return false
	}

	if(mDay <= 0 || mDay > RightDay)
	{
		return false
	}

	return true
}

function checkTime(n,t){
       var pattern = /^(\d|([0-1]\d)|(2[0-4])):(\d|([0-5]\d))$/;
       if( t != "" && !pattern.test(t)) {
              return false;
       }
	   return dcheckTime(t);
}


//check time
function dcheckTime(t) {

	var x = ":";
	var p = "his";
	var a = t.split(x);
	var sh = a[p.indexOf("h")];
	var si = a[p.indexOf("i")];

	var h = parseInt(sh,10);
	var i = parseInt(si,10);

	if (h==24 && i > 0){
		return false;
	}

	return true;
}

function betterDate(strDateStart,strDateEnd){
   var strSeparator = "-";
   var strDateArrayStart;
   var strDateArrayEnd;
   var intDay
   strDateArrayStart = strDateStart.split(strSeparator);
   strDateArrayEnd = strDateEnd.split(strSeparator);
   var strDateS = new Date(strDateArrayStart[0] + "/" + strDateArrayStart[1] + "/" + strDateArrayStart[2]);
   var strDateE = new Date(strDateArrayEnd[0] + "/" + strDateArrayEnd[1] + "/" + strDateArrayEnd[2]);
   intDay = (strDateS-strDateE)/(1000*3600*24)
   return intDay
}
//功能;
//延时事件;
function setDeferEvent(type,action,time){
	if (trim(time).length == 0) time = 1;
	if (typeof(time)!="number") time = 1;

	switch(type.toLowerCase()){
		case "go":
			window.setTimeout("window.location='"+ action +"'",time);
			break;
		case "alert":
			window.setTimeout("alert('"+ action +"')",time);
			break;
		case "js":
		case "javascript":
			window.setTimeout("'"+ action.toString() +"'",time);
			break;
		default:
			alert("Nothing will do!");
			break
	}
}
//Image;
function preloadImages(){
	var d = document;
	if(d.images){
		if(!d.p_i_a) d.p_i_a = new Array();
		var i,j=d.p_i_a.length,a=arguments;
		for(i=0;i<a.length;i++){
			d.p_i_a[j]= new Image();
			d.p_i_a[j++].src = a[i];
		}
	}
}
//Ajax功能; prototype.js用法
function loadAjaxElement(e,u,p,f,l){
	if(arguments.length < 3){
		return ;
	}
	o = $(e);
	o.innerHTML = l;
	p = $H(p).toQueryString();
	new Ajax.Updater(
                    {success: e},
                    u,
                    {method: 'get', parameters: p, onFailure: f});
}
function loadAjaxData(u,p,s,f){
	if(arguments.length < 3){
		return ;
	}
	p = $H(p).toQueryString();
	new Ajax.Request(
                    u,
                    {method: 'get', parameters: p, onSuccess:s,onFailure: f});
}
function sendAjaxElement(e,u,p,f,l){
	if(arguments.length < 3){
		return ;
	}
	o = $(e);
	o.innerHTML = l;
	p = $H(p).toQueryString();
	new Ajax.Updater(
                    {success: e},
                    u,
                    {method: 'post', parameters: p, onFailure: f});
}
function sendAjaxData(u,p,s,f){
	if(arguments.length < 3){
		return ;
	}
	p = $H(p).toQueryString();
	new Ajax.Request(
                    u,
                    {method: 'post', parameters: p, onSuccess:s,onFailure: f});
}

//提醒输入
function checkNoSpec(id,v){
	if (trim(v) != ""){
		$(id).className = "notegray";
	}
	else{
		$(id).className = "notegreen";
	}
	if ($(id).focus == false){
		$(id).className = "notegray";
	}
}

//xmlHttp
var prefixes = ["MSXML2.XmlHttp","Microsoft.XmlHttp","MSXML3.XmlHttp", "MSXML.XmlHttp"];

function getDomObject(){
	for (var i = 0; i < prefixes.length; i++) {
		try{xmlHttp = new ActiveXObject(prefixes[i]);}catch(ex){};
	}
	return xmlHttp;
}

var loadStr = '<img src="/images/loading01.gif"> Loading...';

function showResult(strUrl,objExisted,objDivResult){
	objDivResult.innerHTML = loadStr;
	var xmlHttp = getDomObject();
	xmlHttp.open("GET",strUrl, true);
	xmlHttp.onreadystatechange = function () {
		switch (xmlHttp.readyState) {
           case 3 :
				objDivResult.innerHTML = loadStr;
		        break;
		   case 4 :
			   if (xmlHttp.status == 200){
                    objDivResult.innerHTML = xmlHttp.responseText;
					objExisted.value = xmlHttp.responseText;
		       }
		}
	}
	xmlHttp.setRequestHeader("Content-Type","text/xml")
	xmlHttp.send(null);
}
function showHiddenInfo(tid,imgid,openimg,closeimg){
	var objTid = $('#'+tid);
	var objImgid = $('#'+imgid);
	if (objTid.css('display') == 'table'){
		hiddenInfo(tid,imgid,openimg);
	}
	else{
		showInfo(tid,imgid,closeimg);
	}

	if(typeof(jQuery)!=undefined&&typeof(LazyBeautifyForm) == "function"){
		jQuery("body").LazyBeautifyForm();
	}
}

function showInfo(tid,imgid,closeimg){
	var objTid = $('#'+tid);
	var objImgid = $('#'+imgid);
	if (typeof(imgid) == 'object'){
		objImgid = imgid;
	}
	objTid.css('display','');
	if(closeimg == "" || typeof(closeimg) == "undefined"){
		objImgid.attr('src',"/images/arrowdown.gif");

	}
	else{
		objImgid.attr('src',closeimg);
	}
}

function hiddenInfo(tid,imgid,openimg){
	var objTid = $('#'+tid);
	var objImgid = $('#'+imgid);
	if (typeof(imgid) == 'object'){
		objImgid = imgid;
	}
	objTid.css('display','none');

	if(openimg == "" || typeof(openimg) == "undefined"){
		objImgid.attr('src',"/images/arrowup.gif");
	}
	else{
		objImgid.attr('src',openimg);
	}
}

function doPage(url,idload,idmain){
	var objload = $(idload);
	var objmain = $(idmain);
	objload.style.display = '';
	objload.innerHTML = loadStr;
	var xmlHttp = getDomObject();
	xmlHttp.open("GET",url, true);
	xmlHttp.onreadystatechange = function () {
		switch (xmlHttp.readyState) {
           case 3 :
			    objload.style.display = '';
				objload.innerHTML = loadStr;
		        break;
		   case 4 :
			   if (xmlHttp.status == 200){
					objload.innerHTML = "";
					objload.style.display = 'none';
                    objmain.innerHTML = xmlHttp.responseText;
		       }

		}
	}
	xmlHttp.setRequestHeader("Content-Type","text/xml")
	xmlHttp.send(null);
}

function checkWarningFlag(id,imgid){
	var objID = $(id);
	var objImgid = $(imgid);
	if (objID.value != ""){
		objImgid.style.display = 'none';
	}
	else{
		objImgid.style.display = '';
	}
}

//---时间控件必填检测
function CheckDateWarning(dateid,timeid,imgid){
	var DateId = $(dateid);
	var TimeId = $(timeid);
	var objImgid = $(imgid);
	if (DateId.value != "" && TimeId.value != ""){
		objImgid.style.display = 'none';
	}
	else{
		objImgid.style.display = '';
	}
}
function saveData(url,objsave){
	objsave.style.display = '';
	var xmlHttp = getDomObject();
	xmlHttp.open("GET",url, true);
	xmlHttp.onreadystatechange = function () {
		switch (xmlHttp.readyState) {
           case 3 :
				objsave.style.display = '';
		        break;
		   case 4 :
			   if (xmlHttp.status == 200){
			   //	alert(xmlHttp.responseText);

                    objsave.style.display = 'none';
		       }
		}
	}
	xmlHttp.setRequestHeader("Content-Type","text/xml")
	xmlHttp.send(null);
}

function selectData(url,objselect){
	objselect.style.display = 'none';
	var xmlHttp = getDomObject();
	xmlHttp.open("GET",url, true);
	xmlHttp.onreadystatechange = function () {
		switch (xmlHttp.readyState) {
           case 3 :
				objselect.style.display = 'none';
		        break;
		   case 4 :
			   if (xmlHttp.status == 200){
					objselect.innerHTML = xmlHttp.responseText;
					if (objselect.innerHTML !=""){
						objselect.style.display = '';
					}
					else{
						objselect.style.display = 'none';
					}
		       }
		}
	}
	xmlHttp.setRequestHeader("Content-Type","text/xml")
	xmlHttp.send(null);
}

function GetCookieVal(offset){
	var endstr = document.cookie.indexOf (";", offset);
	if (endstr == -1)
	endstr = document.cookie.length;
	return unescape(document.cookie.substring(offset, endstr));
}

function SetCookie(name, value ,expiresDate){
	var expdate = new Date();
	var argv = SetCookie.arguments;
	var argc = SetCookie.arguments.length;
	var expires = (argc > 2) ? argv[2] : null;
	var path = (argc > 3) ? argv[3] : null;
	var domain = (argc > 4) ? argv[4] : null;
	var secure = (argc > 5) ? argv[5] : false;
	if(expiresDate!=null) expdate.setTime(expdate.getTime() + ( expiresDate * 1000 * 3600 * 24));
	document.cookie = name + "=" + escape (value) +((expiresDate == null) ? "" : ("; expires="+ expdate.toGMTString()))
	+((path == null) ? "" : ("; path=" + path)) +((domain == null) ? "" : ("; domain=" + domain))
	+((secure == true) ? "; secure" : "");
}

function DelCookie(name){
	var exp = new Date();
	exp.setTime (exp.getTime() - 1);
	var cval = GetCookie (name);
	document.cookie = name + "=" + cval + "; expires="+ exp.toGMTString();
}

function GetCookie(name){
	var arg = name + "=";
	var alen = arg.length;
	var clen = document.cookie.length;
	var i = 0;
	while (i < clen){
		var j = i + alen;
		if (document.cookie.substring(i, j) == arg)
		return GetCookieVal (j);
		i = document.cookie.indexOf(" ", i) + 1;
		if (i == 0) break;
	}
	return null;
}

function openWindow(url,w,h){
	w = w>0?w:210;
	h = h>0?h:350;
	th = "edge:raised;scroll:1;status:0;help:0;resizable:1;dialogWidth:"+w+"px;dialogHeight:"+h+"px;";
	window.showModalDialog(url,self,th);
}

function showOText(){
	Element.show('divsave');
	var objOtext = document.getElementById('otext');
	var objOtextImg = document.getElementById('imgotext');
	objOtext.innerHTML = CommonLang.operatorSuccess;
	objOtext.style.color = "green";
	objOtextImg.src="/images/workflow/success.gif";
	setTimeout("hideOText()",2000);
}

function hideOText(){
	Element.hide('divsave');
	var objOtext = document.getElementById('otext');
	var objOtextImg = document.getElementById('imgotext');
	objOtextImg.src="/images/loading01.gif";
	objOtext.style.color = "black";
	objOtext.innerHTML = WebMailLang.Loading;
}

function showNText(){
	Element.show('divnote');
	setTimeout("hideNText()",2000);
}

function hideNText(){
	Element.hide('divnote');

}
function showFileText(){
	Element.show('divnote_file');
	setTimeout("hideFileText()",2000);
}

function hideFileText(){
	Element.hide('divnote_file');

}

//选择流程(单选)
function LoadWindowWorkflow(inputID,inputName,e,onSelect){
	e = e || window.event;

	var loc_x = (e.pageX || (e.clientX + (document.documentElement.scrollLeft || document.body.scrollLeft))) - 270;
	var loc_y = e.pageY || (e.clientX + (document.documentElement.scrollTop || document.body.scrollTop));
	var	url = "/module/work_flow_template_select/index.php?inputID="+inputID+"&inputName="+inputName+"&onSelect="+onSelect;
	window.showModalDialog(url,self,"edge:raised;scroll:0;status:0;help:0;resizable:1;dialogWidth:540px;dialogHeight:500px;dialogTop:"+loc_y+"px;dialogLeft:"+loc_x+"px");
}

//多用户选择
function LoadWindowUser(inputID,inputName,formName,width,height,roleFilter,fun,chooseLeaveOffice)
{
	var roleFilter = roleFilter || null;
	var param = {};
	if(roleFilter == "getSuperiorUser" || roleFilter == "getSubordinateUser") {
		param = {
					getSuperiorInitUserId : $("#USER_ID").val(),
					getDataType : "getSuperiorUser"
				};
	} else if(roleFilter) {
		param = {
			filter : roleFilter
		};
	}
	var dialogID = inputID + "_lazy_user_select_dialog";

	if($("body").find("#"+dialogID).length==0){
		$("body").append('<div id="'+dialogID+'"/>');

		$("#" + dialogID).LazyUserSelect({
			width: width ? width : $(window).width() - 300,
			height: height ? height : $(window).height() - 100,
			param: param,
			chooseLeaveOffice : chooseLeaveOffice || false,
			onDialogClose:function(selectedUser){
				$("#" + inputID).val(selectedUser.userIDStr);
				$("#" + inputName).val(selectedUser.userNameStr);
				if(fun){
					eval(fun+'("'+selectedUser.userIDStr+'","'+selectedUser.userNameStr+'")');
				}
				// 选上级、下级的时候，回调函数
				if(roleFilter == "getSuperiorUser" || roleFilter == "getSubordinateUser") {
					var checkClashParam = {
						roleFilter : roleFilter,
						inputID : inputID,
						inputName : inputName,
						userIDStr : selectedUser.userIDStr,
						userNameStr : selectedUser.userNameStr
					};
					checkClashSuperiorUserId(checkClashParam);
				}
			}
		});
	}

	$("#" + dialogID).data({
		userIDStr: $("#" + inputID).val(),
		userNameStr: $("#"+ inputName).val()
	}).dialog("open");
}
//文档选择
function LoadWindowDoc(inputID,inputName,formName,selectNumber,event)
{
	var URL="/module/doc_select/?inputID="+inputID+"&inputName="+inputName+"&formName="+formName+"&selectNumber="+selectNumber+"&defaultInputID="+$("#"+inputID).attr("value"),loc_x=document.body.scrollLeft-event.offsetX-210,loc_y=document.body.scrollTop-event.offsetY;
	window.showModalDialog(URL,self,"edge:raised;scroll:0;status:0;help:0;resizable:1;dialogWidth:800px;dialogHeight:530px;dialogTop:"+loc_y+"px;dialogLeft:"+loc_x+"px");
}
//用户选择，单个 edit by sun 2007-12-19
function LoadWindowUserSingle(inputID,inputName,formName,width,height,chooseLeaveOffice)
{
	var dialogID = inputID + "_lazy_user_select_dialog";
	if($("body").find("#"+dialogID).length==0){
		$("body").append('<div id="'+dialogID+'"/>');

		$("#" + dialogID).LazyUserSelect({
			mode:"single",
			width: width ? width : $(window).width() - 300,
			height: height ? height : $(window).height() - 100,
			chooseLeaveOffice : chooseLeaveOffice || false,
			onDialogClose:function(selectedUser){
				$("#" + inputID).val(selectedUser.userIDStr);
				$("#" + inputName).val(selectedUser.userNameStr);
			}
		});
	}

	$("#" + dialogID).data({
		userIDStr: $("#" + inputID).val(),
		userNameStr: $("#"+ inputName).val()
	}).dialog("open");
}

//单个用户选择   筛选--可以看到当前选中客户的所有用户
function LoadManageUserSingle(inputID,inputName,formName,customerId,manageUser){
	var dialogID = inputID + "_lazy_user_select_dialog";
	if($("body").find("#"+dialogID).length==0){
		$("body").append('<div id="'+dialogID+'"/>');

		$("#" + dialogID).LazyUserSelect({
			mode:"single",
			param:{
				getDataType:'remind_manager_user_select',
				customerId:customerId,
				manageUser:manageUser
			},
			onDialogClose:function(selectedUser){
				$("#" + inputID).val(selectedUser.userIDStr);
				$("#" + inputName).val(selectedUser.userNameStr);
			}

		});
	}
	$("#" + dialogID).data({
		userIDStr: $("#" + inputID).val(),
		userNameStr: $("#"+ inputName).val()
	}).dialog("open");

}

//单个用户选择，流程代理中，须触发别的事件 edit by sun 2009-02-03
function LoadWindowUserSingleFlowAgent(inputID,inputName,formName)
{
	var dialogID = inputID + "_lazy_user_select_dialog";
	if($("body").find("#"+dialogID).length==0){
		$("body").append('<div id="'+dialogID+'"/>');

		$("#" + dialogID).LazyUserSelect({
			mode:"single",
			width: $(window).width() - 300,
			height:$(window).height() - 100,
			onDialogClose:function(selectedUser){
				$("#" + inputID).val(selectedUser.userIDStr);
				$("#" + inputName).val(selectedUser.userNameStr);
				getFlowTyleByUser();
			}
		});
	}

	$("#" + dialogID).data({
		userIDStr: $("#" + inputID).val(),
		userNameStr: $("#"+ inputName).val()
	}).dialog("open");
	document.forms['form1'].checkall.checked=false;
}
//多角色选择
function LoadWindowPriv(inputID,inputName,formName,event)
{
 	var e  = event || window.event;
	var url = "/module/priv_select_new/index.php?INPUTID="+inputID+"&INPUTNAME="+inputName+"&modeType=muli&defaultInputID="+$("#"+inputID).attr("value");
	var ScreenWidth = screen.availWidth	;
    var ScreenHeight = screen.availHeight ;
	var loc_x = document.body.scrollLeft+e.clientX-100;
	var loc_y = document.body.scrollTop+e.clientY-170;
    window.open(url, '', 'left='+loc_x+', top='+loc_y+ ',Width=400, height=400, toolbar=no, menubar=no,scrollbars=yes, resizable=yes,location=no, status=1') ;
}

//多角色选择++++update by lizhijun---兼容火狐
function LoadCompatWindowPriv(eventObj,inputID,inputName,formName)
{
    var e = eventObj ? eventObj :window.event;
	var url = "/module/priv_select_new/index.php?INPUTID="+inputID+"&INPUTNAME="+inputName+"&modeType=muli&defaultInputID="+$("#"+inputID).attr("value");
	var ScreenWidth = screen.availWidth	;
    var ScreenHeight = screen.availHeight ;
	var loc_x = document.body.scrollLeft+e.clientX-100;
	var loc_y = document.body.scrollTop+e.clientY-170;
    window.open(url, '', 'left='+loc_x+', top='+loc_y+ ',Width=400, height=400, toolbar=no, menubar=no,scrollbars=yes, resizable=yes,location=no, status=1') ;
}
//多排班选择
function LoadWindowDutyAll(inputID,inputName,formName)
{
	  URL="/module/duty_select_new/?inputID="+inputID+"&inputName="+inputName+"&formName="+formName;
	  loc_x=document.body.scrollLeft+event.clientX-event.offsetX-100;
	  loc_y=document.body.scrollTop+event.clientY-event.offsetY+170;
	  window.showModalDialog(URL,self,"edge:raised;scroll:0;status:0;help:0;resizable:1;dialogWidth:200px;dialogHeight:400px;dialogTop:"+loc_y+"px;dialogLeft:"+loc_x+"px");
}

//排班选择
function LoadWindowPrivSingle(inputID,inputName,formName)
{
	  URL="/module/duty_select_single_new/?inputID="+inputID+"&inputName="+inputName+"&formName="+formName;
	  loc_x=document.body.scrollLeft+event.clientX-event.offsetX-100;
	  loc_y=document.body.scrollTop+event.clientY-event.offsetY+170;
	  window.showModalDialog(URL,self,"edge:raised;scroll:0;status:0;help:0;resizable:1;dialogWidth:200px;dialogHeight:400px;dialogTop:"+loc_y+"px;dialogLeft:"+loc_x+"px");
}
//角色选择，单个 edit by sun 2007-12-19 --现在这两个函数都没有地方用到
function LoadWindowPrivSingle(inputID,inputName,formName)
{
	  URL="/module/priv_select_single_new/?inputID="+inputID+"&inputName="+inputName+"&formName="+formName;
	  loc_x=document.body.scrollLeft+event.clientX-event.offsetX-100;
	  loc_y=document.body.scrollTop+event.clientY-event.offsetY+170;
	  window.showModalDialog(URL,self,"edge:raised;scroll:0;status:0;help:0;resizable:1;dialogWidth:200px;dialogHeight:400px;dialogTop:"+loc_y+"px;dialogLeft:"+loc_x+"px");
}
//多部门选择(带权限控制)
function LoadWindowDeptPriv(inputID,inputName,formName,width,height,chooseDeptType,getDataType)
{
	// URL="/module/dept_select_new/?priv=1&inputID="+inputID+"&inputName="+inputName+"&formName="+formName;
	// loc_x=document.body.scrollLeft+event.clientX-event.offsetX-100;
	// loc_y=document.body.scrollTop+event.clientY-event.offsetY+170;
	// window.showModalDialog(URL,self,"edge:raised;scroll:0;status:0;help:0;resizable:1;dialogWidth:480px;dialogHeight:400px;dialogTop:"+loc_y+"px;dialogLeft:"+loc_x+"px");
	var getDataTypeStr = "";
	if(getDataType) {
		getDataTypeStr = getDataType;
	}
	else
		getDataTypeStr = "dept_select_new";
	var dialogID = inputID + "_lazy_dept_select_dialog";
	if($("body").find("#"+dialogID).length==0){
		$("body").append('<div id="'+dialogID+'"/>');
		var mode = "muli";
		//新建用户，直接选部门，单选。
		if(chooseDeptType == "newUserChooseDept") {
			mode = "single";
		}
		$("#" + dialogID).LazyDeptSelect({
			width: width ? width : $(window).width() - 100,
			height: height ? height : $(window).height() - 100,
			mode: mode,
			onDialogClose:function(selectedDept){
				$("#" + inputID).val(selectedDept.deptIDStr).change();
				$("#" + inputName).val(selectedDept.deptNameStr).change();
			},
			param : {
				getDataType : getDataTypeStr,
				// 编辑用户的时候，有权限的上级部门选择，参数
				getEditDeptParentSelectTempDept : $("#getEditDeptParentSelectTempDept").val(),
				getEditDeptParentSelectDeptId : $("#getEditDeptParentSelectDeptId").val()
			}
		});
	}

	$("#" + dialogID).data({
		deptIDStr: $("#" + inputID).val(),
		deptNameStr: $("#"+ inputName).val()
	}).dialog("open");
}
//多部门选择
function LoadWindowDept(inputID,inputName,formName,width,height)
{
	var dialogID = inputID + "_lazy_dept_select_dialog";
	if($("body").find("#"+dialogID).length==0){
		$("body").append('<div id="'+dialogID+'"/>');

		$("#" + dialogID).LazyDeptSelect({
			width: width ? width : $(window).width() - 300,
			height: height ? height : $(window).height() - 100,
			onDialogClose:function(selectedDept){
				$("#" + inputID).val(selectedDept.deptIDStr);
				$("#" + inputName).val(selectedDept.deptNameStr);
			}
		});
	}

	$("#" + dialogID).data({
		deptIDStr: $("#" + inputID).val(),
		deptNameStr: $("#"+ inputName).val()
	}).dialog("open");
}
//部门选择，多个包括所有部门 edit by sun 2007-12-19
function LoadWindowDeptAll(inputID,inputName,formName)
{
	  URL="/module/dept_select_new_all/?inputID="+inputID+"&inputName="+inputName+"&formName="+formName;
	  loc_x=document.body.scrollLeft+event.clientX-event.offsetX-100;
	  loc_y=document.body.scrollTop+event.clientY-event.offsetY+170;
	  window.showModalDialog(URL,self,"edge:raised;scroll:0;status:0;help:0;resizable:1;dialogWidth:480px;dialogHeight:400px;dialogTop:"+loc_y+"px;dialogLeft:"+loc_x+"px");
}
//部门选择，单个 edit by sun 2007-12-19
function LoadWindowDeptSingle(inputID,inputName,formName,width,height)
{
	var dialogID = inputID + "_lazy_dept_select_dialog";
	if($("body").find("#"+dialogID).length==0){
		$("body").append('<div id="'+dialogID+'"/>');

		$("#" + dialogID).LazyDeptSelect({
			mode:"single",
			width: width ? width : $(window).width() - 300,
			height: height ? height : $(window).height() - 100,
			onDialogClose:function(selectedDept){
				$("#" + inputID).val(selectedDept.deptIDStr);
				$("#" + inputName).val(selectedDept.deptNameStr);
			}
		});
	}

	$("#" + dialogID).data({
		deptIDStr: $("#" + inputID).val(),
		deptNameStr: $("#"+ inputName).val()
	}).dialog("open");
}
//流程监控查询中的选择类别，edit by sun 2008-08-14
function LoadWindowFlowtype(inputID,inputName,formName)
{
	url = "/module/flow_type_select/?inputID="+inputID+"&inputName="+inputName+"&formName="+formName;
	loc_x=document.body.scrollLeft+event.clientX-event.offsetX-50;
	loc_y=document.body.scrollTop+event.clientY-event.offsetY+150;
	window.showModalDialog(url,self,"edge:raised;scroll:1;status:0;help:0;resizable:1;dialogWidth:100px;dialogHeight:350px;dialogTop:"+loc_y+"px;dialogLeft:"+loc_x+"px");
	//alert("LoadWindowFlowtype");
}
//流程监控查询中的选择名称，edit by sun 2008-08-14
function LoadWindowFlowname(inputID,inputName,flow_type_id,formName)
{
	flow_type_id_val = document.getElementById(flow_type_id).value;
	url = "/module/flow_name_select/?inputID="+inputID+"&inputName="+inputName+"&formName="+formName+"&flow_type_id="+flow_type_id_val;
	loc_x=document.body.scrollLeft+event.clientX-event.offsetX-50;
	loc_y=document.body.scrollTop+event.clientY-event.offsetY+150;
	window.showModalDialog(url,self,"edge:raised;scroll:1;status:0;help:0;resizable:1;dialogWidth:100px;dialogHeight:350px;dialogTop:"+loc_y+"px;dialogLeft:"+loc_x+"px");
	//alert("LoadWindowFlowname");
}
//共享空间设置管理权限和上传权限人员，edit by dingp 2012-01-06
function LoadWindowDisk(inputID,inputName,formName,diskId,diskType,userStr,userDept)
{
	URL="/module/user_select_disk/?inputID="+inputID+"&inputName="+inputName+"&formName="+formName+"&diskId="+diskId+"&diskType="+diskType+"&userStr="+userStr+"&userDept="+userDept;
	loc_x=document.body.scrollLeft+event.clientX-event.offsetX-100;
	loc_y=document.body.scrollTop+event.clientY-event.offsetY+170;
	window.showModalDialog(URL,self,"edge:raised;scroll:0;status:0;help:0;resizable:1;dialogWidth:480px;dialogHeight:400px;dialogTop:"+loc_y+"px;dialogLeft:"+loc_x+"px");
}
//首页弹出窗口
function openWindows(url){
	var ScreenWidth = screen.availWidth	;
    var ScreenHeight = screen.availHeight ;
    var loc_x = (ScreenWidth - 500) / 2 ;
    var loc_y = (ScreenHeight - 500) / 2 ;
	//loc_x=document.body.scrollLeft+event.clientX-event.offsetX-100;
	//loc_y=document.body.scrollTop+event.clientY-event.offsetY+170;
  	//window.showModalDialog(url,self,"edge:raised;scroll:0;status:0;help:0;resizable:1;dialogWidth:700px;dialogHeight:400px;dialogTop:"+loc_y+"px;dialogLeft:"+loc_x+"px");
	window.open (url, '', 'height=600, width=800, top='+loc_y+', left='+loc_x+', toolbar=no, menubar=no,scrollbars=yes, resizable=yes,location=no, status=1')

}
function LoadWindowNewDoc(url,inputID)
{
	//loc_x = document.body.scrollLeft+event.clientX-event.offsetX+210;
	//loc_y = document.body.scrollTop+event.clientY-event.offsetY+100;
	loc_x = 0;
	loc_y = 0;
	var sWidth  = window.screen.availWidth -30;
	var sHeight = window.screen.availHeight-70;
	url += "&inputID="+inputID;
	if($("#"+inputID).attr("value"))
		url += "&inputValue="+$("#"+inputID).attr("value");
	//window.showModalDialog(url,self,"edge:raised;scroll:1;status:0;help:0;resizable:1;dialogWidth:"+sWidth+"px;dialogHeight:"+sHeight+"px;dialogTop:"+loc_y+"px;dialogLeft:"+loc_x+"px;scroll=0");
	window.open (url, '', 'height='+sHeight+', width='+sWidth+', top='+loc_y+', left='+loc_x+', toolbar=no, menubar=no,scrollbars=yes, resizable=yes,location=no, status=1');
}
//文档窗口
function openDocumentsWindows(par,doc_type){
	var url = "/general/file_folder/file_new/read.php";
	url = url+"?CONTENT_ID="+par;
	var ScreenWidth = screen.availWidth	;
    var ScreenHeight = screen.availHeight ;
	if(doc_type=='2'||doc_type=='3'){
		var height = "800";
		var width = "900";
		var loc_x = (ScreenWidth - 800) / 2 ;
		var loc_y = "72" ;
	}else{
		var height = "600";
		var width = "700";
		var loc_x = (ScreenWidth - 500) / 2 ;
		var loc_y = (ScreenHeight - 500) / 2 ;
	}
	//alert(loc_x);
	//loc_x=document.body.scrollLeft+event.clientX-event.offsetX-100;
	//loc_y=document.body.scrollTop+event.clientY-event.offsetY+170;
  	//window.showModalDialog(url,self,"edge:raised;scroll:0;status:0;help:0;resizable:1;dialogWidth:700px;dialogHeight:400px;dialogTop:"+loc_y+"px;dialogLeft:"+loc_x+"px");
	window.open (url, '', "top=0, left=0,height="+(ScreenHeight-70)+"px, width="+ScreenWidth+"px, toolbar=no, menubar=no,scrollbars=yes, resizable=yes,location=no, status=1")

}

/**
 * 打开编辑器中的链接
 * @param  {[type]} url [description]
 * @return {[type]}     [description]
 */
function openLinkInEditor(url){
	var ScreenWidth = screen.availWidth	;
    var ScreenHeight = screen.availHeight ;
    var loc_x = (ScreenWidth - 500) / 2 -200;
    var loc_y = (ScreenHeight - 500) / 2 ;
	window.open (url, '', "top="+loc_y+", left="+loc_x+",height="+ScreenHeight+", width="+ScreenWidth+", toolbar=no, menubar=no,scrollbars=yes, resizable=yes,location=no, status=1")
}


//文档窗口
function openLinkWindows(url,par,field,f,this_type){
	if(par!=''){
		url = url+"?"+field+"="+par;
	}
	if(f!=''){
		url = url+"&f="+f;
	}
	if(this_type){
		url = url+"&FLOW_TYPE="+this_type;
	}
	var ScreenWidth = screen.availWidth	;
    var ScreenHeight = screen.availHeight ;
    var loc_x = (ScreenWidth - 500) / 2 -200;
    var loc_y = (ScreenHeight - 500) / 2 ;
	//alert(loc_x);
	//loc_x=document.body.scrollLeft+event.clientX-event.offsetX-100;
	//loc_y=document.body.scrollTop+event.clientY-event.offsetY+170;
  	//window.showModalDialog(url,self,"edge:raised;scroll:0;status:0;help:0;resizable:1;dialogWidth:700px;dialogHeight:400px;dialogTop:"+loc_y+"px;dialogLeft:"+loc_x+"px");
	window.open (url, '', "top="+loc_y+", left="+loc_x+",height="+ScreenHeight+", width="+ScreenWidth+", toolbar=no, menubar=no,scrollbars=yes, resizable=yes,location=no, status=1")

}
//获得宽高
function getObjInfoXY(o){
	var to=new Object();
	to.left=to.right=to.top=to.bottom=0;
	var o = document.getElementById(o);

	var twidth=o.offsetWidth;

	var theight=o.offsetHeight;
	while(o!=document.body){
		to.left+=o.offsetLeft;
		to.top+=o.offsetTop;
		o=o.offsetParent;
	}
	to.right=to.left+twidth;
	to.bottom=to.top+theight;
	return to;
}
//JS判断控制上传文件的大小
function limitUploadFile (from_name,file_name,max_size) {
if (document.getElementsByName(from_name)) {
	window.oldOnError = window.onerror;
	window.onerror = function (err) {
		if (err.indexOf('utomation') != -1) {
		alert(CommonLang.noAccessPrivate);
		return true;
		}else{
		return false;
		}};
	var	fileName =  document.getElementsByName(file_name)[0] ;
    var fso = new ActiveXObject('Scripting.FileSystemObject');
    var file = fso.GetFile(fileName.value);
    window.onerror = window.oldOnError;
	file_size = Math.round(file.size/1024,2);
	if(file_size>max_size){
		//objFile.value = "";
		alert(CommonLang.uploadFileOverSize);
		fileName.focus();
		fileName.select();
		return false;
	}
    return true;
	}
}
//文档夹选择
function LoadWindowSelectFile(sortid,sortname,getwhat,filesort)
{
	//alert(filesort);
  URL="/module/document_file_select?sortid="+sortid+"&sortname="+sortname+"&getwhat="+getwhat+"&filesort="+filesort;
  //loc_x=document.body.scrollLeft+event.clientX-event.offsetX-100;
  //loc_y=document.body.scrollTop+event.clientY-event.offsetY+170;
   var ScreenWidth = screen.availWidth	;
   var ScreenHeight = screen.availHeight ;
   var loc_x = (ScreenWidth - 500) / 2 ;
   var loc_y = (ScreenHeight - 200) / 2 ;
  //window.showModalDialog(URL,self,"edge:raised;scroll:0;status:0;help:0;resizable:1;dialogWidth:300px;dialogHeight:395px;dialogTop:"+loc_y+"px;dialogLeft:"+loc_x+"px");
  window.open (URL, '', "top="+loc_y+", left="+loc_x+",height=395px, width=300px, toolbar=no, menubar=no,scrollbars=yes, resizable=yes,location=no, status=1")
}
//掷空数据
function clearConten(content_id,content_name)
{
	document.getElementById(content_id).value="";
	document.getElementById(content_name).value="";

 //document.form1.+'content_name'+.value="";
 // document.form1.+'content_id'+.value="";
}
// 多个清空
function emptyDomValue(domIdArray) {
	var domObjectId = "";
	for(var i = 0; i < domIdArray.length; i++){
		domObjectId = domIdArray[i];
		if($("#"+domObjectId).length > 0) {
			$("#"+domObjectId).val('');
		}
	}
}

//投票调查
function viewVoteIndex(sid){
	var url = "/general/vote/view.php?sid="+sid+"&op=index";
	var ScreenWidth = screen.availWidth	;
    var ScreenHeight = screen.availHeight ;
    var StartX = (ScreenWidth - 500) / 2 ;
    var StartY = (ScreenHeight - 500) / 2 ;
    window.open(url, '', 'left='+ StartX + ', top='+ StartY + ', Width=800, height=600, toolbar=no, menubar=no,scrollbars=yes, resizable=yes,location=no, status=1') ;
}
//投票调查
function seeResultIndex(sid){
	var url = "/general/vote/see_result.php?sid="+sid+"&op=index";
	var ScreenWidth = screen.availWidth	;
    var ScreenHeight = screen.availHeight ;
    var StartX = (ScreenWidth - 500) / 2 ;
    var StartY = (ScreenHeight - 500) / 2 ;
    window.open(url, '', 'left='+ StartX + ', top='+ StartY + ', Width=800, height=600, toolbar=no, menubar=no,scrollbars=yes, resizable=yes,location=no, status=1') ;
}
//通讯录选择框
function LoadWindowSelectAddress(select_url,select_id,select_name,get_what,select_type)
{
	//alert(filesort);
   URL = select_url+"?select_id="+select_id+"&select_name="+select_name+"&get_what="+get_what+"&select_type="+select_type;

  //loc_x=document.body.scrollLeft+event.clientX-event.offsetX-100;
  //loc_y=document.body.scrollTop+event.clientY-event.offsetY+170;
   var ScreenWidth = screen.availWidth	;
   var ScreenHeight = screen.availHeight ;
   var loc_x = (ScreenWidth - 500) / 2 ;
   var loc_y = (ScreenHeight - 200) / 2 ;
  window.open(URL,null,"edge=raised,scrollbars=0,status=0,help=0,resizable=1,width=300,height=395,top="+loc_y+",left="+loc_x);
}

function isAllChecked(checkboxname,allcheckboxname)
{
	checkboxArrayObj = document.getElementsByName(checkboxname);
	allCheckObj      = document.getElementById(allcheckboxname);
	for(i=0;i<checkboxArrayObj.length;i++)
	{
		if(!checkboxArrayObj[i].checked)
		{
			allCheckObj.checked = "";
			return false;
		}
	}
	allCheckObj.checked = "true";
}
//helpPage
function helpPage(a) {
	window.open(a.href,null,'width=580,height=290,location=no,resizable=1,scrollbars=1,status=no,toolbar=no,menu=no,top=150,left=300');
	return false;
}


function thousandFormat(num)
{
	var showValue = num.value;
	if(showValue)
	{
		var midValue = commafyback(showValue);
		if(!isNaN(midValue) && midValue>=0)
			num.value = midValue.toString().commafy();
		else
		{
			alert(CommonLang.inputErrorFomatTip+"！");
			num.value = "";
		}
	}
}

function  commafyback(num)
{
   var x = num.split(',');
   return parseFloat(x.join(""));
}

String.prototype.commafy = function(){
	if (this == "") return "";
	var _n = this.match(/(-?\d+)(\.\d*)?/);
	var length = _n[1].length;
	var i = length % 3
	var str1 = _n[1].substring(0,i)
	var str2 = _n[1].substring(i,length) ;
	var result = str1 + str2.replace(/(\d{3})/g, ",$1") ; // integer.
	if(_n[2])
		result += _n[2].replace(/(\d{3})/g, "$1,").replace(/(.*),$/, "$1"); // decimal.
	result = result.replace(/^,(.*)/, "$1")
	return result;
};
function changeMoneyToChinese(money) {
    var cnNums = new Array("零", "壹", "贰", "叁", "肆", "伍", "陆", "柒", "捌", "玖"); //汉字的数字
    var cnIntRadice = new Array("", "拾", "佰", "仟"); //基本单位
    var cnIntUnits = new Array("", "万", "亿", "兆"); //对应整数部分扩展单位
    // var cnDecUnits = new Array("角", "分", "毫", "厘"); //对应小数部分单位
    var cnDecUnits = new Array("角", "分"); //对应小数部分单位
    var cnInteger = "整"; //整数金额时后面跟的字符
    var cnIntLast = "元"; //整型完以后的单位
    var maxNum = 999999999999999.99; //最大处理的数字
    var IntegerNum; //金额整数部分
    var DecimalNum; //金额小数部分
    var ChineseStr = ""; //输出的中文金额字符串
    var parts; //分离金额后用的数组，预定义
    if (money == "") {
        return "";
    }
    money = parseFloat(money);
    if (money >= maxNum) {
    	$.pnotify("超出最大处理数字");
		return "";
    }
    if (money == 0) {
        ChineseStr = cnNums[0] + cnIntLast + cnInteger;
        //document.getElementById("show").value=ChineseStr;
        return ChineseStr;
    }
    money = money.toString(); //转换为字符串
    if (money.indexOf(".") == -1) {
        IntegerNum = money;
        DecimalNum = '';
    } else {
        parts = money.split(".");
        IntegerNum = parts[0];
        DecimalNum = parts[1].substr(0, 2);
        if(DecimalNum == '00') {
        	DecimalNum = '';
        }
    }
    if (parseInt(IntegerNum, 10) > 0) { //获取整型部分转换
        zeroCount = 0;
        IntLen = IntegerNum.length;
        for (i = 0; i < IntLen; i++) {
            n = IntegerNum.substr(i, 1);
            p = IntLen - i - 1;
            q = p / 4;
            m = p % 4;
            if (n == "0") {
                zeroCount++;
            } else {
                if (zeroCount > 0) {
	            	if(m != "3")
	                    ChineseStr += cnNums[0];
                }
                zeroCount = 0; //归零
                ChineseStr += cnNums[parseInt(n)] + cnIntRadice[m];
            }
            if (m == 0 && zeroCount < 4) {
                ChineseStr += cnIntUnits[q];
            }
        }
        ChineseStr += cnIntLast;
        //整型部分处理完毕
    }
    if (DecimalNum != '') { //小数部分
        decLen = DecimalNum.length;
        if(decLen > 2) decLen = 2;
        for (i = 0; i < decLen; i++) {
            n = DecimalNum.substr(i, 1);
        	if(i == 0 && n == '0') {
                ChineseStr += cnNums[Number(n)];
        	}
            if (n != '0') {
                ChineseStr += cnNums[Number(n)] + cnDecUnits[i];
            }

        }
    }
    if (ChineseStr == '') {
        ChineseStr += cnNums[0] + cnIntLast + cnInteger;
    } else if (DecimalNum == '') {
        ChineseStr += cnInteger;
    } else if (DecimalNum != '' && DecimalNum.length == 1) {
        ChineseStr += cnInteger;
    }
    return ChineseStr;
}
//金额转换成大写
function numToCh(num)
{
	$.pnotify.defaults.styling = "bootstrap3";
	$.pnotify.defaults.closer = false;
	$.pnotify.defaults.sticker = false;
	$.pnotify.defaults.history = false;
	$.pnotify.defaults.delay = 1000;
	$.pnotify.defaults.addclass = "stack-topleft";
	$.pnotify.defaults.animate_speed = 'fast';
	$.pnotify.defaults.type = "error";


	if(num=="")
		return "零元整";
	var ch_str="";

	for(var i=0;i<num.length;i++)
	{
		num=num.replace(",","");//替换千位分隔符
	}
	if(isNaN(num)||num=="0."||num==".0")
	{
		$.pnotify("请检查金额是否为有效的数字");
		return "";
	}
	if(num==0)
		return "零元整";

	return changeMoneyToChinese(num);
	// var part=num.split(".");//将整数部分与小数部分分开
	// if(part[1] && part[1].length > 2) {
	// 	var formulaNum = new Number(num);
	// 	num  = formulaNum.toFixed("2");
	// 	part = num.split(".");
	// }
	// if(part[0].length>12 || part[0] < 0.01)
	// {
	// 	$.pnotify("数字超出大小写转换范围(0.01----999999999999.99)");
	// 	return "";
	// }

	// var num_ch=new Array("零","壹","贰","叁","肆","伍","陆","柒","捌","玖");
	// var z_unit=new Array("元","拾","佰","仟","万","拾","佰","仟","亿","拾","佰","仟");
	// var point=new Array("角","分","厘");

	// //整数部分数据处理
	// for(var i=0;i<part[0].length;i++)
	// {
	// 	ch_str+=num_ch[part[0].substring(i,i+1)]+z_unit[part[0].length-i-1];
	// }
	// //小数部分数据处理
	// if(part.length>1)
	// {
	// 	if(part[1].length>2)
	// 	{
	// 		$.pnotify("数字超出大小写转换范围(0.01----999999999999.99)");
	// 		return "";
	// 	}
	// 	for(var i=0;i<part[1].length;i++)
	// 	{
	// 		ch_str+=num_ch[part[1].substring(i,i+1)]+point[i];
	// 	}
	// }
	// //转化后的字符串处理
	// for(i=0;i<4;i++)
	// {
	// 	ch_str=ch_str.replace("零億","億");
	// 	ch_str=ch_str.replace("零萬","萬");
	// 	ch_str=ch_str.replace("零仟","零");
	// 	ch_str=ch_str.replace("零佰","零");
	// 	ch_str=ch_str.replace("零拾","零");
	// 	ch_str=ch_str.replace("零元","元");
	// 	ch_str=ch_str.replace("億萬","億");
	// 	ch_str=ch_str.replace("零零","零");
	// 	ch_str=ch_str.replace("零角","零");
	// 	ch_str=ch_str.replace("零分","");
	// 	ch_str=ch_str.replace("零厘","");
	// }
	// if(ch_str.substring(ch_str.length-1)==("零"))
	// 	ch_str=ch_str.substring(0,ch_str.length-1)+"整";
	// 	if(ch_str=="元整")
	// 	ch_str="零元整";
	// return ch_str;
}

function Message(content,theme,flag)
{
	var src   = "/theme/" + theme + "/images/message/info.png";
	var color = "#93a8c3";
	if(flag && flag == "failed"){
		src   = "/theme/" + theme + "/images/message/error.png";
	}
	if(flag && flag == "success"){
		src   = "/theme/" + theme + "/images/message/success.png";
	}

	var width = 500;

	if(content.length <=30){
		width = 150;
	}
	else if(content.length <=60){
		width = 280;
	}
	else if(content.length <=75){
		width = 320;
	}
	else if(content.length <=90){
		width = 420;
	}

	var htmlStr ='<center>';
    htmlStr +='    <div align="center" style="border:0px solid #cccccc;width:80%;margin:10px;">';
    htmlStr +='        <table align="center" border="0"  cellspacing="0"  cellpadding="0">';
    htmlStr +='            <tr>';
    htmlStr +='                <td height="5" colspan="2"></td>';
    htmlStr +='            </tr>';
    htmlStr +='            <tr>';
    htmlStr +='                <td height="41" width="53" align="center" style="background:url(/theme/' + theme + '/images/message/msgleftbg.png) no-repeat;"><img src="'+ src +'"></td>';
    htmlStr +='                <td width="' + width + '" align="center" nowrap="nowrap" style="background:url(/theme/' + theme + '/images/message/msgrightbg.png) right top no-repeat;">';
    htmlStr +='                    <span style="font-size:13px;color:'+color+'">'+content+'</span>';
    htmlStr +='                </td>';
    htmlStr +='            </tr>';
    htmlStr +='        </table>';
    htmlStr +='    </div>';
	htmlStr +='</center>';
	return htmlStr;
}
//保存新邮件地址到通讯录
function saveNewAddress(addressStr)
{
	var address_extend = "";
	$.ajax({
		url : "/general/workflow/flow_outmail_do.php",
		type : "POST",
		data : 'newaddress='+addressStr,
		async : false,
		success : function(result) {
			var rs = $.parseJSON(result);
			address_extend = rs;
		}
	});
	if(address_extend!="")
		return address_extend;
}

//根据模块显示提醒
function showRemind(moduleId)
{
	var remindInfo = "1";
	$.ajax({
		url:"/general/news/manage/remind_do.php",
		type:"POST",
		data:"type=moduleRemind&MODULEID="+moduleId,
		async : false,
		success:function(resp) {
			if(resp != "")
			{
				remindInfo = resp;
			}
		}
	});
	if(remindInfo != "")
	{
		return remindInfo;
	}
}
//验证必填函数
function checkValue()
{
	checkValueTogClass.call(this);
	jQuery(this).on("keyup",function (){
		checkValueTogClass.call(this);
	});
}
function checkValueTogClass(){
	jQuery(this).toggleClass("require",jQuery.trim(jQuery(this).val())=='');
}

function LoadCustomerDialog(id,name,form,isRequire,permission){

	if ($(".Div_Customer_Dialog").length>0) {
	}else{
		$("body").append('<div class="Div_Customer_Dialog"><iframe style="width:100%;border:none;height:100%;" frameborder="0" id="Div_Customer_Dialog"></iframe></div>');
		$(".Div_Customer_Dialog").dialog({
		    autoOpen: false,
		    width: 600,
		    modal: true,
		    height:470,
		    dialogClass:"lazy_dialog",  //此行必须有
		    resizable:false
		});
	}

	URL="/general/crm/linkman/customer_select/index.php?id="+id+"&name="+name+"&form="+form+"&dialog_div=Div_Customer_Dialog&isRequire="+isRequire+"&permission="+permission;
  	$("#Div_Customer_Dialog").attr("src",URL);
  	$(".Div_Customer_Dialog").dialog("open");
}

function merge(){
	var	i,
		args = arguments,
		len,
		ret = {},

		doCopy = function (copy, original) {
			var value, key;

			if(typeof copy !== 'object'){
				copy = {};
			}

			for(key in original){
				if(original.hasOwnProperty(key)){
					value = original[key];

					if(value && typeof value === 'object' && Object.prototype.toString.call(value) !== '[object Array]'
							&& key !== 'renderTo' && typeof value.nodeType !== 'number'){
						copy[key] = doCopy(copy[key] || {}, value);

					}else{
						copy[key] = original[key];
					}
				}
			}
			return copy;
		};

	if(args[0] === true){
		ret = args[1];
		args = Array.prototype.slice.call(args, 2);
	}

	len = args.length;
	for(i = 0; i < len; i++){
		ret = doCopy(ret, args[i]);
	}

	return ret;
}
function winexe(NAME,PROG)
{
	var URL ="/general/winexe?PROG="+PROG+"&NAME="+NAME;
	window.open(URL,"winexe","height=100,width=350,status=0,toolbar=no,menubar=no,location=no,scrollbars=yes,top=0,left=0,resizable=no");
}

//兼容不存在window.showModalDialog的浏览器
if(!window.showModalDialog){
    window.showModalDialog = function(url, parent, param){
    	param = param.replace("dialogWidth", "width");
    	param = param.replace("dialogHeight", "height");
    	param = param.replace("dialogTop", "top");
    	param = param.replace("dialogLeft", "left");
    	param = param.replace("scroll", "scrollbars");
    	param = param.replace(/:/g, "=");
    	param = param.replace(/px/g, "");
    	param = param.replace(/;/g, ",");
    	return window.open(url, parent, param);
    }
}
// 选上级、下级的时候，回调函数
function checkClashSuperiorUserId(checkClashParam){
	var inputIdArray   = checkClashParam.userIDStr.split(",");
	var inputNameArray = checkClashParam.userNameStr.split(",");
	$(inputIdArray).each(function(index, el) {
		if(el) {
			var checkClashId = "",
			checkClashName = "";
			if(checkClashParam.roleFilter == "getSuperiorUser") {
				// 选下级，循环排除 user-subordinate-name 里的值
				checkClashId = "user-subordinate-id";
				checkClashName = "user-subordinate-name";

			} else if(checkClashParam.roleFilter == "getSubordinateUser") {
				// 选下级，循环排除 user-superior-name 里的值
				checkClashId = "user-superior-id";
				checkClashName = "user-superior-name";
			}
			if($("#"+checkClashId).val().indexOf(el) > -1) {
				$("#"+checkClashId).val($("#"+checkClashId).val().replace(el+",",""));
				$("#"+checkClashName).val($("#"+checkClashName).val().replace(inputNameArray[index]+",",""));
			}
		}
	});
}
