<?php
class CSV
{
	var $fp = "";
	var $file = ""; //记录CSV文件
	var $num  = "";  //记录统计文件
	var $spot = "";
	/*函数：open(integer)
	返回：$fp
	功能：返回文件指针

	参数：(0,1,2),[0对应"r"][1对应"w"][2对应"a"][3对应"r+"]
	使用：open(0),open(1),open(2)
	*/
	function open($mode)
	{
		global $_lang;
		switch($mode)
		{
			case 0:$way="r";break;
			case 1:$way="w";break;
			case 2:$way="a";break;
			case 3:$way="r+";break;
			default:exit($_lang["common_open_mode_fail"]);break;
		}
		$fp = fopen($this->file,$way);
		if(!$fp)
		{
			exit($_lang["common_open_data_fail"]);
		}
		$this->fp = $fp;
	}
	/*函数：getField()
	返回：Array
	功能：取得CSV文件的字段名称

	使用：count(Array)取得字段数目,Array[0],Array[1],...,Array[n]取得各字段名称

	*/
	function getField()
	{
		global $_lang;
		$this->open(3);
		rewind($this->fp);
		setlocale(LC_ALL,NULL);
	
		$field = fgetcsv($this->fp,1000,$this->spot);
		if(!$field)
		{
			exit($_lang["common_get_csv_name_fail"]);
		}
		$field_num = count($field);
		if($field_num==0||$field==null)
		{
			exit($_lang["common_field_null"]);
		}
		//list($bianhao,$biaoti,$laiyuan,$shijian,$leibie,$fangci) = $field;
		//echo "$bianhao,$biaoti,$laiyuan,$shijian,$leibie,$fangci";
		return $field;
	}

	/*函数getCsvData()
	返回：Array
	功能：取得CSV文件所有数据

	使用：可使用echo 来打印输出查看返回的array数据

	*/

	function getCsvData()
	{
		global $_lang;
		$this->open(3);
		rewind($this->fp);
		setlocale(LC_ALL,NULL);

    	$config = array();

    	$i=0;

		while($line = fgetcsv($this->fp)){

			$i++;
			if ($i==1) {
				continue;
			}

			foreach ($line as $key => $value) {
				$line[$key]=iconv('GBK','UTF-8',$line[$key]);
			}

			$config[]=$line;
			
		}
	
		return $config;
	}

	/**
	*@function 替换获取fgetcsv函数
	*@param $handle
	*@param $length
	*@param $d
	*@param $e
	*/
	function fgetcsv_reg(& $handle, $length = null, $d = ',', $e = '"') {
		$d = preg_quote($d);
		$e = preg_quote($e);
		$_line = "";
		$eof   = false;
		
		while($eof != true) {
			$_line  .= (empty ($length) ? fgets($handle) : fgets($handle, $length));
			$itemcnt = preg_match_all('/'.$e.'/',$_line,$dummy);

			if($itemcnt % 2 == 0)
				$eof = true;
		}

	    $_csv_line    = preg_replace('/(?: |[ ])?$/', $d, trim($_line));
	    $_csv_pattern = '/(' . $e . '[^' . $e . ']*(?:' . $e . $e . '[^' . $e . ']*)*' . $e . '|[^' . $d . ']*)' . $d . '/';
	    preg_match_all($_csv_pattern, $_csv_line, $_csv_matches);

	    $_csv_data = $_csv_matches[1];

	    for($_csv_i = 0; $_csv_i < count($_csv_data); $_csv_i++) {
	        $_csv_data[$_csv_i] = preg_replace('/^' . $e . '(.*)' . $e . '$/s', '$1', $_csv_data[$_csv_i]);
	        $_csv_data[$_csv_i] = str_replace($e . $e, $e, $_csv_data[$_csv_i]);
	    }
	    return empty ($_line) ? false : $_csv_data;
	}

	/*函数：getRecord()
	返回：Array||0 ,0表示到达文件尾

	功能：取得CSV文件的一行字段数据

	使用：count(Array)取得字段数目,Array[0],Array[1],...,Array[n]取得各字段数据

	*/
	function getRecord()
	{
		if(!$this->fp) {			
			$this->fp = $this->open(0);
		}
		setlocale(LC_ALL,NULL);
		$record = fgetcsv($this->fp,1000,$this->spot);
		$record_num = count($record);
		return $record;
	}

	/*函数：rows()
	返回：integer
	功能：返回CSV数据记录条数
	使用：rows(), 可用于分页

	*/
	function rows()
	{
		$file = file($this->file);
		$rows = count($file)-1;
		return $rows;
	}

	/*函数：append()
	返回：空
	功能：添加一条CSV数据记录
	使用：append();
	*/
	function append($arr)
	{
		global $_lang;
		if((count($arr)+1)!=count($this->getField()))
		{
			exit($_lang["common_field_num_error"]);
		}
		if(!$this->fp)
		{
			$this->close();
		}
		$fp=fopen($this->num,"r+");
		$id=fgets($fp,1000);
		$id++;
		rewind($fp);
		fputs($fp,$id);
		fclose($fp);
		$this->open(2);
		fputs($this->fp,"\r\n");
		fputs($this->fp,$id.$this->spot.join($this->spot,$arr));
	}
	/*函数：delete($id)
	功能：删除一个记录

	参数：$id记录号，find()函数返回
	使用：delete($id)
	*/
	function find($field,$str)
	{
		$fp=fopen($this->file,"r");
		$k = 0;
		setlocale(LC_ALL,NULL);
		while($arrLine=fgetcsv($fp,1000,$this->spot))
		{
			$k++;
			$total=count($arrLine);
			for($i=1;$i<=$total;$i++)
			{
				if($arrLine[$field]==$str)
				{
				return $k;
				}
			}
		}
	}
	function delete($id)
	{
		$temp=array();
		$file = file($this->file);
		$total = count($file);
		$k=0;
		for($i=1;$i<$total;$i++)
		{
			if(($i+1)==$id)
			{
				continue;
			}
			$temp[$k]=$file[$i];
			$k++;
		}
		if($this->fp){fclose($this->fp);}
		$fp=fopen($this->file,"w");
		fputs($fp,$file[0]);
		fputs($fp,join($temp));
		fclose($fp);
		$fp2=fopen($this->num,"r+");
		$num=fgets($fp2,1000);
		$num--;
		rewind($fp2);
		fputs($fp2,$num);
		fclose($fp2);
	}
	/*函数：close($fp)
	功能：关闭文件指针

	参数：$fp一个文件指针

	使用：close()
	*/
	function close()
	{
		@fclose($this->fp);
	}
}
?>
