<?php

/**
 * Description of Mmsql
 *
 * @author Administrator
 */
include_once(dirname(__FILE__) . '/DBAL.php');
class Mmsql extends DBAL{
    public function __construct() {
        parent::__construct();
    }
    public function sqlConnect($sqlserver, $sqluser, $sqlpassword, $database, $port = false, $persistency = false, $newLink = false){
		$this->persistency = $persistency;
		$this->user = $sqluser;
		$this->dbname = $database;

		$porteDlimiter = (defined('PHP_OS') && substr(PHP_OS, 0, 3) === 'WIN') ? ',' : ':';
		$this->server = $sqlserver . (($port) ? $porteDlimiter . $port : '');

		@ini_set('mssql.charset', 'UTF-8');
		@ini_set('mssql.textlimit', 2147483647);
		@ini_set('mssql.textsize', 2147483647);

		if (version_compare(PHP_VERSION, '5.1.0', '>=') || (version_compare(PHP_VERSION, '5.0.0-dev', '<=') && version_compare(PHP_VERSION, '4.4.1', '>='))){
			$this->dbConnectId = ($this->persistency) ? @mssql_pconnect($this->server, $this->user, $sqlpassword, $new_link) : @mssql_connect($this->server, $this->user, $sqlpassword, $newLink);
		}else{
			$this->dbConnectId = ($this->persistency) ? @mssql_pconnect($this->server, $this->user, $sqlpassword) : @mssql_connect($this->server, $this->user, $sqlpassword);
		}

		if ($this->dbConnectId && $this->dbname != ''){
			if (!@mssql_select_db($this->dbname, $this->dbConnectId)){
				@mssql_close($this->dbConnectId);
				return false;
			}
		}

		return ($this->dbConnectId) ? $this->dbConnectId : false;
	}
    public function _sqlClose()
	{
		return @mssql_close($this->dbConnectId);
	}
    public function _sqlFreeResult($result){
       return  @mssql_free_result($result);
    }
    public function _execute($query){
        return @mssql_query($query, $this->dbConnectId);
    }
    public function _sqlGetRows($query){
        $result     = $this->_execute($query);
        $data = array();
        if($result){
            while ($row = @mssql_fetch_array($result,MSSQL_ASSOC)){
                array_push($data, $row);
            }
            $this->_sqlFreeResult($result);
            return $data;
        }
        return false;
    }
    public function _sqlGetRow($query){
        $result     = $this->_execute($query);
        $data = array();
        if($result){
            $row = @mssql_fetch_array($result,MSSQL_ASSOC);
            $this->_sqlFreeResult($result);
            return $row;
        }
        return false;
    }
     public function _sqlInsert($data,$tableName,$insertId){
        $query = 'INSERT INTO '.$tableName . '(';
        $nameQuery  = '';
        $valueQuery = '';
        foreach($data as $k => $v){
            $k      = strtoupper($k);
            $nameQuery .= "`$k`,";
            if(is_numeric($v)){
                $valueQuery .= "$v,";
            }else{
                $valueQuery .= "'$v',";
            }
        }
        $nameQuery  = substr($nameQuery,0,strrpos($nameQuery, ','));
        $valueQuery = substr($valueQuery,0,strrpos($valueQuery, ','));
        $query      .= $nameQuery.') VALUES('.$valueQuery.')';
        if($this->_execute($query)){
           return true;
        }
        return false;
    }
    public function _sqlGetTables(){
        $tables = array();
		$result = $this->sql_query('SELECT name FROM sysobjects WHERE xtype=\'U\'');
		while ($row = $this->sql_fetchrow($result))
		{
			$tables[] = $row['name'];
		}
		return $tables;
    }
    public function sqlGetFields($tablename)
	{
		$data = array();
		$query = 'Select Name from SysColumns Where id=Object_Id(\'' . SecurityFilter($tablename) . '\')';
		$result = $this->_execute($query);
		while ($row = $this->sql_fetchrow($result))
		{
			$data[] = $row['Field'];
		}
		return $data;
	}
}
