Ext.onReady(function(){
	Ext.QuickTips.init();
	var msg = function(title, msg){
	    Ext.Msg.show({
	        title: title, 
	        msg: msg,
	        minWidth: 200,
	        modal: true,
	        icon: Ext.Msg.INFO,
	        buttons: Ext.Msg.OK
	    });
	};
	var fp = new Ext.FormPanel({
	    renderTo: 'fi-form',
	    fileUpload: true,
	    width: 500,
	    frame: true,
	    title: 'File Upload Form',
	    autoHeight: true,
	    bodyStyle: 'padding: 10px 10px 0 10px;',
	    labelWidth: 50,
	    defaults: {
	        anchor: '95%',
	        allowBlank: false,
	        msgTarget: 'side'
	    },
	    items: [{
	        xtype: 'textfield',
	        fieldLabel: 'Name'
	    },{
	        xtype: 'fileuploadfield',
	        id: 'form-file',
	        emptyText: 'Select an image',
	        fieldLabel: 'Photo',
	        name: 'photo-path',
	        buttonCfg: {
	            text: '',
	            iconCls: 'upload-icon'
	        }
	    }],
	    buttons: [{
	        text: EOlang.msgSaveEdit,
	        handler: function(){
	            if(fp.getForm().isValid()){
	                fp.getForm().submit({
	                    url: 'file-upload.php',
	                    waitMsg: 'Uploading your photo...',
	                    success: function(fp, o){
	                        msg('Success', 'Processed file "'+o.result.file+'" on the server');
	                    }
	                });
	            }
	        }
	    },{
	        text: EOlang.msgReset,
	        handler: function(){
	            fp.getForm().reset();
	        }
	    }]
	});
});