<?
/**
 *@Copyright (C) 2010 - 2011 Weaver Co.Ltd
 *@systemname:       E-Office
 *@function:         日志播报
 *@encoding:         $_lang['encoding']
 *@author:           samuel|www.weaver.com.cn
 *@date:             2011-12-13
 *@file Version:     1.0
 *@eoffice Version:  8.0
 */

class Broadcast {
	var $needBroadcastTable;
	var $broadcastCount;
	var $userID;
	function Broadcast($needBroadcastTable, $broadcastCount, $userID) {
		$this -> needBroadcastTable = "\"" . implode("\",\"", $needBroadcastTable) . "\"";
		$this -> broadcastCount = $broadcastCount;
		$this -> userID = $userID;
	}

	/*
	 *获取日志主方法
	 */
	function BroadcastMainFunction() {
		global $connection;

		//获取缓存
		$cacheData = $this -> GetCache();

		//获取新的需要播报的日志
		$newBroadcast = $this -> GetNewBroadcast($cacheData);

		//更新缓存
		$this -> WriteCache($newBroadcast, $cacheData);
		return array_reverse($newBroadcast);
	}

	/*
	 *获取标题
	 */
	function GetBroadcastTitle($logSourceField, $logSourceTable, $logSourceKeyField, $logSourceKeyValue) {
		global $connection;
		$query = "SELECT " . SecurityFilter($logSourceField) . " FROM " . SecurityFilter($logSourceTable) . " WHERE " . SecurityFilter($logSourceKeyField) . "=" . SecurityFilter($logSourceKeyValue);
		$result = exequery($connection, $query);
		if ($row = mysql_fetch_array($result)) {
			return $row[$logSourceField];
		} else {
			return false;
		}
	}

	/*
	 *获取最新日志
	 */
	function GetNewBroadcast($cacheData) {
		global $connection;
		global $_lang;

		//获取缓存中最大的日志ID
		if (is_array($cacheData) && count($cacheData) > 0 && date("Y-m-d", strtotime($cacheData[0]["logDateTime"])) == date("Y-m-d")) {
			$logIDFlag = $cacheData[0]["logID"];
		}

		//查询需要播报的日志数据
		$query = "SELECT * FROM sys_broadcast WHERE LOG_SOURCE_TABLE IN (" . SecurityFilter($this -> needBroadcastTable) . ") AND DATE_FORMAT(LOG_DATE_TIME,'%Y-%m-%d') = DATE_FORMAT(NOW(),'%Y-%m-%d')";
		if ($logIDFlag) {
			$query .= " AND LOG_ID>" . $logIDFlag;
		}
		$query .= " ORDER BY LOG_DATE_TIME DESC LIMIT 0,100";

		$result = exequery($connection, $query);

		$newBraoadcast = array();
		if (mysql_num_rows($result) > 0) {
			while ($row = mysql_fetch_array($result)) {

				//操作类型
				$op = $row["LOG_OPREATION_TYPE"];

				//用户ID
				$userID = $row["LOG_USER_ID"];

				//来源表
				$logSourceTable = $row['LOG_SOURCE_TABLE'];

				//来源表主键值
				$logSourceKeyValue = $row['LOG_SOURCE_KEY_VALUE'];

				//来源表主键字段
				$logSourceKeyField = $row["LOG_SOURCE_KEY_FIELD"];

				//来源表标题字段
				$logSourceField = $row["LOG_SOURCE_FIELD"];

				//日志ID
				$logID = $row["LOG_ID"];

				//日志时间
				$logDateTime = $row["LOG_DATE_TIME"];

				//获取用户名和头像
				$userInfor = $this -> GetUserNameAndAvatarType($userID);

				if ($userInfor) {
					$userName = $userInfor["userName"];
					$avatarType = $userInfor["avatarType"];
				}

				if ($op == "new") {//新建
					//检查此条日志的权限
					$checkResult = $this -> CheckPrivilege($logSourceTable, $logSourceKeyValue);

					//获取标题
					$title = $this -> GetBroadcastTitle($logSourceField, $logSourceTable, $logSourceKeyField, $logSourceKeyValue);

					if ($checkResult) {

						array_push($newBraoadcast, array(
								"userID" => $userID,
								"userName" => $userName,
								"logDateTime" => $logDateTime,
								"logID" => $logID,
								"op" => $op,
								"title" => $title,
								"link" => $this -> GetLink($logSourceTable, $logSourceKeyValue),
								"avatarType" => $avatarType,
								"source" => strtolower($logSourceTable)
						));
					}

				} else if ($op == "delete" && $this -> userID == 'admin') {//删除 只有管理员能看到删除

					//删除的标题从备注里边取
					$remark = $row["LOG_REMARK"];
					$remarkArray = json_decode($remark, true);
					$title = $remarkArray["title"];

					array_push($newBraoadcast, array(
							"userID" => $userID,
							"userName" => $userName,
							"logDateTime" => $logDateTime,
							"logID" => $logID,
							"op" => $op,
							"title" => $title,
							"link" => "",
							"avatarType" => $avatarType,
							"source" => strtolower($logSourceTable)
					));
				}

				//达到需要播报的最多条数，退出
				if (count($newBraoadcast) == $this -> broadcastCount) {
					break;
				}
			}
		}
		return $newBraoadcast;
	}

	/*
	 *获取用户名和用户头像类型
	 */
	function GetUserNameAndAvatarType($userID) {
		global $connection;
		$query = "SELECT USER_NAME,AVATAR_TYPE FROM user WHERE USER_ID='" . SecurityFilter($userID) . "'";
		$result = exequery($connection, $query);
		if ($row = mysql_fetch_array($result)) {
			return array(
					"userName" => $row["USER_NAME"],
					"avatarType" => $row["AVATAR_TYPE"]
			);
		} else {
			return false;
		}
	}

	/*
	 * 获取缓存文件
	 */
	function GetCache() {
		$filename = ROOT_PATH . "/cache/broadcast/" . $this -> userID . ".txt";
		if (file_exists($filename)) {
			$content = file_get_contents($filename);
			if (trim($content) == "") {
				return false;
			} else {
				$cacheData = json_decode($content, true);

				//更新头像文件
				for ($i = 0; $i < count($cacheData); $i++) {
					$userInfor = $this -> GetUserNameAndAvatarType($cacheData[$i]["userID"]);
					$cacheData[$i]["avatarType"] = $userInfor["avatarType"];
				}

				if (is_array($cacheData) && count($cacheData) > 0) {
					return $cacheData;
				} else {
					return false;
				}
			}
		} else {
			return false;
		}
	}

	/*
	 * 检查缓存日志是否存在
	 */
	function CheckLogIsExsit($newCacheArray, $oldLogID) {
		for ($i = 0; $i < count($newCacheArray); $i++) {
			$newLogID = $newCacheArray[$i]["logID"];
			if ($oldLogID == $newLogID) {
				return true;
			}
		}
		return false;
	}

	/*
	 * 写入缓存
	 */
	function WriteCache($newCacheArray, $cacheData) {

		//如果新的播报不足展示的条数，则从旧的缓存中补充
		if (count($newCacheArray) < $this -> broadcastCount) {
			if (is_array($cacheData)) {
				for ($i = 0; $i < count($cacheData); $i++) {
					if (count($newCacheArray) == $this -> broadcastCount) {
						break;
					}
					if (!$this -> CheckLogIsExsit($newCacheArray, $cacheData[$i]["logID"])) {
						array_push($newCacheArray, $cacheData[$i]);
					}
				}
			}

		}

		if (count($newCacheArray) == 0) {
			return false;
		}

		$path = ROOT_PATH . "/cache/broadcast";
		if (!file_exists($path)) {
			if (!mkdir($path, 0700)) {
				return false;
			}
		}
		$filename = $path . "/" . $this -> userID . ".txt";
		if (file_put_contents($filename, json_encode($newCacheArray)) == 0) {
			return false;
		}
		return true;
	}

	/*
	 * 验证权限
	 */
	function CheckPrivilege($logSourceTable, $logSourceKeyValue) {

		switch (strtolower($logSourceTable)) {
			//公告
			case 'notify' :
				$notify = new notify();
				$notifyCheckResult = $notify -> notifyAccessControl($logSourceKeyValue);
				if (count($notifyCheckResult) == 1) {
					return true;
				} else {
					return false;
				}
				break;
			//文档
			case 'file_content' :
				$file = new read();
				return $file -> CheckDocumentPurview($logSourceKeyValue);
				break;
			//客户
			case 'customer' :
				$customer = new customer();
				return $customer -> get_customer_purview($logSourceKeyValue);
				break;
			//联系记录
			case 'relation_record' :
				$relation_record = new customer();
				return $relation_record -> get_record_purview($logSourceKeyValue);
				break;
			//日程
			case 'calendar' :
				$calendar = new calendar();
				return $calendar -> getCalengdarPur($logSourceKeyValue);
				break;
			//日志
			case 'diary' :
				$diary = new diary();
				return $diary -> GetDiaryPurview($logSourceKeyValue);
				break;
			//新闻
			case 'news' :
				$news = new news();
				$newsCheckResult = $news -> newsAccessControl($logSourceKeyValue);
				if (count($newsCheckResult) == 1) {
					return true;
				} else {
					return false;
				}
				break;
		}
	}

	/*
	 * 获取播报日志查看链接
	 */
	function GetLink($logSourceTable, $logSourceKeyValue) {
		switch (strtolower($logSourceTable)) {
			//公告
			case 'notify' :
				return "/general/notify/show/read_notify.php?NOTIFY_ID=" . $logSourceKeyValue;
				break;
			//文档
			case 'file_content' :
				return "/general/file_folder/file_new/read.php?CONTENT_ID=" . $logSourceKeyValue;
				break;
			//客户
			case 'customer' :
				return "/general/crm/customer/customer.php?CUSTOMER_ID=" . $logSourceKeyValue;
				break;
			//联系记录
			case 'relation_record' :
				return "/general/crm/customer/record_detail.php?RE_ID=" . $logSourceKeyValue;
				break;
			//日程
			case 'calendar' :
				return "/general/calendar/cal_detail.php?CAL_ID=" . $logSourceKeyValue;
				break;
			//日志
			case 'diary' :
				return "/general/diary/diary_show.php?diaryid=" . $logSourceKeyValue;
				break;
			//新闻
			case 'news' :
				return "/general/news/show/read_news.php?NEWS_ID=" . $logSourceKeyValue;
				break;
		}
	}

}
?>