<?php
/**
*@Systemname:     Teems
*@Filename:       $path/$name
*@Function:       $function
*@Encoding:       $_lang['encoding']
*@Author:         xiulin.liu www.weaver.com.cn
*@Date:           2006-1-17
*@Version:        6.0
*/

/**
*创建Jpeg图片
*@param string $source_src    资源来源
*@param string $picname       图片名
*@param string $dst_width     宽度
*@param string $dst_height    高度
*@return string $reimgscr
*/
function createJpeg($source_src,$picname,$dst_width="100",$dst_height="100")
{
	/*
	var $dst_x;                
	var	$dst_y;
	var	$src_x;                
	var	$src_y;
	var	$dst_width;            
	var	$dst_height;
	*/
	$newpicname = $dst_width.$dst_height.$picname;
	$cachedir   = mkMd5DirForCache($picname);
	$destination = $cachedir.$newpicname;
	$source_src  = iconv("utf-8","gbk",$source_src);
	$dst_x = 0;
	$dst_y = 0;
	$src_x = 0;
	$src_y = 0;
	$im_src = @imagecreatefrompic($source_src);
	$im_width  = @imagesX($im_src);
	$im_height = @imagesY($im_src);
	
	if ($dst_width > 0 && $dst_height < 1)
	{    
		$im_width = imagesX($im_src);
		$new_width = $dst_width;
		$new_height = floor(($new_width/$im_width)*(imagesY($im_src)));		
	}

	if ($dst_height > 0 && $dst_width < 1)
	{
		
		$im_height = imagesY($im_src);
		$new_height = $dst_height;
		$new_width = floor(($new_height/$im_height)*(imagesX($im_src)));		
	}
	
	if ($dst_height > 0 && $dst_width > 0)
	{
		$new_height = $dst_height;
		$new_width = $dst_width;
	}
	if ($dst_height < 1 && $dst_width < 1)
	{
		$new_height = imagesY($im_src);
		$new_width = imagesX($im_src);
	}

    $reimgscr = str_replace(ROOT_PATH,ROOT_URL,$destination);	
	if (is_file($destination))
	{
        $im_src_have = @imagecreatefrompic($destination);
		if (($new_width == imagesx($im_src_have)) && ($new_height == imagesy($im_src_have)))
		{
		   return $reimgscr;
		}	
	}	

	$im = imagecreatetruecolor($new_width, $new_height);
	imagecopyresized($im, $im_src, 0, 0, 0, 0, $new_width, $new_height, $im_width, $im_height);
	imagepic($im, $destination, 85);
	imagedestroy($im); 
	return $reimgscr;
}

/*
	自定义处理bmp图片函数
*/
function ImageCreateFromBMP($filename){
    if(!$f1=fopen($filename,"rb"))returnFALSE;
    $FILE=unpack("vfile_type/Vfile_size/Vreserved/Vbitmap_offset",fread($f1,14));
    if($FILE['file_type']!=19778)returnFALSE;
    $BMP=unpack('Vheader_size/Vwidth/Vheight/vplanes/vbits_per_pixel'.
            '/Vcompression/Vsize_bitmap/Vhoriz_resolution'.
            '/Vvert_resolution/Vcolors_used/Vcolors_important',fread($f1,40));
    $BMP['colors']=pow(2,$BMP['bits_per_pixel']);
    if($BMP['size_bitmap']==0)$BMP['size_bitmap']=$FILE['file_size']-$FILE['bitmap_offset'];
    $BMP['bytes_per_pixel']=$BMP['bits_per_pixel']/8;
    $BMP['bytes_per_pixel2']=ceil($BMP['bytes_per_pixel']);
    $BMP['decal']=($BMP['width']*$BMP['bytes_per_pixel']/4);
    $BMP['decal']-=floor($BMP['width']*$BMP['bytes_per_pixel']/4);
    $BMP['decal']=4-(4*$BMP['decal']);
    if($BMP['decal']==4)$BMP['decal']=0;
    $PALETTE=array();
    if($BMP['colors']<16777216)
    {
        $PALETTE=unpack('V'.$BMP['colors'],fread($f1,$BMP['colors']*4));
    }
    $IMG=fread($f1,$BMP['size_bitmap']);
    $VIDE=chr(0);
    $res=imagecreatetruecolor($BMP['width'],$BMP['height']);
    $P=0;
    $Y=$BMP['height']-1;
    while($Y>=0)
    {
        $X=0;
        while($X<$BMP['width'])
        {
            if($BMP['bits_per_pixel']==24)
                $COLOR=unpack("V",substr($IMG,$P,3).$VIDE);
            elseif($BMP['bits_per_pixel']==16)
            {
                $COLOR=unpack("n",substr($IMG,$P,2));
                $COLOR[1]=$PALETTE[$COLOR[1]+1];
            }
            elseif($BMP['bits_per_pixel']==8)
            {
                $COLOR=unpack("n",$VIDE.substr($IMG,$P,1));
                $COLOR[1]=$PALETTE[$COLOR[1]+1];
            }
            elseif($BMP['bits_per_pixel']==4)
            {
                $COLOR=unpack("n",$VIDE.substr($IMG,floor($P),1));
                if(($P*2)%2==0)$COLOR[1]=($COLOR[1]>>4);else$COLOR[1]=($COLOR[1]&0x0F);
                $COLOR[1]=$PALETTE[$COLOR[1]+1];
            }
            elseif($BMP['bits_per_pixel']==1)
            {
                $COLOR=unpack("n",$VIDE.substr($IMG,floor($P),1));
                if(($P*8)%8==0)$COLOR[1]=$COLOR[1]>>7;
                elseif(($P*8)%8==1)$COLOR[1]=($COLOR[1]&0x40)>>6;
                elseif(($P*8)%8==2)$COLOR[1]=($COLOR[1]&0x20)>>5;
                elseif(($P*8)%8==3)$COLOR[1]=($COLOR[1]&0x10)>>4;
                elseif(($P*8)%8==4)$COLOR[1]=($COLOR[1]&0x8)>>3;
                elseif(($P*8)%8==5)$COLOR[1]=($COLOR[1]&0x4)>>2;
                elseif(($P*8)%8==6)$COLOR[1]=($COLOR[1]&0x2)>>1;
                elseif(($P*8)%8==7)$COLOR[1]=($COLOR[1]&0x1);
                $COLOR[1]=$PALETTE[$COLOR[1]+1];
            }
            else
                returnFALSE;
            imagesetpixel($res,$X,$Y,$COLOR[1]);
            $X++;
            $P+=$BMP['bytes_per_pixel'];
        }
        $Y--;
        $P+=$BMP['decal'];
    }
    fclose($f1);
    return$res;
}

/**
*创建不同格式图片
*@param string $source_src 图片来源
*@return string $im        返回的图像
*/
function imagecreatefrompic($source_src) {
	$suffix = getFileSuffix($source_src);
	switch ($suffix){
		case "jpg":
			$im = @imagecreatefromjpeg($source_src);
			break;
		case "jpeg":
			$im = @imagecreatefromjpeg($source_src);
			break;
		case "gif":
			$im = @imagecreatefromgif($source_src);
			break;
		case "png":
			$im = @imagecreatefrompng($source_src);
			break;
		case "wbm":
			$im = @imagecreatefromwbmp($source_src);
			break;
		case "bmp":
			$im = @ImageCreateFromBMP($source_src);
			break;
		default:
			$im = @imagecreatefromjpeg($source_src);
	}
	return $im;
}

/**
*根据不同图片格式返回对应类型的图片
*@param string $im          创建的图片
*@param string $destination 图片输出的位置
*@param string $quality  	初始值为85
*/
function imagepic($im,$destination,$quality="85"){
	$suffix = getFileSuffix($destination);
	$destination = iconv("utf-8","gbk",$destination);
	switch ($suffix){
		case "jpg":
			@imagejpeg($im,$destination,$quality);
			break;
		case "jpeg":
			@imagejpeg($im,$destination,$quality);
			break;
		case "gif":
			@imagegif($im,$destination);
			break;
		case "png":
			@imagepng($im,$destination);
			break;
		default:
			@imagejpeg($im,$destination,$quality);
	}
}

/**
*加密的缓存文件
*@param string $filename      文件名
*@return string $level_2_dir  返回的是经过加密处理放在缓存下的文件
*/
function mkMd5DirForCache($filename){
	$level_1 = substr(md5($filename),0,2);
	$level_1_dir= CACHE_DIR.$level_1."/";
	if (!is_dir($level_1_dir)){
		mkdir($level_1_dir,0755);
	}
	$level_2 = substr(md5($filename),2,2);
	$level_2_dir= $level_1_dir.$level_2."/";
	if (!is_dir($level_2_dir)){
		mkdir($level_2_dir,0755);
	}
	return $level_2_dir;
}

/**
*创建图片
*@param string $imagesource   图片来源
*@param string $picname       图片名
*@param string $size          初始值为80
*@param string $attachmentid  附件ID
*@return string  $reimgscr    返回创建的图片
*/
function createimage($imagesource,$picname,$size='80',$attachmentid='')
{
	$newpicname  = $size.$picname;
	$cachedir    = mkMd5DirForCache($attachmentid.$picname);
	$destination = $cachedir.$newpicname;
    if(file_exists($destination)){
        $reimgscr = str_replace(ROOT_PATH,ROOT_URL,$destination);
        return $reimgscr;
    }
	$source_src  = iconv("utf-8","gbk",$imagesource);
	$dst_x = 0;
	$dst_y = 0;
	$src_x = 0;
	$src_y = 0;
	$im_src = @imagecreatefrompic($source_src);
	$im_width = @imagesx($im_src);
	$im_height = @imagesy($im_src);
	if ($im_width > $im_height )
	{
		$dst_x = $size;
		$dst_y = ($dst_x*$im_height)/$im_width;
	} else {
		$dst_y = $size;
		@$dst_x = ($dst_y*$im_width)/$im_height;
	}

	if ($size == 0)
	{
		$dst_x = $im_width;
		$dst_y = $im_height;
	}

    $reimgscr = str_replace(ROOT_PATH,ROOT_URL,$destination);
	if (is_file($destination))
	{
		$im_src_have = @imagecreatefrompic($destination);
		if (($dst_x == imagesx($im_src_have)) && ($dst_y == imagesy($im_src_have)))
		{
		   return $reimgscr;
		}	
	}

	$im = @imagecreatetruecolor($dst_x, $dst_y);
	@imagecopyresized($im, $im_src, 0, 0, 0, 0, $dst_x, $dst_y, $im_width, $im_height);
	imagepic($im, $destination, 85);
	@imagedestroy($im); 
	return $reimgscr;	
}

/**
*创建Jpeg类型图片(有$picid区分同文件名的图片)
*@param string $source_src   文件来源
*@param string $picname      图片名称
*@param string $dst_width    图片宽度,初始为100
*@param string $dst_height   图片高度,初始为100
*@param unknown_type $picid  图片ID，新增（区分同名的图片造成的问题）
*@return string $reimgscr    返回创建的图片
*/
function createJpeg2($source_src,$picname,$dst_width="100",$dst_height="100",$picid)
{
	//$newpicname = $dst_width.$dst_height.$picid.$picname;
	$newpicname = $dst_width.$dst_height.$picid;
	//$cachedir   = mkMd5DirForCache($picname);
	$cachedir   = mkMd5DirForCache($picid);
	$destination = $cachedir.$newpicname;
	$source_src  = iconv("utf-8","gbk",$source_src);
	$dst_x  = 0;
	$dst_y  = 0;
	$src_x  = 0;
	$src_y  = 0;
	$im_src = @imagecreatefrompic($source_src);
	$im_width  = imagesX($im_src);
	$im_height = imagesY($im_src);	
	if ($dst_width > 0 && $dst_height < 1)
	{    
		$im_width = imagesX($im_src);
		$new_width = $dst_width;
		$new_height = floor(($new_width/$im_width)*(imagesY($im_src)));
	}

	if ($dst_height > 0 && $dst_width < 1)
	{		
		$im_height = imagesY($im_src);
		$new_height = $dst_height;
		$new_width = floor(($new_height/$im_height)*(imagesX($im_src)));		
	}
	
	if ($dst_height > 0 && $dst_width > 0)
	{
		$new_height = $dst_height;
		$new_width = $dst_width;
	}
    
	$reimgscr = str_replace(ROOT_PATH,ROOT_URL,$destination);	
	if (is_file($destination))
	{
		$im_src_have = @imagecreatefrompic($destination);
		if (($new_width == imagesx($im_src_have)) && ($new_height == imagesy($im_src_have)))
		{
		   return $reimgscr;
		}	
	}
	$im = imagecreatetruecolor($new_width, $new_height);
	imagecopyresized($im, $im_src, 0, 0, 0, 0, $new_width, $new_height, $im_width, $im_height);
	imagepic($im, $destination, 85);
	imagedestroy($im); 
	return $reimgscr;
}
/**
*创建Jpeg类型图片(有$picid区分同文件名的图片)
*@手机客户端图片显示
*/
function createJpeg3($source_src,$picname,$dst_width="100",$dst_height="100",$picid)
{
	$newpicname = $dst_width.$dst_height.$picid.$picname;
	$cachedir   = mkMd5DirForCache($picname);
	$destination = $cachedir.$newpicname;
	$source_src  = iconv("utf-8","gbk",$source_src);
	$dst_x  = 0;
	$dst_y  = 0;
	$src_x  = 0;
	$src_y  = 0;
	$im_src = @imagecreatefrompic($source_src);
	$im_width  = imagesX($im_src);
	$im_height = imagesY($im_src);	
	if ($dst_width > 0 && $dst_height < 1)
	{    
		$im_width = imagesX($im_src);
		$new_width = $dst_width;
		$new_height = floor(($new_width/$im_width)*(imagesY($im_src)));
	}

	if ($dst_height > 0 && $dst_width < 1)
	{		
		$im_height = imagesY($im_src);
		$new_height = $dst_height;
		$new_width = floor(($new_height/$im_height)*(imagesX($im_src)));		
	}
	
	if ($dst_height > 0 && $dst_width > 0)
	{
		$new_height = $dst_height;
		$new_width = $dst_width;
	}
    
	$reimgscr = str_replace(ROOT_PATH,ROOT_URL,$destination);	
	if (is_file($destination))
	{
		$im_src_have = @imagecreatefrompic($destination);
		if (($new_width == imagesx($im_src_have)) && ($new_height == imagesy($im_src_have)))
		{
		   return $reimgscr;
		}	
	}
	$im = imagecreatetruecolor($new_width, $new_height);
	imagecopyresized($im, $im_src, 0, 0, 0, 0, $new_width, $new_height, $im_width, $im_height);
	imagepic($im, $destination, 85);
	imagedestroy($im); 
	return $reimgscr;
}
?>