<?php
/*
 * Filename:
 * Function:        首页天气（特别注意本页编码为gb2312）
 * Encoding:        gb2312
 * Author:          zhanghao www.weaver.com.cn
 * Date:            2010-12-17
 * Version:         6
 * Eoffice Version: 6.0
 */
//数据来源中国气象局
include_once ('inc/simple_html_dom.php');
include_once ('inc/utility_all.php');
class weatherRss {
	/*-----------------------------------------
	 Define
	 -----------------------------------------*/
	var $source = 'http://www.weather.com.cn/html/weather/';
	//来源
	var $id;
	//城市编号
	var $xmldir;
	//xml目录
	var $htmlurl;
	function weatherRss() {
		$rootpath = str_replace('\\', '/', get_cfg_var('doc_root') . "/");
		$this -> xmldir = $rootpath . "cache/rss/";
	}

	//xml是否有效
	function isValidXml($type = "") {
		$xmlurl = $this -> xmldir . $this -> id . ".xml";

		if ($type == "refresh") {//如果是刷新，则删除文件
			@unlink($xmlurl);
		}

		if (file_exists($xmlurl)) {
			if ((time() - filemtime($xmlurl)) < 60 * 60 * 12) {
				//return 1;
			} else {
				$this -> createXml();
			}
		} else {
			$this -> createXml();
		}
	}

	//创建新xml
	//更改了匹配页面的正则表达式，
	function createXml() {
		global $_lang;
		//从气象中心抓取到的页面数据
		$string = $this -> getFile($this -> htmlurl);

		//匹配table
		$tableReg = '/<table\s*class=\"yuBaoTable\".*?>[\s\S]*?<\/table>/';
		preg_match_all($tableReg, $string, $tableInfor);

		//匹配tr
		$trReg = "/<tr\s*.*?>[\s\S]*?<\/tr>/";

		//匹配td
		$aReg = "/<a\s*.*?>[\s\S]*?<\/a>/";
		$weatherInfor = array();

		$weekarray = array(
				$_lang["common_sunday"],
				$_lang["common_monday"],
				$_lang["common_tuesday"],
				$_lang["common_wednesday"],
				$_lang["common_thursday"],
				$_lang["common_friday"],
				$_lang["common_saturday"]
		);
		for ($i = 0; $i < count($tableInfor[0]); $i++) {

			preg_match_all($trReg, $tableInfor[0][$i], $trInfor);

			//白天
			preg_match_all($aReg, $trInfor[0][0], $dayTimeInfor);

			//夜晚
			preg_match_all($aReg, $trInfor[0][1], $nightInfor);

			/***********************************************
			 白天
			 * 0-日期
			 * 2-天气
			 * 3-温度
			 * 4-风向
			 * 5-风速

			 夜晚
			 * 1-天气
			 * 2-温度
			 * 3-风向
			 * 4-风速
			 *
			 */
			$week = date("w", time() + $i * 24 * 3600);
			$date = date("Y".$_lang["common_year"]."n".$_lang["common_month"]."j".$_lang["common_daytime"], time() + $i * 24 * 3600);

			array_push($weatherInfor, array(
					"date" => $date,
					"week" => $weekarray[$week],
					"weather" => strip_tags($dayTimeInfor[0][2]),
					"highTemperature" => str_replace(array(
							"高温",
							"低温",
							"℃"
					), "", strip_tags($dayTimeInfor[0][3])),
					"lowTemperature" => str_replace(array(
							"低温",
							"高温",
							"℃"
					), "", strip_tags($nightInfor[0][2])),
					"windDirection" => str_replace("无持续风向", "无", strip_tags($dayTimeInfor[0][4])),
					"windSpeed" => strip_tags($dayTimeInfor[0][5])
			));

		}

		$txt = "";

		for ($i = 0; $i < count($weatherInfor); $i++) {
			$lowTemperature = $weatherInfor[$i]["lowTemperature"];
			$highTemperature = $weatherInfor[$i]["highTemperature"];

			$txt .= $weatherInfor[$i]["date"] . "*";
			$txt .= $weatherInfor[$i]["week"] . "*";
			$txt .= $weatherInfor[$i]["weather"] . "*";
			$txt .= $highTemperature . "*";
			$txt .= $lowTemperature . "*";
			$txt .= $weatherInfor[$i]["windDirection"] . "*";
			$txt .= $weatherInfor[$i]["windSpeed"] . "*";
			$txt .= "|";
		}
		if (!is_dir($this -> xmldir)) {
			mkdir($this -> xmldir, 0777);
		}
		$this -> putFile($this -> xmldir . $this -> id . ".xml", $txt);
	}

	//取得数据
	function getData() {
		$str = $this -> getFile($this -> xmldir . $this -> id . ".xml");
		$ary = explode("|", $str);
		for ($i = 0; $i < count($ary); $i++) {

			$ary_c = explode("*", $ary[$i]);

			for ($j = 0; $j < count($ary[$i]); $j++) {
				$weatherInfor[$i]["date"] = $ary_c[0];
				$weatherInfor[$i]["week"] = $ary_c[1];
				$weatherInfor[$i]["weather"] = $ary_c[2];
				$weatherInfor[$i]["highTemperature"] = $ary_c[3];
				$weatherInfor[$i]["lowTemperature"] = $ary_c[4];
				$weatherInfor[$i]["windDirection"] = $ary_c[5];
				$weatherInfor[$i]["windSpeed"] = $ary_c[6];
			}
		}
		return $weatherInfor;
	}

	//初始化
	function initRss($id, $type = "") {
		$this -> id = $id;
		$this -> htmlurl = $this -> source . $this -> id . ".shtml";
		$this -> isValidXml($type);
		return $this -> getData();
	}

	function getIp() {
		if ($_SERVER['HTTP_CLIENT_IP']) {
			return $_SERVER['HTTP_CLIENT_IP'];
		} elseif ($_SERVER['HTTP_X_FORWARDED_FOR']) {
			return $_SERVER['HTTP_X_FORWARDED_FOR'];
		} else {
			return $_SERVER['REMOTE_ADDR'];
		}
	}

	function getFile($url) {
		return file_get_contents($url);
	}

	function putFile($file_name, $file_string) {
		if ($f = fopen($file_name, "w")) {
			fputs($f, $file_string);
		}
		fclose($f);
	}

}
?>