<?PHP
/*************************************************************
* Note: 	图形报表-生成柱状图		                         *
* Author: 	Weaver.liuxiulin                                 *
* Contact: 	xiulin.liu@weaver.com.cn		                 *
* Version: 	1.0						                         *
* Eoffice V: 4.0   		                                     *
* Created:  2006-8-8  		                                 *
* Revision: //							                     *
*************************************************************/
include_once("inc/img_func.php");
include_once("inc/img_color.php");
class ReportBarImg{
	/*-----------------------------------------
	Define 
	-----------------------------------------*/
	
	//图片基本属性

	var $property  = 'png'; //图片属性

	var $picwidth  = 800;    //图片宽度
	var $picheight = 300;    //图片高度

	var $spacelefty    = 0.25;
	var $spacerighty   = 0.05;
    var $spacetopx     = 0.15;
    var $spacebottomx  = 0.20;

	var $xnum      = 31; //x轴

	var $xnumcent  = 1;
	var $xnumunits = "";
    var $ynum      = 100; //y轴

	var $ynumcent  = 10;
	var $ynumunits = "";

	var $xlength;  //坐标轴的实际长度 px (有效长度)
	var $ylength;
	var $xyspace  = 20;  //剩余坐标轴的长度

	var $centlength  = 5; //标注点的长度
    var $isynote     = false; //节点是否显示数值

	var $barspace    = 10; //柱形之间的间隙

	var $morebarspace = 5; //多流程bar之间的间隙 可以为负整数

	var $ishavegridx    = false; //是否x显示栅格
	var $ishavegridy    = false; //是否y显示栅格

	var $barside        = true; //描边
	var $effect         = 'alpha'; //柱形颜色

	var $bgcolor        = 'black03';//背景颜色
	var $fringecolort   = 'black01'; //外框颜色
	var $fringecolorb   = 'black02'; //外框颜色
	var $textcolor      = 'white'; //所有文字颜色


	var $charhead   = "";
	var $subhead    = "";
	var $bottomnote = "";
	var $leftnote   = "";

	var $picname    = "";  //图片的文件名

	var $root_path;
	var $drawarray;

	var $im;                 //图片缓冲

	/*
	@ 构造

	@ 2006-8-8
	*/	
	function ReportBarImg(){
		global $_lang;
		$this->charhead    = $_lang["flow_maintitle_default"];
		$this->subhead     = $_lang["flow_subheading_default"];
		$this->bottomnote  = $_lang["flow_bottom_notes"];
		$this->xnumunits   = $_lang["flow_charname"];
		$this->ynumunits   = $_lang["flow_unit"];
		
		$this->root_path  = str_replace('\\','/',get_cfg_var('doc_root')."/");
		$this->picname   = time();
		$this->CreateImg();     // 创建图片
		$this->DefineColor();   //常用颜色定义
		$this->FillImgBg();     //图片背景
		$this->CountXYLength(); //坐标实际长度计算
		$this->DecorateImg();   //图片修饰
	}

	/*
	@ 创建图形
	@ 2006-8-8
	*/
	function CreateImg(){
		$this->im = imagecreatetruecolor($this->picwidth,$this->picheight);
	}

	/*
	@ 填充背景
	@ 2006-8-8
	*/
	function FillImgBg(){
		$color = $this->color[$this->bgcolor];
		imagefilledrectangle($this->im, 0, 0, $this->picwidth, $this->picheight, $color);	
	}

	/*
	@ 修饰图形外围，图表名称，单位等

	@ 2006-8-24
	*/
	function DecorateImg($charhead="",$subhead="",$bottomnote="",$leftnote="",$picname=""){
		$this->charhead   = $charhead?$charhead:$this->charhead;
		$this->subhead    = $subhead?$subhead:$this->subhead;
		$this->bottomnote = $bottomnote?$bottomnote:$this->bottomnote;
		$this->leftnote   = $leftnote?$leftnote:$this->leftnote;
		$this->picname   = $picname?$picname:$this->picname;

		
		imagefilledrectangle($this->im, 0, 0, $this->picwidth*$this->spacelefty, $this->picheight, $this->color[$this->fringecolorb]);
		imagefilledrectangle($this->im, 0, $this->picheight*(1-$this->spacebottomx), $this->picwidth, $this->picheight, $this->color[$this->fringecolorb]);
		imagefilledrectangle($this->im, $this->picwidth*(1-$this->spacerighty), 0, $this->picwidth, $this->picheight, $this->color[$this->fringecolorb]);
		imagefilledrectangle($this->im, 0, 0, $this->picwidth, $this->picheight*$this->spacetopx, $this->color[$this->fringecolort]);

		imageline($this->im,0,0+1,$this->picwidth,0+1,$this->color['white']);
		imageline($this->im,0+1,0,0+1,$this->picheight,$this->color['white']);
		imageline($this->im,0,$this->picheight-1,$this->picwidth,$this->picheight-1,$this->color['blue06']);
		imageline($this->im,$this->picwidth-1,$this->picheight,$this->picwidth-1,0,$this->color['blue06']);
		
		imagestringgb($this->im,12,0,20,($this->picheight*$this->spacetopx)/2,$this->color[$this->textcolor],"simhei.ttf",$this->charhead);
		imagestringgb($this->im,9,0,20,($this->picheight*$this->spacetopx)/2+14,$this->color[$this->textcolor],"simsun.ttc",$this->subhead);

		//底部注解位置的计算x 图片宽度减去左右空隙除2，y 图片高度减去底部空隙除2加字体大小

		imagestringgb($this->im,9,0,$this->picwidth*(1-$this->spacelefty-$this->spacerighty)/2,$this->picheight*(1-($this->spacebottomx)/2)+9,$this->color[$this->textcolor],"simsun.ttc",$this->bottomnote);
		imagestringgb($this->im,9,0,$this->picwidth*(1-$this->spacerighty),$this->picheight*(1-$this->spacebottomx)+18,$this->color[$this->textcolor],"simsun.ttc",$this->xnumunits);

		//imagestring($this->im,3,$this->picwidth*(1-$this->spacerighty)-20,$xy2-$this->xyspace,$this->ynumunits,$color);
		imagestringgb($this->im,9,0,$this->picwidth*($this->spacelefty)-30,$this->picheight*($this->spacetopx)+12,$this->color[$this->textcolor],"simsun.ttc",$this->ynumunits);
	}


	/*
	@ 输出图片
	@ 
	*/
	function OutImg(){
		header('Content-type: image/'.$this->property);
        $this->imagepic();
		imagedestroy($this->im);
		//header('Content-disposition: attachment;filename="'.$this->picname.'"'.'".'.$this->property.'"');
	}

	/*
	@ 定义常用颜色
	@ 2006-9-15
	*/
	function DefineColor(){
		$this->color  = getRPImgColor($this->im);
	}

	/*
	@ 定义图片属性

	@ 2006-9-13
	*/
	function DefinePic($property,$picwidth,$picheight){
		$this->property   = $property;
		$this->picwidth   = $picwidth;
		$this->picheight  = $picheight;

		//2007-5-11
		//重新计算图片space scale 标宽高 450 300
		$sclw = round(450/$this->picwidth,2);
		$sclh = round(300/$this->picheight,2);
		$this->spacelefty    = round(0.25*$sclw,2);
		$this->spacerighty   = round(0.05*$sclw,2);
		$this->spacetopx     = round(0.15*$sclh,2);
		$this->spacebottomx  = round(0.20*$sclh,2);

		$this->ReportBarImg();


		$this->ReportBarImg();
	}

	/*
	@ 定义图片色调
	@ 2006-9-13
	*/
	function DefinePicTinct($bgcolor='gray02',$fringecolort='blue03',$fringecolorb='blue04',$textcolor='black'){
		$this->bgcolor        = $bgcolor;
		$this->fringecolort   = $fringecolort;
		$this->fringecolorb   = $fringecolorb;
		$this->textcolor      = $textcolor;

		$this->ReportBarImg();
	}

	/*
	@ 定义坐标参数
	@ 2006-9-13
	*/
	function DefineCdPar($xnum,$xnumcent,$xnumunits,$ynum,$ynumcent,$ynumunits){
		$this->xnum       = $xnum;
		$this->xnumcent   = $xnumcent;
		$this->xnumunits  = $xnumunits;
		$this->ynum       = $ynum;
		$this->ynumcent   = $ynumcent;
		$this->ynumunits  = $ynumunits;
		$this->ReportBarImg();
	}

	/*
	@ 定义柱图属性

	@ 2006-9-13
	*/	
	function DefineLpPar($ishavegridx=false,$ishavegridy=false,$isynote=false,$barspace=10,$morebarspace=5,$barside=true,$effect='alpha'){
		$this->ishavegridx    = $ishavegridx; //是否显示栅格x
		$this->ishavegridy    = $ishavegridy; //是否显示栅格x
		$this->isynote        = $isynote; //节点是否显示数值

		$this->barspace       = $barspace;//柱形间隙
		$this->morebarspace   = $morebarspace;
		$this->barside        = $barside;
		$this->effect         = $effect;

		//$this->ReportLineImg();
	}


	/*
	@ 计算x,y坐标长度
	@ 2006-8-8
	*/
	function CountXYLength(){
		$this->xlength = $this->picwidth*(1-$this->spacelefty-$this->spacerighty)-$this->xyspace;
		$this->ylength = $this->picheight*(1-$this->spacetopx-$this->spacebottomx)-$this->xyspace;;
	}

	/*
	@ 图片格式不同使用对应函数
	@ 2006-8-8
	*/
	function imagepic(){
		switch ($this->property){
			case 'jpeg':
				imagejpeg($this->im);
				break;
			case 'png':
				imagepng($this->im);
				break;
			case 'gif':
				imagegif($this->im);
				break;
			default:
				imagepng($this->im);
		}
	}
	/*
	@ 创建坐标,坐标线,x轴,y轴单位分布点
	@ 2006-8-8
	*/
	function DrawBasicCoordinate($drawarray=''){
		if(count($drawarray) ==0){
			return;
		}
		$color = $this->color['black'];
		$color_grid = $this->color['gray00'];
		$x1 = $this->picwidth*$this->spacelefty;
		$y1 = $this->picheight*(1-$this->spacebottomx);

		$x2 = $x1;
		$y2 = $this->picheight*$this->spacetopx;
		imageline($this->im,$x1,$y1,$x2,$y2,$color);
		imageline($this->im,$x1-1,$y1,$x2-1,$y2,$color);

		$x2 = $this->picwidth*(1-$this->spacerighty);
		$y2 = $y1;
		imageline($this->im,$x1,$y1,$x2,$y2,$color);
		imageline($this->im,$x1,$y1+1,$x2,$y2+1,$color);

		//x方向的单位分布

		$x_cent_total = floor($this->xnum/$this->xnumcent);
		for ($i=0;$i<=$x_cent_total;$i++){
			$xx1 = $x1+floor(($i*$this->xlength)/$x_cent_total);
			$xy1 = $y1;
			$xx2 = $xx1;
			$xy2 = $y1+$this->centlength;
			imageline($this->im,$xx1,$xy1,$xx2,$xy2,$color);
			//echo "<pre>";print_r($drawarray);
			$text = $drawarray[$i]['x'];
			//imagestring($this->im,2,$xx2,$xy2+5,$text,$color);
			$strx = $x1+floor(($i/$x_cent_total)*$this->xlength-$this->xlength*(1/$x_cent_total)*0.75);
			imagestringgb($this->im,9,0,$strx,$xy2+9,$this->color[$this->textcolor],"simsun.ttc",$text);

			if ($this->ishavegridx && $i<>0){
				imageline($this->im,$xx1,$xy1,$xx2,$y1-$this->ylength,$color_grid);
				//imagelinedashed($this->im,$xx1,$xy1,$xx2,$y1-$this->ylength,$color_grid,$this->color['white'],$interval=5);
			}
		}

		//y方向的单位分布

		$y_cent_total = floor($this->ynum/$this->ynumcent);
		for ($i=0;$i<=$y_cent_total;$i++){
			$xx1 = $x1;
			$xy1 = $y1-floor(($i*$this->ylength)/$y_cent_total);
			$xx2 = $xx1-$this->centlength;
			$xy2 = $xy1;
			//echo "$xx1,$xy1 $xx2,$xy2 <br>";
			imageline($this->im,$xx1,$xy1,$xx2,$xy2,$color);
			$text = round($this->ynum*$i/$y_cent_total,2);
			imagestring($this->im,2,$xx2-30,$xy2-5,$text,$this->color[$this->textcolor]);

			if ($this->ishavegridy && $i<>0){
				imageline($this->im,$xx1,$xy1,$x1+$this->xlength,$xy2,$color_grid);
				//imagelinedashed($this->im,$xx1,$xy1,$x1+$this->xlength,$xy2,$color_grid,$this->color['white'],$interval=5);
			}
		}
	}

	/*
	@ 主程序绘制柱形图
	@ 2006-8-24
	*/
	function DrawReportBar($array,$color_key,$bartype="normal"){
		global $_lang;
		if(count($array) ==0){
			imagestringgb($this->im,10,0,160,60+30,$this->color[$this->textcolor],"simhei.ttf",$_lang["common_no_any_data"]);
			return;
		}

		$total_value  = 0;
		for($i=1;$i<=count($array);$i++){
			$total_value += $array[$i]['y'];
		}
		unset($i);

		$color = $this->color[$color_key];
		$cna = sizeof($array);
		$xperlen  = floor(($this->xlength)/$cna);
		$barwidth = $xperlen-2*$this->barspace;
		
		if($total_value > 0){
		
			for($i=0;$i<$cna;$i++){
				$keynext = $i+1;
				$cur_ynum = $array[$keynext]['y'];
				$x1 = $this->picwidth*$this->spacelefty+($xperlen-$barwidth)/2+$i*$xperlen;
				$y1 = $this->picheight*(1-$this->spacebottomx)-($this->ylength*($cur_ynum/$this->ynum));
				$x2 = $x1+$barwidth;
				$y2 = $this->picheight*(1-$this->spacebottomx);
				$effect = $this->effect;
				//2007-5-15 可以使用单色
				if($bartype == "same"){
					$colorkey = 1;
				}
				else{
					$colorkey = $keynext;
				}
				imagefilledrectangle($this->im,$x1,$y1,$x2,$y2-1,$this->color[$colorkey][$effect]);
				if ($this->barside){
					imagerectangle($this->im,$x1,$y1,$x2,$y2,$this->color['black']);
				}

				$centage = round(($cur_ynum/$total_value),3)*100;
				$centage_str = $centage."%";

				if ($this->isynote){
					imagestring($this->im,2,$x1+$barwidth*0.25,$y1-15,$cur_ynum,$this->color[$this->textcolor]);
					imagestring($this->im,1,$x1+$barwidth*0.25,$y1-25,$centage_str,$this->color['black03']);
				}
			}
		}

	}

	/*
	@ 多组四维数据绘制
	@ 2006-9-8
	*/
	function DrawReportBarMore($array){
		global $_lang;
		if(count($array) ==0){
			imagestringgb($this->im,10,0,160,60+30,$this->color[$this->textcolor],"simhei.ttf",$_lang["common_no_any_data"]);
			return;
		}

		$cna = sizeof($array);
		$xperlen  = floor(($this->xlength)/$cna);
		$barwidth = $xperlen-2*$this->barspace;
		
		for($i=0;$i<$cna;$i++){
			$keynext = $i+1;
			$cur_ar = $array[$keynext]['y'];
			$cnca = sizeof($cur_ar);
			$perbarwd = floor($barwidth/$cnca);
			$x1 = floor($this->picwidth*$this->spacelefty+($xperlen-$barwidth)/2+$i*$xperlen);

			$f_x = 10;
			$f_y = $this->picheight*$this->spacetopx;
			for($j=0;$j<$cnca;$j++){
				$keyj = $j+1;
				$cur_ynum = $array[$keynext]['y'][$keyj]['y'];
				$xx1 = $x1+$j*$perbarwd;
				$yy1 = $this->picheight*(1-$this->spacebottomx)-($this->ylength*($cur_ynum/$this->ynum));
				$xx2 = $xx1+$perbarwd+$this->morebarspace;
				$yy2 = $this->picheight*(1-$this->spacebottomx);
				//echo $xx1.$yy1.$xx2.$;echo "<br>";
				$effect = $this->effect;
				imagefilledrectangle($this->im,$xx1,$yy1,$xx2,$yy2-1,$this->color[$keyj][$effect]);
				if ($this->barside){
					imagerectangle($this->im,$xx1,$yy1,$xx2,$yy2,$this->color['black']);
				}
				
				if ($this->isynote){
					imagestring($this->im,2,$xx1+$barwidth*0.25,$yy1-15,$cur_ynum,$this->color['black']);
				}


				$f_y +=20;
				imagepointfigure('rectangle',$this->im,$f_x,$f_y,10,$this->color[$keyj]['light'],$this->color[$this->textcolor]);
				imagestringgb($this->im,9,0,$f_x+10,$f_y+5,$this->color[$this->textcolor],"simsun.ttc",$array[$keynext]['y'][$keyj]['x']);
			}

		}

	}

}

?>