<?PHP
/**
 *@Copyright (C) 2010 - 2011 Weaver Co.Ltd
 *@systemname:       E-Office
 *@filename:         inc/img_flow.inc.php
 *@function:         创建流程图
 *@encoding:         $_lang['encoding']
 *@author:           www.weaver.com.cn
 *@modify:			 dingp
 *@date:             2012-01-04
 *@file Version:     4.0
 *@eoffice Version:  8.3
*/
class ImgFlow{
	/*-----------------------------------------
	Define 
	-----------------------------------------*/
	
	//图片基本属性

	var $property  = 'jpeg'; //图片属性

	var $picwidth  = 500;    //图片宽度
	var $picheight = 300;    //图片高度

	//层的位置
	var $layer_w   = 80;     //层宽
	var $layer_h   = 70;     //层高
	var $layer_x   = 30;     //开始坐标 x
	var $layer_y   = 120;     //开始坐标 y
	var $be        = 150;    //块间距

	var $te        = 30;     //跨区路线的高度

	var $turnp     = 0;      //转折点


	//箭头形状定义
	var $dia       = 3;      //尾部线直径 
	var $ply       = 4;      //箭头厚度(箭头高度于线直径的比例)
	var $scape     = 2;      //箭头型度(箭头长度于线直径的比例)

	//总流成步骤

	var $total;

	//图片缓冲
	var $im;                 //图片缓冲

	//流程节点集合
	var $export;              

	//颜色 
	var $color;

	//连线间距 x 方向
	var $fe = 5;

	//连线间距 y 方向
	var $ce = 5;

	//显示模式
	var $model;
    
	//当前步骤
	var $current;

	//层坐标集合

	var $coordinate;

	//是否绘制流程曾经退回的痕迹 
	var $isdashed  = false;
	var $flow_id;
	
	/*-----------------------------------------
	Define 
	-----------------------------------------*/


	/*
	@ ImgFlow
	@ function 构造函数

	@ create date 2005-9-8
	*/
	function ImgFlow(){
		$this->CreateImg();
		$this->DefineColor();
		$this->FillImgBg();
	}

	/*
	@ CreateImg
	@ function 创建图片
	@ create date 2005-9-8
	*/
	function CreateImg(){
		//创建图片
		$this->im = imagecreatetruecolor($this->picwidth,$this->picheight);
	}

	/*
	@ CreateImg
	@ function 创建背景
	@ create date 2005-9-8
	*/
	function FillImgBg(){
		$color = $this->color['white'];
		imagefilledrectangle($this->im, 0, 0, $this->picwidth, $this->picheight, $color);	
	}

	/*
	@ OutImg
	@ function 输出图片
	@ create date 2005-9-8
	*/
	function OutImg(){
		header('Content-type: image/'.$this->property);
        $this->imagepic();
		imagedestroy($this->im);
	}

	/*
	@ DestroyImg
	@ function 销毁图形缓冲

	@ create date 2005-9-8
	*/
	function DestroyImg(){
		imagedestroy($this->im);
	}

	/*
	@ DefineColor
	@ function 颜色定义
	@ create date 2005-9-8
	*/
	function DefineColor(){
		$this->color  = array('black'=>imagecolorallocate($this->im, 127,127,127),
								'gray'=>imagecolorallocate($this->im, 200,200,200),
			                    'gray01'=>imagecolorallocate($this->im, 245,245,245),
								'blue'=>imagecolorallocate($this->im, 102,153,255),
								'red'=>imagecolorallocate($this->im, 255,51,0),
								'red'=>imagecolorallocate($this->im, 228,108,10),
								'white'=>imagecolorallocate($this->im, 255,255,255),
								'green'=>imagecolorallocate($this->im, 0,155,50),
								'new_black'=>imagecolorallocatealpha($this->im, 0,0,0,127)
		                 );
	}

	/*
	@ DefinePic
	@ function 定义图片属性

	@ create date 2005-9-8
	*/
	function DefinePic($property,$picwidth,$picheight){
		$this->property   = $property;
		$this->picwidth   = $picwidth;
		$this->picheight  = $picheight;
		$this->ImgFlow();
		$this->layer_y = $this->picheight/2 - $this->layer_h/2;
	}

	/*
	@ Definelayer
	@ function 定义层属性

	@ create date 2005-9-8
	*/
	function DefineLayer($layer_w,$layer_h,$layer_x,$layer_y,$be,$te){
		$this->layer_w  = $layer_w;
		$this->layer_h  = $layer_h;
		$this->layer_x  = $layer_x;
		$this->layer_y  = $layer_y;
		$this->be       = $be;
		$this->te       = $te;
	}

	/*
	@ DefineArrow
	@ function 定义箭头属性

	@ create date 2005-9-8
	*/
	function DefineArrow($dia,$ply,$scape){
		$this->dia   = $dia;
		$this->ply   = $ply;
		$this->scape = $scape;
	}

	/*
	@ DefineExport (主要参数，一定要定义)
	@ function 定义节点集合 
	@ create date 2005-9-8 
	*/
	function DefineExport($export,$model='exit',$current=0,$turnp=0,$isdashed=false){
		$this->isdashed = $isdashed;
		$this->turnp    = $turnp;
		$this->current  = $current;
		$this->export   = $export;
		$this->model    = $model;
		$this->total    = sizeof($export);
		$this->CountCoordinate();
	}

	/*
	@ CreateGraph 
	@ function 创建轨迹 
	@ create date 2005-9-8 
	*/
	/*
	function CreateGraph(){
		if ($this->model == 'edit'){
			$this->turnp?$this->CreateEditFlowimgSpeci():$this->CreateEditFlowimg();	
		}
		else {
			$this->turnp?$this->CreateViewFlowimgSpeci():$this->CreateViewFlowimg();		
		}
	}
	*/

	/*
	@ CreateGraph 
	@ function 创建轨迹 
	@ create date 2005-9-21
	*/
	function CreateGraph($flowar){
		if ($this->model == 'edit'){
			$this->ImgEditFlow($flowar);	
		}
		else if(is_array($flowar)){
			$this->ImgRunFlow($flowar);
		}
	}

	/*
	@ CountCoordinate
	@ function 计算层的坐标(八个点)
	@ create date 2005-9-8
	*/
	function CountCoordinate(){
		//算出节点位置（坐标）
		reset($this->export);
		while (list($key,$val) = each($this->export)){
			//$key //流程当前位置
			//$val //流程出口方向
			
			//绘制模拟的层位置
			$string = $key.".Flow";
			if ($k < $this->turnp || $this->turnp == 0){
				$bl_x1 = $this->layer_x+$k*$this->be;
				$bl_y1 = $this->layer_y;
				$bl_x2 = $this->layer_x+$this->layer_w+$k*$this->be;
				$bl_y2 = $this->layer_y+$this->layer_h;		
			}

			//转折
			if ($k >= $this->turnp && $this->turnp != 0){
				$bl_x1 = $this->layer_x+($this->turnp-1)*$this->be;
				$bl_y1 = $this->layer_y+($k-($this->turnp-1))*$this->be;
				$bl_x2 = $this->layer_x+$this->layer_w+($this->turnp-1)*$this->be;
				$bl_y2 = $this->layer_y+$this->layer_h+($k-($this->turnp-1))*$this->be;	
			}

			

			$margin =1;
			imagefilledrectangle($this->im,$bl_x1,$bl_y1,$bl_x2,$bl_y2,$this->color['white']);
			imagefilledrectangle($this->im,$bl_x1+$margin,$bl_y1+$margin,$bl_x2-$margin,$bl_y2-$margin,$this->color['white']);
			imagestring($this->im,5,$bl_x1+8,$bl_y1,$string,$this->color['white']);	
			

			//每个节点的坐标上下左右坐标 
			//UP上中，DN下中，LT左中，RT右中，TL左上，TR右上，BL左下，BR右下
			$lnpn[$k+1] = array('UP'=>array(floor($bl_x1+($this->layer_w)/2),$bl_y1),
						   'DN'=>array(floor($bl_x1+($this->layer_w)/2),$bl_y1+$this->layer_h),
						   'LT'=>array($bl_x1,floor($bl_y1+$this->layer_h/2)),
						   'RT'=>array($bl_x1+$this->layer_w,floor($bl_y1+($this->layer_h)/2)),
						   'TL'=>array($bl_x1,$bl_y1),
						   'TR'=>array($bl_x1+$this->layer_w,$bl_y1),
						   'BL'=>array($bl_x1,$bl_y1+$this->layer_h),
						   'BR'=>array($bl_x1+$this->layer_w,$bl_y1+$this->layer_h)
					  ); 

			$this->coordinate = $lnpn;

			$k++;
		}
	}

	/*
	@ ImgFlow
	@ function  绘制原图 (编辑的图形)
	@ create date 2005-9-27
	*/
	function ImgEditFlow($flowar){
		global $connection;
		$flowTypeSql = "SELECT FLOW_TYPE  FROM flow_type WHERE FLOW_ID = '".$this->flow_id."' ";
		$flowTypeRs  = exequery($connection,$flowTypeSql);
		if($flowTypeRow = mysql_fetch_array($flowTypeRs))
			$flowType = $flowTypeRow["FLOW_TYPE"];
		if($flowType ==1)
		{
			$prcsIdSql = "SELECT PRCS_ID FROM flow_process WHERE FLOW_ID = '".$this->flow_id."' ORDER BY PRCS_ID ASC";
			$prcsIdRs  = exequery($connection,$prcsIdSql);
			$arrayIndex = 0;
			while($row = mysql_fetch_array($prcsIdRs))
			{
				$arrayIndex++;
				$prcsIdArray[$arrayIndex] = 	$row["PRCS_ID"];
			}	
		}
		reset($flowar);
		$color = $this->color['black'];
		while (list ($keya,$vara) = each($flowar)){
			$key   = key($vara);
			$var   = $vara[$key];
			$xy1   = $this->coordinate[$key];
			$xy2   = $this->coordinate[$var];
			$outVar = "out_str_len_".$key;
			$inVar = "in_str_len_".$var; 
			if($flowType ==2)
			{
				$prcsIdArray[$key] = 	$key;
			}

			//顺向流程
			/*
			$n  步骤差

			$key 当前步骤出发点

			$this->total 总步骤

			$
			*/
			if (($n=($var - $key)) > 0 && $var > 0){
				
				//正向相邻节点，画线
				if ($n == 1){
					$x1 = $xy1['RT']['0'];
					$y1 = $xy1['RT']['1'];
					$x2 = $xy2['LT']['0'];
					$y2 = $xy2['LT']['1'];
					$this->imagefilledarrow($this->im,$x1,$y1+5,$x2,$y2+5,$this->dia,$this->ply,$this->scape,$color);
					imagestring($this->im,2,$x1+($x2-$x1)/2,$y1+5,$prcsIdArray[$key],$this->color['black']);
				}
				//正向跨节点，画线，先画向下，然后水平，最后垂直指向结束节点
				if ($n > 1){
					//echo "$b=".$$b."<br>";
					$x1 = $xy1['DN']['0']-$$outVar*$this->fe;
					$y1 = $xy1['DN']['1'];
					$x2 = $x1;
					$y2 = $y1+$this->te+($n-2)*$this->ce+2*($this->total-$key-2)*$this->ce;
					imagesetthickness($this->im,$this->dia);
					imageline($this->im,$x1,$y1,$x2,$y2,$color);

					$x1 = $xy1['DN']['0']-$$outVar*$this->fe;
					$y1 = $xy1['DN']['1']+$this->te+($n-2)*$this->ce+2*($this->total-$key-2)*$this->ce;
					//x1的位置+节点距离×相差节点+开始节点偏移位置+结束节点偏移位置
					$x2 = $x1+$n*$this->be+($$outVar*$this->fe)+($$inVar+1)*$this->fe;
					$y2 = $y1;
					imagesetthickness($this->im,$this->dia);
					imageline($this->im,$x1,$y1,$x2,$y2,$color);
					
					$x1 = $xy2['DN']['0']+($$inVar+1)*$this->fe;;
					$y1 = $xy1['DN']['1']+$this->te+($n-2)*$this->ce+2*($this->total-$key-2)*$this->ce;
					$x2 = $xy2['DN']['0']+($$inVar+1)*$this->fe;
					$y2 = $xy2['DN']['1'];
					$this->imagefilledarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$color);
					imagestring($this->im,2,$x1-8,$y1-13,$prcsIdArray[$key],$this->color['black']);
				}
			}
			//方向相邻或者跨节点，画线，先画向上，然后水平，最后垂直指向结束节点
			//逆向流程
			if ((($n=($var - $key)) < 0) && $var > 0){
				$n = abs($n);
				$xy1  = $this->coordinate[$key];
				$xy2  = $this->coordinate[$var];
				if ($n == 1){
					$x1 = $xy1['LT']['0'];
					$y1 = $xy1['LT']['1'];
					$x2 = $xy2['RT']['0'];
					$y2 = $xy2['RT']['1'];
					$this->imagefilledarrow($this->im,$x1,$y1-5,$x2,$y2-5,$this->dia,$this->ply,$this->scape,$color);
					imagestring($this->im,2,$x1+($x2-$x1)/2,$y1-20,$prcsIdArray[$key],$this->color['black']);
				}
				else{
					$x1 = $xy1['UP']['0']-($$outVar)*$this->ce;
					$y1 = $xy1['UP']['1'];
					$x2 = $x1;
					$y2 = $y1-$this->te-2*($key-2)*$this->ce-($n-1)*$this->ce;
	
					imagesetthickness($this->im,$this->dia);
					imageline($this->im,$x1,$y1,$x2,$y2,$color);					
				
	
					$x1 = $xy1['UP']['0']-($$outVar)*$this->ce;
					$y1 = $xy1['UP']['1']-$this->te-2*($key-2)*$this->ce-($n-1)*$this->ce;
					$x2 = $xy2['UP']['0']+($$inVar+1)*$this->ce;
					$y2 = $y1;
	
					imagesetthickness($this->im,$this->dia);
					imageline($this->im,$x1,$y1,$x2,$y2,$color);					
					
					/*echo "count=".count($this->export[$n])."<br>";
					echo "n=$n";*/
					//echo "array_search=".array_search($n,$this->export[$n]);
					$x1 = $xy2['UP']['0']+($$inVar+1)*$this->ce;
					$y1 = $xy1['UP']['1']-$this->te-2*($key-2)*$this->ce-($n-1)*$this->ce;
					$x2 = $xy2['UP']['0']+($$inVar+1)*$this->ce;
					$y2 = $xy2['UP']['1'];
					
					$this->imagefilledarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$color);
					imagestring($this->im,2,$x1+2,$y1,$prcsIdArray[$key],$this->color['black']);
				}
			}
			if(abs($var - $key)!=1)
			{
				$$outVar++;
				$$inVar++;
			}
		}
	}
	function ImgEditFlow_new($flowar){
		global $connection;
		$flowTypeSql = "SELECT FLOW_TYPE  FROM flow_type WHERE FLOW_ID = '".$this->flow_id."' ";
		$flowTypeRs  = exequery($connection,$flowTypeSql);
		if($flowTypeRow = mysql_fetch_array($flowTypeRs))
			$flowType = $flowTypeRow["FLOW_TYPE"];
		if($flowType ==1)
		{
			$prcsIdSql = "SELECT PRCS_ID FROM flow_process WHERE FLOW_ID = '".$this->flow_id."' ORDER BY PRCS_ID ASC";
			$prcsIdRs  = exequery($connection,$prcsIdSql);
			$arrayIndex = 0;
			while($row = mysql_fetch_array($prcsIdRs))
			{
				$arrayIndex++;
				$prcsIdArray[$arrayIndex] = 	$row["PRCS_ID"];
			}	
		}
		reset($flowar);
		
		while (list ($keya,$vara) = each($flowar)){
			$key   = key($vara);
			$var1   = $vara[$key];
			$var    = str_replace(",","",$var1);
			$xy1   = $this->coordinate[$key];
			$xy2   = $this->coordinate[$var];
			$outVar = "out_str_len_".$key;
			$inVar = "in_str_len_".$var; 
			if($flowType ==2)
			{
				$prcsIdArray[$key] = 	$key;
			}
			//如果有“,”则表示不是运行流程的线，那么就是黑线，为了防止红线被挡住，所以黑线透明，如果没有“,”则表示是运行流程的线，那么就是红色
			if(strpos($var1,","))
			{
				$color = $this->color['new_black'];
			}
			else
			{
				$color = $this->color['red'];
			}
			//顺向流程
			/*
			$n  步骤差

			$key 当前步骤出发点

			$this->total 总步骤

			$
			*/
			if (($n=($var - $key)) > 0 && $var > 0){
				
				//正向相邻节点，画线
				if ($n == 1){
					$x1 = $xy1['RT']['0'];
					$y1 = $xy1['RT']['1'];
					$x2 = $xy2['LT']['0'];
					$y2 = $xy2['LT']['1'];
					$this->imagefilledarrow($this->im,$x1,$y1+5,$x2,$y2+5,$this->dia,$this->ply,$this->scape,$color);
					imagestring($this->im,2,$x1+($x2-$x1)/2,$y1+5,$prcsIdArray[$key],$this->color['black']);
				}
				//正向跨节点，画线，先画向下，然后水平，最后垂直指向结束节点
				if ($n > 1){
					//echo "$b=".$$b."<br>";
					$x1 = $xy1['DN']['0']-$$outVar*$this->fe;
					$y1 = $xy1['DN']['1'];
					$x2 = $x1;
					$y2 = $y1+$this->te+($n-2)*$this->ce+2*($this->total-$key-2)*$this->ce;
					imagesetthickness($this->im,$this->dia);
					imageline($this->im,$x1,$y1,$x2,$y2,$color);

					$x1 = $xy1['DN']['0']-$$outVar*$this->fe;
					$y1 = $xy1['DN']['1']+$this->te+($n-2)*$this->ce+2*($this->total-$key-2)*$this->ce;
					//x1的位置+节点距离×相差节点+开始节点偏移位置+结束节点偏移位置
					$x2 = $x1+$n*$this->be+($$outVar*$this->fe)+($$inVar+1)*$this->fe;
					$y2 = $y1;
					imagesetthickness($this->im,$this->dia);
					imageline($this->im,$x1,$y1,$x2,$y2,$color);
					
					$x1 = $xy2['DN']['0']+($$inVar+1)*$this->fe;;
					$y1 = $xy1['DN']['1']+$this->te+($n-2)*$this->ce+2*($this->total-$key-2)*$this->ce;
					$x2 = $xy2['DN']['0']+($$inVar+1)*$this->fe;
					$y2 = $xy2['DN']['1'];
					$this->imagefilledarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$color);
					imagestring($this->im,2,$x1-8,$y1-13,$prcsIdArray[$key],$this->color['black']);
				}
			}
			//方向相邻或者跨节点，画线，先画向上，然后水平，最后垂直指向结束节点
			//逆向流程
			if ((($n=($var - $key)) < 0) && $var > 0){
				$n = abs($n);
				$xy1  = $this->coordinate[$key];
				$xy2  = $this->coordinate[$var];
				if ($n == 1){
					$x1 = $xy1['LT']['0'];
					$y1 = $xy1['LT']['1'];
					$x2 = $xy2['RT']['0'];
					$y2 = $xy2['RT']['1'];
					$this->imagefilledarrow($this->im,$x1,$y1-5,$x2,$y2-5,$this->dia,$this->ply,$this->scape,$color);
					imagestring($this->im,2,$x1+($x2-$x1)/2,$y1-20,$prcsIdArray[$key],$this->color['black']);
				}
				else{
					$x1 = $xy1['UP']['0']-($$outVar)*$this->ce;
					$y1 = $xy1['UP']['1'];
					$x2 = $x1;
					$y2 = $y1-$this->te-2*($key-2)*$this->ce-($n-1)*$this->ce;
	
					imagesetthickness($this->im,$this->dia);
					imageline($this->im,$x1,$y1,$x2,$y2,$color);					
				
	
					$x1 = $xy1['UP']['0']-($$outVar)*$this->ce;
					$y1 = $xy1['UP']['1']-$this->te-2*($key-2)*$this->ce-($n-1)*$this->ce;
					$x2 = $xy2['UP']['0']+($$inVar+1)*$this->ce;
					$y2 = $y1;
	
					imagesetthickness($this->im,$this->dia);
					imageline($this->im,$x1,$y1,$x2,$y2,$color);					
					
					/*echo "count=".count($this->export[$n])."<br>";
					echo "n=$n";*/
					//echo "array_search=".array_search($n,$this->export[$n]);
					$x1 = $xy2['UP']['0']+($$inVar+1)*$this->ce;
					$y1 = $xy1['UP']['1']-$this->te-2*($key-2)*$this->ce-($n-1)*$this->ce;
					$x2 = $xy2['UP']['0']+($$inVar+1)*$this->ce;
					$y2 = $xy2['UP']['1'];
					
					$this->imagefilledarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$color);
					imagestring($this->im,2,$x1+2,$y1,$prcsIdArray[$key],$this->color['black']);
				}
			}
			if(abs($var - $key)!=1)
			{
				$$outVar++;
				$$inVar++;
			}
		}
	}
	/*
	@ ImgFlow
	@ function  运行流程图

	@ create date 2005-9-21
	*/
	function ImgRunFlow($flowar){
		reset($flowar);
		$color = $this->color['red'];
		while (list ($keya,$vara) = each($flowar)){

			$key   = key($vara);
			$var   = $vara[$key];
			$xy1   = $this->coordinate[$key];
			$xy2   = $this->coordinate[$var];
			$outVar = "out_str_len_".$key;
			$inVar  = "in_str_len_".$var;

			//顺向流程
			if (($n=($var - $key)) > 0 && $var > 0){
				
				
				if ($n == 1){
					$x1 = $xy1['RT']['0'];
					$y1 = $xy1['RT']['1'];
					$x2 = $xy2['LT']['0'];
					$y2 = $xy2['LT']['1'];
					$this->imagefilledarrow($this->im,$x1,$y1+5,$x2,$y2+5,$this->dia,$this->ply,$this->scape,$color);
				}

				if ($n > 1){
					$x1 = $xy1['DN']['0']-$$outVar*$this->fe;
					$y1 = $xy1['DN']['1'];
					$x2 = $x1;
					$y2 = $y1+$this->te+($n-2)*$this->ce+2*($this->total-$key-2)*$this->ce;
					imagesetthickness($this->im,$this->dia);
					imageline($this->im,$x1,$y1,$x2,$y2,$color);


					$x1 = $xy1['DN']['0']-$$outVar*$this->fe;
					$y1 = $xy1['DN']['1']+$this->te+($n-2)*$this->ce+2*($this->total-$key-2)*$this->ce;
					//x1的位置+节点距离×相差节点+开始节点偏移位置+结束节点偏移位置
					$x2 = $x1+$n*$this->be+($$outVar*$this->fe)+($$inVar+1)*$this->fe;
					$y2 = $y1;
					imagesetthickness($this->im,$this->dia);
					imageline($this->im,$x1,$y1,$x2,$y2,$color);
					
					
					$x1 = $xy2['DN']['0']+($$inVar+1)*$this->fe;;
					$y1 = $xy1['DN']['1']+$this->te+($n-2)*$this->ce+2*($this->total-$key-2)*$this->ce;
					$x2 = $xy2['DN']['0']+($$inVar+1)*$this->fe;
					$y2 = $xy2['DN']['1'];
					$this->imagefilledarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$color);
				}
			}
			//开始节点偏移位置{$$outVar*$this->fe}
			//结束节点偏移位置{($$inVar+1)*$this->fe}
			//逆向流程
			if ((($n=($var - $key)) < 0) && $var > 0){
				$n = abs($n);
				$xy1  = $this->coordinate[$key];
				$xy2  = $this->coordinate[$var];
				if ($n == 1){
					$x1 = $xy1['LT']['0'];
					$y1 = $xy1['LT']['1'];
					$x2 = $xy2['RT']['0'];
					$y2 = $xy2['RT']['1'];
					$this->imagefilledarrow($this->im,$x1,$y1-5,$x2,$y2-5,$this->dia,$this->ply,$this->scape,$color);
				}
				else{
	
					$x1 = $xy1['UP']['0']-($$outVar)*$this->ce;
					$y1 = $xy1['UP']['1'];
					$x2 = $x1;
					$y2 = $y1-$this->te-2*($key-2)*$this->ce-($n-1)*$this->ce;
	
					imagesetthickness($this->im,$this->dia);
					imageline($this->im,$x1,$y1,$x2,$y2,$color);					
				
	
					$x1 = $xy1['UP']['0']-($$outVar)*$this->ce;
					$y1 = $xy1['UP']['1']-$this->te-2*($key-2)*$this->ce-($n-1)*$this->ce;
					$x2 = $xy2['UP']['0']+($$inVar+1)*$this->ce;
					$y2 = $y1;
	
					imagesetthickness($this->im,$this->dia);
					imageline($this->im,$x1,$y1,$x2,$y2,$color);					
					
					/*echo "count=".count($this->export[$n])."<br>";
					echo "n=$n";*/
					//echo "array_search=".array_search($n,$this->export[$n]);
					$x1 = $xy2['UP']['0']+($$inVar+1)*$this->ce;
					$y1 = $xy1['UP']['1']-$this->te-2*($key-2)*$this->ce-($n-1)*$this->ce;
					$x2 = $xy2['UP']['0']+($$inVar+1)*$this->ce;
					$y2 = $xy2['UP']['1'];
					
					$this->imagefilledarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$color);
				}
			}
			if(abs($var - $key)>1)
			{
				$$outVar++;
				$$inVar++;
			}
		}
	}

	/*
	@ SupplyRunFlow
	@ function 补充未运行的流程
	@ create date 2005-9-22
	*/
	function SupplyRunFlow($export){
		reset($export);
		while (list($key,$val) = each($export)){
			$vara = explode(",",$val);
			foreach ($vara as $va ){
				//正向流程
				if (($n=($va - $key)) > 0){
					/*
					$key 当前流程节点
					$va  目的流程节点
					$n   流程节点差

					*/

					if ($key < $this->current){
						$color = $this->color['blue'];
					}
					else{
						$color = $this->color['black'];
					}

					$xy1  = $this->coordinate[$k+1];
					$xy2  = $this->coordinate[$k+1+$n];

					if ($n == 1){
						$x1 = $xy1['RT']['0'];
						$y1 = $xy1['RT']['1'];
						$x2 = $xy2['LT']['0'];
						$y2 = $xy2['LT']['1'];
						$this->imagefilledarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$color);
					}

					if ($n > 1){

						$x1 = $xy1['DN']['0'];
						$y1 = $xy1['DN']['1'];
						$x2 = $x1;
						$y2 = $y1+$this->te;
						imagesetthickness($this->im,$this->dia);
						imageline($this->im,$x1,$y1,$x2,$y2,$color);


						$x1 = $xy1['DN']['0'];
						$y1 = $xy1['DN']['1']+$this->te;
						$x2 = $x1+$n*$this->be;
						$y2 = $y1;
						imagesetthickness($this->im,$this->dia);
						imageline($this->im,$x1,$y1,$x2,$y2,$color);
						
						$x1 = $xy1['DN']['0']+($n*$this->be);
						$y1 = $xy1['DN']['1']+$this->te;
						$x2 = $xy2['DN']['0'];
						$y2 = $xy2['DN']['1'];
						$this->imagefilledarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$color);
					}
				}

				//逆向流程
				if ((($n=($va - $key)) < 0) && $va > 0){

					$color = $this->color['black'];
					$mcolor = $this->color['red'];
					$fcolor = $this->color['white'];

					$xy1  = $this->coordinate[$k+1];
					$xy2  = $this->coordinate[$k+1+$n];

					$x1 = $xy1['UP']['0'];
					$y1 = $xy1['UP']['1'];
					$x2 = $x1;
					$y2 = $y1-$this->te;
					
					imagesetthickness($this->im,$this->dia);
					imageline($this->im,$x1,$y1,$x2,$y2,$color);					

					$x1 = $xy1['UP']['0'];
					$y1 = $xy1['UP']['1']-$this->te;
					$x2 = $x1-abs($n*$this->be);
					$y2 = $y1;

					imagesetthickness($this->im,$this->dia);
					imageline($this->im,$x1,$y1,$x2,$y2,$color);					

					$x1 = $xy1['UP']['0']-abs($n*$this->be);
					$y1 = $xy1['UP']['1']-$this->te;
					$x2 = $xy2['UP']['0'];
					$y2 = $xy2['UP']['1'];

					$this->imagefilledarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$color);

				}
			}
			$k++;
		}
	}


	/*
	@ CreateEditFlowimg
	@ function 创建无转折点的流程图 [流程定义时使用]
	@ create date 2005-9-8
	*/
	function CreateEditFlowimg(){
		/*
		$export  //流程节点出口的聚合数组

		*/
		reset($this->export);
		while (list($key,$val) = each($this->export)){
			$vara = explode(",",$val);
			foreach ($vara as $va ){
				//正向流程
				if (($n=($va - $key)) > 0){
					/*
					$key 当前流程节点
					$va  目的流程节点
					$n   流程节点差

					*/
					$color = $this->color['black'];

					$xy1  = $this->coordinate[$k+1];
					$xy2  = $this->coordinate[$k+1+$n];

					if ($n == 1){
						$x1 = $xy1['RT']['0'];
						$y1 = $xy1['RT']['1'];
						$x2 = $xy2['LT']['0'];
						$y2 = $xy2['LT']['1'];
						$this->imagefilledarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$color);
					}

					if ($n > 1){
						$x1 = $xy1['DN']['0'];
						$y1 = $xy1['DN']['1'];
						$x2 = $x1;
						$y2 = $y1+$this->te;
						imagesetthickness($this->im,$this->dia);
						imageline($this->im,$x1,$y1,$x2,$y2,$color);
						
						$x1 = $xy1['DN']['0'];
						$y1 = $xy1['DN']['1']+$this->te;
						$x2 = $xy2['BL']['0'];
						$y2 = $xy2['BL']['1'];
						$this->imagefilledarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$color);
					}
				}

				//逆向流程
				if ((($n=($va - $key)) < 0) && $va > 0){

					$color = $this->color['red'];

					$xy1  = $this->coordinate[$k+1];
					$xy2  = $this->coordinate[$k+1+$n];

					$x1 = $xy1['UP']['0'];
					$y1 = $xy1['UP']['1'];
					$x2 = $x1;
					$y2 = $y1-$this->te;
					imagesetthickness($this->im,$this->dia);
					imageline($this->im,$x1,$y1,$x2,$y2,$color);

					$x1 = $xy1['UP']['0'];
					$y1 = $xy1['UP']['1']-$this->te;
					$x2 = $xy2['TR']['0'];
					$y2 = $xy2['TR']['1'];
					$this->imagefilledarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$color);
				}
			}
			$k++;
		}
	}

	/*
	@ CreateViewFlowimg
	@ function 创建无转折点的流程图 [流程运行时显示]
	@ create date 2005-9-12
	*/
	function CreateViewFlowimg(){
		/*
		$this->currentstep 当前步骤
		$export 模式 $export = array(1=>2,
		                             2=>3,5 //$currentstep>2 2->5的流程无需表示
									 3=>4
									 4=>5,3 //如果现在的流程步大于此步4->3表示流程曾经从4退回到3
									 5=>
		                            )
		*/ 
		reset($this->export);
		while (list($key,$val) = each($this->export)){
			$vara = explode(",",$val);
			foreach ($vara as $va ){
				//正向流程
				if (($n=($va - $key)) > 0){
					/*
					$key 当前流程节点
					$va  目的流程节点
					$n   流程节点差

					*/
					if ($this->current > $key){
					    $color = $this->color['green'];
					}
					if ($this->current <= $key){
						$color = $this->color['black'];
					}

					$xy1  = $this->coordinate[$k+1];
					$xy2  = $this->coordinate[$k+1+$n];

					if ($n == 1){
						$x1 = $xy1['RT']['0'];
						$y1 = $xy1['RT']['1'];
						$x2 = $xy2['LT']['0'];
						$y2 = $xy2['LT']['1'];
						$this->imagefilledarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$color);
					}

					if ($n > 1){

						$x1 = $xy1['DN']['0'];
						$y1 = $xy1['DN']['1'];
						$x2 = $x1;
						$y2 = $y1+$this->te;
						imagesetthickness($this->im,$this->dia);
						imageline($this->im,$x1,$y1,$x2,$y2,$color);


						$x1 = $xy1['DN']['0'];
						$y1 = $xy1['DN']['1']+$this->te;
						$x2 = $x1+$n*$this->be;
						$y2 = $y1;
						imagesetthickness($this->im,$this->dia);
						imageline($this->im,$x1,$y1,$x2,$y2,$color);
						
						$x1 = $xy1['DN']['0']+($n*$this->be);
						$y1 = $xy1['DN']['1']+$this->te;
						$x2 = $xy2['DN']['0'];
						$y2 = $xy2['DN']['1'];
						$this->imagefilledarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$color);
					}
				}

				//逆向流程
				if ((($n=($va - $key)) < 0) && $va > 0){

					$color = $this->color['red'];
					$mcolor = $this->color['red'];
					$fcolor = $this->color['white'];

					$xy1  = $this->coordinate[$k+1];
					$xy2  = $this->coordinate[$k+1+$n];

					$x1 = $xy1['UP']['0'];
					$y1 = $xy1['UP']['1'];
					$x2 = $x1;
					$y2 = $y1-$this->te;
					if ($this->current >= $key && $this->isdashed == true){
						imagesetthickness($this->im,$this->dia);
						$this->imagelinedashed($this->im,$x1,$y1,$x2,$y2,$mcolor,$fcolor,$interval=5);
					}
					if ($this->current < $key) {
						imagesetthickness($this->im,$this->dia);
						imageline($this->im,$x1,$y1,$x2,$y2,$color);					
					}

					$x1 = $xy1['UP']['0'];
					$y1 = $xy1['UP']['1']-$this->te;
					$x2 = $x1-abs($n*$this->be);
					$y2 = $y1;
					if ($this->current >= $key && $this->isdashed == true){
						imagesetthickness($this->im,$this->dia);
						$this->imagelinedashed($this->im,$x1,$y1,$x2,$y2,$mcolor,$fcolor,$interval=5);
					}
					if ($this->current < $key) {
						imagesetthickness($this->im,$this->dia);
						imageline($this->im,$x1,$y1,$x2,$y2,$color);					
					}

					$x1 = $xy1['UP']['0']-abs($n*$this->be);
					$y1 = $xy1['UP']['1']-$this->te;
					$x2 = $xy2['UP']['0'];
					$y2 = $xy2['UP']['1'];
					if ($this->current >= $key && $this->isdashed == true){
						$this->imagedashedarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$mcolor,$fcolor,$interval=5);
					}
					if ($this->current < $key){
					    $this->imagefilledarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$color);
                    }
				}
			}
			$k++;
		}
	}

	/*
	@ CreateEditFlowimgSpeci
	@ function 创建有转折点的流程图 [流程定义时使用]
	@ create date 2005-9-8
	*/
	function CreateEditFlowimgSpeci(){
		/*
		$export  //流程节点出口的聚合数组

		*/
	    reset($this->export);
		while (list($key,$val) = each($this->export)){
			$vara = explode(",",$val);
			foreach ($vara as $va ){
				//正向流程
				if (($n=($va - $key)) > 0){
					/*
					$key 当前流程节点
					$va  目的流程节点
					$n   流程节点差

					*/
					$color = $this->color['black'];

					$xy1  = $this->coordinate[$k+1];
					$xy2  = $this->coordinate[$k+1+$n];

					//转折之前的流程线
					if ($key < $this->turnp && $va <= $this->turnp){ 
						if ($n == 1){
							$x1 = $xy1['RT']['0'];
							$y1 = $xy1['RT']['1'];
							$x2 = $xy2['LT']['0'];
							$y2 = $xy2['LT']['1'];

							$this->imagefilledarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$color);
						}

						if ($n > 1){
							$x1 = $xy1['DN']['0'];
							$y1 = $xy1['DN']['1'];
							$x2 = $x1;
							$y2 = $y1+$this->te;
							imagesetthickness($this->im,$this->dia);
							imageline($this->im,$x1,$y1,$x2,$y2,$color);
							
							$x1 = $xy1['DN']['0'];
							$y1 = $xy1['DN']['1']+$this->te;
							$x2 = $xy2['BL']['0'];
							$y2 = $xy2['BL']['1'];
							$this->imagefilledarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$color);
						}
					}

					//转折之后的流程线
					if ($key >= $this->turnp){ 
						if ($n == 1){
							$x1 = $xy1['DN']['0'];
							$y1 = $xy1['DN']['1'];
							$x2 = $xy2['UP']['0'];
							$y2 = $xy2['UP']['1'];
							$this->imagefilledarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$color);
						}

						if ($n > 1){
							$x1 = $xy1['BL']['0'];
							$y1 = $xy1['BL']['1'];
							$x2 = $x1-$this->te;
							$y2 = $y1+$this->te;
							imagesetthickness($this->im,$this->dia);
							imageline($this->im,$x1,$y1,$x2,$y2,$color);
							
							$x1 = $xy1['BL']['0']-$this->te;
							$y1 = $xy1['BL']['1']+$this->te;
							$x2 = $xy2['TL']['0'];
							$y2 = $xy2['TL']['1'];
							$this->imagefilledarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$color);
						}
					}

					//跨转折的流程线

					if ($key < $this->turnp && $va > $this->turnp){ 
						$x1 = $xy1['DN']['0'];
						$y1 = $xy1['DN']['1'];
						$x2 = $xy2['TL']['0'];
						$y2 = $xy2['TL']['1'];
						$this->imagefilledarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$color);
					}

				}

				//逆向流程
				if ((($n=($va - $key)) < 0) && $va > 0){
						$color = $this->color['red'];

						$xy1  = $this->coordinate[$k+1];
						$xy2  = $this->coordinate[$k+1+$n];

						//转折之前的流程线
						if ($key <= $this->turnp && $va <= $this->turnp){

							$x1 = $xy1['UP']['0'];
							$y1 = $xy1['UP']['1'];
							$x2 = $x1;
							$y2 = $y1-$this->te;
							imagesetthickness($this->im,$this->dia);
							imageline($this->im,$x1,$y1,$x2,$y2,$color);

							$x1 = $xy1['UP']['0'];
							$y1 = $xy1['UP']['1']-$this->te;
							$x2 = $xy2['TR']['0'];
							$y2 = $xy2['TR']['1'];
							$this->imagefilledarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$color);
						}

						//转折之后的流程线
						if ($key > $this->turnp && $va >= $this->turnp){

							$x1 = $xy1['RT']['0'];
							$y1 = $xy1['RT']['1'];
							$x2 = $x1+$this->te;
							$y2 = $y1;
							imagesetthickness($this->im,$this->dia);
							imageline($this->im,$x1,$y1,$x2,$y2,$color);

							$x1 = $xy1['RT']['0']+$this->te;
							$y1 = $xy1['RT']['1'];
							$x2 = $xy2['BR']['0'];
							$y2 = $xy2['BR']['1'];
							$this->imagefilledarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$color);
						}

						//跨转折的流程线

						if ($key > $this->turnp && $va < $this->turnp){
							$x1 = $xy1['LT']['0'];
							$y1 = $xy1['LT']['1'];
							$x2 = $xy2['BR']['0'];
							$y2 = $xy2['BR']['1'];
							$this->imagefilledarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$color);
						}

				}
			}
			$k++;
		}
	}

	/*
	@ CreateViewFlowimgSpeci
	@ function 创建有转折点的流程图 [流程运行显示]
	@ create date 2005-9-12
	*/
	function CreateViewFlowimgSpeci(){
		/*
		$export  //流程节点出口的聚合数组

		$this->currentstep 当前步骤
		$export 模式 $export = array(1=>2,
		                             2=>3,5 //$currentstep>2 2->5的流程无需表示
									 3=>4
									 4=>5,3 //如果现在的流程步大于此步4->3表示流程曾经从4退回到3
									 5=>
		                            )
		*/ 

	    reset($this->export);
		while (list($key,$val) = each($this->export)){
			$vara = explode(",",$val);
			foreach ($vara as $va ){
				//正向流程
				if (($n=($va - $key)) > 0){
					/*
					$key 当前流程节点
					$va  目的流程节点
					$n   流程节点差

					*/
					if ($this->current > $key){
					    $color = $this->color['green'];
					}
					if ($this->current <= $key){
						$color = $this->color['black'];
					}

					$xy1  = $this->coordinate[$k+1];
					$xy2  = $this->coordinate[$k+1+$n];

					//转折之前的流程线
					if ($key < $this->turnp && $va <= $this->turnp){ 
						if ($n == 1){
							$x1 = $xy1['RT']['0'];
							$y1 = $xy1['RT']['1'];
							$x2 = $xy2['LT']['0'];
							$y2 = $xy2['LT']['1'];
							$this->imagefilledarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$color);
						}

						if ($n > 1 && $this->current <= $key){//只显示当前步骤小于当前节点的正向流程
							$x1 = $xy1['DN']['0'];
							$y1 = $xy1['DN']['1'];
							$x2 = $x1;
							$y2 = $y1+$this->te;
							imagesetthickness($this->im,$this->dia);
							imageline($this->im,$x1,$y1,$x2,$y2,$color);

							if ($va == $this->turnp){//目标节点等于转折点时，修改轨迹路线和终点
								$x1 = $xy1['DN']['0'];
								$y1 = $xy1['DN']['1']+$this->te;
								$x2 = $xy2['BL']['0'];
								$y2 = $xy2['BL']['1'];
								$this->imagefilledarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$color);		
							}

							else {
								$x1 = $xy1['DN']['0'];
								$y1 = $xy1['DN']['1']+$this->te;
								$x2 = $x1+$n*$this->be;
								$y2 = $y1;
								imagesetthickness($this->im,$this->dia);
								imageline($this->im,$x1,$y1,$x2,$y2,$color);

								$x1 = $xy1['DN']['0']+$n*$this->be;
								$y1 = $xy1['DN']['1']+$this->te;
								$x2 = $xy2['DN']['0'];
								$y2 = $xy2['DN']['1'];
								$this->imagefilledarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$color);								
							}								
						}
					}

					//转折之后的流程线
					if ($key >= $this->turnp){ 
						if ($n == 1){
							$x1 = $xy1['DN']['0'];
							$y1 = $xy1['DN']['1'];
							$x2 = $xy2['UP']['0'];
							$y2 = $xy2['UP']['1'];
							$this->imagefilledarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$color);
						}

						if ($n > 1  && $this->current <= $key){
							$x1 = $xy1['BL']['0'];
							$y1 = $xy1['BL']['1'];
							$x2 = $x1-$this->te;
							$y2 = $y1+$this->te;
							imagesetthickness($this->im,$this->dia);
							imageline($this->im,$x1,$y1,$x2,$y2,$color);
							
							$x1 = $xy1['BL']['0']-$this->te;
							$y1 = $xy1['BL']['1']+$this->te;
							$x2 = $xy2['TL']['0'];
							$y2 = $xy2['TL']['1'];
							$this->imagefilledarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$color);
						}
					}

					//跨转折的流程线

					if ($key < $this->turnp && $va > $this->turnp  && $this->current <= $key){ 
						$x1 = $xy1['DN']['0'];
						$y1 = $xy1['DN']['1'];
						$x2 = $xy2['TL']['0'];
						$y2 = $xy2['TL']['1'];
						$this->imagefilledarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$color);
					}
				}

				//逆向流程
				if ((($n=($va - $key)) < 0) && $va > 0){
					$color = $this->color['red'];
					$mcolor = $this->color['red'];
					$fcolor = $this->color['white'];

					$xy1  = $this->coordinate[$k+1];
					$xy2  = $this->coordinate[$k+1+$n];

					//转折之前的流程线
					if ($key <= $this->turnp && $va <= $this->turnp){

						$x1 = $xy1['UP']['0'];
						$y1 = $xy1['UP']['1'];
						$x2 = $x1;
						$y2 = $y1-$this->te;
						if ($this->current >= $key && $this->isdashed == true){
							imagesetthickness($this->im,$this->dia);
							$this->imagelinedashed($this->im,$x1,$y1,$x2,$y2,$mcolor,$fcolor,$interval=5);
						}
						if ($this->current < $key){
							imagesetthickness($this->im,$this->dia);
							imageline($this->im,$x1,$y1,$x2,$y2,$color);
						}

						$x1 = $xy1['UP']['0'];
						$y1 = $xy1['UP']['1']-$this->te;
						$x2 = $x1+$n*$this->be;
						$y2 = $y1;
						if ($this->current >= $key && $this->isdashed == true){
							imagesetthickness($this->im,$this->dia);
							$this->imagelinedashed($this->im,$x1,$y1,$x2,$y2,$mcolor,$fcolor,$interval=5);
						}
						if ($this->current < $key){
							imagesetthickness($this->im,$this->dia);
							imageline($this->im,$x1,$y1,$x2,$y2,$color);
						}

						$x1 = $xy1['UP']['0']+$n*$this->be;
						$y1 = $xy1['UP']['1']-$this->te;
						$x2 = $xy2['UP']['0'];
						$y2 = $xy2['UP']['1'];
						if ($this->current >= $key && $this->isdashed == true){
							$this->imagedashedarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$mcolor,$fcolor,$interval=5);
						}
						if ($this->current < $key){
							$this->imagefilledarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$color);
						}
					}

					//转折之后的流程线
					if ($key > $this->turnp && $va >= $this->turnp){

						$x1 = $xy1['RT']['0'];
						$y1 = $xy1['RT']['1'];
						$x2 = $x1+$this->te;
						$y2 = $y1;
						if ($this->current >= $key && $this->isdashed == true){
							imagesetthickness($this->im,$this->dia);
							$this->imagelinedashed($this->im,$x1,$y1,$x2,$y2,$mcolor,$fcolor,$interval=5);
						}
						if ($this->current < $key){
							imagesetthickness($this->im,$this->dia);
							imageline($this->im,$x1,$y1,$x2,$y2,$color);
						}

						$x1 = $xy1['RT']['0']+$this->te;
						$y1 = $xy1['RT']['1'];
						$x2 = $x1;
						$y2 = $y1+$n*$this->be;
						if ($this->current >= $key && $this->isdashed == true){
							imagesetthickness($this->im,$this->dia);
							$this->imagelinedashed($this->im,$x1,$y1,$x2,$y2,$mcolor,$fcolor,$interval=5);
						}
						if ($this->current < $key){
							imagesetthickness($this->im,$this->dia);
							imageline($this->im,$x1,$y1,$x2,$y2,$color);
						}

						$x1 = $xy1['RT']['0']+$this->te;
						$y1 = $xy1['RT']['1']+$n*$this->be;
						$x2 = $xy2['RT']['0'];
						$y2 = $xy2['RT']['1'];
						if ($this->current >= $key && $this->isdashed == true){
							$this->imagedashedarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$mcolor,$fcolor,$interval=5);
						}
						if ($this->current < $key){
							$this->imagefilledarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$color);
						}
					}

					//跨转折的流程线

					if ($key > $this->turnp && $va < $this->turnp){
						$x1 = $xy1['LT']['0'];
						$y1 = $xy1['LT']['1'];
						$x2 = $xy2['BR']['0'];
						$y2 = $xy2['BR']['1'];
						if ($this->current >= $key && $this->isdashed == true){
							$this->imagedashedarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$mcolor,$fcolor,$interval=5);
						}
						if ($this->current < $key){
							$this->imagefilledarrow($this->im,$x1,$y1,$x2,$y2,$this->dia,$this->ply,$this->scape,$color);
						}
					}

				}
			}
			$k++;
		}
	}

	/*
	@ imagepic
	@ function 定义创建图片函数
	@ create date 2005-9-8
	*/
	function imagepic(){
		switch ($this->property){
			case 'jpeg':
				imagejpeg($this->im);
				break;
			case 'png':
				imagepng($this->im);
				break;
			case 'gif':
				imagegif($this->im);
				break;
			default:
				imagepng($this->im);
		}
	}

	/*
	@ imagelinedashed 本函数可以作为外部函数，所有参数不引用类的属性

	@ function 创建虚线
	@ create date 2005-9-1
	*/
	function imagelinedashed($im,$x1,$y1,$x2,$y2,$mcolor,$fcolor,$interval=5){
		/*
		$interval //间隔距离
		$mcolor   //master主颜色

		$fcolor   //flunky辅颜色

		*/
		if (empty($im)){
			die('ERROR !, source img have not been created !');
			exit;
		}


		//间距控制
		for ($i=0;$i<$interval;$i++){
			$mstyle[$i] = $mcolor;
		}
		for ($i=0;$i<$interval;$i++){
			$fstyle[$i] = $fcolor;
		}
		$style = array_merge($mstyle,$fstyle);

		imagesetthickness($im,1);
		imagesetstyle($im,$style);
		imageline($im,$x1,$y1,$x2,$y2,IMG_COLOR_STYLED);
	}

	/*
	@ imagefilledarrow 本函数可以作为外部函数，所有参数不引用类的属性

	@ function 创建箭头(包括箭头尾线) 实线
	@ create 2005-8-30
	*/
	function imagefilledarrow($im,$x1,$y1,$x2,$y2,$dia=2,$ply=2,$scape=2,$color){

		//箭头属性定义

		/*
		$x1,y1              //起始位置
		$x2,y2              //结束位置
		$ply                //厚度 箭头直径除以线直径

		$scape              //型度 箭头长度除以箭头直径
		$color              //颜色
		$dia                //直径 线的直径
		$im                 //resource image
		*/
		if (empty($im)){
			die('ERROR !, source img have not been created !');
			exit;
		}

		/*
		1,角度为0,180 (y1=y2 & x2-x1<>0) 
		*/
		if (($y2-$y1) == 0){
			//绘制直线
			$y = $y1 - floor($dia/2);
			if ($x2-$x1>0){
				$x = $x2-$dia*$ply*$scape;
			}
			else{
				$x = $x2+$dia*$ply*$scape;
			}

			imagesetthickness($im,$dia);
			imageline($im,$x1,$y1,$x,$y2,$color);
			
			//绘制箭头
			$point[0] = $x;
			$point[1] = $y-round((($dia*$ply-$dia)/2),0);
			$point[2] = $x;
			$point[3] = $y+round((($dia*$ply-$dia)/2),0)+$dia;
			$point[4] = $x2;
			$point[5] = $y2;
			imagesetthickness($im,1);
			//
			imagefilledpolygon($im,$point,3,$color);

		}

		/*
		2,角度为-90,90 (x1=x2 & y2-y1<>0) 
		*/
		if (($x2-$x1) == 0){
			//绘制直线
			$x = $x1 - floor($dia/2);
			if ($y2-$y1>0){
				$y = $y2-$dia*$ply*$scape;
			}
			else{
				$y = $y2+$dia*$ply*$scape;
			}

			imagesetthickness($im,$dia);
			imageline($im,$x1,$y1,$x2,$y,$color);

			
			//绘制箭头
			$point[0] = $x-round((($dia*$ply-$dia)/2),0);
			$point[1] = $y;
			$point[2] = $x+round((($dia*$ply-$dia)/2),0)+$dia;
			$point[3] = $y;
			$point[4] = $x2;
			$point[5] = $y2;
			imagesetthickness($im,1);
			imagefilledpolygon($im,$point,3,$color);
		}

		/*
		3,角度为>0&<90 >90&<180 180,-90 -90,0
		*/
		if (($x2-$x1) != 0 && ($y2-$y1) != 0){
			//勾股定理
			$z = sqrt(($x2-$x1)*($x2-$x1)+($y2-$y1)*($y2-$y1));
			$z1 = $z-$dia*$ply*$scape;

			//0-90
			if (($x2-$x1) > 0 && ($y2-$y1) > 0){
				$x3 = round($z1*(($x2-$x1)/$z)+$x1,0);
				$y3 = round($z1*(($y2-$y1)/$z)+$y1,0);
			}
			
			//90-180
			if (($x2-$x1) < 0 && ($y2-$y1) > 0){
				$x3 = round($x1-abs($z1*(($x2-$x1)/$z)),0);
				$y3 = round($z1*(($y2-$y1)/$z)+$y1,0);
			}

			//-180 -90
			if (($x2-$x1) < 0 && ($y2-$y1) < 0){
				$x3 = round($x1-abs($z1*(($x2-$x1)/$z)),0);
				$y3 = round($y1-abs($z1*(($y2-$y1)/$z)),0);
			}

			//-90 0
			if (($x2-$x1) > 0 && ($y2-$y1) < 0){
				$x3 = round($x1+abs($z1*(($x2-$x1)/$z)),0);
				$y3 = round($y1-abs($z1*(($y2-$y1)/$z)),0);
			}

			//绘制直线
			imagesetthickness($im,$dia);
			imageline($im,$x1,$y1,$x3,$y3,$color);

			//绘制箭头
			$point[0] = floor($x3+(($dia*$ply)/2)*(($y2-$y1)/$z)); //相似原理
			$point[1] = floor($y3-(($dia*$ply)/2)*(($x2-$x1)/$z));
			$point[2] = floor($x3-(($dia*$ply)/2)*(($y2-$y1)/$z));
			$point[3] = floor($y3+(($dia*$ply)/2)*(($x2-$x1)/$z));
			$point[4] = $x2;
			$point[5] = $y2;
			imagesetthickness($im,1);
			imagefilledpolygon($im,$point,3,$color);
		}

	}

	/*
	@ imagedashedarrow 本函数可以作为外部函数，所有参数不引用类的属性

	@ function 创建箭头(包括箭头尾线) 虚线
	@ create 2005-9-2
	*/

	function imagedashedarrow($im,$x1,$y1,$x2,$y2,$dia=1,$ply=4,$scape=2,$mcolor,$fcolor,$interval=5){

		//箭头属性定义

		/*
		$x1,y1              //起始位置
		$x2,y2              //结束位置
		$ply                //厚度 箭头直径除以线直径

		$scape              //型度 箭头长度除以箭头直径
		$color              //颜色
		$dia                //直径 线的直径
		$im                 //resource image
		$mcolor             //主颜色

		$fcolor             //辅助颜色
		$interval           //间距
		*/
		if (empty($im)){
			die('ERROR !, source img have not been created !');
			exit;
		}

		$color = $mcolor;

		/*
		1,角度为0,180 (y1=y2 & x2-x1<>0) 
		*/
		if (($y2-$y1) == 0){
			//绘制直线
			$y = $y1 - floor($dia/2);
			if ($x2-$x1>0){
				$x = $x2-$dia*$ply*$scape;
			}
			else{
				$x = $x2+$dia*$ply*$scape;
			}
			imagesetthickness($im,1);
			$this->imagelinedashed($im,$x1,$y1,$x2,$y2,$mcolor,$fcolor,$interval);
			
			//绘制箭头
			$point[0] = $x;
			$point[1] = $y-round((($dia*$ply-$dia)/2),0);
			$point[2] = $x;
			$point[3] = $y+round((($dia*$ply-$dia)/2),0)+$dia;
			$point[4] = $x2;
			$point[5] = $y2;
			imagesetthickness($im,1);
			imagefilledpolygon($im,$point,3,$color);

		}

		/*
		2,角度为-90,90 (x1=x2 & y2-y1<>0) 
		*/
		if (($x2-$x1) == 0){
			//绘制直线
			$x = $x1 - floor($dia/2);
			if ($y2-$y1>0){
				$y = $y2-$dia*$ply*$scape;
			}
			else{
				$y = $y2+$dia*$ply*$scape;
			}

			imagesetthickness($im,1);
			$this->imagelinedashed($im,$x1,$y1,$x2,$y2,$mcolor,$fcolor,$interval);

			
			//绘制箭头
			$point[0] = $x-round((($dia*$ply-$dia)/2),0);
			$point[1] = $y;
			$point[2] = $x+round((($dia*$ply-$dia)/2),0)+$dia;
			$point[3] = $y;
			$point[4] = $x2;
			$point[5] = $y2;
			imagesetthickness($im,1);
			imagefilledpolygon($im,$point,3,$color);
		}

		/*
		3,角度为>0&<90 >90&<180 180,-90 -90,0
		*/
		if (($x2-$x1) != 0 && ($y2-$y1) != 0){
			//勾股定理
			$z = sqrt(($x2-$x1)*($x2-$x1)+($y2-$y1)*($y2-$y1));
			$z1 = $z-$dia*$ply*$scape;

			//0-90
			if (($x2-$x1) > 0 && ($y2-$y1) > 0){
				$x3 = round($z1*(($x2-$x1)/$z)+$x1,0);
				$y3 = round($z1*(($y2-$y1)/$z)+$y1,0);
			}
			
			//90-180
			if (($x2-$x1) < 0 && ($y2-$y1) > 0){
				$x3 = round($x1-abs($z1*(($x2-$x1)/$z)),0);
				$y3 = round($z1*(($y2-$y1)/$z)+$y1,0);
			}

			//-180 -90
			if (($x2-$x1) < 0 && ($y2-$y1) < 0){
				$x3 = round($x1-abs($z1*(($x2-$x1)/$z)),0);
				$y3 = round($y1-abs($z1*(($y2-$y1)/$z)),0);
			}

			//-90 0
			if (($x2-$x1) > 0 && ($y2-$y1) < 0){
				$x3 = round($x1+abs($z1*(($x2-$x1)/$z)),0);
				$y3 = round($y1-abs($z1*(($y2-$y1)/$z)),0);
			}

			//绘制直线

			imagesetthickness($im,1);
			$this->imagelinedashed($im,$x1,$y1,$x2,$y2,$mcolor,$fcolor,$interval);

			//绘制箭头
			$point[0] = floor($x3+(($dia*$ply)/2)*(($y2-$y1)/$z)); //相似原理
			$point[1] = floor($y3-(($dia*$ply)/2)*(($x2-$x1)/$z));
			$point[2] = floor($x3-(($dia*$ply)/2)*(($y2-$y1)/$z));
			$point[3] = floor($y3+(($dia*$ply)/2)*(($x2-$x1)/$z));
			$point[4] = $x2;
			$point[5] = $y2;
			imagesetthickness($im,1);
			imagefilledpolygon($im,$point,3,$color);
		}

	}
}
?>