<?PHP
/*************************************************************
* Note: 													*
* Author: 	Weaver.liuxiulin								*
* Contact: 	xiulin.liu@weaver.com.cn						*
* Version: 	1.0											    *
* Created:  2006-8-8										*
* Revision: 1.01						                    *
*************************************************************/
/*
@ imagesmoothline 
@ function 平滑连线
@ 
*/
function imagesmoothline( $image, $x1, $y1, $x2, $y2, $color, $trueColor = true ) {
	$fullColor = imageColorsForIndex( $image, $color );
	if ( abs( $x1 - $x2 ) > abs( $y1 - $y2 ) ) {
		$m = ( $y2 - $y1 ) / ( $x2 - $x1 );
		$b = $y1 - $m * $x1;
		$strx = min( $x1, $x2 );
		$endx = max( $x1, $x2 );
		for ( $x = $strx; $x <= $endx; $x++ ) {
			imageSetSmoothPixel( $image, $x, $m * $x + $b, $fullColor, $trueColor );
		}
	} else {
		$m = ( $x2 - $x1 ) / ( $y2 - $y1 );
		$b = $x1 - $m * $y1;
		$stry = min( $y1, $y2 );
		$endy = max( $y1, $y2 );
		for ( $y = $stry; $y <= $endy; $y++ ) {
			imageSetSmoothPixel( $image, $m * $y + $b, $y, $fullColor, $trueColor );
		}
	}
}

/*
@ imageSetSmoothPixel 
@ function 平滑像素
@ 
*/
function imageSetSmoothPixel( $image, $x, $y, $fullColor, $trueColor = true ) {
	$fx = floor( $x );
	$fy = floor( $y );
	$cx = ceil( $x );
	$cy = ceil( $y );
	$xa = $x - $fx;
	$xb = $cx - $x;
	$ya = $y - $fy;
	$yb = $cy - $y;
	if ( $cx == $fx and $cy == $fy ) {
		imageSetSubPixel( $image, $fx, $fy, 0.0, 1.0, $fullColor, $trueColor );
	} else {
		imageSetSubPixel( $image, $fx, $fy, $xa + $ya, $xb + $yb, $fullColor, $trueColor );
		if ( $cy != $fy ) {
			imageSetSubPixel( $image, $fx, $cy, $xa + $yb, $xb + $ya, $fullColor, $trueColor );
		}
		if ( $cx != $fx ) {
			imageSetSubPixel( $image, $cx, $fy, $xb + $ya, $xa + $yb, $fullColor, $trueColor );
			if ( $cy != $fy ) {
				imageSetSubPixel( $image, $cx, $cy, $xb + $yb, $xa + $ya, $fullColor, $trueColor );
			}
		}
	}
}

function imageSetSubPixel( $image, $x, $y, $a, $b, $fullColor, $trueColor = true ) {
	$tempColor = imageColorsForIndex( $image, imageColorAt( $image, $x, $y ) );
	$tempColor[ 'red' ]   = round( $tempColor[ 'red' ]   * $a + $fullColor[ 'red' ]   * $b );
	$tempColor[ 'green' ] = round( $tempColor[ 'green' ] * $a + $fullColor[ 'green' ] * $b );
	$tempColor[ 'blue' ]  = round( $tempColor[ 'blue' ]  * $a + $fullColor[ 'blue' ]  * $b );
	if ( $tempColor[ 'red' ]   > 255 ) $tempColor[ 'red' ]   = 255;
	if ( $tempColor[ 'green' ] > 255 ) $tempColor[ 'green' ] = 255;
	if ( $tempColor[ 'blue' ]  > 255 ) $tempColor[ 'blue' ]  = 255;
	if ( $trueColor ) {
		$newColor = imageColorExactAlpha( $image, $tempColor[ 'red' ], $tempColor[ 'green' ], $tempColor[ 'blue' ], 0 );
	} else {
		if ( imageColorExact( $image, $tempColor[ 'red' ], $tempColor[ 'green' ], $tempColor[ 'blue' ] ) == -1 ) {
			imageColorAllocate( $image, $tempColor[ 'red' ], $tempColor[ 'green' ], $tempColor[ 'blue' ] );
		}
		$newColor = imageColorExact( $image, $tempColor[ 'red' ], $tempColor[ 'green' ], $tempColor[ 'blue' ] );
	}
	imageSetPixel( $image, $x, $y, $newColor );
}

/*
@ imagelinedashed 
@ function 创建虚线
@ create date 2005-9-1
*/
function imagelinedashed($im,$x1,$y1,$x2,$y2,$mcolor,$fcolor,$interval=5){
	/*
	$interval //间隔距离
	$mcolor   //master主颜色

	$fcolor   //flunky辅颜色

	*/
	if (empty($im)){
		die('ERROR !, source img have not been created !');
		exit;
	}


	//间距控制
	for ($i=0;$i<$interval;$i++){
		$mstyle[$i] = $mcolor;
	}
	for ($i=0;$i<$interval;$i++){
		$fstyle[$i] = $fcolor;
	}
	$style = array_merge($mstyle,$fstyle);

	imagesetthickness($im,1);
	imagesetstyle($im,$style);
	imageline($im,$x1,$y1,$x2,$y2,IMG_COLOR_STYLED);
}

/*
@ imagefilledarrow 
@ function 创建箭头(包括箭头尾线) 实线
@ create 2005-8-30
*/
function imagefilledarrow($im,$x1,$y1,$x2,$y2,$dia=2,$ply=2,$scape=2,$color){

	//箭头属性定义

	/*
	$x1,y1              //起始位置
	$x2,y2              //结束位置
	$ply                //厚度 箭头直径除以线直径

	$scape              //型度 箭头长度除以箭头直径
	$color              //颜色
	$dia                //直径 线的直径
	$im                 //resource image
	*/
	if (empty($im)){
		die('ERROR !, source img have not been created !');
		exit;
	}

	/*
	1,角度为0,180 (y1=y2 & x2-x1<>0) 
	*/
	if (($y2-$y1) == 0){
		//绘制直线
		$y = $y1 - floor($dia/2);
		if ($x2-$x1>0){
			$x = $x2-$dia*$ply*$scape;
		}
		else{
			$x = $x2+$dia*$ply*$scape;
		}

		imagesetthickness($im,$dia);
		imagesmoothline($im,$x1,$y1,$x,$y2,$color);
		
		//绘制箭头
		$point[0] = $x;
		$point[1] = $y-round((($dia*$ply-$dia)/2),0);
		$point[2] = $x;
		$point[3] = $y+round((($dia*$ply-$dia)/2),0)+$dia;
		$point[4] = $x2;
		$point[5] = $y2;
		imagesetthickness($im,1);
		imagefilledpolygon($im,$point,3,$color);

	}

	/*
	2,角度为-90,90 (x1=x2 & y2-y1<>0) 
	*/
	if (($x2-$x1) == 0){
		//绘制直线
		$x = $x1 - floor($dia/2);
		if ($y2-$y1>0){
			$y = $y2-$dia*$ply*$scape;
		}
		else{
			$y = $y2+$dia*$ply*$scape;
		}

		imagesetthickness($im,$dia);
		imagesmoothline($im,$x1,$y1,$x2,$y,$color);

		
		//绘制箭头
		$point[0] = $x-round((($dia*$ply-$dia)/2),0);
		$point[1] = $y;
		$point[2] = $x+round((($dia*$ply-$dia)/2),0)+$dia;
		$point[3] = $y;
		$point[4] = $x2;
		$point[5] = $y2;
		imagesetthickness($im,1);
		imagefilledpolygon($im,$point,3,$color);
	}

	/*
	3,角度为>0&<90 >90&<180 180,-90 -90,0
	*/
	if (($x2-$x1) != 0 && ($y2-$y1) != 0){
		//勾股定理
		$z = sqrt(($x2-$x1)*($x2-$x1)+($y2-$y1)*($y2-$y1));
		$z1 = $z-$dia*$ply*$scape;

		//0-90
		if (($x2-$x1) > 0 && ($y2-$y1) > 0){
			$x3 = round($z1*(($x2-$x1)/$z)+$x1,0);
			$y3 = round($z1*(($y2-$y1)/$z)+$y1,0);
		}
		
		//90-180
		if (($x2-$x1) < 0 && ($y2-$y1) > 0){
			$x3 = round($x1-abs($z1*(($x2-$x1)/$z)),0);
			$y3 = round($z1*(($y2-$y1)/$z)+$y1,0);
		}

		//-180 -90
		if (($x2-$x1) < 0 && ($y2-$y1) < 0){
			$x3 = round($x1-abs($z1*(($x2-$x1)/$z)),0);
			$y3 = round($y1-abs($z1*(($y2-$y1)/$z)),0);
		}

		//-90 0
		if (($x2-$x1) > 0 && ($y2-$y1) < 0){
			$x3 = round($x1+abs($z1*(($x2-$x1)/$z)),0);
			$y3 = round($y1-abs($z1*(($y2-$y1)/$z)),0);
		}

		//绘制直线
		imagesetthickness($im,$dia);
		imagesmoothline($im,$x1,$y1,$x3,$y3,$color);

		//绘制箭头
		$point[0] = floor($x3+(($dia*$ply)/2)*(($y2-$y1)/$z)); //相似原理
		$point[1] = floor($y3-(($dia*$ply)/2)*(($x2-$x1)/$z));
		$point[2] = floor($x3-(($dia*$ply)/2)*(($y2-$y1)/$z));
		$point[3] = floor($y3+(($dia*$ply)/2)*(($x2-$x1)/$z));
		$point[4] = $x2;
		$point[5] = $y2;
		imagesetthickness($im,1);
		imagefilledpolygon($im,$point,3,$color);
	}

}

/*
@ imagedashedarrow 
@ function 创建箭头(包括箭头尾线) 虚线
@ create 2005-9-2
*/

function imagedashedarrow($im,$x1,$y1,$x2,$y2,$dia=1,$ply=4,$scape=2,$mcolor,$fcolor,$interval=5){

	//箭头属性定义

	/*
	$x1,y1              //起始位置
	$x2,y2              //结束位置
	$ply                //厚度 箭头直径除以线直径

	$scape              //型度 箭头长度除以箭头直径
	$color              //颜色
	$dia                //直径 线的直径
	$im                 //resource image
	$mcolor             //主颜色

	$fcolor             //辅助颜色
	$interval           //间距
	*/
	if (empty($im)){
		die('ERROR !, source img have not been created !');
		exit;
	}

	$color = $mcolor;

	/*
	1,角度为0,180 (y1=y2 & x2-x1<>0) 
	*/
	if (($y2-$y1) == 0){
		//绘制直线
		$y = $y1 - floor($dia/2);
		if ($x2-$x1>0){
			$x = $x2-$dia*$ply*$scape;
		}
		else{
			$x = $x2+$dia*$ply*$scape;
		}
		imagesetthickness($im,1);
		imagelinedashed($im,$x1,$y1,$x2,$y2,$mcolor,$fcolor,$interval);
		
		//绘制箭头
		$point[0] = $x;
		$point[1] = $y-round((($dia*$ply-$dia)/2),0);
		$point[2] = $x;
		$point[3] = $y+round((($dia*$ply-$dia)/2),0)+$dia;
		$point[4] = $x2;
		$point[5] = $y2;
		imagesetthickness($im,1);
		imagefilledpolygon($im,$point,3,$color);

	}

	/*
	2,角度为-90,90 (x1=x2 & y2-y1<>0) 
	*/
	if (($x2-$x1) == 0){
		//绘制直线
		$x = $x1 - floor($dia/2);
		if ($y2-$y1>0){
			$y = $y2-$dia*$ply*$scape;
		}
		else{
			$y = $y2+$dia*$ply*$scape;
		}

		imagesetthickness($im,1);
		imagelinedashed($im,$x1,$y1,$x2,$y2,$mcolor,$fcolor,$interval);

		
		//绘制箭头
		$point[0] = $x-round((($dia*$ply-$dia)/2),0);
		$point[1] = $y;

		$point[2] = $x+round((($dia*$ply-$dia)/2),0)+$dia;
		$point[3] = $y;
		$point[4] = $x2;
		$point[5] = $y2;
		imagesetthickness($im,1);
		imagefilledpolygon($im,$point,3,$color);
	}

	/*
	3,角度为>0&<90 >90&<180 180,-90 -90,0
	*/
	if (($x2-$x1) != 0 && ($y2-$y1) != 0){
		//勾股定理
		$z = sqrt(($x2-$x1)*($x2-$x1)+($y2-$y1)*($y2-$y1));
		$z1 = $z-$dia*$ply*$scape;

		//0-90
		if (($x2-$x1) > 0 && ($y2-$y1) > 0){
			$x3 = round($z1*(($x2-$x1)/$z)+$x1,0);
			$y3 = round($z1*(($y2-$y1)/$z)+$y1,0);
		}
		
		//90-180
		if (($x2-$x1) < 0 && ($y2-$y1) > 0){
			$x3 = round($x1-abs($z1*(($x2-$x1)/$z)),0);
			$y3 = round($z1*(($y2-$y1)/$z)+$y1,0);
		}

		//-180 -90
		if (($x2-$x1) < 0 && ($y2-$y1) < 0){
			$x3 = round($x1-abs($z1*(($x2-$x1)/$z)),0);
			$y3 = round($y1-abs($z1*(($y2-$y1)/$z)),0);
		}

		//-90 0
		if (($x2-$x1) > 0 && ($y2-$y1) < 0){
			$x3 = round($x1+abs($z1*(($x2-$x1)/$z)),0);
			$y3 = round($y1-abs($z1*(($y2-$y1)/$z)),0);
		}

		//绘制直线

		imagesetthickness($im,1);
		imagelinedashed($im,$x1,$y1,$x2,$y2,$mcolor,$fcolor,$interval);

		//绘制箭头
		$point[0] = floor($x3+(($dia*$ply)/2)*(($y2-$y1)/$z)); //相似原理
		$point[1] = floor($y3-(($dia*$ply)/2)*(($x2-$x1)/$z));
		$point[2] = floor($x3-(($dia*$ply)/2)*(($y2-$y1)/$z));
		$point[3] = floor($y3+(($dia*$ply)/2)*(($x2-$x1)/$z));
		$point[4] = $x2;
		$point[5] = $y2;
		imagesetthickness($im,1);
		imagefilledpolygon($im,$point,3,$color);
	}

}

/*
@ 绘制常用形状
@ 2006-8-9  2006-8-10
*/
function imagepointfigure($figure,$im,$x,$y,$dia,$color_fill,$color_fringe){
	//形状属性定义

	/*
	$figure					//形状
	$x,y					//形状的中点位置

	$dia					//直径
	$color_fill             //填充的颜色

	$color_fringe           //边缘颜色
	*/

	if (empty($im)){
		die('ERROR !, source img have not been created !');
		exit;
	}
	switch($figure){
		case 'rectangle': //矩形
			$x1 = floor($x-$dia/2);
			$y1 = floor($y-$dia/2);
			$x2 = floor($x+$dia/2);
			$y2 = floor($y+$dia/2);
			imagefilledrectangle($im,$x1,$y1,$x2,$y2,$color_fill);
			imagerectangle($im,$x1,$y1,$x2,$y2,$color_fringe);
			break;
		case 'prism': //菱形
			$xy[0] = floor($x-$dia/2);
			$xy[1] = $y;
			$xy[2] = $x;
			$xy[3] = floor($y-$dia/2);
			$xy[4] = floor($x+$dia/2);
			$xy[5] = $y;
			$xy[6] = $x;
			$xy[7] = floor($y+$dia/2);

			imagefilledpolygon($im,$xy,4,$color_fill);
			imagepolygon($im,$xy,4,$color_fring);
			break;
		case 'triangle': //三角形

			$sinln = round(($dia/2)*sin(deg2rad(60)));
			$cosln = round(($dia/2)*sin(deg2rad(30)));
			$xy[0] = floor($x-$sinln);
			$xy[1] = floor($y+$cosln);
			$xy[2] = $x;
			$xy[3] = floor($y-$sinln);
			$xy[4] = floor($x+$sinln);
			$xy[5] = floor($y+$cosln);

			imagefilledpolygon($im,$xy,3,$color_fill);
			imagepolygon($im,$xy,3,$color_fring);
			break;
		case 'pentacle': //五角形

			//未做  2006-9-14
			$x1 = floor($x-$dia/2);
			$y1 = floor($y-$dia/2);
			$x2 = floor($x+$dia/2);
			$y2 = floor($y+$dia/2);
			imagefilledrectangle($im,$x1,$y1,$x2,$y2,$color_fill);
			imagerectangle($im,$x1,$y1,$x2,$y2,$color_fringe);
			break;
		case 'ellipse':  //圆型
			imagefilledellipse($im,$x,$y,$dia,$dia,$color_fill);
			imageellipse($im,$x,$y,$dia,$dia,$color_fringe);
			break;
		case 'crisscross': //十字形

			$radii    = $dia/2;
			$radii_r  = 2;// 
			$xy[0] = floor($x-$radii);
			$xy[1] = floor($y+$radii_r);
			$xy[2] = floor($x-$radii);
			$xy[3] = floor($y-$radii_r);
			$xy[4] = floor($x-$radii_r);
			$xy[5] = floor($y-$radii_r);
			$xy[6] = floor($x-$radii_r);
			$xy[7] = floor($y-$radii);
			$xy[8] = floor($x+$radii_r);
			$xy[9] = floor($y-$radii);
			$xy[10] = floor($x+$radii_r);
			$xy[11] = floor($y-$radii_r);

			$xy[12] = floor($x+$radii);
			$xy[13] = floor($y-$radii_r);
			$xy[14] = floor($x+$radii);
			$xy[15] = floor($y+$radii_r);
			$xy[16] = floor($x+$radii_r);
			$xy[17] = floor($y+$radii_r);
			$xy[18] = floor($x+$radii_r);
			$xy[19] = floor($y+$radii);
			$xy[20] = floor($x-$radii_r);
			$xy[21] = floor($y+$radii);
			$xy[22] = floor($x-$radii_r);
			$xy[23] = floor($y+$radii_r);

			imagefilledpolygon($im,$xy,12,$color_fill);
			imagepolygon($im,$xy,12,$color_fringe);
			break;
		default:
			$x1 = floor($x-$dia/2);
			$y1 = floor($y-$dia/2);
			$x2 = floor($x+$dia/2);
			$y2 = floor($y+$dia/2);
			imagefilledrectangle($im,$x1,$y1,$x2,$y2,$color_fill);
			imagerectangle($im,$x1,$y1,$x2,$y2,$color_fringe);
			break;

	}

}

/*
@ 中文装换为utf8
@ 2006-8-9 
*/
function gb2utf8($gb) 
{ 
      if(!trim($gb)) 
              return $gb; 
	  $root_path=str_replace('\\','/',get_cfg_var('doc_root')."/");
	  $filename="$root_path/inc/gb2312.txt"; 
      $tmp=file($filename); 
      $codetable=array(); 
      while(list($key,$value)=each($tmp)) 
      $codetable[hexdec(substr($value,0,6))]=substr($value,7,6); 

      $utf8=""; 
      while($gb) 
      { 
              if (ord(substr($gb,0,1))>127) 
              { 
                      $tthis=substr($gb,0,2); 
                      $gb=substr($gb,2,strlen($gb)-2); 
                      $utf8.=u2utf8(hexdec($codetable[hexdec(bin2hex($tthis))-0x8080])); 
              } 
              else 
              { 
                      $tthis=substr($gb,0,1); 
                      $gb=substr($gb,1,strlen($gb)-1); 
                      $utf8.=u2utf8($tthis); 
              } 
      } 

return $utf8; 
} 

/*
@ 中文装换为utf8
@ 2006-8-9 
*/
function u2utf8($c) 
{ 
      $str=""; 
      if ($c < 0x80) 
      { 
              $str.=$c; 
      } 
      else if ($c < 0x800) 
      { 
              $str.=chr(0xC0 | $c>>6); 
              $str.=chr(0x80 | $c & 0x3F); 
      } 
      else if ($c < 0x10000) 
      { 
              $str.=chr(0xE0 | $c>>12); 
              $str.=chr(0x80 | $c>>6 & 0x3F); 
              $str.=chr(0x80 | $c & 0x3F); 
      } 
      else if ($c < 0x200000) 
      { 
              $str.=chr(0xF0 | $c>>18); 
              $str.=chr(0x80 | $c>>12 & 0x3F); 
              $str.=chr(0x80 | $c>>6 & 0x3F); 
              $str.=chr(0x80 | $c & 0x3F); 
      } 
return $str; 
} 

/*
@ 绘制中文文字
@ 2006-8-23
*/
function imagestringgb($im,$size,$angle,$x,$y,$color,$font,$str){
	if (empty($im)){
		die('ERROR !, source img have not been created !');
		exit;
	}


	//$str = gb2utf8($str);
	//$str = iconv('GB2312','UTF-8',$str);
	$font_path = getfontsfromwin($font);
	imagettftext($im,$size,$angle,$x,$y,$color,$font_path,$str);
}	

/*
@ 查找字体
@ 2008-1-24
*/
function getfontsfromwin($font){
	$windir = $_SERVER['SystemRoot'];
	$windir = str_replace("\\","/",$windir);
	$fontsdir = $windir."/Fonts/";
	$font = strtoupper($font);
	$fontsdir = $fontsdir.$font;
	return $fontsdir;
} 

/*
@ 转为弧度
@ 2006-8-30
*/
function deg2Arc($degrees) {
    return($degrees * (pi()/180.0));
}

/*
@ 转为RGB
@ 2006-8-30
*/
function getRGB($color){
    $R=($color>>16) & 0xff;
    $G=($color>>8) & 0xff;
    $B=($color) & 0xff;
    return (array($R,$G,$B));
}

/*
@ 取得在椭圆心为（0，0）的椭圆上 x,y点的值

@ 2006-8-30
*/
function pie_point($deg,$va,$vb){
    $x= cos(deg2Arc($deg)) * $va;
    $y= sin(deg2Arc($deg)) * $vb;
    return (array($x, $y));
}

?>