<?PHP
/*************************************************************
* Note: 	图形报表-生成连线图		                         *
* Author: 	Weaver.liuxiulin                                 *
* Contact: 	xiulin.liu@weaver.com.cn		                 *
* Version: 	1.0						                         *
* Eoffice V: 4.0   		                                     *
* Created:  2006-8-8  		                                 *
* Revision: //							                     *
*************************************************************/
include_once("inc/img_func.php");
include_once("inc/img_color.php");
class ReportLineImg{
	/*-----------------------------------------
	Define 
	-----------------------------------------*/
	
	//图片基本属性

	var $property  = 'png'; //图片属性

	var $picwidth  = 800;    //图片宽度
	var $picheight = 300;    //图片高度

	var $spacelefty    = 0.20;
	var $spacerighty   = 0.05;
    var $spacetopx     = 0.15;
    var $spacebottomx  = 0.20;

	var $xnum      = 31; //x轴

	var $xnumcent  = 1;
	var $xnumunits = "M";
    var $ynum      = 100; //y轴

	var $ynumcent  = 10;
	var $ynumunits = "GB";

	var $xlength;  //坐标轴的实际长度 px (有效长度)
	var $ylength;
	var $xyspace  = 20;  //剩余坐标轴的长度

	var $centlength = 5; //标注点的长度
	var $linedia    = 1; //连线的直径


	var $ishavegrid    = false; //是否显示栅格
	var $isynote       = false; //节点是否显示数值

	var $isstresspoint = false; //节点是否突出
	var $isfillarea    = true; //是否填充路径
	var $isdrawline    = true; //是否绘制折线

	var $pointfigure = 'prism'; //节点的形状

	var $pointdia    = 8; //节点的直径

	var $pointsame    = false; //节点边缘颜色

	var $effect         = 'alpha'; //连线和节点颜色效果


	var $bgcolor        = 'black03';//背景颜色
	var $fringecolort   = 'black01'; //外框颜色
	var $fringecolorb   = 'black02'; //外框颜色
	var $textcolor      = 'white'; //所有文字颜色


	var $charhead   = "";
	var $subhead    = "";
	var $bottomnote = "";
	var $leftnote   = "";
	var $picname    = "";

	var $root_path;

	var $im;                 //图片缓冲

	function ReportLineImg(){
		global $_lang;
		$this->charhead = $_lang["flow_travelcosts_table"];
		$this->charhead = $_lang["flow_business_processes"];
		$this->charhead = $_lang["flow_bottom_notes"];
		
		$this->root_path  = str_replace('\\','/',get_cfg_var('doc_root')."/");
		$this->CreateImg();     // 创建图片
		$this->DefineColor();   //常用颜色定义
		$this->FillImgBg();     //图片背景
		$this->CountXYLength(); //坐标实际长度计算
		$this->DecorateImg();   //图片修饰
	}

	/*
	@ 创建图片
	@ 2006-8-10
	*/
	function CreateImg(){
		$this->im = imagecreatetruecolor($this->picwidth,$this->picheight);
	}

	/*
	@ 填充背景
	@ 2006-8-10
	*/
	function FillImgBg(){
		$color = $this->color[$this->bgcolor];
		imagefilledrectangle($this->im, 0, 0, $this->picwidth, $this->picheight, $color);	
	}

	/*
	@ 修饰图形外围，图表名称，单位等

	@ 2006-8-24
	*/
	function DecorateImg($charhead="",$subhead="",$bottomnote="",$leftnote="",$picname=""){
		$this->charhead   = $charhead?$charhead:$this->charhead;
		$this->subhead    = $subhead?$subhead:$this->subhead;
		$this->bottomnote = $bottomnote?$bottomnote:$this->bottomnote;
		$this->leftnote   = $leftnote?$leftnote:$this->leftnote;
		$this->picname   = $picname?$picname:$this->picname;

		
		imagefilledrectangle($this->im, 0, 0, $this->picwidth*$this->spacelefty, $this->picheight, $this->color[$this->fringecolorb]);
		imagefilledrectangle($this->im, 0, $this->picheight*(1-$this->spacebottomx), $this->picwidth, $this->picheight, $this->color[$this->fringecolorb]);
		imagefilledrectangle($this->im, $this->picwidth*(1-$this->spacerighty), 0, $this->picwidth, $this->picheight, $this->color[$this->fringecolorb]);
		imagefilledrectangle($this->im, 0, 0, $this->picwidth, $this->picheight*$this->spacetopx, $this->color[$this->fringecolort]);

		imageline($this->im,0,0+1,$this->picwidth,0+1,$this->color['white']);
		imageline($this->im,0+1,0,0+1,$this->picheight,$this->color['white']);
		imageline($this->im,0,$this->picheight-1,$this->picwidth,$this->picheight-1,$this->color['blue06']);
		imageline($this->im,$this->picwidth-1,$this->picheight,$this->picwidth-1,0,$this->color['blue06']);
		
		imagestringgb($this->im,12,0,20,($this->picheight*$this->spacetopx)/2,$this->color[$this->textcolor],"simhei.ttf",$this->charhead);
		imagestringgb($this->im,9,0,20,($this->picheight*$this->spacetopx)/2+14,$this->color[$this->textcolor],"simsun.ttc",$this->subhead);

		//底部注解位置的计算x 图片宽度减去左右空隙除2，y 图片高度减去底部空隙除2加字体大小

		imagestringgb($this->im,9,0,$this->picwidth*(1-$this->spacelefty-$this->spacerighty)/2,$this->picheight*(1-($this->spacebottomx)/2)+9,$this->color[$this->textcolor],"simsun.ttc",$this->bottomnote);
		imagestringgb($this->im,9,0,$this->picwidth*(1-$this->spacerighty),$this->picheight*(1-$this->spacebottomx)+18,$this->color[$this->textcolor],"simsun.ttc",$this->xnumunits);

		//imagestring($this->im,3,$this->picwidth*(1-$this->spacerighty)-20,$xy2-$this->xyspace,$this->ynumunits,$color);
		imagestringgb($this->im,9,0,$this->picwidth*($this->spacelefty)-30,$this->picheight*($this->spacetopx)+12,$this->color[$this->textcolor],"simsun.ttc",$this->ynumunits);
	}


	/*
	@ 输出图片 
	@ 2006-8-10
	*/
	function OutImg(){
		header('Content-type: image/'.$this->property);
        $this->imagepic();
		imagedestroy($this->im);
	}

	/*
	@ 常用颜色定义 
	@ 2006-8-10
	*/
	function DefineColor(){
		$this->color  = getRPImgColor($this->im);

	}

	/*
	@ 定义图片属性 
	@ 2006-8-10
	*/
	function DefinePic($property,$picwidth,$picheight){
		$this->property   = $property;
		$this->picwidth   = $picwidth;
		$this->picheight  = $picheight;
		
		//2007-5-11 
		$sclw = round(450/$this->picwidth,2);
		$sclh = round(300/$this->picheight,2);
		$this->spacelefty    = round(0.25*$sclw,2);
		$this->spacerighty   = round(0.05*$sclw,2);
		$this->spacetopx     = round(0.15*$sclh,2);
		$this->spacebottomx  = round(0.20*$sclh,2);

		$this->ReportLineImg();
	}


	/*
	@ 定义坐标参数 
	@ 2006-8-10
	*/
	function DefineCdPar($xnum,$xnumcent,$xnumunits,$ynum,$ynumcent,$ynumunits){
		$this->xnum       = $xnum;
		$this->xnumcent   = $xnumcent;
		$this->xnumunits  = $xnumunits;
		$this->ynum       = $ynum;
		$this->ynumcent   = $ynumcent;
		$this->ynumunits  = $ynumunits;
		//$this->ReportLineImg();
	}

	/*
	@ 定义图片色调
	@ 2006-9-13
	*/
	function DefinePicTinct($bgcolor='gray02',$fringecolort='blue03',$fringecolorb='blue04',$textcolor='black'){
		$this->bgcolor        = $bgcolor;
		$this->fringecolort   = $fringecolort;
		$this->fringecolorb   = $fringecolorb;
		$this->textcolor      = $textcolor;

		$this->ReportLineImg();
	}

	/*
	@ 定义线图属性 
	@ 2006-8-10
	*/
	function DefineLpPar($ishavegrid=false,$isynote=false,$isstresspoint=false,$isfillarea=false,$linedia=1,$isdrawline=false,$effect='alpha'){
		$this->ishavegrid    = $ishavegrid; //是否显示栅格
		$this->isynote       = $isynote; //节点是否显示数值

		$this->isstresspoint = $isstresspoint; //节点是否突出
		$this->isfillarea    = $isfillarea; //是否填充路径
		$this->linedia       = $linedia;
		$this->isdrawline    = $isdrawline;
		$this->effect        = $effect;
		//$this->ReportLineImg();
	}

	/*
	@ 定义节点参数 
	@ 2006-8-10
	*/
	function DefinePnPar($pointfigure="prism",$pointdia=4,$pointsame=false){
		$this->pointfigure    = $pointfigure; //节点形状
		$this->pointdia       = $pointdia;    //节点直径
		$this->pointsame       = $pointsame;  //节点边缘线

		//$this->ReportLineImg();
	}


	/*
	@ 计算x,y坐标长度
	@ 2006-8-8
	*/
	function CountXYLength(){
		$this->xlength = $this->picwidth*(1-$this->spacelefty-$this->spacerighty)-$this->xyspace;
		$this->ylength = $this->picheight*(1-$this->spacetopx-$this->spacebottomx)-$this->xyspace;;
	}

	/*
	@ 图片格式不同使用对应函数
	@ 2006-8-8
	*/
	function imagepic(){
		switch ($this->property){
			case 'jpeg':
				imagejpeg($this->im);
				break;
			case 'png':
				imagepng($this->im);
				break;
			case 'gif':
				imagegif($this->im);
				break;
			default:
				imagepng($this->im);
		}
	}
	/*
	@ 创建坐标,坐标线,x轴,y轴单位分布点
	@ 2006-8-8
	*/
	function DrawBasicCoordinate($drawarray=''){
		//
	    if(count($drawarray) == 0){
			return;
		}
		
		$bx = $this->picwidth*$this->spacelefty;
		$by = $this->picheight*(1-($this->spacebottomx)/2);


	    //
		$lx = ($this->picwidth*$this->spacelefty)/2;
		$ly = $this->picheight*(1-$this->spacetopx);
		//imagestringup($this->im,3,$lx,$ly,$this->leftnote,$color);

		$color = $this->color['black'];
		$color_grid = $this->color['gray'];
		$x1 = $this->picwidth*$this->spacelefty;
		$y1 = $this->picheight*(1-$this->spacebottomx);

		$x2 = $x1;
		$y2 = $this->picheight*$this->spacetopx;
		imageline($this->im,$x1,$y1,$x2,$y2,$color);
		imageline($this->im,$x1-1,$y1,$x2-1,$y2,$color);

		$x2 = $this->picwidth*(1-$this->spacerighty);
		$y2 = $y1;
		imageline($this->im,$x1,$y1,$x2,$y2,$color);
		imageline($this->im,$x1,$y1+1,$x2,$y2+1,$color);

		//x方向的单位分布

		$x_cent_total = floor($this->xnum/$this->xnumcent);
		for ($i=0;$i<=$x_cent_total;$i++){
			$xx1 = $x1+floor(($i*$this->xlength)/$x_cent_total);
			$xy1 = $y1;
			$xx2 = $xx1;
			$xy2 = $y1+$this->centlength;
			imageline($this->im,$xx1,$xy1,$xx2,$xy2,$color);
			$text = round($this->xnum*$i/$x_cent_total,2);
			imagestring($this->im,2,$xx2,$xy2+5,$text,$this->color[$this->textcolor]);

			if ($this->ishavegrid && $i<>0){
				imageline($this->im,$xx1,$xy1,$xx2,$y1-$this->ylength,$color_grid);
				//imagelinedashed($this->im,$xx1,$xy1,$xx2,$y1-$this->ylength,$color_grid,$this->color['white'],$interval=5);
			}
		}

		//y方向的单位分布

		$y_cent_total = floor($this->ynum/$this->ynumcent);
		for ($i=0;$i<=$y_cent_total;$i++){
			$xx1 = $x1;
			$xy1 = $y1-floor(($i*$this->ylength)/$y_cent_total);
			$xx2 = $xx1-$this->centlength;
			$xy2 = $xy1;
			//echo "$xx1,$xy1 $xx2,$xy2 <br>";
			imageline($this->im,$xx1,$xy1,$xx2,$xy2,$color);
			$text = round($this->ynum*$i/$y_cent_total,2);
			imagestring($this->im,2,$xx2-20,$xy2,$text,$this->color[$this->textcolor]);

			if ($this->ishavegrid && $i<>0){
				imageline($this->im,$xx1,$xy1,$x1+$this->xlength,$xy2,$color_grid);
				//imagelinedashed($this->im,$xx1,$xy1,$x1+$this->xlength,$xy2,$color_grid,$this->color['white'],$interval=5);
			}
		}
	}

	/*
	@ 分析数组 一维 二维 三维 
	@ 2006-8-31
	*/
	function ParseDrawArray($array,$pointfigure="",$lintype="line"){

		global $_lang;
		$f_x = 10;
		$f_y = $this->picheight*$this->spacetopx;
		//$this->pointfigure = $pointfigure;

		if(count($array) ==0){
			imagestringgb($this->im,10,0,160,60+30,$this->color[$this->textcolor],"simhei.ttf",$_lang["common_no_any_data"]);
			return;
		}

		while(list($key,$var)=each($array)){
			$darray = $var;
			$this->DrawReportLine($darray['value'],$key,$pointfigure,$lintype);

			$f_y +=20;

			//折线说明
			if ($this->isdrawline == true && $this->isfillarea == false){
				//imagesmoothline($this->im,$f_x,$f_y,$f_x+10,$f_y,$this->color[$key]['light']);
				//imagesmoothline($this->im,$f_x,$f_y+1,$f_x+10,$f_y+1,$this->color[$key]['light']);

				switch($lintype){
					case "line":						
						imagesmoothline($this->im,$f_x,$f_y,$f_x+10,$f_y,$this->color[$key]['light']);
						imagesmoothline($this->im,$f_x,$f_y+1,$f_x+10,$f_y+1,$this->color[$key]['light']);
						break;
					case "dashed":
						imagelinedashed($this->im,$f_x,$f_y,$f_x+10,$f_y,$this->color[$key]['light'],$this->color['white'],$interval=5);
						imagelinedashed($this->im,$f_x,$f_y+1,$f_x+10,$f_y+1,$this->color[$key]['light'],$this->color['white'],$interval=5);
						break;
					case "arrow":
						imagefilledarrow($this->im,$f_x,$f_y,$f_x+10,$f_y,$dia=1,$ply=4,$scape=2,$this->color[$key]['light']);
						imagefilledarrow($this->im,$f_x,$f_y+1,$f_x+10,$f_y+1,$dia=1,$ply=4,$scape=2,$this->color[$key]['light']);


						break;
				}
				imagestringgb($this->im,9,0,$f_x+20,$f_y+5,$this->color[$this->textcolor],"simsun.ttc",$darray['name']);

				$f_ln = strlen($array[$i]['x']);
				$x_windage = $f_ln*7;
				//要修改的地方 2006-9-5
				//$f_t_str = array_sum($darray['value']['y']);
				//imagestring($this->im,2,$f_x+30+$x_windage,$f_y-5,$f_t_str,$this->color['black']);
			}

			//节点说明
			if ($this->isdrawline == false && $this->isstresspoint == true && $this->isfillarea == false){
				$colorside = $this->pointsame?$this->color[$key][$this->effect]:$this->color['black'];
				
				imagepointfigure($this->pointfigure,$this->im,$f_x+5,$f_y,$this->pointdia,$this->color[$key][$this->effect],$colorside);
				imagestringgb($this->im,9,0,$f_x+15,$f_y+5,$this->color[$this->textcolor],"simsun.ttc",$darray['name']);
			
			}

			//海浪说明
			if ($this->isfillarea == true){
				imagepointfigure('rectangle',$this->im,$f_x+5,$f_y,$this->pointdia,$this->color[$key]['light'],$this->color[$key]['light']);
				imagestringgb($this->im,9,0,$f_x+15,$f_y+5,$this->color[$this->textcolor],"simsun.ttc",$darray['name']);
			
			}

		}
	}

	/*
	@ 主程序绘制连线图
	@ 2006-8-8
	*/
	function DrawReportLine($array,$color_key,$pointfigure="",$lintype="line"){

		
		if ($pointfigure != ''){
			$this->pointfigure = $pointfigure;
		}
		$color = $this->color[$color_key][$this->effect];
		$color_alpha = $this->color[$color_key]['alpha'];
		$cna = sizeof($array);
		$x[0] = $this->picwidth*$this->spacelefty;
		$y[0] = $this->picheight*(1-$this->spacebottomx);
		$key_priview = 0;
		$key_current = 0;
		for($i=1;$i<=$cna;$i++){
			$key_priview = $i-1;
			$key_current = $i;
			$xnum_current = $array[$i]['x'];
			$ynum_current = $array[$i]['y'];
			$x[$key_current] = $x[0]+floor($this->xlength*($xnum_current/$this->xnum));
			$y[$key_current] = $y[0]-floor($this->ylength*($ynum_current/$this->ynum));
			//突出节点
			if ($this->isstresspoint){
				//echo $this->pointsame;
				$colorside = $this->pointsame?$color:$this->color['black'];
				imagepointfigure($this->pointfigure,$this->im,$x[$key_current],$y[$key_current],$this->pointdia,$color,$colorside);
			}
            
			//连线粗

			if($this->isdrawline && $i<>1){
				for($li=0;$li<$this->linedia;$li++){

					switch($lintype){
						case "line":						
							imagesmoothline($this->im,$x[$key_priview]+$li,$y[$key_priview],$x[$key_current]+$li,$y[$key_current],$color,true);
							break;
						case "dashed":
							imagelinedashed($this->im,$x[$key_priview]+$li,$y[$key_priview],$x[$key_current]+$li,$y[$key_current],$color,$this->color['white'],$interval=5);
							break;
						case "arrow":
							imagefilledarrow($this->im,$x[$key_priview]+$li,$y[$key_priview],$x[$key_current]+$li,$y[$key_current],$dia=1,$ply=4,$scape=2,$color);
							break;
					
					}
					
				
				}
			}
		    	
			if ($this->isynote){
				imagestring($this->im,1,$x[$key_current]+$this->pointdia,$y[$key_current],$array[$i][y],$this->color['red']);
			}

			if ($i==$cna){
				$key_last = $i+1;
				$x[$key_last] = $x[0]+floor($this->xlength*($xnum_current/$this->xnum));
				$y[$key_last] = $y[0];
			
			}
		}
		//填充路径
		if ($this->isfillarea){
			$xycount = count($x);
			for($xyi=0;$xyi<$xycount;$xyi++){
				$xykey_1 = $xyi*2;
				$xykey_2 = $xyi*2+1;
				$xyarray[$xykey_1] = $x[$xyi];
				$xyarray[$xykey_2] = $y[$xyi];
			
			}

			imagefilledpolygon($this->im,$xyarray,$xycount,$color_alpha);
		}
	}

}
?>