<?PHP
/*************************************************************
* Note: 	格式化绘制流程图的数组$export                       *
* Author: 	Weaver.liuxiulin                                 *
* Contact: 	xiulin.liu@weaver.com.cn		                 *
* Version: 	3.x						                         *
* Created:  2005-9-14  		                                 *
* Revision: //							                     *
*************************************************************/
class FormatEx{
	/*-----------------------------------------
	Define 
	-----------------------------------------*/
	var $export;  
	var $sourcear;
	var $pattenar;

	/*
	@ MakeupEx
	@ function 补充步骤定义未填写的下一步

	@ create date 2005-9-14
	*/
	function MakeupEx($inArray){
		while (list($key,$var) = each ($inArray)){
			if ($inArray[$key] == ''){
				$inArray[$key] = $this->GetNextKey($inArray,$key);
			}
		}

		return $inArray;
	}

	/*
	@ GetNextKey
	@ function 取得下一步的key值

	@ create date 2005-9-14
	*/
	function GetNextKey($inArray,$inkey){
		$i=0;
		reset($inArray);
		while (list($key) = each ($inArray)){
			if ($key == $inkey){
				$i++;
				continue;
			}
			if (($i+1) == 2){
				break;
			}
		}
		return $key;
	}

	/*
	@ GetNextKey
	@ function 取得下一步的key值

	@ create date 2005-9-14
	*/
	function ArrayToRun($inArray){
		$i = 0;
		reset($inArray);
		while (list($key,$var) = each ($inArray)){
			$sArray   = explode(',',$var);
			$tmpArray = array();
			while (list($skey,$svar) = each ($sArray)){
				$tmpArray[$key] = $svar;
				$outArray[$i]   = $tmpArray;
				$i++;
			}
		}
		return $outArray;
	}


	/*
	@ ReplaceFlag
	@ function 重新命名数组的下标，并转换数组的值

	@ create date 2005-9-15 modify 2005-9-27
	*/
	function ReplaceFlag($inArray){
		$k = 1;
		while(list($key,$var) = each($inArray)){
			$orderArray[$k] = $var;
			$replace[$key]    = $k;
			$k++;
		}
		//$replace[0]=0;

		
		$orderstr = implode('|',$orderArray);
		
		//残留问题:无法解决逐步替换的多字符与单字符的并行问题 xiulin.liu@weaver.com.cn 2005-10-26
		/*echo $orderstr;
		echo "<br>";
		*/
		//2006-3-28 解决 lxl
		$restr = preg_replace("/(\d+)/e","\$replace[\\1]", $orderstr);
		$lastar   = explode('|',$restr);
		
		$k = 1;
		while (list($key,$var) = each($lastar)){
			$outArray[$k] = $var;
			$k++;
		}

		/*
		echo "<pre>";
		print_r($inArray);
		print_r($replace);
		print_r($orderArray);
		print_r($outArray);
		echo "</pre>";
		exit;
		*/
		return $outArray;
	}

	/*
	@ ReplaceFlagRun
	@ function 重新命名数组的下标，并转换数组的值

	@ create 2005-9-29
	*/
	function ReplaceFlagRun($inArray,$run){

		$k = 1;
		while(list($key,$var) = each($inArray)){
			$orderArray[$k]   = $var;
			$replace[$key]    = $k;
			$k++;
		}

		$orderstr = implode('|',$run);
		$restr = preg_replace("/(\d+)/e","\$replace[\\1]", $orderstr);
		$lastar   = explode('|',$restr);
		
		$k = 0;
		while (list($key,$var) = each($lastar)){
			$outArray[$k] = $var;
			$k++;
		}
		return $outArray;
	
	}

	/*
	@ GetFlowArray
	@ function 获得适合流程图绘制的数组
	@ create date 2005-9-15
	*/
	function GetFlowArray($inArray) {
		while (list($key,$var) = each($inArray)){
			$varr = current($inArray);
			$tmpArray[$key][$var] = $varr;
		}
		while (list($key,$var) = each($tmpArray)){
			while(list($ke,$va) = each($var)){
				$outArray[$ke] = $this->GetSameKey($tmpArray,$ke,$va);
			}
		}
		ksort($outArray);
		reset($outArray);
		return $outArray;
	}

	/*
	@ RecursionFlow
	@ function 重组数组
	@ create date 2005-9-21
	*/
	function RecursionFlow($inArray) {
		reset($inArray);
		while (list($key,$var) = each($inArray)){
		   $varr = current($inArray);
		   $outArray[$key][$var] = $varr;
		}

		return $outArray;
	}

	/*
	@ GetSameKey
	@ function 相同key的值以字符形式相加
	@ create date 2005-9-19
	*/
	function GetSameKey($inar,$inkey,$inva){
		reset($inar);
		while (list($key,$var) = each($inar)){
			while(list($ke,$va) = each($var)){
				if ($ke == $inkey){
					if ($str == ''){
						$str .= $va;
					}
					else if ($va != ''){
					   $str .= ",".$va;
					}
					//$str .= $va?",".$va:$va;
				}
			}
		}
		return $str;

	}

	/*
	@ JoinArray
	@ function 补充未运行的流程
	@ create date 2005-9-20
	NOTE:
	*/
	function JoinArray($ar1,$ar2,$cur){
		/*
		$ar1  运行流程
		$ar2  原始流程
		*/
		while(list($key,$var) = each($ar2) ){
			if ($key < $cur){
				$runAr[$key] = $ar1[$key]?$ar1[$key]:'';
			}

			if ($key == $cur){
				$runAr[$key] = $ar2[$key];
			}

			if ($key > $cur){
				$tmpAr = explode(',',$ar2[$key]);
				foreach ($tmpAr as $tmpVa){
					if (($tmpVa - $key) == 1){
						$runAr[$key] = $tmpVa;
					}
				}
				if ($ar2[$key] == ''){
					$runAr[$key] = '';
				}
			}
		}
		return $runAr;
	}


	/*
	@ SupplyFlow
	@ function 补充未运行的流程
	@ create date 2005-9-22
	*/
	function SupplyFlow($export,$current){
		while (list($key,$var) = each($export)){
			if ($key == $current){
				$export2[$key] = $var;
			}
			if ($key > $current || $key < $current){
				$tmpAr = explode(',',$var);
				foreach ($tmpAr as $tmpVa){
					if (($tmpVa - $key) == 1){
						$export2[$key] = $tmpVa;
					}
				}
				if ($var == ''){
					$export2[$key] = '';
				}
			}
		}
		return $export2;
	}

	/*
	@ GetCurrentSetp
	@ function 取得当前的步骤

	@ create date 2005-9-20
	*/
	function GetCurrentSetp($ar){
		$ra = end($ar);
		reset($ar);
		return $ra;
	}

	/*
	@ CountSize
	@ function 计算图片(网页)大小
	@ create date 2005-9-28
	*/
	function CountSize($inArray){
		$total = count($inArray);
		$x = 500;
		$y = 200;
		if ($total > 3){
			$x = 500+($total-3)*230;
		}
		if($total > 8)
		{
			$x = $total*250;
		}
		if ($total > 3){
			$y = 200+($total-3)*25;
		}
		if($total > 8)
		{
			$y = 200+($total-3)*35;
		}
		$xy['x'] = $x;
		$xy['y'] = $y;
		return $xy;
	}

	/*
	@ array_seek
	@ function 根据已知key指针移到对应位置
	@ create date 2005-9-15
	*/
	function array_seek(&$ar, $key) {
		reset($ar);
		do {
		    if(key($ar) === $key) break;
		}
		while(next($ar) !== false);
	}

}


?>