<?PHP
/*************************************************************
* Note: 	图形报表-生成饼形图		                         *
* Author: 	Weaver.liuxiulin                                 *
* Contact: 	xiulin.liu@weaver.com.cn		                 *
* Version: 	1.0						                         *
* Eoffice V: 4.0   		                                     *
* Created:  2006-8-31  		                                 *
* Revision: //							                     *
*************************************************************/
include_once("inc/img_func.php");
include_once("inc/img_color.php");
class ReportPieImg{
	/*-----------------------------------------
	Define 
	-----------------------------------------*/
	
	//图片基本属性

	var $property  = 'png'; //图片属性

	var $picwidth  = 500;    //图片宽度
	var $picheight = 300;    //图片高度

	var $spacelefty    = 0.05;
	var $spacerighty   = 0.35;
    var $spacetopx     = 0.15;
    var $spacebottomx  = 0.20;

	var $xnum      = 31; //x轴

	var $xnumcent  = 1;
	var $xnumunits = "";
    var $ynum      = 100; //y轴

	var $ynumcent  = 10;
	var $ynumunits = "";

	var $xlength;  //坐标轴的实际长度 px (有效长度)
	var $ylength;
	var $xyspace  = 20;  //剩余坐标轴的长度

	var $centlength  = 5; //标注点的长度
    var $isynote     = false; //节点是否显示数值

	var $barspace    = 10; //柱形之间的间隙


	var $bgcolor        = 'black03';//背景颜色
	var $fringecolort   = 'black01'; //外框颜色
	var $fringecolorb   = 'black02'; //外框颜色
	var $textcolor      = 'white'; //所有文字颜色


	var $ishavegrid    = false; //是否显示栅格

	var $charhead   = "";
	var $subhead    = "";
	var $bottomnote = "";
	var $leftnote   = "";
	var $picname    = "";

	var $root_path;
	var $drawarray;

	var $im;                 //图片缓冲

    var $radii_ln=100;              //椭圆长半轴

    var $radii_sh;                  //椭圆短半轴

	var $radii_scale=0.6;           //椭圆半轴比

	var $centerx;
	var $centery;

	var $haveshadow = true;  //是否显示阴影

	var $ellipse_space=20;      //椭圆距离

    /*
	@ 构造

	@ 2006-8-8
	*/	
	function ReportPieImg(){
		global $_lang;
		$this->xnumunits  = $_lang["flow_charname"];
		$this->ynumunits  = $_lang["flow_unit"] ;
		$this->charhead   = $_lang["flow_travelcosts_table"];
		$this->subhead    = $_lang["flow_business_processes"];
		$this->bottomnote = $_lang["flow_bottom_notes"];
			
		$this->root_path  = str_replace('\\','/',get_cfg_var('doc_root')."/");
		$this->picname   = time();
		$this->CreateImg();     // 创建图片
		$this->DefineColor();   //常用颜色定义
		$this->FillImgBg();     //图片背景
		$this->CountXYLength(); //坐标实际长度计算
		$this->DecorateImg();   //图片修饰

		$this->radii_sh =  $this->radii_ln*$this->radii_scale;
		$this->centerx = $this->picwidth*$this->spacelefty+$this->radii_ln+$this->ellipse_space;
		$this->centery = $this->picheight*$this->spacetopx+$this->radii_sh+$this->ellipse_space;
	}

	/*
	@ 创建图形
	@ 2006-8-8
	*/
	function CreateImg(){
		$this->im = imagecreatetruecolor($this->picwidth,$this->picheight);
		//imageantialias($this->im, true);
	}

	/*
	@ 填充背景
	@ 2006-8-8
	*/
	function FillImgBg(){
		$color = $this->color[$this->bgcolor];
		imagefilledrectangle($this->im, 0, 0, $this->picwidth, $this->picheight, $color);	
	}

	/*
	@ 修饰图形外围，图表名称，单位等

	@ 2006-8-24
	*/
	function DecorateImg($charhead="",$subhead="",$bottomnote="",$leftnote="",$picname=""){
		$this->charhead   = $charhead?$charhead:$this->charhead;
		$this->subhead    = $subhead?$subhead:$this->subhead;
		$this->bottomnote = $bottomnote?$bottomnote:$this->bottomnote;
		$this->leftnote   = $leftnote?$leftnote:$this->leftnote;
		$this->picname   = $picname?$picname:$this->picname;

		
		imagefilledrectangle($this->im, 0, 0, $this->picwidth*$this->spacelefty, $this->picheight, $this->color[$this->fringecolorb]);
		imagefilledrectangle($this->im, 0, $this->picheight*(1-$this->spacebottomx), $this->picwidth, $this->picheight, $this->color[$this->fringecolorb]);
		imagefilledrectangle($this->im, $this->picwidth*(1-$this->spacerighty), 0, $this->picwidth, $this->picheight, $this->color[$this->fringecolorb]);
		imagefilledrectangle($this->im, 0, 0, $this->picwidth, $this->picheight*$this->spacetopx, $this->color[$this->fringecolort]);

		imageline($this->im,0,0+1,$this->picwidth,0+1,$this->color['white']);
		imageline($this->im,0+1,0,0+1,$this->picheight,$this->color['white']);
		imageline($this->im,0,$this->picheight-1,$this->picwidth,$this->picheight-1,$this->color['blue06']);
		imageline($this->im,$this->picwidth-1,$this->picheight,$this->picwidth-1,0,$this->color['blue06']);
		imagestringgb($this->im,12,0,20,($this->picheight*$this->spacetopx)/2,$this->color[$this->textcolor],"simhei.ttf",$this->charhead);
		imagestringgb($this->im,9,0,20,($this->picheight*$this->spacetopx)/2+14,$this->color[$this->textcolor],"simsun.ttc",$this->subhead);

		//底部注解位置的计算x 图片宽度减去左右空隙除2，y 图片高度减去底部空隙除2加字体大小

		imagestringgb($this->im,9,0,$this->picwidth*(1-$this->spacelefty-$this->spacerighty)/2,$this->picheight*(1-($this->spacebottomx)/2)+9,$this->color[$this->textcolor],"simsun.ttc",$this->bottomnote);
	}

	/*
	@ 输出图片
	@ 2006-9-15
	*/
	function OutImg(){
		header('Content-type: image/'.$this->property);
        $this->imagepic();
		imagedestroy($this->im);
		//header('Content-disposition: attachment;filename="'.$this->picname.'"'.'".'.$this->property.'"');
	}

	/*
	@ 定义常用颜色
	@ 2006-9-15
	*/
	function DefineColor(){
		$this->color  = getRPImgColor($this->im);
	}

	/*
	@ 定义图片属性

	@ 2006-9-13
	*/
	function DefinePic($property,$picwidth,$picheight){
		$this->property   = $property;
		$this->picwidth   = $picwidth;
		$this->picheight  = $picheight;
		$this->ReportPieImg();
	}

	/*
	@ 定义图片色调
	@ 2006-9-13
	*/
	function DefinePicTinct($bgcolor='gray02',$fringecolort='blue03',$fringecolorb='blue04',$textcolor='black'){
		$this->bgcolor        = $bgcolor;
		$this->fringecolort   = $fringecolort;
		$this->fringecolorb   = $fringecolorb;
		$this->textcolor      = $textcolor;

		$this->ReportPieImg();
	}

	/*
	@ 定义坐标参数
	@ 2006-9-13
	*/
	function DefineCdPar($xnum,$xnumcent,$xnumunits,$ynum,$ynumcent,$ynumunits){
		$this->xnum       = $xnum;
		$this->xnumcent   = $xnumcent;
		$this->xnumunits  = $xnumunits;
		$this->ynum       = $ynum;
		$this->ynumcent   = $ynumcent;
		$this->ynumunits  = $ynumunits;
		$this->ReportPieImg();
	}


	/*
	@ 定义饼图属性

	@ 2006-9-13
	*/
	function DefineLpPar($ishavegrid=false,$haveshadow=true,$radii_scale=0.6,$radii_ln=100){
		$this->ishavegrid       = $ishavegrid;  //是否显示栅格
		$this->haveshadow       = $haveshadow;  //是否显示阴影
		$this->radii_scale      = $radii_scale; //长宽比

		$this->radii_ln         = $radii_ln;    //长半轴


		$this->ReportPieImg();
	}

	/*
	@ 计算x,y坐标长度
	@ 2006-8-8
	*/
	function CountXYLength(){
		$this->xlength = $this->picwidth*(1-$this->spacelefty-$this->spacerighty)-$this->xyspace;
		$this->ylength = $this->picheight*(1-$this->spacetopx-$this->spacebottomx)-$this->xyspace;;
	}

	/*
	@ 图片格式不同使用对应函数
	@ 2006-8-8
	*/
	function imagepic(){
		switch ($this->property){
			case 'jpeg':
				imagejpeg($this->im);
				break;
			case 'png':
				imagepng($this->im);
				break;
			case 'gif':
				imagegif($this->im);
				break;
			default:
				imagepng($this->im);
		}
	}

	/*
	@ 创建坐标,坐标线,x轴,y轴单位分布点
	@ 2006-8-8
	*/
	function DrawBasicCoordinate($drawarray=''){
		if(count($drawarray) ==0){
			return;
		}
		$color = $this->color['black'];
		$color_grid = $this->color['gray00'];
		$x1 = $this->picwidth*$this->spacelefty;
		$y1 = $this->picheight*(1-$this->spacebottomx);

		$x2 = $x1;
		$y2 = $this->picheight*$this->spacetopx;

		$x2 = $this->picwidth*(1-$this->spacerighty);
		$y2 = $y1;


		//x方向的单位分布

		$x_cent_total = floor($this->xnum/$this->xnumcent);
		for ($i=0;$i<=$x_cent_total;$i++){
			$xx1 = $x1+floor(($i*$this->xlength)/$x_cent_total);
			$xy1 = $y1;
			$xx2 = $xx1;
			$xy2 = $y1+$this->centlength;

			$text = $drawarray[$i]['x'];

			if ($this->ishavegrid && $i<>0){
				imagelinedashed($this->im,$xx1,$xy1,$xx2,$y1-$this->ylength,$color_grid,$this->color['white'],$interval=5);
			}
		}

		//y方向的单位分布

		$y_cent_total = floor($this->ynum/$this->ynumcent);
		for ($i=0;$i<=$y_cent_total;$i++){
			$xx1 = $x1;
			$xy1 = $y1-floor(($i*$this->ylength)/$y_cent_total);
			$xx2 = $xx1-$this->centlength;
			$xy2 = $xy1;

			if ($this->ishavegrid && $i<>0){
				imageline($this->im,$xx1,$xy1,$x1+$this->xlength,$xy2,$color_grid);
				imagelinedashed($this->im,$xx1,$xy1,$x1+$this->xlength,$xy2,$color_grid,$this->color['white'],$interval=5);
			}
		}
	}

	/*
	@ 主程序绘制饼形图
	@ 2006-8-24
	*/
	function DrawReportPie($array){
		global $_lang;
        $dia_ln=$this->radii_ln*2;
        $dia_sh=$this->radii_sh*2;

		$total_piece  = count($array);
		$total_value  = 0;
		for($i=1;$i<=$total_piece;$i++){
			$total_value += $array[$i]['y'];
		}

		if ($total_value>0){
        
			$degree = 0;
			$f_x = $this->picwidth*(1-$this->spacerighty)+10;
			$f_y = $this->picheight*$this->spacetopx;
			for ($i = 1;$i<=$total_piece;$i++) {
				$s_degree = round($degree);
				$degree   += (($array[$i]['y']/$total_value)*360);
				$e_degree = round($degree);
				$percent = number_format($array[$i]['y']/$total_value*100, 2);
				$current_light_color = $this->color[$i]['light'];
				$current_dark_color  = $this->color[$i]['dark'];
				
				//扇形弧

				imagearc($this->im,$this->centerx,$this->centery,$dia_ln,$dia_sh,$s_degree,$e_degree,$current_light_color);
				//画直线

				list($arcx, $arcy) = pie_point($s_degree ,$this->radii_ln,$this->radii_sh);
				imageline($this->im,$this->centerx,$this->centery,floor($this->centerx+$arcx),floor($this->centery+$arcy),$current_light_color);

				list($arcx, $arcy) = pie_point($e_degree,$this->radii_ln , $this->radii_sh);
				imageline($this->im,$this->centerx,$this->centery,ceil($this->centerx +$arcx),ceil($this->centery+$arcy),$current_light_color);
				
				//扇形
				$midpoint = round((($e_degree-$s_degree)/2)+$s_degree);
				list($arcx, $arcy) = pie_point($midpoint, $this->radii_ln*3/4 , $this->radii_sh*3/4);
				imagefilltoborder($this->im,floor($this->centerx+ $arcx),floor($this->centery+$arcy),$current_light_color,$current_light_color);
				imagestring($this->im,1,floor($this->centerx+ $arcx-5),floor($this->centery+$arcy-5),$percent."%",$this->color['black']);

				//阴影
				if ($this->haveshadow){

					if ($s_degree>=0 and $s_degree<=180){
						if($e_degree<=180){
							for($k = 1; $k < 15; $k++)
								imagearc($this->im,$this->centerx, $this->centery+$k,$dia_ln,$dia_sh,$s_degree, $e_degree, $current_dark_color);
						}else{
							for($k = 1; $k < 15; $k++)
								imagearc($this->im,$this->centerx, $this->centery+$k,$dia_ln,$dia_sh,$s_degree,180, $current_dark_color);
						}
					}
				}

				//右边注释

				$f_y +=20;
				imagepointfigure('rectangle',$this->im,$f_x,$f_y,10,$this->color[$i]['light'],$this->color[$this->textcolor]);
				imagestring($this->im,2,$f_x+10,$f_y-5,$percent."%",$this->color[$this->textcolor]);
				imagestringgb($this->im,9,0,$f_x+50,$f_y+5,$this->color[$this->textcolor],"simsun.ttc",$array[$i]['x']);

				$f_ln = strlen($array[$i]['x']);
				$x_windage = $f_ln*7;
				imagestring($this->im,2,$f_x+50+$x_windage,$f_y-5,$array[$i]['y'],$this->color[$this->textcolor]);
			   
			}

			//共计
			$format_total = $total_value;
			$str_total = $_lang["flow_totall"]." $format_total ".$this->ynumunits;
			imagestringgb($this->im,10,0,$f_x,$f_y+30,$this->color[$this->textcolor],"simhei.ttf",$str_total);
		}
		else{
			imagestringgb($this->im,10,0,160,60+30,$this->color[$this->textcolor],"simhei.ttf",$_lang["flow_nodata"]);
		
		}


	}

}

?>
