/**
    封装plupload插件
*/
;(function($, undefined) {
    var methods = {
        init: function(options) {
            //默认参数
            var settings = $.extend({
                //附件列表容器ID
                queueID: false,
                //参数
                param: false,
                //上传路径
                uploadPath: "",
                //是否自动上传
                auto: false,
                //默认文字
                buttonText:UploadifyLang.uploadButton,
                buttonClass:"btn btn-success",
                removeCompleted: false,
                removeTimeout: 3,
                width: 80,
                height: 24,
                showToolTip: true,
                runtimes:"html5,flash,silverlight,html4",
                itemTemplate:function(file){
                    var fileSize = Math.round(file.size / 1024);
                    var suffix   = 'KB';
                    if (fileSize > 1000) {
                        fileSize = Math.round(fileSize / 1000);
                        suffix   = 'MB';
                    }
                    var fileSizeParts = fileSize.toString().split('.');
                    fileSize = fileSizeParts[0];
                    if (fileSizeParts.length > 1) {
                        fileSize += '.' + fileSizeParts[1].substr(0,2);
                    }
                    fileSize += suffix;
                    var fileName = file.name;
                    if (fileName.length > 25) {
                        fileName = fileName.substr(0,25) + '...';
                    }

                    var strHtml = '<span class="items" style="padding-right:5px" id="'+file.id+'">';
                    strHtml += '<a href="javascript:void(0)">'+file.name+'('+fileSize+')</a>';
                    strHtml += '<span class="process"></span>';
                    strHtml += '<a href="javascript:void(0)" class="delete-file" style="visibility: hidden;" title="'+ UploadifyLang.cancelUploadFile +'">';
                    strHtml += '<i class="fa fa-times"></i>';
                    strHtml += '</a>';
                    strHtml += '</span>';

                    return strHtml;
                },
                onQueueComplete: $.noop,
                onUploadSuccess: $.noop,
                onDialogClose  : $.noop,
                onClearQueue   : $.noop
            }, options);


            //错误信息提醒设置
            $.pnotify.defaults.styling = "bootstrap3";
            $.pnotify.defaults.closer = false;
            $.pnotify.defaults.sticker = false;
            $.pnotify.defaults.history = false;
            $.pnotify.defaults.delay = 2000;

            return this.each(function() {

                var $this = $(this),
                    thisID = $this.attr("id"),
                    pluploader;

                //模块的附件上传限制信息
                $.ajax({
                    url: '/inc/jquery/uploadify/newupload.php',
                    data: 'uploadType=' + settings.uploadType
                }).done(function(result) {
                    var parseData = $.parseJSON(result);
                    var limitNumber = parseData.num;
                    var singleLimitSize = parseData.size;
                    var totalLimitSize = parseData.tsize;
                    var limitType = (parseData.deny || '').toUpperCase();
                    var fullPath = parseData.full == 1 ? true : false;
                    var toolTip = parseData.tooltip;
                    var myTotalSize = 0;


                    // 附加上传按钮和提示信息
                    if ($("#" + thisID + "_wraper").size() === 0) {
                        var strHtml = "<div id='" + thisID + "_button'";
                            strHtml += "style='width:"+ settings.width +"px;height:"+ settings.height +"px;line-height:" + (settings.height - 10) + "px;'";
                            strHtml += "class='" + settings.buttonClass + "'>";
                            strHtml += "<span>"+ settings.buttonText +"</span>";
                            strHtml += "</div>";
                            
                        if (settings.showToolTip) {
                            strHtml +="<span style='position:absolute;margin:5px 0 0 5px;'>" + parseData.tooltip + "</span>";
                        }
                        //显示上传文件列表
                        if (!settings.queueID) {
                            strHtml += "<div id='" + thisID + "_queue'></div>";
                        }
                        $this.hide().wrap("<div id='" + thisID + "_wraper'/>").after(strHtml);
                    }
                    
                    
                    pluploader = new plupload.Uploader({
                        runtimes: settings.runtimes,
                        browse_button : thisID + "_button",
                        url : '/inc/jquery/uploadify/uploadify.php',
                        flash_swf_url : '/newplugins/js/plupload-2.1.8/js/Moxie.swf',
                        silverlight_xap_url : '/newplugins/js/plupload-2.1.8/js/Moxie.xap',
                        file_data_name: "Filedata",
                        // General settings
                        //unique_names : true,
                        // Resize images on client-side if we can
                        filters : {
                            //max_file_size : singleLimitSize + "KB",
                            // Specify what files to browse for
                            /*mime_types: [
                                {title : "Image files", extensions : "jpg,gif,png"},
                                {title : "Text files", extensions : "txt"},
                                {title : "Zip files", extensions : "zip"}
                            ],*/
                            prevent_duplicates : true
                        },
                        init: {
                            //文件通过过滤器后触发
                            FileFiltered: function(uploader, file) {
                                //构建错误文件列表
                                var invalidFile = $this.data("invalidFile") || [];

                                if (singleLimitSize != 0 && file.size / 1024 > singleLimitSize) {
                                    $.pnotify({
                                        text: UploadifyLang.sizeExceedWarn.replace(/\{0\}/, file.name).replace(/\{1\}/, (singleLimitSize / 1024).toFixed(2) + "MB"),
                                        type: "error"
                                    });
                                    invalidFile.push(file);
                                    $this.data("invalidFile", invalidFile);
                                    return false;
                                }
                                //选择的文件数量检查
                                if (limitNumber && uploader.files.length > limitNumber) {
                                    $.pnotify({
                                        text: UploadifyLang.uploadFileCount.replace(/\{0\}/, limitNumber),
                                        type: "error"
                                    });
                                    invalidFile.push(file);
                                    $this.data("invalidFile", invalidFile);
                                    return false;
                                }
                                //文件大小总和检查
                                if(totalLimitSize){
                                    var totalSize = 0;
                                    $.each(uploader.files, function(i, f) {
                                        totalSize += f.size;
                                    });
                                    if(totalSize / 1024 > totalLimitSize) {
                                        $.pnotify({
                                            text: UploadifyLang.totalSizeControl + (totalLimitSize / 1024).toFixed(2) + "MB",
                                            type: "error"
                                        });
                                        invalidFile.push(file);
                                        $this.data("invalidFile", invalidFile);
                                        return false;
                                    }
                                }
                            },
                            //单个文件上传结束触发
                            FileUploaded: function(uploader, file, responseObject){
                                //每个文件上传完成后，移除取消上传按钮
                                $("#" + file.id).find('.delete-file').remove();
                                if (settings.removeCompleted) {
                                    if (settings.removeTimeout > 0) {
                                        window.setTimeout(function(){
                                            uploader.removeFile(file);
                                            $("#" + file.id).remove();
                                        }, settings.removeTimeout * 1000);
                                    } else {
                                        uploader.removeFile(file);
                                        $("#" + file.id).remove();
                                    }
                                }
                                settings.onUploadSuccess.call($this, responseObject.response, file.name);
                            },
                            UploadComplete: function(uploader, files){
                                uploader.refresh();
                                //移除取消上传按钮                            
                                settings.onQueueComplete.call($this, files);
                            },
                            UploadProgress: function(uploader, file){
                                //文件上传进度
                                $("#" + file.id).find(".process").html(file.percent + "%");
                            },
                            FilesAdded: function(uploader, files) {
                                var invalidFile = $this.data("invalidFile");
                                if (invalidFile) {
                                    //移除废弃文件
                                    $.each(invalidFile, function(index, file) {
                                        uploader.removeFile(file);
                                        files.splice($.inArray(file, files), 1);
                                    });
                                }
                                $this.data("invalidFile", []);

                                var strArray = ['·', '\'', '—', '#', '%'],
                                    len = strArray.length,
                                    arrErrorFiles = [],
                                    arrDenyExtension = [],
                                    validFileIndex = [],
                                    fileExtension,
                                    i;

                                //检查文件名是否合法
                                $.each(files, function(index ,file){

                                    for (i = 0; i < len; i++) {
                                        if (file.name.indexOf(strArray[i]) != -1) {
                                            arrErrorFiles.push(file);
                                            return false;
                                        }
                                    }

                                    //检查文件类型
                                    if(file.name.indexOf(".") != -1) {
                                        fileExtension = file.name.split(".").pop();
                                        if (limitType.indexOf(fileExtension.toUpperCase()) != -1) {
                                            arrDenyExtension.push(file);
                                            return false;
                                        }
                                    } else {
                                        //没有文件类型视为无效
                                        arrDenyExtension.push(file);
                                        return false;
                                    }
                                    validFileIndex.push(index);
                                });

                                //移除文件名不合法的文件
                                if(arrErrorFiles.length > 0) {
                                    for (i =0, len = arrErrorFiles.length; i < len; i++) {
                                        uploader.removeFile(arrErrorFiles[i]);
                                    }
                                    //提示错误信息
                                    $.pnotify({
                                        text: UploadifyLang.fileNameIllegal,
                                        type: "error"
                                    });
                                    
                                }

                                //移除不合法文件类型
                                if(arrDenyExtension.length > 0) {
                                    var strError = "";
                                    for (i =0, len = arrDenyExtension.length; i < len; i++) {
                                        uploader.removeFile(arrDenyExtension[i]);
                                        strError += UploadifyLang.notAllowUpload + (arrDenyExtension[i].name.split(".")[1] || '') + UploadifyLang.typeFiles + "(" + arrDenyExtension[i].name + ")\n";
                                    }
                                    //提示错误信息
                                    $.pnotify({
                                        text: strError,
                                        type: "error"
                                    });
                                }
                                
                                //显示准备上传的文件
                                if ($.isFunction(settings.itemTemplate)) {
                                    var strFileQueue = "";
                                    $.each(validFileIndex, function(i, v){
                                        strFileQueue += settings.itemTemplate(files[v]);
                                    });
                                    if(settings.queueID) {
                                        $("#" + settings.queueID).append(strFileQueue);
                                    } else {
                                        $("#" + thisID + "_queue").append(strFileQueue);
                                    }
                                }
                                //选择文件窗口关闭事件
                                settings.onDialogClose.call($this);
                            }
                        }
                    });

                    //在实例对象上调用init()方法进行初始化
                    pluploader.init();

                    $("#" + (settings.queueID || thisID + "_queue")).delegate('.delete-file', 'click', function(event) {
                        //取消上传按钮按下时，移除该文件
                        pluploader.removeFile($(this).closest('.items').attr("id"));
                        $(this).closest('.items').remove();
                    })
                    .delegate('.items', 'mouseenter', function(event) {
                        $(this).find('.delete-file').css("visibility", "visible");
                    })
                    .delegate('.items', 'mouseleave', function(event) {
                        $(this).find('.delete-file').css("visibility", "hidden");
                    });

                    //保存默认配置
                    $this.data("uploadSettings", settings);
                    $this.data("uploader", pluploader);
                });
            });
        },
        getUploadCount: function() {
            var pluploader = $(this).data("uploader");
            if (pluploader) {
                return pluploader.files.length;
            } else {
                return 0;
            }
        },
        refresh: function() {
            var uploader = $(this).data("uploader");
            if (uploader) {
                uploader.refresh();
            }
        }
    }
    $.fn.Upload = function(method) {
        if (methods[method]) {
            return methods[method].apply(this, Array.prototype.slice.call(arguments, 1));
        } else if (typeof method === 'object' || !method) {
            return methods.init.apply(this, arguments);
        } else {
            $.error('Method ' + method + ' does not exist on $.Upload');
        }
    };
})(jQuery);

//以下方法兼容原来使用uploadyfy插件代码
;(function($, undefined) {
    var methods = {
        init: function(options) {
            //默认参数
            var settings = $.extend({
                //服务端处理
                uploader: '/inc/jquery/uploadify/uploadify.php',
                //flash文件
                swf: '/newplugins/js/plupload-2.1.8/js/Moxie.swf',
                silverlight_xap_url: '/newplugins/js/plupload-2.1.8/js/Moxie.xap',
                //是否自动上传
                auto: false,
                //是否多选
                multi: false,
                width: 80,
                height: 24,
                queueID: "",
                fileTypeDesc: "",
                fileTypeExts: "",
                //默认文字
                buttonText: "",
                formData: {},
                buttonClass: "",
                removeCompleted: false,
                removeTimeout: 3,
                runtimes:"html5,flash,silverlight,html4",
                itemTemplate: false,
                onUploadStart: $.noop,
                onInit: $.noop,
                onSelect: $.noop,
                onQueueComplete: $.noop,
                onUploadSuccess: $.noop,
                onUploadProgress: $.noop,
                onDialogClose  : $.noop,
                onClearQueue   : $.noop
            }, options);

            return this.each(function() {
                var $this = $(this),
                    thisID = $this.attr("id"),
                    pluploader;

                //没有id的场合，取一个ID
                if (!thisID) {
                    var i = 0;
                    do {
                        thisID = "plupload_" + i;
                        i++;
                    } while ($("#" + thisID).size() > 0);
                    $this.attr("id", thisID);
                }
                
                var inputFileFlag = false;
                var strHtml = "";// 附加上传按钮和提示信息

                if ($("#" + thisID + "_wraper").size() === 0) {
                    if($this.prop("tagName").toLowerCase() === "input" && $this.prop("type").toLowerCase() === "file") {
                        inputFileFlag = true;

                        strHtml += "<div id='" + thisID + "_button'";
                        strHtml += " style='width:"+ ($.isNumeric(settings.width) ? (settings.width + "px") : settings.width) +";height:"+ ($.isNumeric(settings.height) ? (settings.height + "px") : settings.height) +";'";
                        if (settings.buttonClass) {
                            strHtml += " class='" + settings.buttonClass + "'";
                        }
                        strHtml += "><span>"+ settings.buttonText +"</span>";
                        strHtml += "</div>";
                    }
                    //显示上传文件列表
                    if (!settings.queueID) {
                        strHtml += "<div id='" + thisID + "_queue'></div>";
                    }

                    if (inputFileFlag) {
                        $this.hide().wrap("<div id='" + thisID + "_wraper'/>").after(strHtml);
                    } else {
                        $this.after("<div id='" + thisID + "_wraper'/>").next().append(strHtml);
                    }
                }
                
                var mime_types;
                if (settings.fileTypeDesc && settings.fileTypeExts) {
                    mime_types = [
                        {title:settings.fileTypeDesc, extensions:settings.fileTypeExts.replace(/\*|\.|\ /g, "").replace(/\;/g, ",")}
                    ];
                }

                pluploader = new plupload.Uploader({
                    //runtimes:"html5,flash,silverlight,html4",
                    runtimes: settings.runtimes,
                    browse_button: (inputFileFlag ? thisID + "_button" : thisID),
                    url: settings.uploader,
                    flash_swf_url: '/newplugins/js/plupload-2.1.8/js/Moxie.swf',
                    silverlight_xap_url: '/newplugins/js/plupload-2.1.8/js/Moxie.xap',
                    file_data_name: "Filedata",//todo...
                    multi_selection: settings.multi,
                    multipart_params: settings.formData,
                    // General settings
                    //unique_names : true,
                    // Resize images on client-side if we can
                    filters: {
                        //max_file_size : singleLimitSize + "KB",
                        // Specify what files to browse for
                        mime_types: mime_types,
                        prevent_duplicates: true
                    },
                    preinit: {
                        //初始化处理函数
                        Init: function(uploader, info) {
                            settings.onInit.call($this, uploader, info);
                        }
                    },
                    init: {
                        //文件通过过滤器后触发
                        FileFiltered: function(uploader, file) {
                            settings.onSelect.call($this, file);
                        },
                        //文件开始上传时触发
                        UploadFile: function(uploader,file) {
                            settings.onUploadStart.call($this, file);
                        },
                        //单个文件上传结束触发
                        FileUploaded: function(uploader, file, responseObject){
                            //每个文件上传完成后，移除取消上传按钮
                            //$("#" + file.id).children('.delete-file').remove();
                            if (settings.removeCompleted) {
                                    if (settings.removeTimeout > 0) {
                                        window.setTimeout(function(){
                                            uploader.removeFile(file);
                                        }, settings.removeTimeout * 1000);
                                    } else {
                                        uploader.removeFile(file);
                                    }
                                }
                            settings.onUploadSuccess.call($this, file, responseObject.response, responseObject);
                        },
                        UploadComplete: function(uploader, files){
                            //移除取消上传按钮                            
                            settings.onQueueComplete.call($this, files);
                        },
                        UploadProgress: function(uploader, file) {
                            //文件上传进度
                            //$("#" + file.id).children(".process").html(file.percent + "%");
                            settings.onUploadProgress.call($this, file, file.percent, plupload.percent);
                        },
                        FilesAdded: function(uploader, files) {
                            var strArray = ['·', '\'', '—', '#', '%'],
                                len = strArray.length,
                                arrErrorFiles = [],
                                i;

                            //检查文件名是否合法
                            $.each(files, function(index ,file){
                                for (i = 0; i < len; i++) {
                                    if (file.name.indexOf(strArray[i]) != -1) {
                                        arrErrorFiles.push(file);
                                        files.splice($.inArray(file, files), 1);
                                        break;
                                    }
                                }
                            });

                            //移除文件名不合法的文件
                            if(arrErrorFiles.length > 0) {
                                for (i =0, len = arrErrorFiles.length; i < len; i++) {
                                    uploader.removeFile(arrErrorFiles[i]);
                                }
                                //提示错误信息
                                /*$.pnotify({
                                    text: UploadifyLang.fileNameIllegal,
                                    type: "error"
                                });*/
                                
                            }

                            //显示准备上传的文件
                            if ($.isFunction(settings.itemTemplate)) {
                                var strFileQueue = "";
                                $.each(files, function(index, file){
                                    strFileQueue += settings.itemTemplate(file);
                                });
                                $("#" + (settings.queueID || thisID + "_queue")).append(strFileQueue);
                            }

                            //自动上传的场合
                            if (settings.auto) {
                                uploader.start();
                            }
                            //选择文件窗口关闭事件
                            settings.onDialogClose.call($this);
                        }
                    }
                });

                //在实例对象上调用init()方法进行初始化
                pluploader.init();

                /*$("#" + thisID + "_wraper").delegate('.items .delete-file', 'click', function(event) {
                    //取消上传按钮按下时，移除该文件
                    pluploader.removeFile(pluploader.getFile($(this).parent().attr("id")));
                    $(this).parent().remove();
                })
                .delegate('.items', 'mouseenter', function(event) {
                    $(this).children('.delete-file').css("visibility", "visible");
                })
                .delegate('.items', 'mouseleave', function(event) {
                    $(this).children('.delete-file').css("visibility", "hidden");
                });*/

                //保存默认配置
                $this.data("uploadSettings", settings);
                $this.data("uploader", pluploader);
            });
        },
        settings: function(option, value) {
            var $this = $(this);
            var settings = $this.data("uploadSettings");
            var pluploader = $this.data("uploader");
            $.extend(settings, option);
            if (typeof option === "String") {
                switch(option) {
                    case "formData":
                        pluploader.setOption("multipart_params", value);
                        break;
                    default:
                        break;
                }
            } 
            //保存配置
            $this.data("uploadSettings", settings);
            $this.data("uploader", pluploader);
            
        },
        //开始上传文件
        upload: function(fileId){
            var uploader = $(this).data("uploader");
            if (uploader) {
                uploader.start();
            }
        },
        //取消上传文件
        cancel: function(fileId) {
            var uploader = $(this).data("uploader");
            if (uploader) {
                if (fileId === "*") {
                    var settings = $(this).data("uploadSettings");
                    var fileCount = uploader.files.length;
                    /*$.each(uploader.files, function(i, file){
                        uploader.removeFile(file);
                    });*/
                    uploader.splice(); //清除所有文件
                    var settings = $(this).data("uploadSettings");
                    if (settings) {
                        settings.onClearQueue.call(this, fileCount);
                    }
                } else {
                    uploader.removeFile(fileId);
                }
            }
        },
        //销毁plupload实例
        destroy: function(fileId) {
            var uploader = $(this).data("uploader");
            if (uploader) {
                uploader.destroy();
                $(this).removeData("uploader")
            }
        },
        refresh: function() {
            var uploader = $(this).data("uploader");
            if (uploader) {
                uploader.refresh();
            }
        }
    };
    $.fn.uploadify = function(method) {
        if (methods[method]){
            return methods[method].apply(this, Array.prototype.slice.call(arguments, 1));
        } else if (typeof method === 'object' || !method) {
            return methods.init.apply(this, arguments);
        } else {
            $.error('Method ' + method + ' does not exist on $.uploadify');
        }
    }
})(jQuery);
