(function($) {
	$.fn.extend({
		LazyBatchCreate : function(settings) {

			//默认参数
			$.LazyBatchCreate = {
				settings : {
					initialNumber : 5, //初始化数量
					createNumberOnce : 1, //添加数量
					caption : "", //标题
					wrap : false, //是否包裹
					showSequenceNumber : true, //是否显示序号
					autoCreate : true, //是否自动创建最后一行
					showColorTip : true, //是否显示颜色提示信息
					buttons : {
						initialize : true, //是否显示初始化按钮
						create : true, //是否显示添加按钮
						remove : true, //是否显示删除按钮
						toggle : true, //是否显示隐藏、显示按钮
						singleRemove : true, //是否显示单个删除按钮
						close : true //关闭批量新建
					}
				}
			}

			//合并默认参数
			settings = $.extend(true, $.LazyBatchCreate.settings, settings);

			//保存列宽
			var widthInfor = new Array();

			function LazyBatchCreateCallback() {
				$("#lazybatchcreate").find("#content").children("table").find("thead>tr>td").each(function() {
					widthInfor.push($(this).width());
				});
			}

			return this.each(function() {
				//检查参数合法性
				if (!settings.param) {
					alert("Miss Param");
					return;
				}
				try {
					var self = $(this);
					var lazyBatchCreateWrapHtml = '<table border="0" id="lazybatchcreate"><tr><td id="caption"></td></tr><tr"><td><table width="100%" border="0" cellpadding="0" cellspacing="0"><tr><td><table><tr id="topbar"><td><span style="width:110px;color:red;display:none;z-index:99999;" id="checkTip">&nbsp;&nbsp;'+LazyGridLang.ErrorInput+'</span></td></tr></table></td><td align="right" class="closeWrap"></td></tr></table></td></tr><tr><td id="content"></td></tr></table>';

					//包裹九宫格
					if (settings.wrap) {
						var wrapHtml = new Array();
						wrapHtml.push('<table border="0" cellpadding="0" cellspacing="0" width="100%">');

						//当设置了标题时，包裹30px高度的九宫格
						if (settings.caption) {
							wrapHtml.push('<tr height="30">');
							wrapHtml.push('<td>' + settings.caption + '</td>');
						} else {
							wrapHtml.push('<tr height="10">');
						}

						wrapHtml.push('</tr>');
						wrapHtml.push('<tr>');
						wrapHtml.push('<td valign="top" id="lazybatchcreatewrap"></td>');
						wrapHtml.push('</tr>');
						wrapHtml.push('</table>');
						self.html(wrapHtml.join(''));
						$("#lazybatchcreatewrap").html(lazyBatchCreateWrapHtml);

					} else {
						self.html(lazyBatchCreateWrapHtml);
						$("#lazybatchcreate").find("#caption").html(settings.caption);
					}
					//颜色表示提示
					if (settings.showColorTip) {
						$("#lazybatchcreate").find("#topbar").prepend("<td id='colorTip' align='right'>&nbsp;&nbsp;&nbsp;<img src='/images/8/icons/batchcreate/require.png'/><span style='margin-left:5px;color:#6189D6;'>" + BatchCreateLang.Required + "</span>&nbsp;&nbsp;&nbsp;<img src='/images/8/icons/batchcreate/repeat.png'/><span style='margin-left:5px;color:#6189D6;'>" + BatchCreateLang.Repeat + "</span></td>");
					}

					//工具栏按钮

					if (settings.buttons.initialize) {
						$("#lazybatchcreate").find("#topbar").prepend("<td><a class='btn btn-primary' id='initial'>" + BatchCreateLang.Initial + "</a></td>");
					}

					if (settings.buttons.remove) {
						$("#lazybatchcreate").find("#topbar").prepend("<td style='padding-right:20px'><a class='btn btn-danger' id='remove'>" + BatchCreateLang.Delete + "</a></td>");
					}

					if (settings.buttons.create) {
						$("#lazybatchcreate").find("#topbar").prepend("<td><a class='btn btn-success' id='create'>" + BatchCreateLang.Create + "</a></td>");
					}

					//关闭按钮
					if (settings.buttons.close) {
						$("#lazybatchcreate").find(".closeWrap").html("<img id='close' style='cursor:pointer;' title='" + BatchCreateLang.Close + "' src='/images/8/icons/batchcreate/remove.png'/>");
					}
					var thead = "";
					var tbody_tr = "";

					//序号
					if (settings.showSequenceNumber) {
						thead += "<td width='40px' align='center'>" + BatchCreateLang.SequenceNumber + "</td>";
					}

					$.each(settings.param, function(index, value) {

						var widthStr = "";
						if (value.css && value.css.width) {
							widthStr = "width=" + value.css.width;
						}

						thead += "<td " + widthStr + ">" + value.name + "</td>";
						switch(value.type) {
							case "text":
							case "password":
								var cssStr = "";
								if (value.css) {
									$.each(value.css, function(cssIndex, cssValue) {
										cssStr += cssIndex + ":" + cssValue + ";";
									});
								}

								tbody_tr += "<td><input style='" + cssStr + "'";

								if (value.validation) {
									if ($.inArray("require", value.validation) != -1) {
										tbody_tr += " require='true' ";
									}
									if ($.inArray("repeat", value.validation) != -1) {
										tbody_tr += " repeat='true' ";
									}
								}

								if (value.check) {
									tbody_tr += " check='true' ";
								}

								if (value.attribute) {
									$.each(value.attribute, function(index, value) {
										tbody_tr += " " + index + "='" + value + "'";
									});
								}
								tbody_tr += " type='" + value.type + "' name='" + value.field + "[]'/></td>";
								break;
							case "select":
								tbody_tr += "<td><select name='" + value.field + "[]'>";
								$.each(value.source, function(index, value) {
									tbody_tr += "<option value='" + value.value + "'>" + value.data + "</option>";
								})
								tbody_tr += "</select></td>";
								break
						}
					});
					//单个删除按钮
					if (settings.buttons.singleRemove) {
						tbody_tr += "<td width='40px' align='center'><a href='#' class='single-remove'><i class='fa fa-trash-o fa-lg text-danger'></i></a></td>";
					}

					//初始化
					var tbody = "";
					for (var i = 0; i < settings.initialNumber; i++) {
						tbody += "<tr><td width='40px' align='center'><div class='sequence-number'>" + (i + 1) + "</div></td>" + tbody_tr + "</tr>";
					}

					//单个删除按钮的表头
					if (settings.buttons.singleRemove) {
						thead += "<td width='80px' align='center'>" + BatchCreateLang.Delete + "</td>";
					}

					//显示、隐藏按钮
					if (settings.buttons.toggle) {
						thead += "<td width='25px' align='center'><img src='/images/8/icons/batchcreate/toggle-hide.png' border='0' class='toggle' style='margin-top:5px;cursor:pointer;'/></td>";
					}

					//生成批量新建内容
					$("#lazybatchcreate").find("#content").html("<table border='0' cellpadding='0' cellspacing='0'><thead><tr>" + thead + "</tr></thead><tbody>" + tbody + "</tbody></table>");

					//美化表格
					
					//显示、隐藏按钮
					$("#lazybatchcreate .toggle").click(function() {
						$(this).attr("src", function() {
							var src = $(this).attr("src");
							if (src.substring(src.length - 8) == "hide.png") {
								return "/images/8/icons/batchcreate/toggle-show.png";
							} else {
								return "/images/8/icons/batchcreate/toggle-hide.png";
							}
						});
						$("#lazybatchcreate").find("#content").find("tbody").toggle();
						SetWidth(widthInfor);
					});
					//关闭
					$("#close").live('click', function() {
						if (confirm(BatchCreateLang.ConfirmMsg3)) {
							self.empty();
						}
					});
					//单个删除
					$(".single-remove").live('click', function() {
						//若当前行的文本框有内容或者下拉框的选中索引不是0，则提示确认删除信息框
						if ($(this).parent().parent("tr").find(":text,:password").filter(function() {
							return $.trim($(this).val()) != ""
						}).length != 0) {
							if (confirm(BatchCreateLang.ConfirmMsg1)) {
								$(this).parent().parent("tr").remove();
								if (settings.showSequenceNumber) {
									RestartSorting();
								}
								SetWidth(widthInfor);
							}
						} else {
							$(this).parent().parent("tr").remove();
							if (settings.showSequenceNumber) {
								RestartSorting();
							}
							SetWidth(widthInfor);
						}
						return false;
					});
					//删除
					$("#remove").click(function() {
						//若最后一行的文本框有内容，则提示确认删除信息框
						if ($("#lazybatchcreate").find("#content").children("table").find("tbody>tr").last().find(":text").filter(function() {
							return $.trim($(this).val()) != ""
						}).length != 0) {
							if (confirm(BatchCreateLang.ConfirmMsg2)) {
								$("#lazybatchcreate").find("#content").children("table").find("tbody>tr").last().remove();
							}
						} else {
							$("#lazybatchcreate").find("#content").children("table").find("tbody>tr").last().remove();
						}
						SetWidth(widthInfor);
					});
					//添加
					$("#create").click(function() {
						for (var i = 0; i < settings.createNumberOnce; i++) {
							var lastNumber = $("#lazybatchcreate").find("#content").children("table").find("tbody>tr").length;
							if ($("#lazybatchcreate").find("#content").children("table").find("tbody>tr").last().length == 0) {
								$("#lazybatchcreate").find("#content").children("table").find("tbody").append("<tr height='27px'><td width='40px' align='center'><div class='sequence-number'>" + (lastNumber + 1) + "</div></td>" + tbody_tr + "</tr>");
							} else {
								$("#lazybatchcreate").find("#content").children("table").find("tbody>tr").last().after("<tr height='27px'><td width='40px' align='center'><div class='sequence-number'>" + (lastNumber + 1) + "</div></td>" + tbody_tr + "</tr>");
							}
						}
					});
					//初始化
					$("#initial").click(function() {
						if (confirm(BatchCreateLang.InitialMsg1 + settings.initialNumber + BatchCreateLang.InitialMsg2)) {
							if ($("#lazybatchcreate").find("#content").find("tbody").css("display") == "none") {
								$("#lazybatchcreate").find("#content").find("tbody").show();
								$("#lazybatchcreate .toggle").attr("src", "/images/8/icons/batchcreate/toggle-hide.png");
							}
							var tbody = "";
							for (var i = 0; i < settings.initialNumber; i++) {
								tbody += "<tr><td width='40px' align='center'><div class='sequence-number'>" + (i + 1) + "</div></td>" + tbody_tr + "</tr>";
							}
							$("#lazybatchcreate").find("#content").children("table").find("tbody").html(tbody);
						}
					});
					//自动创建新行
					if (settings.autoCreate) {
						$("#lazybatchcreate").find(":text").live('focus', function() {
							if ($(this).parents("tr").first().next("tr").length == 0) {
								var lastNumber = $("#lazybatchcreate").find("#content").children("table").find("tbody>tr").length;
								$("#lazybatchcreate").find("#content").children("table").find("tbody>tr").last().after("<tr height='27px'><td width='40px' align='center'><div class='sequence-number'>" + (lastNumber + 1) + "</div></td>" + tbody_tr + "</tr>");
							}
						});
					}
					//重新编号
					function RestartSorting() {
						$("#lazybatchcreate").find("#content").children("table").find("tbody>tr").each(function(index) {
							$(this).children().find(".sequence-number").html((index + 1));
						});
					}

					//保持列宽
					function SetWidth(widthInfor) {
						$("#lazybatchcreate").find("#content").children("table").find("thead>tr>td").each(function(index) {
							$(this).width(widthInfor[index]);
						});
					}

					//检查特殊字符
					$("#lazybatchcreate").find(":text[check='true']").live('keyup', function(event) {
						var value = $.trim($(this).val());
						var reg = /[^a-zA-Z0-9\u4e00-\u9fa5]+/g;

						if (reg.test(value)) {
							$(this).val(value.replace(reg, ""));
							$("#checkTip").show().fadeOut(1500);
							return false;
						}
					});

					$("#lazybatchcreate").find(":text[require='true']").live('keyup', function() {
						if ($.trim($(this).val()) != "") {
							$(this).parent("div").addClass(function(index, currentClass) {
								$(this).removeClass();
								var lastIndex = currentClass.lastIndexOf('-');
								return currentClass.replace(currentClass.substring(lastIndex + 1), "normal");
							});
						}

					});
					//验证重复
					$("#lazybatchcreate").find(":text[repeat='true']").live({
						keyup : function() {
							var obj = $(this);
							var inputValue = $.trim($(this).val());

							//获取当前text所在的td索引
							var tdIndex = $(this).parents("td:first").prevAll("td").length;

							//获取当前text所在的tr索引
							var trIndex = $(this).parents("tr:first").prevAll("tr").length;

							$("#lazybatchcreate").find("#content").children("table").find("tbody tr").each(function(index, value) {
								if (index != trIndex) {
									var myValue = $.trim($(this).find("td:eq(" + tdIndex + ")").find(":text").val());
									if (myValue != "" && myValue == inputValue) {
										$(this).find("td:eq(" + tdIndex + ")").find(":text").parent("div").addClass(function(index, currentClass) {
											$(this).removeClass();
											var lastIndex = currentClass.lastIndexOf('-');
											return currentClass.replace(currentClass.substring(lastIndex + 1), "repeat");
										});

										obj.parent("div").addClass(function(index, currentClass) {
											$(this).removeClass();
											var lastIndex = currentClass.lastIndexOf('-');
											return currentClass.replace(currentClass.substring(lastIndex + 1), "repeat");
										})
									} else {
										$(this).find("td:eq(" + tdIndex + ")").find(":text").parent("div").addClass(function(index, currentClass) {
											$(this).removeClass();
											var lastIndex = currentClass.lastIndexOf('-');
											if (currentClass.substring(lastIndex + 1) == "repeat") {
												return currentClass.replace(currentClass.substring(lastIndex + 1), "normal");
											} else {
												return currentClass;
											}
										});
									}
								}
							});
						},
						contextmenu : function() {
							return false;
						}
					});
				} catch(error) {
					alert(error);
				}
			});
		},
		CheckRequire : function() {//验证必填
			var require = 0;
			$("#lazybatchcreate").find(":text[require='true'],:password[require='true']").filter(function() {
				if ($.trim($(this).val()) == "") {
					var prevflag = $(this).parents("td:first").nextAll("td").find(":text").filter(function() {
						return $.trim($(this).val()) != ""
					}).length;
					var nextflag = $(this).parents("td:first").prevAll("td").find(":text").filter(function() {
						return $.trim($(this).val()) != ""
					}).length;
					if (prevflag != 0 || nextflag != 0) {
						require++;
						$(this).parent("div").addClass(function(index, currentClass) {
							$(this).removeClass();
							var lastIndex = currentClass.lastIndexOf('-');
							return currentClass.replace(currentClass.substring(lastIndex + 1), "require");
						});
					} else {
						$(this).parent("div").addClass(function(index, currentClass) {
							$(this).removeClass();
							var lastIndex = currentClass.lastIndexOf('-');
							if (currentClass.substring(lastIndex + 1) == "require") {
								return currentClass.replace(currentClass.substring(lastIndex + 1), "normal");
							} else {
								return currentClass;
							}
						});
					}
				} else {
					$(this).parent("div").addClass(function(index, currentClass) {
						$(this).removeClass();
						var lastIndex = currentClass.lastIndexOf('-');
						if (currentClass.substring(lastIndex + 1) == "require") {
							return currentClass.replace(currentClass.substring(lastIndex + 1), "normal");
						} else {
							return currentClass;
						}
					});
				}
			});
			if (require == 0) {
				return true;
			} else {
				return false;
			}
		},
		CheckRepeat : function(url) {//验证重复
			if (url) {
				$.ajax({
					type : "POST",
					url : url,
					data : $("#lazybatchcreate").find(':input').serializeArray(),
					async : false,
					success : function(result) {
						if (result != true) {
							var parsedData = $.parseJSON(result);
							$.each(parsedData, function(index, value) {
								$.each(value, function(newIndex, newValue) {
									$("#lazybatchcreate").find(":text[repeat='true'][name='" + index + "[]']").eq(newValue).parent("div").addClass(function(index, currentClass) {
										$(this).removeClass();
										var lastIndex = currentClass.lastIndexOf('-');
										return currentClass.replace(currentClass.substring(lastIndex + 1), "repeat");
									});
								});
							});
						}
					}
				});
			}

			$("#lazybatchcreate").find(":text[repeat='true']").each(function() {
				var inputValue = $(this).val();
				var tdIndex = $(this).parents("td:first").prevAll("td").length;
				var trIndex = $(this).parents("tr:first").prevAll("tr").length;
				$("#lazybatchcreate").find("#content tbody tr").each(function(index, value) {
					var myValue = $.trim($(this).find("td:eq(" + tdIndex + ")").find(":text").val());
					if (myValue != "" && myValue == inputValue && index != trIndex) {
						$(this).find("td:eq(" + tdIndex + ")").find(":text").parent("div").addClass(function(index, currentClass) {
							$(this).removeClass();
							var lastIndex = currentClass.lastIndexOf('-');
							return currentClass.replace(currentClass.substring(lastIndex + 1), "repeat");
						});
					}
				});
			});
			var $repeatResult = $("#lazybatchcreate").find(":text[repeat='true']").filter(function() {
				return $(this).parent("div").attr("class").indexOf("repeat") != -1;
			});
			if ($repeatResult.length == 0) {
				return true;
			} else {
				return false;
			}

		}
	});
})(jQuery)
