(function($) {

	$.fn.extend({
		LazyBeautifyForm : function(settings) {
			$.LazyBeautifyForm = {
				LazyBeautifyText : {
					size : 21,
					type : "normal"
				},
				LazyBeautifySelect : {
					width : "auto",
					maxHeight : 200,
					title : false
				}
			};

			var settings = $.extend(true, $.LazyBeautifyForm, settings);
			return this.each(function() {
				if ($(this).is(":text,:password")) {
					$(this).LazyBeautifyText(settings.LazyBeautifyText);
				} else if ($(this).is(":checkbox")) {
					$(this).LazyBeautifyCheckBox();
				} else if ($(this).is(":button,:submit,:reset,a[type=button],a[class=button]")) {
					$(this).LazyBeautifyButton();
				} else if ($(this).is(":radio")) {
					$(this).LazyBeautifyRadio();
				} else if ($(this).is("textarea")) {
					$(this).LazyBeautifyTextArea();
				} else if ($(this).is("select")) {
					$(this).LazyBeautifySelect(settings.LazyBeautifySelect);
				} else {
					$(this).find(":text,:password").LazyBeautifyText(settings.LazyBeautifyText);
					$(this).find(":checkbox").LazyBeautifyCheckBox();
					$(this).find(":button,:submit,:reset,a[type=button],a[class=button]").LazyBeautifyButton();
					$(this).find(":radio").LazyBeautifyRadio();
					$(this).find("textarea").LazyBeautifyTextArea();
					$(this).find("select").LazyBeautifySelect(settings.LazyBeautifySelect);
				}
			});
		},
		/***************************
		 Text Field
		 ***************************/
		LazyBeautifyText : function(settings) {
			$.LazyBeautifyText = {
				settings : {
					size : 21,
					type : "normal"
				}
			};

			var settings = $.extend($.LazyBeautifyText.settings, settings);
			return this.each(function() {
				var self = $(this);
				if (self.attr("unformat")) {
					return;
				}
				var type;
				if (self.attr("disabled") || self.attr("readonly")) {
					type = "disabled";
				} else {
					type = self.attr("beautify-type") ? self.attr("beautify-type") : settings.type;
				}

				if (type == "disabled" && !self.attr("disabled")) {
					self.attr("readonly", "true");
				}

				self.attr("lazybeautifyform", "ok").css({
					border : "1px solid #cccccc",
					lineHeight : settings.size + "px"
				}).height(settings.size);

				//处理验证

				if (self.attr("validation")) {
					var validation = self.attr("validation");

					//解析验证数据结构 validation="{require:true,warn:'aa'}"
					var cre = /({.*})/;
					var execResult = cre.exec(validation);
					if (execResult) {
						var data = execResult[1];
						data = eval("(" + data + ")");
						if (data.require) {
							var $warnImg;
							if (data.warn) {
								if ($("#" + data.warn).length == 0) {
									$warnImg = $("<img style='margin:2px 0 0 2px;' src='" + data.warn + "' border='0'/>");
								}
							} else {
								$warnImg = $("<img style='margin:2px 0 0 2px;' src='" + data.theme + "/images/icon/warning.gif' border='0'/>");
							}

							if ($warnImg) {
								$warnImg.insertAfter(self.parent());
							}

							CheckValue();

							function CheckValue() {
								if ($.trim(self.val()) == "") {
									($warnImg || $("#" + data.warn)).show();
									self.data("validationResult", false);
								} else {
									($warnImg || $("#" + data.warn)).hide();
									self.data("validationResult", true);
								}
							}

							//绑定事件
							self.blur(function() {
								CheckValue();
							}).keyup(function() {
								CheckValue();
							});
						}
					} else {
						alert("validation error");
					}

				}
			});
		},
		/***************************
		 CheckBox
		 ***************************/
		LazyBeautifyCheckBox : function() {
			return this.each(function() {

			});
		},
		/***************************
		 Button
		 ***************************/
		LazyBeautifyButton : function(settings) {
			return this.each(function() {
				$(this).addClass("lazybeautifybutton-normal").hover(function() {
					$(this).addClass("hover");
				}, function() {
					$(this).removeClass("hover");
				});
			});
		},
		/***************************
		 Radio
		 ***************************/
		LazyBeautifyRadio : function() {
			return this.each(function() {
				var self = $(this);
				if (self.attr("unformat")) {
					return;
				}

				if (self.css("display") == "none") {
					if (self.parent(".lazybeautifyradioWrapper").length > 0)
						self.removeClass("lazybeautifyformhide").prev("a").remove().end().unwrap(".lazybeautifyradioWrapper");
					return;
				}

				if (self.hasClass('lazybeautifyformhide')) {
					self.removeClass("lazybeautifyformhide").prev("a").remove().end().unwrap(".lazybeautifyradioWrapper");
				}
				var inputSelf = this;
				var aLink = $('<a href="#" class="lazybeautifyradio" rel="' + this.name + '"></a>');
				self.addClass('lazybeautifyformhide').wrap('<span class="lazybeautifyradioWrapper"></span>').parent().prepend(aLink);

				self.change(function() {
					inputSelf.checked && aLink.addClass('lazybeautifyradiochecked') || aLink.removeClass('lazybeautifyradiochecked');
					return true;
				});

				aLink.click(function() {
					if (self.attr('disabled')) {
						return false;
					}
					self.trigger('click').trigger('change');

					$('input[name="' + self.attr('name') + '"]', inputSelf.form).not(self).each(function() {
						$(this).attr('type') == 'radio' && $(this).trigger('change');
					});
					return false;
				});
				if (inputSelf.checked) {
					self.attr('disabled') ? aLink.addClass('lazybeautifyradiocheckeddisabled') : aLink.addClass('lazybeautifyradiochecked');
				} else {
					self.attr('disabled') ? aLink.addClass('lazybeautifyradiodisabled') : aLink.addClass('lazybeautifyradio');
				}
			});
		},
		/***************************
		 TextArea
		 ***************************/
		LazyBeautifyTextArea : function() {
			return this.each(function() {
				var self = $(this);
				if (self.attr("unformat") || self.css("display") == "none" || self.attr("lazybeautifyform") == "ok") {
					return;
				}

				self.css("border", "none");
				var className = "lazybeautifytextarea";
				if (self.attr("readonly") || self.attr("disabled")) {
					className = "lazybeautifytextareadisabled";
				}

				var tableStr = "<table 	 cellspacing='0' cellpadding='0' border='0' class='" + className + "'>";
				tableStr += "<tr height='7px'>";
				tableStr += "<td class='topleft' width='7px'></td><td class='topcenter'></td><td class='topright' width='7px'></td>";
				tableStr += "</tr>";
				tableStr += "<tr>";
				tableStr += "<td class='middleleft' width='7px'></td><td class='middlecenter'>" + self.attr("lazybeautifyform", "ok").html(self.clone()).html() + "</td><td class='middleright' width='7px'></td>";
				tableStr += "</tr>";
				tableStr += "<tr height='7px'>";
				tableStr += "<td class='bottomleft' width='7px'></td><td class='bottomcenter'></td><td class='bottomright' width='7px'></td>";
				tableStr += "</tr>";
				tableStr += "</table>";
				self.replaceWith(tableStr);
			});
		},
		/***************************
		 Select
		 ***************************/
		LazyBeautifySelect : function(settings) {
			$.LazyBeautifySelect = {
				settings : {
					width : "auto",
					maxHeight : 200,
					title : false
				}
			};

			var settings = $.extend($.LazyBeautifySelect.settings, settings);

			return this.each(function() {
				var self = $(this);
				if (self.attr("unformat")) {
					return;
				}

				var wrapClass = self.attr("disabled") ? "lazybeautifyselectdisabled" : "lazybeautifyselect";

				if (self.css("display") == "none") {
					if (self.parent("." + wrapClass).length > 0)
						self.removeClass("lazybeautifyformhide").siblings().remove().end().unwrap("." + wrapClass);
					return;
				}

				if (self.hasClass("lazybeautifyformhide")) {
					self.siblings().remove().end().unwrap("." + wrapClass);
				}

				self.addClass("lazybeautifyformhide").wrap("<div class='" + wrapClass + "'></div>");
				var width = self.attr("width") ? self.attr("width") : settings.width;
				if (width == "auto") {
					width = self.width() + 36;
				}

				var myMaxHeight = self.attr("maxHeight") ? self.attr("maxHeight") : settings.maxHeight;
				var selfParent = self.parent("." + wrapClass);
				var title = settings.title ? settings.title : "";
				selfParent.append("<div class='left'></div><div class='center' style='text-overflow:ellipsis;white-space:nowrap;overflow:hidden;'>" + title + "</div><div class='right'></div><div class='optionwrap'></div>");

				var optionStr = "";
				self.find("option").each(function() {
					if ($(this).attr("img")) {
						optionStr += "<div class='option' value='" + $(this).attr("value") + "'><img align='absmiddle' class='" + self.attr("imgclass") + "' src='" + $(this).attr("img") + "' style='cursor:pointer;'/><span style='padding-left:5px;cursor:text;' class='center-html'>" + $(this).html() + "</span></div>";
					} else if ($(this).attr("split")) {
						optionStr += "<div style='padding:5px;'><div style='height:1px;border-bottom:1px solid #ccc;'></div></div>";
					} else {
						optionStr += "<div title='" + $(this).html() + "' style='text-overflow:ellipsis;white-space:nowrap;overflow:hidden;' class='option' value='" + $(this).attr("value") + "'>" + $(this).html() + "</div>";
					}
				});
				selfParent.children(".optionwrap").html(optionStr);

				selfParent.width(parseInt(width) + 2).children(".center").width(parseInt(width) - 36);

				if (!settings.title) {
					selfParent.children(".center").html(selfParent.children(".optionwrap").find(".option:eq(" + self.get(0).selectedIndex + ")").html());
				}
				selfParent.find(".center,.left,.right").click(function(event) {
					if (wrapClass == "lazybeautifyselectdisabled")
						return false;
					selfParent.children(".optionwrap").toggle().offset({
						top : selfParent.children(".center").offset().top + 21,
						left : selfParent.children(".center").offset().left - 2
					}).width(width).css("max-height", myMaxHeight);
				});

				selfParent.children(".optionwrap").children(".option").hover(function() {
					$(this).addClass("hover");
				}, function() {
					$(this).removeClass("hover");
				}).click(function() {
					if (!settings.title) {
						selfParent.children(".center").html($(this).html()).attr("title", $(this).text());
					}

					selfParent.children(".optionwrap").toggle();
					var selectOptionValue = $(this).attr("value");
					self.find("option").filter(function() {
						return $(this).attr("value") == selectOptionValue;
					}).attr('selected', 'selected');
					self.trigger("change");
				});

				$(document).click(function(event) {
					if (selfParent.children(".optionwrap").css("display") != "none" && event.target.className != "left" && event.target.className != "center" && event.target.className != "right") {
						selfParent.children(".optionwrap").toggle();
					}
				});
			});
		}
	});

})(jQuery);
