/*!
 * jQuery.LazyEmailAddress.js
 * 邮件地址栏插件
 */
(function($) {

	function CheckEmailAddress(emailAddress) {
		if(emailAddress.match(/\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*/)) {
			return true;
		} else {
			return false;
		}
	}

	function FormatAddress(emailAddObj, obj) {
		var emailAddress = emailAddObj.emailAddress ? emailAddObj.emailAddress : emailAddObj;
		var emailAddressForCheck = emailAddress;
		var search_extend_str = "";
		if(emailAddObj.extend){
			//生成<input>存放其他信息
			$.each(emailAddObj.extend, function(index, value){
				search_extend_str+= "<input class='address-extend' type='hidden' extend_value='"+value+"' extend_index='"+index+"' value=''>";
			});
			if(emailAddObj.extend.extend_name)
			{
				emailAddressForCheck = emailAddress;
				search_extend_str+= "<input class='address-extend-email' type='hidden' email='"+emailAddress+"' value=''>";
				emailAddress = emailAddObj.extend.extend_name;
			}
		}else{
			search_extend_str+= "<input class='address-extend-email' type='hidden' email='"+emailAddress+"' value=''>";
		}
		var title;
		var color;
		var background;
		var border;
		if(CheckEmailAddress(emailAddressForCheck)) {
			color = "#000000";
			title = emailAddressForCheck;
			background = "#F3F7FD";
			border = "#BBD8FB";
		} else {
			color = "#B55E5E";
			title = WebMailLang.AddressErrorAlert;
			background = "#FDF5F5";
			border = "#B55E5E";
		}

		obj.val("").before("<table cellpadding='0' cellspacing='0' class='address' style='height:28px;margin-right:2px;margin-top:1px;float:left;'><tr style='height:20px;'><td valign='middle' class='address-title' style='padding:0 3px 0 3px;border:1px solid " + border + ";color:" + color + ";border-right:none;background:" + background + ";cursor:default;' nowrap title='" + title + "'>" + emailAddress + "</td><td valign='middle' style='padding:0 3px 0 3px;border:1px solid " + border + ";border-left:none;background:" + background + ";'>"+search_extend_str+"<i title='"+WebMailLang.DeleteThisAddress+"' style='cursor:pointer;' class='fa fa-times-circle'></i></td></tr></table>");
	}

	function InArray(needle, haystack) {
		if( typeof needle == "string" || typeof needle == "number") {
			for(var i in haystack) {
				if(haystack[i] == needle) {
					return i;
				}
			}
		}
		return -1;
	}

	$.fn.extend({
		LazyWrap : function(html, target) {
			$(this).before(html);
			$(this).prev().find("." + target).append($(this));
			return this;
		},
		LazyEmailCheck : function() {
			var flag = true;
			var self = $(this);
			self.parents(".lazybeautifytextarea:first").find(".address").each(function() {
				if(!$(this).find(".address-extend-email").attr("email"))
					var emailaddress = $(this).find(".address-title").html();
				else
					var emailaddress = $(this).find(".address-extend-email").attr("email");
				if(!CheckEmailAddress(emailaddress)) {
					flag = false;
					return false;
				}
			});
			return flag;
		},
		LazyEmailCheckRepeat : function() {
			var self = $(this);
			var emailArray = new Array();
			var emailCount = new Array();
			self.parents(".lazybeautifytextarea:first").find(".address").each(function() {
				if(!$(this).find(".address-extend-email").attr("email"))
					var address = $(this).find(".address-title").html();
				else
					var address = $(this).find(".address-extend-email").attr("email");
				var index = InArray(address, emailArray);
				if(index != -1) {
					emailCount[index]++;
				} else {
					emailCount.push(1);
					emailArray.push(address);
				}
			});
			var repeatEmail = new Array();
			for(var i = 0; i < emailCount.length; i++) {
				if(emailCount[i] > 1) {
					repeatEmail.push(emailArray[i]);
				}
			}
			return repeatEmail;
		},
		LazyEmailResult : function() {
			var self = $(this);
			var emailArray = new Array();
			self.parents(".lazybeautifytextarea:first").find(".address").each(function() {
				if($(this).find(".address-extend").length)
				{
					var extendObj_son = {};
					$(this).find(".address-extend").each(function() {
						var extend_index = $(this).attr("extend_index");
						extendObj_son[extend_index] = $(this).attr("extend_value");
					});
					var extendObj_extend = {};
					if(!$(this).find(".address-extend-email").attr("email"))
						extendObj_extend.emailAddress = $(this).find(".address-title").html();
					else
						extendObj_extend.emailAddress = $(this).find(".address-extend-email").attr("email");
					extendObj_extend.extend = extendObj_son;
					emailArray.push(extendObj_extend);
				}else{
					emailArray.push($(this).find(".address-title").html());
				}
			});
			return emailArray;
		},
		LazyEmailAddress : function(settings) {
			return this.each(function() {
				var self = $(this);
				var table_id = "table_"+self.attr("id");
				if(!self.attr("unformat")) {
					self.attr("unformat", "true");
				}
				
				if (!self.data("isFormated")) {
					self.data("isFormated", "true").attr("maxLength", 40).css({
						'height' : '28px',
						"border" : "none",
						"ime-mode" : "disabled",
						"float" : "left",
						"overflow" : "visible",
						"line-height" : "25px",
						
					}).LazyWrap("<table cellspacing='0' cellpadding='0' border='0' class='lazybeautifytextarea' id='"+table_id+"'><tr><td class='middlecenter'></td></tr></table>", "middlecenter").wrap($("<div></div>").css({
						'border': '1px solid #ddd',
						'display': 'table-cell',
						"cursor" : "text",
						"width" : settings.width
					}));
				}
				
				// if (!self.data("isFormated")) {
					// self.data("isFormated", "true").attr("maxLength", 40).css({
						// "ime-mode" : "disabled",
						// "float" : "left",
						// "overflow" : "visible",
						// 'width':'480px'
					// });
				// }

				self.click(function() {
					self.focus();
				});
				if(settings.init) {
					for(var n in settings.init)
					{
						if(settings.init[n].emailAddress)
						{
							FormatAddress(settings.init[n], self);
						}
						else
						{
							var addressSplit = settings.init.emailAddress.split(";");
							for(var i = 0; i < addressSplit.length; i++) {
								if(addressSplit[i]!="")
									FormatAddress(addressSplit[i], self);
							}
						}
					}
				}

				$(".fa-times-circle").live({
					'click' : function() {
						$(this).parents(".address").remove();
						self.focus();
					}
				});

				self.keyup(function(event) {
					
					//分号
					if(event.keyCode == 59) {
						var inputValue = $.trim($(this).val()).slice(0, -1);
						if(inputValue != "") {
							FormatAddress(inputValue, self);
						}
						self.focus();
					}
				}).keydown(function(event) {
					
					//tab键、回车键
					if(event.keyCode == 9 || event.keyCode == 13) {
						var inputValue = $.trim($(this).val());
						if(inputValue != "") {
							FormatAddress(inputValue, self);
							self.focus();
							return false;
						}
					
					//backspace键
					}else if(event.keyCode == 8){
						if($.trim($(this).val()) == "" && $(this).prev(".address").length != 0) {
							$(this).prev(".address").remove();
							event.stopImmediatePropagation();
						}
						self.focus();
					}
				});
			})
		}
	});
})(jQuery);
