/*
 * LazyPinyinSearch
 * 拼音检索
 */
(function($) {

	/*
	 * 默认参数
	 */
	$.LazyPinyinSearchSettings = {
		defaultValue : "all",
		callback : false,
		_width : 0,
		indexParam : [{
			key : "A",
			value : "A"
		}, {
			key : "B",
			value : "B"
		}, {
			key : "C",
			value : "C"
		}, {
			key : "D",
			value : "D"
		}, {
			key : "E",
			value : "E"
		}, {
			key : "F",
			value : "F"
		}, {
			key : "G",
			value : "G"
		}, {
			key : "H",
			value : "H"
		}, {
			key : "I",
			value : "I"
		}, {
			key : "J",
			value : "J"
		}, {
			key : "K",
			value : "K"
		}, {
			key : "L",
			value : "L"
		}, {
			key : "M",
			value : "M"
		}, {
			key : "N",
			value : "N"
		}, {
			key : "O",
			value : "O"
		}, {
			key : "P",
			value : "P"
		}, {
			key : "Q",
			value : "Q"
		}, {
			key : "R",
			value : "R"
		}, {
			key : "S",
			value : "S"
		}, {
			key : "T",
			value : "T"
		}, {
			key : "U",
			value : "U"
		}, {
			key : "V",
			value : "V"
		}, {
			key : "W",
			value : "W"
		}, {
			key : "X",
			value : "X"
		}, {
			key : "Y",
			value : "Y"
		}, {
			key : "Z",
			value : "Z"
		}, {
			key : "#",
			value : "#"
		}, {
			key : "all",
			value : LazyGridLang.All
		}]
	}

	function getArrowHtml(type) {
		return "<div  type='" + type + "' id='move-" + type + "'><div class='move-border'></div><div class='move-center'></div><div class='move-arrow-" + type + "'></div><div class='move-center'></div><div class='move-border'></div></div>";
	}


	$.fn.extend({
		LazyPinYinSearch : function(settings) {

			//合并默认参数
			$.extend(true, $.LazyPinyinSearchSettings, settings);
			var self = $(this);

			//生成拼音检索
			var indexHtml = "";
			$.each($.LazyPinyinSearchSettings.indexParam, function(key, value) {
				indexHtml += "<div class='index' key='" + value.key + "'>" + value.value + "</div><div class='split'></div>";
			});
			var centerHtml = getArrowHtml("left") + "<div class='split'></div>" + indexHtml + "<div class='split'></div>" + getArrowHtml("right");
			var pinyinSearchHtml = "<div class='pinyinsearch'><div class='background'><div class='left'></div><div class='center'>" + centerHtml + "</div><div class='right'></div></div></div>";
			self.html(pinyinSearchHtml);
			
			//设置当前项
			self.find(".index[key='" + $.LazyPinyinSearchSettings.defaultValue + "']").removeClass("hover-center").addClass("selected-center").prev().removeClass("hover-border").addClass("selected-border").end().next().removeClass("hover-border").addClass("selected-border");
			//处理无法完整显示拼音检索的情况
			if($.LazyPinyinSearchSettings._width < 869 && self.find("#move-right").css("display") == "none" && self.find("#move-left").css("display") == "none") {
				self.data("moveCount", Math.floor(($.LazyPinyinSearchSettings._width - 4) / 31) - 2);
				self.find(".center").children().hide();

				var defaultValueIndex = self.find(".index[key='" + $.LazyPinyinSearchSettings.defaultValue + "']").prevAll(".index").length;

				if(defaultValueIndex >= parseInt(self.data("moveCount"))) {
					var count = parseInt(self.data("moveCount"));
					var totalCount = $.LazyPinyinSearchSettings.indexParam.length;
					var start = parseInt(defaultValueIndex / count) * count;
					if(start + count > totalCount) {
						self.data("moveStart", start);
						self.data("moveEnd", totalCount);
						self.find("#move-left").show();
						self.find(".index:gt(" + (start - 1) + "),.split:gt(" + (start - 1) + ")").show();
					} else {
						self.data("moveStart", start);

						self.find("#move-left").show();
						self.find("#move-right").show();
						var end = start + count;
						self.data("moveEnd", end);
						self.find(".index").filter(function(index) {
							return index >= start && index < end;
						}).show().prev(".split").show();
					}

				} else {
					self.find(".index:lt(" + parseInt(self.data("moveCount")) + "),.split:lt(" + parseInt(self.data("moveCount")) + ")").show();
					self.find("#move-right").show();
					self.data("moveStart", 0);
					self.data("moveEnd", self.data("moveCount"));
				}
			}

			self.find(".index").hover(function() {

				//如果是选中状态，则不显示划过效果
				if(!$(this).hasClass("selected-center")) {
					$(this).removeClass().addClass("hover-center").prev().removeClass().addClass("hover-border").end().next().removeClass().addClass("hover-border");
				}
			}, function() {
				var nextAddClassName = $(this).next().next().hasClass("selected-center") ? "selected-border" : "split";
				var prevAddClassName = $(this).prev().prev().hasClass("selected-center") ? "selected-border" : "split";
				$(this).removeClass("hover-center").addClass("index").prev(".hover-border").removeClass().addClass(prevAddClassName).end().next().removeClass("hover-border").addClass(nextAddClassName);
			});
			//右移箭头
			self.find("#move-right").die().live('click', function() {
				self.find(".center").children().hide();

				var endTemp = parseInt(self.data("moveEnd")) + parseInt(self.data("moveCount"));

				var endParam;

				if(endTemp > $.LazyPinyinSearchSettings.indexParam.length) {
					endParam = $.LazyPinyinSearchSettings.indexParam.length;
				} else {
					endParam = endTemp;
				}

				self.find(".index").filter(function(index) {
					return index >= parseInt(self.data("moveEnd")) && index < endParam;
				}).show().prev(".split").show();

				self.data("moveStart", self.data("moveEnd"));
				self.data("moveEnd", endParam);

				self.find("#move-left").show();
				if(endParam < $.LazyPinyinSearchSettings.indexParam.length) {
					self.find("#move-right").show();
				}

				return false;
			});
			//左移箭头
			self.find("#move-left").die().live('click', function() {
				self.find(".center").children().hide();

				var startTemp = parseInt(self.data("moveStart")) - parseInt(self.data("moveCount"));

				var startParam;

				if(startTemp <= 0) {
					startParam = 0;
				} else {
					startParam = startTemp;
				}

				self.find(".index").filter(function(index) {
					return index >= startParam && index < parseInt(self.data("moveStart"));
				}).show().prev(".split").show();

				self.data("moveEnd", self.data("moveStart"));
				self.data("moveStart", startParam);

				self.find("#move-right").show();
				if(startParam > 0) {
					self.find("#move-left").show();
				}
				return false;
			});
			//拼音检索选中效果
			self.find(".index").click(function() {
				//点击已选中的索引，不重复提交
				if($(this).hasClass("selected-center")) {
					return;
				}
				//移除已经选中的
				self.find(".index").filter(function() {
					return $(this).hasClass("selected-center");
				}).removeClass("selected-center").next().removeClass("selected-border").addClass("split").end().prev().removeClass("selected-border").addClass("split");

				//选中当前项
				$(this).removeClass("hover-center").addClass("selected-center").prev().removeClass("hover-border").addClass("selected-border").end().next().removeClass("hover-border").addClass("selected-border");

				/*
				 * 调用回调函数
				 * @param key
				 * @param value
				 */
				$.LazyPinyinSearchSettings.callback($(this).attr("key"), $(this).text());
			});
		}
	});
})(jQuery)