(function($) {
	$.LazyQuickSortSettings = {
		callback : false,
		width : 100,
		_limit : 0,
		source:''
	}

	$.fn.extend({

		LazyQuickSort : function(settings) {

			//合并默认参数
			$.extend($.LazyQuickSortSettings, settings);
			//计算最多显示多少字
			settings._limit = Math.floor(settings.width / 17);

			//定义我的查询工具栏
			var mySearchToolBar = "<a href='#' class='removeFromMySearch' title='" + LazyGridLang.RemoveFromMySearch + "'><img border='0' src='" + $.LazyQuickSortSettings.theme + "images/grid/quicksort/tack2.png'/></a><a href='#' class='edit' title='" + LazyGridLang.EditName + "'><img border='0' src='" + $.LazyQuickSortSettings.theme + "images/grid/quicksort/edit.png'/></a>";

			//定义最近查询工具栏
			var recentSearchToolBar = "<a href='#' class='addToMySearch' title='" + LazyGridLang.AddToMySearch + "'><img border='0' src='" + $.LazyQuickSortSettings.theme + "images/grid/quicksort/tack1.png'/></a>";

			//定义清空工具栏
			var emptyToolBar = "<a href='#' class='empty' title='" + LazyGridLang.Empty + "'><img border='0' src='" + $.LazyQuickSortSettings.theme + "images/grid/quicksort/empty.png'/></a>";

			return this.each(function() {
				var self = $(this);					
				if($.LazyQuickSortSettings.source == '') {
					//通过ajax请求快速筛选表中数据获取快速筛选
					$.ajax({
						type : 'POST',
						url : '/inc/plugins/jquery.lazyquicksort.php',
						data : 'type=init&mainID=' + $.LazyQuickSortSettings.mainID,
						success : function(result) {		
							parseData(result,self);
						}
					});
				} else {
					//读取传入的参数解析获取快速筛选
					parseData($.LazyQuickSortSettings.source,self);
				}

				$(".quicksort .title").live('click', function() {
					//确定下拉的宽度和位置
					var width = $(".quicksort .title .center").width() + 33;
					var left = $(".quicksort .title").offset().left;
					var top = $(".quicksort .title").offset().top + 25;
					$(".quicksort .content").toggle().width(width).offset({
						top : top,
						left : left
					});
					return false;
				});
				//下拉选项划过、单击
				$(".quicksort .option").live({
					//划过更改背景色
					"mouseover" : function() {
						$(this).addClass("hover");
						$(this).children("a").show();
						return false;
					},
					"mouseout" : function() {
						$(this).removeClass("hover");
						$(this).children("a").hide();
						return false;
					},
					//单击将当前选项的内容显示到Title中，并隐藏下拉
					"click" : function() {
						$(".quicksort .center").html($(this).text());
						$(".quicksort .content").toggle();
						$.LazyQuickSortSettings.callback($(this));
						return false;
					}
				});

				//组名划过显示清空
				$(".quicksort .group").live({
					"mouseover" : function() {
						$(this).children("a").show();
						return false;
					},
					"mouseout" : function() {
						$(this).children("a").hide();
						return false;
					}
				});

				//添加到我的查询
				$(".quicksort .addToMySearch").live('click', function(event) {
					var self = $(this);
					var $optionObj = $(this).parent(".option");
					var optionID = $optionObj.attr("optionid");
					var optionName = $optionObj.attr("optionname");
					var optionParam = $optionObj.attr("optionparam");

					$.ajax({
						type : 'POST',
						url : '/inc/plugins/jquery.lazyquicksort.php',
						data : 'type=addToMySearch&optionID=' + optionID,
						success : function(result) {
							if (result == 1) {

								//移除当前最近查询
								self.parent().remove();

								//判断是否有我的查询组名

								var mySearchObj = $(".quicksort .group").filter(function() {
									return $(this).text() == LazyGridLang.RecentSearch;
								});
								if ($(".quicksort .group").filter(function() {
									return $(this).text() == LazyGridLang.MySearch;
								}).length == 0) {
									mySearchObj.before("<div class='group'><span style='float:left;'>" + LazyGridLang.MySearch + "</span>" + emptyToolBar + "</div>");
								}
								mySearchObj.before($optionObj.attr("grouptype", 2).find("a").remove().end().append(mySearchToolBar));

								//如果是最有一条最近查询，移除最近查询组名
								if ($(".quicksort .option").filter(function() {
									return $(this).attr("grouptype") == "3";
								}).length == 0) {
									$(".quicksort .group").filter(function() {
										return $(this).text() == LazyGridLang.RecentSearch;
									}).remove();
								}
							} else {
								alert("Error");
							}
						}
					});
					return false;
				});
				//从我的查询中移除
				$(".quicksort .removeFromMySearch").live('click', function(event) {
					var self = $(this);

					$.ajax({
						type : 'POST',
						url : '/inc/plugins/jquery.lazyquicksort.php',
						data : 'type=removeFromMySearch&optionID=' + $(this).parent(".option").attr("optionid"),
						success : function(result) {
							if (result == 1) {
								self.parent().remove();
								if ($(".quicksort .option").filter(function() {
									return $(this).attr("grouptype") == "2";
								}).length == 0) {
									$(".quicksort .group").filter(function() {
										return $(this).text() == LazyGridLang.MySearch;
									}).remove();
								}
							} else {
								alert("Error");
							}
						}
					});
					return false;
				});
				//编辑
				$(".quicksort .edit").live('click', function(event) {
					var $optionObj = $(this).parent(".option");
					var content = $optionObj.attr("optionname");
					var optionID = $optionObj.attr("optionid");
					$("body").append('<table id="edittable" style="position:absolute;width:250px;display:none;z-index:999;" border="0" cellpadding="0" cellspacing="0">' + '<tr height="25">' + '<td width="10" class="tablecornertopleft"></td>' + '<td class="tablecornertopcenter"><span style="float:left;">' + LazyGridLang.Edit + '</span></td>' + '<td width="10" class="tablecornertoprightt"></td>' + '</tr>' + '<tr>' + '<td width="10" class="tablecornermiddleleft"></td>' + '<td class="tablecornermiddlecenter" valign="top">' + '<table style="width:100%;" border="0" cellpadding="0" cellspacing="0">' + '<tr><td><input type="text" style="width:230px;" value="' + content + '"/></td></tr>' + '<tr><td align="right"><table><tr><td><input type="button" class="save" optionID="' + optionID + '" value="' + LazyGridLang.Save + '"/></td><td><input type="button" class="close" value="' + LazyGridLang.Close + '"/></td></tr></table></td></tr>' + '</table>' + '</td>' + '<td width="10" class="tablecornermiddleright" ></td>' + '</tr>' + '<tr height="10">' + '<td width="10" class="tablecornerbottomleft"></td>' + '<td class="tablecornerbottomcenter"></td>' + '<td width="10" class="tablecornerbottomright" ></td>' + '</tr>' + '</table>');

					var top = $(this).offset().top;
					var left = $(this).offset().left;
					$("#edittable").show().offset({
						left : left,
						top : top
					}).find(":text").select();

					$("#edittable").find(":text,:button").LazyBeautifyForm();
					return false;
				});
				//编辑-关闭
				$("#edittable .close").live('click', function() {
					$("#edittable").remove();
					return false;
				});
				//编辑-保存
				$("#edittable .save").live('click', function() {
					var optionName = $("#edittable").find(":text").val();
					var optionID = $(this).attr("optionid");
					if ($.trim(optionName) == "") {
						alert(LazyGridLang.NameEmptyAlert);
					} else {
						$.ajax({
							type : 'POST',
							url : '/inc/plugins/jquery.lazyquicksort.php',
							data : 'type=save&optionID=' + optionID + '&optionName=' + optionName,
							success : function(result) {
								if (result == 1) {
									var subOptionName = optionName;
									if (optionName.length > settings._limit) {
										subOptionName = optionName.substring(0, settings._limit) + "...";
									}

									$(".quicksort .option").filter(function() {
										return $(this).attr("optionid") == optionID;
									}).attr("optionname", optionName).find("span").html(subOptionName);
									$("#edittable").remove();
								} else {
									alert("Error");
								}
							}
						});
					}
					return false;
				});
				//清空
				$(".quicksort .empty").live('click', function() {
					if (!confirm(LazyGridLang.EmptyConfirm)) {
						return;
					}
					var groupType = "";
					if ($(this).parent().text() == LazyGridLang.MySearch) {
						groupType = 2;
					} else if ($(this).parent().text() == LazyGridLang.RecentSearch) {
						groupType = 3
					}

					$.ajax({
						type : 'POST',
						url : '/inc/plugins/jquery.lazyquicksort.php',
						data : 'type=empty&groupType=' + groupType + '&mainID=' + $.LazyQuickSortSettings.mainID,
						success : function(result) {
							if (groupType == 2) {
								$(".quicksort .group").filter(function() {
									return $(this).text() == LazyGridLang.MySearch;
								}).remove();
								$(".quicksort .option").filter(function() {
									return $(this).attr("grouptype") == "2";
								}).remove();
							} else if (groupType == 3) {
								$(".quicksort .group").filter(function() {
									return $(this).text() == LazyGridLang.RecentSearch;
								}).remove();
								$(".quicksort .option").filter(function() {
									return $(this).attr("grouptype") == "3";
								}).remove();
							}
						}
					});
					return false;
				});
			});

			function parseData(data,self) {
				//解析json数据
				var parseResult = $.parseJSON(data);
				var groupName   = "";
				var contentStr  = new Array();

				//添加默认的'全部'选项
				contentStr.push("<div class='option' optionparam='all' optionname='" + LazyGridLang.All + "'>");
				contentStr.push("<span style='float:left;'>" + LazyGridLang.All + "</span>");
				contentStr.push("</div>");

				//遍历快速筛选数据
				$.each(parseResult, function(index, value) {
					var tempGroupName = "";
					if (value.GROUP_TYPE == 1) {
						tempGroupName = value.GROUP_NAME;
					} else if (value.GROUP_TYPE == 2) {
						tempGroupName = LazyGridLang.MySearch;
					} else if (value.GROUP_TYPE == 3) {
						tempGroupName = LazyGridLang.RecentSearch;
					} else {
						//group type error
					}

					//添加组
					if (groupName != tempGroupName) {
						contentStr.push("<div class='group'>");
						contentStr.push("<span style='float:left;'>" + tempGroupName + "</span>");
						if (value.GROUP_TYPE == 2 || value.GROUP_TYPE == 3) {
							contentStr.push(emptyToolBar);
						}
						contentStr.push("</div>");
					}

					var optionParam = "";
					var optionNameTitle = "";

					//最近查询和我的查询需要解析参数
					if (value.GROUP_TYPE == 2 || value.GROUP_TYPE == 3) {
						var parsedOptionParam = $.parseJSON(value.OPTION_PARAM);
						$.each(parsedOptionParam, function(index, value) {
							optionNameTitle += value.title + value.op + value.text + " ";

							if (value.value) {
								optionParam += "&" + value.field + "=" + value.value + "&" + value.field + "_text=" + value.text;
							} else {
								optionParam += "&" + value.field + "=" + value.text;
							}
						});
					} else if (value.GROUP_TYPE == 1) {
						optionParam = value.OPTION_PARAM;
						optionNameTitle = value.OPTION_NAME;
					} else {
						//group type error
					}

					var optionName = value.OPTION_NAME;
					if (optionName.length > settings._limit && value.GROUP_TYPE == 2) {
						optionName = optionName.substring(0, settings._limit) + "...";
					}
					
					if($.LazyQuickSortSettings.optionDisplay && typeof($.LazyQuickSortSettings.optionDisplay) == "string")
					{
						var optionDisplayArr = $.LazyQuickSortSettings.optionDisplay.split(",");
					}
					var optionDisplay = "";
					if($.inArray(optionParam,optionDisplayArr) != "-1")
					{
						optionDisplay = "style='display:none;'";
					}
					//添加项
					contentStr.push("<div " + optionDisplay + " class='option' grouptype='" + value.GROUP_TYPE + "' optionid='" + value.OPTION_ID + "' optionname='" + value.OPTION_NAME + "' optionparam='" + optionParam + "' title='" + optionNameTitle + "'>");
					contentStr.push("<span style='float:left;'>" + optionName + "</span>");
					if (value.GROUP_TYPE == 2) {
						contentStr.push(mySearchToolBar);
					} else if (value.GROUP_TYPE == 3) {
						contentStr.push(recentSearchToolBar);
					}
					contentStr.push("</div>");				
					groupName = tempGroupName;
				});
				var htmlStr = new Array();
				htmlStr.push("<div class='quicksort'>");
				htmlStr.push("<div class='title'>");
				htmlStr.push("<div class='left'></div>");
				htmlStr.push("<div class='center'></div>");
				htmlStr.push("<div class='right'></div>");
				htmlStr.push("</div>");
				htmlStr.push("<div class='content'>");
				htmlStr.push(contentStr.join(''));
				htmlStr.push("</div>");
				htmlStr.push("</div>");

				self.html(htmlStr.join(''));
				//设定宽度
				$(".quicksort .title .center").width($.LazyQuickSortSettings.width);
				$(".quicksort .title").width($.LazyQuickSortSettings.width + 37);
				$(".quicksort").width($.LazyQuickSortSettings.width + 37);
				$(".quicksort").parent(".quickSortWrap").width($.LazyQuickSortSettings.width + 37);
				//选中默认项

				var html = $(".quicksort .option").filter(function() {
					return $(this).attr("optionparam") == $.LazyQuickSortSettings.defaultValue;
				}).attr("optionname");
				$(".quicksort .center").html(html);
			}
		},
		Update : function() {
			$.ajax({
				type : 'POST',
				url : '/inc/plugins/jquery.lazyquicksort.php',
				data : 'type=update&mainID=' + $.LazyQuickSortSettings.mainID,
				success : function(result) {
					var parseResult = $.parseJSON(result);
					//移除所有最近查询
					$(".quicksort .content .option").filter(function() {
						return $(this).attr("grouptype") == 3;
					}).remove();

					$.each(parseResult, function(index, value) {
						var toolStr = "<a href='#' class='addToMySearch' title='" + LazyGridLang.AddToMySearch + "' style='display:none;float:right;margin-right:5px;'><img border='0' class='vv' src='" + $.LazyQuickSortSettings.theme + "images/grid/quicksort/tack1.png'/></a>";
						var emptyToolStr = "<a href='#' class='empty' title='" + LazyGridLang.Empty + "' style='display:none;float:right;margin-right:5px;'><img border='0' src='" + $.LazyQuickSortSettings.theme + "images/grid/quicksort/empty.png'/></a>";

						if ($(".quicksort .content .group").filter(function() {
							return $(this).children("span").html() == LazyGridLang.RecentSearch;
						}).length == 0) {
							$(".quicksort .content").append("<div class='group'><span style='float:left;'>" + LazyGridLang.RecentSearch + "</span>" + emptyToolStr + "</div>");
						}

						var optionName = value.OPTION_NAME;
						var optionParam = value.OPTION_PARAM;
						var optionNameTitle = value.OPTION_NAME;
						if (value.GROUP_TYPE == 2 || value.GROUP_TYPE == 3) {
							var parsedOptionParam = $.parseJSON(value.OPTION_PARAM);
							optionNameTitle = "";
							optionParam = "";
							$.each(parsedOptionParam, function(index, value) {
								optionNameTitle += value.title + value.op + value.text + " ";
								if (value.value) {
									optionParam += "&" + value.field + "=" + value.value + "&" + value.field + "_text=" + value.text;
								} else {
									optionParam += "&" + value.field + "=" + value.text;
								}
							});
						}

						if (optionName.length > $.LazyQuickSortSettings._limit && value.GROUP_TYPE == 2) {
							optionName = optionName.substring(0, $.LazyQuickSortSettings._limit) + "...";
						}

						$(".quicksort .content").append("<div class='option' grouptype='" + value.GROUP_TYPE + "' optionid='" + value.OPTION_ID + "' optionname='" + value.OPTION_NAME + "' optionparam='" + optionParam + "' title='" + optionNameTitle + "'><span style='float:left;'>" + optionName + "</span>" + toolStr + "</div>");
					});
				}
			});
		}
	});	
})(jQuery)


