/* Demo Note:  This demo uses a FileProgress class that handles the UI for displaying the file name and percent complete.
The FileProgress class is not part of SWFUpload.
*/
/* **********************
   Event Handlers
   These are my custom event handlers to make my
   web application behave the way I went when SWFUpload
   completes different tasks.  These aren't part of the SWFUpload
   package.  They are part of my application.  Without these none
   of the actions SWFUpload makes will show up in my application.
   ********************** */
function swfUploadPreLoad()
{
	var self = this;
	var loading = function () {
		document.getElementById("divLoadingContent").style.display = "";
		var longLoad = function () {
			document.getElementById("divLoadingContent").style.display = "none";
			document.getElementById("divLongLoading").style.display    = "";
		};
		this.customSettings.loadingTimeout = setTimeout(function () {
				longLoad.call(self)
			},
			15 * 1000
		);
	};
	
	this.customSettings.loadingTimeout = setTimeout(function () {
			loading.call(self);
		},
		1*1000
	);
}
function swfUploadLoaded() 
{
	var self = this;
	clearTimeout(this.customSettings.loadingTimeout);
	document.getElementById("divLoadingContent").style.display   = "none";
	document.getElementById("divLongLoading").style.display      = "none";
	document.getElementById("divAlternateContent").style.display = "none";
	document.getElementById("btnCancel").onclick = function () { 
		self.cancelQueue(); 
		document.getElementById(self.customSettings.cancelButtonId).disabled = true;
	};
	//上传按钮执行的动作 add by stephen
	document.getElementById("btnUpload").onclick = function () { 
	if(document.getElementById("poto_name").value)
	{
		var get_name      = document.getElementById("poto_name").value;
		var get_poto_type = "ALBUM";
		self.setPostParams({"upload_id":get_name,"upload_type":get_poto_type});
		self.startUpload(); 
		}
	self.startUpload(); 
	};
}
function swfUploadLoadFailed() 
{
	clearTimeout(this.customSettings.loadingTimeout);
	document.getElementById("divLoadingContent").style.display   = "none";
	document.getElementById("divLongLoading").style.display      = "none";
	document.getElementById("divAlternateContent").style.display = "";
}
   
   
function fileQueued(file) 
{
	try {
		FileProgress(file, this.customSettings.myFileListTarget,this);
	} catch (ex) {
		this.debug(ex);
	}
}

function fileQueueError(file, errorCode, message) 
{
	try {
		if (errorCode === SWFUpload.QUEUE_ERROR.QUEUE_LIMIT_EXCEEDED) {
			alert(EOlang.msgUploadFileCountExceed);
			return;
		}
		FileProgress(file, this.customSettings.myFileListTarget,this);
		var tr         = document.getElementById(file.id);
		tr.style.color = "red";
		var bar        = document.getElementById(file.id+"_bar");
		var errInfo    = EOlang.msgChooseFail;
		switch (errorCode) {
		case SWFUpload.QUEUE_ERROR.FILE_EXCEEDS_SIZE_LIMIT:
			errInfo = errInfo + ":"+EOlang.msgFileTooBig;
			this.debug(EOlang.msgError+":"+EOlang.msgFileTooBig+", "+EOlang.msgFileName+": " + file.name + ","+EOlang.msgFileSize+": " + file.size + ", "+EOlangh.msgFileInfor+": " + message);
			break;
		case SWFUpload.QUEUE_ERROR.ZERO_BYTE_FILE:
			errInfo = errInfo + ":0"+EOlang.msgByte+EOlang.msgFile;
			this.debug(EOlang.msgError+": "+msgEmptyFile+", "+EOlang.msgFileName+": " + file.name + ", "+EOlang.msgFileSize+": " + file.size + ", "+EOlangh.msgFileInfor+": " + message);
			break;
		case SWFUpload.QUEUE_ERROR.INVALID_FILETYPE:
			errInfo = errInfo + ":"+EOlang.msgFileTypeError;
			this.debug(EOlang.msgError+": "+EOlang.msgFileTypeError+", "+EOlang.msgFileName+": " + file.name + ", "+EOlang.msgFileSize+": " + file.size + ", "+EOlangh.msgFileInfor+": " + message);
			break;
		default:
			if (file !== null) {
				errInfo = errInfo + ":"+EOlang.msgUnknownError;
			}
			this.debug(EOlang.msgError+": " + errorCode + ", "+EOlang.msgFileName+": " + file.name + ", "+EOlang.msgFileSize+": " + file.size + ", "+EOlangh.msgFileInfor+": " + message);
			break;
		}
		bar.parentNode.innerHTML       = errInfo;
		var delObject                  = document.getElementById(file.id+"_del");
		delObject.parentNode.innerHTML = "&nbsp;";
		swfUploadInstance.cancelUpload(file.id);
	} catch (ex) {
        this.debug(ex);
    }
}

function fileDialogComplete(numFilesSelected, numFilesQueued)
{
	try {
		if (numFilesSelected > 0) {
			document.getElementById(this.customSettings.cancelButtonId).disabled = false;
		}
		if(this.settings.auto_upload){//是否要上传


			this.startUpload();
		}
	} catch (ex)  {
        this.debug(ex);
	}
}

function uploadStart(file) 
{
	try {
		var progress = new FileProgress(file, this.customSettings.progressTarget);
		progress.setStatus("Uploading...");
		progress.toggleCancel(true, this);
	}
	catch (ex) {}
	
	return true;
}

function uploadProgress(file, bytesLoaded, bytesTotal) 
{
	try {
		var percent      = Math.ceil((bytesLoaded / bytesTotal) * 100);
		var bar          = document.getElementById(file.id+"_bar");
		bar.style.width  = percent+"px";
		var tr           = document.getElementById(file.id);
		tr.style.color   = "blue";
	} catch (ex) {
		this.debug(ex);
	}
}

function uploadSuccess(file, serverData) 
{
	var isSuccess = (serverData.indexOf("successed")==0?true:false);
	try {
		if(isSuccess){
			var tr                         = document.getElementById(file.id);
			tr.style.color                 = "#339900";
			var bar                        = document.getElementById(file.id+"_bar");
			bar.parentNode.innerHTML       = EOlang.msgUploadSuccess;
			var delObject                  = document.getElementById(file.id+"_del");
			delObject.parentNode.innerHTML = "&nbsp;";	
			document.getElementById(this.customSettings.myFileListTarget+"Count").innerHTML=this.getStats().files_queued;
		}else{
			var tr                         = document.getElementById(file.id);
			tr.style.color                 = "red";
			var bar                        = document.getElementById(file.id+"_bar");
			bar.parentNode.innerHTML       = EOlang.msgUploadFail+":"+serverData;
			var delObject                  = document.getElementById(file.id+"_del");
			delObject.parentNode.innerHTML = "&nbsp;";
		}
	} catch (ex) {
		this.debug(ex);
	}
}

function uploadError(file, errorCode, message) 
{
	try {
		var progress = new FileProgress(file, this.customSettings.progressTarget);
		progress.setError();
		progress.toggleCancel(false);

		switch (errorCode) {
		case SWFUpload.UPLOAD_ERROR.HTTP_ERROR:
			progress.setStatus(Eolang.msgUploadError+": " + message);
			this.debug(EOlang.msgError+": "+EOlang.msgHttpError+","+EOlang.msgFileName+": " + file.name + ", "+EOlangh.msgFileInfor+": " + message);
			break;
		case SWFUpload.UPLOAD_ERROR.UPLOAD_FAILED:
			progress.setStatus("Upload Failed.");
			this.debug(EOlang.msgError+": "+EOlang.msgUploadFail+", "+EOlang.msgFileName+": " + file.name + ", "+EOlang.msgFileSize+": " + file.size + ", "+EOlangh.msgFileInfor+": " + message);
			break;
		case SWFUpload.UPLOAD_ERROR.IO_ERROR:
			progress.setStatus("Server (IO) Error");
			this.debug(EOlang.msgError+": "+EOlang.msgIOError+", "+EOlang.msgFileName+": " + file.name + ", "+EOlangh.msgFileInfor+": " + message);
			break;
		case SWFUpload.UPLOAD_ERROR.SECURITY_ERROR:
			progress.setStatus("Security Error");
			this.debug(EOlang.msgError+": "+EOlang.msgSafeError+", "+EOlang.msgFileName+": " + file.name + ", "+EOlangh.msgFileInfor+": " + message);
			break;
		case SWFUpload.UPLOAD_ERROR.UPLOAD_LIMIT_EXCEEDED:
			progress.setStatus("Upload limit exceeded.");
			this.debug(EOlang.msgError+": "+EOlang.msgfileoversize+","+EOlang.msgFileName+": " + file.name + ", "+EOlang.msgFileSize+": " + file.size + ", "+EOlangh.msgFileInfor+": " + message);
			break;
		case SWFUpload.UPLOAD_ERROR.FILE_VALIDATION_FAILED:
			progress.setStatus("Failed Validation.  Upload skipped.");
			this.debug(EOlang.msgError+": "+EOlang.msgFileRegisterError+", "+EOlang.msgFileName+": " + file.name + ", "+EOlang.msgFileSize+": " + file.size + ", "+EOlangh.msgFileInfor+": " + message);
			break;
		case SWFUpload.UPLOAD_ERROR.FILE_CANCELLED:
			if (this.getStats().files_queued === 0) {
				document.getElementById(this.customSettings.cancelButtonId).disabled = true;
			}
			progress.setStatus("Cancelled");
			progress.setCancelled();
			break;
		case SWFUpload.UPLOAD_ERROR.UPLOAD_STOPPED:
			progress.setStatus("Stopped");
			break;
		default:
			progress.setStatus("Unhandled Error: " + errorCode);
			this.debug(EOlang.msgError+": " + errorCode + ", "+EOlang.msgFileName+": " + file.name + ", "+EOlang.msgFileSize+": " + file.size + ", "+EOlangh.msgFileInfor+": " + message);
			break;
		}
	} catch (ex) {
        this.debug(ex);
    }
}

function uploadComplete(file) 
{
	if (this.getStats().files_queued === 0) {
		if(document.getElementById("poto_name").value){
			document.getElementById("form1").submit();
			}
		document.getElementById(this.customSettings.cancelButtonId).disabled = true;
		
	}
}

function queueComplete(numFilesUploaded) 
{
	document.getElementById(this.customSettings.myFileListTarget+"SuccessUploadCount").innerHTML = this.getStats().successful_uploads;
}

var _K = 1024;
var _M = _K*1024;
function getNiceFileSize(bitnum)
{
	if(bitnum<_M){
		if(bitnum<_K){
			return bitnum+'B';
		}else{
			return Math.ceil(bitnum/_K)+'K';
		}
		
	}else{
		return Math.ceil(100*bitnum/_M)/100+'M';
	}
}

