(function ($) {

    var methods = {
        init: function (options) {

            //默认参数
            var settings = $.extend({
                //模式 single-单选 multi-多选
                mode: "multi",
                width: $(window).width() - 300,
                height: $(window).height() - 100,
                param: {},
                onDialogClose: $.noop
            }, options);

            return this.each(function () {

                var $this = $(this);

                $this.data({
                    lazyDeptSelectSettings: settings
                });

                var dialogHtml = ['<div class="row">', '<div class="left_wrap col-xs-4">', '<div class="lazy_header"><div class="search_wrap">', '<input type="text" class="search" tip="'+SelectDialog.SelectCheckDept+'" value="'+SelectDialog.SelectCheckDept+'" />', '<a href="javascript:void(0)" class="do_search"><i style="line-height:40px;" class="fa fa-search"></i></a>', '</div></div><ul id="dept_list_dept" class="ztree" style="overflow-y:auto;"></ul>', '<div class="search_result_main_wrap" style="display:none;">', '<div class="lazy_header">', '<span class="tip"> '+SelectDialog.SelectResult+' </span>', '</div>', '<div class="search_result_wrap"></div>', '</div>', '</div>', '<div class="right_wrap col-xs-8">', '<div class="container-fluid">', '<div class="row">', '<div class="lazy_header col-xs-12">', '<a href="javascript:void(0)" class="op_button close_dialog" data-placement="left" title="'+SelectDialog.SelectCloseWindow+'" ><i class="fa fa-times" style="line-height:35px;"></i></a>', '</div>', '</div>', '<div class="row">', '<div class="col-xs-12" >', '<div class="ln-letters dept_filter_wrap" style="margin:5px 5%;"></div>', '</div>', '</div>'].join('');
                if (settings.mode == "multi")
                    dialogHtml += ['<div class="row">', '<div class="col-xs-12">', '<a href="javascript:void(0)" class="op_button clear_all" data-placement="left" style="color:#d9534f;"><i class="fa fa-trash-o" style="line-height:35px;"></i> '+SelectDialog.SelectBtnClear+'</a>', '<a href="javascript:void(0)" class="op_button select_all" data-placement="left" style="color:#36A9E1;"><i class="fa fa-check-square-o" style="line-height:35px;"></i> '+SelectDialog.SelectBtnAll+'</a>', '</div>', '</div>'].join('');
                dialogHtml += ['<div class="row">', '<div class="col-xs-12 dept_list_main_wrap">', '<ul class="dept_list_wrap"></ul>', '</div>', '</div>'].join('');
                if (settings.mode == "multi")
                    dialogHtml += ['<div class="row">', '<div class="col-xs-12 lazy_header">', '<span class="tip">'+SelectDialog.SelectBtnChecked+'(<span class="select_dept_count">0</span>)</span>', '</div>', '</div>', '<div class="row">', '<div class="col-xs-12 selected_dept_wrap"></div>', '</div>'].join('');
                dialogHtml += ['</div>', '</div>', '</div>'].join('');

                $this.addClass("lazy_dept_select_dialog container-fluid").html(dialogHtml);

                //定义dialog
                $this.dialog({
                    autoOpen: false,
                    width: settings.width,
                    height: settings.height,
                    resizable: false,
                    draggable: false,
                    modal: true,
                    dialogClass: 'lazy_dialog',
                    buttons: [{
                            text: SelectDialog.SelectBtnCancel,
                            'class': "btn btn-default",
                            click: function () {
                                $this.dialog("close");
                            }
                        }, {
                            text: SelectDialog.SelectBtnSubmit,
                            'class': "btn btn-primary",
                            click: function () {
                                settings.onDialogClose.call($this, {
                                    deptIDStr: $this.data("deptIDStr"),
                                    deptNameStr: $this.data("deptNameStr")
                                });

                                $this.dialog("close");
                            }
                        }],
                    open: function (event, ui) {

                        //部门树
                        $.fn.zTree.init($this.find("#dept_list_dept"), setting);


                        //初始化已选部门
                        var deptIDStr = $this.data("deptIDStr") ? $this.data("deptIDStr") : "";
                        var deptNameStr = $this.data("deptNameStr") ? $this.data("deptNameStr") : "";

                        $this.removeData(["deptNameStr", "deptIDStr"]);

                        $(".selected_dept_wrap").html("");
                        $(".select_dept_count").html(0);

                        if (deptIDStr != "") {

                            var deptNameSplit = deptNameStr.split(',');
                            var deptIDSplit = deptIDStr.split(',');
                            $.each(deptNameSplit, function (index, value) {
                                if (value != "") {
                                    $this.find(".selected_dept_wrap").append(methods._addDept.call($this, deptIDSplit[index], value, settings.mode));
                                }
                            });

                            $this.find(".select_dept_count").html(deptNameSplit.length - 1);
                        }

                        methods._getDeptByDeptID.call($this);

                    },
                    create: function () {
                        var dialogHeight = $this.dialog("option", "height");
                        $this.find(".dept_list_main_wrap").height(dialogHeight - (settings.mode == "multi" ? 320 : 138));
                        $this.find("#dept_list_dept").height(dialogHeight - 88).niceScroll();
                        $this.find(".search_result_wrap").height(dialogHeight - 128);
                        $this.find(".selected_dept_wrap,.dept_list_main_wrap,.search_result_wrap").niceScroll();
                    }
                });


                /*
                 * 部门树配置信息
                 */

                var setting = {
                    view: {
                        showLine: false,
                        showIcon: false,
                        selectedMulti: false,
                        dblClickExpand: false,
                        addDiyDom: addDiyDom
                    },
                    async: {
                        enable: true,
                        url: "/newplugins/js/jquery-select-dialog/dept/do.php",
                        autoParam: ["id"],
                        otherParam: {
                            "op": "getDeptList",
                            param: settings.param
                        }
                    },
                    callback: {
                        beforeClick: beforeClick,
                        onClick: function (event, treeId, treeNode) {
                            methods._getDeptByDeptID.call($this, treeNode.id);
                        },
                        onAsyncSuccess: zTreeOnAsyncSuccess,
                        onExpand: zTreeOnExpand
                    }
                };
                function zTreeOnExpand(event, treeId, treeNode) {
                    $this.find("#dept_list_dept").getNiceScroll().resize();
                };
                function zTreeOnAsyncSuccess(event, treeId, treeNode, msg) {

                    //初始化的时候选中第一个节点
                    if (treeNode === undefined) {
                        zTree_Menu = $.fn.zTree.getZTreeObj("dept_list_dept");
                        zTree_Menu.selectNode(zTree_Menu.getNodes()[0]);
                    }
                }

                function addDiyDom(treeId, treeNode) {
                    var spaceWidth = 10;
                    var switchObj = $("#" + treeNode.tId + "_switch"),
                            icoObj = $("#" + treeNode.tId + "_ico"),
                            aObj = $("#" + treeNode.tId + "_a");
                    switchObj.remove();
                    icoObj.before(switchObj);
                    var spaceStr = "<span style='display: inline-block;width:" + (spaceWidth * treeNode.level) + "px'></span>";
                    switchObj.before(spaceStr);
                }

                function beforeClick(treeId, treeNode) {
                    var zTree = $.fn.zTree.getZTreeObj("dept_list_dept");
                    zTree.expandNode(treeNode, "", "", "", true);
                    return true;
                }

                $this.find(".dept_filter_wrap").on({
                    click: function () {
                        var $self = $(this);

                        if (!$self.hasClass("ln-disabled")) {
                            $this.find(".dept_filter_wrap a").removeClass("ln-selected");
                            $self.addClass("ln-selected");

                            if ($self.hasClass("all")) {
                                $this.find(".dept_list_wrap .dept_list").show();
                            } else {
                                $this.find(".dept_list_wrap .dept_list").hide();

                                $this.find(".dept_list_wrap .dept_list").filter(function () {
                                    return $(this).attr("dept_name_zm").substr(0, 1).toUpperCase() == $self.html();
                                }).show();
                            }
                        }
                    }
                }, "a");


                //选中取消部门
                $this.find(".dept_list_wrap").on({
                    click: function () {
                        var oldCount = $this.find(".select_dept_count").html();

                        var deptName = $(this).attr("dept_name");
                        var deptID = $(this).attr("dept_id");

                        if ($(this).find(".selected_tip").length > 0) {
                            $this.find(".selected_dept_wrap").find('.dept[dept_id="' + $(this).attr("dept_id") + '"]').remove();
                            $this.find(".select_dept_count").html(parseInt(oldCount) - 1);

                            $this.data("deptNameStr", methods._formatReplaceDeptString.call($this,$this.data("deptNameStr"), deptName));
                            $this.data("deptIDStr", methods._formatReplaceDeptString.call($this,$this.data("deptIDStr"), deptID));

                            $(this).find(".selected_tip").remove();
                        } else {
                            if (settings.mode == "single") {
                                $this.find(".dept_list_wrap .dept_list .selected_tip").remove();
                            }

                            $this.find(".selected_dept_wrap").append(methods._addDept.call($this, $(this).attr("dept_id"), $(this).attr("dept_name"), settings.mode));
                            $this.find(".select_dept_count").html(parseInt(oldCount) + 1);
                            $(this).prepend("<a href='javascript:void(0)' class='selected_tip hover'><i class='fa fa-check-circle'></i></a>");
                        }
                        if (mySearchResult) {
                            mySearchResult.LazyList("reload", {
                                param: {
                                    op: "search",
                                    searchKey: $(".search").val()
                                }
                            });
                        }

                    },
                    mouseenter: function () {
                        $(this).find(".selected_tip").addClass("hover");
                    },
                    mouseleave: function () {
                        $(this).find(".selected_tip").removeClass("hover");
                    }
                }, ".dept_list");

                //全选
                $this.find(".select_all").click(function () {
                    $this.find(".dept_list_wrap .dept_list").each(function (index, value) {

                        if ($(this).find(".selected_tip").length == 0 && $(this).css("display") != "none") {
                            var oldCount = $this.find(".select_dept_count").html();
                            $this.find(".selected_dept_wrap").append(methods._addDept.call($this, $(this).attr("dept_id"), $(this).attr("dept_name"), settings.mode));
                            $this.find(".select_dept_count").html(parseInt(oldCount) + 1);
                            $(this).prepend("<a href='javascript:void(0)' class='selected_tip'><i class='fa fa-check-circle'></i></a>");
                        }
                    });
                });

                //关闭窗口
                $this.find(".close_dialog").click(function () {
                    $this.dialog("close");
                });

                //删除当前部门
                $this.find(".selected_dept_wrap").on({
                    click: function () {

                        var deptID = $(this).attr("dept_id");
                        var deptName = $(this).attr("dept_name");
                        $this.find(".dept_list_wrap .dept_list[dept_id='" + deptID + "']").find(".selected_tip").remove();

                        if (mySearchResult) {
                            mySearchResult.LazyList("reload", {
                                param: {
                                    op: "search",
                                    searchKey: $(".search").val()
                                }
                            });
                        }

                        $(this).remove();
                        var oldCount = $this.find(".select_dept_count").html();
                        $this.find(".select_dept_count").html(parseInt(oldCount) - 1);

                        $this.data("deptNameStr", methods._formatReplaceDeptString.call($this,$this.data("deptNameStr"), deptName));
                        $this.data("deptIDStr", methods._formatReplaceDeptString.call($this,$this.data("deptIDStr"), deptID));

                    }
                }, ".dept");

                //清除所有选中部门
                $this.find(".clear_all").click(function () {

                    $this.find(".dept_list_wrap .dept_list .selected_tip").remove();

                    $this.find(".selected_dept_wrap").html('');
                    $this.find(".select_dept_count").html(0);

                    $this.removeData("deptNameStr");
                    $this.removeData("deptIDStr");
                });

                //查询
                var mySearchResult;

                $this.find(".search").focusin(function () {
                    if ($(this).val() == $(this).attr("tip")) {
                        $(this).val("");
                    }
                }).focusout(function () {
                    if ($(this).val() == "") {
                        $(this).val($(this).attr("tip"));
                    }
                }).keyup(function () {
                    var searchKey = $.trim($(this).val());

                    if (searchKey != "") {

                        if ($this.find(".do_search i").hasClass("fa-search")) {
                            $this.find(".do_search i").removeClass("fa-search").addClass("fa-times-circle");
                        }

                        $this.find("#dept_list_dept").slideUp();
                        $this.find(".search_result_main_wrap").slideDown();

                        setTimeout(function () {
                            if (mySearchResult) {
                                mySearchResult.LazyList("reload", {
                                    param: {
                                        op: "search",
                                        searchKey: searchKey
                                    }
                                });
                            } else {
                                mySearchResult = $this.find(".search_result_main_wrap .search_result_wrap").LazyList({
                                    width: "auto",
                                    dataSource: "/newplugins/js/jquery-select-dialog/dept/do.php",
                                    param: {
                                        op: "search",
                                        searchKey: searchKey
                                    },
                                    itemTitleTemplate: "{title}({count})",
                                    itemListTemplate: function (data) {
                                        var deptIDStr = $this.data("deptIDStr");
                                        if (deptIDStr && deptIDStr.indexOf(data.DEPT_ID) != -1) {
                                            return "<a href='javascript:void(0)' class='selected_tip'><i class='fa fa-check-circle'></i></a>{DEPT_NAME}";
                                        } else {
                                            return "{DEPT_NAME}";
                                        }
                                    },
                                    onItemClick: function (ui, data, event, thisObj) {
                                        //选中
                                        if (thisObj.find(".selected_tip").length == 0) {
                                            if (settings.mode == "single") {
                                                $this.find(".item_list_wrap .selected_tip").remove();
                                            }
                                            else
                                            {
                                                var oldCount = $this.find(".select_dept_count").html();
                                                $this.find(".select_dept_count").html(parseInt(oldCount) + 1);
                                            }
                                            $this.find(".selected_dept_wrap").append(methods._addDept.call($this, data.DEPT_ID, data.DEPT_NAME, settings.mode));
                                            thisObj.find("div").prepend("<a href='javascript:void(0)' class='selected_tip'><i class='fa fa-check-circle'></i></a>");
                                        }
                                        //取消选中
                                        else
                                        {
                                            if (settings.mode != "single") {
                                                var oldCount = $this.find(".select_dept_count").html();
                                                $this.find(".select_dept_count").html(parseInt(oldCount) - 1);
                                            }
                                            $this.find(".selected_dept_wrap").find('.dept[dept_id="' + data.DEPT_ID + '"]').remove();
                                            thisObj.find(".selected_tip").remove();
                                            $this.data("deptNameStr", methods._formatReplaceDeptString.call($this,$this.data("deptNameStr"), data.DEPT_NAME));
                                            $this.data("deptIDStr", methods._formatReplaceDeptString.call($this,$this.data("deptIDStr"), data.DEPT_ID));
                                        }
                                        methods._formatSelecteddepts.call($this);
                                    }
                                });
                            }
                        }, 500);

                    }
                });

                //确定查询
                $this.find(".do_search").click(function () {
                    if ($(this).find("i").hasClass("fa-times-circle")) {

                        $(this).find("i").removeClass("fa-times-circle").addClass("fa-search");

                        $this.find("#dept_list_dept").slideDown();
                        $this.find(".search_result_main_wrap").slideUp();
                        $this.find(".search_wrap,.search").animate({
                            width: 0
                        }, function () {
                            $this.find(".search").css({
                                padding: 0
                            });
                            $this.find(".search_wrap").css({
                                overflow: ""
                            });
                        });

                    } else {
                        $this.find(".search").css({
                            padding: "0 6px"
                        }).val($this.find(".search").attr("tip"));

                        $this.find(".search_wrap,.search").animate({
                            width: "100%"
                        });
                    }
                });

            });
        },
        /**
         * 根据部门获取部门
         * @param {[type]} deptID [description]
         */
        _getDeptByDeptID: function (deptID) {
            return this.each(function () {

                var $this = $(this),
                        settings = $this.data("lazyDeptSelectSettings");

                $.ajax({
                    url: "/newplugins/js/jquery-select-dialog/dept/do.php",
                    data: {
                        deptID: deptID,
                        op: "getDeptByDept",
                        param: settings.param
                    }
                }).done(function (result) {
                    if (result && result != "null") {
                        methods._formatdeptResult.call($this, result);
                    } else {
                        $this.find(".user_list_wrap").html('<div class="alert alert-warning empty_tip">'+SelectDialog.SelectNoDept+'</div>');
                    }
                });
            });

        },
        /**
         * 获取子部门
         * @param {[type]} deptID [description]
         */
        _getSubDeptList: function (deptID) {
            return this.each(function () {

                var $this = $(this);

                $.ajax({
                    url: "/newplugins/js/jquery-select-dialog/dept/do.php",
                    data: {
                        deptID: deptID,
                        op: "getDeptList"
                    }
                }).done(function (result) {
                    if (result && result != "null") {
                        methods._formatdeptResult.call($this, result);
                    } else {
                        $this.find(".dept_list_wrap").html('<div class="alert alert-warning empty_tip">'+SelectDialog.SelectNoDept+'</div>');
                    }
                });
            });

        },
        _formatdeptResult: function (deptResult) {

            return this.each(function () {
                var $this = $(this);
                if (deptResult && deptResult != "null") {
                    var parsedData = $.parseJSON(deptResult);

                    var deptFilterHtml = [];
                    var totaldeptCount = 0;
                    var deptListHtml = [];
                    $.each(parsedData, function (index, value) {

                        var className = index.toLowerCase();

                        var deptLength = value.length;

                        totaldeptCount += deptLength;

                        if (deptLength == 0) {
                            className += " ln-disabled";
                        }
                        deptFilterHtml.push('<a class="' + className + '" title="' + deptLength + '" href="javascript:void(0)">' + index + '</a>');

                        $.each(value, function (deptIndex, deptValue) {
                            deptListHtml.push(methods._formatdeptList.call($this, deptValue));
                        });
                    });

                    $this.find(".dept_filter_wrap").html('<a class="all ln-selected" title="' + totaldeptCount + '" href="javascript:void(0)">'+SelectDialog.SelectBtnBoth+'</a>' + deptFilterHtml.join(''));

                    $this.find(".dept_filter_wrap").find("a").tooltip();

                    $this.find(".dept_list_wrap").html(deptListHtml.join(''));

                    methods._formatSelecteddepts.call($this);

                    $this.find("#dept_list_dept,.dept_list_main_wrap").getNiceScroll().resize();
                } else {
                    $this.find(".dept_list_wrap").html('<div class="alert alert-warning empty_tip">'+SelectDialog.SelectNoDept+'</div>');
                }
            });
        },
        _formatSelecteddepts: function () {

            return this.each(function () {

                var $this = $(this);

                var selecteddeptIDStr = "," + $this.data("deptIDStr") + ",";
                $this.find(".dept_list_wrap .dept_list").each(function (index, value) {
                    var deptID = $(this).attr("dept_id");
                    if (selecteddeptIDStr.indexOf("," + deptID + ",") != -1) {
                        if ($(this).find(".selected_tip").length == 0)
                        {
                            $(this).prepend("<a href='javascript:void(0)' class='selected_tip'><i class='fa fa-check-circle'></i></a>");
                        }
                    }
                    else
                        $this.find(".dept_list_wrap .dept_list[dept_id='" + deptID + "']").find(".selected_tip").remove();
                });
            });

        },
        _addDept: function (deptID, deptName, mode) {

            var $this = $(this);

            if (mode == "single") {
                $this.data({
                    deptNameStr: deptName,
                    deptIDStr: deptID
                });
            } else {
                var deptNameStr = $this.data("deptNameStr");
                var deptIDStr = $this.data("deptIDStr");
                if (deptNameStr) {
                    deptNameStr += deptName + ",";
                    deptIDStr += deptID + ",";
                    $this.data({
                        deptNameStr: deptNameStr,
                        deptIDStr: deptIDStr
                    });
                } else {
                    $this.data({
                        deptNameStr: deptName + ",",
                        deptIDStr: deptID + ","
                    });
                }
            }

            return '<span class="dept" dept_id="' + deptID + '" dept_name="' + deptName + '">' + deptName + '<a href="javascript:void(0)" class="delete"><i class="fa fa-times"></i></a></span>';
        },
        _formatdeptList: function (deptInfor) {
            return "<li class='dept_list' dept_name_zm='" + deptInfor.DEPT_NAME_ZM + "' dept_id='" + deptInfor.DEPT_ID + "' dept_name='" + deptInfor.DEPT_NAME + "'>" + deptInfor.DEPT_NAME + "</li>";
        },
        _formatReplaceDeptString: function (string,replace) {
            var array = string.split(",");
            var index = array.indexOf(replace);
            array.splice(index,1);
            return array.join(",");
        }
    };

    $.fn.LazyDeptSelect = function (method) {
        if (methods[method]) {
            return methods[method].apply(this, Array.prototype.slice.call(arguments, 1));
        } else if (typeof method === 'object' || !method) {
            return methods.init.apply(this, arguments);
        } else {
            $.error('Method ' + method + ' does not exist on jQuery.LazyDeptSelect');
        }

    };
})(jQuery);
