(function($) {

    var methods = {
        init: function(options) {

            //默认参数
            var settings = $.extend(true, {

                //模式 single-单选 multi-多选
                mode: "multi",
                //可以选离职
                chooseLeaveOffice: false,
                width: $(window).width() - 300,
                height: $(window).height() - 100,
                param: {
                    showLeaveOffice : false
                },
                onDialogClose: $.noop,

                //取消按钮回掉
                onDialogCancel: $.noop
            }, options);

            return this.each(function() {

                var $this = $(this);

                $this.data({
                    lazyUserSelectSettings: settings
                });

                var dialogHtml = '<div class="row">\
                                    <div class="left_wrap col-xs-4">\
                                        <div style="" class="search_wrap">\
                                            <input type="text" class="search" tip="'+SelectDialog.SelectTitleTip+'" value="'+SelectDialog.SelectTitleTip+'" />\
                                            <a href="javascript:void(0)" class="do_search"><i style="line-height:40px;" class="fa fa-search"></i></a>\
                                        </div>\
                                        <div class="organization_tab">\
                                            <ul>\
                                            <li user_type="dept" style="width:60px;" title="'+SelectDialog.SelectByDept+'"><a href="#tabs-1"><div style="width:50px;text-overflow:ellipsis;white-space:nowrap;overflow:hidden;">'+SelectDialog.SelectByDept+'</div></a></li>\
                                            <li user_type="priv" style="width:60px;" title="'+SelectDialog.SelectByRole+'"><a href="#tabs-2"><div style="width:50px;text-overflow:ellipsis;white-space:nowrap;overflow:hidden;">'+SelectDialog.SelectByRole+'</div></a></li>\
                                            <li user_type="group" style="width:60px;" title="'+SelectDialog.SelectBygroup+'"><a href="#tabs-3"><div style="width:50px;text-overflow:ellipsis;white-space:nowrap;overflow:hidden;">'+SelectDialog.SelectBygroup+'</div></a></li>\
                                            </ul>\
                                            <div id="tabs-1">\
                                                <div class="tab_panel">\
                                                    <ul id="dept_list'+$this.attr("id")+'" class="ztree"></ul>\
                                                </div>\
                                            </div>\
                                            <div id="tabs-2">\
                                                <div id="priv_list" class="tab_panel"></div>\
                                            </div>\
                                            <div id="tabs-3">\
                                                <div id="group_list" class="tab_panel"></div>\
                                            </div>\
                                        </div>\
                                        <div class="search_result_main_wrap" style="display:none;">\
                                            <div class="lazy_header">\
                                                <span class="tip"> '+SelectDialog.SelectResult+' </span>\
                                            </div>\
                                            <div class="search_result_wrap"></div>\
                                        </div>\
                                    </div>\
                                    <div class="right_wrap col-xs-8">\
                                        <div class="container-fluid">\
                                            <div class="row">\
                                                <div class="lazy_header col-xs-12">';
                if(settings.chooseLeaveOffice) {
                    dialogHtml += '<label style="position:absolute;left:10px;top:8px;" class="">\
                                                        <input type="checkbox" class="lazy-user-select-show-dimission" style=""> '+SelectDialog.SelectShowLeft+'\
                                                    </label>';
                }
                dialogHtml += '<a href="javascript:void(0)" class="op_button close_dialog" data-placement="left" title="'+SelectDialog.SelectCloseWindow+'" ><i class="fa fa-times" style="line-height:35px;"></i></a>\
                                                </div>\
                                            </div>\
                                            <div class="row" style="margin-bottom:10px;">\
                                                <div class="col-xs-12" >\
                                                    <div class="ln-letters user_filter_wrap" style="margin:5px 5%;"></div>\
                                                </div>\
                                            </div>';

                if (settings.mode == "multi") {
                    dialogHtml += '<div class="row">\
                                                <div class="col-xs-12">\
                                                    <a href="javascript:void(0)" class="op_button clear_all" data-placement="left" style="color:#d9534f;"><i class="fa fa-trash-o" style="line-height:35px;"></i> '+SelectDialog.SelectBtnClear+'</a>\
                                                    <a href="javascript:void(0)" class="op_button select_all" data-placement="left" style="color:#36A9E1;"><i class="fa fa-check-square-o" style="line-height:35px;"></i> '+SelectDialog.SelectBtnAll+'</a>\
                                                </div>\
                                            </div>';
                }

                dialogHtml += '<div class="row">\
                                                <div class="col-xs-12 user_list_main_wrap">\
                                                    <ul class="user_list_wrap"></ul>\
                                                </div>\
                                            </div>';
                if (settings.mode == "multi") {
                    dialogHtml += '<div class="row">\
                                                <div class="col-xs-12 lazy_header" style="line-height:35px;">\
                                                    <span class="tip">'+SelectDialog.SelectBtnChecked+'(<span class="select_user_count">0</span>)</span>\
                                                </div>\
                                            </div>\
                                            <div class="row">\
                                                <div class="col-xs-12 selected_user_wrap"></div>\
                                            </div>';
                }
                dialogHtml += '</div>\
                                    </div>\
                                </div>';

                $this.addClass("lazy_user_select_dialog container-fluid").html(dialogHtml);

                //定义dialog
                $this.dialog({
                    autoOpen: false,
                    width: settings.width,
                    height: settings.height,
                    resizable: false,
                    draggable: false,
                    modal: true,
                    dialogClass: 'lazy_dialog',
                    beforeClose: function(event, ui) {
                        //关闭之前，清除查询
                        if ($this.find(".do_search").find("i").hasClass("fa-times-circle")) {
                            $this.find(".do_search").find("i").removeClass("fa-times-circle").addClass("fa-search");
                            $this.find(".organization_tab").slideDown();
                            $this.find(".search_result_main_wrap").slideUp();
                            $this.find(".search_wrap,.search").animate({
                                width: 0
                            }, function() {
                                $this.find(".search").css({
                                    padding: 0
                                });
                                $this.find(".search_wrap").css({
                                    overflow: ""
                                });
                            });
                        }
                    },
                    buttons: [{
                        text: SelectDialog.SelectBtnCancel,
                        'class': "btn btn-default",
                        click: function() {
                            $this.dialog("close");
                            settings.onDialogCancel.call($this);
                        }
                    }, {
                        text: SelectDialog.SelectBtnSubmit,
                        'class': "btn btn-primary",
                        click: function() {
							
                            settings.onDialogClose.call($this, {
                                userIDStr: $this.data("userIDStr"),
                                userNameStr: $this.data("userNameStr")
                            });
                            $this.dialog("close");
                        }
                    }],
                    close: function() {
                        //隐藏滚动条
                        $this.find("#dept_list"+$this.attr("id")+",.selected_user_wrap,.tab_panel,.user_list_main_wrap,.search_result_wrap").getNiceScroll().hide();
                    },
                    open: function(event, ui) {

                        //显示滚动条
                        $this.find("#dept_list"+$this.attr("id")+",.selected_user_wrap,.tab_panel,.user_list_main_wrap,.search_result_wrap").getNiceScroll().show();

                        //部门树
                        $.fn.zTree.init($this.find("#dept_list"+$this.attr("id")), setting);

                        //角色列表
                        $this.find("#priv_list").LazyList({
                            width: "auto",
                            dataSource: "/newplugins/js/jquery-select-dialog/user/do.php",
                            param: {
                                op: "getPrivList",
                                onlyNotEmpty: true,
                                param: settings.param
                            },
                            itemTitleStyle: {
                                fontWeight: "normal"
                            },
                            itemTitleTemplate: "{title}",
                            itemListTemplate: "{PRIV_NAME}({userCount})",
                            onItemTitleClick: function(ui, data) {
                                methods._getUserByPrivID.call($this, "", "");
                            },
                            onItemClick: function(ui, data) {
                                methods._getUserByPrivID.call($this, data.PRIV_NAME, data.USER_PRIV);
                            },
                            onInit: function() {
                                $(this).find("li.title:first div").append("<i title='"+SelectDialog.SelectNoUserRole+"' style='cursor:pointer;line-height:30px;float:right;margin-right:3px;color:#36A9E1;' class='fa fa-bars lazy_tooltip show_all_priv'></i>");
                                $this.find(".lazy_tooltip").tooltip();
                            }
                        });

                        //组列表
                        $this.find("#group_list").LazyList({
                            width: "auto",
                            dataSource: "/newplugins/js/jquery-select-dialog/user/do.php",
                            param: {
                                op: "getGroupList",
                                param: settings.param
                            },
                            itemListTemplate: "{GROUP_NAME}({memberCount})",
                            itemTitleTemplate: "{title}({count})",
                            onItemClick: function(ui, data) {
								methods._getUserByGroupID.call($this, data.GROUP_ID, data.groupType);
                            }
                        });

                        //初始化已选用户
                        var userIDStr = $this.data("userIDStr") ? $this.data("userIDStr") : "";
                        var userNameStr = $this.data("userNameStr") ? $this.data("userNameStr") : "";

                        $this.removeData(["userNameStr", "userIDStr"]);

                        $(".selected_user_wrap").html("");
                        $(".select_user_count").html(0);

                        if (userIDStr != "") {

                            var userNameSplit = userNameStr.split(',');
                            var userIDSplit = userIDStr.split(',');

                            $.each(userNameSplit, function(index, value) {
                                if (value != "") {
                                    $this.find(".selected_user_wrap").append(methods._addUser.call($this, userIDSplit[index], value, settings.mode));
                                }
                            });

                            $this.find(".select_user_count").html(userNameSplit.length - 1);
                        }

                        $this.find(".organization_tab").tabs("option", "active", 0);

                        methods._getUserByDeptID.call($this);

                        // 初始化离职复选框
                        if($this.find(".lazy-user-select-show-dimission").length > 0) {
                            $(':checkbox').iCheck({
                                checkboxClass : 'icheckbox_square-blue'
                            });
                            // 离职点击事件
                            $(".lazy-user-select-show-dimission").on('ifChanged', function(event) {
                                if ($(this).prop("checked")) {
                                    setting.async.otherParam.showLeaveOffice = true;
                                    settings.param.showLeaveOffice = true;
                                    
                                } else {
                                    setting.async.otherParam.showLeaveOffice = false;
                                    settings.param.showLeaveOffice = false;
                                }
                                // var organizationTabActive =  $this.find(".organization_tab").tabs("option","active");
                                // 部门
                                // 重新加载树
                                $.fn.zTree.init($this.find("#dept_list"+$this.attr("id")), setting);
                                methods._getUserByDeptID.call($this);
                                // 角色
                                $this.find("#priv_list").LazyList("reload",{
                                    param : {
                                       param: settings.param
                                    }
                                });
                                methods._getUserByPrivID.call($this, "", "");
                                // 组
                                $this.find("#group_list").LazyList("reload",{
                                    param : {
                                       param: settings.param
                                    }
                                });
                                if (mySearchResult) {
                                    methods._mySearchResultReload.call($this,mySearchResult);
                                }
                                return false;
                            });
                        }  
                    },
                    create: function() {
                        var dialogHeight = $this.dialog("option", "height");
                        $this.find(".user_list_main_wrap").height(dialogHeight - (settings.mode == "multi" ? 320 : 118));
                        $this.find(".tab_panel,.search_result_wrap").height(dialogHeight - 88);
                        $this.find("#dept_list"+$this.attr("id")).height(dialogHeight - 88);
                        $this.find("#dept_list"+$this.attr("id")+",.selected_user_wrap,.tab_panel,.user_list_main_wrap,.search_result_wrap").niceScroll();
                    }
                });

                //初始化标签
                $this.find(".organization_tab").tabs();

                /*
                 * 部门树配置信息
                 */
                var setting = {
                    view: {
                        showLine: false,
                        showIcon: false,
                        selectedMulti: false,
                        dblClickExpand: false,
                        addDiyDom: addDiyDom
                    },
                    async: {
                        enable: true,
                        url: "/newplugins/js/jquery-select-dialog/user/do.php",
                        autoParam: ["id"],
                        otherParam: {
                            "op": "getDeptList",
                            "onlyNotEmpty": true,
                            "showLeaveOffice" : false,
                            param: settings.param
                        },
                    },
                    callback: {
                        beforeClick: beforeClick,
                        onClick: function(event, treeId, treeNode) {
                            methods._getUserByDeptID.call($this, treeNode.id);
                        },
                        onAsyncSuccess: zTreeOnAsyncSuccess,
                        onExpand: zTreeOnExpand
                    }
                };

                function zTreeOnExpand(event, treeId, treeNode) {
                    $this.find("#dept_list"+$this.attr("id")).getNiceScroll().resize();
                };

                function zTreeOnAsyncSuccess(event, treeId, treeNode, msg) {
                    //初始化的时候选中第一个节点
                    if (treeNode === undefined) {
                        zTree_Menu = $.fn.zTree.getZTreeObj("dept_list"+$this.attr("id"));
                        zTree_Menu.selectNode(zTree_Menu.getNodes()[0]);
                    }
                }

                function addDiyDom(treeId, treeNode) {
                    var spaceWidth = 10;
                    var switchObj = $("#" + treeNode.tId + "_switch"),
                        icoObj = $("#" + treeNode.tId + "_ico"),
                        aObj = $("#" + treeNode.tId + "_a");
                    switchObj.remove();
                    icoObj.before(switchObj);
                    var spaceStr = "<span style='display: inline-block;width:" + (spaceWidth * treeNode.level) + "px'></span>";
                    switchObj.before(spaceStr);

                    if (treeNode.id == "") {
                        aObj.append("<i title='"+SelectDialog.SelectNoUserDept+"' style='cursor:pointer;line-height:30px;float:right;color:#36A9E1;' class='fa fa-bars lazy_tooltip show_all_dept'></i>");

                        $this.find(".lazy_tooltip").tooltip();
                    }
                }

                function beforeClick(treeId, treeNode) {
                    var zTree = $.fn.zTree.getZTreeObj("dept_list"+$this.attr("id"));
                    zTree.expandNode(treeNode, "", "", "", true);
                    return true;
                }


                $this.find(".user_filter_wrap").on({
                    click: function() {
                        var $self = $(this);

                        if (!$self.hasClass("ln-disabled")) {
                            $this.find(".user_filter_wrap a").removeClass("ln-selected");
                            $self.addClass("ln-selected");

                            if ($self.hasClass("all")) {
                                $this.find(".user_list_wrap .user_list").show();
                            } else {
                                $this.find(".user_list_wrap .user_list").hide();

                                $this.find(".user_list_wrap .user_list").filter(function() {
                                    return $(this).attr("user_name_zm").substr(0, 1).toUpperCase() == $self.html();
                                }).show();
                            }
                        }
                    }
                }, "a");

                //显示所有部门 默认显示有用户的部门
                $this.find("#dept_list"+$this.attr("id")).on({
                    click: function() {
                        setting.async.otherParam.onlyNotEmpty = "";

                        $.fn.zTree.init($this.find("#dept_list"+$this.attr("id")), setting);
                        return false;
                    }
                }, ".show_all_dept");

                //显示所有角色
                $this.find("#priv_list").on({
                    click: function() {
                        $this.find("#priv_list").LazyList("reload",{
							param: {
                                op: "getPrivList",
                                onlyNotEmpty: ""
                            }
						});
                        return false;
                    }
                }, ".show_all_priv");

                //选中取消用户
                $this.find(".user_list_wrap").on({
                    click: function() {
                        var oldCount = $this.find(".select_user_count").html();

                        var userName = $(this).attr("user_name");
                        var userID = $(this).attr("user_id");

                        if ($(this).find(".selected_tip").length > 0) {
                            $this.find(".selected_user_wrap").find('.user[user_id="' + $(this).attr("user_id") + '"]').remove();
                            $this.find(".select_user_count").html(parseInt(oldCount) - 1);

                            $this.data("userNameStr", $this.data("userNameStr").replace(userName + ",", ""));
                            $this.data("userIDStr", $this.data("userIDStr").replace(userID + ",", ""));

                            $(this).find(".selected_tip").remove();
                        } else {
                            if (settings.mode == "single") {
                                $this.find(".user_list_wrap .user_list .selected_tip").remove();
                            }

                            $this.find(".selected_user_wrap").append(methods._addUser.call($this, $(this).attr("user_id"), $(this).attr("user_name"), settings.mode));
                            $this.find(".select_user_count").html(parseInt(oldCount) + 1);
                            $(this).prepend("<a href='javascript:void(0)' class='selected_tip hover'><i class='fa fa-check-circle'></i></a>");
                        }
                        if (mySearchResult) {
                            methods._mySearchResultReload.call($this,mySearchResult);
                        }

                        $this.find(".selected_user_wrap").getNiceScroll().resize();

                    },
                    mouseenter: function() {
                        $(this).find(".selected_tip").addClass("hover");
                    },
                    mouseleave: function() {
                        $(this).find(".selected_tip").removeClass("hover");
                    }
                }, ".user_list");

                //全选
                $this.find(".select_all").click(function() {
                    $this.find(".user_list_wrap .user_list").each(function(index, value) {

                        if ($(this).find(".selected_tip").length == 0 && $(this).css("display") != "none") {
                            var oldCount = $this.find(".select_user_count").html();
                            $this.find(".selected_user_wrap").append(methods._addUser.call($this, $(this).attr("user_id"), $(this).attr("user_name"), settings.mode));
                            $this.find(".select_user_count").html(parseInt(oldCount) + 1);
                            $(this).prepend("<a href='javascript:void(0)' class='selected_tip'><i class='fa fa-check-circle'></i></a>");
                        }
                    });
					if (mySearchResult) {
						methods._mySearchResultReload.call($this,mySearchResult);
					}
                    $this.find(".selected_user_wrap").getNiceScroll().resize();
                });

                //关闭窗口
                $this.find(".close_dialog").click(function() {
                    $this.dialog("close");
                });

                //删除当前用户
                $this.find(".selected_user_wrap").on({
                    click: function() {

                        var userID = $(this).attr("user_id");
                        var userName = $(this).attr("user_name");
                        $this.find(".user_list_wrap .user_list[user_id='" + userID + "']").find(".selected_tip").remove();

                        if (mySearchResult) {
							methods._mySearchResultReload.call($this,mySearchResult);
                        }

                        $(this).remove();
                        var oldCount = $this.find(".select_user_count").html();
                        $this.find(".select_user_count").html(parseInt(oldCount) - 1);

                        $this.data("userNameStr", $this.data("userNameStr").replace(userName + ",", ""));
                        $this.data("userIDStr", $this.data("userIDStr").replace(userID + ",", ""));
                    }
                }, ".user");

                //清除所有选中用户
                $this.find(".clear_all").click(function() {

                    $this.find(".user_list_wrap .user_list .selected_tip").remove();

                    $this.find(".selected_user_wrap").html('');
                    $this.find(".select_user_count").html(0);

                    $this.removeData("userNameStr");
                    $this.removeData("userIDStr");
					if (mySearchResult) {
						methods._mySearchResultReload.call($this,mySearchResult);
					}
                });

                //查询
                var mySearchResult;
                var handleTimeout;

                $this.find(".search").focusin(function() {
                    if ($(this).val() == $(this).attr("tip")) {
                        $(this).val("");
                    }
                }).focusout(function() {
                    if ($(this).val() == "") {
                        $(this).val($(this).attr("tip"));
                    }
                }).keyup(function() {
                    //取消延时请求代码的执行
                    if(handleTimeout) {
                        clearTimeout(handleTimeout);
                    }
                    
                    var searchKey = $.trim($(this).val());

                    if (searchKey != "") {

                        $this.find(".organization_tab").slideUp();
                        $this.find(".search_result_main_wrap").slideDown();

                        handleTimeout = setTimeout(function() {
                            if (mySearchResult) {
                                methods._mySearchResultReload.call($this,mySearchResult);
                            } else {
                                mySearchResult = $this.find(".search_result_main_wrap .search_result_wrap").LazyList({
                                    width: "auto",
                                    dataSource: "/newplugins/js/jquery-select-dialog/user/do.php",
                                    param: {
                                        op: "search",
                                        searchKey: searchKey,
                                        param: settings.param
                                    },
                                    itemTitleTemplate: "{title}({count})",
                                    itemListTemplate: function(data) {
                                        if (data.USER_NAME) {
                                            var userIDStr = $this.data("userIDStr");
                                            var userSearchListTemplateStr = "";
                                            if (userIDStr && userIDStr.indexOf(data.USER_ID) != -1) {
                                                userSearchListTemplateStr = "<a href='javascript:void(0)' class='selected_tip'><i class='fa fa-check-circle'></i></a>{USER_NAME}";
                                            } else {
                                                userSearchListTemplateStr = "{USER_NAME}";
                                            }
                                            if(data.DEPT_ID == 0)
                                                userSearchListTemplateStr += "<span style='color:#C9C9C9;'>["+SelectDialog.SelectLeft+"]</span>";
                                            return userSearchListTemplateStr;
                                        } else if (data.DEPT_NAME) {
                                            return "{DEPT_NAME}";
                                        } else if (data.PRIV_NAME) {
                                            return "{PRIV_NAME}";
                                        } else if (data.GROUP_NAME) {
                                            return "{GROUP_NAME}";
                                        }
                                    },
                                    onItemClick: function(ui, data, event, thisObj) {

                                        //用户
                                        if (data.USER_NAME) {

                                            //选中
                                            if (thisObj.find(".selected_tip").length == 0) {
                                                if (settings.mode == "single") {
                                                    $this.find(".item_list_wrap .selected_tip").remove();
                                                } else {
                                                    var oldCount = $this.find(".select_user_count").html();
                                                    $this.find(".select_user_count").html(parseInt(oldCount) + 1);
                                                }
                                                $this.find(".selected_user_wrap").append(methods._addUser.call($this, data.USER_ID, data.USER_NAME, settings.mode));
                                                thisObj.find("div").prepend("<a href='javascript:void(0)' class='selected_tip'><i class='fa fa-check-circle'></i></a>");
                                            }
                                            //取消选中
                                            else {
                                                if (settings.mode != "single") {
                                                    var oldCount = $this.find(".select_user_count").html();
                                                    $this.find(".select_user_count").html(parseInt(oldCount) - 1);
                                                }
                                                $this.find(".selected_user_wrap").find('.user[user_id="' + data.USER_ID + '"]').remove();
                                                thisObj.find(".selected_tip").remove();
                                                $this.data("userNameStr", $this.data("userNameStr").replace(data.USER_NAME + ",", ""));
                                                $this.data("userIDStr", $this.data("userIDStr").replace(data.USER_ID + ",", ""));
                                            }
                                            methods._formatSelectedUsers.call($this);
                                        }

                                        //部门
                                        else if (data.DEPT_NAME) {
                                            methods._getUserByDeptID.call($this, data.DEPT_ID);
                                        }

                                        //角色
                                        else if (data.PRIV_NAME) {
                                            methods._getUserByPrivID.call($this, data.PRIV_NAME, data.USER_PRIV);
                                        }

										//组
										else if (data.GROUP_NAME)
										{
											methods._getUserByGroupID.call($this, data.GROUP_ID, data.groupType);
										}
                                    }
                                });
                            }
                        }, 500);

                    }
                });

                //确定查询
                $this.find(".do_search").click(function() {
                    if ($(this).find("i").hasClass("fa-times-circle")) {

                        $(this).find("i").removeClass("fa-times-circle").addClass("fa-search");

                        $this.find(".organization_tab").slideDown();
                        $this.find(".search_result_main_wrap").slideUp();
                        $this.find(".search_wrap,.search").animate({
                            width: 0
                        }, function() {
                            $this.find(".search").css({
                                padding: 0
                            });
                            $this.find(".search_wrap").css({
                                overflow: ""
                            });
                        });

                    } else {
                        $this.find(".do_search i").removeClass("fa-search").addClass("fa-times-circle");

                        $this.find(".search").css({
                            padding: "0 6px"
                        }).val($this.find(".search").attr("tip"));

                        $this.find(".search_wrap,.search").animate({
                            width: "100%"
                        });
                    }
                });

            });
        },

        /**
         * 根据部门获取用户
         * @param {[type]} deptID [description]
         */
        _getUserByDeptID: function(deptID) {
            return this.each(function() {

                var $this = $(this),
                    settings = $this.data("lazyUserSelectSettings");

                $.ajax({
                    url: "/newplugins/js/jquery-select-dialog/user/do.php",
                    data: {
                        deptID: deptID,
                        op: "getUserByDept",
                        param: settings.param
                    }
                }).done(function(result) {
                    if (result && result != "null") {
                        methods._formatUserResult.call($this, result);
                    } else {
                        $this.find(".user_list_wrap").html('<div class="alert alert-warning empty_tip">'+SelectDialog.SelectNoUser+'</div>');
                    }
                });
            });

        },
		//角色
        _getUserByPrivID: function(privName, privID) {

            return this.each(function() {
                var $this = $(this),
                    settings = $this.data("lazyUserSelectSettings");

                $.ajax({
                    url: "/newplugins/js/jquery-select-dialog/user/do.php",
                    data: {
                        privID: privID,
                        op: "getUserByPriv",
                        param: settings.param
                    }
                }).done(function(result) {
                    if (result && result != "null") {
                        methods._formatUserResult.call($this, result);
                    } else {
                        $this.find(".user_list_wrap").html('<div class="alert alert-warning empty_tip">'+SelectDialog.SelectNoRole+'</div>');
                    }
                });
            });

        },
		//组
        _getUserByGroupID: function(GROUP_ID, groupType) {

			return this.each(function() {
                var $this = $(this),
                    settings = $this.data("lazyUserSelectSettings");

                $.ajax({
                    url: "/newplugins/js/jquery-select-dialog/user/do.php",
                    data: {
                        op: "getUserByGroup",
						groupID: GROUP_ID,
						groupType: groupType,
						param: settings.param
                    }
                }).done(function(result) {
                    if (result && result != "null") {
                        methods._formatUserResult.call($this, result);
                    } else {
                        $this.find(".user_list_wrap").html('<div class="alert alert-warning empty_tip">'+SelectDialog.SelectNoGroup+'</div>');
                    }
                });
            });

        },

        _formatUserResult: function(userResult) {

            return this.each(function() {
                var $this = $(this);
                if (userResult && userResult != "null") {
                    var parsedData = $.parseJSON(userResult);

                    var userFilterHtml = [];
                    var totalUserCount = 0;
                    var userListHtml = [];
                    //加载拼音简写
                    $.each(parsedData.PINYIN, function(index, value) {

                        var className = index.toLowerCase();

                        var userLength = value.length;

                        totalUserCount += userLength;

                        if (userLength == 0) {
                            className += " ln-disabled";
                        }
                        userFilterHtml.push('<a class="' + className + '" title="' + userLength + '" href="javascript:void(0)">' + index + '</a>');
                    });
                    //加载人名
                    $.each(parsedData.DATA, function(userIndex, userValue) {
                        userListHtml.push(methods._formatUserList.call($this, userValue));
                    });

                    $this.find(".user_filter_wrap").html('<a class="all ln-selected" title="' + totalUserCount + '" href="javascript:void(0)">'+SelectDialog.SelectBtnBoth+'</a>' + userFilterHtml.join(''));

                    $this.find(".user_filter_wrap").find("a").tooltip();

                    $this.find(".user_list_wrap").html(userListHtml.join(''));

                    methods._formatSelectedUsers.call($this);

                    $this.find("#dept_list"+$this.attr("id")+",.user_list_main_wrap").getNiceScroll().resize();
                } else {
                    $this.find(".user_list_wrap").html('<div class="alert alert-warning empty_tip">'+SelectDialog.SelectNoUser+'</div>');
                }
            });
        },

        _formatSelectedUsers: function() {

            return this.each(function() {

                var $this = $(this);

                var selectedUserIDStr = "," + $this.data("userIDStr") + ",";
                $this.find(".user_list_wrap .user_list").each(function(index, value) {
                    var userID = $(this).attr("user_id");

                    if (selectedUserIDStr.indexOf("," + userID + ",") != -1) {
                        if ($(this).find(".selected_tip").length == 0) {
                            $(this).prepend("<a href='javascript:void(0)' class='selected_tip'><i class='fa fa-check-circle'></i></a>");
                        }
                    } else
                        $this.find(".user_list_wrap .user_list[user_id='" + userID + "']").find(".selected_tip").remove();
                });
            });

        },
        _addUser: function(userID, userName, mode) {

            var $this = $(this);

            if (mode == "single") {
                $this.data({
                    userNameStr: userName,
                    userIDStr: userID
                });
            } else {
                var userNameStr = $this.data("userNameStr");
                var userIDStr = $this.data("userIDStr");
                if (userNameStr) {
                    userNameStr += userName + ",";
                    userIDStr += userID + ",";
                    $this.data({
                        userNameStr: userNameStr,
                        userIDStr: userIDStr
                    });
                } else {
                    $this.data({
                        userNameStr: userName + ",",
                        userIDStr: userID + ","
                    });
                }
            }
            var addUserString = '<span class="user" user_id="' + userID + '" user_name="' + userName + '">' + userName;
            if($this.find(".user_list").filter("[user_id='"+userID+"']").attr("user_dept_id") == 0)
                addUserString += "<span style='color:#C9C9C9;'>["+SelectDialog.SelectLeft+"]</span>";
            addUserString += '<a href="javascript:void(0)" class="delete"><i class="fa fa-times"></i></a></span>';
            return addUserString;
        },
        _formatUserList: function(userInfor) {
            var showUserInfoStr = "<li class='user_list' user_name_zm='" + userInfor.USER_NAME_ZM + "' user_id='" + userInfor.USER_ID + "' user_name='" + userInfor.USER_NAME + "' user_dept_id='"+userInfor.DEPT_ID+"'>" + userInfor.USER_NAME;
                if(userInfor.DEPT_ID == 0)
                    showUserInfoStr += "<span style='color:#C9C9C9;'>["+SelectDialog.SelectLeft+"]</span>";
            showUserInfoStr += "</li>";
            return showUserInfoStr;
        },
		//刷新查询结果
		_mySearchResultReload : function(mySearchResult) {
			var $this = $(this),
				settings = $this.data("lazyUserSelectSettings");
			mySearchResult.LazyList("reload", {
				param: {
					op: "search",
					searchKey: $(".search", this).val(),
					param: settings.param
				}
			});
		}
    };

    $.fn.LazyUserSelect = function(method) {
        if (methods[method]) {
            return methods[method].apply(this, Array.prototype.slice.call(arguments, 1));
        } else if (typeof method === 'object' || !method) {
            return methods.init.apply(this, arguments);
        } else {
            $.error('Method ' + method + ' does not exist on jQuery.LazyUserSelect');
        }

    };
})(jQuery);
