(function($) {

	var methods = {
		init: function(options) {

			//默认参数
			var settings = $.extend({
				//弹出框宽度
				width: 300,
				//数据处理页
				url: "/newplugins/js/phrase/do.php",
				//参数
				param: {
					getType : "getFlowPhrase"
				},
				//选中一条短语后回调函数
				onContentSelect: $.noop,
			}, options);

			//doucment隐藏短语结果框
			$(document).on("click.common_phrase", function(event) {
				$(".lazy-phrase-result-wrap").hide();
			});

			return this.each(function() {

				var self = this,
					$this = $(this);

				$this.data({
					lazyCommonPhraseSettings: settings
				});

				//单行或多行
				if($this.is("input") || $this.is("textarea")) {
					$this.on({
						focus : function() {
							//自定义属性
							$this.attr("custom-input","without");

							//容器
							var $lazyPhraseResultWrap = $("<div/>", {
								'class': "lazy-phrase-result-wrap",
								'html': "<ul/>"
							}).width(settings.width - 1);

							if ($(".lazy-phrase-result-wrap").length < 1) {
								$("body").append($lazyPhraseResultWrap);
							}

							$(".lazy-phrase-result-wrap").find("li").remove();

							//取值填充
							methods._getCommonPhraseDetail.call(self);
						},
						blur : function() {
							if($this.attr("custom-input") == "have") {
								//输入记录保存，允许的。，、？！,.?!
								var userInputData = $this.val(),
									pattern   = new RegExp("[`·~@#$%^&*()+|<>/;:'=\\-_{}\\[\\]\\\\《》\"~@#￥&*（）——|{}【】‘；：”“']"); 
								//过滤
								var userInputDataFormat = userInputData.replace(pattern,"");
								if(userInputDataFormat.length < 30 && $.trim(userInputDataFormat)) {
									methods._saveUserCommonPhrase.call(this,userInputDataFormat);
								}
							}
						},
						click : function() {
							return false;
						},
						change : function() {
							$this.attr("custom-input","have");
						}
					});
				}
			});
		},

		//取值填充
		_getCommonPhraseDetail: function (){
			var $this = $(this),
				settings = $this.data("lazyCommonPhraseSettings");

			$.ajax({
				url: settings.url,
				data: settings.param
			}).done(function(result) {
				if (result) {
					var parsedData = $.parseJSON(result);
					$.each(parsedData, function(key, value) {
						var contentStr = value.CONTENT;
						contentStr     = contentStr.replace(/<\/?[^>]*>/g, '');
						var $resultList = $("<li/>", {
							html: contentStr,
							title: contentStr,
							"class": "lazy-phrase-result-wrap-li"
						}).click(function() {
							//点选行事件
							$this.val($this.val()+contentStr);
						});
						$(".lazy-phrase-result-wrap").append($resultList);
					});
					//调整div位置并展示
					methods._adjustDivPosition.call($this);
				}
			}).fail(function() {
				alert("ajax error");
			});
		},

		//调整div位置并展示
		_adjustDivPosition: function (){
			var $this = $(this),
				settings = $this.data("lazyCommonPhraseSettings");
			//定位
			var adjustResultWrapHeight = "",
				adjustResultWrapWidth = $this.offset().left,
				lazyPhraseResultWrapHeight = $(".lazy-phrase-result-wrap").height(),
				lazyPhraseResultWrapWidth = $(".lazy-phrase-result-wrap").width();
			if($this.is("input")) {
				adjustResultWrapHeight = $this.offset().top + $this.height() + 3;
			} else {
				adjustResultWrapHeight = $this.offset().top + $this.height() + 7;
			}
			//上下调整位置
			if(document.body.offsetHeight-$this.offset().top-$this.height() < lazyPhraseResultWrapHeight) {
				adjustResultWrapHeight = $this.offset().top - lazyPhraseResultWrapHeight - 3;
			}
			//左右调整位置
			if(document.body.offsetWidth-$this.offset().left < lazyPhraseResultWrapWidth) {
				adjustResultWrapWidth = document.body.offsetWidth - lazyPhraseResultWrapWidth - 3;
			}
			$(".lazy-phrase-result-wrap").css("top","").css("left","").offset({
				top: adjustResultWrapHeight,
				left: adjustResultWrapWidth
			});
			//展示div
			$(".lazy-phrase-result-wrap").show();
		},

		//保存符合规则的用户输入数据
		_saveUserCommonPhrase: function (userInputData){
			var $this = $(this),
				settings = $this.data("lazyCommonPhraseSettings"),
				saveUserInputParam = {
					getType : "saveUserInput",
					CONTENT : userInputData
				};
			$.ajax({
				url: settings.url,
				data: saveUserInputParam
			}).done(function(result) {
				
			}).fail(function() {
				alert("ajax error");
			});
		}
	};

	$.fn.LazyCommonPhrase = function(method) {
		if (methods[method]) {
			return methods[method].apply(this, Array.prototype.slice.call(arguments, 1));
		} else if (typeof method === 'object' || !method) {
			return methods.init.apply(this, arguments);
		} else {
			$.error('Method ' + method + ' does not exist on jQuery.LazyCommonPhrase');
		}
	};
})(jQuery);
