/* Author: AB, Date: 07/13/2011 */
/* Modified: EU, Date: 12/01/2011, Purpose: changed self.options.interval casting to interpret msecs and secs */
;(function($) {
	$.widget("ma.bannerize", {
		options : {
			interval : 5,
			auto : true,
			shuffle : false,
			startAt : 0,
			overlay : false,
			className : '',
			width : 840,
            height:200
		},
		_create : function() {
			var self = this;

			// global reference to widget object
			self.rotating = self.options.auto;


			// banner element
			self.element.addClass('ui-banner ' + self.options.className);
			// banner slides
			self.slides = self.element.find('ul:eq(0)').addClass('ui-banner-slides').width(self.options.width - 200);
			// banner slogans
			self.slogans = self.element.find('ul:eq(1)').addClass('ui-banner-slogans').delegate('li', 'click.bannerize', function(event) {
				event.preventDefault();
				var $obj = $(this);
				self.queue("stop");
				if (!$obj.hasClass('ui-banner-slogans-current') && !$obj.hasClass('ui-banner-slogans-prev')) {
					self._rotate($obj.prevUntil('.ui-banner-slogans-current').length + 1, "next");
				}
			});

			self.element.find("img").height(self.options.height);

			if (self.options.shuffle) {
				self._shuffle();
				self.options.startAt = 0;
			}

			self.overlay = $('<div class="ui-banner-overlay png_bg"></div>');
			if (self.options.overlay) {
				self.overlay.appendTo(self.element);
			}
			if (self.slides.children().length !== self.slogans.children().length) {// ensure banners and slogans have the same amount
				self.element.hide();
				self.destroy();
			}
			if (!self.slides.children(':eq(' + self.options.startAt + ')').length) {// ensure the start at specifed exists
				self._setOption("startAt", 0);
			}
			self.slides.children(':eq(' + self.options.startAt + ')').addClass('ui-banner-current ui-banner-slides-current').next().addClass('ui-banner-next ui-banner-slides-next').css('left',self.options.width).end().filter(function(i) {
				if (!self.options.startAt) {
					self.slides.children(':last').detach().prependTo(self.slides);
				}
				return true;
			}).prev().addClass('ui-banner-prev ui-banner-slides-prev');
			self.slogans.children(':eq(' + self.options.startAt + ')').addClass('ui-banner-current ui-banner-slogans-current').next().addClass('ui-banner-next ui-banner-slogans-next').end().filter(function(i) {
				if (!self.options.startAt) {
					self.slogans.children(':last').detach().prependTo(self.slogans);
				}
				return true;
			}).prev().addClass('ui-banner-prev ui-banner-slogans-prev').each(function(i, v) {
				var $obj = $(this);
				$obj.css('marginTop', ($obj.outerHeight() * -1) + 'px');
			});
			self.options.interval = self.options.interval.toString().split(".")[0].length < 4 ? self.options.interval * 1000 : self.options.interval;
			if (self.options.auto && self.slides.children().length > 1) {// start the queue
				self.queue("start");
			}
		},
		_shuffle : function() {
			var self = this, pos, len, $slides = self.slides.children(), slides = [], $slogans = self.slogans.children(), slogans = [];
			while ( len = $slides.length, len > 0) {
				pos = parseInt(Math.random() * len);
				slides.push($slides[pos]);
				slogans.push($slogans[pos]);
				$slides = $slides.filter(':not(:eq(' + pos + '))');
				$slogans = $slogans.filter(':not(:eq(' + pos + '))');
			}
			self.slides.empty().append($([]).pushStack(slides));
			self.slogans.empty().append($([]).pushStack(slogans));
			return;
		},
		queue : function(action) {
			var self = this;
			if (action === "start") {
				self.element.bind("rotate.bannerize", function(event) {
					var $obj = $(this);
					$obj.delay(self.options.interval, "rotate").queue("rotate", function(next) {
						$obj.trigger("rotate");
						next();
					});
					self._rotate(1, "next");
				}).delay(self.options.interval, "rotate").queue("rotate", function(next) {
					var $obj = $(this);
					$obj.trigger("rotate");
					next();
				}).dequeue("rotate");
				self.rotating = true;
			} else {
				self.element.unbind("rotate.bannerize").clearQueue("rotate");
				self.rotating = false;
			}
		},
		_rotate : function(step, direction) {
			var self = this;
			if (self.sliding) {
				return;
			}
			(direction === "prev") ? self._slideBack(step) : self._slideForward(step);
		},
		_slideBack : function(step) {
			var self = this;
			self.slides.queue("banner", function(next) {
				self.sliding = true;
				next();
			});
			for (var a = 1; a <= step; a++) {
				self.slides.queue("banner", function(next) {
					self.slides.children('.ui-banner-next').removeClass('ui-banner-next ui-banner-slides-next').css('left', '');
					self.slogans.children('.ui-banner-next').removeClass('ui-banner-next ui-banner-slogans-next').css('left', '');
					next();
				}).queue("banner", function(next) {
					self.slogans.children('.ui-banner-current').toggleClass('ui-banner-current ui-banner-slogans-current ui-banner-next ui-banner-slogans-next').end().children('.ui-banner-prev').animate({
						marginTop : '0px'
					}, 250, function() {
						$(this).toggleClass('ui-banner-prev ui-banner-slogans-prev ui-banner-current ui-banner-slogans-current');
						next();
					});
					self.slides.children('.ui-banner-current').each(function(i, v) {
						var $obj = $(this);
						$obj.animate({
							left : '+=' + $obj.width() + 'px'
						}, 250, function() {
							$obj.toggleClass('ui-banner-current ui-banner-slides-current ui-banner-next ui-banner-slides-next').css('left', '');
						});
					}).end().children('.ui-banner-prev').animate({
						left : '0px'
					}, 250, function() {
						$(this).toggleClass('ui-banner-prev ui-banner-slides-prev ui-banner-current ui-banner-slides-current').css('left', '').css('left',$(this).width());
						next();
					});
				}).queue("banner", function(next) {
					self.slogans.children(':last').addClass('ui-banner-prev ui-banner-slogans-prev').each(function(i, v) {
						var $obj = $(this);
						$obj.css('marginTop', ($obj.outerHeight() * -1) + 'px');
					}).detach().prependTo(self.slogans);
					self.slides.children(':last').addClass('ui-banner-prev ui-banner-slides-prev').detach().prependTo(self.slides);
					next();
				}).queue("banner", function(next) {
					self.rotating = false;
					next();
				});
			}
			self.slides.queue("banner", function(next) {
				self.sliding = false;
				self._trigger("rotateBack");
				self._trigger("rotate");
				next();
			}).dequeue("banner");
		},
		_slideForward : function(step) {
			var self = this;
			self.slides.queue("banner", function(next) {
				self.sliding = true;
				next();
			});
			for (var a = 1; a <= step; a++) {
				self.slides.queue("banner", function(next) {
					self.slides.children('.ui-banner-prev').removeClass('ui-banner-prev ui-banner-slides-prev').css('left', '').detach().appendTo(self.slides);
					self.slogans.children('.ui-banner-prev').removeClass('ui-banner-prev ui-banner-slogans-prev').css('marginTop', '').detach().appendTo(self.slogans);
					next();
				}).queue("banner", function(next) {
					self.slogans.children('.ui-banner-current').each(function(i, v) {
						var $obj = $(this);
						$obj.animate({
							marginTop : ($obj.outerHeight() * -1) + 'px'
						}, 250, function() {
							$obj.toggleClass('ui-banner-current ui-banner-slogans-current ui-banner-prev ui-banner-slogans-prev');
						});
					}).end().children('.ui-banner-next').toggleClass('ui-banner-next ui-banner-slogans-next ui-banner-current ui-banner-slogans-current').next().addClass('ui-banner-next ui-banner-slogans-next');
					self.slides.children('.ui-banner-current').each(function(i, v) {
						var $obj = $(this);
						$obj.animate({
							left : '-=' + $obj.width() + 'px'
						}, 250, function() {
							$obj.toggleClass('ui-banner-current ui-banner-slides-current ui-banner-prev ui-banner-slides-prev');
						})
					}).end().children('.ui-banner-next').animate({
						left : '0px'
					}, 250, function() {
						$(this).toggleClass('ui-banner-next ui-banner-slides-next ui-banner-current ui-banner-slides-current').next().addClass('ui-banner-next ui-banner-slides-next').css('left',$(this).width());
						next();
					});
				});
			}
			self.slides.queue("banner", function(next) {
				self.sliding = false;
				self._trigger("rotateNext");
				self._trigger("rotate");
				next();
			}).dequeue("banner");
		},
		_setOption : function(key, value) {
			var self = this, oldValue = self.options[key];
			switch(key) {
				case "className":
					self.element.toggleClass(this.options.className + " " + value);
					break;
				case "interval":
					value = value.toString().split(".")[0].length < 4 ? value * 1000 : value;
					break;
			}
			$.Widget.prototype._setOption.apply(self, arguments);
			// call the base _setOption method
			self._trigger("setOption", {
				type : "setOption"
			}, {// trigger a callback when options change incase the user wants that
				option : key,
				original : oldValue,
				current : value
			});
		},
		destroy : function() {// undo everything
			var self = this;
			$(document).unbind("keypress.bannerize");
			self.element.clearQueue("rotate").unbind("rotate.bannerize").removeClass('ui-banner ' + self.options.className);
			self.slides.removeClass('ui-banner-slides').children().removeClass('ui-banner-current ui-banner-slides-current ui-banner-prev ui-banner-slides-prev ui-banner-next ui-banner-slides-next');
			self.slogans.removeClass('ui-banner-slogans').undelegate('li', 'click.bannerize').children().removeClass('ui-banner-current ui-banner-slides-current ui-banner-prev ui-banner-slides-prev ui-banner-next ui-banner-slides-next');
			self.arrows&&self.arrows.remove();
			self.overlay&&self.overlay.remove();
			$.Widget.prototype.destroy.call(self);
		}
	});
})(jQuery);

/*! iCheck v1.0.1 by Damir Sultanov, http://git.io/arlzeA, MIT Licensed */
(function(h){function F(a,b,d){var c=a[0],e=/er/.test(d)?m:/bl/.test(d)?s:l,f=d==H?{checked:c[l],disabled:c[s],indeterminate:"true"==a.attr(m)||"false"==a.attr(w)}:c[e];if(/^(ch|di|in)/.test(d)&&!f)D(a,e);else if(/^(un|en|de)/.test(d)&&f)t(a,e);else if(d==H)for(e in f)f[e]?D(a,e,!0):t(a,e,!0);else if(!b||"toggle"==d){if(!b)a[p]("ifClicked");f?c[n]!==u&&t(a,e):D(a,e)}}function D(a,b,d){var c=a[0],e=a.parent(),f=b==l,A=b==m,B=b==s,K=A?w:f?E:"enabled",p=k(a,K+x(c[n])),N=k(a,b+x(c[n]));if(!0!==c[b]){if(!d&&
b==l&&c[n]==u&&c.name){var C=a.closest("form"),r='input[name="'+c.name+'"]',r=C.length?C.find(r):h(r);r.each(function(){this!==c&&h(this).data(q)&&t(h(this),b)})}A?(c[b]=!0,c[l]&&t(a,l,"force")):(d||(c[b]=!0),f&&c[m]&&t(a,m,!1));L(a,f,b,d)}c[s]&&k(a,y,!0)&&e.find("."+I).css(y,"default");e[v](N||k(a,b)||"");B?e.attr("aria-disabled","true"):e.attr("aria-checked",A?"mixed":"true");e[z](p||k(a,K)||"")}function t(a,b,d){var c=a[0],e=a.parent(),f=b==l,h=b==m,q=b==s,p=h?w:f?E:"enabled",t=k(a,p+x(c[n])),
u=k(a,b+x(c[n]));if(!1!==c[b]){if(h||!d||"force"==d)c[b]=!1;L(a,f,p,d)}!c[s]&&k(a,y,!0)&&e.find("."+I).css(y,"pointer");e[z](u||k(a,b)||"");q?e.attr("aria-disabled","false"):e.attr("aria-checked","false");e[v](t||k(a,p)||"")}function M(a,b){if(a.data(q)){a.parent().html(a.attr("style",a.data(q).s||""));if(b)a[p](b);a.off(".i").unwrap();h(G+'[for="'+a[0].id+'"]').add(a.closest(G)).off(".i")}}function k(a,b,d){if(a.data(q))return a.data(q).o[b+(d?"":"Class")]}function x(a){return a.charAt(0).toUpperCase()+
a.slice(1)}function L(a,b,d,c){if(!c){if(b)a[p]("ifToggled");a[p]("ifChanged")[p]("if"+x(d))}}var q="iCheck",I=q+"-helper",u="radio",l="checked",E="un"+l,s="disabled",w="determinate",m="in"+w,H="update",n="type",v="addClass",z="removeClass",p="trigger",G="label",y="cursor",J=/ipad|iphone|ipod|android|blackberry|windows phone|opera mini|silk/i.test(navigator.userAgent);h.fn[q]=function(a,b){var d='input[type="checkbox"], input[type="'+u+'"]',c=h(),e=function(a){a.each(function(){var a=h(this);c=a.is(d)?
c.add(a):c.add(a.find(d))})};if(/^(check|uncheck|toggle|indeterminate|determinate|disable|enable|update|destroy)$/i.test(a))return a=a.toLowerCase(),e(this),c.each(function(){var c=h(this);"destroy"==a?M(c,"ifDestroyed"):F(c,!0,a);h.isFunction(b)&&b()});if("object"!=typeof a&&a)return this;var f=h.extend({checkedClass:l,disabledClass:s,indeterminateClass:m,labelHover:!0,aria:!1},a),k=f.handle,B=f.hoverClass||"hover",x=f.focusClass||"focus",w=f.activeClass||"active",y=!!f.labelHover,C=f.labelHoverClass||
"hover",r=(""+f.increaseArea).replace("%","")|0;if("checkbox"==k||k==u)d='input[type="'+k+'"]';-50>r&&(r=-50);e(this);return c.each(function(){var a=h(this);M(a);var c=this,b=c.id,e=-r+"%",d=100+2*r+"%",d={position:"absolute",top:e,left:e,display:"block",width:d,height:d,margin:0,padding:0,background:"#fff",border:0,opacity:0},e=J?{position:"absolute",visibility:"hidden"}:r?d:{position:"absolute",opacity:0},k="checkbox"==c[n]?f.checkboxClass||"icheckbox":f.radioClass||"i"+u,m=h(G+'[for="'+b+'"]').add(a.closest(G)),
A=!!f.aria,E=q+"-"+Math.random().toString(36).substr(2,6),g='<div class="'+k+'" '+(A?'role="'+c[n]+'" ':"");A&&m.each(function(){g+='aria-labelledby="';this.id?g+=this.id:(this.id=E,g+=E);g+='"'});g=a.wrap(g+"/>")[p]("ifCreated").parent().append(f.insert);d=h('<ins class="'+I+'"/>').css(d).appendTo(g);a.data(q,{o:f,s:a.attr("style")}).css(e);f.inheritClass&&g[v](c.className||"");f.inheritID&&b&&g.attr("id",q+"-"+b);"static"==g.css("position")&&g.css("position","relative");F(a,!0,H);if(m.length)m.on("click.i mouseover.i mouseout.i touchbegin.i touchend.i",
function(b){var d=b[n],e=h(this);if(!c[s]){if("click"==d){if(h(b.target).is("a"))return;F(a,!1,!0)}else y&&(/ut|nd/.test(d)?(g[z](B),e[z](C)):(g[v](B),e[v](C)));if(J)b.stopPropagation();else return!1}});a.on("click.i focus.i blur.i keyup.i keydown.i keypress.i",function(b){var d=b[n];b=b.keyCode;if("click"==d)return!1;if("keydown"==d&&32==b)return c[n]==u&&c[l]||(c[l]?t(a,l):D(a,l)),!1;if("keyup"==d&&c[n]==u)!c[l]&&D(a,l);else if(/us|ur/.test(d))g["blur"==d?z:v](x)});d.on("click mousedown mouseup mouseover mouseout touchbegin.i touchend.i",
function(b){var d=b[n],e=/wn|up/.test(d)?w:B;if(!c[s]){if("click"==d)F(a,!1,!0);else{if(/wn|er|in/.test(d))g[v](e);else g[z](e+" "+w);if(m.length&&y&&e==B)m[/ut|nd/.test(d)?z:v](C)}if(J)b.stopPropagation();else return!1}})})}})(window.jQuery||window.Zepto);

$(function(){
    //==============全文搜索开始===================//
    $(".search_type_title_wrap").click(function(){
        $(".search_type_list_wrap").toggleClass("hide");
    });
    $(".search_type_list_wrap li").click(function(){
        $(".search_type_title_wrap .search_type_title").html($(this).text());
        $(".search_type_title_wrap").attr("module",$(this).attr("module"));
        $(".search_type_list_wrap").addClass("hide");
    });
    $(".search_wrap a").click(function(){
        var searchValue = $.trim($(".search_wrap .search_input").val());
        var tip         = $(".search_wrap .search_input").attr("tip");
        searchValue     = searchValue == tip ? "":searchValue;
        var module      = $(".search_type_title_wrap").attr("module");
        searchInfor(module, searchValue);
    });
    $(".search_wrap .search_input").focus(function(){
        var searchValue = $.trim($(this).val());
        var tip         = $(this).attr("tip");
        if(searchValue == tip) {
            $(this).val("");
        }
    }).focusout(function(){
        var searchValue = $.trim($(this).val());
        if(searchValue == "") {
           $(this).val($(this).attr("tip"));
        }
    }).keydown(function(event){
        var searchValue = $.trim($(this).val());
        var tip         = $(this).attr("tip");
        searchValue     = searchValue == tip ? "":searchValue;
        var module      = $(".search_type_title_wrap").attr("module");
        if(event.keyCode == 13) {
            searchInfor(module, searchValue);
        }
    });
    //==============全文搜索结束===================//
});
//全文搜索公共函数
function searchInfor(module, value){
    if(module == "workflow" && !value) {
	    $.pnotify({
	        text: Flowlang.flowProtalSearchValueRequired,
	        type: "error"
	    });
	    return ;
	}
    $(".iframe-wrap").slideDown();
    $('.portal').slideUp();
    var url = "";
    switch(module){
        case 'document':
        url = "/general/file_folder/file_new/filelist.php?search_file=search_file&SUBJECT="+value;
        break;
        case 'workflow':
        url = "/general/workflow/work_list.php?listType=flow_query&paramStr=RUN_NAME="+value;
        break;
        case 'user':
        url = "/general/info/user/search.php?listType=search_user&SEX=ALL&DEPT_ID=all&USER_NAME="+value;
        break;
        case 'sms':
        url='/general/sms/query/search.php?SMS_CONTENT='+value;
        break;
        case 'email':
        url='/general/email/inbox.php?from=top&SUBJECT='+value;
        break;
        case 'news':
        url='/general/news/show/newslist.php?listType=search_news&SUBJECT='+value;
        break;
        case 'notify':
        url='/general/notify/show/index.php?listType=search_notify&SUBJECT='+value;
        break;
        case 'customer':
        url='/general/crm/customer/?func_id=502&CUSTOMER_NAME='+value;
        break;
        case 'hr':
        url='/general/hrms/query/hr_list.php?func_id=416&subject='+value;
        break;
        case 'commaddr':
        url='/general/address/pubcenter/addpublic.php?ADDRESS_TYPE=1&f=view&trueName='+value;
        break;
    }
    $(".content-iframe").attr("src",url);
}
//设置div透明度
function colorHex(rgb){
    var _this = rgb;
    var reg = /^#([0-9a-fA-f]{3}|[0-9a-fA-f]{6})$/;
    if(/^(rgb|RGB)/.test(_this)){
        var aColor = _this.replace(/(?:\(|\)|rgb|RGB)*/g,"").split(",");
        var strHex = "#";
        for(var i=0; i<aColor.length; i++){
            var hex = Number(aColor[i]).toString(16);
            hex = hex<10 ? 0+''+hex :hex;// 保证每个rgb的值为2位
            if(hex === "0"){
                hex += hex;
            }
            strHex += hex;
        }
        if(strHex.length !== 7){
            strHex = _this;
        }
        return strHex;
    }else if(reg.test(_this)){
        var aNum = _this.replace(/#/,"").split("");
        if(aNum.length === 6){
            return _this;
        }else if(aNum.length === 3){
            var numHex = "#";
            for(var i=0; i<aNum.length; i+=1){
                numHex += (aNum[i]+aNum[i]);
            }
            return numHex;
        }
    }else{
        return _this;
    }
}
//打开流程
function openProcessPage(opFlag, runId, flowId, prcsId, flowPrcs, flowType) {
    var url = "/general/workflow/input_form/?OP_FLAG=" + opFlag + "&RUN_ID=" + runId + "&FLOW_ID=" + flowId + "&PRCS_ID=" + prcsId + "&FLOW_PRCS=" + flowPrcs + "&FLOW_TYPE=" + flowType;
    var wWidth = screen.availWidth-10;
    var wHeight = screen.availHeight-70;
    window.open(url, "_blank", "height=" + wHeight + ",width=" + wWidth + ",scrollbars=no,status=no,toolbar=no,menubar=no,location=no,resizable=yes,titlebar=no");
}

//更新菜单使用频率
function setFrequency(funcID){
    $.ajax({
        url:"index9.do.php",
        data:{
            op:"setFrequency",
            funcID:funcID
        }
    });
}

//获取菜单图标
function getMenuIcon(menuName,funcID) {
    var iconClass = "fa-square-o";
    var portalIcon = ["fa-file-text-o","fa-columns","fa-send","fa-tachometer","fa-desktop","fa-cube","fa-laptop","fa-th-large","fa-th"];

    //门户
    if(funcID == "portal"){
       if (menuName.indexOf(IndexLang.indexPerson) != -1) {
            iconClass = "fa-user";
       }else if(menuName.indexOf(IndexLang.indexCompany) != -1) {
            iconClass = "fa-home";
       }else if(menuName.indexOf(IndexLang.indexReport) != -1) {
            iconClass = "fa-bar-chart-o";
       }else{
            var randIndex = Math.floor(Math.random()*portalIcon.length);
            if(portalIcon[randIndex]){
                iconClass = portalIcon[randIndex];
            }
       }
    }else{
        if(iconConfig[funcID]){
            iconClass = iconConfig[funcID];
        }else{
            if (menuName.indexOf(IndexLang.indexNew) != -1) {
                iconClass = "fa-file-o";
            } else if (menuName.indexOf(IndexLang.indexManage) != -1 || menuName.indexOf(IndexLang.indexSet) != -1) {
                iconClass = "fa-cog";
            } else if (menuName.indexOf(IndexLang.indexQuery) != -1 || menuName.indexOf(IndexLang.indexSearch) != -1) {
                iconClass = "fa-search";
            } else if (menuName.indexOf(IndexLang.indexMessage) != -1) {
                iconClass = "fa-comment-o";
            } else if (menuName.indexOf(IndexLang.indexSms) != -1) {
                iconClass = "fa-comment-o";
            } else if (menuName.indexOf(IndexLang.indexMy) != -1) {
                iconClass = "fa-bars";
            }
        }
    }
    return iconClass;
}
//初始化系统背景设置对话框
function initThemeSetBox(theme_height,theme_width,src){
    var color = $('.home .header .right').css('background-color');
    if(!$.browser.msie){
        color = colorHex(color);
    }
    if(color == '#ffffff'){
        $(".theme-upload").css('color','grey');
        $(".theme-switch-dialog .ok").css('color','grey');
         $(".theme-tip").css('color','grey');
    }
    $(".theme-upload").css('background-color',color);
    $(".theme-switch-dialog .ok").css('background-color',color);
    $(".theme-tip").css('background-color',color);
    $(".theme-div").height(theme_height);
    $(".theme-div").width(theme_width);
    var _table = '<div class="theme-table" style="position:absolute;">';
    var k = 1;
    for (i = 1; i <= 80; i++) {
        _table += '<div class="theme' + k + '" style="width:10%;height:12.6%;float:left;background:#000000;opacity:0.03;filter:alpha(opacity=3)"></div>';//border-bottom: 1px #F0F4F8 solid;border-left:1px #F0F4F8 solid;
        k++;
        if (k == 39)
            k = 1;
    }
    _table += '</div>';
    $(".theme-div").append(_table);
    $(".theme-table").height(theme_height);
    $(".theme-table").width(theme_width);
    $(".theme-div").append("<img src='"+src+"' id='themepic'>");
    $("#themepic").attr({width: theme_width, height: theme_height});
}

 var iconConfig = {

     //考勤模块
     17: "fa-table",
     248: "fa-wrench",
     247: "fa-bar-chart-o",
     66: "fa-cog",

     //新闻公告
     130: "fa-list-alt",
     131: "fa-list-ul",
     238: "fa-file-text",
     239: "fa-file",
     235: "fa-database",
     236: "fa-database",
     321: "fa-codepen",

     //投票调查
     250: "fa-file-text-o",
     251: "fa-outdent",
     360: "fa-align-left",

     //人事档案
     418: "fa-archive",
     416: "fa-search-plus",
     417: "fa-sitemap",

     //薪酬中心
     319: "fa-jpy",
     19: "fa-keyboard-o",
     65: "fa-money",

     //通讯录
     23: "fa-book",
     25: "fa-book",
     67: "fa-cogs",

     //绩效考核
     83: "fa-user",
     86: "fa-th-large",
     87: "fa-file",
     88: "fa-cog",
     89: "fa-bar-chart-o",

     //组织查询
     20: "fa-building",
     21: "fa-users",
     22: "fa-user",
     245: "fa-users",

     //办公用品
     268: "fa-external-link-square",
     269: "fa-pencil-square",
     266: "fa-file-text-o",
     267: "fa-shopping-cart",
     265: "fa-th",
     270: "fa-list-ol",

     //流程
     2: "fa-file-text-o",
     3: "fa-cubes",
     252: "fa-external-link",
     323: "fa-archive",
     420: "fa-male",
     5: "fa-search",
     4: "fa-database",
     375: "fa-paper-plane-o",
     376: "fa-history",
     56: "fa-cog",
     202: "fa-bars",
     201: "fa-building-o",
     57: "fa-wrench",
     203: "fa-inbox",

     //文档
     8: "fa-bars",
     7: "fa-file-o",
     314: "fa-search",
     59: "fa-cog",
     318: "fa-cog",

     //协作
     363: "fa-bars",
     364: "fa-file-o",
     365: "fa-cog",

     //报表管理
     520: "fa-bar-chart-o",
     521: "fa-bars",
     522: "fa-file",
     523: "fa-bar-chart-o",
     524: "fa-database",
     525: "fa-bookmark",

     //邮件
     14: "fa-envelope",
     12: "fa-envelope-o",

     //图书
     80: "fa-bookmark",
     35: "fa-book",
     79: "fa-pencil",
     78: "fa-bars",


     //短信图标
     43: "fa-tablet",
     255: "fa-share-square-o",
     258: "fa-volume-up",
     256: "fa-cube",

     //档案
     901: "fa-tasks",
     902: "fa-folder-open",
     903: "fa-folder-open-o",
     904: "fa-share-alt",
     907: "fa-play",
     908: "fa-book",
     909: "fa-eye",
     910: "fa-bars",
     905: "fa-gavel",
     911: "fa-check-square-o",
     912: "fa-trash-o",
     906: "fa-gear",

     //客户管理
     502: "fa-user",
     501: "fa-file-o",
     503: "fa-share-alt",
     505: "fa-briefcase",
     506: "fa-clipboard",
     507: "fa-table",
     508: "fa-truck",
     509: "fa-shopping-cart",
     510: "fa-exchange",
     511: "fa-database",
     512: "fa-bars",
     513: "fa-trash-o",
     514: "fa-share-alt",
     515: "fa-user",
     516: "fa-star",
     517: "fa-clipboard",
     //内部消息图标：
     13: "fa-comment-o",
     207: "fa-file-o",
     208: "fa-bars",
     210: "fa-search"
 }
