<?php
/**
 * @消息推送类
 */
class SendMobileSms {

	private $_param; //接口配置数组
	private $_connection;//数据库连接对象

	public function __construct() {
		$this->_connection	= $this->_openConnection();//连接数据库
		$this->_param		= $this->_loadParam(); //加载配置文件
	}
	/**
	 * @启动发送
	 * @return boolean
	 */
	public function start() {
		$sendUrl = $this->_param['sendUrl'];//推送地址
		$pushKey = $this->_param['pushKey'];//推送密钥
		if ($sendUrl == '' || $pushKey == '') {
			return false;
		}
		$mobileSms = $this->_getSendMobileSms();
		if ($mobileSms) {
			foreach ($mobileSms as $value) {
				$userAccounts	= $value['USER_ACCOUNTS'];
				$content		= str_replace("\n", '', str_replace('！', '!', str_replace('：', ':', trim($value['SEND_CONTENT']))));
				$hash			= md5(trim($userAccounts . $content . '1' . '{}' . $pushKey));
				$newUrl			= 'http://' . $sendUrl . '/pushMessage.do?userid=' . $userAccounts . '&msg=' . urlencode($content) . '&badge=1&para={}&hash=' . $hash;
				$ch				= curl_init($newUrl);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, true); // 获取数据返回
				curl_setopt($ch, CURLOPT_BINARYTRANSFER, true); // 在启用 CURLOPT_RETURNTRANSFER 时候将获取数据返回
				curl_setopt($ch, CURLOPT_TIMEOUT,30);
				$result = curl_exec($ch);
				$this->_addSendSmsLog($result, $content, $userAccounts);
				curl_close($ch);
				if(!$result){
					continue;
				}
				$query			= 'DELETE FROM mobile_sms WHERE ID=' . $value['ID'];
				$this->_exeQuery($this->_connection, $query);
			}
		}
	}
	/**
	 * @将需推送的消息插入中间表
	 * @param type $userId
	 * @param type $content
	 * @return boolean
	 */
	public function insertMobileSms($userId, $content) {
		$content = SecurityFilter($content);
		if (!$userId) {
			return false;
		}
		$userAccounts	= $this->_getUserIdAndAccount($userId);
		$query			= "INSERT INTO mobile_sms(`USER_ACCOUNTS`,`SEND_CONTENT`,`SEND_STATE`) VALUE ";
		$size			= sizeof($userAccounts);
		foreach ($userAccounts as $key => $userAccount) {
			if ($key == $size - 1) {
				$query .= "('$userAccount','$content',0)";
			} else {
				$query .= "('$userAccount','$content',0) , ";
			}
		}
		$this->_exeQuery($this->_connection, $query);
	}
	/**
	 * @打开数据库连接
	 * @return type
	 */
	private function _openConnection() {
		$dbConfig		= $this->_loadDbConfig();
		$mysqlServer	= $dbConfig['dataurl'];
		$mysqlUser		= $dbConfig['datauser'];
		$mysqlDb		= $dbConfig['dataname'];
		$mysqlPass		= $dbConfig['datapassword'];
		$connection		= mysql_connect($mysqlServer, $mysqlUser, $mysqlPass);
		if (!$connection) {
			die("<h3>数据库连接失败</h3>");
		}
		$myDB = mysql_select_db($mysqlDb, $connection);
		if (!$myDB) {
			die("<h3>数据库选择失败</h3>");
		}
		return $connection;
	}
	/**
	 * @执行数据库操作
	 * @param type $connection
	 * @param type $query
	 * @return type
	 */
	private function _exeQuery($connection, $query) {
		mysql_query("SET NAMES 'utf8'");
		return mysql_query($query, $connection);
	}
	/**
	 * @获取需推送的消息
	 * @return boolean
	 */
	private function _getSendMobileSms() {
		$query		= "SELECT * FROM mobile_sms  ORDER BY `ID` ASC LIMIT 0 ,100";
		$mobileSms	= array();
		$rs			= $this->_exeQuery($this->_connection, $query);
		if ($rs) {
			while ($row = mysql_fetch_array($rs)) {
				$mobileSms[] = $row;
			}
			return $mobileSms;
		}
		return false;
	}
	/**
	 * @获取推送消息相关参数
	 * @staticvar type $param
	 * @return type
	 */
	private function _loadParam() {
		static $param;
		if (isset($param)) {
			return $param;
		}
		$sql	= "SELECT * FROM sys_para WHERE PARA_NAME IN('MOBILE_PUSH_URL','MOBILE_PUSH_KEY','MOBILE_PUSH_BUTTON')";
		$rs		= $this->_exeQuery($this->_connection, $sql);
		$_param = array();
		while ($row = mysql_fetch_array($rs)) {
			if ($row['PARA_NAME'] == 'MOBILE_PUSH_URL') {
				$_param['sendUrl'] = $row['PARA_VALUE'];
			} else if ($row['PARA_NAME'] == 'MOBILE_PUSH_KEY') {
				$_param['pushKey'] = $row['PARA_VALUE'];
			} else if ($row['PARA_NAME'] == 'MOBILE_PUSH_BUTTON') {
				$_param['mobileButton'] = intval($row['PARA_VALUE']);
			}
		}
		$param = $_param;
		return $param;
	}
	/**
	 * @加载数据库配置参数
	 * @return type
	 */
	private function _loadDbConfig() {
		$dir		= dirname(dirname(dirname(dirname(__FILE__))));
		$REGF_DIR	= $dir . "/bin/";
		$configfile = $REGF_DIR . "mysql_config.ini";
		$iniArray	= @parse_ini_file($configfile);
		return $iniArray;
	}
	/**
	 * @获取用户账号
	 * @param type $userId
	 * @return type
	 */
	private function _getUserIdAndAccount($userId) {
		$arrayid	= explode(",", $userId);
		$userIdStr	= '';
		foreach ($arrayid as $v) {
			$userIdStr .= '\'' . SecurityFilter($v) . '\',';
		}
		$userIdStr	= substr($userIdStr, 0, strrpos($userIdStr, ','));
		$userSql	= 'SELECT USER_ACCOUNTS from user WHERE USER_ID IN(' . $userIdStr . ') AND DEPT_ID > 0';
		$userRs		= $this->_exeQuery($this->_connection, $userSql);
		$userAccounts = array();
		while ($userRow = mysql_fetch_array($userRs)) {
			$userAccounts[] = $userRow['USER_ACCOUNTS'];
		}
		return $userAccounts;
	}

	/**
	 * 手机端消息发送日志
	 * @param type $result
	 * @param type $content
	 * @param type $userId
	 */
	private function _addSendSmsLog($result, $content, $userId) {
		$rootpath	= dirname(dirname(dirname(__FILE__)));
		$logName	= $rootpath . '/E-mobile/Public/logs/sms_logs/' . date('Y-m-d') . '.log';
		$handle		= @fopen($logName, 'a');
		$array		= explode('{"', $result);
		$array		= explode('"}', $array[1]);
		$array		= explode(',', str_replace('\"', '', $array[0]));
		$array		= explode(':', str_replace('"', '', $array[0]));
		if ($array[1] == '1') {
			$contents = '发送内容：' . $content . '——接收人账号为:' . $userId . '的消息' . "\t" . '发送成功' . "\t\t" . date('Y-m-d H:i:s') . "\n";
		} else {
			$contents = '发送内容：' . $content . '——接收人账号为:' . $userId . '的消息' . "\t" . '发送失败' . "\t" . $result . "\t\t" . date('Y-m-d H:i:s') . "\n";
		}
		@fwrite($handle, $contents);
		@fclose($handle);
	}

}
