<?php
/**
 *@copyright (C) 2000 - 2010 Weaver Co.Ltd
 *@package   eoffice
 *@name      webservice/address/addr.wsdl.php
 *@version   1.0 
 *@author    liuqingyu
 */
include_once ("inc/checkcurrentsession.php");
include_once ("nusoap/lib/nusoap.php");
include_once ("api/address.class.php");
include_once ("wap/function.php");
include_once ("inc/conn.php");
include_once("inc/utility_all.php");
include_once ("inc/function_picture.php");

$server = new soap_server();
$server->soap_defencoding = "UTF-8";
$server->decode_utf8 = false;
$server->configureWSDL ('AddressServicewsdl','urn:AddressServicewsdl');
$server->wsdl->schemaTargetNamespace = 'urn:AddressServicewsdl';
//定义UseInfor的参数结构
$server->wsdl->addComplexType(
							'UserInfor',
							'complexType',
							'array',
							'all',
							'',
							array(
								  'user_id'    => array('name'=>'user_id','type'=>'xsd:string'),
								  'user_name'  => array('name'=>'user_name','type'=>'xsd:string'),		
								  'session_id' => array('name'=>'session_id','type'=>'xsd:string')		
							)
);

$server->register(
			'GetAddressList',
			array(
				  'offset' => 'xsd:string',
				  'rows' => 'xsd:string',
				  'searchCondition' => 'xsd:string',
				  'checkdiff' => 'xsd:string',
				  'groupdiff' => 'xsd:string',
				  'UserInfor' => 'tns:UserInfor'
				  ),
			array ('return' => 'xsd:string'),
			'urn:AddressServicewsdl',
			'urn:AddressServicewsdl#GetAddressList',
			'rpc',
			'encoded',
			'Get Address GetAddressList'
			);
//获取通讯录列表
function GetAddressList($offset,$rows,$searchCondition,$checkdiff,$groupdiff,$UserInfor) 
{
	CheckCurrentSession ();
	global $ATTACH_PATH;
	$addrApi = new address($UserInfor);
	$Infor = array();
	$addrs = $addrApi->GetAddressInfor($offset,$rows,'',$searchCondition,$checkdiff,$groupdiff);
	foreach($addrs as $index => $val)
	{
		$Infor[$index]["ID"]         = $addrs[$index]["ID"];
		$Infor[$index]["Name"]       = $addrs[$index]["Name"];
		$Infor[$index]["Sex"]        = $addrs[$index]["Sex"];
		$Infor[$index]["Mobile"]     = $addrs[$index]["Mobile"];
		$Infor[$index]["Email"]      = $addrs[$index]["Email"];
		$Infor[$index]["Department"] = $addrs[$index]["Department"];
		$Infor[$index]["GroupID"]    = $addrs[$index]["GroupID"];
		$Infor[$index]["GroupName"]  = $addrs[$index]["GroupName"];
		$Infor[$index]["CREAT_TIME"] = $addrs[$index]["CREAT_TIME"];
		if($addrs[$index]["FRIST_IMAGE"]!="")
		{
			$attachment = pathinfo($addrs[$index]["FRIST_IMAGE"]);	
			$name       = $attachment["basename"];
			$img_src    = ROOT_PATH.$addrs[$index]["FRIST_IMAGE"];
			$urlpic     = createJpeg($img_src,$name,"96","96");
			$Infor[$index]["PIC_DIR"] = $urlpic;	
		}
		else
		{
			$Infor[$index]["PIC_DIR"] = "";		
		}
	}
	return json_encode($Infor);
}
//----------------注册获取通讯录详情
$server->register(
			'GetAddressInformation',
			array(
				  'AddressId' => 'xsd:int',
				  'UserInfor' => 'tns:UserInfor'
				  ),
			array ('return' => 'xsd:string' ),
			'urn:AddressServicewsdl',
			'urn:AddressServicewsdl#GetAddressInformation',
			'rpc',
			'encoded',
			'Get Address GetAddressInformation'
			);
function GetAddressInformation($AddressId,$UserInfor)
{
	CheckCurrentSession ();
	$addrApi = new address($UserInfor);
	$addrs = $addrApi->GetAddressInfor('','',$AddressId,'','','');
	return json_encode($addrs[0]);	
}

//----------------注册获取通讯录的总记录数函数
$server->register(
			'GetAddressAmount',
			array(
				  'searchCondition' => 'xsd:string',
				  'checkdiff' => 'xsd:string',
				  'groupid' => 'xsd:string',
				  'UserInfor' => 'tns:UserInfor'
				  ),
			array('return' => 'xsd:string' ),
			'urn:AddressServicewsdl',
			'urn:AddressServicewsdl#GetAddressAmount',
			'rpc',
			'encoded',
			'Get Address GetAddressAmount'
			);
//获取通讯录的总记录数
function GetAddressAmount($searchCondition,$checkdiff,$groupid,$UserInfor) 
{
	CheckCurrentSession ();
	$addrApi = new address($UserInfor);
	$addrs = $addrApi->GetMyAddressAmount($searchCondition,$checkdiff,$groupid);
	return $addrs;
}
//----------------注册获取通讯录结构函数
//参数结构
$server->wsdl->addComplexType(
	'AddressStructParam',
	'complexType',
	'struct',
	'all',
	'',
	array(
		'diff'    => array('name'=>'diff','type'=>'xsd:string'),
		'groupid' => array('name'=>'groupid','type'=>'xsd:string'),
		'userid'  => array('name'=>'userid','type'=>'xsd:string')
	)
);
$server->register(
			'GetAddressStruct',
			array(
				  'Info' => 'tns:AddressStructParam',
				  ),
			array ('return' => 'xsd:string' ),
			'urn:AddressServicewsdl',
			'urn:AddressServicewsdl#GetAddressStruct',
			'rpc',
			'encoded',
			'Get Address GetAddressStruct'
			);
function GetAddressStruct($Info)
{
	CheckCurrentSession ();
	$addrApi = new address ();
	$AddressStructInfo = $addrApi->GetAddressStruct($Info);
	return json_encode($AddressStructInfo);	
}
$server->service($HTTP_RAW_POST_DATA);
?>