<?
/**
 * @copyright (C) 2000 - 2010 Weaver Co.Ltd
 * @package   eoffice7.3
 * @name      webservice/document/document.wsdl.php
 * @version   1.0 
 * @author    samuel
 * @modify    liuqingyu
 */

include_once("nusoap/lib/nusoap.php");
include_once("api/file.class.php");
include_once("inc/conn.php");
include_once("inc/document_function.php");
include_once("inc/checkcurrentsession.php");
include_once("inc/utility_all.php");

$server = new soap_server ();
$server->soap_defencoding = "UTF-8";
$server->decode_utf8 = false;
$server->configureWSDL ( 'DocumentServicewsdl', 'urn:DocumentServicewsdl' );
$server->wsdl->schemaTargetNamespace = 'urn:DocumentServicewsdl';
//定义UseInfor的参数结构
$server->wsdl->addComplexType(
							'UserInfor',
							'complexType',
							'array',
							'all',
							'',
							array(
								  'user_id'    => array('name'=>'user_id','type'=>'xsd:string'),
								  'user_name'  => array('name'=>'user_name','type'=>'xsd:string'),		
								  'session_id' => array('name'=>'session_id','type'=>'xsd:string')		
							)
);
//--------------------------------定义传入参数的结构
$server->wsdl->addComplexType(
				'FileSearchType',
				'complexType',
				'struct',
				'all',
				'',
				array(
					  'FileCreatUser' => array('name'=>'FileCreatUser','type'=>'xsd:string'),
					  'FileName'      => array('name'=>'FileName','type'=>'xsd:string'),
					  'FileType'      => array('name'=>'FileType','type'=>'xsd:string'),
					  'FileList'      => array('name'=>'FileList','type'=>'xsd:string')
					  )
				);
$server->register(
			'GetDocumentInforList',
			array(
				  'orderBy'         => 'xsd:string',
				  'limitOffset'     => 'xsd:string',
				  'limitRows'       => 'xsd:string',
				  'SearchType'      => 'tns:FileSearchType',
				  'UserInfor'       => 'tns:UserInfor'
				  ),
			array('return' => 'xsd:string' ),
			'urn:DocumentServicewsdl',
			'urn:DocumentServicewsdl#GetDocumentInforList',
			'rpc',
			'encoded',
			'Get Public GetDocumentInforList'
			);
//获取文档信息列表
function GetDocumentInforList($orderBy,$limitOffset,$limitRows,$SearchType,$UserInfor)
{
	CheckCurrentSession ();
	$read = new read($UserInfor);
	$result = $read->GetDocumentContent('',$SearchType["FileName"],$orderBy,$limitOffset,$limitRows,$SearchType);
	$Infor = array();
	foreach($result as $index => $val)
	{
		$Infor[$index]["SortId"]        = $result[$index]["SortId"];
		$Infor[$index]["DocumentId"]    = $result[$index]["DocumentId"];
		$Infor[$index]["Subject"]       = $result[$index]["Subject"];
		$Infor[$index]["SendTime"]      = $result[$index]["SendTime"];
		$Infor[$index]["UserName"]      = $result[$index]["UserName"];
		$Infor[$index]["UserId"]        = $result[$index]["UserId"];
		$Infor[$index]["DocumentId"]    = $result[$index]["DocumentId"];
		$Infor[$index]["CONTENT_TYPE"]  = $result[$index]["CONTENT_TYPE"];
		//判断已读、未读
		$check = $read->CheckFileRead($Infor[$index]["DocumentId"]);
		if($check)
		{
			//未读
			$Infor[$index]["InformationRead"] = "0";	
		}
		else
		{
			//已读
			$Infor[$index]["InformationRead"] = "1";		
		}
	}
	return json_encode($Infor);
}
$server->register(
			'GetDocumentInformation',
			array(
				  'DocumentId'      => 'xsd:int',
				  'UserInfor'       => 'tns:UserInfor'
				  ),
			array('return' => 'xsd:string' ),
			'urn:DocumentServicewsdl',
			'urn:DocumentServicewsdl#GetDocumentInformation',
			'rpc',
			'encoded',
			'Get Public GetDocumentInformation'
			);
//获取文档信息
function GetDocumentInformation($DocumentId,$UserInfor)
{
	CheckCurrentSession ();
	$read = new read($UserInfor);
	$infor = $read->getDocumentResoultById($DocumentId,"","webservice");
	$fileInfor = array();
	$fileInfor["SortId"]        = $infor["SortId"];
	$fileInfor["Subject"]       = $infor["Subject"];
	$fileInfor["SendTime"]      = $infor["SendTime"];
	$fileInfor["UserName"]      = $infor["UserName"];
	$fileInfor["UserId"]        = $infor["UserId"];
	$fileInfor["Content"]       = $infor["Content"];
	$fileInfor["AttachmentDir"] = GetATTACHMENTURL($infor["AttachmentId"],$infor["AttachmentName"]);
	$fileInfor["LinkDoc"]       = $infor["LinkDoc"];
	$fileInfor["DocumentId"]    = $infor["DocumentId"];
	$fileInfor["CONTENT_TYPE"]  = $infor["ContentType"];
	//$infor = $read->GetDocumentContent($DocumentId,'','','','',array());
	//添加日志信息
	$read->AddFileReadDiary($DocumentId,'3','file_content','');
	return json_encode($fileInfor);
}
//--------------------------------定义参数结构
$server->wsdl->addComplexType(
				'FileSearchCount',
				'complexType',
				'struct',
				'all',
				'',
				array(
					  'FileName'      => array('name'=>'FileName','type'=>'xsd:string'),
					  'FileCreatUser' => array('name'=>'FileCreatUser','type'=>'xsd:string'),
					  'FileType'      => array('name'=>'FileType','type'=>'xsd:string'),
					  'FileList'      => array('name'=>'FileList','type'=>'xsd:string')
					  )
				);

$server->register(
			'GetDocumentAmount',
			array('FileSearch'=>'tns:FileSearchCount','UserInfor' => 'tns:UserInfor'),
			array('return' => 'xsd:string' ),
			'urn:DocumentServicewsdl',
			'urn:DocumentServicewsdl#GetDocumentAmount',
			'rpc',
			'encoded',
			'Get Document GetDocumentAmount'
			);
//获取文档数量
function GetDocumentAmount($FileSearch,$UserInfor) {
	CheckCurrentSession ();
	$read = new read($UserInfor);
	return $read->GetDocumentCount($FileSearch);
}
//--------------------------------获取未读文档数量
$server->register(
			'GetUnReadFileAmount',
			array('FileSearch'=>'tns:FileSearchType','UserInfor' => 'tns:UserInfor'),
			array('return' => 'xsd:string' ),
			'urn:DocumentServicewsdl',
			'urn:DocumentServicewsdl#GetUnReadFileAmount',
			'rpc',
			'encoded',
			'Get Document GetUnReadFileAmount'
			);
//获取未读文档数量
function GetUnReadFileAmount($FileSearch,$UserInfor) {
	CheckCurrentSession ();
	$read = new read($UserInfor);
	return $read->GetUnReadFileCount($FileSearch);
}

//---------------------------------获取文档回复
$server->register(
			'GetDocumentReply',
			array(
				  'DocumentId' => 'xsd:string'
				  ),
			array('return' => 'xsd:string' ),
			'urn:DocumentServicewsdl',
			'urn:DocumentServicewsdl#GetDocumentReply',
			'rpc',
			'encoded',
			'Get Public Document reply'
			);

//获取文档回复
function GetDocumentReply($DocumentId)
{
	CheckCurrentSession ();
	$read = new read ();
	$Infor = $read->GetDocumentReply($DocumentId);
	return json_encode($Infor);
}

$server->register(
			'GetDocumentList',
			array(
				  'DocumentId' => 'xsd:string'
				  ),
			array('return' => 'xsd:string' ),
			'urn:DocumentServicewsdl',
			'urn:DocumentServicewsdl#GetDocumentList',
			'rpc',
			'encoded',
			'Get Public Document List'
			);
//获取当前文档目录信息
function GetDocumentList($DocumentId)
{
	CheckCurrentSession ();
	$read = new read ();
	$Infor = $read->GetDocumentList($DocumentId);	
	return json_encode($Infor);	
}

//--------------------------------
$server->register(
			'GetFileRelation',
			array(
				  'SortDiff' => 'xsd:string',
				  'SortId'   => 'xsd:string',
				  'UserInfor' => 'tns:UserInfor'
				  ),
			array('return' => 'xsd:string' ),
			'urn:DocumentServicewsdl',
			'urn:DocumentServicewsdl#GetFileRelation',
			'rpc',
			'encoded',
			'Get Public Document ListRealation'
			);
//获取文件夹的上下级关系
function GetFileRelation($SortDiff,$SortId,$UserInfor)
{
	CheckCurrentSession ();
	$read = new read($UserInfor);
	$Infor = $read->GetFileRelation($SortDiff,$SortId);	
	return json_encode($Infor);		
}
//--------------------------------定义参数结构
$server->wsdl->addComplexType(
				'SaveReply',
				'complexType',
				'struct',
				'all',
				'',
				array(
					  'UserId'       => array('name'=>'UserId','type'=>'xsd:string'),
					  'DocumentId'   => array('name'=>'DocumentId','type'=>'xsd:string'),
					  'ReplyTime'    => array('name'=>'ReplyTime','type'=>'xsd:string'),
					  'ReplyContent' => array('name'=>'ReplyContent','type'=>'xsd:string')
					  )
				);

$server->register(
			'SaveFileReply',
			array('Reply'=>'tns:SaveReply'),
			array('return' => 'xsd:string' ),
			'urn:DocumentServicewsdl',
			'urn:DocumentServicewsdl#SaveFileReply',
			'rpc',
			'encoded',
			'Get Document Reply'
			);
//保存文档回复
function SaveFileReply($Reply)
{
	CheckCurrentSession ();
	$read = new read ();
	return $read->SaveFileReply($Reply);		
}
//--------------------------------
$server->register(
			'GetFilePurview',
			array(
				  'SortId'=>'xsd:string'
				  ),
			array(
				  'return' => 'xsd:string'
				  ),
			'urn:DocumentServicewsdl',
			'urn:DocumentServicewsdl#GetFilePurview',
			'rpc',
			'encoded',
			'Get Document GetFilePurviewply'
			);
//获取文件夹权限
function GetFilePurview($SortId)
{
	CheckCurrentSession ();
	$read = new read ();
	$Infor = $read->GetFilePurview($SortId);
	return json_encode($Infor);	
}
//新建文档
//--------------------------------定义返回结构
$server->wsdl->addComplexType(
				'filearray',
				'complexType',
				'struct',
				'all',
				'',
				array(
					  'subject'        => array('name'=>'subject','type'=>'xsd:string'),
					  'sortid'         => array('name'=>'sortid','type'=>'xsd:string'),
					  'content'        => array('name'=>'content','type'=>'xsd:string'),
					  'attachmentid'   => array('name'=>'attachmentid','type'=>'xsd:string'),
					  'attachmentname' => array('name'=>'attachmentname','type'=>'xsd:string')
					  )
				);
$server->register(
			'NewCreatFile',
			array(
				  'filedata'        => 'tns:filearray',
				  'UserInfor'       => 'tns:UserInfor',
				  'diff'            => 'xsd:string'
				  ),
			array('return' => 'xsd:string' ),
			'urn:DocumentServicewsdl',
			'urn:DocumentServicewsdl#NewCreatFile',
			'rpc',
			'encoded',
			'Get Public NewCreatFile'
			);
function NewCreatFile($filedata,$UserInfor,$diff)
{
	CheckCurrentSession ();
	$read = new read($UserInfor);
	$documentid = $read->CreatNewDocument($filedata,$diff);	
	return json_encode($documentid);
}
$server->service ( $HTTP_RAW_POST_DATA );
?>