<?php
/**
 * @copyright (C) 2000 - 2010 Weaver Co.Ltd
 * @package   eoffice7.3
 * @name      webservice/email/email.wsdl.php
 * @version   1.0 
 * @author    liuqingyu
 */
include_once("nusoap/lib/nusoap.php");
include_once("api/email.class.php");
include_once("inc/conn.php");
include_once("inc/oa_config.php");
include_once("inc/checkcurrentsession.php");
include_once("inc/utility_all.php");
global $ATTACH_PATH;
$attachment_url = str_replace ( ROOT_PATH, ROOT_URL, $ATTACH_PATH );
session_start();
/*************************************
 * 实例化soap_server对象并初始化
 *************************************/ 
$server         = new soap_server();
$server->soap_defencoding = "UTF-8";
$server->decode_utf8      = false;
$server->configureWSDL('EmailServicewsdl','EmailServicewsdl');
$server->wsdl->schemaTargetNamespace = 'EmailServicewsdl';
//定义UseInfor的参数结构
$server->wsdl->addComplexType(
							'UserInfor',
							'complexType',
							'array',
							'all',
							'',
							array(
								  'user_id'    => array('name'=>'user_id','type'=>'xsd:string'),
								  'user_name'  => array('name'=>'user_name','type'=>'xsd:string'),		
								  'session_id' => array('name'=>'session_id','type'=>'xsd:string')		
							)
);

/******************************************
 * 添加类型
 ******************************************/
$server->wsdl->addComplexType(
	'EmailOtherParams','complexType','struct','all','',
	array(
		'words' => array('name'=>'words','type'=>'xsd:string'),
		'orderby' => array('name'=>'orderby','type'=>'xsd:string'),
		'page' =>array('name'=>'page','type'=>'xsd:string'),
		'limit' => array('name'=>'limit','type'=>'xsd:string')		
	)
);

$server->wsdl->addComplexType('InsertData','complexType','array','all','',
	array(
		'receiver_id'     => array('name'=>'receiver_id','type'=>'xsd:string'),
		'subject'         => array('name'=>'subject','type'=>'xsd:string'),
		'content'         => array('name'=>'content','type'=>'xsd:string'),
		'attachment_id'   => array('name'=>'attachment_id','type'=>'xsd:string'),
		'attachment_name' => array('name'=>'attachment_name','type'=>'xsd:string'),		
		'send_flag'       => array('name'=>'send_flag','type'=>'xsd:string'),
		'CopyToId'        => array('name'=>'CopyToId','type'=>'xsd:string')
	)
);
/******************************************
 * 	Functions
 ******************************************/
/**
 * 身份验证
 * @param string $sessionid
 */	
function authCheck($UserInfor){
	CheckCurrentSession();
	return new email($UserInfor);
}

$server->register('AddNewEamil',
	array('data' => 'tns:InsertData','UserInfor' => 'tns:UserInfor'), 
	array('return' => 'xsd:string'),
	'urn:EmailServicewsdl',
	'urn:EmailServicewsdl#AddNewEamil',
	'rpc','encoded',
	'send an internal AddNewEamil'
	);
/**
 * 增加保存邮件
 * @param array $data array 邮件内容数组
 * @return string 新增邮件的ID串 
 */
function AddNewEamil($data,$UserInfor){
	$email = authCheck($UserInfor);
	$result = $email->addEmail($data);
	$infor = "";
	if($result!=""){
		$infor = "1";	
	}else{
		$infor = "0";		
	}
	return $infor;
}
###
$server->register('DeleteEmail',
	array('id' => 'xsd:string'), 
	array('return' => 'xsd:string'),
	'urn:EmailServicewsdl',
	'urn:EmailServicewsdl#DeleteEmail',
	'rpc','encoded',
	'del an Email By email Id'
	);
/**
 * 按指定id删除邮件
 * @param int $id 邮件ID
 * @return 成功1 or 失败0
 */
function DeleteEmail($EmailId){
	$email = authCheck(array());
	if(empty($EmailId))
	{
		return 0;	
	}
	if(strstr($EmailId,","))
	{
		$id_array = explode(',', $EmailId);	
		$email->delEmailByIds($id_array);
		return 1;
	}
	else
	{
		$email->delEmailById($EmailId);
		return 1;		
	}
}
##
$server->register('getAttachment',
	array('file' => 'xsd:string'), 
	array('return' => 'xsd:string'),
	'urn:EmailServicewsdl',
	'urn:EmailServicewsdl#getAttachment',
	'rpc','encoded',
	'get Attachment infomation,return as json'
	);
/**
 * 获取邮件附件名
 * @param file $file 文件名
 * @return json  文件信息
 */
function getAttachment( $file ='' ){
	$email = authCheck(array());
	$data = $email->getAttachment($file);
	return json_encode($data);
}
##
$server->register('getEmailAmount',
	array('boxtype' => 'xsd:string','word'=>'xsd:string','UserInfor' => 'tns:UserInfor'), 
	array('return' => 'xsd:string'),
	'urn:EmailServicewsdl',
	'urn:EmailServicewsdl#getEmailAmount',
	'rpc','encoded',
	'get Email Amount'
	);
/**
 * 取得邮件数量
 * @param string $boxtype 邮箱文件夹类型
 * @param string $words 搜索关键字
 * @return 邮件数量
 */
function getEmailAmount($boxtype,$words,$UserInfor){
	$email = authCheck($UserInfor);
	return $email->getEmailAmount($boxtype,$words);
}
##
$server->register('GetEmailSingle',
	array('id' => 'xsd:int','box'=>'xsd:string'), 
	array('return' => 'xsd:string'),
	'urn:EmailServicewsdl',
	'urn:EmailServicewsdl#GetEmailSingle',
	'rpc','encoded',
	'get Email information By GetEmailSingle'
	);
/**
 * get email by email id 
 * @param int $id email id
 * @return array email info
 */
function GetEmailSingle($id,$box){
	global $attachment_url;
	$email      = authCheck(array());
	$Infor      = array();
	$data       = $email->getEmailById($id,$box);
	$name_array = explode('*',$data['ATTACHMENT_NAME']);
	$id_array   = explode(',',$data['ATTACHMENT_ID']);	
	foreach($id_array as $id_index => $id){
		if($id == '') continue;
		$id_array[$id_index] = $attachment_url.$id.'/'.$name_array[$id_index];
	}
	//$data['ATTACHMENT_ID'] = implode(',',$id_array);
	$Infor['EMAIL_ID']          = $data['EMAIL_ID'];
	$Infor['FROM_ID']           = $data['FROM_ID'];
	$Infor['FROM_NAME']         = $data['FROM_NAME'];
	$Infor['TO_ID']             = $data['TO_ID'];
	$Infor['TO_ID2']            = $data['TO_ID2'];
	$Infor['COPY_TO_ID']        = $data['COPY_TO_ID'];
	$Infor['SECRET_TO_ID']      = $data['SECRET_TO_ID'];
	if($data['TO_ID']==""){
		$data['TO_ID_NAME'] = "";	
	}else{
		if(strpos($data['TO_ID'],",")){
			$Infor['TO_ID_NAME']        = getUsernameStr($data['TO_ID']);	
		}else{
			$Infor['TO_ID_NAME']        = getUserNameNew($data['TO_ID']);	
		}	
	}
	if($data['SEND_FLAG']==0){
		$data['TO_ID2'] = $data['TO_ID'];
		$data['TO_ID2_NAME'] = $data['TO_ID_NAME'];
	}else
	{
		if($data['TO_ID2']==""){
			$data['TO_ID2_NAME'] = "";	
		}else{
			$data['TO_ID2_NAME']       = getUsernameStr($data['TO_ID2']);	
		}	
	}
	/*if($data['TO_ID2']==""){
		$Infor['TO_ID2_NAME'] = "";	
	}else{
		$Infor['TO_ID2_NAME']       = getUsernameStr($data['TO_ID2']);	
	}*/
	if($data['COPY_TO_ID']==""){
		$Infor['COPY_TO_ID_NAME'] = "";	
	}else{
		$Infor['COPY_TO_ID_NAME']   = getUsernameStr($data['COPY_TO_ID']);	
	}
	if($data['SECRET_TO_ID']==""){
		$Infor['SECRET_TO_ID_NAME'] = "";	
	}else{
		$Infor['SECRET_TO_ID_NAME'] = getUsernameStr($data['SECRET_TO_ID']);	
	}
	$Infor['SUBJECT']           = $data['SUBJECT'];
	$Infor['CONTENT']           = $data['CONTENT'];
	$Infor['SEND_TIME']         = $data['SEND_TIME'];
	$Infor['ATTACHMENT_ID']     = $data['ATTACHMENT_ID'];
	$Infor['ATTACHMENT_NAME']   = $data['ATTACHMENT_NAME'];
	$Infor['ATTACHMENT_DIR']    = implode(',',$id_array);
	$Infor['READ_FLAG']         = $data['READ_FLAG'];
	$Infor['SEND_FLAG']         = $data['SEND_FLAG'];
	$Infor['DELETE_FLAG']       = $data['DELETE_FLAG'];
	$Infor['SMS_REMIND']        = $data['SMS_REMIND'];
	$Infor['BOX_ID']            = $data['BOX_ID'];
	$Infor['DELETE_BY_SENT']    = $data['DELETE_BY_SENT'];
	return json_encode($Infor);
}
##
$server->register('GetAllEmails',
	array('boxtype' => 'xsd:string',
	'others'=>'tns:EmailOtherParams',
	'UserInfor' => 'tns:UserInfor'
	), 
	array('return' => 'xsd:string'),
	'urn:EmailServicewsdl',
	'urn:EmailServicewsdl#GetAllEmails',
	'rpc','encoded',
	'get Email list as GetAllEmails'
	);
/**
 * 获取邮件列表
 * @param string $boxtype 邮箱文件夹类型
 * @param array $others array 搜索关键字等其他sql限制
 * @param bool $return_json 是否返回JSON类型,默认为false
 * @return 邮件列表内容数组
 */
function GetAllEmails($boxtype = -1,$others = array(),$UserInfor){
	$email      = authCheck($UserInfor);
	$data       = $email->getEmails($boxtype,'',$others);
	$EmailInfor = array();
	foreach($data as $index => $val){
		$EmailInfor[$index]['EMAIL_ID']          = $data[$index]['EMAIL_ID'];
		$EmailInfor[$index]['FROM_ID']           = $data[$index]['FROM_ID'];
		$EmailInfor[$index]['FROM_NAME']         = $data[$index]['FROM_NAME'];
		$EmailInfor[$index]['TO_ID']             = $data[$index]['TO_ID'];
		$EmailInfor[$index]['TO_ID2']            = $data[$index]['TO_ID2'];
		$EmailInfor[$index]['COPY_TO_ID']        = $data[$index]['COPY_TO_ID'];
		$EmailInfor[$index]['SECRET_TO_ID']      = $data[$index]['SECRET_TO_ID'];
		$EmailInfor[$index]['SUBJECT']           = $data[$index]['SUBJECT'];
		$EmailInfor[$index]['SEND_TIME']         = $data[$index]['SEND_TIME'];
		$EmailInfor[$index]['READ_FLAG']         = $data[$index]['READ_FLAG'];
		$EmailInfor[$index]['SEND_FLAG']         = $data[$index]['SEND_FLAG'];
		$EmailInfor[$index]['DELETE_FLAG']       = $data[$index]['DELETE_FLAG'];
		$EmailInfor[$index]['SMS_REMIND']        = $data[$index]['SMS_REMIND'];
		$EmailInfor[$index]['BOX_ID']            = $data[$index]['BOX_ID'];
		$EmailInfor[$index]['DELETE_BY_SENT']    = $data[$index]['DELETE_BY_SENT'];
		$EmailInfor[$index]['TO_ID_NAME']        = getUserNameNew($val['TO_ID']);
		$EmailInfor[$index]['TO_ID2_NAME']       = getUsernameStr($val['TO_ID2']);
		$EmailInfor[$index]['COPY_TO_ID_NAME']   = getUsernameStr($val['COPY_TO_ID']);
		$EmailInfor[$index]['SECRET_TO_ID_NAME'] = getUsernameStr($val['SECRET_TO_ID']);
	}
	return json_encode($EmailInfor);
}

##
$server->register('getInboxMailCount',
	array('userid' => 'xsd:string'), 
	array('return' => 'xsd:string'),
	'urn:EmailServicewsdl',
	'urn:EmailServicewsdl#getInboxMailCount',
	'rpc','encoded',
	'get the amount of Inbox'
	);
/**
 * 取得收件箱邮件数量
 * @param int $userid 用户ID
 * @return 邮件数量
 */
function getInboxMailCount($userid){
	$email = authCheck(array());
	return $email->getInboxMailCount($userid);
}
##
$server->register('getNewEmailAmount',
	array('keyword' => 'xsd:string','UserInfor' => 'tns:UserInfor'), 
	array('return' => 'xsd:string'),
	'urn:EmailServicewsdl',
	'urn:EmailServicewsdl#getNewEmailAmount',
	'rpc','encoded',
	'get the Amount of New Email'
	);
/**
 * 获取新邮件的数量
 * @param string $keyword 搜索关键字
 * @return 邮件数量
 */
function getNewEmailAmount($keyword="",$UserInfor){
	$email = authCheck($UserInfor);
	return $email->getNewEmailAmount($keyword);
}
##
$server->register('getPreNextEmail',
	array('emailid' => 'xsd:int','flag'=>'xsd:string','UserInfor' => 'tns:UserInfor'), 
	array('return' => 'xsd:string'),
	'urn:EmailServicewsdl',
	'urn:EmailServicewsdl#getPreNextEmail',
	'rpc','encoded',
	'get the pre or next Email'
	);
/**
 * 取得上/下一封邮件
 * @param int $emailid 邮件id
 * @param string $flag 上(pre)/下(next)标志
 * @return 邮件内容数组
 */
function getPreNextEmail($emailid,$flag,$UserInfor){
	$email = authCheck($UserInfor);
	if($flag=="pre")
	{
		$checkflag = "pre";	
	}
	else
	{
		$checkflag = "next";		
	}
	return json_encode($email->getPreNextEmail($emailid,$checkflag));
}
##
$server->register('getUnreadMailCount',
	array('userid' => 'xsd:string'), 
	array('return' => 'xsd:string'),
	'urn:EmailServicewsdl',
	'urn:EmailServicewsdl#getUnreadMailCount',
	'rpc','encoded',
	'get the amount of unread mail'
	);
/**
 * get Unread Mail Count
 * @param int $userid user id
 * @return mail count
 */
function getUnreadMailCount($userid){
	$email = authCheck(array());
	return $email->getUnreadMailCount($userid);
}

/**
 * 新版邮件发送02
 */
 //定义参数结构
$server->wsdl->addComplexType(
		  'NewSendParams',
		  'complexType',
		  'struct',
		  'all',
		  '',
		  array
		  (
			  'SendFlag'       => array('name'=>'SendFlag','type'=>'xsd:string'),
			  'FromId'         => array('name'=>'FromId','type'=>'xsd:string'),
			  'ToId'           => array('name'=>'ToId','type'=>'xsd:string'),
			  'ToId2'          => array('name'=>'ToId2','type'=>'xsd:string'),
			  'CopyToId'       => array('name'=>'CopyToId','type'=>'xsd:string'),
			  'SecretToId'     => array('name'=>'SecretToId','type'=>'xsd:string'),
			  'Subject'        => array('name'=>'Subject','type'=>'xsd:string'),
			  'Content'        => array('name'=>'Content','type'=>'xsd:string'),
			  'Sendtime'       => array('name'=>'Sendtime','type'=>'xsd:string'),
			  'AttachmentId'   => array('name'=>'AttachmentId','type'=>'xsd:string'),
			  'AttachmentName' => array('name'=>'AttachmentName','type'=>'xsd:string')
		  )
);
$server->register(
	'NewSendEmail',
	array(
		  'Info' => 'tns:NewSendParams'
		  ), 
	array(
		  'return' => 'xsd:string'
		  ),
	'urn:EmailServicewsdl',
	'urn:EmailServicewsdl#NewSendEmail',
	'rpc','encoded',
	'update Email NewSendEmail'
	);

function NewSendEmail($Info)
{
	$email = authCheck(array());
	if($Info["Sendtime"]=="")
	{
		$Info["Sendtime"] = date('Y-m-d H:i:s',time());		
	}
	$email->NewSendEmail($Info);
	return 1;
}

##
$server->register('updateEmailStatus',
	array('emailid' => 'xsd:int'), 
	array('return' => 'xsd:string'),
	'urn:EmailServicewsdl',
	'urn:EmailServicewsdl#updateEmailStatus',
	'rpc','encoded',
	'update Email Status'
	);
/**
 * 更新邮件为已读状态
 * @param int $emailid 邮件ID
 * @return 成功1
 */
function updateEmailStatus($emailid){
	$email = authCheck(array());
	$email->updateEmailStatus($emailid);
	return 1;
}

//返回数据
$server->service($HTTP_RAW_POST_DATA);
?>