<?php
/**
 * @copyright (C) 2000 - 2010 Weaver Co.Ltd
 * @package   eoffice7.0
 * @name      webroot/webservice/news/news.wsdl.php
 * @version   1.0 
 * @author    liuqingyu
 */

include_once ("nusoap/lib/nusoap.php");
include_once ("api/news.class.php");
include_once ("api/user.class.php");
include_once ("inc/conn.php");
include_once ("inc/function_picture.php");
include_once ("inc/utility_all.php");
include_once ("inc/checkcurrentsession.php");
/*---------实例化soap_server对象并初始化---------*/
$server                   = new soap_server();
$server->soap_defencoding = "UTF-8";
$server->decode_utf8      = false;
$server->configureWSDL ( 'NewsServicewsdl', 'urn:NewsServicewsdl' );
$server->wsdl->schemaTargetNamespace = 'urn:NewsServicewsdl';
/*---------注册获取新闻列表函数---------*/
//定义参数类型
$server->wsdl->addComplexType(
		'NewsSearch',
		'complexType',
		'array',
		'all',
		'',
		array(
			  'NewsSubject'     => array('name'=>'NewsSubject','type'=>'xsd:string'),
			  'NewsSort'        => array('name'=>'NewsSort','type'=>'xsd:string'),		
			  'NewsOther'       => array('name'=>'NewsOther','type'=>'xsd:string')		
		)
);
$server->register (
		'GetNewsList',
		array (
			   'start'  => 'xsd:string',
			   'limit'  => 'xsd:string',
			   'search' => 'tns:NewsSearch',
			   'UserId' => 'xsd:string'
			   ),
		array ('return' => 'xsd:string'),
		'urn:NewsServicewsdl',
		'urn:NewsServicewsdl#GetNewsList',
		'rpc',
		'encoded',
		'Get E-office news GetNewsList'
	);

/*
@function:  获取新闻 列表
@parameter: $a->          string  :每页显示的条数
			$b->          string  :当前页从第几条开始显示
			$c->          string  :需要获取新闻的ID号
@return:    $news->       Array   :新闻的详细信息
*/
function GetNewsList($start,$limit,$search,$UserId) {
	CheckCurrentSession();
	global $ATTACH_PATH;
	$newsApi = new news ();
	$news    = $newsApi->getNewsInfo($limit,$start,"",$search);
	$Infor   = array();
	foreach($news as $index => $val)
	{
		$Infor[$index]['NEWS_ID']          = $news[$index]['NEWS_ID'];
		$Infor[$index]['SUBJECT']          = $news[$index]['SUBJECT'];
		$Infor[$index]['PROVIDER']         = $news[$index]['PROVIDER'];
		$Infor[$index]['PROVIDER_NAME']    = $news[$index]['PROVIDER_NAME'];
		$Infor[$index]['USER_PRIV']        = $news[$index]['USER_PRIV'];
		$Infor[$index]['NEWS_TIME']        = $news[$index]['NEWS_TIME'];
		$Infor[$index]['CLICK_COUNT']      = $news[$index]['CLICK_COUNT'];
		$Infor[$index]['NEWS_TYPE_ID']     = $news[$index]['NEWS_TYPE_ID'];
		$Infor[$index]['ALLOW_REPLY']      = $news[$index]['ALLOW_REPLY'];
		$Infor[$index]['news_reader']      = $news[$index]['news_reader'];
		$Infor[$index]['news_reader_name'] = getUsernameStr($val['news_reader']);
		//判断新闻已读、未读
		if(strstr($Infor[$index]['news_reader'],$UserId.","))
		{
			//已读
			$Infor[$index]['InformationRead'] = "0";	
		}
		else
		{
			//未读
			$Infor[$index]['InformationRead'] = "1";	
		}
		$Infor[$index]['ATTACHMENT_ID']    = $news[$index]['ATTACHMENT_ID'];
		$Infor[$index]['ATTACHMENT_NAME']  = $news[$index]['ATTACHMENT_NAME'];
		if($news[$index]['ATTACHMENT_ID']!="")
		{
			$rootpic = $ATTACH_PATH.$news[$index]['ATTACHMENT_ID']."/".$news[$index]['ATTACHMENT_NAME'];
			$urlpic  = createJpeg2($rootpic,$news[$index]['ATTACHMENT_NAME'],"96","96",$news[$index]['ATTACHMENT_ID']);
			$Infor[$index]['PICTURE_DIR'] = $urlpic;	
		}
		else
		{
			$Infor[$index]['PICTURE_DIR'] = "";		
		}
	}
	return json_encode($Infor);
}
/*---------注册获取新闻详细信息---------*/
$server->register (
		'GetNewsInformation',
		array (
			   'NewsId' => 'xsd:string',
			   'UserId' => 'xsd:string'
			   ),
		array ('return' => 'xsd:string'),
		'urn:NewsServicewsdl',
		'urn:NewsServicewsdl#GetNewsInformation',
		'rpc',
		'encoded',
		'Get E-office news GetNewsInformation'
	);
/*
@function:  获取新闻详细信息
@parameter: $NewsId->     string  :新闻ID号
@return:    $news->       Array   :新闻的详细信息
*/
function GetNewsInformation($NewsId,$UserId) {
	CheckCurrentSession();
	$newsApi = new news ();
	//添加阅读人员
	$AddReader = $newsApi->AddNewsReader($NewsId,$UserId);
	$news = $newsApi->getNewsInfo("","",$NewsId,array());
	foreach($news as $index => $val)
	{
		$news[$index]['news_reader_name'] = getUsernameStr($val['news_reader']);	
	}
	$ReplyData = $newsApi->GetNewsReply($news[0]["NEWS_ID"]);
	foreach($ReplyData as $index => $val)
	{
		$ReplyData[$index]['USER_NAME'] = getUserNameNew($val['USER_ID']);	
	}
	$news[0]["Reply"] = $ReplyData;
	return json_encode($news[0]);
}

/*---------注册获取新闻数目函数getNewsAmount---------*/
$server->register(
		'getNewsAmount',
		array('search' => 'tns:NewsSearch'),
		array('return' => 'xsd:string'),
		'urn:NewsServicewsdl',
		'urn:NewsServicewsdl#getNewsAmount',
		'rpc',
		'encoded',
		'Get E-office news count'
	);
/*
@function:  获取新闻数量
@parameter: 无
@return:    $counts->       string   :新闻的数量
*/
function getNewsAmount($search){
	CheckCurrentSession();
	$newsapi = new news();
	$counts  = $newsapi->GetNewsCount($search);
    return $counts;	
	}
	
/*---------注册获取新闻类别信息函数---------*/

$server->register(
		'GetNewsSort',
		array('SortId' => 'xsd:int'),
		array('return' => 'xsd:string'),
		'urn:NewsServicewsdl',
		'urn:NewsServicewsdl#GetNewsSort',
		'rpc',
		'encoded',
		'Get E-office news GetNewsSort'
	);
/*
@function:  获取新闻类别信息
@parameter: 无
@return:    $counts->       string   :新闻类别信息
*/
function GetNewsSort($SortId){
	CheckCurrentSession();
	$newsapi = new news();
	$Infor  = $newsapi->GetNewsSortInformation($SortId);
    return json_encode($Infor);	
	}
/*---------注册获取未读新闻数量函数---------*/
$server->register(
		'GetNewsUnreadSum',
		array('UserId' => 'xsd:string'),
		array('return' => 'xsd:int'),
		'urn:NewsServicewsdl',
		'urn:NewsServicewsdl#GetNewsUnreadSum',
		'rpc',
		'encoded',
		'Get E-office news GetNewsUnreadSum'
	);
/*
@function:  获取新闻未读数量
@parameter: 
@return:    $counts->       string   :新闻的数量
*/
function GetNewsUnreadSum($UserId){
	CheckCurrentSession();
	$newsapi = new news();
	$Infor  = $newsapi->NewUnreadSum($UserId);
    return $Infor;	
	}		

//返回数据
$HTTP_RAW_POST_DATA = isset($HTTP_RAW_POST_DATA) ? $HTTP_RAW_POST_DATA : '';
$server->service($HTTP_RAW_POST_DATA);

?>