<?php
/**
* @copyright (C) 2000 - 2010 Weaver Co.Ltd
* @package   eoffice7.0
* @name      webroot/webservice/notify/notify.wsdl.php
* @version   1.0 
* @author    liuqingyu
*/
include_once("nusoap/lib/nusoap.php");
include_once("api/notify.class.php");
include_once("api/user.class.php");
include_once("inc/conn.php");
include_once("wap/function.php");
//session处理
include_once("inc/checkcurrentsession.php");
//实例化soap_server对象并初始化
$server                   = new soap_server();
$server->soap_defencoding = "UTF-8";
$server->decode_utf8      = false;
$server->configureWSDL('notifyServicewsdl','urn:notifyServicewsdl');
$server->wsdl->schemaTargetNamespace = 'urn:notifyServicewsdl';
//定义UseInfor的参数结构
$server->wsdl->addComplexType(
							'UserInfor',
							'complexType',
							'array',
							'all',
							'',
							array(
								  'user_id'    => array('name'=>'user_id','type'=>'xsd:string'),
								  'user_name'  => array('name'=>'user_name','type'=>'xsd:string'),		
								  'session_id' => array('name'=>'session_id','type'=>'xsd:string')		
							)
);
//定义参数类型
$server->wsdl->addComplexType(
		'NotifySearch',
		'complexType',
		'array',
		'all',
		'',
		array(
			  'NotifySubject'     => array('name'=>'NotifySubject','type'=>'xsd:string'),
			  'NotifySort'        => array('name'=>'NotifySort','type'=>'xsd:string'),		
			  'NotifyOther'       => array('name'=>'NotifyOther','type'=>'xsd:string')		
		)
);
/*---------注册获取公告信息函数getNotifyInfo---------*/
$server->register(
		'GetNotifyList',
		array(
			  'start' => 'xsd:string',
			  'limit'=> 'xsd:string',
			  'search'=> 'tns:NotifySearch',
			  'UserInfor' => 'tns:UserInfor'
			  ), 
		array('return' => 'xsd:string'),
		'urn:notifyServicewsdl',
		'urn:notifyServicewsdl#GetNotifyList',
		'rpc',
		'encoded',
		'Get E-office notify GetNotifyList'
	);
/*
@function:  获取公告列表
@parameter: $a->               string  :每页显示的条数
			$b->               string  :当前页从第几条开始显示
			$c->               string  :查看或者当前的公告ID
@return:    $notify_message->  Array   :公告的详细信息
*/
function GetNotifyList($start,$limit,$search,$UserInfor){
	CheckCurrentSession();
	$notifyApi         = new notify($UserInfor);
	$notify_message    = $notifyApi->getNotifyInfo($limit,$start,"",$search);
	$Infor             = array();
	foreach($notify_message as $index => $val)
	{
		$Infor[$index]['NOTIFY_ID']     = $notify_message[$index]['NOTIFY_ID'];
		$Infor[$index]['FROM_ID']       = $notify_message[$index]['FROM_ID'];
		$Infor[$index]['FROM_NAME']     = $notify_message[$index]['FROM_NAME'];
		$Infor[$index]['SUBJECT']       = $notify_message[$index]['SUBJECT'];
		$Infor[$index]['SEND_TIME']     = $notify_message[$index]['SEND_TIME'];
		$Infor[$index]['READERS']       = $notify_message[$index]['READERS'];
		$Infor[$index]['READERS_NAME']  = getUsernameStr($val['READERS']);
		//判断新闻已读、未读
		if(strstr($Infor[$index]['READERS'],$UserInfor["user_id"].","))
		{
			//已读
			$Infor[$index]['InformationRead'] = "1";	
		}
		else
		{
			//未读
			$Infor[$index]['InformationRead'] = "0";	
		}
		$Infor[$index]['READ_FLAG']     = $notify_message[$index]['READ_FLAG'];
		$Infor[$index]['NOTIFY_TYPE']   = $notify_message[$index]['NOTIFY_TYPE'];
		$Infor[$index]['PUBLISH_DEPT']  = $notify_message[$index]['PUBLISH_DEPT'];
		$Infor[$index]['PUBLISH_PRIV']  = $notify_message[$index]['PUBLISH_PRIV'];
		$Infor[$index]['PUBLISH_USER']  = $notify_message[$index]['PUBLISH_USER'];
	}
	return json_encode($Infor);
}
/*---------注册获取公告详细信息函数-------------------*/
$server->register(
		'GetNotifyInformation',
		array(
			  'NotifyId' => 'xsd:int',
			  'UserInfor' => 'tns:UserInfor'
			  ), 
		array('return' => 'xsd:string'),
		'urn:notifyServicewsdl',
		'urn:notifyServicewsdl#GetNotifyInformation',
		'rpc',
		'encoded',
		'Get E-office notify GetNotifyInformation'
	);
/*
@function:  获取公告详细信息
@parameter: $NotifyId->        int     :公告ID
@return:    $notify_message->  Array   :公告的详细信息
*/
function GetNotifyInformation($NotifyId,$UserInfor){
	CheckCurrentSession();
	$notifyApi            = new notify($UserInfor);
	//更新公告阅读人员
	$notify_update_status = $notifyApi->updateReadStatus($NotifyId);
	$notify_message       = $notifyApi->getNotifyInfo("","",$NotifyId,array());
	foreach($notify_message as $index => $val)
	{
		$notify_message[$index]['READERS_NAME']       = getUsernameStr($val['READERS']);	
	}
	return json_encode($notify_message[0]);
}

/*---------注册获取公告类别函数getNotifyType---------*/
$server->register(
			'GetNotifyType',
			array(
				  'TypeId' => 'xsd:string'
				  ),
			array('return' => 'xsd:string' ),
			'urn:notifyServicewsdl',
			'urn:notifyServicewsdl#GetNotifyType',
			'rpc',
			'encoded',
			'Get Public notify type'
			);

/*
@function:  获取类别
@parameter: $TypeId->               string  :公告类别ID，可以为空
@return:    $NotifyType->  Array   :公告的详细信息
*/
function GetNotifyType($TypeId){
	CheckCurrentSession();
	$notifyApi     = new notify();
	$NotifyType    = $notifyApi->GetNotifyType($TypeId);
	return json_encode($NotifyType);
}

/*---------注册获取公告数量函数getNotifyAmount---------*/
$server->register(
		'getNotifyAmount',
		array('search' => 'tns:NotifySearch','UserInfor' => 'tns:UserInfor'),
		array('return'=>'xsd:string'),
		'urn:notifyServicewsdl',
		'urn:notifyServicewsdl#getNotifyAmount',
		'rpc',
		'encoded',
		'Get E-office notify count'
	);
/*
@function:  获取公告数量
@parameter: 无
@return:    $notify_counts->  string  :公告数量
*/
function getNotifyAmount($search,$UserInfor){
	CheckCurrentSession();
	$notifyApi 		  = new notify($UserInfor);
	$notify_counts    = $notifyApi->getNotifyAmount($search);
	return $notify_counts;
	}

/*---------注册获取最新公告数量函数getNewNotifyAmount---------*/
$server->register(
		'getNewNotifyAmount',
		array('UserInfor' => 'tns:UserInfor'),
		array('return'=>'xsd:string'),
		'urn:notifyServicewsdl',
		'urn:notifyServicewsdl#getNewNotifyAmount',
		'rpc',
		'encoded',
		'Get E-office notify count'
	);
/*
@function:  获取最新未读公告数
@parameter: 无
@return:    $notify_new_counts->  string  :公告数
*/
function getNewNotifyAmount($UserInfor){
	CheckCurrentSession();
	$notifyApi 		       = new notify($UserInfor);
	$notify_new_counts     = $notifyApi->getNewNotifyAmount();
	return $notify_new_counts;
	}


//返回数据

$HTTP_RAW_POST_DATA = isset($HTTP_RAW_POST_DATA) ? $HTTP_RAW_POST_DATA : '';
$server->service($HTTP_RAW_POST_DATA);

?>