<?php
/**
 * @copyright (C) 2000 - 2010 Weaver Co.Ltd
 * @package   eoffice7.3
 * @name      webservice/sms/sms.wsdl.php
 * @version   1.0 
 * @author    liuqingyu
 */
include_once ("nusoap/lib/nusoap.php");
include_once ("inc/conn.php");
include_once ("inc/checkcurrentsession.php");
include_once ("api/sms.class.php");
include_once ("inc/oa_config.php");
global $ATTACH_PATH;
$attachment_url = str_replace ( ROOT_PATH, ROOT_URL, $ATTACH_PATH );

//实例化soap_server对象并初始化
$server                   = new soap_server();
$server->soap_defencoding = "UTF-8";
$server->decode_utf8      = false;
$server->configureWSDL('SmsServicewsdl','urn:SmsServicewsdl');
$server->wsdl->schemaTargetNamespace = 'urn:SmsServicewsdl';
//定义UseInfor的参数结构
$server->wsdl->addComplexType(
							'UserInfor',
							'complexType',
							'array',
							'all',
							'',
							array(
								  'user_id'    => array('name'=>'user_id','type'=>'xsd:string'),
								  'user_name'  => array('name'=>'user_name','type'=>'xsd:string'),		
								  'session_id' => array('name'=>'session_id','type'=>'xsd:string')		
							)
);
/******************************************
 * 添加类型
 ******************************************/
$server->wsdl->addComplexType(
	'Data',
	'complexType',
	'struct',
	'all',
	'',
	array(
		//'fromid'=>array('name'=>'fromid','type'=>'xsd:string'),
		'toid'=>array('name'=>'toid','type'=>'xsd:string'),
		'smstype'=>array('name'=>'smstype','type'=>'xsd:int'),
		'content'=>array('name'=>'content','type'=>'xsd:string'),
		'sendtime'=>array('name'=>'sendtime','type'=>'xsd:string'),		
		'remindflag'=>array('name'=>'remindflag','type'=>'xsd:string'),		
		'attachid'=>array('name'=>'attachid','type'=>'xsd:string'),		
		'attachname'=>array('name'=>'attachname','type'=>'xsd:string')		
	)
);

/******************************************
 * 	Functions
 ******************************************/
/**
 * 身份验证
 * @param string $sessionid
 */	
function authCheck($UserInfor){
	CheckCurrentSession();
	return new sms($UserInfor);
}	

#####################################
$server->register(
	'cancelNotifySmsRemind',
	array('notifyId' => 'xsd:string','UserInfor' => 'tns:UserInfor'),
	array('return' => 'xsd:string'),
	'urn:SmsServicewsdl',
	'urn:SmsServicewsdl#cancelNotifySmsRemind',
	'rpc','encoded',
	'cancel notify sms remind'
	);
/**
 * 取消公告消息提醒
 * @param int $notifyId id
 * @return 成功 1,失败 0
 */
function cancelNotifySmsRemind($notifyId,$UserInfor){
	$sms = authCheck($UserInfor);
	if(empty($notifyId)) return 0;
	$sms->cancelNotifySmsRemind($notifyId);
	return 1;
}
###
$server->register(
	'deleteSms',
	array('ids' => 'xsd:string'),
	array('return' => 'xsd:string'),
	'urn:SmsServicewsdl',
	'urn:SmsServicewsdl#deleteSms',
	'rpc','encoded',
	'delete sms by id string'
	);
/**
 * 删除消息
 * @param string $ids 消息ID: 1,2,3
 * @type string $type 0 receiver or 1 sender
 * @return 成功 1,失败 0
 */		
function deleteSms($ids,$type = 0){
	$sms = authCheck(array());
	if(empty($ids)) return 0;
	$conn = OpenConnection();
	$delete_field = $type == 0? 'receive_del' : 'send_del';
	$id_array = explode(',', $ids);
	foreach ($id_array as $id){
		if($id == '') continue;
		$query = "UPDATE `sms` SET `$delete_field` = '1' WHERE `sms_id` = $id";
		$result = mysql_query($query,$conn);
		if($result == 0 ) return 0;
	} 
	return 1;
}
###
$server->register(
	'getNewSmsAmount',
	array('UserInfor' => 'tns:UserInfor'),
	array('return' => 'xsd:string'),
	'urn:SmsServicewsdl',
	'urn:SmsServicewsdl#getNewSmsAmount',
	'rpc','encoded',
	'get New Sms Amount'
	);
/**
 * 取得新消息数量
 * @return 消息数量
 */	
function getNewSmsAmount($UserInfor){
	$sms = authCheck($UserInfor);
	$amount = $sms->getNewSmsAmount();
	return $amount;
}
###
$server->register(
	'getPreNextSms',
	array('smsid' => 'xsd:string','flag'=>'xsd:string','UserInfor' => 'tns:UserInfor'),
	array('return' => 'xsd:string'),
	'urn:SmsServicewsdl',
	'urn:SmsServicewsdl#getPreNextSms',
	'rpc','encoded',
	'get Pre or Next Sms by current sms id'
	);
/**
 * 取得上/下一条消息
 * @param int $smsid 消息id
 * @param string $flag next or pre
 * @return 消息内容数组
 */	
function getPreNextSms($smsid,$flag,$UserInfor){
	$sms = authCheck($UserInfor);
	$data = $sms->getPreNextSms($smsid,$flag);
	return json_encode($data);
}
###
$server->register(
	'getSmsAmount',
	array('keyWord'=>'xsd:string','UserInfor' => 'tns:UserInfor'),
	array('return' => 'xsd:string'),
	'urn:SmsServicewsdl',
	'urn:SmsServicewsdl#getSmsAmount',
	'rpc','encoded',
	'get Sms Amount by user id'
	);
/**
 * 取得消息总数量
 * @return 消息数量
 */		

function getSmsAmount($keyWord,$UserInfor){
	$sms = authCheck($UserInfor);
	$amount = $sms->getSmsAmount($keyWord);
	return $amount;
}	
###
$server->register(
	'GetSmsInformation',
	array('limit'=>'xsd:int','start'=>'xsd:int','keyWord'=>'xsd:string','UserInfor' => 'tns:UserInfor'),
	array('return' => 'xsd:string'),
	'urn:SmsServicewsdl',
	'urn:SmsServicewsdl#GetSmsInformation',
	'rpc','encoded',
	'get sms infomation as GetSmsInformation'
	);
/**
 * 取得消息列表
 * @param int $limit 每页数量
 * @param int $start 开始ID
 * @param string $keyWord 搜索关键字
 * @return 消息内容数组
 */
function GetSmsInformation($limit,$start,$keyWord,$UserInfor){
	global $attachment_url;
	$sms = authCheck($UserInfor);
	
	$data = $sms->getSmsInfo($limit,$start,'',$keyWord);
	$data = $sms->replaceUserStr('FROM_ID','FROM_NAME', $data);
	$data = $sms->replaceUserStr('TO_ID','TO_NAME', $data);
	foreach($data as $index => $val){
		$name_array = explode('*',$val['ATTACHMENT_NAME']);
		$id_array = explode(',',$val['ATTACHMENT_ID']);	
		foreach($id_array as $id_index => $id){
			if($id == '') continue;
			$id_array[$id_index] = $attachment_url.$id.'/'.$name_array[$id_index];
		}
		$data[$index]['ATTACHMENT_DIR']  = implode(',',$id_array);
		//判断是否已读
		$data[$index]['InformationRead'] = $val['REMIND_FLAG'];
		$smsTypeInfo	= 		
		$sms->getSmstypeUrls($val['SMS_TYPE'],$val['CONTENT'],$val['TABLE_ID'],$val['TABLE_VAR'],$val['TABLE_NAME'],$val['TO_ID']);
		$data[$index]['SMSTYPEURL'] = $smsTypeInfo['URL'];
	}
	return json_encode($data);
}
###
$server->register(
	'GetSmsInfoById',
	array('smsid'=>'xsd:int','UserInfor' => 'tns:UserInfor'),
	array('return' => 'xsd:string'),
	'urn:SmsServicewsdl',
	'urn:SmsServicewsdl#GetSmsInfoById',
	'rpc','encoded',
	'get Sms infomation By GetSmsInfoById'
	);
/**
 * 取得传入ID的消息内容
 * @param int $smsid 消息ID
 * @return 消息内容数组
 */
function GetSmsInfoById($smsid,$UserInfor){
	global $attachment_url;
	$sms = authCheck($UserInfor);
	if($smsid == '') return array();
	$data =  $sms->getSmsInfo('','',$smsid,'');
	$data = $sms->replaceUserStr('FROM_ID','FROM_NAME', $data);
	$data = $sms->replaceUserStr('TO_ID','TO_NAME', $data);
	//设置为已查看并取消消息提醒
	$sms->updateRemind($smsid);
	foreach($data as $index => $val){
		$name_array = explode('*',$val['ATTACHMENT_NAME']);
		$id_array = explode(',',$val['ATTACHMENT_ID']);	
		foreach($id_array as $id_index => $id){
			if($id == '') continue;
			$id_array[$id_index] = $attachment_url.$id.'/'.$name_array[$id_index];
		}
		$data[$index]['ATTACHMENT_DIR'] = implode(',',$id_array);
	}
	return json_encode($data[0]);
}
###
$server->register(
	'notifySmsRemind',
	array('notifyId' => 'xsd:int','UserInfor' => 'tns:UserInfor'),
	array('return' => 'xsd:string'),
	'urn:SmsServicewsdl',
	'urn:SmsServicewsdl#notifySmsRemind',
	'rpc','encoded',
	'set notify flag'
	);
/**
 * 设置消息提醒
 * @param int $notifyId 消息ID
 * @return 成功返回1
 */	
function notifySmsRemind($notifyId,$UserInfor) {
	$sms = authCheck($UserInfor);
	$sms->notifySmsRemind($notifyId);
	return 1;
}
###
$server->register(
	'updateRemind',
	array('smsid' => 'xsd:int'),
	array('return' => 'xsd:string'),
	'urn:SmsServicewsdl',
	'urn:SmsServicewsdl#updateRemind',
	'rpc','encoded',
	'update remind flag'
	);
/**
 * 修改提醒状态
 * @param int $smsid	sms id
 * @return 1 on success
 */
function updateRemind($smsid){
	$sms = authCheck(array());
	$sms->updateRemind($smsid);
	return 1;
}
###
$server->register(
	'sendSms',
	array('data' => 'tns:Data','UserInfor' => 'tns:UserInfor'),
	array('return' => 'xsd:string'),
	'urn:SmsServicewsdl',
	'urn:SmsServicewsdl#sendSms',
	'rpc','encoded',
	'send sms infomation'
	);
/**
 * 发送消息
 * @param array $data 消息数据array('fromid'=>'','toid'=>'',...)
 * @return inserted id
 */
function sendSms($data,$UserInfor){
	$sms = authCheck($UserInfor);
	return $sms->sendSms($data);
}

//返回数据
$server->service($HTTP_RAW_POST_DATA);
?>