<?php
/**
 * @copyright (C) 2000 - 2011 Weaver Co.Ltd
 * @package eoffice7.9
 * @name webservice/user/user.wsdl.php
 * @version 1.0
 * @author samuel
 * @modify liuqingyu
 */
require_once('nusoap/lib/nusoap.php');
require_once('inc/conn.php');
require_once('inc/checkcurrentsession.php');
require_once('api/user.class.php');
include_once('inc/oa_config.php');

$server = new soap_server();
$server -> soap_defencoding = "UTF-8";
$server -> decode_utf8 = false;
$server -> configureWSDL('UserServicewsdl', 'urn:UserServicewsdl');
$server -> wsdl -> schemaTargetNamespace = 'urn:UserServicewsdl';

$server -> wsdl -> addComplexType('UserInfor',
  'complexType', 
  'struct',
  'all',
   '', 
   array(
   'useraccounts' => array('name' => 'useraccounts', 'type' => 'xsd:string'), 
   'username' => array('name' => 'username', 'type' => 'xsd:string'), 
   'userpriv' => array('name' => 'userpriv', 'type' => 'xsd:string'), 
   'postpriv' => array('name' => 'postpriv', 'type' => 'xsd:string'), 
   'postdept' => array('name' => 'postdept', 'type' => 'xsd:string'), 
   'deptid' => array('name' => 'deptid', 'type' => 'xsd:string'), 
   'sex' => array('name' => 'sex', 'type' => 'xsd:string'), 
   'birthday' => array('name' => 'birthday', 'type' => 'xsd:string'), 
   'telnodept' => array('name' => 'telnodept', 'type' => 'xsd:string'), 
   'faxnodept' => array('name' => 'faxnodept', 'type' => 'xsd:string'), 
   'addhome' => array('name' => 'addhome', 'type' => 'xsd:string'), 
   'postnohome' => array('name' => 'postnohome', 'type' => 'xsd:string'), 
   'telnohome' => array('name' => 'telnohome', 'type' => 'xsd:string'), 
   'mobileno' => array('name' => 'mobileno', 'type' => 'xsd:string'),
   'bpno' => array('name' => 'bpno', 'type' => 'xsd:string'),
   'email' => array('name' => 'email', 'type' => 'xsd:string'),
   'qicqno' => array('name' => 'qicqno', 'type' => 'xsd:string'),
   'icqno' => array('name' => 'icqno', 'type' => 'xsd:string'),
   'msn' => array('name' => 'msn', 'type' => 'xsd:string'),
   'nickname' => array('name' => 'nickname', 'type' => 'xsd:string'),
   'callsound' => array('name' => 'callsound', 'type' => 'xsd:string'),
   'bbssignature' => array('name' => 'bbssignature', 'type' => 'xsd:string'),
   'dutytype' => array('name' => 'dutytype', 'type' => 'xsd:string'),
   'lastvisittime' => array('name' => 'lastvisittime', 'type' => 'xsd:string'),
   'smson' => array('name' => 'smson', 'type' => 'xsd:string'),
   'menuhide' => array('name' => 'menuhide', 'type' => 'xsd:string'),
   'theme' => array('name' => 'theme', 'type' => 'xsd:string'),
   'smslogin' => array('name' => 'smslogin', 'type' => 'xsd:string'),
   'listnumber' => array('name' => 'listnumber', 'type' => 'xsd:string'),
   'notes' => array('name' => 'notes', 'type' => 'xsd:string'),
   'wapallow' => array('name' => 'wapallow', 'type' => 'xsd:string'),
   'password' => array('name' => 'password', 'type' => 'xsd:string'),
   'usbkeylogin' => array('name' => 'usbkeylogin', 'type' => 'xsd:string'),
   'userstatus' => array('name' => 'userstatus', 'type' => 'xsd:string'),
   ));
$server -> register('InsertUser', 
					array('userInfor' => 'tns:UserInfor'),
					array('return' => 'xsd:string'), 
					'urn:UserServicewsdl', 
					'urn:UserServicewsdl#InsertUser', 
					'rpc', 
					'encoded', 
					'Insert user');

function InsertUser($userInfor) {
	CheckCurrentSession ();
	$user = new user();
	$insertResult = $user -> insertUser($userInfor);
	return $insertResult;
}

$server -> register('EditUser', 
					array('userID'=>'xsd:string','userInfor' => 'tns:UserInfor'),
					array('return' => 'xsd:string'), 
					'urn:UserServicewsdl', 
					'urn:UserServicewsdl#EditUser', 
					'rpc', 
					'encoded', 
					'Edit user');

function EditUser($userID, $userInfor) {
	CheckCurrentSession ();
	$userInfor ['userid'] = $userID;
	$user = new user ();
	$updateResult = $user->editUser ( $userInfor );
	return $updateResult;
}

$server -> register('DeleteUser', 
					array('userID'=>'xsd:string'),
					array('return' => 'xsd:string'), 
					'urn:UserServicewsdl', 
					'urn:UserServicewsdl#DeleteUser', 
					'rpc', 
					'encoded', 
					'Edit user');

function DeleteUser($userID) {
	CheckCurrentSession ();
	$user = new user();
	$deleteResult = $user->deleteUser($userID);
	return $deleteResult;
}

$server -> service($HTTP_RAW_POST_DATA);
?>