<?php
/**
* @copyright (C) 2000 - 2010 Weaver Co.Ltd
* @package   eoffice6.0
* @name      webservice/workflow/workflow.wsdl.php
* @version   1.0 
* @author    sunxiang
*/
include_once("nusoap/lib/nusoap.php");
include_once("api/list.class.php");
include_once("api/flow.class.php");
include_once("inc/function_page_01.php");
include_once("inc/conn.php");
include_once("inc/checkcurrentsession.php");
include_once("inc/utility_all.php");

//实例化soap_server对象并初始化
$server                   = new soap_server();
$server->soap_defencoding = "UTF-8";
$server->decode_utf8      = false;
$server->configureWSDL('ListServicewsdl','urn:ListServicewsdl');
$server->wsdl->schemaTargetNamespace = 'urn:ListServicewsdl';
//定义UseInfor的参数结构
$server->wsdl->addComplexType(
							'UserInfor',
							'complexType',
							'array',
							'all',
							'',
							array(
								  'user_id'    => array('name'=>'user_id','type'=>'xsd:string'),
								  'user_name'  => array('name'=>'user_name','type'=>'xsd:string'),		
								  'session_id' => array('name'=>'session_id','type'=>'xsd:string')		
							)
);
//注册一个名字为getList的函数
//定义getList参数结构
$server->wsdl->addComplexType(
	'FlowListSearch',
	'complexType',
	'struct',
	'all',
	'',
	array(
		'FlowName'        => array('name'=>'FlowName','type'=>'xsd:string'),
		'SearchEndTime'   => array('name'=>'SearchEndTime','type'=>'xsd:string'),
		'SearchBeginTime' => array('name'=>'SearchTime','type'=>'xsd:string')
	)
);

$server->register('GetFlowList',
				  array(
						'userId' => 'xsd:string',
						'flowId' => 'xsd:string',
						'start' => 'xsd:string',
						'limit' => 'xsd:string',
						'type' => 'xsd:string',
						'Search'=>'tns:FlowListSearch'
						),
				  array('return' => 'xsd:string'),
				  'urn:ListServicewsdl',
				  'urn:ListServicewsdl#GetFlowList',
				  'rpc',
				  'encoded',
				  'Get E-office GetFlowList'
				  );

$server->register('unreadToDoCount',
				  array('userId' => 'xsd:string'),
				  array('return' => 'xsd:int'),
				  'urn:ListServicewsdl',
				  'urn:ListServicewsdl#unreadToDoCount',
				  'rpc',
				  'encoded',
				  'Get E-office getUnreadToDoCount'
				  );

$server->register('toDoCount',
				  array('userId' => 'xsd:string'),
				  array('return' => 'xsd:int'),
				  'urn:ListServicewsdl',
				  'urn:ListServicewsdl#toDoCount',
				  'rpc',
				  'encoded',
				  'Get E-office gettoDoCount'
				  );

//getList函数实现的功能，通过调用api的实例
function GetFlowList($userId,$flowId,$start,$limit,$type,$Search)
{
    $userId = SecurityFilter($userId);
	CheckCurrentSession();
	global $connection;
	$SearchFlowTime = "";
	if($Search["FlowName"]!="")
	{
		$SearchFlowName = " AND fr.RUN_NAME LIKE '%".$Search["FlowName"]."%' ";	
	}
	if($Search["SearchBeginTime"]!="")
	{
		$SearchFlowTime .= " AND UNIX_TIMESTAMP(fr.CREATE_TIME)>=UNIX_TIMESTAMP('".$Search["SearchBeginTime"]."') ";	
	}
	if($Search["SearchEndTime"]!="")
	{
		$SearchFlowTime .= " AND UNIX_TIMESTAMP(fr.CREATE_TIME)<=UNIX_TIMESTAMP('".$Search["SearchEndTime"]."') ";	
	}
	if($flowId)
	{
		switch($type)
		{
			case "to_do":
				$p1 = array("WHERE"=>"frp.USER_ID='$userId' AND (((frp.SAVEFORM_TIME IS NULL AND frp.OP_FLAG=0) OR (frp.PRCS_FLAG='2' AND frp.OP_FLAG=1)) OR( frp.PRCS_FLAG = 1)) AND fr.FLOW_ID = '".$flowId."' ".$SearchFlowName.$SearchFlowTime,"GROUPBY"=>"frp.RUN_ID","SORTBY"=>"frp.RUN_ID DESC","LIMIT"=>$limit,"START"=>$start);
				break;
			case "passed":
				$p1 = array("WHERE"=>"frp.RUN_ID=fr.RUN_ID AND frp.USER_ID='$userId' AND fr.CURRENT_STEP<>0
                AND ((frp.OP_FLAG=1 AND frp.DELIVER_TIME<>'NULL') 
				      OR 
					 (frp.OP_FLAG=0 AND frp.SAVEFORM_TIME<>'NULL')) AND fr.FLOW_ID = '".$flowId."'".$SearchFlowName.$SearchFlowTime,"GROUPBY"=>"frp.RUN_ID","SORTBY"=>"frp.RUN_ID DESC","LIMIT"=>$limit,"START"=>$start);
				break;
			case "finished":
				$p1 = array("WHERE"=>"fr.CURRENT_STEP = '0' 
				AND frp.USER_ID ='".$userId."' AND ((SAVEFORM_TIME IS NOT NULL AND SAVEFORM_TIME <> '0000-00-00 00:00:00' AND OP_FLAG ='0') OR( DELIVER_TIME IS NOT NULL AND DELIVER_TIME <> '0000-00-00 00:00:00' AND OP_FLAG ='1') ) AND fr.FLOW_ID = '".$flowId."' ".$SearchFlowName.$SearchFlowTime,"GROUPBY"=>"frp.RUN_ID","SORTBY"=>"frp.RUN_ID DESC","LIMIT"=>$limit,"START"=>$start);
				break;	
		}
	}
	else
	{
		switch($type)
		{
			case "to_do":
				$p1 = array("WHERE"=>"frp.USER_ID='$userId' AND (((frp.SAVEFORM_TIME IS NULL AND frp.OP_FLAG=0) OR (frp.PRCS_FLAG='2' AND frp.OP_FLAG=1)) OR( frp.PRCS_FLAG = 1)) AND ft.FLOW_TYPE = 1 ".$SearchFlowName.$SearchFlowTime,"GROUPBY"=>"frp.RUN_ID","SORTBY"=>"frp.RUN_ID DESC","LIMIT"=>$limit,"START"=>$start);
				break;
			case "passed":
				$p1 = array("WHERE"=>"frp.RUN_ID=fr.RUN_ID AND frp.USER_ID='$userId' AND fr.CURRENT_STEP<>0
                AND ((frp.OP_FLAG=1 AND frp.DELIVER_TIME<>'NULL') 
				      OR 
					 (frp.OP_FLAG=0 AND frp.SAVEFORM_TIME<>'NULL')) ".$SearchFlowName.$SearchFlowTime,"GROUPBY"=>"frp.RUN_ID","SORTBY"=>"frp.RUN_ID DESC","LIMIT"=>$limit,"START"=>$start);
				break;
			case "finished":
				$p1 = array("WHERE"=>"fr.CURRENT_STEP = '0' 
				AND frp.USER_ID ='".$userId."' AND ((SAVEFORM_TIME IS NOT NULL AND SAVEFORM_TIME <> '0000-00-00 00:00:00' AND OP_FLAG ='0') OR( DELIVER_TIME IS NOT NULL AND DELIVER_TIME <> '0000-00-00 00:00:00' AND OP_FLAG ='1') ) ".$SearchFlowName.$SearchFlowTime,"GROUPBY"=>"frp.RUN_ID","SORTBY"=>"frp.RUN_ID DESC","LIMIT"=>$limit,"START"=>$start);
				break;	
		}
	}
	$p2       = array("type"=>"$type");
	$listwApi = new listItem($p1,$p2);
	$listData = $listwApi->getList();
	$Infor    = array();
	foreach($listData as $index => $val)
	{
		$Infor[$index]["RUN_ID"]           = $listData[$index]["RUN_ID"];
		$Infor[$index]["MAX_PRCS_ID"]      = $listData[$index]["MAX_PRCS_ID"];
		$Infor[$index]["RUN_NAME"]         = $listData[$index]["RUN_NAME"];
		$Infor[$index]["FLOW_ID"]          = $listData[$index]["FLOW_ID"];
		$Infor[$index]["ATTACHMENT_ID"]    = $listData[$index]["ATTACHMENT_ID"];
		$Infor[$index]["ATTACHMENT_NAME"]  = $listData[$index]["ATTACHMENT_NAME"];
		$Infor[$index]["ATTACHMENT_DIR"]   = $listData[$index]["ATTACHMENT_DIR"];
		$Infor[$index]["CREATE_TIME"]      = $listData[$index]["CREATE_TIME"];
		$Infor[$index]["RUN_SEQ"]          = $listData[$index]["RUN_SEQ"];
		$Infor[$index]["LINK_DOC"]         = $listData[$index]["LINK_DOC"];
		$Infor[$index]["LINK_DOC_NAME"]    = $listData[$index]["LINK_DOC_NAME"];
		$Infor[$index]["CREATOR"]          = $listData[$index]["CREATOR"];
		$Infor[$index]['CREATOR_NAME']     = getUserNameNew($val['CREATOR']);
		$Infor[$index]["VIEW_USER"]        = $listData[$index]["VIEW_USER"];
		$Infor[$index]["CURRENT_STEP"]     = $listData[$index]["CURRENT_STEP"];
		$Infor[$index]["FLOW_NAME"]        = $listData[$index]["FLOW_NAME"];
		$Infor[$index]["FORM_ID"]          = $listData[$index]["FORM_ID"];
		$Infor[$index]["FLOW_DOC"]         = $listData[$index]["FLOW_DOC"];
		$Infor[$index]["FLOW_LINK"]        = $listData[$index]["FLOW_LINK"];
		$Infor[$index]["FLOW_TYPE"]        = $listData[$index]["FLOW_TYPE"];
		$Infor[$index]["MANAGE_USER"]      = $listData[$index]["MANAGE_USER"];
		$Infor[$index]['MANAGE_USER_NAME'] = getUsernameStr($val['MANAGE_USER']);
		$Infor[$index]["FLOW_SORT"]        = $listData[$index]["FLOW_SORT"];
		$Infor[$index]["FLOW_SEQUENCE"]    = $listData[$index]["FLOW_SEQUENCE"];
		$Infor[$index]["FLOW_NOORDER"]     = $listData[$index]["FLOW_NOORDER"];
		$Infor[$index]["HANDLE_WAY"]       = $listData[$index]["HANDLE_WAY"];
		$Infor[$index]["COUNTERSIGN"]      = $listData[$index]["COUNTERSIGN"];
		$Infor[$index]["CAN_EDIT_FLOWNO"]  = $listData[$index]["CAN_EDIT_FLOWNO"];
		//返回节点名称
		$sql = "SELECT * FROM flow_process WHERE FLOW_ID='".$val['FLOW_ID']."' AND PRCS_ID='".$val['PRCS_ID']."'";
		$rs = exequery($connection, $sql);
		if($row = mysql_fetch_array($rs))	
		{
			$listData[$index]['PRCS_NAME'] = $row["PRCS_NAME"];	
		}
		//判断是否已读
		if($listData[$index]["PRCS_TIME"]!="")
		{
			//已读
			$Infor[$index]["InformationRead"] = "1";	
		}
		else
		{
			//未读
			$Infor[$index]["InformationRead"] = "0";	
		}
	}
	//返回结果
	return json_encode($Infor);
}
function unreadToDoCount($userId)
{
    $userId = SecurityFilter($userId);
	CheckCurrentSession();
	$p1 = array("WHERE"=>"frp.USER_ID='$userId' AND frp.PRCS_FLAG='1' AND frp.RUN_ID = fr.RUN_ID AND fr.FLOW_ID = ft.FLOW_ID AND ft.FLOW_TYPE != 2 GROUP BY frp.RUN_ID","LIMIT"=>"all");
	$p2 = array("type"=>"unread_to_do_count");
	$listwApi = new listItem($p1,$p2);
	$listData = $listwApi->getList();
	return $listData;
}
function toDoCount($userId)
{
    $userId = SecurityFilter($userId);
	CheckCurrentSession();
	//$p1 = array("WHERE"=>"frp.USER_ID='$userId' AND frp.RUN_ID = fr.RUN_ID  AND fr.FLOW_ID = ft.FLOW_ID AND ( ( (SAVEFORM_TIME IS NULL AND OP_FLAG=0) OR (PRCS_FLAG='2' AND OP_FLAG=1) ) OR PRCS_FLAG='1' ) GROUP BY frp.RUN_ID");
	$p1 = array("WHERE"=>"frp.USER_ID='$userId' AND frp.RUN_ID = fr.RUN_ID  AND fr.FLOW_ID = ft.FLOW_ID AND ( ( (SAVEFORM_TIME IS NULL AND OP_FLAG=0) OR (PRCS_FLAG='2' AND OP_FLAG=1) ) OR PRCS_FLAG='1' ) AND ft.FLOW_TYPE = '1' GROUP BY frp.RUN_ID");
	$p2 = array("type"=>"to_do_count");
	$listwApi = new listItem($p1,$p2);
	$listData = $listwApi->getList();
	return $listData;
}
function getOtherSetInfo($flowid)
{
    $userId = SecurityFilter($userId);
	CheckCurrentSession();
	$workflowApi = new workflow($flowid);
	$otherInfo   = $workflowApi->getOtherSetInfo();
	//使用json对返回结果进行加密
	$otherInfo   = json_encode($otherInfo);
	//返回结果
	return $otherInfo;
}
//-------------------------------返回流程数量
$server->wsdl->addComplexType(
	'FlowSearchCount',
	'complexType',
	'struct',
	'all',
	'',
	array(
		'UserId'          => array('name'=>'UserId','type'=>'xsd:string'),
		'FlowId'          => array('name'=>'FlowId','type'=>'xsd:string'),
		'FlowName'        => array('name'=>'FlowName','type'=>'xsd:string'),
		'SearchEndTime'   => array('name'=>'SearchEndTime','type'=>'xsd:string'),
		'SearchBeginTime' => array('name'=>'SearchTime','type'=>'xsd:string'),
		'FlowType'        => array('name'=>'FlowType','type'=>'xsd:string')
	)
);
$server->register('GetFlowCount',
				  array(
						'SearchCondition'=>'tns:FlowSearchCount'
						),
				  array('return' => 'xsd:string'),
				  'urn:ListServicewsdl',
				  'urn:ListServicewsdl#GetFlowCount',
				  'rpc',
				  'encoded',
				  'Get E-office GetFlowCount'
				  );
//获取流程数量
function GetFlowCount($SearchCondition)
{
	CheckCurrentSession();
	$FlowList = new listItem();
	return $FlowList->GetFlowCount($SearchCondition);
}
//-------------------------------获取可新建的流程
$server->register('GetMyCreatFlow',
				  array(
						'UserId'=>'xsd:string'
						),
				  array('return' => 'xsd:string'),
				  'urn:ListServicewsdl',
				  'urn:ListServicewsdl#GetMyCreatFlow',
				  'rpc',
				  'encoded',
				  'Get E-office GetMyCreatFlow'
				  );
function GetMyCreatFlow($UserId)
{
    $userId = SecurityFilter($userId);
	CheckCurrentSession();
	$FlowList = new listItem();
	$UserInfo = array();
	$DepyId   = getUserDept($UserId);
	$PrivId   = getUserPrivId($UserId);
	$UserInfo["UserId"] = $UserId;
	$UserInfo["DepyId"] = $DepyId;
	$UserInfo["PrivId"] = $PrivId;
	$result = $FlowList->GetMyCreatFlow($UserInfo);	
	$Infor = array();
	foreach($result as $index => $val)
	{
		$Infor[$index]["FLOW_SORT_ID"]      = $result[$index]["FLOW_SORT_ID"];
		$Infor[$index]["FLOW_NAME"]         = $result[$index]["FLOW_NAME"];
		$Infor[$index]["FLOW_ID"]           = $result[$index]["FLOW_ID"];
		$Infor[$index]["FLOW_TYPE"]         = $result[$index]["FLOW_TYPE"];
		$Infor[$index]["FORM_ID"]           = $result[$index]["FORM_ID"];
		$Infor[$index]["FLOW_SORT_NOORDER"] = $result[$index]["FLOW_SORT_NOORDER"];
		$Infor[$index]["FLOW_SORT_TITLE"]   = $result[$index]["FLOW_SORT_TITLE"];
	}
	return json_encode($Infor);	
}
//-------------------------------获取未读待办流程数量
$server->register('GetMyUnreadFlowSum',
				  array(
						'UserInfor' => 'tns:UserInfor'
						),
				  array('return' => 'xsd:int'),
				  'urn:ListServicewsdl',
				  'urn:ListServicewsdl#GetMyUnreadFlowSum',
				  'rpc',
				  'encoded',
				  'Get E-office GetMyUnreadFlowSum'
				  );
function GetMyUnreadFlowSum($UserInfor)
{
	CheckCurrentSession();
	$flow = new flow($UserInfor);
	$flownewcnt = $flow->getNewFlowAmount();
	return $flownewcnt;
}


//返回数据
$server->service($HTTP_RAW_POST_DATA);
?>