<?php
/**
 *@copyright (C) 2000 - 2010 Weaver Co.Ltd
 *@package   eoffice
 *@name      webservice/address/addr.wsdl.php
 *@version   1.0 
 *@author    liuqingyu
 */
include_once ("inc/checkcurrentsession.php");
include_once ("nusoap/lib/nusoap.php");
include_once ("api/address.class.php");
include_once ("wap/function.php");
include_once ("inc/conn.php");
include_once("inc/utility_all.php");

$server = new soap_server();
$server->soap_defencoding = "UTF-8";
$server->decode_utf8 = false;
$server->configureWSDL ('AddressServicewsdl','urn:AddressServicewsdl');
$server->wsdl->schemaTargetNamespace = 'urn:AddressServicewsdl';
//定义UseInfor的参数结构
$server->wsdl->addComplexType(
							'UserInfor',
							'complexType',
							'array',
							'all',
							'',
							array(
								  'user_id'    => array('name'=>'user_id','type'=>'xsd:string'),
								  'user_name'  => array('name'=>'user_name','type'=>'xsd:string'),		
								  'session_id' => array('name'=>'session_id','type'=>'xsd:string')		
							)
);

//定义返回格式
$server->wsdl->addComplexType(
				'addressInfor',
				'complexType',
				'array',
				'',
				'SOAP-ENC:Array',
				array(),
				array(
					   array(
							'ref' => 'SOAP-ENC:arrayType',
							'wsdl:arrayType' => 'tns:addressInforArray[]')
					   ),
				'tns:addressInforArray'
				);
$server->wsdl->addComplexType (
				'addressInforArray',
				'complexType',
				'struct',
				'all',
				'',
				array (
					'ID'           => array('name' => 'ID', 'type' => 'xsd:string' ),
					'Name'         => array('name' => 'Name', 'type' => 'xsd:string' ),
					'Sex'          => array('name' => 'Sex', 'type' => 'xsd:string' ),
					'Mobile'       => array('name' => 'Mobile', 'type' => 'xsd:string' ),
					'Email'        => array('name' => 'Email', 'type' => 'xsd:string' ),
					'Department'   => array('name' => 'Department', 'type' => 'xsd:string' ),
					'GroupID'      => array('name' => 'GroupID', 'type' => 'xsd:string' ),
					'GroupName'    => array('name' => 'GroupName', 'type' => 'xsd:string' )
					)
				);
$server->register(
			'GetAddressList',
			array(
				  'offset' => 'xsd:string',
				  'rows' => 'xsd:string',
				  'searchCondition' => 'xsd:string',
				  'checkdiff' => 'xsd:string',
				  'groupdiff' => 'xsd:string',
				  'UserInfor' => 'tns:UserInfor'
				  ),
			array ('return' => 'tns:addressInfor' ),
			'urn:AddressServicewsdl',
			'urn:AddressServicewsdl#GetAddressList',
			'rpc',
			'encoded',
			'Get Address GetAddressList'
			);
//获取通讯录列表
function GetAddressList($offset,$rows,$searchCondition,$checkdiff,$groupdiff,$UserInfor) 
{
	CheckCurrentSession ();
	$addrApi = new address($UserInfor);
	$addrs = $addrApi->GetAddressInfor($offset,$rows,'',$searchCondition,$checkdiff,$groupdiff);
	return $addrs;
}
//----------------注册获取通讯录详情
$server->wsdl->addComplexType (
				'ReturnAddressInfo',
				'complexType',
				'struct',
				'all',
				'',
				array (
					'ID'           => array('name' => 'ID', 'type' => 'xsd:string' ),
					'Name'         => array('name' => 'Name', 'type' => 'xsd:string' ),
					'Sex'          => array('name' => 'Sex', 'type' => 'xsd:string' ),
					'Mobile'       => array('name' => 'Mobile', 'type' => 'xsd:string' ),
					'Email'        => array('name' => 'Email', 'type' => 'xsd:string' ),
					'Company'      => array('name' => 'Company', 'type' => 'xsd:string' ),
					'Department'   => array('name' => 'Department', 'type' => 'xsd:string' ),
					'Comment'      => array('name' => 'Comment', 'type' => 'xsd:string' ),
					'Birthday'     => array('name'=>'Birthday','type'=>'xsd:string'),
					'Work_Tel'     => array('name'=>'Work_Tel','type'=>'xsd:string'),
					'Home_address' => array('name'=>'Home_address','type'=>'xsd:string'),
					'Home_Tel'     => array('name'=>'Home_Tel','type'=>'xsd:string'),
					'GroupID'      => array('name'=>'GroupID','type'=>'xsd:string'),
					'GroupName'    => array('name'=>'GroupName','type'=>'xsd:string'),
					'Groupparent'  => array('name'=>'Groupparent','type'=>'xsd:string'),
					'Grouptype'    => array('name'=>'Grouptype','type'=>'xsd:string')
					)
				);
$server->register(
			'GetAddressInformation',
			array(
				  'AddressId' => 'xsd:int',
				  'UserInfor' => 'tns:UserInfor'
				  ),
			array ('return' => 'tns:ReturnAddressInfo' ),
			'urn:AddressServicewsdl',
			'urn:AddressServicewsdl#GetAddressInformation',
			'rpc',
			'encoded',
			'Get Address GetAddressInformation'
			);
function GetAddressInformation($AddressId,$UserInfor)
{
	CheckCurrentSession ();
	$addrApi = new address($UserInfor);
	$addrs = $addrApi->GetAddressInfor('','',$AddressId,'','','');
	return $addrs[0];	
}

//----------------注册获取通讯录的总记录数函数
$server->register(
			'GetAddressAmount',
			array(
				  'searchCondition' => 'xsd:string',
				  'checkdiff' => 'xsd:string',
				  'groupid' => 'xsd:string',
				  'UserInfor' => 'tns:UserInfor'
				  ),
			array('return' => 'SOAP-ENC:string' ),
			'urn:AddressServicewsdl',
			'urn:AddressServicewsdl#GetAddressAmount',
			'rpc',
			'encoded',
			'Get Address GetAddressAmount'
			);
//获取通讯录的总记录数
function GetAddressAmount($searchCondition,$checkdiff,$groupid,$UserInfor) 
{
	CheckCurrentSession ();
	$addrApi = new address($UserInfor);
	$addrs = $addrApi->GetMyAddressAmount($searchCondition,$checkdiff,$groupid);
	return $addrs;
}
//----------------注册获取通讯录结构函数
//参数结构
$server->wsdl->addComplexType(
	'AddressStructParam',
	'complexType',
	'struct',
	'all',
	'',
	array(
		'diff'    => array('name'=>'diff','type'=>'xsd:string'),
		'groupid' => array('name'=>'groupid','type'=>'xsd:string'),
		'userid'  => array('name'=>'userid','type'=>'xsd:string')
	)
);
//定义返回格式
$server->wsdl->addComplexType(
				'AddressStructArray',
				'complexType',
				'array',
				'',
				'SOAP-ENC:Array',
				array(),
				array(
					   array(
							'ref' => 'SOAP-ENC:arrayType',
							'wsdl:arrayType' => 'tns:AddressStruct[]')
					   ),
				'tns:AddressStruct'
				);
$server->wsdl->addComplexType (
				'AddressStruct',
				'complexType',
				'struct',
				'all',
				'',
				array (
					'GROUP_ID'      => array('name' => 'GROUP_ID', 'type' => 'xsd:string' ),
					'GROUP_NAME'    => array('name' => 'GROUP_NAME', 'type' => 'xsd:string' ),
					'GROUP_PARENT'  => array('name' => 'GROUP_PARENT', 'type' => 'xsd:string' ),
					'GROUP_USER'    => array('name' => 'GROUP_USER', 'type' => 'xsd:string' ),
					'GROUP_PRIV'    => array('name' => 'GROUP_PRIV', 'type' => 'xsd:string' ),
					'GROUP_DEPT'    => array('name' => 'GROUP_DEPT', 'type' => 'xsd:string' ),
					'GROUP_ORDER'   => array('name' => 'GROUP_ORDER', 'type' => 'xsd:string' ),
					'GROUP_GET'     => array('name' => 'GROUP_GET', 'type' => 'xsd:string' ),
					'GROUP_DATE'    => array('name' => 'GROUP_DATE', 'type' => 'xsd:string' ),
					'USER_ID'       => array('name' => 'USER_ID', 'type' => 'xsd:string' )
					)
				);

$server->register(
			'GetAddressStruct',
			array(
				  'Info' => 'tns:AddressStructParam',
				  ),
			array ('return' => 'tns:AddressStructArray' ),
			'urn:AddressServicewsdl',
			'urn:AddressServicewsdl#GetAddressStruct',
			'rpc',
			'encoded',
			'Get Address GetAddressStruct'
			);

function GetAddressStruct($Info)
{
	CheckCurrentSession ();
	$addrApi = new address ();
	$AddressStructInfo = $addrApi->GetAddressStruct($Info);
	return $AddressStructInfo;	
}
$server->service($HTTP_RAW_POST_DATA);
?>