<?php
/**
 *@copyright (C) 2000 - 2010 Weaver Co.Ltd
 *@package   eoffice
 *@name      webservice/attendance/attendance.wsdl.php
 *@version   1.0 
 *@author    liuqingyu
 */
include_once ("inc/checkcurrentsession.php");
include_once ("nusoap/lib/nusoap.php");
include_once ("api/attend.class.php");
include_once ("api/user.class.php");
include_once ("inc/conn.php");
include_once ("inc/utility_all.php");

/*---------实例化soap_server对象并初始化---------*/
$server = new soap_server ();
$server->soap_defencoding = "UTF-8";
$server->decode_utf8 = false;
$server->configureWSDL ( 'AttendaceServicewsdl', 'urn:AttendaceServicewsdl' );
$server->wsdl->schemaTargetNamespace = 'urn:AttendaceServicewsdl';
//获取签到签退时间
$server->wsdl->addComplexType(
				'AttenReturn',
				'complexType',
				'struct',
				'all',
				'',
				array(
					  'LoginInTime'       => array ('name' => 'LoginInTime', 'type' => 'xsd:string' ),
					  'LoginInLateTime'   => array ('name' => 'LoginInLateTime', 'type' => 'xsd:string' ),
					  'LoginOutTime'      => array ('name' => 'LoginOutTime', 'type' => 'xsd:string' ),
					  'LoginOutEarlyTime' => array ('name' => 'LoginOutEarlyTime', 'type' => 'xsd:string' )
					  )
				);
$server->register (
		'GetLoginInOut',
		array (
			   'UserId' => 'xsd:string',
			   'HandSign' => 'xsd:string'
			   ),
		array ('return' => 'tns:AttenReturn'),
		'urn:AttendaceServicewsdl',
		'urn:AttendaceServicewsdl#GetLoginInOut',
		'rpc',
		'encoded',
		'Get E-office Atten GetLoginInOut'
	);

//保存签到签退到数据库
$server->wsdl->addComplexType(
				'ReReturn',
				'complexType',
				'struct',
				'all',
				'',
				array(
					  'SIGN_IN_TIME'  => array ('name' => 'SIGN_IN_TIME', 'type' => 'xsd:string' ),
					  'SIGN_OUT_TIME' => array ('name' => 'SIGN_OUT_TIME','type' => 'xsd:string' ),
					  )
				);
$server->register (
		'SaveAttendance',
		array (
			   'UserAccounts' => 'xsd:string',
			   'AttendanceTime' => 'xsd:string'
			   ),
		array ('return' => 'tns:ReReturn'),
		'urn:AttendaceServicewsdl',
		'urn:AttendaceServicewsdl#SaveAttendance',
		'rpc',
		'encoded',
		'Get E-office Atten SaveAttendance'
	);

function GetLoginInOut($UserId,$HandSign)
{
	CheckCurrentSession();
	$AttensApi = new attend();
	$UserInfo["UserId"]     = $UserId;
	$UserInfo["DeptId"]     = getUserDept($UserId);
	$UserInfo["PrivId"]     = getUserPrivId($UserId);
	$UserInfo["LoginCheck"] = $HandSign;
	$LoginTime = $AttensApi->GetLoginInOut($UserInfo);
	return $LoginTime;	
}

function SaveAttendance($UserAccounts,$AttendanceTime) {
	CheckCurrentSession();
	$Attend   = new attend();
	$User     = new user();
	$UserId   = $User -> getUserIDByUserAccount($UserAccounts);
	$UserInfo["UserId"]  = $UserId;
	$UserInfo["DeptId"]  = getUserDept($UserId);
	$UserInfo["PrivId"]  = getUserPrivId($UserId);
	$UserInfo["AttTime"] = $AttendanceTime;

	$AttResult = $Attend -> InsertAttendance($UserInfo);
	return $AttResult;
}

//返回数据
$server->service ( $HTTP_RAW_POST_DATA );
?>