<?
/**
 * @copyright (C) 2000 - 2010 Weaver Co.Ltd
 * @package   eoffice7.3
 * @name      webservice/document/document.wsdl.php
 * @version   1.0 
 * @author    samuel
 * @modify    liuqingyu
 */

include_once("nusoap/lib/nusoap.php");
include_once("api/file.class.php");
include_once("inc/conn.php");
include_once("inc/document_function.php");
include_once("inc/checkcurrentsession.php");
include_once("inc/utility_all.php");

$server = new soap_server ();
$server->soap_defencoding = "UTF-8";
$server->decode_utf8 = false;
$server->configureWSDL ( 'DocumentServicewsdl', 'urn:DocumentServicewsdl' );
$server->wsdl->schemaTargetNamespace = 'urn:DocumentServicewsdl';
//定义UseInfor的参数结构
$server->wsdl->addComplexType(
							'UserInfor',
							'complexType',
							'array',
							'all',
							'',
							array(
								  'user_id'    => array('name'=>'user_id','type'=>'xsd:string'),
								  'user_name'  => array('name'=>'user_name','type'=>'xsd:string'),		
								  'session_id' => array('name'=>'session_id','type'=>'xsd:string')		
							)
);
//--------------------------------定义传入参数的结构
$server->wsdl->addComplexType(
				'FileSearchType',
				'complexType',
				'struct',
				'all',
				'',
				array(
					  'FileCreatUser' => array('name'=>'FileCreatUser','type'=>'xsd:string'),
					  'FileName'      => array('name'=>'FileName','type'=>'xsd:string'),
					  'FileType'      => array('name'=>'FileType','type'=>'xsd:string'),
					  'FileList'      => array('name'=>'FileList','type'=>'xsd:string')
					  )
				);
//定义返回结构
$server->wsdl->addComplexType(
				'documentRerurnArray',
				'complexType',
				'array',
				'',
				'SOAP-ENC:Array',
				array(),
				array(
					  array(
							'ref' => 'SOAP-ENC:arrayType',
							'wsdl:arrayType' => 'tns:documentReturn[]'
							)
					  ),
				'tns:documentReturn' );

$server->wsdl->addComplexType(
				'documentReturn',
				'complexType',
				'struct',
				'all',
				'',
				array(
					  'SortId' => array ('name' => 'SortId', 'type' => 'xsd:string' ),
					  'Subject' => array ('name' => 'Subject', 'type' => 'xsd:string' ),
					  'SendTime' => array ('name' => 'SendTime', 'type' => 'xsd:string' ),
					  'UserName' => array ('name' => 'UserName', 'type' => 'xsd:string' ),
					  'UserId' => array ('name' => 'UserId', 'type' => 'xsd:string' ),
					  'DocumentId' => array ('name' => 'DocumentId', 'type' => 'xsd:string' ),
					  'CONTENT_TYPE' => array ('name' => 'CONTENT_TYPE', 'type' => 'xsd:string' )
					  )
				);

$server->register(
			'GetDocumentInforList',
			array(
				  'orderBy'         => 'xsd:string',
				  'limitOffset'     => 'xsd:string',
				  'limitRows'       => 'xsd:string',
				  'SearchType'      => 'tns:FileSearchType',
				  'UserInfor'       => 'tns:UserInfor'
				  ),
			array('return' => 'tns:documentRerurnArray' ),
			'urn:DocumentServicewsdl',
			'urn:DocumentServicewsdl#GetDocumentInforList',
			'rpc',
			'encoded',
			'Get Public GetDocumentInforList'
			);
//获取文档信息列表
function GetDocumentInforList($orderBy,$limitOffset,$limitRows,$SearchType,$UserInfor)
{
	CheckCurrentSession ();
	$read = new read($UserInfor);
	return $read->GetDocumentContent('',$SearchType["FileName"],$orderBy,$limitOffset,$limitRows,$SearchType);
}
//--------------------------------定义返回结构
$server->wsdl->addComplexType(
				'ReturnDocumentInfor',
				'complexType',
				'struct',
				'all',
				'',
				array(
					  'SortId' => array ('name' => 'SortId', 'type' => 'xsd:string' ),
					  'Subject' => array ('name' => 'Subject', 'type' => 'xsd:string' ),
					  'SendTime' => array ('name' => 'SendTime', 'type' => 'xsd:string' ),
					  'UserName' => array ('name' => 'UserName', 'type' => 'xsd:string' ),
					  'UserId' => array ('name' => 'UserId', 'type' => 'xsd:string' ),
					  'Content' => array ('name' => 'Content', 'type' => 'xsd:string' ),
					  'AttachmentDir' => array ('name' => 'AttachmentDir', 'type' => 'xsd:string' ),
					  'LinkDoc' => array ('name' => 'LinkDoc', 'type' => 'xsd:string' ),
					  'DocumentId' => array ('name' => 'DocumentId', 'type' => 'xsd:string' ),
					  'CONTENT_TYPE' => array ('name' => 'CONTENT_TYPE', 'type' => 'xsd:string' )
					  )
				);
$server->register(
			'GetDocumentInformation',
			array(
				  'DocumentId'      => 'xsd:int',
				  'UserInfor'       => 'tns:UserInfor'
				  ),
			array('return' => 'tns:ReturnDocumentInfor' ),
			'urn:DocumentServicewsdl',
			'urn:DocumentServicewsdl#GetDocumentInformation',
			'rpc',
			'encoded',
			'Get Public GetDocumentInformation'
			);
//获取文档信息列表
function GetDocumentInformation($DocumentId,$UserInfor)
{
	CheckCurrentSession ();
	$read = new read($UserInfor);
	$infor = $read->getDocumentResoultById($DocumentId,"","webservice");
	$fileInfor = array();
	$fileInfor["SortId"]        = $infor["SortId"];
	$fileInfor["Subject"]       = $infor["Subject"];
	$fileInfor["SendTime"]      = $infor["SendTime"];
	$fileInfor["UserName"]      = $infor["UserName"];
	$fileInfor["UserId"]        = $infor["UserId"];
	$fileInfor["Content"]       = $infor["Content"];
	$fileInfor["AttachmentDir"] = GetATTACHMENTURL($infor["AttachmentId"],$infor["AttachmentName"]);
	$fileInfor["LinkDoc"]       = $infor["LinkDoc"];
	$fileInfor["DocumentId"]    = $infor["DocumentId"];
	$fileInfor["CONTENT_TYPE"]  = $infor["ContentType"];
	return $fileInfor;
}
//--------------------------------定义参数结构
$server->wsdl->addComplexType(
				'FileSearchCount',
				'complexType',
				'struct',
				'all',
				'',
				array(
					  'FileName'      => array('name'=>'FileName','type'=>'xsd:string'),
					  'FileCreatUser' => array('name'=>'FileCreatUser','type'=>'xsd:string'),
					  'FileType'      => array('name'=>'FileType','type'=>'xsd:string'),
					  'FileList'      => array('name'=>'FileList','type'=>'xsd:string')
					  )
				);

$server->register(
			'GetDocumentAmount',
			array('FileSearch'=>'tns:FileSearchCount','UserInfor' => 'tns:UserInfor'),
			array('return' => 'xsd:string' ),
			'urn:DocumentServicewsdl',
			'urn:DocumentServicewsdl#GetDocumentAmount',
			'rpc',
			'encoded',
			'Get Document GetDocumentAmount'
			);
//获取文档数量
function GetDocumentAmount($FileSearch,$UserInfor) {
	CheckCurrentSession ();
	$read = new read($UserInfor);
	return $read->GetDocumentCount($FileSearch);
}
//--------------------------------定义返回结构
$server->wsdl->addComplexType(
				'ReplyArray',
				'complexType',
				'array',
				'',
				'SOAP-ENC:Array',
				array(),
				array(
					  array(
							'ref' => 'SOAP-ENC:arrayType',
							'wsdl:arrayType' => 'tns:Reply[]'
							)
					  ),
				'tns:Reply' 
				);
$server->wsdl->addComplexType(
				'Reply',
				'complexType',
				'struct',
				'all',
				'',
				array(
					  'REVERT_ID'  => array ('name' => 'REVERT_ID', 'type' => 'xsd:string' ),
					  'SORT_ID'    => array ('name' => 'SORT_ID', 'type' => 'xsd:string' ),
					  'RE_TIME'    => array ('name' => 'RE_TIME', 'type' => 'xsd:string' ),
					  'RE_NAME'    => array ('name' => 'RE_NAME', 'type' => 'xsd:string' ),
					  'RE_CONTENT' => array ('name' => 'RE_CONTENT', 'type' => 'xsd:string' ),
					  'USER_ID'    => array ('name' => 'USER_ID', 'type' => 'xsd:string' ),
					  'CONTENT_ID' => array ('name' => 'CONTENT_ID', 'type' => 'xsd:string' )
					  )
				);

$server->register(
			'GetDocumentReply',
			array(
				  'DocumentId' => 'xsd:string'
				  ),
			array('return' => 'tns:ReplyArray' ),
			'urn:DocumentServicewsdl',
			'urn:DocumentServicewsdl#GetDocumentReply',
			'rpc',
			'encoded',
			'Get Public Document reply'
			);

//获取文档回复
function GetDocumentReply($DocumentId)
{
	CheckCurrentSession ();
	$read = new read ();
	return $read->GetDocumentReply($DocumentId);
}
//--------------------------------定义返回结构
$server->wsdl->addComplexType(
				'ListRerurnArray',
				'complexType',
				'struct',
				'all',
				'',
				array(
					  'FILE_TYPE'   => array ('name' => 'FILE_TYPE', 'type' => 'xsd:string' ),
					  'SORT_ID'     => array ('name' => 'SORT_ID', 'type' => 'xsd:string' ),
					  'FROM_ID'     => array ('name' => 'FROM_ID', 'type' => 'xsd:string' ),
					  'SORT_PARENT' => array ('name' => 'SORT_PARENT', 'type' => 'xsd:string' ),
					  'SORT_NAME'   => array ('name' => 'SORT_NAME', 'type' => 'xsd:string' ),
					  'SORT_TYPE'   => array ('name' => 'SORT_TYPE', 'type' => 'xsd:string' ),
					  'CREATE_TIME' => array ('name' => 'CREATE_TIME', 'type' => 'xsd:string' ),
					  'USER_ID'     => array ('name' => 'USER_ID', 'type' => 'xsd:string' )
					  )
				);
$server->register(
			'GetDocumentList',
			array(
				  'DocumentId' => 'xsd:string'
				  ),
			array('return' => 'tns:ListRerurnArray' ),
			'urn:DocumentServicewsdl',
			'urn:DocumentServicewsdl#GetDocumentList',
			'rpc',
			'encoded',
			'Get Public Document List'
			);
//获取当前文档目录信息
function GetDocumentList($DocumentId)
{
	CheckCurrentSession ();
	$read = new read ();
	return $read->GetDocumentList($DocumentId);	
}

//--------------------------------定义返回结构
$server->wsdl->addComplexType(
				'FileListArray',
				'complexType',
				'array',
				'',
				'SOAP-ENC:Array',
				array(),
				array(
					  array(
							'ref' => 'SOAP-ENC:arrayType',
							'wsdl:arrayType' => 'tns:FileList[]'
							)
					  ),
				'tns:FileList' );

$server->wsdl->addComplexType(
				'FileList',
				'complexType',
				'struct',
				'all',
				'',
				array(
					  'SORT_ID'     => array ('name' => 'SORT_ID', 'type' => 'xsd:string' ),
					  'FROM_ID'     => array ('name' => 'FROM_ID', 'type' => 'xsd:string' ),
					  'SORT_PARENT' => array ('name' => 'SORT_PARENT', 'type' => 'xsd:string' ),
					  'SORT_NAME'   => array ('name' => 'SORT_NAME', 'type' => 'xsd:string' ),
					  'SORT_TYPE'   => array ('name' => 'SORT_TYPE', 'type' => 'xsd:string' ),
					  'CREATE_TIME' => array ('name' => 'CREATE_TIME', 'type' => 'xsd:string' ),
					  'USER_ID'     => array ('name' => 'USER_ID', 'type' => 'xsd:string' ),
					  'MODE_ID'     => array ('name' => 'MODE_ID', 'type' => 'xsd:string' ),
					  'TPL_ID'      => array ('name' => 'TPL_ID', 'type' => 'xsd:string' ),
					  'PUR_METHOD'  => array ('name' => 'PUR_METHOD', 'type' => 'xsd:string' ),
					  'FILE_SORTING'  => array ('name' => 'FILE_SORTING', 'type' => 'xsd:string' )
					  )
				);

$server->register(
			'GetFileRelation',
			array(
				  'SortDiff' => 'xsd:string',
				  'SortId'   => 'xsd:string',
				  'UserInfor' => 'tns:UserInfor'
				  ),
			array('return' => 'tns:FileListArray' ),
			'urn:DocumentServicewsdl',
			'urn:DocumentServicewsdl#GetFileRelation',
			'rpc',
			'encoded',
			'Get Public Document ListRealation'
			);
//获取文件夹的上下级关系
function GetFileRelation($SortDiff,$SortId,$UserInfor)
{
	CheckCurrentSession ();
	$read = new read($UserInfor);
	return $read->GetFileRelation($SortDiff,$SortId);		
}
//--------------------------------定义参数结构
$server->wsdl->addComplexType(
				'SaveReply',
				'complexType',
				'struct',
				'all',
				'',
				array(
					  'UserId'       => array('name'=>'UserId','type'=>'xsd:string'),
					  'DocumentId'   => array('name'=>'DocumentId','type'=>'xsd:string'),
					  'ReplyTime'    => array('name'=>'ReplyTime','type'=>'xsd:string'),
					  'ReplyContent' => array('name'=>'ReplyContent','type'=>'xsd:string')
					  )
				);

$server->register(
			'SaveFileReply',
			array('Reply'=>'tns:SaveReply'),
			array('return' => 'xsd:string' ),
			'urn:DocumentServicewsdl',
			'urn:DocumentServicewsdl#SaveFileReply',
			'rpc',
			'encoded',
			'Get Document Reply'
			);
//保存文档回复
function SaveFileReply($Reply)
{
	CheckCurrentSession ();
	$read = new read ();
	return $read->SaveFileReply($Reply);		
}
//--------------------------------定义返回结构
$server->wsdl->addComplexType(
				'FileSortArray',
				'complexType',
				'array',
				'',
				'SOAP-ENC:Array',
				array(),
				array(
					  array(
							'ref' => 'SOAP-ENC:arrayType',
							'wsdl:arrayType' => 'tns:FileSort[]'
							)
					  ),
				'tns:FileSort' );

$server->wsdl->addComplexType(
				'FileSort',
				'complexType',
				'struct',
				'all',
				'',
				array(
					  'SORT_ID'     => array ('name' => 'SORT_ID', 'type' => 'xsd:string' ),
					  'SORT_TYPE'   => array ('name' => 'SORT_TYPE', 'type' => 'xsd:string' ),
					  'USER_ID'     => array ('name' => 'USER_ID', 'type' => 'xsd:string' ),
					  'PRIV_ID'     => array ('name' => 'PRIV_ID', 'type' => 'xsd:string' ),
					  'DEPT_ID'     => array ('name' => 'DEPT_ID', 'type' => 'xsd:string' ),
					  'DEPT_MANAGE' => array ('name' => 'DEPT_MANAGE', 'type' => 'xsd:string' ),
					  'DEPT_NEW'    => array ('name' => 'DEPT_NEW', 'type' => 'xsd:string' ),
					  'DEPT_DOWN'   => array ('name' => 'DEPT_DOWN', 'type' => 'xsd:string' ),
					  'DEPT_RE'     => array ('name' => 'DEPT_RE', 'type' => 'xsd:string' ),
					  'PRIV_MANAGE' => array ('name' => 'PRIV_MANAGE', 'type' => 'xsd:string' ),
					  'PRIV_NEW'    => array ('name' => 'PRIV_NEW', 'type' => 'xsd:string' ),
					  'PRIV_DOWN'   => array ('name' => 'PRIV_DOWN', 'type' => 'xsd:string' ),
					  'PRIV_RE'     => array ('name' => 'PRIV_RE', 'type' => 'xsd:string' ),
					  'USER_MANAGE' => array ('name' => 'USER_MANAGE', 'type' => 'xsd:string' ),
					  'USER_NEW'    => array ('name' => 'USER_NEW', 'type' => 'xsd:string' ),
					  'USER_DOWN'   => array ('name' => 'USER_DOWN', 'type' => 'xsd:string' ),
					  'USER_RE'     => array ('name' => 'USER_RE', 'type' => 'xsd:string' )
					  )
				);
$server->register(
			'GetFilePurview',
			array(
				  'SortId'=>'xsd:string'
				  ),
			array(
				  'return' => 'tns:FileSortArray'
				  ),
			'urn:DocumentServicewsdl',
			'urn:DocumentServicewsdl#GetFilePurview',
			'rpc',
			'encoded',
			'Get Document GetFilePurviewply'
			);
//获取文件夹权限
function GetFilePurview($SortId)
{
	CheckCurrentSession ();
	$read = new read ();
	return $read->GetFilePurview($SortId);	
}
//新建文档
//--------------------------------定义返回结构
$server->wsdl->addComplexType(
				'filearray',
				'complexType',
				'struct',
				'all',
				'',
				array(
					  'subject'        => array('name'=>'subject','type'=>'xsd:string'),
					  'sortid'         => array('name'=>'sortid','type'=>'xsd:string'),
					  'content'        => array('name'=>'content','type'=>'xsd:string'),
					  'attachmentid'   => array('name'=>'attachmentid','type'=>'xsd:string'),
					  'attachmentname' => array('name'=>'attachmentname','type'=>'xsd:string')
					  )
				);
$server->register(
			'NewCreatFile',
			array(
				  'filedata'        => 'tns:filearray',
				  'UserInfor'       => 'tns:UserInfor',
				  'diff'            => 'xsd:string'
				  ),
			array('return' => 'xsd:string' ),
			'urn:DocumentServicewsdl',
			'urn:DocumentServicewsdl#NewCreatFile',
			'rpc',
			'encoded',
			'Get Public NewCreatFile'
			);
function NewCreatFile($filedata,$UserInfor,$diff)
{
	CheckCurrentSession ();
	$read = new read($UserInfor);
	$documentid = $read->CreatNewDocument($filedata,$diff);	
	return $documentid;
}

$server->service ( $HTTP_RAW_POST_DATA );
?>