<?php
/**
 * @copyright (C) 2000 - 2010 Weaver Co.Ltd
 * @package   eoffice7.0
 * @name      webroot/webservice/news/news.wsdl.php
 * @version   1.0 
 * @author    liuqingyu
 */

include_once ("nusoap/lib/nusoap.php");
include_once ("api/news.class.php");
include_once ("api/user.class.php");
include_once ("inc/conn.php");
include_once ("inc/function_picture.php");
include_once ("inc/utility_all.php");
include_once ("inc/checkcurrentsession.php");
/*---------实例化soap_server对象并初始化---------*/
$server                   = new soap_server();
$server->soap_defencoding = "UTF-8";
$server->decode_utf8      = false;
$server->configureWSDL ( 'NewsServicewsdl', 'urn:NewsServicewsdl' );
$server->wsdl->schemaTargetNamespace = 'urn:NewsServicewsdl';
/*---------注册获取新闻列表函数---------*/
//定义参数类型
$server->wsdl->addComplexType(
		'NewsSearch',
		'complexType',
		'array',
		'all',
		'',
		array(
			  'NewsSubject'     => array('name'=>'NewsSubject','type'=>'xsd:string'),
			  'NewsSort'        => array('name'=>'NewsSort','type'=>'xsd:string'),		
			  'NewsOther'       => array('name'=>'NewsOther','type'=>'xsd:string')		
		)
);
//=========定义返回值类型 begin
$server->wsdl->addComplexType (
		'newsinfo_return_array', 
		'complexType',
		'array',
		'',
		'SOAP-ENC:Array',
		array (),
		array (
			array ('ref' => 'SOAP-ENC:arrayType','wsdl:arrayType' => 'tns:newsinfo_return[]')
			),
	   'tns:newsinfo_return'
	);
$server->wsdl->addComplexType (
		'newsinfo_return',
		'complexType',
		'struct',
		'all',
		'',
		array(
			  'NEWS_ID'          => array ('name' => 'NEWS_ID', 'type' => 'xsd:string'),
			  'SUBJECT'          => array ('name' => 'SUBJECT', 'type' => 'xsd:string'),
			  'PROVIDER'         => array ('name' => 'PROVIDER', 'type' => 'xsd:string'),
			  'PROVIDER_NAME'    => array ('name' => 'PROVIDER_NAME', 'type' => 'xsd:string'),
			  'USER_PRIV'        => array ('name' => 'USER_PRIV', 'type' => 'xsd:string'),
			  'NEWS_TIME'        => array ('name' => 'NEWS_TIME', 'type' => 'xsd:string' ),
			  'CLICK_COUNT'      => array ('name' => 'CLICK_COUNT', 'type' => 'xsd:string'),
			  'NEWS_TYPE_ID'     => array ('name' => 'NEWS_TYPE_ID', 'type' => 'xsd:string' ),
			  'ALLOW_REPLY'      => array ('name' => 'ALLOW_REPLY', 'type' => 'xsd:string' ),
			  'news_reader'      => array ('name' => 'news_reader', 'type' => 'xsd:string' ),
			  'news_reader_name' => array ('name' => 'news_reader_name', 'type' => 'xsd:string' ),
			  'ATTACHMENT_ID'    => array ('name' => 'ATTACHMENT_ID', 'type' => 'xsd:string'),
			  'ATTACHMENT_NAME'  => array ('name' => 'ATTACHMENT_NAME', 'type' => 'xsd:string'),
			  'PICTURE_DIR'      => array ('name' => 'PICTURE_DIR', 'type' => 'xsd:string')
			  )
	);
//========= end
$server->register (
		'GetNewsList',
		array (
			   'start' => 'xsd:string',
			   'limit' => 'xsd:string',
			   'search' => 'tns:NewsSearch'
			   ),
		array ('return' => 'tns:newsinfo_return_array'),
		'urn:NewsServicewsdl',
		'urn:NewsServicewsdl#GetNewsList',
		'rpc',
		'encoded',
		'Get E-office news GetNewsList'
	);

/*
@function:  获取新闻 列表
@parameter: $a->          string  :每页显示的条数
			$b->          string  :当前页从第几条开始显示
			$c->          string  :需要获取新闻的ID号
@return:    $news->       Array   :新闻的详细信息
*/
function GetNewsList($start,$limit,$search) {
	CheckCurrentSession();
	$newsApi = new news ();
	$news = $newsApi->getNewsInfo($limit,$start,"",$search);
	foreach($news as $index => $val)
	{
		$news[$index]['news_reader_name'] = getUsernameStr($val['news_reader']);	
	}
	return $news;
}
/*---------注册获取新闻详细信息---------*/
$server->wsdl->addComplexType (
		'ReturnNewsInfor',
		'complexType',
		'struct',
		'all',
		'',
		array(
			  'NEWS_ID'          => array ('name' => 'NEWS_ID', 'type' => 'xsd:string'),
			  'SUBJECT'          => array ('name' => 'SUBJECT', 'type' => 'xsd:string'),
			  'PROVIDER'         => array ('name' => 'PROVIDER', 'type' => 'xsd:string'),
			  'PROVIDER_NAME'    => array ('name' => 'PROVIDER_NAME', 'type' => 'xsd:string'),
			  'USER_PRIV'        => array ('name' => 'USER_PRIV', 'type' => 'xsd:string'),
			  'NEWS_TIME'        => array ('name' => 'NEWS_TIME', 'type' => 'xsd:string' ),
			  'CLICK_COUNT'      => array ('name' => 'CLICK_COUNT', 'type' => 'xsd:string'),
			  'CONTENT'          => array ('name' => 'CONTENT', 'type' => 'xsd:string' ),
			  'NEWS_TYPE_ID'     => array ('name' => 'NEWS_TYPE_ID', 'type' => 'xsd:string' ),
			  'ALLOW_REPLY'      => array ('name' => 'ALLOW_REPLY', 'type' => 'xsd:string' ),
			  'news_reader'      => array ('name' => 'news_reader', 'type' => 'xsd:string' ),
			  'news_reader_name' => array ('name' => 'news_reader_name', 'type' => 'xsd:string' ),
			  'ATTACHMENT_ID'    => array ('name' => 'ATTACHMENT_ID', 'type' => 'xsd:string'),
			  'ATTACHMENT_NAME'  => array ('name' => 'ATTACHMENT_NAME', 'type' => 'xsd:string'),
			  'PICTURE_DIR'      => array ('name' => 'PICTURE_DIR', 'type' => 'xsd:string')
			  )
	);
$server->register (
		'GetNewsInformation',
		array (
			   'NewsId' => 'xsd:string'
			   ),
		array ('return' => 'tns:ReturnNewsInfor'),
		'urn:NewsServicewsdl',
		'urn:NewsServicewsdl#GetNewsInformation',
		'rpc',
		'encoded',
		'Get E-office news GetNewsInformation'
	);
/*
@function:  获取新闻详细信息
@parameter: $NewsId->     string  :新闻ID号
@return:    $news->       Array   :新闻的详细信息
*/
function GetNewsInformation($NewsId) {
	CheckCurrentSession();
	$newsApi = new news ();
	$news = $newsApi->getNewsInfo("","",$NewsId,array());
	foreach($news as $index => $val)
	{
		$news[$index]['news_reader_name'] = getUsernameStr($val['news_reader']);	
	}
	return $news[0];
}

/*---------注册获取新闻数目函数getNewsAmount---------*/
$server->register(
		'getNewsAmount',
		array('search' => 'tns:NewsSearch'),
		array('return' => 'xsd:string'),
		'urn:NewsServicewsdl',
		'urn:NewsServicewsdl#getNewsAmount',
		'rpc',
		'encoded',
		'Get E-office news count'
	);
/*
@function:  获取新闻数量
@parameter: 无
@return:    $counts->       string   :新闻的数量
*/
function getNewsAmount($search){
	CheckCurrentSession();
	$newsapi = new news();
	$counts  = $newsapi->GetNewsCount($search);
    return $counts;	
	}
	
/*---------注册获取新闻类别信息函数---------*/
$server->wsdl->addComplexType (
		'ReturnNewsSortInfor', 
		'complexType',
		'array',
		'',
		'SOAP-ENC:Array',
		array (),
		array (
			array ('ref' => 'SOAP-ENC:arrayType','wsdl:arrayType' => 'tns:NewsSortInfor[]')
			),
	   'tns:NewsSortInfor'
	);
$server->wsdl->addComplexType (
		'NewsSortInfor',
		'complexType',
		'struct',
		'all',
		'',
		array(
			  'NEWS_TYPE_ID'    => array ('name' => 'NEWS_TYPE_ID', 'type' => 'xsd:string'),
			  'NEWS_TYPE_NAME'  => array ('name' => 'NEWS_TYPE_NAME', 'type' => 'xsd:string'),
			  'NEWS_TYPE_PRO'   => array ('name' => 'NEWS_TYPE_PRO', 'type' => 'xsd:string')
			  )
	);

$server->register(
		'GetNewsSort',
		array('SortId' => 'xsd:int'),
		array('return' => 'tns:ReturnNewsSortInfor'),
		'urn:NewsServicewsdl',
		'urn:NewsServicewsdl#GetNewsSort',
		'rpc',
		'encoded',
		'Get E-office news GetNewsSort'
	);
/*
@function:  获取新闻数量
@parameter: 无
@return:    $counts->       string   :新闻的数量
*/
function GetNewsSort($SortId){
	CheckCurrentSession();
	$newsapi = new news();
	$Infor  = $newsapi->GetNewsSortInformation($SortId);
    return $Infor;	
	}	

//返回数据
$HTTP_RAW_POST_DATA = isset($HTTP_RAW_POST_DATA) ? $HTTP_RAW_POST_DATA : '';
$server->service($HTTP_RAW_POST_DATA);

?>