<?php
/**
* @copyright (C) 2000 - 2010 Weaver Co.Ltd
* @package   eoffice7.0
* @name      webroot/webservice/notify/notify.wsdl.php
* @version   1.0 
* @author    liuqingyu
*/
include_once("nusoap/lib/nusoap.php");
include_once("api/notify.class.php");
include_once("api/user.class.php");
include_once("inc/conn.php");
include_once("wap/function.php");
//session处理
include_once("inc/checkcurrentsession.php");
//实例化soap_server对象并初始化
$server                   = new soap_server();
$server->soap_defencoding = "UTF-8";
$server->decode_utf8      = false;
$server->configureWSDL('notifyServicewsdl','urn:notifyServicewsdl');
$server->wsdl->schemaTargetNamespace = 'urn:notifyServicewsdl';
//定义UseInfor的参数结构
$server->wsdl->addComplexType(
							'UserInfor',
							'complexType',
							'array',
							'all',
							'',
							array(
								  'user_id'    => array('name'=>'user_id','type'=>'xsd:string'),
								  'user_name'  => array('name'=>'user_name','type'=>'xsd:string'),		
								  'session_id' => array('name'=>'session_id','type'=>'xsd:string')		
							)
);
//定义参数类型
$server->wsdl->addComplexType(
		'NotifySearch',
		'complexType',
		'array',
		'all',
		'',
		array(
			  'NotifySubject'     => array('name'=>'NotifySubject','type'=>'xsd:string'),
			  'NotifySort'        => array('name'=>'NotifySort','type'=>'xsd:string'),		
			  'NotifyOther'       => array('name'=>'NotifyOther','type'=>'xsd:string')		
		)
);
/*---------注册获取公告信息函数getNotifyInfo---------*/
//=========定义返回值类型 begin
$server->wsdl->addComplexType (
		'NotifyDetialArray',
		'complexType',
		'array',
		'',
		'SOAP-ENC:Array',
		array (),
		array (
			   array ('ref' => 'SOAP-ENC:arrayType', 'wsdl:arrayType' => 'tns:NotifyDetial[]')
			   ),
		'tns:NotifyDetial'
	);
$server->wsdl->addComplexType (
		'NotifyDetial',
		'complexType',
		'struct',
		'all',
		'',
		array(
			  'NOTIFY_ID' => array ('name' => 'NOTIFY_ID', 'type' => 'xsd:string'),
			  'FROM_ID' => array ('name' => 'FROM_ID', 'type' => 'xsd:string'),
			  'FROM_NAME' => array ('name' => 'FROM_NAME', 'type' => 'xsd:string'),
			  'SUBJECT' => array ('name' => 'SUBJECT', 'type' => 'xsd:string'),
			  'SEND_TIME' => array ('name' => 'SEND_TIME', 'type' => 'xsd:string' ),
			  'READERS' => array ('name' => 'READERS', 'type' => 'xsd:string'),
			  'READERS_NAME' => array ('name' => 'READERS_NAME', 'type' => 'xsd:string'),
			  'READ_FLAG' => array ('name' => 'READ_FLAG', 'type' => 'xsd:string' ),
			  'NOTIFY_TYPE' => array ('name' => 'NOTIFY_TYPE', 'type' => 'xsd:string'),
			  'PUBLISH_DEPT' => array ('name' => 'PUBLISH_DEPT', 'type' => 'xsd:string'),
			  'PUBLISH_PRIV' => array ('name' => 'PUBLISH_PRIV', 'type' => 'xsd:string'),
			  'PUBLISH_USER' => array ('name' => 'PUBLISH_USER', 'type' => 'xsd:string')
			  )
	);
//========= end
$server->register(
		'GetNotifyList',
		array(
			  'start' => 'xsd:string',
			  'limit'=> 'xsd:string',
			  'search'=> 'tns:NotifySearch',
			  'UserInfor' => 'tns:UserInfor'
			  ), 
		array('return' => 'tns:NotifyDetialArray'),
		'urn:notifyServicewsdl',
		'urn:notifyServicewsdl#GetNotifyList',
		'rpc',
		'encoded',
		'Get E-office notify GetNotifyList'
	);
/*
@function:  获取公告列表
@parameter: $a->               string  :每页显示的条数
			$b->               string  :当前页从第几条开始显示
			$c->               string  :查看或者当前的公告ID
@return:    $notify_message->  Array   :公告的详细信息
*/
function GetNotifyList($start,$limit,$search,$UserInfor){
	CheckCurrentSession();
	$notifyApi         = new notify($UserInfor);
	$notify_message    = $notifyApi->getNotifyInfo($limit,$start,"",$search);
	foreach($notify_message as $index => $val)
	{
		$notify_message[$index]['READERS_NAME']       = getUsernameStr($val['READERS']);	
	}
	return $notify_message;
}
/*---------注册获取公告详细信息函数-------------------*/
$server->wsdl->addComplexType (
		'NotifyInformation',
		'complexType',
		'struct',
		'all',
		'',
		array(
			  'NOTIFY_ID' => array ('name' => 'NOTIFY_ID', 'type' => 'xsd:string'),
			  'FROM_ID' => array ('name' => 'FROM_ID', 'type' => 'xsd:string'),
			  'FROM_NAME' => array ('name' => 'FROM_NAME', 'type' => 'xsd:string'),
			  'SUBJECT' => array ('name' => 'SUBJECT', 'type' => 'xsd:string'),
			  'CONTENT' => array ('name' => 'CONTENT', 'type' => 'xsd:string'),
			  'SEND_TIME' => array ('name' => 'SEND_TIME', 'type' => 'xsd:string' ),
			  'READERS' => array ('name' => 'READERS', 'type' => 'xsd:string'),
			  'READERS_NAME' => array ('name' => 'READERS_NAME', 'type' => 'xsd:string'),
			  'READ_FLAG' => array ('name' => 'READ_FLAG', 'type' => 'xsd:string' ),
			  'ATTACHMENT_ID' => array ('name' => 'ATTACHMENT_ID', 'type' => 'xsd:string'),
			  'ATTACHMENT_NAME' => array ('name' => 'ATTACHMENT_NAME', 'type' => 'xsd:string'),
  			  'ATTACHMENT_DIR' => array ('name' => 'ATTACHMENT_DIR', 'type' => 'xsd:string'),
			  'NOTIFY_TYPE' => array ('name' => 'NOTIFY_TYPE', 'type' => 'xsd:string'),
			  'PUBLISH_DEPT' => array ('name' => 'PUBLISH_DEPT', 'type' => 'xsd:string'),
			  'PUBLISH_PRIV' => array ('name' => 'PUBLISH_PRIV', 'type' => 'xsd:string'),
			  'PUBLISH_USER' => array ('name' => 'PUBLISH_USER', 'type' => 'xsd:string')
			  )
	);
//========= end
$server->register(
		'GetNotifyInformation',
		array(
			  'NotifyId' => 'xsd:int',
			  'UserInfor' => 'tns:UserInfor'
			  ), 
		array('return' => 'tns:NotifyInformation'),
		'urn:notifyServicewsdl',
		'urn:notifyServicewsdl#GetNotifyInformation',
		'rpc',
		'encoded',
		'Get E-office notify GetNotifyInformation'
	);
/*
@function:  获取公告详细信息
@parameter: $NotifyId->        int     :公告ID
@return:    $notify_message->  Array   :公告的详细信息
*/
function GetNotifyInformation($NotifyId,$UserInfor){
	CheckCurrentSession();
	$notifyApi         = new notify($UserInfor);
	$notify_message    = $notifyApi->getNotifyInfo("","",$NotifyId,array());
	foreach($notify_message as $index => $val)
	{
		$notify_message[$index]['READERS_NAME']       = getUsernameStr($val['READERS']);	
	}
	return $notify_message[0];
}

/*---------注册获取公告类别函数getNotifyType---------*/
$server->wsdl->addComplexType (
		'notify_type_array',
		'complexType',
		'array',
		'',
		'SOAP-ENC:Array',
		array (),
		array (
			   array ('ref' => 'SOAP-ENC:arrayType', 'wsdl:arrayType' => 'tns:notify_type[]')
			   ),
		'tns:notify_type'
	);
$server->wsdl->addComplexType (
		'notify_type',
		'complexType',
		'struct',
		'all',
		'',
		array(
			  'NOTIFY_TYPE_ID' => array ('name' => 'NOTIFY_TYPE_ID', 'type' => 'xsd:string'),
			  'NOTIFY_TYPE_NAME' => array ('name' => 'NOTIFY_TYPE_NAME', 'type' => 'xsd:string'),
			  'NOTIFY_TYPE_PRO' => array ('name' => 'NOTIFY_TYPE_PRO', 'type' => 'xsd:string')
			  )
	);

$server->register(
			'GetNotifyType',
			array(
				  'TypeId' => 'xsd:string'
				  ),
			array('return' => 'tns:notify_type_array' ),
			'urn:notifyServicewsdl',
			'urn:notifyServicewsdl#GetNotifyType',
			'rpc',
			'encoded',
			'Get Public notify type'
			);

/*
@function:  获取类别
@parameter: $TypeId->               string  :公告类别ID，可以为空
@return:    $NotifyType->  Array   :公告的详细信息
*/
function GetNotifyType($TypeId){
	CheckCurrentSession();
	$notifyApi     = new notify();
	$NotifyType    = $notifyApi->GetNotifyType($TypeId);
	return $NotifyType;
}

/*---------注册获取公告数量函数getNotifyAmount---------*/
$server->register(
		'getNotifyAmount',
		array('search' => 'tns:NotifySearch','UserInfor' => 'tns:UserInfor'),
		array('return'=>'xsd:string'),
		'urn:notifyServicewsdl',
		'urn:notifyServicewsdl#getNotifyAmount',
		'rpc',
		'encoded',
		'Get E-office notify count'
	);
/*
@function:  获取公告数量
@parameter: 无
@return:    $notify_counts->  string  :公告数量
*/
function getNotifyAmount($search,$UserInfor){
	CheckCurrentSession();
	$notifyApi 		  = new notify($UserInfor);
	$notify_counts    = $notifyApi->getNotifyAmount($search);
	return $notify_counts;
	}

/*---------注册获取最新公告数量函数getNewNotifyAmount---------*/
$server->register(
		'getNewNotifyAmount',
		array('UserInfor' => 'tns:UserInfor'),
		array('return'=>'xsd:string'),
		'urn:notifyServicewsdl',
		'urn:notifyServicewsdl#getNewNotifyAmount',
		'rpc',
		'encoded',
		'Get E-office notify count'
	);
/*
@function:  获取最新未读公告数
@parameter: 无
@return:    $notify_new_counts->  string  :公告数
*/
function getNewNotifyAmount($UserInfor){
	CheckCurrentSession();
	$notifyApi 		       = new notify($UserInfor);
	$notify_new_counts     = $notifyApi->getNewNotifyAmount();
	return $notify_new_counts;
	}

/*---------注册更新阅读公告的人员函数updateReadStatus---------*/
$server->register(
		'updateReadStatus',
		array('notifyid'=>'xsd:int','UserInfor' => 'tns:UserInfor'),
		array('return'=>'xsd:string'),
		'urn:notifyServicewsdl',
		'urn:notifyServicewsdl#updateReadStatus',
		'rpc',
		'encoded',
		'Get E-office notify count'
	);
/*
@function:  更新阅读公告的人员
@parameter: $notifyid->         int :当前浏览公告的ID号
@return:    无
*/
function updateReadStatus($notifyid,$UserInfor){
	CheckCurrentSession();
	$notifyApi 		        = new notify($UserInfor);
	$notify_update_status   = $notifyApi->updateReadStatus($notifyid);
	return 1;
	}

//返回数据

$HTTP_RAW_POST_DATA = isset($HTTP_RAW_POST_DATA) ? $HTTP_RAW_POST_DATA : '';
$server->service($HTTP_RAW_POST_DATA);

?>