<?php
/**
* @copyright (C) 2000 - 2010 Weaver Co.Ltd
* @package   eoffice7.0
* @name      webroot/webservice/online_person/online_person.wsdl.php
* @version   1.0
* @author    liuqingyu
*/

include_once("nusoap/lib/nusoap.php");
include_once("api/user.class.php");
include_once("inc/conn.php");
include_once("inc/utility_all.php");
include_once("inc/function_picture.php");
include_once("inc/checkcurrentsession.php");
/*---------实例化soap_server对象并初始化---------*/
$server                   = new soap_server();
$server->soap_defencoding = "UTF-8";
$server->decode_utf8      = false;
$server->configureWSDL('personServicewsdl','urn:personServicewsdl');
$server->wsdl->schemaTargetNamespace = 'urn:personServicewsdl';
/*---------注册获取用户信息函数get_UserInfo---------*/
//=========定义返回值类型 begin
$server->wsdl->addComplexType (
		'userinfo_return_array',
		'complexType', 'array',
		'',
		'SOAP-ENC:Array',
		array (),
		array (
			   array ('ref' => 'SOAP-ENC:arrayType', 'wsdl:arrayType' => 'tns:userinfo_return[]')
			   ),
		'tns:userinfo_return'
	);
$server->wsdl->addComplexType (
		'userinfo_return',
		'complexType',
		'struct',
		'all',
		'',
		array(
			  'USER_ID' => array ('name' => 'USER_ID', 'type' => 'xsd:string'),
			  'USER_ACCOUNTS' => array ('name' => 'USER_ACCOUNTS', 'type' => 'xsd:string'),
			  'USER_NAME' => array ('name' => 'USER_NAME', 'type' => 'xsd:string'),
			  'USER_PRIV' => array ('name' => 'USER_PRIV', 'type' => 'xsd:string'),
			  'PRIV_NAME' => array ('name' => 'PRIV_NAME', 'type' => 'xsd:string'),
			  'DEPT_ID' => array ('name' => 'DEPT_ID', 'type' => 'xsd:string' ),
			  'DEPT_NAME' => array ('name' => 'DEPT_NAME', 'type' => 'xsd:string' ),
			  'SEX' => array ('name' => 'SEX', 'type' => 'xsd:string'),
			  'BIRTHDAY' => array ('name' => 'BIRTHDAY', 'type' => 'xsd:string' ),
			  'MOBIL_NO' => array ('name' => 'MOBIL_NO', 'type' => 'xsd:string'),
			  'EMAIL' => array ('name' => 'EMAIL', 'type' => 'xsd:string'),
			  'TEL_NO_DEPT' => array ('name' => 'TEL_NO_DEPT', 'type' => 'xsd:string'),
			  'ADD_HOME' => array ('name' => 'ADD_HOME', 'type' => 'xsd:string'),
			  'POST_NO_HOME' => array ('name' => 'POST_NO_HOME', 'type' => 'xsd:string'),
			  'FAX_NO_DEPT' => array ('name' => 'FAX_NO_DEPT', 'type' => 'xsd:string')
			  )
	);
//=========end
$server->register(
		'get_UserInfo',
		array(
			  'a'=>'xsd:string',
			  'b'=>'xsd:string',
			  'c'=>'xsd:string',
			  'd'=>'xsd:string',
			  'e'=>'xsd:string',
			  'f'=>'xsd:string'
			  ),
		array('return' => 'tns:userinfo_return_array'),
		'urn:personServicewsdl',
		'urn:personServicewsdl#get_UserInfo',
		'rpc',
		'encoded',
		'Get E-office online_person count'
	);
/*
@function:  获取用户信息
@parameter: $a->          string  :查看用户ID号
			$b->          string  :用户账户
			$c->          string  :用户状态
			$d->          string  :每页显示的用户数
			$e->          string  :下一页从第几个用户开始
			$f->          string  :是否在线
@return:    $user_info->  Array   :用户的详细信息
*/
function get_UserInfo($a,$b,$c,$d,$e,$f)
{
	//CheckCurrentSession();
	$userapi   = new user();
	$user_info = array();
	$user_info = $userapi->getUserInfo($a,$b,$c,$d,$e,$f);
	foreach($user_info as $index => $val)
	{
		$user_info[$index]['PRIV_NAME'] = getPrivStr($val['USER_PRIV'].",");
		$user_info[$index]['PRIV_NAME'] = substr($user_info[$index]['PRIV_NAME'],0,-1);
		$user_info[$index]['DEPT_NAME'] = getDeptName($val['DEPT_ID']);
	}
	return $user_info;
	}

/*---------注册获取用户统计，在线统计数函数getUserAmount---------*/
$server->register(
		'getUserAmount',
		array(
			  'a'=>'xsd:string',
			  'b'=>'xsd:string'
			  ),
		array('return'=>'xsd:string'),
		'urn:personServicewsdl',
		'urn:personServicewsdl#getUserAmount',
		'rpc',
		'encoded',
		'Get E-office online_person count'
	);
/*
@function:  用户统计，在线统计
@parameter: $a->              string  :用户的状态
			$b->              string  :是否在线
@return:    $user_counts->    string  :返回人员的数目
*/
function getUserAmount($a,$b)
{
	CheckCurrentSession();
	$userapi     = new user();
	$user_counts = $userapi->getUserAmount($a,$b);
	return $user_counts;

	}
//
/*---------注册获取用户是否在线函数getOnline---------*/
//=========定义返回值类型 begin
$server->wsdl->addComplexType(
		'return_online',
		'complexType',
		'struct',
		'all',
		'',
		array(
			  'img'=>array('name'=>'img','type'=>'xsd:string'),
			  'status'=>array('name'=>'status','type'=>'xsd:string')
			  )
	);
//========= end
$server->register(
		'getOnline',
		array('userid'=>'xsd:string'),
		array('return'=>'tns:return_online'),
		'urn:personServicewsdl',
		'urn:personServicewsdl#getOnline',
		'rpc',
		'encoded',
		'Get E-office online_person count'
	);
/*
@function:  判断用户是否在线
@parameter: $userid->          string  :判断用户的ID号
@return:    $user_online->     Array   :在线状态和在线图标
*/
function getOnline($userid)
{
	CheckCurrentSession();
	$user_online = getIsOnline($userid);
	return $user_online;

	}

/*---------注册获取用户角色函数getPrivInfo---------*/
//=========定义返回值类型 begin
$server->wsdl->addComplexType(
		'return_user_privinfo',
		'complexType',
		'struct',
		'all',
		'',
		array(
			  'USER_PRIV'=>array('name'=>'USER_PRIV','type'=>'xsd:string'),
			  'PRIV_NAME'=>array('name'=>'PRIV_NAME','type'=>'xsd:string')
			  )
	);
//========= end
$server->register(
		'getPrivInfo',
		array('a'=>'xsd:string'),
		array('return'=>'tns:return_user_privinfo'),
		'urn:personServicewsdl',
		'urn:personServicewsdl#getPrivInfo',
		'rpc',
		'encoded',
		'Get E-office online_person count'
	);
/*
@function:  获取用户角色
@parameter: $a->               string  :查看用户的权限角色ID号
@return:    $user_deptinfo->   Array   :查看用户的角色ID号和角色名称
*/
function getPrivInfo($a)
{
	CheckCurrentSession();
	$userapi       = new user();
	$user_privinfo = $userapi->	getPrivInfo($a);
	return $user_privinfo;

	}

/*---------注册获取用户部门函数getUserAmount---------*/
//=========定义返回值类型 begin
$server->wsdl->addComplexType(
		'ReturnDeptInfo',
		'complexType',
		'struct',
		'all',
		'',
		array(
			  'DEPT_ID'=>array('name'=>'DEPT_ID','type'=>'xsd:string'),
			  'DEPT_NAME'=>array('name'=>'DEPT_NAME','type'=>'xsd:string'),
			  'DEPT_PARENT'=>array('name'=>'DEPT_PARENT','type'=>'xsd:string')
			  )
	);
//========= end
$server->register(
		'GetDeptInformation',
		array('a'=>'xsd:int'),
		array('return'=>'tns:ReturnDeptInfo'),
		'urn:personServicewsdl',
		'urn:personServicewsdl#GetDeptInformation',
		'rpc',
		'encoded',
		'Get E-office online_person GetDeptInformation'
	);
/*
@function:  获取用户部门
@parameter: $a->               string  :查看用户的部门ID号
@return:    $user_deptinfo->   Array   :查看用户的部门ID号和部门名称
*/
function GetDeptInformation($a)
{
	CheckCurrentSession();
	$userapi       = new user();
	$user_deptinfo = $userapi->getDeptInfo($a);
	return $user_deptinfo;

	}

/*---------注册获取用户图片函数getHrInfo---------*/
//=========定义返回值类型 begin
$server->wsdl->addComplexType(
		'return_user_Hrinfo',
		'complexType',
		'struct',
		'all',
		'',
		array(
			  'USER_ID'=>array('name'=>'USER_ID','type'=>'xsd:string'),
			  'PHOTO'=>array('name'=>'PHOTO','type'=>'xsd:string'),
			  'PICTURE_DIR'=>array('name'=>'PICTURE_DIR','type'=>'xsd:string')
			  )
	);
//========= end
$server->register(
		'getHrInfo',
		array('a'=>'xsd:string'),
		array('return'=>'tns:return_user_Hrinfo'),
		'urn:personServicewsdl',
		'urn:personServicewsdl#getHrInfo',
		'rpc',
		'encoded',
		'Get E-office online_person count'
	);
/*
@function:  获取图片
@parameter: $a->              string  :查看用户的ID号
@return:    $user_hrinfo->    Array   :查看用户ID号和图片
*/
function getHrInfo($a)
{
	CheckCurrentSession();
	$userapi       = new user();
	$user_hrinfo   = $userapi->getHrInfo($a);
	return $user_hrinfo;

	}

///*---------注册获取创建图片函数getCreatpic---------*/
$server->register(
		'getCreatpic',
		array(
			  'imagesource'=>'xsd:string',
			  'picname'=>'xsd:string',
			  'size'=>'xsd:string',
			  'attachmentid'=>'xsd:string'
			  ),
		array('return'=>'xsd:string'),
		'urn:personServicewsdl',
		'urn:personServicewsdl#getCreatpic',
		'rpc',
		'encoded',
		'Get E-office online_person count'
	);
/*
@function:  创建图片
@parameter: $imagesource->  string  :图片路径
			$picname->      string  :图片名称
			$size->         string  :图片大小
			$attachmentid-> string  :图片附件的ID号
@return:    $creat_pic->    string  :图片路径
*/
function getCreatpic($imagesource,$picname,$size,$attachmentid)
{
	CheckCurrentSession();
	$creat_pic = createimage($imagesource,$picname,$size='80',$attachmentid='');
	return $creat_pic;

}
///*---------注册获取所有部门函数---------*/
//=========定义返回值类型
$server->wsdl->addComplexType (
		'ReturnDeptArray',
		'complexType', 'array',
		'',
		'SOAP-ENC:Array',
		array (),
		array (
			   array ('ref' => 'SOAP-ENC:arrayType', 'wsdl:arrayType' => 'tns:ReturnDept[]')
			   ),
		'tns:ReturnDept'
	);
$server->wsdl->addComplexType (
		'ReturnDept',
		'complexType',
		'struct',
		'all',
		'',
		array(
			  'DEPT_ID'    => array('name'=>'DEPT_ID','type'=>'xsd:string'),
			  'DEPT_NAME'  => array('name'=>'DEPT_NAME','type'=>'xsd:string'),
			  'TEL_NO'     => array('name'=>'TEL_NO','type'=>'xsd:string'),
			  'FAX_NO'     => array('name'=>'FAX_NO','type'=>'xsd:string'),
			  'DEPT_PARENT'=> array('name'=>'DEPT_PARENT','type'=>'xsd:string'),
			  'DEPT_NO'    => array('name'=>'DEPT_NO','type'=>'xsd:string')
			  )
	);
$server->register(
		'GetAllDeptInfo',
		array('DeptId'=>'xsd:int',),
		array('return'=>'tns:ReturnDeptArray'),
		'urn:personServicewsdl',
		'urn:personServicewsdl#GetAllDeptInfo',
		'rpc',
		'encoded',
		'Get E-office online_person Dept'
	);
//获取所有部门
function GetAllDeptInfo($DeptId)
{
	CheckCurrentSession();
	$userapi       = new user();
	$AllDeptInfo = $userapi->GetAllDeptInfo($DeptId);
	return $AllDeptInfo;
}

///*---------注册获取某部门或者角色下人员信息---------*/
//定义参数结构
$server->wsdl->addComplexType(
				'SearchCondition',
				'complexType',
				'array',
				'all',
				'',
				array(
					'PrivId'   => array('name'=>'PrivId','type'=>'xsd:string'),
					'DeptId'   => array('name'=>'DeptId','type'=>'xsd:string'),
					'Relation' => array('name'=>'Relation','type'=>'xsd:string'),
					'Search'   => array('name'=>'Search','type'=>'xsd:string')
				)
);
//=========定义返回值类型
$server->wsdl->addComplexType (
		'DeptUserArray',
		'complexType', 'array',
		'',
		'SOAP-ENC:Array',
		array (),
		array (
			   array ('ref' => 'SOAP-ENC:arrayType', 'wsdl:arrayType' => 'tns:DeptUser[]')
			   ),
		'tns:DeptUser'
	);
$server->wsdl->addComplexType (
		'DeptUser',
		'complexType',
		'struct',
		'all',
		'',
		array(
			  'USER_ID'    => array('name'=>'USER_ID','type'=>'xsd:string'),
			  'USER_NAME'  => array('name'=>'USER_NAME','type'=>'xsd:string')
			  )
	);
$server->register(
		'GetAllDeptUser',
		array('Infor'=>'tns:SearchCondition'),
		array('return'=>'tns:DeptUserArray'),
		'urn:personServicewsdl',
		'urn:personServicewsdl#GetAllDeptUser',
		'rpc',
		'encoded',
		'Get E-office online_person GetAllDeptUser'
	);
//获取某部门或者角色下人员信息
function GetAllDeptUser($Infor)
{
	CheckCurrentSession();
	$userapi       = new user();
	$AllUser = $userapi->GetAllDeptUser($Infor);
	return $AllUser;
}

$server->register(
		'GetUserIdbyUserAccount',
		array('useraccount'=>'xsd:string'),
		array('return'=>'xsd:string'),
		'urn:personServicewsdl',
		'urn:personServicewsdl#GetUserIdbyUserAccount',
		'rpc',
		'encoded',
		'Get E-office online_person GetUserIdbyUserAccount'
	);


//根据用户账号获取用户ID
function GetUserIdbyUserAccount($useraccount) {
	CheckCurrentSession();
	global $connection;
	$query = "SELECT * FROM user WHERE USER_ACCOUNTS='".SecurityFilter($useraccount)."'";
	$res   = exequery($connection,$query);
	if($row = mysql_fetch_array($res)) {
		$USER_ID = $row["USER_ID"];
		return $USER_ID;
	}
}


/*---------注册获取用户角色函数GetUserPriv---------*/
$server->wsdl->addComplexType (
		'UserPrivArray',
		'complexType', 'array',
		'',
		'SOAP-ENC:Array',
		array (),
		array (
			   array ('ref' => 'SOAP-ENC:arrayType', 'wsdl:arrayType' => 'tns:UserPriv[]')
			   ),
		'tns:UserPriv'
	);


$server->wsdl->addComplexType(
		'UserPriv',
		'complexType',
		'struct',
		'all',
		'',
		array(
			  'USER_PRIV'=>array('name'=>'USER_PRIV','type'=>'xsd:string'),
			  'PRIV_NAME'=>array('name'=>'PRIV_NAME','type'=>'xsd:string')
			  )
	);

$server->register(
		'GetUserPriv',
		array('privname'=>'xsd:string'),
		array('return'=>'tns:UserPrivArray'),
		'urn:personServicewsdl',
		'urn:personServicewsdl#GetUserPriv',
		'rpc',
		'encoded',
		'Get E-office online_person GetUserPriv'
	);


//获取所有的角色信息
function GetUserPriv($privname) {
	CheckCurrentSession();
	global $connection;
	$userapi = new user();
	$reStr   = $userapi->GetAllPrivInfor($privname);
	return $reStr;
}

//返回数据
$server->service($HTTP_RAW_POST_DATA);
?>