<?php
/**
* @copyright (C) 2000 - 2010 Weaver Co.Ltd
* @package   eoffice6.0
* @name      webservice/workflow/workflow.wsdl.php
* @version   1.0 
* @author    sunxiang
*/
include_once("nusoap/lib/nusoap.php");
include_once("api/list.class.php");
include_once("inc/function_page_01.php");
include_once("inc/conn.php");
include_once("inc/checkcurrentsession.php");
include_once("inc/utility_all.php");
//实例化soap_server对象并初始化
$server                   = new soap_server();
$server->soap_defencoding = "UTF-8";
$server->decode_utf8      = false;
$server->configureWSDL('ListServicewsdl','urn:ListServicewsdl');
$server->wsdl->schemaTargetNamespace = 'urn:ListServicewsdl';

//注册一个名字为getList的函数
//定义getList参数结构
$server->wsdl->addComplexType(
	'FlowListSearch',
	'complexType',
	'struct',
	'all',
	'',
	array(
		'FlowName'        => array('name'=>'FlowName','type'=>'xsd:string'),
		'SearchEndTime'   => array('name'=>'SearchEndTime','type'=>'xsd:string'),
		'SearchBeginTime' => array('name'=>'SearchTime','type'=>'xsd:string')
	)
);

//定义getList,type=to_do函数返回值的结构体
$server->wsdl->addComplexType(
    'FlowListInfoArray',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array(
            'ref' => 'SOAP-ENC:arrayType',
            'wsdl:arrayType' => 'tns:FlowListInfo[]'
			  )
		),
    'tns:FlowListInfo'
);
$server->wsdl->addComplexType ( 
	'FlowListInfo', 
	'complexType', 
	'struct', 
	'all', 
	'',
	array (
		"RUN_ID"           => array ('name' => 'RUN_ID', 'type' => 'xsd:int' ),
		"PRCS_ID"          => array ('name' => 'PRCS_ID', 'type' => 'xsd:string' ),
		"PRCS_NAME"        => array ('name' => 'PRCS_NAME', 'type' => 'xsd:string' ),
		"MAX_PRCS_ID"      => array ('name' => 'MAX_PRCS_ID', 'type' => 'xsd:int' ),
		"RUN_NAME"         => array ('name' => 'RUN_NAME',   'type' => 'xsd:string'),
		"FLOW_ID"          => array ('name' => 'FLOW_ID', 'type' => 'xsd:int' ),
		"ATTACHMENT_ID"    => array ('name' => 'ATTACHMENT_ID', 'type' => 'xsd:string' ),
		"ATTACHMENT_NAME"  => array ('name' => 'ATTACHMENT_NAME', 'type' => 'xsd:string' ),
		"ATTACHMENT_DIR"   => array ('name' => 'ATTACHMENT_DIR', 'type' => 'xsd:string' ),
		"CREATE_TIME"      => array ('name' => 'CREATE_TIME', 'type' => 'xsd:string' ),
		"RUN_SEQ"          => array ('name' => 'RUN_SEQ', 'type' => 'xsd:string' ),
		"LINK_DOC"         => array ('name' => 'LINK_DOC', 'type' => 'xsd:string' ),
		"LINK_DOC_NAME"    => array ('name' => 'LINK_DOC_NAME', 'type' => 'xsd:string' ),
		"CREATOR"          => array ('name' => 'CREATOR', 'type' => 'xsd:string' ),
		"CREATOR_NAME"     => array ('name' => 'CREATOR_NAME', 'type' => 'xsd:string' ),
		"VIEW_USER"        => array ('name' => 'VIEW_USER', 'type' => 'xsd:string' ),
		"CURRENT_STEP"     => array ('name' => 'CURRENT_STEP', 'type' => 'xsd:int' ),
		"FLOW_NAME"        => array ('name' => 'FLOW_NAME', 'type' => 'xsd:string' ),
		"FORM_ID"          => array ('name' => 'FORM_ID', 'type' => 'xsd:int' ),
		"FLOW_DOC"         => array ('name' => 'FLOW_DOC', 'type' => 'xsd:string' ),
		"FLOW_LINK"        => array ('name' => 'FLOW_LINK', 'type' => 'xsd:int' ),
		"FLOW_TYPE"        => array ('name' => 'FLOW_TYPE', 'type' => 'xsd:string' ),
		"MANAGE_USER"      => array ('name' => 'MANAGE_USER', 'type' => 'xsd:string' ),
		"MANAGE_USER_NAME" => array ('name' => 'MANAGE_USER_NAME', 'type' => 'xsd:string' ),
		"FLOW_SORT"        => array ('name' => 'FLOW_SORT', 'type' => 'xsd:int' ),
		"FLOW_SEQUENCE"    => array ('name' => 'FLOW_SEQUENCE', 'type' => 'xsd:string' ),
		"FLOW_NOORDER"     => array ('name' => 'FLOW_NOORDER', 'type' => 'xsd:int' ),
		"HANDLE_WAY"       => array ('name' => 'HANDLE_WAY', 'type' => 'xsd:int' ),
		"COUNTERSIGN"      => array ('name' => 'COUNTERSIGN', 'type' => 'xsd:int' ),
		"CAN_EDIT_FLOWNO"  => array ('name' => 'CAN_EDIT_FLOWNO', 'type' => 'xsd:int' )
		)
);
$server->register('GetFlowList',
				  array(
						'userId' => 'xsd:string',
						'flowId' => 'xsd:string',
						'start' => 'xsd:string',
						'limit' => 'xsd:string',
						'type' => 'xsd:string',
						'Search'=>'tns:FlowListSearch'
						),
				  array('return' => 'tns:FlowListInfoArray'),
				  'urn:ListServicewsdl',
				  'urn:ListServicewsdl#GetFlowList',
				  'rpc',
				  'encoded',
				  'Get E-office GetFlowList'
				  );

$server->register('unreadToDoCount',
				  array('userId' => 'xsd:string'),
				  array('return' => 'xsd:int'),
				  'urn:ListServicewsdl',
				  'urn:ListServicewsdl#unreadToDoCount',
				  'rpc',
				  'encoded',
				  'Get E-office getUnreadToDoCount'
				  );

$server->register('toDoCount',
				  array('userId' => 'xsd:string'),
				  array('return' => 'xsd:int'),
				  'urn:ListServicewsdl',
				  'urn:ListServicewsdl#toDoCount',
				  'rpc',
				  'encoded',
				  'Get E-office gettoDoCount'
				  );

//getList函数实现的功能，通过调用api的实例
function GetFlowList($userId,$flowId,$start,$limit,$type,$Search)
{
    $userId = SecurityFilter($userId);
	CheckCurrentSession();
	global $connection;
	$SearchFlowTime = "";
	if($Search["FlowName"]!="")
	{
		$SearchFlowName = " AND fr.RUN_NAME LIKE '%".$Search["FlowName"]."%' ";	
	}
	if($Search["SearchBeginTime"]!="")
	{
		$SearchFlowTime .= " AND UNIX_TIMESTAMP(fr.CREATE_TIME)>=UNIX_TIMESTAMP('".$Search["SearchBeginTime"]."') ";	
	}
	if($Search["SearchEndTime"]!="")
	{
		$SearchFlowTime .= " AND UNIX_TIMESTAMP(fr.CREATE_TIME)<=UNIX_TIMESTAMP('".$Search["SearchEndTime"]."') ";	
	}
	if($flowId)
	{
		switch($type)
		{
			case "to_do":
				$p1 = array("WHERE"=>"frp.USER_ID='$userId' AND (((frp.SAVEFORM_TIME IS NULL AND frp.OP_FLAG=0) OR (frp.PRCS_FLAG='2' AND frp.OP_FLAG=1)) OR( frp.PRCS_FLAG = 1)) AND fr.FLOW_ID = '".$flowId."' ".$SearchFlowName.$SearchFlowTime,"GROUPBY"=>"frp.RUN_ID","SORTBY"=>"frp.RUN_ID DESC","LIMIT"=>$limit,"START"=>$start);
				break;
			case "passed":
				$p1 = array("WHERE"=>"frp.RUN_ID=fr.RUN_ID AND frp.USER_ID='$userId' AND fr.CURRENT_STEP<>0
                AND ((frp.OP_FLAG=1 AND frp.DELIVER_TIME<>'NULL') 
				      OR 
					 (frp.OP_FLAG=0 AND frp.SAVEFORM_TIME<>'NULL')) AND fr.FLOW_ID = '".$flowId."'".$SearchFlowName.$SearchFlowTime,"GROUPBY"=>"frp.RUN_ID","SORTBY"=>"frp.RUN_ID DESC","LIMIT"=>$limit,"START"=>$start);
				break;
			case "finished":
				$p1 = array("WHERE"=>"fr.CURRENT_STEP = '0' 
				AND frp.USER_ID ='".$userId."' AND ((SAVEFORM_TIME IS NOT NULL AND SAVEFORM_TIME <> '0000-00-00 00:00:00' AND OP_FLAG ='0') OR( DELIVER_TIME IS NOT NULL AND DELIVER_TIME <> '0000-00-00 00:00:00' AND OP_FLAG ='1') ) AND fr.FLOW_ID = '".$flowId."' ".$SearchFlowName.$SearchFlowTime,"GROUPBY"=>"frp.RUN_ID","SORTBY"=>"frp.RUN_ID DESC","LIMIT"=>$limit,"START"=>$start);
				break;	
		}
	}
	else
	{
		switch($type)
		{
			case "to_do":
				$p1 = array("WHERE"=>"frp.USER_ID='$userId' AND (((frp.SAVEFORM_TIME IS NULL AND frp.OP_FLAG=0) OR (frp.PRCS_FLAG='2' AND frp.OP_FLAG=1)) OR( frp.PRCS_FLAG = 1)) AND ft.FLOW_TYPE = 1 ".$SearchFlowName.$SearchFlowTime,"GROUPBY"=>"frp.RUN_ID","SORTBY"=>"frp.RUN_ID DESC","LIMIT"=>$limit,"START"=>$start);
				break;
			case "passed":
				$p1 = array("WHERE"=>"frp.RUN_ID=fr.RUN_ID AND frp.USER_ID='$userId' AND fr.CURRENT_STEP<>0
                AND ((frp.OP_FLAG=1 AND frp.DELIVER_TIME<>'NULL') 
				      OR 
					 (frp.OP_FLAG=0 AND frp.SAVEFORM_TIME<>'NULL')) ".$SearchFlowName.$SearchFlowTime,"GROUPBY"=>"frp.RUN_ID","SORTBY"=>"frp.RUN_ID DESC","LIMIT"=>$limit,"START"=>$start);
				break;
			case "finished":
				$p1 = array("WHERE"=>"fr.CURRENT_STEP = '0' 
				AND frp.USER_ID ='".$userId."' AND ((SAVEFORM_TIME IS NOT NULL AND SAVEFORM_TIME <> '0000-00-00 00:00:00' AND OP_FLAG ='0') OR( DELIVER_TIME IS NOT NULL AND DELIVER_TIME <> '0000-00-00 00:00:00' AND OP_FLAG ='1') ) ".$SearchFlowName.$SearchFlowTime,"GROUPBY"=>"frp.RUN_ID","SORTBY"=>"frp.RUN_ID DESC","LIMIT"=>$limit,"START"=>$start);
				break;	
		}
	}
	$p2       = array("type"=>"$type");
	$listwApi = new listItem($p1,$p2);
	$listData = $listwApi->getList();
	foreach($listData as $index => $val)
	{
		$listData[$index]['CREATOR_NAME']      = getUserNameNew($val['CREATOR']);
		$listData[$index]['MANAGE_USER_NAME']  = getUsernameStr($val['MANAGE_USER']);
		//返回节点名称
		$sql = "SELECT * FROM flow_process WHERE FLOW_ID='".$val['FLOW_ID']."' AND PRCS_ID='".$val['PRCS_ID']."'";
		$rs = exequery($connection, $sql);
		if($row = mysql_fetch_array($rs))	
		{
			$listData[$index]['PRCS_NAME'] = $row["PRCS_NAME"];	
		}
	}
	//返回结果
	return $listData;
}
function unreadToDoCount($userId)
{
    $userId = SecurityFilter($userId);
	CheckCurrentSession();
	$p1 = array("WHERE"=>"frp.USER_ID='$userId' AND frp.PRCS_FLAG='1' AND frp.RUN_ID = fr.RUN_ID AND fr.FLOW_ID = ft.FLOW_ID AND ft.FLOW_TYPE != 2 GROUP BY frp.RUN_ID","LIMIT"=>"all");
	$p2 = array("type"=>"unread_to_do_count");
	$listwApi = new listItem($p1,$p2);
	$listData = $listwApi->getList();
	return $listData;
}
function toDoCount($userId)
{
    $userId = SecurityFilter($userId);
	CheckCurrentSession();
	//$p1 = array("WHERE"=>"frp.USER_ID='$userId' AND frp.RUN_ID = fr.RUN_ID  AND fr.FLOW_ID = ft.FLOW_ID AND ( ( (SAVEFORM_TIME IS NULL AND OP_FLAG=0) OR (PRCS_FLAG='2' AND OP_FLAG=1) ) OR PRCS_FLAG='1' ) GROUP BY frp.RUN_ID");
	$p1 = array("WHERE"=>"frp.USER_ID='$userId' AND frp.RUN_ID = fr.RUN_ID  AND fr.FLOW_ID = ft.FLOW_ID AND ( ( (SAVEFORM_TIME IS NULL AND OP_FLAG=0) OR (PRCS_FLAG='2' AND OP_FLAG=1) ) OR PRCS_FLAG='1' ) AND ft.FLOW_TYPE = '1' GROUP BY frp.RUN_ID");
	$p2 = array("type"=>"to_do_count");
	$listwApi = new listItem($p1,$p2);
	$listData = $listwApi->getList();
	return $listData;
}
function getOtherSetInfo($flowid)
{
	CheckCurrentSession();
	$workflowApi = new workflow($flowid);
	$otherInfo   = $workflowApi->getOtherSetInfo();
	//使用json对返回结果进行加密
	$otherInfo   = json_encode($otherInfo);
	//返回结果
	return $otherInfo;
}
//-------------------------------返回流程数量
$server->wsdl->addComplexType(
	'FlowSearchCount',
	'complexType',
	'struct',
	'all',
	'',
	array(
		'UserId'          => array('name'=>'UserId','type'=>'xsd:string'),
		'FlowId'          => array('name'=>'FlowId','type'=>'xsd:string'),
		'FlowName'        => array('name'=>'FlowName','type'=>'xsd:string'),
		'SearchEndTime'   => array('name'=>'SearchEndTime','type'=>'xsd:string'),
		'SearchBeginTime' => array('name'=>'SearchTime','type'=>'xsd:string'),
		'FlowType'        => array('name'=>'FlowType','type'=>'xsd:string')
	)
);
$server->register('GetFlowCount',
				  array(
						'SearchCondition'=>'tns:FlowSearchCount'
						),
				  array('return' => 'xsd:string'),
				  'urn:ListServicewsdl',
				  'urn:ListServicewsdl#GetFlowCount',
				  'rpc',
				  'encoded',
				  'Get E-office GetFlowCount'
				  );
//获取流程数量
function GetFlowCount($SearchCondition)
{
	CheckCurrentSession();
	$FlowList = new listItem();
	return $FlowList->GetFlowCount($SearchCondition);
}
//-------------------------------获取可新建的流程
//定义返回结构
$server->wsdl->addComplexType(
    'CreatFlowArray',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array(
            'ref' => 'SOAP-ENC:arrayType',
            'wsdl:arrayType' => 'tns:CreatFlow[]'
			  )
		),
    'tns:CreatFlow'
);

$server->wsdl->addComplexType ( 
	'CreatFlow', 
	'complexType', 
	'struct', 
	'all', 
	'',
	array (
		"FLOW_SORT_ID"       => array ('name' => 'FLOW_SORT_ID', 'type' => 'xsd:string' ),
		"FLOW_NAME"          => array ('name' => 'FLOW_NAME', 'type' => 'xsd:string' ),
		"FLOW_ID"            => array ('name' => 'FLOW_ID', 'type' => 'xsd:string' ),
		"FLOW_TYPE"          => array ('name' => 'FLOW_TYPE', 'type' => 'xsd:string' ),
		"FORM_ID"            => array ('name' => 'FORM_ID', 'type' => 'xsd:string' ),
		"FLOW_SORT_NOORDER"  => array ('name' => 'FLOW_SORT_NOORDER', 'type' => 'xsd:string' ),
		"FLOW_SORT_TITLE"    => array ('name' => 'FLOW_SORT_TITLE', 'type' => 'xsd:string' )
		)
);

$server->register('GetMyCreatFlow',
				  array(
						'UserId'=>'xsd:string'
						),
				  array('return' => 'tns:CreatFlowArray'),
				  'urn:ListServicewsdl',
				  'urn:ListServicewsdl#GetMyCreatFlow',
				  'rpc',
				  'encoded',
				  'Get E-office GetMyCreatFlow'
				  );
function GetMyCreatFlow($UserId)
{
    $userId = SecurityFilter($userId);
	CheckCurrentSession();
	$FlowList = new listItem();
	$UserInfo = array();
	$DepyId   = getUserDept($UserId);
	$PrivId   = getUserPrivId($UserId);
	$UserInfo["UserId"] = $UserId;
	$UserInfo["DepyId"] = $DepyId;
	$UserInfo["PrivId"] = $PrivId;
	return $FlowList->GetMyCreatFlow($UserInfo);	
}

//返回数据
$server->service($HTTP_RAW_POST_DATA);
?>