<?
/**
* @copyright (C) 2000 - 2010 Weaver Co.Ltd
* @package   eoffice6.0
* @name      webservice/workflow/workflow.wsdl.php
* @version   1.0 
* @author    sunxiang
* @modify    liuqingyu
*/
include_once("nusoap/lib/nusoap.php");
include_once("inc/conn.php");
include_once("inc/utility_all.php");
include_once("inc/checkcurrentsession.php");
include_once("general/workflow/flow_expr_run.php");
include_once("general/workflow/flow_agency/function_agent.php");
include_once("api/fixedworkflow.class.php");
include_once("api/freeworkflow.class.php");

//实例化soap_server对象并初始化
$server                   = new soap_server();
$server->soap_defencoding = "UTF-8";
$server->decode_utf8      = false;
$server->configureWSDL('WorkflowServicewsdl','urn:WorkflowServicewsdl');
$server->wsdl->schemaTargetNamespace = 'urn:WorkflowServicewsdl';
//定义getFormData函数返回值的结构体
$server->wsdl->addComplexType(
    'fieldValueArray',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array(
            'ref' => 'SOAP-ENC:arrayType',
            'wsdl:arrayType' => 'tns:fieldValue[]'
			  )
		),
    'tns:fieldValue'
);
$server->wsdl->addComplexType ( 
	'fieldValue', 
	'complexType', 
	'struct', 
	'all', 
	'',
	array (
		"RUN_ID"=>array ('name' => 'RUN_ID', 'type' => 'xsd:string' ),
		"ITEM_ID"=>array ('name' => 'ITEM_ID', 'type' => 'xsd:string' ),
		"ITEM_DATA"=>array ('name' => 'ITEM_DATA', 'type' => 'xsd:string')
		)
);
//注册一个名字为getFormData的函数,获取表单数据
$server->register(
				  'getFormData',
				  array(
						'flowid' => 'xsd:string',
						'runid' => 'xsd:string'
						),
				  array(
						'return' => 'tns:fieldValueArray'
						),
				  'urn:WorkflowServicewsdl',
				  'urn:WorkflowServicewsdl#getFormData',
				  'rpc',
				  'encoded',
				  'Get E-office workflow Formdata'
				  );
//注册一个名字为getOtherSetInfo的函数,获取流程其它设置的信息
$server->register(
				  'getOtherSetInfo',
				  array(
						'flowid' => 'xsd:string'
						),
				  array(
						'return' => 'xsd:string'
						),
				  'urn:WorkflowServicewsdl',
				  'urn:WorkflowServicewsdl#getOtherSetInfo',
				  'rpc',
				  'encoded',
				  'Get E-office workflow otherinfo'
				  );
//定义getFiedAndValue函数返回值的结构体
$server->wsdl->addComplexType(
    'FiedAndValueArray',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array(
            'ref' => 'SOAP-ENC:arrayType',
            'wsdl:arrayType' => 'tns:FiedAndValue[]'
			  )
		),
    'tns:FiedAndValue'
);
$server->wsdl->addComplexType ( 
	'FiedAndValue', 
	'complexType', 
	'struct', 
	'all', 
	'',
	array (
		"name"  => array ('name' => 'name', 'type' => 'xsd:string' ),
		"title" => array ('name' => 'title', 'type' => 'xsd:string' ),
		"class" => array ('name' => 'class', 'type' => 'xsd:string'),
		"value" => array ('name' => 'value', 'type' => 'xsd:string'),
		"type"  => array ('name' => 'type', 'type' => 'xsd:string'),
		"check" => array ('name' => 'check', 'type' => 'xsd:string')
		)
);
//注册一个名字为getFiedAndValue的函数,获取流程表单字段值
$server->register(
				  'GetFlowFiedAndValue',
				  array(
						'flowid' => 'xsd:string',
						'runid' => 'xsd:string'
						),
				  array(
						'return' => 'tns:FiedAndValueArray'
						),
				  'urn:WorkflowServicewsdl',
				  'urn:WorkflowServicewsdl#GetFlowFiedAndValue',
				  'rpc',
				  'encoded',
				  'Get E-office workflow field and GetFlowFiedAndValue'
				  );
//注册一个名字为saveFormData的函数,保存流程表单数据
$server->register(
				  'saveFormData',
				  array(
						'formdata'=>'SOAP-ENC:Array',
						'flowid' => 'xsd:string',
						'runid' => 'xsd:string',
						'docid' => 'xsd:string'
						),
				  array(
						'return' => 'SOAP-ENC:Array'
						),
				  'urn:WorkflowServicewsdl',
				  'urn:WorkflowServicewsdl#saveFormData',
				  'rpc',
				  'encoded',
				  'Save E-office workflow form value'
				  );
//定义getNextNodes函数返回值的结构体
$server->wsdl->addComplexType(
    'nextNodes',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array(
            'ref' => 'SOAP-ENC:arrayType',
            'wsdl:arrayType' => 'tns:nextNode[]'
			  )
		),
    'tns:nextNode'
);
$server->wsdl->addComplexType ( 
	'nextNode', 
	'complexType', 
	'struct', 
	'all', 
	'',
	array (
		"FLOW_PRCS"=>array ('name' => 'FLOW_PRCS', 'type' => 'xsd:int' ),
		"PRCS_NAME"=>array ('name' => 'PRCS_NAME', 'type' => 'xsd:string' ),
		"CHECKED"  =>array ('name' => 'CHECKED',   'type' => 'xsd:int'),
		"mainuser"  =>array ('name' => 'mainuser',   'type' => 'xsd:string')
		)
);
//注册一个名字为getNextNodes的函数,获取流程的出口节点
$server->register(
				  'getNextNodes',
				  array(
						'flowid' => 'xsd:string',
						'runid' => 'xsd:string',
						'userid' => 'xsd:string',
						'prcsId' => 'xsd:string'
						),
				  array(
						'return' => 'tns:nextNodes'
						),
				  'urn:WorkflowServicewsdl',
				  'urn:WorkflowServicewsdl#getNextNodes',
				  'rpc',
				  'encoded',
				  'Get E-office workflow next nodes'
				  );
//注册一个名字为setHaveRead的函数,设置为已查看
$server->register(
				  'setHaveRead',
				  array(
						'flowid' => 'xsd:string',
						'runid' => 'xsd:string',
						'userId' => 'xsd:string',
						"sid"=>"xsd:string"
						),
				  array(
						'return' => 'xsd:int'
						),
				  'urn:WorkflowServicewsdl',
				  'urn:WorkflowServicewsdl#setHaveRead',
				  'rpc',
				  'encoded',
				  'Get E-office workflow next nodes'
				  );
//注册一个名字为saveForm的函数,经办理提交流程的操作
$server->register(
				  'saveForm',
				  array(
						'flowid' => 'xsd:string',
						'runid' => 'xsd:string'
						),
				  array(
						'return' => 'SOAP-ENC:Array'
						),
				  'urn:WorkflowServicewsdl',
				  'urn:WorkflowServicewsdl#saveForm',
				  'rpc',
				  'encoded',
				  'E-office workflow saveForm'
				  );
//注册一个名字为saveForm的函数,经办理提交流程的操作
$server->register(
				  'turnNext',
				  array(
						'flowid' => 'xsd:string',
						'runid' => 'xsd:string',
						'userId' => 'xsd:string',
						'flowPrcs' => 'xsd:string',
						'prcsId' => 'xsd:string',
						'prcsUser' => 'xsd:string',
						'prcsOpUser' => 'xsd:string',
						'docId' => 'xsd:string',
						'oP' => 'xsd:string',
						'subFlowRunIds' => 'xsd:string',
						'limitDate' => 'xsd:string',
						'monitor' => 'xsd:string',
						'mbSmsContent' => 'xsd:string',
						'smsContent' => 'xsd:string',
						'emailContent' => 'xsd:string',
						'sid'=>'xsd:string'
						),
				  array(
						'return' => 'xsd:int'
						),
				  'urn:WorkflowServicewsdl',
				  'urn:WorkflowServicewsdl#turnNext',
				  'rpc',
				  'encoded',
				  'E-office workflow turnNext'
				  );

//注册一个名字为create的函数,创建流程
$server->register(
				  'create',
				  array(
						'flowId' => 'xsd:string',
						'userId' => 'xsd:string',
						'flowData' =>'xsd:string'
						),
				  array(
						'runId' => 'xsd:string'
						),
				  'urn:WorkflowServicewsdl',
				  'urn:WorkflowServicewsdl#create',
				  'rpc',
				  'encoded',
				  'E-office Create workflow'
				  );

//注册一个名字为getFlowInfo的函数,根据流程id获取流程运行的步骤信息
//定义返回结构
$server->wsdl->addComplexType(
	'flowInfo',
	'complexType',
	'struct',
	'all',
	'',
	array(
		'RUN_ID'     => array('name'=>'RUN_ID','type'=>'xsd:string'),
		'PRCS_ID'    => array('name'=>'PRCS_ID','type'=>'xsd:string'),
		'USER_ID'    => array('name'=>'USER_ID','type'=>'xsd:string'),
		'PRCS_TIME'  => array('name'=>'PRCS_TIME','type'=>'xsd:string'),
		'DELIVER_TIME'  => array('name'=>'DELIVER_TIME','type'=>'xsd:string'),
		'SAVEFORM_TIME' => array('name'=>'SAVEFORM_TIME','type'=>'xsd:string'),
		'PRCS_FLAG'  => array('name'=>'PRCS_FLAG','type'=>'xsd:string'),
		'FLOW_PRCS'  => array('name'=>'FLOW_PRCS','type'=>'xsd:string'),
		'OP_FLAG'    => array('name'=>'OP_FLAG','type'=>'xsd:string'),
		'LIMIT_DATE' => array('name'=>'LIMIT_DATE','type'=>'xsd:string'),
		'IS_REMIND'  => array('name'=>'IS_REMIND','type'=>'xsd:string'),
		'BY_AGENT_ID'       => array('name'=>'BY_AGENT_ID','type'=>'xsd:string'),
		'FLOW_AGENCY_ID'    => array('name'=>'FLOW_AGENCY_ID','type'=>'xsd:string'),
		'SUB_FLOW_RUN_IDS'  => array('name'=>'SUB_FLOW_RUN_IDS','type'=>'xsd:string'),
		'FORWARD_USER_ID'   => array('name'=>'FORWARD_USER_ID','type'=>'xsd:string'),
		'LAST_VISITED_TIME' => array('name'=>'LAST_VISITED_TIME','type'=>'xsd:string'),
		'MONITOR_SUBMIT'    => array('name'=>'MONITOR_SUBMIT','type'=>'xsd:string')
	)
);

$server->register(
				  'getFlowInfo',
				  array(
						'flowId' => 'xsd:string',
						'runId'  => 'xsd:string'
						),
				  array(
						'return' => 'tns:flowInfo'
						),
				  'urn:WorkflowServicewsdl',
				  'urn:WorkflowServicewsdl#getFlowInfo',
				  'rpc',
				  'encoded',
				  'E-office getFlowInfo'
				  );

//定义autoGetProcessor函数返回值的结构体
$server->wsdl->addComplexType(
    'Processors',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array(
            'ref' => 'SOAP-ENC:arrayType',
            'wsdl:arrayType' => 'tns:Processor[]'
			  )
		),
    'tns:Processor'
);
$server->wsdl->addComplexType ( 
	'Processor', 
	'complexType', 
	'struct', 
	'all', 
	'',
	array (
		"userid"  =>array ('name' => 'userid',  'type' => 'xsd:string' ),
		"username"=>array ('name' => 'username', 'type' => 'xsd:string' ),
		"deptid"  =>array ('name' => 'deptid',   'type' => 'xsd:int'),
		"opflag"  =>array ('name' => 'opflag',   'type' => 'xsd:int')
		)
);
//注册一个名字为autoGetProcessor的函数,获取流程当前节点的办理人
$server->register(
				  'autoGetProcessor',
				  array(
						'flowid' => 'xsd:string',
						'runid' => 'xsd:string',
						'flowPrcs' => 'xsd:string'
						),
				  array(
						'return' => 'tns:Processors'
						),
				  'urn:WorkflowServicewsdl',
				  'urn:WorkflowServicewsdl#autoGetProcessor',
				  'rpc',
				  'encoded',
				  'Get E-office workflow dealer'
				  );
//定义getDefaultManage函数返回值的结构体
$server->wsdl->addComplexType ( 
	'DefaultManage', 
	'complexType', 
	'struct', 
	'all', 
	'',
	array (
		"canEdit"  =>array ('name' => 'canEdit', 'type' => 'xsd:string' ),
		"defaultUser"=>array ('name' => 'defaultUser', 'type' => 'xsd:string' ),
		"defaultManage"=>array ('name' => 'defaultManage', 'type' => 'xsd:string' ),
		"defaultUserName"=>array ('name' => 'defaultUserName', 'type' => 'xsd:string' ),
		"defaultManageName"=>array ('name' => 'defaultManageName', 'type' => 'xsd:string' )
		)
);

//注册一个名字为getDefaultManage的函数,获取流程某个节点或当前节点的默认主办人的信息和是否可以修改办理人
$server->register(
				  'GetFlowDefaultManage',
				  array(
						'flowid' => 'xsd:string',
						'runid' => 'xsd:string',
						'flowPrcs' => 'xsd:string'
						),
				  array(
						'return' => 'tns:DefaultManage'
						),
				  'urn:WorkflowServicewsdl',
				  'urn:WorkflowServicewsdl#GetFlowDefaultManage',
				  'rpc',
				  'encoded',
				  'Get E-office workflow GetFlowDefaultManage'
				  );

//注册一个名字为saveFeedBack的函数,保存签办反馈
$server->register(
				  'saveFeedBack',
				  array(
						'userid' => 'xsd:string',
						'flow_id' => 'xsd:string',
						'run_id' => 'xsd:string',
						'content' => 'xsd:string',
						'attachment_id' => 'xsd:string',
						'attachment_name' => 'xsd:string'
						),
				  array(
						'return' => 'xsd:string'
						),
				  'urn:WorkflowServicewsdl',
				  'urn:WorkflowServicewsdl#saveFeedBack',
				  'rpc',
				  'encoded',
				  'saveFeedBack'
				  );
//定义getFeedBack函数返回值的结构体
$server->wsdl->addComplexType(
    'feedbacks',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array(
            'ref' => 'SOAP-ENC:arrayType',
            'wsdl:arrayType' => 'tns:feedback[]'
			  )
		),
    'tns:feedback'
);
$server->wsdl->addComplexType ( 
	'feedback', 
	'complexType', 
	'struct', 
	'all', 
	'',
	array (
		"RUN_ID"          =>array ('name' => 'RUN_ID',  'type' => 'xsd:string' ),
		"USER_ID"         =>array ('name' => 'USER_ID',  'type' => 'xsd:string' ),
		"USER_NAME"       =>array ('name' => 'USER_NAME',  'type' => 'xsd:string' ),
		"CONTENT"         =>array ('name' => 'CONTENT', 'type' => 'xsd:string' ),
		"ATTACHMENT_ID"   =>array ('name' => 'ATTACHMENT_ID',   'type' => 'xsd:string'),
		"ATTACHMENT_NAME" =>array ('name' => 'ATTACHMENT_NAME',   'type' => 'xsd:string'),
		"ATTACHMENT_DIR"  =>array ('name' => 'ATTACHMENT_DIR',   'type' => 'xsd:string'),
		"EDIT_TIME"       =>array ('name' => 'EDIT_TIME',   'type' => 'xsd:string'),
		"SEQ_ID"          =>array ('name' => 'SEQ_ID',   'type' => 'xsd:string'),
		"FLOW_PRCS"       =>array ('name' => 'FLOW_PRCS',   'type' => 'xsd:string'),
		"PRCS_ID"         =>array ('name' => 'PRCS_ID',   'type' => 'xsd:string'),
		"PRCS_NAME"       =>array ('name' => 'PRCS_NAME',   'type' => 'xsd:string'),
		
		)
);
//注册一个名字为getFeedBack的函数,保存签办反馈
$server->register(
				  'GetFlowFeedBack',
				  array(
						'flow_id' => 'xsd:string',
						'run_id' => 'xsd:string'
						),
				  array(
						'return' => 'tns:feedbacks'
						),
				  'urn:WorkflowServicewsdl',
				  'urn:WorkflowServicewsdl#GetFlowFeedBack',
				  'rpc',
				  'encoded',
				  'GetFlowFeedBack'
				  );
//注册一个名字为error的函数,返回错误代码
$server->register(
				  'webserviceError',
				  array(),
				  array(
						'return' => 'xsd:string'
						),
				  'urn:WorkflowServicewsdl',
				  'urn:WorkflowServicewsdl#error',
				  'rpc',
				  'encoded',
				  'Get Webservice error id'
				  );

//注册一个名字为turnNextOrEnd的函数,经办理提交流程的操作
$server->register(
				  'turnNextOrEnd',
				  array(
						'flowid' => 'xsd:string',
						'runid' => 'xsd:string',
						'userId' => 'xsd:string',
						'flowPrcs' => 'xsd:string',
						'prcsId' => 'xsd:string',
						'prcsUser' => 'xsd:string',
						'prcsOpUser' => 'xsd:string',
						'docId' => 'xsd:string',
						'oP' => 'xsd:string',
						'subFlowRunIds' => 'xsd:string',
						'limitDate' => 'xsd:string',
						'monitor' => 'xsd:string',
						'mbSmsContent' => 'xsd:string',
						'smsContent' => 'xsd:string',
						'emailContent' => 'xsd:string',
						'canEndFlow'=>'xsd:string'
						),
				  array(
						'return' => 'xsd:int'
						),
				  'urn:WorkflowServicewsdl',
				  'urn:WorkflowServicewsdl#turnNextOrEnd',
				  'rpc',
				  'encoded',
				  'E-office workflow turnNextOrEnd'
				  );
/**
 * 通过调用api的实例,实现上面注册的函数getFormData的功能
 * @access public
 * @para   int flowid 流程类别id
 * @para   int run_id 流程id
 * @return str json_encode $formdata
*/
function getFormData($flowid,$runid)
{
	CheckCurrentSession();
	$workflowApi = new workflow($flowid);
	$workflowApi->runId = $runid;
	$formdata    = $workflowApi->getFormData();
	return $formdata;
}
/**
 * 通过调用api的实例,实现上面注册的函数getOtherSetInfo的功能
 * @access public
 * @para   int flowid 流程类别id
 * @return str json_encode $otherInfo
*/
function getOtherSetInfo($flowid)
{
	CheckCurrentSession();
	$workflowApi = new workflow($flowid);
	$otherInfo   = $workflowApi->getOtherSetInfo();
	//返回结果
	return $otherInfo;
}
/**
 * 通过调用api的实例,实现上面注册的函数getFiedAndValue的功能
 * @access public
 * @para   int flowid 流程类别id
 * @para   int run_id 流程id
 * @return str json_encode $fieldAndValue
*/
function GetFlowFiedAndValue($flowid,$runid)
{
	CheckCurrentSession();
	$workflowApi   = new workflow($flowid);
	$workflowApi->runId = $runid;
	$fieldAndValue = $workflowApi->getFormRunValue();
	return $fieldAndValue;
}
/**
 * 通过调用api的实例,实现上面注册的函数saveFormData的功能
 * @access public
 * @para   int flowid 流程类别id
 * @para   int run_id 流程id
 * @return str json_encode $rs 
*/
function saveFormData($formdata,$flowid,$runid,$docid)
{
	CheckCurrentSession();
	$workflowApi   = new workflow($flowid);
	$workflowApi->runId = $runid;
	$workflowApi->flowRunningInfo();
	$rs = $workflowApi->autoSave($formdata,$docid,$formdata,$runid);
	return $rs;
}
/**
 * 通过调用api的实例,实现上面注册的函数getNextNodes的功能
 * @access public
 * @para   int flowid 流程类别id
 * @para   int run_id 流程id
 * @para   int userid 用户ID
 * @para   int prcsId 当前步骤ID
 * @return str json_encode $nodesArray
*/
function getNextNodes($flowid,$runid,$userid,$prcsId)
{
	CheckCurrentSession();
	$workflowApi = new fixedWorkflow($flowid);
	$workflowApi->runId = $runid;
	$nodesArray  = $workflowApi->getCurrentNextPrcstoid();
	$OP_FLAG     = $workflowApi->isOpFlag($userid,$prcsId);
	if($OP_FLAG)
	{
		$mainuser = "1";	
	}
	else
	{
		$mainuser = "0";	
	}
	for($i=0;$i<count($nodesArray);$i++)
	{
		$nodesArray[$i]["mainuser"] = $mainuser;
	}
	
	return $nodesArray;
}
/**
 * 通过调用api的实例,实现上面注册的函数setHaveRead的功能
 * @access public
 * @para   int flowid 流程类别id
 * @para   int run_id 流程id
 * @para   str userid 当前用户id
 * @return void
*/
function setHaveRead($flowid,$runid,$userid)
{
	CheckCurrentSession ();
	$workflowApi = new fixedWorkflow($flowid);
	$workflowApi->runId = $runid;
	$node_info  = $workflowApi->getNodeInfo();
	$prcs_info  = $workflowApi->getPrcsInfo();
	$prcs_count = count($prcs_info);
	if($prcs_count)
	{
		$flow_prcs = $prcs_info[$prcs_count-1]["FLOW_PRCS"];
		$prcs_id   = $prcs_info[$prcs_count-1]["PRCS_ID"];
	}
	else
	{
		die("流程已被删除");
	}
	$prcsOptype = $node_info[$flow_prcs]["PRCS_OPTYPE"]; 
	$workflowApi->setOpFlag($prcsOptype,$prcs_id,$flow_prcs,$userid);
	$workflowApi->cancelSmsRemind();
	$workflowApi->markHaveReceive($userid,$prcs_id);
	return 1;
}
/**
 * 通过调用api的实例,实现上面注册的函数turnNext的功能
 * @access public
 * @para   int flowid 流程类别id
 * @para   int run_id 流程id
 * @para   int userId 用户id
 * @para   int flowPrcs 当前步骤对应节点
 * @para   int prcsId 当前步骤
 * @para   int prcsUser 经办人id组合
 * @para   int prcsOpUser 主办人id
 * @para   int docId 关联文档id组合
 * @para   int oP 操作
 * @para   int subFlowRunIds 子流程id组合
 * @para   int limitDate 催办时间
 * @para   int monitor 监控转交人
 * @para   int mbSmsContent 手机提醒内容
 * @para   int smsContent 内部消息提醒内容
 * @para   int emailContent 邮件提醒内容
 * @return void
*/
function turnNext($flowid,$runid,$userId,$flowPrcs,$prcsId,$prcsUser,$prcsOpUser,$docId,$oP,$subFlowRunIds,$limitDate,$monitor,$mbSmsContent,$smsContent,$emailContent)
{
	//CheckCurrentSession();
	$workflowApi = new fixedWorkflow($flowid);	
	$workflowApi->runId = $runid;
	$OP_FLAG     = $workflowApi->isOpFlag($userId,$prcsId);
	if($OP_FLAG)
	{
		$workflowApi->turnnext($flowPrcs,$prcsId,$prcsUser,$prcsOpUser,$docId,$oP,$subFlowRunIds,$limitDate,$monitor,$mbSmsContent,$smsContent,$emailContent,'','webservice');
	}
	else
	{
		$workflowApi->saveForm($prcsId,$userId);
	}	
	return 1;
}

/**
 * 通过调用api的实例,实现上面注册的函数turnNext的功能
 * @access public
 * @para   int flowid 流程类别id
 * @para   int run_id 流程id
 * @para   int userId 用户id
 * @para   int flowPrcs 当前步骤对应节点
 * @para   int prcsId   当前步骤
 * @para   int prcsUser 经办人id组合
 * @para   int prcsOpUser 主办人id
 * @para   int docId      关联文档id组合
 * @para   int oP         操作
 * @para   int subFlowRunIds 子流程id组合
 * @para   int limitDate     催办时间
 * @para   int monitor		 监控转交人
 * @para   int mbSmsContent  手机提醒内容
 * @para   int smsContent	 内部消息提醒内容
 * @para   int emailContent  邮件提醒内容
 * @para   string canEndFlow 是否结束流程
 * @return void
*/
function turnNextOrEnd($flowid,$runid,$userId,$flowPrcs,$prcsId,$prcsUser,$prcsOpUser,$docId,$oP,$subFlowRunIds,$limitDate,$monitor,$mbSmsContent,$smsContent,$emailContent,$canEndFlow)
{
	$workflowApi = new fixedWorkflow($flowid);	
	$workflowApi->runId = $runid;
	$OP_FLAG     = $workflowApi->isOpFlag($userId,$prcsId);
	if($OP_FLAG)
	{
		$workflowApi->turnnext($flowPrcs,$prcsId,$prcsUser,$prcsOpUser,$docId,$oP,$subFlowRunIds,$limitDate,$monitor,$mbSmsContent,$smsContent,$emailContent,'','webservice',$canEndFlow);
	}
	else
	{
		$workflowApi->saveForm($prcsId,$userId);
	}	
	return 1;
}

/**
 * 通过调用api的实例,实现上面注册的函数autoGetProcessor的功能
 * @access public
 * @para   int flowid 流程类别id
 * @para   int run_id 流程id
 * @return void
*/
function autoGetProcessor($flowid,$runid,$flowPrcs)
{
	CheckCurrentSession();
	$workflowApi = new fixedWorkflow($flowid);
	$workflowApi->runId = $runid;
	$node_info  = $workflowApi->getNodeInfo();
	$prcs_info  = $workflowApi->getPrcsInfo();
	$prcs_count = count($prcs_info);
	if($flowPrcs)
	{
		$flow_prcs = $flowPrcs;	
	}
	else
	{
		$flow_prcs = $prcs_info[$prcs_count-1]["FLOW_PRCS"];
	}
	$prcsUser            = trim($node_info[$flow_prcs]["PRCS_USER"],",");
	$prcsDept            = trim($node_info[$flow_prcs]["PRCS_DEPT"],",");
	$prcsPriv            = trim($node_info[$flow_prcs]["PRCS_PRIV"],",");
	$prcsAutoGetUser     = $node_info[$flow_prcs]["PRCS_AUTO_GET_USER"];
	$canEdit             = $node_info[$flow_prcs]["PRCS_DEFAULT_TYPE"];
	$default_manage      = $node_info[$flow_prcs]["PRCS_DEFAULT_MANAGE"];
	
	$dealers             = $workflowApi->autoGetProcessor($prcsUser,$prcsDept,$prcsPriv,$prcsAutoGetUser);
	//返回结果
	return $dealers;
}
/**
 * 通过调用api的实例,实现上面注册的函数getDefaultManage的功能
 * @access public
 * @para   int flowid 流程类别id
 * @para   int run_id 流程id
 * @para   int flowPrcs 流程节点号
 * @return array
*/
function GetFlowDefaultManage($flowid,$runid,$flowPrcs='')
{
	CheckCurrentSession();
	$workflowApi = new fixedWorkflow($flowid);
	$workflowApi->runId = $runid;
	if($flowPrcs)
	{
		$flow_prcs = $flowPrcs;
	}
	else
	{
		$prcs_info  = $workflowApi->getPrcsInfo();
		$prcs_count = count($prcs_info);
		if($prcs_count)
		{
			$flow_prcs = $prcs_info[$prcs_count-1]["FLOW_PRCS"];
		}
	}
	//判断此节点是否已经走过，走过的话，用走过的主办人作为默认办理人和默认主办人
	$have_run_info  = $workflowApi->nodeHaveRun($flow_prcs);
	if($have_run_info["USER_ID"])
	{
		$canEdit        = 0;
		$default_user   = $have_run_info["USER_ID"]; 
		$default_manage = $have_run_info["USER_ID"];
		$default_user_name   = getUsernameStr($have_run_info["USER_ID"]); 
		$default_manage_name = getUserNameNew($have_run_info["USER_ID"]);
	}
	else
	{
		$node_info      = $workflowApi->getNodeInfo();
		$canEdit        = $node_info[$flow_prcs]["PRCS_DEFAULT_TYPE"];
		$default_user   = $node_info[$flow_prcs]["PRCS_DEFAULT_USER"]; 
		$default_manage = $node_info[$flow_prcs]["PRCS_DEFAULT_MANAGE"];
		$default_user_name   = getUsernameStr($node_info[$flow_prcs]["PRCS_DEFAULT_USER"]); 
		$default_manage_name = getUserNameNew($node_info[$flow_prcs]["PRCS_DEFAULT_MANAGE"]);
	}	 	
	//返回结果
	return array("canEdit"=>$canEdit,"defaultUser"=>$default_user,"defaultManage"=>$default_manage,"defaultUserName"=>$default_user_name,"defaultManageName"=>$default_manage_name);
}
/**
 * 通过调用api的实例,实现上面注册的函数saveFeedBack的功能
 * @access public
 * @para   str userid   用户id
 * @para   int flow_id  流程类别id
 * @para   int run_id   流程id
 * @para   str content  反馈意见的内容
 * @para   str attachment_id   附件id字符串
 * @para   str attachment_name 附件名称字符串
 * @return array
*/
function saveFeedBack($userid,$flow_id,$run_id,$content,$attachment_id,$attachment_name)
{
	CheckCurrentSession();
	$workflowApi = new fixedWorkflow($flow_id);
	$workflowApi->runId = $run_id;
	$rs = $workflowApi->saveFeedBack($userid,addslashes($content),$attachment_id,$attachment_name);	
	//返回结果
	return $rs;
}
/**
 * 通过调用api的实例,实现上面注册的函数getFeedBack的功能
 * @access public
 * @para   int flow_id 流程类别id
 * @para   int run_id  流程id
 * @return array
*/
function GetFlowFeedBack($flow_id,$run_id)
{
	CheckCurrentSession();
	$workflowApi = new fixedWorkflow($flow_id);
	$workflowApi->runId = $run_id;
	$rs = $workflowApi->getFeedBack();
	$flowInfo = $workflowApi->getNodeInfo();
	for($i=0;$i < count($rs);$i++)
	{
		$flow_prcs           = $rs[$i]["FLOW_PRCS"];
		$rs[$i]["PRCS_NAME"] = $flowInfo[$flow_prcs]["PRCS_NAME"];
		$rs[$i]["USER_NAME"] = getUserNameNew($rs[$i]["USER_ID"]);
	}
	//返回结果
	return $rs;
}
/****************************表单字段信息函数******************/
//定义参数结构
$server->wsdl->addComplexType(
				'ParamListFiled',
				'complexType',
				'struct',
				'all',
				'',
				array(
					'FlowId' => array('name'=>'FlowId','type'=>'xsd:string'),
					'PrcsId' => array('name'=>'PrcsId','type'=>'xsd:string')
				)
);
//定义返回结构
$server->wsdl->addComplexType(
	 	'ReturnListFiledArray',
	 	'complexType',
	 	'array',
	 	'',
	 	'SOAP-ENC:Array',
		array(),
	 	array(
	 		array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:ReturnListFile[]')
	 	),
	 	'tns:ReturnListFile'
);
$server->wsdl->addComplexType(
	'ReturnListFile',
	'complexType',
	'struct',
	'all',
	'',
	array(
	    'FLOW_ID'            => array('name'=>'FLOW_ID','type'=>'xsd:string'),
	    'PRCS_ID'            => array('name'=>'PRCS_ID','type'=>'xsd:string'),
	    'PRCS_NAME'          => array('name'=>'PRCS_NAME','type'=>'xsd:string'),
	    'PRCS_USER'          => array('name'=>'PRCS_USER','type'=>'xsd:string'),
		'PRCS_ITEM'          => array('name'=>'PRCS_ITEM','type'=>'xsd:string'),
		'PRCS_TO'            => array('name'=>'PRCS_TO','type'=>'xsd:string'),
		'PRCS_ITEM_VIEW'     => array('name'=>'PRCS_ITEM_VIEW','type'=>'xsd:string'),
		'PRCS_ITEM_CAPACITY' => array('name'=>'PRCS_ITEM_CAPACITY','type'=>'xsd:string'),
		'PRCS_ITEM_AUTO'     => array('name'=>'PRCS_ITEM_AUTO','type'=>'xsd:string')
	)
);
$server->register('GetListFiledInfo',
				  array('filed' => 'tns:ParamListFiled'),
				  array('return' => 'tns:ReturnListFiledArray'),
				  'urn:WorkflowServicewsdl',
				  'urn:WorkflowServicewsdl#GetListFiledInfo',
				  'rpc',
				  'encoded',
				  'GetListFiledInfo'
				  );
//返回表单字段信息
function GetListFiledInfo($filed)
{
	CheckCurrentSession();
	$workflowApi   = new workflow($filed["FlowId"]);
	$ListFiledInfo = $workflowApi->GetListFiledInfo($filed);
	return $ListFiledInfo;
}

/****************************获取表单总信息函数******************/
//定义参数结构
$server->wsdl->addComplexType(
				'ParamListAll',
				'complexType',
				'struct',
				'all',
				'',
				array(
					'FlowId' => array('name'=>'FlowId','type'=>'xsd:string'),
					'RunId'  => array('name'=>'RunId','type'=>'xsd:string'),
					'PrcsId' => array('name'=>'PrcsId','type'=>'xsd:string')
				)
);
//定义返回结构
$server->wsdl->addComplexType(
	 	'ReturnListAllArray',
	 	'complexType',
	 	'array',
	 	'',
	 	'SOAP-ENC:Array',
		array(),
	 	array(
	 		array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:ReturnListAll[]')
	 	),
	 	'tns:ReturnListAll'
);
$server->wsdl->addComplexType(
	'ReturnListAll',
	'complexType',
	'struct',
	'all',
	'',
	array(
		'name'      => array('name'=>'name','type'=>'xsd:string'),
		'title'     => array('name'=>'title','type'=>'xsd:string'),
		'class'     => array('name'=>'class','type'=>'xsd:string'),
		'value'     => array('name'=>'value','type'=>'xsd:string'),
		'allvalue'  => array('name'=>'allvalue','type'=>'xsd:string'),
		'type'      => array('name'=>'type','type'=>'xsd:string'),
		'check'     => array('name'=>'check','type'=>'xsd:string'),
		'RUN_ID'    => array('name'=>'RUN_ID','type'=>'xsd:string'),
		'ITEM_ID'   => array('name'=>'ITEM_ID','type'=>'xsd:string'),
		'nature'    => array('name'=>'nature','type'=>'xsd:string'),
		'edit_prcs' => array('name'=>'edit_prcs','type'=>'xsd:string')
	)
);
$server->register('GetListAllInformation',
				  array('Info' => 'tns:ParamListAll'),
				  array('return' => 'tns:ReturnListAllArray'),
				  'urn:WorkflowServicewsdl',
				  'urn:WorkflowServicewsdl#GetListAllInformation',
				  'rpc',
				  'encoded',
				  'GetListAllInformation'
				  );
//获取表单总信息函数
function GetListAllInformation($Info)
{
	CheckCurrentSession();
	$workflowApi   = new workflow($Info["FlowId"]);
	$workflowApi->runId = $Info["RunId"];
	$ListFiledInfo = $workflowApi->GetListAllInformation($Info);
	return $ListFiledInfo;
}
/****************************获取流程相关信息（公共附件、相关文档、查看权限）******************/
//定义返回结构
$server->wsdl->addComplexType(
	'ReturnAttachment',
	'complexType',
	'struct',
	'all',
	'',
	array(
		'RUN_NAME'        => array('name'=>'RUN_NAME','type'=>'xsd:string'),
		'ATTACHMENT_ID'   => array('name'=>'ATTACHMENT_ID','type'=>'xsd:string'),
		'ATTACHMENT_NAME' => array('name'=>'ATTACHMENT_NAME','type'=>'xsd:string'),
		'ATTACHMENT_DIR'  => array('name'=>'ATTACHMENT_DIR','type'=>'xsd:string'),
		'RUN_SEQ'         => array('name'=>'RUN_SEQ','type'=>'xsd:string'),
		'LINK_DOC'        => array('name'=>'LINK_DOC','type'=>'xsd:string'),
		'VIEW_USER'       => array('name'=>'VIEW_USER','type'=>'xsd:string'),
		'CREATOR'         => array('name'=>'CREATOR','type'=>'xsd:string'),
		'CREATOR_NAME'    => array('name'=>'CREATOR_NAME','type'=>'xsd:string'),
		'CURRENT_STEP'    => array('name'=>'CURRENT_STEP','type'=>'xsd:string')
	)
);
$server->register('GetFlowOtherInformation',
				  array('FlowId'=>'xsd:string',
						'RunId'=>'xsd:string'
						),
				  array('return' => 'tns:ReturnAttachment'),
				  'urn:WorkflowServicewsdl',
				  'urn:WorkflowServicewsdl#GetFlowOtherInformation',
				  'rpc',
				  'encoded',
				  'GetFlowOtherInformation'
				  );

//获取表单总信息函数
function GetFlowOtherInformation($FlowId,$RunId)
{
	CheckCurrentSession();
	$workflowApi   = new workflow($FlowId);
	$workflowApi->runId = $RunId;
	$OtherInfo = $workflowApi->GetFlowOtherInformation();
	$OtherInfo['CREATOR_NAME'] = getUserNameNew($OtherInfo['CREATOR']);
	return $OtherInfo;
}

//新建流程
function create($flowId,$userId,$flowData)
{
	$flowDataArray = $flowData;
	$workflowApi   = new workflow($flowId);
	if($workflowApi->flowType == 1)
	{
		$workFlowInstance = new fixedWorkflow($flowId);	
		$workFlowInstance->create($userId,'',$flowDataArray);
	} else {
		$workFlowInstance = new freeWorkflow($flowId); 	
		$workFlowInstance->create($userId,'',$flowDataArray);
	}
	$retun = $workFlowInstance->runId;
	return $retun;
}

//根据流程id获取流程运行信息
function getFlowInfo($flowId,$runId)
{
	//$returnArr          = array();
	$workflowApi        = new workflow($flowId); 
	$workflowApi->runId = $runId;
	$flowInfoArray      = $workflowApi->getPrcsInfo();

	$returnArr["RUN_ID"]       = $flowInfoArray[0]["RUN_ID"];
	$returnArr["PRCS_ID"]      = $flowInfoArray[0]["PRCS_ID"];
	$returnArr["USER_ID"]      = $flowInfoArray[0]["USER_ID"];
	$returnArr["PRCS_TIME"]    = $flowInfoArray[0]["PRCS_TIME"];
	$returnArr["DELIVER_TIME"] = $flowInfoArray[0]["DELIVER_TIME"];
	$returnArr["SAVEFORM_TIME"]= $flowInfoArray[0]["SAVEFORM_TIME"];
	$returnArr["PRCS_FLAG"]    = $flowInfoArray[0]["PRCS_FLAG"];
	$returnArr["OP_FLAG"]      = $flowInfoArray[0]["OP_FLAG"];
	$returnArr["LIMIT_DATE"]   = $flowInfoArray[0]["LIMIT_DATE"];
	$returnArr["IS_REMIND"]    = $flowInfoArray[0]["IS_REMIND"];
	$returnArr["BY_AGENT_ID"]  = $flowInfoArray[0]["BY_AGENT_ID"];
	$returnArr["FLOW_AGENCY_ID"]    = $flowInfoArray[0]["FLOW_AGENCY_ID"];
	$returnArr["SUB_FLOW_RUN_IDS"]  = $flowInfoArray[0]["SUB_FLOW_RUN_IDS"];
	$returnArr["FORWARD_USER_ID"]   = $flowInfoArray[0]["FORWARD_USER_ID"];
	$returnArr["LAST_VISITED_TIME"] = $flowInfoArray[0]["LAST_VISITED_TIME"];
	$returnArr["MONITOR_SUBMIT"]    = $flowInfoArray[0]["MONITOR_SUBMIT"];

	return $returnArr;
}

//注册一个名字为getFlowTurnInfo的函数,根据流程id和runId获取流程流转信息
//定义返回结构
$server->wsdl->addComplexType(
    'flowTurnInfo',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array(
            'ref' => 'SOAP-ENC:arrayType',
            'wsdl:arrayType' => 'tns:turnInfo[]'
			  )
		),
    'tns:turnInfo'
);
$server->wsdl->addComplexType ( 
	'turnInfo', 
	'complexType', 
	'struct', 
	'all', 
	'',
	array (
		"PRCS_ID"   => array ('name' => 'PRCS_ID',  'type' => 'xsd:string' ),
		"PRCS_NAME" => array ('name' => 'PRCS_NAME',  'type' => 'xsd:string'),	
		"PRCS_USER" => array ('name' => 'PRCS_USER',  'type' => 'xsd:string'),
		"PRCS_ITEM" => array ('name' => 'PRCS_ITEM',  'type' => 'xsd:string'),
		"PRCS_DEPT" => array ('name' => 'PRCS_DEPT',  'type' => 'xsd:string'),
		"PRCS_PRIV" => array ('name' => 'PRCS_PRIV',  'type' => 'xsd:string'),
		"PRCS_TO" => array ('name' => 'PRCS_TO',  'type' => 'xsd:string'),
		"PRCS_FORWARD" => array ('name' => 'PRCS_FORWARD',  'type' => 'xsd:string'),
		"END_WORKFLOW" => array ('name' => 'END_WORKFLOW',  'type' => 'xsd:string'),
		"FLOW_OUTSEND" => array ('name' => 'FLOW_OUTSEND',  'type' => 'xsd:string'),
		"FLOW_OUTMAIL" => array ('name' => 'FLOW_OUTMAIL',  'type' => 'xsd:string'),
		"PRCS_CONCOURSE" => array ('name' => 'PRCS_CONCOURSE',  'type' => 'xsd:string'),
		"PRCS_DEFAULT_USER" => array ('name' => 'PRCS_DEFAULT_USER',  'type' => 'xsd:string'),
		"PRCS_DEFAULT_MANAGE" => array ('name' => 'PRCS_DEFAULT_MANAGE',  'type' => 'xsd:string'),
		"PRCS_AUTO_GET_USER" => array ('name' => 'PRCS_AUTO_GET_USER',  'type' => 'xsd:string')
		)
);

$server->register(
					'getFlowTurnInfo',
					array(
						'flowId' => 'xsd:string',
						'runId'  => 'xsd:string'
					),
					array(
						'return' => 'tns:flowTurnInfo'
					),
					'urn:WorkflowServicewsdl',
				    'urn:WorkflowServicewsdl#getFlowTurnInfo',
				    'rpc',
				    'encoded',
				    'E-office getFlowTurnInfo'
				  );

function getFlowTurnInfo($flowId,$runId) 
{
	$workflowApi  = new fixedWorkflow($flowId);	
	$workflowApi->runId = $runId;
	$flowTurnInfo = $workflowApi->getNodeRunInfo();
	
	foreach($flowTurnInfo as $key=>$value) {
		$returnArr[$key]["PRCS_ID"]   = $value["PRCS_ID"];
		$returnArr[$key]["PRCS_NAME"] = $value["PRCS_NAME"];
		$returnArr[$key]["PRCS_USER"] = $value["PRCS_USER"];
		$returnArr[$key]["PRCS_ITEM"] = $value["PRCS_ITEM"];
		$returnArr[$key]["PRCS_DEPT"] = $value["PRCS_DEPT"];
		$returnArr[$key]["PRCS_PRIV"] = $value["PRCS_PRIV"];
		$returnArr[$key]["PRCS_TO"]   = $value["PRCS_TO"];
		$returnArr[$key]["PRCS_FORWARD"] = $value["PRCS_FORWARD"];
		$returnArr[$key]["END_WORKFLOW"] = $value["END_WORKFLOW"];
		$returnArr[$key]["FLOW_OUTSEND"] = $value["FLOW_OUTSEND"];
		$returnArr[$key]["FLOW_OUTMAIL"] = $value["FLOW_OUTMAIL"];
		$returnArr[$key]["PRCS_CONCOURSE"]      = $value["PRCS_CONCOURSE"];
		$returnArr[$key]["PRCS_DEFAULT_USER"]   = $value["PRCS_DEFAULT_USER"];
		$returnArr[$key]["PRCS_DEFAULT_MANAGE"] = $value["PRCS_DEFAULT_MANAGE"];
		$returnArr[$key]["PRCS_AUTO_GET_USER"]  = $value["PRCS_AUTO_GET_USER"];
	}
	return $returnArr;
}

//注册一个名字为createNew的函数,创建流程(可以传入流水号)
$server->register(
				  'createNew',
				  array(
						'flowId' => 'xsd:string',
						'userId' => 'xsd:string',
						'flowData' =>'xsd:string',
						'runSeq'=>'xsd:string',
						'runName'=>'xsd:string'
						),
				  array(
						'runId' => 'xsd:string'
						),
				  'urn:WorkflowServicewsdl',
				  'urn:WorkflowServicewsdl#createNew',
				  'rpc',
				  'encoded',
				  'E-office CreateNew workflow'
				  );
//新建流程(可以传入流水号)
function createNew($flowId,$userId,$flowData,$runSeq,$runName)
{
	$flowDataArray = $flowData;
	$workflowApi   = new workflow($flowId);
	if($workflowApi->flowType == 1)
	{
		$workFlowInstance = new fixedWorkflow($flowId);	
		$workFlowInstance->create($userId,'',$flowDataArray,$runSeq,$runName);
	} else {
		$workFlowInstance = new freeWorkflow($flowId); 	
		$workFlowInstance->create($userId,'',$flowDataArray,$runSeq,$runName);
	}
	$retun = $workFlowInstance->runId;
	return $retun;
}
//注册一个名字为updateRunseq的函数,可以修改流水号
$server->register(
				  'updateRunseq',
				  array(
						'flowId' => 'xsd:string',
						'runId' => 'xsd:string',
						'runSeq'=>'xsd:string'
						),
				  array(
						'result' => 'xsd:string'
						),
				  'urn:WorkflowServicewsdl',
				  'urn:WorkflowServicewsdl#updateRunseq',
				  'rpc',
				  'encoded',
				  'E-office updateRunseq workflow'
				  );

//updateRunseq(可以修改流水号)
function updateRunseq($flowId,$runId,$runSeq) {
	$workflowApi = new workflow($flowId);
	if($workflowApi->flowType == 1) {
		$workFlowInstance = new fixedWorkflow($flowId);
		$result = $workFlowInstance->updateRunseq($flowId,$runId,$runSeq);
	} else {
		$workFlowInstance = new freeWorkflow($flowId);
		$result = $workFlowInstance->updateRunseq($flowId,$runId,$runSeq);
	}

	return $result;
}

//注册一个名字为updateRunname的函数,修改流程标题
$server->register(
				  'updateRunname',
				  array(
						'flowId' => 'xsd:string',
						'runId' => 'xsd:string',
						'runName'=>'xsd:string'
						),
				  array(
						'result' => 'xsd:string'
						),
				  'urn:WorkflowServicewsdl',
				  'urn:WorkflowServicewsdl#updateRunname',
				  'rpc',
				  'encoded',
				  'E-office updateRunname workflow'
				  );
//updateRunname
function updateRunname($flowId,$runId,$runName) {
	$workflowApi = new workflow($flowId);
	if($workflowApi->flowType == 1) {
		$workFlowInstance = new fixedWorkflow($flowId);
		$result = $workFlowInstance->updateRunname($flowId,$runId,$runName);
	} else {
		$workFlowInstance = new freeWorkflow($flowId);
		$result = $workFlowInstance->updateRunname($flowId,$runId,$runName);
	}
	return $result;
}

//返回数据
$server->service($HTTP_RAW_POST_DATA);
?>