<?php
require_once 'nusoap/lib/nusoap.php';
require_once 'inc/conn.php';
require_once 'inc/checkcurrentsession.php';
include_once("api/email.class.php");
include_once 'inc/oa_config.php';

global $ATTACH_PATH;
$attachment_url = str_replace ( ROOT_PATH, ROOT_URL, $ATTACH_PATH );
session_start();
/*************************************
 * 实例化soap_server对象并初始化
 *************************************/ 
$server         = new soap_server();
$server->soap_defencoding = "UTF-8";
$server->decode_utf8      = false;
$server->configureWSDL('EmailServicewsdl','EmailServicewsdl');
$server->wsdl->schemaTargetNamespace = 'EmailServicewsdl';
/******************************************
 * 添加类型
 ******************************************/
$server->wsdl->addComplexType(
	'EmailOtherParams','complexType','struct','all','',
	array(
		'words' => array('name'=>'words','type'=>'xsd:string'),
		'orderby' => array('name'=>'orderby','type'=>'xsd:string'),
		'page' =>array('name'=>'page','type'=>'xsd:string'),
		'limit' => array('name'=>'limit','type'=>'xsd:string')		
	)
);
$server->wsdl->addComplexType(
	 	'ArrayOfEmailRow',
	 	'complexType',
	 	'array',
	 	'',
	 	'SOAP-ENC:Array',
		array(),
	 	array(
	 		array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:EmailRow[]')
	 	),
	 	'tns:EmailRow'
);
$server->wsdl->addComplexType(
	'EmailRow',
	'complexType',
	'struct',
	'all',
	'',
	array(
	    'EMAIL_ID' => array('name'=>'EMAIL_ID','type'=>'xsd:string'),
	    'FROM_ID' =>  array('name'=>'FROM_ID','type'=>'xsd:string'),
	    'FROM_NAME' =>  array('name'=>'FROM_NAME','type'=>'xsd:string'),
	    'TO_ID' =>  array('name'=>'TO_ID','type'=>'xsd:string'),
	    'TO_ID2' =>  array('name'=>'TO_ID2','type'=>'xsd:string'),
	    'COPY_TO_ID' =>  array('name'=>'COPY_TO_ID','type'=>'xsd:string'),
	    'SECRET_TO_ID' =>   array('name'=>'SECRET_TO_ID','type'=>'xsd:string'),
	    'SUBJECT' =>   array('name'=>'SUBJECT','type'=>'xsd:string'),
	    'CONTENT' =>   array('name'=>'CONTENT','type'=>'xsd:string'),
	    'SEND_TIME' =>   array('name'=>'SEND_TIME','type'=>'xsd:string'),
	    'ATTACHMENT_ID' =>   array('name'=>'ATTACHMENT_ID','type'=>'xsd:string'),
	    'ATTACHMENT_NAME' =>   array('name'=>'ATTACHMENT_NAME','type'=>'xsd:string'),
	    'READ_FLAG' =>  array('name'=>'READ_FLAG','type'=>'xsd:string'),
	    'SEND_FLAG' =>  array('name'=>'SEND_FLAG','type'=>'xsd:string'),
	    'DELETE_FLAG' =>  array('name'=>'DELETE_FLAG','type'=>'xsd:string'),
	    'SMS_REMIND' =>  array('name'=>'SMS_REMIND','type'=>'xsd:string'),
	    'BOX_ID' =>  array('name'=>'BOX_ID','type'=>'xsd:string'),
	    'DELETE_BY_SENT' =>  array('name'=>'DELETE_BY_SENT','type'=>'xsd:string')
	)
);

$server->wsdl->addComplexType(
	'EmailPreNext',
	'complexType',
	'struct',
	'all',
	'',
	array(
		'emailid'=>array('name'=>'emailid','type' =>'xsd:string'),
		'subject'=>array('name'=>'subject','type'=>'xsd:string')
	)
);
$server->wsdl->addComplexType('Data','complexType','array','all','',
	array(
		'receiver_id'=>array('name'=>'receiver_id','type'=>'xsd:string'),
		'subject'=>array('name'=>'subject','type'=>'xsd:string'),
		'content'=>array('name'=>'content','type'=>'xsd:string'),
		'attachment_id'=>array('name'=>'attachment_id','type'=>'xsd:string'),
		'attachment_name'=>array('name'=>'attachment_name','type'=>'xsd:string'),		
		'send_flag'=>array('name'=>'send_flag','type'=>'xsd:string')		
	)
);
/******************************************
 * 	Functions
 ******************************************/
/**
 * 身份验证
 * @param string $sessionid
 */	
function authCheck(){
	CheckCurrentSession();
	return new email();
}

$server->register('addEmail',
	array('data' => 'tns:Data'), 
	array('return' => 'xsd:string'),
	'urn:EmailServicewsdl',
	'urn:EmailServicewsdl#addEmail',
	'rpc','encoded',
	'send an internal email'
	);
/**
 * 增加保存邮件
 * @param array $data array 邮件内容数组
 * @return string 新增邮件的ID串 
 */
function addEmail( $data){
	$email = authCheck();
	$result = $email->addEmail($data);
	return $result;
}
###
$server->register('delEmailById',
	array('id' => 'xsd:int'), 
	array('return' => 'xsd:string'),
	'urn:EmailServicewsdl',
	'urn:EmailServicewsdl#delEmailById',
	'rpc','encoded',
	'del an Email By email Id'
	);
/**
 * 按指定id删除邮件
 * @param int $id 邮件ID
 * @return 成功1 or 失败0
 */
function delEmailById( $id ){
	$email = authCheck();
	if(empty($id)) return 0;
	$email->delEmailById($id);
	return 1;	
}
###
$server->register('delEmailByIds',
	array('ids' => 'xsd:string'), 
	array('return' => 'xsd:string'),
	'urn:EmailServicewsdl',
	'urn:EmailServicewsdl#delEmailByIds',
	'rpc','encoded',
	'del an Email By email Id string:1,2,3,'
	);
/**
 * 根据id串删除多条邮件
 * @param string $ids array id字符串:'1,2,3'
 * @return 成功1，失败0 
 */	
function delEmailByIds( $ids){
	$email = authCheck();
	if(empty($ids)) return 0;
	$id_array = explode(',', $ids);
	return $email->delEmailByIds($id_array);
}
##
$server->register('getAttachment',
	array('file' => 'xsd:string'), 
	array('return' => 'xsd:string'),
	'urn:EmailServicewsdl',
	'urn:EmailServicewsdl#getAttachment',
	'rpc','encoded',
	'get Attachment infomation,return as json'
	);
/**
 * 获取邮件附件名
 * @param file $file 文件名
 * @return json  文件信息
 */
function getAttachment( $file ='' ){
	$email = authCheck();
	$data = $email->getAttachment($file);
	return json_encode($data);
}
##
$server->register('getEmailAmount',
	array('boxtype' => 'xsd:string','word'=>'xsd:string'), 
	array('return' => 'xsd:string'),
	'urn:EmailServicewsdl',
	'urn:EmailServicewsdl#getEmailAmount',
	'rpc','encoded',
	'get Email Amount'
	);
/**
 * 取得邮件数量
 * @param string $boxtype 邮箱文件夹类型
 * @param string $words 搜索关键字
 * @return 邮件数量
 */
function getEmailAmount($boxtype = -1,$words = null){
	$email = authCheck();
	return $email->getEmailAmount($boxtype,$words);
}
##
$server->register('getEmailById',
	array('id' => 'xsd:int'), 
	array('return' => 'tns:EmailRow'),
	'urn:EmailServicewsdl',
	'urn:EmailServicewsdl#getEmailById',
	'rpc','encoded',
	'get Email information By email Id'
	);
/**
 * get email by email id 
 * @param int $id email id
 * @return array email info
 */
function getEmailById( $id ){
	global $attachment_url;
	$email = authCheck();
	$data = $email->getEmailById($id);
	
	$name_array = explode('*',$data['ATTACHMENT_NAME']);
	$id_array = explode(',',$data['ATTACHMENT_ID']);	
	foreach($id_array as $id_index => $id){
		if($id == '') continue;
		$id_array[$id_index] = $attachment_url.$id.'/'.$name_array[$id_index];
	}
	$data['ATTACHMENT_ID'] = implode(',',$id_array);
	
	return $data;
}
##
$server->register('getEmails',
	array('boxtype' => 'xsd:string',
	'others'=>'tns:EmailOtherParams',
	), 
	array('return' => 'tns:ArrayOfEmailRow'),
	'urn:EmailServicewsdl',
	'urn:EmailServicewsdl#getEmails',
	'rpc','encoded',
	'get Email list as array'
	);
/**
 * 获取邮件列表
 * @param string $boxtype 邮箱文件夹类型
 * @param array $others array 搜索关键字等其他sql限制
 * @param bool $return_json 是否返回JSON类型,默认为false
 * @return 邮件列表内容数组
 */
function getEmails($boxtype = -1,$others = array()){
	global $attachment_url;
	$email = authCheck();
	$data = $email->getEmails($boxtype,'',$others);
	
	foreach($data as $index => $val){
		$name_array = explode('*',$val['ATTACHMENT_NAME']);
		$id_array = explode(',',$val['ATTACHMENT_ID']);	
		foreach($id_array as $id_index => $id){
			if($id == '') continue;
			$id_array[$id_index] = $attachment_url.$id.'/'.$name_array[$id_index];
		}
		$data[$index]['ATTACHMENT_ID'] = implode(',',$id_array);
	}
	
	return $data;
}

##
$server->register('getInboxMailCount',
	array('userid' => 'xsd:string'), 
	array('return' => 'xsd:string'),
	'urn:EmailServicewsdl',
	'urn:EmailServicewsdl#getInboxMailCount',
	'rpc','encoded',
	'get the amount of Inbox'
	);
/**
 * 取得收件箱邮件数量
 * @param int $userid 用户ID
 * @return 邮件数量
 */
function getInboxMailCount($userid){
	$email = authCheck();
	return $email->getInboxMailCount($userid);
}
##
$server->register('getNewEmailAmount',
	array('keyword' => 'xsd:string'), 
	array('return' => 'xsd:string'),
	'urn:EmailServicewsdl',
	'urn:EmailServicewsdl#getNewEmailAmount',
	'rpc','encoded',
	'get the Amount of New Email'
	);
/**
 * 获取新邮件的数量
 * @param string $keyword 搜索关键字
 * @return 邮件数量
 */
function getNewEmailAmount($keyword=""){
	$email = authCheck();
	return $email->getNewEmailAmount($keyword);
}
##
$server->register('getPreNextEmail',
	array('emailid' => 'xsd:int','flag'=>'xsd:string'), 
	array('return' => 'tns:EmailPreNext'),
	'urn:EmailServicewsdl',
	'urn:EmailServicewsdl#getPreNextEmail',
	'rpc','encoded',
	'get the pre or next Email'
	);
/**
 * 取得上/下一封邮件
 * @param int $emailid 邮件id
 * @param string $flag 上(pre)/下(next)标志
 * @return 邮件内容数组
 */
function getPreNextEmail($emailid,$flag="next"){
	$email = authCheck();
	return $email->getPreNextEmail($emailid,$flag);
}
##
$server->register('getUnreadMailCount',
	array('userid' => 'xsd:string'), 
	array('return' => 'xsd:string'),
	'urn:EmailServicewsdl',
	'urn:EmailServicewsdl#getUnreadMailCount',
	'rpc','encoded',
	'get the amount of unread mail'
	);
/**
 * get Unread Mail Count
 * @param int $userid user id
 * @return mail count
 */
function getUnreadMailCount($userid){
	$email = authCheck();
	return $email->getUnreadMailCount($userid);
}

##
$server->register('sendEmail',
	array('fromid' => 'xsd:string',
		'toid'=>'xsd:string',
		'toid2'=>'xsd:string',
		'subject'=>'xsd:string',
		'content'=>'xsd:string',
		'sendtime'=>'xsd:string',
		'attachid'=>'xsd:string',
		'attachname'=>'xsd:string'
	), 
	array('return' => 'xsd:string'),
	'urn:EmailServicewsdl',
	'urn:EmailServicewsdl#sendEmail',
	'rpc','encoded',
	'send an email'
	);
/**
 * 邮件发送
 * @param string $fromid 发件人ID
 * @param string $toid 收件人ID
 * @param string $toid2 收件人ID串
 * @param string $subject 主题
 * @param string $content 内容
 * @param string $sendtime 发送时间
 * @param string $attachid 附件ID，以逗号隔开
 * @param string $attachname 附件名，以逗号隔开
 * @return 成功1
 */
function sendEmail($fromid,$toid,$toid2,$subject,$content,$sendtime,$attachid= '',$attachname='') {
	$email = authCheck();
	$email->sendEmail($fromid,$toid,$toid2,$subject,$content,$sendtime,$attachid,$attachname);
	return 1;
}
##
$server->register('updateEmailStatus',
	array('emailid' => 'xsd:int'), 
	array('return' => 'xsd:string'),
	'urn:EmailServicewsdl',
	'urn:EmailServicewsdl#updateEmailStatus',
	'rpc','encoded',
	'update Email Status'
	);
/**
 * 更新邮件为已读状态
 * @param int $emailid 邮件ID
 * @return 成功1
 */
function updateEmailStatus($emailid){
	$email = authCheck();
	$email->updateEmailStatus($emailid);
	return 1;
}

//返回数据
$server->service($HTTP_RAW_POST_DATA);