<?php

/**
 * @copyright (C) 2001 - 2011 Weaver Co.Ltd
 * @package       eoffice 8.0
 * @name          eoffice.wsdl.php (WebService-客户端)
 * @version       1.0
 * @author        samuel|www.weaver.com.cn
 * @date          2012-8-1
 */
include_once ("nusoap/lib/nusoap.php");
include_once ("inc/conn.php");
include_once ("api/user.class.php");
include_once ("api/attend.class.php");
include_once ("inc/utility_all.php");
include_once ("general/workflow/prcs_role.php");
include_once ("lang/cn/common.lang.php");
include ('api/login.class.php');
include_once ('inc/reg_func.php');
include ('inc/oa_config.php');

$server = new soap_server();
$server->soap_defencoding = "UTF-8";
$server->decode_utf8 = false;
$server->configureWSDL('EofficeService', 'urn:EofficeService');
$server->wsdl->schemaTargetNamespace = 'urn:EofficeService';

/* * ************************************************************
 * 登录
 * *********************************************************** */
$server->wsdl->addComplexType('UserLoginReturn', 'complexType', 'struct', 'all', '', array(
    'code' => array(
        'name' => 'code',
        'type' => 'xsd:string'
    ),
    'infor' => array(
        'name' => 'infor',
        'type' => 'tns:userInforObj'
    )
));

$server->wsdl->addComplexType('userInforObj', 'complexType', 'struct', 'all', '', array(
    'sessionID' => array(
        'name' => 'sessionID',
        'type' => 'xsd:string'
    ),
    'userID' => array(
        'name' => 'userID',
        'type' => 'xsd:string'
    ),
    'deptID' => array(
        'name' => 'deptID',
        'type' => 'xsd:string'
    ),
    'privID' => array(
        'name' => 'privID',
        'type' => 'xsd:string'
    ),
    'userName' => array(
        'name' => 'userName',
        'type' => 'xsd:string'
    ),
    'userAccount' => array(
        'name' => 'userAccount',
        'type' => 'xsd:string'
    ),
    'avatarType' => array(
        'name' => 'userAvatar',
        'type' => 'xsd:string'
    ),
    'slogan' => array(
        'name' => 'slogan',
        'type' => 'xsd:string'
    ),
    'smsFrequency' => array(
        'name' => 'smsFrequency',
        'type' => 'xsd:string'
    ),
    'smsUploadParam' => array(
        'name' => 'smsUploadParam',
        'type' => 'tns:smsUploadParam'
    ),
    'documentUploadParam' => array(
        'name' => 'documentUploadParam',
        'type' => 'tns:documentUploadParam'
    )
));

//内部消息附件参数
$server->wsdl->addComplexType('smsUploadParam', 'complexType', 'struct', 'all', '', array(
    'maxNumber' => array(
        'name' => 'maxNumber',
        'type' => 'xsd:string'
    ),
    'singleMaxSize' => array(
        'name' => 'singleMaxSize',
        'type' => 'xsd:string'
    ),
    'totalMaxSize' => array(
        'name' => 'totalMaxSize',
        'type' => 'xsd:string'
    ),
    'denySuffix' => array(
        'name' => 'denySuffix',
        'type' => 'xsd:string'
    )
));

//文档附件上传参数
$server->wsdl->addComplexType('documentUploadParam', 'complexType', 'struct', 'all', '', array(
    'maxNumber' => array(
        'name' => 'maxNumber',
        'type' => 'xsd:string'
    ),
    'singleMaxSize' => array(
        'name' => 'singleMaxSize',
        'type' => 'xsd:string'
    ),
    'totalMaxSize' => array(
        'name' => 'totalMaxSize',
        'type' => 'xsd:string'
    ),
    'denySuffix' => array(
        'name' => 'denySuffix',
        'type' => 'xsd:string'
    )
));
$server->register('UserLogin', array(
    'userAccount' => 'xsd:string',
    'password' => 'xsd:string'
        ), array(
    'return' => 'tns:UserLoginReturn'
        ), 'urn:EofficeService', 'urn:EofficeService#UserLogin', 'rpc', 'encoded', 'UserLogin');

function UserLogin($userAccount, $password) {
    global $connection, $_lang;

$userAccount = htmlspecialchars(stripslashes($userAccount));
$userAccount  = str_replace("'","’",$userAccount);
$userAccount  = str_replace('"','“',$userAccount);
$userAccount = SecurityFilter($userAccount);
    //检查用户名是否为空
    if (trim($userAccount) == "") {
        $userLoginReturn["code"] = "0x0000001";
        return $userLoginReturn;
    }

    //检查用户名是否存在
    $checkUserAccountIsExsitQuery = "SELECT * FROM user WHERE USER_ACCOUNTS='" . trim($userAccount) . "'";
    $checkUserAccountIsExsitResult = exequery($connection, $checkUserAccountIsExsitQuery);
    if ($checkUserAccountIsExsitRow = mysql_fetch_array($checkUserAccountIsExsitResult)) {
        if (trim($checkUserAccountIsExsitRow["USER_ACCOUNTS"]) != trim($userAccount)) {
            $userLoginReturn["code"] = "0x0000002";
            return $userLoginReturn;
        }
    } else {
        $userLoginReturn["code"] = "0x0000002";
        return $userLoginReturn;
    }

    //检查密码
    $checkPasswordQuery = "SELECT PASSWORD FROM user WHERE USER_ACCOUNTS='" . trim($userAccount) . "'";

    $checkPasswordResult = exequery($connection, $checkPasswordQuery);
    $checkPasswordRow = mysql_fetch_array($checkPasswordResult);
    $myPassword = $checkPasswordRow["PASSWORD"];

    if (crypt($password, $myPassword) != $myPassword) {
        $userLoginReturn["code"] = "0x0000003";
        return $userLoginReturn;
    }

    $query = "SELECT * from USER where USER_ACCOUNTS='" . $userAccount . "'";
    $cursor = exequery($connection, $query);
    $ROW = mysql_fetch_array($cursor);

    $timenow = time();
    $CUR_TIME = date("Y-m-d H:i:s", $timenow);
    $query = "update USER set LAST_VISIT_TIME='$CUR_TIME' where USER_ID='" . $ROW["USER_ID"] . "'";
    exequery($connection, $query);


    $LOGIN_THEME = $ROW["THEME"];
    $template = $ROW["TEMPLATE"];
    if (!$template) {
        $template_query = "SELECT TEMPLATE_NAME FROM sys_template WHERE TEMPLATE_DEFAULT = 1 ";
        $template_rs = exequery($connection, $template_query);
        if ($row_tp = mysql_fetch_array($template_rs)) {
            $template = $row_tp["TEMPLATE_NAME"];
        } else {
            $template = "8series";
        }
    }
    if ($template == "8series") {
        $mainUrl = "/general/index8.php";
    } else if ($template == "7series") {
        $mainUrl = "/general/index.php";
    } else {
        $mainUrl = "index8.php";
    }
    if ($LOGIN_THEME == '') {
        $LOGIN_THEME = 'default';
    }
    $LOGIN_THEME = $template . "/" . $LOGIN_THEME;

    session_start();

    $_SESSION["LOGIN_USER_ID"] = $ROW["USER_ID"];
    $_SESSION["LOGIN_PASSWORD"] = $ROW["PASSWORD"];
    $_SESSION["LOGIN_POST_PRIV"] = $ROW["POST_PRIV"];
    $_SESSION["LOGIN_USER_ACCOUNTS"] = $ROW["USER_ACCOUNTS"];
    $_SESSION["LOGIN_USER_NAME"] = $ROW["USER_NAME"];
    $_SESSION["LOGIN_USER_PRIV"] = $ROW["USER_PRIV"];
    $_SESSION["LOGIN_DEPT_ID"] = $ROW["DEPT_ID"];
    $_SESSION["LOGIN_FUNC_STR"] = GetUserFuncIDStr($ROW["USER_ID"]);
    $_SESSION["LOGIN_THEME"] = $LOGIN_THEME;
    $_SESSION["LOGIN_LANG"] = "cn";
    $_SESSION["LOGIN_LANG_ID"] = 1;

    $infor["sessionID"] = session_id();
    $infor["userID"] = $ROW["USER_ID"];
    $infor["deptID"] = $ROW["USER_ID"];
    $infor["privID"] = $ROW["USER_PRIV"];
    $infor["userName"] = $ROW["USER_NAME"];
    $infor["userAccount"] = $ROW["USER_ACCOUNTS"];
    $infor["avatarType"] = $ROW["AVATAR_TYPE"];

    //更新最后一次登录时间
    $query = "update USER set LAST_VISIT_TIME='$CUR_TIME' where USER_ID='" . $ROW["USER_ID"] . "'";
    exequery($connection, $query);

    //增加登录日志
    add_log(1, $_lang["common_login_from_PC"], $ROW["USER_ID"]);

    //获取系统参数
    $query = "SELECT * FROM `sys_para`;";
    $result = exequery($connection, $query);
    while ($row = mysql_fetch_array($result)) {
        switch ($row["PARA_NAME"]) {
            case "slogan":
                $infor["slogan"] = $row["PARA_VALUE"];
                break;

            case "SMS_FREQUENCY":
                $infor["smsFrequency"] = $row["PARA_VALUE"];
                break;
        }
    }

    //获取内部消息和文档的附件上传参数
    $query = "SELECT * FROM sys_upload WHERE MODULE_NAME='SMS' OR MODULE_NAME ='FILE'";

    $result = exequery($connection, $query);
    while ($row = mysql_fetch_array($result)) {
        if ($row["MODULE_NAME"] == "SMS") {
            $temp["maxNumber"] = $row["UPLOAD_MAX_NUM"];
            $temp["singleMaxSize"] = $row["UPLOAD_SINGLE_MAX_SIZE"];
            $temp["totalMaxSize"] = $row["UPLOAD_TOTAL_MAX_SIZE"];
            $temp["denySuffix"] = "|" . $row["DENY_SUFFIX"] . "|" . UPLOADROLE;
            $infor["smsUploadParam"] = $temp;
        } else if ($row["MODULE_NAME"] == "FILE") {
            $temp["maxNumber"] = $row["UPLOAD_MAX_NUM"];
            $temp["singleMaxSize"] = $row["UPLOAD_SINGLE_MAX_SIZE"];
            $temp["totalMaxSize"] = $row["UPLOAD_TOTAL_MAX_SIZE"];
            $temp["denySuffix"] = "|" . $row["DENY_SUFFIX"] . "|" . UPLOADROLE;
            $infor["documentUploadParam"] = $temp;
        }
    }

    //获取文旦

    $userLoginReturn["code"] = "0x0000000";
    $userLoginReturn["infor"] = $infor;

    return $userLoginReturn;
}

/* * ************************************************************
 * 获取语言
 * *********************************************************** */

$server->wsdl->addComplexType('languageRerurnArray', 'complexType', 'array', '', 'SOAP-ENC:Array', array(), array(
    array(
        'ref' => 'SOAP-ENC:arrayType',
        'wsdl:arrayType' => 'tns:languageReturn[]'
    )
        ), 'tns:languageReturn');

$server->wsdl->addComplexType('languageReturn', 'complexType', 'struct', 'all', '', array(
    'langID' => array(
        'name' => 'langID',
        'type' => 'xsd:string'
    ),
    'langName' => array(
        'name' => 'langName',
        'type' => 'xsd:string'
    )
));

$server->register('GetLanguage', array(), array(
    'return' => 'tns:languageRerurnArray'
        ), 'urn:EofficeService', 'urn:EofficeService#GetLanguage', 'rpc', 'encoded', 'GetLanguage');

function GetLanguage() {
    global $connection;
    $query = "SELECT LANG_ID,LANG_NAME FROM language";
    $result = exequery($connection, $query);
    $language = array();
    while ($row = mysql_fetch_array($result)) {
        $temp["langID"] = $row["LANG_ID"];
        $temp["langName"] = $row["LANG_NAME"];
        array_push($language, $temp);
    }
    return $language;
}

/* * ************************************************************
 * 默认菜单
 * *********************************************************** */
$server->wsdl->addComplexType('menuRerurnArray', 'complexType', 'array', '', 'SOAP-ENC:Array', array(), array(
    array(
        'ref' => 'SOAP-ENC:arrayType',
        'wsdl:arrayType' => 'tns:menuReturn[]'
    )
        ), 'tns:menuReturn');

$server->wsdl->addComplexType('menuReturn', 'complexType', 'struct', 'all', '', array(
    'funcName' => array(
        'name' => 'funcName',
        'type' => 'xsd:string'
    ),
    'funcID' => array(
        'name' => 'funcID',
        'type' => 'xsd:string'
    ),
    'menuLink' => array(
        'name' => 'menuLink',
        'type' => 'xsd:string'
    ),
    'imageLink' => array(
        'name' => 'imageLink',
        'type' => 'xsd:string'
    )
));

$server->register('GetCommonMenu', array(
    'userPriv' => 'xsd:string',
    'userID' => 'xsd:string',
    'langID' => 'xsd:string'
        ), array(
    'return' => 'tns:menuRerurnArray'
        ), 'urn:EofficeService', 'urn:EofficeService#GetCommonMenu', 'rpc', 'encoded', 'GetCommonMenu');

/*
 * 获取菜单链接
 * @param $funcCode 菜单Code
 * @param $funcName 菜单名称
 * @return 菜单链接
 */

function GetMenuLink($funcCode, $funcName) {
    if (trim($funcCode) == "" || trim($funcCode) == "@") {

        $href = "";
    } else {
        if (strstr($funcCode, "http://") || strstr($funcCode, "workflow/new/do.php") || strstr($funcCode, "workflow/new/freedo.php")) {

            if (strstr($funcCode, "workflow/new/do.php") || strstr($funcCode, "workflow/new/freedo.php")) {
                $funcCode = "/general/" . $funcCode;
            }
            if (strstr($funcCode, "workflow/new/do.php") || strstr($funcCode, "workflow/new/freedo.php")) {
                $href = "/general/workflow/flow_redirect.php?url=" . urlencode($funcCode) . "&FUNC_ID=$func_id";
            } else {
                $href = $funcCode;
            }
        } elseif (strstr($funcCode, "file://")) {

            $winpath = str_replace("\\", "/", str_replace("file://", "", $funcCode));
            $winpath = base64_encode($winpath);
            $href = "/general/winexe/run_cache.php?path=" . $winpath . "&name=" . urlencode($funcName);
        } elseif (strstr($funcCode, "*")) {
            $func_code = str_replace("*", "", $funcCode);

            //原单点登录打开方式
            $href = "/general/loginothersys/run_login.php?id=" . $func_code;
        } else {

            //加入参数=====================================
            $needle = "?";

            //判断是否包含?这个字符
            $tmparray = explode($needle, $funcCode);
            if (count($tmparray) > 1) {
                $href = "/general/" . $funcCode . "&func_id=$func_id";
            } else {
                $href = "/general/" . $funcCode . "?func_id=$func_id";
            }
        }
    }

    return $href;
}

/*
 * 获取用户角色菜单ID
 * @param $userID 用户ID
 * @return 用户角色菜单ID字符串
 */

function GetUserFuncIDStr($userID) {

    global $connection;

    $getUserInforSQL = 'SELECT USER_PRIV,USER_SUB_PRIV
    					FROM user
    					WHERE USER_ID = "' . SecurityFilter($userID) . '"';
    $getUserInforResult = exequery($connection, $getUserInforSQL);

    if ($getUserInforRow = mysql_fetch_array($getUserInforResult)) {
        $userPriv = $getUserInforRow['USER_PRIV'];
        $userSubPriv = $getUserInforRow['USER_SUB_PRIV'];
    }

    $loginObj = new Login();

    //获取有权限的菜单id
    $loginFuncStr = $loginObj->getFuncStr($userPriv);

    $userSubFuncStr = $loginObj->getUserSubPriv($userSubPriv);

    //查询用户辅助权限,并一起赋给主权限
    if (!empty($userSubFuncStr)) {
        $loginFuncStr = implode(",", array_filter(array_unique(explode(",", $loginFuncStr . "," . $userSubFuncStr))));
    }

    return trim($loginFuncStr, ',');
}

/*
 *
 *
 * 获取没有授权的模块ID
 */

function getFuncNoModID() {
    global $connection;
    $machineCode = get_machine_code(1);
    $verifyFile = BIN_PATH . "auth/" . md5($machineCode . "eoffice9731") . ".evf"; // 模块

    if (file_exists($verifyFile)) {
        $ModuleVerify = authcode(file_get_contents($verifyFile), "DECODE");
    } else {
        $ModuleVerify = "error";
    }

    if ($ModuleVerify && $ModuleVerify != "error") {
        $moduleVerifyInfor = json_decode($ModuleVerify, true);
    } else {
        //将授权信息存储在本地

        $arr_verify_list[0] = array();
        $arr_verify_list[2] = array();

        $arr_verify_list[1]['time'] = strtotime("today");

        file_put_contents(UTH_TMP_PATH."auth/verify_client.inc", json_encode($arr_verify_list));
        return $arr_verify_list;
    }

    //获取所有的模块
    $query = "SELECT s.`FUNC_ID`,m.FUNC_NAME ,s.MENU_ID
					  FROM `sys_function` AS s JOIN `menu_lang` AS m ON s.FUNC_ID = m.FUNC_ID
					  WHERE LENGTH(MENU_ID) = 2
					  AND s.`FUNC_ISEOFFICE` = 1
                                          AND m.LANG_ID = 1
					  ORDER BY `FUNC_ORDER` ";
    $result = exequery($connection, $query);


    $arr_verify_list = array();
    while ($row = mysql_fetch_array($result)) {

        $funcID = $row["FUNC_ID"];
        $menuID = $row["MENU_ID"];

        if ($ModuleVerify) {

            if ($ModuleVerify == "error") {

                $arr_verify_list[0][] = $funcID;
                $arr_verify_list[2][] = $menuID;
            } else {

                if (is_array($moduleVerifyInfor) && array_key_exists($funcID, $moduleVerifyInfor)) {
                    if ($moduleVerifyInfor[$funcID] != "") {

                        if (strtotime(date("Y-m-d")) > abs(strtotime($moduleVerifyInfor[$funcID]))) {

                            $arr_verify_list[0][] = $funcID;
                            $arr_verify_list[2][] = $menuID;
                        }
                    }
                } else {

                    $arr_verify_list[0][] = $funcID;
                    $arr_verify_list[2][] = $menuID;
                }
            }
        }
    }



//将授权信息存储在本地
    if (!$arr_verify_list[0]) {
        $arr_verify_list[0] = array();
        $arr_verify_list[2] = array();
    }
    $arr_verify_list[1]['time'] = strtotime("today");

    file_put_contents(UTH_TMP_PATH."auth/verify_client.inc", json_encode($arr_verify_list));
    return $arr_verify_list;
}

/*
 * 获取常用菜单
 * @param $userPriv 用户角色
 * @param $userID 用户ID
 * @param $langID 菜单语言ID
 * @return 常用菜单信息
 */

function GetCommonMenu($userPriv, $userID, $langID) {
    global $connection;
    $userID = SecurityFilter($userID);
    $langID = SecurityFilter($langID);
    //获取角色权限
    $funcIDStr = GetUserFuncIDStr($userID);
    $funcIDStr = $funcIDStr == "" ? 0 : $funcIDStr;

    $query = "SELECT
				a.FUNC_NAME AS FUNC_NAME_SYS,
				a.FUNC_NAME_PY AS FUNC_NAME_PY_SYS,
				a.FUNC_NAME_ZM AS FUNC_NAME_ZM_SYS,
				b.FUNC_ID,
				b.FUNC_NAME AS FUNC_NAME_USER,
				b.FUNC_NAME_PY AS FUNC_NAME_PY_USER,
				b.FUNC_NAME_ZM AS FUNC_NAME_ZM_USER,
				b.FUNC_CODE,
				b.FUNC_ISSYS,
				c.FUNC_IMG
				FROM menu_lang AS a
				JOIN user_menu AS b
				ON a.FUNC_ID = b.FUNC_ID
				JOIN sys_function AS c
				ON a.FUNC_ID = c.FUNC_ID
				WHERE ((b.FUNC_ID IN ($funcIDStr) AND b.FUNC_ISSYS=1 AND a.LANG_ID = " . $langID . " )
				OR b.FUNC_ISSYS=0)
				AND LEFT(b.FUNC_CODE,1)<>'@'
				AND b.FUNC_CODE <> ''
				AND b.USER_ID = '" . $userID . "'
				AND b.FUNC_ISSHOW = 1
				ORDER BY FREQUENCY DESC
				LIMIT 0,12";

    $result = exequery($connection, $query);
    $returnArray = array();
    while ($row = mysql_fetch_array($result)) {
        if ($row["FUNC_ISSYS"] == 1) {
            $funcName = $row['FUNC_NAME_SYS'];
        } else {
            $funcName = $row['FUNC_NAME_USER'];
        }
        $funcID = $row['FUNC_ID'];
        $menuID = $row['MENU_ID'];
        $funcCode = $row['FUNC_CODE'];
        $funcImg = $row['FUNC_IMG'];

        if ($funcImg == "") {
            $imgSrc = '/images/8/icons/48/' . $funcID . '.png';
        } else {
            $imgSrc = '/attachment/index/48/' . $funcImg;
        }

        $imgSrc = file_exists(ROOT_PATH . $imgSrc) ? $imgSrc : '/images/8/icons/48/default.png';

        $tempArray["funcName"] = $funcName;
        $tempArray["funcID"] = $funcID;
        $tempArray["imageLink"] = $imgSrc;
        $tempArray["menuLink"] = GetMenuLink($funcCode, $funcName);

        array_push($returnArray, $tempArray);
    }
    return $returnArray;
}

/* * ************************************************************
 * 所有菜单
 * *********************************************************** */

$server->wsdl->addComplexType('allMenuRerurnArray', 'complexType', 'array', '', 'SOAP-ENC:Array', array(), array(
    array(
        'ref' => 'SOAP-ENC:arrayType',
        'wsdl:arrayType' => 'tns:allMenuReturn[]'
    )
        ), 'tns:allMenuReturn');

$server->wsdl->addComplexType('allMenuReturn', 'complexType', 'struct', 'all', '', array(
    'funcName' => array(
        'name' => 'funcName',
        'type' => 'xsd:string'
    ),
    'funcNamePY' => array(
        'name' => 'funcNamePY',
        'type' => 'xsd:string'
    ),
    'funcNameZM' => array(
        'name' => 'funcNameZM',
        'type' => 'xsd:string'
    ),
    'funcID' => array(
        'name' => 'funcID',
        'type' => 'xsd:string'
    ),
    'menuLink' => array(
        'name' => 'menuLink',
        'type' => 'xsd:string'
    ),
    'menuID' => array(
        'name' => 'menuID',
        'type' => 'xsd:string'
    ),
    'isParent' => array(
        'name' => 'isParent',
        'type' => 'xsd:string'
    ),
    'imageLink' => array(
        'name' => 'imageLink',
        'type' => 'xsd:string'
    )
));
$server->register('GetAllMenu', array(
    'userPriv' => 'xsd:string',
    'userID' => 'xsd:string',
    'langID' => 'xsd:string'
        ), array(
    'return' => 'tns:allMenuRerurnArray'
        ), 'urn:EofficeService', 'urn:EofficeService#GetAllMenu', 'rpc', 'encoded', 'Get All Menu');

/*
 * 是否有子菜单
 */

function IsHaveChildrenMenu($userID, $menuID, $funcIDStr) {
    global $connection;
    $userID = SecurityFilter($userID);
    $menuID = SecurityFilter($menuID);
    $funcIDStr = SecurityFilter($funcIDStr);
    $menuLength = strlen($menuID);

    $query = "SELECT COUNT(*) AS CNT FROM user_menu
			   WHERE LEFT(MENU_ID," . $menuLength . ")='" . $menuID . "'
			   AND LENGTH(MENU_ID)=" . (strlen($menuID) + 2) . "
			   AND ((FUNC_ID IN ($funcIDStr) AND FUNC_ISSYS=1)
				OR FUNC_ISSYS=0)
				AND USER_ID = '" . $userID . "'
				AND FUNC_ISSHOW = 1";
    $result = exequery($connection, $query);
    if ($row = mysql_fetch_array($result)) {
        if ($row['CNT'] > 0) {
            return true;
        } else {
            return false;
        }
    }
}

function GetAllMenu($userPriv, $userID, $langID) {

    global $connection;

    //获取角色权限
    $funcIDStr = GetUserFuncIDStr($userID);
    $funcIDStr = $funcIDStr == "" ? 0 : $funcIDStr;

    if (!file_exists(UTH_TMP_PATH."auth/verify_client.inc")) {
        $arr = getFuncNoModID();
    } else {
        $arr = json_decode(file_get_contents(UTH_TMP_PATH."auth/verify_client.inc"), true);
        $time = time();
        if (abs($time - $arr[1]['time']) > 86399) {
            //更新文件
            $arr = getFuncNoModID();
        }
    }

//更新文件内容


    $query = "SELECT
				a.FUNC_NAME AS FUNC_NAME_SYS,
				a.FUNC_NAME_PY AS FUNC_NAME_PY_SYS,
				a.FUNC_NAME_ZM AS FUNC_NAME_ZM_SYS,
				b.FUNC_ID,
				b.FUNC_NAME AS FUNC_NAME_USER,
				b.FUNC_NAME_PY AS FUNC_NAME_PY_USER,
				b.FUNC_NAME_ZM AS FUNC_NAME_ZM_USER,
				b.FUNC_CODE,
				b.FUNC_ISSYS,
				b.MENU_ID,
				c.FUNC_IMG
				FROM menu_lang AS a
				RIGHT JOIN user_menu AS b
				ON a.FUNC_ID = b.FUNC_ID
				LEFT JOIN sys_function AS c
				ON a.FUNC_ID = c.FUNC_ID
				WHERE ((b.FUNC_ID IN (".SecurityFilter($funcIDStr).") AND b.FUNC_ISSYS=1 AND a.LANG_ID = " . SecurityFilter($langID) . ")
				OR b.FUNC_ISSYS=0)
				AND b.USER_ID = '" . SecurityFilter($userID) . "'
				AND b.FUNC_ISSHOW = 1 ORDER BY b.ORDER_ID ASC";

    $result = exequery($connection, $query);
    $returnArray = array();
    while ($row = mysql_fetch_array($result)) {

        if ($row["FUNC_ISSYS"] == 1) {
            $funcName = $row['FUNC_NAME_SYS'];
            $funcNamePY = $row['FUNC_NAME_PY_SYS'];
            $funcNameZM = $row['FUNC_NAME_ZM_SYS'];
        } else {
            $funcName = $row['FUNC_NAME_USER'];
            $funcNamePY = $row['FUNC_NAME_PY_USER'];
            $funcNameZM = $row['FUNC_NAME_ZM_USER'];
        }
        $funcID = $row['FUNC_ID'];
        $menuID = $row['MENU_ID'];
        $menuIDNew = substr($menuID, 0, 2);
        if (in_array($funcID, $arr[0])) {
            continue;
        } else if (in_array($menuIDNew, $arr[2])) {
            continue;
        }


        $funcCode = $row['FUNC_CODE'];
        $funcImg = $row['FUNC_IMG'];

        $menuIDLength = strlen($menuID);

        if ($funcCode == "" || strstr($funcCode, "@") !== false) {
            $isParent = "true";
        } else {
            $isParent = "false";
        }
        if ($isParent == "true" && !IsHaveChildrenMenu($userID, $menuID, $funcIDStr)) {
            continue;
        }
        if ($funcImg == "") {
            $imgSrc = '/images/8/icons/16/' . $funcID . '.png';
        } else {
            $imgSrc = '/attachment/index/16/' . $funcImg;
        }

        $imgSrc = file_exists(ROOT_PATH . $imgSrc) ? $imgSrc : '/images/8/icons/16/default.png';

        $tempArray["isParent"] = $isParent;
        $tempArray["funcName"] = $funcName;
        $tempArray["funcNamePY"] = $funcNamePY;
        $tempArray["funcNameZM"] = $funcNameZM;
        $tempArray["funcID"] = $funcID;
        $tempArray["imageLink"] = $imgSrc;
        $tempArray["menuID"] = $menuID;
        $tempArray["menuLink"] = GetMenuLink($funcCode, $funcName);

        array_push($returnArray, $tempArray);
    }

    return $returnArray;
}

/* * ************************************************************
 * 根据用户获取菜单
 * *********************************************************** */
$server->register('GetMenuByUserID', array(
    'userID' => 'xsd:string'
        ), array(
    'return' => 'xsd:string'
        ), 'urn:EofficeService', 'urn:EofficeService#GetMenuByUserID', 'rpc', 'encoded', 'GetMenuByUserID');

function GetMenuByUserID($userID) {
    global $connection;
    $query = "SELECT b.FUNC_ID_STR FROM user as a JOIN user_priv as b ON a.USER_PRIV=b.USER_PRIV WHERE a.USER_ID='" . SecurityFilter($userID) . "'";
    $result = exequery($connection, $query);
    if ($row = mysql_fetch_array($result)) {

        return $row["FUNC_ID_STR"];
    }
}

/* * ************************************************************
 * 用户
 * *********************************************************** */
$server->wsdl->addComplexType('userReturnArray', 'complexType', 'array', '', 'SOAP-ENC:Array', array(), array(
    array(
        'ref' => 'SOAP-ENC:arrayType',
        'wsdl:arrayType' => 'tns:userReturn[]'
    )
        ), 'tns:userReturn');

$server->wsdl->addComplexType('userReturn', 'complexType', 'struct', 'all', '', array(
    'deptID' => array(
        'name' => 'deptID',
        'type' => 'xsd:string'
    ),
    'userPriv' => array(
        'name' => 'userPriv',
        'type' => 'xsd:string'
    ),
    'userID' => array(
        'name' => 'userID',
        'type' => 'xsd:string'
    ),
    'userName' => array(
        'name' => 'userName',
        'type' => 'xsd:string'
    ),
    'avatarType' => array(
        'name' => 'avatarType',
        'type' => 'xsd:string'
    ),
    'department' => array(
        'name' => 'department',
        'type' => 'xsd:string'
    ),
    'userPrivName' => array(
        'name' => 'userPrivName',
        'type' => 'xsd:string'
    ),
    'email' => array(
        'name' => 'email',
        'type' => 'xsd:string'
    ),
    'phoneNumber' => array(
        'name' => 'phoneNumber',
        'type' => 'xsd:string'
    ),
    'birthday' => array(
        'name' => 'birthday',
        'type' => 'xsd:string'
    ),
    'userNamePY' => array(
        'name' => 'userNamePY',
        'type' => 'xsd:string'
    ),
    'userNameZM' => array(
        'name' => 'userNameZM',
        'type' => 'xsd:string'
    )
));
$server->register('GetUser', array(), array(
    'return' => 'tns:userReturnArray'
        ), 'urn:EofficeService', 'urn:EofficeService#GetUser', 'rpc', 'encoded', 'Get User');

function GetUser() {
    global $connection;
    $query = "SELECT a.*,b.DEPT_NAME,c.PRIV_NAME
				FROM user as a
				JOIN department as b
				ON a.DEPT_ID = b.DEPT_ID
				JOIN user_priv as c
				ON a.USER_PRIV = c.USER_PRIV
				WHERE a.DEPT_ID!=0
				ORDER BY a.LISTNUMBER,a.USER_NAME";
    $result = exequery($connection, $query);
    $returnArray = array();
    while ($row = mysql_fetch_array($result)) {
        $tempArray["deptID"] = $row["DEPT_ID"];
        $tempArray["userID"] = $row["USER_ID"];
        $tempArray["userName"] = $row["USER_NAME"];
        $tempArray["userPriv"] = $row["USER_PRIV"];
        $tempArray["avatarType"] = $row["AVATAR_TYPE"];
        $tempArray["department"] = $row["DEPT_NAME"];
        $tempArray["userPrivName"] = $row["PRIV_NAME"];
        $tempArray["email"] = $row["EMAIL"];
        $tempArray["phoneNumber"] = $row["MOBIL_NO"];
        $tempArray["birthday"] = $row["BIRTHDAY"];
        $tempArray["userNamePY"] = $row["USER_NAME_PY"];
        $tempArray["userNameZM"] = $row["USER_NAME_ZM"];

        array_push($returnArray, $tempArray);
    }
    return $returnArray;
}

/* * ************************************************************
 * 部门
 * *********************************************************** */
$server->wsdl->addComplexType('deptReturnArray', 'complexType', 'array', '', 'SOAP-ENC:Array', array(), array(
    array(
        'ref' => 'SOAP-ENC:arrayType',
        'wsdl:arrayType' => 'tns:deptReturn[]'
    )
        ), 'tns:deptReturn');

$server->wsdl->addComplexType('deptReturn', 'complexType', 'struct', 'all', '', array(
    'deptID' => array(
        'name' => 'deptID',
        'type' => 'xsd:string'
    ),
    'deptName' => array(
        'name' => 'deptName',
        'type' => 'xsd:string'
    ),
    'deptParent' => array(
        'name' => 'deptParent',
        'type' => 'xsd:string'
    )
));
$server->register('GetDept', array(), array(
    'return' => 'tns:deptReturnArray'
        ), 'urn:EofficeService', 'urn:EofficeService#GetDept', 'rpc', 'encoded', 'Get Dept');

function GetDept() {
    global $connection;
    $query = "SELECT DEPT_ID,DEPT_NAME,DEPT_PARENT FROM department ORDER BY DEPT_NO ASC";
    $result = exequery($connection, $query);
    $returnArray = array();
    while ($row = mysql_fetch_array($result)) {
        $tempArray["deptID"] = $row["DEPT_ID"];
        $tempArray["deptName"] = $row["DEPT_NAME"];
        $tempArray["deptParent"] = $row["DEPT_PARENT"];
        array_push($returnArray, $tempArray);
    }
    return $returnArray;
}

/* * ************************************************************
 * 角色
 * *********************************************************** */
$server->wsdl->addComplexType('privReturnArray', 'complexType', 'array', '', 'SOAP-ENC:Array', array(), array(
    array(
        'ref' => 'SOAP-ENC:arrayType',
        'wsdl:arrayType' => 'tns:privReturn[]'
    )
        ), 'tns:privReturn');

$server->wsdl->addComplexType('privReturn', 'complexType', 'struct', 'all', '', array(
    'privID' => array(
        'name' => 'privID',
        'type' => 'xsd:string'
    ),
    'privName' => array(
        'name' => 'privName',
        'type' => 'xsd:string'
    )
));
$server->register('GetPriv', array(), array(
    'return' => 'tns:privReturnArray'
        ), 'urn:EofficeService', 'urn:EofficeService#GetPriv', 'rpc', 'encoded', 'Get Priv');

function GetPriv() {
    global $connection;
    $query = "SELECT USER_PRIV,PRIV_NAME FROM user_priv ORDER BY PRIV_NO";
    $result = exequery($connection, $query);
    $returnArray = array();
    while ($row = mysql_fetch_array($result)) {
        $tempArray["privID"] = $row["USER_PRIV"];
        $tempArray["privName"] = $row["PRIV_NAME"];
        array_push($returnArray, $tempArray);
    }
    return $returnArray;
}

/* * ************************************************************
 * 发送消息
 * *********************************************************** */
$server->register('SendMessage', array(
    'fromUserID' => 'xsd:string',
    "toUserID" => "xsd:string",
    "content" => "xsd:string",
    "attachmentID" => "xsd:string",
    "attachmentName" => "xsd:string"
        ), array(
    'return' => 'xsd:string'
        ), 'urn:EofficeService', 'urn:EofficeService#SendMessage', 'rpc', 'encoded', 'SendMessage');

function SendMessage($fromUserID, $toUserID, $content, $attachmentID, $attachmentName) {
    global $connection;
    $query = "INSERT INTO sms
			(FROM_ID,TO_ID,SMS_TYPE,CONTENT,SEND_TIME,REMIND_FLAG,ATTACHMENT_ID,ATTACHMENT_NAME)
			VALUES
			('" . SecurityFilter($fromUserID) . "','" . SecurityFilter($toUserID) . "',0,'" . SecurityFilter($content) . "',NOW(),1,'" . SecurityFilter($attachmentID) . "','" . SecurityFilter($attachmentName) . "')";
    return exequery($connection, $query);
}

/* * ************************************************************
 * 获取消息
 * *********************************************************** */
$server->wsdl->addComplexType('messageReturnArray', 'complexType', 'array', '', 'SOAP-ENC:Array', array(), array(
    array(
        'ref' => 'SOAP-ENC:arrayType',
        'wsdl:arrayType' => 'tns:messageReturn[]'
    )
        ), 'tns:messageReturn');

$server->wsdl->addComplexType('messageReturn', 'complexType', 'struct', 'all', '', array(
    'fromUserName' => array(
        'name' => 'fromUserName',
        'type' => 'xsd:string'
    ),
    'content' => array(
        'name' => 'content',
        'type' => 'xsd:string'
    ),
    'sendTime' => array(
        'name' => 'sendTime',
        'type' => 'xsd:string'
    ),
    'fromUserAvatar' => array(
        'name' => 'fromUserAvatar',
        'type' => 'xsd:string'
    ),
    'fromUserID' => array(
        'name' => 'fromUserID',
        'type' => 'xsd:string'
    ),
    'smsID' => array(
        'name' => 'smsID',
        'type' => 'xsd:string'
    ),
    'smsType' => array(
        'name' => 'smsType',
        'type' => 'xsd:string'
    ),
    'attachmentID' => array(
        'name' => 'attachmentID',
        'type' => 'xsd:string'
    ),
    'attachmentName' => array(
        'name' => 'attachmentName',
        'type' => 'xsd:string'
    ),
    'typeText' => array(
        'name' => 'typeText',
        'type' => 'xsd:string'
    ),
    'typeUrl' => array(
        'name' => 'typeUrl',
        'type' => 'xsd:string'
    ),
    'smsTypeName' => array(
        'name' => 'smsTypeName',
        'type' => 'xsd:string'
    )
));
$server->register('GetMessage', array(
    'userID' => 'xsd:string',
    "isOnlyNew" => "xsd:boolean"
        ), array(
    'return' => 'tns:messageReturnArray'
        ), 'urn:EofficeService', 'urn:EofficeService#GetMessage', 'rpc', 'encoded', 'GetMessage');

function GetMessage($userID, $isOnlyNew) {
    global $connection;

    $CUR_TIME = date("Y-m-d H:i:s", time());
    $query = "SELECT * FROM sms
					WHERE TO_ID='" . SecurityFilter($userID) . "'
					AND receive_del = 0
					AND send_del  !=1
					AND SEND_TIME<='$CUR_TIME'";

    $limit = " LIMIT 0,30";
    if ($isOnlyNew) {

        $query.= " AND REMIND_FLAG=1";
        $limit = "";
    }
    $query.= " ORDER BY SEND_TIME DESC " . $limit;

    $result = exequery($connection, $query);
    $returnArray = array();
    while ($row = mysql_fetch_array($result)) {
        $tempArray["smsID"] = $row["SMS_ID"];
        $tempArray["smsType"] = $row["SMS_TYPE"];
        $tempArray["attachmentID"] = $row["ATTACHMENT_ID"];
        $tempArray["attachmentName"] = $row["ATTACHMENT_NAME"];
        $tempArray["fromUserID"] = $row["FROM_ID"];
        $tempArray["fromUserName"] = getUserNameNew($row["FROM_ID"]);
        $tempArray["fromUserAvatar"] = getUserAvatarType($row["FROM_ID"]);
        $tempArray["content"] = $row["CONTENT"];
        $tempArray["sendTime"] = $row["SEND_TIME"];

        $typeArray = getSmstypeUrl($row["SMS_TYPE"], $row["CONTENT"], $row["TABLE_ID"], $row["TABLE_VAR"], $row["TABLE_NAME"], $userID, $row["SMS_ID"]);
        $tempArray["typeText"] = $typeArray['TEXT'];
        $tempArray["typeUrl"] = $typeArray['URL'];

        array_push($returnArray, $tempArray);
    }
    return $returnArray;
}

/* * ************************************************************
 * 标记消息为已读
 * *********************************************************** */
$server->register('SetMessageRead', array(
    'userID' => 'xsd:string',
    'messageIDStr' => 'xsd:string',
    'fromUserID' => 'xsd:string'
        ), array(), 'urn:EofficeService', 'urn:EofficeService#SetMessageRead', 'rpc', 'encoded', 'SetMessageRead');

function SetMessageRead($userID, $messageIDStr, $fromUserID) {
    global $connection;

    $CUR_TIME = date("Y-m-d H:i:s", time());

    $query = "UPDATE `sms`
				SET `REMIND_FLAG` = 0 WHERE SEND_TIME<='$CUR_TIME' AND TO_ID='" . SecurityFilter($userID) . "'";

    if ($fromUserID != "") {
        $query.= " AND FROM_ID='" . SecurityFilter($fromUserID) . "'";
    }

    if ($messageIDStr != "") {
        $query.= " AND SMS_ID IN (".SecurityFilter($messageIDStr).")";
    }
    exequery($connection, $query);
}

/* * ************************************************************
 * 创建文档
 * *********************************************************** */
$server->register('CreateFile', array(
    'subject' => 'xsd:string',
    'attachmentIDStr' => 'xsd:string',
    'attachmentNameStr' => 'xsd:string',
    'userID' => 'xsd:string'
        ), array(
    'return' => 'xsd:string'
        ), 'urn:EofficeService', 'urn:EofficeService#CreateFile', 'rpc', 'encoded', 'CreateFile');

function CreateFile($subject, $attachmentIDStr, $attachmentNameStr, $userID) {


    global $connection;

    //
    $query1 = "SELECT * from file_set where USER_ID='".SecurityFilter($userID)."'";
    $cursor = exequery($connection, $query1);
    if ($ROW = mysql_fetch_array($cursor)) {
        $FILE_SET = $ROW['FILE_SET'];
    } else {
        $FILE_SET = 1;
    }

    $currentTime = date("Y-m-d H:i:s", time());
    $attachmentIDObj = explode(",", $attachmentIDStr);
    $attachmentNameObj = explode("*", $attachmentNameStr);
    $count = count($attachmentIDObj) - 1; // 最后一个是空 不考虑

    if ($FILE_SET == 2) {
        // $attachmentIDStrNew = trim(",",$attachmentIDStr);
        for ($i = 0; $i < $count; $i++) {
            $subject_temp = path_info($attachmentNameObj[$i]);
            $query = "INSERT INTO `file_content`
				(
				`CONTENT_TYPE`,
				`SORT_ID`,
				`FROM_ID`,
				`SUBJECT`,
				`SEND_TIME`,
				`USER_ID`,
				`ATTACHMENT_ID`,
				`ATTACHMENT_NAME`,
				`FILE_TYPE`)
				VALUES
				(
				1,
				-1,
				0,
				'" . SecurityFilter($subject_temp['filename']) . "',
				'" . $currentTime . "',
				'" . SecurityFilter($userID) . "',
				'" . SecurityFilter($attachmentIDObj[$i]) . ',' . "',
				'" . SecurityFilter($attachmentNameObj[$i]) . '*' . "',
				1);";

            exequery($connection, $query);
        }
    } else {
        // 生成一篇文档
        // 取第一个文件名
        $subject_temp = path_info($attachmentNameObj[$count - 1]);

        $query = "INSERT INTO `file_content`
				(
				`CONTENT_TYPE`,
				`SORT_ID`,
				`FROM_ID`,
				`SUBJECT`,
				`SEND_TIME`,
				`USER_ID`,
				`ATTACHMENT_ID`,
				`ATTACHMENT_NAME`,
				`FILE_TYPE`)
				VALUES
				(
				1,
				-1,
				0,
				'" . SecurityFilter($subject_temp['filename']) . "',
				'" . $currentTime . "',
				'" . SecurityFilter($userID) . "',
				'" . SecurityFilter($attachmentIDStr) . "',
				'" . SecurityFilter($attachmentNameStr) . "',
				1);";

        exequery($connection, $query);
    }

    return mysql_insert_id();
}

function path_info($filepath) {
    $path_parts = array();
    $path_parts ['dirname'] = rtrim(substr($filepath, 0, strrpos($filepath, '/')), "/") . "/";
    $path_parts ['basename'] = ltrim(substr($filepath, strrpos($filepath, '/')), "/");
    $path_parts ['extension'] = substr(strrchr($filepath, '.'), 1);
    $path_parts ['filename'] = ltrim(substr($path_parts ['basename'], 0, strrpos($path_parts ['basename'], '.')), "/");
    return $path_parts;
}

/* * ************************************************************
 * 获取最新版本
 * *********************************************************** */
$server->wsdl->addComplexType('newVersionReturnArray', 'complexType', 'struct', 'all', '', array(
    'version' => array(
        'name' => 'version',
        'type' => 'xsd:string'
    ),
    'readme' => array(
        'name' => 'readme',
        'type' => 'tns:newVersionReadmeArray'
    )
));

$server->wsdl->addComplexType('newVersionReadmeArray', 'complexType', 'array', '', 'SOAP-ENC:Array', array(), array(
    array(
        'ref' => 'SOAP-ENC:arrayType',
        'wsdl:arrayType' => 'tns:newVersionReadme[]'
    )
        ), 'tns:newVersionReadme');

$server->wsdl->addComplexType('newVersionReadme', 'complexType', 'struct', 'all', '', array(
    'subject' => array(
        'name' => 'subject',
        'type' => 'xsd:string'
    ),
    'describe' => array(
        'name' => 'describe',
        'type' => 'xsd:string'
    ),
    'image' => array(
        'name' => 'image',
        'type' => 'xsd:string'
    )
));

$server->register('GetNewVersion', array(), array(
    'return' => 'tns:newVersionReturnArray'
        ), 'urn:EofficeService', 'urn:EofficeService#GetNewVersion', 'rpc', 'encoded', 'GetNewVersion');

function GetNewVersion() {
    global $connection;

    //获取新版本号
    $getVersionQuery = "SELECT * FROM `client_version` ORDER BY DATE_TIME DESC LIMIT 0,1";
    $getVersionResult = exequery($connection, $getVersionQuery);
    if ($getVersionRow = mysql_fetch_array($getVersionResult)) {
        $return["version"] = $getVersionRow["VERSION"];

        $getReadmeQuery = "SELECT * FROM `client_version_readme` WHERE CLIENT_VERSION_ID=" . $getVersionRow['CLIENT_VERSION_ID'];
        $getReadmeResult = exequery($connection, $getReadmeQuery);

        while ($getReadmeRow = mysql_fetch_array($getReadmeResult)) {
            $temp["subject"] = $getReadmeRow["README_SUBJECT"];
            $temp["describe"] = $getReadmeRow["README_DESCRIBE"];
            $temp["image"] = $getReadmeRow["README_IMAGE"];
            if (!is_array($return["readme"])) {
                $return["readme"] = array();
            }
            array_push($return["readme"], $temp);
        }
    }
    return $return;
}

/*
 * 签到、签退
 */
$server->register('Attend', array(
    'userID' => 'xsd:string',
    'deptID' => 'xsd:string',
    'privID' => 'xsd:string',
    'checkType' => 'xsd:string'
        ), array(
    'return' => 'xsd:string'
        ), 'urn:EofficeService', 'urn:EofficeService#Attend', 'rpc', 'encoded', 'Attend');

function Attend($userID, $deptID, $privID, $checkType) {
    $userInfor["UserId"] = $userID;
    $userInfor["DepyId"] = $deptID;
    $userInfor["PrivId"] = $privID;
    $userInfor["LoginCheck"] = $checkType;

    $attend = new attend;
    $result = $attend->GetLoginInOut($userInfor);
    if ($checkType == "in") {
        return $result["LoginInLateTime"];
    } else {
        return $result["LoginOutEarlyTime"];
    }
}

/*
 * 判断是否已签到
 */
$server->register('CheckIsSignIn', array(
    'userID' => 'xsd:string'
        ), array(
    'return' => 'xsd:string'
        ), 'urn:EofficeService', 'urn:EofficeService#CheckIsSignIn', 'rpc', 'encoded', 'CheckIsSignIn');

function CheckIsSignIn($userID) {
    $attend = new attend;
    $dutyId = $attend->getUserDutyType($userID);
    $dutyArray = $attend->getDutyData($dutyId);
    return $attend->isSignIn($dutyArray, $dutyId, $userID);
}

$server->service($HTTP_RAW_POST_DATA);
?>