<?php
/**
 * @copyright (C) 2000 - 2010 Weaver Co.Ltd
 * @package   eoffice7.0
 * @name      webroot/webservice/news/news.wsdl.php
 * @version   1.0 
 * @author    liuqingyu
 */

include_once ("nusoap/lib/nusoap.php");
include_once ("api/news.class.php");
include_once ("api/user.class.php");
include_once ("inc/conn.php");
include_once ("inc/function_picture.php");
include_once ("inc/utility_all.php");
include_once ("inc/checkcurrentsession.php");
/*---------实例化soap_server对象并初始化---------*/
$server = new soap_server ();
$server->soap_defencoding = "UTF-8";
$server->decode_utf8 = false;
$server->configureWSDL ( 'NewsServicewsdl', 'urn:NewsServicewsdl' );
$server->wsdl->schemaTargetNamespace = 'urn:NewsServicewsdl';
/*---------注册获取新闻信息函数getNewsInfo---------*/
//=========定义返回值类型 begin
$server->wsdl->addComplexType (
		'newsinfo_return_array', 
		'complexType',
		'array',
		'',
		'SOAP-ENC:Array',
		array (),
		array (
			array ('ref' => 'SOAP-ENC:arrayType','wsdl:arrayType' => 'tns:newsinfo_return[]')
			),
	   'tns:newsinfo_return'
	);
$server->wsdl->addComplexType (
		'newsinfo_return',
		'complexType',
		'struct',
		'all',
		'',
		array(
			  'NEWS_ID' => array ('name' => 'NEWS_ID', 'type' => 'xsd:string'),
			  'SUBJECT' => array ('name' => 'SUBJECT', 'type' => 'xsd:string'),
			  'PROVIDER' => array ('name' => 'PROVIDER', 'type' => 'xsd:string'),
			  'PROVIDER_NAME' => array ('name' => 'PROVIDER_NAME', 'type' => 'xsd:string'),
			  'USER_PRIV' => array ('name' => 'USER_PRIV', 'type' => 'xsd:string'),
			  'NEWS_TIME' => array ('name' => 'NEWS_TIME', 'type' => 'xsd:string' ),
			  'CLICK_COUNT' => array ('name' => 'CLICK_COUNT', 'type' => 'xsd:string'),
			  'CONTENT' => array ('name' => 'CONTENT', 'type' => 'xsd:string' ),
			  'ATTACHMENT_ID' => array ('name' => 'ATTACHMENT_ID', 'type' => 'xsd:string'),
			  'ATTACHMENT_NAME' => array ('name' => 'ATTACHMENT_NAME', 'type' => 'xsd:string'),
			  'PICTURE_DIR' => array ('name' => 'PICTURE_DIR', 'type' => 'xsd:string')
			  )
	);
//========= end
$server->register (
		'getNewsInfo',
		array (
			   'a' => 'xsd:string',
			   'b' => 'xsd:string',
			   'c' => 'xsd:string'
			   ),
		array ('return' => 'tns:newsinfo_return_array'),
		'urn:NewsServicewsdl',
		'urn:NewsServicewsdl#getNewsInfo',
		'rpc',
		'encoded',
		'Get E-office news count'
	);
/*---------注册获取新闻数目函数getNewsAmount---------*/
$server->register(
		'getNewsAmount',
		array(),
		array('return' => 'xsd:string'),
		'urn:NewsServicewsdl',
		'urn:NewsServicewsdl#getNewsAmount',
		'rpc',
		'encoded',
		'Get E-office news count'
	);
/*
@function:  获取新闻信息
@parameter: $a->          string  :每页显示的条数
			$b->          string  :当前页从第几条开始显示
			$c->          string  :需要获取新闻的ID号
@return:    $news->       Array   :新闻的详细信息
*/
function getNewsInfo($a, $b, $c) {
	CheckCurrentSession();
	$newsApi = new news ();
	$news = $newsApi->getNewsInfo ( $a, $b, $c );
	return $news;
}

/*
@function:  获取新闻总数量
@parameter: 无
@return:    $counts->       string   :新闻的数量
*/
function getNewsAmount(){
	CheckCurrentSession();
	$newsapi = new news();
	$counts  = $newsapi->getNewsAmount();
    return $counts;	
	}

//返回数据
$server->service ( $HTTP_RAW_POST_DATA );

?>