<?php

/**
* @copyright (C) 2000 - 2010 Weaver Co.Ltd
* @package   eoffice7.0
* @name      webroot/webservice/notify/notify.wsdl.php
* @version   1.0 
* @author    liuqingyu
*/
include_once("nusoap/lib/nusoap.php");
include_once("api/notify.class.php");
include_once("api/user.class.php");
include_once("inc/conn.php");
include_once("wap/function.php");
//session处理
include_once("inc/checkcurrentsession.php");
//实例化soap_server对象并初始化
$server                   = new soap_server();
$server->soap_defencoding = "UTF-8";
$server->decode_utf8      = false;
$server->configureWSDL('notifyServicewsdl','urn:notifyServicewsdl');
$server->wsdl->schemaTargetNamespace = 'urn:notifyServicewsdl';

/*---------注册获取公告信息函数getNotifyInfo---------*/
//=========定义返回值类型 begin
$server->wsdl->addComplexType (
		'notifyinfo_return_array',
		'complexType',
		'array',
		'',
		'SOAP-ENC:Array',
		array (),
		array (
			   array ('ref' => 'SOAP-ENC:arrayType', 'wsdl:arrayType' => 'tns:notifyinfo_return[]')
			   ),
		'tns:notifyinfo_return'
	);
$server->wsdl->addComplexType (
		'notifyinfo_return',
		'complexType',
		'struct',
		'all',
		'',
		array(
			  'NOTIFY_ID' => array ('name' => 'NOTIFY_ID', 'type' => 'xsd:string'),
			  'FROM_ID' => array ('name' => 'FROM_ID', 'type' => 'xsd:string'),
			  'FROM_NAME' => array ('name' => 'FROM_NAME', 'type' => 'xsd:string'),
			  'SUBJECT' => array ('name' => 'SUBJECT', 'type' => 'xsd:string'),
			  'CONTENT' => array ('name' => 'CONTENT', 'type' => 'xsd:string'),
			  'SEND_TIME' => array ('name' => 'SEND_TIME', 'type' => 'xsd:string' ),
			  'READERS' => array ('name' => 'READERS', 'type' => 'xsd:string'),
			  'READ_FLAG' => array ('name' => 'READ_FLAG', 'type' => 'xsd:string' ),
			  'ATTACHMENT_ID' => array ('name' => 'ATTACHMENT_ID', 'type' => 'xsd:string'),
			  'ATTACHMENT_NAME' => array ('name' => 'ATTACHMENT_NAME', 'type' => 'xsd:string'),
  			  'ATTACHMENT_DIR' => array ('name' => 'ATTACHMENT_DIR', 'type' => 'xsd:string')
			  )
	);
//========= end
$server->register(
		'getNotifyInfo',
		array(
			  'a' => 'xsd:string',
			  'b'=> 'xsd:string',
			  'c'=> 'xsd:string'
			  ), 
		array('return' => 'tns:notifyinfo_return_array'),
		'urn:notifyServicewsdl',
		'urn:notifyServicewsdl#getNotifyInfo',
		'rpc',
		'encoded',
		'Get E-office notify count'
	);
/*
@function:  获取公告信息
@parameter: $a->               string  :每页显示的条数
			$b->               string  :当前页从第几条开始显示
			$c->               string  :查看或者当前的公告ID
@return:    $notify_message->  Array   :公告的详细信息
*/
function getNotifyInfo($a,$b,$c){
	CheckCurrentSession($sessid);
	$notifyApi         = new notify();
	$notify_message    = $notifyApi->getNotifyInfo($a,$b,$c);
	return $notify_message;
}

/*---------注册获取公告数量函数getNotifyAmount---------*/
$server->register(
		'getNotifyAmount',
		array(),
		array('return'=>'xsd:string'),
		'urn:notifyServicewsdl',
		'urn:notifyServicewsdl#getNotifyAmount',
		'rpc',
		'encoded',
		'Get E-office notify count'
	);
/*
@function:  获取公告总数
@parameter: 无
@return:    $notify_counts->  string  :公告总数
*/
function getNotifyAmount(){
	CheckCurrentSession($sessid);
	$notifyApi 		  = new notify();
	$notify_counts    = $notifyApi->getNotifyAmount();
	return $notify_counts;
	}

/*---------注册获取最新公告数量函数getNewNotifyAmount---------*/
$server->register(
		'getNewNotifyAmount',
		array(),
		array('return'=>'xsd:string'),
		'urn:notifyServicewsdl',
		'urn:notifyServicewsdl#getNewNotifyAmount',
		'rpc',
		'encoded',
		'Get E-office notify count'
	);
/*
@function:  获取最新未读公告数
@parameter: 无
@return:    $notify_new_counts->  string  :公告数
*/
function getNewNotifyAmount(){
	CheckCurrentSession($sessid);
	$notifyApi 		       = new notify();
	$notify_new_counts     = $notifyApi->getNewNotifyAmount();
	return $notify_new_counts;
	}

/*---------注册更新阅读公告的人员函数updateReadStatus---------*/
$server->register(
		'updateReadStatus',
		array('notifyid'=>'xsd:int'),
		array('return'=>'xsd:string'),
		'urn:notifyServicewsdl',
		'urn:notifyServicewsdl#updateReadStatus',
		'rpc',
		'encoded',
		'Get E-office notify count'
	);
/*
@function:  更新阅读公告的人员
@parameter: $notifyid->         int :当前浏览公告的ID号
@return:    无
*/
function updateReadStatus($notifyid){
	CheckCurrentSession($sessid);
	$notifyApi 		        = new notify();
	$notify_update_status   = $notifyApi->updateReadStatus($notifyid);
	return 1;
	
	}

//返回数据

$HTTP_RAW_POST_DATA = isset($HTTP_RAW_POST_DATA) ? $HTTP_RAW_POST_DATA : '';
$server->service($HTTP_RAW_POST_DATA);




?>