<?php
/**
 * 
 */
require_once 'nusoap/lib/nusoap.php';
require_once 'inc/conn.php';
require_once 'inc/checkcurrentsession.php';
require_once 'api/sms.class.php';
include_once 'inc/oa_config.php';

global $ATTACH_PATH;
$attachment_url = str_replace ( ROOT_PATH, ROOT_URL, $ATTACH_PATH );
	
/******************************************
 * 实例化soap_server对象并初始化
 ******************************************/
$server                   = new soap_server();
$server->soap_defencoding = "UTF-8";
$server->decode_utf8      = false;
$server->configureWSDL('SmsServicewsdl','urn:SmsServicewsdl');
$server->wsdl->schemaTargetNamespace = 'urn:SmsServicewsdl';
/******************************************
 * 添加类型
 ******************************************/
$server->wsdl->addComplexType(
	'SmsRow',
	'complexType',
	'struct',
	'all',
	'',
	array(
		'SMS_ID' =>array('name' => 'SMS_ID', 'type'=>'xsd:string'),
		'FROM_ID' =>array('name' => 'FROM_ID', 'type'=>'xsd:string'),
		'TO_ID' =>array('name' => 'TO_ID', 'type'=>'xsd:string'),
		'SMS_TYPE' =>array('name' => 'SMS_TYPE', 'type'=>'xsd:string'),
		'CONTENT' =>array('name' => 'CONTENT', 'type'=>'xsd:string'),
		'SEND_TIME' =>array('name' => 'SEND_TIME', 'type'=>'xsd:string'),
		'REMIND_FLAG' =>array('name' => 'REMIND_FLAG', 'type'=>'xsd:string'),
		'ATTACHMENT_ID' =>array('name' => 'ATTACHMENT_ID', 'type'=>'xsd:string'),
		'ATTACHMENT_NAME' =>array('name' => 'ATTACHMENT_NAME', 'type'=>'xsd:string'),
		'FROM_NAME' =>array('name' => 'FROM_NAME', 'type'=>'xsd:string'),
		'TO_NAME' =>array('name' => 'TO_NAME', 'type'=>'xsd:string')
	)
);
$server->wsdl->addComplexType(
	 	'ArrayOfSmsRow',
	 	'complexType',
	 	'array',
	 	'',
	 	'SOAP-ENC:Array',
		array(),
	 	array(
	 		array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:SmsRow[]')
	 	),
	 	'tns:SmsRow'
);

$server->wsdl->addComplexType(
	'Data',
	'complexType',
	'struct',
	'all',
	'',
	array(
		//'fromid'=>array('name'=>'fromid','type'=>'xsd:string'),
		'toid'=>array('name'=>'toid','type'=>'xsd:string'),
		'smstype'=>array('name'=>'smstype','type'=>'xsd:int'),
		'content'=>array('name'=>'content','type'=>'xsd:string'),
		'sendtime'=>array('name'=>'sendtime','type'=>'xsd:string'),		
		'remindflag'=>array('name'=>'remindflag','type'=>'xsd:string'),		
		'attachid'=>array('name'=>'attachid','type'=>'xsd:string'),		
		'attachname'=>array('name'=>'attachname','type'=>'xsd:string')		
	)
);

$server->wsdl->addComplexType(
	'SmsPreNext',
	'complexType',
	'struct',
	'all',
	'',
	array(
		'smsid'=>array('name'=>'smsid','type' =>'xsd:string'),
		'subject'=>array('name'=>'subject','type'=>'xsd:string')
	)
);
function check_input($value) {
    // 去除斜杠
    if (get_magic_quotes_gpc()) {
        $value = stripslashes($value);
    }
    // 如果不是数字则加引号
    if (!is_numeric($value)) {
        $value = mysql_real_escape_string($value);
    }
    return $value;
}
/******************************************
 * 	Functions
 ******************************************/
/**
 * 身份验证
 * @param string $sessionid
 */	
function authCheck(){
	CheckCurrentSession();
	return new sms();
}	

#####################################
$server->register(
	'cancelNotifySmsRemind',
	array('notifyId' => 'xsd:string'),
	array('return' => 'xsd:string'),
	'urn:SmsServicewsdl',
	'urn:SmsServicewsdl#cancelNotifySmsRemind',
	'rpc','encoded',
	'cancel notify sms remind'
	);
/**
 * 取消公告消息提醒
 * @param int $notifyId id
 * @return 成功 1,失败 0
 */
function cancelNotifySmsRemind($notifyId){
	$sms = authCheck();
	if(empty($notifyId)) return 0;
	$sms->cancelNotifySmsRemind(intval($notifyId));
	return 1;
}
###
$server->register(
	'deleteSms',
	array('ids' => 'xsd:string'),
	array('return' => 'xsd:string'),
	'urn:SmsServicewsdl',
	'urn:SmsServicewsdl#deleteSms',
	'rpc','encoded',
	'delete sms by id string'
	);
/**
 * 删除消息
 * @param string $ids 消息ID: 1,2,3
 * @type string $type 0 receiver or 1 sender
 * @return 成功 1,失败 0
 */		
function deleteSms($ids,$type = 0){
	$sms = authCheck();
	if(empty($ids)) return 0;
	$conn = OpenConnection();
	$delete_field = $type == 0? 'receive_del' : 'send_del';
	$id_array = explode(',', $ids);
	foreach ($id_array as $id){
		if($id == '') continue;
		$query = "UPDATE `sms` SET `$delete_field` = '1' WHERE `sms_id` = $id";
		$result = mysql_query($query,$conn);
		if($result == 0 ) return 0;
	} 
	return 1;
}
###
$server->register(
	'getNewSmsAmount',
	array('userid' => 'xsd:string'),
	array('return' => 'xsd:string'),
	'urn:SmsServicewsdl',
	'urn:SmsServicewsdl#getNewSmsAmount',
	'rpc','encoded',
	'get New Sms Amount'
	);
/**
 * 取得新消息数量
 * @return 消息数量
 */	
function getNewSmsAmount(){
	$sms = authCheck();
	$amount = $sms->getNewSmsAmount();
	return $amount;
}
###
$server->register(
	'getPreNextSms',
	array('smsid' => 'xsd:string','flag'=>'xsd:string'),
	array('return' => 'tns:SmsPreNext'),
	'urn:SmsServicewsdl',
	'urn:SmsServicewsdl#getPreNextSms',
	'rpc','encoded',
	'get Pre or Next Sms by current sms id'
	);
/**
 * 取得上/下一条消息
 * @param int $smsid 消息id
 * @param string $flag next or pre
 * @return 消息内容数组
 */	
function getPreNextSms($smsid,$flag="next"){
	$sms = authCheck();
	$data = $sms->getPreNextSms(intval($smsid),$flag);
	return $data;
}
###
$server->register(
	'getSmsAmount',
	array('keyWord'=>'xsd:string'),
	array('return' => 'SOAP-ENC:string'),
	'urn:SmsServicewsdl',
	'urn:SmsServicewsdl#getSmsAmount',
	'rpc','encoded',
	'get Sms Amount by user id'
	);
/**
 * 取得消息总数量
 * @return 消息数量
 */		

function getSmsAmount($keyWord = ''){
	$sms = authCheck();
	$amount = $sms->getSmsAmount(check_input($keyWord));
	return $amount;
}	
###
$server->register(
	'getSmsInfo',
	array('limit'=>'xsd:int','start'=>'xsd:int','keyWord'=>'xsd:string'),
	array('return' => 'tns:ArrayOfSmsRow'),
	'urn:SmsServicewsdl',
	'urn:SmsServicewsdl#getSmsInfo',
	'rpc','encoded',
	'get sms infomation as list'
	);
/**
 * 取得消息列表
 * @param int $limit 每页数量
 * @param int $start 开始ID
 * @param string $keyWord 搜索关键字
 * @return 消息内容数组
 */
function getSmsInfo($limit=0,$start=0,$keyWord=""){
	global $attachment_url;
	$sms = authCheck();
	
	$data = $sms->getSmsInfo($limit,$start,'', check_input($keyWord));
	$data = $sms->replaceUserStr('FROM_ID','FROM_NAME', $data);
	$data = $sms->replaceUserStr('TO_ID','TO_NAME', $data);
	foreach($data as $index => $val){
		$name_array = explode('*',$val['ATTACHMENT_NAME']);
		$id_array = explode(',',$val['ATTACHMENT_ID']);	
		foreach($id_array as $id_index => $id){
			if($id == '') continue;
			$id_array[$id_index] = $attachment_url.$id.'/'.$name_array[$id_index];
		}
		$data[$index]['ATTACHMENT_ID'] = implode(',',$id_array);
	}
	return $data;
}
###
$server->register(
	'getSmsById',
	array('smsid'=>'xsd:int'),
	array('return' => 'tns:SmsRow'),
	'urn:SmsServicewsdl',
	'urn:SmsServicewsdl#getSmsById',
	'rpc','encoded',
	'get Sms infomation By Id'
	);
/**
 * 取得传入ID的消息内容
 * @param int $smsid 消息ID
 * @return 消息内容数组
 */
function getSmsById($smsid){
	global $attachment_url;
	$sms = authCheck();
	if($smsid == '') return array();
	$data =  $sms->getSmsInfo('','',intval($smsid));
	$data = $sms->replaceUserStr('FROM_ID','FROM_NAME', $data);
	$data = $sms->replaceUserStr('TO_ID','TO_NAME', $data);
	
	foreach($data as $index => $val){
		$name_array = explode('*',$val['ATTACHMENT_NAME']);
		$id_array = explode(',',$val['ATTACHMENT_ID']);	
		foreach($id_array as $id_index => $id){
			if($id == '') continue;
			$id_array[$id_index] = $attachment_url.$id.'/'.$name_array[$id_index];
		}
		$data[$index]['ATTACHMENT_ID'] = implode(',',$id_array);
	}
	return $data[0];
}
###
$server->register(
	'notifySmsRemind',
	array('notifyId' => 'xsd:int'),
	array('return' => 'xsd:string'),
	'urn:SmsServicewsdl',
	'urn:SmsServicewsdl#notifySmsRemind',
	'rpc','encoded',
	'set notify flag'
	);
/**
 * 设置消息提醒
 * @param int $notifyId 消息ID
 * @return 成功返回1
 */	
function notifySmsRemind($notifyId) {
	$sms = authCheck();
	$sms->notifySmsRemind(intval($notifyId));
	return 1;
}
###
$server->register(
	'updateRemind',
	array('smsid' => 'xsd:int'),
	array('return' => 'xsd:string'),
	'urn:SmsServicewsdl',
	'urn:SmsServicewsdl#updateRemind',
	'rpc','encoded',
	'update remind flag'
	);
/**
 * 修改提醒状态
 * @param int $smsid	sms id
 * @return 1 on success
 */
function updateRemind($smsid){
	$sms = authCheck();
	$sms->updateRemind(intval($smsid));
	return 1;
}
###
$server->register(
	'sendSms',
	array('data' => 'tns:Data'),
	array('return' => 'xsd:string'),
	'urn:SmsServicewsdl',
	'urn:SmsServicewsdl#sendSms',
	'rpc','encoded',
	'send sms infomation'
	);
/**
 * 发送消息
 * @param array $data 消息数据array('fromid'=>'','toid'=>'',...)
 * @return inserted id
 */
function sendSms($data){
	$sms = authCheck();
	return $sms->sendSms($data);
}

//返回数据
$server->service($HTTP_RAW_POST_DATA);