<?php
/**
* @copyright (C) 2000 - 2010 Weaver Co.Ltd
* @package   eoffice6.0
* @name      webservice/workflow/workflow.wsdl.php
* @version   1.0 
* @author    sunxiang
*/
include_once("nusoap/lib/nusoap.php");
include_once("api/list.class.php");
include_once("inc/function_page_01.php");
include_once("inc/conn.php");
include_once("inc/checkcurrentsession.php");
//实例化soap_server对象并初始化
$server                   = new soap_server();
$server->soap_defencoding = "UTF-8";
$server->decode_utf8      = false;
$server->configureWSDL('ListServicewsdl','urn:ListServicewsdl');
$server->wsdl->schemaTargetNamespace = 'urn:ListServicewsdl';
//注册一个名字为getList的函数
//定义getList,type=to_do函数返回值的结构体
$server->wsdl->addComplexType(
    'flowInfos',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array(
            'ref' => 'SOAP-ENC:arrayType',
            'wsdl:arrayType' => 'tns:flowInfo[]'
			  )
		),
    'tns:flowInfo'
);
$server->wsdl->addComplexType ( 
	'flowInfo', 
	'complexType', 
	'struct', 
	'all', 
	'',
	array (
		"RUN_ID"          => array ('name' => 'RUN_ID', 'type' => 'xsd:int' ),
		"MAX_PRCS_ID"     => array ('name' => 'MAX_PRCS_ID', 'type' => 'xsd:int' ),
		"RUN_NAME"        => array ('name' => 'RUN_NAME',   'type' => 'xsd:string'),
		"FLOW_ID"         => array ('name' => 'FLOW_ID', 'type' => 'xsd:int' ),
		"ATTACHMENT_ID"   => array ('name' => 'ATTACHMENT_ID', 'type' => 'xsd:string' ),
		"ATTACHMENT_NAME" => array ('name' => 'ATTACHMENT_NAME', 'type' => 'xsd:string' ),
		"CREATE_TIME"     => array ('name' => 'CREATE_TIME', 'type' => 'xsd:string' ),
		"RUN_SEQ"         => array ('name' => 'RUN_SEQ', 'type' => 'xsd:string' ),
		"LINK_DOC"        => array ('name' => 'LINK_DOC', 'type' => 'xsd:string' ),
		"CREATOR"         => array ('name' => 'CREATOR', 'type' => 'xsd:string' ),
		"VIEW_USER"       => array ('name' => 'VIEW_USER', 'type' => 'xsd:string' ),
		"CURRENT_STEP"    => array ('name' => 'CURRENT_STEP', 'type' => 'xsd:int' ),
		"FLOW_NAME"       => array ('name' => 'FLOW_NAME', 'type' => 'xsd:string' ),
		"FORM_ID"         => array ('name' => 'FORM_ID', 'type' => 'xsd:int' ),
		"FLOW_DOC"        => array ('name' => 'FLOW_DOC', 'type' => 'xsd:string' ),
		"FLOW_LINK"       => array ('name' => 'FLOW_LINK', 'type' => 'xsd:int' ),
		"FLOW_TYPE"       => array ('name' => 'FLOW_TYPE', 'type' => 'xsd:string' ),
		"MANAGE_USER"     => array ('name' => 'MANAGE_USER', 'type' => 'xsd:string' ),
		"FLOW_SORT"       => array ('name' => 'FLOW_SORT', 'type' => 'xsd:int' ),
		"FLOW_SEQUENCE"   => array ('name' => 'FLOW_SEQUENCE', 'type' => 'xsd:string' ),
		"FLOW_NOORDER"    => array ('name' => 'FLOW_NOORDER', 'type' => 'xsd:int' ),
		"HANDLE_WAY"      => array ('name' => 'HANDLE_WAY', 'type' => 'xsd:int' ),
		"COUNTERSIGN"     => array ('name' => 'COUNTERSIGN', 'type' => 'xsd:int' ),
		"CAN_EDIT_FLOWNO" => array ('name' => 'CAN_EDIT_FLOWNO', 'type' => 'xsd:int' ),
		)
);
$server->register('getList',array('userId' => 'xsd:string','flowId' => 'xsd:string','start' => 'xsd:string','limit' => 'xsd:string','type' => 'xsd:string'), array('return' => 'tns:flowInfos'),'urn:ListServicewsdl','urn:ListServicewsdl#getList','rpc','encoded','Get E-office getList');

$server->register('unreadToDoCount',array('userId' => 'xsd:string'), array('return' => 'xsd:int'),'urn:ListServicewsdl','urn:ListServicewsdl#unreadToDoCount','rpc','encoded','Get E-office getUnreadToDoCount');

$server->register('toDoCount',array('userId' => 'xsd:string'), array('return' => 'xsd:int'),'urn:ListServicewsdl','urn:ListServicewsdl#toDoCount','rpc','encoded','Get E-office gettoDoCount');

//getList函数实现的功能，通过调用api的实例
function getList($userId,$flowId,$start,$limit,$type)
{
    $userId = SecurityFilter($userId);
    CheckCurrentSession();
    if($flowId)
    {
            $p1 = array("WHERE"=>"frp.USER_ID='$userId' AND (((frp.SAVEFORM_TIME IS NULL AND frp.OP_FLAG=0) OR (frp.PRCS_FLAG='2' AND frp.OP_FLAG=1)) OR( frp.PRCS_FLAG = 1)) AND fr.FLOW_ID = '".$flowId."' ","GROUPBY"=>"frp.RUN_ID","SORTBY"=>"frp.RUN_ID DESC","LIMIT"=>$limit,"START"=>$start);
    }
    else
    {
            $p1 = array("WHERE"=>"frp.USER_ID='$userId' AND (((frp.SAVEFORM_TIME IS NULL AND frp.OP_FLAG=0) OR (frp.PRCS_FLAG='2' AND frp.OP_FLAG=1)) OR( frp.PRCS_FLAG = 1)) AND ft.FLOW_TYPE = 1 ","GROUPBY"=>"frp.RUN_ID","SORTBY"=>"frp.RUN_ID DESC","LIMIT"=>$limit,"START"=>$start);
    }
    $p2       = array("type"=>"$type");
    $listwApi = new listItem($p1,$p2);
    $listData = $listwApi->getList();
    //使用json对返回结果进行加密
    //$listData    = json_encode($listData);
    //返回结果

    return $listData;
}
function unreadToDoCount($userId)
{
    $userId = SecurityFilter($userId);
    CheckCurrentSession();
    $p1 = array("WHERE"=>"frp.USER_ID='$userId' AND frp.PRCS_FLAG='1' AND frp.RUN_ID = fr.RUN_ID AND fr.FLOW_ID = ft.FLOW_ID AND ft.FLOW_TYPE != 2 GROUP BY frp.RUN_ID","LIMIT"=>"all");
    $p2 = array("type"=>"unread_to_do_count");
    $listwApi = new listItem($p1,$p2);
    $listData = $listwApi->getList();
    return $listData;
}
function toDoCount($userId)
{
    $userId = SecurityFilter($userId);
    CheckCurrentSession();
    $p1 = array("WHERE"=>"frp.USER_ID='$userId' AND frp.RUN_ID = fr.RUN_ID  AND fr.FLOW_ID = ft.FLOW_ID AND ( ( (SAVEFORM_TIME IS NULL AND OP_FLAG=0) OR (PRCS_FLAG='2' AND OP_FLAG=1) ) OR PRCS_FLAG='1' ) GROUP BY frp.RUN_ID");
    $p2 = array("type"=>"to_do_count");
    $listwApi = new listItem($p1,$p2);
    $listData = $listwApi->getList();
    return $listData;
}
function getOtherSetInfo($flowid)
{
	CheckCurrentSession();
	$workflowApi = new workflow($flowid);
	$otherInfo   = $workflowApi->getOtherSetInfo();
	//使用json对返回结果进行加密
	$otherInfo   = json_encode($otherInfo);
	//返回结果
	return $otherInfo;
}
//返回数据
$server->service($HTTP_RAW_POST_DATA);
?>