<?php
/**
* @copyright (C) 2000 - 2010 Weaver Co.Ltd
* @package   eoffice6.0
* @name      webservice/workflow/workflow.wsdl.php
* @version   1.0 
* @author    sunxiang
*/

include_once("nusoap/lib/nusoap.php");
include_once("api/fixedworkflow.class.php");
include_once("inc/conn.php");
include_once("general/workflow/flow_expr_run.php");
include_once("general/workflow/flow_agency/function_agent.php");
include_once("inc/checkcurrentsession.php");
//实例化soap_server对象并初始化
$server                   = new soap_server();
$server->soap_defencoding = "UTF-8";
$server->decode_utf8      = false;
$server->configureWSDL('WorkflowServicewsdl','urn:WorkflowServicewsdl');
$server->wsdl->schemaTargetNamespace = 'urn:WorkflowServicewsdl';
//定义getFormData函数返回值的结构体
$server->wsdl->addComplexType(
    'fieldValueArray',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array(
            'ref' => 'SOAP-ENC:arrayType',
            'wsdl:arrayType' => 'tns:fieldValue[]'
			  )
		),
    'tns:fieldValue'
);
$server->wsdl->addComplexType ( 
	'fieldValue', 
	'complexType', 
	'struct', 
	'all', 
	'',
	array (
		"RUN_ID"=>array ('name' => 'RUN_ID', 'type' => 'xsd:string' ),
		"ITEM_ID"=>array ('name' => 'ITEM_ID', 'type' => 'xsd:string' ),
		"ITEM_DATA"=>array ('name' => 'ITEM_DATA', 'type' => 'xsd:string')
		)
);
//注册一个名字为getFormData的函数,获取表单数据
$server->register('getFormData',array('flowid' => 'xsd:string','runid' => 'xsd:string'), array('return' => 'tns:fieldValueArray'),
     'urn:WorkflowServicewsdl','urn:WorkflowServicewsdl#getFormData','rpc','encoded','Get E-office workflow Formdata');
//注册一个名字为getOtherSetInfo的函数,获取流程其它设置的信息
$server->register('getOtherSetInfo',array('flowid' => 'xsd:string'), array('return' => 'xsd:string'), 
     'urn:WorkflowServicewsdl','urn:WorkflowServicewsdl#getOtherSetInfo','rpc','encoded','Get E-office workflow otherinfo');
//定义getFiedAndValue函数返回值的结构体
$server->wsdl->addComplexType(
    'FiedAndValueArray',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array(
            'ref' => 'SOAP-ENC:arrayType',
            'wsdl:arrayType' => 'tns:FiedAndValue[]'
			  )
		),
    'tns:FiedAndValue'
);
$server->wsdl->addComplexType ( 
	'FiedAndValue', 
	'complexType', 
	'struct', 
	'all', 
	'',
	array (
		"name"=>array ('name' => 'name', 'type' => 'xsd:string' ),
		"title"=>array ('name' => 'title', 'type' => 'xsd:string' ),
		"class"=>array ('name' => 'class', 'type' => 'xsd:string'),
		"value"=>array ('name' => 'value', 'type' => 'xsd:string')
		)
);
//注册一个名字为getFiedAndValue的函数,获取流程表单字段值
$server->register('getFiedAndValue',array('flowid' => 'xsd:string','runid' => 'xsd:string'), array('return' => 'tns:FiedAndValueArray'), 'urn:WorkflowServicewsdl','urn:WorkflowServicewsdl#getFiedAndValue','rpc','encoded','Get E-office workflow field and value');
//注册一个名字为saveFormData的函数,保存流程表单数据
$server->register('saveFormData',array('formdata'=>'SOAP-ENC:Array','flowid' => 'xsd:string','runid' => 'xsd:string','docid' => 'xsd:string'), array('return' => 'SOAP-ENC:Array'), 
     'urn:WorkflowServicewsdl','urn:WorkflowServicewsdl#saveFormData','rpc','encoded','Save E-office workflow form value');
//定义getNextNodes函数返回值的结构体
$server->wsdl->addComplexType(
    'nextNodes',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array(
            'ref' => 'SOAP-ENC:arrayType',
            'wsdl:arrayType' => 'tns:nextNode[]'
			  )
		),
    'tns:nextNode'
);
$server->wsdl->addComplexType ( 
	'nextNode', 
	'complexType', 
	'struct', 
	'all', 
	'',
	array (
		"FLOW_PRCS"=>array ('name' => 'FLOW_PRCS', 'type' => 'xsd:int' ),
		"PRCS_NAME"=>array ('name' => 'PRCS_NAME', 'type' => 'xsd:string' ),
		"CHECKED"  =>array ('name' => 'CHECKED',   'type' => 'xsd:int')
		)
);
//注册一个名字为getNextNodes的函数,获取流程的出口节点
$server->register('getNextNodes',array('flowid' => 'xsd:string','runid' => 'xsd:string'), array('return' => 'tns:nextNodes'), 
     'urn:WorkflowServicewsdl','urn:WorkflowServicewsdl#getNextNodes','rpc','encoded','Get E-office workflow next nodes');
//注册一个名字为setHaveRead的函数,设置为已查看
$server->register('setHaveRead',array('flowid' => 'xsd:string','runid' => 'xsd:string','userId' => 'xsd:string',"sid"=>"xsd:string"), array('return' => 'xsd:int'), 
     'urn:WorkflowServicewsdl','urn:WorkflowServicewsdl#setHaveRead','rpc','encoded','Get E-office workflow next nodes');
//注册一个名字为saveForm的函数,经办理提交流程的操作
$server->register('saveForm',array('flowid' => 'xsd:string','runid' => 'xsd:string'), array('return' => 'SOAP-ENC:Array'), 
     'urn:WorkflowServicewsdl','urn:WorkflowServicewsdl#saveForm','rpc','encoded','E-office workflow saveForm');
//注册一个名字为saveForm的函数,经办理提交流程的操作
$server->register('turnNext',array('flowid' => 'xsd:string','runid' => 'xsd:string','userId' => 'xsd:string','flowPrcs' => 'xsd:string','prcsId' => 'xsd:string','prcsUser' => 'xsd:string','prcsOpUser' => 'xsd:string','docId' => 'xsd:string','oP' => 'xsd:string','subFlowRunIds' => 'xsd:string','limitDate' => 'xsd:string','monitor' => 'xsd:string','mbSmsContent' => 'xsd:string','smsContent' => 'xsd:string','emailContent' => 'xsd:string','sid'=>'xsd:string'), array('return' => 'xsd:int'), 
     'urn:WorkflowServicewsdl','urn:WorkflowServicewsdl#turnNext','rpc','encoded','E-office workflow turnNext');
//定义autoGetProcessor函数返回值的结构体
$server->wsdl->addComplexType(
    'Processors',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array(
            'ref' => 'SOAP-ENC:arrayType',
            'wsdl:arrayType' => 'tns:Processor[]'
			  )
		),
    'tns:Processor'
);
$server->wsdl->addComplexType ( 
	'Processor', 
	'complexType', 
	'struct', 
	'all', 
	'',
	array (
		"userid"  =>array ('name' => 'userid',  'type' => 'xsd:string' ),
		"username"=>array ('name' => 'username', 'type' => 'xsd:string' ),
		"deptid"  =>array ('name' => 'deptid',   'type' => 'xsd:int'),
		"opflag"  =>array ('name' => 'opflag',   'type' => 'xsd:int')
		)
);
//注册一个名字为autoGetProcessor的函数,获取流程当前节点的办理人
$server->register('autoGetProcessor',array('flowid' => 'xsd:string','runid' => 'xsd:string','flowPrcs' => 'xsd:string'), array('return' => 'tns:Processors'),     'urn:WorkflowServicewsdl','urn:WorkflowServicewsdl#autoGetProcessor','rpc','encoded','Get E-office workflow dealer');
//定义getDefaultManage函数返回值的结构体
$server->wsdl->addComplexType ( 
	'DefaultManage', 
	'complexType', 
	'struct', 
	'all', 
	'',
	array (
		"canEdit"  =>array ('name' => 'canEdit', 'type' => 'xsd:string' ),
		"defaultUser"=>array ('name' => 'defaultUser', 'type' => 'xsd:string' ),
		"defaultManage"=>array ('name' => 'defaultManage', 'type' => 'xsd:string' )
		)
);
//注册一个名字为getDefaultManage的函数,获取流程某个节点或当前节点的默认主办人的信息和是否可以修改办理人
$server->register('getDefaultManage',array('flowid' => 'xsd:string','runid' => 'xsd:string','flowPrcs' => 'xsd:string'), array('return' => 'tns:DefaultManage'), 'urn:WorkflowServicewsdl','urn:WorkflowServicewsdl#getDefaultManage','rpc','encoded','Get E-office workflow dealer');

//注册一个名字为saveFeedBack的函数,保存签办反馈
$server->register('saveFeedBack',array('userid' => 'xsd:string','flow_id' => 'xsd:string','run_id' => 'xsd:string','content' => 'xsd:string','attachment_id' => 'xsd:string','attachment_name' => 'xsd:string'), array('return' => 'xsd:string'), 'urn:WorkflowServicewsdl','urn:WorkflowServicewsdl#saveFeedBack','rpc','encoded','saveFeedBack');
//定义getFeedBack函数返回值的结构体
$server->wsdl->addComplexType(
    'feedbacks',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array(
            'ref' => 'SOAP-ENC:arrayType',
            'wsdl:arrayType' => 'tns:feedback[]'
			  )
		),
    'tns:feedback'
);
$server->wsdl->addComplexType ( 
	'feedback', 
	'complexType', 
	'struct', 
	'all', 
	'',
	array (
		"RUN_ID"  =>array ('name' => 'RUN_ID',  'type' => 'xsd:string' ),
		"CONTENT"=>array ('name' => 'CONTENT', 'type' => 'xsd:string' ),
		"ATTACHMENT_ID"  =>array ('name' => 'ATTACHMENT_ID',   'type' => 'xsd:string'),
		"ATTACHMENT_NAME"  =>array ('name' => 'ATTACHMENT_NAME',   'type' => 'xsd:string'),
		"EDIT_TIME"  =>array ('name' => 'EDIT_TIME',   'type' => 'xsd:string'),
		"SEQ_ID"  =>array ('name' => 'SEQ_ID',   'type' => 'xsd:string'),
		"FLOW_PRCS"  =>array ('name' => 'FLOW_PRCS',   'type' => 'xsd:string'),
		"PRCS_ID"  =>array ('name' => 'PRCS_ID',   'type' => 'xsd:string'),
		"PRCS_NAME"  =>array ('name' => 'PRCS_NAME',   'type' => 'xsd:string'),
		
		)
);
//注册一个名字为getFeedBack的函数,保存签办反馈
$server->register('getFeedBack',array('flow_id' => 'xsd:string','run_id' => 'xsd:string'), array('return' => 'tns:feedbacks'), 'urn:WorkflowServicewsdl','urn:WorkflowServicewsdl#getFeedBack','rpc','encoded','getFeedBack');
//注册一个名字为error的函数,返回错误代码
$server->register('webserviceError',array(), array('return' => 'xsd:string'), 'urn:WorkflowServicewsdl','urn:WorkflowServicewsdl#error','rpc','encoded','Get Webservice error id');
/**
 * 通过调用api的实例,实现上面注册的函数getFormData的功能
 * @access public
 * @para   int flowid 流程类别id
 * @para   int run_id 流程id
 * @return str json_encode $formdata
*/
function getFormData($flowid,$runid)
{
	CheckCurrentSession();
	$workflowApi = new workflow(intval($flowid));
	$workflowApi->runId = intval($runid);
	$formdata    = $workflowApi->getFormData();
	return $formdata;
}
/**
 * 通过调用api的实例,实现上面注册的函数getOtherSetInfo的功能
 * @access public
 * @para   int flowid 流程类别id
 * @return str json_encode $otherInfo
*/
function getOtherSetInfo($flowid)
{
	CheckCurrentSession();
	$workflowApi = new workflow(intval($flowid));
	$otherInfo   = $workflowApi->getOtherSetInfo();
	//返回结果
	return $otherInfo;
}
/**
 * 通过调用api的实例,实现上面注册的函数getFiedAndValue的功能
 * @access public
 * @para   int flowid 流程类别id
 * @para   int run_id 流程id
 * @return str json_encode $fieldAndValue
*/
function getFiedAndValue($flowid,$runid)
{
	CheckCurrentSession();
	$workflowApi   = new workflow(intval($flowid));
	$workflowApi->runId = intval($runid);
	$fieldAndValue = $workflowApi->getFormRunValue();
	return $fieldAndValue;
}
/**
 * 通过调用api的实例,实现上面注册的函数saveFormData的功能
 * @access public
 * @para   int flowid 流程类别id
 * @para   int run_id 流程id
 * @return str json_encode $rs 
*/
function saveFormData($formdata,$flowid,$runid,$docid)
{
	CheckCurrentSession();
	$workflowApi   = new workflow(intval($flowid));
	$workflowApi->runId = intval($runid);
	$workflowApi->flowRunningInfo();
	$rs = $workflowApi->autoSave($formdata,$docid);
	return $rs;
}
/**
 * 通过调用api的实例,实现上面注册的函数getNextNodes的功能
 * @access public
 * @para   int flowid 流程类别id
 * @para   int run_id 流程id
 * @return str json_encode $nodesArray
*/
function getNextNodes($flowid,$runid)
{
	CheckCurrentSession();
	$workflowApi = new fixedWorkflow(intval($flowid));
	$workflowApi->runId = intval($runid);
	$nodesArray  = $workflowApi->getCurrentNextPrcstoid();
	return $nodesArray;
}
/**
 * 通过调用api的实例,实现上面注册的函数setHaveRead的功能
 * @access public
 * @para   int flowid 流程类别id
 * @para   int run_id 流程id
 * @para   str userid 当前用户id
 * @return void
*/
function setHaveRead($flowid,$runid,$userid,$sid)
{
	CheckCurrentSession ($sid);
	$workflowApi = new fixedWorkflow(intval($flowid));
	$workflowApi->runId = intval($runid);
	$node_info  = $workflowApi->getNodeInfo();
	$prcs_info  = $workflowApi->getPrcsInfo();
	$prcs_count = count($prcs_info);
	if($prcs_count)
	{
		$flow_prcs = $prcs_info[$prcs_count-1]["FLOW_PRCS"];
		$prcs_id   = $prcs_info[$prcs_count-1]["PRCS_ID"];
	}
	else
	{
		die("流程已被删除");
	}
	$prcsOptype = $node_info[$flow_prcs]["PRCS_OPTYPE"]; 
	$workflowApi->setOpFlag($prcsOptype,$prcs_id,$flow_prcs,$userid);
	$workflowApi->cancelSmsRemind();
	$workflowApi->markHaveReceive($userid,$prcs_id);
	return 1;
}
/**
 * 通过调用api的实例,实现上面注册的函数turnNext的功能
 * @access public
 * @para   int flowid 流程类别id
 * @para   int run_id 流程id
 * @para   int userId 用户id
 * @para   int flowPrcs 当前步骤对应节点
 * @para   int prcsId 当前步骤
 * @para   int prcsUser 经办人id组合
 * @para   int prcsOpUser 主办人id
 * @para   int docId 关联文档id组合
 * @para   int oP 操作
 * @para   int subFlowRunIds 子流程id组合
 * @para   int limitDate 催办时间
 * @para   int monitor 监控转交人
 * @para   int mbSmsContent 手机提醒内容
 * @para   int smsContent 内部消息提醒内容
 * @para   int emailContent 邮件提醒内容
 * @return void
*/
function turnNext($flowid,$runid,$userId,$flowPrcs,$prcsId,$prcsUser,$prcsOpUser,$docId,$oP,$subFlowRunIds,$limitDate,$monitor,$mbSmsContent,$smsContent,$emailContent,$sid)
{
	CheckCurrentSession(sid);
	$workflowApi = new fixedWorkflow(intval($flowid));	
	$workflowApi->runId = intval($runid);
	$OP_FLAG     = $workflowApi->isOpFlag($userId,$prcsId);
	if($OP_FLAG)
	{
		$workflowApi->turnnext($flowPrcs,$prcsId,$prcsUser,$prcsOpUser,$docId,$oP,$subFlowRunIds,$limitDate,$monitor,$mbSmsContent,$smsContent,$emailContent);
	}
	else
	{
		$workflowApi->saveForm($prcsId);
	}	
	return 1;
}
/**
 * 通过调用api的实例,实现上面注册的函数autoGetProcessor的功能
 * @access public
 * @para   int flowid 流程类别id
 * @para   int run_id 流程id
 * @return void
*/
function autoGetProcessor($flowid,$runid,$flowPrcs)
{
	CheckCurrentSession();
	$workflowApi = new fixedWorkflow(intval($flowid));
	$workflowApi->runId = intval($runid);
	$node_info  = $workflowApi->getNodeInfo();
	$prcs_info  = $workflowApi->getPrcsInfo();
	$prcs_count = count($prcs_info);
	if($flowPrcs)
	{
		$flow_prcs = $flowPrcs;	
	}
	else
	{
		$flow_prcs = $prcs_info[$prcs_count-1]["FLOW_PRCS"];
	}
	$prcsUser            = trim($node_info[$flow_prcs]["PRCS_USER"],",");
	$prcsDept            = trim($node_info[$flow_prcs]["PRCS_DEPT"],",");
	$prcsPriv            = trim($node_info[$flow_prcs]["PRCS_PRIV"],",");
	$prcsAutoGetUser     = $node_info[$flow_prcs]["PRCS_AUTO_GET_USER"];
	$canEdit             = $node_info[$flow_prcs]["PRCS_DEFAULT_TYPE"];
	$default_manage      = $node_info[$flow_prcs]["PRCS_DEFAULT_MANAGE"];
	
	$dealers             = $workflowApi->autoGetProcessor($prcsUser,$prcsDept,$prcsPriv,$prcsAutoGetUser);
	//返回结果
	return $dealers;
}
/**
 * 通过调用api的实例,实现上面注册的函数error的功能
 * @access public
 * @return string
*/
/**
 * 通过调用api的实例,实现上面注册的函数getDefaultManage的功能
 * @access public
 * @para   int flowid 流程类别id
 * @para   int run_id 流程id
 * @para   int flowPrcs 流程节点号
 * @return array
*/
function getDefaultManage($flowid,$runid,$flowPrcs='')
{
	CheckCurrentSession();
	$workflowApi = new fixedWorkflow(intval($flowid));
	$workflowApi->runId = intval($runid);
	if($flowPrcs)
	{
		$flow_prcs = $flowPrcs;
	}
	else
	{
		$prcs_info  = $workflowApi->getPrcsInfo();
		$prcs_count = count($prcs_info);
		if($prcs_count)
		{
			$flow_prcs = $prcs_info[$prcs_count-1]["FLOW_PRCS"];
		}
	}
	//判断此节点是否已经走过，走过的话，用走过的主办人作为默认办理人和默认主办人
	$have_run_info  = $workflowApi->nodeHaveRun($flow_prcs);
	if($have_run_info["USER_ID"])
	{
		$canEdit        = 0;
		$default_user   = $have_run_info["USER_ID"]; 
		$default_manage = $have_run_info["USER_ID"];
	}
	else
	{
		$node_info      = $workflowApi->getNodeInfo();
		$canEdit        = $node_info[$flow_prcs]["PRCS_DEFAULT_TYPE"];
		$default_user   = $node_info[$flow_prcs]["PRCS_DEFAULT_USER"]; 
		$default_manage = $node_info[$flow_prcs]["PRCS_DEFAULT_MANAGE"];
	}	 	
	//返回结果
	return array("canEdit"=>$canEdit,"defaultUser"=>$default_user,"defaultManage"=>$default_manage);
}
/**
 * 通过调用api的实例,实现上面注册的函数saveFeedBack的功能
 * @access public
 * @para   str userid   用户id
 * @para   int flow_id  流程类别id
 * @para   int run_id   流程id
 * @para   str content  反馈意见的内容
 * @para   str attachment_id   附件id字符串
 * @para   str attachment_name 附件名称字符串
 * @return array
*/
function saveFeedBack($userid,$flow_id,$run_id,$content,$attachment_id,$attachment_name)
{
	CheckCurrentSession();
	$workflowApi = new fixedWorkflow(intval($flow_id));
	$workflowApi->runId = intval($run_id);
	$rs = $workflowApi->saveFeedBack($userid,$content,$attachment_id,$attachment_name);	
	//返回结果
	return $rs;
}
/**
 * 通过调用api的实例,实现上面注册的函数getFeedBack的功能
 * @access public
 * @para   int flow_id 流程类别id
 * @para   int run_id  流程id
 * @return array
*/
function getFeedBack($flow_id,$run_id)
{
	CheckCurrentSession();
	$workflowApi = new fixedWorkflow(intval($flow_id));
	$workflowApi->runId = intval($run_id);
	$rs = $workflowApi->getFeedBack();
	$flowInfo = $workflowApi->getNodeInfo();
	for($i=0;$i < count($rs);$i++)
	{
		$flow_prcs           = $rs[$i]["FLOW_PRCS"];
		$rs[$i]["PRCS_NAME"] = $flowInfo[$flow_prcs]["PRCS_NAME"];
	}
	
	//返回结果
	return $rs;
}


//返回数据
$server->service($HTTP_RAW_POST_DATA);
?>