<?php
/**
 * @copyright (C) 2001 - 2011 Weaver Co.Ltd
 * @package       eoffice 8.3
 * @function      商务客户的API文件
 * @encoding      $_lang['encoding']
 * @name          api/customer.class.php
 * @version       70
 * @author        Qu|www.weaver.com.cn
 * @date          2012-12-24
 */
include('db.class.php');
class customer extends database{
	/**默认验证
	*/
	function default_validate()
	{
		global $connection, $customer_id, $customer_name, $manage_user;
		//先读客户经理角色级别
		$query2	 = "SELECT up.* FROM user_priv as up, user as u WHERE up.USER_PRIV=u.USER_PRIV AND u.USER_ID='".SecurityFilter($manage_user)."'";
		$cursor2 = exequery($connection, $query2);
		if($row2 = mysql_fetch_array($cursor2)) {
			$priv_no	= $row2["PRIV_NO"];
		}
		//再读登陆者的角色级别
		$query3	 = "SELECT up.* FROM user_priv as up, user as u WHERE up.USER_PRIV=u.USER_PRIV AND u.USER_ID='".SecurityFilter($_SESSION['LOGIN_USER_ID'])."'";
		$cursor3 = exequery($connection, $query3);
		if($row3 = mysql_fetch_array($cursor3)){
			$login_priv_no	= $row3["PRIV_NO"];
		}

		if($login_priv_no < $priv_no) {
			$purview_ses = "<a href=\"#\" onclick=\"customer_detail('".$customer_id."');\">".$customer_name."</a>";
		} else {
			$purview_ses = false;
		}
		return $purview_ses;
	}

	/**部门验证
	*/
	function dept_validate()
	{
		global $connection, $purview_dept;
		if($purview_dept == 'ALL_DEPT')
			return true;
		$query2	 = "SELECT d.* FROM department as d, user as u WHERE u.DEPT_ID=d.DEPT_ID AND u.USER_ID='".SecurityFilter($_SESSION['LOGIN_USER_ID'])."'";
		$cursor2 = exequery($connection, $query2);
		if($row2 = mysql_fetch_array($cursor2)){
			$dept_id	= $row2["DEPT_ID"];
		}

		if(array_search($dept_id, explode(",", $purview_dept)) !== false){
			return true;
		}
		else
		{
			return false;
		}
	}

	/**角色验证
	*/
	function role_validate()
	{
		global $connection, $purview_role;
		$query2	= "SELECT up.* FROM user_priv as up,user as u WHERE up.USER_PRIV=u.USER_PRIV AND u.USER_ID='".SecurityFilter($_SESSION['LOGIN_USER_ID'])."'";
		$cursor2 = exequery($connection, $query2);

		if($row2= mysql_fetch_array($cursor2))
		{
			$login_priv_no	= $row2["USER_PRIV"];
		}

		if(array_search($login_priv_no, explode(",", $purview_role)) !== false)
		{
			return true;
		}
		else
		{
			return false;
		}
	}

	/**人员验证
	*/
	function user_validate()
	{
		global $connection, $purview_user;

		if(array_search($_SESSION['LOGIN_USER_ID'], explode(",", $purview_user)) !== false)
		{
			return true;
		}
		else
		{
			return false;
		}
	}

//获取查询客户信息的sql语句
function get_customer_sql_string_fun ($flag = 1, $order, $sens ,$where_str = '',$limit = '')
{
	if($flag==1)
		$sql = 	$this->get_customer_manage_str();
	else if($flag==2)
		$sql =  $this->get_customer_all_str();
	else if($flag==0)
		$sql =  $this->get_customer_view_str();
	else if($flag==3)
		$sql =  $this->get_customer_admin();

	$sql .= $where_str ;
	switch( $order )
	{
		case 'customer_name':
			$sql	.= " order by c.CUSTOMER_NAME";
			break;
		case 'tel_no':
			$sql	.= " order by c.TEL_NO";
			break;
		default:
			$sql	.= " order by c.CUSTOMER_ID";
			break;
	}

	$sql	.= $sens ?' ASC':' DESC';

	if(!empty($limit)){
		$sql	.= $limit;
	}
	return $sql;
}

	/**获取客户信息
	*$flag        状态字段
	*$order       排序字段
	*$sens        升降序字段
	*$param       保存用户角色等信息的数组
	*$where_str   保存查询条件的数组
	*$end         分页参数1
	*$pagecount   分页参数2
	*$quicksort   快速筛选参数
	*$from        客户导出参数1
	*$start       客户导出参数
	*$limits
	*$user_id     用户ID
	*/
	function get_customer_sql_string($flag=1,$order,$sens,$param='',$where_str='',$end='',$pagecount='',$quicksort='',$from='',$start='',$limits='',$user_id='')
	{
		global $connection;
		$login_priv = $this->get_login_priv($user_id);
		$returnStr = "";
		if($flag==1)
			$sql = $this->get_customer_manage_str();
		else if($flag==2)
			$sql = $this->get_customer_all_str();
		else if($flag==0)
			$sql = $this->get_customer_view_str($param,$user_id);
		else if($flag==3)
			$sql = $this->get_customer_admin();

		if($where_str) {
			foreach($where_str as $key=>$value) {
				if($key == "MANAGE_USER") {
					$sql .= " AND c.MANAGE_USER='".SecurityFilter($value)."'";
				} else if($key == "CUSTOMER_NAME") {
					$sql .= " AND c.CUSTOMER_NAME LIKE '%".SecurityFilter($value)."%'";
				} else if($key == "CUSTOMER_TYPE") {
					if($value!="" && $value!=0) {
						$sql .= " AND c.CUSTOMER_TYPE=".SecurityFilter($value);
					}
				} else if($key == "TEL_NO") {
					$sql .= " AND c.TEL_NO LIKE '%".SecurityFilter($value)."%'";
				} else if($key == "FAX_NO") {
					$sql .= " AND c.FAX_NO LIKE '%".SecurityFilter($value)."%'";
				} else if($key == "CUSTOMER_WWW") {
					$sql .= " AND c.CUSTOMER_WWW LIKE '%".SecurityFilter($value)."%'";
				} else if($key == "EMAIL") {
					$sql .= " AND c.EMAIL LIKE '%".SecurityFilter($value)."%'";
				} else if($key == "CUSTOMER_ADD") {
					$sql .= " AND c.CUSTOMER_ADD LIKE '%".SecurityFilter($value)."%'";
				} else if($key == "POSTALCODE") {
					$sql .= " AND c.POSTALCODE LIKE '%".SecurityFilter($value)."%'";
				} else if($key == "MEMO") {
					$sql .= " AND c.MEMO LIKE '%".SecurityFilter($value)."%'";
				} else if($key == "OTHER_FIELD") {
					$sql .= " ".SecurityFilter($value);
				}
			}
		}

		if($param=="" || $param=="all" || $param=="All" || $param=="全部") {
		} else if($param=="#") {
			$sql .= " AND left(CUSTOMER_NAME_ZM,1) in ('0','1','2','3','4','5','6','7','8','9')";
		} else {
			$param = strtolower($param);
			$sql .= " AND left(CUSTOMER_NAME_ZM,1) ='" . SecurityFilter($param) . "'";
		}

		if($quicksort) {
			switch($quicksort) {
				case"manage_user":
					$sql .= " AND c.MANAGE_USER='".SecurityFilter($login_priv["priv_user"])."'";
					break;
				case"thismonth":
					$sql .= " AND DATE_FORMAT(c.CREATE_TIME,'%Y-%m')=DATE_FORMAT(NOW(),'%Y-%m')";
					break;
				case"create":
					$sql .= " AND c.CREATEOR='".SecurityFilter($login_priv["priv_user"])."'";
					break;
			}
		}

		preg_match('/SELECT ([^\"\']*)[\s]FROM[\s]/i', $sql, $reg);
		$getCountQuery   = str_replace($reg[1], 'COUNT(*) AS CNT', $sql);
		$getCountResult  = exequery($connection, $getCountQuery);
		if ($getCountRow = mysql_fetch_array($getCountResult)) {
			$resultCount = $getCountRow['CNT'];
		}

		$sql   .= " ORDER BY ".$order." ".$sens;
		if($start == '' && $limits == '') {
			if($pagecount) {
				$end = $end*$pagecount;
				//批量删除最后一页的数据，页面无跳转的问题的问题的修复
				if($end>=$resultCount)
				{
					$end = max(0,$end-$pagecount);
				}
				$sql .= " limit ".$end.",".$pagecount;
			}
		} else {
			$sql .= " limit ".$start.",".$limits;
		}
		$count  = 0;
		$cousor = exequery($connection,$sql);
		while($row = mysql_fetch_array($cousor)) {
			$count++;
			$returnStr[$count][CUSTOMER_ID]   = $row["CUSTOMER_ID"];
			$returnStr[$count][CUSTOMER_NAME] = $row["CUSTOMER_NAME"];
			$returnStr[$count][TEL_NO]        = $row["TEL_NO"];
			$returnStr[$count][FAX_NO]        = $row["FAX_NO"];
			$returnStr[$count][EMAIL]         = $row["EMAIL"];
			$returnStr[$count][CUSTOMER_ADD]  = $row["CUSTOMER_ADD"];
			$returnStr[$count][POSTALCODE]    = $row["POSTALCODE"];
			$returnStr[$count][MANAGE_USER]   = $row["MANAGE_USER"];
			$returnStr[$count][USER_NAME]     = $row["USER_NAME"];
			$returnStr[$count][USER_ID]       = $row["USER_ID"];
			$returnStr[$count][AVATAR_TYPE]   = $row["AVATAR_TYPE"];
			$returnStr[$count][CUSTOMER_TYPE] = $row["CUSTOMER_TYPE"];
			$returnStr[$count][PURVIEW] 	  = $row["PURVIEW"];
			$returnStr[$count][DEPT_ID] 	  = $row["DEPT_ID"];
			$returnStr[$count][USER_ACCOUNTS] = $row["USER_ACCOUNTS"];
			$returnStr[$count][CUSTOMER_NUMBER] = $row["CUSTOMER_NUMBER"];
			$returnStr[$count][CUSTOMER_WWW]  = $row["CUSTOMER_WWW"];
			$returnStr[$count][LE_PERSON]     = $row["LE_PERSON"];
            $returnStr[$count][CREATE_TIME]     = $row["CREATE_TIME"];
		}
		$returnStr[count($row)][COUNT]  = $resultCount;
		return $returnStr;
	}

	/**查询客户的sql语句
	*/
	function get_customer_all_str(){
		$sql = " SELECT c.CUSTOMER_ID, c.CUSTOMER_NAME, c.TEL_NO, c.FAX_NO, c.EMAIL, c.CUSTOMER_TYPE,c.MANAGE_USER,c.PURVIEW,u.USER_NAME
				 FROM customer as c
				 LEFT JOIN user as u ON u.USER_ID = c.MANAGE_USER ";
		return $sql;
	}

	/**客户信息管理，查询sql语句
	*/
	function get_customer_manage_str()
	{
		$sql = "SELECT c.CUSTOMER_ID, c.CUSTOMER_NAME, c.TEL_NO, c.FAX_NO, c.EMAIL, c.CUSTOMER_TYPE,c.MANAGE_USER,c.PURVIEW, u.USER_NAME, u.DEPT_ID, u.USER_ACCOUNTS
				   FROM customer as c
				   LEFT JOIN user as u ON u.USER_ID = c.MANAGE_USER WHERE c.MANAGE_USER = '".SecurityFilter($_SESSION['LOGIN_USER_ID']). "'";
		return $sql;
	}

	/**获取下属的用户账户
	*$login_priv  用户角色字段
	*/
	function get_underling_accounts($login_priv){
		global $connection;
		switch($login_priv['post_priv']){
			case '0':
				$sql = "SELECT USER_ACCOUNTS
						FROM USER u
						LEFT JOIN user_priv up ON up.USER_PRIV = u.USER_PRIV
						WHERE up.PRIV_NO > '". SecurityFilter($login_priv['priv_no']) . "'  AND DEPT_ID = '".SecurityFilter($login_priv['priv_dept'])."'";
				break;
			case '1':
				$sql = "SELECT USER_ACCOUNTS
						FROM USER u
						LEFT JOIN user_priv up ON up.USER_PRIV = u.USER_PRIV
						WHERE up.PRIV_NO > '". SecurityFilter($login_priv['priv_no']) . "'";
				break;
			case '2':
				$sql = "SELECT USER_ACCOUNTS
						FROM USER u
						LEFT JOIN user_priv up ON up.USER_PRIV = u.USER_PRIV
						WHERE up.PRIV_NO > '". SecurityFilter($login_priv['priv_no']) . "' AND INSTR('".SecurityFilter($login_priv['post_dept'])."',DEPT_ID)>0 ";
				break;
		}
		$cursor = exequery($connection, $sql);
		while($row= mysql_fetch_array($cursor)){
			$accounts[] = $row["USER_ACCOUNTS"];
		}
		if(empty($accounts))
			$accounts = array($login_priv['priv_user']);
		else
			$accounts = array_filter($accounts);
		return $accounts;
	}

	/**获取下级帐户名字符串
	*$login_priv 用户角色
	*/
	function get_accounts_str($login_priv){
		$accounts_array = $this->get_underling_accounts($login_priv);
		foreach($accounts_array as $acc){
			$accounts_str .= "'" . $acc . "',";
		}
		if($accounts_str == "") {
			global $connection;
			$query = "SELECT * FROM user WHERE USER_ID='".SecurityFilter($_SESSION['LOGIN_USER_ID'])."'";
			$rs    = exequery($connection,$query);
			$row   = mysql_fetch_array($rs);
			$accounts_str = "'".$row["USER_ACCOUNTS"]."',";
		}
		$accounts_str = substr( $accounts_str, 0, -1 );
		return $accounts_str;
	}

	/**获取有权限查看当前客户的所有用户
	*$customerId 客户id
	*/
	function get_customer_userid_str($customerId = ''){
		global $connection;
		$returnids = "";
		$idarr = array();
		$sql = "SELECT * FROM `customer` WHERE CUSTOMER_ID='".SecurityFilter($customerId)."'";
		$userid_sql = "SELECT USER_ID FROM `user` ";
		$cursor = exequery($connection, $sql);
		while($row = mysql_fetch_assoc($cursor)){
			$USER_ID = $row['PURVIEW_USER'];
			$USER_PRIV = $row['PURVIEW_ROLE'];
			$DEPT_ID = $row['PURVIEW_DEPT'];
			$SERVICE_USER = $row['SERVICE_USER'];
			$MANAGE_USER = $row['MANAGE_USER'];
			$PURVIEW = $row['PURVIEW'];
			if($SERVICE_USER){
				$USER_ID = $USER_ID . "$SERVICE_USER,";
			};
			if($MANAGE_USER){
				$managesuper_ids = $this->get_superuserid_str($MANAGE_USER);
				$USER_ID = $USER_ID . $managesuper_ids;
			};
			if($PURVIEW == '3'){
				if(str_replace(",","','",trim($USER_ID,","))){
					$ids = implode(",",array_unique(explode(",",trim($USER_ID,","))));
					$sql2 .= " USER_ID IN ('".str_replace(",","','",$ids)."') OR";
				}
				if(str_replace(",","','",trim($USER_PRIV,",")))
					$sql2 .= " USER_PRIV IN ('".str_replace(",","','",trim($USER_PRIV,","))."') OR";
				if(str_replace(",","','",trim($DEPT_ID,",")))
					$sql2 .= " DEPT_ID IN ('".str_replace(",","','",trim($DEPT_ID,","))."') ";
				if(trim($sql2,"OR"))
				{
					$userid_sql .= " WHERE  ".trim($sql2,"OR")."  ";
				}
			}
		};
		$cursor2 = exequery($connection, $userid_sql);
		while($row2 = mysql_fetch_assoc($cursor2)){
			// $idarr[] = $row2['USER_ID'];
			$returnids .= "'".$row2["USER_ID"]."',";
		};
		// if(count($idarr)){
		// 	$returnids = "";
		// 	foreach($idarr as $k => $v){
		// 		$returnids .= $this->get_superuserid_str($v);
		// 	};
		// 	$returnids = implode(",",array_unique(explode(",",trim($returnids,","))));
			// echo trim($returnids,",");
		// }
		return trim($returnids, ",");
	}

	/**获取上级id符串
	*$uids 用户id
	*/
	function get_superuserid_str($userId = ''){
		$login_priv   = $this->get_login_priv($userId);
		global $connection;
		$sql = "SELECT DISTINCT(USER_ID) FROM USER u
				LEFT JOIN user_priv up ON up.USER_PRIV = u.USER_PRIV
				WHERE up.PRIV_NO < '". SecurityFilter($login_priv['priv_no']) . "'";
		$sql .= " AND ((u.POST_PRIV = '0' AND u.DEPT_ID = '".SecurityFilter($login_priv['priv_dept'])."' ) OR (u.POST_PRIV = '1') OR (u.POST_PRIV = '2' AND INSTR(CONCAT(CONCAT(',',u.POST_DEPT),','),',".SecurityFilter($login_priv['priv_dept'])."')>0 AND u.DEPT_ID>0 ))";
		if($userId){
			$uids = "$userId,";
		};
		$cursor = exequery($connection, $sql);
		if($cursor){
			while($row = mysql_fetch_assoc($cursor)){
				$uids .= "".$row["USER_ID"].",";;
			}
		};
		return $uids;
	}

	/**获取下级id符串
	*$uids 用户id
	*/
	function get_userid_str($login_priv=array(),$userId = ''){
		if(empty($login_priv))$login_priv   = $this->get_login_priv();
		global $connection;
		$sql = "SELECT USER_ID FROM USER u
				LEFT JOIN user_priv up ON up.USER_PRIV = u.USER_PRIV
				WHERE up.PRIV_NO > '". SecurityFilter($login_priv['priv_no']) . "'";
		switch($login_priv['post_priv']){
			case '0':  //同部门
				$sql .= " AND DEPT_ID = '".SecurityFilter($login_priv['priv_dept'])."'";
				break;
			case '1':  //全体
				$sql .= '';
				break;
			case '2':  //指定部门111,222,
				$sql .= " AND INSTR(',".SecurityFilter($login_priv['post_dept'])."',CONCAT(CONCAT(',',DEPT_ID),','))>0 AND DEPT_ID>0";
				break;
			default:
				$sql = '';
				break;
		}
		$cursor = exequery($connection, $sql);
        if($userId != ''){
            $userId = $userId;
        }else{
            $userId = $_SESSION['LOGIN_USER_ID'];
        }
		$uids = "'$userId',";
		if($cursor){
			while($row= mysql_fetch_array($cursor)){
				$uids .= "'".$row["USER_ID"]."',";
			}
		}
		return $uids;
	}

	/**获取下级权限条件sql
	*$uids 用户id
	*/
	function get_purview_where($user_id = ''){
		if($user_id != '') {
			$user_id = $user_id;
		} else {
			$user_id = $_SESSION['LOGIN_USER_ID'];
		}
		$login_priv  =  $this->get_login_priv($user_id);
		$useridStr 	 = 	$this->get_userid_str($login_priv,$user_id);
		$useridStr 	 = 	rtrim($useridStr,',');
		return "(c.MANAGE_USER IN($useridStr)
				OR
					c.SERVICE_USER = '".$user_id."'
				OR
				 	PURVIEW = 2
				OR
					(PURVIEW = 3
						AND
						(	INSTR(CONCAT(',',PURVIEW_DEPT),',". SecurityFilter($login_priv['priv_dept']) .",')>0
				 			OR
				 			instr(CONCAT(',',PURVIEW_ROLE),',". SecurityFilter($login_priv['user_priv']) .",')>0
				 			OR
				 			instr(CONCAT(',',PURVIEW_USER),',". SecurityFilter($login_priv['priv_user']) .",')>0
				 		)
					)
				) ";
	}

	/**客户信息查询，查询sql语句
	*$param     保存包含用户角色信息的数组
	*$user_id   用户ID
	*$emailSearchParam 收件人查询功能传入的查询参数
	*/
	function get_customer_view_str($param,$user_id='',$emailSearchParam='')
	{
		$purview_where = $this->get_purview_where($user_id);

		$sql = "SELECT c.CUSTOMER_ID, c.CUSTOMER_NAME, c.TEL_NO, c.FAX_NO, c.EMAIL, c.CUSTOMER_TYPE,c.MANAGE_USER,c.PURVIEW,c.CUSTOMER_ADD,c.CUSTOMER_NUMBER,c.CUSTOMER_WWW,c.POSTALCODE,c.LE_PERSON,c.CUSTOMER_NAME_PY,c.CUSTOMER_NAME_ZM,c.CREATE_TIME,u.USER_NAME,u.USER_ID,u.AVATAR_TYPE, u.DEPT_ID, u.USER_ACCOUNTS
				FROM customer as c
				LEFT JOIN user as u ON(u.USER_ID = c.MANAGE_USER)
				LEFT JOIN user_priv as up ON(up.USER_PRIV = u.USER_PRIV)
					 WHERE $purview_where";
		if($emailSearchParam)
		{
			$sql.= $emailSearchParam;
		}
		return $sql;
	}

	/**获取有权限查询的客户
	*/
	function get_customer_view_name($user_id='')
	{
		global $connection;
		$purview_where = $this->get_purview_where($user_id);
		if($user_id!='admin'){
			$sql = "SELECT c.CUSTOMER_ID
					FROM customer as c
						 WHERE $purview_where";
		}else{
			$sql = "SELECT CUSTOMER_ID FROM customer";
		}

		$rs   = exequery($connection,$sql);
		$cust = "";
		while($row = mysql_fetch_array($rs)) {
			$cust .= "'".$row["CUSTOMER_ID"]."',";
		}
		return $cust;
	}

	//超级管理员，获取客户信息表中所有的数据
	function get_customer_admin() {
		$sql = "SELECT c.CUSTOMER_ID, c.CUSTOMER_NAME, c.TEL_NO, c.FAX_NO, c.EMAIL, c.CUSTOMER_TYPE,c.MANAGE_USER,c.PURVIEW,u.USER_NAME, u.DEPT_ID, u.USER_ACCOUNTS
				FROM customer as c
				LEFT JOIN user as u ON(u.USER_ID = c.MANAGE_USER)
				LEFT JOIN user_priv as up ON(up.USER_PRIV = u.USER_PRIV)
				" ;
		return $sql;
	}

	/**获取联系人的信息
	*$flag          状态
	*$order         排序字段
	*$sens          升降序字段
	*$where_str     保存查询信息的数组
	*$customer_id   客户ID
	*$end           分页参数1
	*$pagecount     分页参数2
	*$pinyinSearch  拼音检索参数
	*$quicksort     快速筛选参数
	*/
	function get_linkman_sql_string($flag,$order,$sens,$where_str='',$customer_id='',$end='',$pagecount='',$pinyinSearch='',$quicksort='',$user_id='')
	{
		global $connection;
		$login_priv   = $this->get_login_priv($user_id);
		$returnStr = "";

		if($flag == 0) {
			$sql = $this->get_linkman_str_with_preview($user_id);
		} else {
			$sql = $this->get_linkman_str_all();
		}
		if($pinyinSearch=="" || $pinyinSearch=="all") {
		} else if($pinyinSearch=="#") {
			$sql .= " AND left(LINKMAN_NAME_ZM,1) in ('0','1','2','3','4','5','6','7','8','9')";
		} else {
			$pinyinSearch = strtolower($pinyinSearch);
			$sql .= " AND left(LINKMAN_NAME_ZM,1) ='" . $pinyinSearch . "'";
		}
		if($where_str) {
			foreach($where_str as $key=>$value) {
                $value = SecurityFilter($value);
				if($key == "CUSTOMER_ID") {
					$sql .= " AND l.CUSTOMER_ID=".$value;
				}else if($key == "LINKMAN_NAME") {
					$sql .= " AND l.LINKMAN_NAME LIKE '%".$value."%'";
				}else if($key == "POST_PRIV") {
					$sql .= " AND l.POST_PRIV LIKE '%".$value."%'";
				}else if($key == "HOBBY") {
					$sql .= " AND l.HOBBY LIKE '%".$value."%'";
				}else if($key == "TEL_NO_WORK") {
					$sql .= " AND l.TEL_NO_WORK LIKE '%".$value."%'";
				}else if($key == "TEL_NO_HOME") {
					$sql .= " AND l.TEL_NO_HOME LIKE '%".$value."%'";
				}else if($key == "MOBILE") {
					$sql .= " AND l.MOBILE LIKE '%".$value."%'";
				}else if($key == "EMAIL") {
					$sql .= " AND l.EMAIL LIKE '%".$value."%'";
				}else if($key == "OTHER_FIELD") {
					$sql .= " ".$value;
				}
			}
		}

		if($quicksort) {
			switch($quicksort) {
				case "thismonth":
					$sql .= " AND MONTH(l.BIRTHDAY)=MONTH(CURDATE())";
					break;
				case "nextmonth":
					$sql .= " AND ((DATE_FORMAT(l.BIRTHDAY,'%m')=(MONTH(CURDATE())+1)) OR ((MONTH(CURDATE())=12 AND MONTH(l.BIRTHDAY)=1)))";
					break;
				case "thisweek":
					$thisMonday = date('Y-m-d', time()-86400*date('w')+(date('w')>0?86400:-6*86400));
					$thisSunday = date('Y-m-d', time()-86400*date('w')+(date('w')>0?(86400*7):86400));

					if(date(n,strtotime($thisMonday))<=date(n,strtotime($thisSunday))) {
						$sql .= " AND DATE_FORMAT(l.BIRTHDAY,'%m-%d') >= DATE_FORMAT(DATE_ADD(CURDATE(),INTERVAL -WEEKDAY(CURDATE()) DAY),'%m-%d') AND DATE_FORMAT(l.BIRTHDAY,'%m-%d')<=DATE_FORMAT(DATE_ADD(CURDATE(),INTERVAL 6-WEEKDAY(CURDATE()) DAY),'%m-%d')";
					} else {
						$sql .= " AND ((DATE_FORMAT(l.BIRTHDAY,'%m-%d')>=DATE_FORMAT(DATE_ADD(CURDATE(),INTERVAL -WEEKDAY(CURDATE()) DAY),'%m-%d') AND DATE_FORMAT(l.BIRTHDAY,'%m-%d')<='12-31') OR (DATE_FORMAT(l.BIRTHDAY,'%m-%d')>='01-01' AND DATE_FORMAT(l.BIRTHDAY,'%m-%d')<=DATE_FORMAT(DATE_ADD(CURDATE(),INTERVAL 6-WEEKDAY(CURDATE()) DAY),'%m-%d')))";
					}
					break;
				case "nextweek":
					$nextMonday = date('Y-m-d', time()-86400*date('w')+(date('w')>0?(86400*8):86400));
					$nextSunday = date('Y-m-d', time()-86400*date('w')+(date('w')>0?(86400*15):(86400*8)));

					if(date(n,strtotime($nextMonday))<=date(n,strtotime($nextSunday))) {
						$sql .= " AND DATE_FORMAT(l.BIRTHDAY,'%m-%d') >= DATE_FORMAT(DATE_ADD((DATE_ADD(CURDATE(),INTERVAL -WEEKDAY(CURDATE()) DAY)),INTERVAL 7 DAY),'%m-%d') AND DATE_FORMAT(l.BIRTHDAY,'%m-%d') <= DATE_FORMAT(DATE_ADD((DATE_ADD(CURDATE(),INTERVAL -WEEKDAY(CURDATE()) DAY)),INTERVAL 13 DAY),'%m-%d')";
					} else {
						$sql .= " AND ((DATE_FORMAT(l.BIRTHDAY,'%m-%d')>=DATE_FORMAT(DATE_ADD((DATE_ADD(CURDATE(),INTERVAL -WEEKDAY(CURDATE()) DAY)),INTERVAL 7 DAY),'%m-%d') AND DATE_FORMAT(l.BIRTHDAY,'%m-%d')<='12-31') OR (DATE_FORMAT(l.BIRTHDAY,'%m-%d')>='01-01' AND DATE_FORMAT(l.BIRTHDAY,'%m-%d')<=DATE_FORMAT(DATE_ADD((DATE_ADD(CURDATE(),INTERVAL -WEEKDAY(CURDATE()) DAY)),INTERVAL 13 DAY),'%m-%d')))";
					}
					break;
				case "create":
					$sql .= " AND l.CREATEOR='".SecurityFilter($login_priv["priv_user"])."'";
					break;
			}
		}

		preg_match('/SELECT ([^\"\']*)[\s]FROM[\s]/i', $sql, $reg);
		$getCountQuery   = str_replace($reg[1], 'COUNT(*) AS CNT', $sql);
		$getCountResult  = exequery($connection, $getCountQuery);
		if ($getCountRow = mysql_fetch_array($getCountResult)) {
			$resultCount = $getCountRow['CNT'];
		}

		$sql .= " ORDER BY ".$order." ".$sens;

		if($pagecount) {
			$end    = $end*$pagecount;
			//批量删除最后一页的数据，页面无跳转的问题的问题的修复
			if($end>=$resultCount)
			{
				$end = max(0,$end-$pagecount);
			}
			$sql   .= " limit ".$end.",".$pagecount;
		}
		$cousor = exequery($connection,$sql);
		$count  = 0;
		while($row = mysql_fetch_array($cousor)) {
			$count++;
			$returnStr[$count][CUSTOMER_ID]   = $row["CUSTOMER_ID"];
			$returnStr[$count][LINKMAN_ID]    = $row["LINKMAN_ID"];
			$returnStr[$count][LINKMAN_NAME]  = $row["LINKMAN_NAME"];
			$returnStr[$count][CUSTOMER_NAME] = $row["CUSTOMER_NAME"];
			$returnStr[$count][EMAIL]         = $row["EMAIL"];
			$returnStr[$count][TEL_NO_WORK]   = $row["TEL_NO_WORK"];
			$returnStr[$count][MANAGE_USER]   = $row["MANAGE_USER"];
			$returnStr[$count][PURVIEW]       = $row["PURVIEW"];
			$returnStr[$count][PURVIEW_DEPT]  = $row["PURVIEW_DEPT"];
			$returnStr[$count][PURVIEW_ROLE]  = $row["PURVIEW_ROLE"];
			$returnStr[$count][PURVIEW_USER]  = $row["PURVIEW_USER"];
			$returnStr[$count][MOBILE]        = $row["MOBILE"];
			$returnStr[$count][ATTACHMENT_ID] = $row["ATTACHMENT_ID"];
			$returnStr[$count][CREATEOR]      = $row["CREATEOR"];
		}
		$returnStr[count($row)][COUNT] = $resultCount;
		return $returnStr;
	}


	/**交往记录查询语句
	*$order    是否排序
	*$sens     升降序字段
	*$where_str保存查询条件数组
	*/
	function get_contact_sql_string( $order=true, $sens=true ,$where_str='' )
	{
		$purview_where = $this->get_purview_where();
		$sql = "SELECT ct.*, c.CUSTOMER_ID, c.CUSTOMER_NAME, c.MANAGE_USER,c.PURVIEW, l.LINKMAN_NAME, u.USER_NAME,u.DEPT_ID, u.USER_ACCOUNTS, up.USER_PRIV
				FROM contact as ct
				LEFT JOIN customer as c ON ct.CUSTOMER_ID = c.CUSTOMER_ID
				LEFT JOIN linkman as l ON ct.LINKMAN_ID = l.LINKMAN_ID
				LEFT JOIN user as u ON(u.USER_ID = c.MANAGE_USER)
				LEFT JOIN user_priv as up ON(up.USER_PRIV = u.USER_PRIV)
					WHERE $purview_where";
		$sql = $sql . $where_str;
		switch($order)
		{
			case 'contact_content':
				$sql .= " order by ct.CONTACT_CONTENT";
				break;
			case 'contact_date':
				$sql .= " order by ct.CONTACT_DATE";
				break;
			case 'customer_name':
				$sql .= " order by c.CUSTOMER_NAME";
				break;
			case 'linkman_name':
				$sql .= " order by ct.LINKMAN_NAME";
				break;
			default:
				$sql	.= " order by ct.CONTACT_ID";
				break;
		}
		$sens = $sens?' DESC':' ASC';
		$sql  = $sql.$sens;
		return $sql;
	}

	/**销售记录查询语句
	*$order      排序字段
	*$sens       升降序字段
	*$where_str  查询条件保存的数组
	*$end        分页参数1
	*$pagecount  分页参数2
	*/
	function get_sale_sql_string($order, $sens ,$where_str='',$end='',$pagecount=''){
		global $connection;
		$returnStr    = "";
		$purview_where = $this->get_purview_where();
		$select_sahistory = "SELECT s.*, p.PRODUCT_ID, p.PRODUCT_NAME, c.CUSTOMER_ID, c.CUSTOMER_NAME, c.MANAGE_USER,c.PURVIEW, u.USER_NAME,u.DEPT_ID, u.USER_ACCOUNTS, up.USER_PRIV
				FROM";
		$sql = " sale_history as s
				LEFT JOIN customer as c ON s.CUSTOMER_ID = c.CUSTOMER_ID
				LEFT JOIN product as p ON s.PRODUCT_ID = p.PRODUCT_ID
				LEFT JOIN user as u ON(u.USER_ID = c.MANAGE_USER)
				LEFT JOIN user_priv as up ON(up.USER_PRIV = u.USER_PRIV)
				WHERE $purview_where";

		if($where_str) {
			foreach($where_str as $key=>$value) {
			    $value = SecurityFilter($value);
				if($key == "CUSTOMER_ID") {
					$sql .= " AND s.CUSTOMER_ID=".$value;
				}
				elseif($key == "PRODUCT_ID") {
					$sql .= " AND s.PRODUCT_ID=".$value;
				}
				elseif($key == "DATE") {
					$sql .= " AND s.DATE>='".$value."'";
				}
				elseif($key == "DATE2") {
					$sql .= " AND s.DATE<='".$value."'";
				}
				elseif($key == "AMT") {
					if(is_numeric($value)) {
						$sql .= " AND s.AMT>=".$value;
					} else {
						$sql .= " AND s.AMT LIKE '%".$value."%'";
					}
				}
				elseif($key == "AMT2") {
					if(is_numeric($value)) {
						$sql .= " AND s.AMT<=".$value;
					} else {
						$sql .= " OR s.AMT LIKE '%".$value."%'";
					}
				}

				elseif($key == "PRICE") {
					if(is_numeric($value)) {
						$sql .= " AND s.PRICE>=".$value;
					} else {
						$sql .= " AND s.PRICE LIKE '%".$value."%'";
					}
				}
				elseif($key == "PRICE2") {
					if(is_numeric($value)) {
						$sql .= " AND s.PRICE<=".$value;
					} else {
						$sql .= " OR s.PRICE LIKE '%".$value."%'";
					}
				}
				elseif($key == "DISCOUNT") {
					if(is_numeric($value)) {
						$sql .= " AND s.DISCOUNT>=".$value;
					} else {
						$sql .= " AND s.DISCOUNT LIKE '%".$value."%'";
					}
				}
				elseif($key == "DISCOUNT2") {
					if(is_numeric($value)) {
						$sql .= " AND s.DISCOUNT<=".$value;
					} else {
						$sql .= " OR s.DISCOUNT LIKE '%".$value."%'";
					}
				}
				elseif($key == "SALESMAN") {
					$sql .= " AND s.SALESMAN LIKE '%".$value."%'";
				}
				elseif($key == "MEMO") {
					$sql .= " AND s.MEMO LIKE '%".$value."%'";
				}
			}
		}

		$getCountQuery   = "SELECT COUNT(*) AS CNT FROM".$sql;
		$getCountResult  = exequery($connection, $getCountQuery);
		if ($getCountRow = mysql_fetch_array($getCountResult)) {
			$resultCount = $getCountRow['CNT'];
		}
		if($order == "PRICE") {
			$sql .= " ORDER BY CAST(s.PRICE AS SIGNED)"." ".$sens;
		} else if($order == "DISCOUNT") {
			$sql .= " ORDER BY CAST(s.DISCOUNT AS DECIMAL)"." ".$sens;
		} else {
			$sql .= " ORDER BY s.".$order." ".$sens;
		}


		if($pagecount) {
			$end  = $end*$pagecount;
			//批量删除最后一页的数据，页面无跳转的问题的问题的修复
			if($end>=$resultCount)
			{
				$end = max(0,$end-$pagecount);
			}
			$sql .= " limit ".$end.",".$pagecount;
		}
		$cousor = exequery($connection,$select_sahistory.$sql);
		$count  = 0;
		while($row = mysql_fetch_array($cousor)) {
			$count++;
			$returnStr[$count][HISTORY_ID]    = $row["HISTORY_ID"];
			$returnStr[$count][CUSTOMER_ID]   = $row["CUSTOMER_ID"];
			$returnStr[$count][CUSTOMER_NAME] = $row["CUSTOMER_NAME"];
			$returnStr[$count][PRODUCT_ID]    = $row["PRODUCT_ID"];
			$returnStr[$count][PRODUCT_NAME]  = $row["PRODUCT_NAME"];
			$returnStr[$count][PRODUCT_ID]    = $row["PRODUCT_ID"];
			$returnStr[$count][DATE]          = $row["DATE"];
			$returnStr[$count][AMT]           = $row["AMT"];
			$returnStr[$count][PRICE]         = $row["PRICE"];
			$returnStr[$count][SALESMAN]      = $row["SALESMAN"];
			$returnStr[$count][DISCOUNT]      = $row["DISCOUNT"];
			$returnStr[$count][MEMO]          = $row["MEMO"];
			$returnStr[$count][DEPT]          = $row["PURVIEW_DEPT"];
			$returnStr[$count][ROLE]     	  = $row["PURVIEW_ROLE"];
			$returnStr[$count][USER]    	  = $row["PURVIEW_USER"];
			$returnStr[$count][MANAGE_USER]   = $row["MANAGE_USER"];
			$returnStr[$count][SALE_HISTORY_CREATE_USER] = $row["SALE_HISTORY_CREATE_USER"];
		}
		$returnStr[count($row)][COUNT] = $resultCount;
		return $returnStr;
	}

	/**供应商查询记录并返回
	*$order        排序字段
	*$sens         升降序字段
	*$where_str    保存查询信息的数组
	*$provider_id  供应商ID
	*$end          分页参数1
	*$pagecount    分页参数2
	*/
	function get_provider_info($order,$sens,$where_str='',$provider_id='',$end='',$pagecount='') {
		global $connection;
		$returnStr    = "";
		$login_priv   = $this->get_login_priv();
		$provider_select = "SELECT * FROM ";
		if($provider_id == '') {
			$query  = " provider WHERE 1=1";
		} else {
			$query  = " provider WHERE PROVIDER_ID='".$provider_id."'";
		}

		if($where_str!="") {
			foreach($where_str as $key=>$value) {
			    $value = SecurityFilter($value);
				if($key == "PROVIDER_NAME") {
					$query .= " AND PROVIDER_NAME LIKE '%".$value."%'";
				}
				elseif($key == "TEL_NO") {
					$query .= " AND TEL_NO LIKE '%".$value."%'";
				}
				elseif($key == "FAX_NO") {
					$query .= " AND FAX_NO LIKE '%".$value."%'";
				}
				elseif($key == "PROVIDER_WWW") {
					$query .= " AND PROVIDER_WWW LIKE '%".$value."%'";
				}
				elseif($key == "EMAIL") {
					$query .= " AND EMAIL LIKE '%".$value."%'";
				}
				elseif($key == "PROVIDER_ADD") {
					$query .= " AND PROVIDER_ADD LIKE '%".$value."%'";
				}
				elseif($key == "POSTALCODE") {
					$query .= " AND POSTALCODE LIKE '%".$value."%'";
				}
				elseif($key == "MEMO") {
					$query .= " AND MEMO LIKE '%".$value."%'";
				}
				elseif($key == "BANK") {
					$query .= " AND BANK LIKE '%".$value."%'";
				}
				elseif($key == "ACCOUNT") {
					$query .= " AND ACCOUNT LIKE '%".$value."%'";
				}
			}
		}

		$getCountQuery   = "SELECT COUNT(*) AS CNT FROM ".$query;
		$getCountResult  = exequery($connection, $getCountQuery);
		if ($getCountRow = mysql_fetch_array($getCountResult)) {
			$resultCount = $getCountRow['CNT'];
		}

		$query .= " ORDER BY ".$order." ".$sens;

		if($pagecount != "") {
			$end  = $end*$pagecount;
			//批量删除最后一页的数据，页面无跳转的问题的问题的修复
			if($end>=$resultCount)
			{
				$end = max(0,$end-$pagecount);
			}
			$query .= " limit ".$end.",".$pagecount;
		}
		$cousor = exequery($connection,$provider_select.$query);
		$count  = 0;
		if($provider_id == '') {
			while($row = mysql_fetch_array($cousor)) {
				$count++;
				$returnStr[$count][PROVIDER_ID]  = $row["PROVIDER_ID"];
				$returnStr[$count][TEL_NO]       = $row["TEL_NO"];
				$returnStr[$count][PROVIDER_NAME]= $row["PROVIDER_NAME"];
				$returnStr[$count][PROVIDER_WWW] = $row["PROVIDER_WWW"];
				$returnStr[$count][EMAIL]        = $row["EMAIL"];
				$returnStr[$count][PROVIDER_CREATE_USER] = $row["PROVIDER_CREATE_USER"];

			}
		} else {
			if($row = mysql_fetch_array($cousor)) {
				$count++;
				$returnStr[$count][PROVIDER_ID]  = $row["PROVIDER_ID"];
				$returnStr[$count][TEL_NO]       = $row["TEL_NO"];
				$returnStr[$count][PROVIDER_NAME]= $row["PROVIDER_NAME"];
				$returnStr[$count][PROVIDER_WWW] = $row["PROVIDER_WWW"];
				$returnStr[$count][EMAIL]        = $row["EMAIL"];
				$returnStr[$count][FAX_NO]       = $row["FAX_NO"];
				$returnStr[$count][PROVIDER_ADD] = $row["PROVIDER_ADD"];
				$returnStr[$count][POSTALCODE]   = $row["POSTALCODE"];
				$returnStr[$count][BANK]         = $row["BANK"];
				$returnStr[$count][ACCOUNT]      = $row["ACCOUNT"];
				$returnStr[$count][MEMO]         = $row["MEMO"];
				$returnStr[$count][PROVIDER_CREATE_USER] = $row["PROVIDER_CREATE_USER"];
			}
		}
		$returnStr[count($row)][COUNT] = $resultCount;
		return $returnStr;
	}

	/**获取产品的信息
	*$order     排序字段
	*$sens      升降序字段
	*$where_str 保存查询条件的数组
	*$end       分页参数1
	*$pagecount 分页参数2
	*/
	function get_product_info($order,$sens,$where_str='',$end='',$pagecount='') {
		global $connection;
		$returnStr    = "";
		$login_priv   = $this->get_login_priv();
		$accounts_str = $this->get_accounts_str( $login_priv );

		$select_product = "SELECT pt.*, pr.PROVIDER_NAME, pr.PROVIDER_ID FROM";
		$query  = " product as pt, provider as pr WHERE pt.PROVIDER_ID=pr.PROVIDER_ID ";

		if($where_str) {
			foreach($where_str as $key=>$value) {
                $value = SecurityFilter($value);
                if($key == "PROVIDER_ID") {
					$query .= " AND pt.PROVIDER_ID='".$value."'";
				}
				elseif($key == "PRODUCT_NAME") {
					$query .= " AND pt.PRODUCT_NAME LIKE '%".$value."%'";
				}
				elseif($key == "PRODUCT_TYPE") {
					$query .= " AND pt.PRODUCT_TYPE LIKE '%".$value."%'";
				}
				elseif($key == "MEASURE_UNIT") {
					$query .= " AND pt.MEASURE_UNIT LIKE '%".$value."%'";
				}
				elseif($key == "COST_PRICE") {
					if(is_numeric($value)) {
						$query .= " AND pt.COST_PRICE<=".$value;
					} else {
						$query .= " AND pt.COST_PRICE LIKE '%".$value."%'";
					}
				}
				elseif($key == "STANDARD_PRICE") {
					if(is_numeric($value)) {
						$query .= " AND pt.STANDARD_PRICE<=".$value;
					} else {
						$query .= " AND pt.STANDARD_PRICE LIKE '%".$value."%'";
					}
				}
				elseif($key == "PRODUCT_DESC") {
					$query .= " AND pt.PRODUCT_DESC LIKE '%".$value."%'";
				}
				elseif($key == "OTHER_FIELD") {
					$query .= " ".$value;
				}
			}
		}

		$getCountQuery   = "SELECT COUNT(*) AS CNT FROM".$query;
		$getCountResult  = exequery($connection, $getCountQuery);
		if ($getCountRow = mysql_fetch_array($getCountResult)) {
			$resultCount = $getCountRow['CNT'];
		}

		if($order == "COST_PRICE") {
			$query .= " ORDER BY CAST(pt.COST_PRICE AS SIGNED)"." ".$sens;
		} else if($order == "STANDARD_PRICE") {
			$query .= " ORDER BY CAST(pt.STANDARD_PRICE AS SIGNED)"." ".$sens;
		} else {
			$query .= " ORDER BY pt.".$order." ".$sens;
		}

		if($pagecount) {
			$end    = $end*$pagecount;
			//批量删除最后一页的数据，页面无跳转的问题的问题的修复
			if($end>=$resultCount)
			{
				$end = max(0,$end-$pagecount);
			}
			$query .= " limit ".$end.",".$pagecount;
		}
		$count  = 0;
		$cousor = exequery($connection,$select_product.$query);
		while($row = mysql_fetch_array($cousor)) {
			$count++;
			$returnStr[$count][PRODUCT_ID]          = $row["PRODUCT_ID"];
			$returnStr[$count][PRODUCT_NAME]        = $row["PRODUCT_NAME"];
			$returnStr[$count][PRODUCT_TYPE]        = $row["PRODUCT_TYPE"];
			$returnStr[$count][MEASURE_UNIT]        = $row["MEASURE_UNIT"];
			$returnStr[$count][COST_PRICE]          = $row["COST_PRICE"];
			$returnStr[$count][STANDARD_PRICE]      = $row["STANDARD_PRICE"];
			$returnStr[$count][PROVIDER_ID]         = $row["PROVIDER_ID"];
			$returnStr[$count][PROVIDER_NAME]       = $row["PROVIDER_NAME"];
			$returnStr[$count][PRODUCT_DESC]        = $row["PRODUCT_DESC"];
			$returnStr[$count][PRODUCT_CREATE_USER] = $row["PRODUCT_CREATE_USER"];
		}
		$returnStr[count($row)][COUNT] = $resultCount;
		return $returnStr;
	}

	/**获取目前产品表中的最大ID值,自定义字段需要的值
	*/
	function get_max_product_id() {
		global $connection;
		$sql = "SELECT MAX(PRODUCT_ID) AS mp_id FROM product";
		$cousor = exequery($connection,$sql);
		if($row = mysql_fetch_array($cousor))
			return $row;
	}

	/**获取业务机会最大ID
	*/
	function get_max_oper_id() {
		global $connection;
		$sql = "SELECT MAX(OPER_ID) AS mp_id FROM operation";
		$cousor = exequery($connection,$sql);
		if($row = mysql_fetch_array($cousor))
			return $row;
	}

    /**获取联系人最大ID
	*/
	function get_max_linkman_id() {
		global $connection;
		$sql = "SELECT MAX(LINKMAN_ID) AS mp_id FROM linkman";
		$cousor = exequery($connection,$sql);
		if($row = mysql_fetch_array($cousor))
			return $row;
	}

    /**获取客户最大ID
	*/
	function get_max_customer_id() {
		global $connection;
		$sql = "SELECT MAX(CUSTOMER_ID) AS mp_id FROM customer";
		$cousor = exequery($connection,$sql);
		if($row = mysql_fetch_array($cousor))
			return $row;
	}

    /**获取合同最大ID
	*/
	function get_max_contract_id() {
		global $connection;
		$sql = "SELECT MAX(CON_ID) AS mp_id FROM contract";
		$cousor = exequery($connection,$sql);
		if($row = mysql_fetch_array($cousor))
			return $row;
	}

	/**获取联系记录最大ID
	*/
	function get_max_record_id() {
		global $connection;
		$sql = "SELECT MAX(RE_ID) AS mp_id FROM relation_record";
		$cousor = exequery($connection,$sql);
		if($row = mysql_fetch_array($cousor))
			return $row;
	}

	//该查询一般用于根据客户id号查询该客户下所属的联系人,因为有客户id,所以不需要再做权限判断.
	function get_linkman_str_all()
	{
		$sql_string = "SELECT l.*,c.CUSTOMER_NAME,c.MANAGE_USER FROM linkman as l LEFT JOIN customer as c ON l.CUSTOMER_ID = c.CUSTOMER_ID where 1 " ;
		return $sql_string;
	}

	//根据当前登录的用户权限查询相应的联系人，需要根据当前登录用户的客户经理判断，查找该客户经理所属的联系人
	/*
	*$emailSearchParam 收件人查询功能传入的查询参数
	*/
	function get_linkman_str_with_preview($user_id='',$emailSearchParam='')
	{
		$purview_where = $this->get_purview_where();
		$sql_string	= "SELECT l.*, c.MANAGE_USER, c.CUSTOMER_NAME, u.USER_NAME
						  FROM linkman as l
						  LEFT JOIN customer as c ON l.CUSTOMER_ID = c.CUSTOMER_ID
						  INNER JOIN user as u ON u.USER_ID = c.MANAGE_USER
						  INNER JOIN user_priv as up ON up.USER_PRIV = u.USER_PRIV
								WHERE $purview_where";
		if($emailSearchParam)
			$sql_string.= $emailSearchParam;
		return $sql_string;
	}

	//获取登录用户的权限信息
	function get_login_priv($user_id='')
	{
		global $connection;
		if($user_id !="") {
			$user = $user_id;
		} else {
			$user = $_SESSION['LOGIN_USER_ID'];
		}
		$user = SecurityFilter($user);
		//再读登陆者的角色级别
		$sql = "SELECT up.USER_PRIV, up.PRIV_NO, u.DEPT_ID, u.USER_ID, u.USER_ACCOUNTS, u.POST_PRIV, u.POST_DEPT FROM user_priv as up
					 LEFT JOIN user as u ON(u.USER_PRIV = up.USER_PRIV)
						 WHERE  u.USER_ID='".$user."'";
		$cursor= exequery( $connection, $sql );
		if($row= mysql_fetch_array($cursor)) {
			$login_priv['priv_no']	 = $row["PRIV_NO"];
			$login_priv['priv_dept'] = $row["DEPT_ID"];
			$login_priv['priv_user'] = $row["USER_ID"];
			$login_priv['post_priv'] = $row['POST_PRIV'];
			$login_priv['post_dept'] = $row['POST_DEPT'];
			$login_priv['user_priv'] = $row['USER_PRIV'];
		}
		return $login_priv;
	}

	//客户信息管理页面的list页面的
	function get_c_info( $customer_type ,$_lang )
	{
		switch( $customer_type )
		{
			case '1':
				$c_title = $_lang["customer_query_formal"];
				$c_img	 = "<img src='/theme/".$_SESSION['LOGIN_THEME']."/images/icon/1-formal.gif' border='0'>";
				break;
			case '2':
				$c_title = $_lang["customer_query_important"];
				$c_img	 = "<img src='/theme/".$_SESSION['LOGIN_THEME']."/images/icon/2-emphasis.gif' border='0'>";
				break;
			case '3':
				$c_title = $_lang["customer_query_hidden"];
				$c_img	 = "<img src='/theme/".$_SESSION['LOGIN_THEME']."/images/icon/3-latent.gif' border='0'>";
				break;
			case '4':
				$c_title = $_lang["customer_query_ineffective"];
				$c_img	 = "<img src='/theme/".$_SESSION['LOGIN_THEME']."/images/icon/4-useless.gif' border='0'>";
				break;
			default:
				$c_title = $_lang["customer_query_no_state"];
				$c_img	 = "";
				break;
		}
		$c_info['title'] = $c_title;
		$c_info['img']   = $c_img;
		return $c_info;
	}

	/**客户转移
	*$user_id    用户ID
	*$where_str  查询条件的数组
	*/
	function get_customer_move_str($user_id,$where_str='')
	{
		global $connection;
		$login_priv   = $this->get_login_priv();
		$accounts_str = $user_id;
        $login_priv['priv_user'] = SecurityFilter($login_priv['priv_user']);
        $accounts_str = SecurityFilter($accounts_str);
        $login_priv['priv_no'] = SecurityFilter($login_priv['priv_no']);
        $login_priv['priv_dept'] = SecurityFilter($login_priv['priv_dept']);
        $login_priv['user_priv'] = SecurityFilter($login_priv['user_priv']);
		$sql = "SELECT c.CUSTOMER_ID, c.CUSTOMER_NAME, c.TEL_NO, c.FAX_NO, c.EMAIL, c.CUSTOMER_TYPE,c.MANAGE_USER,c.PURVIEW,u.USER_NAME, u.DEPT_ID, u.USER_ACCOUNTS
					FROM customer as c
					LEFT JOIN user as u ON(u.USER_ID = c.MANAGE_USER)
					LEFT JOIN user_priv as up ON(up.USER_PRIV = u.USER_PRIV)
					WHERE 1=1
					   AND((u.USER_ACCOUNTS IN($accounts_str)
						OR
						c.MANAGE_USER = '" .$login_priv['priv_user']. "'
						OR
						(up.PRIV_NO > '".$login_priv['priv_no']."' AND PURVIEW = 1 AND u.USER_ACCOUNTS IN($accounts_str))
						OR
						PURVIEW = 2
						OR
						(PURVIEW = 3
						AND
						(INSTR(CONCAT(',',PURVIEW_DEPT),',". $login_priv['priv_dept'] .",')>0
						OR
						 INSTR(CONCAT(',',PURVIEW_ROLE),',". $login_priv['user_priv'] .",')>0
						OR
						INSTR(CONCAT(',',PURVIEW_USER),',". $login_priv['priv_user'] .",')>0
						))))
				";
			foreach($where_str AS $key=>$value) {
                $value = SecurityFilter($value);
			if($key == "CUSTOMER_NAME") {
				$sql .= " AND c.CUSTOMER_NAME LIKE '%".$value."%'";
			} else if($key == "USER_ID") {
				$sql .= " AND u.USER_ID IN (".$value.")";
			}
		}
		$count  = 0;
		$cousor = exequery($connection,$sql);
		while($row = mysql_fetch_array($cousor)) {
			$count++;
			$returnStr[$count][CUSTOMER_ID]   = $row["CUSTOMER_ID"];
			$returnStr[$count][CUSTOMER_NAME] = $row["CUSTOMER_NAME"];
			$returnStr[$count][TEL_NO]        = $row["TEL_NO"];
			$returnStr[$count][FAX_NO]        = $row["FAX_NO"];
			$returnStr[$count][EMAIL]         = $row["EMAIL"];
			$returnStr[$count][CUSTOMER_ADD]  = $row["CUSTOMER_ADD"];
			$returnStr[$count][POSTALCODE]    = $row["POSTALCODE"];
			$returnStr[$count][MANAGE_USER]   = $row["MANAGE_USER"];
			$returnStr[$count][USER_NAME]     = $row["USER_NAME"];
			$returnStr[$count][CUSTOMER_TYPE] = $row["CUSTOMER_TYPE"];
			$returnStr[$count][PURVIEW] 	  = $row["PURVIEW"];
			$returnStr[$count][DEPT_ID] 	  = $row["DEPT_ID"];
			$returnStr[$count][USER_ACCOUNTS] = $row["USER_ACCOUNTS"];
			$returnStr[$count][CUSTOMER_NUMBER] = $row["CUSTOMER_NUMBER"];
			$returnStr[$count][CUSTOMER_WWW]  = $row["CUSTOMER_WWW"];
			$returnStr[$count][LE_PERSON]     = $row["LE_PERSON"];
		}
		$returnStr[count($row)][COUNT]  = $resultCount;
		return $returnStr;
	}

    /**获取联系人名称
	*$linkman_id   联系人ID
	*$customer_id  客户ID
	*/
	function get_linkmanname($linkman_id,$customer_id='') {
		global $connection;
		if($linkman_id && $customer_id=='') {
			$query  = "SELECT * FROM linkman WHERE LINKMAN_ID='".SecurityFilter($linkman_id)."'";
			$cousor = exequery($connection,$query);
			if($row = mysql_fetch_array($cousor)) {
				$LINKMAN_NAME = $row["LINKMAN_NAME"];
			}
			return $LINKMAN_NAME;
		} else {
			if($customer_id) {
				$query = "SELECT LINKMAN_ID, LINKMAN_NAME FROM linkman
							 WHERE CUSTOMER_ID=".SecurityFilter($customer_id)." ORDER BY LINKMAN_ID DESC LIMIT 0,1";
				$cousor = exequery($connection,$query);
				if($row = mysql_fetch_array($cousor)) {
					return $row;
				}
			}
		}
	}
	/**获取一条表数据
	*$table表名
	*$field字段
	*/
	function get_data($table,$field,$wh){
		global $connection;
		$sql  =  "SELECT ".$field."
			   		FROM ".$table."
					WHERE ".$wh."
					LIMIT 1";
		$query = exequery($connection,$sql);
		return mysql_fetch_array($query);
	}

	/**联系记录
	*$order             排序字段
	*$sens              升降序字段
	*$customer_id       客户ID
	*$where_str         保存查询条件的数组
	*$record_id         联系记录ID
	*$end               分页参数1
	*$pagecount         分页参数2
	*$quicksort         快速筛选参数
	*$pinyin            拼音检索参数
	*/
	function get_relation_record($order,$sens,$customer_id='',$where_str='',$record_id='',$end='',$pagecount='',$quicksort='',$pinyin='',$user_id='') {

		global $connection,$_lang;
		$login_priv   = $this->get_login_priv($user_id);
		//$accounts_str = $user_id;
		//判断客户ID是否在其中
		//$customer_ids = $this->get_customer_view_name($user_id);

		$count = 0;

		if($record_id == "") {
			if($customer_id) {
				$sql = "SELECT * FROM relation_record WHERE CUSTOMER_ID='".SecurityFilter($customer_id)."'";
			} else {
				if($customer_ids!="") {
					$sql = "SELECT * FROM relation_record WHERE CUSTOMER_ID IN(".substr($customer_ids,0,-1).")";
				} else {
					$sql = "SELECT * FROM relation_record WHERE CUSTOMER_ID=0";
				}
			}

			if($where_str) {
				foreach($where_str as $key=>$value) {
				    $value = SecurityFilter($value);
					if($key == "RE_DATE1") {
						$sql .= " AND RE_DATE1>='".$value."'";
					} else if($key == "RE_DATE2") {
						$sql .= " AND RE_DATE2<='".$value."'";
					} else if($key == "CUSTOMER_ID") {
						$sql .= " AND CUSTOMER_ID=".$value;
					} else if($key == "LINKMAN_ID") {
						$sql .= " AND lINKMAN_ID=".$value;
					} else if($key == "RE_TYPE") {
						if($value != 0) {
							$sql .= " AND RE_TYPE=".$value;
						}
					} else if($key == "RE_RECORD") {
						$sql .= " AND RE_RECORD LIKE '%".$value."%'";
					}
				}
			}

			if($pinyin=="" || $pinyin=="all") {
			} else if($pinyin=="#") {
				$sql .= " AND left(RE_TITLE_ZM,1) in ('0','1','2','3','4','5','6','7','8','9')";
			} else {
				$pinyin = strtolower($pinyin);
				$sql .= " AND left(RE_TITLE_ZM,1) ='".$pinyin."'";
			}

			if($quicksort) {
				switch($quicksort) {
					case"create":
						$sql .= " AND CREATEOR='".$login_priv["priv_user"]."'";
						break;
					case"thismonth":
						$sql .= " AND DATE_FORMAT(RE_DATE1,'%Y-%m')=DATE_FORMAT(NOW(),'%Y-%m')";
						break;
					case"lastmonth":
						$sql .= " AND ((DATE_FORMAT(RE_DATE1,'%Y-%m')=DATE_FORMAT(DATE_SUB(curdate(),INTERVAL 1 MONTH),'%Y-%m')) OR ((MONTH(CURDATE())=1 AND MONTH(RE_DATE1)=12 AND (YEAR(RE_DATE1)=YEAR(CURDATE())-1))))";
						break;
					case"thisweek":
						$thisMonday = date('Y-m-d', time()-86400*date('w')+(date('w')>0?86400:-6*86400));
						$thisSunday = date('Y-m-d', time()-86400*date('w')+(date('w')>0?(86400*7):86400));
							$sql .= " AND DATE_FORMAT(RE_DATE1,'%Y-%m-%d') >= '".$thisMonday."' AND DATE_FORMAT(RE_DATE1,'%Y-%m-%d')<='".$thisSunday."'";
						break;
					case"lastweek":
						$lastMonday = date('Y-m-d', time()-86400*date('w')+(date('w')>0?-6*86400:-14*86400));
						$lastSunday = date('Y-m-d', time()-86400*date('w')+(date('w')>0?0:-6*86400));
							$sql .= " AND DATE_FORMAT(RE_DATE1,'%Y-%m-%d') >= '$lastMonday' AND DATE_FORMAT(RE_DATE1,'%Y-%m-%d')<='$lastSunday'";
						break;
					case"tendays":
						$sql .= " AND RE_DATE1 BETWEEN DATE_SUB(CURDATE(), INTERVAL 9 DAY) AND CURDATE()";
						break;
					case"thirtydays":
						$sql .= " AND RE_DATE1 BETWEEN DATE_SUB(CURDATE(), INTERVAL 29 DAY) AND CURDATE()";
						break;
					case"hundreddays":
						$sql .= " AND RE_DATE1 BETWEEN DATE_SUB(CURDATE(), INTERVAL 99 DAY) AND CURDATE() ";
						break;
				}
			}

			preg_match('/SELECT ([^\"\']*)[\s]FROM[\s]/i', $sql, $reg);
			$getCountQuery   = str_replace($reg[1], 'COUNT(*) AS CNT', $sql);
			$getCountResult  = exequery($connection, $getCountQuery);
			if ($getCountRow = mysql_fetch_array($getCountResult)) {
				$resultCount = $getCountRow['CNT'];
			}

			$sql .= " ORDER BY ".$order." ".$sens;

			if($pagecount) {
				$end    = $end*$pagecount;
				//批量删除最后一页的数据，页面无跳转的问题的问题的修复
				if($end>=$resultCount)
				{
					$end = max(0,$end-$pagecount);
				}
				$sql .= " limit ".$end.",".$pagecount;
			}

			$cousor = exequery($connection,$sql);
			while($row = mysql_fetch_array($cousor)) {
				$count++;
				$reStr[$count][RE_ID]       = $row["RE_ID"];
				$reStr[$count][RE_TITLE]    = $row["RE_TITLE"];
				$reStr[$count][RE_DATE1]    = $row["RE_DATE1"];
				$reStr[$count][RE_DATE2]    = $row["RE_DATE2"];
				$reStr[$count][RE_TIME1]    = $row["RE_TIME1"];
				$reStr[$count][RE_TIME2]    = $row["RE_TIME2"];
				$reStr[$count][RE_RECORD]   = $row["RE_RECORD"];
				$reStr[$count][LINKMAN_ID]  = $row["LINKMAN_ID"];
				$reStr[$count][CUSTOMER_ID] = $row["CUSTOMER_ID"];
				$reStr[$count][CREATEOR]    = $row["CREATEOR"];


				if($reStr[$count][RE_TITLE]=="")
				{
					$reStr[$count][RE_TITLE] = $_lang["customer_not_have_title"];
				}
			}
		} else {
			$sql = "SELECT * FROM relation_record WHERE 1
					    AND RE_ID>0
					    AND RE_ID='".$record_id."'";
			$cousor = exequery($connection,$sql);
			if($row=mysql_fetch_array($cousor)) {
				$count++;
				$reStr[$count][RE_ID]       = $row["RE_ID"];
				$reStr[$count][RE_TITLE]    = $row["RE_TITLE"];
				$reStr[$count][RE_DATE1]    = $row["RE_DATE1"];
				$reStr[$count][RE_DATE2]    = $row["RE_DATE2"];
				$reStr[$count][RE_TIME1]    = $row["RE_TIME1"];
				$reStr[$count][RE_TIME2]    = $row["RE_TIME2"];
				$reStr[$count][CREATEOR]    = $row["CREATEOR"];
				$reStr[$count][RE_TYPE]     = $row["RE_TYPE"];
				$reStr[$count][RE_RECORD]   = $row["RE_RECORD"];
				$reStr[$count][LINKMAN_ID]  = $row["LINKMAN_ID"];
				$reStr[$count][CUSTOMER_ID] = $row["CUSTOMER_ID"];
				$reStr[$count][CREATEOR]    = $row["CREATEOR"];
				$reStr[$count][CUSTOMER_NAME]   = $info[CUSTOMER_NAME];
				$reStr[$count][ATTACHMENT_ID]   = $row["ATTACHMENT_ID"];
				$reStr[$count][ATTACHMENT_NAME] = $row["ATTACHMENT_NAME"];
				if($reStr[$count][RE_TITLE] == "")
				{
				     $reStr[$count][RE_TITLE] = $_lang["customer_not_have_title"];
				}
			}
		}

		$reStr[count($row)][COUNT] =$resultCount;

		return $reStr;
	}

	/**获取业务机会信息(包括有权限看到的和详情页面某条具体业务机会信息)
	*$user_id            用户ID
	*$order              排序字段
	*$sens               升降序字段
	*$where_str          保存查询条件的数组
	*$customer_id        客户ID
	*$oper_id            业务机会ID
	*$end                分页参数1
	*$Pagecount          分页参数2
	*$pinYinSearchParam  拼音检索参数
	*$quicksort          快速筛选参数
	*/
	function get_operation_str($user_id,$order,$sens,$where_str='',$customer_id='',$oper_id='',$end='',$pagecount='',$pinYinSearchParam='',$quicksort='')
	{
		global $connection;
		$returnStr    = "";
		$login_priv   = $this->get_login_priv();
		$accounts_str = $user_id;
		$customer_ids = $this->get_customer_view_name($user_id);

		if($customer_id == '' && $oper_id == '') {
			if($customer_ids != "") {
				$sql  = "SELECT * FROM operation
						WHERE CUSTOMER_ID IN (".SecurityFilter(substr($customer_ids,0,-1)).")";
			} else {
				$sql = "SELECT * FROM operation WHERE CUSTOMER_ID=0";
			}
		} elseif($customer_id !='' && $oper_id == '') {
			$sql  = "SELECT * FROM operation
						WHERE CUSTOMER_ID='".SecurityFilter($customer_id)."'
					";
		} elseif($oper_id && $customer_id=='') {
			$sql = "SELECT * FROM operation
						WHERE OPER_ID='".SecurityFilter($oper_id)."'";
		}
		if($pinYinSearchParam=='' || $pinYinSearchParam=='all') {
		} else if($pinYinSearchParam == "#") {
			$sql .= " AND left(OPER_NAME_ZM,1) in ('0','1','2','3','4','5','6','7','8','9')";
		} else {
			$pinYinSearchParam = strtolower($pinYinSearchParam);
			$sql .= " AND left(OPER_NAME_ZM,1) ='" . SecurityFilter($pinYinSearchParam) . "'";
		}

		if($where_str) {
			foreach($where_str as $key=>$value) {
                $value = SecurityFilter($value);
				if($key == "OPER_NAME") {
					$sql .= " AND OPER_NAME LIKE '%".$value."%'";
				} else if($key == "OPER_TYPE") {
					if($value != "") {
						$sql .= " AND OPER_TYPE=".$value;
					}
				} else if($key == "CUSTOMER_ID") {
					$sql .= " AND CUSTOMER_ID=".$value;
				} else if($key == "OPER_POSSIBLE") {
					if(is_numeric($value)) {
						$sql .= " AND OPER_ORIGIN<='".$value."'";
					} else {
						$sql .= " AND OPER_ORIGIN LIKE '%".$value."%'";
					}
				} else if($key == "OPER_MONEY") {
					if(is_numeric($value)) {
						$sql .= " AND OPER_MONEY<='".$value."'";
					} else {
						$sql .= " AND OPER_MONEY LIKE '%".$value."%'";
					}
				} else if($key == "OPER_DATE") {
					$sql .= " AND OPER_DATE<='".$value."'";
				} else if($key == "OPER_SOURCE") {
					if($value != "") {
						$sql .= " AND OPER_SOURCE=".$value;
					}
				} else if($key == "OPERATION_STEP") {
					if($value != "") {
						$sql .= " AND OPER_STEP=".$value;
					}
				} else if($key == "OTHER_FIELD") {
					$sql .= " ".$value;
				}
			}
		}

		if($quicksort) {
			switch($quicksort) {
				case "create":
					$sql .= " AND CREATOR='".SecurityFilter($login_priv["priv_user"])."'";
					break;
				case "monthend":
					$sql .= " AND DATE_FORMAT(OPER_DATE,'%Y-%m')=DATE_FORMAT(NOW(),'%Y-%m')";
					break;
				case "thismonth":
					$sql .= " AND DATE_FORMAT(CREATE_TIME,'%Y-%m')=DATE_FORMAT(NOW(),'%Y-%m')";
					break;
				case "startrank":
					$sql .= " ORDER BY CAST(OPER_START AS DECIMAL) DESC LIMIT 0,10";
					break;
			}
		}

		preg_match('/SELECT ([^\"\']*)[\s]FROM[\s]/i', $sql, $reg);
		$getCountQuery   = str_replace($reg[1], 'COUNT(*) AS CNT', $sql);
		$getCountResult  = exequery($connection, $getCountQuery);
		if ($getCountRow = mysql_fetch_array($getCountResult)) {
			$resultCount = $getCountRow['CNT'];
			if($quicksort == "startrank") {
				if($resultCount > 10) {
					$resultCount = 10;
				}
			}
		}

		if($quicksort != "startrank") {
			$sql   .= " ORDER BY ".$order." ".$sens;
		}

		if($pagecount) {
			$end    = $end*$pagecount;
			//批量删除最后一页的数据，页面无跳转的问题的问题的修复
			if($end>=$resultCount)
			{
				$end = max(0,$end-$pagecount);
			}
			if($quicksort != "startrank") {
				$sql   .= " limit ".$end.",".$pagecount;
			}
		}
		$count  = 0;
		$cousor = exequery($connection,$sql);
		while($row = mysql_fetch_array($cousor)) {
			$count++;
			$returnStr[$count][OPER_ID]     = $row["OPER_ID"];
			$returnStr[$count][OPER_NAME]   = $row["OPER_NAME"];
			$returnStr[$count][OPER_MONEY]  = $row["OPER_MONEY"];
			$returnStr[$count][OPER_ORIGIN] = $row["OPER_ORIGIN"];
			$returnStr[$count][OPER_TYPE]   = $row["OPER_TYPE"];
			$returnStr[$count][OPER_SOURCE] = $row["OPER_SOURCE"];
			$returnStr[$count][OPER_STEP]   = $row["OPER_STEP"];
			$returnStr[$count][OPER_START]  = $row["OPER_START"];
			$returnStr[$count][OPER_DATE]   = $row["OPER_DATE"];
			$returnStr[$count][OPER_NOTE]   = $row["OPER_NOTE"];
			$returnStr[$count][CUSTOMER_ID] = $row["CUSTOMER_ID"];
			$returnStr[$count][CREATEOR]    = $row["CREATOR"];
			$returnStr[$count][OPER_STATUS] = $row["OPER_STATUS"];
			$returnStr[$count][CREATE_TIME] = $row["CREATE_TIME"];
		}
		$returnStr[count($row)][COUNT] = $resultCount;
		return $returnStr;
	}

	/**获取业务机会的追踪记录
	*$oper_id 业务机会ID
	*$end
	*/
	function get_oper_record($oper_id,$end='') {
		global $connection;
		$query  = "SELECT * FROM oper_records WHERE OPER_ID='".SecurityFilter($oper_id)."' ORDER BY OPRE_ID DESC";
		if($end) {
			$query .= " LIMIT 0,1";
		}

		$cousor    = exequery($connection,$query);
		$returnStr = array();
		$count = 0;
		if($row = mysql_fetch_array) {
			while($row = mysql_fetch_array($cousor)) {
				$count++;
				$returnStr[$count][LAST_PO]   = $row["LAST_PO"];
				$returnStr[$count][THIS_PO]   = $row["THIS_PO"];
				$returnStr[$count][OPER_TEXT] = $row["OPER_TEXT"];
				$returnStr[$count][OPER_STEP] = $row["OPER_STEP"];
				$returnStr[$count][RE_DATE]   = $row["RE_DATE"];
				$returnStr[$count][CREATEOR]  = $row["CREATEOR"];
			}
			$return[$count][COUNT] = mysql_num_rows($cousor);
		}
		return $returnStr;
	}

	/**获取合同信息的方法(包括有权限的和合同详情页面的某条合同的信息)
	*$order        排序字段
	*$sens         升降序字段
	*$where_str    查询条件信息保存的数组
	*$con_id       合同的ID
	*$customer_id  客户ID
	*$end          分页参数1
	*$pagecount    分页参数2
	*$quicksort    快速筛选参数
	*$pinyinsearch 拼音检索参数
	*/
	function get_contract_info($order,$sens,$where_str='',$con_id='',$customer_id='',$end='',$pagecount='',$quicksort='',$pinyinsearch='',$user_id='') {
		global $connection;
		$returnStr    = "";
		$login_priv   = $this->get_login_priv();
		$accounts_str = $user_id;
		$customer_ids = $this->get_customer_view_name($user_id);

		$contract_select = "SELECT * FROM";
		if($con_id=='') {
			if($customer_id=="") {
				if($customer_ids != "") {
					$query = " contract
							 WHERE CUST_ID IN(".SecurityFilter(substr($customer_ids,0,-1)).")";
				} else {
					$query = " contract WHERE CUST_ID=0";
				}
			} else {
				$query = " contract
							 WHERE CUST_ID =".SecurityFilter($customer_id);
			}
			if($where_str) {
				foreach($where_str as $key=>$value) {
				    $value = SecurityFilter($value);
					if($key == "CONTRACT_NAME") {
						$query .= " AND CON_NAME LIKE '%".$value."%'";
					} else if($key == "CONTRACT_NO") {
						$query .= " AND CON_NO LIKE '%".$value."%'";
					} else if($key == "CUSTOMER_ID") {
						$query .= " AND CUST_ID =".$value;
					} else if($key == "CONTACT_DATE") {
						$query .= " AND CON_DATE1>='".$value."'";
					} else if($key == "CONTACT_DATE2") {
						$query .= " AND CON_DATE2<='".$value."'";
					} else if($key == "SIGNER_NAME") {
						$query .= " AND CON_SIGNATORY LIKE '%".$value."%'";
					} else if($key == "CON_CSIGN") {
						$query .= " AND CON_CSIGN LIKE '%".$value."%'";
					} else if($key == "CONTACT_DATE3") {
						$query .= " AND SIGNATORY_DATE<='".$value."'";
					} else if($key == "CONTACT_DATE4") {
						$query .= " AND CSIGN_DATE <='".$value."'";
					}
				}
			}

			if($pinyinsearch=="" || $pinyinsearch=="all") {
			} else if($pinyinsearch=="#") {
				$query .= " AND left(CON_NAME_ZM,1) in ('0','1','2','3','4','5','6','7','8','9')";
			} else {
				$pinyinsearch = strtolower($pinyinsearch);
				$query .= " AND left(CON_NAME_ZM,1) ='" . SecurityFilter($pinyinsearch) . "'";
			}

			if($quicksort) {
				switch($quicksort) {
					case"create":
						$query .= " AND CREATEOR='".SecurityFilter($login_priv["priv_user"])."'";
						break;
					case"money":
						$query .= " ORDER BY CAST(`CON_COUNT` AS DECIMAL) DESC,CON_ID DESC LIMIT 0,10";
						break;
					case"thisyear":
						$query .= " AND DATE_FORMAT(CON_DATE2,'%Y')=DATE_FORMAT(NOW(),'%Y')";
						break;
					case"thismonth":
						$query .= " AND DATE_FORMAT(CON_DATE2,'%Y-%m')=DATE_FORMAT(NOW(),'%Y-%m')";
						break;
					case"nextmonth":
						$query .= " AND ((MONTH(CON_DATE2)=(MONTH(CURDATE())+1) AND YEAR(CON_DATE2)=YEAR(CURDATE()))
										OR (MONTH(CURDATE())=12 AND MONTH(con_date2)=1 AND (YEAR(con_date2)=YEAR(CURDATE())+1)))";
						break;
				}
			}


			$getCountQuery   = "SELECT COUNT(*) AS CNT FROM".$query;
			$getCountResult  = exequery($connection, $getCountQuery);
			if ($getCountRow = mysql_fetch_array($getCountResult)) {
				$resultCount = $getCountRow['CNT'];
				if($quicksort == "money") {
					if($resultCount > 10) {
						$resultCount = 10;
					}
				}
			}

			if($quicksort != "money") {
				$query .= " ORDER BY ".$order." ".$sens;
			}

			if($pagecount) {
				$end    = $end*$pagecount;
				//批量删除最后一页的数据，页面无跳转的问题的问题的修复
				if($end>=$resultCount)
				{
					$end = max(0,$end-$pagecount);
				}
				if($quicksort != "money") {
					$query .= " limit ".$end.",".$pagecount;
				}
			}
			$count  = 0;
			$cousor = exequery($connection,$contract_select.$query);
			while($row = mysql_fetch_array($cousor)) {
				$count++;
				$returnStr[$count][CON_ID]    = $row["CON_ID"];
				$returnStr[$count][CON_NAME]  = $row["CON_NAME"];
				$returnStr[$count][CON_NO]    = $row["CON_NO"];
				$returnStr[$count][CON_DATE1] = $row["CON_DATE1"];
				$returnStr[$count][CON_DATE2] = $row["CON_DATE2"];
				$returnStr[$count][CUST_ID]   = $row["CUST_ID"];
				$returnStr[$count][CON_NOTE]  = $row["CON_NOTE"];
				$returnStr[$count][CON_COUNT] = $row["CON_COUNT"];
				$returnStr[$count][CREATEOR]  = $row["CREATEOR"];
			}
		} else {
			$query = "SELECT * FROM contract
						  WHERE  CON_ID='".SecurityFilter($con_id)."'";

			preg_match('/SELECT ([^\"\']*)[\s]FROM[\s]/i', $query, $reg);
			$getCountQuery   = str_replace($reg[1], 'COUNT(*) AS CNT', $query);
			$getCountResult  = exequery($connection, $getCountQuery);
			if ($getCountRow = mysql_fetch_array($getCountResult)) {
				$resultCount = $getCountRow['CNT'];
			}
			if($pagecount) {
				$end    = $end*$pagecount;
				$query .= " limit ".$end.",".$pagecount;
			}

			$count  = 0;
			$cousor = exequery($connection,$query);
			if($row = mysql_fetch_array($cousor)) {
				$count++;
				$returnStr[$count][CON_ID]    = $row["CON_ID"];
				$returnStr[$count][CON_NAME]  = $row["CON_NAME"];
				$returnStr[$count][CON_NO]    = $row["CON_NO"];
				$returnStr[$count][CON_DATE1] = $row["CON_DATE1"];
				$returnStr[$count][CON_DATE2] = $row["CON_DATE2"];
				$returnStr[$count][CUST_ID]   = $row["CUST_ID"];
				$returnStr[$count][CON_SIGNATORY]  = $row["CON_SIGNATORY"];
				$returnStr[$count][CON_CSIGN]	   = $row["CON_CSIGN"];
				$returnStr[$count][SIGNATORY_DATE] = $row["SIGNATORY_DATE"];
				$returnStr[$count][CSIGN_DATE]     = $row["CSIGN_DATE"];
				$returnStr[$count][CON_TYPE]       = $row["CON_TYPE"];
				$returnStr[$count][COUNT]     = $row["CON_COUNT"];
				$returnStr[$count][CREATEOR]  = $row["CREATEOR"];
				$returnStr[$count][CON_NOTE]  = $row["CON_NOTE"];
				$returnStr[$count][ATTACHMENT_ID]   = $row["ATTACHMENT_ID"];
				$returnStr[$count][ATTACHMENT_NAME] = $row["ATTACHMENT_NAME"];
				$returnStr[$count][CREATEOR]        = $row["CREATEOR"];
			}
		}
		$returnStr[count($row)][COUNT] = $resultCount;
		return $returnStr;
	}

	/**获取客户的信息(根据客户名)
	*$customer_name 客户名
	*$like sql语句模糊查询
	*/
	function get_customerinfo($customer_name,$like='') {
		global $connection;
		$login_priv   = $this->get_login_priv();
		$accounts_str = $user_id;
		$returnStr    = "";
		if($like=='') {
			$sql = "SELECT * FROM customer
			            WHERE CUSTOMER_NAME='".SecurityFilter($customer_name)."'";
			$cousor = exequery($connection,$sql);
			if($row = mysql_fetch_array($cousor)) {
				return $row;
			}
		} else {
			$sql 	= "SELECT * FROM customer WHERE CUSTOMER_NAME LIKE '%".SecurityFilter($customer_name)."%'";
			$cousor = exequery($connection,$sql);
			$count=0;
			while($row = mysql_fetch_array($cousor)) {
				$count++;
				$returnStr[$count][CUSTOMER_ID]   = $row["CUSTOMER_ID"];
				$returnStr[$count][CUSTOMER_NAME] = $row["CUSTOMER_NAME"];
				$returnStr[$count][MANAGE_USER]   = $row["MANAGE_USER"];
				$returnStr[$count][PURVIEW]       = $row["PURVIEW"];
				$returnStr[$count][PURVIEW_DEPT]  = $row["PURVIEW_DEPT"];
				$returnStr[$count][PURVIEW_ROLE]  = $row["PURVIEW_ROLE"];
				$returnStr[$count][PURVIEW_USER]  = $row["PURVIEW_USER"];
			}
			return $returnStr;
		}
	}

		/**
	 * 获取类似的客户信息
	 *
	 * @param  string $name
	 * @return array $where_str
	 */
	function getSimiliarCustomerByName($name){
		global $connection;
		$sql    = " SELECT customer_id,customer_name FROM customer WHERE CUSTOMER_NAME LIKE '%". SecurityFilter($name) ."%' ORDER BY CUSTOMER_ID DESC limit 0,10";
		$cursor = exequery( $connection, $sql );

		while( $row = mysql_fetch_array( $cursor, MYSQL_ASSOC) ){
			$result[] = $row;
		}

		if( !empty($result) )
			return $result;
		else
			return false;
	}

	/**获取客户的信息(根据客户ID)
	*$customer_id 客户的ID
	*/
	function get_customer_info($customer_id,$purview=1){
		$row = $this->getDataOne('customer','*',array('CUSTOMER_ID'=>$customer_id));
		if($row) {
			if($purview==1){
				$PurviewValue = $this->getPurview($row);
				if($PurviewValue) {
					return $row;
				}
			}else{
				return $row;
			}
		}
	}

	/**判断客户的权限(系统播报中用到的方法)
	*$customer_id 客户的ID
	*/
	function get_customer_purview($customer_id) {
		global $connection;
		$login_priv   = $this->get_login_priv();
		$accounts_str = $user_id;
		$sql = "SELECT * FROM customer
		           WHERE CUSTOMER_ID='".SecurityFilter($customer_id)."'";
		$cousor = exequery($connection,$sql);
		if($row = mysql_fetch_array($cousor)) {
			$PurviewValue = $this->getPurview ($row);
			if($PurviewValue) {
				return true;
			} else {
				return false;
			}
		}
	}

	/**是否有联系记录的权限
	*$re_id 联系记录的ID
	*/
	function get_record_purview($re_id) {
		global $connection;
		$sql = "SELECT * FROM relation_record WHERE RE_ID='".SecurityFilter($re_id)."'";
		$cousor = exequery($connection,$sql);
		if($row = mysql_fetch_array($cousor)) {
			$cust_id = $row["CUSTOMER_ID"];
		}
		$customer_purview = $this->get_customer_purview($cust_id);
		if($customer_purview) {
			return true;
		} else {
			return false;
		}
	}

	/**是否有客户查看权限
	*$arr  保存客户ID和客户经理信息的数组
	*/
	function getPurview($arr) {
		global $connection;
		$purview_where = $this->get_purview_where();

		$CustomerId  = $arr['CUSTOMER_ID'];
		$Manage_user = $arr['MANAGE_USER'];

		$query = "
			SELECT COUNT(*) as CNT2 FROM customer as c
				LEFT JOIN user as u ON(u.USER_ID = c.MANAGE_USER)
				LEFT JOIN user_priv as up ON(up.USER_PRIV = u.USER_PRIV)
				WHERE CUSTOMER_ID = '".SecurityFilter($CustomerId)."'
					AND $purview_where";
		$cousor = exequery ($connection,$query);
		$row = mysql_fetch_array($cousor);
		$CNT2 = $row ["CNT2"];
		if ($CNT2 == 0 && $Manage_user != $login_priv['priv_user'])
		{
			return false;
		}
		else
		{
			return true;
		}
	}

	/**删除数据的方法
	*$tableName  删除的数据表名
	*$tableId    数据表中的ID
	*/
	function del_data($tableName,$tableId) {
		global $connection;
		switch($tableName) {
			case 'LINKMAN':
				$this->del_linkman($tableId);
				break;
			case 'OPERATION':
				$this->del_operation($tableId);
				break;
			case 'RELATION_RECORD':
				$this->del_relation_record($tableId);
				break;
			case 'RELATION_REMIND':
				$this->del_relation_remind($tableId);
			break;
			case 'CONTRACT':
				$this->del_contract($tableId);
				break;
			case 'SMS':
				$this->del_sms($tableId);
			break;
			case 'SALE_HISTORY':
				$this->del_sale_history($tableId);
				break;
			case 'PROVIDER':
				$this->del_provider($tableId);
				break;
			case 'PRODUCT':
				$this->del_product($tableId);
				break;
		}
	}

    /**删除联系人
	*$Linkman_id 联系人表中的ID
	*/
	function del_linkman($linkman_id) {
		global $connection;
		$query = "DELETE FROM LINKMAN WHERE LINKMAN_ID='".SecurityFilter($linkman_id)."'";
		exequery($connection,$query);

		$sql = "DELETE FROM relation_record WHERE LINKMAN_ID='".SecurityFilter($linkman_id)."'";
		exequery($connection,$sql);
	}

	/**删除业务机会
	*$oper_id 业务机会表中的ID
	*/
	function del_operation($oper_id) {
		global $connection;
		$query = "DELETE FROM operation WHERE OPER_ID='".SecurityFilter($oper_id)."'";
		exequery($connection,$query);

		$sql = "DELETE FROM oper_records WHERE OPER_ID='".SecurityFilter($oper_id)."'";
		exequery($connection,$sql);
	}

	/**删除消息提醒
	*$sms_id 消息表中的SMS_ID
	*/
	function del_sms($sms_id) {
		global $connection;
		$query = "DELETE FROM sms WHERE SMS_ID='".SecurityFilter($sms_id)."'";
		exequery($connection,$query);
	}

	/**删除联系记录
	*$re_id 联系记录表中的ID
	*/
	function del_relation_record($re_id) {
		global $connection;
		$login_priv = $this->get_login_priv();

		$sql = "SELECT * FROM relation_record WHERE RE_ID='".SecurityFilter($re_id)."'";

		$cousor = exequery($connection,$sql);
		if($row = mysql_fetch_array($cousor)) {
			if($row["RE_TITLE"] == "") {
				$row["RE_TITLE"] = $_lang["customer_not_have_title"];
			}
			$remarkArray["title"] = $row["RE_TITLE"];
			$remarkRecord         = addslashes(json_encode($remarkArray));

			if ($row["ATTACHMENT_ID"]!="" && $row["ATTACHMENT_NAME"]!="") {
				$attachment_id_arr = explode(",", $row["ATTACHMENT_ID"]);
				$attachment_name_arr = explode("*", $row["ATTACHMENT_NAME"]);

				for ($i=0; $i <count($attachment_id_arr); $i++) {
					global $ATTACH_PATH;
				    $PATH = $ATTACH_PATH . $attachment_id_arr[$i];

				    $FILENAME = $PATH . "/" . $attachment_name_arr[$i];
				    $FILENAME = ICONV('UTF-8', 'GBK', $FILENAME);

				    @unlink($FILENAME);
				    @rmdir($PATH);
				}
			}

			$query = "DELETE FROM relation_record WHERE RE_ID='".SecurityFilter($re_id)."'";
			exequery($connection,$query);

			AddBroacastLog($login_priv["priv_user"],"RELATION_RECORD","RE_ID",$re_id,"RE_TITLE","delete",$remarkRecord);
		}
	}

	/**删除联系提醒
	*$remind_id 联系提醒表中的ID
	*/
	function del_relation_remind($remind_id) {
		global $connection;
		$login_priv = $this->get_login_priv();

		$sql = "SELECT * FROM relation_remind WHERE REMIND_ID='".SecurityFilter($remind_id)."'";

		$cousor = exequery($connection,$sql);
		if($row = mysql_fetch_array($cousor)) {

			$query = "DELETE FROM relation_remind WHERE REMIND_ID='".SecurityFilter($remind_id)."'";
			exequery($connection,$query);

			// AddBroacastLog($login_priv["priv_user"],"RELATION_REMIND","REMIND_ID",$remind_id,"delete",$remarkRecord);
		}
	}

    /**删除合同
	*$con_id 合同表中的ID
	*/
	function del_contract($con_id) {
	    $con_id = SecurityFilter($con_id);
		global $connection;
		$query = "DELETE FROM contract WHERE CON_ID='".$con_id."'";
		exequery($connection,$query);

		unset($query);
		$querys = "DELETE FROM contract_payment WHERE CON_ID='".$con_id."'";
		exequery($connection,$querys);

		$sql = "DELETE FROM sms WHERE TABLE_NAME='CONTRACT_PAYMENT' AND TABLE_ID='".$con_id."'";
		exequery($connection,$sql);

		$query1 = "DELETE FROM sms WHERE TABLE_NAME='CONTRACT' AND TABLE_ID='".$con_id."'";
		exequery($connection,$query1);
	}

    /**删除销售记录
	*$history_id 销售纪录表中的ID
	*/
	function del_sale_history($history_id) {
		global $connection;
		$query = "DELETE FROM sale_history WHERE HISTORY_ID='".SecurityFilter($history_id)."'";
		exequery($connection,$query);
	}

	/**删除供应商
	*$provider_id 供应商表中的ID
	*/
	function del_provider($provider_id) {
		global $connection;
		$query = "DELETE FROM provider WHERE PROVIDER_ID='".SecurityFilter($provider_id)."'";
		exequery($connection,$query);
	}

    /**删除产品
	*$product_id 产品表中的ID
	*/
	function del_product($product_id) {
		global $connection;
		$query = "DELETE FROM product WHERE PRODUCT_ID='".SecurityFilter($product_id)."'";
		exequery($connection,$query);

		$sql = "DELETE FROM sale_history WHERE PRODUCT_ID='".SecurityFilter($product_id)."'";
		exequery($connection,$sql);
	}

	/**新建保存数据
	*$tableName  保存到那个数据表中
	*$inarr      保存的相关新建信息的数组
	*/
	function saveData($tableName,$inarr) {
		global $connection,$_lang;
		switch($tableName) {
			case 'CUSTOMER':
				$this->addCustomer($inarr);
				break;
			case 'LINKMAN':
				$this->addLinkman($inarr);
				break;
			case 'OPERATION':
				$this->addOperation($inarr);
				break;
			case 'RELATION_RECORD':
				$this->addRelationRecord($inarr);
				break;
			case 'RELATION_REMIND':
				$this->addRelationRemind($inarr);
				break;
			case 'CONTRACT':
				$this->addContract($inarr);
				break;
			case 'SALE_HISTORY':
				$this->addSaleHistory($inarr);
				break;
			case 'PROVIDER':
				$this->addProvider($inarr);
				break;
			case 'PRODUCT':
				$this->addProduct($inarr);
				break;
			case 'OPER_RECORDS':
				$this->addOperRecords($inarr);
				break;
			case 'CONTRACT_PAYMENT':
				$this->addContractPayment($inarr);
				break;
		}
	}

	/**新增客户
	*$inarr 保存客户信息的数组
	*/
	function addCustomer($inarr) {
		global $connection;
		$login_priv = $this->get_login_priv();

		if($inarr[0]!="") {
			$query = " INSERT INTO CUSTOMER (CUSTOMER_NAME,TEL_NO,FAX_NO,CUSTOMER_WWW,EMAIL,CUSTOMER_ADD,POSTALCODE,MEMO,MANAGE_USER,
				CREATE_TIME,CUSTOMER_NUMBER,CUSTOMER_TYPE,SCALE,CUSTOMER_INDUSTRY,CUSTOMER_PROFIT,PROVINCE,CITY,PURVIEW,
				PURVIEW_DEPT,PURVIEW_ROLE,PURVIEW_USER,CREATEOR,BIRTHDAY_REMIND_SMS,BIRTHDAY_REMIND,LE_PERSON,PERSON_INFO,CUSTOMER_NAME_PY,CUSTOMER_NAME_ZM,CUSTOMER_STATUS,CUSTOMER_STATE,SERVICE_USER,CUSTOMER_ATTRIBUTE)
				VALUES ('".
                SecurityFilter($inarr[0])."','".
                SecurityFilter($inarr[1])."','" .
                SecurityFilter($inarr[2])."','".
                SecurityFilter($inarr[3])."','".
                SecurityFilter($inarr[4])."','".
                SecurityFilter($inarr[5])."','".
                SecurityFilter($inarr[6])."','".
                SecurityFilter($inarr[7])."','".
                SecurityFilter($inarr[8])."','".
                SecurityFilter($inarr[9])."','".
                SecurityFilter($inarr[10])."','".
                SecurityFilter($inarr[11])."','".
                SecurityFilter($inarr[12])."','".
                SecurityFilter($inarr[13])."','".
                SecurityFilter($inarr[14])."','".
                SecurityFilter($inarr[15])."','".
                SecurityFilter($inarr[16])."','".
                SecurityFilter($inarr[17])."','".
                SecurityFilter($inarr[18])."','".
                SecurityFilter($inarr[19])."','".
                SecurityFilter($inarr[20])."','".
                SecurityFilter($inarr[21])."','".
                SecurityFilter($inarr[22])."','".
                SecurityFilter($inarr[23])."','".
                SecurityFilter($inarr[24])."','".
                SecurityFilter($inarr[25])."','".
                SecurityFilter($inarr[27])."','".
                SecurityFilter($inarr[28])."','".
                SecurityFilter($inarr[29])."','".
                SecurityFilter($inarr[30])."','".
                SecurityFilter($inarr[31])."')";

			exequery($connection,$query);

			$customer_id = $this->get_max_customer_id();
			AddBroacastLog($login_priv["priv_user"],"CUSTOMER","CUSTOMER_ID",$customer_id["mp_id"],"CUSTOMER_NAME","new");
		} else {
			return false;
		}
	}

    /**新增联系人
	*$inarr 保存联系人信息的数组
	*/
	function addLinkman($inarr) {
		global $connection;
		if($inarr[0]!= "" && $inarr[1]!="") {
            $query = "INSERT INTO linkman (CUSTOMER_ID,LINKMAN_NAME,CREATEOR,SEX,BIRTHDAY,POST_PRIV,LINK_DEPT,HOBBY,ADD_HOME,
					POSTALCODE_HOME,TEL_NO_WORK,TEL_NO_HOME,FAX_NO,MOBILE,EMAIL,OICQ,ICQ,MEMO,ATTACHMENT_ID,ATTACHMENT_NAME,
					LINKMAN_NAME_PY,LINKMAN_NAME_ZM) VALUES ('" . SecurityFilter($inarr[0]) . "','" . SecurityFilter($inarr[1]) . "','" . SecurityFilter($inarr[2]) . "','" . SecurityFilter($inarr[3]) . "','" . SecurityFilter($inarr[4]) . "','" . SecurityFilter($inarr[5]) . "','" . SecurityFilter($inarr[6]) . "','" . SecurityFilter($inarr[7]) . "','" . SecurityFilter($inarr[8]) . "','" . SecurityFilter($inarr[9]) . "','" . SecurityFilter($inarr[10]) . "','" . SecurityFilter($inarr[11]) . "','" . SecurityFilter($inarr[12]) . "','" . SecurityFilter($inarr[13]) . "','" . SecurityFilter($inarr[14]) . "','" . SecurityFilter($inarr[15]) . "','" . SecurityFilter($inarr[16]) . "','" . SecurityFilter($inarr[17]) . "','" . SecurityFilter($inarr[18]) . "','" . SecurityFilter($inarr[19]) . "','" . SecurityFilter($inarr[20]) . "','" . SecurityFilter($inarr[21]) . "')";
			exequery($connection,$query);
		} else {
			return false;
		}
	}

	/**新增业务机会
	*$inarr 保存业务机会信息的数组
	*/
	function addOperation($inarr) {
		global $connection;
		if($inarr[0]!="" && $inarr[2]!= "") {
			$query = "INSERT INTO operation (OPER_NAME,CREATOR,CUSTOMER_ID,OPER_TYPE,OPER_MONEY,OPER_DATE,OPER_ORIGIN,OPER_STEP,
					OPER_SOURCE,OPER_NOTE,OPER_NAME_PY,OPER_NAME_ZM,CREATE_TIME,OPER_START,OPER_STATUS) VALUES ('".
                SecurityFilter($inarr[0])."','".
                SecurityFilter($inarr[1])."','".
                SecurityFilter($inarr[2])."','".
                SecurityFilter($inarr[3])."','".
                SecurityFilter($inarr[4])."','".
                SecurityFilter($inarr[5])."','".
                SecurityFilter($inarr[6])."','".
                SecurityFilter($inarr[7])."','".
                SecurityFilter($inarr[8])."','".
                SecurityFilter($inarr[9])."','".
                SecurityFilter($inarr[10])."','".
                SecurityFilter($inarr[11])."','".
                SecurityFilter($inarr[12])."','".
                SecurityFilter($inarr[13])."','".
                SecurityFilter($inarr[14])."')";
			exequery($connection,$query);
		} else {
			return false;
		}
	}

    /**新增联系记录
	*$inarr 保存联系记录信息的数组
	*/
	function addRelationRecord($inarr) {
		global $connection;
		$login_priv = $this->get_login_priv();

		if($inarr[5]!="" && $inarr[9]!= "") {
			$query = "INSERT INTO relation_record
			(RE_TITLE,RE_DATE1,RE_DATE2,RE_TIME1,RE_TIME2,LINKMAN_ID,RE_TYPE,CREATEOR,RE_RECORD,CUSTOMER_ID,ATTACHMENT_ID,
			ATTACHMENT_NAME,RE_TITLE_PY,RE_TITLE_ZM,CREAT_DATE)
			VALUES ('".
                SecurityFilter($inarr[0])."','".
                SecurityFilter($inarr[1])."','".
                SecurityFilter($inarr[2])."','".
                SecurityFilter($inarr[3])."','".
                SecurityFilter($inarr[4])."','".
                SecurityFilter($inarr[5])."','".
                SecurityFilter($inarr[6])."','".
                SecurityFilter($inarr[7])."','".
                SecurityFilter($inarr[8])."','".
                SecurityFilter($inarr[9])."','".
                SecurityFilter($inarr[10])."','".
                SecurityFilter($inarr[11])."','".
                SecurityFilter($inarr[12])."','".
                SecurityFilter($inarr[13])."',NOW())";

			exequery($connection,$query);
			$sql = "UPDATE customer SET LAST_RECORD_TIME=NOW() WHERE CUSTOMER_ID='".$inarr[9]."'";
			exequery($connection,$sql);
			$re_id = $this->get_max_record_id();
			AddBroacastLog($login_priv["priv_user"],"RELATION_RECORD","RE_ID",$re_id["mp_id"],"RE_TITLE","new");
		} else {
			return false;
		}
	}

	/**新增联系提醒
	 *$inarr 保存联系提醒信息的数组
	 */
	function addRelationRemind($inarr) {
		global $connection;
		if($inarr[0]!="" && $inarr[4]!= "") {
			$query = "INSERT INTO relation_remind
			(CUSTOMER_ID,SMS_ID,CHARGEMAN_ID,LINKMAN_ID,REMIND_DATE,REMIND_CONTENT,REMIND_TYPE,CREATOR,CREATE_DATE)
			VALUES ('".
                SecurityFilter($inarr[0])."','".
                SecurityFilter($inarr[1])."','".
                SecurityFilter($inarr[2])."','".
                SecurityFilter($inarr[3])."','".
                SecurityFilter($inarr[4])."','".
                SecurityFilter($inarr[5])."','".
                SecurityFilter($inarr[6])."','".
                SecurityFilter($inarr[7])."',NOW())";
			exequery($connection,$query);
		} else {
			return false;
		}
	}

	/**新增合同
	*$inarr 保存合同信息的数组
	*/
	function addContract($inarr) {
		global $connection;
		if($inarr[0] != "" && $inarr[5]!= "") {
			$query = "INSERT INTO contract (CON_NAME,CON_NO,CREATEOR,CON_DATE1,CON_DATE2,CUST_ID,CON_SIGNATORY,CON_CSIGN,SIGNATORY_DATE,
					CSIGN_DATE,CON_TYPE,CON_COUNT,CON_NOTE,ATTACHMENT_ID,ATTACHMENT_NAME,CON_NAME_PY,CON_NAME_ZM,SMS_REMIND) VALUES ('".
                SecurityFilter($inarr[0])."','".
                SecurityFilter($inarr[1])."','".
                SecurityFilter($inarr[2])."','".
                SecurityFilter($inarr[3])."','".
                SecurityFilter($inarr[4])."','".
                SecurityFilter($inarr[5])."','".
                SecurityFilter($inarr[6])."','".
                SecurityFilter($inarr[7])."','".
                SecurityFilter($inarr[8])."','".
                SecurityFilter($inarr[9])."','".
                SecurityFilter($inarr[10])."','".
                SecurityFilter($inarr[11])."','".
                SecurityFilter($inarr[12])."','".
                SecurityFilter($inarr[13])."','".
                SecurityFilter($inarr[14])."','".
                SecurityFilter($inarr[15])."','".
                SecurityFilter($inarr[16])."','".
                SecurityFilter($inarr[17])."')";
			exequery($connection,$query);
		} else {
			return false;
		}
	}

    /**新增销售纪录
	*$inarr 保存销售记录信息的数组
	*/
	function addSaleHistory($inarr) {
		global $connection;
		if($inarr[0] != "" && $inarr[1]) {
			$query = "INSERT INTO sale_history (CUSTOMER_ID,PRODUCT_ID,DATE,AMT,PRICE,DISCOUNT,SALESMAN,MEMO,SALE_HISTORY_CREATE_USER) VALUES ('".
                SecurityFilter($inarr[0])."','".
                SecurityFilter($inarr[1])."','".
                SecurityFilter($inarr[2])."','".
                SecurityFilter($inarr[3])."','".
                SecurityFilter($inarr[4])."','".
                SecurityFilter($inarr[5])."','".
                SecurityFilter($inarr[6])."','".
                SecurityFilter($inarr[7])."','".
                SecurityFilter($inarr[8])."')";
			exequery($connection,$query);
		} else {
			return false;
		}
	}

    /**新增供应商
	*$inarr 保存供应商信息的数组
	*/
	function addProvider($inarr) {
		global $connection;
		if($inarr[0] != "") {
			$query = "INSERT INTO provider (PROVIDER_NAME,TEL_NO,FAX_NO,PROVIDER_WWW,EMAIL,PROVIDER_ADD,POSTALCODE,BANK,ACCOUNT,MEMO,
					PROVIDER_CREATE_USER) VALUES ('".
                SecurityFilter($inarr[0])."','".
                SecurityFilter($inarr[1])."','".
                SecurityFilter($inarr[2])."','".
                SecurityFilter($inarr[3])."','".
                SecurityFilter($inarr[4])."','".
                SecurityFilter($inarr[5])."','".
                SecurityFilter($inarr[6])."','".
                SecurityFilter($inarr[7])."','".
                SecurityFilter($inarr[8])."','".
                SecurityFilter($inarr[9])."','".
                SecurityFilter($inarr[10])."')";
			exequery($connection,$query);
		} else {
			return false;
		}
	}

	/**新增产品
	*$inarr 保存产品信息的数组
	*/
	function addProduct($inarr) {
		global $connection;
		if($inarr[0] != "") {
			$query = "INSERT INTO product (PRODUCT_NAME,PRODUCT_TYPE,MEASURE_UNIT,COST_PRICE,STANDARD_PRICE,PROVIDER_ID,
					PRODUCT_DESC,PRODUCT_CREATE_USER) VALUES ('".
                SecurityFilter($inarr[0])."','".
                SecurityFilter($inarr[1])."','".
                SecurityFilter($inarr[2])."','".
                SecurityFilter($inarr[3])."','".
                SecurityFilter($inarr[4])."','".
                SecurityFilter($inarr[5])."','".
                SecurityFilter($inarr[6])."','".
                SecurityFilter($inarr[7])."')";
			exequery($connection,$query);
		} else {
			return false;
		}
	}

	/**增加业务机会追踪记录
	*$inarr  保存业务机会追踪记录信息的数组
	*/
	function addOperRecords($inarr) {
		global $connection;
		if($inarr[4] != "") {
			$query = "INSERT INTO oper_records (OPER_ID,LAST_PO,THIS_PO,OPER_STEP,OPER_TEXT,RE_DATE,CREATEOR) VALUES ('".
                SecurityFilter($inarr[0])."','".
                SecurityFilter($inarr[1])."','".
                SecurityFilter($inarr[2])."','".
                SecurityFilter($inarr[3])."','".
                SecurityFilter($inarr[4])."','".
                SecurityFilter($inarr[5])."','".
                SecurityFilter($inarr[6])."')";
			exequery($connection,$query);
		} else {
			return false;
		}
	}

	/**增加合同收付款记录
	*$inarr 保存合同收付款信息的数组
	*/
	function addContractPayment($inarr) {
		global $connection;
		if($inarr['PAY_DATE'] != '') {
			$query = "INSERT INTO contract_payment(CON_ID,USER_ID,CREATE_TIME,PAY_DATE,PAY_NOTE) VALUES ('".
                SecurityFilter($inarr['CON_ID'])."','".
                SecurityFilter($inarr['USER_ID'])."',NOW(),'".
                SecurityFilter($inarr['PAY_DATE'])."','".
                SecurityFilter($inarr['PAY_REMIND_CONTENT'])."')";

			exequery($connection,$query);
		} else {
			return false;
		}
	}

	/**编辑后保存数组的方法
	*$tableName  数据表名
	*$inarr      保存编辑信息的数组
	*$tableId    对应的数据表的ID
	*/
	function saveEditData($tableName,$inarr,$tableId) {
		global $connection;
		$login_priv = $this->get_login_priv();

		switch($tableName) {
			case "CUSTOMER":
				$this->saveCustomer($inarr,$tableId);
				break;
			case "LINKMAN":
				$this->saveLinkman($inarr,$tableId);
				break;
			case "OPERATION":
				$this->saveOperation($inarr,$tableId);
				break;
			case "RELATION_RECORD":
				$this->saveRelation($inarr,$tableId);
				break;
			case "CONTRACT":
				$this->saveContract($inarr,$tableId);
				break;
			case "SALE_HISTORY":
				$this->saveHistory($inarr,$tableId);
				break;
			case "PRODUCT":
				$this->saveProduct($inarr,$tableId);
				break;
			case "PROVIDER":
				$this->saveProvider($inarr,$tableId);
				break;
			case "OPER_RECORDS":
				$this->saveOperRecord($inarr);
				break;
		}
		exequery($connection,$query);
	}

	/**编辑后保存客户
	*$inarr       编辑后保存客户信息的数组
	*$customer_id 传入的客户的ID
	*/
	function saveCustomer($inarr,$customer_id) {
		global $connection;
		$pyCustomer = convertPy($inarr["CUSTOMER_NAME"]);
		$query = "UPDATE customer SET
					  CUSTOMER_NAME='".SecurityFilter(dhtmlspecialchars($inarr["CUSTOMER_NAME"]))."',
					  TEL_NO='".SecurityFilter(dhtmlspecialchars($inarr["TEL_NO"]))."',
					  FAX_NO='".SecurityFilter(dhtmlspecialchars($inarr["FAX_NO"]))."',
					  CUSTOMER_WWW='".SecurityFilter(dhtmlspecialchars($inarr["CUSTOMER_WWW"]))."',
					  EMAIL='".SecurityFilter(dhtmlspecialchars($inarr["EMAIL"]))."',
					  CUSTOMER_ADD='".SecurityFilter(dhtmlspecialchars($inarr["CUSTOMER_ADD"]))."',
					  POSTALCODE='".SecurityFilter(dhtmlspecialchars($inarr["POSTALCODE"]))."',
					  MEMO='".SecurityFilter($inarr["MEMO"])."',
					  MANAGE_USER='".SecurityFilter($inarr["MANAGE_USER"])."',
					  CUSTOMER_NUMBER='".SecurityFilter(dhtmlspecialchars($inarr["customer_no"]))."',
					  CUSTOMER_TYPE='".SecurityFilter($inarr["door_type"])."',
					  SCALE='".SecurityFilter($inarr["scale"])."',
					  CUSTOMER_INDUSTRY='".SecurityFilter($inarr["CUSTOMER_INDUSTRY"])."',
					  CUSTOMER_PROFIT='".SecurityFilter(dhtmlspecialchars($inarr["CUSTOMER_PROFIT"]))."',
					  PROVINCE='".SecurityFilter($inarr["province"])."',
					  CITY='".SecurityFilter($inarr["cityid"])."',
					  PURVIEW='".SecurityFilter($inarr["purview"])."',
					  PURVIEW_DEPT='".SecurityFilter($inarr["to_id"])."',
					  PURVIEW_ROLE='".SecurityFilter($inarr["user_priv_id"])."',
					  PURVIEW_USER='".SecurityFilter($inarr["copy_to_id"])."',
					  BIRTHDAY_REMIND_SMS='".SecurityFilter($inarr["BIRTHDAY_REMIND_SMS"])."',
					  BIRTHDAY_REMIND='".SecurityFilter($inarr["BIRTHDAY_REMIND"])."',
					  LE_PERSON='".SecurityFilter(dhtmlspecialchars($inarr["LE_PERSON"]))."',
					  PERSON_INFO='".SecurityFilter($inarr["PERSON_INFO"])."',
					  CUSTOMER_NAME_PY='".SecurityFilter($pyCustomer[0])."',
					  CUSTOMER_NAME_ZM='".SecurityFilter($pyCustomer[1])."'
				 WHERE CUSTOMER_ID='".SecurityFilter($customer_id)."'";
		exequery($connection,$query);
	}

	/**编辑后保存联系人
	*$inarr      编辑后保存联系人信息的数组
	*$linkman_id 传入的联系人ID
	*/
	function saveLinkman($inarr,$linkman_id) {
		global $connection;
		$pyLinkman = convertPy($inarr["LINKMAN_NAME"]);
		$query = "UPDATE linkman SET
					 CUSTOMER_ID='".SecurityFilter($inarr["CUSTOMER_ID"])."',
				     LINKMAN_NAME='".SecurityFilter(dhtmlspecialchars($inarr["LINKMAN_NAME"]))."',
					 SEX='".SecurityFilter($inarr["SEX"])."',
					 BIRTHDAY='".SecurityFilter($inarr["BIRTHDAY"])."',
					 POST_PRIV='".SecurityFilter(dhtmlspecialchars($inarr["POST_PRIV"]))."',
					 LINK_DEPT='".SecurityFilter(dhtmlspecialchars($inarr["DEPT"]))."',
					 HOBBY='".SecurityFilter(dhtmlspecialchars($inarr["HOBBY"]))."',
					 ADD_HOME='".SecurityFilter($inarr["ADD_HOME"])."',
					 POSTALCODE_HOME='".SecurityFilter(dhtmlspecialchars($inarr["POSTALCODE_HOME"]))."',
					 TEL_NO_WORK='".SecurityFilter(dhtmlspecialchars($inarr["TEL_NO_WORK"]))."',
					 TEL_NO_HOME='".SecurityFilter(dhtmlspecialchars($inarr["TEL_NO_HOME"]))."',
					 FAX_NO='".SecurityFilter(dhtmlspecialchars($inarr["FAX"]))."',
					 MOBILE='".SecurityFilter(dhtmlspecialchars($inarr["MOBILE"]))."',
					 EMAIL='".SecurityFilter(dhtmlspecialchars($inarr["EMAIL"]))."',
					 OICQ='".SecurityFilter(dhtmlspecialchars($inarr["OICQ"]))."',
					 ICQ='".SecurityFilter(dhtmlspecialchars($inarr["ICQ"]))."',
					 MEMO='".SecurityFilter($inarr["MEMO"])."',
					 ATTACHMENT_ID='".SecurityFilter($inarr["ATTACHMENT_ID"])."',
					 ATTACHMENT_NAME='".SecurityFilter($inarr["ATTACHMENT_NAME"])."',
					 LINKMAN_NAME_PY='".SecurityFilter($pyLinkman[0])."',
					 LINKMAN_NAME_ZM='".SecurityFilter($pyLinkman[1])."'
				WHERE LINKMAN_ID='".SecurityFilter($linkman_id)."'";
		 exequery($connection,$query);

		 $sql = "UPDATE relation_record SET CUSTOMER_ID='".SecurityFilter($inarr["CUSTOMER_ID"])."' WHERE LINKMAN_ID='".SecurityFilter($linkman_idSecurityFilter())."'";
		 exequery($connection,$sql);
	}

	/**编辑后保存业务机会
	*$inarr   编辑后业务机会信息的数组
	*$oper_id 传入的业务机会的ID
	*/
	function saveOperation($inarr,$oper_id) {
		global $connection;
		$pyOpername = convertPy($inarr["OPER_NAME"]);
		$query = "UPDATE operation SET
		              OPER_NAME='".SecurityFilter(trim(dhtmlspecialchars($inarr["OPER_NAME"])))."',
					  CUSTOMER_ID='".SecurityFilter($inarr["CUSTOMER_ID"])."',
					  OPER_TYPE='".SecurityFilter($inarr["OPER_TYPE"])."',
					  OPER_MONEY='".SecurityFilter($inarr["OPER_MONEY"])."',
					  OPER_DATE='".SecurityFilter($inarr["BEGIN_DATE"])."',
					  OPER_ORIGIN='".SecurityFilter($inarr["OPER_ORIGIN"])."',
					  OPER_STEP='".SecurityFilter($inarr["OPER_STEP"])."',
					  OPER_SOURCE='".SecurityFilter($inarr["OPER_SOURCE"])."',
					  OPER_NOTE='".SecurityFilter($inarr["OPER_NOTE"])."',
					  OPER_NAME_PY='".SecurityFilter(trim($pyOpername[0]))."',
					  OPER_NAME_ZM='".SecurityFilter(trim($pyOpername[1]))."',
					  OPER_START='".SecurityFilter($inarr["OPER_START"])."',
					  OPER_STATUS='".SecurityFilter($inarr["OPER_STATUS"])."'
				 WHERE OPER_ID='".SecurityFilter($oper_id)."'";
		exequery($connection,$query);
	}

	/**编辑后保存联系记录
	*$inarr  编辑后的联系记录信息的数组
	*$re_id  传入的联系记录的ID
	*/
	function saveRelation($inarr,$re_id) {
		global $connection;
		$pyRecord = convertPy($inarr["RE_TITLE"]);
		$query = "UPDATE relation_record SET
					  RE_TITLE='".SecurityFilter(dhtmlspecialchars(trim($inarr["RE_TITLE"])))."',
					  RE_DATE1='".SecurityFilter($inarr["RE_DATE1"])."',
					  RE_DATE2='".SecurityFilter($inarr["RE_DATE2"])."',
					  RE_TIME1='".SecurityFilter($inarr["RE_TIME1"])."',
					  RE_TIME2='".SecurityFilter($inarr["RE_TIME2"])."',
					  LINKMAN_ID='".SecurityFilter($inarr["linkman_id"])."',
					  RE_TYPE='".SecurityFilter($inarr["RE_TYPE"])."',
					  RE_RECORD='".SecurityFilter($inarr["RE_RECORD"])."',
					  CUSTOMER_ID='".SecurityFilter($inarr["CUSTOMER_ID"])."',
					  ATTACHMENT_ID='".SecurityFilter($inarr["attachmentIDStr"])."',
					  ATTACHMENT_NAME='".SecurityFilter($inarr["attachmentNameStr"])."',
					  RE_TITLE_PY='".SecurityFilter(trim($pyRecord[0]))."',
					  RE_TITLE_ZM='".SecurityFilter(trim($pyRecord[1]))."'
				WHERE RE_ID='".SecurityFilter($re_id)."'";
		exequery($connection,$query);
	}

	/**编辑后保存合同
	*$inarr    编辑后保存的合同信息的数组
	*$con_id   传入的合同ID
	*/
	function saveContract($inarr,$con_id) {
		global $connection;
		$pyContract = convertPy($inarr["CON_NAME"]);
		$query = "UPDATE contract SET
				      CON_NAME='".SecurityFilter(trim(dhtmlspecialchars($inarr["CON_NAME"])))."',
					  CON_NO='".SecurityFilter(dhtmlspecialchars($inarr["CON_NO"]))."',
					  CON_DATE1='".SecurityFilter($inarr["CONTACT_DATE1"])."',
					  CON_DATE2='".SecurityFilter($inarr["CONTACT_DATE2"])."',
					  CUST_ID='".SecurityFilter($inarr["CUSTOMER_ID"])."',
					  CON_SIGNATORY='".SecurityFilter(dhtmlspecialchars($inarr["CON_SIGNATORY"]))."',
					  CON_CSIGN='".SecurityFilter(dhtmlspecialchars($inarr["CON_CSIGN"]))."',
					  SIGNATORY_DATE='".SecurityFilter($inarr["SIGNATORY_DATE"])."',
					  CSIGN_DATE='".SecurityFilter($inarr["CSIGN_DATE"])."',
					  CON_TYPE='".SecurityFilter($inarr["CON_TYPE"])."',
					  CON_COUNT='".SecurityFilter($inarr["CON_COUNT"])."',
					  CON_NOTE='".SecurityFilter($inarr["CON_NOTE"])."',
					  ATTACHMENT_ID='".SecurityFilter($inarr["attachmentIDStr"])."',
					  ATTACHMENT_NAME='".SecurityFilter($inarr["attachmentNameStr"])."',
					  CON_NAME_PY='".SecurityFilter(trim($pyContract[0]))."',
					  CON_NAME_ZM='".SecurityFilter(trim($pyContract[1]))."',
					  SMS_REMIND='".SecurityFilter($inarr["contract_remind"])."'
				WHERE CON_ID='".SecurityFilter($con_id)."'";
		exequery($connection,$query);
	}

	/**编辑后保存销售记录
	*$inarr       编辑后保存的销售纪录信息的数组
	*$history_id  传入的销售记录的ID*/
	function saveHistory($inarr,$history_id) {
		global $connection;
		$query = "UPDATE sale_history SET
					  CUSTOMER_ID='".SecurityFilter($inarr["CUSTOMER_ID"])."',
					  PRODUCT_ID='".SecurityFilter($inarr["PRODUCT_ID"])."',
					  DATE='".SecurityFilter($inarr["DATE"])."',
					  AMT='".SecurityFilter(dhtmlspecialchars($inarr["AMT"]))."',
					  PRICE='".SecurityFilter(dhtmlspecialchars($inarr["PRICE"]))."',
					  SALESMAN='".SecurityFilter(dhtmlspecialchars($inarr["SALESMAN"]))."',
					  DISCOUNT='".SecurityFilter($inarr["DISCOUNT"])."',
					  MEMO='".SecurityFilter($inarr["MEMO"])."'
				WHERE HISTORY_ID='".SecurityFilter($history_id)."'";
		exequery($connection,$query);
	}

	/**编辑后保存产品
	*$inarr 传入的修改产品的数组
	*$product_id 对应产品数据表中得ID
	*/
	function saveProduct($inarr,$product_id) {
		global $connection;
		$query = "UPDATE product SET
					   PRODUCT_NAME='".SecurityFilter(dhtmlspecialchars($inarr["PRODUCT_NAME"]))."',
					   PRODUCT_TYPE='".SecurityFilter($inarr["PRODUCT_TYPE"])."',
					   MEASURE_UNIT='".SecurityFilter(dhtmlspecialchars($inarr["MEASURE_UNIT"]))."',
					   COST_PRICE='".SecurityFilter($inarr["COST_PRICE"])."',
					   STANDARD_PRICE='".SecurityFilter(dhtmlspecialchars($inarr["STANDARD_PRICE"]))."',
					   PROVIDER_ID='".SecurityFilter($inarr["PROVIDER_ID"])."',
					   PRODUCT_DESC='".SecurityFilter($inarr["PRODUCT_DESC"])."'
				WHERE PRODUCT_ID='".SecurityFilter($product_id)."'";
		exequery($connection,$query);
	}

	/**编辑后保存供应商
	*$inarr  编辑修改后的供应商信息的数组
	*$provider_id  供应商表中的ID
	*/
	function saveProvider($inarr,$provider_id) {
		global $connection;
		$query = "UPDATE provider SET
				      PROVIDER_NAME='".SecurityFilter(dhtmlspecialchars($inarr["PROVIDER_NAME"]))."',
					  TEL_NO='".SecurityFilter(dhtmlspecialchars($inarr["TEL_NO"]))."',
					  FAX_NO='".SecurityFilter(dhtmlspecialchars($inarr["FAX_NO"]))."',
					  PROVIDER_WWW='".SecurityFilter(dhtmlspecialchars($inarr["PROVIDER_WWW"]))."',
					  EMAIL='".SecurityFilter(dhtmlspecialchars($inarr["EMAIL"]))."',
					  PROVIDER_ADD='".SecurityFilter(dhtmlspecialchars($inarr["PROVIDER_ADD"]))."',
					  POSTALCODE='".SecurityFilter(dhtmlspecialchars($inarr["POSTALCODE"]))."',
					  BANK='".SecurityFilter(dhtmlspecialchars($inarr["BANK"]))."',
					  ACCOUNT='".SecurityFilter(dhtmlspecialchars($inarr["ACCOUNT"]))."',
					  MEMO='".SecurityFilter($inarr["MEMO"])."'
				WHERE PROVIDER_ID='".SecurityFilter($provider_id)."'";
		exequery($connection,$query);
	}

	//编辑后保存业务追踪记录
	function saveOperRecord($inarr) {
		global $connection;
		$query = "UPDATE oper_records SET
					   THIS_PO='".SecurityFilter($_REQUEST["OPER_ORIGIN"])."',
					   OPER_STEP='".SecurityFilter($_REQUEST["OPERATION_STEP"])."',
					   OPER_TEXT='".SecurityFilter($_REQUEST["MEMO"])."',
					   RE_DATE=CURDATE()
				WHERE OPER_ID='".SecurityFilter($_REQUEST["OPER_ID"])."'";
		exequery($connection,$query);
	}


	//获取客户表中最大的ID
	function getCustomerId() {
		global $connection;
		$sql         = "SELECT MAX(CUSTOMER_ID) AS MCID FROM customer";
		$cousor      = exequery($connection,$sql);
		$row         = mysql_fetch_array($cousor);
		$CUSTOMER_ID = $row["MCID"];
		return $CUSTOMER_ID;
	}

	//获取客户名称
	function getCustomerName($customer_id) {
		$sql         = "SELECT CUSTOMER_NAME FROM customer where CUSTOMER_ID=".SecurityFilter($customer_id);
		$cousor      = exequery($this->connection,$sql);
		$row         = mysql_fetch_array($cousor);
		return $row["CUSTOMER_NAME"];
	}

	//获取客户名称
	function getCustomer($customer_id) {
		global $connection;
		$sql         = "SELECT *,c.EMAIL AS EMAIL FROM customer as c
						LEFT JOIN user as u on c.CREATEOR = u.USER_ID
						where CUSTOMER_ID=".SecurityFilter($customer_id);
		$cousor      = exequery($connection,$sql);
		$row         = mysql_fetch_array($cousor);
		return $row;
	}

	/**删除客户相关的数据
	*$customer_id  客户表中的ID
	*/
	function del_customer_data($customer_id) {
		global $connection;
		$query	= "DELETE FROM linkman WHERE CUSTOMER_ID='".SecurityFilter($customer_id)."'";
		exequery($connection, $query);

		//删除对应的交往记录
		$query1	= "DELETE FROM contact WHERE CUSTOMER_ID='".SecurityFilter($customer_id)."'";
		exequery($connection, $query1);

		//删除对应的销售记录
		$query2 = "DELETE FROM sale_history WHERE CUSTOMER_ID = '".SecurityFilter($customer_id)."'";
		exequery($connection, $query2);

		//删除对应的业务(包括业务的追踪记录)
		$sql = "SELECT * FROM operation WHERE CUSTOMER_ID='".SecurityFilter($customer_id)."'";
		$rs  = exequery($connection,$sql);
		while($row = mysql_fetch_array($rs)) {
			$OPER_ID = $row["OPER_ID"];
			unset($sql);
			$sql = "DELETE FROM oper_records WHERE OPER_ID='".SecurityFilter($OPER_ID)."'";
			exequery($connection,$sql);
		}

		$query3 = "DELETE FROM operation WHERE CUSTOMER_ID='".SecurityFilter($customer_id)."'";
		exequery($connection,$query3);

		//删除对应的联系记录
		$query4 = "DELETE FROM relation_record WHERE CUSTOMER_ID='".SecurityFilter($customer_id)."'";
		exequery($connection,$query4);

		$sql1 = "SELECT * FROM contract WHERE CUST_ID='".SecurityFilter($customer_id)."'";
		$cousor = exequery($connection,$sql1);
		if($row = mysql_fetch_array($cousor)) {
			$CON_ID = $row["CON_ID"];
			$querys = "DELETE FROM contract_payment WHERE CON_ID='".SecurityFilter($CON_ID)."'";
			exequery($connection,$querys);

			$querys1 = "DELETE FROM sms WHERE TABLE_NAME='CONTRACT' AND TABLE_ID='".SecurityFilter($CON_ID)."'";
			exequery($connection,$querys1);

			$querys2 = "DELETE FROM sms WHERE TABLE_NAME='CONTRACT_PAYMENT' AND TABLE_ID='".SecurityFilter($CON_ID)."'";
			exequery($connection,$querys2);
		}

		//删除对应的合同
		$query5 = "DELETE FROM contract WHERE CUST_ID='".SecurityFilter($customer_id)."'";
		exequery($connection,$query5);

	}

	/*批量添加联系人
	*$linkarr   保存联系人姓名信息的数组
	*$monumarr  保存联系人手机号码信息的数组
	*$position  保存联系人职位信息的数组
	*$email     保存联系人邮箱信息的数组
	*/
	function add_linkman_fast($linkarr,$monumarr,$position,$email) {
		global $connection;
		$CUSTOMER_ID = $this->getCustomerId();

		for($i=0;$i<count($linkarr);$i++) {
			unset($query);
			$query = "INSERT INTO linkman (CUSTOMER_ID,LINKMAN_NAME,MOBILE,POST_PRIV,EMAIL) VALUES('".SecurityFilter($CUSTOMER_ID)."','".SecurityFilter($linkarr[$i])."','".SecurityFilter($monumarr[$i])."',
			          '".SecurityFilter($position[$i])."','".SecurityFilter($email[$i])."')";
		    exequery($connection,$query);
		}
	}

	/**获取省份
	*$proId  省份表中的ID
	*$show   是否显示所有省份
	*/
	function get_proName($proId='',$show='') {
		global $connection;
		if($proId!='') {
			$sql = "SELECT * FROM province WHERE proID='".SecurityFilter($proId)."'";
			$cousor = exequery($connection,$sql);
			if($row = mysql_fetch_array($cousor)) {
				$proName = $row["proName"];
			}
		} else if($show) {
			$sql = "SELECT * FROM province ORDER BY proID";
			$cousor = exequery($connection,$sql);
			$count = 0;
			while($row = mysql_fetch_array($cousor)) {
				$count++;
				$proName .= $row["proName"].",";
			}
		}
		return $proName;
	}

	/**获取城市
	*$proId   传入的省份ID
	*$cityId  传入的城市ID
	*/
	function get_cityName($proId,$cityId='') {
		global $connection;
		if(!$cityId) {
			$sql    = "SELECT * FROM city WHERE proID='".SecurityFilter($proId)."'";
			$cousor = exequery($connection,$sql);
			$count  = 0;
			while($row = mysql_fetch_array($cousor)) {
				$count++;
				$resultStr[$count][cityName] = $row["cityName"];
			}
		} else {
			$sql    = "SELECT * FROM city WHERE cityId='".SecurityFilter($cityId)."'";
			$cousor = exequery($connection,$sql);
			$count  = 0;
			if($row = mysql_fetch_array($cousor)) {
				$count++;
				$resultStr[$count][cityName] = $row["cityName"];
			}
		}
		return $resultStr[$count][cityName];
	}

	/**获取客户的客户经理
	*$customer_id  传入的客户ID
	*/
	function getCustomerMgr($customer_id) {
		global $connection;
		if($customer_id) {
			$sql = "SELECT * FROM customer WHERE CUSTOMER_ID='".SecurityFilter($customer_id)."'";
			$cousor = exequery($connection,$sql);
			if($row = mysql_fetch_array($cousor)) {
				$MANAGE_USER = $row["MANAGE_USER"];
			}
			return $MANAGE_USER;
		}
	}

	/**获取某个联系人的信息
	*$linkman_id 传入的联系人ID
	*/
	function getLinkinfo($linkman_id) {
		global $connection;
		if($linkman_id) {
			$query = "SELECT * FROM linkman WHERE LINKMAN_ID='".SecurityFilter($linkman_id)."'";
			$cousor = exequery($connection,$query);
			$row = mysql_fetch_array($cousor);
			if($row)
				return $row;
		}
	}

	/**获取供应商名
	*$provider_id 传入的供应商ID
	*/
	function getProviderName($provider_id) {
		global $connection;
		if($provider_id) {
			$query = "SELECT * FROM provider WHERE PROVIDER_ID='".SecurityFilter($provider_id)."'";
			$cousor = exequery($connection,$query);
			$row = mysql_fetch_array($cousor);
			if($row) {
				return $row["PROVIDER_NAME"];
			}
		}
	}

	/**获取产品名
	*$product_id 传入的产品ID
	*/
	function getProductName($product_id) {
		global $connection;
		if($product_id) {
			$query = "SELECT * FROM product WHERE PRODUCT_ID='".SecurityFilter($product_id)."'";
			$cousor = exequery($connection,$query);
			$row = mysql_fetch_array($cousor);
			if($row) {
				return $row["PRODUCT_NAME"];
			}
		}
	}

	/**
	*
	*/
	function get_contract_payment_info($con_id) {
		global $connection;
		if($con_id) {
			$query  = "SELECT * FROM contract_payment WHERE CON_ID='".SecurityFilter($con_id)."' ORDER BY ID DESC";
			$cousor = exequery($connection,$query);
			$count  = 0;
			while($row = mysql_fetch_array($cousor)) {
				$count++;
				$reStr[$count]['ID']          = $row["ID"];
				$reStr[$count]['USER_ID']     = $row["USER_ID"];
				$reStr[$count]['CREATE_TIME'] = $row["CREATE_TIME"];
				$reStr[$count]['PAY_DATE']    = $row["PAY_DATE"];
				$reStr[$count]['PAY_NOTE']    = $row["PAY_NOTE"];
			}
			return $reStr;
		}
	}
	/**
	*获取客户的信息(E-mobile)
	*/
	function GetEmobileCustomerInfor($customer_id){
		global $connection;
		if($customer_id!="")
		{
			$infor = array();
			$sql = "SELECT * FROM customer
		           WHERE CUSTOMER_ID='".SecurityFilter($customer_id)."'";
			$cousor = exequery($connection,$sql);
			if($row = mysql_fetch_assoc($cousor)) {
				$infor = $row;
			}
			return $infor;
		}
		else
		{
			return false;
		}
	}
	/**
	*获取客户联系人(E-mobile)
	*/
	function GetEmobileLinkmanInfor($customer_id,$linkid,$search=''){
		global $connection;
		if($customer_id!="" || $linkid!="")
		{
			$infor = array();
			if($customer_id!="" && $linkid=="")
			{
				$sql = "SELECT *
						FROM linkman
						WHERE CUSTOMER_ID = '".SecurityFilter($customer_id)."'
						";
				if($search!="")
				{
					$sql .= " AND LINKMAN_NAME LIKE '%".SecurityFilter($search)."%'";
				}
				$sql .= " ORDER BY LINKMAN_ID DESC";
				$cousor = exequery($connection,$sql);
				while($row = mysql_fetch_assoc($cousor)) {
					$infor[] = $row;
				}
			}
			if($linkid!="" && $customer_id=="")
			{
				$sql = "SELECT *
						FROM linkman
						WHERE LINKMAN_ID = '".SecurityFilter($linkid)."'";
				$cousor = exequery($connection,$sql);
				if($row = mysql_fetch_assoc($cousor)) {
					$infor = $row;
				}
			}
			return $infor;
		}
		else
		{
			return false;
		}
	}
	/**
	*获取客户联系联系记录(E-mobile)
	*/
	function GetEmobileRecordInfor($customer_id,$recordid){
		global $connection;
		if($customer_id!="" || $recordid!="")
		{
			$infor = array();
			if($customer_id!="" && $recordid=="")
			{
				$sql = "SELECT *
						FROM relation_record
						WHERE CUSTOMER_ID = '".SecurityFilter($customer_id)."'
						ORDER BY RE_ID DESC";
				$cousor = exequery($connection,$sql);
				while($row = mysql_fetch_assoc($cousor)) {
					$infor[] = $row;
				}
			}
			if($recordid!="" && $customer_id=="")
			{
				$sql = "SELECT *
						FROM relation_record
						WHERE RE_ID = '".SecurityFilter($recordid)."'";
				$cousor = exequery($connection,$sql);
				if($row = mysql_fetch_assoc($cousor)) {
					$infor = $row;
				}
			}
			return $infor;
		}
		else
		{
			return false;
		}
	}
	/*
	*新增联系记录(E-mobile)
	*/
	function AddEmobileLinkRecord($inarr,$userid)
	{
		global $connection;
		$query = "INSERT INTO relation_record (RE_TITLE,RE_DATE1,RE_DATE2,RE_TIME1,RE_TIME2,LINKMAN_ID,RE_TYPE,CREATEOR,RE_RECORD,CUSTOMER_ID,ATTACHMENT_ID,ATTACHMENT_NAME,RE_TITLE_PY,RE_TITLE_ZM,CREAT_DATE) VALUES ('".$inarr[0]."','".$inarr[1]."','".$inarr[2]."','".$inarr[3]."','".$inarr[4]."','".$inarr[5]."','".$inarr[6]."','".$inarr[7]."','".$inarr[8]."','".$inarr[9]."','".$inarr[10]."','".$inarr[11]."','".$inarr[12]."','".$inarr[13]."','".date('Y-m-d H:i:s')."')";
		exequery($connection,$query);
        $sql = "UPDATE customer SET LAST_RECORD_TIME=NOW() WHERE CUSTOMER_ID='".$inarr[9]."'";
        exequery($connection,$sql);
		$re_id = $this->get_max_record_id();
		AddBroacastLog($userid,"RELATION_RECORD","RE_ID",$re_id["mp_id"],"RE_TITLE","new");
	}

	function getShaixuan(){
		global $connection;
		$query = "SELECT * FROM `quicksort` where MAIN_ID='business_3'";

		$result = exequery($connection, $query);
		while ($row = mysql_fetch_assoc($result)) {
			$contactList[] = $row;
		}
		return $contactList;
	}


	//解析csv文件
	function _fgetcsv(&$handle, $length = null, $d = ',', $e = '"') {
		$d = preg_quote($d);
		$e = preg_quote($e);
		$_line = "";
		$eof=false;
		while ($eof != true) {
			$_line .= (empty ($length) ? fgets($handle) : fgets($handle, $length));
			$itemcnt = preg_match_all('/' . $e . '/', $_line, $dummy);
			if ($itemcnt % 2 == 0)
				$eof = true;
		}
		$_csv_line = preg_replace('/(?: |[ ])?$/', $d, trim($_line));
		$_csv_pattern = '/(' . $e . '[^' . $e . ']*(?:' . $e . $e . '[^' . $e . ']*)*' . $e . '|[^' . $d . ']*)' . $d . '/';
		preg_match_all($_csv_pattern, $_csv_line, $_csv_matches);
		$_csv_data = $_csv_matches[1];
		for ($_csv_i = 0; $_csv_i < count($_csv_data); $_csv_i++) {
			$_csv_data[$_csv_i] = preg_replace('/^' . $e . '(.*)' . $e . '$/s', '$1' , $_csv_data[$_csv_i]);
			$_csv_data[$_csv_i] = str_replace($e . $e, $e, $_csv_data[$_csv_i]);
		}
		return empty ($_line) ? false : $_csv_data;
	}

	/**
	*@function 插入日志
	*@param $insertData["FIELD_CONTENT"]  修改过后的字段
	*@param $insertData["TABLES"]         修改的表(如客户,联系人,合同等)
	*@param $insertData["TABLE_ID"]       修改的表的唯一ID标识
	*@param $insertData["MODIFY_USER"]    修改人
	*/
	function saveCustomerLog($insertData) {
		global $connection;
		$sql = "INSERT INTO customer_log (FIELD_CONTENT,TABLES,TABLE_ID,MODIFY_USER,MODIFY_TIME)
		VALUES ('".
            SecurityFilter(addslashes($insertData["FIELD_CONTENT"]))."','".
            SecurityFilter($insertData["TABLE"])."','".
            SecurityFilter($insertData["TABLE_ID"])."','".
            SecurityFilter($insertData["MODIFY_USER"])."',NOW())";

		$res = exequery($connection,$sql);
		if($res)
		{
			return true;
		}
	}

	/**
	*@function 获取日志
	*@param
	*@
	*@return   logInfoArr 日志信息
	*/
	function getCustomerLog($moduleInfo)
	{
		global $connection;
		$sql = "SELECT cl.*,USER_NAME FROM customer_log cl,user u WHERE 1
		           AND cl.MODIFY_USER=u.USER_ID AND TABLES='".SecurityFilter($moduleInfo['module'])."'
				   AND TABLE_ID='".SecurityFilter($moduleInfo['module_id'])."' ORDER BY MODIFY_TIME DESC";

		$res = exequery($connection,$sql);
		$logCount = mysql_num_rows($res);
		if($logCount >0)
		{
			$logInfoArr = array();
			while($row = mysql_fetch_array($res))
			{
				array_push($logInfoArr,$row);
			}

			return $logInfoArr;
		}
	}

	/**
	*@function 获取日志
	*@param
	*@
	*@return   logInfoArr 日志信息
	*/
	function getCustomerLogs($param)
	{
		global $connection;
		$limitRows 	  	= 	$param["itemsPerPage"];
		$limitOffset  	= 	$param["currentPage"] * $limitRows;
		$sql = "SELECT cl.*,u.USER_NAME FROM customer_log cl,user u
				WHERE cl.MODIFY_USER=u.USER_ID AND TABLES='".SecurityFilter($param['module'])."'
				AND TABLE_ID='".SecurityFilter($param['module_id'])."'
				ORDER BY MODIFY_TIME DESC
		        LIMIT $limitOffset,$limitRows";
		$res = exequery($connection,$sql);
		$logInfoArr = array();
		while($row = mysql_fetch_array($res)){
			$logInfoArr[] = $row;
		}
		return $logInfoArr;
	}

	/**
	*@function 获取日志
	*@param
	*@
	*@return   logInfoArr 日志信息
	*/
	function getCustomerLogsNum($param)
	{
		global $connection;
		$sql = "SELECT count(*) as num FROM customer_log
			 	WHERE TABLES='".SecurityFilter($param['module'])."'
				AND TABLE_ID='".SecurityFilter($param['module_id'])."'";

		$res = exequery($connection,$sql);
		$count = 0;
		if($row = mysql_fetch_array($res)){
			$count = $row['num'];
		}
		return $count;
	}

	/**
	*@function 插入日志
	*@param $data["FIELD_CONTENT"]  修改过后的字段
	*@param $data["TABLES"]         修改的表(如客户,联系人,合同等)
	*@param $data["TABLE_ID"]       修改的表的唯一ID标识
	*@param $data["MODIFY_USER"]    修改人
	*/
	function addSaveCustomerLog($data) {
		global $connection;
		$sql = "SELECT ID  FROM customer_log
		 		WHERE TABLES='".SecurityFilter($data['TABLE'])."' AND TABLE_ID='".SecurityFilter($data['TABLE_ID'])."' AND MODIFY_USER='".SecurityFilter($_SESSION["LOGIN_USER_ID"])."' AND FIELD_CONTENT='".SecurityFilter($data['FIELD_CONTENT'])."'";
		$id = 0;
		$query_count = exequery($connection,$sql);
		if($row = mysql_fetch_array($query_count)){
			$id = empty($row['ID'])?0:$row['ID'];
		}
		if($id>0){
			$sql = "UPDATE customer_log SET MODIFY_TIME=NOW() WHERE ID = ".SecurityFilter($id);
		}else{
			$sql = "INSERT INTO customer_log (FIELD_CONTENT,TABLES,TABLE_ID,MODIFY_USER,MODIFY_TIME)
			VALUES ('".SecurityFilter(addslashes($data["FIELD_CONTENT"]))."','".SecurityFilter($data["TABLE"])."','".SecurityFilter($data["TABLE_ID"])."','".SecurityFilter($data["MODIFY_USER"])."',NOW())";
		}
		$res = exequery($connection,$sql);
		if($res) return true;
	}

	/**
	*@function 获取客户最近联系记录
	*@date
	*
	*/
	function getLatestRecord($customerInfo)
	{
		global $connection;
		$sql = "SELECT * FROM relation_record WHERE 1
				   AND CUSTOMER_ID='".SecurityFilter($customerInfo["CUSTOMER_ID"])."'
				   ORDER BY RE_DATE1 DESC,RE_TIME1 DESC LIMIT 0,1";
		$res = exequery($connection,$sql);
		$recordInfo = array();
		if($row = mysql_fetch_array($res))
		{
			array_push($recordInfo,$row);
		}
		return $recordInfo;
	}

	/**
	*@function 更新客户信息
	*@date
	*
	*/
	function customerUpdate($data,$where)
	{
		global $connection;
		$sql = "UPDATE customer SET ".$data." WHERE ".$where;
		$res = exequery($connection,$sql);

	}

	/**
	*@function 批量追加分享人
	*@date
	*
	*/
	function customerUpdateAdd($data,$where)
	{
		global $connection;
		$sql = "select CUSTOMER_ID,PURVIEW,PURVIEW_DEPT,PURVIEW_ROLE,PURVIEW_USER from customer WHERE ".$where;
		$query = exequery($connection,$sql);
		while($row = mysql_fetch_array($query)){
			if(!empty($row['CUSTOMER_ID'])){
				$data_update = '';
				if(!empty($data['PURVIEW_DEPT'])){
					$row['PURVIEW_DEPT'] = implode(',',array_unique(explode(',',$row['PURVIEW_DEPT'].$data['PURVIEW_DEPT'])));
					$data_update .= "PURVIEW_DEPT = '".$row['PURVIEW_DEPT']."',";
				}

				if(!empty($data['PURVIEW_ROLE'])){
					$row['PURVIEW_ROLE'] = implode(',',array_unique(explode(',',$row['PURVIEW_ROLE'].$data['PURVIEW_ROLE'])));
					$data_update .= "PURVIEW_ROLE = '".$row['PURVIEW_ROLE']."',";
				}

				if(!empty($data['PURVIEW_USER'])){
					$row['PURVIEW_USER'] = implode(',',array_unique(explode(',',$row['PURVIEW_USER'].$data['PURVIEW_USER'])));
					$data_update .= "PURVIEW_USER = '".$row['PURVIEW_USER']."',";
				}

				if(!empty($where)){
					$data_update = rtrim($data_update,',');
					$sql = "UPDATE customer SET ".$data_update." WHERE CUSTOMER_ID = ".SecurityFilter($row['CUSTOMER_ID']);
					exequery($connection,$sql);
				}
			}
		}
	}
	/**
	*@function 获取相似客户
	*@date
	*
	*/
	function getSimilarNames($customer_name)
	{
		global $connection;
		$sql = "SELECT CUSTOMER_ID,CUSTOMER_NAME,LEFT(CREATE_TIME,10) AS CREATE_TIME,USER_NAME,LAST_RECORD_TIME AS LATEST_RELATION_TIME FROM customer c,user u
						WHERE c.MANAGE_USER=u.USER_ID AND CUSTOMER_NAME LIKE '%".SecurityFilter($customer_name)."%' ORDER BY CREATE_TIME DESC ";
		$res = exequery($connection,$sql);

		$returnInfo = array();
		while($row = mysql_fetch_array($res))
		{
			if($row['LATEST_RELATION_TIME']=='0000-00-00 00:00:00')$row['LATEST_RELATION_TIME'] = '';
			$returnInfo[] = $row;
		}
		return $returnInfo;
	}
	/**
	*@function 获取相似客户数量
	*@date
	*
	*/
	function getSimilarNum($customer_name)
	{
		global $connection;
		$num = 0;
		$sql = "SELECT count(*) as num FROM customer WHERE  CUSTOMER_NAME LIKE '%".SecurityFilter($customer_name)."%'";
		$query = exequery($connection,$sql);
		if($row = mysql_fetch_array($query)){
			$num = $row['num'];
		}
		return $num;
	}
	/**
	*@function 获取业务机会
	*@date
	*
	*/
	function getOpportunityNum($param)
	{
		global $connection;
		$where = $this->getOpportunityWhere($param);
		$num = 0;
		$sql = "SELECT COUNT(*) AS num FROM operation as o,customer AS c
				WHERE o.CUSTOMER_ID=c.CUSTOMER_ID AND $where";
		$query = exequery($connection,$sql);
		if($row = mysql_fetch_array($query)){
			$num = $row['num'];
		}
		return $num;
	}
	/**
	*@function 获取业务机会
	*@date
	*
	*/
	function getOpportunityList($param)
	{
		global $connection;
		$where = $this->getOpportunityWhere($param,1);
		$data = array();
		$sql = "SELECT o.*,c.MANAGE_USER,c.CUSTOMER_NAME,c.SERVICE_USER FROM operation as o,customer AS c
				WHERE o.CUSTOMER_ID=c.CUSTOMER_ID AND $where";
		$query = exequery($connection,$sql);
		while ($row = mysql_fetch_assoc($query)) {
			$row["MANAGE_USER_NAME"]=showUserGeneral($row["MANAGE_USER"]);
			$row["CREATOR_NAME"]=showUserGeneral($row["CREATOR"]);

			if($row["OPER_DATE"]=="0000-00-00"){
				$row["OPER_DATE"]="";
			}
			$list[] = $row;
		}
		return $list;
	}
	/**
	*@function 获取业务机会
	*@date
	*
	*/
	function getOpportunityWhere($param,$list=0)
	{
		$wher_purview   =   $this->get_purview_where();
		$limitRows   	= 	$param["itemsPerPage"];
		$limitOffset 	= 	$param["currentPage"] * $limitRows;
		$sortField   	= 	$param["sortField"] ? $param["sortField"] : "OPER_ID";
		$sortType    	= 	$param["sortType"] ? $param["sortType"] : "DESC";
		$where_query 	= 	$param['where_query'];
		$quicksort 		= 	$param['business_type'];
		$query  = '';
		$query .= $wher_purview.' ';
		if ($where_query!='') {
			$where_query = stripslashes($where_query);
			$query .= $where_query;
		}
		$search_field 	= 	$param['search_field'];
		$search_str 	= 	$param['search_str'];
		if ($search_field && $search_field=="OPER_NAME") {
			$query .= " AND o.".$search_field." like '%".SecurityFilter($search_str)."%' ";
		}elseif ($search_field && $search_field=="CUSTOMER_NAME") {
			$query .= " AND c.".$search_field." like '%".SecurityFilter($search_str)."%' ";
		}

		if($quicksort) {
			switch($quicksort) {
				case "all":
					$query .= "";
					break;
				case "my":
					$query .= " AND o.CREATOR='".SecurityFilter($_SESSION['LOGIN_USER_ID'])."'";
					break;
				case "other_business":
					$query .= " AND o.CREATOR!='".SecurityFilter($_SESSION['LOGIN_USER_ID'])."'";
					break;
				case "create":
					$query .= " AND o.CREATOR='".SecurityFilter($_SESSION['LOGIN_USER_ID'])."'";
					break;
				case "monthend":
					$query .= " AND DATE_FORMAT(o.OPER_DATE,'%Y-%m')=DATE_FORMAT(NOW(),'%Y-%m')";
					break;
				case "thismonth":
					$query .= " AND DATE_FORMAT(o.CREATE_TIME,'%Y-%m')=DATE_FORMAT(NOW(),'%Y-%m')";
					break;
				case "startrank":
					$query .= " ORDER BY CAST(o.OPER_START AS DECIMAL) DESC LIMIT 0,10";
					break;
			}
		}
		if($list == 1 && $quicksort != 'startrank'){
			if ($sortField == 'MANAGE_USER') {
				$query.=" ORDER BY  c." . $sortField . " " . $sortType;
			} else {
				$query.=" ORDER BY  o." . $sortField . " " . $sortType;
			}

			$query.= " LIMIT " . $limitOffset . "," . $limitRows;
		}
		return $query;
	}

	/**获取客户的客户经理
	*$customer_id  传入的客户ID
	*/
	function hasPurview($customer_id) {
		global $connection;
		if($customer_id) {
			$sql = "SELECT MANAGE_USER,SERVICE_USER FROM customer WHERE CUSTOMER_ID='".SecurityFilter($customer_id)."' LIMIT 1";
			$query = exequery($connection,$sql);
			$customer = mysql_fetch_array($query);
		}
		$manUids = $this->get_userid_str();
		if($_SESSION['LOGIN_USER_ID']!=$customer['MANAGE_USER'] && $_SESSION['LOGIN_USER_ID']!=$customer['SERVICE_USER'] && strpos($manUids,$customer['MANAGE_USER'])===FALSE) {
			return 0;
		}else{
			return 1;
		}

	}

    /**
     * 检测客户编号是否重复
     * @access public
     * @param array $param
     * @return bool
     */
    public function check_customer_no($param) {
    	global $connection;
    	$sql  = "SELECT COUNT(*) as num FROM customer WHERE CUSTOMER_NUMBER = '".SecurityFilter($param["CUSTOMER_NUMBER"])."'";
    	if(!empty($param['CUSTOMER_ID'])){
    		$sql .= " AND CUSTOMER_ID!='".SecurityFilter($param['CUSTOMER_ID'])."'" ;
    	}
		$query     = exequery($connection,$sql);
		$row = mysql_fetch_array($query);
		return $row["num"]>0?1:0;
    }

    /**
     * 获取客户经理数量
     * @access public
     * @param array $param ,$type:1获取列表sql,2:获取数量sql
     * @return bool
     */
    public function getManagerSql($param,$type=1) {
		$limitRows 		= $param["itemsPerPage"];
		$limitOffset 	= $param["currentPage"] * $limitRows;
		$sortField 		= $param["sortField"] ? $param["sortField"] : "CUSTOMER_ID";
		$sortType 		= $param["sortType"] ? $param["sortType"] : "DESC";
		$search_field 	= $param['search_field'];
		$search_str 	= $param['search_str'];

		$sql_count  = "SELECT COUNT(*) AS CNT ";
		$sql_select = "SELECT c.MANAGE_USER,count(c.MANAGE_USER) as CUST_NUM,u.DEPT_ID,u.USER_PRIV ";
		$sql_from = "FROM customer as c
				LEFT JOIN user as u ON(u.USER_ID = c.MANAGE_USER)
				LEFT JOIN user_priv as up ON(up.USER_PRIV = u.USER_PRIV)
				LEFT JOIN department as d ON(u.DEPT_ID = d.DEPT_ID)
				WHERE 1=1 ";
		$sql_where = '';
		if($search_field =="MANAGE_USER_NAME"){
			$sql_where .= "AND u.USER_NAME LIKE '%".SecurityFilter($search_str)."%' ";
		}else if($search_field =="DEPT_NAME"){
			$sql_where .= "AND d.DEPT_NAME LIKE '%".SecurityFilter($search_str)."%' ";
		}else if($search_field =="ROLE_NAME"){
			$sql_where .= "AND up.PRIV_NAME LIKE '%".SecurityFilter($search_str)."%' ";
		}

		$sql_where .= "group by c.MANAGE_USER";
		$middle="from (SELECT c.MANAGE_USER,count(c.MANAGE_USER) as CUST_NUM ";

		if($type == 1){
			if($sortField != "CUSTOMER_ID"){
				$sql_where.=" ORDER BY  " . $sortField . " " . $sortType;
			}
			$sql_where.=" LIMIT " . $limitOffset . "," . $limitRows;

			return $sql_select.$sql_from.$sql_where;
		}else if($type == 2){
			if(empty($search_field)){
				return "SELECT COUNT(DISTINCT MANAGE_USER) AS CNT FROM customer";
			}else{
				return $sql_count.$middle.$sql_from.$sql_where." ) a";
			}

		}
    }

    /**
     * 获取业务机会
     * @access public
     * @param array $param ,$type:1获取列表sql,2:获取数量sql
     * @return bool
     */
    public function getOperationSql($param,$type=1) {
		$limitRows 		= $param["itemsPerPage"];
		$limitOffset 	= $param["currentPage"] * $limitRows;
		$sortField 		= $param["sortField"] ? $param["sortField"] : "OPER_ID";
		$sortType 		= $param["sortType"] ? $param["sortType"] : "DESC";
		$customerID 	= (int)$param['customerID'];
		$quicksort 		= $param['quick_sort'];
		$search_field 	= $param['search_field'];
		$search_str 	= htmlspecialchars($param['search_str']);

		$sql_select = "SELECT o.*,c.MANAGE_USER,c.CUSTOMER_NAME ";
		$sql_count = "SELECT COUNT(*) AS CNT ";
		$sql_from = "FROM operation as o,customer c WHERE o.CUSTOMER_ID=c.CUSTOMER_ID AND o.CUSTOMER_ID='" . SecurityFilter($customerID) . "' ";
		$sql_where = '';
		if ($search_field && $search_str) {
			$sql_where .= " AND o.".$search_field." like '%".SecurityFilter($search_str)."%'";
		}

		$isStarRank=0;
		if($quicksort) {
			switch($quicksort) {
				case "create":
					$sql_where .= " AND o.CREATOR='".SecurityFilter($_SESSION['LOGIN_USER_ID'])."'";
					break;
				case "monthend":
					$sql_where .= " AND DATE_FORMAT(o.OPER_DATE,'%Y-%m')=DATE_FORMAT(NOW(),'%Y-%m')";
					break;
				case "thismonth":
					$sql_where .= " AND DATE_FORMAT(o.CREATE_TIME,'%Y-%m')=DATE_FORMAT(NOW(),'%Y-%m')";
					break;
				case "startrank":
					$sql_where .= " ORDER BY CAST(o.OPER_START AS DECIMAL) DESC LIMIT 0,10";
					$isStarRank=1;
					break;
			}
		}

		if($type == 1){
			if ($isStarRank==0) {
				$sql_where .=" ORDER BY  o." . $sortField . " " . $sortType . "
					LIMIT " . $limitOffset . "," . $limitRows;
				return $sql_select.$sql_from.$sql_where;
			}else{
				return $sql_select.$sql_from.$sql_where;
			}
		}else if($type == 2){
			return $sql_count.$sql_from.$sql_where;
		}

    }

/**
     * 获取导入导出SQL
     * @access public
     * @param array $param ,$type:1获取列表sql,2:获取数量sql
     * @return bool
     */
    public function getImportSql($param,$type=1) {
		$purview_where 	= $this->get_purview_where();
		$quicksort 		= $param['quick_sort'];
		$where_query 	= $param['where_query'];
		$search_field 	= $param['search_field'];
		$search_str 	= $param['search_str'];

		$sql_select = "SELECT pro.proName,cit.cityName,c.CUSTOMER_ID, c.CUSTOMER_NAME, c.TEL_NO, c.FAX_NO, c.EMAIL,c.CREATE_TIME, c.CUSTOMER_TYPE,c.MANAGE_USER,c.PURVIEW,c.CUSTOMER_ADD,c.CUSTOMER_NUMBER,c.CUSTOMER_WWW,c.POSTALCODE,c.LE_PERSON,c.CUSTOMER_NAME_PY,c.CUSTOMER_NAME_ZM,u.USER_NAME,u.USER_ID,u.AVATAR_TYPE, u.DEPT_ID, u.USER_ACCOUNTS ";

		$sql_count = "SELECT COUNT(*) AS CNT ";

		$sql_from = "FROM customer as c
				LEFT JOIN province as pro ON(c.PROVINCE = pro.proID)
				LEFT JOIN city as cit ON(c.CITY = cit.cityId)
				LEFT JOIN user as u ON(u.USER_ID = c.MANAGE_USER)
				LEFT JOIN user_priv as up ON(up.USER_PRIV = u.USER_PRIV)
					WHERE $purview_where";
		$sql_where = '';
		if ($search_field =="CUSTOMER_NAME") {
			$sql_where .= " AND c.".$search_field." like '%".SecurityFilter($search_str)."%'";
		}elseif ($search_field =="proName") {
			$sql_where .= " AND pro.".$search_field." like '%".SecurityFilter($search_str)."%'";
		}elseif ($search_field =="cityName") {
			$sql_where .= " AND cit.".$search_field." like '%".SecurityFilter($search_str)."%'";
		}

		if ($where_query!='') {
			$where_query = stripslashes($where_query);
			$sql_where .= $where_query;
		}

		if($quicksort) {
			switch($quicksort) {
				case"manage_user":
					$sql_where .= " AND c.MANAGE_USER='".SecurityFilter($_SESSION["LOGIN_USER_ID"])."'";
					break;
				case"thismonth":
					$sql_where .= " AND DATE_FORMAT(c.CREATE_TIME,'%Y-%m')=DATE_FORMAT(NOW(),'%Y-%m')";
					break;
				case"create":
					$sql_where .= " AND c.CREATEOR='".SecurityFilter($_SESSION["LOGIN_USER_ID"])."'";
					break;
			}
		}

		if($type == 1){
			return $sql_select.$sql_from.$sql_where;
		}else if($type == 2){
			return $sql_count.$sql_from.$sql_where;
		}
    }


/**
     * 获取客户列表
     * @access public
     * @param array $param ,$type:1获取列表sql,2:获取数量sql
     * @return bool
     */
    public function getCustomerListSql($param) {
		$where_str = '';
		if($param['query'] == 1 ){
			$where_str .= " and c.CUSTOMER_NAME like '%".SecurityFilter($CUSTOMER_NAME)."%' ";
		}
		$manage_id = '"'.str_replace(",","\",\"",rtrim($param["manage_id"],",")).'"';

		if($manage_id){
			$where_str .= " and c.MANAGE_USER in(".SecurityFilter($manage_id).") ";
		}

		$sql = " SELECT c.CUSTOMER_ID, c.CUSTOMER_NAME, c.TEL_NO, c.FAX_NO, c.EMAIL,
						c.CUSTOMER_TYPE,c.MANAGE_USER,c.PURVIEW,u.USER_NAME
				 FROM customer as c
			     LEFT JOIN user as u ON u.USER_ID = c.MANAGE_USER
				 WHERE 1 " . $where_str. ' LIMIT 0,100 ';
		return $sql;
    }

/**
     * 获取客户列表
     * @access public
     * @param array $param ,$type:1获取列表sql,2:获取数量sql
     * @return bool
     */
    public function getCustomerInfoSql($param) {
			$sql	= "SELECT c.*, u.USER_NAME FROM customer as c, USER as u WHERE c.MANAGE_USER=u.USER_ID GROUP BY c.CUSTOMER_NAME";
			switch($param['order']){
				case 'customer_name':
					$sql	.= " ORDER BY c.CUSTOMER_NAME";
					break;
				case 'tel_no':
					$sql	.= " ORDER BY c.TEL_NO";
					break;
				default:
					$sql	.= " ORDER BY c.CUSTOMER_ID";
					break;
			}
			$sql	.= $param['sens']?' ASC':' DESC';
			return $sql;
    }

    /**
     * 获取客户数量
     * @access public
     * @param array $param ,$type:1获取列表sql,2:获取数量sql
     * @return bool
     */
    public function getCustomerSql($param,$type=1,$cate='crm_move') {
		$limitRows 		= $param["itemsPerPage"];
		$limitOffset	= $param["currentPage"] * $limitRows;
		$sortField 		= $param["sortField"] ? $param["sortField"] : "CUSTOMER_ID";
		$sortType 		= $param["sortType"] ? $param["sortType"] : "DESC";
		$quicksort 		= $param['quick_sort'];
		$where_query 	= $param['where_query'];
		$search_field 	= $param['search_field'];
		$search_str 	= $param['search_str'];


		$purview_where = $this->get_purview_where();

		$sql_count = "SELECT COUNT(*) AS CNT ";
		$sql_select = "SELECT pro.proName,cit.cityName,c.CUSTOMER_ID, c.CUSTOMER_NAME, c.TEL_NO, c.FAX_NO, c.EMAIL,c.CREATE_TIME, c.CUSTOMER_TYPE,c.MANAGE_USER,c.PURVIEW,c.CUSTOMER_ADD,c.CUSTOMER_NUMBER,c.CUSTOMER_WWW,c.POSTALCODE,c.LE_PERSON,c.CUSTOMER_NAME_PY,c.CUSTOMER_NAME_ZM,u.USER_NAME,u.USER_ID,u.AVATAR_TYPE, u.DEPT_ID, u.USER_ACCOUNTS ";

		$sql_from = "FROM customer as c
				LEFT JOIN province as pro ON(c.PROVINCE = pro.proID)
				LEFT JOIN city as cit ON(c.CITY = cit.cityId)
				LEFT JOIN user as u ON(u.USER_ID = c.MANAGE_USER)
				LEFT JOIN user_priv as up ON(up.USER_PRIV = u.USER_PRIV)";

		if($cate == 'crm_move'){
			$sql_from .= " WHERE 1=1";
		}else if($cate == 'import'){
			$sql_from .= " WHERE $purview_where";
		}

		$sql_where = '';
		if ($search_field =="CUSTOMER_NAME") {
			$sql_where .= " AND c.".$search_field." like '%".SecurityFilter($search_str)."%'";
		} elseif ($search_field =="proName") {
			$sql_where .= " AND pro.".$search_field." like '%".SecurityFilter($search_str)."%'";
		} elseif ($search_field =="cityName") {
			$sql_where .= " AND cit.".$search_field." like '%".SecurityFilter($search_str)."%'";
		} else if ($search_field =="MANAGE_USER_NAME") {
			$sql_where .= " AND u.USER_NAME like '%".SecurityFilter($search_str)."%'";
		} else if ($search_field =="DEPT_NAME") {
			$sql_where .= " AND d.DEPT_NAME like '%".SecurityFilter($search_str)."%'";
		} else if ($search_field =="ROLE_NAME") {
			$sql_where .= " AND up.PRIV_NAME like '%".SecurityFilter($search_str)."%'";
		}

		if ($where_query!='') {
			$where_query = stripslashes($where_query);
			$sql_where .= $where_query;
		}

		if($quicksort) {
			switch($quicksort) {
				case"manage_user":
					$sql_where .= " AND c.MANAGE_USER='".SecurityFilter($_SESSION["LOGIN_USER_ID"])."'";
					break;
				case"thismonth":
					$sql_where .= " AND DATE_FORMAT(c.CREATE_TIME,'%Y-%m')=DATE_FORMAT(NOW(),'%Y-%m')";
					break;
				case"create":
					$sql_where .= " AND c.CREATEOR='".SecurityFilter($_SESSION["LOGIN_USER_ID"])."'";
					break;
			}
		}

		if($type == 1){
			$sql_where .= " ORDER BY  c." . $sortField . " " . $sortType . "
				LIMIT " . $limitOffset . "," . $limitRows;
			return $sql_select.$sql_from.$sql_where;
		}else if($type == 2){
			if(empty($quicksort)&&empty($where_query)&&empty($search_field)&&$cate!='import'){
				return $sql_count."FROM customer as c";
			}else{
				return $sql_count.$sql_from.$sql_where;
			}
		}else if($type == 3){
			$new_manager=rtrim($param["MANAGE_USER"],",");
			$sql_from = "FROM customer as c
					LEFT JOIN province as pro ON(c.PROVINCE = pro.proID)
					LEFT JOIN city as cit ON(c.CITY = cit.cityId)
					LEFT JOIN user as u ON(u.USER_ID = c.MANAGE_USER)
					LEFT JOIN department as d ON(u.DEPT_ID = d.DEPT_ID)
					LEFT JOIN user_priv as up ON(up.USER_PRIV = u.USER_PRIV)
						WHERE 1=1";
			return $sql_select.$sql_from.$sql_where;
		}
    }

    /**
     * 获取分享权限
     * @access public
     * @param array $param ,$type:1获取列表sql,2:获取数量sql
     * @return bool
     */
    public function getPermissionSql($param,$type=1) {
		$search_field 	= $param['search_field'];
		$search_str 	= $param['search_str'];
		$sql_count = "SELECT COUNT(*) AS CNT ";
		$sql_select = "SELECT c.CUSTOMER_ID, c.CUSTOMER_NAME, c.CREATE_TIME ,u.USER_NAME AS MANAGE_USER_NAME ";
		$sql_from = "FROM customer AS c
		             LEFT JOIN user as u ON(u.USER_ID = c.MANAGE_USER) ";

		if ($search_field =="CUSTOMER_NAME") {
			$sql_where = "WHERE c.".$search_field." like '%".SecurityFilter($search_str)."%' ";
		}

		if($type == 1){
			$sql_where .= "ORDER BY c.CUSTOMER_ID DESC ";
			return $sql_select.$sql_from.$sql_where;
		}else if($type == 2){
			return $sql_count.$sql_from.$sql_where;
		}
    }

	/**
     * 获取联系人
     * @access public
     * @param array $param ,$type:1获取列表sql,2:获取数量sql
     * @return bool
     */
    public function getCustomerIndexSql($param,$type=1,$userId = '') {
		$purview_where  		=   $this->get_purview_where($userId);
		$limitRows 	  			= 	$param["itemsPerPage"];
		$limitOffset  			= 	$param["currentPage"] * $limitRows;
		$sortField    			= 	$param["sortField"] ? $param["sortField"] : "CUSTOMER_ID";
		$sortType 	  			= 	$param["sortType"] ? $param["sortType"] : "DESC";
		$quicksort 				= 	$param['quick_sort'];
		$datefilter 			= 	$param['date_filter'];
		$customer_type_sort 	= 	$param['customer_type_sort'];
		$customer_industry_sort = 	$param['customer_industry_sort'];
		$customer_provice_sort  = 	$param['customer_provice_sort'];
		$search_field 			= 	$param['search_field'];
		$search_str   			= 	$param['search_str'];

		$sql_select   = "SELECT c.CUSTOMER_ID,c.CREATE_TIME,c.CUSTOMER_NAME,c.CUSTOMER_TYPE,c.TEL_NO,c.MANAGE_USER,c.SERVICE_USER,u.USER_ID,u.USER_NAME AS MANAGE_USER_NAME,u.MOBIL_NO AS MANAGE_USER_PHONE,u.AVATAR_TYPE ";
		$sql_count = "SELECT COUNT(*) AS CNT ";

		$sql_from = "FROM customer as c
				LEFT JOIN user as u ON u.USER_ID = c.MANAGE_USER
				WHERE $purview_where";

		$sql_where = '';

		if ($customer_type_sort) {
			$sql_where .= " AND c.CUSTOMER_TYPE='".$customer_type_sort."'";
		}

		if($datefilter && strpos($datefilter,'-')){
			$timeArr = explode('-',$datefilter);
			$dateTime = date("Y-m-d", strtotime("-".$timeArr[1]))." 23:59:59";
            $dateTime = SecurityFilter($dateTime);
			if($timeArr[0]=='ncontact'){
				$sql_where .= " AND c.LAST_RECORD_TIME<'".$dateTime."'";
			}else if($timeArr[0]=='contact'){
				$sql_where .= " AND c.LAST_RECORD_TIME>'".$dateTime."'";
			}else if($timeArr[0]=='create'){
				$sql_where .= " AND c.CREATE_TIME>'".$dateTime."'";
			}else if($timeArr[0]=='nremind'){
				$date = date("Y-m-d", strtotime("+".$timeArr[1]));
				$today = date("Y-m-d");

				$sql_from = "FROM customer as c
						LEFT JOIN user as u ON u.USER_ID = c.MANAGE_USER
						LEFT JOIN relation_remind as rrd ON rrd.CUSTOMER_ID = c.CUSTOMER_ID
						WHERE $purview_where";

				$sql_where .= " AND rrd.REMIND_DATE >= '".SecurityFilter($today) ."' AND rrd.REMIND_DATE < '". SecurityFilter($date) ."'";
			}

		}

		if($quicksort){
			switch($quicksort) {
				case"manage_user":
					$sql_where .= " AND c.MANAGE_USER='".SecurityFilter($_SESSION["LOGIN_USER_ID"])."'";
					break;
				case"service_user":
					$sql_where .= " AND c.SERVICE_USER='".SecurityFilter($_SESSION["LOGIN_USER_ID"])."'";
					break;
				case"create":
					$sql_where .= " AND c.CREATEOR='".SecurityFilter($_SESSION["LOGIN_USER_ID"])."'";
					break;
			}
		}

		if ($customer_industry_sort) {
			$sql_where .= " AND c.CUSTOMER_INDUSTRY='".SecurityFilter($customer_industry_sort)."'";
		}

		if ($customer_provice_sort) {
			$sql_where .= " AND c.PROVINCE='".SecurityFilter($customer_provice_sort)."'";
		}

		if (!empty($search_field)&&$search_field=='MANAGE_USER') {
			$sql_where .= " AND u.USER_NAME like '%".SecurityFilter($search_str)."%'";
		}else if (!empty($search_field)&&$search_field=='SERVICE_USER') {
			$sql_from = "FROM customer as c
					LEFT JOIN user as u ON u.USER_ID = c.MANAGE_USER
					LEFT JOIN user as us ON us.USER_ID = c.SERVICE_USER
					WHERE $purview_where";
			$sql_where .= " AND us.USER_NAME like '%".SecurityFilter($search_str)."%'";
		}else if (!empty($search_field)&&!empty($search_str)&&$search_field!='MANAGE_USER') {
			$sql_where .= " AND c.".$search_field." like '%".SecurityFilter($search_str)."%'";
		}

		if(isset($param["where_query"])&&!empty($param["where_query"])){
			$where_query = stripslashes($param["where_query"]);

			if (strpos($where_query, 'rr') !== false) {
				$sql_select   = "SELECT DISTINCT(c.CUSTOMER_ID),c.CREATE_TIME,c.CUSTOMER_NAME,c.CUSTOMER_TYPE,c.TEL_NO,c.MANAGE_USER,c.SERVICE_USER,u.USER_ID,u.USER_NAME AS MANAGE_USER_NAME,u.MOBIL_NO AS MANAGE_USER_PHONE,u.AVATAR_TYPE ";
				$sql_count = "SELECT COUNT(DISTINCT(c.CUSTOMER_ID)) AS CNT ";

				$sql_from = "FROM customer as c
						LEFT JOIN user as u ON u.USER_ID = c.MANAGE_USER
						LEFT JOIN relation_record as rr ON rr.CUSTOMER_ID = c.CUSTOMER_ID
						WHERE $purview_where";
			}

			$sql_where .= " ".$where_query." ";
		}

		$sql_order_limit .=" ORDER BY c." . $sortField . " " . $sortType . "
				  LIMIT " . $limitOffset . "," . $limitRows;

		if($type == 1){
			return $sql_select.$sql_from.$sql_where.$sql_order_limit;
		}else if($type == 2){
			return $sql_count.$sql_from.$sql_where;
		}
    }

	/**
     * 获取回收站客户
     * @access public
     * @param array $param ,$type:1获取列表
     * @return bool
     */
    public function getCustomerRecycleSql($param,$type=1) {
		$limitRows 		= $param["itemsPerPage"];
		$limitOffset	= $param["currentPage"] * $limitRows;
		$sortField 		= $param["sortField"] ? $param["sortField"] : "CUSTOMER_ID";
		$sortType 		= $param["sortType"] ? $param["sortType"] : "DESC";
		$quicksort 		= $param['quick_sort'];
		$where_query 	= $param['where_query'];
		$search_field 	= $param['search_field'];
		$search_str 	= $param['search_str'];

		$sql_count = "SELECT COUNT(*) ";
		$sql_select = "SELECT pro.proName,cit.cityName,c.CUSTOMER_ID, c.CUSTOMER_NAME, c.TEL_NO, c.FAX_NO, c.EMAIL,c.CREATE_TIME, c.CUSTOMER_TYPE,c.MANAGE_USER,c.PURVIEW,c.CUSTOMER_ADD,c.CUSTOMER_NUMBER,c.CUSTOMER_WWW,c.POSTALCODE,c.LE_PERSON,c.CUSTOMER_NAME_PY,c.CUSTOMER_NAME_ZM,u.USER_NAME,u.USER_ID,u.AVATAR_TYPE, u.DEPT_ID, u.USER_ACCOUNTS ";

		$sql_from = "FROM customer_recycle as c
				LEFT JOIN user as u ON(u.USER_ID = c.MANAGE_USER)
				LEFT JOIN province as pro ON(c.PROVINCE = pro.proID)
				LEFT JOIN city as cit ON(c.CITY = cit.cityId)";


		if (!empty($search_field)&&$search_field=='MANAGE_USER') {
			$sql_where .= " AND u.USER_NAME like '%".SecurityFilter($search_str)."%'";
		}else if (!empty($search_field)&&$search_field=='SERVICE_USER') {
			$sql_from = "FROM customer_recycle as c
					LEFT JOIN user as u ON u.USER_ID = c.MANAGE_USER
					LEFT JOIN user as us ON us.USER_ID = c.SERVICE_USER
					LEFT JOIN province as pro ON(c.PROVINCE = pro.proID)
					LEFT JOIN city as cit ON(c.CITY = cit.cityId)";
			$sql_where .= " AND us.USER_NAME like '%".SecurityFilter($search_str)."%'";
		}else if (!empty($search_field)&&!empty($search_str)&&$search_field!='MANAGE_USER') {
			$sql_where .= " AND c.".$search_field." like '%".SecurityFilter($search_str)."%'";
		}

		$sql_from .= " WHERE 1";

		if ($where_query!='') $sql_where .= stripslashes($where_query);

		if($type == 1){
			$sql_where .= " ORDER BY  c." . $sortField . " " . $sortType . "
				LIMIT " . $limitOffset . "," . $limitRows;
			return $sql_select.$sql_from.$sql_where;
		}else if($type == 2){
			if(empty($quicksort)&&empty($where_query)&&empty($search_field)){
				return $sql_count."FROM customer_recycle as c";
			}else{
				return $sql_count.$sql_from.$sql_where;
			}
		}
    }

	/**
     * 获取回收站客户
     * @access public
     * @param array $param ,$type:1获取列表
     * @return bool
     */
    public function getCustomerMergeSql($param,$type=1) {
		$limitRows 		= $param["itemsPerPage"];
		$limitOffset	= $param["currentPage"] * $limitRows;
		$sortField 		= $param["sortField"] ? $param["sortField"] : "CUSTOMER_ID";
		$sortType 		= $param["sortType"] ? $param["sortType"] : "DESC";
		$quicksort 		= $param['quick_sort'];
		$where_query 	= $param['where_query'];
		$search_field 	= $param['search_field'];
		$search_str 	= $param['search_str'];

		$sql_count = "SELECT COUNT(*) ";
		$sql_select = "SELECT pro.proName,cit.cityName,c.CUSTOMER_ID, c.CUSTOMER_NAME, c.TEL_NO, c.FAX_NO, c.EMAIL,c.CREATE_TIME, c.CUSTOMER_TYPE,c.MANAGE_USER,c.PURVIEW,c.CUSTOMER_ADD,c.CUSTOMER_NUMBER,c.CUSTOMER_WWW,c.POSTALCODE,c.LE_PERSON,c.CUSTOMER_NAME_PY,c.CUSTOMER_NAME_ZM,u.USER_NAME,u.USER_ID,u.AVATAR_TYPE, u.DEPT_ID, u.USER_ACCOUNTS ";

		$sql_from = "FROM customer as c
				LEFT JOIN user as u ON(u.USER_ID = c.MANAGE_USER)
				LEFT JOIN province as pro ON(c.PROVINCE = pro.proID)
				LEFT JOIN city as cit ON(c.CITY = cit.cityId)";


		if (!empty($search_field)&&$search_field=='MANAGE_USER') {
			$sql_where .= " AND u.USER_NAME like '%".SecurityFilter($search_str)."%'";
		}else if (!empty($search_field)&&$search_field=='SERVICE_USER') {
			$sql_from = "FROM customer as c
					LEFT JOIN user as u ON u.USER_ID = c.MANAGE_USER
					LEFT JOIN user as us ON us.USER_ID = c.SERVICE_USER
					LEFT JOIN province as pro ON(c.PROVINCE = pro.proID)
					LEFT JOIN city as cit ON(c.CITY = cit.cityId)";
			$sql_where .= " AND us.USER_NAME like '%".SecurityFilter($search_str)."%'";
		}else if (!empty($search_field)&&!empty($search_str)&&$search_field!='MANAGE_USER') {
			$sql_where .= " AND c.".$search_field." like '%".SecurityFilter($search_str)."%'";
		}

		$sql_from .= " WHERE 1 ";

		if ($where_query!='') {
			$where_query = stripslashes($where_query);
			$sql_where .= $where_query;
		}

		if($type == 1){
			$sql_where .= " ORDER BY  c." . $sortField . " " . $sortType . "
				LIMIT " . $limitOffset . "," . $limitRows;
			return $sql_select.$sql_from.$sql_where;
		}else if($type == 2){
			if(empty($quicksort)&&empty($where_query)&&empty($search_field)){
				return $sql_count."FROM customer as c";
			}else{
				return $sql_count.$sql_from.$sql_where;
			}
		}
    }

	/**
     * 获取联系人
     * @access public
     * @param array $param ,$type:1获取列表sql,2:获取数量sql
     * @return bool
     */
    public function getCustomerLinkSql($param,$type=1) {
		$purview_where  = $this->get_purview_where();
		$limitRows 		= $param["itemsPerPage"];
		$limitOffset 	= $param["currentPage"] * $limitRows;
		$sortField 		= $param["sortField"] ? $param["sortField"] : "CUSTOMER_NAME_ZM";
		$sortType 		= $param["sortType"] ? $param["sortType"] : "DESC";
		$search_field 	= $param['search_field'];
		$search_str 	= $param['search_str'];

		$sql_select = "SELECT c.CUSTOMER_ID, c.CUSTOMER_NAME,c.MANAGE_USER,c.CREATE_TIME ";
		$sql_count 	= "SELECT COUNT(*) AS CNT ";


		$sql_from = "FROM customer as c
				LEFT JOIN user as u ON(u.USER_ID = c.MANAGE_USER)
				LEFT JOIN user_priv as up ON(up.USER_PRIV = u.USER_PRIV)
					WHERE $purview_where";

		$sql_where = '';
		if ($search_field) {
			$sql_where .= " AND c.".$search_field." like '%".SecurityFilter($search_str)."%'";
		}

		$sql_order_limit = " ORDER BY c." . $sortField . " " . $sortType . "
				  LIMIT " . $limitOffset . "," . $limitRows;

		if($type == 1){
			return $sql_select.$sql_from.$sql_where.$sql_order_limit;
		}else if($type == 2){
			return $sql_count.$sql_from.$sql_where;
		}
    }

/**
     * 获取联系人
     * @access public
     * @param array $param ,$type:1获取列表sql,2:获取数量sql
     * @return bool
     */
    public function getCustomerAllLinkSql($param,$type=1) {
		$limitRows 		= $param["itemsPerPage"];
		$limitOffset 	= $param["currentPage"] * $limitRows;
		$sortField 		= $param["sortField"] ? $param["sortField"] : "CUSTOMER_NAME_ZM";
		$sortType 		= $param["sortType"] ? $param["sortType"] : "DESC";
		$search_field 	= $param['search_field'];
		$search_str 	= $param['search_str'];

		$sql_select 	= "SELECT CUSTOMER_ID,CUSTOMER_NAME,MANAGE_USER ";
		$sql_count 		= "SELECT COUNT(*) AS CNT ";
		$sql_from 		= "FROM customer WHERE 1=1";
		$sql_where = '';
		if ($search_field) {
			$sql_where .= " AND ".$search_field." like '%".SecurityFilter($search_str)."%'";
		}

		$sql_order_limit  =  " ORDER BY " . $sortField . " " . $sortType . "
				  LIMIT " . $limitOffset . "," . $limitRows;

		if($type == 1){
			return $sql_select.$sql_from.$sql_where.$sql_order_limit;
		}else if($type == 2){
			return $sql_count.$sql_from.$sql_where;
		}

    }

/**
     * 获取联系人
     * @access public
     * @param array $param ,$type:1获取列表sql,2:获取数量sql
     * @return bool
     */
    public function getLinkmanSql($param,$type=1) {
		$purview_where 	= $this->get_purview_where();
		$limitRows 		= $param["itemsPerPage"];
		$limitOffset 	= $param["currentPage"] * $limitRows;
		$sortField 		= $param["sortField"] ? $param["sortField"] : "LINKMAN_ID";
		$sortType 		= $param["sortType"] ? $param["sortType"] : "DESC";
		$quicksort 		= $param["quick_sort"];
		$where_query 	= $param['where_query'];
		$search_field	= $param['search_field'];
		$search_str 	= dhtmlspecialchars($param['search_str']);

		$sql_select		= "SELECT l.*, c.MANAGE_USER, c.CUSTOMER_NAME, c.SERVICE_USER ";
		$sql_count		= "SELECT count(*) as CNT ";
		$sql_from		= "FROM linkman as l
				LEFT JOIN customer as c ON l.CUSTOMER_ID = c.CUSTOMER_ID
				WHERE $purview_where";
		$sql_where = '';
		if($quicksort) {
			switch($quicksort) {
				case "thismonth":
					$sql_where .= " AND MONTH(l.BIRTHDAY)=MONTH(CURDATE())";
					break;
				case "nextmonth":
					$sql_where .= " AND ((DATE_FORMAT(l.BIRTHDAY,'%m')=(MONTH(CURDATE())+1)) OR ((MONTH(CURDATE())=12 AND MONTH(l.BIRTHDAY)=1)))";
					break;
				case "thisweek":
					$thisMonday = date('Y-m-d', time()-86400*date('w')+(date('w')>0?86400:-6*86400));
					$thisSunday = date('Y-m-d', time()-86400*date('w')+(date('w')>0?(86400*7):86400));

					if(date(n,strtotime($thisMonday))<=date(n,strtotime($thisSunday))) {
						$sql_where .= " AND DATE_FORMAT(l.BIRTHDAY,'%m-%d') >= DATE_FORMAT(DATE_ADD(CURDATE(),INTERVAL -WEEKDAY(CURDATE()) DAY),'%m-%d') AND DATE_FORMAT(l.BIRTHDAY,'%m-%d')<=DATE_FORMAT(DATE_ADD(CURDATE(),INTERVAL 6-WEEKDAY(CURDATE()) DAY),'%m-%d')";
					} else {
						$sql_where .= " AND ((DATE_FORMAT(l.BIRTHDAY,'%m-%d')>=DATE_FORMAT(DATE_ADD(CURDATE(),INTERVAL -WEEKDAY(CURDATE()) DAY),'%m-%d') AND DATE_FORMAT(l.BIRTHDAY,'%m-%d')<='12-31') OR (DATE_FORMAT(l.BIRTHDAY,'%m-%d')>='01-01' AND DATE_FORMAT(l.BIRTHDAY,'%m-%d')<=DATE_FORMAT(DATE_ADD(CURDATE(),INTERVAL 6-WEEKDAY(CURDATE()) DAY),'%m-%d')))";
					}
					break;
				case "nextweek":
					$nextMonday = date('Y-m-d', time()-86400*date('w')+(date('w')>0?(86400*8):86400));
					$nextSunday = date('Y-m-d', time()-86400*date('w')+(date('w')>0?(86400*15):(86400*8)));

					if(date(n,strtotime($nextMonday))<=date(n,strtotime($nextSunday))) {
						$sql_where .= " AND DATE_FORMAT(l.BIRTHDAY,'%m-%d') >= DATE_FORMAT(DATE_ADD((DATE_ADD(CURDATE(),INTERVAL -WEEKDAY(CURDATE()) DAY)),INTERVAL 7 DAY),'%m-%d') AND DATE_FORMAT(l.BIRTHDAY,'%m-%d') <= DATE_FORMAT(DATE_ADD((DATE_ADD(CURDATE(),INTERVAL -WEEKDAY(CURDATE()) DAY)),INTERVAL 13 DAY),'%m-%d')";
					} else {
						$sql_where .= " AND ((DATE_FORMAT(l.BIRTHDAY,'%m-%d')>=DATE_FORMAT(DATE_ADD((DATE_ADD(CURDATE(),INTERVAL -WEEKDAY(CURDATE()) DAY)),INTERVAL 7 DAY),'%m-%d') AND DATE_FORMAT(l.BIRTHDAY,'%m-%d')<='12-31') OR (DATE_FORMAT(l.BIRTHDAY,'%m-%d')>='01-01' AND DATE_FORMAT(l.BIRTHDAY,'%m-%d')<=DATE_FORMAT(DATE_ADD((DATE_ADD(CURDATE(),INTERVAL -WEEKDAY(CURDATE()) DAY)),INTERVAL 13 DAY),'%m-%d')))";
					}
					break;
				case "create":
					$sql_where .= " AND l.CREATEOR='".SecurityFilter($_SESSION['LOGIN_USER_ID'])."'";
					break;
			}
		}

		if ($where_query!='') {
			$sql_where .= stripslashes($where_query);
		}

		if ($search_field) {
			$sql_where .= " AND l.".$search_field." like '%".SecurityFilter($search_str)."%'";
		}


		$sql_order_limit =" ORDER BY  " . $sortField . " " . $sortType . "
					LIMIT " . $limitOffset . "," . $limitRows;

		if($type == 1){
			return $sql_select.$sql_from.$sql_where.$sql_order_limit;
		}else if($type == 2){
			return $sql_count.$sql_from.$sql_where;
		}

    }

    /**
     * 获取联系记录数量
     * @access public
     * @param array $param ,$type:1获取列表sql,2:获取数量sql
     * @return bool
     */
    public function getRecordSql($param,$type=1) {
		$perPage  		=	 isset($param["itemsPerPage"])?$param["itemsPerPage"]:15;
		$offset  		=	 $param["currentPage"]*$perPage;

		$record_type 	=	 isset($param['quick_sort'])?$param['quick_sort']:'';
		$search_field 	=	 isset($param['search_field'])?$param['search_field']:'';
		$search_str   	=	 $param['search_str'];
		$where_sql 		=	 isset($param['where_sql'])?$param['where_sql']:'';

		$sortField      =	 $_REQUEST["sortField"] ? $_REQUEST["sortField"] : "RE_ID";
		$sortType       =	 $_REQUEST["sortType"] ? $_REQUEST["sortType"] : "DESC";

		$purview_where  =	 $this->get_purview_where();
		$sql_count 	= "select count(*) as cnt ";
		$sql_select = "SELECT
					r.RE_ID,
					r.CREATEOR,
					r.RE_DATE1,
					r.RE_DATE2,
					r.RE_TIME1,
					r.RE_TIME2,
					r.RE_RECORD,
					r.LINKMAN_ID,
					r.RE_TYPE,
					r.CREAT_DATE,
					c.CUSTOMER_NAME,
					c.MANAGE_USER,
					c.CUSTOMER_ID";

			$sql_from = " FROM  `relation_record` AS r
					LEFT JOIN  `customer` AS c ON r.CUSTOMER_ID = c.CUSTOMER_ID ";

			if($search_field=='USER_NAME'){
				$sql_from .=" LEFT JOIN  `user` AS u ON u.USER_ID = r.CREATEOR ";

			}

			$sql_where = " WHERE $purview_where";

			if ($search_field) {
				$sql_where .= " AND ".$search_field." like '%".SecurityFilter($search_str)."%'";
			}

			if ($record_type == "my") {
				$sql_where .= " AND r.CREATEOR = '" . SecurityFilter($_SESSION['LOGIN_USER_ID']) . "'";
			} else if ($record_type == "other") {
				$sql_where .= " AND r.CREATEOR != '" . SecurityFilter($_SESSION['LOGIN_USER_ID']) . "'";
			}

			if ($where_sql) {
				$sql_where .= $where_sql;
			}

			if($type == 1){
				$sql_where .=" ORDER BY  " . $sortField . " " . $sortType . "
						 LIMIT ".$offset.",".$perPage;

				return $sql_select.$sql_from.$sql_where;
			}else if($type == 2){
				return $sql_count.$sql_from.$sql_where;
			}
    }

  /**
     * 获取联系记录数量
     * @access public
     * @param array $param ,$type:1获取列表sql,2:获取数量sql
     * @return bool
     */
    public function getRelationRecordSql($param,$type=1) {
		$purview_where  = $this->get_purview_where();
		$recordType 	= isset($param['recordType'])?$param['recordType']:'';
		$customerID 	= $param['customerID'];
		$limitRows  	= $param["itemsPerPage"];
		$limitOffset  	= $param["currentPage"] * $limitRows;
		$search_field 	= isset($param['search_field'])?$param['search_field']:'';
		$search_str   	= $param['search_str'];

		$sql_count = "select count(*) as cnt ";
		$sql_select = "SELECT
					r.RE_ID,
					r.CREATEOR,
					r.ATTACHMENT_ID,
					r.ATTACHMENT_NAME,
					r.RE_DATE1,
					r.RE_DATE2,
					r.RE_TIME1,
					r.RE_TIME2,
					r.ATTACHMENT_ID,
					r.ATTACHMENT_NAME,
					r.RE_RECORD,
					r.LINKMAN_ID,
					r.RE_TYPE,
					r.CREAT_DATE,
					c.CUSTOMER_NAME,
					c.MANAGE_USER AS MAN_USER,
					c.CUSTOMER_ID";

		if ($customerID) {
			$sql_select .= ",l.LINKMAN_NAME,u.USER_NAME";

			$sql_from = " FROM  `relation_record` AS r
					JOIN  `linkman` AS l ON r.LINKMAN_ID = l.LINKMAN_ID
					LEFT JOIN  `user` AS u ON r.CREATEOR = u.USER_ID
					LEFT JOIN  `customer` AS c ON r.CUSTOMER_ID = c.CUSTOMER_ID ";
			$query = " WHERE c.CUSTOMER_ID = '" . SecurityFilter($customerID) . "'";

			if ($search_field=="CUSTOMER_NAME") {
				$query .= " AND c.".$search_field." like '%".SecurityFilter($search_str)."%'";
			}else if ($search_field=="RE_RECORD") {
				$query .= " AND r.".$search_field." like '%".SecurityFilter($search_str)."%'";
			}else if ($search_field=="LINKMAN_NAME") {
				$query .= " AND l.".$search_field." like '%".SecurityFilter($search_str)."%'";
			}

		}else {
			$sql_from = " FROM  `relation_record` AS r
					LEFT JOIN  `customer` AS c ON r.CUSTOMER_ID = c.CUSTOMER_ID ";

			$query = " WHERE $purview_where";

			if ($recordType == "my") {
				$query .= " AND r.CREATEOR = '" . SecurityFilter($_SESSION['LOGIN_USER_ID']) . "'";
			} else if ($recordType == "else") {
				$query .= " AND r.CREATEOR != '" . SecurityFilter($_SESSION['LOGIN_USER_ID']) . "'";
			}

		}
		if($type == 1){
				$query .= " ORDER BY  `r`.`RE_ID` DESC ";
				$query .= " LIMIT ".$limitOffset.",".$limitRows;
			return $sql_select.$sql_from.$query;
		}else if($type == 2){
			return $sql_count.$sql_from.$query;
		}
    }


    /**
     * 获取联系提醒（数量）
     * @access public
     * @param array $param ,$type:1获取列表sql,2:获取数量sql
     * @return bool
     */
    public function getRelationRemindSql($param,$type=1) {
    	global $connection;
    	$purview_where  = $this->get_purview_where();
    	$returnStr = "";
		$customerID 	= $param['customerID'];
		$limitRows  	= $param["itemsPerPage"];
		$limitOffset  	= $param["currentPage"] * $limitRows;
		$quicksort 		= $param["quick_sort"];
		$search_field 	= $param['search_field'];
		$search_str 	= $param['search_str'];
		$where_query 	= $param['where_query'];
		$sortField 		= $param["sortField"] ? $param["sortField"] : "REMIND_DATE";
		$sortType 		= $param["sortType"] ? $param["sortType"] : "ASC";
		$sql_count = "select count(*) as cnt ";
		$sql_select = "SELECT
					r.REMIND_ID,
					r.SMS_ID,
					r.CUSTOMER_ID,
					r.CHARGEMAN_ID,
					r.LINKMAN_ID,
					r.REMIND_DATE,
					r.REMIND_CONTENT,
					r.REMIND_TYPE,
					r.IS_HANDLE,
					r.CREATOR,
					r.CREATE_DATE,
					c.CUSTOMER_ID,
					c.CUSTOMER_NAME";
		if ($customerID) {
			$sql_select .= ",l.LINKMAN_NAME,cc.CC_NAME";
			// $sql = "SELECT * FROM `customer` WHERE CUSTOMER_ID='".$customerID."'";
			// $cursor = exequery($connection,$sql);
			// while($row = mysql_fetch_array($cursor)){
			// 	$manage_user = $row['MANAGE_USER'];
			// 	$USER_ID = $row['PURVIEW_USER'];
			// 	$USER_PRIV = $row['PURVIEW_ROLE'];
			// 	$DEPT_ID = $row['PURVIEW_DEPT'];
			// 	$SERVICE_USER = $row['SERVICE_USER'];
			// 	$PURVIEW = $row['PURVIEW'];
			// 	$USER_ID = $USER_ID . $SERVICE_USER;
			// }
			// if($PURVIEW != '2'){
			// 	if($manage_user != ''){
			// 		$manager_priv_info = $this->get_login_priv($manage_user);
			// 		$ids = $this->get_userid_str($manager_priv_info,$manage_user);
			// 	}
			// 	if(str_replace(",","','",trim($USER_ID,",")) && trim($ids,"'")){
			// 	$returnStr .= " USER_ID IN ('".str_replace(",","','",trim($USER_ID,","))."',".trim($ids,",").") OR";
			// 	}elseif(str_replace(",","','",trim($USER_ID,","))){
			// 		$returnStr .= " USER_ID IN ('".str_replace(",","','",trim($USER_ID,","))."') OR";
			// 	}
			// 	if(str_replace(",","','",trim($USER_PRIV,",")))
			// 		$returnStr .= " USER_PRIV IN ('".str_replace(",","','",trim($USER_PRIV,","))."') OR";
			// 	if(str_replace(",","','",trim($DEPT_ID,",")))
			// 		$returnStr .= " DEPT_ID IN ('".str_replace(",","','",trim($DEPT_ID,","))."') ";
			// 	if(trim($returnStr,"OR"))
			// 	{
			// 		$idsarr = " ( ".trim($returnStr,"OR")." ) ";
			// 		$sql_from = " FROM  `relation_remind` AS r
			// 			LEFT JOIN  `customer` AS c ON r.CUSTOMER_ID = c.CUSTOMER_ID
			// 			LEFT JOIN  `combocox_child` AS cc ON r.REMIND_TYPE = cc.CC_VALUE AND cc.CC_PARENT_ID = 28
			// 			LEFT JOIN  `user` AS u ON  ".$idsarr ."
			// 			LEFT JOIN  `linkman` AS l ON r.LINKMAN_ID = l.LINKMAN_ID";
			// 		$query = " WHERE u.USER_ID = '".$_SESSION['LOGIN_USER_ID']."'  AND c.CUSTOMER_ID = '" . $customerID ."'  ";
			// 	}
			// }else{
				$sql_from = " FROM  `relation_remind` AS r
					LEFT JOIN  `customer` AS c ON r.CUSTOMER_ID = c.CUSTOMER_ID
					LEFT JOIN  `combocox_child` AS cc ON r.REMIND_TYPE = cc.CC_VALUE AND cc.CC_PARENT_ID = 28
					LEFT JOIN  `linkman` AS l ON r.LINKMAN_ID = l.LINKMAN_ID";
				$query = " WHERE $purview_where AND c.CUSTOMER_ID = '" . SecurityFilter($customerID) ."' ";
			// }
			if(!empty($where_query)){
				//高级搜索
				$query .= urldecode($where_query);
			}else{
				if($search_str && $search_field){
				if($search_str == "未处理"){
					$search_str = 0;
				}elseif($search_str == "已处理"){
					$search_str = 1;
				}
				$query .= " AND r.".$search_field." = '".SecurityFilter($search_str)."'";
				}
				if($quicksort) {
					switch($quicksort) {
						case "handled":
							$query .= " AND r.IS_HANDLE = '1'";
							break;
						case "unhandled":
							$query .= " AND r.IS_HANDLE = '0'";
							break;
						case "myall":
							$query .= " AND r.CHARGEMAN_ID = '".SecurityFilter($_SESSION['LOGIN_USER_ID'])."' ";
							break;
						case "myhandled":
							$query .= " AND r.CHARGEMAN_ID = '".SecurityFilter($_SESSION['LOGIN_USER_ID'])."' AND r.IS_HANDLE = '1'";
							break;
						case "myunhandled":
							$query .= " AND r.CHARGEMAN_ID = '".SecurityFilter($_SESSION['LOGIN_USER_ID'])."' AND r.IS_HANDLE = '0'";
							break;
					}
				}
			}
		}else {
			$sql_from = " FROM  `relation_remind` AS r
					LEFT JOIN  `customer` AS c ON r.CUSTOMER_ID = c.CUSTOMER_ID ";
			$query = " WHERE $purview_where";
		}
		if($type == 1){
			if($sortField == "REMIND_DATE" ){
				$query .= " ORDER BY r.IS_HANDLE ASC, r.REMIND_DATE " . SecurityFilter($sortType) .", r.CREATE_DATE ASC" ;
			}elseif($sortField == "CHARGEMAN_ID"){
				$query .= " ORDER BY r.CHARGEMAN_ID " . SecurityFilter($sortType) ."";
			}
				$query .= " LIMIT ".$limitOffset.",".$limitRows;
		    // echo $sql_select.$sql_from.$query;
		    // exit;
		    return $sql_select.$sql_from.$query;
		}else if($type == 2){
			return $sql_count.$sql_from.$query;
		}
    }



    /**
     * 获取联系人
     * @access public
     * @param array $param ,$type:1获取列表sql,2:获取数量sql
     * @return bool
     */
    public function getContactsSql($param,$type=1) {
		$purview_where 	= $this->get_purview_where();
		$limitRows 		= $param["itemsPerPage"];
		$limitOffset 	= $param["currentPage"] * $limitRows;
		$sortField 		= $param["sortField"] ? $param["sortField"] : "LINKMAN_ID";
		$sortType 		= $param["sortType"] ? $param["sortType"] : "DESC";
		$customerID 	= $param['customerID'];
		$quicksort 		= $param["quick_sort"];
		$search_field 	= $param['search_field'];
		$search_str 	= $param['search_str'];

		$sql_select	= "SELECT l.*, c.MANAGE_USER, c.CUSTOMER_NAME, u.USER_NAME ";
		$sql_count  = "SELECT count(*) as CNT ";

		$sql_from="FROM linkman as l
						  LEFT JOIN customer as c ON l.CUSTOMER_ID = c.CUSTOMER_ID
						  INNER JOIN user as u ON u.USER_ID = c.MANAGE_USER
						  INNER JOIN user_priv as up ON up.USER_PRIV = u.USER_PRIV
								WHERE 1=1 AND l.CUSTOMER_ID = '" . SecurityFilter($customerID) . "' AND $purview_where";
		$sql_where = '';
		if($quicksort) {
			switch($quicksort) {
				case "thismonth":
					$sql_where .= " AND MONTH(l.BIRTHDAY)=MONTH(CURDATE())";
					break;
				case "nextmonth":
					$sql_where .= " AND ((DATE_FORMAT(l.BIRTHDAY,'%m')=(MONTH(CURDATE())+1)) OR ((MONTH(CURDATE())=12 AND MONTH(l.BIRTHDAY)=1)))";
					break;
				case "thisweek":
					$thisMonday = date('Y-m-d', time()-86400*date('w')+(date('w')>0?86400:-6*86400));
					$thisSunday = date('Y-m-d', time()-86400*date('w')+(date('w')>0?(86400*7):86400));

					if(date(n,strtotime($thisMonday))<=date(n,strtotime($thisSunday))) {
						$sql_where .= " AND DATE_FORMAT(l.BIRTHDAY,'%m-%d') >= DATE_FORMAT(DATE_ADD(CURDATE(),INTERVAL -WEEKDAY(CURDATE()) DAY),'%m-%d') AND DATE_FORMAT(l.BIRTHDAY,'%m-%d')<=DATE_FORMAT(DATE_ADD(CURDATE(),INTERVAL 6-WEEKDAY(CURDATE()) DAY),'%m-%d')";
					} else {
						$sql_where .= " AND ((DATE_FORMAT(l.BIRTHDAY,'%m-%d')>=DATE_FORMAT(DATE_ADD(CURDATE(),INTERVAL -WEEKDAY(CURDATE()) DAY),'%m-%d') AND DATE_FORMAT(l.BIRTHDAY,'%m-%d')<='12-31') OR (DATE_FORMAT(l.BIRTHDAY,'%m-%d')>='01-01' AND DATE_FORMAT(l.BIRTHDAY,'%m-%d')<=DATE_FORMAT(DATE_ADD(CURDATE(),INTERVAL 6-WEEKDAY(CURDATE()) DAY),'%m-%d')))";
					}
					break;
				case "nextweek":
					$nextMonday = date('Y-m-d', time()-86400*date('w')+(date('w')>0?(86400*8):86400));
					$nextSunday = date('Y-m-d', time()-86400*date('w')+(date('w')>0?(86400*15):(86400*8)));

					if(date(n,strtotime($nextMonday))<=date(n,strtotime($nextSunday))) {
						$sql_where .= " AND DATE_FORMAT(l.BIRTHDAY,'%m-%d') >= DATE_FORMAT(DATE_ADD((DATE_ADD(CURDATE(),INTERVAL -WEEKDAY(CURDATE()) DAY)),INTERVAL 7 DAY),'%m-%d') AND DATE_FORMAT(l.BIRTHDAY,'%m-%d') <= DATE_FORMAT(DATE_ADD((DATE_ADD(CURDATE(),INTERVAL -WEEKDAY(CURDATE()) DAY)),INTERVAL 13 DAY),'%m-%d')";
					} else {
						$sql_where .= " AND ((DATE_FORMAT(l.BIRTHDAY,'%m-%d')>=DATE_FORMAT(DATE_ADD((DATE_ADD(CURDATE(),INTERVAL -WEEKDAY(CURDATE()) DAY)),INTERVAL 7 DAY),'%m-%d') AND DATE_FORMAT(l.BIRTHDAY,'%m-%d')<='12-31') OR (DATE_FORMAT(l.BIRTHDAY,'%m-%d')>='01-01' AND DATE_FORMAT(l.BIRTHDAY,'%m-%d')<=DATE_FORMAT(DATE_ADD((DATE_ADD(CURDATE(),INTERVAL -WEEKDAY(CURDATE()) DAY)),INTERVAL 13 DAY),'%m-%d')))";
					}
					break;
				case "create":

					$sql_where .= " AND l.CREATEOR='".SecurityFilter($_SESSION['LOGIN_USER_ID'])."'";
					break;
			}
		}

		if ($search_field && $search_str) {
			$sql_where .= " AND l.".$search_field." like '%".SecurityFilter($search_str)."%'";
		}

		if($type == 1){
			$sql_where .=" ORDER BY  " . $sortField . " " . $sortType . "
						LIMIT " . $limitOffset . "," . $limitRows;
			return $sql_select.$sql_from.$sql_where;
		}else if($type == 2){
			return $sql_count.$sql_from.$sql_where;
		}
    }

   /**
     * 获取联系人
     * @access public
     * @param array $param ,$type:1获取列表sql,2:获取数量sql
     * @return bool
     */
    public function getContractSql($param,$type=1) {
    	$LOGIN_USER_ID  = $_SESSION['LOGIN_USER_ID'];
		$limitRows 		= $param["itemsPerPage"];
		$limitOffset 	= $param["currentPage"] * $limitRows;
		$sortField 		= $param["sortField"] ? $param["sortField"] : "CON_ID";
		$sortType 		= $param["sortType"] ? $param["sortType"] : "DESC";
		$customerID 	= (int)$param['customerID'];
		$quicksort 		= $param['quick_sort'];
		$search_field 	= $param['search_field'];
		$search_str 	= $param['search_str'];

		$sql_select = "SELECT * ";
		$sql_count  = "SELECT COUNT(*) AS CNT ";
		$sql_from 	= "FROM  `contract`
					WHERE CUST_ID = '" . SecurityFilter($customerID) . "'";

		$sql_where = '';
		if ($search_field && $search_str) {
			$sql_where .= " AND ".$search_field." like '%".SecurityFilter($search_str)."%'";
		}

		if($quicksort) {
			switch($quicksort) {
				case"create":
					$sql_where .= " AND CREATEOR='".SecurityFilter($LOGIN_USER_ID)."'";
					break;
				case"thisyear":
					$sql_where .= " AND DATE_FORMAT(CON_DATE2,'%Y')=DATE_FORMAT(NOW(),'%Y')";
					break;
				case"thismonth":
					$sql_where .= " AND DATE_FORMAT(CON_DATE2,'%Y-%m')=DATE_FORMAT(NOW(),'%Y-%m')";
					break;
				case"nextmonth":
					$sql_where .= " AND ((MONTH(CON_DATE2)=(MONTH(CURDATE())+1) AND YEAR(CON_DATE2)=YEAR(CURDATE()))
									OR (MONTH(CURDATE())=12 AND MONTH(con_date2)=1 AND (YEAR(con_date2)=YEAR(CURDATE())+1)))";
					break;
			}
		}

		if($type == 1){
			if($quicksort&&$quicksort=="money") {
				$sql_where .= " ORDER BY CAST(`CON_COUNT` AS DECIMAL) DESC LIMIT 0,10";
			}else{
				$sql_where.=" ORDER BY  " . $sortField . " " . $sortType . "
						LIMIT " . $limitOffset . "," . $limitRows;
			}
			return $sql_select.$sql_from.$sql_where;
		}else if($type == 2){
			return $sql_count.$sql_from.$sql_where;
		}
    }

 /**
     * 获取联系人
     * @access public
     * @param array $param ,$type:1获取列表sql,2:获取数量sql
     * @return bool
     */
    public function getContractIndexSql($param,$type=1) {
		$limitRows 		= $param["itemsPerPage"];
		$limitOffset 	= $param["currentPage"] * $limitRows;
		$sortField 		= $param["sortField"] ? $param["sortField"] : "CON_ID";
		$sortType 		= $param["sortType"] ? $param["sortType"] : "DESC";
		$quick_sort   	= $param['quick_sort'];
		$where_query  	= $param['where_query'];
		$search_field 	= $param['search_field'];
		$search_str   	= $param['search_str'];
		$purview_where 	= $this->get_purview_where();
		$LOGIN_USER_ID  = $_SESSION['LOGIN_USER_ID'];

		$sql_select = "SELECT *,con.CREATEOR AS CON_CREATEOR,c.SERVICE_USER ";
		$sql_count  = "SELECT COUNT(*) AS CNT ";
		$sql_from 	= "FROM contract con,customer c,user u,user_priv up
						WHERE c.MANAGE_USER=u.USER_ID
		              	AND u.USER_PRIV=up.USER_PRIV
		              	AND c.CUSTOMER_ID=con.CUST_ID ";
		$sql_where = " AND $purview_where";

		if ($search_field) {
			$sql_where .= " AND ".$search_field." LIKE '%".SecurityFilter($search_str)."%'";
		}

		switch($quick_sort) {
			case"create":
				$sql_where .= " AND con.CREATEOR='".SecurityFilter($LOGIN_USER_ID)."'";
				break;
			case"thisyear":
				$sql_where .= " AND DATE_FORMAT(CON_DATE2,'%Y')=DATE_FORMAT(NOW(),'%Y')";
				break;
			case"thismonth":
				$sql_where .= " AND DATE_FORMAT(CON_DATE2,'%Y-%m')=DATE_FORMAT(NOW(),'%Y-%m')";
				break;
			case"nextmonth":
				$sql_where .= " AND ((MONTH(CON_DATE2)=(MONTH(CURDATE())+1) AND YEAR(CON_DATE2)=YEAR(CURDATE()))
								OR (MONTH(CURDATE())=12 AND MONTH(con_date2)=1 AND (YEAR(con_date2)=YEAR(CURDATE())+1)))";
				break;
			default :
				break;
		}

		if ($where_query!='') {
			$sql_where .= stripslashes($where_query);
		}

		if($type == 1){
			if($quick_sort&&$quick_sort=="money") {
				$sql_where .= " ORDER BY CAST(`CON_COUNT` AS DECIMAL) DESC LIMIT 0,10";
			}else{
				$sql_where .= " ORDER BY  " . $sortField . " " . $sortType . "
						LIMIT " . $limitOffset . "," . $limitRows;
			}

			return $sql_select.$sql_from.$sql_where;
		}else if($type == 2){
			return $sql_count.$sql_from.$sql_where;
		}
    }

   /**
     * 获取联系人
     * @access public
     * @param array $param ,$type:1获取列表sql,2:获取数量sql
     * @return bool
     */
    public function getProviderSql($param,$type=1) {
		$limitRows 		= $param["itemsPerPage"];
		$limitOffset 	= $param["currentPage"] * $limitRows;
		$sortField 		= $param["sortField"] ? $param["sortField"] : "PROVIDER_ID";
		$sortType 		= $param["sortType"] ? $param["sortType"] : "DESC";
		$search_field 	= $param['search_field'];
		$search_str 	= $param['search_str'];
		$where_query 	= $param['where_query'];

		$sql_count 		= "SELECT COUNT(*) AS CNT ";
		$sql_select 	= "SELECT * ";
		$sql_from 		= "FROM provider WHERE 1=1";

		$sql_where = "";
		if ($search_field && $search_str) {
			$sql_where .= " AND ".$search_field." like '%".SecurityFilter($search_str)."%'";
		}

		if ($where_query!='') {
			$sql_where .= stripslashes($where_query);
		}

		$sql_order_limit =" ORDER BY  " . $sortField . " " . $sortType . "
					LIMIT " . $limitOffset . "," . $limitRows;

		if($type == 1){
			return $sql_select.$sql_from.$sql_where.$sql_order_limit;
		}else if($type == 2){
			return $sql_count.$sql_from.$sql_where;
		}
    }

/**
     * 获取产品
     * @access public
     * @param array $param ,$type:1获取列表sql,2:获取数量sql
     * @return bool
     */
    public function getProductSql($param,$type=1) {
		$limitRows 		= $param["itemsPerPage"];
		$limitOffset 	= $param["currentPage"] * $limitRows;
		$sortField 		= $param["sortField"] ? $param["sortField"] : "PRODUCT_ID";
		$sortType		= $param["sortType"] ? $param["sortType"] : "DESC";
		$search_field 	= $param['search_field'];
		$search_str 	= $param['search_str'];
		$where_query 	= $param['where_query'];

		$sql_count 	= "SELECT COUNT(*) AS CNT ";
		$sql_select = "SELECT pt.*, pr.PROVIDER_NAME, pr.PROVIDER_ID ";
		$sql_from  	= "from product as pt, provider as pr WHERE pt.PROVIDER_ID=pr.PROVIDER_ID ";
		$sql_where 	= '';
		if ($search_field && $search_str) {
			if ($search_field=="PRODUCT_NAME" || $search_field=="PRODUCT_TYPE") {
				$sql_where .= " AND pt.".$search_field." like '%".SecurityFilter($search_str)."%'";
			}else if ($search_field=="PROVIDER_NAME") {
				$sql_where .= " AND pr.".$search_field." like '%".SecurityFilter($search_str)."%'";
			}
		}

		if ($where_query!='') {
			$sql_where .= stripslashes($where_query);
		}

		$sql_order_limit = " ORDER BY  pt." . $sortField . " " . $sortType . "
					LIMIT " . $limitOffset . "," . $limitRows;

		if($type == 1){
			return $sql_select.$sql_from.$sql_where.$sql_order_limit;
		}else if($type == 2){
			return $sql_count.$sql_from.$sql_where;
		}
    }

	/**
     * 获取产品
     * @access public
     * @param array $param ,$type:1获取列表sql,2:获取数量sql
     * @return bool
     */
    public function getSaleProductSql($param,$type=1) {
		$limitRows 		= $param["itemsPerPage"];
		$limitOffset 	= $param["currentPage"] * $limitRows;
		$sortField 		= $param["sortField"] ? $param["sortField"] : "PRODUCT_ID";
		$sortType		= $param["sortType"] ? $param["sortType"] : "DESC";
		$search_field 	= $param['search_field'];
		$search_str 	= $param['search_str'];

		$sql_select = "SELECT PRODUCT_ID, PRODUCT_NAME, PRODUCT_TYPE ";
		$sql_count = "SELECT COUNT(*) AS CNT ";
		$sql_from = "FROM PRODUCT where 1=1";
		$sql_where 	= '';

		if ($search_field) {
			$sql_where .= " AND ".$search_field." like '%".SecurityFilter($search_str)."%'";
		}

		$sql_order_limit = " ORDER BY " . $sortField . " " . $sortType . "
				  LIMIT " . $limitOffset . "," . $limitRows;

		if($type == 1){
			return $sql_select.$sql_from.$sql_where.$sql_order_limit;
		}else if($type == 2){
			return $sql_count.$sql_from.$sql_where;
		}
    }

	/**
     * 获取产品
     * @access public
     * @param array $param ,$type:1获取列表sql,2:获取数量sql
     * @return bool
     */
    public function getSaleSql($param,$type=1) {
		$limitRows 		= $param["itemsPerPage"];
		$limitOffset 	= $param["currentPage"] * $limitRows;
		$sortField 		= $param["sortField"] ? $param["sortField"] : "HISTORY_ID";
		$sortType 		= $param["sortType"] ? $param["sortType"] : "DESC";
		$search_field 	= $param['search_field'];
		$search_str		= $param['search_str'];
		$where_query 	= $param['where_query'];
		$purview_where 	= $this->get_purview_where();

		$sql_count 	= "SELECT COUNT(*) AS CNT ";
		$sql_select = "SELECT s.*, p.PRODUCT_ID, p.PRODUCT_NAME, c.CUSTOMER_ID, c.CUSTOMER_NAME, c.MANAGE_USER,c.PURVIEW,c.SERVICE_USER, u.USER_NAME,u.DEPT_ID, u.USER_ACCOUNTS, up.USER_PRIV ";

		$sql_from = "from sale_history as s
				LEFT JOIN customer as c ON s.CUSTOMER_ID = c.CUSTOMER_ID
				LEFT JOIN product as p ON s.PRODUCT_ID = p.PRODUCT_ID
				LEFT JOIN user as u ON(u.USER_ID = c.MANAGE_USER)
				LEFT JOIN user_priv as up ON(up.USER_PRIV = u.USER_PRIV)
				WHERE $purview_where";

		$sql_where 	= '';
		if ($search_field && $search_str) {
			if ($search_field=="SALESMAN") {
				$sql_where .= " AND s.".$search_field." like '%".SecurityFilter($search_str)."%'";
			}else if ($search_field=="CUSTOMER_NAME") {
				$sql_where .= " AND c.".$search_field." like '%".SecurityFilter($search_str)."%'";
			}else if ($search_field=="PRODUCT_NAME") {
				$sql_where .= " AND p.".$search_field." like '%".SecurityFilter($search_str)."%'";
			}
		}

		if ($where_query!='') {
			$sql_where .= stripslashes($where_query);
		}

		$sql_order_limit = " ORDER BY  s." . $sortField . " " . $sortType . "
					LIMIT " . $limitOffset . "," . $limitRows;

		if($type == 1){
			return $sql_select.$sql_from.$sql_where.$sql_order_limit;
		}else if($type == 2){
			return $sql_count.$sql_from.$sql_where;
		}
    }

	/**
	*获取查询语句的 sum 字段
	*@param  string $count_type
	*@return string $field
	*/
	function get_summary_field( $count_type ) {
		$count_type = explode( ',', $count_type );
		$count_type = array_filter($count_type);
		//分组查询列名
		$field = '';
		foreach($count_type as $type){
			if($type == 1)
				$field .= ' SUM(PRICE * AMT) as MONEY_TOTAL ,';
			if($type == 2)
				$field .= ' SUM(PRICE * AMT *(1-DISCOUNT)) as MONEY_DISCOUNT ';
		}
		$field = preg_replace( "/\,$/", '', $field );
		return $field;
	}

	  /**
	*获取销售记录汇总

	*@param  string $where_str
	*@param  string $count_type
	*@return array $result
	*/
	function get_summary_data_count( $where_str, $count_type ){
		global $connection;
		$summary_field_str = $this->get_summary_field($count_type);
		//总计数据
		$sql = "SELECT $summary_field_str  FROM sale_history s
		        LEFT JOIN USER u ON s.SALESMAN = u.USER_ID
				LEFT JOIN customer c ON s.CUSTOMER_ID = c.CUSTOMER_ID
				LEFT JOIN product p ON s.PRODUCT_ID = p.PRODUCT_ID
				WHERE 1 = 1 ". $where_str ;
		$cursor = exequery($connection,$sql);
		while($row = mysql_fetch_array( $cursor ,MYSQL_ASSOC )){
			$result[] = $row;
		}
		return $result;
	}

	 /**
	*获取销售记录统计查询结果

	*@param  string $group
	*@param  string $where_str
	*@param  string $sort
	*@param  string $count_type
	*@return array $result
	*/
	function get_summary_data_list( $group, $where_str, $sort, $count_type ){
		global $connection;
		$group_field_str = $this->get_group_field( $group );
		if(strstr($group,'s.DATE'))
			$group = 'LEFT(DATE,7)';

		$summary_field_str = $this->get_summary_field($count_type);
		//排序字段
		if( strstr( $summary_field_str, 'MONEY_TOTAL' ) )
			$order = 'MONEY_TOTAL';
		if( strstr( $summary_field_str, 'MONEY_DISCOUNT' ) )
			$order = 'MONEY_DISCOUNT';
		//排序
		if($sort)
			$order_str = " ORDER BY $order $sort ";
		//分组查询数据
		$sql = "
				SELECT $group_field_str, $summary_field_str FROM sale_history s
		            LEFT JOIN USER u ON s.SALESMAN = u.USER_ID
					LEFT JOIN customer c ON s.CUSTOMER_ID = c.CUSTOMER_ID
					LEFT JOIN product P ON s.PRODUCT_ID = p.PRODUCT_ID
				    WHERE 1 = 1 ". $where_str ." GROUP BY $group " ;

		$sql   = $this->page($sql, 15);
		//防止分页函数中加入排序引起错误.
		if($sort){
			$sql = str_replace("limit", $order_str." limit", $sql);
		}

		$cursor	= exequery( $connection, $sql );
		while($row = mysql_fetch_array( $cursor , MYSQL_ASSOC )) {
			$result[] = $row;
		}
		return $result;
	}

	/**
	*获取查询语句的group by 的字段

	*@param  string $group
	*@return string $field
	*/
	function get_group_field( $group ){
		// 查询中group by的列
		switch( $group ){
			case "s.SALESMAN":
				$field = 'USER_NAME';
				break;
			case "s.CUSTOMER_ID":
				$field = 'CUSTOMER_NAME';
				break;
			case "s.PRODUCT_ID":
				$field = 'PRODUCT_NAME';
				break;
			case "s.DATE":
				$field = 'LEFT(DATE,7) AS mon';
				break;
		}
		return $field;
	}


/**
 *数据分页
 *@param string $sql       传入的sql语句
 *@param string $per_page  分页多少条数据
 *@return strint $sql      返回经过分页的sql语句
 */
function page($sql, $per_page = 20) {
	global $cur_page, $total_page_nums, $last_page, $next_page, $num, $page_count;
	$page_count = $per_page;
	//2009-01-15 sx 修改匹配 匹配不唯一
	preg_match('/SELECT ([^\"\']*)[\s]FROM[\s]/i', $sql, $reg);

	$regStr = $reg[1];
	$fromPos = strpos(strtoupper($regStr),"FROM");
	if($fromPos)
	{
		$regStr = substr($regStr,$fromPos);
		$regStr = "COUNT(*) ".$regStr;
		$sql_c = str_replace($reg[1],$regStr, $sql);
	}
	else
	{
		$sql_c = str_replace($reg[1], 'COUNT(*)', $sql);
	}
	$pos = 0;
	$pos = preg_match("/group[ |\f|\n|\r|\t|\v]*by/", $sql_c);
	$result = mysql_query($sql_c);
	$num = 0;
	if ($pos) {
		$num = mysql_num_rows($result);
	} else {
		$row = mysql_fetch_array($result);
		$num = $row[0];
	}
	$total_page_nums = ceil($num / $per_page);
	if ($_POST[go]) {
		$cur_page = $_POST[curpage];
	} else
		$cur_page = $_GET[cur_page];
	if (!isset($cur_page) || $cur_page == 0)
		$cur_page = 1;
	$last_page = $cur_page - 1;

	if ($last_page < 1) {
		$last_page = 1;
	}
	$next_page = $cur_page + 1;
	if ($next_page > $total_page_nums)
		$next_page = $total_page_nums;

	$pages = ($cur_page - 1) * $per_page;
	while ($pages >= $num) {
		$cur_page = $cur_page - 1;
		$pages = ($cur_page - 1) * $per_page;
	}
	$pages = max(0, $pages);
	$sql .= " limit $pages," . $per_page;

	return $sql;
}

    /**
     * 获取联系记录
     * @access public
     * @param array $param
     * @return bool
     */
    public function getRecord($re_id) {
    	global $connection;
		$sql    = "SELECT * FROM relation_record WHERE RE_ID = ".SecurityFilter($re_id)." LIMIT 1";
		$query  = exequery($connection,$sql);
		return mysql_fetch_array($query);

    }

    /**
     * 获取联系记录类型
     * @access public
     * @param array $param
     * @return bool
     */
    public function getRecordType($re_type,$cc_parent_id=28) {
    	global $connection;
		$sql 	= "SELECT CC_NAME FROM combocox_child WHERE CC_PARENT_ID=". SecurityFilter($cc_parent_id) ." AND CC_VALUE='".SecurityFilter($re_type)."' LIMIT 1";
		$query  = exequery($connection,$sql);
		$row 	= mysql_fetch_array($query);
		return $row['CC_NAME'];
    }

    /**
     * 删除联系记录
     * @access public
     * @param array $param
     * @return bool
     */
    public function delRecords($re_ids) {
    	global $connection;
    	$re_ids = str_replace(",","','",$re_ids);
		$sql 	= "DELETE FROM relation_record WHERE RE_ID IN('".SecurityFilter($re_ids)."')";
		$ok = exequery($connection,$sql);
		return $ok?1:0;
    }

    /**
     * 获取必填字段
     * @access public
     * @param array $param
     * @return array()
     */
    public function getCostomerValidate($table='customer') {
		$sql = "SELECT FIELD_NAME,IS_VALIDATE FROM customer_validate_field WHERE TABLE_NAME='".SecurityFilter($table)."'";
		$query  = exequery($this->connection,$sql);
		$res    =  array();
		while($row 	= mysql_fetch_array($query)){
			$res[$row['FIELD_NAME']] = $row['IS_VALIDATE'];
		}
		return $res;
    }

    /**
     * 获取必填字段
     * @access public
     * @param array $param
     * @return bool
     */
    public function setCustomerValidate($data,$table='customer') {
    	if($this->delCustomerValidate($table)){
    		return $this->addAll('customer_validate_field',$data);
    	}
    }

    /**
     * 删除必填字段
     * @access public
     * @param array $param
     * @return bool
     */
    public function delCustomerValidate($table='customer') {
		$sql = "DELETE FROM customer_validate_field WHERE TABLE_NAME='".SecurityFilter($table)."'";
		return exequery($this->connection,$sql);
    }

  /**
     * 获取联系记录数量
     * @access public
     * @param array $param ,$type:1获取列表sql,2:获取数量sql
     * @return bool
     */
    public function getExportExcel($param) {
		$export    		= $param["EXPORT"];
		$purview_where 	= $this->get_purview_where();
		$quicksort 		= $param['quick_sort'];
		$where_query 	= $param['where_query'];
		$search_field 	= $param['search_field'];
		$search_str 	= $param['search_str'];
		switch($export) {
			case"0":
				break;
			case"1":
				$start  = 0;
				$limits = 1000;
				break;
			case"2":
				$start  = 1000;
				$limits = 1000;
				break;
			case"3":
				$start  = $_REQUEST["COUNT1"] - 1;
				$limit = $_REQUEST["COUNT2"] - $_REQUEST["COUNT1"];
				if($limit == 0) {
					$limits = 1;
				} else if($limit >= 1) {
					$limits = $limit+1;
				}
				break;
		}


		$sql = "SELECT c.*,pro.proName,cit.cityName,u.USER_NAME AS MANAGE_USER_NAME,us.USER_NAME AS SERVICE_USER_NAME,uc.USER_NAME AS CREATEOR_NAME ";

		$query = "FROM customer as c
				LEFT JOIN province as pro ON(c.PROVINCE = pro.proID)
				LEFT JOIN city as cit ON(c.CITY = cit.cityId)
				LEFT JOIN user as u ON(u.USER_ID = c.MANAGE_USER)
				LEFT JOIN user as us ON(us.USER_ID = c.SERVICE_USER)
				LEFT JOIN user as uc ON(uc.USER_ID = c.CREATEOR)
				LEFT JOIN user_priv as up ON(up.USER_PRIV = u.USER_PRIV)
					WHERE $purview_where";

		if ($search_field =="CUSTOMER_NAME") {
			$query .= " AND c.".$search_field." like '%".SecurityFilter($search_str)."%'";
		}elseif ($search_field =="proName") {
			$query .= " AND pro.".$search_field." like '%".SecurityFilter($search_str)."%'";
		}elseif ($search_field =="cityName") {
			$query .= " AND cit.".$search_field." like '%".SecurityFilter($search_str)."%'";
		}

		if($quicksort) {
			switch($quicksort) {
				case"manage_user":
					$query .= " AND c.MANAGE_USER='".SecurityFilter($_SESSION["LOGIN_USER_ID"])."'";
					break;
				case"thismonth":
					$query .= " AND DATE_FORMAT(c.CREATE_TIME,'%Y-%m')=DATE_FORMAT(NOW(),'%Y-%m')";
					break;
				case"create":
					$query .= " AND c.CREATEOR='".SecurityFilter($_SESSION["LOGIN_USER_ID"])."'";
					break;
			}
		}

		if ($where_query!='') {
			$where_query = stripslashes($where_query);
			$query .= $where_query;
		}

		if ($start>=0 && $limits>0) {
			$query.=" ORDER BY c.CUSTOMER_ID DESC
				LIMIT " . $start . "," . $limits;
		}
		$result = exequery($this->connection, $sql.$query);
		$list =  array();
		while ($row = mysql_fetch_assoc($result)) {
			$list[] = $row;
		}
		return $list;
    }

  	/**
     * 获取所有联系记录
     * @access public
     * @param array $param
     * @return array()
     */
    public function getAllRecord() {
		$customer_ids = $this->get_customer_view_name($_SESSION['LOGIN_USER_ID']);
		//获取所有联系记录数量
		$where = "1=1 ";
		if($customer_ids!="") {
			$where .= " AND a.CUSTOMER_ID IN(".SecurityFilter(substr($customer_ids,0,-1)).")";
		} else {
			$where .= " AND a.CUSTOMER_ID=0";
		}

		$getAllCountRow = $this->getDataOne('relation_record','COUNT(*) AS CNT',$where);
		return $getAllCountRow['CNT'];
    }

  	/**
     * 获取我的联系记录
     * @access public
     * @param array $param
     * @return array()
     */
    public function getMyRecord() {
		$customer_ids = $this->get_customer_view_name($_SESSION['LOGIN_USER_ID']);
		$where = "a.CREATEOR = '" . $_SESSION['LOGIN_USER_ID'] . "'";
		$where .= " AND a.CUSTOMER_ID IN(".SecurityFilter(substr($customer_ids,0,-1)).")";
		$getMyCountRow = $this->getDataOne('relation_record','COUNT(*) AS CNT',$where);
		return $getMyCountRow['CNT'];
    }

  	/**
     * 获取表单字段
     * @access public
     * @param array $param
     * @return array()
     */
    public function getCustomerField($table) {
		$sql  	= "SHOW COLUMNS FROM $table";
		$query 	= exequery($this->connection,$sql);
		$list 	= array();
		while($row = mysql_fetch_array($query)){
			$list[] = $row;
		}
		return $list;
    }

    /**
     * 获取sql数组
     * @access public
     * @param array $param
     * @return bool
     */
    public function getList($sql,$get_type="array") {
    	$list 	= array();
		$query = $this->query($sql);
		$get_type = 'mysql_fetch_'.$get_type;
		while($row = $get_type($query)){
			$list[] = $row;
		}
		return $list;
    }

    /**
     * 获取sql数量
     * @access public
     * @param array $param
     * @return bool
     */
    public function getNum($sql) {
		$query  = $this->query($sql);
		$row 	= mysql_fetch_array($query);
		return $row[0]>0?$row[0]:0;
    }

  	/**
     * 获取字段
     * @access public
     * @param array $param
     * @return array()
     */
    public function getData($table,$field='*',$where='',$get_type="array") {
		$sql 	= "SELECT $field FROM $table ".$this->parseWhere($where);
		$query  = $this->query($sql);
		$list   =  array();
		$get_type = 'mysql_fetch_'.$get_type;
		while($row 	= $get_type($query)){
			$list[] = $row;
		}
		return $list;
    }
  	/**
     * 获取字段
     * @access public
     * @param array $param
     * @return array()
     */
    public function getDataOne($table,$field='*',$where='',$get_type="array") {
		$sql 	= "SELECT $field FROM $table ".$this->parseWhere($where);
		$query  = $this->query($sql);
		$get_type = 'mysql_fetch_'.$get_type;
		if ($row = $get_type($query)) {
			return $row;
		}

		return array();
    }

  	/**
     * 获取字段
     * @access public
     * @param array $param
     * @return array()
     */
    public function getDataNum($table,$where='1') {
		$sql 	= "SELECT count(*) FROM $table WHERE $where";
		$query  = $this->query($sql);
		$row 	= mysql_fetch_array($query);
		return $row[0];
    }

 	/**
     * 插入数据
     * @access private
     * @param array $value
     * @return int
     */
	public function addData($table,$data){
		return $this->add($table,$data);
	}

    /**
     * 更新记录
     * @access public
     * @param mixed $data 数据
     * @param array $options 表达式
     * @return false | integer
     */
    public function updateData($table,$data,$where) {
        return $this->update($table,$data,$where);
    }
    /**
     * 删除记录
     * @access public
     * @param array $param
     * @return bool
     */
    public function delData($table,$where) {
    	return $this->delete($table,$where);
    }

	/**
	*删除客户
	* @access public
	* @param int $customer_id 客户表中的ID
	* @return 0 or 1
	*/
	function delCustomer($customer_id) {
		$where = array('CUSTOMER_ID'=>(int)$customer_id);
		$customer = $this->getDataOne('customer','*',$where,'assoc');
		if(!empty($customer)) {
			$customer['PERSON_INFO'] = addslashes($customer['PERSON_INFO']);
			$last_ins_id = $this->addData('customer_recycle',$customer);
			if($last_ins_id>0){
				$result = $this->delete('customer',$where);
				return $result?1:0;
			}
		}
	}

	/**
	*批量删除客户
	* @access public
	* @param int $customer_ids 客户表中的ID
	* @return 0 or 1
	*/
	function batchDelCustomer($customer_ids) {
		$where = "CUSTOMER_ID IN('".str_replace(",","','",rtrim($customer_ids,','))."')";
		$customers = $this->getData('customer','*',$where,'assoc');
		if(!empty($customers)) {
			$rows = $this->addAll('customer_recycle',$customers);
			if($rows>0){
				$result = $this->delete('customer',$where);
				return $result?1:0;
			}
		}
	}

	/**
	*恢复客户
	* @access public
	* @param int $customer_id 客户表中的ID
	* @return 0 or 1
	*/
	function customerRecover($customer_id) {
		$where = array('CUSTOMER_ID'=>(int)$customer_id);
		$customer = $this->getDataOne('customer_recycle','*',$where,'assoc');
		if(!empty($customer)) {
			$customer['PERSON_INFO'] = addslashes($customer['PERSON_INFO']);
			$last_ins_id = $this->add('customer',$customer);
			if($last_ins_id>0){
				$result = $this->delete('customer_recycle',$where);
				return $result?1:0;
			}
		}
	}

	/**
	*彻底删除客户
	* @access public
	* @param int $customer_id 客户表中的ID
	* @param int $num:1删除1个客户,
	* @return 0 or 1
	*/
	function customerDelete($customer_id,$num=1) {
		if($num==1){
			$where = array('CUSTOMER_ID'=>(int)$customer_id);
		}else{
			$customer_id_arr = explode(',',$customer_id);
			foreach($customer_id_arr as $k=>$v){
				if((int)$v == 0){
					unset($customer_id_arr[$k]);
				}
			}
			$customer_id_str = implode("','",$customer_id_arr);
			$where = "CUSTOMER_ID IN('".SecurityFilter($customer_id_str)."')";
		}
		$result = $this->delete('customer_recycle',$where);
		$this->delete('relation_record',$where);			//删除联系记录
		$this->delete('linkman',$where);					//删除联系人
		return $result?1:0;
	}

	/**
	*获取合并客户
	* @access public
	* @param
	* @return array
	*/
	function getMergeCustomer() {
		if(isset($_COOKIE['merge_customer'])){
			$customer_id_arr = array_unique(array_filter(explode(',',$_COOKIE['merge_customer'])));
			$customer_ids 	 = implode("','",$customer_id_arr);

			$sql = "SELECT ";
			$sql.= 'c.CUSTOMER_ID,
					c.CUSTOMER_NAME,
					u.USER_NAME AS query_cus_man,
					us.USER_NAME AS service_manage,
					c.TEL_NO,
					c.FAX_NO,
					c.CUSTOMER_WWW,
					c.EMAIL,
					c.CUSTOMER_ADD,
					c.POSTALCODE,
					c.CUSTOMER_NUMBER,
					c.CUSTOMER_STATE AS customer_status,
					c.CUSTOMER_STATUS AS crm_cus_state,
					c.CUSTOMER_TYPE AS query_cus_type,
					c.SCALE AS cus_extent,
					uc.USER_NAME AS crm_cont_creat,
					c.LE_PERSON,
					c.PERSON_INFO AS legol_person_info,
					c.CREATE_TIME AS man_create_time,
					c.CUSTOMER_INDUSTRY AS industry,
					c.CUSTOMER_PROFIT AS profit,
					c.CUSTOMER_ATTRIBUTE AS customer_attribute,
					pro.proName AS cus_province,
					cit.cityName AS cus_city
					';

			$sql .= "FROM customer AS c
					LEFT JOIN user AS u ON u.USER_ID = c.MANAGE_USER
					LEFT JOIN user AS us ON us.USER_ID = c.SERVICE_USER
					LEFT JOIN user AS uc ON uc.USER_ID = c.CREATEOR
					LEFT JOIN province AS pro ON c.PROVINCE = pro.proID
					LEFT JOIN city AS cit ON c.CITY = cit.cityId ";

			$sql .= "WHERE c.CUSTOMER_ID IN('".SecurityFilter($customer_ids)."')";
			$list = $this->getList($sql,'assoc');
			return $list;
		}
		return '';
	}

	/**
	*合并客户
	* @access public
	* @param int $customer_id 保留的客户
	* @return 0 or 1
	*/
	function customerMerge($customer_id) {
		$customer_id_arr = array_unique(array_filter(explode(',',$_COOKIE['merge_customer'])));
		$customer = $this->getDataOne('customer','*',array('CUSTOMER_ID'=>$customer_id),'assoc');
		$customer_no_empty = array_filter($customer);
		$customer_empty = array_diff($customer,$customer_no_empty);
		$customer_empty_keys = array_keys($customer_empty);
		unset($customer_id_arr[array_search($customer_id,$customer_id_arr)]);
		if(!empty($customer_id_arr)&&!empty($customer_id)){
			$customer_ids 	 = implode("','",$customer_id_arr);
			$where  = "CUSTOMER_ID IN('".$customer_ids."')";
			$data = array('CUSTOMER_ID'=>$customer_id);
			$customers = $this->getData('customer','*',$where,'assoc');
			foreach($customers as $key=>$val){
				foreach($val as $k=>$v){
					if(!empty($v)&&in_array($k,$customer_empty_keys)&&empty($customer_empty[$k])){
						$customer_empty[$k] = ($k=='PERSON_INFO')?addslashes($v):$v;
					}
				}
			}
			$customer_new = array_filter($customer_empty);
			$this->updateData('linkman',$data,$where);			//更新联系人
			$this->updateData('relation_record',$data,$where);	//更新联系记录
			$this->updateData('operation',$data,$where);		//更新业务机会
			$this->updateData('sale_history',$data,$where);		//更新销售记录
			$where_con  = "CUST_ID IN('".$customer_ids."')";
			$data_con = array('CUST_ID'=>$customer_id);
			$this->updateData('contract',$data_con,$where_con);			//更新合同
			$this->updateData('customer',$customer_new,array('CUSTOMER_ID'=>$customer_id));	//合并其他客户填充项
			$result = $this->delData('customer',$where);		//删除其他客户
			if($result){
				setcookie("merge_customer","",time()-1);
				setcookie("merge_customer_num","",time()-1);
			}
			return $result?1:0;
		}
	}

	/**
	*检查合并客户
	* @access public
	* @param int $customer_id 保留的客户
	* @return 0 or 1
	*/
	function customerMergeCheck() {
		$customer_id_arr = array_unique(array_filter(explode(',',$_COOKIE['merge_customer'])));
		$customer_num = $_COOKIE['merge_customer_num'];
		if(!empty($customer_id_arr)){
			$customer_ids 	 = implode("','",$customer_id_arr);
			$where  = "CUSTOMER_ID IN('".SecurityFilter($customer_ids)."')";
			$customer_ids_arr_new = $this->getData('customer','CUSTOMER_ID',$where,'assoc');
			$customer_ids_new = array();
			$cumtomer_num_new = 0;
			foreach($customer_ids_arr_new as $k=>$v){
				$cumtomer_num_new++;
				$customer_ids_new[] = $v['CUSTOMER_ID'];
			}
			if($cumtomer_num_new != $customer_num){
				setcookie("merge_customer",implode(',',$customer_ids_new));
				setcookie("merge_customer_num",$cumtomer_num_new);
				return 1;
			}
		}
		return 0;
	}
	/**
	*判断登录用户是否有文档权限
	* @access public
	* @param int $customer_id 客户id
	* @return 0 or 1
	*/
	function get_customer_preview($customer_id){
		$purview_where = $this->get_purview_where($user_id);
		$sql = "SELECT c.CUSTOMER_ID FROM customer as c
				LEFT JOIN user as u ON u.USER_ID = c.MANAGE_USER
				WHERE $purview_where";

		$list = $this->getList($sql,'assoc');

		foreach($list as $k=>$v){
			if($v['CUSTOMER_ID'] == $customer_id){
				return 1;
			}
		}
		return 0;
	}
	/**
	*添加申请权限
	* @access public
	* @param array $data
	* @return 0 or 1
	*/
	function addApplicationPermissions($data){
		$num = 0;
		foreach($data as $v){
			$has_permissions = $this->hasPermissions($v);
			if($has_permissions){
				$id = $this->add('customer_permissions',$v);
				if($id>0)$num++;
			}
		}

		return $has_permissions?$num:-1;
	}

	/**
	*是否有权限
	* @access public
	* @param array $data
	* @return 0 or 1
	*/
	function hasPermissions($data){
		$sql = "SELECT COUNT(*) FROM customer WHERE CUSTOMER_ID = '".SecurityFilter($data['CUSTOMER_ID'])."' AND ";
		$where = '';
		if($data['PERMISSION'] == 1){
			$where = "PURVIEW_USER LIKE '%".SecurityFilter($data['USER_ID'])."%'";
		}else if($data['PERMISSION'] == 2){
			$where = "SERVICE_USER = '".SecurityFilter($data['USER_ID'])."'";
		}else if($data['PERMISSION'] == 3){
			$where = "MANAGE_USER = '".SecurityFilter($data['USER_ID'])."'";
		}

		if($where != ''){
			$num = $this->getNum($sql.$where);
			return $num > 0 ? 0 : 1;
		}
		return 0;
	}

	/**
	*获取申请
	* @access public
	* @param array $param
	* @return 0 or 1
	*/
	function getApplicationSql($param,$type,$user_id=''){
		$limitRows 		= $param["itemsPerPage"];
		$limitOffset 	= $param["currentPage"] * $limitRows;
		$sortField 		= isset($param["sortField"]) ? $param["sortField"] : "CAP_ID";
		$sortType		= isset($param["sortType"]) ? $param["sortType"] : "DESC";
		$quicksort 		= isset($param['quick_sort']) ?  $param['quick_sort'] : 1;
		$search_field 	= isset($param['search_field']) ? $param['search_field'] : '';
		$search_str 	= isset($param['search_str']) ? $param['search_str'] : '';

		$sql_select = "SELECT c.CUSTOMER_ID, c.CUSTOMER_NAME,u.USER_NAME AS MANAGE_USER_NAME,cp.STATUS,cp.CAP_ID,cp.PERMISSION,cp.CREATE_TIME,up.USER_NAME AS APPLY_USER ";
		$sql_count = "SELECT COUNT(*) AS CNT ";
		$sql_from = "FROM customer_permissions AS cp
				  	 LEFT JOIN customer AS c ON c.CUSTOMER_ID = cp.CUSTOMER_ID
                     LEFT JOIN user as u ON u.USER_ID = c.MANAGE_USER
                     LEFT JOIN user as up ON up.USER_ID = cp.USER_ID ";

		if($quicksort>0){
			$sql_where = "WHERE cp.STATUS='". SecurityFilter($quicksort) ."' ";
		}else{
			$sql_where = "WHERE 1 ";
		}

		if(!empty($user_id)){
			$sql_where .= "AND cp.USER_ID='$user_id'";
		}

		if (!empty($search_field)&&!empty($search_str)) {
			$sql_where .= "AND c.".$search_field." like '%".SecurityFilter($search_str)."%'";
		}

		$sql_order_limit = " ORDER BY cp." . $sortField . " " . $sortType . "
				  LIMIT " . $limitOffset . "," . $limitRows;

		if($type == 1){
			return $sql_select.$sql_from.$sql_where.$sql_order_limit;
		}else if($type == 2){
			return $sql_count.$sql_from.$sql_where;
		}
	}

	/**
	*删除申请
	* @access public
	* @param array $data
	* @return 0 or 1
	*/
	function delApplication($data){
		$res = $this->delete('customer_permissions',array('CAP_ID'=>array('in',$data)));
		return $res?1:0;
	}

	/**
	*审核申请
	* @access public
	* @param int $cap_id
	* @return array
	*/
	function getApplication($cap_id){
		$sql = "SELECT * FROM customer_permissions AS cp
				LEFT JOIN customer AS c ON c.CUSTOMER_ID = cp.CUSTOMER_ID
		 	    WHERE CAP_ID = ". SecurityFilter($cap_id) ." LIMIT 1";
        $query  = $this->query($sql);
		$row = mysql_fetch_array($query);
		return $row;
	}

	/**
	*审核申请
	* @access public
	* @param int $cap_id
	* @return array
	*/
	function checkApplication($cap_id,$status){
		$sql = "UPDATE customer_permissions SET STATUS = ".(int)SecurityFilter($status)." WHERE CAP_ID = ".(int)SecurityFilter($cap_id);
        $res = $this->query($sql);
        if($status==2){
        	$info = $this->getApplication($cap_id);
        	$where = array('CUSTOMER_ID' => $info['CUSTOMER_ID']);
        	$data = array();
        	if($info['PERMISSION'] == 1){
        		if($info['PURVIEW'] == 3){
        			if(strpos($info['PURVIEW_USER'],$info['USER_ID']) === false){
          				$user_id = $info['PURVIEW_USER'].$info['USER_ID'].',';
			        	$data = array('PURVIEW_USER' => $user_id);
        			}
        		}
        	}else if($info['PERMISSION'] == 2){
				$data = array('SERVICE_USER' => $info['USER_ID']);
        	}else if($info['PERMISSION'] == 3){
		        $data = array('MANAGE_USER' => $info['USER_ID']);

			}
			if(!empty($data)) $this->update('customer',$data,$where);
        }
        return $res?1:0;
	}

	/**
	*批量审核申请
	* @access public
	* @param int $cap_id
	* @return array
	*/
	function batchCheck($cap_ids){
		$num = count($cap_ids);
		if($num == 0) exit;
		$i = 0;
       	foreach($cap_ids as $cap_id){
       		if($this->checkApplication($cap_id,2)) $i++;
       	}
      	return $num == $i?1:0;
	}
	/**
	*判断联系人重复
	* @access public
	* @param int $linkman 联系人
	* @return 0 or 1
	*/
	function checkLinkMan($customer_id,$link_man){
		if(!empty($customer_id)&&!empty($link_man)){
			$row = $this->getDataOne('linkman','count(*)',array('CUSTOMER_ID'=>(int)$customer_id,'LINKMAN_NAME'=>$link_man));
			if($row[0]>0) return 1;
		}
	}

	/**
	* 获取客户自定义字段
	* @access public
	* @return array
	*/
	function getCustomFields(){
		$result = array();
		$sql = "SELECT F_ID,F_NAME FROM field_set WHERE F_TABLE = 'customer'";
		$res = $this->query($sql);
		while($row = mysql_fetch_array($res)) {
			$result[$row['F_ID']] = $row['F_NAME'];
		}
		return $result;
	}

	/**
	 * 获取省份
	 * @access public
	 * @return array
	 */
	function getProvince() {
		$result = array();
		$sql = "SELECT proID,proName FROM province";
		$res = $this->query($sql);
		while($row = mysql_fetch_array($res)) {
			$result[$row['proName']] = $row['proID'];
		}
		return $result;
	}

	/**
	 * 获取市
	 * @access public
	 * @return array
	 */
	function getCity() {
		$result = array();
		$sql = "SELECT cityId,cityName FROM city";
		$res = $this->query($sql);
		while($row = mysql_fetch_array($res)) {
			$result[$row['cityName']] = $row['cityId'];
		}
		return $result;
	}

	/**
	 * 查询客户联系人
	 * @access public
	 * @param int $linkman 联系人
	 * @return 0 or 1
	 */
	function getCustomerLinkman($customer_id){
		global $connection;
		$sql = "SELECT LINKMAN_ID,LINKMAN_NAME,MOBILE,TEL_NO_WORK FROM linkman WHERE CUSTOMER_ID = ". SecurityFilter($customer_id) ."  AND (MOBILE != '' OR TEL_NO_WORK != '') LIMIT 1";

		$query = exequery($connection, $sql);

		if ($row = mysql_fetch_assoc($query)) {
			return $row;
		}

		return '';
	}

    /**
     * 获取客户查询列表
     * @access public
     * @param array $param
     * @return bool
     */
    public function getCustomerList($sql) {
    	$list = $customerId = array();
		$query = $this->query($sql);

		while($row = mysql_fetch_array($query)){
			$list[$row['CUSTOMER_ID']] = $row;
			$customerId[] = $row['CUSTOMER_ID'];
		}

		//主联系人
		$linkmanPrimary = array();
		if (!empty($customerId)) {
			$sql = "SELECT LINKMAN_ID,CUSTOMER_ID,LINKMAN_NAME,MOBILE,TEL_NO_WORK,PRIMARY_LINKMAN FROM linkman WHERE CUSTOMER_ID IN (".SecurityFilter(implode(',', $customerId)).") AND PRIMARY_LINKMAN=1 AND (MOBILE != '' OR TEL_NO_WORK != '')";

			$query = $this->query($sql);
			while($row = mysql_fetch_array($query)){
				$list[$row['CUSTOMER_ID']]['LINKMAN'] = $row['LINKMAN_NAME'];
				$list[$row['CUSTOMER_ID']]['LINKMAN_TEL'] = !empty($row['MOBILE']) ? $row['MOBILE'] : $row['TEL_NO_WORK'];
				$linkmanPrimary[] = $row['CUSTOMER_ID'];
			}

			$customerId = array_diff($customerId, $linkmanPrimary);
		}

		//有联系记录
		$linkmanRecord = array();
		if (!empty($customerId)) {
			$sql = "SELECT MAX(rr.RE_ID) AS MAX_RE_ID FROM relation_record AS rr LEFT JOIN linkman AS l ON rr.LINKMAN_ID = l.LINKMAN_ID WHERE l.CUSTOMER_ID IN (".SecurityFilter(implode(',', $customerId)).") GROUP BY l.CUSTOMER_ID";

			$query = $this->query($sql);

			$recordIds = '';
			while($row = mysql_fetch_array($query)){
				$recordIds .= "'".$row['MAX_RE_ID']."',";
			}

			if (!empty($recordIds)) {
				$recordIds = rtrim($recordIds, ',');

				$sql = "SELECT l.LINKMAN_ID, l.CUSTOMER_ID, l.LINKMAN_NAME, l.MOBILE, l.TEL_NO_WORK FROM linkman AS l LEFT JOIN relation_record AS rr ON l.LINKMAN_ID = rr.LINKMAN_ID WHERE rr.RE_ID IN (". SecurityFilter($recordIds) .")";

				$query = $this->query($sql);

				while($row = mysql_fetch_array($query)){
					$list[$row['CUSTOMER_ID']]['LINKMAN'] = $row['LINKMAN_NAME'];
					$list[$row['CUSTOMER_ID']]['LINKMAN_TEL'] = !empty($row['MOBILE']) ? $row['MOBILE'] : $row['TEL_NO_WORK'];
					$linkmanRecord[] = $row['CUSTOMER_ID'];
				}

				$customerId = array_diff($customerId, $linkmanRecord);
			}

		}

		$linkmanTel = array();
		if (!empty($customerId)) {
			$sql = "SELECT LINKMAN_ID,CUSTOMER_ID,LINKMAN_NAME,MOBILE,TEL_NO_WORK FROM linkman WHERE CUSTOMER_ID IN (".SecurityFilter(implode(',', $customerId)).")";

			$query = $this->query($sql);

			while($row = mysql_fetch_array($query)){
				if (!isset($linkmanTel[$row['CUSTOMER_ID']]) || $linkmanTel[$row['CUSTOMER_ID']] < $row['LINKMAN_ID']) {
					$linkman_tel = !empty($row['MOBILE']) ? $row['MOBILE'] : $row['TEL_NO_WORK'];

					if (!isset($list[$row['CUSTOMER_ID']]['LINKMAN_TEL']) || !empty($linkman_tel) || (empty($list[$row['CUSTOMER_ID']]['LINKMAN_TEL']) && empty($linkman_tel))) {
						$list[$row['CUSTOMER_ID']]['LINKMAN'] = $row['LINKMAN_NAME'];
						$list[$row['CUSTOMER_ID']]['LINKMAN_TEL'] = $linkman_tel;
					}
				}
			}

		}

		return array_values($list);
    }

	/**
	 * 保存字段权限
	 *
	 * @param array $data
	 *
	 * @return bool
	 */
	function saveFields($data){
		$editField = $this->getFieldsById(1);

		if (empty($editField)) {
			return $this->add('customer_fields_set', $data);
		} else {
			return $this->update('customer_fields_set', $data, array('FIELD_SET_ID' => 1));
		}
	}

	/**
	 * 查看字段权限
	 *
	 * @param int $id 字段权限id
	 *
	 * @return array
	 */
	function getFieldsById($id){
		$where = "FIELD_SET_ID = $id";
		return $this->getFields($where);
	}

	/**
	 * 获取禁止编辑字段
	 *
	 * @param int $id 字段权限id
	 * @param int $user_id 用户id
	 *
	 * @return array
	 */
	function getDisEditFields($id, $user_id){
		$login_priv  =  $this->get_login_priv($user_id);

		$where = "(INSTR(CONCAT(',',PURVIEW_DEPT),',". SecurityFilter($login_priv['priv_dept']) .",')>0
		 			OR
		 			instr(CONCAT(',',PURVIEW_ROLE),',". SecurityFilter($login_priv['user_priv']) .",')>0
		 			OR
		 			instr(CONCAT(',',PURVIEW_USER),',". SecurityFilter($login_priv['priv_user']) .",')>0
		 		)";

		return $this->getFields($where);
	}

	/**
	 * 查看字段权限
	 *
	 * @param string $where 查询条件
	 *
	 * @return array
	 */
	function getFields($where){
		$sql = "SELECT * FROM customer_fields_set where $where";
		$query = $this->query($sql);

		if ($row = mysql_fetch_assoc($query)) {
			return $row;
		}

		return array();
	}

	/**
	 * 获取用户自定义字段名称字符串或数组
	 *
	 * @param  string $tableName 表名;string $returnType 返回类型 'string' or 'array'
	 * @author miaochenchen
	 * @date   2016-12-21
	 * @return array
	 */
	function getUserDefinedFieldName($tableName, $returnType = 'string') {
		$sql = "SELECT * FROM field_set WHERE F_TABLE = '".SecurityFilter($tableName)."' ORDER BY F_ID asc";
		$res = $this->query($sql);
		$fieldInfo = '';
		if($returnType == 'string') {
			while($row = mysql_fetch_array($res))
			{
				$fieldInfo .= ','.$row['F_NAME'];
			}
		}elseif($returnType == 'array'){
			$fieldInfo = array();
			while($row = mysql_fetch_array($res))
			{
				$key = strtoupper($tableName."_SET_".$row["F_ID"]);
				$fieldInfo[$key] = $row;
			}
		}
		return $fieldInfo;
	}
}
