<?php
/**
 * @copyright (C) 2001 - 2011 Weaver Co.Ltd
 * @package       eoffice 8.3
 * @function      常用函数页
 * @encoding      $_lang['encoding']
 * @name          inc/utility_all.php
 * @version       93
 * @author        Qu|www.weaver.com.cn
 * @date          2012-12-18
 * @modify        liu
 */
include_once ("inc/conn.php");
include_once ("inc/AppGlobal.php");
include_once ("inc/reg_func.php");
include_once("general/dingtalk/api/dingtalk.class.php");

function daddslashes($string, $force = 1) {
    if (is_array($string)) {
        foreach ($string as $key => $val) {
            $string[$key] = daddslashes($val, $force);
        }
    } else {
        $string = addslashes($string);
    }
    return $string;
}

function dhtmlspecialchars($string) {
    if (get_magic_quotes_gpc() != 1) {
        $Do = daddslashes($string);
        $DoString = $Do;
    } else {
        $DoString = $string;
    }
    if (is_array($DoString)) {
        foreach ($DoString as $key => $val) {
            $DoString[$key] = dhtmlspecialchars($val);
        }
    } else {
        $DoString = str_replace(array('&', '"', '<', '>', "'"), array('&amp;', '&quot;', '&lt;', '&gt;', '&#039'), $DoString);
        if (strpos($DoString, '&amp;#') !== false) {
            $DoString = preg_replace('/&amp;((#(\d{3,5}|x[a-fA-F0-9]{4}));)/', '&\\1', $DoString);
        }
    }
    return $DoString;
}

/**
 * 格式化日期
 * @param  string $STRING1  格式化前的字符串
 * @return string $STRING2  返回格式化后的字符串(如 1999年2月1日)
 */
function format_date($STRING1) {
    global $_lang;
    $STRING1 = str_replace("-0", "-", $STRING1);
    $STR = strtok($STRING1, "-");
    $STRING2 = $STR . $_lang["common_year"];
    $STR = strtok("-");
    $STRING2 .= $STR . $_lang["common_month"];
    $STR = strtok(" ");
    $STRING2 .= $STR . $_lang["common_daytime"];
    return $STRING2;
}

/**
 * 获取星期中对应的那一天
 * @param  string $STRING1 传入的
 * @return string 返回的是对应星期中的哪一天(如"六")
 */
function get_week($STRING1) {
    global $_lang;
    $STR = strtok($STRING1, "-");
    $YEAR = $STR;
    $STR = strtok("-");
    $MONTH = $STR;
    $STR = strtok(" ");
    $DAY = $STR;
    $TIME1 = mktime(0, 0, 0, $MONTH, $DAY, $YEAR);

    switch (date("w", $TIME1)) {
        case 0:
            return $_lang["common_sunday"];
        case 1:
            return $_lang["common_mon"];
        case 2:
            return $_lang["common_tue"];
        case 3:
            return $_lang["common_wed"];
        case 4:
            return $_lang["common_thu"];
        case 5:
            return $_lang["common_fri"];
        case 6:
            return $_lang["common_sat"];
    }
}

/**
 * 格式化货币
 * @param  string $STR  格式化前传入的货币
 * @return string $STR  返回格式化后的货币
 */
function format_money($STR) {
    if ($STR == "")
        return "";
    if ($STR == ".00")
        return "0.00";
    $TOK = strtok($STR, ".");

    if (strcmp($STR, $TOK) == "0")
        $STR .= ".00";
    else {
        $TOK = strtok(".");
        for ($I = 1; $I <= 2 - strlen($TOK); $I++)
            $STR .= "0";
    }

    if (substr($STR, 0, 1) == ".")
        $STR = "0" . $STR;
    return $STR;
}

/**
 * 日期的比较
 * @param  string $DATE1   传入比较的日期1
 * @param  string $DATE2   传入比较的日期2
 * @return (0/1/-1)DATE1=DATE2 返回0,DATE1>DATE2 返回1,DATE1<DATE2 返回-1
 */
function compare_date($DATE1, $DATE2) {
    $STR = strtok($DATE1, "-");
    $YEAR1 = $STR;
    $STR = strtok("-");
    $MON1 = $STR;
    $STR = strtok("-");
    $DAY1 = $STR;
    $STR = strtok($DATE2, "-");
    $YEAR2 = $STR;
    $STR = strtok("-");
    $MON2 = $STR;
    $STR = strtok("-");
    $DAY2 = $STR;

    if ($YEAR1 > $YEAR2)
        return 1;
    else
    if ($YEAR1 < $YEAR2)
        return - 1;
    else {
        if ($MON1 > $MON2)
            return 1;
        else
        if ($MON1 < $MON2)
            return - 1;
        else {
            if ($DAY1 > $DAY2)
                return 1;
            else
            if ($DAY1 < $DAY2)
                return - 1;
            else
                return 0;
        }
    }
}

/*
 * 时间的比较
 * @param  string $time1  传入比较的时间1
 * @param  string $time2  传入比较的时间2
 * @param  bool $time3(初始为false)
 * @return (0/1/-1)time1=time2 返回0,time1>time2 返回1,time1<time2 返回-1
 */

function new_compare_time($time1, $time2, $time3 = false) {
    $time1 = explode(' ', $time1);
    $time2 = explode(' ', $time2);
    $d1 = split('-', $time1[0]);
    $t1 = split(':', $time1[1]);
    $d2 = split('-', $time2[0]);
    $t2 = split(':', $time2[1]);
    $timeNow = mktime($t1[0], $t1[1], $t1[2], $d1[1], $d1[2], $d1[0]);
    $timeStart = mktime($t2[0], $t2[1], $t2[2], $d2[1], $d2[2], $d2[0]);

    if ($time3 != false) {
        $time3 = explode(' ', $time3);
        $d3 = split('-', $time3[0]);
        $t3 = split(':', $time3[1]);
        $timeEnd = mktime($t3[0], $t3[1], $t3[2], $d3[1], $d3[2], $d3[0]);
    }

    if ($time3 != false) {
        if ($timeNow > $timeStart && $timeNow < $timeEnd)
            return 0;
    } else {
        if ($timeNow = $timeStart)
            return 0;
    }

    if ($timeNow < $timeStart)
        return - 1;
    if ($timeNow > $timeEnd)
        return 1;
}

/**
 * 时间比较
 * @param  string $TIME!
 * @param  string $TIME2
 * @return (0/1/-1) time1=time2 返回0,time1>time2 返回1,time1<time2 返回-1
 */
function compare_time($TIME1, $TIME2) {
    $STR = strtok($TIME1, ":");
    $HOUR1 = $STR;
    $STR = strtok(":");
    $MIN1 = $STR;
    $STR = strtok(":");
    $SEC1 = $STR;
    $STR = strtok($TIME2, ":");
    $HOUR2 = $STR;
    $STR = strtok(":");
    $MIN2 = $STR;
    $STR = strtok(":");
    $SEC2 = $STR;

    if ($HOUR1 > $HOUR2)
        return 1;
    else
    if ($HOUR1 < $HOUR2)
        return - 1;
    else {
        if ($MIN1 > $MIN2)
            return 1;
        else
        if ($MIN1 < $MIN2)
            return - 1;
        else {
            if ($SEC1 > $SEC2)
                return 1;
            else
            if ($SEC1 < $SEC2)
                return - 1;
            else
                return 0;
        }
    }
}

/**
 * 日期时间的比较
 * @param  string $DATE_TIME1   传入比较的日期时间1
 * @param  string $DATE_TIME2   传入比较的日期时间2
 * @return (0/1/-1) date_time1=date_time2 返回0,date_time1>date_time2 返回1,date_time1<date_time2 返回-1
 */
function compare_date_time($DATE_TIME1, $DATE_TIME2) {
    if ($DATE_TIME1 == null || strlen($DATE_TIME1) == 0 || $DATE_TIME2 == null ||
            strlen($DATE_TIME2) == 0)
        return - 1;
    $DATE_TIME1_ARRY = explode(" ", $DATE_TIME1);
    $DATE_TIME2_ARRY = explode(" ", $DATE_TIME2);

    if (compare_date($DATE_TIME1_ARRY[0], $DATE_TIME2_ARRY[0]) == 1)
        return 1;
    elseif (compare_date($DATE_TIME1_ARRY[0], $DATE_TIME2_ARRY[0]) == 0) {
        if (compare_time($DATE_TIME1_ARRY[1], $DATE_TIME2_ARRY[1]) == 1)
            return 1;
        elseif (compare_time($DATE_TIME1_ARRY[1], $DATE_TIME2_ARRY[1]) == 0)
            return 0;
        else
            return - 1;
    } else
        return - 1;
}

/**
 * 上传附件
 * @param  string $ATTACHMENT      附件文件
 * @param  string $ATTACHMENT_NAME 附件名
 * @return string $ATTACHMENT_ID   返回附件ID
 */
function upload($ATTACHMENT, $ATTACHMENT_NAME) {
    global $_lang;
    if (!file_exists($ATTACHMENT)) {
        Message("", $_lang["common_uploaderror3"]);
        ?>
        <script language="javascript">
            setTimeout("history.back()", 3000)
        </script>
        <?
        exit;
    }
    //限制上传的文件类型
    preg_match("/\.([a-zA-Z]{2,5})$/", $ATTACHMENT_NAME, $arrayT);
    $suffix = $arrayT[1];
    $role = UPLOADROLE;
    $pos = $suffix ? strpos($role, strtoupper($suffix)) : false;
    if (!($pos === false)) {
        Message("", $_lang["common_uploaderror2"]);
        ?>
        <script language="javascript">
            setTimeout("history.back()", 3000)
        </script>
        <?
        exit;
    }

    //-- 生成随机数 --
    /* mt_srand((double)microtime()*1000000);
      $ATTACHMENT_ID = mt_rand(); */
    $ATTACHMENT_ID = createFileDir();
    //-- 将上载文件转存 --
    global $ATTACH_PATH;
    $ATTACHMENT_NAME = str_replace("\'", "’", $ATTACHMENT_NAME);
    $PATH = $ATTACH_PATH . $ATTACHMENT_ID;

    if (!file_exists($PATH))
        mkdir($PATH, 0700);
    $ATTACHMENT_NAME = ICONV('UTF-8', 'GBK', $ATTACHMENT_NAME);
    $FILENAME = $PATH . "/" . $ATTACHMENT_NAME;
    copy($ATTACHMENT, $FILENAME);

    unlink($ATTACHMENT);

    if (!file_exists($FILENAME)) {
        Message("", $_lang["common_uploaderror3"]);
        ?>
        <script language="javascript">
            setTimeout("history.back()", 3000)
        </script>
        <?php
        exit;
    }
    return $ATTACHMENT_ID;
}

/**
 * 上传附件生成随机数
 * @return string $RADOM_ID 返回的是生成的随机数
 */
function createFileDir() {
    global $ATTACH_PATH;
    mt_srand((double) microtime() * 1000000);
    $RADOM_ID = mt_rand() + mt_rand();
    if (!file_exists($ATTACH_PATH . $RADOM_ID))
        return $RADOM_ID;
    else
        return createFileDir();
}

/**
 * 删除附件
 * @param string $ATTACHMENT_ID   附件ID
 * @param string $ATTACHMENT_NAME 附件名
 */
function delete_attach($ATTACHMENT_ID, $ATTACHMENT_NAME) {
    global $ATTACH_PATH;
    $PATH = $ATTACH_PATH . $ATTACHMENT_ID;

    $FILENAME = $PATH . "/" . $ATTACHMENT_NAME;
    $FILENAME = ICONV('UTF-8', 'GBK', $FILENAME);

    @unlink($FILENAME);
    @rmdir($PATH);
}

/**
 *
 * @param string $ATTACHMENT_ID   附件ID
 * @param string $ATTACHMENT_NAME 附件名
 * @param string $THEME           系统所用的主题样式
 */
function delete_template_title($ATTACHMENT_ID, $ATTACHMENT_NAME, $THEME) {
    global $ATTACH_PATH;
    $PATH = $ATTACH_PATH . $THEME;
    //$FILENAME=$PATH."/".$THEME;
    $I = 0;
    if ($handle = @opendir($PATH)) {
        while (false !== ($file = readdir($handle))) {
            if ($file != "." && $file != "..") {
                $FILE_ARRAY[$I++] = $file;
            }
        }
        closedir($handle);
    }
    @sort($FILE_ARRAY);
    @reset($FILE_ARRAY);
    for ($I = 0; $I < sizeof($FILE_ARRAY); $I++) {
        unlink($PATH . "/" . $FILE_ARRAY[$I]);
    }
    @rmdir($PATH);
}

/**
 * 附件大小
 * @param  string $ATTACHMENT_ID 附件ID
 * @param  string $ATTACHMENT_NAME 附件名
 * @return string $ATTACH_SIZE  返回附件大小
 */
function attach_size($ATTACHMENT_ID, $ATTACHMENT_NAME) {
    $ATTACH_SIZE = 0;

    global $ATTACH_PATH;
    $PATH = $ATTACH_PATH . $ATTACHMENT_ID;
    $FILENAME = $PATH . "/" . $ATTACHMENT_NAME;
    $FILENAME = ICONV('UTF-8', 'GBK', $FILENAME);
    if (file_exists($FILENAME))
        $ATTACH_SIZE = filesize($FILENAME);

    return $ATTACH_SIZE;
}

/**
 * 针对中文的定位折行.(本论坛使用的是这个函数.)/判断某个位置是中文字符的左还是右半部分，或不是中文
 * @param  string $str       传入的字符串
 * @param  string $location  判断的位置
 * @return string $f_str     返回值 -1 左 0 不是中文字符 1 右
 */
function is_chinese(&$str, $location) {
    $ch = true;
    $i = $location;
    while (ord($str[$i]) > 0xa0 && $i >= 0) {
        $ch = !$ch;
        $i--;
    }

    if ($i != $location) {
        $f_str = $ch ? 1 : -1;
    } else {
        $f_str = false;
    }
    return $f_str;
}

/**
 * 中文字符串截取函数
 * @param  string $str     传入的字符串
 * @param  string $start   开始位置，从0开始
 * @param  string $long    = 0 则从start 一直取到字符串尾
 * @param  string $ltor    = true 时从左到右取字符，false 时到右到左取字符
 * @param  string $cn_len  中文字符按字节取还是字数取，如果按字数取，则一个中文当一个字节计算
 * @return string $f_str   返回截取后的字符串
 */
function csubstr(&$str, $start = 0, $long = 0, $ltor = true, $cn_len = 2) {
    if ($long == 0)
        $long = strlen($str);
    if ($ltor == false)
        $str = cstrrev($str);

    if ($cn_len == 1) {
        for ($i = 0, $fs = 0; $i < $start; $fs++)
            $i += (ord($str[$fs]) <= 0xa0) ? 1 : 0.5;
        for ($i = 0, $fe = $fs; $i < $long; $fe++)
            $i += (ord($str[$fe]) <= 0xa0) ? 1 : 0.5;
        $long = $fe - $fs;
    } else {
        $fs = (is_chinese($str, $start) == 1) ? $start - 1 : $start;
        $fe = $long + $start - 1;
        $end = (is_chinese($str, $fe) == -1) ? $fe - 1 : $fe;
        $long = $end - $fs + 1;
    }

    $f_str = substr($str, $fs, $long);
    if ($ltor == false)
        $f_str = cstrrev($f_str);
    return $f_str;
}

/**
 * 检查IP是否合法
 * @param  string $IP      传入的IP地址
 * @return bool true/false 返回true表示IP地址合法，返回false表示IP地址不合法
 */
function is_ip($IP) {
    $IP_ARRAY = explode(".", $IP);
    $IP_ARRAY_NUM = sizeof($IP_ARRAY);
    if ($IP_ARRAY_NUM != 4)
        return false;
    for ($I = 0; $I < $IP_ARRAY_NUM; $I++) {
        if (!is_numeric($IP_ARRAY[$I]) || $IP_ARRAY[$I] < 0 || $IP_ARRAY[$I] > 255)
            return false;
        if ($I == 3 && $IP_ARRAY[$I] == 255)
            return false;
    }
    return true;
}

/**
 * 限制IP登录/考勤中，检查IP是否在限制范围中
 * @param  string $USER_IP     用户的IP
 * @param  string $TYPE        限制类型(登录/考勤)
 * @param  string $USER_NAME   用户名
 * @return bool $canAccess 返回true表示用户IP在限制范围内，返回false表示在范围外
 */
function check_ip($USER_IP, $TYPE, $USER_NAME) {
    $connection = OpenConnection();
    $query = "select * from user where USER_ACCOUNTS ='".SecurityFilter($USER_NAME)."'";
    $cursor = exequery($connection, $query);
    if ($ROW = mysql_fetch_array($cursor)) {
        $DEPT_ID = $ROW["DEPT_ID"];
        $USER_PRIV = $ROW["USER_PRIV"];
        $USER_ID = $ROW["USER_ID"];
    }
    $query = "select * from IP_RULE where TYPE='".SecurityFilter($TYPE)."'";
    $cursor = exequery($connection, $query);

    //1——可以访问，不在规则限制范围内
    $flag1 = 0;
    //2——可以访问，在规则限制范围内，并且在起始IP和结束IP之间
    $flag2 = 0;
    //3——不可以访问，在规则限制范围内，并且不在起始IP和结束IP之间
    $flag3 = 0;

    while ($ROW = mysql_fetch_array($cursor)) {
        $BEGIN_IP = $ROW["BEGIN_IP"];
        $END_IP = $ROW["END_IP"];
        $SELECT_DEPT = $ROW["DEPT_ID"];
        $SELECT_PRIV = $ROW["PRIV_ID"];
        $SELECT_USER = $ROW["USER_ID"];

        $NUM_BEGIN_IP = sprintf("%u", ip2long($BEGIN_IP));
        $NUM_END_IP = sprintf("%u", ip2long($END_IP));
        $NUM_USER_IP = sprintf("%u", ip2long($USER_IP));

        $isInRange = false; //是否在规则的限制范围内
        if ($SELECT_DEPT == '' && $SELECT_PRIV == '' && $SELECT_USER == '') {
            $isInRange = true;
        } else {
            if ($SELECT_DEPT != '') {
                $SELECT_DEPT = ',' . $SELECT_DEPT;
                $my_dept_id = ',' . $DEPT_ID . ',';
                if (strpos($SELECT_DEPT, $my_dept_id) !== false) {
                    $isInRange = true;
                }
            }
            if ($SELECT_PRIV != '') {
                $SELECT_PRIV = ',' . $SELECT_PRIV;
                $my_priv = ',' . $USER_PRIV . ',';
                if (strpos($SELECT_PRIV, $my_priv) !== false) {
                    $isInRange = true;
                }
            }
            if ($SELECT_USER != '') {
                $SELECT_USER = ',' . $SELECT_USER;
                $my_user_id = ',' . $USER_ID . ',';
                if (strpos($SELECT_USER, $my_user_id) !== false) {
                    $isInRange = true;
                }
            }
        }
        if ($isInRange) { //在规则限制范围内
            if ($NUM_USER_IP >= $NUM_BEGIN_IP && $NUM_USER_IP <= $NUM_END_IP) { //在起始IP和结束IP之间，可以访问
                $flag2++;
            } else { //不在起始IP和结束IP之间，不可以访问
                $flag3++;
            }
        } else { //不在规则限制范围内，可以访问
            $flag1++;
        }
    }

    if ($flag2 != 0) {
        return true;
    } else
    if ($flag3 != 0) {
        return false;
    } else
    if ($flag1 != 0) {
        return true;
    } else {
        return true;
    }
}

/**
 *
 * @param  string $STR
 * @param  string $FIRST
 * @param  string $LAST
 * @return string $RETURN_STR
 */
function maskstr($STR, $FIRST, $LAST) {
    if (!is_numeric($FIRST) || !is_numeric($LAST))
        return;
    if (strlen($STR) <= $FIRST + $LAST)
        return $STR;

    $RETURN_STR = substr($STR, 0, $FIRST);
    for ($I = 0; $I < strlen(substr($STR, $FIRST, -$LAST)); $I++)
        $RETURN_STR .= "*";
    $RETURN_STR .= substr($STR, -$LAST);

    return $RETURN_STR;
}

function get_ip() {
    if ($_SERVER["HTTP_X_FORWARDED_FOR"] == "") {
        $user_ip = $_SERVER["REMOTE_ADDR"];
    } else {
        $user_ip = $_SERVER["HTTP_X_FORWARDED_FOR"];
    }
    return $user_ip;
}

function getIPLoc_QQ($queryIP) {

    $url = 'http://ip.qq.com/cgi-bin/searchip?searchip1=' . $queryIP;

    $ch = curl_init($url);

    curl_setopt($ch, CURLOPT_ENCODING, 'gb2312');

    curl_setopt($ch, CURLOPT_TIMEOUT, 10);

    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true); // 获取数据返回

    $result = curl_exec($ch);

    $result = mb_convert_encoding($result, "utf-8", "gb2312"); // 编码转换，否则乱码

    curl_close($ch);

    preg_match("@<span>(.*)</span></p>@iU", $result, $ipArray);

    $loc = $ipArray[1];
    return $loc;
}

/**
 * 增加系统日志
 * @param  string $TYPE      日志的类型
 * @param  string $REMARK    日志的备注
 * @param  string $OPERATOR  增加系统日志的用户ID
 * @return string $query     返回的sql语句
 */
function add_log($TYPE, $REMARK, $OPERATOR) {
    $connection = OpenConnection();
    $CUR_TIME = date("Y-m-d H:i:s", time());
    $USER_IP = get_ip();
    //$ipArea  = getIPLoc_QQ($USER_IP);
    if ($TYPE == 3 || $TYPE == 4) {
        $query = "SELECT * from DEPARTMENT where DEPT_ID=".SecurityFilter($REMARK)."";
        $cursor = exequery($connection, $query);
        if ($ROW = mysql_fetch_array($cursor)) {
            $DEPT_ID = $ROW["DEPT_ID"];
            $DEPT_NAME = $ROW["DEPT_NAME"];
        }
        $REMARK = "$DEPT_NAME,DEPT_ID=$DEPT_ID";
    } elseif ($TYPE == 5) {
        $temp = explode(".", $REMARK);
        $DEPT_ID = $temp[0];
        $DEPT_NAME = $temp[1];
        $REMARK = "$DEPT_NAME,DEPT_ID=$DEPT_ID";
    } elseif ($TYPE == 12) {
        $TYPE = 12;
        $REMARK = $REMARK;
    } elseif ($TYPE == 6 || $TYPE == 7 || $TYPE == 8 || $TYPE == 11) {
        $query = "SELECT * from USER where USER_ID='".SecurityFilter($REMARK)."'";
        $cursor = exequery($connection, $query);
        if ($ROW = mysql_fetch_array($cursor)) {
            $USER_ID = $ROW["USER_ID"];
            $USER_NAME = $ROW["USER_NAME"];
            $DEPT_ID = $ROW["DEPT_ID"];
        }

        $query = "SELECT * from DEPARTMENT where DEPT_ID=".SecurityFilter($DEPT_ID)."";
        $cursor = exequery($connection, $query);
        if ($ROW = mysql_fetch_array($cursor))
            $DEPT_NAME = $ROW["DEPT_NAME"];

        $REMARK = "[$DEPT_NAME]$USER_NAME,USER_ID=$USER_ID";
    }

    $query = "insert into SYS_LOG (USER_ID,TIME,IP,IP_AREA,TYPE,REMARK) values ('".SecurityFilter($OPERATOR)."','".SecurityFilter($CUR_TIME)."','".SecurityFilter($USER_IP)."','','".SecurityFilter($TYPE)."','".SecurityFilter($REMARK)."')";
    exequery($connection, $query);
    return $query;
}

/**
 * 检查固定资产折旧处理
 * @return true/false  返回true表示有折旧处理，返回false表示无
 */
function check_cfg() {
    $connection = OpenConnection();
    $query = "select * from CP_ASSETCFG";
    $cursor = exequery($connection, $query);
    if ($ROW = mysql_fetch_array($cursor)) {
        $DPCT_SORT = $ROW["DPCT_SORT"];
        $BAL_SORT = $ROW["BAL_SORT"];
    }
    if ($DPCT_SORT != "M" && $DPCT_SORT != "S" && $DPCT_SORT != "Y" || $BAL_SORT !=
            "01" && $BAL_SORT != "02")
        return false;
    else
        return true;
}

/**
 * 判断PARENT_ID是否是DEPT_ID的父节点
 * @param  string $DEPT_ID    部门ID
 * @param  string $PARENT_ID  部门ID的父节点
 * @return (0/1)              返回1表示PARENT_ID是DEPT_ID的父节点，返回0表示不是
 */
function is_dept_parent($DEPT_ID, $PARENT_ID) {
    global $connection;
    $query = "SELECT DEPT_ID FROM department WHERE DEPT_ID = '" . SecurityFilter($DEPT_ID) . "' AND SORT_LEVEL_ID LIKE '%|" . SecurityFilter($PARENT_ID) . "|%'";
    $cursor = exequery($connection, $query);
    if ($ROW = mysql_fetch_array($cursor)) {
        return 1;
    } else {
        return 0;
    }
}

/**
 * 查看$DEPT_ID是否属于本人管理范围
 * @param  string $DEPT_ID
 * @return string $DEPT_PRIV
 */
function is_dept_priv($DEPT_ID) {
    global $LOGIN_USER_ID, $LOGIN_DEPT_ID;

    $connection = OpenConnection();
    $query = "SELECT POST_PRIV,POST_DEPT from USER where USER_ID='".SecurityFilter($LOGIN_USER_ID)."'";
    $cursor = exequery($connection, $query);
    if ($ROW = mysql_fetch_array($cursor)) {
        $POST_PRIV = $ROW["POST_PRIV"];
        $POST_DEPT = $ROW["POST_DEPT"];
    }

    if ($POST_PRIV == 0 && $DEPT_ID != $LOGIN_DEPT_ID && !is_dept_parent($DEPT_ID, $LOGIN_DEPT_ID))
        $DEPT_PRIV = 0;
    else
    if ($POST_PRIV == 2) {
        $DEPT_PRIV = 0;

        $MY_ARRAY = explode(",", $POST_DEPT);
        $ARRAY_COUNT = sizeof($MY_ARRAY);
        if ($MY_ARRAY[$ARRAY_COUNT - 1] == "")
            $ARRAY_COUNT--;
        for ($I = 0; $I < $ARRAY_COUNT; $I++) {
            if (is_dept_parent($DEPT_ID, $MY_ARRAY[$I]) || $MY_ARRAY[$I] == $DEPT_ID) {
                $DEPT_PRIV = 1;
                break;
            }
        }
    } else
        $DEPT_PRIV = 1;
    return $DEPT_PRIV;
}

/**
 * 多级部门下拉菜单，支持按管理范围列出
 * @param  string $DEPT_ID       部门ID
 * @param  string $DEPT_CHOOSE   选择的部门
 * @param  string $POST_OP       管理范围
 * @return string $OPTION_TEXT   返回多级部门下拉菜单
 */
function my_dept_tree($DEPT_ID, $DEPT_CHOOSE, $POST_OP) {
    global $DEEP_COUNT;
    if ($DEEP_COUNT == "")
        $DEEP_COUNT = "|";

    $connection = OpenConnection();
    $query = "SELECT * FROM department WHERE DEPT_PARENT=".SecurityFilter($DEPT_ID)." ORDER BY DEPT_NO";
    $cursor = exequery($connection, $query);
    $OPTION_TEXT = "";
    $DEEP_COUNT1 = $DEEP_COUNT;
    $DEEP_COUNT .= "　|";
    while ($ROW = mysql_fetch_array($cursor)) {
        $COUNT++;
        $DEPT_ID = $ROW["DEPT_ID"];
        $DEPT_NO = $ROW["DEPT_NO"];
        $DEPT_NAME = $ROW["DEPT_NAME"];
        $DEPT_PARENT = $ROW["DEPT_PARENT"];
        $DEPT_ZM = $ROW["DEPT_NAME_ZM"];
        $DEPT_NAME = str_replace("<", "&lt", $DEPT_NAME);
        $DEPT_NAME = str_replace(">", "&gt", $DEPT_NAME);
        $DEPT_NAME = stripslashes($DEPT_NAME);

        if ($POST_OP == 1)
            $DEPT_PRIV = is_dept_priv($DEPT_ID);
        else
            $DEPT_PRIV = 1;

        $OPTION_TEXT_CHILD = my_dept_tree($DEPT_ID, $DEPT_CHOOSE, $POST_OP);

        if ($DEPT_PRIV == 1) {
            $OPTION_TEXT .= "<option ";
            if ($DEPT_ID == $DEPT_CHOOSE)
                $OPTION_TEXT .= "selected ";
            $OPTION_TEXT .= "value=$DEPT_ID alt=$DEPT_ZM>" . $DEEP_COUNT1 . "─(" . $DEPT_NO . ")-" . $DEPT_NAME . "</option>\n";
        }

        if ($OPTION_TEXT_CHILD != "")
            $OPTION_TEXT .= $OPTION_TEXT_CHILD;
    } //while
    $DEEP_COUNT = $DEEP_COUNT1;
    return $OPTION_TEXT;
}

/**
 * 递归求解完整的多级部门名称
 * @param  string $DEPT_ID    传入的部门的ID
 * @return string $DEPT_NAME  返回的多级部门名称
 */
function dept_long_name($DEPT_ID) {
    $connection = OpenConnection();
    $query = "SELECT * from DEPARTMENT where DEPT_ID=".SecurityFilter($DEPT_ID)."";
    $cursor = exequery($connection, $query);
    if ($ROW = mysql_fetch_array($cursor)) {
        $DEPT_NAME = $ROW["DEPT_NAME"];
        $DEPT_PARENT = $ROW["DEPT_PARENT"];

        if ($DEPT_PARENT == 0)
            return $DEPT_NAME;
        else
            return dept_long_name($DEPT_PARENT) . "/" . $DEPT_NAME;
    }
}

/**
 * 求解单个部门名称
 * @param  string $DEPT_ID    传入的部门的ID
 * @return string $DEPT_NAME  返回的部门的名称
 */
function dept_small_name($DEPT_ID) {
    $connection = OpenConnection();
    $query = "SELECT * from DEPARTMENT where DEPT_ID=".SecurityFilter($DEPT_ID)."";
    $cursor = exequery($connection, $query);
    if ($ROW = mysql_fetch_array($cursor)) {
        $DEPT_NAME = $ROW["DEPT_NAME"];
        return $DEPT_NAME;
    }
}

/**
 * 返回匹配文件格式的图片
 * @param  string $fichier   传入的文件名
 * @return string $image     返回对应格式的文件图片
 */
function image_mimetype($fichier) {
    if (eregi("\.mid$", $fichier)) {
        $image = "mid.gif";
    } else
    if (eregi("\.txt$", $fichier)) {
        $image = "txt.gif";
    } else
    if (eregi("\.sql$", $fichier)) {
        $image = "txt.gif";
    } else
    if (eregi("\.js$", $fichier)) {
        $image = "js.gif";
    } else
    if (eregi("\.gif$", $fichier)) {
        $image = "gif.gif";
    } else
    if (eregi("\.jpg$", $fichier)) {
        $image = "jpg.gif";
    } else
    if (eregi("\.html$", $fichier)) {
        $image = "html.gif";
    } else
    if (eregi("\.htm$", $fichier)) {
        $image = "html.gif";
    } else
    if (eregi("\.rar$", $fichier)) {
        $image = "rar.gif";
    } else
    if (eregi("\.gz$", $fichier)) {
        $image = "zip.gif";
    } else
    if (eregi("\.tgz$", $fichier)) {
        $image = "zip.gif";
    } else
    if (eregi("\.z$", $fichier)) {
        $image = "zip.gif";
    } else
    if (eregi("\.ra$", $fichier)) {
        $image = "ram.gif";
    } else
    if (eregi("\.ram$", $fichier)) {
        $image = "ram.gif";
    } else
    if (eregi("\.rm$", $fichier)) {
        $image = "ram.gif";
    } else
    if (eregi("\.pl$", $fichier)) {
        $image = "pl.gif";
    } else
    if (eregi("\.zip$", $fichier)) {
        $image = "zip.gif";
    } else
    if (eregi("\.wav$", $fichier)) {
        $image = "wav.gif";
    } else
    if (eregi("\.php$", $fichier)) {
        $image = "php.gif";
    } else
    if (eregi("\.phtml$", $fichier)) {
        $image = "php.gif";
    } else
    if (eregi("\.exe$", $fichier)) {
        $image = "exe.gif";
    } else
    if (eregi("\.bmp$", $fichier)) {
        $image = "bmp.gif";
    } else
    if (eregi("\.png$", $fichier)) {
        $image = "gif.gif";
    } else
    if (eregi("\.css$", $fichier)) {
        $image = "css.gif";
    } else
    if (eregi("\.mp3$", $fichier)) {
        $image = "mp3.gif";
    } else
    if (eregi("\.xls$", $fichier)) {
        $image = "xls.gif";
    } else
    if (eregi("\.doc$", $fichier)) {
        $image = "doc.gif";
    } else
    if (eregi("\.pdf$", $fichier)) {
        $image = "pdf.gif";
    } else
    if (eregi("\.mov$", $fichier)) {
        $image = "mov.gif";
    } else
    if (eregi("\.avi$", $fichier)) {
        $image = "avi.gif";
    } else
    if (eregi("\.mpg$", $fichier)) {
        $image = "mpg.gif";
    } else
    if (eregi("\.mpeg$", $fichier)) {
        $image = "mpeg.gif";
    } else
    if (eregi("\.swf$", $fichier)) {
        $image = "flash.gif";
    } else {
        $image = "defaut.gif";
    }
    return $image;
}

/**
 * 多级文档下拉菜单，支持按管理范围列出
 * @param  string $SORT_ID_CHOOSE   选中的文档
 * @param  string $FILE_SORT        文档类型
 * @param  string $PARENT_ID        上一级文档ID
 * @param  string $LOGIN_DEPT_ID    登录的部门ID
 * @param  string $LOGIN_USER_ID    登录的用户ID
 * @param  string $SORT
 * @return string $OPTION_TEXT      返回的多级文档下拉菜单
 */
function my_sort_tree($SORT_ID_CHOOSE, $FILE_SORT, $PARENT_ID, $LOGIN_DEPT_ID, $LOGIN_USER_ID, $SORT) {
    global $DEEP_COUNT, $_lang;
    if ($DEEP_COUNT == "")
        $DEEP_COUNT = "|";

    $connection = OpenConnection();
    if ($PARENT_ID == 0) {
        if ($FILE_SORT == 1)
            $query = "SELECT * from FILE_SORT where (SORT_TYPE='1' or (SORT_TYPE='2' and DEPT_ID=".SecurityFilter($LOGIN_DEPT_ID).") or (SORT_TYPE='3' and (InStr(USER_ID,',".SecurityFilter($LOGIN_USER_ID).",')>0 or InStr(USER_ID,'".SecurityFilter($LOGIN_USER_ID).",')=1))) and SORT_PARENT=".SecurityFilter($PARENT_ID)." order by SORT_NAME";
        else
            $query = "SELECT * from FILE_SORT where SORT_TYPE='4' and USER_ID='".SecurityFilter($LOGIN_USER_ID)."' and SORT_PARENT=".SecurityFilter($PARENT_ID)." order by SORT_NAME";
    } else
        $query = "SELECT * from FILE_SORT where SORT_PARENT=".SecurityFilter($PARENT_ID)." order by SORT_NAME";

    $cursor = exequery($connection, $query);
    $OPTION_TEXT = "";
    if ($FILE_SORT == 2 && $PARENT_ID == 0)
        $OPTION_TEXT = "<option value=0>─ " . $_lang["common_personal_file_cab"] . "</option>\n";
    $DEEP_COUNT1 = $DEEP_COUNT;
    $DEEP_COUNT .= "　|";
    $XML_TEXT = "";
    while ($ROW = mysql_fetch_array($cursor)) {
        $SORT_ID = $ROW["SORT_ID"];
        $SORT_NAME = $ROW["SORT_NAME"];
        $SORT_NAME = str_replace("<", "&lt", $SORT_NAME);
        $SORT_NAME = str_replace(">", "&gt", $SORT_NAME);
        $SORT_NAME = stripslashes($SORT_NAME);

        $OPTION_TEXT_CHILD = my_sort_tree($SORT_ID_CHOOSE, $FILE_SORT, $SORT_ID, $LOGIN_DEPT_ID, $LOGIN_USER_ID, $SORT);


        $OPTION_TEXT .= "<option value=$SORT_ID";
        if ($SORT_ID == $SORT_ID_CHOOSE)
            $OPTION_TEXT .= " selected";
        $OPTION_TEXT .= ">" . $DEEP_COUNT1 . "─" . $SORT_NAME . "</option>\n";

        if ($SORT == 1 && $SORT_ID == $SORT_ID_CHOOSE)
            continue;

        if ($OPTION_TEXT_CHILD != "")
            $OPTION_TEXT .= $OPTION_TEXT_CHILD;
    } //while
    $DEEP_COUNT = $DEEP_COUNT1;
    return $OPTION_TEXT;
}

/**
 * doc文档转换为txt类型
 * @param  string $path  文档路径
 * @return string $OUT   返回值
 */
function doc2txt($path) {
    exec($_SERVER["DOCUMENT_ROOT"] . "inc/doc2txt.exe -q -s $path", $OUT_ARRAY);
    $count = count($OUT_ARRAY);
    for ($i = 0; $i < $count; $i++)
        $OUT .= $OUT_ARRAY[$i] . "\n";
    return $OUT;
}

/**
 * 日常事务内部消息提醒
 */
function affair_sms() {
    global $LOGIN_USER_ID, $_lang;
    $CUR_DATE = date("Y-m-d", time());
    $CUR_TIME = date("Y-m-d H:i:s", time());
    $connection = OpenConnection();
    $query = "SELECT * from AFFAIR where USER_ID='".SecurityFilter($LOGIN_USER_ID)."' and BEGIN_TIME<='".SecurityFilter($CUR_TIME)."' and (LAST_REMIND<'".SecurityFilter($CUR_DATE)."' or LAST_REMIND='0000-00-00')";
    $cursor = exequery($connection, $query);

    while ($ROW = mysql_fetch_array($cursor)) {
        $AFF_ID = $ROW["AFF_ID"];
        $USER_ID = $ROW["USER_ID"];
        $TYPE = $ROW["TYPE"];
        $REMIND_DATE = $ROW["REMIND_DATE"];
        $REMIND_TIME = $ROW["REMIND_TIME"];
        $CONTENT = $ROW["CONTENT"];
        $SEND_TIME = date("Y-m-d", time()) . " " . $REMIND_TIME;
        $SMS_CONTENT = $_lang["common_affairremind"] . "：" . csubstr($CONTENT, 0, 100);

        $FLAG = 0;
        if ($TYPE == "2")
            $FLAG = 1;
        elseif ($TYPE == "3" && date("w", time()) == $REMIND_DATE)
            $FLAG = 1;
        elseif ($TYPE == "4" && date("j", time()) == $REMIND_DATE)
            $FLAG = 1;
        elseif ($TYPE == "5") {
            $REMIND_ARR = explode("-", $REMIND_DATE);
            $REMIND_DATE_MON = $REMIND_ARR[0];
            $REMIND_DATE_DAY = $REMIND_ARR[1];
            if (date("n", time()) == $REMIND_DATE_MON && date("j", time()) == $REMIND_DATE_DAY)
                $FLAG = 1;
        }

        if ($FLAG == 1) {
            $query = "insert into SMS(FROM_ID,TO_ID,SMS_TYPE,CONTENT,SEND_TIME,REMIND_FLAG) values ('".SecurityFilter($LOGIN_USER_ID)."','".SecurityFilter($LOGIN_USER_ID)."','5','".SecurityFilter($SMS_CONTENT)."','".SecurityFilter($SEND_TIME)."','1')";
            exequery($connection, $query);

            $query = "update AFFAIR set LAST_REMIND='".SecurityFilter($CUR_DATE)."' where AFF_ID=".SecurityFilter($AFF_ID)."";
            exequery($connection, $query);
        }
    }
}

/**
 * 查询今天是否有过生日   liurui
 *
 */
function birthday_info() {
    $connection = OpenConnection();
    $sql = "SELECT LOG_ID FROM SYS_LOG WHERE DATE_FORMAT(TIME,'%y %m %d')=DATE_FORMAT(NOW(),'%y %m %d')";
    $sql .= " AND TYPE = 19";
    $cursor = exequery($connection, $sql);
    if (!mysql_fetch_array($cursor)) {
        $query = "SELECT USER_ID FROM USER WHERE ";
        $query .= "DATE_FORMAT(BIRTHDAY,'%m %d')=DATE_FORMAT(NOW(),'%m %d') AND DEPT_ID > 0 ";
        $cursor = exequery($connection, $query);
        if (mysql_fetch_array($cursor)) {
            birthday_mail();
        }
    }
}

/**
 * 办公用品借用到期提醒 2007-2-5 lxl
 */
function officeitem_sms() {
    global $connection, $_lang;
    $sql = "
			SELECT * FROM officeitem_take
				WHERE TO_DAYS('" . date("Y-m-d") .
            "')>TO_DAYS(DATE_FORMAT(MODE_TIME,'%Y-%m-%d'))
				AND MODES=2
				AND STATUS=2
				AND CONCEAL=0
				AND TAKE_OPERATOR='" . $_SESSION['LOGIN_USER_ID'] . "'
			";

    $rs = exequery($connection, $sql);
    while ($row = mysql_fetch_array($rs)) {
        $sqlap = "SELECT APPELLATION_ID,APPELLATION FROM officeitem_appellation WHERE APPELLATION_ID='" .
                SecurityFilter($row['APPELLATION_ID']) . "'";
        $rsap = exequery($connection, $sqlap);
        $rowap = mysql_fetch_array($rsap);
        $appname = $rowap['APPELLATION'];
        $fromid = "admin";
        $toid = $_SESSION['LOGIN_USER_ID'];
        $systype = 17;
        $modetime = date("Y-m-d", strtotime($row['MODE_TIME']));
        $sendtime = date("Y-m-d H:i:s");
        $remind = 1;
        $content = getSmstype($systype) . "：" . $appname . " " . $_lang["common_expire_date"] . " " . $modetime;
        $sqlsms = "INSERT INTO sms(FROM_ID,TO_ID,SMS_TYPE,CONTENT,SEND_TIME,REMIND_FLAG)
					VALUES
					('".SecurityFilter($fromid)."','".SecurityFilter($toid)."','".SecurityFilter($systype)."','".SecurityFilter($content)."','".SecurityFilter($sendtime)."','".SecurityFilter($remind)."')";
        exequery($connection, $sqlsms);
    }
}

/**
 * 生日祝福,生成邮件    liurui
 */
function birthday_mail() {
    global $connection, $_lang;
    //查询生日卡设置
    $query = "SELECT * FROM BIRTHDAY WHERE SELECTED = 1 ";
    $cursor = exequery($connection, $query);
    $hasCard = mysql_affected_rows();
    if (!$hasCard) {
        return false;
    }

    if ($ROW = mysql_fetch_array($cursor)) {
        $title = $ROW["TITLE"];
        $content = $ROW["CONTENT"];
        $underwrite = $ROW["UNDERWRITE"];
        $sms_remind = $ROW["SMS_REMIND"];
    }

    $query1 = "SELECT USER_NAME FROM USER WHERE USER_ID = '" . SecurityFilter($underwrite) . "'";
    $cursor = exequery($connection, $query1);
    if ($ROW = mysql_fetch_array($cursor)) {
        $user_name = $ROW["USER_NAME"];
    }
    $SUBJECT = $title;
    $SEND_TIME = date('Y-m-d h:i:s');
    $CONTENT = "<table width=\"100%\"  border=\"1\" cellspacing=\"0\" cellpadding=\"0\"><tr><td>$content</td></tr><tr><td align=\"right\">$user_name</td></tr><tr><td align=\"right\">$SEND_TIME</td></tr></table>";
    //查询今天过生日的用户并用还
    $query2 = "SELECT USER_ID FROM USER WHERE ";
    $query2 .= "DATE_FORMAT(BIRTHDAY,'%m %d')=DATE_FORMAT(NOW(),'%m %d') AND DEPT_ID > 0 ";
    $cursor1 = exequery($connection, $query2);
    $i = 0;
    $CONTENT = str_replace("'", "\'", $CONTENT);
    while ($ROW = mysql_fetch_array($cursor1)) {
        //插入邮件
        $USER_ID[$i] = $ROW["USER_ID"];
        $query3 = "insert into EMAIL(FROM_ID,TO_ID,TO_ID2,SUBJECT,CONTENT,SEND_TIME,READ_FLAG,";
        $query3 .= " SEND_FLAG,DELETE_FLAG)values('" . SecurityFilter($underwrite) . "',";
        $query3 .= "'" . SecurityFilter($USER_ID[$i]) . "','" . SecurityFilter($USER_ID[$i]) . ",','" . SecurityFilter($SUBJECT) . "','" .
                SecurityFilter($CONTENT) . "','" . SecurityFilter($SEND_TIME) . "',";
        $query3 .= "'0','1','0')";
        $cursor2 = exequery($connection, $query3);
        $TABLE_ID = mysql_insert_id();
        if ($cursor2) {
            add_log(19, $_lang["other_send_email_success"], "admin");
        }
        if ($sms_remind == "1") {

            $SMS_CONTENT = $_lang["other_birthday_remind"] . csubstr($SUBJECT, 0, 100);
            $smstype = 2;
            $tablename = "email";
            sendSms($underwrite, $USER_ID[$i], $SMS_CONTENT, $sms_remind, 2, $tablename, $TABLE_ID);
        }
        $i++;
    }
}

/**
 * 限时办理的流程，超过限制的日期，向主办人和监控人员发送短信提醒办理
 */
function limitdate_flow_sms() {
    global $connection, $_lang;
    $now_date = date("Y-m-d H:i:s", time());
    $sql = "
	        SELECT fr.RUN_NAME,frp.RUN_ID,frp.PRCS_ID,frp.FLOW_PRCS,frp.USER_ID,frp.LIMIT_DATE,fr.FLOW_ID,ft.FLOW_NAME,ft.MANAGE_USER
				FROM flow_run_prcs frp,flow_run fr,flow_type ft
					WHERE frp.RUN_ID=fr.RUN_ID
					AND fr.FLOW_ID=ft.FLOW_ID
					AND frp.OP_FLAG=1
				    AND LIMIT_DATE<>'0000-00-00 00:00:00' AND  LIMIT_DATE <> NULL
			        AND PRCS_FLAG<3
					AND frp.LIMIT_DATE<'" . SecurityFilter($now_date) . "'
					AND frp.IS_REMIND=0
	       ";
    $res = exequery($connection, $sql);
    while ($row = mysql_fetch_array($res)) {
        //$_SESSION['LOGIN_USER_ID'] 7,15
        $parimary_user = $row['USER_ID']; //主办人员
        $manage_user = $row['MANAGE_USER']; //监控人员
        $flow_name = $row['FLOW_NAME'];
        $run_name = $row['RUN_NAME'];
        $run_id = $row['RUN_ID'];
        $flow_id = $row['FLOW_ID'];
        $prcs_id = $row['PRCS_ID'];
        $flow_prcs = $row['FLOW_PRCS'];
        $array_userid = explode(',', $manage_user);

        while (list($key, $var) = each($array_userid)) {
            if ($var == $_SESSION['LOGIN_USER_ID']) {
                //如果监控人员中包括登录的用户,给监控人员(用户)发送短信
                $SMS_CONTENT = $_lang["other_flow_listen"] . $run_name;
                $smstype = 15;
                $to_id = $var;
                $tablename = "flow_run";
                $TABLE_ID = $run_id;
                $SMS_REMIND = 1;
                $TABLE_VAR = "FLOW_ID,RUN_ID,PRCS_ID,FLOW_PRCS,|$flow_id,$run_id,$prcs_id,$flow_prcs,";
                sendSms("admin", $to_id, $SMS_CONTENT, $SMS_REMIND, $smstype, $tablename, $TABLE_ID, $TABLE_VAR);
                //echo $sql_sms;
                exequery($connection, $sql_sms);
                //修改状态
                $sql_run_flow = "
				                UPDATE flow_run_prcs SET IS_REMIND=1
									WHERE RUN_ID=" . SecurityFilter($row['RUN_ID']) . "
									AND USER_ID='" . SecurityFilter($row['USER_ID']) . "'
									AND PRCS_ID=" . SecurityFilter($row['PRCS_ID']) . "
				                ";
                exequery($connection, $sql_run_flow);
                break;
            }
        }

        if (isset($to_id) && $parimary_user == $to_id) {
            //监控人员中包括了主办人，主办人与登录用户为同一人
            break;
        }
        if (empty($to_id) && $parimary_user == $_SESSION['LOGIN_USER_ID']) {
            //
            $SMS_CONTENT = $_lang["flow_flowsmscontent"] . $run_name;
            $smstype = 7;
            $tablename = "flow_run";
            $to_id = $parimary_user;
            $TABLE_ID = $run_id;
            $SMS_REMIND = 1;
            $TABLE_VAR = "FLOW_ID,RUN_ID,PRCS_ID,FLOW_PRCS,|$flow_id,$run_id,$prcs_id,$flow_prcs,";
            sendSms("admin", $to_id, $SMS_CONTENT, $SMS_REMIND, $smstype, $tablename, $TABLE_ID, $TABLE_VAR);
            //修改状态
            $sql_run_flow = "
							UPDATE flow_run_prcs SET IS_REMIND=1
								WHERE RUN_ID=" . SecurityFilter($row['RUN_ID']) . "
								AND USER_ID='" .SecurityFilter( $row['USER_ID']) . "'
								AND PRCS_ID=" . SecurityFilter($row['PRCS_ID']) . "
							";
            exequery($connection, $sql_run_flow);
            break;
        }
    }
}

/**
 * 高亮显示关键字
 * @param  string $in    传入的字符串
 * @param  string $color 高亮颜色
 * @param  string $re    加粗的字体
 * @return string $out   返回高亮显示的字符串
 */
function replaceStr($in, $color, $re) {
    $out = str_replace($re, "<span style='font-weight:bold'>$re</span>", $in);
    return $out;
}

/**
 * 截取字符 xiulin.liu@weaver.com.cn 2005-11-28
 * @param  string $in     传入的字符串
 * @param  string $num    截取的位数
 * @param  string $suffix
 * @return string $restr  返回截取后的
 */
function substrGB($in, $num, $suffix = '') {
    //echo mb_strlen($in);
    if (mb_strlen($in, 'UTF-8') > $num) {
        $restr = mb_substr($in, 0, $num, 'UTF-8') . $suffix;
    } else {
        $restr = $in;
    }
    return $restr;
}

/**
 * 取出一段字符串
 * @param  string $string 传入的字符串
 * @param  string $sublen 取出长度
 * @param  string $suffix
 * @param  int $start     开始位置
 * @param  string $code   编码
 * @return string $tmpstr 返回的字符串
 */
function cutstrGU($string, $sublen, $suffix, $start = 0, $code = 'UTF-8') {
    if ($code == 'UTF-8') {
        $pa = "/[\x01-\x7f]|[\xc2-\xdf][\x80-\xbf]|\xe0[\xa0-\xbf][\x80-\xbf]|[\xe1-\xef][\x80-\xbf][\x80-\xbf]|\xf0[\x90-\xbf][\x80-\xbf][\x80-\xbf]|[\xf1-\xf7][\x80-\xbf][\x80-\xbf][\x80-\xbf]/";
        preg_match_all($pa, $string, $t_string);
        if (count($t_string[0]) - $start > $sublen) {
            return join('', array_slice($t_string[0], $start, $sublen)) . $suffix;
        }
        return join('', array_slice($t_string[0], $start, $sublen));
    } else {
        $start = $start * 2;
        $sublen = $sublen * 2;
        $strlen = strlen($string);
        $tmpstr = '';

        for ($i = 0; $i < $strlen; $i++) {
            if ($i >= $start && $i < ($start + $sublen)) {
                if (ord(substr($string, $i, 1)) > 129) {
                    $tmpstr .= substr($string, $i, 2);
                } else {
                    $tmpstr .= substr($string, $i, 1);
                }
            }
            if (ord(substr($string, $i, 1)) > 129)
                $i++;
        }
        if (strlen($tmpstr) < $strlen)
            $tmpstr .= $suffix;
        return $tmpstr;
    }
}

/**
 * 获取短信类型 xiulin.liu@weaver.com.cn 2005-11-29
 * @param  string $SMS_TYPE       短信类型
 * @return string $SMS_TYPE_NAME  返回短信类型名称
 */
function getSmstype($SMS_TYPE) {
    global $_lang;
    switch ($SMS_TYPE) {
        case "0":
            $SMS_TYPE_NAME = $_lang["common_personsms"];
            break;
        case "1":
            $SMS_TYPE_NAME = $_lang["common_noticeremind"];
            break;
        case "2":
            $SMS_TYPE_NAME = $_lang["common_mailremind"];
            break;
        case "3":
            $SMS_TYPE_NAME = $_lang["common_netmeetingremind"];
            break;
        case "4":
            $SMS_TYPE_NAME = $_lang["common_reportsalaryremind"];
            break;
        case "5":
            $SMS_TYPE_NAME = $_lang["common_dairlyremind"];
            break;
        case "6":
            $SMS_TYPE_NAME = $_lang["common_attendanceremind"];
            break;
        case "7":
            $SMS_TYPE_NAME = $_lang["common_workflowremind"];
            break;
        case "8":
            $SMS_TYPE_NAME = $_lang["common_approvalmeetapplyremind"];
            break;
        case "9":
            $SMS_TYPE_NAME = $_lang["common_vehicleapplyremind"];
            break;
        case "10":
            $SMS_TYPE_NAME = $_lang["common_approvalvehicleapplyremind"];
            break;
        case "11":
            $SMS_TYPE_NAME = $_lang["common_vehiclemaintenanceremind"];
            break;
        case "12":
            $SMS_TYPE_NAME = $_lang["common_vehicleapplyremind"];
            break;
        case "13":
            $SMS_TYPE_NAME = $_lang["common_meetapplyremind"];
            break;
        case "15":
            $SMS_TYPE_NAME = $_lang["common_overtimeflow"];
            break;
        case "16":
            $SMS_TYPE_NAME = $_lang["common_officesuppliesdealreminded"];
            break;
        case "17":
            $SMS_TYPE_NAME = $_lang["common_officesuppliesdealreminded"];
            break;
        case "18":
            $SMS_TYPE_NAME = $_lang["common_news_inspection"];
            break;
        case "19":
            $SMS_TYPE_NAME = $_lang["common_birthday_linkman"];
            break;
        case "20":
            $SMS_TYPE_NAME = $_lang['common_file_inspection'];
            break;
        case "21":
            $SMS_TYPE_NAME = $_lang['common_notify_inspection'];
            break;
        case "22":
            $SMS_TYPE_NAME = $_lang['common_news_inspection'];
            break;
        case "23":
            $SMS_TYPE_NAME = $_lang['common_system_news'];
            break;
        case "24":
            $SMS_TYPE_NAME = $_lang["common_diary_reply"];
            break;
        case "25":
            $SMS_TYPE_NAME = $_lang["common_diary_reply"];
            break;
        case "26":
            $SMS_TYPE_NAME = $_lang["common_cooperationremind"];
            break;
        case "27":
            $SMS_TYPE_NAME = $_lang["common_newsremind"];
            break;
        case "28":
            $SMS_TYPE_NAME = $_lang["common_calendar"];
            break;
        case "29":
            $SMS_TYPE_NAME = $_lang["common_contract_payment"];
            break;
        case "30":
        case "31":
            $SMS_TYPE_NAME = $_lang["common_remind_infor"];
            break;
        case "32":
            $SMS_TYPE_NAME = $_lang["common_vehicleReturnremind"];
            break;
        case "33":
            $SMS_TYPE_NAME = $_lang["common_vehicleReturnExamineremind"];
            break;
        case "34":
            $SMS_TYPE_NAME = "项目提醒";
            break;
        case "35":
            $SMS_TYPE_NAME = $_lang["common_personsms"];
            break;
        case "36":
            $SMS_TYPE_NAME = $_lang["common_contact_remind"];
            break;
        case "37":
            $SMS_TYPE_NAME = $_lang["common_task"];
            break;
        default:
            $SMS_TYPE_NAME = $_lang["common_unknowsms"];
    }
    return $SMS_TYPE_NAME;
}

/**
 * 获取内部消息的url
 * @param  string $SMS_TYPE   内部消息类型
 * @param  string $CONTENT    内部消息内容
 * @param  string $TABLE_ID   表的ID
 * @param  string $TABLE_VAR  表的值
 * @return array $ARY          返回包括url的数组
 */
function getSmstypeUrl($SMS_TYPE, $CONTENT, $TABLE_ID = "", $TABLE_VAR = "", $TABLE_NAME = "", $USER_ID = "", $SMS_ID = '') {
    global $connection, $_lang, $LOGIN_USER_ID;
    $TEXT = $_lang["common_do_it"];

    switch ($SMS_TYPE) {
        case "0":
            $URL = '/general/sms/receive/';
            $TEXT = "";
            break;
        case "1":
            $URL = '/general/notify/show/';
            if ($TABLE_ID != "") {
                $URL = '/general/notify/show/read_notify.php?NOTIFY_ID=' . $TABLE_ID . '&limit=0';
            }
            $TEXT = $_lang["common_browse_notify"];
            break;
        case "2":
            $URL = '/general/email/';
            if ($TABLE_ID != "") {
                $URL = '/general/email/email_detail.php?EMAIL_ID=' . $TABLE_ID . '&boxid=-1&toid=' . $USER_ID;
            }
            $TEXT = $_lang["common_browse_email"];
            break;
        case "3":
            $URL = '/general/netmeeting/';
            break;
        case "4":
            $URL = '/general/salary/submit?func_id=19';
            break;
        case "5":
            $URL = '/general/calendar/affair/';
            break;
        case "6":
            if (strstr($CONTENT, $_lang["common_submit"]) && strstr($CONTENT, $_lang["common_apply"]) && strstr($CONTENT, $_lang["common_pleaseinstructions"])) {
                $URL = '/general/attendance/manage/att_pass_appov.php?TABLE_NAME=' . $TABLE_NAME . '&TABLE_ID=' . $TABLE_ID;
                $TEXT = $_lang["common_do_it"];
            } else {
                $URL = '/general/attendance/personal/';
                $TEXT = $_lang["common_in_and_do"];
            }
            break;
        case "7":
            //流程是否已结束
            $TEXT = $_lang["common_browse_form"];
            if ($TABLE_ID > 0) {
                $arryflow = explode("|", $TABLE_VAR);
                $arkey = explode(",", $arryflow[0]);
                $arval = explode(",", $arryflow[1]);
                $FLOW_ID = $arval[0];
                $RUN_ID = $arval[1];
                $PRCS_ID = $arval[2];
                $FLOW_PRCS = $arval[3];

                $sqlft = "SELECT FLOW_TYPE FROM flow_type WHERE FLOW_ID=" . SecurityFilter($FLOW_ID);
                $rsft = exequery($connection, $sqlft);
                $rowft = mysql_fetch_array($rsft);
                $htmsuffix == "";
                if ($rowft['FLOW_TYPE'] == 2) {
                    $htmsuffix = "free_";
                }

                $tmpurlview = "/general/workflow/print/index.php?FLOW_ID=" . $FLOW_ID .
                        "&RUN_ID=" . $RUN_ID;
                $tmpurldo = "/general/workflow/input_form/" . $htmsuffix .
                        "input_form.php?RUN_ID=" . $RUN_ID . "&FLOW_ID=" . $FLOW_ID . "&PRCS_ID=" . $PRCS_ID .
                        "&FLOW_PRCS=" . $FLOW_PRCS;
                $sql = "SELECT RUN_ID FROM flow_run_prcs WHERE RUN_ID=" . SecurityFilter($RUN_ID) .
                        " AND PRCS_FLAG<>'4'";
                $rs = exequery($connection, $sql);
                if ($row = mysql_fetch_array($rs)) {
                    $sqlfl = "SELECT * FROM flow_run_prcs WHERE RUN_ID=" . SecurityFilter($RUN_ID) .
                            "  AND USER_ID='" . SecurityFilter($USER_ID) .
                            "' ORDER BY PRCS_ID DESC LIMIT 1";
                    $rsfl = exequery($connection, $sqlfl);
                    if ($rowfl = mysql_fetch_array($rsfl)) {
                        //主办人是否办理结束
                        if ($rowfl['OP_FLAG'] == 1) {
                            if ($rowfl['PRCS_FLAG'] == 4 || $rowfl['PRCS_FLAG'] == 3) {
                                $URL = $tmpurlview;
                            } else {
                                $TEXT = $_lang["common_do_workflow"];
                                $URL = "/general/workflow/input_form/" . $htmsuffix . "input_form.php?RUN_ID=" .
                                        $RUN_ID . "&FLOW_ID=" . $FLOW_ID . "&PRCS_ID=" . $rowfl['PRCS_ID'] .
                                        "&FLOW_PRCS=" . $rowfl['FLOW_PRCS'] . "&OP_FLAG=" . $rowfl['OP_FLAG'];
                            }
                        }
                        //经办人是否办理结束
                        else {
                            $sql = "(SELECT SAVEFORM_TIME,PRCS_ID,PRCS_TIME FROM flow_run_prcs WHERE RUN_ID = '". SecurityFilter($RUN_ID) .
                                    "' AND USER_ID = '". SecurityFilter($USER_ID) .
                                    "' AND PRCS_TIME IS NULL)
                                    UNION
                                    (SELECT SAVEFORM_TIME,PRCS_ID,PRCS_TIME FROM flow_run_prcs
                                    WHERE RUN_ID = '". SecurityFilter($RUN_ID) .
                                    "' AND user_id = '". SecurityFilter($USER_ID) .
                                    "' AND PRCS_TIME IS NOT NULL
                                    ORDER BY PRCS_ID DESC,PRCS_TIME DESC
                                    LIMIT 0,1)
                                    LIMIT 0,1";
                            $rsfrp = exequery($connection,$sql);
                            if ($rowfrp = mysql_fetch_array($rsfrp)){
                                if($rowfrp['SAVEFORM_TIME'] == null){
                                $TEXT = $_lang["common_do_workflow"];
                                    $URL = "/general/workflow/input_form/" . $htmsuffix . "input_form.php?RUN_ID=" .
                                            $RUN_ID . "&FLOW_ID=" . $FLOW_ID . "&PRCS_ID=" . $rowfl['PRCS_ID'] .
                                            "&FLOW_PRCS=" . $rowfl['FLOW_PRCS'] . "&OP_FLAG=" . $rowfl['OP_FLAG'];
                                }else{
                                    $URL = $tmpurlview;
                                }
                            }
                            // if ($rowfl['SAVEFORM_TIME'] == null) {
                            //     $TEXT = $_lang["common_do_workflow"];
                            //     $URL = "/general/workflow/input_form/" . $htmsuffix . "input_form.php?RUN_ID=" .
                            //             $RUN_ID . "&FLOW_ID=" . $FLOW_ID . "&PRCS_ID=" . $rowfl['PRCS_ID'] .
                            //             "&FLOW_PRCS=" . $rowfl['FLOW_PRCS'] . "&OP_FLAG=" . $rowfl['OP_FLAG'];
                            // } else {
                            //     $URL = $tmpurlview;
                            // }
                        }
                    } else {
                        //查询当前的run-id,如果BY_AGENT_ID存在
                        $sqlf2 = "SELECT * FROM flow_run_prcs WHERE RUN_ID=" . SecurityFilter($RUN_ID) .
                                "  AND BY_AGENT_ID='" . SecurityFilter($USER_ID) .
                                "' ORDER BY PRCS_ID DESC LIMIT 1";
                        $rsf2 = exequery($connection, $sqlf2);
                        if ($rowf2 = mysql_fetch_assoc($rsf2)) {
                            $URL = $tmpurlview;
                            $TEXT = $_lang["common_to_workflow"];
                        } else {
                            // 抄送流程判断
                            $sqlf3 = "SELECT * FROM flow_copy WHERE RUN_ID=" . SecurityFilter($RUN_ID) .
                                    "  AND BY_USER_ID='" . SecurityFilter($USER_ID) .
                                    "' ORDER BY PRCS_ID DESC LIMIT 1";
                            $rsf3 = exequery($connection, $sqlf3);
                            if ($rowf3 = mysql_fetch_assoc($rsf3)) {
                                $URL = $tmpurlview;
                            } else {
                                $URL = "";
                                $TEXT = $_lang["common_to_workflow_remove"];
                            }
                        }
                    }
                }
                //流程已结束
                else {
                    $URL = $tmpurlview;
                    //有短信提醒,且流程办理完了,但是没有查看权限,判断为被转移了
                    if (!run_role($RUN_ID, 0)) {
                        $URL = "/general/workflow/print/index.php?FLOW_ID=" . $FLOW_ID . "&RUN_ID=" . $RUN_ID;
                        $TEXT = $_lang["common_to_workflow"];
                    } else {
                        $sqlf = "SELECT * FROM flow_run_prcs WHERE RUN_ID=" . SecurityFilter($RUN_ID) .
                                "  AND USER_ID='" . SecurityFilter($USER_ID) .
                                "' ORDER BY PRCS_ID DESC LIMIT 1";
                        $rsf = exequery($connection, $sqlf);
                        if ($rowf = mysql_fetch_array($rsf)) {
                            if ($rowf['OP_FLAG'] != 1 && $rowf['SAVEFORM_TIME'] == null) {
                                $TEXT = $_lang["common_do_workflow"];
                                $URL = "/general/workflow/input_form/" . $htmsuffix . "input_form.php?RUN_ID=" .
                                        $RUN_ID . "&FLOW_ID=" . $FLOW_ID . "&PRCS_ID=" . $rowf['PRCS_ID'] .
                                        "&FLOW_PRCS=" . $rowf['FLOW_PRCS'] . "&OP_FLAG=" . $rowf['OP_FLAG'];
                            }
                        }
                    }
                }
            } else {
                $URL = '/general/workflow/';
            }
            break;
        case "8":
            $URL = '/general/meetings/myapply/index.php?apply_id=' . $TABLE_ID;
            $TEXT = $_lang["common_check_message"];
            break;
        case "9":
            $URL = '/general/vehicles/examine.php?apply_id=' . $TABLE_ID;
            $TEXT = $_lang["common_do_it"];
            break;
        case "10":
            $URL = '/general/vehicles/show_single.php?apply_id=' . $TABLE_ID;
            $TEXT = $_lang["common_check_apply_message"];
            break;
        case "11":
            $URL = '/general/sms/detail.php?SMS_ID='.$SMS_ID . '&TABLE_NAME=' . $TABLE_NAME . '&TABLE_ID=' . $TABLE_ID;
            break;
        case "12":
            $URL = '/general/vehicles/manage/show_read.php?car_id=' . $TABLE_ID . '&diff=homepage';
            // $URL = '/general/vehicles/show.php?apply_id='.$TABLE_ID;
            $TEXT = $_lang["common_check_message"];
            break;
        case "13":
            $URL = '/general/meetings/examine/index.php?apply_id=' . $TABLE_ID;
            $TEXT = $_lang["common_do_it"];
            break;
        case "15":
            $URL = '/general/workflow/manage.php';
            break;
        case "16":
            $URL = '/general/officeitem/takemanage/index.php?id';
            $TEXT = $_lang["common_in_and_do"];
            break;
        case "17":
            $URL = '/general/officeitem/take/index.php?id';
            $TEXT = $_lang["common_in_and_do"];
            break;
        case "18":
            $URL = '/general/inspection/approval.php?NEWS_ID=' . $TABLE_ID;
            $TEXT = $_lang["common_view_news"];
            break;
        case "19":
            $URL = '/general/crm/linkman/index.php?lid=1';
            $TEXT = $_lang["common_list_linkman"];
            break;
        case "20":
            $URL = '/general/file_folder/file_new/read.php?CONTENT_ID=' . $TABLE_ID;
            $TEXT = $_lang["common_check_file"];
            break;
        case "21":
            $URL = '/general/inspection/approval_notify.php?notify_id=' . $TABLE_ID;
            $TEXT = $_lang["common_inspection_notify"];
            break;
        case "22":
            $URL = '/general/news/show/read_news.php?NEWS_ID=' . $TABLE_ID;
            $TEXT = $_lang["common_read_news"];
            break;
        case "23":
            $URL = '/general/sms/receive/';
            $TEXT = "";
            break;
        case "24":
            $URL = '/general/diary/index.php?diaryid=' . $TABLE_ID;
            $TEXT = $_lang["common_in_and_do"];
            break;
        case "25":
            $URL = '/general/diary/info/index.php?diaryid=' . $TABLE_ID;
            $TEXT = $_lang["common_in_and_do"];
            break;
        case "26":
            $URL = '/general/cooperation/coop_view/index.php?theme_id=' . $TABLE_ID;
            $TEXT = $_lang["common_in_and_do"];
            break;
        case "27":
            $URL = '/general/news/show/';
            if ($TABLE_ID != "") {
                $URL = '/general/news/show/read_news.php?NEWS_ID=' . $TABLE_ID . '&limit=0';
            }
            $TEXT = $_lang["common_check_news"];
            break;
        case "28":
            $URL = '/general/calendar9/calendar/show.php?dataId=' . $TABLE_ID . "&checkDiff=remind&";
            $TEXT = $_lang["common_check_schedule"];
            break;
        case "29":
            $URL = '/general/crm/customer/contract_detail.php?CON_ID=' . $TABLE_ID;
            $TEXT = $_lang["common_check_contract"];
            break;

        //工作微博的提醒方式不需要操作
        case "30":
        case "31":
            $URL = '';
            $TEXT = '';
            break;
        case "32":
            $URL = '/general/vehicles/examine.php?apply_id=' . $TABLE_ID;
            $TEXT = $_lang["common_do_it"];
            break;
        case "33":
            $URL = '/general/vehicles/show_single.php?apply_id=' . $TABLE_ID;
            $TEXT = $_lang["common_check_apply_message"];
            break;
        case "34":
            $URL = '/general/project/myproject/quesRemindshow.php?data_id=' . $TABLE_ID . "&other";
            $TEXT = "进入办理";
            break;
        case "35":
            $URL = '/general/crm/customer/new/detail/index.php?CUSTOMER_ID=' . $TABLE_ID . "&come=1";
            $TEXT = $_lang["common_check_detail"];
            break;
        case "36":
            if($TABLE_ID>0){
                $sql = "SELECT IS_HANDLE FROM relation_remind where REMIND_ID = '" . SecurityFilter($TABLE_ID) . "'";
                $cursor = exequery($connection, $sql);
                $row = mysql_fetch_array($cursor);
                $IS_HANDLE = $row['IS_HANDLE'];
                if($IS_HANDLE == '0'){
                    $arrySms = explode("|", $TABLE_VAR);
                    $arkey = explode(",", $arrySms[0]);
                    $arval = explode(",", $arrySms[1]);
                    $REMIND_ID = $arval[0];
                    $CUSTOMER_ID = $arval[1];
                    $SMS_ID = $arval[2];
                    $LINKMAN_ID = $arval[4];
                    $REMIND_TYPE = $arval[3];
                    $URL = "/general/crm/customer/new/record/record_new.php?openflag=1&remind_id=".$REMIND_ID."&customerID=".$CUSTOMER_ID."&sms_id=".$SMS_ID."&linkman_id=".$LINKMAN_ID."&remind_type=".$REMIND_TYPE."";
                    $TEXT = $_lang["common_do_it"];
                }
            }
            break;
        case "37":
            $URL = "/general/task/mytask/index.php?func_id=531";
            break;
    }
    $ARY['TEXT'] = $TEXT;
    $ARY['URL'] = $URL;
    return $ARY;
}

/**
 * 根据情况修改了ATTACHMENT值，yangjun@weaver.com.cn 2006.7.6
 * @param  string $ATTACHMENT        附件文件
 * @param  string $ATTACHMENT_NAME   附件文件名
 * @param  string $logo
 * @return
 */
function upload_template_logo($ATTACHMENT, $ATTACHMENT_NAME, $logo) {
    global $file_err, $_lang;
    $chmod = 0755;

    if ($logo == "2") {
        $mMarkName = $_POST["ATTACHMENT2"];
        $mMarkFile = $_FILES['ATTACHMENT2']['name'];
        $mMarkSize = $_FILES['ATTACHMENT2']['size'];
        $filetype = $_FILES['ATTACHMENT2']['type'];
        $file_tmp = $_FILES['ATTACHMENT2']['tmp_name'];
        $file_err = $_FILES['ATTACHMENT2']['error'];
    } elseif ($logo == "1") {
        $mMarkName = $_POST["ATTACHMENT"];
        $mMarkFile = $_FILES['ATTACHMENT']['name'];
        $mMarkSize = $_FILES['ATTACHMENT']['size'];
        $filetype = $_FILES['ATTACHMENT']['type'];
        $file_tmp = $_FILES['ATTACHMENT']['tmp_name'];
        $file_err = $_FILES['ATTACHMENT']['error'];
    } else {
        $mMarkName = $_POST["ATTACHMENT"];
        $mMarkFile = $_FILES['ATTACHMENT']['name'];
        $mMarkSize = $_FILES['ATTACHMENT']['size'];
        $filetype = $_FILES['ATTACHMENT']['type'];
        $file_tmp = $_FILES['ATTACHMENT']['tmp_name'];
        $file_err = $_FILES['ATTACHMENT']['error'];
    }

    $mMarkType = strrchr($mMarkFile, '.'); //取得后缀
    $mFilePath = $_SERVER["DOCUMENT_ROOT"] . "attachment/theme/" . $logo;

    if (($file_err == 0) && ($mMarkSize != 0)) {

        // Check extension.
        if (!$mMarkType) {
            unlink($file_tmp);
            die($_lang["common_fileneedextension"]);
        }

        // extra check to prevent file attacks.
        if (is_uploaded_file($file_tmp)) {
            /*
             * check if the directory exists
             * if it doesnt exist, make the directory
             */
            if (!file_exists($mFilePath))
                mkdir($mFilePath, 0700);
            $filename = "logo" . $mMarkType;


            if (@move_uploaded_file($file_tmp, $mFilePath . '/' . $filename)) {

            } else {
                // error moving file. check file permissions.
                unlink($file_tmp);
                echo '<strong>Error:</strong> Unable to move file to designated directory.';
            }
        } else {
            // file seems suspicious... delete file and error out.
            unlink($file_tmp);
            echo '<strong>Error:</strong> File does not appear to be a valid upload. Could be a file attack.';
        }
    } else {
        // Kill temp file, if any, and display error.
        if ($file_tmp != '') {
            unlink($file_tmp);
        }
    }
    $FILENAME = $mFilePath . "/" . $filename;
    if (!file_exists($FILENAME)) {
        Message($_lang["common_uploaderror"], $_lang["common_reason"] . "：" . $_lang["common_uploaderror3"]);
        Button_Back();
        exit;
    }
    return $logo;
}

/**
 * 检查是否有主页发布的调查表,如果是已经调查过的，也不弹出,需要在发布部门范围内
 */
function input_survey() {
    global $HTTP_COOKIE_VARS, $connection, $USER_FUNC_ID_STR;
    $LOGIN_DEPT_ID = $_SESSION['LOGIN_DEPT_ID'];
    $LOGIN_USER_PRIV = $_SESSION['LOGIN_USER_PRIV'];
    $LOGIN_USER_ID = $_SESSION['LOGIN_USER_ID'];
    $vote_flag = isThisPri($_SESSION['LOGIN_FUNC_STR'], '250');

    //如果没有投票调查权限
    if (!$vote_flag)
        return;
    else {
        $dataNow = date("Y-m-d H:i:s", time());
        $query = "
				SELECT SID from phpqsurvey
					where Active='y'
					AND ((StartDate<='$dataNow' AND EndDate>='".SecurityFilter($dataNow)."' )
						  OR
						 (StartDate<='".SecurityFilter($dataNow)."' and UNIX_TIMESTAMP(EndDate)= 0))
					AND((DEPT_ID='DEPT_ALL')
						 OR
						(INStr(DEPT_ID,',".SecurityFilter($LOGIN_DEPT_ID).",')>0 or INStr(DEPT_ID,'".SecurityFilter($LOGIN_DEPT_ID).",')=1)
						 OR
						(INStr(PRIV_ID,',".SecurityFilter($LOGIN_USER_PRIV).",')>0 or INStr(PRIV_ID,'".SecurityFilter($LOGIN_USER_PRIV).",')=1)
						 OR
						(InStr(USER_ID,'".SecurityFilter($LOGIN_USER_ID).",')>0 or INStr(PRIV_ID,',".SecurityFilter($LOGIN_USER_ID).",')=1))
					AND AdvanceInterface='y' order by AddDate
			";
        $cursor = exequery($connection, $query);
        while ($ROW = mysql_fetch_array($cursor)) {
            $SID = $ROW['SID'];
            if ($SID != '') {
                $sql = "
					     SELECT COUNT(*) AS CNT FROM phpqlog WHERE SID = ".SecurityFilter($SID)." AND USER_ID = '" .
                        SecurityFilter($LOGIN_USER_ID) . "'
						";
                $cur = exequery($connection, $sql);
                $ROW = mysql_fetch_array($cur);
                $cnt = $ROW['CNT'];
                if ($cnt != 0) {
                    continue;
                } else {
                    return $SID;
                    break;
                }
            }
        }
    }
}

/**
 * 信息发送权限
 * @param  string $str       区别判断：email、message、mobile;默认为mobile
 * @return string $reValue   返回true：有权限，false：无权限
 */
function ifSendMbSms($diff = 'mobile') {
    global $USER_FUNC_ID_STR;
    if ($diff == 'mobile') {
        $pri = 255;
    } else if ($diff == 'message') {
        $pri = 13;
    } else if ($diff == 'email') {
        $pri = 12;
    }
    $instr = $USER_FUNC_ID_STR;
    $inArray = explode(',', $instr);
    $reValue = false;
    while (list($key, $var) = each($inArray)) {
        if ($var == $pri) {
            $reValue = true;
            break;
        }
    }
    return $reValue;
}

//检查是否开通手机短信
function CheckMobilePriv() {
    global $connection;
    $query = "SELECT COUNT(*) AS CNT FROM menu_lang WHERE FUNC_ID = 257";
    $result = exequery($connection, $query);
    if ($row = mysql_fetch_array($result)) {
        if ($row["CNT"] == 0) {
            return false;
        } else {
            return true;
        }
    } else {
        return false;
    }
}

/**
 * 转换成HTML
 * @param  string $str    传入的字符串
 * @return string $sTemp  返回转换称HTML后的
 */
function inHTML($str) {
    if (!isset($str))
        return "";
    $sTemp = str_replace("&amp;", "&", $str);
    $sTemp = str_replace("&lt;", "<", $sTemp);
    $sTemp = str_replace("&gt;", ">", $sTemp);
    $sTemp = str_replace("&quot;", chr(34), $sTemp);
    return ($sTemp);
}

/**
 * 文件类型图片路径
 * @param  string $sFileName          传入的文件名
 * @return string $icondir.$sPicName  返回的文件类型图片路径
 */
function getFileSuffixIcon($sFileName) {
    $icondir = "/images/icon/filetype/";
    $sFileName = strtolower($sFileName);
    preg_match("/\.([a-zA-Z]{2,4})$/", $sFileName, $sExt);
    $fullName = $icondir . $sExt[1] . ".png";
    if (!file_exists(ROOT_PATH . $fullName)) {
        return $icondir . "unknown.png";
    } else {
        return $fullName;
    }
}

/**
 * 文件类型图片路径
 * @param  string $sFileName         传入的文件名
 * @return string $icondir.$sPicName 返回的文件类型的图片路径
 */
function getFileSuffixIcon32($sFileName) {
    $icondir = "/images/icon/filetype3232/";
    $sFileName = strtolower($sFileName);
    preg_match("/\.([a-zA-Z]{2,4})$/", $sFileName, $sExt);

    $fullName = $icondir . $sExt[1] . ".png";
    if (!file_exists(ROOT_PATH . $fullName)) {
        return $icondir . "unknown.png";
    } else {
        return $fullName;
    }
}

/**
 * 获得文件类型
 * @param  string $sFileName    传入的文件名
 * @return strtolower($sExt[1]) 返回获取的文件类型
 */
function getFileSuffix($sFileName) {
    $sFileName = strtolower($sFileName);
    preg_match("/\.([a-zA-Z]{2,4})$/", $sFileName, $sExt);
    return strtolower($sExt[1]);
}

/**
 * 是否是office文件
 * @param  string $fileName  传入的文件名
 * @return bool true/false   返回true表示是office文件，返回false表示不是office文件
 */
function isOfficeOfFile($fileName) {
    $fileName = strtolower($fileName);
    preg_match("/\.([a-zA-Z]{2,4})$/", $fileName, $sExt);
    $suffix = strtolower($sExt[1]);
    $of_expression = ",doc,docx,docm,dotx,dotm,dot,wpt,xls,xlsx,xlsm,xlsb,csv,ppt,pps,pptx,ppsm,ppsx";
    if (strpos($of_expression, "," . $suffix . ",") === false) {
        return false;
    }
    return true;
}

/**
 * 是否是图片文件
 * @param  string $fileName   传入的文件名
 * @return bool true/false    返回true表示是图片文件，返回false表示不是图片文件
 */
function isPicOfFile($fileName) {
    $fileName = strtolower($fileName);
    preg_match("/\.([a-zA-Z]{2,4})$/", $fileName, $sExt);
    $suffix = strtolower($sExt[1]);
    $pc_expression = ",jpeg,jpg,bmp,png,gif,";
    if (strpos($pc_expression, "," . $suffix . ",") === false) {
        return false;
    }
    return true;
}

/**
 * 是否有此权限
 * @param  string $func_priview_str 功能的字符串
 * @param  string $priview          权限
 * @return bool true/false          返回true表示有权限，返回false表示没有权限
 * //被注释掉代码为函数源代码，最后一行，和第四行也是
 */
function isThisPri($func_priview_str, $priview) {
    //$str_array = explode(',',$func_priview_str);
    $func_priview_str = "," . $func_priview_str . ",";
    //array_pop($str_array);
    $s_array = explode(',', $priview);

    foreach ($s_array as $pri) {
        $pattern = "," . $pri . ",";
        $result = strpos($func_priview_str, $pattern);
        if ($result !== false) {
            return true;
        }
    }
    //for($i=0; $i<sizeof($str_array); $i++){
    //if(in_array($s_array[0], $str_array) && $s_array[0] != "")
    //return true;
    //}
    return false;
}

/**
 * 系统菜单路径相同的func_id
 * @param string $func_id 传入的系统菜单的func_id唯一ID
 * @return string $FUNC_ID 返回与传入的func_id路径相同的func_id的值
 */
function isMenuPri($func_id) {
    global $connection;
    $sql = "SELECT * FROM sys_function WHERE FUNC_ID='".SecurityFilter($func_id)."'";
    $rs = exequery($connection, $sql);
    $row = mysql_fetch_array($rs);
    if ($row) {
        $FUNC_CODE = $row["FUNC_CODE"];
    }
    unset($sql);
    unset($rs);
    if ($FUNC_CODE != '@') {
        $query = "SELECT * FROM sys_function WHERE FUNC_CODE='".SecurityFilter($FUNC_CODE)."'";
        $rs = exequery($connection, $query);
        $FUNC_ID = "";
        while ($ROW = mysql_fetch_array($rs)) {
            $FUNC_ID .= "," . $ROW["FUNC_ID"];
        }
        return $FUNC_ID;
    }
}

/**
 * 多userid转换为username lxl 2006-11-6
 * @param  string $struserid 传入的多个用户ID
 * @return $strusername      返回的是转换好的多个用户名
 */
function getUsernameStr($struserid, $field = "USER_NAME") {
    global $connection;
    if ($struserid == "") {
        $usernamestr = "";
    } else {
        if (substr($struserid, -1, 1) == ",") {
            $struserid = substr($struserid, 0, strlen($struserid) - 1);
        }
        $sql_order = " ORDER BY find_in_set( USER_ID , '" . SecurityFilter($struserid) . "') ";
        $struserid = "'" . str_replace(",", "','", $struserid) . "'";

        $sql = "SELECT " . $field . " FROM user WHERE USER_ID IN (" . SecurityFilter($struserid) . ")";
        $sql .= $sql_order;
        $rs = exequery($connection, $sql);
        $uaccount = 0;
        $strusername = '';
        if (strpos($field, ",")) {
            while ($row = mysql_fetch_array($rs)) {
                if (!empty($row))
                    $strusername[] = $row;
            }
        }else {
            while ($row = mysql_fetch_array($rs)) {
                $uaccount++;
                $user_name = $row['USER_NAME'];
                $strusername .= $user_name . ",";
            }
        }
    }
    return $strusername;
}

/**
 * 多USER_PRIV转换为PRIV_NAMElxl 2006-11-6
 * @param  string $strpriv     传入的多个角色ID
 * @return string $strprivname 返回的转换好的角色名
 */
function getPrivStr($strpriv) {
    global $connection;
    if ($strpriv == "") {
        $strprivname = "";
    } else {
        if (substr($strpriv, -1, 1) == ",") {
            $strpriv = substr($strpriv, 0, strlen($strpriv) - 1);
        }
        $sql_order = " ORDER BY find_in_set( USER_PRIV , '" . SecurityFilter($strpriv) . "') ";
        $strpriv = "'" . str_replace(",", "','", $strpriv) . "'";

        $sql = "SELECT PRIV_NAME FROM user_priv WHERE USER_PRIV IN (" . SecurityFilter($strpriv) . ")";
        $sql .= $sql_order;
        $rs = exequery($connection, $sql);
        $uaccount = 0;
        while ($row = mysql_fetch_array($rs)) {
            $uaccount++;
            $priv_name = $row['PRIV_NAME'];
            $strprivname .= $priv_name . ",";
        }
    }
    return $strprivname;
}

/**
 * 多DEPT_ID转换为DEPT_NAME lxl 2006-11-6
 * @param  string $strdeptid    传入的多个部门ID
 * @return string $strdeptname  返回转换后的部门名称
 */
function getDeptStr($strdeptid) {
    global $connection;
    if ($strdeptid == "") {
        $strdeptname = "";
    } else {
        if (substr($strdeptid, -1, 1) == ",") {
            $strdeptid = substr($strdeptid, 0, strlen($strdeptid) - 1);
        }
        $sql_order = " ORDER BY find_in_set( DEPT_ID , '" . SecurityFilter($strdeptid) . "') ";
        $strdeptid = "'" . str_replace(",", "','", $strdeptid) . "'";

        $sql = "SELECT DEPT_NAME FROM department WHERE DEPT_ID IN (" . SecurityFilter($strdeptid) . ")";
        $sql .= $sql_order;
        $rs = exequery($connection, $sql);
        $uaccount = 0;
        while ($row = mysql_fetch_array($rs)) {
            $uaccount++;
            $dept_name = $row['DEPT_NAME'];
            $strdeptname .= $dept_name . ",";
        }
    }
    $strdeptname = trim($strdeptname, ",");
    return $strdeptname;
}

/**
 * 多用户角色Id转换为用户角色名称显示
 * @param  string struserpriv
 * @return string struserprivname
 */
function getUserPrivStr($struserpriv) {
    global $connection;
    if ($struserpriv == "") {
        $struserprivname = "";
    } else {
        if (substr($struserpriv, -1, 1) == ",") {
            $struserpriv = substr($struserpriv, 0, strlen($struserpriv) - 1);
        }
        $sql_order = " ORDER BY find_in_set( USER_PRIV , '" . SecurityFilter($struserpriv) . "') ";
        $struserpriv = "'" . str_replace(",", "','", $struserpriv) . "'";

        $sql = "SELECT PRIV_NAME FROM user_priv WHERE USER_PRIV IN (" . SecurityFilter($struserpriv) . ")";
        $sql .= $sql_order;
        $rs = exequery($connection, $sql);
        $uaccount = 0;
        while ($row = mysql_fetch_array($rs)) {
            $uaccount++;
            $priv_name = $row['PRIV_NAME'];
            $struserprivname .= $priv_name . ",";
        }
    }
    $struserprivname = trim($struserprivname, ",");
    return $struserprivname;
}

/**
 * 解析多参数
 * @param  string $enpar   传入的字符串
 * @return array $rearr    返回经过解析多参数后的数组
 */
function explodeStPar($enpar) {
    $depar = base64_decode($enpar);
    $arrpar = explode("|", $depar);
    if (!is_array($arrpar)) {
        return false;
    }
    for ($i = 0; $i < sizeof($arrpar); $i++) {
        $strpar = $arrpar[$i];
        $tmparr = explode(':', $strpar);
        for ($j = 0; $j < sizeof($tmparr); $j++) {
            if ($j == 0) {
                preg_match("/\[([a-z0-9-_].+)\]/i", $tmparr[$j], $exp);
                $par = $exp[1];
            } else {
                preg_match("/\[(.*)\]/i", $tmparr[$j], $exp);
                $val = $exp[1];
            }
        }
        if (trim($par) != "") {
            $rearr[$par] = $val;
        }
    }
    return $rearr;
}

/**
 * en多参数
 * @param  string $dearray  传入的数组
 * @return array  返回经过MIME base64编码的数组
 */
function implodeStPar($dearray) {
    if (!is_array($dearray)) {
        return false;
    }
    $enpar = "";
    while (list($key, $var) = each($dearray)) {
        $enpar .= "[" . $key . "]:[" . $var . "]|";
    }
    return str_replace("+", "%2B", base64_encode($enpar));
}

/**
 * 解析js中的escape
 * @param  string $str
 * @return string join("",$ar)
 */
function unescape($str) {
    $str = rawurldecode($str);
    preg_match_all("/%u.{4}|&#x.{4};|&#d+;|&#d+?|.+/U", $str, $r);
    $ar = $r[0];
    foreach ($ar as $k => $v) {
        if (substr($v, 0, 2) == "%u")
            $ar[$k] = iconv("UCS-2", "GBK", pack("H4", substr($v, -4)));
        elseif (substr($v, 0, 3) == "&#x")
            $ar[$k] = iconv("UCS-2", "GBK", pack("H4", substr($v, 3, -1)));
        elseif (substr($v, 0, 2) == "&#") {
            $ar[$k] = iconv("UCS-2", "GBK", pack("n", preg_replace("/[^d]/", "", $v)));
        }
    }
    return join("", $ar);
}

/**
 * 记录日志
 * @param string $SEQ_ID
 * @param string $OPERATION_TYPE
 * @param string $TABLE_NAME
 * @param string $ACCOUNT_LOG
 */
function saveSysOpLog($SEQ_ID, $OPERATION_TYPE, $TABLE_NAME, $ACCOUNT_LOG, $userid = "") {
    global $connection;
    $RECORD_TIME = date("Y-m-d H:i:s", time());
    if ($ACCOUNT_LOG == 'flow_log') {
        $user_id = "";
    } else {
        if ($userid != "") {
            $user_id = $userid;
        } else {
            $user_id = $_SESSION['LOGIN_USER_ID'];
        }
    }
    $IP = getenv("REMOTE_ADDR");
    $query = "
			INSERT INTO `sys_op_log` (`SEQ_ID`,`USER_ID`,`OPERATION_DATE`,`OPERATION_TYPE`,`TABLE_NAME` ,`ACCOUNT_LOG`,`IP`)VALUES
			('".SecurityFilter($SEQ_ID)."', '".SecurityFilter($user_id)."', '".SecurityFilter($RECORD_TIME)."', '".SecurityFilter($OPERATION_TYPE)."', '".SecurityFilter($TABLE_NAME)."', '".SecurityFilter($ACCOUNT_LOG)."','".SecurityFilter($IP)."')
			";
    $cursor = exequery($connection, $query);
    $LOG_ID = mysql_insert_id();
    return $LOG_ID;
}

/*
 * 获取用户头像图片类型
 */

function getUserAvatarType($user_id) {
    global $connection;
    $query = "
			SELECT AVATAR_TYPE FROM `user`  WHERE USER_ID = '" . SecurityFilter($user_id) . "'
			";
    $rc = exequery($connection, $query);
    $row = mysql_fetch_array($rc);
    $avatarType = $row[0];
    return $avatarType;
}

/**
 * 用户ID转换
 * @param  string $user_id    传入的用户的ID
 * @return string $user_name  返回的用户名
 */
function getUserNameNew($user_id) { //用户ID转换为用户名
    global $connection;
    $user_spit = substr($user_id, 0, -1);
    $array_id = explode(",", $user_spit);
    if (count($array_id) == 1) {
        $query = "
			SELECT USER_NAME FROM `user`  WHERE USER_ID = '" . SecurityFilter($user_id) . "'
			";
        $rc = exequery($connection, $query);
        $row = mysql_fetch_array($rc);
        $user_name = $row[0];
        return $user_name;
    }
    if (count($array_id) > 1) { //多个用户ID转换
        for ($i = 0; $i < count($array_id); $i++) {
            $query = "
				SELECT USER_NAME FROM `user`  WHERE USER_ID = '" . SecurityFilter($array_id[$i]) . "'
				";
            $rc = exequery($connection, $query);
            $row = mysql_fetch_array($rc);
            $user_name .= "&nbsp;";
            $user_name .= $row['USER_NAME'];
        }
        return $user_name;
    }
}

function getUserId($username) {
    global $connection;
    //$user_spit = substr($username, 0, -1);
    //$array_name = explode(",", $user_spit);
    //if (count($array_name) == 1) {
    $query = "
            SELECT USER_ID FROM `user`  WHERE USER_NAME LIKE '%" . SecurityFilter($username) . "%'
            ";
    $rc = exequery($connection, $query);
    $user_id .= ",";
    while ($row = mysql_fetch_array($rc)) {
        $user_id .= $row['USER_ID'];
    }
    $user_id = substr($user_id, 1, strlen($user_id));
    return $user_id;
    // }
    // if (count($array_id) > 1) //多个用户ID转换
    //     {
    //     for ($i = 0; $i < count($array_id); $i++) {
    //         $query = "
    //             SELECT USER_ID FROM `user`  WHERE USER_NAME LIKE '%" . $array_name[$i] . "%'
    //             ";
    //         $rc = exequery($connection, $query);
    //         $row = mysql_fetch_array($rc);
    //         $user_id .= ",";
    //         $user_id .= $row['USER_ID'];
    //     }
    //      $user_id=substr($user_id,1,strlen($user_id));
    //     return $user_id;
    // }
}

/**
 * 转换编码
 * @param  string $string    传入的字符串
 * @param  string $type      转换的编码类型
 * @return string            返回经过编码转换后的字符串
 */
function getTypeString($string, $type) {
    $encoding = mb_detect_encoding($string, array('ASCII', 'UTF-8', 'GB2312', 'GBK',
        'BIG5'));
    return iconv($encoding, $type, $string);
    //return mb_convert_encoding($string, 'utf-8', $encoding);
}

/**
 * 获取部门名称
 * @param  string $dept_id   传入的部门ID
 * @return string $dept_name 返回的部门名称
 */
function getDeptName($dept_id) {
    $connection = OpenConnection();
    $dept_query = "SELECT DEPT_NAME FROM department WHERE DEPT_ID = '" . SecurityFilter($dept_id) .
            "' ";
    $dept_rs = exequery($connection, $dept_query);
    if ($dept_rs) {
        $dept_rows = mysql_fetch_array($dept_rs);
        $dept_name = $dept_rows["DEPT_NAME"];
    }
    return $dept_name;
}

/**
 * 根据档案的的id得到档案姓名
 * @param  string $hr_id     传入的档案的ID
 * @return string $hr_user_name 返回的档案的姓名
 */
function getHrUserName($hr_id) {
    $connection = OpenConnection();
    $query = "SELECT TRUE_NAME FROM hrms WHERE ID = '" . SecurityFilter($hr_id) . "'";
    $rs = exequery($connection, $query);
    if ($rows = mysql_fetch_array($rs)) {
        $hr_user_name = $rows["TRUE_NAME"];
    }
    return $hr_user_name;
}

/**
 * 根据部门的id(DEPT_ID)得到它的所有下级部门的id字符串
 * @param  string $dept_id     传入的部门的ID
 * @return string $dept_id_str 返回的是部门ID所有下级部门的ID字符串
 */
function getSubDeptIdStr($dept_id) {
    $connection = OpenConnection();
    $query = "SELECT DEPT_ID FROM department WHERE DEPT_PARENT = '" . SecurityFilter($dept_id) . "'";
    $rs = exequery($connection, $query);
    while ($rows = mysql_fetch_array($rs)) {
        $dept_id_str .= $rows["DEPT_ID"] . ",";
        $dept_id_str .= getSubDeptIdStr($rows["DEPT_ID"]);
    }
    return $dept_id_str;
}

/**
 * 获取名称
 * @param  string $FROM_ID     传入的sql中限制条件的ID
 * @param  string $GETNAME     传入的sql语句搜索字段
 * @param  string $GET_ID      sql语句的约束条件
 * @param  string $FROM_TYPE   传入的表名
 * @return string $GETSHOWNAME 返回获取的值
 */
function getNameFromId($FROM_ID, $GETNAME, $GET_ID, $FROM_TYPE) {
    $GETNAME = SecurityFilter($GETNAME);
    $FROM_ID = SecurityFilter($FROM_ID);
    $GET_ID = SecurityFilter($GET_ID);
    $FROM_TYPE = SecurityFilter($FROM_TYPE);
    $connection = OpenConnection();
    $THISID = trim($FROM_ID, ",");
    $THISID = "'" . $THISID . "'";
    $THISID = str_replace(",", "','", $THISID);
    $sql_name = "SELECT {$GETNAME} FROM {$FROM_TYPE} WHERE {$GET_ID} IN($THISID)";

    // $sql_name = "SELECT {".SecurityFilter($GETNAME)."} FROM {".SecurityFilter($FROM_TYPE)."} WHERE {".SecurityFilter($GET_ID)."} IN(".SecurityFilter($THISID).")";
    $rs_name = exequery($connection, $sql_name);
    while ($row_name = @mysql_fetch_array($rs_name)) {
        $GETSHOWNAME .= $row_name[$GETNAME] . ",";
    }
    return $GETSHOWNAME;
}

/**
 * 根据FUNC_ID获取名称
 * @param  string $func_id    传入的菜单的ID
 * @reutrn string $func_name  返回的是菜单名
 */
function getFuntName($func_id) {
    global $connection;
    $len = $_SESSION['LOGIN_LANG_ID'];
    $query = "
			SELECT * FROM menu_lang
					WHERE FUNC_ID = ".SecurityFilter($func_id)."
					AND LANG_ID = ".SecurityFilter($len)."
			";
    $rs = exequery($connection, $query);
    $ROW = mysql_fetch_array($rs);
    $func_name = $ROW["FUNC_NAME"];
    return $func_name;
}

/**
 * 新建的权限选择
 * @param string $input_name   标题
 * @param string $form1_name   表单名
 * @param string $this_id      sql语句中约束条件的值
 * @param string $table_field  sql语句中的字段
 * @param string $table_name   sql语句中的表名
 * @param string $DEPT_ID      部门ID
 * @param string $PRIV_ID      角色ID
 * @param string $USER_ID      用户ID
 */
function createPurSelect($input_name, $form1_name, $this_id, $table_field, $table_name, $DEPT_ID = "DEPT_ID", $PRIV_ID = "PRIV_ID", $USER_ID = "USER_ID", $is_noshell = "", $loadUserWidth = "", $loadUserHeight = "") {
    global $connection, $_lang;
    $query = "
			SELECT ".SecurityFilter($DEPT_ID).",".SecurityFilter($PRIV_ID).",".SecurityFilter($USER_ID)."  FROM ".SecurityFilter($table_name)." WHERE ".SecurityFilter($table_field)." = '" .
            SecurityFilter($this_id) . "'
			";
    $cursor = exequery($connection, $query);
    $ROW = mysql_fetch_array($cursor);
    $THIS_DEPT = $ROW[$DEPT_ID];
    $THIS_PRIV = $ROW[$PRIV_ID];
    if ($THIS_DEPT == 'DEPT_ALL' || $THIS_DEPT == 'ALL_DEPT') {
        $THIS_DEPT = '';
    }
    $THIS_USER = $ROW[$USER_ID];
    if ($THIS_DEPT != '') {
        $THIS_DEPT_NAME = getNameFromId($THIS_DEPT, 'DEPT_NAME', 'DEPT_ID', 'department');
    }
    if ($THIS_PRIV != '') {
        $THIS_PRIV_NAME = getNameFromId($THIS_PRIV, 'PRIV_NAME', 'USER_PRIV', 'user_priv');
    }
    if ($THIS_USER != '') {
        $THIS_USER_NAME = getNameFromId($THIS_USER, 'USER_NAME', 'USER_ID', 'user');
    }
    ?>
    <table width="100%" class="form_table" cellpadding="<?
    if ($table_name == "coop_theme" || $table_name == "ip_rule" || $table_name == "template_file" || $table_name == "coop_sort") {
        echo "2";
    } else {
        echo "5";
    }
    ?>" cellspacing="0">
        <tr>
            <td class="title" <?
            if ($is_noshell == "") {
                echo "align='center'";
            } else {
                echo "width='" . $is_noshell . "'";
            }
            ?>><?= $_lang["common_dept"] ?>&nbsp;&nbsp;</td>
            <td>
                <textarea id="<?= $input_name ?>_DEPT_NAME" name="<?= $input_name ?>_DEPT_NAME" style="overflow:auto;width:300px;" readonly><?= $THIS_DEPT_NAME ?></textarea>
                <input type="button" class="btn btn-primary" onClick="LoadWindowDept('<?= $input_name ?>_DEPT', '<?= $input_name ?>_DEPT_NAME', '<?= $form1_name ?>', '<?= $loadUserWidth ?>', '<?= $loadUserHeight ?>');" value='<?= $_lang["common_choose"] ?>'>
                <input type="button" class="btn btn-danger" onClick="clearConten('<?= $input_name ?>_DEPT', '<?= $input_name ?>_DEPT_NAME')" value='<?= $_lang["common_empty"] ?>'>
                <input type="hidden" id="<?= $input_name ?>_DEPT" name="<?= $input_name ?>_DEPT" value="<?= $THIS_DEPT ?>" >
                <input type="hidden" id="<?= $input_name ?>" value="<?= $this_id ?>" name="<?= $input_name ?>">
            </td>
        </tr>
        <tr>
            <td class="title" <?
            if ($is_noshell == "") {
                echo "align='center'";
            } else {
                echo "width='" . $is_noshell . "'";
            }
            ?>><?= $_lang["common_role"] ?>&nbsp;&nbsp;</td>
            <td>
                <textarea id="<?= $input_name ?>_PRIV_NAME" name="<?= $input_name ?>_PRIV_NAME" style="overflow:auto;width:300px;" readonly><?= $THIS_PRIV_NAME ?></textarea>
                <input type="button" class="btn btn-primary" onClick="LoadWindowPriv('<?= $input_name ?>_PRIV', '<?= $input_name ?>_PRIV_NAME', '<?= $form1_name ?>', event);" value='<?= $_lang["common_choose"] ?>'>
                <input type="button" class="btn btn-danger" onClick="clearConten('<?= $input_name ?>_PRIV', '<?= $input_name ?>_PRIV_NAME')" value='<?= $_lang["common_empty"] ?>'>
                <input type="hidden" id="<?= $input_name ?>_PRIV" name="<?= $input_name ?>_PRIV" value="<?= $THIS_PRIV ?>" >
                <input type="hidden" value="<?= $this_id ?>" id="<?= $input_name ?>" name="<?= $input_name ?>">
            </td>
        </tr>
        <tr>
            <td class="title" <?
            if ($is_noshell == "") {
                echo "align='center'";
            } else {
                echo "width='" . $is_noshell . "'";
            }
            ?>><?= $_lang["common_user"] ?>&nbsp;&nbsp;</td>
            <td>
                <textarea id="<?= $input_name ?>_USER_NAME" name="<?= $input_name ?>_USER_NAME" style="overflow:auto;width:300px;" readonly><?= $THIS_USER_NAME ?></textarea>
                <input type="button" class="btn btn-primary" onClick="LoadWindowUser('<?= $input_name ?>_USER', '<?= $input_name ?>_USER_NAME', '<?= $form1_name ?>', '<?= $loadUserWidth ?>', '<?= $loadUserHeight ?>');" value='<?= $_lang["common_choose"] ?>'>
                <input type="button" class="btn btn-danger" onClick="clearConten('<?= $input_name ?>_USER', '<?= $input_name ?>_USER_NAME')" value='<?= $_lang["common_empty"] ?>'>
                <input type="hidden" id="<?= $input_name ?>_USER" name="<?= $input_name ?>_USER" value="<?= $THIS_USER ?>" >
                <input type="hidden" value="<?= $this_id ?>" id="<?= $input_name ?>" name="<?= $input_name ?>">
            </td>
        </tr>
    </table>
    <?
}

/**
 * 权限选择,公告
 * @param  string $input_name   公告标题
 * @param  string $form1_name   表单名
 * @param  string $this_id      sql语句中约束条件的值
 * @param  string $table_field  表中的字段
 * @param  string $table_name   sql语句中的表名
 * @param  string $DEPT_ID      部门ID
 * @param  string $PRIV_ID      角色ID
 * @param  string $USER_ID      用户ID
 */
function createPurSelectNotify($input_name, $form1_name, $this_id, $table_field, $table_name, $DEPT_ID = "DEPT_ID", $PRIV_ID = "PRIV_ID", $USER_ID = "USER_ID", $is_noshell = "") {
    global $connection, $_lang;
    $query = "
			SELECT ".SecurityFilter($DEPT_ID).",".SecurityFilter($PRIV_ID).",".SecurityFilter($USER_ID)."  FROM ".SecurityFilter($table_name)." WHERE ".SecurityFilter($table_field)." = '" .
            $this_id . "'
			";
    $cursor = exequery($connection, $query);
    $ROW = mysql_fetch_array($cursor);
    $THIS_DEPT = $ROW[$DEPT_ID];
    $THIS_PRIV = $ROW[$PRIV_ID];
    if ($THIS_DEPT == 'ALL_DEPT') {
        $THIS_DEPT = '';
    }
    $THIS_USER = $ROW[$USER_ID];
    if ($THIS_DEPT != '') {
        $THIS_DEPT_NAME = getNameFromId($THIS_DEPT, 'DEPT_NAME', 'DEPT_ID', 'department');
    }
    if ($THIS_PRIV != '') {
        $THIS_PRIV_NAME = getNameFromId($THIS_PRIV, 'PRIV_NAME', 'USER_PRIV', 'user_priv');
    }
    if ($THIS_USER != '') {
        $THIS_USER_NAME = getNameFromId($THIS_USER, 'USER_NAME', 'USER_ID', 'user');
    }
    ?>
    <table style="border:0px solid #E1E1E1;" width="500px" cellpadding="0" cellspacing="0" >
        <tr>
            <td nowrap class="page-body-table" <?
            if ($is_noshell == "") {
                echo "align='center'";
            } else {
                echo " align='left' width='" . $is_noshell . "'";
            }
            ?>><?= $_lang["common_dept"] ?>：</td>
            <td>
                <table>
                    <tr>
                        <td>
                            <textarea cols='35' id="<?= $input_name ?>_DEPT_NAME" name="<?= $input_name ?>_DEPT_NAME" rows="2" class="textarea" wrap="yes" style="overflow:auto" readonly><?= $THIS_DEPT_NAME ?></textarea>
                        </td><td valign="bottom">
                            <input type="button" onClick="LoadWindowDept('<?= $input_name ?>_DEPT', '<?= $input_name ?>_DEPT_NAME', '<?= $form1_name ?>');" value="<?= $_lang["common_choose"] ?>" name="">
                            <input type="button" onClick="clearConten('<?= $input_name ?>_DEPT', '<?= $input_name ?>_DEPT_NAME')" value="<?= $_lang["common_empty"] ?>" name="">
                        </td>
                    </tr>
                </table>
                <input type="hidden" id="<?= $input_name ?>_DEPT" name="<?= $input_name ?>_DEPT" value="<?= $THIS_DEPT ?>" >
                <input type="hidden" id="<?= $input_name ?>" value="<?= $this_id ?>" name="<?= $input_name ?>">
            </td>
        </tr>
        <tr>
            <td nowrap class="page-body-table" <?
            if ($is_noshell == "") {
                echo "align='center'";
            } else {
                echo " align='left'";
            }
            ?>><?= $_lang["common_role"] ?>：</td>
            <td>
                <table>
                    <tr>
                        <td>
                            <textarea cols='35' id="<?= $input_name ?>_PRIV_NAME" name="<?= $input_name ?>_PRIV_NAME" rows="2" class="textarea" wrap="yes" style="overflow:auto" readonly><?= $THIS_PRIV_NAME ?></textarea>
                        </td><td valign="bottom">
                            <input type="button" onClick="LoadWindowPriv('<?= $input_name ?>_PRIV', '<?= $input_name ?>_PRIV_NAME', '<?= $form1_name ?>', event);" value="<?= $_lang["common_choose"] ?>" name="">
                            <input type="button" onClick="clearConten('<?= $input_name ?>_PRIV', '<?= $input_name ?>_PRIV_NAME')" value="<?= $_lang["common_empty"] ?>" name="">
                        </td>
                    </tr>
                </table>
                <input type="hidden" id="<?= $input_name ?>_PRIV" name="<?= $input_name ?>_PRIV" value="<?= $THIS_PRIV ?>" >
                <input type="hidden" value="<?= $this_id ?>" id="<?= $input_name ?>" name="<?= $input_name ?>">
            </td>
        </tr>

        <tr>
            <td nowrap class="page-body-table" <?
            if ($is_noshell == "") {
                echo "align='center'";
            } else {
                echo " align='left'";
            }
            ?>><?= $_lang["common_user"] ?>：</td>
            <td>
                <table>
                    <tr>
                        <td>
                            <textarea cols='35' id="<?= $input_name ?>_USER_NAME" name="<?= $input_name ?>_USER_NAME" rows="2" class="textarea" wrap="yes" style="overflow:auto" readonly><?= $THIS_USER_NAME ?></textarea>
                        </td><td valign="bottom">
                            <input type="button" onClick="LoadWindowUser('<?= $input_name ?>_USER', '<?= $input_name ?>_USER_NAME', '<?= $form1_name ?>');" value="<?= $_lang["common_choose"] ?>" name="">
                            <input type="button" onClick="clearConten('<?= $input_name ?>_USER', '<?= $input_name ?>_USER_NAME')" value="<?= $_lang["common_empty"] ?>" name="">
                        </td>
                    </tr>
                </table>
                <input type="hidden" id="<?= $input_name ?>_USER" name="<?= $input_name ?>_USER" value="<?= $THIS_USER ?>" >
                <input type="hidden" value="<?= $this_id ?>" id="<?= $input_name ?>" name="<?= $input_name ?>">
            </td>
        </tr>
    </table>
    <?
}

/**
 * 判断权限
 * @param string $table_field sql语句中的表字段
 * @param string $this_id    sql语句中约束条件的值
 * @param string $table_name 表名
 * @param string $DEPT_ID    部门ID
 * @param string $PRIV_ID    角色ID
 * @param string $USER_ID    用户ID
 */
function getPurview($table_field, $this_id, $table_name, $DEPT_ID = "DEPT_ID", $PRIV_ID = "PRIV_ID", $USER_ID = "USER_ID") {
    global $connection;
    $LOGIN_USER_ID = $_SESSION['LOGIN_USER_ID'];
    $LOGIN_DEPT_ID = $_SESSION['LOGIN_DEPT_ID'];
    $LOGIN_PRIV_ID = $_SESSION['LOGIN_USER_PRIV'];
    $query = "SELECT $table_field  FROM $table_name WHERE $table_field = '" . $this_id . "'
				and(
					($DEPT_ID='DEPT_ALL')
					or
					(INStr(".SecurityFilter($DEPT_ID).",',".SecurityFilter($LOGIN_DEPT_ID).",')>0 or INStr(".SecurityFilter($DEPT_ID).",'".SecurityFilter($LOGIN_DEPT_ID).",')=1)
					or
					(INStr(".SecurityFilter($PRIV_ID).",',".SecurityFilter($LOGIN_PRIV_ID).",')>0 or INStr(".SecurityFilter($PRIV_ID).",'".SecurityFilter($LOGIN_PRIV_ID).",')=1)
					or
					(INStr(".SecurityFilter($USER_ID).",',".SecurityFilter($LOGIN_USER_ID).",')>0 or INStr(".SecurityFilter($USER_ID).",'".SecurityFilter($LOGIN_USER_ID).",')=1))";
    $cursor = exequery($connection, $query);
    if (mysql_fetch_array($cursor)) {
        return true;
    } else {
        return false;
    }
}

/**
 * 获取回复
 * @param string $input_name  文档标题
 * @param string $table_name  表名
 * @param string $field       字段名
 * @param string $sort_field
 * @param string $fromwhere   获取来源
 */
function getReTextArea($input_name, $table_name, $field, $sort_field, $fromwhere = '') {
    ?>
    <a href="/inc/get_shortcut.php?table_name=<?= $table_name ?>&field=<?= $field ?>&sort_field=<?= $sort_field ?>&input_name=<?= $input_name ?>&fromwhere=<?= $fromwhere ?>" onclick="return hs.htmlExpand(this, {objectType: 'iframe', width: 260})"><img class="img" src="/theme/<?= $_SESSION["LOGIN_THEME"] ?>/images/icon/shortcut.gif" ></a>
    <?
}

/**
 * 用“,”拆开字符串组成数组
 * @param  string $string    传入的字符串
 * @return array $tokens     返回用","拆开后组成的数组
 */
function spitByStrtok($string) {
    for ($tokens = array(), $nextToken = strtok($string, ','); $nextToken !== false; $nextToken = strtok(',')) {
        $tokens[] = $nextToken;
    }
    return $tokens;
}

/**
 * 获取流程的相关文档
 * @param int $FLOW_ID      流程分类的ID
 * @param int $RUN_ID       流程的ID
 * @param int $PRCS_ID      流程节点
 * @param int $FLOW_PRCS    节点的处理情况
 * @param string $FORM_NAME  表单名
 * @param string $INPUT_NAME 文档标题名
 */
function getDocLink($FLOW_ID, $RUN_ID, $PRCS_ID, $FLOW_PRCS, $FORM_NAME, $INPUT_NAME, $from = "") {
    global $connection, $rooturl, $_lang;
    $LOGIN_USER_ID = $_SESSION['LOGIN_USER_ID'];
    $query = "SELECT * from FLOW_RUN WHERE RUN_ID=".SecurityFilter($RUN_ID)."";
    $cursor = exequery($connection, $query);
    if ($ROW = mysql_fetch_array($cursor)) {
        $RUN_NAME = $ROW["RUN_NAME"];
        $LINK_DOC = $ROW["LINK_DOC"];
    }

    //增加判断流程是否委托出去，查看表单是不做验证
    if ($from != "view") {
        $workFlowInstance = new workflow($FLOW_ID);
        $workFlowInstance->runId = $RUN_ID;
        /* $OP_FLAG                   = $workFlowInstance->isOpFlag($LOGIN_USER_ID,$PRCS_ID);
          if($OP_FLAG)
          {
          $turned = $workFlowInstance->haveTurned($PRCS_ID,$LOGIN_USER_ID);
          }
          else
          {
          $turned = $workFlowInstance->operatorHaveTurned($PRCS_ID,$LOGIN_USER_ID);
          } */
        if ($workFlowInstance->haveTurned($PRCS_ID, $LOGIN_USER_ID) && $workFlowInstance->operatorHaveTurned($PRCS_ID, $LOGIN_USER_ID)) {
            Message("", $_lang["flow_haveturn_can_not_save"]);
            ?>
            <input type="hidden" name="<?= $INPUT_NAME ?>" id="<?= $INPUT_NAME ?>" value="<?= $LINK_DOC ?>" >
            <?
            exit;
        }
    }
    if (!run_role($RUN_ID, $PRCS_ID)) {
        Message("", $_lang["flow_not_existed"]);
        ?>
        <input type="hidden" name="<?= $INPUT_NAME ?>" id="<?= $INPUT_NAME ?>" value="<?= $LINK_DOC ?>" >
        <?
        exit;
    }
    $query = "SELECT * from FLOW_TYPE WHERE FLOW_ID=".SecurityFilter($FLOW_ID)."";
    $cursor1 = exequery($connection, $query);
    if ($ROW = mysql_fetch_array($cursor1)) {
        $FLOW_NAME = $ROW["FLOW_NAME"];
        $FORM_ID = $ROW["FORM_ID"];
        $FLOW_TYPE = $ROW["FLOW_TYPE"];
        $FLOW_LINK = $ROW["FLOW_LINK"];
    }

    if ($FLOW_TYPE == "1") {
        $query = "SELECT * from FLOW_PROCESS WHERE FLOW_ID=".SecurityFilter($FLOW_ID)." AND PRCS_ID=".SecurityFilter($FLOW_PRCS)."";
        $cursor = exequery($connection, $query);
        if ($ROW = mysql_fetch_array($cursor)) {
            $PRCS_ITEM = $ROW["PRCS_ITEM"];
            $PRCS_OPTYPE = $ROW["PRCS_OPTYPE"];
        }
        $query = "SELECT * from FLOW_RUN_PRCS WHERE RUN_ID=".SecurityFilter($RUN_ID)." AND PRCS_ID=".SecurityFilter($PRCS_ID)." AND USER_ID='" .
                SecurityFilter($LOGIN_USER_ID) . "'";
        $cursor = exequery($connection, $query);
        if ($ROW = mysql_fetch_array($cursor))
            $OP_FLAG = $ROW["OP_FLAG"];

        if ($PRCS_OPTYPE == 3 && $from != "view") {
            $maxOpFlag = $workFlowInstance->opFlagIsExist($PRCS_ID);
            if ($maxOpFlag <= 0) {
                $OP_FLAG = "1";
            }
        }
    }
    $DOC_EDIT = 0;
    if ((find_id($PRCS_ITEM, "[D@]") && $OP_FLAG) || ($FLOW_TYPE == "2" && $FLOW_LINK ==
            '1')) {
        $DOC_EDIT = 1;
    }
    if ($DOC_EDIT && $from != "view") {
        ?>
        <div class="lazy_sub_header">
            <button type="button" style="" class="btn btn-primary" onclick="LoadWindowNewDoc('/general/file_folder/file_new/neworedit/index.php?f=other_new&input_name=<?= $INPUT_NAME ?>', '<?= $INPUT_NAME ?>');" title="<?= $_lang["common_upload"] ?><?= $_lang["common_new"] ?>"><?= $_lang["common_new"] ?>
            </button>
            <button type="button" style="" class="btn btn-primary" onclick="LoadWindowDoc('<?= $INPUT_NAME ?>', 'DOC_NAME', '<?= $FORM_NAME ?>', '', event);" title="<?= $_lang ["common_add"] ?>"><?= $_lang["common_add"] ?>
            </button>
        </div>
        <?
    }
    ?>
    <span id="DOC_NAME"></span>
    <input type="hidden" name="<?= $INPUT_NAME ?>" id="<?= $INPUT_NAME ?>" value="<?= $LINK_DOC ?>" >
    <div id="nodatadiv"></div>
    <?
}

/**
 * 关联新建文档
 * @param string $INPUT_NAME  文档标题名
 * @param string $FORM_NAME   表单名
 */
function LoadOpDoc($INPUT_NAME, $FORM_NAME) {
    global $_lang;
    ?>
    <span valign="top"  style="cursor:hand;">
        <table border="0" width="200px" cellspacing="0" cellpadding="3">
            <tr>
                <td>
                    <table>
                        <tr>
                            <td>
                                <table cellpadding="0" cellspacing="0">
                                    <tr>
                                        <td class="uploadifyButtonLeft">

                                        </td>
                                        <td class="uploadifyButtonCenter" onclick="LoadWindowDoc('<?= $INPUT_NAME ?>', 'DOC_NAME', '<?= $FORM_NAME ?>', '');" style="cursor:pointer">
                                            <?= $_lang["common_add"] ?>
                                        </td>
                                        <td class="uploadifyButtonRight">
                                        </td>
                                    </tr>
                                </table>
                            </td>
                            <td>
                                <table cellpadding="0" cellspacing="0">
                                    <tr>
                                        <td class="uploadifyButtonLeft">

                                        </td>
                                        <td class="uploadifyButtonCenter" onclick="LoadWindowNewDoc('/general/file_folder/file_new/neworedit/index.php?f=other_new&input_name=<?= $INPUT_NAME ?>');" style="cursor:pointer">
                                            <?= $_lang["common_new"] ?>
                                        </td>
                                        <td class="uploadifyButtonRight">
                                        </td>
                                    </tr>
                                </table>
                            </td>
                        </tr>
                    </table>
                </td>
            </tr>
        </table>
    </span>
    <?php
}

/**
 * 根据文档ID获取关联文档
 * @param  string $content_id   文档的ID
 * @return string $link_doc_str 返回关联的文档
 */
function getFlowDocLink($content_id) {
    global $connection, $_lang;
    $query = "SELECT * FROM file_content WHERE CONTENT_ID=".SecurityFilter($content_id)." ";
    $cursor = exequery($connection, $query);
    $ROW = mysql_fetch_array($cursor);
    $LINK_DOC = $ROW["LINK_DOC"];
    if ($LINK_DOC != '') {
        $tokenarr = spitByStrtok($LINK_DOC);
        while (list(, $content_id) = each($tokenarr)) {
            $query = "
						SELECT * FROM file_content
							WHERE CONTENT_ID = ".SecurityFilter($content_id)."
						";
            $res = exequery($connection, $query);
            if ($ROW = mysql_fetch_array($res)) {
                $SUBJECT = $ROW['SUBJECT'];
                $link_doc_str .= "<span id='" . $content_id . "'><img src='" . THEME_FLAG . "/" .
                        $_SESSION['LOGIN_THEME'] .
                        "/images/icon/document.gif' align='absmiddle'><span onclick = \"openDocumentsWindows('$content_id');\" class=\"linkdivOp\" onmouseover=\"this.style.color='red'\" onmouseout = \"this.style.color='blue'\">$SUBJECT</span>&nbsp;&nbsp;</span>";
            }
        }
    } else {
        $link_doc_str = $_lang["common_relevance_file"];
    }
    return $link_doc_str;
}

/**
 * 统一设置字段值
 * @param string $field_name   字段名
 * @param string $field_value  字段值
 */
function setFieldPara($field_name, $field_value) {
    global $connection;
    $query = "
			SELECT COUNT(*) AS CNT FROM sys_para WHERE PARA_NAME = '".SecurityFilter($field_name)."'
			";
    $res = exequery($connection, $query);
    $ROW = mysql_fetch_array($res);
    $CONT = $ROW['CNT'];
    if ($CONT == 0) {
        $query_i = "
			INSERT INTO `sys_para` (`PARA_NAME` ,`PARA_VALUE` )VALUES
				('".SecurityFilter($field_name)."', '".SecurityFilter($field_value)."');
		";
    } else {
        $query_i = "
			UPDATE `sys_para` SET `PARA_VALUE` = '".SecurityFilter($field_value)."'
				WHERE CONVERT( `sys_para`.`PARA_NAME` USING utf8 ) = '".SecurityFilter($field_name)."'
				";
    }
    exequery($connection, $query_i);
}

/**
 * 获取某个字段的值
 * @param  string $field_name      字段名
 * @return string $PARA_VALUE*1000  返回字段值*1000
 */
function getFieldPara($field_name) {
    global $connection;
    $query = "
			SELECT * FROM sys_para WHERE PARA_NAME = '".SecurityFilter($field_name)."'
			";
    $res = exequery($connection, $query);
    $ROW = mysql_fetch_array($res);
    $PARA_VALUE = $ROW['PARA_VALUE'];
    return $PARA_VALUE * 1000;
}

/**
 * 递归文档获取路径
 * @param  string $f_id      文档目录类的ID
 * @return string $file_url  返回递归文档路径
 */
function get_url($f_id) {
    global $connection;
    $sql2 = "select SORT_PARENT, SORT_NAME from file_sort where SORT_ID=" . SecurityFilter($f_id);
    $cursors2 = exequery($connection, $sql2);
    if ($rows2 = mysql_fetch_row($cursors2)) {
        $sort_parent = $rows2[0];
        $sort_name2 = $rows2[1];
    }

    if ($sort_parent != "") {
        $file_url .= get_url($sort_parent) . '/' . $sort_name2;
    }
    return $file_url;
}

/**
 * 根据流程类别id,取出流程类别名称 by sun 2008-08-14
 * @param string $id        传入的流程类别的ID
 * @return string $flowname 返回的是流程类别名称
 */
function getFlowTypeNameById($id) {
    global $connection;
    $query = "SELECT FLOW_NAME FROM flow_type WHERE FLOW_ID = '" . SecurityFilter($id) . "' ";
    $rs = exequery($connection, $query);
    $rows = mysql_fetch_array($rs);
    $flowname = $rows["FLOW_NAME"];
    return $flowname;
}

/**
 * 根据流程分类id,取出流程分类名称  by sun 2008-08-14
 * @param  string $id 流程分类的ID
 * @return string $sortname 返回流程分类名称
 */
function getFlowSortNameById($id) {
    global $connection;
    $query = "SELECT TITLE FROM flow_sort WHERE ID = '" . SecurityFilter($id) . "' ";
    $rs = exequery($connection, $query);
    $rows = mysql_fetch_array($rs);
    $sortname = $rows["TITLE"];
    return $sortname;
}

/**
 * 是否在线 2008-9-22 lxl
 * @param  string $user_id 传入用户ID
 * @return array $onar     返回包括用户在线信息的数组
 */
function getIsOnline($userid) {
    global $connection, $_lang;
    $sql = "SELECT VISIT_TIME FROM user_online WHERE USER_ID='" . SecurityFilter($userid) . "'";
    $rs = exequery($connection, $sql);
    $row = mysql_fetch_array($rs);
    $onar['img'] = "";
    $onar['status'] = 0;
    if (abs(time() - strtotime($row['VISIT_TIME'])) < 150) {
        $onar['img'] = "<img src='/images/littlegif/icon_0400.gif' title='" . $_lang["info_user_search_online"] .
                "'>";
        $onar['status'] = 1;
    }
    return $onar;
}

/**
 * 发送短信 lxl 2008-9-23
 * @param string $from_id  发送人ID，默认为admin
 * @param string $toidstr  接收人iD
 * @param string $content  短信内容
 * @param string $remind   是否提醒，默认为1
 * @param string $smstype  短信提醒类型
 * @param string $tablename表名
 * @param string $tableid  表ID
 * @param string $tablevar 表达值
 * @param string $attid    附件ID
 * @param string $attname  附件名
 * @param string $sendtime 发送时间，
 */
function sendSms($fromid = "admin", $toidstr, $content, $remind = 1, $smstype = 0, $tablename = "", $tableid = "", $tablevar = "", $attid = "", $attname = "", $sendtime = "") {
    global $connection, $_lang;

    is_registered();
    global $IS_REGISTERED_MYOA;
    if(!trim($fromid)){
        return false;
    }

    if (trim($content) == "" || $toidstr == "") {
        return false;
    }

    if (false !== strpos($tablevar, '|')) {
        $tablevarArr = explode('|', $tablevar);
        $copy = $tablevarArr[2] ? $tablevarArr[2] : false;
        $tablevar = $tablevarArr[0] . '|' . $tablevarArr[1];
    }
    $arrayid = explode(",", $toidstr);

    if ($IS_REGISTERED_MYOA == 0) { //试用用户
        $wxCode1 = $wxCode2 = $dtCode = 1;
    } else {
        $wxCode1 = AppGlobal::getModApp(499);
        $wxCode2 = AppGlobal::getModApp(107);
        $wxCode3 = AppGlobal::getModApp(925);
        $dtCode = AppGlobal::getModApp(120);
    }





    $nowTime = date("Y-m-d H:i:s", time());
    //发送时间比当前时间 超前 定时发送 不推送
    if ($sendtime > $nowTime) {
        //不推送
        $wxCode1 = 0;
        $wxCode2 = 0;
        $dtCode = 0;
    }

    if ($wxCode2 == 1) {
        $qyWechat = checkQyWeixinModule(true);
    } else {
        $qyWechat = false;
    }
    if ($wxCode3 == 1) {
        include_once("general/workwechat/proxy/WorkWechat.proxy.php");
        $wechat = new WorkWechatProxy();
        $wechatData = $wechat->wechatData();
        if (!empty($wechatData) && $wechatData['is_push'] == 1) {
             $workWechat = true;
        }

    } else {
        $workWechat = false;
    }
    if ($wxCode1 == 1) {
        $wechat = checkWeixinModule(true);
    } else {
        $wechat = false;
    }


    if ($dtCode == 1) {
        $dingtalk = checkDingTalkModule(true);
    } else {
        $dingtalk = false;
    }

    //微信公众号推送
    $opt = array(
        'sourceType' => $smstype,
        'tableName' => $tablename,
        'sourceID' => $tableid,
        'fromID' => $fromid,
        'copy' => $copy
    );
    //$tablevar FLOW_ID,RUN_ID,PRCS_ID,FLOW_PRCS
    if (7 == $smstype) {
        $temp = explode(',', trim(strstr($tablevar, '|'), '|'));
        $opt['sourceID'] = $temp[1] . ',' . $temp[0] . ',' . $temp[3] . ',' . $temp[2];
    }

    // while (list($key, $toid) = each($arrayid)) {
    foreach ($arrayid as $toid) {
        if ($toid != "") {

            if (!$sendtime) {
                $sendtime = date("Y-m-d H:i:s", time());
            }
            $sql = " INSERT INTO sms  (FROM_ID,TO_ID,SMS_TYPE,CONTENT,SEND_TIME,REMIND_FLAG,ATTACHMENT_ID,ATTACHMENT_NAME,TABLE_NAME,TABLE_ID,TABLE_VAR)  VALUES ('" . SecurityFilter($fromid) . "','" . SecurityFilter($toid) . "','" . SecurityFilter($smstype) . "','" . SecurityFilter($content) . "','" . SecurityFilter($sendtime) . "','" . SecurityFilter($remind) . "','" . SecurityFilter($attid) . "','" . SecurityFilter($attname) . "','" . SecurityFilter($tablename) . "','" . SecurityFilter($tableid) . "','" . SecurityFilter($tablevar) . "')";
            exequery($connection, $sql);
            if ($wechat) {
                sendMp($wechat, $toid, $content, $opt);
            }

            if ($dingtalk) {
                sendDingTalk($dingtalk, $toid, $content, $opt);
            }
        }
    }
    sendMobileSms($toidstr, $content);
    // 企业号推送
    $toidstr_qy = str_replace(",", "|", $toidstr);
    if ($qyWechat) {
        sendQYMp($qyWechat, $toidstr_qy, $content, $opt);
    }
    if ($workWechat) {
         sendWorkWechat($toidstr_qy, $content, $opt);
    }

//    发送钉钉消息
}

//发送消息 特殊的 用车维护（2次消息插入）
function sendSmsMain($fromid = "admin", $toidstr, $content, $remind = 1, $smstype = 0, $tablename = "", $tableid = "", $tablevar = array(), $attid = "", $attname = "", $sendtime = array()) {
    global $connection, $_lang;

    is_registered();
    global $IS_REGISTERED_MYOA;

    if(!trim($fromid)){
        return false;
    }

    if (trim($content) == "" || $toidstr == "") {
        return false;
    }

    $arrayid = explode(",", $toidstr);

    if ($IS_REGISTERED_MYOA == 0) { //试用用户
        $wxCode1 = $wxCode2 = 1 ;
        $dtCode = 1;
    } else {
        $wxCode1 = AppGlobal::getModApp(499);
        $wxCode2 = AppGlobal::getModApp(107);
        $dtCode = AppGlobal::getModApp(120);
    }

    if ($wxCode2 == 1) {
        $qyWechat = checkQyWeixinModule(true);
    } else {
        $qyWechat = false;
    }
    if ($wxCode1 == 1) {
        $wechat = checkWeixinModule(true);
    } else {
        $wechat = false;
    }
     if ($wxCode3 == 1) {
        include_once("general/workwechat/proxy/WorkWechat.proxy.php");
        $wechat = new WorkWechatProxy();
        $wechatData = $wechat->wechatData();
        if (!empty($wechatData) && $wechatData['is_push'] == 1) {
             $workWechat = true;
        }
       
    } else {
        $workWechat = false;
    }
    
    
if ($dtCode == 1) {
        $dingtalk = checkDingTalkModule(true);
    } else {
        $dingtalk = false;
    }


    //微信公众号推送
    $opt = array(
        'sourceType' => $smstype,
        'tableName' => $tablename,
        'sourceID' => $tableid,
        'fromID' => $fromid,
        'copy' => $copy
    );


    $sms_array = $tablevar;

    foreach ($arrayid as $toid) {
        if ($toid != "") {
            $content1 = "用车维护开始：[" . $sms_array['name'] . "]-" . $sms_array['type'] . "；维护时间：" . $sms_array['begin'] . "--" . $sms_array['end'];
            $sql = " INSERT INTO sms  (FROM_ID,TO_ID,SMS_TYPE,CONTENT,SEND_TIME,REMIND_FLAG,ATTACHMENT_ID,ATTACHMENT_NAME,TABLE_NAME,TABLE_ID,TABLE_VAR)  VALUES ('" . SecurityFilter($fromid) . "','" . SecurityFilter($toid) . "','" . SecurityFilter($smstype) . "','" . SecurityFilter($content1) . "','" . SecurityFilter($sendtime[0]) . "','" . SecurityFilter($remind) . "','" . SecurityFilter($attid) . "','" . SecurityFilter($attname) . "','" . SecurityFilter($tablename) . "','" . SecurityFilter($tableid) . "','')";
            exequery($connection, $sql);
            $content2 = "用车维护结束：[" . $sms_array['name'] . "]-" . $sms_array['type'] . "；结束时间：" . $sms_array['end'];
            $sql2 = " INSERT INTO sms  (FROM_ID,TO_ID,SMS_TYPE,CONTENT,SEND_TIME,REMIND_FLAG,ATTACHMENT_ID,ATTACHMENT_NAME,TABLE_NAME,TABLE_ID,TABLE_VAR)  VALUES ('" . SecurityFilter($fromid) . "','" . SecurityFilter($toid) . "','" . SecurityFilter($smstype) . "','" . SecurityFilter($content2) . "','" . SecurityFilter($sendtime[1]) . "','" . SecurityFilter($remind) . "','" . SecurityFilter($attid) . "','" . SecurityFilter($attname) . "','" . SecurityFilter($tablename) . "','" . SecurityFilter($tableid) . "','')";
            exequery($connection, $sql2);
            if ($wechat) {
                 sendMp($wechat, $toid, $content, $opt);
            }

             if ($dingtalk) {
                sendDingTalk($dingtalk, $toid, $content, $opt);
            }
        }
    }
    sendMobileSms($toidstr, $content);
    // 企业号推送
    $toidstr_qy = str_replace(",", "|", $toidstr);
    if ($qyWechat) {
        sendQYMp($qyWechat, $toidstr_qy, $content, $opt);
    }
    if ($workWechat) {
         sendWorkWechat($toidstr_qy, $content, $opt);
    }
}

/*
 * 消息推送验证
 *
 *
 */

function sendMobileSms($toidstr, $content) {
    global $connection;
    $sql = 'SELECT * FROM sys_para where PARA_NAME in ("MOBILE_PUSH_URL","MOBILE_PUSH_KEY","MOBILE_PUSH_BUTTON") and PARA_VALUE >0';
    $rs = exequery($connection, $sql);
    $sendUrl = '';
    $pushKey = '';
    $mobileButton = 0;
    while ($row = mysql_fetch_array($rs)) {
        if ($row['PARA_NAME'] == 'MOBILE_PUSH_URL') {
            $sendUrl = $row['PARA_VALUE'];
        } else if ($row['PARA_NAME'] == 'MOBILE_PUSH_KEY') {
            $pushKey = $row['PARA_VALUE'];
        } else if ($row['PARA_NAME'] == 'MOBILE_PUSH_BUTTON') {
            $mobileButton = intval($row['PARA_VALUE']);
        }
    }
    if ($mobileButton == 0 || $sendUrl == '' || $pushKey == '') {
        return false; // 查看是否需要推送
    }
	insertMobileSms($toidstr, $content);
}
/**
* @将需推送的消息插入中间表
* @param type $userId
* @param type $content
* @return boolean
*/
function insertMobileSms($userId, $content) {
	global $connection;

	if (!$userId) {
		return false;
	}
	$userAccounts	= getUserIdAndAccount($userId);

	$query			= "INSERT INTO mobile_sms(`USER_ACCOUNTS`,`SEND_CONTENT`,`SEND_STATE`) VALUE ";

	$size			= sizeof($userAccounts);

	foreach ($userAccounts as $key => $userAccount) {
		if ($key == $size - 1) {
			$query .= "('".SecurityFilter($userAccount)."','".SecurityFilter($content)."',0)";
		} else {
			$query .= "('".SecurityFilter($userAccount)."','".SecurityFilter($content)."',0) , ";
		}
	}

	exequery($connection, $query);
}
/**
* @获取用户账号
* @param type $userId
* @return type
*/
function getUserIdAndAccount($userId) {
	global $connection;
	$userIdStr	= '';

	foreach (explode(",", $userId) as $v) {
		$userIdStr .= '\'' . $v . '\',';
	}

	$userSql	= 'SELECT USER_ACCOUNTS from user '
		. 'WHERE USER_ID IN(' . SecurityFilter(substr($userIdStr, 0, strrpos($userIdStr, ','))) . ') AND DEPT_ID > 0';

	$userRs		= exequery($connection, $userSql);

	$userAccounts = array();

	while ($userRow = mysql_fetch_assoc($userRs)) {
		$userAccounts[] = $userRow['USER_ACCOUNTS'];
	}

	return $userAccounts;
}
function sendMp($wechat, $toID, $content = null, $opt = array()) {
    global $connection;

    if (!$toID)
        return -3;

    $sql = "select openid from weixin_user where uid = '".SecurityFilter($toID)."'";
    $res = exequery($connection, $sql);
    $row = @mysql_fetch_assoc($res);

    if (!$row['openid'])
        return -1;

    $sourceType = $opt['sourceType'];
    $sourceID = $opt['sourceID'];
    $fromID = $opt['fromID'];

    if ($opt['copy']) {
        $sourceID .= '|' . $opt['copy'];
    }

    $sql = "select USER_NAME from user where USER_ID = '".SecurityFilter($fromID)."'";
    $userResult = exequery($connection, $sql);
    $userRow = @mysql_fetch_assoc($userResult);

    $filter = array(1, 2, 7, 20, 26, 27, 28,35);
    if (!in_array($sourceType, $filter)) {
        $url = '';
    } else {
        $url = $wechat->getDomain() . "/general/weixin/oauth2.php?uid={$toID}&sourceType={$sourceType}&sourceID={$sourceID}";
    }

    $content = htmlspecialchars_decode($content);
    $temp = str_replace("\"", "'", stripcslashes($content));

    $content = urlencode(str_replace(array("\n", "\r", "\r\n"), '', $temp));

    $option['openid'] = $row['openid'];
    $option['userName'] = $userRow['USER_NAME'];
    $option['sourceType'] = $opt['sourceType'];


    $wechat->pushTemplate($option, $content, $url);

    return false;
}

function sendDingTalk($dingtalk, $toID, $content = null, $opt = array()) {
    global $connection;
    if (!$toID) {
        return -3;
    }

    //换I

    $oaId = $toID;

    $toID = dingTalkToUser($toID);

    $sourceType = $opt['sourceType'];
    $sourceID = $opt['sourceID'];

    if ($opt['copy']) {
        $sourceID .= '|' . $opt['copy'];
    }

    $filter = array(1, 2, 7, 20, 26, 27, 28,35,24);

    $dingRow = $dingtalk->getDingTalk();

    if (!in_array($sourceType, $filter)) {
        @session_start();
        $sessionkey = session_id() . '_' . $oaId;
        $url = $dingRow["domain"] . "/E-mobile/App/Init.php?weiApi=1&sessionkey={$sessionkey}&m=smsCenter_Sms";
    } else {
        $url = $dingRow["domain"] . "/general/dingtalk/oauth2.php?uid={$oaId}&sourceType={$sourceType}&sourceID={$sourceID}";
    }

    $content = htmlspecialchars_decode($content);
    $temp = str_replace("\"", "'", stripcslashes($content));

    $content = urlencode(str_replace(array("\n", "\r", "\r\n"), '', $temp));


    $agentId = $dingRow["agentid"];

    if (!$agentId) {
        return false;
    }

    $option['url'] = $url;

    $option['content'] = $content;
    $option['uids'] = $toID;
    $option['agentid'] = $agentId;

    return $dingtalk->pushTemplate($option);
}

function sendQYMp($qyWechat, $uids, $content, $opt = array()) {
    global $connection;

    if (!$uids) {
        return -3;
    }

    //微信企业号进行转换信息 -  只算同步之后的
    //uids | 分隔
    $uids = $qyWechat->transferUserID($uids);


    $sourceType = $opt['sourceType'];
    $sourceID = $opt['sourceID'];

    if ($opt['copy']) {
        $sourceID .= '|' . $opt['copy'];
    }


    $filter = array(1, 2, 7, 20, 26, 27, 28,35);
    $url = "";
    if (!in_array($sourceType, $filter)) {
        $url = 'x';
    }
//    else {
//        $url = $qyWechat->getDomain() . "/general/qyweixin/redirect.php?uids={$uids}&sourceType={$sourceType}&sourceID={$sourceID}";
//    }
    //过滤内容

    $content = htmlspecialchars_decode($content);
    $temp = str_replace("\"", "'", stripcslashes($content));
    $content = str_replace(array("\n", "\r", "\r\n"), '', $temp);

    $option['url'] = $url;
    $option['sourceID'] = $sourceID;
    $option['content'] = $content;
    $option['uids'] = $uids;
    $option['sourceType'] = $sourceType;

    return $qyWechat->pushNews($option);
}
function sendWorkWechat($uids, $content, $opt = array()) {
    include_once("general/workwechat/proxy/WorkWechat.proxy.php");
    $wechat = new WorkWechatProxy();
    if (!$uids) {
        return -3;
    }

    //微信企业号进行转换信息 -  只算同步之后的
    //uids | 分隔
    // $uids = $wechat->transferUserID($uids);

    $wechatData = $wechat->wechatData();

    $sourceType = $opt['sourceType'];
    $sourceID = $opt['sourceID'];

    if ($opt['copy']) {
        $sourceID .= '|' . $opt['copy'];
    }
    $filter = array(1, 2, 7, 20, 26, 27, 28,35);
    $url = "";
   //  if (!in_array($sourceType, $filter)) {
   //      $url = 'x';
   //  }
   // else {
   //     $url = $wechatData['domain'] . "/general/qyweixin/redirect.php?uids={$uids}&sourceType={$sourceType}&sourceID={$sourceID}";
   // }
    //过滤内容

    $content = htmlspecialchars_decode($content);
    $temp = str_replace("\"", "'", stripcslashes($content));
    $content = str_replace(array("\n", "\r", "\r\n"), '', $temp);

    $option['url'] = $url;
    $option['sourceID'] = $sourceID;
    $option['content'] = $content;
    $option['uids'] = $uids;
    $option['sourceType'] = $sourceType;


    return $wechat->pushNews($option);
}
//ＳＭＳ推送消息　企业号为空
function sendQYMpNews($qyWechat, $uids, $content, $opt = array()) {
    global $connection;

    if (!$uids) {
        return -3;
    }

     $uids = $qyWechat->transferUserID($uids);

    $content = htmlspecialchars_decode($content);
    $temp = str_replace("\"", "'", stripcslashes($content));
    $content = str_replace(array("\n", "\r", "\r\n"), '', $temp);

    $option['content'] = $content;
    $option['uids'] = $uids;

    return $qyWechat->pushSmsNews($option);
}

function sendWorkWechatSms($uids, $content) {
    include_once("general/workwechat/proxy/WorkWechat.proxy.php");
    $wechat = new WorkWechatProxy();
    if (!$uids) {
        return -3;
    }
    $sourceType = $opt['sourceType'];
    $wechatData = $wechat->wechatData();
    $content = htmlspecialchars_decode($content);
    $temp = str_replace("\"", "'", stripcslashes($content));
    $content = str_replace(array("\n", "\r", "\r\n"), '', $temp);
    $option['content'] = $content;
    $option['uids'] = $uids;
    return $wechat->pushText($option);
}

/**
 * 获取用户部门ID
 * @param  string $userid   传入的用户ID
 * @return string $dept_id  返回用户对应的部门ID
 */
function getUserDept($userid) {
    global $connection;
    $dept_id = -1;
    $query = "SELECT DEPT_ID FROM user WHERE USER_ID = '" . SecurityFilter($userid) . "'";
    $rs = exequery($connection, $query);
    if ($rows = mysql_fetch_array($rs)) {
        $dept_id = $rows["DEPT_ID"];
    }
    return $dept_id;
}

/**
 * 获取用户角色ID
 * @param  string $userid   传入的用户ID
 * @return string $dept_id  返回用户对应的角色ID
 */
function getUserPrivId($userid) {
    global $connection;
    $query = "SELECT USER_PRIV FROM user WHERE USER_ID = '" . SecurityFilter($userid) . "'";
    $rs = exequery($connection, $query);
    if ($rows = mysql_fetch_array($rs)) {
        $priv_id = $rows["USER_PRIV"];
    }
    return $priv_id;
}

/**
 * 使用","分割
 * @param string $string   传入的字符串
 * @return array $tokens  返回分割后的
 */
function tokenizeDocument($string) {
    for ($tokens = array(), $nextToken = strtok($string, ','); $nextToken !== false; $nextToken = strtok(',')) {
        $tokens[] = $nextToken;
    }
    return $tokens;
}

/**
 * 获取流程委托的用户ID
 * @param string $RUN_ID    流程的ID
 * @return string $USER_PUR 返回委托的用户ID
 */
function getFlowUserAll($RUN_ID) {
    global $connection;
    $query = "
			SELECT USER_ID from FLOW_RUN_PRCS where RUN_ID = '" . SecurityFilter($RUN_ID) . "'
			UNION
			SELECT BY_USER_ID FROM flow_copy WHERE RUN_ID ='" . SecurityFilter($RUN_ID) . "'
		";
    $res = exequery($connection, $query);
    while ($ROW = mysql_fetch_array($res)) {
        $USER_ID = $ROW['USER_ID'];
        $USER_PAR = "," . $USER_ID . ",";
        $USER_ALL_PAR = "," . $USER_PUR;
        if (!strstr($USER_ALL_PAR, $USER_PAR)) {
            $USER_PUR .= $USER_ID . ",";
        }
    }
    //给流程委托人赋予文档权限
    $query = "SELECT DISTINCT(BY_AGENT_ID) FROM flow_run_prcs WHERE RUN_ID = '" . SecurityFilter($RUN_ID) .
            "' AND BY_AGENT_ID != '' ";
    $rs = exequery($connection, $query);
    while ($rows = mysql_fetch_array($rs)) {
        $USER_PAR = "," . $rows["BY_AGENT_ID"] . ",";
        $USER_ALL_PAR = "," . $USER_PUR;
        if (!strstr($USER_ALL_PAR, $USER_PAR)) {
            $USER_PUR .= $rows["BY_AGENT_ID"] . ",";
        }
    }
    return $USER_PUR;
}

/**
 * 增加有文档查看权限用户
 * @param  string $COMNET_STR  文档ID
 * @param  string $USER_STR    用户
 * @param  string $RUN_ID      流程的ID(初始为空)
 *
 */
function addDocViewPur($COMENT_STR, $USER_STR, $RUN_ID = '') {
    global $connection;
    if (substr($COMENT_STR, -1) == ",") {
        $DOC_SQL = substr($COMENT_STR, 0, -1);
    } else {
        $DOC_SQL = $COMENT_STR;
    }
    $USER_STR_ALL = getFlowUserAll($RUN_ID);
    $query_pur = "select CONTENT_ID,SHARE_USER FROM file_content where CONTENT_ID IN (".SecurityFilter($DOC_SQL).")";
    $res = exequery($connection, $query_pur);
    while ($ROW = mysql_fetch_array($res)) {
        $USER_ID_SQL = $ROW['SHARE_USER'];
        $DOCUMENT_ID = $ROW['CONTENT_ID'];
        if ($USER_ID_SQL != '') {
            $USER_ID_PAR = "," . $USER_ID_SQL;
            $insert_user = $USER_ID_SQL;
            $tokenarr = tokenizeDocument($USER_STR_ALL);
            while (list(, $TOK_USER) = each($tokenarr)) {
                $par_user = "," . $TOK_USER . ",";
                if (!strstr($USER_ID_PAR, $par_user)) {
                    $insert_user .= $TOK_USER . ",";
                }
            }
            $query_insert = "update file_content set SHARE_TIME=NOW(),SHARE_USER='" . SecurityFilter($insert_user) .
                    "' where CONTENT_ID=".SecurityFilter($DOCUMENT_ID)."";
            exequery($connection, $query_insert);
        } else {
            if (substr($USER_STR_ALL, -1) != ",") {
                $insert_id = $USER_STR_ALL . ',';
            } else {
                $insert_id = $USER_STR_ALL;
            }
            $query_insert = "update file_content set SHARE_TIME=NOW(),SHARE_USER='" . SecurityFilter($insert_id) .
                    "' where CONTENT_ID=".SecurityFilter($DOCUMENT_ID)."";
            exequery($connection, $query_insert);
        }
    }
}

/**
 * 是否有电子签章
 * @return true/false  返回true表示有，返回false表示无
 */
function isHtmlSignature() {
    global $connection;
    $sql = "SELECT PARA_VALUE FROM sys_para WHERE PARA_NAME = 'HTML_SIGNATURE' ";
    $rs = exequery($connection, $sql);
    if ($rows = mysql_fetch_array($rs)) {
        $html_signature_value = $rows["PARA_VALUE"];
    }
    if ($html_signature_value)
        return true;
    else
        return false;
}

/**
 * 是否有手机电子签章
 * @return true/false  返回true表示有，返回false表示无
 */
function isPhoneSignature() {
    global $connection;
    $sql = "SELECT PARA_VALUE FROM sys_para WHERE PARA_NAME = 'PHONE_SIGNATURE' ";
    $rs = exequery($connection, $sql);
    if ($rows = mysql_fetch_array($rs)) {
        $phone_signature_value = $rows["PARA_VALUE"];
    }
    if ($phone_signature_value)
        return true;
    else
        return false;
}

/**
 * 生成所有部门列表数据  2009-08-05 sun
 * @return string $deptArray  返回的是所有部门列表
 */
function getAllDept() {
    global $connection;
    $sql = "SELECT DEPT_ID,DEPT_NAME FROM department ORDER BY DEPT_ID ASC ";
    $rs = exequery($connection, $sql);
    $i = 0;
    $deptArray = "";
    while ($rows = mysql_fetch_array($rs)) {
        $deptArray[$i]["DEPT_ID"] = $rows["DEPT_ID"];
        $deptArray[$i]["DEPT_NAME"] = $rows["DEPT_NAME"];
        $i++;
    }
    return $deptArray;
}

/**
 * 生成所有角色列表数据  2009-08-05 sun
 * @return string $privArray  返回的是所有角色列表
 */
function getAllPriv() {
    global $connection;
    $sql = "SELECT USER_PRIV,PRIV_NAME FROM user_priv ORDER BY USER_PRIV ASC ";
    $rs = exequery($connection, $sql);
    $i = 0;
    $privArray = "";
    while ($rows = mysql_fetch_array($rs)) {
        $privArray[$i]["USER_PRIV"] = $rows["USER_PRIV"];
        $privArray[$i]["PRIV_NAME"] = $rows["PRIV_NAME"];
        $i++;
    }
    return $privArray;
}

/**
 * 生成所有权限和相关角色列表数据 2012-09-14 dingp
 * @return string $powerandprivArray  返回的是所有权限和相关角色列表数据列表
 */
function getAllPowerAndPriv() {
    global $connection;
    $sql = "SELECT priv_no,GROUP_CONCAT(DISTINCT CAST( user_priv AS char ) ) AS priv_str,GROUP_CONCAT(DISTINCT priv_name) AS name_str FROM user_priv GROUP BY priv_no ";
    $rs = exequery($connection, $sql);
    $i = 0;
    $powerandprivArray = "";
    while ($rows = mysql_fetch_array($rs)) {
        $powerandprivArray[$i]["priv_no"] = $rows["priv_no"];
        $powerandprivArray[$i]["priv_str"] = $rows["priv_no"] . "@_@" . $rows["priv_str"];
        $powerandprivArray[$i]["name_str"] = $rows["priv_no"] . " (" . $rows["name_str"] . ")";
        $i++;
    }
    return $powerandprivArray;
}

/**
 * 当天有人登录系统就触发该操作
 */
function today_action() {
    crm_birthday_remind();
}

/**
 * 客户生日提醒
 */
function crm_birthday_remind() {
    global $connection;
    include_once ("inc/mobile_sms.inc.php");
    $date = substr(date("Y-m-d"), 5, 5);

    $sql = "SELECT l.LINKMAN_NAME , c.MANAGE_USER ,c.BIRTHDAY_REMIND ,c.BIRTHDAY_REMIND_SMS, c.CUSTOMER_NAME ,u.USER_NAME ,u.MOBIL_NO ,u.USER_ID FROM linkman as l
				INNER JOIN customer as c ON(l.CUSTOMER_ID=c.CUSTOMER_ID)
				INNER JOIN user as u ON(u.USER_ID = c.MANAGE_USER)
				    WHERE l.BIRTHDAY like '%" . SecurityFilter($date) . "' AND u.DEPT_ID>0
				";
    $rs = exequery($connection, $sql);
    $title = "您的客户今天生日：";
    while ($row = mysql_fetch_array($rs)) {
        $crm_con = $row['LINKMAN_NAME'] . "(" . $row['CUSTOMER_NAME'] . ")";
        if ($row['BIRTHDAY_REMIND'] == 1 && $row['MOBIL_NO'] != '') {
            if (!$crm_bir_sms[$row['USER_ID']]) {
                $crm_bir_sms[$row['USER_ID']]['content'] = $title . $crm_con;
            } else {
                $crm_bir_sms[$row['USER_ID']]['content'] .= "," . $crm_con;
            }
        }
        if ($row['BIRTHDAY_REMIND_SMS'] == 1) {
            if (!$crm_bir[$row['USER_ID']]) {
                $crm_bir[$row['USER_ID']]['content'] = $title . $crm_con;
            } else {
                $crm_bir[$row['USER_ID']]['content'] .= "," . $crm_con;
            }
        }
    }
    if (ifSmsBeforeAuth()) {
        $newSms = new MobileSms();
        if ($newSms->allow) {
            if (sizeof($crm_bir_sms) > 0) {
                foreach ($crm_bir_sms as $key => $val) {
                    $sql = "SELECT MOBIL_NO FROM user WHERE USER_ID='" . SecurityFilter($key) . "'";
                    $rs = exequery($connection, $sql);
                    $row = mysql_fetch_array($rs);
                    $to_no = $row['MOBIL_NO'];
                    if (!empty($to_no)) {
                        $sql = "SELECT * FROM sms_tb_msg WHERE To_Mobile='".SecurityFilter($to_no)."' AND Content='" . SecurityFilter($val['content']) . "' AND LEFT(Finish_DateTime,4) = '" . date('Y') . "' LIMIT 1";
                        $query = exequery($connection, $sql);
                        if ($row = mysql_fetch_array($query)) {

                        } else {
                            $newSms->SelfSendMore($key, $val['content'], 'admin');
                        }
                    }
                }
            }
        }
    }

    if (sizeof($crm_bir) > 0) {
        $today = date("Y-m-d");
        foreach ($crm_bir as $key => $val) {
            $sql = "SELECT * FROM sms WHERE TO_ID='".SecurityFilter($key)."' AND SMS_TYPE=19 AND CONTENT='" . SecurityFilter($val['content']) . "' AND LEFT(SEND_TIME,10) = '" . SecurityFilter($today) . "' LIMIT 1";
            $query = exequery($connection, $sql);
            if ($row = mysql_fetch_array($query)) {

            } else {
                sendSms("admin", $key, $val['content'], 1, 19);
            }
        }
    }
}

/**
 * 手机短信是否允许外发
 * @return true/false  返回true表示允许，返回false表示不允许
 */
function ifSmsBeforeAuth() {
    global $connection;
    $sql = "SELECT * FROM mobile_sms_option WHERE MSO_MB_ALLOW=1 AND SMS_IS_USE=1";
    $rs = exequery($connection, $sql);
    if ($row = mysql_fetch_array($rs)) {
        return true;
    } else {
        return false;
    }
}

/**
 * 格式化文件大小
 * @param  string $fileSize    格式化前传入的文件大小
 * @return string $fileSizeStr 格式化后返回的文件大小
 */
function formatFileSize($fileSize) {
    if ($fileSize <= 1024) {
        $fileSizeStr = "<span style=\"color:#000000;font-size:9px\">" . $fileSize .
                'B</span>';
    }

    if ($fileSize > 1024 && $fileSize < 1024 * 1024) {
        $fileSizeStr = "<span style=\"color:#000000;font-size:9px\">" . round($fileSize /
                        1024, 2) . 'K</span>';
    }
    if ($fileSize >= 1024 * 1024) {
        $fileSizeStr = "<span style=\"color:#000000;font-size:9px\">" . round($fileSize /
                        (1024 * 1024), 2) . 'M</span>';
    }
    return $fileSizeStr;
}

/**
 * 用户是否离职
 * @param  string $user   传入的用户的ID
 * @return true/false     返回true表示用户已经离职，返回false表示用户没有离职
 */
function isLeaver($user) {
    global $connection;
    $sql = "SELECT DEPT_ID FROM user WHERE USER_ID = '" . SecurityFilter($user) . "'";
    $rs = exequery($connection, $sql);
    if ($rows = mysql_fetch_array($rs)) {
        $deptId = $rows["DEPT_ID"];
    }
    if ($deptId > 0)
        return false;
    else
        return true;
}

/**
 * 是否有UsgKey登录
 * @return string $usbType   返回Usb登录的类型
 */
function isUsbKeyLogin() {
    global $connection;
    $sql = "SELECT * FROM sys_para WHERE PARA_NAME = 'LOGIN_USBKEY_TYPE'";
    $rs = exequery($connection, $sql);
    if ($rows = mysql_fetch_array($rs)) {
        $usbType = $rows["PARA_VALUE"];
    }
    return $usbType;
}

/**
 * 获取用户信息
 * @param userIdStr ,$type 1、全部 2、在职 3、离职 4、删除
 * @return array
 */
function getUserInfo($userIdStr, $type) {
    global $connection;
    $sql = "SELECT * FROM user WHERE find_in_set(USER_ID,'" . SecurityFilter($userIdStr) . "') ";
    if ($type == 2) {
        $sql .= " AND DEPT_ID > 0 ";
    } else
    if ($type == 3) {
        $sql .= " AND DEPT_ID = 0 ";
    } else
    if ($type == 4) {
        $sql .= " AND DEPT_ID = -1 ";
    }
    $sql .= " GROUP BY USER_ID ORDER BY USER_PRIV ";
    $rs = exequery($connection, $sql);
    while ($row = mysql_fetch_array($rs, MYSQL_ASSOC)) {
        $rows[] = $row;
    }
    if ($rows)
        return $rows;
    else
        return array();
}

/**
 * 获取系统以及菜单的FUNC_ID
 * @param  string $func_id  传入的菜单的func_id
 * @return string $func_id  返回的是该菜单的以及菜单的func_id
 */
function checkFuncid($func_id) {
    global $connection;
    $query = "
			select menu_id from sys_function where func_id='".SecurityFilter($func_id)."'
			";
    $cousor = exequery($connection, $query);
    while ($row = mysql_fetch_array($cousor)) {
        $menu_id = $row["menu_id"];
    }
    $menu_id = substr($menu_id, 0, 2);
    $sql = "
			select func_id from sys_function where menu_id = '".SecurityFilter($menu_id)."'
			";
    unset($row);
    unset($cousor);
    unset($query);
    $cousor = exequery($connection, $sql);
    while ($row = mysql_fetch_array($cousor)) {
        $func_id = $row["func_id"];
    }
    return $func_id;
}

/**
 * 获取菜单的提醒配置
 * @param  string $func_id  传入的系统一级菜单ID
 * @return array $array     返回包括内部消息，手机短信以及内部邮件配置的数组
 */
function checkReminds($func_id, $user_priv = "") {
    global $connection;
    $querys = "select * from remind where func_id='".SecurityFilter($func_id)."'";
    $cousor = exequery($connection, $querys);
    while ($ROW = mysql_fetch_array($cousor)) {
        $sms_select = $ROW["sms_select"];
        $smstel_select = $ROW["smstel_select"];
        $email_select = $ROW["email_select"];
        $sms_modify = $ROW["sms_modify"];
        $smstel_modify = $ROW["smstel_modify"];
        $email_modify = $ROW["email_modify"];
    }
    $array = array($sms_select, $smstel_select, $email_select, $sms_modify, $smstel_modify,
        $email_modify);

    //Edit By Samuel TD:6355  20110628  判断是否有发短信的权限  发送短信的菜单ID是255
    if ($user_priv != "") {
        $userPrivID = $user_priv;
    } else {
        $userPrivID = $_SESSION ['LOGIN_USER_PRIV'];
    }
    $getUserPrivSQL = "SELECT FUNC_ID_STR FROM user_priv WHERE USER_PRIV=".SecurityFilter($userPrivID)."";
    $getUserPrivResult = exequery($connection, $getUserPrivSQL);
    if ($getUserPrivRow = mysql_fetch_array($getUserPrivResult)) {
        $userPrivStr = $getUserPrivRow ['FUNC_ID_STR'];
    }
    if (strstr(("," . $userPrivStr), '255') === false) {
        $array [4] = 0;
    }
    return $array;
}

/**
 * 是否注册手机短信功能
 * @return $sms_Id
 */
function Smstel_reg() {
    /* $connection = OpenConnection(); */
    global $connection;
    $sql = "
			SELECT * FROM mobile_sms_option
				WHERE SMS_IS_USE = 1
			";
    $rs = exequery($connection, $sql);
    if ($row = mysql_fetch_array($rs)) {
        $sms_id = $row['SMS_ID'];
    }
    if ($sms_id != "") {
        return $sms_id;
    }
}

/**
 * 如果有合同即将到期的在职员工存在给发送人事档案管理者发送提示信息
 * 合同已经过期的不给予提醒
 */
function send_mes_to_hr($SEND_NAME) {
    global $connection;
    include_once("lang/cn/hr.lang.php");

    //判断是否有劳务合同即将到期的员工
    $expire_employees = '';
    $expire_employees_name = '';
    $expire_employees_names = '';

    $query = "SELECT * FROM sys_para
				  WHERE PARA_NAME='HRLABOR_ROUND'";
    $res = exequery($connection, $query);
    if ($row = mysql_fetch_array($res)) {
        $hrlabor_round = $row["PARA_VALUE"];
    }

    $sql = "SELECT ID,USER_ID,TRUE_NAME FROM hrms
			    WHERE `LABOR_END_TIME` >= CURDATE()
				AND `LABOR_END_TIME` <= DATE_ADD(CURRENT_DATE, interval " . SecurityFilter($hrlabor_round) . " day)
				AND `LABOR_END_TIME` != '0000-00-00'
				AND LABOR_REMIND_SIGN = 0
		   ";
    $rs = exequery($connection, $sql);
    while ($rows = mysql_fetch_assoc($rs)) {
        if ($rows["USER_ID"] != '') {
            $expire_employees .= $rows["USER_ID"] . ',';
            $expire_employees_name .= $rows["TRUE_NAME"] . ",";
        } else {
            $expire_employees_names .= $rows["TRUE_NAME"] . ",";
            $hrms_ids .= $rows["ID"] . ",";
        }
    }
    if ($expire_employees != '') {
        $expire_employees = substr($expire_employees, 0, -1);
        $expire_employees_name = substr($expire_employees_name, 0, -1);
    }
    if ($expire_employees_names != '') {
        $expire_employees_names = substr($expire_employees_names, 0, -1);
        $hrms_ids = substr($hrms_ids, 0, -1);
    }
    unset($rs);

    //获取具有人事档案管理权限的人员
    $hrtoidstrs = hr_management();
    //if (empty($hrtoidstrs))
    //exit;
    //获取【我的人事】提醒方式
    $fun_id = 5;
    $sms_arr = checkReminds($fun_id);
    //判断提醒方式
    if ($sms_arr[0] == 1) {
        //发送短消息
        if ($expire_employees != '') {
            sendSms("admin", $hrtoidstrs, $expire_employees_name . $_lang["hr_others_labor_expiring_remind"], '1', '23', 'SMS');
            sendSms("admin", $expire_employees, $_lang["hr_oneself_labor_expiring_remind"], '1', '23', 'SMS');
        }
        if ($expire_employees_names != '') {
            sendSms("admin", $hrtoidstrs, $expire_employees_names . $_lang["hr_others_labor_expiring_remind"], '1', '23', 'SMS');
        }
    }
    //手机短信提醒
    if ($sms_arr[1] == 1) {
        include_once("inc/mobile_sms.inc.php");

        $newSms = new MobileSms();
        if ($expire_employees != '') {
            $newSms->SelfSendMore($hrtoidstrs, $expire_employees_name . $_lang["hr_others_labor_expiring_remind"], 'admin');
            $newSms->SelfSendMore($expire_employees, $_lang["hr_oneself_labor_expiring_remind"], 'admin');
        }
        if ($expire_employees_names != '') {
            $newSms->SelfSendMore($hrtoidstrs, $expire_employees_names . $_lang["hr_others_labor_expiring_remind"], 'admin');
        }
    }
    //邮件提醒
    if ($sms_arr[2] == 1) {
        include_once("api/email.class.php");
        //发送邮件
        $email = new email();
        $hrtoidstrs_arr = explode(',', $hrtoidstrs);
        if ($expire_employees != '') {
            foreach ($hrtoidstrs_arr as $to_id) {
                //给hr发邮件
                $email->sendEmail("admin", $to_id, $hrtoidstrs, $_lang["hr_labor_expire_remind"], $expire_employees_name . $_lang["hr_others_labor_expiring_remind"], date('Y-m-d H:i:s', time()), '', '');
            }
            $expire_employees_arr = explode(',', $expire_employees);
            foreach ($expire_employees_arr as $to_id) {
                //给对应员工发邮件
                $email->sendEmail("admin", $to_id, $to_id, $_lang["hr_labor_expire_remind"], $_lang["hr_oneself_labor_expiring_remind"], date('Y-m-d H:i:s', time()), '', '');
            }
        }
        if ($expire_employees_names != '') {
            foreach ($hrtoidstrs_arr as $to_id) {
                //给hr发邮件
                $email->sendEmail("admin", $to_id, $hrtoidstrs, $_lang["hr_labor_expire_remind"], $expire_employees_names . $_lang["hr_others_labor_expiring_remind"], date('Y-m-d H:i:s', time()), '', '');
            }
        }
    }
    //把提醒过的人事档案劳务合同有效期提醒标记值为1，表示以提醒过，不再重复提醒
    if ($expire_employees != '') {
        $expire_employees = "'" . str_replace(",", "','", $expire_employees) . "'";
        $sql = "UPDATE HRMS SET LABOR_REMIND_SIGN='1' WHERE USER_ID IN (" . SecurityFilter($expire_employees) . ")";
        exequery($connection, $sql);
    }

    if ($expire_employees_names != '') {
        $hrms_ids = "'" . str_replace(",", "','", $hrms_ids) . "'";
        $sql = "UPDATE HRMS SET LABOR_REMIND_SIGN='1' WHERE ID IN(" . SecurityFilter($hrms_ids) . ")";
        exequery($connection, $sql);
    }
    unset($hrtoidstrs);
    unset($expire_employees);
    //}
}

/**
 * 取出具有人事档案管理权限的人
 */
function hr_management() {
    global $connection;
    //取出具有人事档案管理权限的角色
    $sql = "SELECT `USER_PRIV`,`FUNC_ID_STR` FROM  `USER_PRIV` ";
    $user_priv = '';
    $rs = exequery($connection, $sql);
    while ($row = mysql_fetch_assoc($rs)) {
        $FUNC_ID_STR = "," . $row["FUNC_ID_STR"];
        //判断该角色是否有人事档案管理权限
        if (strpos($FUNC_ID_STR, ",417,") !== false)
            $user_priv .= $row["USER_PRIV"] . ',';
    }
    $user_priv = substr($user_priv, 0, -1);

    if ($user_priv) {
        //取出具有人事档案管理权限的人员
        $sql = "SELECT `USER_ID` FROM USER WHERE `USER_PRIV` IN (" . SecurityFilter($user_priv) .
                ") AND DEPT_ID>0";
        $res = exequery($connection, $sql);
        $hrtoidstrs = '';
        while ($R = mysql_fetch_assoc($res)) {
            $hrtoidstrs .= $R["USER_ID"] . ",";
        }
        $hrtoidstrs = substr($hrtoidstrs, 0, -1);
    } else {
        $hrtoidstrs = "admin";
    }
    return $hrtoidstrs;
}

/**
 * 用户状态由其他状态变为离职状态时，发送离职提醒
 * @param  string $USER_ID    用户的ID
 * @param  string $USER_NAME  用户的用户名
 */
function send_dimission_remind($USER_ID, $USER_NAME, $SEND_NAME) {
    global $connection;
    //判断该用户是否已经被提醒过
    $sql = "SELECT COUNT(*) FROM HRMS WHERE USER_ID = '".SecurityFilter($USER_ID)."'";
    $rs = exequery($connection, $sql);
    $row = mysql_fetch_row($rs);
    unset($rs);
    //die;
    //如果该理智用户没有被提醒过，则发送提醒
    if ($row[0] == 1) {
        include_once("lang/cn/hr.lang.php");
        //获取具有人事档案管理权限的人员
        $hrtoidstrs = hr_management();
        //if(empty($hrtoidstrs));
        //exit;
        //获取【我的人事】的默认提醒方式
        $fun_id = 5;
        $sms_arr = checkReminds($fun_id);
        //判断提醒方式
        if ($sms_arr[0] == 1) {
            //发送短消息
            sendSms($SEND_NAME, $hrtoidstrs, $USER_NAME . $_lang["hr_dimission"], '1', '0', 'SMS');
        }
        //手机短信提醒
        if ($sms_arr[1] == 1) {
            include_once("inc/mobile_sms.inc.php");
            //$hrtoidstrs_arr = explode(',');
            if (ifSendMbSms()) {
                $newSms = new MobileSms();
                $newSms->SelfSendMore($hrtoidstrs, $USER_NAME . $_lang["hr_dimission"]);
            }
        }
        //邮件提醒
        if ($sms_arr[2] == 1) {
            include_once("api/email.class.php");
            //发送邮件
            $email = new email();
            $hrtoidstrs_arr = explode(',', $hrtoidstrs);
            //print_r($hrtoidstrs_arr);
            foreach ($hrtoidstrs_arr as $to_id) {
                //给hr发邮件
                $email->sendEmail($SEND_NAME, $to_id, $hrtoidstrs, $_lang["hr_dimission_remind"], $USER_NAME .
                        $_lang["hr_dimission"], date('Y-m-d H:i:s', time()), '', '');
            }
        }
        $sql = "UPDATE HRMS SET LABOR_REMIND_SIGN='1' WHERE USER_ID = '".SecurityFilter($USER_ID)."'";
        exequery($connection, $sql);
        unset($hrtoidstrs);
    }
}

/**
 * 用户有离职状态变为其他状态，发送状态变化提醒
 * @param  string $USER_ID   用户的ID
 * @param  string $USER_NAME 用户的用户名
 */
function send_dimission_to_other_remind($USER_ID, $USER_NAME, $SEND_NAME) {
    global $connection;
    include_once("lang/cn/hr.lang.php");
    //获取具有人事档案管理权限的人员
    $hrtoidstrs = hr_management();
    //if(empty($hrtoidstrs));
    //exit;
    //获取【我的人事】的默认提醒方式
    $fun_id = 5;
    $sms_arr = checkReminds($fun_id);
    //判断提醒方式
    if ($sms_arr[0] == 1) {
        //发送短消息
        sendSms($SEND_NAME, $hrtoidstrs, $USER_NAME . $_lang["hr_dimission_to_job"], '1', '0', 'SMS');
    }
    //手机短信提醒
    if ($sms_arr[1] == 1) {
        include_once("inc/mobile_sms.inc.php");
        //$hrtoidstrs_arr = explode(',');
        if (ifSendMbSms()) {
            $newSms = new MobileSms();
            $newSms->SelfSendMore($hrtoidstrs, $USER_NAME . $_lang["hr_dimission_to_job"]);
        }
    }
    //邮件提醒
    if ($sms_arr[2] == 1) {
        include_once("api/email.class.php");
        //发送邮件
        $email = new email();
        $hrtoidstrs_arr = explode(',', $hrtoidstrs);
        //print_r($hrtoidstrs_arr);
        foreach ($hrtoidstrs_arr as $to_id) {
            //给hr发邮件
            $email->sendEmail($SEND_NAME, $to_id, $hrtoidstrs, $_lang["hr_fanpin_remind"], $USER_NAME .
                    $_lang["hr_dimission_to_job"], date('Y-m-d H:i:s', time()), '', '');
        }
    }
    $sql = "UPDATE HRMS SET LABOR_REMIND_SIGN='0' WHERE USER_ID = '".SecurityFilter($USER_ID)."'";
    exequery($connection, $sql);
    unset($hrtoidstrs);
}

/**
 * 部门列表，没有离职项
 * @param  string $DEPT_ID     部门的ID
 * @param  string $DEPT_CHOOSE 选择的部门
 * @param  string $POST_OP	 管理范围
 * @return string $OPTION_TEXT 返回的部门列表
 */
function my_dept_tree_n($DEPT_ID, $DEPT_CHOOSE, $POST_OP) {
    global $DEEP_COUNT;
    if ($DEEP_COUNT == "")
        $DEEP_COUNT = "|";

    $connection = OpenConnection();
    $query = "SELECT * FROM department WHERE DEPT_PARENT=".SecurityFilter($DEPT_ID)." ORDER BY DEPT_NO";
    $cursor = exequery($connection, $query);
    $OPTION_TEXT = "";
    $DEEP_COUNT1 = $DEEP_COUNT;
    $DEEP_COUNT .= "　|";
    while ($ROW = mysql_fetch_array($cursor)) {
        $COUNT++;
        $DEPT_ID = $ROW["DEPT_ID"];
        $DEPT_NAME = $ROW["DEPT_NAME"];
        $DEPT_PARENT = $ROW["DEPT_PARENT"];
        $DEPT_NO = $ROW["DEPT_NO"];
        $DEPT_NAME = str_replace("<", "&lt", $DEPT_NAME);
        $DEPT_NAME = str_replace(">", "&gt", $DEPT_NAME);
        $DEPT_NAME = stripslashes($DEPT_NAME);

        if ($POST_OP == 1)
            $DEPT_PRIV = is_dept_priv($DEPT_ID);
        else
            $DEPT_PRIV = 1;

        $OPTION_TEXT_CHILD = my_dept_tree_n($DEPT_ID, $DEPT_CHOOSE, $POST_OP);

        if ($DEPT_PRIV == 1) {
            $OPTION_TEXT .= "<option ";
            if ($DEPT_ID == $DEPT_CHOOSE)
                $OPTION_TEXT .= "selected ";
            $OPTION_TEXT .= "value=$DEPT_ID>" . $DEEP_COUNT1 . "─(" . $DEPT_NO . ")-" . $DEPT_NAME . "</option>";
        }

        if ($OPTION_TEXT_CHILD != "")
            $OPTION_TEXT .= $OPTION_TEXT_CHILD;
    }
    $DEEP_COUNT = $DEEP_COUNT1;
    return $OPTION_TEXT;
}

/**
 * 职位列表
 * @param  array $arrayDatalist   传入的
 * @param  string $pid 初始值为空
 * @return string $str 返回的职位列表
 */
function outPSselect($arrayDatalist, $pid = "") {
    $str = "";
    for ($i = 0; $i < count($arrayDatalist['list']); $i++) {

        $str .= '<option value="' . $arrayDatalist['list'][$i]['positionid'] . '"';
        if ($pid == $arrayDatalist['list'][$i]['positionid']) {
            $str .= ' selected';
        }
        $str .= '>' . $arrayDatalist['list'][$i]['positionname'] . '</option>';
    }
    return $str;
}

/**
 * 拆分字符串(处理字母、汉字、数字混合字符)
 * @param string $str 需拆分的字符串
 */
function str_split_utf8($str) {
    $split = 1;
    $array = array();

    for ($i = 0; $i < strlen($str);) {
        $value = ord($str[$i]);
        if ($value > 127) {
            if ($value >= 192 && $value <= 223)
                $split = 2;
            elseif ($value >= 224 && $value <= 239)
                $split = 3;
            elseif ($value >= 240 && $value <= 247)
                $split = 4;
        } else {
            $split = 1;
        }


        $key = NULL;
        for ($j = 0; $j < $split; $j++, $i++) {
            $key .= $str[$i];
        }
        array_push($array, $key);
    }
    return $array;
}

/**
 * @进行拼音的转换
 * @param string $str 需要进行拼音转换的字段
 */
function convertPy($str) {
    global $connection;
    $splitStr = str_split_utf8($str);
    $pinYinStr = "";
    $ZiMuStr = "";

    for ($j = 0; $j < count($splitStr); $j++) {
        if (preg_match('/^[\x{4e00}-\x{9fa5}]+$/u', $splitStr[$j])) {
            //对新增加的字段的拼音进行处理的地方
            $query1 = "SELECT * FROM pinyin WHERE hz='" . SecurityFilter($splitStr[$j]) . "';";
            $result1 = exequery($connection, $query1);
            if ($row1 = mysql_fetch_array($result1)) {
                $pinYinStr .= $row1['py'];
                $ZiMuStr .= $row1['zm'];
            }
        } else {
            $pinYinStr .= $splitStr[$j];
            $ZiMuStr .= $splitStr[$j];
        }
    }
    $pinYinarr = array($pinYinStr, $ZiMuStr);
    return $pinYinarr;
}

function AddRecentSearchParam($searchArray, $mainID, $userID) {
    global $connection, $_lang;
    ;
    $searchParam = addslashes(json_encode($searchArray));
    $OptionID = -1;
    //获取最近查询数量
    $getRecentSearchCountSQL = "SELECT COUNT(*) AS CNT FROM quicksort WHERE MAIN_ID='" . SecurityFilter($mainID) . "' AND GROUP_TYPE='3' AND USER_ID='" . SecurityFilter($userID) . "'";
    $getRecentSearchCountResult = exequery($connection, $getRecentSearchCountSQL);
    if ($getRecentSearchCountRow = mysql_fetch_array($getRecentSearchCountResult)) {
        $recentSearchCount = $getRecentSearchCountRow["CNT"];
    }

    //查看是否有相同项
    $getRepeatRecentSearchOptionSQL = "SELECT OPTION_ID FROM quicksort WHERE MAIN_ID='" . SecurityFilter($mainID) . "' AND GROUP_TYPE='3' AND OPTION_PARAM='" . SecurityFilter($searchParam) . "' AND USER_ID='" . SecurityFilter($userID) . "'";

    $getRepeatRecentSearchOptionResult = exequery($connection, $getRepeatRecentSearchOptionSQL);
    if ($getRepeatRecentSearchOptionRow = mysql_fetch_array($getRepeatRecentSearchOptionResult)) {
        $OptionID = $getRepeatRecentSearchOptionRow["OPTION_ID"];
    }

    //更新相同项的时间
    if ($OptionID != -1) {
        $updateRepeatRecentSearchSQL = "UPDATE quicksort SET OPTION_INSERT_TIME=NOW()  WHERE OPTION_ID='" . SecurityFilter($OptionID) . "'";
        exequery($connection, $updateRepeatRecentSearchSQL);
    } else {
        //如果最近查询已经5条，删除最旧的一条
        if ($recentSearchCount == 5) {
            $deleteOldestRecentSearchSQL = "DELETE  FROM quicksort WHERE MAIN_ID='" . SecurityFilter($mainID) . "' AND GROUP_TYPE='3' AND USER_ID='" . SecurityFilter($userID) . "'  ORDER BY OPTION_INSERT_TIME LIMIT 1";
            exequery($connection, $deleteOldestRecentSearchSQL);
        }

        //插入新的最近查询
        $addRecentSearchSQL = "INSERT INTO quicksort (OPTION_NAME,USER_ID,OPTION_PARAM,GROUP_TYPE,GROUP_NAME,MAIN_ID) VALUES (' " . SecurityFilter($_lang["common_search"]) . date("m-d H:i:s") . "','" . SecurityFilter($userID) . "','" . SecurityFilter($searchParam) . "',3,'','" . SecurityFilter($mainID) . "')";
        exequery($connection, $addRecentSearchSQL);
    }
}

//判断是否某个变量值是否在某个范围里面，用于菜单判断等等
function IsPriviews($str_array, $priview) {
    $priview = explode(",", $priview);
    for ($i = 0; $i < sizeof($priview); $i++) {
        if (in_array($str_array, $priview))
            return true;
        else
            return false;
    }
}

function haveMenuPriv($userPriv, $menuId) {
    global $connection;
    //获取用户的菜单权限
    $privSql = "SELECT * FROM user_priv WHERE USER_PRIV = '" . SecurityFilter($userPriv) . "'";
    $privRs = exequery($connection, $privSql);
    $privRow = mysql_fetch_array($privRs);
    $func_id_str = $privRow["FUNC_ID_STR"];
    return IsPriviews($menuId, $func_id_str);
}

function havaPortalPriv($portalId, $userId) {
    global $connection;
    //获取用户的部门信息和角色信息
    $userInfo = getUserInfo($userId, 2);
    $deptId = $userInfo[0]["DEPT_ID"];
    $userPriv = $userInfo[0]["USER_PRIV"];
    //有界面管理菜单权限的就算有权限
    if (haveMenuPriv($userPriv, "101"))
        return true;
    $sql = "SELECT PORTAL_ID FROM index_portal
			WHERE PORTAL_ID ='" . SecurityFilter($portalId) . "'
			AND(
				(
					(VIEW_DEPT_ID='DEPT_ALL')
					or
					(INStr(VIEW_DEPT_ID,',".SecurityFilter($deptId).",')>0 or INStr(VIEW_DEPT_ID,'".SecurityFilter($deptId).",')=1)
					or
					(INStr(VIEW_PRIV_ID,',".SecurityFilter($userPriv).",')>0 or INStr(VIEW_PRIV_ID,'".SecurityFilter($userPriv).",')=1)
					or
					(INStr(VIEW_USER_ID,',".SecurityFilter($userId).",')>0 or INStr(VIEW_USER_ID,'".SecurityFilter($userId).",')=1)
				)
				OR(
					(DEPT_ID='DEPT_ALL')
					or
					(INStr(DEPT_ID,',".SecurityFilter($deptId).",')>0 or INStr(DEPT_ID,'".SecurityFilter($deptId).",')=1)
					or
					(INStr(PRIV_ID,',".SecurityFilter($userPriv)."')>0 or INStr(PRIV_ID,'".SecurityFilter($userPriv).",')=1)
					or
					(INStr(USER_ID,',".SecurityFilter($userId).",')>0 or INStr(USER_ID,'".SecurityFilter($userId).",')=1)
				)";
    if ($portalId == 1) {
        $sql .= "
				OR(
					VIEW_USER_ID = 0 AND VIEW_PRIV_ID = 0
				)
				";
    }
    $sql .= ")";
    $rs = exequery($connection, $sql);
    $rows = mysql_fetch_array($rs);
    if ($rows["PORTAL_ID"])
        return true;
    else
        return false;
}

/*
 * 添加播报日志
 * @param $logUserID             用户ID
 * @param $logSourceTable        日志来源表
 * @param $logSourceKeyField     日志来源表主键字段
 * @param $logSourceKeyValue     日志来源表主键值
 * @param $logSourceField     	 日志来源表字段
 * @param $logOpreationType      日志类型   new、delete
 * @param $logRemark      		 备注
 */

function AddBroacastLog($logUserID, $logSourceTable, $logSourceKeyField, $logSourceKeyValue, $logSourceField, $logOpreationType, $logRemark = "") {
    global $connection;
    $query = "INSERT INTO sys_broadcast
			(`LOG_USER_ID`,
			`LOG_SOURCE_TABLE`,
			`LOG_SOURCE_KEY_FIELD`,
			`LOG_SOURCE_KEY_VALUE`,
			`LOG_SOURCE_FIELD`,
			`LOG_OPREATION_TYPE`,
			`LOG_REMARK`)
			VALUES
			(
				'" . SecurityFilter($logUserID) . "',
				'" . SecurityFilter($logSourceTable) . "',
				'" . SecurityFilter($logSourceKeyField) . "',
				'" . SecurityFilter($logSourceKeyValue) . "',
				'" . SecurityFilter($logSourceField) . "',
				'" . SecurityFilter($logOpreationType) . "',
				'" . SecurityFilter($logRemark) . "'
			);";
    exequery($connection, $query);
}

/*
 * 取消首页内部消息提醒
 * @param $TO_ID          用户ID
 * @param $TABLE_ID       提醒记录的ID
 * @param $TABLE_NAME     记录的表名
 */

function SMSCancelRemind($TO_ID, $TABLE_ID, $TABLE_NAME = "") {
    global $connection;
    if ($TABLE_NAME)
        $query = "UPDATE SMS SET REMIND_FLAG=0 WHERE TO_ID='" . SecurityFilter($TO_ID) . "' AND TABLE_ID='" . SecurityFilter($TABLE_ID) . "' AND TABLE_NAME='" . SecurityFilter($TABLE_NAME) . "'";
    else
        $query = "UPDATE SMS SET REMIND_FLAG=0 WHERE TO_ID='" . SecurityFilter($TO_ID) . "' AND TABLE_ID='" . SecurityFilter($TABLE_ID) . "' ";
    exequery($connection, $query);
}

/**
 * 获取附件地址(webservice)
 * @param string $attachmentid 附件ID(多个用,隔开)
 * @param string $attachmentName 附件名称
 * @return string 附件地址(多个用,隔开 如果没有附件则返回空)
 */
function GetATTACHMENTURL($attachmentid, $attachmentName) {
    if (trim($attachmentid) != "") {
        $attachmentidSplit = explode(",", $attachmentid);
        $attachmentNameSplit = explode("*", $attachmentName);
        $attachmentArray = "";
        for ($i = 0; $i < count($attachmentidSplit); $i ++) {
            if (trim($attachmentidSplit [$i]) == "") {
                continue;
            }
            try {
                global $ATTACH_PATH;
                $attachmentDir = str_replace(ROOT_PATH, ROOT_URL, $ATTACH_PATH) . $attachmentidSplit [$i] . "/" . $attachmentNameSplit [$i];
            } catch (Exception $e) {
                $attachmentDir = "";
            }
            if ($attachmentDir !== "") {
                if ($attachmentArray == "") {
                    $attachmentArray = $attachmentDir;
                } else {
                    $attachmentArray .= "," . $attachmentDir;
                }
            }
        }
        return $attachmentArray;
    } else {
        return "";
    }
}

/*
 * 流程数据外发函数
 * @param $url         外发地址
 * @param $data        外发数据数组
 * @param $send_param  外发需要的参数
 */

function post_data($url, $data, $send_param = "") {
    $data["PRINT_MODEL"] = "";
    $encoded = "";
    while (list($k, $v) = each($data)) {
        $encoded .= ($encoded ? "&" : "");
        //$encoded .= rawurlencode($k)."=".rawurlencode($v);
        $encoded .= $k . "=" . rawurlencode($v);
    }

    if ($send_param != "")
        $encoded .= "&" . $send_param;
    if (!function_exists(curl_init)) {

    } else {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Expect:'));
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $encoded);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_HEADER, false);
        curl_setopt($ch, CURLOPT_NOBODY, false);
        curl_exec($ch);
        curl_close($ch);
    }
}

/**
 * 数据外发
 * @global type $connection
 * @param type $FLOW_ID
 * @param type $RUN_ID
 * @param type $FLOW_PRCS
 * @param type $PRCS_ID
 * @param type $PRCS_USER
 * @param type $PRCS_OP_USER
 * @param type $OP
 */
function getSendNeedDataBeforeSend($FLOW_ID, $RUN_ID, $FLOW_PRCS, $PRCS_ID, $PRCS_USER, $PRCS_OP_USER, $OP) {
    global $connection;
    //在这里根据$PRCS_ID查询出当前该流程处在哪个节点，对比$FLOW_PRCS，即可知道是前进还是后退
    $sqls = "SELECT * FROM flow_run_prcs WHERE RUN_ID='" . SecurityFilter($RUN_ID) . "' AND PRCS_ID='" . SecurityFilter($PRCS_ID) . "'";
    $ress = exequery($connection, $sqls);
    $rows = mysql_fetch_array($ress);
    $now_flow_prcs = $rows["FLOW_PRCS"];

    $sql = "SELECT FLOW_OUTSEND_TYPE FROM flow_process WHERE FLOW_ID = '" . SecurityFilter($FLOW_ID) . "' AND PRCS_ID = '" . SecurityFilter($now_flow_prcs) . "'";
    $rs = exequery($connection, $sql);
    $row = mysql_fetch_array($rs);
    $flowSendType = $row['FLOW_OUTSEND_TYPE'];
    switch ($flowSendType) {
        case 1:
            return urlAddrSend($FLOW_ID, $RUN_ID, $FLOW_PRCS, $PRCS_ID, $PRCS_USER, $PRCS_OP_USER, $OP, $now_flow_prcs);
            break;
        case 2:
            return innerDataSend($FLOW_ID, $RUN_ID, $FLOW_PRCS, $PRCS_ID, $PRCS_USER, $PRCS_OP_USER, $OP, $now_flow_prcs);
            break;
        case 3:
            return outerDatabaseSend($FLOW_ID, $RUN_ID, $FLOW_PRCS, $PRCS_USER, $PRCS_OP_USER, $now_flow_prcs);
            break;
    }
}

function innerDataSend($FLOW_ID, $RUN_ID, $FLOW_PRCS, $PRCS_ID, $PRCS_USER, $PRCS_OP_USER, $OP, $now_flow_prcs) {
    global $connection;
    $workFlowInstance = new fixedWorkflow($FLOW_ID);
    $workFlowInstance->runId = $RUN_ID;
    $config_url = $workFlowInstance->getOutSend($now_flow_prcs);

    if (($FLOW_PRCS != "" && $now_flow_prcs > $FLOW_PRCS) || $config_url == "")
        return true; //如果是后退的流程，或者外发地址为空，不外发数据

    $fieldConfig = file_get_contents($config_url);
    $fieldArray = json_decode($fieldConfig, true);

    $outsend_url = $fieldArray['sendUrl'];
    $outsend_arr = parse_url($outsend_url);
    $send_param = $outsend_arr["query"];
    if ($send_param != "")
        $url = substr($outsend_url, 0, strpos($outsend_url, $send_param) - 1);
    else
        $url = $outsend_url;

    $fieldMap = $fieldArray['fieldMap'];
    $flow_data_arr = array();
    //取表单数据新
    $form_data = $workFlowInstance->getFormDataNew();
    $flowRunInfo = $workFlowInstance->flowRunningInfo();
    $flowInfo = $workFlowInstance->getFlowInfo();
    $nodeInfo = $workFlowInstance->getNodeInfo();
    //$PRINT_MODEL        = $flowInfo["PRINT_MODEL"];
    $RUN_NAME = $flowRunInfo["RUN_NAME"];
    $PRCS_DATE_TIME = $flowRunInfo["CREATE_TIME"];
    $PRCS_DATE = strtok($PRCS_DATE_TIME, " ");
    $OP_FLAG = $workFlowInstance->isOpFlag($_SESSION["LOGIN_USER_ID"], $PRCS_ID);
    $PRCS_ITEM = $nodeInfo[$FLOW_PRCS]["PRCS_ITEM"];
    $PRCS_ITEM_CAPACITY = $nodeInfo[$FLOW_PRCS]["PRCS_ITEM_CAPACITY"];
    $PRCS_ITEM_AUTO = $nodeInfo[$FLOW_PRCS]["PRCS_ITEM_AUTO"];
    $PRCS_ITEM_REQUIRED = $nodeInfo[$FLOW_PRCS]["PRCS_ITEM_REQUIRED"];


    $query = "SELECT * FROM flow_form_type WHERE FORM_ID='" . SecurityFilter($workFlowInstance->formId) . "'";
    $cursor1 = exequery($connection, $query);
    if ($ROW = mysql_fetch_array($cursor1)) {
        $FORM_NAME = $ROW ["FORM_NAME"];
        $PRINT_MODEL = $ROW ["PRINT_MODEL"];
    }
    //----------- 步骤1 -------------
    $query = "SELECT * FROM flow_run_prcs WHERE RUN_ID='" . SecurityFilter($RUN_ID) . "' AND PRCS_ID=1";
    $cursor = exequery($connection, $query);
    if ($ROW = mysql_fetch_array($cursor)) {
        $PRCS_TIME1 = $ROW ["PRCS_TIME"];
        $PRCS_TIME1 = format_date($PRCS_TIME1);
    }
    $PRINT_MODEL = str_replace("#[表单]", "<b>$FORM_NAME</b>", $PRINT_MODEL);
    $PRINT_MODEL = str_replace("#[流水号]", $RUN_NAME, $PRINT_MODEL);
    $PRINT_MODEL = str_replace("#[时间]", "日期：$PRCS_TIME1", $PRINT_MODEL);

    //实例化表单解析类
    $iAnalyticFormView = new AnalyticFormView($PRINT_MODEL);
    //必要的参数
    $iAnalyticFormView->flowType = $workFlowInstance->flowType; //设置流程种类
    $iAnalyticFormView->flowId = $FLOW_ID;                    //设置流程类别
    $iAnalyticFormView->formName = $FORM_NAME;                  //设置流程表单名称
    $iAnalyticFormView->runId = $RUN_ID;                     //设置当前运行流程id
    $iAnalyticFormView->prcsId = $PRCS_ID;                    //设置当前运行流程序号
    $iAnalyticFormView->flowPrcs = $FLOW_PRCS;                  //设置当前运行流程节点
    $iAnalyticFormView->formData = $form_data;                  //流程表单数据
    $iAnalyticFormView->opFlag = $OP_FLAG;                    //设置是否是主办人
    $iAnalyticFormView->runSeq = $flowRunInfo["RUN_SEQ"];     //设置流程的流水号
    $iAnalyticFormView->needTotal = "1";                         //用PHP的方式进行统计
    $iAnalyticFormView->foroutmail = "1";                         //用外发邮件需要的方式获取表单内容
    //调用表单解析
    $PRINT_MODEL_CONTENT = $iAnalyticFormView->analytic_form();

    //获取表单TITLE
    $formElement = html_element($PRINT_MODEL);
    $ITEM_ID = 0;
    for ($i = 0; $i < count($formElement); $i++) {
        $ELEMENT = $formElement[$i];
        $ENAME = get_attr($ELEMENT, "NAME");
        $ID = get_attr($ELEMENT, "ID");
        $EVALUE = get_attr($ELEMENT, "VALUE");
        $EITLE = get_attr($ELEMENT, "TITLE");
        $ECLASS = get_attr($ELEMENT, "CLASS");
        $EITLE = str_replace("+", "＋", $EITLE);
        $EITLE = str_replace("#", "＃", $EITLE);
        $EITLE = str_replace(" ", "", $EITLE);
        if ($ECLASS != "DATE" && $ECLASS != "time") {
            //用title=>value的方式，将表单控件的值传递
            if ($fieldMap[$EITLE]) {
                $fieldName = $fieldMap[$EITLE];
            } else {
                $fieldName = $EITLE;
            }
            $flow_data_arr[$fieldName] = $form_data[$ID];
        }
    }
    //其余参数
    $flow_data_arr["FORM_ID"] = $workFlowInstance->formId;      //流程表单ID
    $flow_data_arr["FLOW_ID"] = $FLOW_ID;                       //流程类别ID
    $flow_data_arr["RUN_ID"] = $RUN_ID;                        //流程运行ID
    $flow_data_arr["FLOW_NAME"] = $workFlowInstance->flowName;    //流程名称
    $flow_data_arr["RUN_NAME"] = $RUN_NAME;                      //流程运行名称
    $flow_data_arr["RUN_SEQ"] = $flowRunInfo["RUN_SEQ"];        //流程的流水号
    $flow_data_arr["FLOW_PRCS"] = $FLOW_PRCS;                     //当前运行流程节点
    $flow_data_arr["PRCS_ID"] = $PRCS_ID;                       //当前运行流程序号
    $flow_data_arr["PRCS_USER"] = $PRCS_USER;                     //经办人
    $flow_data_arr["PRCS_OP_USER"] = $PRCS_OP_USER;                  //主办人
    $flow_data_arr["PRCS_OP_USER_NAME"] = getUserNameNew($PRCS_OP_USER);  //主办人NAME
    $flow_data_arr["OP"] = $OP;                            //操作类型
    $flow_data_arr["LOGIN_USER_ID"] = $_SESSION["LOGIN_USER_ID"];     //当前用户ID
    $flow_data_arr["LOGIN_USER_NAME"] = $_SESSION["LOGIN_USER_NAME"];   //当前用户NAME
    $flow_data_arr["FLOW_TYPE"] = $workFlowInstance->flowType;    //流程种类
    $flow_data_arr["FLOW_DOC"] = $workFlowInstance->flowDoc;     //结束归档
    $flow_data_arr["FORM_NAME"] = $flowInfo["FORM_NAME"];         //流程表单名称
    $flow_data_arr["CREATOR"] = $flowRunInfo["CREATOR"];        //流程创建者
    $flow_data_arr["PRCS_DATE"] = $PRCS_DATE;                     //当前运行流程创建日期
    $flow_data_arr["PRCS_DATE_TIME"] = $PRCS_DATE_TIME;                //当前运行流程创建日期时间
    $flow_data_arr["OP_FLAG"] = $OP_FLAG;                       //是否是主办人
    $flow_data_arr["PRCS_ITEM"] = $PRCS_ITEM;                     //可以编辑的字段
    $flow_data_arr["PRCS_ITEM_CAPACITY"] = $PRCS_ITEM_CAPACITY;            //智能获值字段
    $flow_data_arr["PRCS_ITEM_AUTO"] = $PRCS_ITEM_AUTO;                //自动获值字段
    $flow_data_arr["PRCS_ITEM_REQUIRED"] = $PRCS_ITEM_REQUIRED;            //必填字段
    //签办反馈
    $query = "SELECT * FROM flow_run_feedback WHERE RUN_ID=".SecurityFilter($RUN_ID)." ORDER BY EDIT_TIME DESC";
    $cursor = exequery($connection, $query);
    $fb_num = 0;
    while ($ROW = mysql_fetch_array($cursor)) {
        $USER_ID = $ROW["USER_ID"];
        $CONTENT = $ROW["CONTENT"];
        $ATTACHMENT_ID = $ROW["ATTACHMENT_ID"];
        $ATTACHMENT_NAME = $ROW["ATTACHMENT_NAME"];
        $EDIT_TIME = $ROW["EDIT_TIME"];
        $SEQ_ID = $ROW["SEQ_ID"];
        $FLOW_PRCS = $ROW["FLOW_PRCS"];
        $prcsId = $ROW["PRCS_ID"];
        $flow_data_arr["FEEDBACK_" . $fb_num] = $USER_ID . "@_@" . $CONTENT . "@_@" . $ATTACHMENT_ID . "@_@" . $ATTACHMENT_NAME . "@_@" . $EDIT_TIME . "@_@" . $SEQ_ID . "@_@" . $FLOW_PRCS . "@_@" . $prcsId;                    //签办反馈，相关信息用“@_@”连接
        $fb_num++;
    }
    //公共附件
    $flow_data_arr["PUBLIC_ATTACHMENT_ID"] = $flowRunInfo["ATTACHMENT_ID"];              //公共附件ID
    $flow_data_arr["PUBLIC_ATTACHMENT_NAME"] = $flowRunInfo["ATTACHMENT_NAME"];            //公共附件NAME
    //相关文档
    $flow_data_arr["LINK_DOC"] = $flowRunInfo["LINK_DOC"];                   //相关文档
    //子流程
    $sub_workflow_ids_total = "";
    $sub_workflow_sql = "SELECT SUB_FLOW_RUN_IDS FROM  flow_run_prcs  WHERE RUN_ID = '" . SecurityFilter($RUN_ID) . "' ";
    $sub_workflow_rs = exequery($connection, $sub_workflow_sql);
    while ($sub_workflow_rows = mysql_fetch_array($sub_workflow_rs)) {
        $sub_workflow_rows_array = explode(",", trim($sub_workflow_rows["SUB_FLOW_RUN_IDS"], ","));
        for ($p = 0; $p < count($sub_workflow_rows_array); $p++) {
            if (!find_id($sub_workflow_ids_total, $sub_workflow_rows_array[$p]))
                $sub_workflow_ids_total .= $sub_workflow_rows_array[$p] . ",";
        }
    }
    $sub_workflow_ids_array = explode(",", trim($sub_workflow_ids_total, ","));
    $sub_workflow_ids_count = count($sub_workflow_ids_array);
    if ($sub_workflow_ids_array[0] == "")
        $sub_workflow_ids_count--;
    if ($sub_workflow_ids_count > 0) {
        for ($q = 0; $q < $sub_workflow_ids_count; $q++) {
            $sub_detail_sql = "SELECT * FROM flow_run WHERE RUN_ID = '" .SecurityFilter($sub_workflow_ids_array[$q]) . "' ";
            $sub_detail_rs = exequery($connection, $sub_detail_sql);
            if ($sub_detail_rows = mysql_fetch_array($sub_detail_rs)) {
                $sub_workflow_name = $sub_detail_rows["RUN_NAME"];
                $sub_workflow_id = $sub_detail_rows["FLOW_ID"];
                $CREATOR = $sub_detail_rows["CREATOR"];
                $CREATE_TIME = $sub_detail_rows["CREATE_TIME"];
                $sub_workflow_run_id = $sub_detail_rows["RUN_ID"];
                $sub_workFlowInstance = new fixedWorkflow($sub_workflow_id);
                $sub_workFlowInstance->runId = $sub_workflow_run_id;
                $flow_data_arr["SUB_WORKFLOW_" . $q . "_RUN_NAME"] = $sub_workflow_name;    //子流程运行名称
                $flow_data_arr["SUB_WORKFLOW_" . $q . "_RUN_ID"] = $sub_workflow_run_id;  //子流程运行ID
                $flow_data_arr["SUB_WORKFLOW_" . $q . "_FLOW_ID"] = $sub_workflow_id;      //子流程类别ID
                $flow_data_arr["SUB_WORKFLOW_" . $q . "_CREATOR"] = $CREATOR;              //子流程创建者
                $flow_data_arr["SUB_WORKFLOW_" . $q . "_CREATE_TIME"] = $CREATE_TIME;          //子流程创建时间
                $flow_data_arr["SUB_WORKFLOW_" . $q . "_FORM_ID"] = $sub_workFlowInstance->formId; //子流程表单ID
                $flow_data_arr["SUB_WORKFLOW_" . $q . "_FLOW_NAME"] = $sub_workFlowInstance->flowName; //子流程名称
            }
        }
    }

    $flow_data_arr["PRINT_MODEL"] = $PRINT_MODEL_CONTENT;              //带数据的流程表单

    $result_data = post_data($url, $flow_data_arr, $send_param);
    return true;
}

function outerDatabaseSend($FLOW_ID, $RUN_ID, $FLOW_PRCS, $PRCS_USER, $PRCS_OP_USER, $now_flow_prcs) {
    global $connection;
    $workFlowInstance = new fixedWorkflow($FLOW_ID);
    $workFlowInstance->runId = $RUN_ID;
    $config_url = $workFlowInstance->getOutSend($now_flow_prcs);

    if (($FLOW_PRCS != "" && $now_flow_prcs > $FLOW_PRCS) || $config_url == "")
        return true; //如果是后退的流程，或者外发地址为空，不外发数据

    $fieldConfig = file_get_contents($config_url);
    $fieldArray = json_decode($fieldConfig, true);
    $dbHost = $fieldArray['dbHost'];
    $dbPort = $fieldArray['dbPort'];
    $dbType = $fieldArray['dbType'];
    $dbUser = $fieldArray['dbUser'];
    $dbPass = $fieldArray['dbPass'];
    $dbName = $fieldArray['dbName'];
    $tableName = $fieldArray['tableName'];
    $fieldMap = $fieldArray['fieldMap'];
    include ('inc/data_send/db/' . $dbType . '.php');
    $db = new $dbType();
    $db->sqlConnect($dbHost, $dbUser, $dbPass, $dbName, $dbPort);

    $flow_data_arr = array();
    //取表单数据新
    $form_data = $workFlowInstance->getFormDataNew();
    $flowRunInfo = $workFlowInstance->flowRunningInfo();
    $RUN_NAME = $flowRunInfo["RUN_NAME"];
    $PRCS_DATE_TIME = $flowRunInfo["CREATE_TIME"];
    $PRCS_DATE = strtok($PRCS_DATE_TIME, " ");
    $query = "SELECT * FROM flow_form_type WHERE FORM_ID='" . SecurityFilter($workFlowInstance->formId) . "'";
    $cursor1 = exequery($connection, $query);
    if ($ROW = mysql_fetch_array($cursor1)) {
        $FORM_NAME = $ROW ["FORM_NAME"];
        $PRINT_MODEL = $ROW ["PRINT_MODEL"];
    }
    //----------- 步骤1 -------------
    $query = "SELECT * FROM flow_run_prcs WHERE RUN_ID='" . SecurityFilter($RUN_ID) . "' AND PRCS_ID=1";
    $cursor = exequery($connection, $query);
    if ($ROW = mysql_fetch_array($cursor)) {
        $PRCS_TIME1 = $ROW ["PRCS_TIME"];
        $PRCS_TIME1 = format_date($PRCS_TIME1);
    }
    $PRINT_MODEL = str_replace("#[表单]", "<b>$FORM_NAME</b>", $PRINT_MODEL);
    $PRINT_MODEL = str_replace("#[流水号]", $RUN_NAME, $PRINT_MODEL);
    $PRINT_MODEL = str_replace("#[时间]", "日期：$PRCS_TIME1", $PRINT_MODEL);
    //获取表单TITLE
    $formElement = html_element($PRINT_MODEL);
    $ITEM_ID = 0;
    for ($i = 0; $i < count($formElement); $i++) {
        $ELEMENT = $formElement[$i];
        $ENAME = get_attr($ELEMENT, "NAME");
        $ID = get_attr($ELEMENT, "ID");
        $EVALUE = get_attr($ELEMENT, "VALUE");
        $EITLE = get_attr($ELEMENT, "TITLE");
        $ECLASS = get_attr($ELEMENT, "CLASS");
        $EITLE = str_replace("+", "＋", $EITLE);
        $EITLE = str_replace("#", "＃", $EITLE);
        $EITLE = str_replace(" ", "", $EITLE);
        if ($ECLASS != "DATE" && $ECLASS != "time") {
            //用title=>value的方式，将表单控件的值传递
            $flow_data_arr[$EITLE] = $form_data[$ID];
        }
    }
    //其余参数
    $flow_data_arr["RUN_ID"] = $RUN_ID;                      //流程运行名称
    $flow_data_arr["RUN_NAME"] = $RUN_NAME;                      //流程运行名称
    $flow_data_arr["RUN_SEQ"] = $flowRunInfo["RUN_SEQ"];        //流程的流水号
    $flow_data_arr["PRCS_USER"] = $PRCS_USER;                     //经办人
    $flow_data_arr["PRCS_OP_USER"] = $PRCS_OP_USER;                  //主办人
    $flow_data_arr["PRCS_OP_USER_NAME"] = getUserNameNew($PRCS_OP_USER);  //主办人NAME
    $flow_data_arr["LOGIN_USER_ID"] = $_SESSION["LOGIN_USER_ID"];     //当前用户ID
    $flow_data_arr["LOGIN_USER_NAME"] = $_SESSION["LOGIN_USER_NAME"];   //当前用户NAME
    $flow_data_arr["PRCS_DATE"] = $PRCS_DATE;                     //当前运行流程创建日期
    $flow_data_arr["PRCS_DATE_TIME"] = $PRCS_DATE_TIME;                //当前运行流程创建日期时间
    //公共附件
    $flow_data_arr["PUBLIC_ATTACHMENT_ID"] = $flowRunInfo["ATTACHMENT_ID"];              //公共附件ID
    $flow_data_arr["PUBLIC_ATTACHMENT_NAME"] = $flowRunInfo["ATTACHMENT_NAME"];            //公共附件NAME
    //相关文档
    $flow_data_arr["LINK_DOC"] = $flowRunInfo["LINK_DOC"];                   //相关文档
    $sendData = array();
    foreach ($fieldMap as $key => $value) {
        $sendData[$value] = $flow_data_arr[$key];
    }
    return $db->sqlInsert($sendData, $tableName);
}

/*
 * 把原来的外发的那一段内容抽出来做成函数，主要完成外发之前的数据验证拼接等
 * @param $FLOW_ID         流程类别ID
 * @param $RUN_ID          流程运行ID
 * @param $FLOW_PRCS       流程节点
 * @param $PRCS_ID         流程走的的步骤
 */

function urlAddrSend($FLOW_ID, $RUN_ID, $FLOW_PRCS, $PRCS_ID, $PRCS_USER, $PRCS_OP_USER, $OP, $now_flow_prcs) {
    global $connection;
    $workFlowInstance = new fixedWorkflow($FLOW_ID);
    $workFlowInstance->runId = $RUN_ID;

    //在这里根据$PRCS_ID查询出当前该流程处在哪个节点，对比$FLOW_PRCS，即可知道是前进还是后退
//	$sqls = "SELECT * FROM flow_run_prcs WHERE RUN_ID='".$RUN_ID."' AND PRCS_ID='".$PRCS_ID."'";
//	$ress = exequery($connection,$sqls);
//	$rows = mysql_fetch_array($ress);
//	$now_flow_prcs = $rows["FLOW_PRCS"];
    //获取外发地址
    $outsend_url = $workFlowInstance->getOutSend($now_flow_prcs);

    if (($FLOW_PRCS != "" && $now_flow_prcs > $FLOW_PRCS) || $outsend_url == "") {
        return true;
        //如果是后退的流程，或者外发地址为空，不外发数据
    } else {
        $outsend_arr = parse_url($outsend_url);
        $send_param = $outsend_arr["query"];
        if ($send_param != "")
            $url = substr($outsend_url, 0, strpos($outsend_url, $send_param) - 1);
        else
            $url = $outsend_url;
        $flow_data_arr = array();
        //取表单数据新
        $form_data = $workFlowInstance->getFormDataNew();
        $flowRunInfo = $workFlowInstance->flowRunningInfo();
        $flowInfo = $workFlowInstance->getFlowInfo();
        $nodeInfo = $workFlowInstance->getNodeInfo();
        //$PRINT_MODEL        = $flowInfo["PRINT_MODEL"];
        $RUN_NAME = $flowRunInfo["RUN_NAME"];
        $PRCS_DATE_TIME = $flowRunInfo["CREATE_TIME"];
        $PRCS_DATE = strtok($PRCS_DATE_TIME, " ");
        $OP_FLAG = $workFlowInstance->isOpFlag($_SESSION["LOGIN_USER_ID"], $PRCS_ID);
        $PRCS_ITEM = $nodeInfo[$FLOW_PRCS]["PRCS_ITEM"];
        $PRCS_ITEM_CAPACITY = $nodeInfo[$FLOW_PRCS]["PRCS_ITEM_CAPACITY"];
        $PRCS_ITEM_AUTO = $nodeInfo[$FLOW_PRCS]["PRCS_ITEM_AUTO"];
        $PRCS_ITEM_REQUIRED = $nodeInfo[$FLOW_PRCS]["PRCS_ITEM_REQUIRED"];


        $query = "SELECT * FROM flow_form_type WHERE FORM_ID='" . SecurityFilter($workFlowInstance->formId) . "'";
        $cursor1 = exequery($connection, $query);
        if ($ROW = mysql_fetch_array($cursor1)) {
            $FORM_NAME = $ROW ["FORM_NAME"];
            $PRINT_MODEL = $ROW ["PRINT_MODEL"];
        }
        //----------- 步骤1 -------------
        $query = "SELECT * FROM flow_run_prcs WHERE RUN_ID='" . SecurityFilter($RUN_ID) . "' AND PRCS_ID=1";
        $cursor = exequery($connection, $query);
        if ($ROW = mysql_fetch_array($cursor)) {
            $PRCS_TIME1 = $ROW ["PRCS_TIME"];
            $PRCS_TIME1 = format_date($PRCS_TIME1);
        }
        $PRINT_MODEL = str_replace("#[表单]", "<b>$FORM_NAME</b>", $PRINT_MODEL);
        $PRINT_MODEL = str_replace("#[流水号]", $RUN_NAME, $PRINT_MODEL);
        $PRINT_MODEL = str_replace("#[时间]", "日期：$PRCS_TIME1", $PRINT_MODEL);

        //实例化表单解析类
        $iAnalyticFormView = new AnalyticFormView($PRINT_MODEL);
        //必要的参数
        $iAnalyticFormView->flowType = $workFlowInstance->flowType; //设置流程种类
        $iAnalyticFormView->flowId = $FLOW_ID;                    //设置流程类别
        $iAnalyticFormView->formName = $FORM_NAME;                  //设置流程表单名称
        $iAnalyticFormView->runId = $RUN_ID;                     //设置当前运行流程id
        $iAnalyticFormView->prcsId = $PRCS_ID;                    //设置当前运行流程序号
        $iAnalyticFormView->flowPrcs = $FLOW_PRCS;                  //设置当前运行流程节点
        $iAnalyticFormView->formData = $form_data;                  //流程表单数据
        $iAnalyticFormView->opFlag = $OP_FLAG;                    //设置是否是主办人
        $iAnalyticFormView->runSeq = $flowRunInfo["RUN_SEQ"];     //设置流程的流水号
        $iAnalyticFormView->needTotal = "1";                         //用PHP的方式进行统计
        $iAnalyticFormView->foroutmail = "1";                         //用外发邮件需要的方式获取表单内容
        //调用表单解析
        $PRINT_MODEL_CONTENT = $iAnalyticFormView->analytic_form();

        //获取表单TITLE
        $formElement = html_element($PRINT_MODEL);
        $ITEM_ID = 0;
        for ($i = 0; $i < count($formElement); $i++) {
            $ELEMENT = $formElement[$i];
            $ENAME = get_attr($ELEMENT, "NAME");
            $ID = get_attr($ELEMENT, "ID");
            $EVALUE = get_attr($ELEMENT, "VALUE");
            $EITLE = get_attr($ELEMENT, "TITLE");
            $ECLASS = get_attr($ELEMENT, "CLASS");
            $EITLE = str_replace("+", "＋", $EITLE);
            $EITLE = str_replace("#", "＃", $EITLE);
            $EITLE = str_replace(" ", "", $EITLE);
            if ($ECLASS != "DATE" && $ECLASS != "time") {
                //用title=>value的方式，将表单控件的值传递
                $flow_data_arr[$EITLE] = $form_data[$ID];
            }
        }
        //其余参数
        $flow_data_arr["FORM_ID"] = $workFlowInstance->formId;      //流程表单ID
        $flow_data_arr["FLOW_ID"] = $FLOW_ID;                       //流程类别ID
        $flow_data_arr["RUN_ID"] = $RUN_ID;                        //流程运行ID
        $flow_data_arr["FLOW_NAME"] = $workFlowInstance->flowName;    //流程名称
        $flow_data_arr["RUN_NAME"] = $RUN_NAME;                      //流程运行名称
        $flow_data_arr["RUN_SEQ"] = $flowRunInfo["RUN_SEQ"];        //流程的流水号
        $flow_data_arr["FLOW_PRCS"] = $FLOW_PRCS;                     //当前运行流程节点
        $flow_data_arr["PRCS_ID"] = $PRCS_ID;                       //当前运行流程序号
        $flow_data_arr["PRCS_USER"] = $PRCS_USER;                     //经办人
        $flow_data_arr["PRCS_OP_USER"] = $PRCS_OP_USER;                  //主办人
        $flow_data_arr["PRCS_OP_USER_NAME"] = getUserNameNew($PRCS_OP_USER);  //主办人NAME
        $flow_data_arr["OP"] = $OP;                            //操作类型
        $flow_data_arr["LOGIN_USER_ID"] = $_SESSION["LOGIN_USER_ID"];     //当前用户ID
        $flow_data_arr["LOGIN_USER_NAME"] = $_SESSION["LOGIN_USER_NAME"];   //当前用户NAME
        $flow_data_arr["FLOW_TYPE"] = $workFlowInstance->flowType;    //流程种类
        $flow_data_arr["FLOW_DOC"] = $workFlowInstance->flowDoc;     //结束归档
        $flow_data_arr["FORM_NAME"] = $flowInfo["FORM_NAME"];         //流程表单名称
        $flow_data_arr["CREATOR"] = $flowRunInfo["CREATOR"];        //流程创建者
        $flow_data_arr["PRCS_DATE"] = $PRCS_DATE;                     //当前运行流程创建日期
        $flow_data_arr["PRCS_DATE_TIME"] = $PRCS_DATE_TIME;                //当前运行流程创建日期时间
        $flow_data_arr["OP_FLAG"] = $OP_FLAG;                       //是否是主办人
        $flow_data_arr["PRCS_ITEM"] = $PRCS_ITEM;                     //可以编辑的字段
        $flow_data_arr["PRCS_ITEM_CAPACITY"] = $PRCS_ITEM_CAPACITY;            //智能获值字段
        $flow_data_arr["PRCS_ITEM_AUTO"] = $PRCS_ITEM_AUTO;                //自动获值字段
        $flow_data_arr["PRCS_ITEM_REQUIRED"] = $PRCS_ITEM_REQUIRED;            //必填字段
        //签办反馈
        $query = "SELECT * FROM flow_run_feedback WHERE RUN_ID=".SecurityFilter($RUN_ID)." ORDER BY EDIT_TIME DESC";
        $cursor = exequery($connection, $query);
        $fb_num = 0;
        while ($ROW = mysql_fetch_array($cursor)) {
            $USER_ID = $ROW["USER_ID"];
            $CONTENT = $ROW["CONTENT"];
            $ATTACHMENT_ID = $ROW["ATTACHMENT_ID"];
            $ATTACHMENT_NAME = $ROW["ATTACHMENT_NAME"];
            $EDIT_TIME = $ROW["EDIT_TIME"];
            $SEQ_ID = $ROW["SEQ_ID"];
            $FLOW_PRCS = $ROW["FLOW_PRCS"];
            $prcsId = $ROW["PRCS_ID"];
            $flow_data_arr["FEEDBACK_" . $fb_num] = $USER_ID . "@_@" . $CONTENT . "@_@" . $ATTACHMENT_ID . "@_@" . $ATTACHMENT_NAME . "@_@" . $EDIT_TIME . "@_@" . $SEQ_ID . "@_@" . $FLOW_PRCS . "@_@" . $prcsId;                    //签办反馈，相关信息用“@_@”连接
            $fb_num++;
        }
        //公共附件
        $flow_data_arr["PUBLIC_ATTACHMENT_ID"] = $flowRunInfo["ATTACHMENT_ID"];              //公共附件ID
        $flow_data_arr["PUBLIC_ATTACHMENT_NAME"] = $flowRunInfo["ATTACHMENT_NAME"];            //公共附件NAME
        //相关文档
        $flow_data_arr["LINK_DOC"] = $flowRunInfo["LINK_DOC"];                   //相关文档
        //子流程
        $sub_workflow_ids_total = "";
        $sub_workflow_sql = "SELECT SUB_FLOW_RUN_IDS FROM  flow_run_prcs  WHERE RUN_ID = '" . SecurityFilter($RUN_ID) . "' ";
        $sub_workflow_rs = exequery($connection, $sub_workflow_sql);
        while ($sub_workflow_rows = mysql_fetch_array($sub_workflow_rs)) {
            $sub_workflow_rows_array = explode(",", trim($sub_workflow_rows["SUB_FLOW_RUN_IDS"], ","));
            for ($p = 0; $p < count($sub_workflow_rows_array); $p++) {
                if (!find_id($sub_workflow_ids_total, $sub_workflow_rows_array[$p]))
                    $sub_workflow_ids_total .= $sub_workflow_rows_array[$p] . ",";
            }
        }
        $sub_workflow_ids_array = explode(",", trim($sub_workflow_ids_total, ","));
        $sub_workflow_ids_count = count($sub_workflow_ids_array);
        if ($sub_workflow_ids_array[0] == "")
            $sub_workflow_ids_count--;
        if ($sub_workflow_ids_count > 0) {
            for ($q = 0; $q < $sub_workflow_ids_count; $q++) {
                $sub_detail_sql = "SELECT * FROM flow_run WHERE RUN_ID = '" . SecurityFilter($sub_workflow_ids_array[$q]) . "' ";
                $sub_detail_rs = exequery($connection, $sub_detail_sql);
                if ($sub_detail_rows = mysql_fetch_array($sub_detail_rs)) {
                    $sub_workflow_name = $sub_detail_rows["RUN_NAME"];
                    $sub_workflow_id = $sub_detail_rows["FLOW_ID"];
                    $CREATOR = $sub_detail_rows["CREATOR"];
                    $CREATE_TIME = $sub_detail_rows["CREATE_TIME"];
                    $sub_workflow_run_id = $sub_detail_rows["RUN_ID"];
                    $sub_workFlowInstance = new fixedWorkflow($sub_workflow_id);
                    $sub_workFlowInstance->runId = $sub_workflow_run_id;
                    $flow_data_arr["SUB_WORKFLOW_" . $q . "_RUN_NAME"] = $sub_workflow_name;    //子流程运行名称
                    $flow_data_arr["SUB_WORKFLOW_" . $q . "_RUN_ID"] = $sub_workflow_run_id;  //子流程运行ID
                    $flow_data_arr["SUB_WORKFLOW_" . $q . "_FLOW_ID"] = $sub_workflow_id;      //子流程类别ID
                    $flow_data_arr["SUB_WORKFLOW_" . $q . "_CREATOR"] = $CREATOR;              //子流程创建者
                    $flow_data_arr["SUB_WORKFLOW_" . $q . "_CREATE_TIME"] = $CREATE_TIME;          //子流程创建时间
                    $flow_data_arr["SUB_WORKFLOW_" . $q . "_FORM_ID"] = $sub_workFlowInstance->formId; //子流程表单ID
                    $flow_data_arr["SUB_WORKFLOW_" . $q . "_FLOW_NAME"] = $sub_workFlowInstance->flowName; //子流程名称
                }
            }
        }

        $flow_data_arr["PRINT_MODEL"] = $PRINT_MODEL_CONTENT;              //带数据的流程表单

        $result_data = post_data($url, $flow_data_arr, $send_param);
        return true;
    }
}

/*
 * 批量或单独将对应好的数据插入对应数据库
 * @param $insert_arr         要插入的数组
 * @param $type               是否有返回值
 */

function INSERT_FLOW_CONNECT($insert_arr, $type = "") {
    $insert_id_str = "";
    if (!$insert_arr[0]) {
        $insert_arr = array($insert_arr);
    }
    $i = 0;
    while ($i < count($insert_arr)) {
        //创建数据库连接
        if ($insert_arr[$i]["connection"] != "") {
            $MYSQL_SERVER = $insert_arr[$i]["connection"]["MYSQL_SERVER"];
            $MYSQL_USER = $insert_arr[$i]["connection"]["MYSQL_USER"];
            $MYSQL_PASS = $insert_arr[$i]["connection"]["MYSQL_PASS"];
            $MYSQL_DB = $insert_arr[$i]["connection"]["MYSQL_DB"];
            $C = @mysql_pconnect($MYSQL_SERVER, $MYSQL_USER, $MYSQL_PASS, MYSQL_CLIENT_COMPRESS) or ( $C = @mysql_connect($MYSQL_SERVER, $MYSQL_USER, $MYSQL_PASS));
            if (!$C) {
                //die("<h3>无法连接到数据库,请检查数据库状态</h3>");
            }
            mysql_select_db($MYSQL_DB, $C);
            $connection = $C;
        } else {
            global $connection;
        }

        //拼接SQL并执行
        $table_field = "";
        $table_value = "";
        $query = "";
        foreach ($insert_arr[$i]["value"] as $key => $subject) {
            $table_field.= $key . ",";
            $table_value.="'" . $subject . "'" . ",";
        }
        $table_name = $insert_arr[$i]["table"]["TABLE"];
        $query = "INSERT INTO " . $table_name;
        $query.= " (" . SecurityFilter(substr($table_field, 0, strrpos($table_field, ",")) ). ") VALUES ";
        $query.= "(" . SecurityFilter(substr($table_value, 0, strrpos($table_value, ","))) . ")";
        exequery($connection, $query);
        $insert_id_str.= mysql_insert_id();
        $insert_id_str.= ",";
        $i++;
    }
    if ($type != "") {
        return $insert_id_str;
    }
}

/**
 * 验证sessionkey(webservice)
 * @param string $SessionKey session_id
 * @return bool true 正确；false 错误
 */
function CheckSessionKeys($SessionKey) {
    $inipath = php_ini_loaded_file();
    $ini_array = parse_ini_file($inipath);
    $Session_Dir = $ini_array["session.save_path"];
    $name = "sess_" . $SessionKey;
    if (strtolower(substr(PHP_OS, 0, 3)) == win) {
        $filename = $Session_Dir . "\\" . $name;
    } else {
        $filename = $Session_Dir . "/" . $name;
    }
    if (file_exists($filename)) {
        return true;
    } else {
        return false;
    }
}

/**
 * 是否开通流程数据外发功能
 * @return true/false  返回true表示有，返回false表示无
 */
function isDataSendout() {
    global $connection;
    $sql = "SELECT PARA_VALUE FROM sys_para WHERE PARA_NAME = 'DATA_SENDOUT' ";
    $rs = exequery($connection, $sql);
    if ($rows = mysql_fetch_array($rs)) {
        $DATA_SENDOUT = $rows["PARA_VALUE"];
    }
    if ($DATA_SENDOUT)
        return true;
    else
        return false;
}

/**
 * 获取两个日期之间的具体日期
 * return array
 */
function getDates($startdate, $enddate) {
    global $connection;
    $reStr = array();
    $start_year = date(Y, strtotime($startdate));
    $start_month = date(n, strtotime($startdate));
    $start_day = date(j, strtotime($startdate));
    $count_start = date(t, strtotime($startdate));
    $end_year = date(Y, strtotime($enddate));
    $end_month = date(n, strtotime($enddate));
    $end_day = date(j, strtotime($enddate));
    $count_end = date(t, strtotime($enddate));

    for ($y = $start_year; $y <= $end_year; $y++) {
        if ($start_month > $end_month) {
            if ($y == $start_year) {
                for ($j = $start_month; $j <= 12; $j++) {
                    if ($j == $start_month) {
                        for ($d = $start_day; $d <= $count_start; $d++) {
                            if ($d <= 9) {
                                $d = "0" . $d;
                            }

                            $sign_date = $y . "-" . $j . "-" . $d;
                            array_push($reStr, $sign_date);
                        }
                    } else {
                        for ($d = 1; $d <= date(t, strtotime($y . "-" . $j . "-01")); $d++) {
                            if ($d <= 9) {
                                $d = "0" . $d;
                            }
                            $sign_date = $y . "-" . $j . "-" . $d;
                            array_push($reStr, $sign_date);
                        }
                    }
                }
            } else {
                for ($j = 1; $j <= $end_month; $j++) {
                    if ($j <= 9) {
                        $j = "0" . $j;
                    }

                    if ($j == $end_month) {
                        for ($d = 1; $d <= $end_day; $d++) {
                            if ($d <= 9) {
                                $d = "0" . $d;
                            }
                            $sign_date = $y . "-" . $j . "-" . $d;
                            array_push($reStr, $sign_date);
                        }
                    } else {
                        for ($d = 1; $d <= date(t, strtotime($y . "-" . $j . "-01")); $d++) {
                            if ($d <= 9) {
                                $d = "0" . $d;
                            }
                            $sign_date = $y . "-" . $j . "-" . $d;
                            array_push($reStr, $sign_date);
                        }
                    }
                }
            }
        } else if ($start_month <= $end_month) {
            if ($start_year == $end_year) {
                for ($j = $start_month; $j <= $end_month; $j++) {
                    if ($j <= 9) {
                        $j = "0" . $j;
                    }
                    if ($start_month == $end_month) {
                        for ($d = $start_day; $d <= $end_day; $d++) {
                            if ($d <= 9) {
                                $d = "0" . $d;
                            }
                            $sign_date = $y . "-" . $j . "-" . $d;
                            array_push($reStr, $sign_date);
                        }
                    } else {
                        if ($j == $start_month) {
                            for ($d = $start_day; $d <= $count_start; $d++) {
                                if ($d <= 9) {
                                    $d = "0" . $d;
                                }
                                $sign_date = $y . "-" . $j . "-" . $d;
                                array_push($reStr, $sign_date);
                            }
                        } else if ($j > $start_month && $j < $end_month) {
                            for ($d = 1; $d <= date(t, strtotime($y . "-" . $j . "-01")); $d++) {
                                if ($d <= 9) {
                                    $d = "0" . $d;
                                }
                                $sign_date = $y . "-" . $j . "-" . $d;
                                array_push($reStr, $sign_date);
                            }
                        } else if ($j == $end_month) {
                            for ($d = 1; $d <= $end_day; $d++) {
                                if ($d <= 9) {
                                    $d = "0" . $d;
                                }
                                $sign_date = $y . "-" . $j . "-" . $d;
                                array_push($reStr, $sign_date);
                            }
                        }
                    }
                }
            } else {
                if ($y == $start_year) {
                    for ($j = $start_month; $j <= 12; $j++) {
                        if ($j <= 9) {
                            $j = "0" . $j;
                        }
                        if ($j == $start_month) {
                            for ($d = $start_day; $d <= date(t, strtotime($y . "-" . $start_month . "-01")); $d++) {
                                if ($d <= 9) {
                                    $d = "0" . $d;
                                }
                                $sign_date = $y . "-" . $j . "-" . $d;
                                array_push($reStr, $sign_date);
                            }
                        } else {
                            for ($d = 1; $d <= date(t, strtotime($y . "-" . $j . "-" . "-01")); $d++) {
                                if ($d <= 9) {
                                    $d = "0" . $d;
                                }
                                $sign_date = $y . "-" . $j . "-" . $d;
                                array_push($reStr, $sign_date);
                            }
                        }
                    }
                } else if ($y == $end_year) {
                    for ($j = 1; $j <= $end_month; $j++) {
                        if ($j != $end_month) {
                            if ($j <= 9) {
                                $j = "0" . $j;
                            }
                            for ($d = 1; $d <= date(t, strtotime($y . "-" . $j . "-01")); $d++) {
                                if ($d <= 9) {
                                    $d = "0" . $d;
                                }
                                $sign_date = $y . "-" . $j . "-" . $d;
                                array_push($reStr, $sign_date);
                            }
                        } else {
                            for ($d = 1; $d <= $end_day; $d++) {
                                if ($d <= 9) {
                                    $d = "0" . $d;
                                }
                                $sign_date = $y . "-" . $j . "-" . $d;
                                array_push($reStr, $sign_date);
                            }
                        }
                    }
                } else {
                    for ($j = 1; $j <= 12; $j++) {
                        if ($j <= 9) {
                            $j = "0" . $j;
                        }
                        for ($d = 1; $d <= date(t, strtotime($y . "-" . $j . "-01")); $d++) {
                            $sign_date = $y . "-" . $j . "-" . $d;
                            array_push($reStr, $sign_date);
                        }
                    }
                }
            }
        }
    }
    return $reStr;
}

function getUserPriv($userId = '') {
    global $connection, $LOGIN_USER_ID;
    if ($userId == '') {
        $userId = $LOGIN_USER_ID;
    }
    $query = "SELECT up.FUNC_ID_STR FROM user_priv AS up LEFT JOIN user AS u ON up.USER_PRIV = u.USER_PRIV WHERE USER_ID='".SecurityFilter($userId)."'";
    $res = exequery($connection, $query);
    if ($row = mysql_fetch_array($res)) {
        return $row['FUNC_ID_STR'];
    }
    return false;
}

function getLoginUserPriv($user_id = '') {
    global $connection, $LOGIN_USER_ID, $lang;
    if ($user_id == '') {
        $user_id = $LOGIN_USER_ID;
    }

    $query = "SELECT * FROM user WHERE USER_ID='" . SecurityFilter($user_id) . "'";
    $res = exequery($connection, $query);
    if ($row = mysql_fetch_array($res)) {
        $sql = "SELECT * FROM user_priv WHERE USER_PRIV='" . SecurityFilter($row["USER_PRIV"]) . "'";
        $cousor = exequery($connection, $sql);
        if ($Row = mysql_fetch_array($cousor)) {
            return $Row["FUNC_ID_STR"];
        }
    }
}

//json对象转Array
function object_array($array) {
    if (is_object($array)) {
        $array = (array) $array;
    }
    if (is_array($array)) {
        foreach ($array as $key => $value) {
            $array[$key] = object_array($value);
        }
    }
    return $array;
}

/**
 * 通讯录里取当前group_id的目录名称
 * @param    $group_id 目录ID
 * @return   $group_name  当前目录ID对应的目录名称
 */
function getAddressGroupName($group_id) {
    global $connection;
    $query = "SELECT group_name FROM address_group WHERE group_id = '".SecurityFilter($group_id)."'";
    $cursor = exequery($connection, $query);
    if ($ROW = mysql_fetch_array($cursor))
        $group_name = $ROW["group_name"];
    return $group_name;
}

/**
 * 获取联系人的所属客户
 */
function getLinkmanCustomer($linkman_id) {
    global $connection;
    $query = "SELECT CUSTOMER_NAME FROM CUSTOMER WHERE CUSTOMER_ID = '".SecurityFilter($linkman_id)."'";
    $cursor = exequery($connection, $query);
    if ($ROW = mysql_fetch_array($cursor))
        $name = $ROW["CUSTOMER_NAME"];
    return $name;
}

/**
 * 将新地址存到通讯录里面，返回通讯录ID
 */
function saveNewEmailAddress($newAddressStr) {
    global $connection, $_lang;
    $A1 = $newAddressStr;
    //判断当前这个人的个人通讯录里是否有未分组联系人
    $sql = "SELECT * FROM address_group WHERE USER_ID ='" . SecurityFilter($_SESSION['LOGIN_USER_ID']) . "' AND UNCLASSIFIED = '1'";
    $cursor = exequery($connection, $sql);
    if ($ROW = mysql_fetch_array($cursor)) {
        $GROUP_ID = $ROW["GROUP_ID"];
    } else {
        //生成一个个人通讯录里的未分组联系人组
        $sql_2 = "INSERT INTO `address_group` (`GROUP_NAME` ,`GROUP_RENAME` ,`GROUP_DATE` ,`USER_ID` ,`UNCLASSIFIED` ) VALUES ('" . SecurityFilter($_lang["common_address_unclassified"]) . "', '', NOW() , '" . SecurityFilter($_SESSION['LOGIN_USER_ID']) . "', '1')";
        exequery($connection, $sql_2);
        $GROUP_ID = mysql_insert_id();
    }
    $query = "INSERT INTO address (`ADD_TYPE`,`NAME_PINYIN`,`NAME_INDEX`,`A1`,`A2`,`A6`,`A10`,`A11`,`A12`) VALUES('2','" . Pinyin($A1, 'utf-8') . "','" . substr(Pinyin($A1, 'utf-8'), 0, 1) . "','" . $A1 . "','" . SecurityFilter($_lang["common_man"]) . "','" . $A1 . "','" . SecurityFilter($GROUP_ID) . "','" . SecurityFilter($_SESSION['LOGIN_USER_ID']) . "',now())";
    exequery($connection, $query);
    $ADD_ID = mysql_insert_id();
    $addextend = "tongxunlu," . $ADD_ID;
    return $addextend;
}

/**
 * 获取是否默认生成流程名称
 */
function getFlowShowName($FLOW_ID) {
    global $connection;
    $sql = "SELECT FLOW_SHOW_NAME FROM flow_others WHERE FLOW_ID='" . SecurityFilter($FLOW_ID) . "'";
    $cursor = exequery($connection, $sql);
    if ($row = mysql_fetch_array($cursor)) {
        if ($row["FLOW_SHOW_NAME"]) {
            return true;
        } else {
            return false;
        }
    } else {
        return false;
    }
}

/**
 * 获取系统是那个版本的
 */
function getSystemVersion() {
    global $connection;
    $sql = "SELECT PARA_VALUE  FROM sys_para  WHERE PARA_NAME ='SYSTEM_VERSION'";
    $cursor = exequery($connection, $sql);
    if ($row = mysql_fetch_array($cursor)) {
        return $row["PARA_VALUE"];
    } else {
        return false;
    }
}

/**
 * 获取流程紧急程度名称的函数
 * @param  str $InstancyType   紧急程度的数字
 * @return str 紧急程度 0：正常、1：重要、2：紧急
 */
function getInstancyName($InstancyType) {
    global $connection, $_lang;
    $InstancyName = "";
    switch ($InstancyType) {
        case '0':
            $InstancyName = $_lang["common_normal"];
            break;
        case '1':
            $InstancyName = $_lang["common_important"];
            break;
        case '2':
            $InstancyName = $_lang["common_instancy"];
            break;
        default:
            break;
    }
    return $InstancyName;
}

/**
 * 根据流程ID,节点ID，取出节点名称
 * @param  string $flow_id 流程ID
 * @param  string $prcs_id 节点ID
 * @return string $prcs_name 返回节点名称
 */
function getFlowPrcsName($prcs_id, $flow_id) {
    global $connection;
    $query = "SELECT PRCS_NAME FROM flow_process WHERE FLOW_ID = '" . SecurityFilter($flow_id) . "' AND PRCS_ID = '" . SecurityFilter($prcs_id) . "'";
    $rs = exequery($connection, $query);
    $rows = mysql_fetch_array($rs);
    $prcs_name = $rows["PRCS_NAME"];
    return $prcs_name;
}

/**
 * 动态字段数据源转换url
 * @param  str $path   用户配置的数据源
 * @return str $newUrl 转换后的url
 */
function pathToUrl($dataPath, $other) {
    $urlArray = parse_url($dataPath);
    $protcal = $urlArray["scheme"] ? $urlArray["scheme"] : "http";
    $host = $urlArray["host"] ? $urlArray["host"] : $_SERVER['SERVER_NAME'];
    $port = $urlArray["port"];
    if (!$urlArray["host"])
        $port = $_SERVER['SERVER_PORT'];
    $path = $urlArray["path"];

    $query = $urlArray["query"];
    foreach ($other as $key => $val) {
        if ($key != "targetUrl") {
            if ($query)
                $query .= "&$key=" . urlencode($val) . "&";
            else
                $query .= "$key=" . urlencode($val) . "&";
        }
    }
    $newUrl = $protcal . "://" . $host;

    if ($port)
        $newUrl .= ":" . $port;
    if ($path)
        $newUrl .= $path;
    if ($query)
        $newUrl .= "?" . $query;
    return $newUrl;
}

/**
 * 获取办公资产借取方式
 */
function getOfficeitemMode($modes) {
    global $_lang;
    if ($modes == '1') {
        $modes_name = $_lang["asset_use"];
    } else if ($modes == '2') {
        $modes_name = $_lang["asset_borrow_use"];
    } else {
        $modes_name = json_decode($modes);
    }
    return $modes_name;
}

/**
 * 获取办公资产申请的当前状态
 */
function getOfficeitemStatus($status) {
    global $_lang;
    if ($status == '0') {
        $status_name = $_lang["asset_audit"];
    } else if ($status == '1') {
        $status_name = $_lang["asset_not_pass"];
    } else if ($status == '2') {
        $status_name = $_lang["asset_have_passed"];
    } else {
        $status_name = json_decode($status);
    }
    return $status_name;
}

/**
 * 获取当前办公资产名称
 */
function getOfficeitemName($appellation_id) {
    global $connection;
    if (is_numeric($appellation_id)) {
        $sql = "SELECT * FROM officeitem_appellation WHERE APPELLATION_ID='" . SecurityFilter($appellation_id) . "'";
        $res = exequery($connection, $sql);
        $row = mysql_fetch_array($res);
        return $row["APPELLATION"];
    } else {
        return json_decode($appellation_id);
    }
}

/**
 * 获取SORT_LEVEL_ID属性的值
 * @param  stirng $sortParentID 需要获取SORT_LEVEL_ID属性的文件夹
 * @return string $SORT_LEVEL_ID
 */
function getSortLevelId($sortParentID) {
    global $connection;
    $query = "SELECT SORT_LEVEL_ID FROM file_sort WHERE SORT_ID = '" . SecurityFilter($sortParentID) . "'";
    $result = exequery($connection, $query);
    if ($row = mysql_fetch_array($result)) {
        $sortID = $row["SORT_LEVEL_ID"];
        return $sortID;
    } else {
        return "|";
    }
}

/**
 * @function 是否执行组织架构的同步
 *
 *
 */
function isSysSync() {
    global $connection;
    $query = "SELECT * FROM sys_para WHERE PARA_NAME='SysSync'";
    $res = exequery($connection, $query);
    if ($row = mysql_fetch_array($res)) {
        $sysSync = $row["PARA_VALUE"];
    }
    return strtolower($sysSync);
}

/**
 * @function 档案执行同步
 *
 */
function syncHrms() {
    global $connection;
    $sql = "SELECT USER_ID,DELETE_FLAG FROM hrms WHERE USER_ID <>''
                  AND USER_ID is not NULL";
    $res = exequery($connection, $sql);
    $userIds = array();
    while ($row = mysql_fetch_array($res)) {
        $userIds[$row["USER_ID"]] = array("USER_ID" => $row["USER_ID"], "DELETE_FLAG" => $row["DELETE_FLAG"]);
    }
    //格式化档案表,为所有的系统用户添加一个基本档案
    $query = "SELECT USER_ID,USER_NAME,DEPT_ID,SEX,EMAIL,BIRTHDAY,TEL_NO_HOME,ADD_HOME,NOTES FROM USER
				  WHERE DEPT_ID > 0
                  AND IS_AUTOHRMS='1'";
    $rs = exequery($connection, $query);
    while ($rows = mysql_fetch_array($rs)) {
        $dept_id = $rows["DEPT_ID"];
        $dept_name = getDeptName($dept_id);
        if (count($userIds) == 0 || (!$userIds[$rows["USER_ID"]]["USER_ID"] && $userIds[$rows["USER_ID"]]["DELETE_FLAG"] != "1")) {
            $hr_sql = "INSERT INTO hrms(USER_ID,TRUE_NAME,DEPARTMENT,SEX,EMAIL,BIRTHDAY,DEPT_ID,HOME_ADDR,HOME_TEL,RESUME,LABOR_REMIND_SIGN) VALUES('" . SecurityFilter($rows["USER_ID"]) . "','" . SecurityFilter($rows["USER_NAME"]) . "','" . SecurityFilter($dept_name) . "','" . SecurityFilter($rows["SEX"]) . "','" . SecurityFilter($rows["EMAIL"]) . "','" . SecurityFilter($rows["BIRTHDAY"] ). "','" . SecurityFilter($rows["DEPT_ID"]) . "','" . SecurityFilter($rows['ADD_HOME']) . "','" . SecurityFilter($rows['TEL_NO_HOME'] ). "','" . SecurityFilter($rows['NOTES']) . "','0') ";
            $in_rs = exequery($connection, $hr_sql);
        }
    }
    //如果部门不存在了,则将档案的DEPT_ID值修改为0
    $dept_query = "UPDATE hrms SET DEPT_ID = '' WHERE DEPT_ID NOT IN (SELECT DEPT_ID FROM department) ";
    $dept_rs = exequery($connection, $dept_query);
}

/**
 * @function 生成考核提醒
 *
 */
function performSms() {
    global $connection;
    $query = "SELECT * FROM performance_tpl WHERE 1 AND PERFORMANCE_IS_REMIND='1'";
    $res = exequery($connection, $query);
    $sendFlag = false;
    while ($row = mysql_fetch_array($res)) {
        //根据是月度考核还是其他考核方案进行处理
        if ($row["PERFORMANCE_ID"] == '1') {
            $startDay = $row["PERFORM_START_DAY"];
            $endDay = $row["PERFORM_END_DAY"];
            $thisYear = date("Y", time());
            $thisMonth = date("n", time());
            if ($thisMonth == '1' && $row["PERFORM_START_MONTH"] == '1') {
                $performStartDay = ($thisYear - 1) . "-12-" . $startDay;
                $endMonth = $row["PERFORM_END_MONTH"] == 2 ? $thisMonth : ($thisMonth + 1);
                $performEndDay = $thisYear . "-" . $endMonth . "-" . $endDay;
            } else if ($thisMonth == '12' && $row["PERFORM_END_MONTH"] == 3) {
                $startMonth = $row["PERFORM_START_MONTH"] == 1 ? ($thisMonth - 1) : $thisMonth;
                $performStartDay = $thisYear . "-" . $startMonth . "-" . $startDay;
                $performEndDay = ($thisYear + 1) . "-1-" . $startDay;
            } else {
                $startMonth = $row["PERFORM_START_MONTH"] == 1 ? ($thisMonth - 1) : $thisMonth;
                $endMonth = $row["PERFORM_END_MONTH"] == 2 ? $thisMonth : ($thisMonth + 1);
                $performStartDay = $thisYear . "-" . $startMonth . "-" . $startDay;
                $performEndDay = $thisYear . "-" . $endMonth . "-" . $endDay;
            }
        } else {
            $performStartDay = $row["PERFORMANCE_TIME_START"];
            $performEndDay = $row["PERFORMANCE_TIME_END"];
        }
        if (strtotime($performStartDay) <= strtotime(date("Y-m-d", time())) && strtotime($performEndDay) >= strtotime(date("Y-m-d", time()))) {
            $sendFlag = true;
        }
    }

    if ($sendFlag == true) {
        $sql = "SELECT * FROM  performance_setperformer WHERE 1 AND APPROVER_DEFAULT!=''";
        $res = exequery($connection, $sql);
        $toIds = array();
        while ($ROW = mysql_fetch_array($res)) {
            !in_array($ROW["APPROVER_DEFAULT"], $toIds) ? array_push($toIds, $ROW["APPROVER_DEFAULT"]) : "";
        }

        $toIds = count($toIds) != 0 ? implode(",", $toIds) : "";
        if (count($toIds) != 0) {

            $querys = "SELECT * FROM sms WHERE 1 AND TABLE_NAME='performance' AND TABLE_ID='" . date("Y-m", time()) . "'";
            $rs = exequery($connection, $querys);
            if (!$rows = mysql_fetch_array($rs)) {
                sendSms('admin', $toIds, "有新的绩效考核,请查看", 1, 0, 'performance', date("Y-m", time()));
            }
        }
    }
}

/**
 * @function 生成二维码图片
 *
 */
function saveQrImg($userInfo) {
    $qrStr = "BEGIN:VCARD\nVERSION:2.1" .
            "\nFN:" . getUsernameNew($userInfo["USER_ID"]) .
            "\nEMAIL;PREF;INTERNET:" . $userInfo["EMAIL"] .
            "\nTEL;CELL;VOICE:" . $userInfo["MOBIL_NO"] .
            "\nORG:" . $userInfo["ORG"] .
            "\nROLE:" . getDeptName($userInfo["DEPT_ID"]) .
            "\nTITLE:" . $userInfo["USER_PRIV"] .
            "\nADR;WORK;POSTAL:" . $userInfo["ADD_HOME"] . ";" . $userInfo["POST_NO_HOME"] .
            "\nEND:VCARD";
    $errorCorrectionLevel = "L";
    $matrixPointSize = "2";
    $filePath = ROOT_PATH . "attachment/qrcode/";
    if (!file_exists($filePath)) {
        mkdir($filePath);
    }
    if (file_exists($filePath . $userInfo["USER_ID"] . ".png")) {
        unlink($filePath . $userInfo["USER_ID"] . ".png");
    }
    QRcode::png($qrStr, $filePath . $userInfo["USER_ID"] . ".png", $errorCorrectionLevel, $matrixPointSize);
}

//文件名转换成图标的CLASS
function fileTypeToFontIcon($sFileName) {
    $sFileName = strtolower($sFileName);
    preg_match("/\.([a-zA-Z]{2,4})$/", $sFileName, $sExt);
    $fileType = strtolower($sExt[1]);
    switch ($fileType) {
        case "zip":
        case "rar":
            $fileTypeClass = "fa-file-archive-o";

            break;
        case "mp3":
            $fileTypeClass = "fa-file-audio-o";
            break;
        case "xls":
        case "xlsx":
            $fileTypeClass = "fa-file-excel-o";
            break;
        case "doc":
        case "docx":
            $fileTypeClass = "fa-file-word-o";
            break;
        case "jpg":
        case "png":
        case "gif":
            $fileTypeClass = "fa-file-image-o";
            break;
        case "mp4":
            $fileTypeClass = "fa-file-movie-o";
            break;
        case "pdf":
            $fileTypeClass = "fa-file-pdf-o";
            break;
        case "ppt":
            $fileTypeClass = "fa-file-powerpoint-o";
            break;
        case "txt":
            $fileTypeClass = "fa-file-text-o";
            break;
        default:
            $fileTypeClass = "fa-file-o";
            break;
    }
    return $fileTypeClass;
}

function writetodatabase($TABLE_ID, $TABLE_NAME, $USER_ID, $HTTP_URL, $MIME_TYPE, $ATTACHMENT_NAME, $ATTACHMENT_SIZE) {
    global $connection;
    $createdate = date("Y-m-d H:i:s");
    $query = "INSERT INTO attachment (TABLE_ID,TABLE_NAME,USER_ID,HTTP_URL,MIME_TYPE,ATTACHMENT_NAME,ATTACHMENT_SIZE,CREATE_DATE)VALUES('" . SecurityFilter($TABLE_ID) . "','" . SecurityFilter($TABLE_NAME) . "','" . SecurityFilter($USER_ID) . "','" . SecurityFilter($HTTP_URL) . "','" . SecurityFilter($MIME_TYPE) . "','" . SecurityFilter($ATTACHMENT_NAME) . "','" . SecurityFilter($ATTACHMENT_SIZE) . "','" . SecurityFilter($createdate) . "')";
    $rs = exequery($connection, $query);
}

/*
 *  获取post，get，cookie提交的参数。
 *  $var_name (参数名称)
 *  $default (默认值)
 *  $cookie (判断是否获取cookie值)
 */

function request_var($var_name, $default = "", $cookie = false) {
    if (!$cookie) {
        if (!isset($_GET[$var_name]) && !isset($_POST[$var_name])) {
            return (is_array($default)) ? array() : $default;
        }
        return isset($_POST[$var_name]) ? $_POST[$var_name] : $_GET[$var_name];
    } else {
        return isset($_COOKIE[$var_name]) ? $_COOKIE[$var_name] : ((is_array($default)) ? array() : $default);
    }
}

/**
 * 加密、解密函数
 * $str = 'abcdef';
 * $key = 'eoffice9731';
 * echo authCode($str,'ENCODE',$key,0); //加密
 * $str = '56f4yER1DI2WTzWMqsfPpS9hwyoJnFP2MpC8SOhRrxO7BOk';
 * echo authCode($str,'DECODE',$key,0); //解密
 *
 * @param  [type]  $string    [需要加密、解密的字符串]
 * @param  string  $operation [DECODE-解密 ENCODE-解密]
 * @param  string  $key       [密钥]
 * @param  integer $expiry    [密文有效期]
 * @return [type]             [description]
 */
function authCode($string, $operation = 'DECODE', $key = 'eoffice9731', $expiry = 0) {

    // 动态密匙长度，相同的明文会生成不同密文就是依靠动态密匙
    $ckey_length = 4;

    // 密匙
    $key = md5($key);

    // 密匙a会参与加解密
    $keya = md5(substr($key, 0, 16));

    // 密匙b会用来做数据完整性验证
    $keyb = md5(substr($key, 16, 16));

    // 密匙c用于变化生成的密文
    $keyc = $ckey_length ? ($operation == 'DECODE' ? substr($string, 0, $ckey_length) : substr(md5(microtime()), -$ckey_length)) : '';

    // 参与运算的密匙
    $cryptkey = $keya . md5($keya . $keyc);
    $key_length = strlen($cryptkey);

    // 明文，前10位用来保存时间戳，解密时验证数据有效性，10到26位用来保存$keyb(密匙b)，
    //解密时会通过这个密匙验证数据完整性
    // 如果是解码的话，会从第$ckey_length位开始，因为密文前$ckey_length位保存 动态密匙，以保证解密正确
    $string = $operation == 'DECODE' ? base64_decode(substr($string, $ckey_length)) : sprintf('%010d', $expiry ? $expiry + time() : 0) . substr(md5($string . $keyb), 0, 16) . $string;
    $string_length = strlen($string);
    $result = '';
    $box = range(0, 255);
    $rndkey = array();

    // 产生密匙簿
    for ($i = 0; $i <= 255; $i++) {
        $rndkey[$i] = ord($cryptkey[$i % $key_length]);
    }

    // 用固定的算法，打乱密匙簿，增加随机性，好像很复杂，实际上对并不会增加密文的强度
    for ($j = $i = 0; $i < 256; $i++) {
        $j = ($j + $box[$i] + $rndkey[$i]) % 256;
        $tmp = $box[$i];
        $box[$i] = $box[$j];
        $box[$j] = $tmp;
    }

    // 核心加解密部分
    for ($a = $j = $i = 0; $i < $string_length; $i++) {
        $a = ($a + 1) % 256;
        $j = ($j + $box[$a]) % 256;
        $tmp = $box[$a];
        $box[$a] = $box[$j];
        $box[$j] = $tmp;

        // 从密匙簿得出密匙进行异或，再转成字符
        $result.= chr(ord($string[$i]) ^ ($box[($box[$a] + $box[$j]) % 256]));
    }
    if ($operation == 'DECODE') {

        // 验证数据有效性，请看未加密明文的格式
        if ((substr($result, 0, 10) == 0 || substr($result, 0, 10) - time() > 0) && substr($result, 10, 16) == substr(md5(substr($result, 26) . $keyb), 0, 16)) {
            return substr($result, 26);
        } else {
            return '';
        }
    } else {

        // 把动态密匙保存在密文里，这也是为什么同样的明文，生产不同密文后能解密的原因
        // 因为加密后的密文可能是一些特殊字符，复制过程可能会丢失，所以用base64编码
        return $keyc . str_replace('=', '', base64_encode($result));
    }
}

function dealSVGforIE($svg) {
    if (empty($svg)) {
        return false;
    }

    $svg = stripslashes($svg);
    $filter = array('</rect>', '</path>');
    $svg = str_replace($filter, '', $svg);

    $rect = '/(<rect.*)\/?>/U';
    $rect_replace = '${1}></rect>';

    $path = '/(<path.*)\/?>/U';
    $path_replace = '${1}></path>';

    $svg = preg_replace($rect, $rect_replace, $svg);
    $svg = preg_replace($path, $path_replace, $svg);

    return $svg;
}

/**
 * 是否开通动联动态码登录验证
 * @return result  返回是否开通
 */
function isDynamiCode() {
    global $connection;
    $query = "SELECT * FROM sys_para WHERE PARA_NAME = 'DYNAMI_CODE'";
    $res = exequery($connection, $query);
    if ($row = mysql_fetch_array($res)) {
        $dynamiCode = $row["PARA_VALUE"];
    }
    return $dynamiCode;
}

/**
 * $string：需要加密解密的字符串；$operation：判断是加密还是解密，E表示加密，D表示解密；$key：密匙。
 * @param type $string
 * @param type $operation
 * @param type $key
 * @return string
 */
function encrypt2($string, $operation, $key = '') {
    $key = md5($key);
    $key_length = strlen($key);
    $string = $operation == 'D' ? base64_decode($string) : substr(md5($string . $key), 0, 8) . $string;
    $string_length = strlen($string);
    $rndkey = $box = array();
    $result = '';
    for ($i = 0; $i <= 255; $i++) {
        $rndkey[$i] = ord($key[$i % $key_length]);
        $box[$i] = $i;
    }
    for ($j = $i = 0; $i < 256; $i++) {
        $j = ($j + $box[$i] + $rndkey[$i]) % 256;
        $tmp = $box[$i];
        $box[$i] = $box[$j];
        $box[$j] = $tmp;
    }
    for ($a = $j = $i = 0; $i < $string_length; $i++) {
        $a = ($a + 1) % 256;
        $j = ($j + $box[$a]) % 256;
        $tmp = $box[$a];
        $box[$a] = $box[$j];
        $box[$j] = $tmp;
        $result.=chr(ord($string[$i]) ^ ($box[($box[$a] + $box[$j]) % 256]));
    }
    if ($operation == 'D') {
        if (substr($result, 0, 8) == substr(md5(substr($result, 8) . $key), 0, 8)) {
            return substr($result, 8);
        } else {
            return'';
        }
    } else {
        return str_replace('=', '', base64_encode($result));
    }
}

/**
 * 获取浏览器类型
 * @return string
 */
function getBrowserType() {
    $browserInfo = $_SERVER["HTTP_USER_AGENT"];

    if (strpos($browserInfo, 'Maxthon')) {
        $browser = 'Maxthon';
    } elseif (strpos($browserInfo, 'MSIE 8.0')) {
        $browser = 'IE8';
    } elseif (strpos($browserInfo, 'MSIE 7.0')) {
        $browser = 'IE7';
    } elseif (strpos($browserInfo, 'MSIE 6.0')) {
        $browser = 'IE6';
    } elseif (strpos($browserInfo, 'NetCaptor')) {
        $browser = 'NetCaptor';
    } elseif (strpos($browserInfo, 'Netscape')) {
        $browser = 'Netscape';
    } elseif (strpos($browserInfo, 'Lynx')) {
        $browser = 'Lynx';
    } elseif (strpos($browserInfo, 'Opera')) {
        $browser = 'Opera';
    } elseif (strpos($browserInfo, 'Konqueror')) {
        $browser = 'Konqueror';
    } elseif (strpos($browserInfo, 'Firefox')) {
        $browser = 'Firefox';
    } elseif (strpos($browserInfo, 'Safari')) {
        $browser = 'Safari';
    } else {
        $browser = 'other';
    }
    return $browser;
}

/**
 * 取得机器码
 * pls give me some comments
 * @param int $limit 如果为1则只取第一个码
 * @return limit 返回所有机器码，limit为1时只返回第一个码
 */
function getMachineCode($limit = 0) {
    $code_array = array();
    $mac_codes = array();
    //2007-4-17 lxl
    $tmp_dir = get_cfg_var('upload_tmp_dir') . "/";
    $mac_today_fn = $tmp_dir . "cache_" . md5(strtotime(date("Y-m-d")));
    $mac_yestoday_fn = $tmp_dir . "cache_" . md5(strtotime(date("Y-m-d")) - 60 * 60 * 24 * 1);
    if (file_exists($mac_today_fn)) {
        $handle = fopen($mac_today_fn, 'r');
        //$mac_code = base64_decode(fread($handle,1024));
        $data = base64_decode(fread($handle, 1024));
        $mac_codes = unserialize($data);
        unset($data);
    } else {
        include_once 'inc/get_mac.inc.php';
        $mac = new GetMacAddr(PHP_OS);
        //$mac_code = $mac->mac_addr;		//$mac_code was a string before
        $mac_codes = $mac->mac_array;  //$mac_codes is an array now
        $fp = fopen($mac_today_fn, "w");
        $data = serialize($mac_codes);   //serialize the mac_codes array
        fwrite($fp, base64_encode($data));
        fclose($fp);
        unset($data);
    }

    if (file_exists($mac_yestoday_fn)) {
        @unlink($mac_yestoday_fn);
    }
    $cup_code = $_ENV["PROCESSOR_REVISION"];
    foreach ($mac_codes as $code) {
        $code = str_replace('-', '', $code);
        $machine_code = $code . $cup_code;
        $code_array[] = strtoupper(md5($machine_code));
    }
    return $limit == 1 ? $code_array[0] : $code_array;
}

/**
 * 读取远程连接
 * 	@param url 需要请求的远程url
 * 	@post post方式请求的数据
 * 	@json 请求时 数据格式是否为json
 * 	@return 远程连接返回的结果
 */
function httpContents($url, $post = null, $json = false) {

    if ($post) {
        if (!$json) {
            ksort($post);

            $content = http_build_query($post);
            $length = strlen($content);

            $options = array(
                'http' => array(
                    'method' => 'POST',
                    'header' => "Content-type: application/x-www-form-urlencoded\r\n" .
                    "Content-length: {$length}\r\n",
                    'content' => $content
                )
            );
        } else {
            $options = array();
            $length = strlen($post);

            $options = array(
                'http' => array(
                    'method' => 'POST',
                    'header' => "Content-type: application/json; charset=utf-8\r\n" .
                    "Content-length: {$length}\r\n",
                    'content' => $post
                )
            );
        }

        return file_get_contents($url, false, stream_context_create($options));
    } else {

        return file_get_contents($url);
    }
}

//检测是否有角色通信
function checkRoleModule() {
    global $connection;

    $sql = "show tables like 'role_to_role'";
    $result = exequery($connection, $sql);
    $check = @mysql_fetch_row($result);

    if ('role_to_role' == $check[0]) {
        return true;
    }

    return false;
}

function checkWeixinModule($checkPush = false) {
    global $connection;

    if ($checkPush) {
        $confSQL = "select PARA_VALUE from sys_para where PARA_NAME = 'sys_mp_push'";
        $res = exequery($connection, $confSQL);
        $row = mysql_fetch_assoc($res);

        if (!$row['PARA_VALUE']) {
            return false;
        }
    }


    $file = ROOT_PATH . 'general/weixin/wechat.php';
    if (!is_file($file)) {
        return false;
    }

    $sql = 'select * from weixin_token limit 1';
    $resource = exequery($connection, $sql);
    $result = @mysql_fetch_assoc($resource);

    $access_token = $result['access_token'];
    $token_time = $result['token_time'];
    $appid = trim($result['appid']);
    $secret = trim($result['appsecret']);
    //没有配置 直接返回
    if (!$appid || !$secret) {
        return false;
    }

    if (!$access_token && $appid) {
        // 解决access_token为空丢失的情况
        $url = "https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid={$appid}&secret={$secret}";
        $json = AppGlobal::getToken($url);
        $result = json_decode($json, true);
        $time = time();
        if (!isset($result['errcode'])) {
            $sql = "update weixin_token set access_token = '".SecurityFilter($result['access_token'])."', token_time = '".SecurityFilter($time)."' where appid = '".SecurityFilter($appid)."'";
            exequery($connection, $sql);
        } else {
            return false;
        }
    }


    include_once($file);
    $uid = $_SESSION['LOGIN_USER_ID'];
    $wechat = new wechat();

    return $wechat;
}

function checkQyWeixinModule($checkPush = false) {
    global $connection;


    if ($checkPush) {
        $confSQL = "select PARA_VALUE from sys_para where PARA_NAME = 'sys_qy_push'";
        $result = exequery($connection, $confSQL);
        $row = mysql_fetch_assoc($result);

        if (!$row['PARA_VALUE']) {
            return false;
        }
    }
    $file = ROOT_PATH . 'general/qyweixin/qywechat.php';
    if (!is_file($file)) {
        return false;
    }
    $sql = 'select * from qyweixin_token';
    $resource = exequery($connection, $sql);
    $result = @mysql_fetch_assoc($resource);

    $corpid = $result['corpid'];
    $secret = $result['secret'];

        if (!$corpid || !$secret) {
        return false;
    }

        $access_token = $result['access_token'];
    $token_time = $result['token_time'];

if (!$access_token || !$token_time || (abs(time() - $token_time) > 7200)) {
        // 解决access_token为空丢失的情况
        $url = "https://qyapi.weixin.qq.com/cgi-bin/gettoken?corpid={$corpid}&corpsecret={$secret}";
        $json = AppGlobal::getToken($url);
        $result = json_decode($json, true);
        $time = time();
        if (!isset($result['errcode'])) { // 不存在错误编码
            $sql = "update qyweixin_token set access_token = '".SecurityFilter($result['access_token'])."', token_time = '{$time}'";
            exequery($connection, $sql);
        } else {
            return false;
        }
    }




    include_once($file);
    $uid = $_SESSION['LOGIN_USER_ID'];
    $qyWechat = new qyWechat($uid);

    return $qyWechat;
}

function checkDingTalkModule($checkPush = false) {
    global $connection;

    if ($checkPush) {
        $confSQL = "select PARA_VALUE from sys_para where PARA_NAME = 'sys_dingtalk_push'";
        $result = exequery($connection, $confSQL);
        $row = mysql_fetch_assoc($result);

        if (!$row['PARA_VALUE']) {
            return false;
        }
    }
    $file = ROOT_PATH . 'general/dingtalk/api/dingtalk.class.php';
    if (!is_file($file)) {
        return false;
    }
    $sql = 'select * from dingtalk_token';
    $resource = exequery($connection, $sql);
    $result = @mysql_fetch_assoc($resource);

    $appkey = $result['appkey'];
    $appsecret = $result['appsecret'];

    if (!$appkey || !$appsecret) {
        return false;
    }

    $access_token = $result['access_token'];
    $token_time = $result['token_time'];

    if (!$access_token || !$token_time || (abs(time() - $token_time) > 7200)) {
        // 解决access_token为空丢失的情况
        $url = "https://oapi.dingtalk.com/gettoken?appkey={$corpid}&appsecret={$secret}";
        $json = AppGlobal::getToken($url);
        $obj = json_decode($json, true);
        $time = time();
        if (isset($obj["errmsg"]) && $obj["errmsg"] == "ok") { // 不存在错误编码
            $sql = "update dingtalk_token set 	access_token	 = '".SecurityFilter($obj['access_token'])."', token_time = '{$time}' where corpid = '".SecurityFilter($corpid)."'";
            exequery($connection, $sql);
        } else {
            return false;
        }
    }

    include_once($file);

    $dingtalk = new dingtalk();

    return $dingtalk;
}

/**
 * 推送消息，循环在外
 *
 *  $arr = array(
  "query" => $query,
  "fromid" => $fromid ,//发送
  "content" => $content,
  "remind" => $remind  ,
  "smstype" => $smstype ,
  "tablename" => $tablename ,
  "tableid" => $tableid ,
  "tablevar" => $tablevar ,
  "attid" => $attid ,
  "attname" => $attname ,
  "sendtime" => $sendtime
  );

 *
 */
function sendQCSms($arr = array()) {
    global $connection;
    if (!$arr) {
        return false;
    }
    extract($arr);

    $USER_ID_STRING = "";
    $cursor = exequery($connection, $query);
    $arr_USER_ID = array();
    while ($ROW = mysql_fetch_assoc($cursor)) {
        $arr_USER_ID[] = $ROW;
    }
    foreach ($arr_USER_ID as $key => $val) {
        $USER_ID_STRING .= $val["USER_ID"] . ",";
    }

    $USER_ID_STRING = substr($USER_ID_STRING, 0, -1);

    // 内部消息勾选
    sendSms($fromid, $USER_ID_STRING, $content, $remind, $smstype, $tablename, $tableid, $tablevar, $attid, $attname, $sendtime);
}

//** 创建目录并授权

function custom_checkpath($path) {
    $pathes = explode('/', $path);
    $dir = '';
    foreach ($pathes as $k => $v) {
        if ($v) {
            $dir .= $v . '/';
            if (!is_dir($dir)) {
                mkdir($dir, 0777);
                chmod($dir, 0777);
            }
        }
    }
}

/**
 * 换用户信息 钉钉ID 换 OA用户ID
 */
function dingTalkToUser($userId) {
    global $connection;
    $confSQL = "select * from dingtalk_user where oa_id = '".SecurityFilter($userId)."'";
    $result = exequery($connection, $confSQL);
    $row = mysql_fetch_assoc($result);

    if (!$row['userid']) {
        return $userId;
    } else {
        return $row['userid'];
    }
}

/**
 * 解决 点击办理（查看）后 查看消息的情况
 */

function readSmsStatus($sms_id){
    global $connection;
    if(!$sms_id || $sms_id <= 0){
       return TRUE;
    }
    $confSQL = "UPDATE  `sms` SET  `REMIND_FLAG` =  '0' WHERE  `SMS_ID` = ".SecurityFilter($sms_id)." ";
    @exequery($connection, $confSQL);

    return TRUE;

}


/**
 * 费用费用统计
 */

function getChargeCost($where){
     global $connection;
     $getSumChargeCost = "SELECT SUM( CHARGE_COST ) as CNT FROM  `charge_list` cl WHERE 1 AND $where";

     $result = exequery($connection, $getSumChargeCost);
     $row = mysql_fetch_assoc($result);

    if (!isset($row['CNT'])) {
        return 0;
    } else {
        return $row['CNT'];
    }

}
// 获取系统版本，然后放在js/css后面，解决缓存问题
function getVersion()
{
    static $version;
    if(isset($version)){
        return $version;
    }
    global $connection;
    $sql        = "SELECT * FROM version";
    $rs         = exequery($connection, $sql);
    $row        = mysql_fetch_array($rs,MYSQL_ASSOC);
    return $row['VER'];
}


//制作等比缩放的图片
function scaleImage($pic, $maxx = 159, $maxy = 78, $prefix = 'thumb_') {

        $info = getimageSize($pic); //获取图片的基本信息


        $w = $info[0]; //获取宽度
        $h = $info[1]; //获取高度
        //获取图片的类型并为此创建对应图片资源
        switch ($info[2]) {
            case 1: //gif
                $im = imagecreatefromgif($pic);
                break;
            case 2: //jpg
                $im = imagecreatefromjpeg($pic);
                break;
            case 3: //png
                $im = imagecreatefrompng($pic);
                break;
            default:
                die(0);
        }

        //计算缩放比例
        if (($maxx / $w) > ($maxy / $h)) {
            $b = $maxy / $h;
        } else {
            $b = $maxx / $w;
        }

        //计算出缩放后的尺寸
        $nw = floor($w * $b);
        $nh = floor($h * $b);

        //创建一个新的图像源(目标图像)
        $des = imagecreatetruecolor($nw, $nh);

        imagesavealpha($des, true);
        $color = imagecolorallocatealpha($des, 255, 255, 255, 127);
        imagefill($des, 0, 0, $color);

        imagecopyresampled($des, $im, 0, 0, 0, 0, $nw, $nh, $w, $h);



        //输出图像（根据源图像的类型，输出为对应的类型）
        $picinfo = pathinfo($pic); //解析源图像的名字和路径信息
        $newpicname = $picinfo["dirname"] . DIRECTORY_SEPARATOR . $prefix . $picinfo["basename"];

        switch ($info[2]) {
            case 1:
                imagegif($des, $newpicname);
                break;
            case 2:
                imagejpeg($des, $newpicname);
                break;
            case 3:
                 imagealphablending($des, FALSE);
                 imagesavealpha($des,TRUE);
                 imagepng($des,$newpicname);
                 break;

        }
        //释放图片资源
        imagedestroy($im);
        imagedestroy($des);
        //返回结果
        return $newpicname;
    }

 function checkUserInfo($where){
     global $connection;
     $sql = " SELECT USER_ID  FROM user WHERE $where";
     $result = exequery($connection, $sql);
     $row = mysql_fetch_assoc($result);
        if ($row) {
                return $row;
        }
        return false;

    }
